/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/auxiliaryWindow","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(K){for(var e=[],I=0,L=K.length;I<L;I++)e[I]=ee[K[I]];return e};define(ee[132],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(v,p,m){const d=L(v,p);if(d!==-1)return v[d]}e.findLast=I;function L(v,p,m=v.length-1){for(let d=m;d>=0;d--){const c=v[d];if(p(c))return d}return-1}e.findLastIdx=L;function r(v,p){const m=_(v,p);return m===-1?void 0:v[m]}e.findLastMonotonous=r;function _(v,p,m=0,d=v.length){let c=m,E=d;for(;c<E;){const u=Math.floor((c+E)/2);p(v[u])?c=u+1:E=u}return c-1}e.findLastIdxMonotonous=_;function M(v,p){const m=C(v,p);return m===v.length?void 0:v[m]}e.findFirstMonotonous=M;function C(v,p,m=0,d=v.length){let c=m,E=d;for(;c<E;){const u=Math.floor((c+E)/2);p(v[u])?E=u:c=u+1}return c}e.findFirstIdxMonotonousOrArrLen=C;function h(v,p,m=0,d=v.length){const c=C(v,p,m,d);return c===v.length?-1:c}e.findFirstIdxMonotonous=h;class a{static{this.assertInvariants=!1}constructor(p){this._array=p,this._findLastMonotonousLastIdx=0}findLastMonotonous(p){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!p(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=p}const m=_(this._array,p,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=m+1,m===-1?void 0:this._array[m]}}e.MonotonousArray=a;function g(v,p){if(v.length===0)return;let m=v[0];for(let d=1;d<v.length;d++){const c=v[d];p(c,m)>0&&(m=c)}return m}e.findFirstMaxBy=g;function w(v,p){if(v.length===0)return;let m=v[0];for(let d=1;d<v.length;d++){const c=v[d];p(c,m)>=0&&(m=c)}return m}e.findLastMaxBy=w;function S(v,p){return g(v,(m,d)=>-p(m,d))}e.findFirstMinBy=S;function f(v,p){if(v.length===0)return-1;let m=0;for(let d=1;d<v.length;d++){const c=v[d];p(c,v[m])>0&&(m=d)}return m}e.findMaxIdxBy=f;function y(v,p){for(const m of v){const d=p(m);if(d!==void 0)return d}}e.mapFindFirst=y}),define(ee[133],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(M,C){const h=Object.create(null);for(const a of M){const g=C(a);let w=h[g];w||(w=h[g]=[]),w.push(a)}return h}e.groupBy=I;function L(M,C){const h=[],a=[];for(const g of M)C.has(g)||h.push(g);for(const g of C)M.has(g)||a.push(g);return{removed:h,added:a}}e.diffSets=L;function r(M,C){const h=[],a=[];for(const[g,w]of M)C.has(g)||h.push(w);for(const[g,w]of C)M.has(g)||a.push(w);return{removed:h,added:a}}e.diffMaps=r;function _(M,C){const h=new Set;for(const a of C)M.has(a)&&h.add(a);return h}e.intersection=_}),define(ee[134],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(C,h){const a=Math.pow(10,h);return Math.round(C*a)/a}class L{constructor(h,a,g,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=I(Math.max(Math.min(1,w),0),3)}static equals(h,a){return h.r===a.r&&h.g===a.g&&h.b===a.b&&h.a===a.a}}e.RGBA=L;class r{constructor(h,a,g,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=I(Math.max(Math.min(1,a),0),3),this.l=I(Math.max(Math.min(1,g),0),3),this.a=I(Math.max(Math.min(1,w),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.l===a.l&&h.a===a.a}static fromRGBA(h){const a=h.r/255,g=h.g/255,w=h.b/255,S=h.a,f=Math.max(a,g,w),y=Math.min(a,g,w);let v=0,p=0;const m=(y+f)/2,d=f-y;if(d>0){switch(p=Math.min(m<=.5?d/(2*m):d/(2-2*m),1),f){case a:v=(g-w)/d+(g<w?6:0);break;case g:v=(w-a)/d+2;break;case w:v=(a-g)/d+4;break}v*=60,v=Math.round(v)}return new r(v,p,m,S)}static _hue2rgb(h,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?h+(a-h)*6*g:g<1/2?a:g<2/3?h+(a-h)*(2/3-g)*6:h}static toRGBA(h){const a=h.h/360,{s:g,l:w,a:S}=h;let f,y,v;if(g===0)f=y=v=w;else{const p=w<.5?w*(1+g):w+g-w*g,m=2*w-p;f=r._hue2rgb(m,p,a+1/3),y=r._hue2rgb(m,p,a),v=r._hue2rgb(m,p,a-1/3)}return new L(Math.round(f*255),Math.round(y*255),Math.round(v*255),S)}}e.HSLA=r;class _{constructor(h,a,g,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=I(Math.max(Math.min(1,a),0),3),this.v=I(Math.max(Math.min(1,g),0),3),this.a=I(Math.max(Math.min(1,w),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.v===a.v&&h.a===a.a}static fromRGBA(h){const a=h.r/255,g=h.g/255,w=h.b/255,S=Math.max(a,g,w),f=Math.min(a,g,w),y=S-f,v=S===0?0:y/S;let p;return y===0?p=0:S===a?p=((g-w)/y%6+6)%6:S===g?p=(w-a)/y+2:p=(a-g)/y+4,new _(Math.round(p*60),v,S,h.a)}static toRGBA(h){const{h:a,s:g,v:w,a:S}=h,f=w*g,y=f*(1-Math.abs(a/60%2-1)),v=w-f;let[p,m,d]=[0,0,0];return a<60?(p=f,m=y):a<120?(p=y,m=f):a<180?(m=f,d=y):a<240?(m=y,d=f):a<300?(p=y,d=f):a<=360&&(p=f,d=y),p=Math.round((p+v)*255),m=Math.round((m+v)*255),d=Math.round((d+v)*255),new L(p,m,d,S)}}e.HSVA=_;class M{static fromHex(h){return M.Format.CSS.parseHex(h)||M.red}static equals(h,a){return!h&&!a?!0:!h||!a?!1:h.equals(a)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:_.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof r)this._hsla=h,this.rgba=r.toRGBA(h);else if(h instanceof _)this._hsva=h,this.rgba=_.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&r.equals(this.hsla,h.hsla)&&_.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=M._relativeLuminanceForComponent(this.rgba.r),a=M._relativeLuminanceForComponent(this.rgba.g),g=M._relativeLuminanceForComponent(this.rgba.b),w=.2126*h+.7152*a+.0722*g;return I(w,4)}static _relativeLuminanceForComponent(h){const a=h/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(h){const a=this.getRelativeLuminance(),g=h.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const a=this.getRelativeLuminance(),g=h.getRelativeLuminance();return a>g}isDarkerThan(h){const a=this.getRelativeLuminance(),g=h.getRelativeLuminance();return a<g}lighten(h){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:a,g,b:w,a:S}=this.rgba;return new M(new L(a,g,w,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const a=h.rgba,g=this.rgba.a,w=a.a,S=g+w*(1-g);if(S<1e-6)return M.transparent;const f=this.rgba.r*g/S+a.r*w*(1-g)/S,y=this.rgba.g*g/S+a.g*w*(1-g)/S,v=this.rgba.b*g/S+a.b*w*(1-g)/S;return new M(new L(f,y,v,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:a,g,b:w,a:S}=this.rgba;return new M(new L(h.rgba.r-S*(h.rgba.r-a),h.rgba.g-S*(h.rgba.g-g),h.rgba.b-S*(h.rgba.b-w),1))}flatten(...h){const a=h.reduceRight((g,w)=>M._flatten(w,g));return M._flatten(this,a)}static _flatten(h,a){const g=1-h.rgba.a;return new M(new L(g*a.rgba.r+h.rgba.a*h.rgba.r,g*a.rgba.g+h.rgba.a*h.rgba.g,g*a.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(h,a,g){if(h.isLighterThan(a))return h;g=g||.5;const w=h.getRelativeLuminance(),S=a.getRelativeLuminance();return g=g*(S-w)/S,h.lighten(g)}static getDarkerColor(h,a,g){if(h.isDarkerThan(a))return h;g=g||.5;const w=h.getRelativeLuminance(),S=a.getRelativeLuminance();return g=g*(w-S)/w,h.darken(g)}static{this.white=new M(new L(255,255,255,1))}static{this.black=new M(new L(0,0,0,1))}static{this.red=new M(new L(255,0,0,1))}static{this.blue=new M(new L(0,0,255,1))}static{this.green=new M(new L(0,255,0,1))}static{this.cyan=new M(new L(0,255,255,1))}static{this.lightgrey=new M(new L(211,211,211,1))}static{this.transparent=new M(new L(0,0,0,0))}}e.Color=M,function(C){let h;(function(a){let g;(function(w){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:C.Format.CSS.formatRGBA(t)}w.formatRGB=S;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(t)}w.formatHSL=y;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=v;function p(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function m(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}w.formatHex=m;function d(t,l=!1){return l&&t.rgba.a===1?C.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}w.formatHexA=d;function c(t){return t.isOpaque()?C.Format.CSS.formatHex(t):C.Format.CSS.formatRGBA(t)}w.format=c;function E(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const s=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new C(new L(s,i,n,1))}if(l===9){const s=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),o=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new C(new L(s,i,n,o/255))}if(l===4){const s=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new C(new L(16*s+s,16*i+i,16*n+n))}if(l===5){const s=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),o=u(t.charCodeAt(4));return new C(new L(16*s+s,16*i+i,16*n+n,(16*o+o)/255))}return null}w.parseHex=E;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(h=C.Format||(C.Format={}))}(M||(e.Color=M={}))}),define(ee[54],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(M){return(C,h,a)=>{let g=null,w=null;if(typeof a.value=="function"?(g="value",w=a.value):typeof a.get=="function"&&(g="get",w=a.get),!w)throw new Error("not supported");a[g]=M(w,h)}}function L(M,C,h){let a=null,g=null;if(typeof h.value=="function"?(a="value",g=h.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",g=h.get),!g)throw new Error("not supported");const w=`$memoize$${C}`;h[a]=function(...S){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,S)}),this[w]}}e.memoize=L;function r(M,C,h){return I((a,g)=>{const w=`$debounce$${g}`,S=`$debounce$result$${g}`;return function(...f){this[S]||(this[S]=h?h():void 0),clearTimeout(this[w]),C&&(this[S]=C(this[S],...f),f=[this[S]]),this[w]=setTimeout(()=>{a.apply(this,f),this[S]=h?h():void 0},M)}})}e.debounce=r;function _(M,C,h){return I((a,g)=>{const w=`$throttle$timer$${g}`,S=`$throttle$result$${g}`,f=`$throttle$lastRun$${g}`,y=`$throttle$pending$${g}`;return function(...v){if(this[S]||(this[S]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[S]=C(this[S],...v)),this[y])return;const p=this[f]+M;p<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[S]]),this[S]=h?h():void 0):(this[y]=!0,this[w]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),a.apply(this,[this[S]]),this[S]=h?h():void 0},p-Date.now()))}})}e.throttle=_}),define(ee[14],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(l=>{l(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function r(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function _(u){a(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=_;function M(u){a(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function C(u){if(u instanceof Error){const{name:t,message:l}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:s,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=C;const h="Canceled";function a(u){return u instanceof g?!0:u instanceof Error&&u.name===h&&u.message===h}e.isCancellationError=a;class g extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=g;function w(){const u=new Error(h);return u.name=u.message,u}e.canceled=w;function S(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=S;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=f;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=y;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=v;class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=m;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const l=new c;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.BugIndicatingError=E}),define(ee[23],te([0,1,14,132]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(B,z=0){return B[B.length-(1+z)]}e.tail=r;function _(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=_;function M(B,z,j=(ce,fe)=>ce===fe){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let ce=0,fe=B.length;ce<fe;ce++)if(!j(B[ce],z[ce]))return!1;return!0}e.equals=M;function C(B,z){const j=B.length-1;z<j&&(B[z]=B[j]),B.pop()}e.removeFastWithoutKeepingOrder=C;function h(B,z,j){return a(B.length,ce=>j(B[ce],z))}e.binarySearch=h;function a(B,z){let j=0,ce=B-1;for(;j<=ce;){const fe=(j+ce)/2|0,ue=z(fe);if(ue<0)j=fe+1;else if(ue>0)ce=fe-1;else return fe}return-(j+1)}e.binarySearch2=a;function g(B,z,j){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const ce=z[Math.floor(z.length*Math.random())],fe=[],ue=[],he=[];for(const ye of z){const we=j(ye,ce);we<0?fe.push(ye):we>0?ue.push(ye):he.push(ye)}return B<fe.length?g(B,fe,j):B<fe.length+he.length?he[0]:g(B-(fe.length+he.length),ue,j)}e.quickSelect=g;function w(B,z){const j=[];let ce;for(const fe of B.slice(0).sort(z))!ce||z(ce[0],fe)!==0?(ce=[fe],j.push(ce)):ce.push(fe);return j}e.groupBy=w;function*S(B,z){let j,ce;for(const fe of B)ce!==void 0&&z(ce,fe)?j.push(fe):(j&&(yield j),j=[fe]),ce=fe;j&&(yield j)}e.groupAdjacentBy=S;function f(B,z){for(let j=0;j<=B.length;j++)z(j===0?void 0:B[j-1],j===B.length?void 0:B[j])}e.forEachAdjacent=f;function y(B,z){for(let j=0;j<B.length;j++)z(j===0?void 0:B[j-1],B[j],j+1===B.length?void 0:B[j+1])}e.forEachWithNeighbors=y;function v(B,z,j){const ce=[];function fe(ye,we,Se){if(we===0&&Se.length===0)return;const De=ce[ce.length-1];De&&De.start+De.deleteCount===ye?(De.deleteCount+=we,De.toInsert.push(...Se)):ce.push({start:ye,deleteCount:we,toInsert:Se})}let ue=0,he=0;for(;;){if(ue===B.length){fe(ue,0,z.slice(he));break}if(he===z.length){fe(ue,B.length-ue,[]);break}const ye=B[ue],we=z[he],Se=j(ye,we);Se===0?(ue+=1,he+=1):Se<0?(fe(ue,1,[]),ue+=1):Se>0&&(fe(ue,0,[we]),he+=1)}return ce}e.sortedDiff=v;function p(B,z,j){const ce=v(B,z,j),fe=[],ue=[];for(const he of ce)fe.push(...B.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:fe,added:ue}}e.delta=p;function m(B,z,j){if(j===0)return[];const ce=B.slice(0,j).sort(z);return c(B,z,ce,j,B.length),ce}e.top=m;function d(B,z,j,ce,fe){return j===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ye=B.length,we=B.slice(0,j).sort(z);for(let Se=j,De=Math.min(j+ce,ye);Se<ye;Se=De,De=Math.min(De+ce,ye)){if(Se>j&&await new Promise(Ne=>setTimeout(Ne)),fe&&fe.isCancellationRequested)throw new I.CancellationError;c(B,z,we,Se,De)}return we})().then(ue,he)})}e.topAsync=d;function c(B,z,j,ce,fe){for(const ue=j.length;ce<fe;ce++){const he=B[ce];if(z(he,j[ue-1])<0){j.pop();const ye=(0,L.findFirstIdxMonotonousOrArrLen)(j,we=>z(he,we)<0);j.splice(ye,0,he)}}}function E(B){return B.filter(z=>!!z)}e.coalesce=E;function u(B){let z=0;for(let j=0;j<B.length;j++)B[j]&&(B[z]=B[j],z+=1);B.length=z}e.coalesceInPlace=u;function t(B,z,j){B.splice(j,0,B.splice(z,1)[0])}e.move=t;function l(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=l;function s(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=s;function i(B,z=j=>j){const j=new Set;return B.filter(ce=>{const fe=z(ce);return j.has(fe)?!1:(j.add(fe),!0)})}e.distinct=i;function n(B){const z=new Set;return j=>{const ce=B(j);return z.has(ce)?!1:(z.add(ce),!0)}}e.uniqueFilter=n;function o(B,z){return B.length>0?B[0]:z}e.firstOrDefault=o;function b(B,z){return B.length>0?B[B.length-1]:z}e.lastOrDefault=b;function D(B,z,j=(ce,fe)=>ce===fe){let ce=0;for(let fe=0,ue=Math.min(B.length,z.length);fe<ue&&j(B[fe],z[fe]);fe++)ce++;return ce}e.commonPrefixLength=D;function R(B){return[].concat(...B)}e.flatten=R;function P(B,z){let j=typeof z=="number"?B:0;typeof z=="number"?j=B:(j=0,z=B);const ce=[];if(j<=z)for(let fe=j;fe<z;fe++)ce.push(fe);else for(let fe=j;fe>z;fe--)ce.push(fe);return ce}e.range=P;function k(B,z,j){return B.reduce((ce,fe)=>(ce[z(fe)]=j?j(fe):fe,ce),Object.create(null))}e.index=k;function O(B,z){return B.push(z),()=>F(B,z)}e.insert=O;function F(B,z){const j=B.indexOf(z);if(j>-1)return B.splice(j,1),z}e.remove=F;function $(B,z,j){const ce=B.slice(0,z),fe=B.slice(z);return ce.concat(j,fe)}e.arrayInsert=$;function re(B,z){let j;if(typeof z=="number"){let ce=z;j=()=>{const fe=Math.sin(ce++)*179426549;return fe-Math.floor(fe)}}else j=Math.random;for(let ce=B.length-1;ce>0;ce-=1){const fe=Math.floor(j()*(ce+1)),ue=B[ce];B[ce]=B[fe],B[fe]=ue}}e.shuffle=re;function J(B,z){const j=B.indexOf(z);j>-1&&(B.splice(j,1),B.unshift(z))}e.pushToStart=J;function ae(B,z){const j=B.indexOf(z);j>-1&&(B.splice(j,1),B.push(z))}e.pushToEnd=ae;function ne(B,z){for(const j of z)B.push(j)}e.pushMany=ne;function se(B,z){return Array.isArray(B)?B.map(z):z(B)}e.mapArrayOrNot=se;function G(B){return Array.isArray(B)?B:[B]}e.asArray=G;function V(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=V;function x(B,z,j){const ce=U(B,z),fe=B.length,ue=j.length;B.length=fe+ue;for(let he=fe-1;he>=ce;he--)B[he+ue]=B[he];for(let he=0;he<ue;he++)B[he+ce]=j[he]}e.insertInto=x;function W(B,z,j,ce){const fe=U(B,z);let ue=B.splice(fe,j);return ue===void 0&&(ue=[]),x(B,fe,ce),ue}e.splice=W;function U(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var H;(function(B){function z(ue){return ue<0}B.isLessThan=z;function j(ue){return ue<=0}B.isLessThanOrEqual=j;function ce(ue){return ue>0}B.isGreaterThan=ce;function fe(ue){return ue===0}B.isNeitherLessOrGreaterThan=fe,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function Q(B,z){return(j,ce)=>z(B(j),B(ce))}e.compareBy=Q;function ie(...B){return(z,j)=>{for(const ce of B){const fe=ce(z,j);if(!H.isNeitherLessOrGreaterThan(fe))return fe}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=ie;const oe=(B,z)=>B-z;e.numberComparator=oe;const N=(B,z)=>(0,e.numberComparator)(B?1:0,z?1:0);e.booleanComparator=N;function A(B){return(z,j)=>-B(z,j)}e.reverseOrder=A;class T{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let j=this.firstIdx;for(;j<this.items.length&&z(this.items[j]);)j++;const ce=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,ce}takeFromEndWhile(z){let j=this.lastIdx;for(;j>=0&&z(this.items[j]);)j--;const ce=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const j=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,j}}e.ArrayQueue=T;class q{static{this.empty=new q(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(j=>(z(j),!0))}toArray(){const z=[];return this.iterate(j=>(z.push(j),!0)),z}filter(z){return new q(j=>this.iterate(ce=>z(ce)?j(ce):!0))}map(z){return new q(j=>this.iterate(ce=>j(z(ce))))}some(z){let j=!1;return this.iterate(ce=>(j=z(ce),!j)),j}findFirst(z){let j;return this.iterate(ce=>z(ce)?(j=ce,!1):!0),j}findLast(z){let j;return this.iterate(ce=>(z(ce)&&(j=ce),!0)),j}findLastMaxBy(z){let j,ce=!0;return this.iterate(fe=>((ce||H.isGreaterThan(z(fe,j)))&&(ce=!1,j=fe),!0)),j}}e.CallbackIterable=q}),define(ee[135],te([0,1,14]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,a){if(!h)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=L;function r(h,a="Unreachable"){throw new Error(a)}e.assertNever=r;function _(h){if(!h)throw new I.BugIndicatingError("Assertion Failed")}e.assert=_;function M(h){if(!h()){debugger;h(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function C(h,a){let g=0;for(;g<h.length-1;){const w=h[g],S=h[g+1];if(!a(w,S))return!1;g++}return!0}e.checkAdjacentItems=C}),define(ee[82],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(L){const r=this;let _=!1,M;return function(){return _||(_=!0,M=L.apply(r,arguments)),M}}e.createSingleCallFunction=I}),define(ee[69],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=r;const _=Object.freeze([]);function M(){return _}L.empty=M;function*C(u){yield u}L.single=C;function h(u){return r(u)?u:C(u)}L.wrap=h;function a(u){return u||_}L.from=a;function*g(u){for(let t=u.length-1;t>=0;t--)yield u[t]}L.reverse=g;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function S(u){return u[Symbol.iterator]().next().value}L.first=S;function f(u,t){for(const l of u)if(t(l))return!0;return!1}L.some=f;function y(u,t){for(const l of u)if(t(l))return l}L.find=y;function*v(u,t){for(const l of u)t(l)&&(yield l)}L.filter=v;function*p(u,t){let l=0;for(const s of u)yield t(s,l++)}L.map=p;function*m(...u){for(const t of u)for(const l of t)yield l}L.concat=m;function d(u,t,l){let s=l;for(const i of u)s=t(s,i);return s}L.reduce=d;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}L.slice=c;function E(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const s=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=s.next();if(n.done)return[l,L.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=E})(I||(e.Iterable=I={}))}),define(ee[44],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_||(e.ParseOptions=_={}));function M(t,l=!1){let s=0;const i=t.length;let n="",o=0,b=16,D=0;function R(J){let ae=0,ne=0;for(;ae<J;){const se=t.charCodeAt(s);if(se>=48&&se<=57)ne=ne*16+se-48;else if(se>=65&&se<=70)ne=ne*16+se-65+10;else if(se>=97&&se<=102)ne=ne*16+se-97+10;else break;s++,ae++}return ae<J&&(ne=-1),ne}function P(J){s=J,n="",o=0,b=16,D=0}function k(){const J=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&a(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&a(t.charCodeAt(s)))for(s++;s<t.length&&a(t.charCodeAt(s));)s++;else return D=3,t.substring(J,s);let ae=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&a(t.charCodeAt(s))){for(s++;s<t.length&&a(t.charCodeAt(s));)s++;ae=s}else D=3;return t.substring(J,ae)}function O(){let J="",ae=s;for(;;){if(s>=i){J+=t.substring(ae,s),D=2;break}const ne=t.charCodeAt(s);if(ne===34){J+=t.substring(ae,s),s++;break}if(ne===92){if(J+=t.substring(ae,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const G=R(4);G>=0?J+=String.fromCharCode(G):D=4;break}default:D=5}ae=s;continue}if(ne>=0&&ne<=31)if(h(ne)){J+=t.substring(ae,s),D=2;break}else D=6;s++}return J}function F(){if(n="",D=0,o=s,s>=i)return o=i,b=17;let J=t.charCodeAt(s);if(C(J)){do s++,n+=String.fromCharCode(J),J=t.charCodeAt(s);while(C(J));return b=15}if(h(J))return s++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),b=14;switch(J){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,n=O(),b=10;case 47:{const ae=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return n=t.substring(ae,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const ne=i-1;let se=!1;for(;s<ne;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,se=!0;break}s++}return se||(s++,D=1),n=t.substring(ae,s),b=13}return n+=String.fromCharCode(J),s++,b=16}case 45:if(n+=String.fromCharCode(J),s++,s===i||!a(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=k(),b=11;default:for(;s<i&&$(J);)s++,J=t.charCodeAt(s);if(o!==s){switch(n=t.substring(o,s),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(J),s++,b=16}}function $(J){if(C(J)||h(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let J;do J=F();while(J>=12&&J<=15);return J}return{setPosition:P,getPosition:()=>s,scan:l?re:F,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>D}}e.createScanner=M;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function a(t){return t>=48&&t<=57}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function w(t,l){const s=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(R,P,k,O){o.value=R,o.offset=P,o.length=k,o.type=O,o.colonOffset=void 0,n=o}try{c(t,{onObjectBegin:(R,P)=>{if(l<=R)throw i;n=void 0,b=l>R,s.push("")},onObjectProperty:(R,P,k)=>{if(l<P||(D(R,P,k,"property"),s[s.length-1]=R,l<=P+k))throw i},onObjectEnd:(R,P)=>{if(l<=R)throw i;n=void 0,s.pop()},onArrayBegin:(R,P)=>{if(l<=R)throw i;n=void 0,s.push(0)},onArrayEnd:(R,P)=>{if(l<=R)throw i;n=void 0,s.pop()},onLiteralValue:(R,P,k)=>{if(l<P||(D(R,P,k,u(R)),l<=P+k))throw i},onSeparator:(R,P,k)=>{if(l<=P)throw i;if(R===":"&&n&&n.type==="property")n.colonOffset=P,b=!1,n=void 0;else if(R===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(b=!0,s[s.length-1]=""),n=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:n,isAtPropertyKey:b,matches:R=>{let P=0;for(let k=0;P<R.length&&k<s.length;k++)if(R[P]===s[k]||R[P]==="*")P++;else if(R[P]!=="**")return!1;return P===R.length}}}e.getLocation=w;function S(t,l=[],s=_.DEFAULT){let i=null,n=[];const o=[];function b(R){Array.isArray(n)?n.push(R):i!==null&&(n[i]=R)}return c(t,{onObjectBegin:()=>{const R={};b(R),o.push(n),n=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];b(R),o.push(n),n=R,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:b,onError:(R,P,k)=>{l.push({error:R,offset:P,length:k})}},s),n[0]}e.parse=S;function f(t,l=[],s=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}c(t,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,P,k)=>{i=o({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:P,length:k,parent:i})},onObjectEnd:(R,P)=>{i.length=R+P-i.offset,i=i.parent,n(R+P)},onArrayBegin:(R,P)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,P)=>{i.length=R+P-i.offset,i=i.parent,n(R+P)},onLiteralValue:(R,P,k)=>{o({type:u(R),offset:P,length:k,parent:i,value:R}),n(P+k)},onSeparator:(R,P,k)=>{i.type==="property"&&(R===":"?i.colonOffset=P:R===","&&n(P))},onError:(R,P,k)=>{l.push({error:R,offset:P,length:k})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=f;function y(t,l){if(!t)return;let s=t;for(const i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=y;function v(t){if(!t.parent||!t.parent.children)return[];const l=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;l.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&l.push(s)}return l}e.getNodePath=v;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const l=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(l[s.children[0].value]=p(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,l,s=!1){return l>=t.offset&&l<t.offset+t.length||s&&l===t.offset+t.length}e.contains=m;function d(t,l,s=!1){if(m(t,l,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=d(i[n],l,s);if(o)return o}return t}}e.findNodeAtOffset=d;function c(t,l,s=_.DEFAULT){const i=M(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?ie=>Q(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(l.onObjectBegin),D=o(l.onObjectProperty),R=n(l.onObjectEnd),P=n(l.onArrayBegin),k=n(l.onArrayEnd),O=o(l.onLiteralValue),F=o(l.onSeparator),$=n(l.onComment),re=o(l.onError),J=s&&s.disallowComments,ae=s&&s.allowTrailingComma;function ne(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:J||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(Q){case 12:case 13:J?se(10):$();break;case 16:se(1);break;case 15:case 14:break;default:return Q}}}function se(Q,ie=[],oe=[]){if(re(Q),ie.length+oe.length>0){let N=i.getToken();for(;N!==17;){if(ie.indexOf(N)!==-1){ne();break}else if(oe.indexOf(N)!==-1)break;N=ne()}}}function G(Q){const ie=i.getTokenValue();return Q?O(ie):D(ie),ne(),!0}function V(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(se(2),Q=0)}catch{se(2)}O(Q);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ne(),!0}function x(){return i.getToken()!==10?(se(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(F(":"),ne(),H()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function W(){b(),ne();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||se(4,[],[]),F(","),ne(),i.getToken()===2&&ae)break}else Q&&se(6,[],[]);x()||se(4,[],[2,5]),Q=!0}return R(),i.getToken()!==2?se(7,[2],[]):ne(),!0}function U(){P(),ne();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||se(4,[],[]),F(","),ne(),i.getToken()===4&&ae)break}else Q&&se(6,[],[]);H()||se(4,[],[4,5]),Q=!0}return k(),i.getToken()!==4?se(8,[4],[]):ne(),!0}function H(){switch(i.getToken()){case 3:return U();case 1:return W();case 10:return G(!0);default:return V()}}return ne(),i.getToken()===17?s.allowEmptyContent?!0:(se(4,[],[]),!1):H()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=c;function E(t,l){const s=M(t),i=[];let n,o=0,b;do switch(b=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:o!==b&&i.push(t.substring(o,b)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),o=s.getPosition();break}while(n!==17);return i.join("")}e.stripComments=E;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ee[136],te([0,1,44]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(a,g,w){let S,f,y,v,p;if(g){for(v=g.offset,p=v+g.length,y=v;y>0&&!h(a,y-1);)y--;let b=p;for(;b<a.length&&!h(a,b);)b++;f=a.substring(y,b),S=M(f,w)}else f=a,S=0,y=0,v=0,p=a.length;const m=C(w,a);let d=!1,c=0,E;w.insertSpaces?E=_(" ",w.tabSize||4):E="	";const u=(0,I.createScanner)(f,!1);let t=!1;function l(){return m+_(E,S+c)}function s(){let b=u.scan();for(d=!1;b===15||b===14;)d=d||b===14,b=u.scan();return t=b===16||u.getTokenError()!==0,b}const i=[];function n(b,D,R){!t&&D<p&&R>v&&a.substring(D,R)!==b&&i.push({offset:D,length:R-D,content:b})}let o=s();if(o!==17){const b=u.getTokenOffset()+y,D=_(E,S);n(D,y,b)}for(;o!==17;){let b=u.getTokenOffset()+u.getTokenLength()+y,D=s(),R="";for(;!d&&(D===12||D===13);){const k=u.getTokenOffset()+y;n(" ",b,k),b=u.getTokenOffset()+u.getTokenLength()+y,R=D===12?l():"",D=s()}if(D===2)o!==1&&(c--,R=l());else if(D===4)o!==3&&(c--,R=l());else{switch(o){case 3:case 1:c++,R=l();break;case 5:case 12:R=l();break;case 13:d?R=l():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}d&&(D===12||D===13)&&(R=l())}const P=u.getTokenOffset()+y;n(R,b,P),o=D}return i}e.format=L;function r(a,g){const w=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?w.replace(/\r\n|\r|\n/g,g.eol):w}e.toFormattedString=r;function _(a,g){let w="";for(let S=0;S<g;S++)w+=a;return w}function M(a,g){let w=0,S=0;const f=g.tabSize||4;for(;w<a.length;){const y=a.charAt(w);if(y===" ")S++;else if(y==="	")S+=f;else break;w++}return Math.floor(S/f)}function C(a,g){for(let w=0;w<g.length;w++){const S=g.charAt(w);if(S==="\r")return w+1<g.length&&g.charAt(w+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return a&&a.eol||`
`}e.getEOL=C;function h(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.isEOL=h}),define(ee[137],te([0,1,44,136]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(a,g,w){return _(a,g,void 0,w)}e.removeProperty=r;function _(a,g,w,S,f){const y=g.slice(),v=[],p=(0,I.parseTree)(a,v);let m,d;for(;y.length>0&&(d=y.pop(),m=(0,I.findNodeAtLocation)(p,y),m===void 0&&w!==void 0);)typeof d=="string"?w={[d]:w}:w=[w];if(m)if(m.type==="object"&&typeof d=="string"&&Array.isArray(m.children)){const c=(0,I.findNodeAtLocation)(m,[d]);if(c!==void 0)if(w===void 0){if(!c.parent)throw new Error("Malformed AST");const E=m.children.indexOf(c.parent);let u,t=c.parent.offset+c.parent.length;if(E>0){const l=m.children[E-1];u=l.offset+l.length}else u=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return M(a,{offset:u,length:t-u,content:""},S)}else return M(a,{offset:c.offset,length:c.length,content:JSON.stringify(w)},S);else{if(w===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(w)}`,u=f?f(m.children.map(l=>l.children[0].value)):m.children.length;let t;if(u>0){const l=m.children[u-1];t={offset:l.offset+l.length,length:0,content:","+E}}else m.children.length===0?t={offset:m.offset+1,length:0,content:E}:t={offset:m.offset+1,length:0,content:E+","};return M(a,t,S)}}else if(m.type==="array"&&typeof d=="number"&&Array.isArray(m.children))if(w!==void 0){const c=`${JSON.stringify(w)}`;let E;if(m.children.length===0||d===0)E={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const u=d===-1||d>m.children.length?m.children.length:d,t=m.children[u-1];E={offset:t.offset+t.length,length:0,content:","+c}}return M(a,E,S)}else{const c=d,E=m.children[c];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const t=m.children[c-1],l=t.offset+t.length,s=m.offset+m.length;u={offset:l,length:s-2-l,content:""}}else u={offset:E.offset,length:m.children[c+1].offset-E.offset,content:""};return M(a,u,S)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return M(a,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(w)},S)}}e.setProperty=_;function M(a,g,w){let S=C(a,g),f=g.offset,y=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;f>0&&!(0,L.isEOL)(S,f-1);)f--;for(;y<S.length&&!(0,L.isEOL)(S,y);)y++}const v=(0,L.format)(S,{offset:f,length:y-f},w);for(let m=v.length-1;m>=0;m--){const d=v[m];S=C(S,d),f=Math.min(f,d.offset),y=Math.max(y,d.offset+d.length),y+=d.content.length-d.length}const p=a.length-(S.length-y)-f;return[{offset:f,length:p,content:S.substring(f,y)}]}e.withFormatting=M;function C(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.applyEdit=C;function h(a,g){const w=g.slice(0).sort((f,y)=>{const v=f.offset-y.offset;return v===0?f.length-y.length:v});let S=a.length;for(let f=w.length-1;f>=0;f--){const y=w[f];if(y.offset+y.length<=S)a=C(a,y);else throw new Error("Overlapping edit");S=y.offset}return a}e.applyEdits=h}),define(ee[83],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(ee[101],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(_){this.element=_,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let _=this._first;for(;_!==I.Undefined;){const M=_.next;_.prev=I.Undefined,_.next=I.Undefined,_=M}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,M){const C=new I(_);if(this._first===I.Undefined)this._first=C,this._last=C;else if(M){const a=this._last;this._last=C,C.prev=a,a.next=C}else{const a=this._first;this._first=C,C.next=a,a.prev=C}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(C))}}shift(){if(this._first!==I.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==I.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==I.Undefined&&_.next!==I.Undefined){const M=_.prev;M.next=_.next,_.next.prev=M}else _.prev===I.Undefined&&_.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):_.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):_.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==I.Undefined;)yield _.element,_=_.next}}e.LinkedList=L}),define(ee[31],te([0,1]),function(K,e){"use strict";var I,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function _(d,c,E){let u=d.get(c);return u===void 0&&(u=E,d.set(c,u)),u}e.getOrSet=_;function M(d){const c=[];return d.forEach((E,u)=>{c.push(`${u} => ${E}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.mapToString=M;function C(d){const c=[];return d.forEach(E=>{c.push(E)}),`Set(${d.size}) {${c.join(", ")}}`}e.setToString=C;class h{constructor(c,E){this.uri=c,this.value=E}}function a(d){return Array.isArray(d)}class g{static{this.defaultToKey=c=>c.toString()}constructor(c,E){if(this[I]="ResourceMap",c instanceof g)this.map=new Map(c.map),this.toKey=E??g.defaultToKey;else if(a(c)){this.map=new Map,this.toKey=E??g.defaultToKey;for(const[u,t]of c)this.set(u,t)}else this.map=new Map,this.toKey=c??g.defaultToKey}set(c,E){return this.map.set(this.toKey(c),new h(c,E)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,E){typeof E<"u"&&(c=c.bind(E));for(const[u,t]of this.map)c(t.value,t.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=g;class w{constructor(c,E){this[L]="ResourceSet",!c||typeof c=="function"?this._map=new g(c):(this._map=new g(E),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,E){this._map.forEach((u,t)=>c.call(E,t,t,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var S;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class f{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,E=0){const u=this._map.get(c);if(u)return E!==0&&this.touch(u,E),u.value}set(c,E,u=0){let t=this._map.get(c);if(t)t.value=E,u!==0&&this.touch(t,u);else{switch(t={key:c,value:E,next:void 0,previous:void 0},u){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(c,t),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const E=this._map.get(c);if(E)return this._map.delete(c),this.removeItem(E),this._size--,E.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,E){const u=this._state;let t=this._head;for(;t;){if(E?c.bind(E)(t.value,t.key,this):c(t.value,t.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,E=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}values(){const c=this,E=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}entries(){const c=this,E=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let E=this._head,u=this.size;for(;E&&u>c;)this._map.delete(E.key),E=E.next,u--;this._head=E,this._size=u,E&&(E.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const E=c.next,u=c.previous;if(!E||!u)throw new Error("Invalid list");E.previous=u,u.next=E}c.next=void 0,c.previous=void 0,this._state++}touch(c,E){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(c===this._head)return;const u=c.next,t=c.previous;c===this._tail?(t.next=void 0,this._tail=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(E===2){if(c===this._tail)return;const u=c.next,t=c.previous;c===this._head?(u.previous=void 0,this._head=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((E,u)=>{c.push([u,E])}),c}fromJSON(c){this.clear();for(const[E,u]of c)this.set(E,u)}}e.LinkedMap=f;class y extends f{constructor(c,E=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,E),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,E=2){return super.get(c,E)}peek(c){return super.get(c,0)}set(c,E){return super.set(c,E,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class v{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let E=this.map.get(c)||0;return E===0?!1:(E--,E===0?this.map.delete(c):this.map.set(c,E),!0)}has(c){return this.map.has(c)}}e.CounterSet=v;class p{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[E,u]of c)this.set(E,u)}clear(){this._m1.clear(),this._m2.clear()}set(c,E){this._m1.set(c,E),this._m2.set(E,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const E=this._m1.get(c);return E===void 0?!1:(this._m1.delete(c),this._m2.delete(E),!0)}forEach(c,E){this._m1.forEach((u,t)=>{c.call(E,u,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=p;class m{constructor(){this.map=new Map}add(c,E){let u=this.map.get(c);u||(u=new Set,this.map.set(c,u)),u.add(E)}delete(c,E){const u=this.map.get(c);u&&(u.delete(E),u.size===0&&this.map.delete(c))}forEach(c,E){const u=this.map.get(c);u&&u.forEach(E)}get(c){const E=this.map.get(c);return E||new Set}}e.SetMap=m}),define(ee[2],te([0,1,23,133,31,82,69]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const C=!1;let h=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(k){let O=this.livingDisposables.get(k);return O||(O={parent:null,source:null,isSingleton:!1,value:k,idx:a.idx++},this.livingDisposables.set(k,O)),O}trackDisposable(k){const O=this.getDisposableData(k);O.source||(O.source=new Error().stack)}setParent(k,O){const F=this.getDisposableData(k);F.parent=O}markAsDisposed(k){this.livingDisposables.delete(k)}markAsSingleton(k){this.getDisposableData(k).isSingleton=!0}getRootParent(k,O){const F=O.get(k);if(F)return F;const $=k.parent?this.getRootParent(this.getDisposableData(k.parent),O):k;return O.set(k,$),$}getTrackedDisposables(){const k=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,k).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(k=10,O){let F;if(O)F=O;else{const ne=new Map,se=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,ne).isSingleton);if(se.length===0)return;const G=new Set(se.map(V=>V.value));if(F=se.filter(V=>!(V.parent&&G.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function $(ne){function se(V,x){for(;V.length>0&&x.some(W=>typeof W=="string"?W===V[0]:V[0].match(W));)V.shift()}const G=ne.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return se(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const re=new r.SetMap;for(const ne of F){const se=$(ne);for(let G=0;G<=se.length;G++)re.add(se.slice(0,G).join(`
`),ne)}F.sort((0,I.compareBy)(ne=>ne.idx,I.numberComparator));let J="",ae=0;for(const ne of F.slice(0,k)){ae++;const se=$(ne),G=[];for(let V=0;V<se.length;V++){let x=se[V];x=`(shared with ${re.get(se.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${x}`;const U=re.get(se.slice(0,V).join(`
`)),H=(0,L.groupBy)([...U].map(Q=>$(Q)[V]),Q=>Q);delete H[se[V]];for(const[Q,ie]of Object.entries(H))G.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${Q}`);G.unshift(x)}J+=`


==================== Leaking disposable ${ae}/${F.length}: ${ne.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return F.length>k&&(J+=`


... and ${F.length-k} more leaking disposables

`),{leaks:F,details:J}}}e.DisposableTracker=a;function g(P){h=P}if(e.setDisposableTracker=g,C){const P="__is_disposable_tracked__";g(new class{trackDisposable(k){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[P]||console.log(O)},3e3)}setParent(k,O){if(k&&k!==t.None)try{k[P]=!0}catch{}}markAsDisposed(k){if(k&&k!==t.None)try{k[P]=!0}catch{}}markAsSingleton(k){}})}function w(P){return h?.trackDisposable(P),P}e.trackDisposable=w;function S(P){h?.markAsDisposed(P)}e.markAsDisposed=S;function f(P,k){h?.setParent(P,k)}function y(P,k){if(h)for(const O of P)h.setParent(O,k)}function v(P){return h?.markAsSingleton(P),P}e.markAsSingleton=v;function p(P){return typeof P.dispose=="function"&&P.dispose.length===0}e.isDisposable=p;function m(P){if(M.Iterable.is(P)){const k=[];for(const O of P)if(O)try{O.dispose()}catch(F){k.push(F)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}e.dispose=m;function d(P){for(const k of P)p(k)&&k.dispose();return[]}e.disposeIfDisposable=d;function c(...P){const k=E(()=>m(P));return y(P,k),k}e.combinedDisposable=c;function E(P){const k=w({dispose:(0,_.createSingleCallFunction)(()=>{S(k),P()})});return k}e.toDisposable=E;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return f(k,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(k),k.dispose()}}deleteAndLeak(k){k&&this._toDispose.has(k)&&(this._toDispose.delete(k),f(k,null))}}e.DisposableStore=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new u,w(this),f(this._store,this)}dispose(){S(this),this._store.dispose()}_register(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(k)}}e.Disposable=t;class l{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(k){this._isDisposed||k===this._value||(this._value?.dispose(),k&&f(k,this),this._value=k)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const k=this._value;return this._value=void 0,k&&f(k,null),k}}e.MutableDisposable=l;class s{constructor(k){this._disposable=k,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(k){let O=k;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,S(this))},this}}e.SafeDisposable=i;class n{constructor(){this.references=new Map}acquire(k,...O){let F=this.references.get(k);F||(F={counter:0,object:this.createReferencedObject(k,...O)},this.references.set(k,F));const{object:$}=F,re=(0,_.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(k,F.object),this.references.delete(k))});return F.counter++,{object:$,dispose:re}}}e.ReferenceCollection=n;class o{constructor(k){this.referenceCollection=k}async acquire(k,...O){const F=this.referenceCollection.acquire(k,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch($){throw F.dispose(),$}}}e.AsyncReferenceCollection=o;class b{constructor(k){this.object=k}dispose(){}}e.ImmortalReference=b;function D(P){const k=new u;try{P(k)}finally{k.dispose()}}e.disposeOnReturn=D;class R{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(k){return this._store.has(k)}get size(){return this._store.size}get(k){return this._store.get(k)}set(k,O,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(k)?.dispose(),this._store.set(k,O)}deleteAndDispose(k){this._store.get(k)?.dispose(),this._store.delete(k)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=R}),define(ee[84],te([0,1,31]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new I.LRUCache(1e4);function r(a){return h(a,"NFC",L)}e.normalizeNFC=r;const _=new I.LRUCache(1e4);function M(a){return h(a,"NFD",_)}e.normalizeNFD=M;const C=/[^\u0000-\u0080]/;function h(a,g,w){if(!a)return a;const S=w.get(a);if(S)return S;let f;return C.test(a)?f=a.normalize(g):f=a,w.set(a,f),f}e.removeAccents=function(){const a=/[\u0300-\u036f]/g;return function(g){return M(g).replace(a,"")}}()}),define(ee[138],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(C,h,a){return Math.min(Math.max(C,h),a)}e.clamp=I;function L(C,h){return(h+C%h)%h}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class _{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class M{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const a=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function K(r){const _=[];typeof r=="number"&&_.push("code/timeOrigin",r);function M(h){_.push(h,Date.now())}function C(){const h=[];for(let a=0;a<_.length;a+=2)h.push({name:_[a],startTime:_[a+1]});return h}return{mark:M,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))_.push({name:M.name,startTime:Math.round(r+M.startTime)});return _}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function I(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:K)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function I(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return K[L].call(r.exports,r,r.exports,I),r.l=!0,r.exports}return I.m=K,I.c=e,I.d=function(L,r,_){I.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:_})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,r){if(1&r&&(L=I(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var _=Object.create(null);if(I.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var M in L)I.d(_,M,function(C){return L[C]}.bind(null,M));return _},I.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(r,"a",r),r},I.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},I.p="",I(I.s=0)}([function(K,e,I){(function(L){var r;e=K.exports=oe,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],h=e.src=[],a=0,g=a++;h[g]="0|[1-9]\\d*";var w=a++;h[w]="[0-9]+";var S=a++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;h[f]="("+h[g]+")\\.("+h[g]+")\\.("+h[g]+")";var y=a++;h[y]="("+h[w]+")\\.("+h[w]+")\\.("+h[w]+")";var v=a++;h[v]="(?:"+h[g]+"|"+h[S]+")";var p=a++;h[p]="(?:"+h[w]+"|"+h[S]+")";var m=a++;h[m]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var d=a++;h[d]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var c=a++;h[c]="[0-9A-Za-z-]+";var E=a++;h[E]="(?:\\+("+h[c]+"(?:\\."+h[c]+")*))";var u=a++,t="v?"+h[f]+h[m]+"?"+h[E]+"?";h[u]="^"+t+"$";var l="[v=\\s]*"+h[y]+h[d]+"?"+h[E]+"?",s=a++;h[s]="^"+l+"$";var i=a++;h[i]="((?:<|>)?=?)";var n=a++;h[n]=h[w]+"|x|X|\\*";var o=a++;h[o]=h[g]+"|x|X|\\*";var b=a++;h[b]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[m]+")?"+h[E]+"?)?)?";var D=a++;h[D]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[d]+")?"+h[E]+"?)?)?";var R=a++;h[R]="^"+h[i]+"\\s*"+h[b]+"$";var P=a++;h[P]="^"+h[i]+"\\s*"+h[D]+"$";var k=a++;h[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;h[O]="(?:~>?)";var F=a++;h[F]="(\\s*)"+h[O]+"\\s+",C[F]=new RegExp(h[F],"g");var $=a++;h[$]="^"+h[O]+h[b]+"$";var re=a++;h[re]="^"+h[O]+h[D]+"$";var J=a++;h[J]="(?:\\^)";var ae=a++;h[ae]="(\\s*)"+h[J]+"\\s+",C[ae]=new RegExp(h[ae],"g");var ne=a++;h[ne]="^"+h[J]+h[b]+"$";var se=a++;h[se]="^"+h[J]+h[D]+"$";var G=a++;h[G]="^"+h[i]+"\\s*("+l+")$|^$";var V=a++;h[V]="^"+h[i]+"\\s*("+t+")$|^$";var x=a++;h[x]="(\\s*)"+h[i]+"\\s*("+l+"|"+h[b]+")",C[x]=new RegExp(h[x],"g");var W=a++;h[W]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var U=a++;h[U]="^\\s*("+h[D]+")\\s+-\\s+("+h[D]+")\\s*$";var H=a++;h[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)r(Q,h[Q]),C[Q]||(C[Q]=new RegExp(h[Q]));function ie(Y,le){if(Y instanceof oe)return Y;if(typeof Y!="string"||Y.length>_||!(le?C[s]:C[u]).test(Y))return null;try{return new oe(Y,le)}catch{return null}}function oe(Y,le){if(Y instanceof oe){if(Y.loose===le)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof oe))return new oe(Y,le);r("SemVer",Y,le),this.loose=le;var ge=Y.trim().match(le?C[s]:C[u]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Re=+Me;if(Re>=0&&Re<M)return Re}return Me}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ie,e.valid=function(Y,le){var ge=ie(Y,le);return ge?ge.version:null},e.clean=function(Y,le){var ge=ie(Y.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Y){return r("SemVer.compare",this.version,this.loose,Y),Y instanceof oe||(Y=new oe(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},oe.prototype.compareMain=function(Y){return Y instanceof oe||(Y=new oe(Y,this.loose)),A(this.major,Y.major)||A(this.minor,Y.minor)||A(this.patch,Y.patch)},oe.prototype.comparePre=function(Y){if(Y instanceof oe||(Y=new oe(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Me=Y.prerelease[le];if(r("prerelease compare",le,ge,Me),ge===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ge===void 0)return-1;if(ge!==Me)return A(ge,Me)}while(++le)},oe.prototype.inc=function(Y,le){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,le,ge,Me){typeof ge=="string"&&(Me=ge,ge=void 0);try{return new oe(Y,ge).inc(le,Me).version}catch{return null}},e.diff=function(Y,le){if(z(Y,le))return null;var ge=ie(Y),Me=ie(le);if(ge.prerelease.length||Me.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Me[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Me[Re])return Re},e.compareIdentifiers=A;var N=/^[0-9]+$/;function A(Y,le){var ge=N.test(Y),Me=N.test(le);return ge&&Me&&(Y=+Y,le=+le),ge&&!Me?-1:Me&&!ge?1:Y<le?-1:Y>le?1:0}function T(Y,le,ge){return new oe(Y,ge).compare(new oe(le,ge))}function q(Y,le,ge){return T(Y,le,ge)>0}function B(Y,le,ge){return T(Y,le,ge)<0}function z(Y,le,ge){return T(Y,le,ge)===0}function j(Y,le,ge){return T(Y,le,ge)!==0}function ce(Y,le,ge){return T(Y,le,ge)>=0}function fe(Y,le,ge){return T(Y,le,ge)<=0}function ue(Y,le,ge,Me){var Re;switch(le){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y!==ge;break;case"":case"=":case"==":Re=z(Y,ge,Me);break;case"!=":Re=j(Y,ge,Me);break;case">":Re=q(Y,ge,Me);break;case">=":Re=ce(Y,ge,Me);break;case"<":Re=B(Y,ge,Me);break;case"<=":Re=fe(Y,ge,Me);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function he(Y,le){if(Y instanceof he){if(Y.loose===le)return Y;Y=Y.value}if(!(this instanceof he))return new he(Y,le);r("comparator",Y,le),this.loose=le,this.parse(Y),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(Y,le){return A(le,Y)},e.major=function(Y,le){return new oe(Y,le).major},e.minor=function(Y,le){return new oe(Y,le).minor},e.patch=function(Y,le){return new oe(Y,le).patch},e.compare=T,e.compareLoose=function(Y,le){return T(Y,le,!0)},e.rcompare=function(Y,le,ge){return T(le,Y,ge)},e.sort=function(Y,le){return Y.sort(function(ge,Me){return e.compare(ge,Me,le)})},e.rsort=function(Y,le){return Y.sort(function(ge,Me){return e.rcompare(ge,Me,le)})},e.gt=q,e.lt=B,e.eq=z,e.neq=j,e.gte=ce,e.lte=fe,e.cmp=ue,e.Comparator=he;var ye={};function we(Y,le){if(Y instanceof we)return Y.loose===le?Y:new we(Y.raw,le);if(Y instanceof he)return new we(Y.value,le);if(!(this instanceof we))return new we(Y,le);if(this.loose=le,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Se(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function De(Y,le,ge,Me,Re,Fe,Ae,ze,Be,X,de,me,be){return((le=Se(ge)?"":Se(Me)?">="+ge+".0.0":Se(Re)?">="+ge+"."+Me+".0":">="+le)+" "+(ze=Se(Be)?"":Se(X)?"<"+(+Be+1)+".0.0":Se(de)?"<"+Be+"."+(+X+1)+".0":me?"<="+Be+"."+X+"."+de+"-"+me:"<="+ze)).trim()}function Ne(Y,le){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Y.length;ge++)if(r(Y[ge].semver),Y[ge].semver!==ye&&Y[ge].semver.prerelease.length>0){var Me=Y[ge].semver;if(Me.major===le.major&&Me.minor===le.minor&&Me.patch===le.patch)return!0}return!1}return!0}function pe(Y,le,ge){try{le=new we(le,ge)}catch{return!1}return le.test(Y)}function ve(Y,le,ge,Me){var Re,Fe,Ae,ze,Be;switch(Y=new oe(Y,Me),le=new we(le,Me),ge){case">":Re=q,Fe=fe,Ae=B,ze=">",Be=">=";break;case"<":Re=B,Fe=ce,Ae=q,ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Y,le,Me))return!1;for(var X=0;X<le.set.length;++X){var de=le.set[X],me=null,be=null;if(de.forEach(function(Le){Le.semver===ye&&(Le=new he(">=0.0.0")),me=me||Le,be=be||Le,Re(Le.semver,me.semver,Me)?me=Le:Ae(Le.semver,be.semver,Me)&&(be=Le)}),me.operator===ze||me.operator===Be||(!be.operator||be.operator===ze)&&Fe(Y,be.semver)||be.operator===Be&&Ae(Y,be.semver))return!1}return!0}he.prototype.parse=function(Y){var le=this.loose?C[G]:C[V],ge=Y.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=ye},he.prototype.toString=function(){return this.value},he.prototype.test=function(Y){return r("Comparator.test",Y,this.loose),this.semver===ye||(typeof Y=="string"&&(Y=new oe(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Y,le){if(!(Y instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(Y.value,le),pe(this.value,ge,le);if(Y.operator==="")return ge=new we(this.value,le),pe(Y.semver,ge,le);var Me=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Fe=this.semver.version===Y.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ze=ue(this.semver,"<",Y.semver,le)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Be=ue(this.semver,">",Y.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Me||Re||Fe&&Ae||ze||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var le=this.loose;Y=Y.trim(),r("range",Y,le);var ge=le?C[U]:C[W];Y=Y.replace(ge,De),r("hyphen replace",Y),Y=Y.replace(C[x],"$1$2$3"),r("comparator trim",Y,C[x]),Y=(Y=(Y=Y.replace(C[F],"$1~")).replace(C[ae],"$1^")).split(/\s+/).join(" ");var Me=le?C[G]:C[V],Re=Y.split(" ").map(function(Fe){return function(Ae,ze){return r("comp",Ae),Ae=function(Be,X){return Be.trim().split(/\s+/).map(function(de){return function(me,be){r("caret",me,be);var Le=be?C[se]:C[ne];return me.replace(Le,function(Ue,Oe,We,$e,He){var je;return r("caret",me,Ue,Oe,We,$e,He),Se(Oe)?je="":Se(We)?je=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Se($e)?je=Oe==="0"?">="+Oe+"."+We+".0 <"+Oe+"."+(+We+1)+".0":">="+Oe+"."+We+".0 <"+(+Oe+1)+".0.0":He?(r("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),je=Oe==="0"?We==="0"?">="+Oe+"."+We+"."+$e+He+" <"+Oe+"."+We+"."+(+$e+1):">="+Oe+"."+We+"."+$e+He+" <"+Oe+"."+(+We+1)+".0":">="+Oe+"."+We+"."+$e+He+" <"+(+Oe+1)+".0.0"):(r("no pr"),je=Oe==="0"?We==="0"?">="+Oe+"."+We+"."+$e+" <"+Oe+"."+We+"."+(+$e+1):">="+Oe+"."+We+"."+$e+" <"+Oe+"."+(+We+1)+".0":">="+Oe+"."+We+"."+$e+" <"+(+Oe+1)+".0.0"),r("caret return",je),je})}(de,X)}).join(" ")}(Ae,ze),r("caret",Ae),Ae=function(Be,X){return Be.trim().split(/\s+/).map(function(de){return function(me,be){var Le=be?C[re]:C[$];return me.replace(Le,function(Ue,Oe,We,$e,He){var je;return r("tilde",me,Ue,Oe,We,$e,He),Se(Oe)?je="":Se(We)?je=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Se($e)?je=">="+Oe+"."+We+".0 <"+Oe+"."+(+We+1)+".0":He?(r("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),je=">="+Oe+"."+We+"."+$e+He+" <"+Oe+"."+(+We+1)+".0"):je=">="+Oe+"."+We+"."+$e+" <"+Oe+"."+(+We+1)+".0",r("tilde return",je),je})}(de,X)}).join(" ")}(Ae,ze),r("tildes",Ae),Ae=function(Be,X){return r("replaceXRanges",Be,X),Be.split(/\s+/).map(function(de){return function(me,be){me=me.trim();var Le=be?C[P]:C[R];return me.replace(Le,function(Ue,Oe,We,$e,He,je){r("xRange",me,Ue,Oe,We,$e,He,je);var Je=Se(We),Xe=Je||Se($e),it=Xe||Se(He);return Oe==="="&&it&&(Oe=""),Je?Ue=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&it?(Xe&&($e=0),it&&(He=0),Oe===">"?(Oe=">=",Xe?(We=+We+1,$e=0,He=0):it&&($e=+$e+1,He=0)):Oe==="<="&&(Oe="<",Xe?We=+We+1:$e=+$e+1),Ue=Oe+We+"."+$e+"."+He):Xe?Ue=">="+We+".0.0 <"+(+We+1)+".0.0":it&&(Ue=">="+We+"."+$e+".0 <"+We+"."+(+$e+1)+".0"),r("xRange return",Ue),Ue})}(de,X)}).join(" ")}(Ae,ze),r("xrange",Ae),Ae=function(Be,X){return r("replaceStars",Be,X),Be.trim().replace(C[H],"")}(Ae,ze),r("stars",Ae),Ae}(Fe,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Fe){return!!Fe.match(Me)})),Re=Re.map(function(Fe){return new he(Fe,le)})},we.prototype.intersects=function(Y,le){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Me){return Y.set.some(function(Re){return Re.every(function(Fe){return Me.intersects(Fe,le)})})})})},e.toComparators=function(Y,le){return new we(Y,le).set.map(function(ge){return ge.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new oe(Y,this.loose));for(var le=0;le<this.set.length;le++)if(Ne(this.set[le],Y))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Y,le,ge){var Me=null,Re=null;try{var Fe=new we(le,ge)}catch{return null}return Y.forEach(function(Ae){Fe.test(Ae)&&(Me&&Re.compare(Ae)!==-1||(Re=new oe(Me=Ae,ge)))}),Me},e.minSatisfying=function(Y,le,ge){var Me=null,Re=null;try{var Fe=new we(le,ge)}catch{return null}return Y.forEach(function(Ae){Fe.test(Ae)&&(Me&&Re.compare(Ae)!==1||(Re=new oe(Me=Ae,ge)))}),Me},e.validRange=function(Y,le){try{return new we(Y,le).range||"*"}catch{return null}},e.ltr=function(Y,le,ge){return ve(Y,le,"<",ge)},e.gtr=function(Y,le,ge){return ve(Y,le,">",ge)},e.outside=ve,e.prerelease=function(Y,le){var ge=ie(Y,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,le,ge){return Y=new we(Y,ge),le=new we(le,ge),Y.intersects(le)},e.coerce=function(Y){if(Y instanceof oe)return Y;if(typeof Y!="string")return null;var le=Y.match(C[k]);return le==null?null:ie((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,I(1))},function(K,e){var I,L,r=K.exports={};function _(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function C(p){if(I===setTimeout)return setTimeout(p,0);if((I===_||!I)&&setTimeout)return I=setTimeout,setTimeout(p,0);try{return I(p,0)}catch{try{return I.call(null,p,0)}catch{return I.call(this,p,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:_}catch{I=_}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var h,a=[],g=!1,w=-1;function S(){g&&h&&(g=!1,h.length?a=h.concat(a):w=-1,a.length&&f())}function f(){if(!g){var p=C(S);g=!0;for(var m=a.length;m;){for(h=a,a=[];++w<m;)h&&h[w].run();w=-1,m=a.length}h=null,g=!1,function(d){if(L===clearTimeout)return clearTimeout(d);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(d);try{L(d)}catch{try{return L.call(null,d)}catch{return L.call(this,d)}}}(p)}}function y(p,m){this.fun=p,this.array=m}function v(){}r.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)m[d-1]=arguments[d];a.push(new y(p,m)),a.length!==1||g||C(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=v,r.addListener=v,r.once=v,r.off=v,r.removeListener=v,r.removeAllListeners=v,r.emit=v,r.prependListener=v,r.prependOnceListener=v,r.listeners=function(p){return[]},r.binding=function(p){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(p){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ee[139],te([0,1]),function(K,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(C,h,a){this.level=C,this.key=h,this.value=a,this.forward=[]}}const r=void 0;class _{constructor(C,h=2**16){this.comparator=C,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r),this._size=0}has(C){return!!_._search(this,C,this.comparator)}get(C){return _._search(this,C,this.comparator)?.value}set(C,h){return _._insert(this,C,h,this.comparator)&&(this._size+=1),this}delete(C){const h=_._delete(this,C,this.comparator);return h&&(this._size-=1),h}forEach(C,h){let a=this._header.forward[0];for(;a;)C.call(h,a.value,a.key,this),a=a.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",h=this._header.forward[0];for(;h;)C+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return C}static _search(C,h,a){let g=C._header;for(let w=C._level-1;w>=0;w--)for(;g.forward[w]&&a(g.forward[w].key,h)<0;)g=g.forward[w];if(g=g.forward[0],g&&a(g.key,h)===0)return g}static _insert(C,h,a,g){const w=[];let S=C._header;for(let f=C._level-1;f>=0;f--){for(;S.forward[f]&&g(S.forward[f].key,h)<0;)S=S.forward[f];w[f]=S}if(S=S.forward[0],S&&g(S.key,h)===0)return S.value=a,!1;{const f=_._randomLevel(C);if(f>C._level){for(let y=C._level;y<f;y++)w[y]=C._header;C._level=f}S=new L(f,h,a);for(let y=0;y<f;y++)S.forward[y]=w[y].forward[y],w[y].forward[y]=S;return!0}}static _randomLevel(C,h=.5){let a=1;for(;Math.random()<h&&a<C._maxLevel;)a+=1;return a}static _delete(C,h,a){const g=[];let w=C._header;for(let S=C._level-1;S>=0;S--){for(;w.forward[S]&&a(w.forward[S].key,h)<0;)w=w.forward[S];g[S]=w}if(w=w.forward[0],!w||a(w.key,h)!==0)return!1;for(let S=0;S<C._level&&g[S].forward[S]===w;S++)g[S].forward[S]=w.forward[S];for(;C._level>0&&C._header.forward[C._level-1]===r;)C._level-=1;return!0}}e.SkipList=_}),define(ee[70],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(_){return new L(_)}constructor(_){this._now=I&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ee[3],te([0,1,14,82,2,101,70]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const C=!1,h=!1;var a;(function(R){R.None=()=>r.Disposable.None;function P(ue){if(h){const{onDidAddListener:he}=ue,ye=y.create();let we=0;ue.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),he?.()}}}function k(ue,he){return V(ue,()=>{},0,void 0,!0,void 0,he)}R.defer=k;function O(ue){return(he,ye=null,we)=>{let Se=!1,De;return De=ue(Ne=>{if(!Se)return De?De.dispose():Se=!0,he.call(ye,Ne)},null,we),Se&&De.dispose(),De}}R.once=O;function F(ue,he,ye){return se((we,Se=null,De)=>ue(Ne=>we.call(Se,he(Ne)),null,De),ye)}R.map=F;function $(ue,he,ye){return se((we,Se=null,De)=>ue(Ne=>{he(Ne),we.call(Se,Ne)},null,De),ye)}R.forEach=$;function re(ue,he,ye){return se((we,Se=null,De)=>ue(Ne=>he(Ne)&&we.call(Se,Ne),null,De),ye)}R.filter=re;function J(ue){return ue}R.signal=J;function ae(...ue){return(he,ye=null,we)=>{const Se=(0,r.combinedDisposable)(...ue.map(De=>De(Ne=>he.call(ye,Ne))));return G(Se,we)}}R.any=ae;function ne(ue,he,ye,we){let Se=ye;return F(ue,De=>(Se=he(Se,De),Se),we)}R.reduce=ne;function se(ue,he){let ye;const we={onWillAddFirstListener(){ye=ue(Se.fire,Se)},onDidRemoveLastListener(){ye?.dispose()}};he||P(we);const Se=new c(we);return he?.add(Se),Se.event}function G(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function V(ue,he,ye=100,we=!1,Se=!1,De,Ne){let pe,ve,Y,le=0,ge;const Me={leakWarningThreshold:De,onWillAddFirstListener(){pe=ue(Fe=>{le++,ve=he(ve,Fe),we&&!Y&&(Re.fire(ve),ve=void 0),ge=()=>{const Ae=ve;ve=void 0,Y=void 0,(!we||le>1)&&Re.fire(Ae),le=0},typeof ye=="number"?(clearTimeout(Y),Y=setTimeout(ge,ye)):Y===void 0&&(Y=0,queueMicrotask(ge))})},onWillRemoveListener(){Se&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,pe.dispose()}};Ne||P(Me);const Re=new c(Me);return Ne?.add(Re),Re.event}R.debounce=V;function x(ue,he=0,ye){return R.debounce(ue,(we,Se)=>we?(we.push(Se),we):[Se],he,void 0,!0,void 0,ye)}R.accumulate=x;function W(ue,he=(we,Se)=>we===Se,ye){let we=!0,Se;return re(ue,De=>{const Ne=we||!he(De,Se);return we=!1,Se=De,Ne},ye)}R.latch=W;function U(ue,he,ye){return[R.filter(ue,he,ye),R.filter(ue,we=>!he(we),ye)]}R.split=U;function H(ue,he=!1,ye=[],we){let Se=ye.slice(),De=ue(ve=>{Se?Se.push(ve):pe.fire(ve)});we&&we.add(De);const Ne=()=>{Se?.forEach(ve=>pe.fire(ve)),Se=null},pe=new c({onWillAddFirstListener(){De||(De=ue(ve=>pe.fire(ve)),we&&we.add(De))},onDidAddFirstListener(){Se&&(he?setTimeout(Ne):Ne())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return we&&we.add(pe),pe.event}R.buffer=H;function Q(ue,he){return(we,Se,De)=>{const Ne=he(new oe);return ue(function(pe){const ve=Ne.evaluate(pe);ve!==ie&&we.call(Se,ve)},void 0,De)}}R.chain=Q;const ie=Symbol("HaltChainable");class oe{constructor(){this.steps=[]}map(he){return this.steps.push(he),this}forEach(he){return this.steps.push(ye=>(he(ye),ye)),this}filter(he){return this.steps.push(ye=>he(ye)?ye:ie),this}reduce(he,ye){let we=ye;return this.steps.push(Se=>(we=he(we,Se),we)),this}latch(he=(ye,we)=>ye===we){let ye=!0,we;return this.steps.push(Se=>{const De=ye||!he(Se,we);return ye=!1,we=Se,De?Se:ie}),this}evaluate(he){for(const ye of this.steps)if(he=ye(he),he===ie)break;return he}}function N(ue,he,ye=we=>we){const we=(...pe)=>Ne.fire(ye(...pe)),Se=()=>ue.on(he,we),De=()=>ue.removeListener(he,we),Ne=new c({onWillAddFirstListener:Se,onDidRemoveLastListener:De});return Ne.event}R.fromNodeEventEmitter=N;function A(ue,he,ye=we=>we){const we=(...pe)=>Ne.fire(ye(...pe)),Se=()=>ue.addEventListener(he,we),De=()=>ue.removeEventListener(he,we),Ne=new c({onWillAddFirstListener:Se,onDidRemoveLastListener:De});return Ne.event}R.fromDOMEventEmitter=A;function T(ue){return new Promise(he=>O(ue)(he))}R.toPromise=T;function q(ue){const he=new c;return ue.then(ye=>{he.fire(ye)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}R.fromPromise=q;function B(ue,he){return he(void 0),ue(ye=>he(ye))}R.runAndSubscribe=B;function z(ue,he){let ye=null;function we(De){ye?.dispose(),ye=new r.DisposableStore,he(De,ye)}we(void 0);const Se=ue(De=>we(De));return(0,r.toDisposable)(()=>{Se.dispose(),ye?.dispose()})}R.runAndSubscribeWithStore=z;class j{constructor(he,ye){this._observable=he,this._counter=0,this._hasChanged=!1;const we={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ye||P(we),this.emitter=new c(we),ye&&ye.add(this.emitter)}beginUpdate(he){this._counter++}handlePossibleChange(he){}handleChange(he,ye){this._hasChanged=!0}endUpdate(he){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ce(ue,he){return new j(ue,he).emitter.event}R.fromObservable=ce;function fe(ue){return he=>{let ye=0,we=!1;const Se={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ue.reportChanges(),we&&(we=!1,he()))},handlePossibleChange(){},handleChange(){we=!0}};return ue.addObserver(Se),ue.reportChanges(),{dispose(){ue.removeObserver(Se)}}}}R.fromObservableLight=fe})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this._idPool=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g._idPool++}`,g.all.add(this)}start(P){this._stopWatch=new M.StopWatch,this.listenerCount=P}stop(){if(this._stopWatch){const P=this._stopWatch.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=g;let w=-1;function S(R){const P=w;return w=R,{dispose(){w=P}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(P,k=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=k,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(P,k){const O=this.threshold;if(O<=0||k<O)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(P.value)||0;if(this._stacks.set(P.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let $,re=0;for(const[J,ae]of this._stacks)(!$||re<ae)&&($=J,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${re}):`),console.warn($)}return()=>{const $=this._stacks.get(P.value)||0;this._stacks.set(P.value,$-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class p{constructor(P){this.value=P,this.id=v++}}const m=2,d=(R,P)=>{if(R instanceof p)P(R);else for(let k=0;k<R.length;k++){const O=R[k];O&&P(O)}};class c{constructor(P){this._size=0,this._options=P,this._leakageMon=w>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??w):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(C){const P=this._listeners;queueMicrotask(()=>{d(P,k=>k.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(P,k,O)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;k&&(P=P.bind(k));const F=new p(P);let $,re;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(F.stack=y.create(),$=this._leakageMon.check(F.stack,this._size+1)),C&&(F.stack=re??y.create()),this._listeners?this._listeners instanceof p?(this._deliveryQueue??=new u,this._listeners=[this._listeners,F]):this._listeners.push(F):(this._options?.onWillAddFirstListener?.(this),this._listeners=F,this._options?.onDidAddFirstListener?.(this)),this._size++;const J=(0,r.toDisposable)(()=>{$?.(),this._removeListener(F)});return O instanceof r.DisposableStore?O.add(J):Array.isArray(O)&&O.push(J),J},this._event}_removeListener(P){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const k=this._listeners,O=k.indexOf(P);if(O===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[O]=void 0;const F=this._deliveryQueue.current===this;if(this._size*m<=k.length){let $=0;for(let re=0;re<k.length;re++)k[re]?k[$++]=k[re]:F&&(this._deliveryQueue.end--,$<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=$}}_deliver(P,k){if(!P)return;const O=this._options?.onListenerError||I.onUnexpectedError;if(!O){P.value(k);return}try{P.value(k)}catch(F){O(F)}}_deliverQueue(P){const k=P.current._listeners;for(;P.i<P.end;)this._deliver(k[P.i++],P.value);P.reset()}fire(P){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof p)this._deliver(this._listeners,P);else{const k=this._deliveryQueue;k.enqueue(this,P,this._listeners.length),this._deliverQueue(k)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const E=()=>new u;e.createEventDeliveryQueue=E;class u{constructor(){this.i=-1,this.end=0}enqueue(P,k,O){this.i=0,this.end=O,this.current=P,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(P,k,O){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList),d(this._listeners,F=>this._asyncDeliveryQueue.push([F.value,P]));this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[F,$]=this._asyncDeliveryQueue.shift(),re=[],J={...$,token:k,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");O&&(ae=O(ae,F)),re.push(ae)}};try{F(J)}catch(ae){(0,I.onUnexpectedError)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,I.onUnexpectedError)(ne.reason)})}}}e.AsyncEmitter=t;class l extends c{get isPaused(){return this._isPaused!==0}constructor(P){super(P),this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=P?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const P=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(P))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(P){this._size&&(this._isPaused!==0?this._eventQueue.push(P):super.fire(P))}}e.PauseableEmitter=l;class s extends l{constructor(P){super(P),this._delay=P.delay??100}fire(P){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(P)}}e.DebounceEmitter=s;class i extends c{constructor(P){super(P),this._queuedEvents=[],this._mergeFn=P?.merge}fire(P){this.hasListeners()&&(this._queuedEvents.push(P),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(k=>super.fire(k)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(P){const k={event:P,listener:null};this.events.push(k),this.hasListeners&&this.hook(k);const O=()=>{this.hasListeners&&this.unhook(k);const F=this.events.indexOf(k);this.events.splice(F,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(P=>this.hook(P))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(P=>this.unhook(P))}hook(P){P.listener=P.event(k=>this.emitter.fire(k))}unhook(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class o{constructor(P,k,O,F){this._store=new r.DisposableStore;const $=this._store.add(new n),re=this._store.add(new r.DisposableMap);function J(ae){re.set(ae,$.add(F(ae)))}for(const ae of P)J(ae);this._store.add(k(ae=>{J(ae)})),this._store.add(O(ae=>{re.deleteAndDispose(ae)})),this.event=$.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=o;class b{constructor(){this.buffers=[]}wrapEvent(P){return(k,O,F)=>P($=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>k.call(O,$)):k.call(O,$)},void 0,F)}bufferEvents(P){const k=[];this.buffers.push(k);const O=P();return this.buffers.pop(),k.forEach(F=>F()),O}}e.EventBufferer=b;class D{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=r.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(P){this.inputEvent=P,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=P(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(ee[22],te([0,1,3]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,h){const a=setTimeout(C.bind(h),0);return{dispose(){clearTimeout(a)}}});var r;(function(C){function h(a){return a===C.None||a===C.Cancelled||a instanceof _?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}C.isCancellationToken=h,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=r.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=M}),define(ee[140],te([0,1,22]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new I.CancellationTokenSource,h=this.task(C.token);return this.result={promise:h,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=L;class r{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const h=JSON.stringify(C);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=r;class _{get cachedValues(){return this._map}constructor(C){this.fn=C,this._map=new Map}get(C){if(this._map.has(C))return this._map.get(C);const h=this.fn(C);return this._map.set(C,h),h}}e.CachedFunction=_}),define(ee[62],te([0,1,14,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(E){const u=E;return u?typeof u.read=="function":!1}e.isReadable=r;function _(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=_;function M(E){const u=E;return u?_(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=M;function C(E,u){return new h(E,u)}e.newWriteableStream=C;class h{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,I.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let l;switch(u){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const s=l.indexOf(t);s>=0&&l.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(E,u){const t=[];let l;for(;(l=E.read())!==null;)t.push(l);return u(t)}e.consumeReadable=a;function g(E,u,t){const l=[];let s;for(;(s=E.read())!==null&&l.length<t;)l.push(s);return s===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return E.read()}}}e.peekReadable=g;function w(E,u){return new Promise((t,l)=>{const s=[];S(E,{onData:i=>{u&&s.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(s):void 0)}})})}e.consumeStream=w;function S(E,u,t){E.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),E.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),E.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.listenStream=S;function f(E,u){return new Promise((t,l)=>{const s=new L.DisposableStore,i=[],n=D=>{if(i.push(D),i.length>u)return s.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},o=D=>(s.dispose(),l(D)),b=()=>(s.dispose(),t({stream:E,buffer:i,ended:!0}));s.add((0,L.toDisposable)(()=>E.removeListener("error",o))),E.on("error",o),s.add((0,L.toDisposable)(()=>E.removeListener("end",b))),E.on("end",b),s.add((0,L.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}e.peekStream=f;function y(E,u){const t=C(u);return t.end(E),t}e.toStream=y;function v(){const E=C(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=v;function p(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.toReadable=p;function m(E,u,t){const l=C(t);return S(E,{onData:s=>l.write(u.data(s)),onError:s=>l.error(u.error?u.error(s):s),onEnd:()=>l.end()}),l}e.transform=m;function d(E,u,t){let l=!1;return{read:()=>{const s=u.read();return l?s:(l=!0,s!==null?t([E,s]):E)}}}e.prefixedReadable=d;function c(E,u,t){let l=!1;const s=C(t);return S(u,{onData:i=>l?s.write(i):(l=!0,s.write(t([E,i]))),onError:i=>s.error(i),onEnd:()=>{l||(l=!0,s.write(E)),s.end()}}),s}e.prefixedStream=c}),define(ee[18],te([0,1,83,62]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",_=new I.Lazy(()=>new Uint8Array(256));let M,C;class h{static alloc(k){return r?new h(Buffer.allocUnsafe(k)):new h(new Uint8Array(k))}static wrap(k){return r&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new h(k)}static fromString(k,O){return!(O?.dontUseNodeBuffer||!1)&&r?new h(Buffer.from(k)):(M||(M=new TextEncoder),new h(M.encode(k)))}static fromByteArray(k){const O=h.alloc(k.length);for(let F=0,$=k.length;F<$;F++)O.buffer[F]=k[F];return O}static concat(k,O){if(typeof O>"u"){O=0;for(let re=0,J=k.length;re<J;re++)O+=k[re].byteLength}const F=h.alloc(O);let $=0;for(let re=0,J=k.length;re<J;re++){const ae=k[re];F.set(ae,$),$+=ae.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=h.alloc(this.byteLength);return k.set(this),k}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(k,O){return new h(this.buffer.subarray(k,O))}set(k,O){if(k instanceof h)this.buffer.set(k.buffer,O);else if(k instanceof Uint8Array)this.buffer.set(k,O);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),O);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return S(this.buffer,k)}writeUInt32BE(k,O){f(this.buffer,k,O)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,O){v(this.buffer,k,O)}readUInt8(k){return p(this.buffer,k)}writeUInt8(k,O){m(this.buffer,k,O)}indexOf(k,O=0){return a(this.buffer,k instanceof h?k.buffer:k,O)}}e.VSBuffer=h;function a(P,k,O=0){const F=k.byteLength,$=P.byteLength;if(F===0)return 0;if(F===1)return P.indexOf(k[0]);if(F>$-O)return-1;const re=_.value;re.fill(k.length);for(let se=0;se<k.length;se++)re[k[se]]=k.length-se-1;let J=O+k.length-1,ae=J,ne=-1;for(;J<$;)if(P[J]===k[ae]){if(ae===0){ne=J;break}J--,ae--}else J+=Math.max(k.length-ae,re[P[J]]),ae=k.length-1;return ne}e.binaryIndexOf=a;function g(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0}e.readUInt16LE=g;function w(P,k,O){P[O+0]=k&255,k=k>>>8,P[O+1]=k&255}e.writeUInt16LE=w;function S(P,k){return P[k]*2**24+P[k+1]*2**16+P[k+2]*2**8+P[k+3]}e.readUInt32BE=S;function f(P,k,O){P[O+3]=k,k=k>>>8,P[O+2]=k,k=k>>>8,P[O+1]=k,k=k>>>8,P[O]=k}e.writeUInt32BE=f;function y(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0|P[k+2]<<16>>>0|P[k+3]<<24>>>0}e.readUInt32LE=y;function v(P,k,O){P[O+0]=k&255,k=k>>>8,P[O+1]=k&255,k=k>>>8,P[O+2]=k&255,k=k>>>8,P[O+3]=k&255}e.writeUInt32LE=v;function p(P,k){return P[k]}e.readUInt8=p;function m(P,k,O){P[O]=k}e.writeUInt8=m;function d(P){return L.consumeReadable(P,k=>h.concat(k))}e.readableToBuffer=d;function c(P){return L.toReadable(P)}e.bufferToReadable=c;function E(P){return L.consumeStream(P,k=>h.concat(k))}e.streamToBuffer=E;async function u(P){return P.ended?h.concat(P.buffer):h.concat([...P.buffer,await E(P.stream)])}e.bufferedStreamToBuffer=u;function t(P){return L.toStream(P,k=>h.concat(k))}e.bufferToStream=t;function l(P){return L.transform(P,{data:k=>typeof k=="string"?h.fromString(k):h.wrap(k)},k=>h.concat(k))}e.streamToBufferReadableStream=l;function s(P){return L.newWriteableStream(k=>h.concat(k),P)}e.newWriteableBufferStream=s;function i(P,k){return L.prefixedReadable(P,k,O=>h.concat(O))}e.prefixedBufferReadable=i;function n(P,k){return L.prefixedStream(P,k,O=>h.concat(O))}e.prefixedBufferStream=n;function o(P){let k=0,O=0,F=0;const $=new Uint8Array(Math.floor(P.length/4*3)),re=ae=>{switch(O){case 3:$[F++]=k|ae,O=0;break;case 2:$[F++]=k|ae>>>2,k=ae<<6,O=3;break;case 1:$[F++]=k|ae>>>4,k=ae<<4,O=2;break;default:k=ae<<2,O=1}};for(let ae=0;ae<P.length;ae++){const ne=P.charCodeAt(ae);if(ne>=65&&ne<=90)re(ne-65);else if(ne>=97&&ne<=122)re(ne-97+26);else if(ne>=48&&ne<=57)re(ne-48+52);else if(ne===43||ne===45)re(62);else if(ne===47||ne===95)re(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${P[ae]}`)}}const J=F;for(;O>0;)re(0);return h.wrap($).slice(0,J)}e.decodeBase64=o;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:P},k=!0,O=!1){const F=O?D:b;let $="";const re=P.byteLength%3;let J=0;for(;J<P.byteLength-re;J+=3){const ae=P[J+0],ne=P[J+1],se=P[J+2];$+=F[ae>>>2],$+=F[(ae<<4|ne>>>4)&63],$+=F[(ne<<2|se>>>6)&63],$+=F[se&63]}if(re===1){const ae=P[J+0];$+=F[ae>>>2],$+=F[ae<<4&63],k&&($+="==")}else if(re===2){const ae=P[J+0],ne=P[J+1];$+=F[ae>>>2],$+=F[(ae<<4|ne>>>4)&63],$+=F[ne<<2&63],k&&($+="=")}return $}e.encodeBase64=R}),define(ee[27],te([0,1,140,83]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=r;const _=/{(\d+)}/g;function M(X,...de){return de.length===0?X:X.replace(_,function(me,be){const Le=parseInt(be,10);return isNaN(Le)||Le<0||Le>=de.length?me:de[Le]})}e.format=M;const C=/{([^}]+)}/g;function h(X,de){return X.replace(C,(me,be)=>de[be]??me)}e.format2=h;function a(X){return X.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=a;function g(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=g;function w(X,de){let me=0;const be=de.charCodeAt(0);for(let Le=X.length-1;Le>=0;Le--)X.charCodeAt(Le)===be&&me++;return me}e.count=w;function S(X,de,me="\u2026"){return X.length<=de?X:`${X.substr(0,de)}${me}`}e.truncate=S;function f(X,de=" "){const me=y(X,de);return v(me,de)}e.trim=f;function y(X,de){if(!X||!de)return X;const me=de.length;if(me===0||X.length===0)return X;let be=0;for(;X.indexOf(de,be)===be;)be=be+me;return X.substring(be)}e.ltrim=y;function v(X,de){if(!X||!de)return X;const me=de.length,be=X.length;if(me===0||be===0)return X;let Le=be,Ue=-1;for(;Ue=X.lastIndexOf(de,Le-1),!(Ue===-1||Ue+me!==Le);){if(Ue===0)return"";Le=Ue}return X.substring(0,Le)}e.rtrim=v;function p(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function m(X){return X.replace(/\*/g,"")}e.stripWildcards=m;function d(X,de,me={}){if(!X)throw new Error("Cannot create regex from empty string");de||(X=g(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let be="";return me.global&&(be+="g"),me.matchCase||(be+="i"),me.multiline&&(be+="m"),me.unicode&&(be+="u"),new RegExp(X,be)}e.createRegExp=d;function c(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function E(X){return X.split(/\r\n|\r|\n/)}e.splitLines=E;function u(X){for(let de=0,me=X.length;de<me;de++){const be=X.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}e.firstNonWhitespaceIndex=u;function t(X,de=0,me=X.length){for(let be=de;be<me;be++){const Le=X.charCodeAt(be);if(Le!==32&&Le!==9)return X.substring(de,be)}return X.substring(de,me)}e.getLeadingWhitespace=t;function l(X,de=X.length-1){for(let me=de;me>=0;me--){const be=X.charCodeAt(me);if(be!==32&&be!==9)return me}return-1}e.lastNonWhitespaceIndex=l;function s(X,de,me){const be=[];let Le=0;for(const Ue of X.matchAll(de)){if(be.push(X.slice(Le,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Le=Ue.index+Ue[0].length,be.push(me(Ue[0],...Ue.slice(1),Ue.index,X,Ue.groups))}return be.push(X.slice(Le)),Promise.all(be).then(Ue=>Ue.join(""))}e.replaceAsync=s;function i(X,de){return X<de?-1:X>de?1:0}e.compare=i;function n(X,de,me=0,be=X.length,Le=0,Ue=de.length){for(;me<be&&Le<Ue;me++,Le++){const $e=X.charCodeAt(me),He=de.charCodeAt(Le);if($e<He)return-1;if($e>He)return 1}const Oe=be-me,We=Ue-Le;return Oe<We?-1:Oe>We?1:0}e.compareSubstring=n;function o(X,de){return b(X,de,0,X.length,0,de.length)}e.compareIgnoreCase=o;function b(X,de,me=0,be=X.length,Le=0,Ue=de.length){for(;me<be&&Le<Ue;me++,Le++){let $e=X.charCodeAt(me),He=de.charCodeAt(Le);if($e===He)continue;if($e>=128||He>=128)return n(X.toLowerCase(),de.toLowerCase(),me,be,Le,Ue);R($e)&&($e-=32),R(He)&&(He-=32);const je=$e-He;if(je!==0)return je}const Oe=be-me,We=Ue-Le;return Oe<We?-1:Oe>We?1:0}e.compareSubstringIgnoreCase=b;function D(X){return X>=48&&X<=57}e.isAsciiDigit=D;function R(X){return X>=97&&X<=122}e.isLowerAsciiLetter=R;function P(X){return X>=65&&X<=90}e.isUpperAsciiLetter=P;function k(X,de){return X.length===de.length&&b(X,de)===0}e.equalsIgnoreCase=k;function O(X,de){const me=de.length;return de.length>X.length?!1:b(X,de,0,me)===0}e.startsWithIgnoreCase=O;function F(X,de){const me=Math.min(X.length,de.length);let be;for(be=0;be<me;be++)if(X.charCodeAt(be)!==de.charCodeAt(be))return be;return me}e.commonPrefixLength=F;function $(X,de){const me=Math.min(X.length,de.length);let be;const Le=X.length-1,Ue=de.length-1;for(be=0;be<me;be++)if(X.charCodeAt(Le-be)!==de.charCodeAt(Ue-be))return be;return me}e.commonSuffixLength=$;function re(X){return 55296<=X&&X<=56319}e.isHighSurrogate=re;function J(X){return 56320<=X&&X<=57343}e.isLowSurrogate=J;function ae(X,de){return(X-55296<<10)+(de-56320)+65536}e.computeCodePoint=ae;function ne(X,de,me){const be=X.charCodeAt(me);if(re(be)&&me+1<de){const Le=X.charCodeAt(me+1);if(J(Le))return ae(be,Le)}return be}e.getNextCodePoint=ne;function se(X,de){const me=X.charCodeAt(de-1);if(J(me)&&de>1){const be=X.charCodeAt(de-2);if(re(be))return ae(be,me)}return me}class G{get offset(){return this._offset}constructor(de,me=0){this._str=de,this._len=de.length,this._offset=me}setOffset(de){this._offset=de}prevCodePoint(){const de=se(this._str,this._offset);return this._offset-=de>=65536?2:1,de}nextCodePoint(){const de=ne(this._str,this._len,this._offset);return this._offset+=de>=65536?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class V{get offset(){return this._iterator.offset}constructor(de,me=0){this._iterator=new G(de,me)}nextGraphemeLength(){const de=le.getInstance(),me=this._iterator,be=me.offset;let Le=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ue=me.offset,Oe=de.getGraphemeBreakType(me.nextCodePoint());if(ve(Le,Oe)){me.setOffset(Ue);break}Le=Oe}return me.offset-be}prevGraphemeLength(){const de=le.getInstance(),me=this._iterator,be=me.offset;let Le=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ue=me.offset,Oe=de.getGraphemeBreakType(me.prevCodePoint());if(ve(Oe,Le)){me.setOffset(Ue);break}Le=Oe}return be-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function x(X,de){return new V(X,de).nextGraphemeLength()}e.nextCharLength=x;function W(X,de){return new V(X,de).prevGraphemeLength()}e.prevCharLength=W;function U(X,de){de>0&&J(X.charCodeAt(de))&&de--;const me=de+x(X,de);return[me-W(X,me),me]}e.getCharContainingOffset=U;function H(X){const de=new V(X);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}e.charCount=H;let Q;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(X){return Q||(Q=ie()),Q.test(X)}e.containsRTL=oe;const N=/^[\t\n\r\x20-\x7E]*$/;function A(X){return N.test(X)}e.isBasicASCII=A,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=T;function q(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=q;function B(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=B;function z(X,de){if(X.length<de)return X;const me=/\b/g;let be=0;for(;me.test(X)&&!(X.length-me.lastIndex<de);)be=me.lastIndex,me.lastIndex+=1;return X.substring(be).replace(/^\s/,"")}e.lcut=z;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function fe(X){return X&&(X=X.replace(j,"").replace(ce,"")),X}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function he(X){return ue(X)?X.substr(1):X}e.stripUTF8BOM=he;function ye(X,de){if(!X||!de||X.length<de.length)return!1;const me=de.length,be=X.toLowerCase();let Le=0,Ue=-1;for(;Le<me;){const Oe=be.indexOf(de[Le],Ue+1);if(Oe<0)return!1;Ue=Oe,Le++}return!0}e.fuzzyContains=ye;function we(X,de=!1){return X?(de&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=we;function Se(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=Se;function De(X,de=1){if(de===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.getNLines=De;function Ne(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Ne;function pe(X){return le.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=pe;function ve(X,de){return X===0?de!==5&&de!==7:X===2&&de===3?!1:X===4||X===2||X===3||de===4||de===2||de===3?!0:!(X===8&&(de===8||de===9||de===11||de===12)||(X===11||X===9)&&(de===9||de===10)||(X===12||X===10)&&de===10||de===5||de===13||de===7||X===1||X===13&&de===14||X===6&&de===6)}var Y;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class le{static{this._INSTANCE=null}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}constructor(){this._data=ge()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this._data,be=me.length/3;let Le=1;for(;Le<=be;)if(de<me[3*Le])Le=2*Le;else if(de>me[3*Le+1])Le=2*Le+1;else return me[3*Le+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(X,de){if(X===0)return 0;const me=Re(X,de);if(me!==void 0)return me;const be=new G(de,X);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Me;function Re(X,de){const me=new G(de,X);let be=me.prevCodePoint();for(;Fe(be)||be===65039||be===8419;){if(me.offset===0)return;be=me.prevCodePoint()}if(!B(be))return;let Le=me.offset;return Le>0&&me.prevCodePoint()===8205&&(Le=me.offset),Le}function Fe(X){return 127995<=X&&X<=127999}var Ae;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(de=>{function me(je){const Je=new Map;for(let Xe=0;Xe<je.length;Xe+=2)Je.set(je[Xe],je[Xe+1]);return Je}function be(je,Je){const Xe=new Map(je);for(const[it,nt]of Je)Xe.set(it,nt);return Xe}function Le(je,Je){if(!je)return Je;const Xe=new Map;for(const[it,nt]of je)Je.has(it)&&Xe.set(it,nt);return Xe}const Ue=this.ambiguousCharacterData.value;let Oe=de.filter(je=>!je.startsWith("_")&&je in Ue);Oe.length===0&&(Oe=["_default"]);let We;for(const je of Oe){const Je=me(Ue[je]);We=Le(We,Je)}const $e=me(Ue._common),He=be($e,We);return new ze(He)})}static getInstance(de){return ze.cache.get(Array.from(de))}static{this._locales=new L.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(de){return Be.getData().has(de)}static get codePoints(){return Be.getData()}}e.InvisibleCharacters=Be}),define(ee[55],te([0,1,27]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return r(m,0)}e.hash=L;function r(m,d){switch(typeof m){case"object":return m===null?_(349,d):Array.isArray(m)?h(m,d):a(m,d);case"string":return C(m,d);case"boolean":return M(m,d);case"number":return _(m,d);case"undefined":return _(937,d);default:return _(617,d)}}e.doHash=r;function _(m,d){return(d<<5)-d+m|0}e.numberHash=_;function M(m,d){return _(m?433:863,d)}function C(m,d){d=_(149417,d);for(let c=0,E=m.length;c<E;c++)d=_(m.charCodeAt(c),d);return d}e.stringHash=C;function h(m,d){return d=_(104579,d),m.reduce((c,E)=>r(E,c),d)}function a(m,d){return d=_(181387,d),Object.keys(m).sort().reduce((c,E)=>(c=C(E,c),r(m[E],c)),d)}class g{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=r(d,this._value),this._value}}e.Hasher=g;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function S(m,d,c=32){const E=c-d,u=~((1<<E)-1);return(m<<d|(u&m)>>>E)>>>0}function f(m,d=0,c=m.byteLength,E=0){for(let u=0;u<c;u++)m[d+u]=E}function y(m,d,c="0"){for(;m.length<d;)m=c+m;return m}function v(m,d=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):y((m>>>0).toString(16),d/4)}e.toHexString=v;class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const c=d.length;if(c===0)return;const E=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,l,s;for(t!==0?(l=t,s=-1,t=0):(l=d.charCodeAt(0),s=0);;){let i=l;if(I.isHighSurrogate(l))if(s+1<c){const n=d.charCodeAt(s+1);I.isLowSurrogate(n)?(s++,i=I.computeCodePoint(l,n)):i=65533}else{t=l;break}else I.isLowSurrogate(l)&&(i=65533);if(u=this._push(E,u,i),s++,s<c)l=d.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(d,c,E){return E<128?d[c++]=E:E<2048?(d[c++]=192|(E&1984)>>>6,d[c++]=128|(E&63)>>>0):E<65536?(d[c++]=224|(E&61440)>>>12,d[c++]=128|(E&4032)>>>6,d[c++]=128|(E&63)>>>0):(d[c++]=240|(E&1835008)>>>18,d[c++]=128|(E&258048)>>>12,d[c++]=128|(E&4032)>>>6,d[c++]=128|(E&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=p._bigBlock32,c=this._buffDV;for(let b=0;b<64;b+=4)d.setUint32(b,c.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)d.setUint32(b,S(d.getUint32(b-12,!1)^d.getUint32(b-32,!1)^d.getUint32(b-56,!1)^d.getUint32(b-64,!1),1),!1);let E=this._h0,u=this._h1,t=this._h2,l=this._h3,s=this._h4,i,n,o;for(let b=0;b<80;b++)b<20?(i=u&t|~u&l,n=1518500249):b<40?(i=u^t^l,n=1859775393):b<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),o=S(E,5)+i+s+n+d.getUint32(b*4,!1)&4294967295,s=l,l=t,t=S(u,30),u=E,E=o;this._h0=this._h0+E&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=p}),define(ee[71],te([0,1,27]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const _="error",M="warning",C="warn",h="info",a="ignore";function g(S){return S?I.equalsIgnoreCase(_,S)?r.Error:I.equalsIgnoreCase(M,S)||I.equalsIgnoreCase(C,S)?r.Warning:I.equalsIgnoreCase(h,S)?r.Info:r.Ignore:r.Ignore}r.fromValue=g;function w(S){switch(S){case r.Error:return _;case r.Warning:return M;case r.Info:return h;default:return a}}r.toString=w}(L||(L={})),e.default=L}),define(ee[141],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[56],te([0,1,23,27]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const y=f.charCodeAt(0),v=this._value.charCodeAt(this._pos);return y-v}value(){return this._value[this._pos]}}e.StringIterator=r;class _{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class M{constructor(f=!0,y=!0){this._splitOnBackslash=f,this._caseSensitive=y}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let y=f.length-1;y>=0;y--,this._valueLen--){const v=this._value.charCodeAt(y);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var C;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(C||(C={}));class h{constructor(f,y){this._ignorePathCasing=f,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,L.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(g||(g={}));class w{static forUris(f=()=>!1,y=()=>!1){return new w(new h(f,y))}static forPaths(f=!1){return new w(new M(void 0,!f))}static forStrings(){return new w(new r)}static forConfigKeys(){return new w(new _)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,y){if(y){const v=y.slice(0);(0,I.shuffle)(v);for(const p of v)this.set(p,f)}else{const v=f.slice(0);(0,I.shuffle)(v);for(const p of v)this.set(p[0],p[1])}}set(f,y){const v=this._iter.reset(f);let p;this._root||(this._root=new a,this._root.segment=v.value());const m=[];for(p=this._root;;){const c=v.cmp(p.segment);if(c>0)p.left||(p.left=new a,p.left.segment=v.value()),m.push([-1,p]),p=p.left;else if(c<0)p.right||(p.right=new a,p.right.segment=v.value()),m.push([1,p]),p=p.right;else if(v.hasNext())v.next(),p.mid||(p.mid=new a,p.mid.segment=v.value()),m.push([0,p]),p=p.mid;else break}const d=p.value;p.value=y,p.key=f;for(let c=m.length-1;c>=0;c--){const E=m[c][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const t=m[c][0],l=m[c+1][0];if(t===1&&l===1)m[c][1]=E.rotateLeft();else if(t===-1&&l===-1)m[c][1]=E.rotateRight();else if(t===1&&l===-1)E.right=m[c+1][1]=m[c+1][1].rotateRight(),m[c][1]=E.rotateLeft();else if(t===-1&&l===1)E.left=m[c+1][1]=m[c+1][1].rotateLeft(),m[c][1]=E.rotateRight();else throw new Error;if(c>0)switch(m[c-1][0]){case-1:m[c-1][1].left=m[c][1];break;case 1:m[c-1][1].right=m[c][1];break;case 0:m[c-1][1].mid=m[c][1];break}else this._root=m[0][1]}}return d}get(f){return this._getNode(f)?.value}_getNode(f){const y=this._iter.reset(f);let v=this._root;for(;v;){const p=y.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else break}return v}has(f){const y=this._getNode(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,y){const v=this._iter.reset(f),p=[];let m=this._root;for(;m;){const d=v.cmp(m.segment);if(d>0)p.push([-1,m]),m=m.left;else if(d<0)p.push([1,m]),m=m.right;else if(v.hasNext())v.next(),p.push([0,m]),m=m.mid;else break}if(m){if(y?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const d=this._min(m.right);if(d.key){const{key:c,value:E,segment:u}=d;this._delete(d.key,!1),m.key=c,m.value=E,m.segment=u}}else{const d=m.left??m.right;if(p.length>0){const[c,E]=p[p.length-1];switch(c){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this._root=d}for(let d=p.length-1;d>=0;d--){const c=p[d][1];c.updateHeight();const E=c.balanceFactor();if(E>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),p[d][1]=c.rotateLeft()):E<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),p[d][1]=c.rotateRight()),d>0)switch(p[d-1][0]){case-1:p[d-1][1].left=p[d][1];break;case 1:p[d-1][1].right=p[d][1];break;case 0:p[d-1][1].mid=p[d][1];break}else this._root=p[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this._iter.reset(f);let v=this._root,p;for(;v;){const m=y.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(y.hasNext())y.next(),p=v.value||p,v=v.mid;else break}return v&&v.value||p}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,y){const v=this._iter.reset(f);let p=this._root;for(;p;){const m=v.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(v.hasNext())v.next(),p=p.mid;else return p.mid?this._entries(p.mid):y?p.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[y,v]of this)f(v,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const y=[];return this._dfsEntries(f,y),y[Symbol.iterator]()}_dfsEntries(f,y){f&&(f.left&&this._dfsEntries(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,y),f.right&&this._dfsEntries(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const v=y.balanceFactor();return v<-1||v>1?!1:f(y.left)&&f(y.right)};return f(this._root)}}e.TernarySearchTree=w}),define(ee[12],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(u){return typeof u=="string"}e.isString=I;function L(u){return Array.isArray(u)&&u.every(t=>I(t))}e.isStringArray=L;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=r;function _(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.isTypedArray=_;function M(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=M;function C(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=C;function h(u){return u===!0||u===!1}e.isBoolean=h;function a(u){return typeof u>"u"}e.isUndefined=a;function g(u){return!w(u)}e.isDefined=g;function w(u){return a(u)||u===null}e.isUndefinedOrNull=w;function S(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function f(u){if(w(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=f;function y(...u){const t=[];for(let l=0;l<u.length;l++){const s=u[l];if(w(s))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(s)}return t}e.assertAllDefined=y;const v=Object.prototype.hasOwnProperty;function p(u){if(!r(u))return!1;for(const t in u)if(v.call(u,t))return!1;return!0}e.isEmptyObject=p;function m(u){return typeof u=="function"}e.isFunction=m;function d(...u){return u.length>0&&u.every(m)}e.areFunctions=d;function c(u,t){const l=Math.min(u.length,t.length);for(let s=0;s<l;s++)E(u[s],t[s])}e.validateConstraints=c;function E(u,t){if(I(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(u instanceof t)return}catch{}if(!w(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E}),define(ee[72],te([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(C,h){if((0,I.isString)(h)){const a=L[h];if(a===void 0)throw new Error(`${C} references an unknown codicon: ${h}`);h=a}return L[C]=h,{id:C}}function _(){return L}e.getCodiconFontCharacters=_;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const d=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([c,E])=>{d[c]=E&&typeof E=="object"?L(E):E}),d}e.deepClone=L;function r(m){if(!m||typeof m!="object")return m;const d=[m];for(;d.length>0;){const c=d.shift();Object.freeze(c);for(const E in c)if(_.call(c,E)){const u=c[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,I.isTypedArray)(u)&&d.push(u)}}return m}e.deepFreeze=r;const _=Object.prototype.hasOwnProperty;function M(m,d){return C(m,d,new Set)}e.cloneAndChange=M;function C(m,d,c){if((0,I.isUndefinedOrNull)(m))return m;const E=d(m);if(typeof E<"u")return E;if(Array.isArray(m)){const u=[];for(const t of m)u.push(C(t,d,c));return u}if((0,I.isObject)(m)){if(c.has(m))throw new Error("Cannot clone recursive data-structure");c.add(m);const u={};for(const t in m)_.call(m,t)&&(u[t]=C(m[t],d,c));return c.delete(m),u}return m}function h(m,d,c=!0){return(0,I.isObject)(m)?((0,I.isObject)(d)&&Object.keys(d).forEach(E=>{E in m?c&&((0,I.isObject)(m[E])&&(0,I.isObject)(d[E])?h(m[E],d[E],c):m[E]=d[E]):m[E]=d[E]}),m):d}e.mixin=h;function a(m,d){if(m===d)return!0;if(m==null||d===null||d===void 0||typeof m!=typeof d||typeof m!="object"||Array.isArray(m)!==Array.isArray(d))return!1;let c,E;if(Array.isArray(m)){if(m.length!==d.length)return!1;for(c=0;c<m.length;c++)if(!a(m[c],d[c]))return!1}else{const u=[];for(E in m)u.push(E);u.sort();const t=[];for(E in d)t.push(E);if(t.sort(),!a(u,t))return!1;for(c=0;c<u.length;c++)if(!a(m[u[c]],d[u[c]]))return!1}return!0}e.equals=a;function g(m){const d=new Set;return JSON.stringify(m,(c,E)=>{if((0,I.isObject)(E)||Array.isArray(E)){if(d.has(E))return"[Circular]";d.add(E)}return E})}e.safeStringify=g;function w(m,d){const c=Object.create(null);return!m||!d||Object.keys(d).forEach(u=>{const t=m[u],l=d[u];a(t,l)||(c[u]=l)}),c}e.distinct=w;function S(m,d){const c=d.toLowerCase(),E=Object.keys(m).find(u=>u.toLowerCase()===c);return E?m[E]:m[d]}e.getCaseInsensitive=S;function f(m,d){const c=Object.create(null);for(const[E,u]of Object.entries(m))d(E,u)&&(c[E]=u);return c}e.filter=f;function y(m){let d=[];for(;Object.prototype!==m;)d=d.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return d}e.getAllPropertyNames=y;function v(m){const d=[];for(const c of y(m))typeof m[c]=="function"&&d.push(c);return d}e.getAllMethodNames=v;function p(m,d){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return d(u,t)},E={};for(const u of m)E[u]=c(u);return E}e.createProxyObject=p}),define(ee[102],te([0,1,72]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function C(h){return h&&typeof h=="object"&&typeof h.id=="string"}M.isThemeColor=C})(L||(e.ThemeColor=L={}));function r(M){return{id:M}}e.themeColorFromId=r;var _;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function h(d){const c=C.exec(d.id);if(!c)return h(I.Codicon.error);const[,E,u]=c,t=["codicon","codicon-"+E];return u&&t.push("codicon-modifier-"+u.substring(1)),t}M.asClassNameArray=h;function a(d){return h(d).join(" ")}M.asClassName=a;function g(d){return"."+h(d).join(".")}M.asCSSSelector=g;function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||L.isThemeColor(d.color))}M.isThemeIcon=w;const S=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function f(d){const c=S.exec(d);if(!c)return;const[,E]=c;return{id:E}}M.fromString=f;function y(d){return{id:d}}M.fromId=y;function v(d,c){let E=d.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),c&&(E=`${E}~${c}`),{id:E}}M.modify=v;function p(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}M.getModifier=p;function m(d,c){return d.id===c.id&&d.color?.id===c.color?.id}M.isEqual=m})(_||(e.ThemeIcon=_={}))}),define(ee[32],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return I.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(C){for(let h=0;h<C.length;h++)C[h]=Math.floor(Math.random()*256);return C};const _=new Uint8Array(16),M=[];for(let C=0;C<256;C++)M.push(C.toString(16).padStart(2,"0"));return function(){r(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let h=0,a="";return a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a+="-",a+=M[_[h++]],a+=M[_[h++]],a+="-",a+=M[_[h++]],a+=M[_[h++]],a+="-",a+=M[_[h++]],a+=M[_[h++]],a+="-",a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a+=M[_[h++]],a}}()}),define(ee[142],te([0,1,85,45,82]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function _(M,C){if(await new Promise((g,w)=>{const S=L.createReadStream(M),f=I.createHash("sha1");S.pipe(f);const y=(0,r.createSingleCallFunction)((v,p)=>{S.removeAllListeners(),f.removeAllListeners(),v?w(v):g(p)});S.once("error",y),S.once("end",y),f.once("error",y),f.once("data",v=>y(void 0,v.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=_}),define(ee[143],te([0,1,28]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const C=M.replace(/\-/g,":").toLowerCase();return!L.has(C)}function _(){const M=(0,I.networkInterfaces)();for(const C in M){const h=M[C];if(h){for(const{mac:a}of h)if(r(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ee[86],te([0,1,28,56,32,143]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(a){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(a)}value(){if(this._value===void 0){let a=0,g=0;const w=(0,I.networkInterfaces)();for(const S in w){const f=w[S];if(f)for(const{mac:y,internal:v}of f)v||(g+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(a+=1))}this._value=g>0?a/g:0}return this._value}};let M;async function C(a){return M||(M=(async()=>await h(a)||r.generateUuid())()),M}e.getMachineId=C;async function h(a){try{const g=await new Promise((S,f)=>{K(["crypto"],S,f)}),w=(0,_.getMac)();return g.createHash("sha256").update(w,"utf8").digest("hex")}catch(g){a(g);return}}}),define(ee[103],te([0,1,87]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(C,h,a,g=1){let w=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!w)return w=!0,S(0)},a);r(C,h,g,y=>{if(!w)return w=!0,clearTimeout(f),S(y)})})}e.findFreePort=L;function r(C,h,a,g){if(h===0)return g(0);const w=new I.Socket;w.once("connect",()=>(M(w),r(C+a,h-1,a,g))),w.once("data",()=>{}),w.once("error",S=>(M(w),S.code!=="ECONNREFUSED"?r(C+a,h-1,a,g):g(C))),w.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(C,h,a,g="127.0.0.1"){let w=!1,S,f=1;const y=I.createServer({pauseOnConnect:!0});function v(p,m){w||(w=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),m(p))}return new Promise(p=>{S=setTimeout(()=>{v(0,p)},a),y.on("listening",()=>{v(C,p)}),y.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&f<h?(C++,f++,y.listen(C,g)):v(0,p)}),y.on("close",()=>{v(0,p)}),y.listen(C,g)})}e.findFreePortFaster=_;function M(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(h){console.error(h)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function I(h){const a=new Set;if(Array.isArray(h))for(const g of h)typeof g=="string"&&a.add(g);return Array.from(a)}function L(){const h=e();return h?Array.from(h):[]}function r(h){if(process.platform!=="win32")return;const a=e();if(a)if(typeof h=="string")a.add(h.toLowerCase());else for(const g of I(h))r(g)}function _(h){if(typeof h!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const w of a){if(h.indexOf(w)!==0)continue;const f=h.indexOf("\\",w.length);if(f===-1)continue;const y=h.substring(w.length,f);if(y){g=y;break}}return g}function M(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function C(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:_,disableUNCAccessRestrictions:M,isUNCAccessRestrictionsDisabled:C}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[144],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[145],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(r,_){this.sender=r,this.onMessage=_}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[146],te([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(ee[147],te([0,1,146]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,_=r*24,M=_*7,C=_*30,h=_*365;function a(w,S,f,y){typeof w!="number"&&(w=w.getTime());const v=Math.round((new Date().getTime()-w)/1e3);if(v<-30)return(0,I.localize)(0,null,a(new Date().getTime()+v*1e3,!1));if(!y&&v<30)return(0,I.localize)(1,null);let p;return v<L?(p=v,S?p===1?f?(0,I.localize)(2,null,p):(0,I.localize)(3,null,p):f?(0,I.localize)(4,null,p):(0,I.localize)(5,null,p):p===1?f?(0,I.localize)(6,null,p):(0,I.localize)(7,null,p):f?(0,I.localize)(8,null,p):(0,I.localize)(9,null,p)):v<r?(p=Math.floor(v/L),S?p===1?f?(0,I.localize)(10,null,p):(0,I.localize)(11,null,p):f?(0,I.localize)(12,null,p):(0,I.localize)(13,null,p):p===1?f?(0,I.localize)(14,null,p):(0,I.localize)(15,null,p):f?(0,I.localize)(16,null,p):(0,I.localize)(17,null,p)):v<_?(p=Math.floor(v/r),S?p===1?f?(0,I.localize)(18,null,p):(0,I.localize)(19,null,p):f?(0,I.localize)(20,null,p):(0,I.localize)(21,null,p):p===1?f?(0,I.localize)(22,null,p):(0,I.localize)(23,null,p):f?(0,I.localize)(24,null,p):(0,I.localize)(25,null,p)):v<M?(p=Math.floor(v/_),S?p===1?(0,I.localize)(26,null,p):(0,I.localize)(27,null,p):p===1?(0,I.localize)(28,null,p):(0,I.localize)(29,null,p)):v<C?(p=Math.floor(v/M),S?p===1?f?(0,I.localize)(30,null,p):(0,I.localize)(31,null,p):f?(0,I.localize)(32,null,p):(0,I.localize)(33,null,p):p===1?f?(0,I.localize)(34,null,p):(0,I.localize)(35,null,p):f?(0,I.localize)(36,null,p):(0,I.localize)(37,null,p)):v<h?(p=Math.floor(v/C),S?p===1?f?(0,I.localize)(38,null,p):(0,I.localize)(39,null,p):f?(0,I.localize)(40,null,p):(0,I.localize)(41,null,p):p===1?f?(0,I.localize)(42,null,p):(0,I.localize)(43,null,p):f?(0,I.localize)(44,null,p):(0,I.localize)(45,null,p)):(p=Math.floor(v/h),S?p===1?f?(0,I.localize)(46,null,p):(0,I.localize)(47,null,p):f?(0,I.localize)(48,null,p):(0,I.localize)(49,null,p):p===1?f?(0,I.localize)(50,null,p):(0,I.localize)(51,null,p):f?(0,I.localize)(52,null,p):(0,I.localize)(53,null,p))}e.fromNow=a;function g(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=g}),define(ee[148],te([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ee[49],te([0,1,23,12,148]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function _(w,S){return S&&(w.stack||w.stacktrace)?r.localize(0,null,C(w),M(w.stack)||M(w.stacktrace)):C(w)}function M(w){return Array.isArray(w)?w.join(`
`):w}function C(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?r.localize(1,null,w.message):w.message||r.localize(2,null)}function h(w=null,S=!1){if(!w)return r.localize(3,null);if(Array.isArray(w)){const f=I.coalesce(w),y=h(f[0],S);return f.length>1?r.localize(4,null,y,f.length):y}if(L.isString(w))return w;if(w.detail){const f=w.detail;if(f.error)return _(f.error,S);if(f.exception)return _(f.exception,S)}return w.stack?_(w,S):w.message?w.message:r.localize(5,null)}e.toErrorMessage=h;function a(w){const S=w;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=a;function g(w,S){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=S,f}e.createErrorWithActions=g}),define(ee[149],te([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ee[150],te([0,1,149]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[151],te([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,151]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,_=!1,M=!1,C=!1,h=!1,a=!1,g=!1,w=!1,S=!1,f,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,p,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const c=typeof d?.versions?.electron=="string",E=c&&d?.type==="renderer";if(typeof navigator=="object"&&!E)m=navigator.userAgent,L=m.indexOf("Windows")>=0,r=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,h=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,y=f,v=navigator.language;else if(typeof d=="object"){L=d.platform==="win32",r=d.platform==="darwin",_=d.platform==="linux",M=_&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,a=c,w=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const D=d.env.VSCODE_NLS_CONFIG;if(D)try{const R=JSON.parse(D),P=R.availableLanguages["*"];f=R.locale,v=R.osLocale,y=P||e.LANGUAGE_DEFAULT,p=R._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var u;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let l=0;r?l=1:L?l=3:_&&(l=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=_,e.isLinuxSnap=M,e.isNative=C,e.isElectron=a,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=g,e.isMobile=S,e.isCI=w,e.platform=l,e.userAgent=m,e.language=y;var s;(function(D){function R(){return e.language}D.value=R;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=P;function k(){return e.language==="en"}D.isDefault=k})(s||(e.Language=s={})),e.locale=f,e.platformLocale=v,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let k=0,O=D.length;k<O;k++){const F=D[k];if(F.id===P.data.vscodeScheduleAsyncWork){D.splice(k,1),F.callback();return}}});let R=0;return P=>{const k=++R;D.push({id:k,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||g?2:L?1:3;let n=!0,o=!1;function b(){if(!o){o=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,n=new Uint16Array(D.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=b,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const r=I.globals.vscode.process;L={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,35]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,_=90,M=122,C=46,h=47,a=92,g=58,w=63;class S extends Error{constructor(l,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let b=`The "${l}" ${o} ${n} of type ${s}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,l){if(t===null||typeof t!="object")throw new S(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new S(l,"string",t)}const v=I.platform==="win32";function p(t){return t===h||t===a}function m(t){return t===h}function d(t){return t>=L&&t<=_||t>=r&&t<=M}function c(t,l,s,i){let n="",o=0,b=-1,D=0,R=0;for(let P=0;P<=t.length;++P){if(P<t.length)R=t.charCodeAt(P);else{if(i(R))break;R=h}if(i(R)){if(!(b===P-1||D===1))if(D===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const k=n.lastIndexOf(s);k===-1?(n="",o=0):(n=n.slice(0,k),o=n.length-1-n.lastIndexOf(s)),b=P,D=0;continue}else if(n.length!==0){n="",o=0,b=P,D=0;continue}}l&&(n+=n.length>0?`${s}..`:"..",o=2)}else n.length>0?n+=`${s}${t.slice(b+1,P)}`:n=t.slice(b+1,P),o=P-b-1;b=P,D=0}else R===C&&D!==-1?++D:D=-1}return n}function E(t,l){f(l,"pathObject");const s=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let l="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=I.cwd():(o=I.env[`=${l}`]||I.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===a)&&(o=`${l}\\`));const b=o.length;let D=0,R="",P=!1;const k=o.charCodeAt(0);if(b===1)p(k)&&(D=1,P=!0);else if(p(k))if(P=!0,p(o.charCodeAt(1))){let O=2,F=O;for(;O<b&&!p(o.charCodeAt(O));)O++;if(O<b&&O!==F){const $=o.slice(F,O);for(F=O;O<b&&p(o.charCodeAt(O));)O++;if(O<b&&O!==F){for(F=O;O<b&&!p(o.charCodeAt(O));)O++;(O===b||O!==F)&&(R=`\\\\${$}\\${o.slice(F,O)}`,D=O)}}}else D=1;else d(k)&&o.charCodeAt(1)===g&&(R=o.slice(0,2),D=2,b>2&&p(o.charCodeAt(2))&&(P=!0,D=3));if(R.length>0)if(l.length>0){if(R.toLowerCase()!==l.toLowerCase())continue}else l=R;if(i){if(l.length>0)break}else if(s=`${o.slice(D)}\\${s}`,i=P,P&&l.length>0)break}return s=c(s,!i,"\\",p),i?`${l}\\${s}`:`${l}${s}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let s=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return m(o)?"\\":t;if(p(o))if(n=!0,p(t.charCodeAt(1))){let D=2,R=D;for(;D<l&&!p(t.charCodeAt(D));)D++;if(D<l&&D!==R){const P=t.slice(R,D);for(R=D;D<l&&p(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&!p(t.charCodeAt(D));)D++;if(D===l)return`\\\\${P}\\${t.slice(R)}\\`;D!==R&&(i=`\\\\${P}\\${t.slice(R,D)}`,s=D)}}}else s=1;else d(o)&&t.charCodeAt(1)===g&&(i=t.slice(0,2),s=2,l>2&&p(t.charCodeAt(2))&&(n=!0,s=3));let b=s<l?c(t.slice(s),!n,"\\",p):"";return b.length===0&&!n&&(b="."),b.length>0&&p(t.charCodeAt(l-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const s=t.charCodeAt(0);return p(s)||l>2&&d(s)&&t.charCodeAt(1)===g&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,s;for(let o=0;o<t.length;++o){const b=t[o];y(b,"path"),b.length>0&&(l===void 0?l=s=b:l+=`\\${b}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++n;const o=s.length;o>1&&p(s.charCodeAt(1))&&(++n,o>2&&(p(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&p(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const s=e.win32.resolve(t),i=e.win32.resolve(l);if(s===i||(t=s.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===a;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===a;)o--;const b=o-n;let D=0;for(;D<l.length&&l.charCodeAt(D)===a;)D++;let R=l.length;for(;R-1>D&&l.charCodeAt(R-1)===a;)R--;const P=R-D,k=b<P?b:P;let O=-1,F=0;for(;F<k;F++){const re=t.charCodeAt(n+F);if(re!==l.charCodeAt(D+F))break;re===a&&(O=F)}if(F!==k){if(O===-1)return i}else{if(P>k){if(l.charCodeAt(D+F)===a)return i.slice(D+F+1);if(F===2)return i.slice(D+F)}b>k&&(t.charCodeAt(n+F)===a?O=F:F===2&&(O=3)),O===-1&&(O=0)}let $="";for(F=n+O+1;F<=o;++F)(F===o||t.charCodeAt(F)===a)&&($+=$.length===0?"..":"\\..");return D+=O,$.length>0?`${$}${i.slice(D,R)}`:(i.charCodeAt(D)===a&&++D,i.slice(D,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const s=l.charCodeAt(2);if(s!==w&&s!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(d(l.charCodeAt(0))&&l.charCodeAt(1)===g&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(l===1)return p(n)?t:".";if(p(n)){if(s=i=1,p(t.charCodeAt(1))){let D=2,R=D;for(;D<l&&!p(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&p(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&!p(t.charCodeAt(D));)D++;if(D===l)return t;D!==R&&(s=i=D+1)}}}}else d(n)&&t.charCodeAt(1)===g&&(s=l>2&&p(t.charCodeAt(2))?3:2,i=s);let o=-1,b=!0;for(let D=l-1;D>=i;--D)if(p(t.charCodeAt(D))){if(!b){o=D;break}}else b=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let s=0,i=-1,n=!0,o;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(s=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let b=l.length-1,D=-1;for(o=t.length-1;o>=s;--o){const R=t.charCodeAt(o);if(p(R)){if(!n){s=o+1;break}}else D===-1&&(n=!1,D=o+1),b>=0&&(R===l.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=s;--o)if(p(t.charCodeAt(o))){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let l=0,s=-1,i=0,n=-1,o=!0,b=0;t.length>=2&&t.charCodeAt(1)===g&&d(t.charCodeAt(0))&&(l=i=2);for(let D=t.length-1;D>=l;--D){const R=t.charCodeAt(D);if(p(R)){if(!o){i=D+1;break}continue}n===-1&&(o=!1,n=D+1),R===C?s===-1?s=D:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||n===-1||b===0||b===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return p(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(p(n)){if(i=1,p(t.charCodeAt(1))){let O=2,F=O;for(;O<s&&!p(t.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&p(t.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&!p(t.charCodeAt(O));)O++;O===s?i=O:O!==F&&(i=O+1)}}}}else if(d(n)&&t.charCodeAt(1)===g){if(s<=2)return l.root=l.dir=t,l;if(i=2,p(t.charCodeAt(2))){if(s===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,b=i,D=-1,R=!0,P=t.length-1,k=0;for(;P>=i;--P){if(n=t.charCodeAt(P),p(n)){if(!R){b=P+1;break}continue}D===-1&&(R=!1,D=P+1),n===C?o===-1?o=P:k!==1&&(k=1):o!==-1&&(k=-1)}return D!==-1&&(o===-1||k===0||k===1&&o===D-1&&o===b+1?l.base=l.name=t.slice(b,D):(l.name=t.slice(b,o),l.base=t.slice(b,D),l.ext=t.slice(o,D))),b>0&&b!==i?l.dir=t.slice(0,b-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(v){const t=/\\/g;return()=>{const l=I.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let l="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,s=n.charCodeAt(0)===h)}return l=c(l,!s,"/",m),s?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=c(t,!l,"/",m),t.length===0?l?"/":s?"./":".":(s&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let l;for(let s=0;s<t.length;++s){const i=t[s];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const s=1,i=t.length,n=i-s,o=1,b=l.length-o,D=n<b?n:b;let R=-1,P=0;for(;P<D;P++){const O=t.charCodeAt(s+P);if(O!==l.charCodeAt(o+P))break;O===h&&(R=P)}if(P===D)if(b>D){if(l.charCodeAt(o+P)===h)return l.slice(o+P+1);if(P===0)return l.slice(o+P)}else n>D&&(t.charCodeAt(s+P)===h?R=P:P===0&&(R=0));let k="";for(P=s+R+1;P<=i;++P)(P===i||t.charCodeAt(P)===h)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(o+R)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){s=n;break}}else i=!1;return s===-1?l?"/":".":l&&s===1?"//":t.slice(0,s)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let s=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let b=l.length-1,D=-1;for(o=t.length-1;o>=0;--o){const R=t.charCodeAt(o);if(R===h){if(!n){s=o+1;break}}else D===-1&&(n=!1,D=o+1),b>=0&&(R===l.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===h){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let l=-1,s=0,i=-1,n=!0,o=0;for(let b=t.length-1;b>=0;--b){const D=t.charCodeAt(b);if(D===h){if(!n){s=b+1;break}continue}i===-1&&(n=!1,i=b+1),D===C?l===-1?l=b:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===s+1?"":t.slice(l,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.charCodeAt(0)===h;let i;s?(l.root="/",i=1):i=0;let n=-1,o=0,b=-1,D=!0,R=t.length-1,P=0;for(;R>=i;--R){const k=t.charCodeAt(R);if(k===h){if(!D){o=R+1;break}continue}b===-1&&(D=!1,b=R+1),k===C?n===-1?n=R:P!==1&&(P=1):n!==-1&&(P=-1)}if(b!==-1){const k=o===0&&s?1:o;n===-1||P===0||P===1&&n===b-1&&n===o+1?l.base=l.name=t.slice(k,b):(l.name=t.slice(k,n),l.base=t.slice(k,b),l.ext=t.slice(n,b))}return o>0?l.dir=t.slice(0,o-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[33],te([0,1,9,4,27,12]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function C(o){return o.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function h(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function a(o,b=I.posix.sep){if(!o)return"";const D=o.length,R=o.charCodeAt(0);if(M(R)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let k=3;const O=k;for(;k<D&&!M(o.charCodeAt(k));k++);if(O!==k&&!M(o.charCodeAt(k+1))){for(k+=1;k<D;k++)if(M(o.charCodeAt(k)))return o.slice(0,k+1).replace(/[\\/]/g,b)}}return b}else if(m(R)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+b:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<D;P++)if(M(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.getRoot=a;function g(o){if(!L.isWindows||!o||o.length<5)return!1;let b=o.charCodeAt(0);if(b!==92||(b=o.charCodeAt(1),b!==92))return!1;let D=2;const R=D;for(;D<o.length&&(b=o.charCodeAt(D),b!==92);D++);return!(R===D||(b=o.charCodeAt(D+1),isNaN(b)||b===92))}e.isUNC=g;const w=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,b=L.isWindows){const D=b?w:S;return!(!o||o.length===0||/^\s+$/.test(o)||(D.lastIndex=0,D.test(o))||b&&f.test(o)||o==="."||o===".."||b&&o[o.length-1]==="."||b&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=y;function v(o,b,D){const R=o===b;return!D||R?R:!o||!b?!1:(0,r.equalsIgnoreCase)(o,b)}e.isEqual=v;function p(o,b,D,R=I.sep){if(o===b)return!0;if(!o||!b||b.length>o.length)return!1;if(D){if(!(0,r.startsWithIgnoreCase)(o,b))return!1;if(b.length===o.length)return!0;let k=b.length;return b.charAt(b.length-1)===R&&k--,o.charAt(k)===R}return b.charAt(b.length-1)!==R&&(b+=R),o.indexOf(b)===0}e.isEqualOrParent=p;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function d(o,b){return L.isWindows&&o.endsWith(":")&&(o+=I.sep),(0,I.isAbsolute)(o)||(o=(0,I.join)(b,o)),o=(0,I.normalize)(o),L.isWindows?(o=(0,r.rtrim)(o,I.sep),o.endsWith(":")&&(o+=I.sep)):(o=(0,r.rtrim)(o,I.sep),o||(o=I.sep)),o}e.sanitizeFilePath=d;function c(o){const b=(0,I.normalize)(o);return L.isWindows?o.length>3?!1:E(b)&&(o.length===2||b.charCodeAt(2)===92):b===I.posix.sep}e.isRootOrDriveLetter=c;function E(o,b=L.isWindows){return b?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function u(o,b=L.isWindows){return E(o,b)?o[0]:void 0}e.getDriveLetter=u;function t(o,b,D){return b.length>o.length?-1:o===b?0:(D&&(o=o.toLowerCase(),b=b.toLowerCase()),o.indexOf(b))}e.indexOfPath=t;function l(o){const b=o.split(":");let D,R,P;for(const k of b){const O=Number(k);(0,_.isNumber)(O)?R===void 0?R=O:P===void 0&&(P=O):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:R!==void 0?R:void 0,column:P!==void 0?P:R!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,b,D=8){let R="";for(let k=0;k<D;k++){let O;k===0&&L.isWindows&&!b&&(D===3||D===4)?O=i:O=s,R+=O.charAt(Math.floor(Math.random()*O.length))}let P;return b?P=`${b}-${R}`:P=R,o?(0,I.join)(o,P):P}e.randomPath=n}),define(ee[73],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function _(C,...h){const a=h.reduce((S,f)=>(S[f]=!0,S),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(S=>!a[S]).forEach(S=>{for(let f=0;f<g.length;f++)if(S.search(g[f])!==-1){delete C[S];break}})}e.sanitizeProcessEnvironment=_;function M(C){C&&(delete C.DEBUG,I.isMacintosh&&delete C.DYLD_LIBRARY_PATH,I.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[7],te([0,1,9,4]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,_=/^\//,M=/^\/\//;function C(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function a(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const g="",w="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,b,D,R,P=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=h(n,P),this.authority=o||g,this.path=a(this.scheme,b||g),this.query=D||g,this.fragment=R||g,C(this,P))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:b,path:D,query:R,fragment:P}=n;return o===void 0?o=this.scheme:o===null&&(o=g),b===void 0?b=this.authority:b===null&&(b=g),D===void 0?D=this.path:D===null&&(D=g),R===void 0?R=this.query:R===null&&(R=g),P===void 0?P=this.fragment:P===null&&(P=g),o===this.scheme&&b===this.authority&&D===this.path&&R===this.query&&P===this.fragment?this:new p(o,b,D,R,P)}static parse(n,o=!1){const b=S.exec(n);return b?new p(b[2]||g,s(b[4]||g),s(b[5]||g),s(b[7]||g),s(b[9]||g),o):new p(g,g,g,g,g)}static file(n){let o=g;if(L.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const b=n.indexOf(w,2);b===-1?(o=n.substring(2),n=w):(o=n.substring(2,b),n=n.substring(b)||w)}return new p("file",o,n,g,g)}static from(n,o){return new p(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.isWindows&&n.scheme==="file"?b=f.file(I.win32.join(E(n,!0),...o)).path:b=I.posix.join(n.path,...o),n.with({path:b})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new p(n);return o._formatted=n.external??null,o._fsPath=n._sep===v?n.fsPath??null:null,o}}else return n}}e.URI=f;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const v=L.isWindows?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=v),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,n,o){let b,D=-1;for(let R=0;R<i.length;R++){const P=i.charCodeAt(R);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||o&&P===91||o&&P===93||o&&P===58)D!==-1&&(b+=encodeURIComponent(i.substring(D,R)),D=-1),b!==void 0&&(b+=i.charAt(R));else{b===void 0&&(b=i.substr(0,R));const k=m[P];k!==void 0?(D!==-1&&(b+=encodeURIComponent(i.substring(D,R)),D=-1),b+=k):D===-1&&(D=R)}}return D!==-1&&(b+=encodeURIComponent(i.substring(D))),b!==void 0?b:i}function c(i){let n;for(let o=0;o<i.length;o++){const b=i.charCodeAt(o);b===35||b===63?(n===void 0&&(n=i.substr(0,o)),n+=m[b]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=E;function u(i,n){const o=n?c:d;let b="",{scheme:D,authority:R,path:P,query:k,fragment:O}=i;if(D&&(b+=D,b+=":"),(R||D==="file")&&(b+=w,b+=w),R){let F=R.indexOf("@");if(F!==-1){const $=R.substr(0,F);R=R.substr(F+1),F=$.lastIndexOf(":"),F===-1?b+=o($,!1,!1):(b+=o($.substr(0,F),!1,!1),b+=":",b+=o($.substr(F+1),!1,!0)),b+="@"}R=R.toLowerCase(),F=R.lastIndexOf(":"),F===-1?b+=o(R,!1,!0):(b+=o(R.substr(0,F),!1,!0),b+=R.substr(F))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const F=P.charCodeAt(1);F>=65&&F<=90&&(P=`/${String.fromCharCode(F+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const F=P.charCodeAt(0);F>=65&&F<=90&&(P=`${String.fromCharCode(F+32)}:${P.substr(2)}`)}b+=o(P,!0,!1)}return k&&(b+="?",b+=o(k,!1,!1)),O&&(b+="#",b+=n?O:d(O,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(ee[152],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.isRemoteConsoleLog=L;function r(a){const g=[];let w;try{const S=JSON.parse(a.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),w=f.__$stack),g.push(...S)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:w}}e.parse=r;function _(a){if(typeof a!="string")return _(r(a).stack);const g=a;if(g){const w=M(g),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(S&&S.length===4)return{uri:I.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=_;function M(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function C(a,g){const{args:w,stack:S}=r(a),f=typeof w[0]=="string"&&w.length===1;let y=M(S);y&&(y=`(${y.trim()})`);let v=[];if(typeof w[0]=="string"?y&&f?v=[`%c[${g}] %c${w[0]} %c${y}`,h("blue"),h(""),h("grey")]:v=[`%c[${g}] %c${w[0]}`,h("blue"),h(""),...w.slice(1)]:v=[`%c[${g}]%`,h("blue"),...w],y&&!f&&v.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,v)}e.log=C;function h(a){return`color: ${a}`}}),define(ee[74],te([0,1,18,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(h){return JSON.stringify(h,M)}e.stringify=r;function _(h){let a=JSON.parse(h);return a=C(a),a}e.parse=_;function M(h,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function C(h,a=0){if(!h||a>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return L.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof I.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let g=0;g<h.length;++g)h[g]=C(h[g],a+1);else for(const g in h)Object.hasOwnProperty.call(h,g)&&(h[g]=C(h[g],a+1))}return h}e.revive=C}),define(ee[13],te([0,1,14,4,7]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${_.vscodeRemoteResource}`}set(g,w,S){this._hosts[g]=w,this._ports[g]=S}setConnectionToken(g,w){this._connectionTokens[g]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(p){return I.onUnexpectedError(p),g}const w=g.authority;let S=this._hosts[w];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const f=this._ports[w],y=this._connectionTokens[w];let v=`path=${encodeURIComponent(g.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),r.URI.from({scheme:L.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${S}:${f}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class C{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const w=this.toUri(g,K);return this.uriToBrowserUri(w)}uriToBrowserUri(g){return g.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===_.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${_.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?g.with({scheme:_.vscodeFileResource,authority:g.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const w=this.toUri(g,K);return this.uriToFileUri(w)}uriToFileUri(g){return g.scheme===_.vscodeFileResource?g.with({scheme:_.file,authority:g.authority!==C.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,w){return r.URI.isUri(g)?g:r.URI.parse(w.toUrl(g))}}e.FileAccess=new C;var h;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const w="vscode-coi";function S(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:r.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const p=v?.get(w);if(p)return g.get(p)}a.getHeadersFromQuery=S;function f(y,v,p){if(!globalThis.crossOriginIsolated)return;const m=v&&p?"3":p?"2":"1";y instanceof URLSearchParams?y.set(w,m):y[w]=m}a.addSearchParam=f})(h||(e.COI=h={}))}),define(ee[19],te([0,1,33,13,9,4,27,7]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=h;class a{constructor(y){this._ignorePathCasing=y}compare(y,v,p=!1){return y===v?0:(0,M.compare)(this.getComparisonKey(y,p),this.getComparisonKey(v,p))}isEqual(y,v,p=!1){return y===v?!0:!y||!v?!1:this.getComparisonKey(y,p)===this.getComparisonKey(v,p)}getComparisonKey(y,v=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,v,p=!1){if(y.scheme===v.scheme){if(y.scheme===L.Schemas.file)return I.isEqualOrParent(h(y),h(v),this._ignorePathCasing(y))&&y.query===v.query&&(p||y.fragment===v.fragment);if((0,e.isEqualAuthority)(y.authority,v.authority))return I.isEqualOrParent(y.path,v.path,this._ignorePathCasing(y),"/")&&y.query===v.query&&(p||y.fragment===v.fragment)}return!1}joinPath(y,...v){return C.URI.joinPath(y,...v)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return r.posix.basename(y.path)}extname(y){return r.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let v;return y.scheme===L.Schemas.file?v=C.URI.file(r.dirname(h(y))).path:(v=r.posix.dirname(y.path),y.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),v="/")),y.with({path:v})}normalizePath(y){if(!y.path.length)return y;let v;return y.scheme===L.Schemas.file?v=C.URI.file(r.normalize(h(y))).path:v=r.posix.normalize(y.path),y.with({path:v})}relativePath(y,v){if(y.scheme!==v.scheme||!(0,e.isEqualAuthority)(y.authority,v.authority))return;if(y.scheme===L.Schemas.file){const d=r.relative(h(y),h(v));return _.isWindows?I.toSlashes(d):d}let p=y.path||"/";const m=v.path||"/";if(this._ignorePathCasing(y)){let d=0;for(const c=Math.min(p.length,m.length);d<c&&!(p.charCodeAt(d)!==m.charCodeAt(d)&&p.charAt(d).toLowerCase()!==m.charAt(d).toLowerCase());d++);p=m.substr(0,d)+p.substr(d)}return r.posix.relative(p,m)}resolvePath(y,v){if(y.scheme===L.Schemas.file){const p=C.URI.file(r.resolve(h(y),v));return y.with({authority:p.authority,path:p.path})}return v=I.toPosixPath(v),y.with({path:r.posix.resolve(y.path,v)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,v){return y===v||y!==void 0&&v!==void 0&&(0,M.equalsIgnoreCase)(y,v)}hasTrailingPathSeparator(y,v=r.sep){if(y.scheme===L.Schemas.file){const p=h(y);return p.length>I.getRoot(p).length&&p[p.length-1]===v}else{const p=y.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,v=r.sep){return(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,v=r.sep){let p=!1;if(y.scheme===L.Schemas.file){const m=h(y);p=m!==void 0&&m.length===I.getRoot(m).length&&m[m.length-1]===v}else{v="/";const m=y.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path+"/"}):y}}e.ExtUri=a,e.extUri=new a(()=>!1),e.extUriBiasedIgnorePathCase=new a(f=>f.scheme===L.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new a(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function g(f,y){const v=[];for(let p=0;p<f.length;p++){const m=y(f[p]);f.some((d,c)=>c===p?!1:(0,e.isEqualOrParent)(m,y(d)))||v.push(f[p])}return v}e.distinctParents=g;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[E,u]=c.split(":");E&&u&&p.set(E,u)});const d=v.path.substring(0,v.path.indexOf(";"));return d&&p.set(f.META_DATA_MIME,d),p}f.parseMetaData=y})(w||(e.DataUri=w={}));function S(f,y,v){if(y){let p=f.path;return p&&p[0]!==r.posix.sep&&(p=r.posix.sep+p),f.with({scheme:v,authority:y,path:p})}return f.with({scheme:v})}e.toLocalResource=S}),define(ee[8],te([0,1,22,14,3,2,19,4,141]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function a(A){return!!A&&typeof A.then=="function"}e.isThenable=a;function g(A){const T=new I.CancellationTokenSource,q=A(T.token),B=new Promise((z,j)=>{const ce=T.token.onCancellationRequested(()=>{ce.dispose(),T.dispose(),j(new L.CancellationError)});Promise.resolve(q).then(fe=>{ce.dispose(),T.dispose(),z(fe)},fe=>{ce.dispose(),T.dispose(),j(fe)})});return new class{cancel(){T.cancel()}then(z,j){return B.then(z,j)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=g;function w(A,T,q){return new Promise((B,z)=>{const j=T.onCancellationRequested(()=>{j.dispose(),B(q)});A.then(B,z).finally(()=>j.dispose())})}e.raceCancellation=w;function S(A,T){return new Promise((q,B)=>{const z=T.onCancellationRequested(()=>{z.dispose(),B(new L.CancellationError)});A.then(q,B).finally(()=>z.dispose())})}e.raceCancellationError=S;async function f(A){let T=-1;const q=A.map((B,z)=>B.then(j=>(T=z,j)));try{return await Promise.race(q)}finally{A.forEach((B,z)=>{z!==T&&B.cancel()})}}e.raceCancellablePromises=f;function y(A,T,q){let B;const z=setTimeout(()=>{B?.(void 0),q?.()},T);return Promise.race([A.finally(()=>clearTimeout(z)),new Promise(j=>B=j)])}e.raceTimeout=y;function v(A){return new Promise((T,q)=>{const B=A();a(B)?B.then(T,q):T(B)})}e.asPromise=v;class p{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const q=()=>{if(this.queuedPromise=null,this.isDisposed)return;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(q,q).then(B)})}return new Promise((q,B)=>{this.queuedPromise.then(q,B)})}return this.activePromise=T(),new Promise((q,B)=>{this.activePromise.then(z=>{this.activePromise=null,q(z)},z=>{this.activePromise=null,B(z)})})}dispose(){this.isDisposed=!0}}e.Throttler=p;class m{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=m;class d{constructor(){this.promiseMap=new Map}queue(T,q){const z=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(T)===z&&this.promiseMap.delete(T)});return this.promiseMap.set(T,z),z}}e.SequencerByKey=d;const c=(A,T)=>{let q=!0;const B=setTimeout(()=>{q=!1,T()},A);return{isTriggered:()=>q,dispose:()=>{clearTimeout(B),q=!1}}},E=A=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,A())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class u{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,q=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,j)=>{this.doResolve=z,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=q===h.MicrotaskDelay?E(B):c(q,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class t{constructor(T){this.delayer=new u(T),this.throttler=new p}trigger(T,q){return this.delayer.trigger(()=>this.throttler.queue(T),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class l{constructor(){this._isOpen=!1,this._promise=new Promise((T,q)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class s extends l{constructor(T){super(),this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(A,T){return T?new Promise((q,B)=>{const z=setTimeout(()=>{j.dispose(),q()},A),j=T.onCancellationRequested(()=>{clearTimeout(z),j.dispose(),B(new L.CancellationError)})}):g(q=>i(A,q))}e.timeout=i;function n(A,T=0,q){const B=setTimeout(()=>{A(),q&&z.dispose()},T),z=(0,_.toDisposable)(()=>{clearTimeout(B),q?.deleteAndLeak(z)});return q?.add(z),z}e.disposableTimeout=n;function o(A){const T=[];let q=0;const B=A.length;function z(){return q<B?A[q++]():null}function j(ce){ce!=null&&T.push(ce);const fe=z();return fe?fe.then(j):Promise.resolve(T)}return Promise.resolve(null).then(j)}e.sequence=o;function b(A,T=B=>!!B,q=null){let B=0;const z=A.length,j=()=>{if(B>=z)return Promise.resolve(q);const ce=A[B++];return Promise.resolve(ce()).then(ue=>T(ue)?Promise.resolve(ue):j())};return j()}e.first=b;function D(A,T=B=>!!B,q=null){if(A.length===0)return Promise.resolve(q);let B=A.length;const z=()=>{B=-1;for(const j of A)j.cancel?.()};return new Promise((j,ce)=>{for(const fe of A)fe.then(ue=>{--B>=0&&T(ue)?(z(),j(ue)):B===0&&j(q)}).catch(ue=>{--B>=0&&(z(),ce(ue))})})}e.firstParallel=D;class R{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(T){return this._size++,new Promise((q,B)=>{this.outstandingPromises.push({factory:T,c:q,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const q=T.factory();q.then(T.c,T.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=R;class P extends R{constructor(){super(1)}}e.Queue=P;class k{constructor(){this.sequentializer=new V,this.tasks=0}queue(T){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,T())):this.sequentializer.run(this.tasks++,T())}}e.LimitedQueue=k;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const T=new U;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueFor(T,q=M.extUri){const B=q.getComparisonKey(T);let z=this.queues.get(B);if(!z){z=new P;const j=this.drainListenerCount++,ce=r.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(j),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new _.DisposableMap),this.drainListeners.set(j,ce),this.queues.set(B,z)}return z}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class F{constructor(T,q){this._token=-1,typeof T=="function"&&typeof q=="number"&&this.setIfNotSet(T,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},q)}setIfNotSet(T,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},q))}}e.TimeoutTimer=F;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,q){this.cancel(),this._token=setInterval(()=>{T()},q)}}e.IntervalTimer=$;class re{constructor(T,q){this.timeoutToken=-1,this.runner=T,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=re;class J{constructor(T,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=J;class ae extends re{constructor(T,q){super(T,q),this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner?.(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ae;class ne extends _.Disposable{constructor(T,q){super(),this.options=T,this.handler=q,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const q of T)this.pendingWork.push(q);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new re(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=A=>{(0,C.setTimeout0)(()=>{if(T)return;const q=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(A,T)=>{const q=requestIdleCallback(A,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(q))}}}}();class se{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function G(A,T,q){let B;for(let z=0;z<q;z++)try{return await A()}catch(j){B=j,await i(T)}throw B}e.retry=G;class V{isRunning(T){return typeof T=="number"?this._running?.taskId===T:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(T,q,B){return this._running={taskId:T,cancel:()=>B?.(),promise:q},q.then(()=>this.doneRunning(T),()=>this.doneRunning(T)),q}doneRunning(T){this._running&&T===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const T=this._queued;this._queued=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this._queued)this._queued.run=T;else{let q,B;const z=new Promise((j,ce)=>{q=j,B=ce});this._queued={run:T,promise:z,promiseResolve:q,promiseReject:B}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=V;class x{constructor(T,q=()=>Date.now()){this.interval=T,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=x;var W;(function(A){A[A.Resolved=0]="Resolved",A[A.Rejected=1]="Rejected"})(W||(W={}));class U{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((T,q)=>{this.completeCallback=T,this.errorCallback=q})}complete(T){return new Promise(q=>{this.completeCallback(T),this.outcome={outcome:0,value:T},q()})}error(T){return new Promise(q=>{this.errorCallback(T),this.outcome={outcome:1,value:T},q()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=U;var H;(function(A){async function T(B){let z;const j=await Promise.all(B.map(ce=>ce.then(fe=>fe,fe=>{z||(z=fe)})));if(typeof z<"u")throw z;return j}A.settled=T;function q(B){return new Promise(async(z,j)=>{try{await B(z,j)}catch(ce){j(ce)}})}A.withAsyncBody=q})(H||(e.Promises=H={}));var Q;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(Q||(Q={}));class ie{static fromArray(T){return new ie(q=>{q.emitMany(T)})}static fromPromise(T){return new ie(async q=>{q.emitMany(await T)})}static fromPromises(T){return new ie(async q=>{await Promise.all(T.map(async B=>q.emitOne(await B)))})}static merge(T){return new ie(async q=>{await Promise.all(T.map(async B=>{for await(const z of B)q.emitOne(z)}))})}static{this.EMPTY=ie.fromArray([])}constructor(T){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const q={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(T(q)),this.resolve()}catch(B){this.reject(B)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(T,q){return new ie(async B=>{for await(const z of T)B.emitOne(q(z))})}map(T){return ie.map(this,T)}static filter(T,q){return new ie(async B=>{for await(const z of T)q(z)&&B.emitOne(z)})}filter(T){return ie.filter(this,T)}static coalesce(T){return ie.filter(T,q=>!!q)}coalesce(){return ie.coalesce(this)}static async toPromise(T){const q=[];for await(const B of T)q.push(B);return q}toPromise(){return ie.toPromise(this)}emitOne(T){this._state===0&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===0&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(T){this._state===0&&(this._state=2,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class oe extends ie{constructor(T,q){super(q),this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function N(A){const T=new I.CancellationTokenSource,q=A(T.token);return new oe(T,async B=>{const z=T.token.onCancellationRequested(()=>{z.dispose(),T.dispose(),B.reject(new L.CancellationError)});try{for await(const j of q){if(T.token.isCancellationRequested)return;B.emitOne(j)}z.dispose(),T.dispose()}catch(j){z.dispose(),T.dispose(),B.reject(j)}})}e.createCancelableAsyncIterable=N}),define(ee[104],te([0,1,23,8,33,31,9,4,27]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function a(){return Object.create(null)}e.getEmptyExpression=a,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const g="[/\\\\]",w="[^/\\\\]",S=/\//g;function f(V,x){switch(V){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}${x?`|${g}${w}+`:""})*?`}}function y(V,x){if(!V)return[];const W=[];let U=!1,H=!1,Q="";for(const ie of V){switch(ie){case x:if(!U&&!H){W.push(Q),Q="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=ie}return Q&&W.push(Q),W}e.splitGlobAware=y;function v(V){if(!V)return"";let x="";const W=y(V,e.GLOB_SPLIT);if(W.every(U=>U===e.GLOBSTAR))x=".*";else{let U=!1;W.forEach((H,Q)=>{if(H===e.GLOBSTAR){if(U)return;x+=f(2,Q===W.length-1)}else{let ie=!1,oe="",N=!1,A="";for(const T of H){if(T!=="}"&&ie){oe+=T;continue}if(N&&(T!=="]"||!A)){let q;T==="-"?q=T:(T==="^"||T==="!")&&!A?q="^":T===e.GLOB_SPLIT?q="":q=(0,h.escapeRegExpCharacters)(T),A+=q;continue}switch(T){case"{":ie=!0;continue;case"[":N=!0;continue;case"}":{const B=`(?:${y(oe,",").map(z=>v(z)).join("|")})`;x+=B,ie=!1,oe="";break}case"]":{x+="["+A+"]",N=!1,A="";break}case"?":x+=w;continue;case"*":x+=f(1);continue;default:x+=(0,h.escapeRegExpCharacters)(T)}}Q<W.length-1&&(W[Q+1]!==e.GLOBSTAR||Q+2<W.length)&&(x+=g)}U=H===e.GLOBSTAR})}return x}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),l=function(){return!1},s=function(){return null};function i(V,x){if(!V)return s;let W;typeof V!="string"?W=V.pattern:W=V,W=W.trim();const U=`${W}_${!!x.trimForExclusions}`;let H=t.get(U);if(H)return n(H,V);let Q;return p.test(W)?H=b(W.substr(4),W):(Q=m.exec(o(W,x)))?H=D(Q[1],W):(x.trimForExclusions?c:d).test(W)?H=R(W,x):(Q=E.exec(o(W,x)))?H=P(Q[1].substr(1),W,!0):(Q=u.exec(o(W,x)))?H=P(Q[1],W,!1):H=k(W),t.set(U,H),n(H,V)}function n(V,x){if(typeof x=="string")return V;const W=function(U,H){return(0,r.isEqualOrParent)(U,x.base,!C.isLinux)?V((0,h.ltrim)(U.substr(x.base.length),M.sep),H):null};return W.allBasenames=V.allBasenames,W.allPaths=V.allPaths,W.basenames=V.basenames,W.patterns=V.patterns,W}function o(V,x){return x.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function b(V,x){return function(W,U){return typeof W=="string"&&W.endsWith(V)?x:null}}function D(V,x){const W=`/${V}`,U=`\\${V}`,H=function(ie,oe){return typeof ie!="string"?null:oe?oe===V?x:null:ie===V||ie.endsWith(W)||ie.endsWith(U)?x:null},Q=[V];return H.basenames=Q,H.patterns=[x],H.allBasenames=Q,H}function R(V,x){const W=se(V.slice(1,-1).split(",").map(oe=>i(oe,x)).filter(oe=>oe!==s),V),U=W.length;if(!U)return s;if(U===1)return W[0];const H=function(oe,N){for(let A=0,T=W.length;A<T;A++)if(W[A](oe,N))return V;return null},Q=W.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ie=W.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function P(V,x,W){const U=M.sep===M.posix.sep,H=U?V:V.replace(S,M.sep),Q=M.sep+H,ie=M.posix.sep+V;let oe;return W?oe=function(N,A){return typeof N=="string"&&(N===H||N.endsWith(Q)||!U&&(N===V||N.endsWith(ie)))?x:null}:oe=function(N,A){return typeof N=="string"&&(N===H||!U&&N===V)?x:null},oe.allPaths=[(W?"*/":"./")+V],oe}function k(V){try{const x=new RegExp(`^${v(V)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?V:null}}catch{return s}}function O(V,x,W){return!V||typeof x!="string"?!1:F(V)(x,void 0,W)}e.match=O;function F(V,x={}){if(!V)return l;if(typeof V=="string"||$(V)){const W=i(V,x);if(W===s)return l;const U=function(H,Q){return!!W(H,Q)};return W.allBasenames&&(U.allBasenames=W.allBasenames),W.allPaths&&(U.allPaths=W.allPaths),U}return ae(V,x)}e.parse=F;function $(V){const x=V;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=$;function re(V){return V.allBasenames||[]}e.getBasenameTerms=re;function J(V){return V.allPaths||[]}e.getPathTerms=J;function ae(V,x){const W=se(Object.getOwnPropertyNames(V).map(oe=>ne(oe,V[oe],x)).filter(oe=>oe!==s)),U=W.length;if(!U)return s;if(!W.some(oe=>!!oe.requiresSiblings)){if(U===1)return W[0];const oe=function(T,q){let B;for(let z=0,j=W.length;z<j;z++){const ce=W[z](T,q);if(typeof ce=="string")return ce;(0,L.isThenable)(ce)&&(B||(B=[]),B.push(ce))}return B?(async()=>{for(const z of B){const j=await z;if(typeof j=="string")return j}return null})():null},N=W.find(T=>!!T.allBasenames);N&&(oe.allBasenames=N.allBasenames);const A=W.reduce((T,q)=>q.allPaths?T.concat(q.allPaths):T,[]);return A.length&&(oe.allPaths=A),oe}const H=function(oe,N,A){let T,q;for(let B=0,z=W.length;B<z;B++){const j=W[B];j.requiresSiblings&&A&&(N||(N=(0,M.basename)(oe)),T||(T=N.substr(0,N.length-(0,M.extname)(oe).length)));const ce=j(oe,N,T,A);if(typeof ce=="string")return ce;(0,L.isThenable)(ce)&&(q||(q=[]),q.push(ce))}return q?(async()=>{for(const B of q){const z=await B;if(typeof z=="string")return z}return null})():null},Q=W.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ie=W.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function ne(V,x,W){if(x===!1)return s;const U=i(V,W);if(U===s)return s;if(typeof x=="boolean")return U;if(x){const H=x.when;if(typeof H=="string"){const Q=(ie,oe,N,A)=>{if(!A||!U(ie,oe))return null;const T=H.replace("$(basename)",()=>N),q=A(T);return(0,L.isThenable)(q)?q.then(B=>B?V:null):q?V:null};return Q.requiresSiblings=!0,Q}}return U}function se(V,x){const W=V.filter(oe=>!!oe.basenames);if(W.length<2)return V;const U=W.reduce((oe,N)=>{const A=N.basenames;return A?oe.concat(A):oe},[]);let H;if(x){H=[];for(let oe=0,N=U.length;oe<N;oe++)H.push(x)}else H=W.reduce((oe,N)=>{const A=N.patterns;return A?oe.concat(A):oe},[]);const Q=function(oe,N){if(typeof oe!="string")return null;if(!N){let T;for(T=oe.length;T>0;T--){const q=oe.charCodeAt(T-1);if(q===47||q===92)break}N=oe.substr(T)}const A=U.indexOf(N);return A!==-1?H[A]:null};Q.basenames=U,Q.patterns=H,Q.allBasenames=U;const ie=V.filter(oe=>!oe.basenames);return ie.push(Q),ie}function G(V,x){return(0,I.equals)(V,x,(W,U)=>typeof W=="string"&&typeof U=="string"?W===U:typeof W!="string"&&typeof U!="string"?W.base===U.base&&W.pattern===U.pattern:!1)}e.patternsEquals=G}),define(ee[46],te([0,1,23,33,9,4,19,27]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:b,relative:D}=n;if(D){const k=a(i,D,o);if(typeof k=="string")return k}let R=i.fsPath;if(o===1&&!_.isWindows?R=R.replace(/\//g,"\\"):o!==1&&_.isWindows&&(R=R.replace(/\\/g,"/")),o!==1&&b?.userHome){const k=b.userHome.fsPath;let O;i.scheme!==b.userHome.scheme&&i.path.startsWith(r.posix.sep)?O=b.userHome.with({path:i.path}).fsPath:O=i.fsPath,R=S(O,k,o)}return(o===1?r.win32:r.posix).normalize(g(R,o===1))}e.getPathLabel=h;function a(i,n,o){const b=o===1?r.win32:r.posix,D=o===3?M.extUri:M.extUriIgnorePathCase,R=n.getWorkspace(),P=(0,I.firstOrDefault)(R.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=P.uri.with({path:i.path}));const k=n.getWorkspaceFolder(i);if(!k)return;let O;if(D.isEqual(k.uri,i)?O="":O=D.relativePath(k.uri,i)??"",O&&(O=b.normalize(O)),R.folders.length>1&&!n.noPrefix){const F=k.name?k.name:D.basenameOrAuthority(k.uri);O=O?`${F} \u2022 ${O}`:F}return O}function g(i,n=_.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=g;let w=Object.create(null);function S(i,n,o=_.OS){if(o===1||!i||!n)return i;let b=w.original===n?w.normalized:void 0;b||(b=n,_.isWindows&&(b=(0,L.toSlashes)(b)),b=`${(0,C.rtrim)(b,r.posix.sep)}${r.posix.sep}`,w={original:n,normalized:b});let D=i;return _.isWindows&&(D=(0,L.toSlashes)(D)),(o===3?D.startsWith(b):(0,C.startsWithIgnoreCase)(D,b))?`~/${D.substr(b.length)}`:i}e.tildify=S;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const y="\u2026",v="\\\\",p="~";function m(i,n=r.sep){const o=new Array(i.length);let b=!1;for(let D=0;D<i.length;D++){const R=i[D];if(R===""){o[D]=`.${n}`;continue}if(!R){o[D]=R;continue}b=!0;let P="",k=R;k.indexOf(v)===0?(P=k.substr(0,k.indexOf(v)+v.length),k=k.substr(k.indexOf(v)+v.length)):k.indexOf(n)===0?(P=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(p)===0&&(P=k.substr(0,k.indexOf(p)+p.length),k=k.substr(k.indexOf(p)+p.length));const O=k.split(n);for(let F=1;b&&F<=O.length;F++)for(let $=O.length-F;b&&$>=0;$--){b=!1;let re=O.slice($,$+F).join(n);for(let J=0;!b&&J<i.length;J++)if(J!==D&&i[J]&&i[J].indexOf(re)>-1){const ae=$+F===O.length,ne=$>0&&i[J].indexOf(n)>-1?n+re:re,se=i[J].endsWith(ne);b=!ae||se}if(!b){let J="";(O[0].endsWith(":")||P!=="")&&($===1&&($=0,F++,re=O[0]+n+re),$>0&&(J=O[0]+n),J=P+J),$>0&&(J=J+y+n),J=J+re,$+F<O.length&&(J=J+n+y),o[D]=J}}b&&(o[D]=R)}return o}e.shorten=m;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function c(i,n=Object.create(null)){const o=[];let b=!1,D="";for(const R of i)if(R==="$"||b&&R==="{")D&&o.push({value:D,type:d.TEXT}),D="",b=!0;else if(R==="}"&&b){const P=n[D];if(typeof P=="string")P.length&&o.push({value:P,type:d.VARIABLE});else if(P){const k=o[o.length-1];(!k||k.type!==d.SEPARATOR)&&o.push({value:P.label,type:d.SEPARATOR})}D="",b=!1}else D+=R;return D&&!b&&o.push({value:D,type:d.TEXT}),o.filter((R,P)=>{if(R.type===d.SEPARATOR){const k=o[P-1],O=o[P+1];return[k,O].every(F=>F&&(F.type===d.VARIABLE||F.type===d.TEXT)&&F.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=c;function E(i,n){return _.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function u(i,n){return _.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):_.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=s(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return s(i)}e.splitRecentLabel=l;function s(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,o=n.basename(i),b=n.dirname(i);return o.length?{name:o,parentPath:b}:{name:b,parentPath:""}}}),define(ee[153],te([0,1,18,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(w){return w.toJSON()}class _{constructor(S){this._uriTransformer=S}transformIncoming(S){const f=this._uriTransformer.transformIncoming(S);return f===S?S:r(L.URI.from(f))}transformOutgoing(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:r(L.URI.from(f))}transformOutgoingURI(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:L.URI.from(f)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function M(w,S,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof L.URI)return S.transformOutgoing(w);for(const y in w)if(Object.hasOwnProperty.call(w,y)){const v=M(w[y],S,f+1);v!==null&&(w[y]=v)}}return null}function C(w,S){const f=M(w,S,0);return f===null?w:f}e.transformOutgoingURIs=C;function h(w,S,f,y){if(!w||y>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?L.URI.revive(S.transformIncoming(w)):S.transformIncoming(w);if(w instanceof I.VSBuffer)return null;for(const v in w)if(Object.hasOwnProperty.call(w,v)){const p=h(w[v],S,f,y+1);p!==null&&(w[v]=p)}}return null}function a(w,S){const f=h(w,S,!1,0);return f===null?w:f}e.transformIncomingURIs=a;function g(w,S){const f=h(w,S,!0,0);return f===null?w:f}e.transformAndReviveIncomingURIs=g}),define(ee[21],te([0,1,45,28,154,8,33,84,9,4,19,7]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function f(ne,se=S.UNLINK,G){if((0,M.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return se===S.UNLINK?v(ne):y(ne,G)}async function y(ne,se=(0,M.randomPath)((0,L.tmpdir)())){try{try{await I.promises.rename(ne,se)}catch(G){return G.code==="ENOENT"?void 0:v(ne)}v(se).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function v(ne){return(0,r.promisify)(I.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function p(ne){if((0,M.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function m(ne,se){return E(await(se?d(ne):(0,r.promisify)(I.readdir)(ne)))}async function d(ne){try{return await(0,r.promisify)(I.readdir)(ne,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const se=[],G=await m(ne);for(const V of G){let x=!1,W=!1,U=!1;try{const H=await e.Promises.lstat((0,h.join)(ne,V));x=H.isFile(),W=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}se.push({name:V,isFile:()=>x,isDirectory:()=>W,isSymbolicLink:()=>U})}return se}function c(ne){return E(I.readdirSync(ne))}e.readdirSync=c;function E(ne){return ne.map(se=>typeof se=="string"?a.isMacintosh?(0,C.normalizeNFC)(se):se:(se.name=a.isMacintosh?(0,C.normalizeNFC)(se.name):se.name,se))}async function u(ne){const se=await m(ne),G=[];for(const V of se)await l.existsDirectory((0,h.join)(ne,V))&&G.push(V);return G}function t(ne,se=1e3){return new Promise(G=>{let V=!1;const x=setInterval(()=>{V||(V=!0,I.access(ne,W=>{V=!1,W&&(clearInterval(x),G(void 0))}))},se)})}e.whenDeleted=t;var l;(function(ne){async function se(x){let W;try{if(W=await e.Promises.lstat(x),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(a.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw U}}ne.stat=se;async function G(x){try{const{stat:W,symbolicLink:U}=await ne.stat(x);return W.isFile()&&U?.dangling!==!0}catch{}return!1}ne.existsFile=G;async function V(x){try{const{stat:W,symbolicLink:U}=await ne.stat(x);return W.isDirectory()&&U?.dangling!==!0}catch{}return!1}ne.existsDirectory=V})(l||(e.SymlinkSupport=l={}));const s=new _.ResourceQueue;function i(ne,se,G){return s.queueFor(w.URI.file(ne),g.extUriBiasedIgnorePathCase).queue(()=>{const V=R(G);return new Promise((x,W)=>b(ne,se,V,U=>U?W(U):x()))})}let n=!0;function o(ne){n=ne}e.configureFlushOnWrite=o;function b(ne,se,G,V){if(!n)return I.writeFile(ne,se,{mode:G.mode,flag:G.flag},V);I.open(ne,G.flag,G.mode,(x,W)=>{if(x)return V(x);I.writeFile(W,se,U=>{if(U)return I.close(W,()=>V(U));I.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),I.close(W,Q=>V(Q))))})})}function D(ne,se,G){const V=R(G);if(!n)return I.writeFileSync(ne,se,{mode:V.mode,flag:V.flag});const x=I.openSync(ne,V.flag,V.mode);try{I.writeFileSync(x,se);try{I.fdatasyncSync(x)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o(!1)}}finally{I.closeSync(x)}}e.writeFileSync=D;function R(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function P(ne,se,G=6e4){if(ne!==se)try{a.isWindows&&typeof G=="number"?await k(ne,se,Date.now(),G):await(0,r.promisify)(I.rename)(ne,se)}catch(V){if(ne.toLowerCase()!==se.toLowerCase()&&V.code==="EXDEV"||ne.endsWith("."))await O(ne,se,{preserveSymlinks:!1}),await f(ne,S.MOVE);else throw V}}async function k(ne,se,G,V,x=0){try{return await(0,r.promisify)(I.rename)(ne,se)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-G>=V)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${W}`),W;if(x===0){let U=!1;try{const{stat:H}=await l.stat(se);H.isFile()||(U=!0)}catch{}if(U)throw W}return await(0,_.timeout)(Math.min(100,x*10)),k(ne,se,G,V,x+1)}}async function O(ne,se,G){return $(ne,se,{root:{source:ne,target:se},options:G,handledSourcePaths:new Set})}const F=511;async function $(ne,se,G){if(G.handledSourcePaths.has(ne))return;G.handledSourcePaths.add(ne);const{stat:V,symbolicLink:x}=await l.stat(ne);if(x){if(G.options.preserveSymlinks)try{return await ae(ne,se,G)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(x.dangling)return}return V.isDirectory()?re(ne,se,V.mode&F,G):J(ne,se,V.mode&F)}async function re(ne,se,G,V){await e.Promises.mkdir(se,{recursive:!0,mode:G});const x=await m(ne);for(const W of x)await $((0,h.join)(ne,W),(0,h.join)(se,W),V)}async function J(ne,se,G){await e.Promises.copyFile(ne,se),await e.Promises.chmod(se,G)}async function ae(ne,se,G){let V=await e.Promises.readlink(ne);(0,M.isEqualOrParent)(V,G.root.source,!a.isLinux)&&(V=(0,h.join)(G.root.target,V.substr(G.root.source.length+1))),await e.Promises.symlink(V,se)}e.Promises=new class{get access(){return(0,r.promisify)(I.access)}get stat(){return(0,r.promisify)(I.stat)}get lstat(){return(0,r.promisify)(I.lstat)}get utimes(){return(0,r.promisify)(I.utimes)}get read(){return(ne,se,G,V,x)=>new Promise((W,U)=>{I.read(ne,se,G,V,x,(H,Q,ie)=>H?U(H):W({bytesRead:Q,buffer:ie}))})}get readFile(){return(0,r.promisify)(I.readFile)}get write(){return(ne,se,G,V,x)=>new Promise((W,U)=>{I.write(ne,se,G,V,x,(H,Q,ie)=>H?U(H):W({bytesWritten:Q,buffer:ie}))})}get appendFile(){return(0,r.promisify)(I.appendFile)}get fdatasync(){return(0,r.promisify)(I.fdatasync)}get truncate(){return(0,r.promisify)(I.truncate)}get copyFile(){return(0,r.promisify)(I.copyFile)}get open(){return(0,r.promisify)(I.open)}get close(){return(0,r.promisify)(I.close)}get symlink(){return(0,r.promisify)(I.symlink)}get readlink(){return(0,r.promisify)(I.readlink)}get chmod(){return(0,r.promisify)(I.chmod)}get mkdir(){return(0,r.promisify)(I.mkdir)}get unlink(){return(0,r.promisify)(I.unlink)}get rmdir(){return(0,r.promisify)(I.rmdir)}get realpath(){return(0,r.promisify)(I.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return f}get rename(){return P}get copy(){return O}}}),define(ee[105],te([0,1,45,9,4,27,21]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(S){if(r.isLinux)return S;const f=(0,L.dirname)(S);if(S===f)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const p=(0,M.readdirSync)(f).filter(m=>m.toLowerCase()===y);if(p.length===1){const m=C(f);if(m)return(0,L.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(y);if(m>=0){const d=C(f);if(d)return(0,L.join)(d,p[m])}}}catch{}return null}e.realcaseSync=C;async function h(S){if(r.isLinux)return S;const f=(0,L.dirname)(S);if(S===f)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const p=(await M.Promises.readdir(f)).filter(m=>m.toLowerCase()===y);if(p.length===1){const m=await h(f);if(m)return(0,L.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(y);if(m>=0){const d=await h(f);if(d)return(0,L.join)(d,p[m])}}}catch{}return null}e.realcase=h;async function a(S){try{return await M.Promises.realpath(S)}catch{const y=w(S);return await M.Promises.access(y,I.constants.R_OK),y}}e.realpath=a;function g(S){try{return I.realpathSync(S)}catch{const y=w(S);return I.accessSync(y,I.constants.R_OK),y}}e.realpathSync=g;function w(S){return(0,_.rtrim)((0,L.normalize)(S),L.sep)}}),define(ee[106],te([0,1,28,9,21]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,M=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class w{constructor(u,t,l){this.exePath=u,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:u=!1}={}){const t=S({useAlternateBitness:E});if(!t)return null;const l=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let s=-1,i=null;for(const b of await r.Promises.readdir(l)){let D=-1;if(u){const P=b.indexOf("-");if(P<0)continue;const k=b.substring(0,P);if(!_.test(k)||b.substring(P+1)!=="preview")continue;D=parseInt(k,10)}else{if(!_.test(b))continue;D=parseInt(b,10)}if(D<=s)continue;const R=L.join(l,b,"pwsh.exe");await r.SymlinkSupport.existsFile(R)&&(i=R,s=D)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=u?" Preview":"";return new w(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=E?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(u))if(t.test(s)){const i=L.join(u,s,"pwsh.exe");return new w(i,l)}return null}function v(){const E=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function p(){const E=L.join(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*m(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=v(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=p(),E&&(yield E)}async function*d(){for await(const E of m())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=d;async function c(){for await(const E of d())return E;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ee[88],te([0,1,9,4,35,73,12,21]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return _.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return _.TerminateResponseCode}});function h(w=r.env){return w.comspec||"cmd.exe"}e.getWindowsShell=h;function a(w){let S=[],f=!1;const y=function(v){if(f){S.push(v);return}(!w.send(v,m=>{if(m&&console.error(m),f=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(c=>y(c))}})||L.isWindows)&&(f=!0)};return{send:y}}e.createQueuedSender=a;var g;(function(w){async function S(f,y,v){if(I.isAbsolute(f))return f;if(y===void 0&&(y=r.cwd()),I.dirname(f)!=="."||(v===void 0&&M.isString(r.env.PATH)&&(v=r.env.PATH.split(I.delimiter)),v===void 0||v.length===0))return I.join(y,f);async function m(d){if(await C.Promises.exists(d)){let c;try{c=await C.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&(c=await C.Promises.lstat(d))}return c?!c.isDirectory():!1}return!1}for(const d of v){let c;if(I.isAbsolute(d)?c=I.join(d,f):c=I.join(y,d,f),await m(c))return c;let E=c+".com";if(await m(E)||(E=c+".exe",await m(E)))return E}return I.join(y,f)}w.findExecutable=S})(g||(e.win32=g={}))}),define(ee[107],te([0,1,47,13]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((C,h)=>{let a;const g=new Map;function w(f,y,v,p,m){const d=g.get(y);if(f===M||d){const c={name:S(v),cmd:v,pid:f,ppid:y,load:p,mem:m};g.set(f,c),f===M&&(a=c),d&&(d.children||(d.children=[]),d.children.push(c),d.children.length>1&&(d.children=d.children.sort((E,u)=>E.pid-u.pid)))}}function S(f){const y=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,p=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(p.exec(f))return"electron-crash-reporter";if(m.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let E=c.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let t="";do E=u.exec(f),E&&(t+=E+" ");while(E);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,v)=>{K(["@vscode/windows-process-tree"],y,v)}).then(y=>{y.getProcessList(M,v=>{if(!v){h(new Error(`Root process ${M} not found`));return}y.getProcessCpuUsage(v,p=>{const m=new Map;p.forEach(d=>{const c=f(d.commandLine||"");m.set(d.pid,{name:S(c),cmd:c,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),a=m.get(M),a?(m.forEach(d=>{const c=m.get(d.ppid);c&&(c.children||(c.children=[]),c.children.push(d))}),m.forEach(d=>{d.children&&(d.children=d.children.sort((c,E)=>c.pid-E.pid))}),C(a)):h(new Error(`Root process ${M} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[a];const v=[];for(;y.length;){const m=y.shift();m&&(v.push(m.pid),m.children&&(y=y.concat(m.children)))}let p=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+v.join(" "),(0,I.exec)(p,{},(m,d,c)=>{if(m||c)h(m||new Error(c.toString()));else{const E=d.toString().split(`
`);for(let u=0;u<v.length;u++){const t=g.get(v[u]);t.load=parseFloat(E[u])}if(!a){h(new Error(`Root process ${M} not found`));return}C(a)}})};(0,I.exec)("which ps",{},(y,v,p)=>{if(y||p)if(process.platform!=="linux")h(y||new Error(p.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(m,{},(d,c,E)=>{d||E?h(d||new Error(E.toString())):(_(c,w),f())})}else{const m=v.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${m} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,E,u)=>{c||u&&!u.includes("screen size is bogus")?h(c||new Error(u.toString())):(_(E,w),process.platform==="linux"?f():a?C(a):h(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function _(M,C){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=M.toString().split(`
`);for(const g of a){const w=h.exec(g.trim());w&&w.length===6&&C(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ee[108],te([0,1,28,4,106,88]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(w,S){return w===1?L.isWindows?g():_.getWindowsShell(S):h(w,S)}e.getSystemShell=M;let C=null;function h(w,S){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!C){let f;if(L.isWindows)f="/bin/bash";else{if(f=S.SHELL,!f)try{f=(0,I.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}C=f}return C}let a=null;async function g(){return a||(a=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),a}});var Ee=this&&this.__decorate||function(K,e,I,L){var r=arguments.length,_=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(K,e,I,L);else for(var C=K.length-1;C>=0;C--)(M=K[C])&&(_=(r<3?M(_):r>3?M(e,I,_):M(e,I))||_);return r>3&&_&&Object.defineProperty(e,I,_),_};define(ee[42],te([0,1,23,8,18,22,54,14,3,2,74,27,12]),function(K,e,I,L,r,_,M,C,h,a,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f||(f={}));function y(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function p(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));function d(x){let W=0;for(let U=0;;U+=7){const H=x.read(1);if(W|=(H.buffer[0]&127)<<U,!(H.buffer[0]&128))return W}}const c=s(0);function E(x,W){if(W===0){x.write(c);return}let U=0;for(let Q=W;Q!==0;Q=Q>>>7)U++;const H=r.VSBuffer.alloc(U);for(let Q=0;W!==0;Q++)H.buffer[Q]=W&127,W=W>>>7,W>0&&(H.buffer[Q]|=128);x.write(H)}class u{constructor(W){this.buffer=W,this.pos=0}read(W){const U=this.buffer.slice(this.pos,this.pos+W);return this.pos+=U.byteLength,U}}e.BufferReader=u;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(l||(l={}));function s(x){const W=r.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const i={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object),Uint:s(l.Int)},n=typeof Buffer<"u";function o(x,W){if(typeof W>"u")x.write(i.Undefined);else if(typeof W=="string"){const U=r.VSBuffer.fromString(W);x.write(i.String),E(x,U.byteLength),x.write(U)}else if(n&&Buffer.isBuffer(W)){const U=r.VSBuffer.wrap(W);x.write(i.Buffer),E(x,U.byteLength),x.write(U)}else if(W instanceof r.VSBuffer)x.write(i.VSBuffer),E(x,W.byteLength),x.write(W);else if(Array.isArray(W)){x.write(i.Array),E(x,W.length);for(const U of W)o(x,U)}else if(typeof W=="number"&&(W|0)===W)x.write(i.Uint),E(x,W);else{const U=r.VSBuffer.fromString(JSON.stringify(W));x.write(i.Object),E(x,U.byteLength),x.write(U)}}e.serialize=o;function b(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(d(x)).toString();case l.Buffer:return x.read(d(x)).buffer;case l.VSBuffer:return x.read(d(x));case l.Array:{const U=d(x),H=[];for(let Q=0;Q<U;Q++)H.push(b(x));return H}case l.Object:return JSON.parse(x.read(d(x)).toString());case l.Int:return d(x)}}e.deserialize=b;class D{constructor(W,U,H=null,Q=1e3){this.protocol=W,this.ctx=U,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(W,U){this.channels.set(W,U),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const U=this.send([W.type]);this.logger?.logOutgoing(U,0,1,p(W.type));return}case 201:case 202:case 204:case 203:{const U=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(U,W.id,1,p(W.type),W.data);return}}}send(W,U=void 0){const H=new t;return o(H,W),o(H,U),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const U=new u(W),H=b(U),Q=b(U),ie=H[0];switch(ie){case 100:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}`),this.disposeActiveRequest({type:ie,id:H[1]});case 103:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}`),this.disposeActiveRequest({type:ie,id:H[1]})}}onPromise(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const H=new _.CancellationTokenSource;let Q;try{Q=U.call(this.ctx,W.name,W.arg,H.token)}catch(N){Q=Promise.reject(N)}const ie=W.id;Q.then(N=>{this.sendResponse({id:ie,data:N,type:201})},N=>{N instanceof Error?this.sendResponse({id:ie,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:ie,data:N,type:203})}).finally(()=>{oe.dispose(),this.activeRequests.delete(W.id)});const oe=(0,a.toDisposable)(()=>H.cancel());this.activeRequests.set(W.id,oe)}onEventListen(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const H=W.id,ie=U.listen(this.ctx,W.name,W.arg)(oe=>this.sendResponse({id:H,data:oe,type:204}));this.activeRequests.set(W.id,ie)}disposeActiveRequest(W){const U=this.activeRequests.get(W.id);U&&(U.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let U=this.pendingRequests.get(W.channelName);U||(U=[],this.pendingRequests.set(W.channelName,U));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:W,timeoutTimer:H})}flushPendingRequests(W){const U=this.pendingRequests.get(W);if(U){for(const H of U)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var R;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class P{constructor(W,U=null){this.protocol=W,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=U}getChannel(W){const U=this;return{call(H,Q,ie){return U.isDisposed?Promise.reject(new C.CancellationError):U.requestPromise(W,H,Q,ie)},listen(H,Q){return U.isDisposed?h.Event.None:U.requestEvent(W,H,Q)}}}requestPromise(W,U,H,Q=_.CancellationToken.None){const ie=this.lastRequestId++,N={id:ie,type:100,channelName:W,name:U,arg:H};if(Q.isCancellationRequested)return Promise.reject(new C.CancellationError);let A;return new Promise((q,B)=>{if(Q.isCancellationRequested)return B(new C.CancellationError);const z=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(ie),q(he.data);break;case 202:{this.handlers.delete(ie);const ye=new Error(he.data.message);ye.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ye.name=he.data.name,B(ye);break}case 203:this.handlers.delete(ie),B(he.data);break}};this.handlers.set(ie,ue),this.sendRequest(N)};let j=null;this.state===m.Idle?z():(j=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),j.then(()=>{j=null,z()}));const ce=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ie,type:101}),B(new C.CancellationError)},fe=Q.onCancellationRequested(ce);A=(0,a.combinedDisposable)((0,a.toDisposable)(ce),fe),this.activeRequests.add(A)}).finally(()=>{A.dispose(),this.activeRequests.delete(A)})}requestEvent(W,U,H){const Q=this.lastRequestId++,oe={id:Q,type:102,channelName:W,name:U,arg:H};let N=null;const A=new h.Emitter({onWillAddFirstListener:()=>{N=(0,L.createCancelablePromise)(q=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(A),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(A),this.sendRequest({id:Q,type:103}))}}),T=q=>A.fire(q.data);return this.handlers.set(Q,T),A.event}sendRequest(W){switch(W.type){case 100:case 102:{const U=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(U,W.id,0,`${y(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const U=this.send([W.type,W.id]);this.logger?.logOutgoing(U,W.id,0,y(W.type));return}}}send(W,U=void 0){const H=new t;return o(H,W),o(H,U),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const U=new u(W),H=b(U),Q=b(U),ie=H[0];switch(ie){case 200:return this.logger?.logIncoming(W.byteLength,0,0,p(ie)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,H[1],0,p(ie),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(W){if(W.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=P,Ee([M.memoize],P.prototype,"onDidInitializePromise",null);class k{get connections(){const W=[];return this._connections.forEach(U=>W.push(U)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(W(({protocol:U,onDidClientDisconnect:H})=>{const Q=h.Event.once(U.onMessage);this.disposables.add(Q(ie=>{const oe=new u(ie),N=b(oe),A=new D(U,N),T=new P(U);this.channels.forEach((B,z)=>A.registerChannel(z,B));const q={channelServer:A,channelClient:T,ctx:N};this._connections.add(q),this._onDidAddConnection.fire(q),this.disposables.add(H(()=>{A.dispose(),T.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)}))}))}))}getChannel(W,U){const H=this;return{call(Q,ie,oe){let N;if((0,S.isFunction)(U)){const T=(0,I.getRandomElement)(H.connections.filter(U));N=T?Promise.resolve(T):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,U))}else N=U.routeCall(H,Q,ie);const A=N.then(T=>T.channelClient.getChannel(W));return F(A).call(Q,ie,oe)},listen(Q,ie){if((0,S.isFunction)(U))return H.getMulticastEvent(W,U,Q,ie);const oe=U.routeEvent(H,Q,ie).then(N=>N.channelClient.getChannel(W));return F(oe).listen(Q,ie)}}}getMulticastEvent(W,U,H,Q){const ie=this;let oe;const N=new h.Emitter({onWillAddFirstListener:()=>{oe=new a.DisposableStore;const A=new h.EventMultiplexer,T=new Map,q=z=>{const ce=z.channelClient.getChannel(W).listen(H,Q),fe=A.add(ce);T.set(z,fe)},B=z=>{const j=T.get(z);j&&(j.dispose(),T.delete(z))};ie.connections.filter(U).forEach(q),h.Event.filter(ie.onDidAddConnection,U)(q,void 0,oe),ie.onDidRemoveConnection(B,void 0,oe),A.event(N.fire,N,oe),oe.add(A)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return N.event}registerChannel(W,U){this.channels.set(W,U);for(const H of this._connections)H.channelServer.registerChannel(W,U)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class O{constructor(W,U,H=null){const Q=new t;o(Q,U),W.send(Q.buffer),this.channelClient=new P(W,H),this.channelServer=new D(W,U,H)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,U){this.channelServer.registerChannel(W,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(x){return{call(W,U,H){return x.then(Q=>Q.call(W,U,H))},listen(W,U){const H=new h.Relay;return x.then(Q=>H.input=Q.listen(W,U)),H.event}}}e.getDelayedChannel=F;function $(x){let W=!1;return{call(U,H,Q){return W?x.call(U,H,Q):(0,L.timeout)(0).then(()=>W=!0).then(()=>x.call(U,H,Q))},listen(U,H){if(W)return x.listen(U,H);const Q=new h.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>Q.input=x.listen(U,H)),Q.event}}}e.getNextTickChannel=$;class re{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const U of W.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await h.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=re;var J;(function(x){function W(ie,oe,N){const A=ie,T=N&&N.disableMarshalling,q=new Map;for(const B in A)H(B)&&q.set(B,h.Event.buffer(A[B],!0,void 0,oe));return new class{listen(B,z,j){const ce=q.get(z);if(ce)return ce;if(Q(z)){const fe=A[z];if(typeof fe=="function")return fe.call(A,j)}throw new C.ErrorNoTelemetry(`Event not found: ${z}`)}call(B,z,j){const ce=A[z];if(typeof ce=="function"){if(!T&&Array.isArray(j))for(let ue=0;ue<j.length;ue++)j[ue]=(0,g.revive)(j[ue]);let fe=ce.apply(A,j);return fe instanceof Promise||(fe=Promise.resolve(fe)),fe}throw new C.ErrorNoTelemetry(`Method not found: ${z}`)}}}x.fromService=W;function U(ie,oe){const N=oe&&oe.disableMarshalling;return new Proxy({},{get(A,T){if(typeof T=="string")return oe?.properties?.has(T)?oe.properties.get(T):Q(T)?function(q){return ie.listen(T,q)}:H(T)?ie.listen(T):async function(...q){let B;oe&&!(0,S.isUndefinedOrNull)(oe.context)?B=[oe.context,...q]:B=q;const z=await ie.call(T,B);return N?z:(0,g.revive)(z)};throw new C.ErrorNoTelemetry(`Property not found: ${String(T)}`)}})}x.toService=U;function H(ie){return ie[0]==="o"&&ie[1]==="n"&&w.isUpperAsciiLetter(ie.charCodeAt(2))}function Q(ie){return/^onDynamic/.test(ie)&&w.isUpperAsciiLetter(ie.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const W=x.toString();if(W!=="[object Object]")return W}return x}function se(x){return Array.isArray(x)?x.map(ne):ne(x)}function G(x,W,U,H,Q,ie,oe){oe=se(oe);const N=ae[Q],A=N[H%N.length];let T=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ie)?(T=T.concat(oe),T.push(")")):T.push(oe),console.log.apply(console,T)}class V{constructor(W,U){this._outgoingPrefix=W,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,U,H,Q,ie){this._totalOutgoing+=W,G(this._outgoingPrefix,this._totalOutgoing,W,U,H,Q,ie)}logIncoming(W,U,H,Q,ie){this._totalIncoming+=W,G(this._incomingPrefix,this._totalIncoming,W,U,H,Q,ie)}}e.IPCLogger=V}),define(ee[155],te([0,1,18,3,42]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",a=>I.VSBuffer.wrap(a.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class M extends r.IPCClient{constructor(h,a){const g=new _(h);super(g,a),this.protocol=g}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=M}),define(ee[109],te([0,1,18,3,2,42]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function b(R,P){if(!n.has(R)){const k=String(++o);n.set(R,k)}return n.get(R)}function D(R,P,k,O){if(!i.enableDiagnostics)return;const F=b(R,P);if(O instanceof I.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=I.VSBuffer.alloc(O.byteLength);$.set(O),i.records.push({timestamp:Date.now(),id:F,label:P,type:k,buff:$})}else i.records.push({timestamp:Date.now(),id:F,label:P,type:k,data:O})}i.traceSocketEvent=D})(C||(e.SocketDiagnostics=C={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let a=null;function g(){return a||(a=I.VSBuffer.alloc(0)),a}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return g();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const P=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),P}if(this._chunks[0].byteLength>n){const P=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),P}const b=I.VSBuffer.alloc(n);let D=0,R=0;for(;n>0;){const P=this._chunks[R];if(P.byteLength>n){const k=P.slice(0,n);b.set(k,D),D+=n,o&&(this._chunks[R]=P.slice(n),this._totalLength-=n),n-=n}else b.set(P,D),D+=P.byteLength,o?(this._chunks.shift(),this._totalLength-=P.byteLength):R++,n-=P.byteLength}return b}}e.ChunkStream=w;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class v{constructor(n,o,b,D){this.type=n,this.id=o,this.ack=b,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const b=this._state.messageType,D=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new v(b,D,R,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=I.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(o,n.data)}_bufferAdd(n,o){const b=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,b}_bufferTake(){const n=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class d extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new v(1,0,0,n))}}e.Protocol=d;class c extends _.IPCClient{static fromSocket(n,o){return new c(new d(n),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,o,b=null){super(n,o,b),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=c;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,o=this._first;for(;o;)o=o.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let o=0,b=this._first;for(;b;)n[o++]=b.data,b=b.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new u(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class l{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<l._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=l._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),o=(1+l._HISTORY_LENGTH)*1e3;let b=0;for(let D=0;D<l._HISTORY_LENGTH;D++)n-this.lastRuns[D]<=o&&b++;return 1-b/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??l.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new p(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new v(5,0,0,g());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new v(7,0,0,g());this._socketWriter.write(n)}sendResume(){const n=new v(8,0,0,g());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new p(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(b=>this._receiveMessage(b))),this._socketDisposables.add(this._socket.onClose(b=>this._onSocketClose.fire(b))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,g());this._socketWriter.write(n);const o=this._outgoingUnackMsg.toArray();for(let b=0,D=o.length;b<D;b++)this._socketWriter.write(o[b]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new v(6,0,0,g())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let b=0,D=o.length;b<D;b++)this._socketWriter.write(o[b]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const b=new v(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(b),this._isReconnecting||(this._socketWriter.write(b),this._recvAckCheck())}sendControl(n){const o=new v(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime,b=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&b>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:b});return}const R=Math.max(2e4-o,2e4-b,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,g());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new v(9,0,this._incomingAckId,g());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(ee[38],te([0,1,15,14,13]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class _{constructor(){this.mapListenerToWrapper=new WeakMap}on(C,h){const a=(g,...w)=>{this.validateEvent(C,g)&&h(g,...w)};return this.mapListenerToWrapper.set(h,a),I.ipcMain.on(C,a),this}once(C,h){return I.ipcMain.once(C,(a,...g)=>{this.validateEvent(C,a)&&h(a,...g)}),this}handle(C,h){return I.ipcMain.handle(C,(a,...g)=>this.validateEvent(C,a)?h(a,...g):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return I.ipcMain.removeHandler(C),this}removeListener(C,h){const a=this.mapListenerToWrapper.get(h);return a&&(I.ipcMain.removeListener(C,a),this.mapListenerToWrapper.delete(h)),this}validateEvent(C,h){if(!C||!C.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const a=h.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let w="unknown";try{w=new URL(g).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${g}'.`),!1}return w!==r.VSCODE_AUTHORITY?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${w}'.`),!1):a.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new _}),define(ee[156],te([0,1,15,38,144]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function _(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(C,h,a,g,w)=>{const S=M(C,g,a);S.popup({x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{S&&C.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=_;function M(C,h,a){const g=new I.Menu;return a.forEach(w=>{let S;w.type==="separator"?S=new I.MenuItem({type:w.type}):Array.isArray(w.submenu)?S=new I.MenuItem({submenu:M(C,h,w.submenu),label:w.label}):S=new I.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(f,y,v)=>C.sender.send(h,w.id,v)}),g.append(S)}),g}}),define(ee[157],te([0,1,38,18,3,2,42,145]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(g,w){const S=r.Event.fromNodeEventEmitter(I.validatedIpcMain,w,(y,v)=>({event:y,message:v})),f=r.Event.filter(S,({event:y})=>y.sender.id===g);return r.Event.map(f,({message:y})=>y&&L.VSBuffer.wrap(y))}class a extends M.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const w=r.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:S})=>S);return r.Event.map(w,S=>{const f=S.id;a.Clients.get(f)?.dispose();const v=new r.Emitter;a.Clients.set(f,(0,_.toDisposable)(()=>v.fire()));const p=h(f,"vscode:message"),m=r.Event.any(r.Event.signal(h(f,"vscode:disconnect")),v.event);return{protocol:new C.Protocol(S,p),onDidClientDisconnect:m}})}constructor(){super(a.getOnDidClientConnect())}}e.Server=a}),define(ee[110],te([0,1,38,3,32,155]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends _.Client{constructor(a,g){super({addEventListener:(w,S)=>a.addListener(w,S),removeEventListener:(w,S)=>a.removeListener(w,S),postMessage:w=>a.postMessage(w),start:()=>a.start(),close:()=>a.close()},g)}}e.Client=M;async function C(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,r.generateUuid)();h.webContents.send("vscode:createMessageChannel",a);const g=L.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:w}=await L.Event.toPromise(L.Event.once(L.Event.filter(g,S=>S.nonce===a)));return w}e.connect=C}),define(ee[158],te([0,1,47,8,18,22,152,14,3,2,37,88,73,42]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(m){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",d=>r.VSBuffer.wrap(Buffer.from(d,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=y;class v{constructor(m,d){this.modulePath=m,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new L.Delayer(c),this.child=null,this._client=null}getChannel(m){const d=this;return{call(c,E,u){return d.requestPromise(m,c,E,u)},listen(c,E){return d.requestEvent(m,c,E)}}}requestPromise(m,d,c,E=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(m),t=(0,L.createCancelablePromise)(i=>u.call(d,c,i)),l=E.onCancellationRequested(()=>t.cancel()),s=(0,a.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{l.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(m,d,c){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let E;const u=new h.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(m).listen(d,c)(u.fire,u),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(d.env),this.child=(0,I.fork)(this.modulePath,m,d);const c=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,M.isRemoteConsoleLog)(n)){(0,M.log)(n,`IPC Library: ${this.options.serverName}`);return}c.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const u=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&u.send(n.buffer.toString("base64")),l=c.event,s={send:t,onMessage:l};this._client=new f.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(b=>(0,a.dispose)(b)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(m){let d=this.channels.get(m);return d||(d=this.client.getChannel(m),this.channels.set(m,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ee[111],te([0,1,8,3,2,74,12]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function h(S){const f=S;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var a;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(f,y=Object.create(null)){super(),this.database=f,this.options=y,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){this._onDidChangeStorage.pause();try{f.changed?.forEach((y,v)=>this.acceptExternal(v,y)),f.deleted?.forEach(y=>this.acceptExternal(y,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(f,y){if(this.state===a.Closed)return;let v=!1;(0,M.isUndefinedOrNull)(y)?v=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),v=!0),v&&this._onDidChangeStorage.fire({key:f,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const v=this.cache.get(f);return(0,M.isUndefinedOrNull)(v)?y:v}getBoolean(f,y){const v=this.get(f);return(0,M.isUndefinedOrNull)(v)?y:v==="true"}getNumber(f,y){const v=this.get(f);return(0,M.isUndefinedOrNull)(v)?y:parseInt(v,10)}getObject(f,y){const v=this.get(f);return(0,M.isUndefinedOrNull)(v)?y:(0,_.parse)(v)}async set(f,y,v=!1){if(this.state===a.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(f,v);const p=(0,M.isObject)(y)||Array.isArray(y)?(0,_.stringify)(y):String(y);if(this.cache.get(f)!==p)return this.cache.set(f,p),this.pendingInserts.set(f,p),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire({key:f,external:v}),this.doFlush()}async delete(f,y=!1){if(!(this.state===a.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire({key:f,external:y}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(this.hasPending)return this.doFlush(f)}async doFlush(f){return this.options.hint===C.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}isInMemory(){return this.options.hint===C.STORAGE_IN_MEMORY}}e.Storage=g;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert?.forEach((y,v)=>this.items.set(v,y)),f.delete?.forEach(y=>this.items.delete(y))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(ee[159],te([0,1,8,3,31,9,21]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(g,w=Object.create(null)){this.path=g,this.options=w,this.name=(0,_.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const g=await this.whenConnected,w=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(f=>w.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${w.size} rows`),w}async updateItems(g){const w=await this.whenConnected;return this.doUpdateItems(w,g)}doUpdateItems(g,w){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${w.insert?(0,r.mapToString)(w.insert):"0"}), delete(${w.delete?(0,r.setToString)(w.delete):"0"})`),this.transaction(g,()=>{const S=w.insert,f=w.delete;if(S&&S.size>0){const y=[];y.push([]);let v=0;S.forEach((p,m)=>{let d=y[v];d.length>C.MAX_HOST_PARAMETERS&&(v++,d=[],y.push(d)),d.push(m,p)}),y.forEach(p=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,m=>m.run(p),()=>{const m=[];let d=0;return S.forEach((c,E)=>{m.push(E),d+=c.length}),`Keys: ${m.join(", ")} Length: ${d}`})})}if(f&&f.size){const y=[];y.push([]);let v=0;f.forEach(p=>{let m=y[v];m.length>C.MAX_HOST_PARAMETERS&&(v++,m=[],y.push(m)),m.push(p)}),y.forEach(p=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,m=>m.run(p),()=>{const m=[];return f.forEach(d=>{m.push(d)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const g=await this.whenConnected;return this.exec(g,"VACUUM")}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const w=await this.whenConnected;return this.doClose(w,g)}doClose(g,w){return new Promise((S,f)=>{g.db.close(y=>(y&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${y}`),this.path===C.IN_MEMORY_PATH?S():!g.isErroneous&&!g.isInMemory?this.backup().then(S,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),S())):typeof w=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const p=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:w()}).then(()=>p(),m=>(p(),Promise.reject(m)))})).then(S,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return M.Promises.copy(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const w=await this.whenConnected,S=await this.get(w,g?"PRAGMA integrity_check":"PRAGMA quick_check"),f=g?S.integrity_check:S.quick_check;return w.isErroneous?`${f} (last error: ${w.lastError})`:w.isInMemory?`${f} (in-memory!)`:f}async connect(g,w=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${w})`);try{return await this.doConnect(g)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&w)return await(0,I.timeout)(C.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await M.Promises.unlink(g);try{await M.Promises.rename(this.toBackupPath(g),g,!1)}catch{}return await this.doConnect(g)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(C.IN_MEMORY_PATH)}}}handleSQLiteError(g,w){g.isErroneous=!0,g.lastError=w,this.logger.error(w)}doConnect(g){return new Promise((w,S)=>{new Promise((f,y)=>{K(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(g,v=>v?y.db&&v.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(v)):S(v):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(y),p=>y.db.close(()=>S(p)))),isInMemory:g===C.IN_MEMORY_PATH};y.db.on("error",v=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&y.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},S)})}exec(g,w){return new Promise((S,f)=>{g.db.exec(w,y=>y?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${y}`),f(y)):S())})}get(g,w){return new Promise((S,f)=>{g.db.get(w,(y,v)=>y?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${y}`),f(y)):S(v))})}all(g,w){return new Promise((S,f)=>{g.db.all(w,(y,v)=>y?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${y}`),f(y)):S(v))})}transaction(g,w){return new Promise((S,f)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),w(),g.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${y}`),f(y)):S())})})}prepare(g,w,S,f){const y=g.db.prepare(w),v=p=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${p} (${w}). Details: ${f()}`)};y.on("error",v),S(y),y.finalize(p=>{p&&v(p),y.removeListener("error",v)})}}e.SQLiteStorageDatabase=C;class h{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace?.(g)}error(g){this.logError?.(g)}}}),define(ee[160],te([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(ee[161],te([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ee[175],te([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ee[176],te([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ee[182],te([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[194],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(M){let C=[];try{Array.isArray(M.workspaces)&&(C=M.workspaces.map(h=>({workspace:{id:h.id,configPath:I.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=r;function _(M){let C=[];try{Array.isArray(M.folders)&&(C=M.folders.map(h=>({folderUri:I.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=_}),define(ee[195],te([0,1,14,163]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(r||(e.TokenType=r={}));function _(...a){switch(a.length){case 1:return(0,L.localize)(0,null,a[0]);case 2:return(0,L.localize)(1,null,a[0],a[1]);case 3:return(0,L.localize)(2,null,a[0],a[1],a[2]);default:return}}const M=(0,L.localize)(3,null),C=(0,L.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(g){return this._input=g,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(_("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(_("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(_("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(g){return this._isAtEnd()||this._input.charCodeAt(this._current)!==g?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(g){this._tokens.push({type:g,offset:this._start})}_error(g){const w=this._start,S=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:S};this._errors.push({offset:w,lexeme:S,additionalInfo:g}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const g=this.stringRe.exec(this._input);if(g){this._current=this._start+g[0].length;const w=this._input.substring(this._start,this._current),S=h._keywords.get(w);S?this._addToken(S):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let g=this._current,w=!1,S=!1;for(;;){if(g>=this._input.length){this._current=g,this._error(C);return}const y=this._input.charCodeAt(g);if(w)w=!1;else if(y===47&&!S){g++;break}else y===91?S=!0:y===92?w=!0:y===93&&(S=!1);g++}for(;g<this._input.length&&h._regexFlags.has(this._input.charCodeAt(g));)g++;this._current=g;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(ee[196],te([0,1,3,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(C,h,a){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(C,h,a){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class _ extends L.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,h,a){this.channel.call("attach",[C,h,a])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,h){this.channel.call("terminate",[C,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,h){return this.channel.call("openExtensionDevelopmentHostWindow",[C,h])}}e.ExtensionHostDebugChannelClient=_}),define(ee[197],te([0,1,147,54,13,9,35,19,7]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,_.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(h.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=M.env.VSCODE_PORTABLE;return f?h.URI.file((0,_.join)(f,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,_.resolve)(f):(0,_.normalize)((0,_.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,_.resolve)(f)):h.URI.file((0,_.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,_.resolve)(f);const y=M.env.VSCODE_EXTENSIONS;if(y)return y;const v=M.env.VSCODE_PORTABLE;return v?(0,_.join)(v,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,_.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,_.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=M.env.VSCODE_PORTABLE;return f?h.URI.file((0,_.join)(f,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,y,v){this._args=f,this.paths=y,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,Ee([L.memoize],a.prototype,"appRoot",null),Ee([L.memoize],a.prototype,"userHome",null),Ee([L.memoize],a.prototype,"userDataPath",null),Ee([L.memoize],a.prototype,"appSettingsHome",null),Ee([L.memoize],a.prototype,"tmpDir",null),Ee([L.memoize],a.prototype,"cacheHome",null),Ee([L.memoize],a.prototype,"stateResource",null),Ee([L.memoize],a.prototype,"userRoamingDataHome",null),Ee([L.memoize],a.prototype,"userDataSyncHome",null),Ee([L.memoize],a.prototype,"sync",null),Ee([L.memoize],a.prototype,"machineSettingsResource",null),Ee([L.memoize],a.prototype,"workspaceStorageHome",null),Ee([L.memoize],a.prototype,"localHistoryHome",null),Ee([L.memoize],a.prototype,"keyboardLayoutResource",null),Ee([L.memoize],a.prototype,"argvResource",null),Ee([L.memoize],a.prototype,"isExtensionDevelopment",null),Ee([L.memoize],a.prototype,"untitledWorkspacesHome",null),Ee([L.memoize],a.prototype,"builtinExtensionsPath",null),Ee([L.memoize],a.prototype,"extensionsPath",null),Ee([L.memoize],a.prototype,"extensionDevelopmentLocationURI",null),Ee([L.memoize],a.prototype,"extensionDevelopmentKind",null),Ee([L.memoize],a.prototype,"extensionTestsLocationURI",null),Ee([L.memoize],a.prototype,"debugExtensionHost",null),Ee([L.memoize],a.prototype,"logLevel",null),Ee([L.memoize],a.prototype,"extensionLogLevel",null),Ee([L.memoize],a.prototype,"serviceMachineIdResource",null),Ee([L.memoize],a.prototype,"disableTelemetry",null),Ee([L.memoize],a.prototype,"disableWorkspaceTrust",null),Ee([L.memoize],a.prototype,"useInMemorySecretStorage",null),Ee([L.memoize],a.prototype,"policyFile",null);function g(S,f){return w(S["inspect-extensions"],S["inspect-brk-extensions"],5870,f,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=g;function w(S,f,y,v,p,m){const c=Number(f||S)||(v?null:y),E=c?!!f:!1;let u;if(m)try{u=JSON.parse(m)}catch{}return{port:c,break:E,debugId:p,env:u}}e.parseDebugParams=w}),define(ee[112],te([0,1,307,4,166]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const _={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(v,p,m=M){const d=v.find(o=>o.length>0&&o[0]!=="-"),c={},E=["_"],u=[],t={};let l;for(const o in p){const b=p[o];b.type==="subcommand"?o===d&&(l=b):(b.alias&&(c[o]=b.alias),b.type==="string"||b.type==="string[]"?(E.push(o),b.deprecates&&E.push(...b.deprecates)):b.type==="boolean"&&(u.push(o),b.deprecates&&u.push(...b.deprecates)),b.global&&(t[o]=b))}if(l&&d){const o=t;for(const P in l.options)o[P]=l.options[P];const b=v.filter(P=>P!==d),D=m.getSubcommandReporter?m.getSubcommandReporter(d):void 0,R=C(b,o,D);return{[d]:R,_:[]}}const s=I(v,{string:E,boolean:u,alias:c}),i={},n=s;i._=s._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in p){const b=p[o];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let D=n[o];if(b.deprecates)for(const R of b.deprecates)n.hasOwnProperty(R)&&(D||(D=n[R],D&&m.onDeprecatedOption(R,b.deprecationMessage||(0,r.localize)(37,null,o))),delete n[R]);if(typeof D<"u"){if(b.type==="string[]"){if(Array.isArray(D)||(D=[D]),!b.allowEmptyValue){const R=D.filter(P=>P.length>0);R.length!==D.length&&(m.onEmptyValue(o),D=R.length>0?R:void 0)}}else b.type==="string"&&(Array.isArray(D)?(D=D.pop(),m.onMultipleValues(o,D)):!D&&!b.allowEmptyValue&&(m.onEmptyValue(o),D=void 0));i[o]=D,b.deprecationMessage&&m.onDeprecatedOption(o,b.deprecationMessage)}delete n[o]}for(const o in n)m.onUnknownOption(o);return i}e.parseArgs=C;function h(v,p){let m="";return p.args&&(Array.isArray(p.args)?m=` <${p.args.join("> <")}>`:m=` <${p.args}>`),p.alias?`-${p.alias} --${v}${m}`:`--${v}${m}`}function a(v,p){const m=[];for(const d in v){const c=v[d],E=h(d,c);m.push([E,c.description])}return g(m,p)}e.formatOptions=a;function g(v,p){const d=v.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if(p-d<25)return v.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=p-d-1,E=[];for(const u of v){const t=u[0],l=S(u[1],c),s=w(d-t.length-2);E.push("  "+t+s+l[0]);for(let i=1;i<l.length;i++)E.push(w(d)+l[i])}return E}function w(v){return" ".repeat(v)}function S(v,p){const m=[];for(;v.length;){const d=v.length<p?v.length:v.lastIndexOf(" ",p),c=v.slice(0,d).trim();v=v.slice(d),m.push(c)}return m}function f(v,p,m,d,c){const E=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${v} ${m}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${p} [${(0,r.localize)(40,null)}]${u}`),t.push(""),c?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(41,null,p)):t.push((0,r.localize)(42,null,p)),t.push(""));const l={},s=[];for(const i in d){const n=d[i];if(n.type==="subcommand")n.description&&s.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(_[n]),t.push(...a(o,E)),t.push(""))}return s.length&&(t.push((0,r.localize)(43,null)),t.push(...g(s.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function y(v,p){return`${v||(0,r.localize)(44,null)}
${p||(0,r.localize)(45,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ee[198],te([0,1,87,196,112]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class _ extends L.ExtensionHostDebugBroadcastChannel{constructor(C){super(),this.windowsMainService=C}call(C,h,a){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(a[0],a[1]):super.call(C,h,a)}async openExtensionDevelopmentHostWindow(C,h){const a=(0,r.parseArgs)(C,r.OPTIONS);a.debugRenderer=h;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[w]=await this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!h)return{success:!0};const S=w.win;if(!S)return{success:!0};const f=S.webContents.debugger;let y=f.isAttached()?1/0:0;const v=(0,I.createServer)(p=>{y++===0&&f.attach();let m=!1;const d=u=>{m||p.write(JSON.stringify(u)+"\0")},c=(u,t,l,s)=>d({method:t,params:l,sessionId:s});S.on("close",()=>{f.removeListener("message",c),p.end(),m=!0}),f.addListener("message",c);let E=Buffer.alloc(0);p.on("data",u=>{E=Buffer.concat([E,u]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let l;try{const s=E.slice(0,t).toString("utf8");E=E.slice(t+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(l.method,l.params,l.sessionId).then(s=>d({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>d({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",u=>{console.error("error on cdp pipe:",u)}),p.on("close",()=>{m=!0,--y===0&&f.detach()})});return await new Promise(p=>v.listen(0,p)),S.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=_}),define(ee[63],te([0,1,308,167,112]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(w,S){const f=(c,E)=>{console.warn((0,L.localize)(0,null,c,E))},y=c=>{console.warn((0,L.localize)(1,null,c))},v=(c,E)=>{console.warn((0,L.localize)(2,null,c,E))},p=c=>({onUnknownOption:E=>{r.NATIVE_CLI_COMMANDS.includes(c)||console.warn((0,L.localize)(3,null,E,c))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(c)?p:void 0}),m={onUnknownOption:c=>{console.warn((0,L.localize)(4,null,c))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:p},d=(0,r.parseArgs)(w,r.OPTIONS,S?m:void 0);return d.goto&&d._.forEach(c=>I(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,L.localize)(5,null))),d}function M(w){const S=w.findIndex(f=>!/^-/.test(f));if(S>-1)return[...w.slice(0,S),...w.slice(S+1)]}function C(w){let[,...S]=w;process.env.VSCODE_DEV&&(S=M(S)||[]);const f=!g(process.env);return _(S,f)}e.parseMainProcessArgv=C;function h(w){let[,,...S]=w;return process.env.VSCODE_DEV&&(S=M(S)||[]),_(S,!0)}e.parseCLIProcessArgv=h;function a(w,...S){const f=w.indexOf("--");return f===-1?w.push(...S):w.splice(f,0,...S),w}e.addArg=a;function g(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),function(){"use strict";function K(e,I,L){function r(M,C){const h=_(M,C),a=[h];return e.isAbsolute(h)||a.unshift(L),e.resolve(...a)}function _(M,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,C);const g=M["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(I.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,C)}return{getUserDataPath:r}}if(typeof define=="function")define(ee[199],te([113,28,35]),function(e,I,L){return K(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=K(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,28,197,199]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class _ extends L.AbstractNativeEnvironmentService{constructor(a,g){super(a,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,r.getUserDataPath)(a,g.nameShort)},g)}}e.NativeEnvironmentService=_;function M(h,a){return(0,L.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,a,h.extensionEnvironment)}e.parsePtyHostDebugPort=M;function C(h,a){return(0,L.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,a,h.extensionEnvironment)}e.parseSharedProcessDebugPort=C}),define(ee[200],te([0,1,45,28,33]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function _(M){const C=(0,r.randomPath)((0,L.tmpdir)());try{return(0,I.writeFileSync)(C,""),M&&console.log(`Marker file for --wait created: ${C}`),C}catch(h){M&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=_}),define(ee[201],te([0,1,12,169]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,C,h,a){try{_(M,C,h,a)}catch(g){M.error(g?.message??g)}return C}e.localizeManifest=r;function _(M,C,h,a){const g=(w,S,f)=>{const y=w[S];if((0,I.isString)(y)){const v=y,p=v.length;if(p>1&&v[0]==="%"&&v[p-1]==="%"){const m=v.substr(1,p-2);let d=h[m];d===void 0&&a&&(d=a[m]);const c=typeof d=="string"?d:d?.message,E=a?.[m],u=typeof E=="string"?E:E?.message;if(!c){u||M.warn(`[${C.name}]: ${(0,L.localize)(0,null,m)}`);return}if(f&&(S==="title"||S==="category")&&u&&u!==c){const t={value:c,original:u};w[S]=t}else w[S]=c}}else if((0,I.isObject)(y))for(const v in y)y.hasOwnProperty(v)&&(v==="commands"?g(y,v,!0):g(y,v,f));else if(Array.isArray(y))for(let v=0;v<y.length;v++)g(y,v,f)};for(const w in C)C.hasOwnProperty(w)&&g(C,w)}}),define(ee[202],te([0,1,19,71,171,203]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function h(m){return m=m.trim(),m==="*"||M.test(m)}e.isValidVersionStr=h;function a(m){if(!h(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=m.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=a;function g(m){if(!m)return null;const d=m.majorBase,c=m.majorMustEqual,E=m.minorBase;let u=m.minorMustEqual;const t=m.patchBase;let l=m.patchMustEqual;m.hasCaret&&(d===0||(u=!1),l=!1);let s=0;if(m.preRelease){const i=C.exec(m.preRelease);if(i){const[,n,o,b]=i;s=Date.UTC(Number(n),Number(o)-1,Number(b))}}return{majorBase:d,majorMustEqual:c,minorBase:E,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:s}}e.normalizeVersion=g;function w(m,d,c){let E;typeof m=="string"?E=g(a(m)):E=m;let u;d instanceof Date?u=d.getTime():typeof d=="string"&&(u=new Date(d).getTime());let t;if(typeof c=="string"?t=g(a(c)):t=c,!E||!t)return!1;const l=E.majorBase,s=E.minorBase,i=E.patchBase;let n=t.majorBase,o=t.minorBase,b=t.patchBase;const D=t.notBefore;let R=t.majorMustEqual,P=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:s>o?!0:s<o||u&&u<D?!1:i>=b:(l===1&&n===0&&(!R||!P||!k)&&(n=1,o=0,b=0,R=!0,P=!1,k=!1),l<n?!1:l>n?!R:s<o?!1:s>o?!P:i<b?!1:i>b?!k:!(u&&u<D))}e.isValidVersion=w;function S(m,d,c,E,u){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof E.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!E.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!p(E.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!p(E.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const i=(0,I.joinPath)(c,E.main);(0,I.isEqualOrParent)(i,c)||t.push([L.default.Warning,r.localize(10,null,i.path,c.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,I.joinPath)(c,E.browser);(0,I.isEqualOrParent)(i,c)||t.push([L.default.Warning,r.localize(12,null,i.path,c.path)])}}if(!_.valid(E.version))return t.push([L.default.Error,r.localize(13,null)]),t;const l=[];if(!f(m,d,E,u,l))for(const i of l)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=S;function f(m,d,c,E,u){return E||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(m,d,c.engines.vscode,u)}e.isValidExtensionVersion=f;function y(m,d,c){return m==="*"||v(d,c,m)}e.isEngineValid=y;function v(m,d,c,E=[]){const u=g(a(c));if(!u)return E.push(r.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(r.localize(15,null,c)),!1}else if(!u.majorMustEqual)return E.push(r.localize(16,null,c)),!1;return w(m,d,u)?!0:(E.push(r.localize(17,null,m,c)),!1)}function p(m){if(!Array.isArray(m))return!1;for(let d=0,c=m.length;d<c;d++)if(typeof m[d]!="string")return!1;return!0}}),define(ee[204],te([0,1,18,32]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(_,M,C){let h=C&&C.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const g=(await M.readFile(_.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(g)?g:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await M.writeFile(_.serviceMachineIdResource,I.VSBuffer.fromString(h))}catch{}}return C?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=r}),define(ee[75],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(r,_=[],M=!1){this.ctor=r,this.staticArguments=_,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=I}),define(ee[205],te([0,1,75]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function _(C,h,a){h instanceof I.SyncDescriptor||(h=new I.SyncDescriptor(h,[],!!a)),L.push([C,h])}e.registerSingleton=_;function M(){return L}e.getSingletonServiceDescriptors=M}),define(ee[206],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(_,M){this.key=_,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(const M of this._nodes.values())M.outgoing.size===0&&_.push(M);return _}insertEdge(_,M){const C=this.lookupOrInsertNode(_),h=this.lookupOrInsertNode(M);C.outgoing.set(h.key,h),h.incoming.set(C.key,C)}removeNode(_){const M=this._hashFn(_);this._nodes.delete(M);for(const C of this._nodes.values())C.outgoing.delete(M),C.incoming.delete(M)}lookupOrInsertNode(_){const M=this._hashFn(_);let C=this._nodes.get(M);return C||(C=new I(M,_),this._nodes.set(M,C)),C}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){const _=[];for(const[M,C]of this._nodes)_.push(`${M}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return _.join(`
`)}findCycleSlow(){for(const[_,M]of this._nodes){const C=new Set([_]),h=this._findCycle(M,C);if(h)return h}}_findCycle(_,M){for(const[C,h]of _.outgoing){if(M.has(C))return[...M,C].join(" -> ");M.add(C);const a=this._findCycle(h,M);if(a)return a;M.delete(C)}}}e.Graph=L}),define(ee[6],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function C(h){return h[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=C})(I||(e._util=I={})),e.IInstantiationService=r("instantiationService");function L(M,C,h){C[I.DI_TARGET]===C?C[I.DI_DEPENDENCIES].push({id:M,index:h}):(C[I.DI_DEPENDENCIES]=[{id:M,index:h}],C[I.DI_TARGET]=C)}function r(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const C=function(h,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,h,g)};return C.toString=()=>M,I.serviceIds.set(M,C),C}e.createDecorator=r;function _(M){return M}e.refineServiceDecorator=_}),define(ee[64],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[17],te([0,1,12,7,6]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function _(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationOverrides=_;function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function h(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.isConfigured=a;function g(m,d){const c=Object.create(null);for(const E in m)w(c,E,m[E],d);return c}e.toValuesTree=g;function w(m,d,c,E){const u=d.split("."),t=u.pop();let l=m;for(let s=0;s<u.length;s++){const i=u[s];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${d} as ${u.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=c}catch{E(`Ignoring ${d} as ${u.join(".")} is ${JSON.stringify(l)}`)}else E(`Ignoring ${d} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=w;function S(m,d){const c=d.split(".");f(m,c)}e.removeFromValueTree=S;function f(m,d){const c=d.shift();if(d.length===0){delete m[c];return}if(Object.keys(m).indexOf(c)!==-1){const E=m[c];typeof E=="object"&&!Array.isArray(E)&&(f(E,d),Object.keys(E).length===0&&delete m[c])}}function y(m,d,c){function E(l,s){let i=l;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=d.split("."),t=E(m,u);return typeof t>"u"?c:t}e.getConfigurationValue=y;function v(m,d,c){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in m?I.isObject(m[E])&&I.isObject(d[E])?v(m[E],d[E],c):c&&(m[E]=d[E]):m[E]=d[E])})}e.merge=v;function p(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ee[114],te([0,1,4,27,195,6,162,14]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",I.isMacintosh),h.set("isLinux",I.isLinux),h.set("isWindows",I.isWindows),h.set("isWeb",I.isWeb),h.set("isMacNative",I.isMacintosh&&!I.isWeb),h.set("isEdge",I.isEdge),h.set("isFirefox",I.isFirefox),h.set("isChrome",I.isChrome),h.set("isSafari",I.isSafari);function a(N,A){if(h.get(N)!==void 0)throw(0,C.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(N,A)}e.setConstant=a;const g=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const S={regexParsingWithErrorRecovery:!0},f=(0,M.localize)(0,null),y=(0,M.localize)(1,null),v=(0,M.localize)(2,null),p=(0,M.localize)(3,null),m=(0,M.localize)(4,null),d=(0,M.localize)(5,null),c=(0,M.localize)(6,null),E=(0,M.localize)(7,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=S){this._config=A,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const T=this._expr();if(!this._isAtEnd()){const q=this._peek(),B=q.type===17?d:void 0;throw this._parsingErrors.push({message:m,offset:q.offset,lexeme:r.Scanner.getLexeme(q),additionalInfo:B}),u._parseError}return T}catch(T){if(T!==u._parseError)throw T;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const T=this._and();A.push(T)}return A.length===1?A[0]:t.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const T=this._term();A.push(T)}return A.length===1?A[0]:t.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const T=this._expr();return this._consume(1,p),T?.negate()}case 17:return this._advance(),O.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const T=this._expr();return this._consume(1,p),T}case 17:{const T=A.lexeme;if(this._advance(),this._matchOne(9)){const B=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),B.type!==10)throw this._errExpectedButGot("REGEX",B);const z=B.lexeme,j=z.lastIndexOf("/"),ce=j===z.length-1?void 0:this._removeFlagsGY(z.substring(j+1));let fe;try{fe=new RegExp(z.substring(1,j),ce)}catch{throw this._errExpectedButGot("REGEX",B)}return ne.create(T,fe)}switch(B.type){case 10:case 19:{const z=[B.lexeme];this._advance();let j=this._peek(),ce=0;for(let we=0;we<B.lexeme.length;we++)B.lexeme.charCodeAt(we)===40?ce++:B.lexeme.charCodeAt(we)===41&&ce--;for(;!this._isAtEnd()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let we=0;we<j.lexeme.length;we++)j.lexeme.charCodeAt(we)===40?ce++:B.lexeme.charCodeAt(we)===41&&ce--}if(ce<0)break;z.push(r.Scanner.getLexeme(j)),this._advance(),j=this._peek()}const fe=z.join(""),ue=fe.lastIndexOf("/"),he=ue===fe.length-1?void 0:this._removeFlagsGY(fe.substring(ue+1));let ye;try{ye=new RegExp(fe.substring(1,ue),he)}catch{throw this._errExpectedButGot("REGEX",B)}return t.regex(T,ye)}case 18:{const z=B.lexeme;this._advance();let j=null;if(!(0,L.isFalsyOrWhitespace)(z)){const ce=z.indexOf("/"),fe=z.lastIndexOf("/");if(ce!==fe&&ce>=0){const ue=z.slice(ce+1,fe),he=z[fe+1]==="i"?"i":"";try{j=new RegExp(ue,he)}catch{throw this._errExpectedButGot("REGEX",B)}}}if(j===null)throw this._errExpectedButGot("REGEX",B);return ne.create(T,j)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const B=this._value();return t.notIn(T,B)}switch(this._peek().type){case 3:{this._advance();const B=this._value();if(this._previous().type===18)return t.equals(T,B);switch(B){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,B)}}case 4:{this._advance();const B=this._value();if(this._previous().type===18)return t.notEquals(T,B);switch(B){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,B)}}case 5:return this._advance(),J.create(T,this._value());case 6:return this._advance(),ae.create(T,this._value());case 7:return this._advance(),$.create(T,this._value());case 8:return this._advance(),re.create(T,this._value());case 13:return this._advance(),t.in(T,this._value());default:return t.has(T)}}case 20:throw this._parsingErrors.push({message:c,offset:A.offset,lexeme:"",additionalInfo:E}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,T){if(this._check(A))return this._advance();throw this._errExpectedButGot(T,this._peek())}_errExpectedButGot(A,T,q){const B=(0,M.localize)(8,null,A,r.Scanner.getLexeme(T)),z=T.offset,j=r.Scanner.getLexeme(T);return this._parsingErrors.push({message:B,offset:z,lexeme:j,additionalInfo:q}),u._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=u;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(A){return b.create(A)}static equals(A,T){return D.create(A,T)}static notEquals(A,T){return k.create(A,T)}static regex(A,T){return ne.create(A,T)}static in(A,T){return R.create(A,T)}static notIn(A,T){return P.create(A,T)}static not(A){return O.create(A)}static and(...A){return V.create(A,null,!0)}static or(...A){return x.create(A,null,!0)}static greater(A,T){return $.create(A,T)}static greaterEquals(A,T){return re.create(A,T)}static smaller(A,T){return J.create(A,T)}static smallerEquals(A,T){return ae.create(A,T)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=t;function l(N){const A=new u({regexParsingWithErrorRecovery:!1});return N.map(T=>(A.parse(T),A.lexingErrors.length>0?A.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,M.localize)(9,null,q.additionalInfo):(0,M.localize)(10,null),offset:q.offset,length:q.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}e.validateWhenClauses=l;function s(N,A){const T=N?N.substituteConstants():void 0,q=A?A.substituteConstants():void 0;return!T&&!q?!0:!T||!q?!1:T.equals(q)}e.expressionsAreEqualWithConstantSubstitution=s;function i(N,A){return N.cmp(A)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=o;class b{static create(A,T=null){const q=h.get(A);return typeof q=="boolean"?q?o.INSTANCE:n.INSTANCE:new b(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:U(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?o.INSTANCE:n.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class D{static create(A,T,q=null){if(typeof T=="boolean")return T?b.create(A,q):O.create(A,q);const B=h.get(A);return typeof B=="boolean"?T===(B?"true":"false")?o.INSTANCE:n.INSTANCE:new D(A,T,q)}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=h.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?o.INSTANCE:n.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class R{static create(A,T){return new R(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.valueKey),q=A.getValue(this.key);return Array.isArray(T)?T.includes(q):typeof q=="string"&&typeof T=="object"&&T!==null?g.call(T,q):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class P{static create(A,T){return new P(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=11,this._negated=R.create(A,T)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class k{static create(A,T,q=null){if(typeof T=="boolean")return T?O.create(A,q):b.create(A,q);const B=h.get(A);return typeof B=="boolean"?T===(B?"true":"false")?n.INSTANCE:o.INSTANCE:new k(A,T,q)}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=h.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?n.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class O{static create(A,T=null){const q=h.get(A);return typeof q=="boolean"?q?n.INSTANCE:o.INSTANCE:new O(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:U(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?n.INSTANCE:o.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(N,A){if(typeof N=="string"){const T=parseFloat(N);isNaN(T)||(N=T)}return typeof N=="string"||typeof N=="number"?A(N):n.INSTANCE}class ${static create(A,T,q=null){return F(T,B=>new $(A,B,q))}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=$;class re{static create(A,T,q=null){return F(T,B=>new re(A,B,q))}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=re;class J{static create(A,T,q=null){return F(T,B=>new J(A,B,q))}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=J;class ae{static create(A,T,q=null){return F(T,B=>new ae(A,B,q))}constructor(A,T,q){this.key=A,this.value=T,this.negated=q,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ae;class ne{static create(A,T){return new ne(A,T)}constructor(A,T){this.key=A,this.regexp=T,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const T=this.regexp?this.regexp.source:"",q=A.regexp?A.regexp.source:"";return T<q?-1:T>q?1:0}equals(A){if(A.type===this.type){const T=this.regexp?this.regexp.source:"",q=A.regexp?A.regexp.source:"";return this.key===A.key&&T===q}return!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=ne;class se{static create(A){return new se(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new se(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function G(N){let A=null;for(let T=0,q=N.length;T<q;T++){const B=N[T].substituteConstants();if(N[T]!==B&&A===null){A=[];for(let z=0;z<T;z++)A[z]=N[z]}A!==null&&(A[T]=B)}return A===null?N:A}class V{static create(A,T,q){return V._normalizeArr(A,T,q)}constructor(A,T){this.expr=A,this.negated=T,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,q=this.expr.length;T<q;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=G(this.expr);return A===this.expr?this:V.create(A,this.negated,!1)}evaluate(A){for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].evaluate(A))return!1;return!0}static _normalizeArr(A,T,q){const B=[];let z=!1;for(const j of A)if(j){if(j.type===1){z=!0;continue}if(j.type===0)return n.INSTANCE;if(j.type===6){B.push(...j.expr);continue}B.push(j)}if(B.length===0&&z)return o.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];for(;B.length>1;){const j=B[B.length-1];if(j.type!==9)break;B.pop();const ce=B.pop(),fe=B.length===0,ue=x.create(j.expr.map(he=>V.create([he,ce],null,q)),null,fe);ue&&(B.push(ue),B.sort(i))}if(B.length===1)return B[0];if(q){for(let j=0;j<B.length;j++)for(let ce=j+1;ce<B.length;ce++)if(B[j].negate().equals(B[ce]))return n.INSTANCE;if(B.length===1)return B[0]}return new V(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new V(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class x{static create(A,T,q){return x._normalizeArr(A,T,q)}constructor(A,T){this.expr=A,this.negated=T,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,q=this.expr.length;T<q;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=G(this.expr);return A===this.expr?this:x.create(A,this.negated,!1)}evaluate(A){for(let T=0,q=this.expr.length;T<q;T++)if(this.expr[T].evaluate(A))return!0;return!1}static _normalizeArr(A,T,q){let B=[],z=!1;if(A){for(let j=0,ce=A.length;j<ce;j++){const fe=A[j];if(fe){if(fe.type===0){z=!0;continue}if(fe.type===1)return o.INSTANCE;if(fe.type===9){B=B.concat(fe.expr);continue}B.push(fe)}}if(B.length===0&&z)return n.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];if(q){for(let j=0;j<B.length;j++)for(let ce=j+1;ce<B.length;ce++)if(B[j].negate().equals(B[ce]))return o.INSTANCE;if(B.length===1)return B[0]}return new x(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new x(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());for(;A.length>1;){const T=A.shift(),q=A.shift(),B=[];for(const z of oe(T))for(const j of oe(q))B.push(V.create([z,j],null,!1));A.unshift(x.create(B,null,!1))}this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends b{static{this._info=[]}static all(){return W._info.values()}constructor(A,T,q){super(A,null),this._defaultValue=T,typeof q=="object"?W._info.push({...q,key:A}):q!==!0&&W._info.push({key:A,description:q,type:T!=null?typeof T:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return D.create(this.key,A)}notEqualsTo(A){return k.create(this.key,A)}}e.RawContextKey=W,e.IContextKeyService=(0,_.createDecorator)("contextKeyService");function U(N,A){return N<A?-1:N>A?1:0}function H(N,A,T,q){return N<T?-1:N>T?1:A<q?-1:A>q?1:0}function Q(N,A){if(N.type===0||A.type===1)return!0;if(N.type===9)return A.type===9?ie(N.expr,A.expr):!1;if(A.type===9){for(const T of A.expr)if(Q(N,T))return!0;return!1}if(N.type===6){if(A.type===6)return ie(A.expr,N.expr);for(const T of N.expr)if(Q(T,A))return!0;return!1}return N.equals(A)}e.implies=Q;function ie(N,A){let T=0,q=0;for(;T<N.length&&q<A.length;){const B=N[T].cmp(A[q]);if(B<0)return!1;B===0&&T++,q++}return T===N.length}function oe(N){return N.type===9?N.expr:[N]}}),define(ee[90],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function L(_){return!!_.hostName&&!!_.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(M,C){return{}}async getSystemInfo(M,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,C){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(ee[115],te([0,1,19,71,164,6,46,4,37]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,_.createDecorator)("dialogService");var a;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(a||(a={}));class g{getConfirmationButtons(p){return this.getButtons(p,a.Confirmation)}getPromptButtons(p){return this.getButtons(p,a.Prompt)}getInputButtons(p){return this.getButtons(p,a.Input)}getButtons(p,m){const d=[];switch(m){case a.Confirmation:{const c=p;c.primaryButton?d.push(c.primaryButton):d.push((0,r.localize)(0,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,r.localize)(1,null));break}case a.Prompt:{const c=p;Array.isArray(c.buttons)&&c.buttons.length>0&&d.push(...c.buttons.map(E=>E.label)),c.cancelButton&&(c.cancelButton===!0?d.push((0,r.localize)(2,null)):typeof c.cancelButton=="string"?d.push(c.cancelButton):c.cancelButton.label?d.push(c.cancelButton.label):d.push((0,r.localize)(3,null))),d.length===0&&d.push((0,r.localize)(4,null));break}case a.Input:{const c=p;c.primaryButton?d.push(c.primaryButton):d.push((0,r.localize)(5,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,r.localize)(6,null));break}}return d}getDialogType(p){if(typeof p=="string")return p;if(typeof p=="number")return p===L.default.Info?"info":p===L.default.Error?"error":p===L.default.Warning?"warning":"none"}getPromptResult(p,m,d){const c=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&c.push(p.cancelButton);let E=c[m]?.run({checkboxChecked:d});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:d}}}e.AbstractDialogHandler=g,e.IFileDialogService=(0,_.createDecorator)("fileDialogService");var w;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const S=10;function f(v){const p=[];return p.push(...v.slice(0,S).map(m=>typeof m=="string"?m:(0,I.basename)(m))),v.length>S&&(v.length-S===1?p.push((0,r.localize)(7,null)):p.push((0,r.localize)(8,null,v.length-S))),p.push(""),p.join(`
`)}e.getFileNamesMessage=f;function y(v,p){const m=(0,h.deepClone)(v);let d=(m.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),c=(v.buttons||[]).map((t,l)=>l),E=0,u=m.cancelId??d.length-1;if(d.length>1){const t=typeof u=="number"?d[u]:void 0;if(C.isLinux||C.isMacintosh){if(typeof t=="string"&&d.length>1&&u!==1){d.splice(u,1),d.splice(1,0,t);const l=c[u];c.splice(u,1),c.splice(1,0,l),u=1}C.isLinux&&d.length>1&&(d=d.reverse(),c=c.reverse(),E=d.length-1,typeof t=="string"&&(u=E-1))}else if(C.isWindows&&typeof t=="string"&&d.length>1&&u!==d.length-1){d.splice(u,1),d.push(t);const l=c[u];c.splice(u,1),c.push(l),u=d.length-1}}return m.buttons=d,m.defaultId=E,m.cancelId=u,m.noLink=!0,m.title=m.title||p.nameLong,{options:m,buttonIndeces:c}}e.massageMessageBoxOptions=y}),define(ee[116],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,I.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService");var L;(function(C){C.kwallet="kwallet",C.kwallet5="kwallet5",C.gnome="gnome",C.gnomeKeyring="gnome-keyring",C.gnomeLibsecret="gnome-libsecret",C.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(C){C.unknown="unknown",C.basicText="basic_text",C.gnomeAny="gnome_any",C.gnomeLibsecret="gnome_libsecret",C.gnomeKeyring="gnome_keyring",C.kwallet="kwallet",C.kwallet5="kwallet5",C.kwallet6="kwallet6",C.dplib="dpapi",C.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function _(C){return C==="kwallet"||C==="kwallet5"||C==="kwallet6"}e.isKwallet=_;function M(C){return C==="gnome_any"||C==="gnome_libsecret"||C==="gnome_keyring"}e.isGnome=M}),define(ee[36],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[117],te([0,1,168,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function _(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function M(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function C(d,c){return c==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function h(d,c,E){return C(c,E)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===E?!0:a(E).includes(d)}e.isTargetPlatformCompatible=h;function a(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=a;function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=g;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var f;(function(d){d.Install="install",d.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var p;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class m extends Error{constructor(c,E){super(c),this.code=E,this.name=E}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[208],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ee[209],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[210],te([0,1,47,13,9,4,73,21,88,172,208]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=a.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{static{this.CMD="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(I,E,h.getWindowsShell(),u)}spawnTerminal(E,u,t,l){const s=u.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=r.basename(s,".exe").toLowerCase();if(i==="cmder")return E.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),i==="wt"&&n.push("-d ."),new Promise((o,b)=>{const D=p(process),R=E.spawn(t,n,{cwd:l,env:D});R.on("error",b),R.on("exit",()=>o())})}runInTerminal(E,u,t,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,o)=>{const b=`"${u} - ${w}"`,D=`""${t.join('" "')}" & pause"`,R=Object.assign({},p(process),l);Object.keys(R).filter($=>R[$]===null).forEach($=>delete R[$]);const P={cwd:u,env:R,windowsVerbatimArguments:!0};let k,O;r.basename(i,".exe")==="wt"?(k=i,O=["-d",".",f.CMD,"/c",D]):(k=f.CMD,O=["/c","start",b,"/wait",i,"/c",D]),I.spawn(k,O,P).on("error",$=>{o(m($))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f;class y extends S{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(I,E,u)}runInTerminal(E,u,t,l,s){const i=s.osxExec||g.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{if(i===g.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const b=i===g.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`).fsPath,"-t",E||w,"-w",u];for(const O of t)R.push("-a"),R.push(O);if(l){const O=Object.assign({},p(process),l);for(const F in O){const $=O[F];$===null?(R.push("-u"),R.push(F)):(R.push("-e"),R.push(`${F}=${$}`))}}let P="";const k=I.spawn(y.OSASCRIPT,R);k.on("error",O=>{o(m(O))}),k.stderr.on("data",O=>{P+=O.toString()}),k.on("exit",O=>{if(O===0)n(void 0);else if(P){const F=P.split(`
`,1);o(new Error(F[0]))}else o(new Error(a.localize(1,null,b,O)))})}else o(new Error(a.localize(2,null,i)))})}spawnTerminal(E,u,t){const l=u.osxExec||g.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const n=["-a",l];t&&n.push(t);const o=p(process),b=E.spawn("/usr/bin/open",n,{cwd:t,env:o});b.on("error",i),b.on("exit",()=>s())})}}e.MacExternalTerminalService=y;class v extends S{static{this.WAIT_MESSAGE=a.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(I,E,u)}runInTerminal(E,u,t,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const b=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const R=`${d(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;b.push(`''${R}''`);const P=Object.assign({},p(process),l);Object.keys(P).filter($=>P[$]===null).forEach($=>delete P[$]);const k={cwd:u,env:P};let O="";const F=I.spawn(D,b,k);F.on("error",$=>{o(m($))}),F.stderr.on("data",$=>{O+=$.toString()}),F.on("exit",$=>{if($===0)n(void 0);else if(O){const re=O.split(`
`,1);o(new Error(re[0]))}else o(new Error(a.localize(4,null,D,$)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await C.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(n=>{const o=p(process),b=E.spawn(n,[],{cwd:t,env:o});b.on("error",i),b.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=v;function p(c){const E={...c.env};return(0,M.sanitizeProcessEnvironment)(E),E}function m(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(a.localize(5,null,c.path)):c}function d(c){let E="";for(const u of c)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(ee[16],te([0,1,56,9,27,12,7,174,6,4,13]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function w(U){return U.create===!0}e.isFileOpenForWriteOptions=w;var S;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var f;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function v(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=v;function p(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=p;function m(U){return!!(U.capabilities&131072)}e.hasFileCloneCapability=m;function d(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function c(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=c;function E(U){return v(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;function u(U){return v(U)?!!(U.capabilities&32768):!1}e.hasFileAtomicWriteCapability=u;function t(U){return!!(U.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function l(U){return!!(U.capabilities&2048)}e.hasReadonlyCapability=l;var s;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(H,Q){const ie=new i(H.toString(),Q);return b(ie,Q),ie}constructor(H,Q){super(H),this.code=Q}}e.FileSystemProviderError=i;function n(U,H){return i.create(U,H)}e.createFileSystemProviderError=n;function o(U){return U||n((0,C.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=o;function b(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=b;function D(U){if(!U)return s.Unknown;if(U instanceof i)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return s.Unknown;switch(H[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=D;function R(U){if(U instanceof re)return U.fileOperationResult;switch(D(U)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=R;var P;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class k{constructor(H,Q,ie){this.resource=H,this.operation=Q,this.target=ie}isOperation(H){return this.operation===H}}e.FileOperationEvent=k;var O;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class F{constructor(H,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const oe of H){const N=ie.get(oe.type);switch(N?N.push([oe.resource,oe]):ie.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,N]of ie)switch(oe){case 1:this.added=I.TernarySearchTree.forUris(()=>Q),this.added.fill(N);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>Q),this.updated.fill(N);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>Q),this.deleted.fill(N);break}}contains(H,...Q){return this.doContains(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.doContains(H,{includeChildren:!0},...Q)}doContains(H,Q,...ie){if(!H)return!1;const oe=ie.length>0;return!!((!oe||ie.includes(1))&&(this.added?.get(H)||Q.includeChildren&&this.added?.findSuperstr(H))||(!oe||ie.includes(0))&&(this.updated?.get(H)||Q.includeChildren&&this.updated?.findSuperstr(H))||(!oe||ie.includes(2))&&(this.deleted?.findSubstr(H)||Q.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function $(U,H,Q){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),Q?(0,r.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=$;class re extends Error{constructor(H,Q,ie){super(H),this.fileOperationResult=Q,this.options=ie}}e.FileOperationError=re;class J extends re{constructor(H,Q,ie,oe){super(H,Q,oe),this.fileOperationResult=Q,this.size=ie}}e.TooLargeFileOperationError=J;class ae extends re{constructor(H,Q,ie){super(H,2,ie),this.stat=Q}}e.NotModifiedSinceFileOperationError=ae;var ne;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var se;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(se||(e.FileKind=se={})),e.ETAG_DISABLED="";function G(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=G;async function V(U,H){if(!H.hasProvider(M.URI.from({scheme:U.scheme})))return new Promise(Q=>{const ie=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===U.scheme&&oe.added&&(ie.dispose(),Q())})})}e.whenProviderRegistered=V;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(H){return(0,_.isNumber)(H)||(H=0),H<x.KB?(0,C.localize)(1,null,H.toFixed(0)):H<x.MB?(0,C.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,C.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,C.localize)(4,null,(H/x.GB).toFixed(2)):(0,C.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x;function W(U){const H=typeof U=="string"||U?.scheme===g.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===g.Schemas.file?1024*x.MB:H?10*x.MB:a.isWeb?50*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=W}),define(ee[211],te([0,1,18,49,14,3,2,62,7,32,16]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends M.Disposable{constructor(f,y){super(),this.channel=f,this.extraCapabilities=y,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,a.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,y){const{buffer:v}=await this.channel.call("readFile",[f,y]);return v}readFileStream(f,y,v){const p=(0,C.newWriteableStream)(d=>I.VSBuffer.concat(d.map(c=>I.VSBuffer.wrap(c))).buffer),m=new M.DisposableStore;return m.add(this.channel.listen("readFileStream",[f,y])(d=>{if(d instanceof I.VSBuffer)p.write(d.buffer);else{if(d==="end")p.end();else{let c;if(d instanceof Error)c=d;else{const E=d;c=(0,g.createFileSystemProviderError)(E.message??(0,L.toErrorMessage)(E),E.code??g.FileSystemProviderErrorCode.Unknown)}p.error(c),p.end()}m.dispose()}})),m.add(v.onCancellationRequested(()=>{p.error((0,r.canceled)()),p.end(),m.dispose()})),p}writeFile(f,y,v){return this.channel.call("writeFile",[f,I.VSBuffer.wrap(y),v])}open(f,y){return this.channel.call("open",[f,y])}close(f){return this.channel.call("close",[f])}async read(f,y,v,p,m){const[d,c]=await this.channel.call("read",[f,y,m]);return v.set(d.buffer.slice(0,c),p),c}write(f,y,v,p,m){return this.channel.call("write",[f,y,I.VSBuffer.wrap(v),p,m])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,y){return this.channel.call("delete",[f,y])}rename(f,y,v){return this.channel.call("rename",[f,y,v])}copy(f,y,v){return this.channel.call("copy",[f,y,v])}cloneFile(f,y){return this.channel.call("cloneFile",[f,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const y=f;this._onDidChange.fire(y.map(v=>({resource:h.URI.revive(v.resource),type:v.type})))}else{const y=f;this._onDidWatchError.fire(y)}}))}watch(f,y){const v=(0,a.generateUuid)();return this.channel.call("watch",[this.sessionId,v,f,y]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=w}),define(ee[118],te([0,1,18,14,175,16]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(g,w,S,f,y,v){let p;try{await C(g,w,S,f,y,v)}catch(m){p=m}finally{p&&y.errorTransformer&&(p=y.errorTransformer(p)),typeof p<"u"&&S.error(p),S.end()}}e.readFileIntoStream=M;async function C(g,w,S,f,y,v){h(v);const p=await g.open(w,{create:!1});try{h(v);let m=0,d=0,c=y&&typeof y.length=="number"?y.length:void 0,E=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do d=await g.read(p,u,E.buffer,t,E.byteLength-t),u+=d,t+=d,m+=d,typeof c=="number"&&(c-=d),t===E.byteLength&&(await S.write(f(E)),E=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),t=0);while(d>0&&(typeof c!="number"||c>0)&&h(v)&&a(m,y));if(t>0){let l=t;typeof c=="number"&&(l=Math.min(t,c)),S.write(f(E.slice(0,l)))}}catch(m){throw(0,_.ensureFileSystemProviderError)(m)}finally{await g.close(p)}}function h(g){if(g.isCancellationRequested)throw(0,L.canceled)();return!0}function a(g,w){if(typeof w?.limits?.size=="number"&&g>w.limits.size)throw(0,_.createFileSystemProviderError)((0,r.localize)(0,null),_.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[76],te([0,1,104,2,9,4,7,16]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(m){return m.recursive===!0}e.isRecursiveWatchRequest=h;class a extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(d,c,E,u){super(),this.onFileChanges=d,this.onLogMessage=c,this.verboseLogging=E,this.options=u,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new L.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),d.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),d.add(this.watcher.onDidError(c=>this.onError(c)))}onError(d){this.options.restartOnError?this.restartCounter<a.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=a;class g extends a{constructor(d,c,E){super(d,c,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=g;class w extends a{constructor(d,c,E){super(d,c,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function S(m){return m.map(d=>({type:d.type,resource:M.URI.revive(d.resource)}))}e.toFileChanges=S;function f(m){const d=new p;for(const c of m)d.processEvent(c);return d.coalesce()}e.coalesceEvents=f;function y(m,d){return typeof d=="string"&&!d.startsWith(I.GLOBSTAR)&&!(0,r.isAbsolute)(d)?{base:m,pattern:d}:d}e.normalizeWatcherPattern=y;function v(m,d){const c=[];for(const E of d)c.push((0,I.parse)(y(m,E)));return c}e.parseWatcherPatterns=v;class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return _.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const c=this.mapPathToChange.get(this.toKey(d));let E=!1;if(c){const u=c.type,t=d.type;c.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?E=!0:u===1&&t===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else E=!0;E&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],c=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(d.push(E),!1):!0).sort((E,u)=>E.resource.fsPath.length-u.resource.fsPath.length).filter(E=>c.some(u=>(0,C.isParent)(E.resource.fsPath,u,!_.isLinux))?!1:(c.push(E.resource.fsPath),!0)).concat(d)}}}),define(ee[212],te([0,1,45,8,22,33,2,84,9,4,7,105,21,76]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends M.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(m,d,c,E){super(),this.request=m,this.onDidFilesChange=d,this.onLogMessage=c,this.verboseLogging=E,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(u=>this.handleFileChanges(u),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,f.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,f.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await S.Promises.stat(m);this._register(await this.doWatch(m,d.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let d=m.path;try{d=await S.Promises.realpath(m.path),m.path===d&&(d=await(0,w.realcase)(m.path)??m.path),m.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${d})`)}catch{}return d}async doWatch(m,d){if(a.isMacintosh&&(0,_.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const c=new r.CancellationTokenSource(this.cts.token),E=new M.DisposableStore;try{const u=(0,h.basename)(m),t=(0,I.watch)(m);E.add((0,M.toDisposable)(()=>{t.removeAllListeners(),t.close()})),this.trace(`Started watching: '${m}'`);const l=new Set;if(d)try{for(const i of await S.Promises.readdir(m))l.add(i)}catch(i){this.error(i)}const s=new Map;E.add((0,M.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),t.on("error",(i,n)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),t.on("change",(i,n)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),a.isMacintosh&&(o=(0,C.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){s.get(o)?.dispose();const b=setTimeout(async()=>{if(s.delete(o),o===u&&!await S.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const D=await this.existsChildStrictCase((0,h.join)(m,o));if(c.token.isCancellationRequested)return;let R;D?l.has(o)?R=0:(R=1,l.add(o)):(l.delete(o),R=2),this.onFileChange({resource:g.URI.file((0,h.join)(this.request.path,o)),type:R})},y.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,M.toDisposable)(()=>clearTimeout(b)))}else{let b;l.has(o)?b=0:(b=1,l.add(o)),this.onFileChange({resource:g.URI.file((0,h.join)(this.request.path,o)),type:b})}else if(i==="rename"||o!==u){const b=setTimeout(async()=>{const D=await S.Promises.exists(m);c.token.isCancellationRequested||(D?(this.onFileChange({resource:g.URI.file(this.request.path),type:0},!0),E.add(await this.doWatch(m,!1))):(this.onFileChange({resource:g.URI.file(this.request.path),type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);E.clear(),E.add((0,M.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:g.URI.file(this.request.path),type:0},!0)})}catch(u){await S.Promises.exists(m)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${u.toString()})`)}return(0,M.toDisposable)(()=>{c.dispose(!0),E.dispose()})}onFileChange(m,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!d&&this.excludes.some(c=>c(m.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${m.resource.fsPath}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(m.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${m.resource.fsPath}`):this.fileChangesAggregator.work(m))}handleFileChanges(m){const d=(0,f.coalesceEvents)(m);if(d.length>0){if(this.verboseLogging)for(const E of d)this.trace(`>> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.throttledFileChangesEmitter.work(d)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(m){if(a.isLinux)return S.Promises.exists(m);try{const d=(0,h.basename)(m);return(await S.Promises.readdir((0,h.dirname)(m))).some(E=>E===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function v(p,m,d,c,E=512){const u=await S.Promises.open(p,"r"),t=Buffer.allocUnsafe(E),l=new r.CancellationTokenSource(c);let s,i=!1;const n={path:p,excludes:[],recursive:!1},o=new y(n,b=>{(async()=>{for(const{type:D}of b)if(D===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:R}=await S.Promises.read(u,t,0,E,null);if(!R||l.token.isCancellationRequested)break;m(t.slice(0,R))}}catch(R){s=new Error(R),l.dispose(!0)}finally{i=!1}}})()});return await o.ready,d(),new Promise((b,D)=>{l.token.onCancellationRequested(async()=>{o.dispose();try{await S.Promises.close(u)}catch(R){s=new Error(R)}s?D(s):b()})})}e.watchFileContents=v}),define(ee[213],te([0,1,3,104,2,4,212]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(a){const g=this.normalizeRequests(a),w=g.filter(f=>{const y=this.watchers.get(f.path);return y?!(0,L.patternsEquals)(y.request.excludes,f.excludes)||!(0,L.patternsEquals)(y.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!g.find(y=>y.path===f.path&&(0,L.patternsEquals)(y.excludes,f.excludes)&&(0,L.patternsEquals)(y.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.trace(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of w)this.startWatching(f)}startWatching(a){const g=new M.NodeJSFileWatcherLibrary(a,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),w={request:a,instance:g};this.watchers.set(a.path,w)}async stop(){for(const[a]of this.watchers)this.stopWatching(a);this.watchers.clear()}stopWatching(a){const g=this.watchers.get(a);g&&(this.watchers.delete(a),g.instance.dispose())}normalizeRequests(a){const g=new Map;for(const w of a){const S=_.isLinux?w.path:w.path.toLowerCase();g.set(S,w)}return Array.from(g.values())}async setVerboseLogging(a){this.verboseLogging=a;for(const[,g]of this.watchers)g.instance.setVerboseLogging(a)}trace(a){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a)})}toMessage(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.NodeJSWatcher=C}),define(ee[214],te([0,1,76,213]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends I.AbstractNonRecursiveWatcherClient{constructor(M,C,h){super(M,C,h),this.init()}createWatcher(M){return M.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(ee[215],te([0,1,13,42,158,76]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends _.AbstractUniversalWatcherClient{constructor(h,a,g){super(h,a,g),this.init()}createWatcher(h){const a=h.add(new r.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(a.onDidProcessExit(({code:g,signal:w})=>this.onError(`terminated by itself with code ${g}, signal: ${w}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[91],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...r){this._entries=new Map;for(const[_,M]of r)this.set(_,M)}set(r,_){const M=this._entries.get(r);return this._entries.set(r,_),M}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=I}),define(ee[216],te([0,1,8,14,2,75,206,6,91,101]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class w extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class S{constructor(p=new h.ServiceCollection,m=!1,d,c=g){this._services=p,this._strict=m,this._parent=d,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=c?d?._globalGraph??new M.Graph(E=>E):void 0}createChild(p){return new S(p,this._strict,this,this._enableTracing)}invokeFunction(p,...m){const d=y.traceInvocation(this._enableTracing,p);let c=!1;try{return p({get:u=>{if(c)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(u,d);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...m)}finally{c=!0,d.stop()}}createInstance(p,...m){let d,c;return p instanceof _.SyncDescriptor?(d=y.traceCreation(this._enableTracing,p.ctor),c=this._createInstance(p.ctor,p.staticArguments.concat(m),d)):(d=y.traceCreation(this._enableTracing,p),c=this._createInstance(p,m,d)),d.stop(),c}_createInstance(p,m=[],d){const c=C._util.getServiceDependencies(p).sort((t,l)=>t.index-l.index),E=[];for(const t of c){const l=this._getOrCreateServiceInstance(t.id,d);l||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(l)}const u=c.length>0?c[0].index:m.length;if(m.length!==u){console.trace(`[createInstance] First service dependency of ${p.name} at position ${u+1} conflicts with ${m.length} static arguments`);const t=u-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,u)}return Reflect.construct(p,m.concat(E))}_setServiceInstance(p,m){if(this._services.get(p)instanceof _.SyncDescriptor)this._services.set(p,m);else if(this._parent)this._parent._setServiceInstance(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const m=this._services.get(p);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):m}_getOrCreateServiceInstance(p,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const d=this._getServiceInstanceOrDescriptor(p);return d instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,d,m.branch(p,!0)):(m.branch(p,!1),d)}_safeCreateAndCacheServiceInstance(p,m,d){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,m,d)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,m,d){const c=new M.Graph(t=>t.id.toString());let E=0;const u=[{id:p,desc:m,_trace:d}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),E++>1e3)throw new w(c);for(const l of C._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(l.id);if(s||this._throwIfStrict(`[createInstance] ${p} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),s instanceof _.SyncDescriptor){const i={id:l.id,desc:s,_trace:t._trace.branch(l.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new w(c);break}for(const{data:l}of t){if(this._getServiceInstanceOrDescriptor(l.id)instanceof _.SyncDescriptor){const i=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,i)}c.removeNode(l)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,m,d=[],c,E){if(this._services.get(p)instanceof _.SyncDescriptor)return this._createServiceInstance(p,m,d,c,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,m,d,c,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(p,m,d=[],c,E){if(c){const u=new S(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(p);const t=new Map,l=new I.IdleValue(()=>{const s=u._createInstance(m,d,E);for(const[i,n]of t){const o=s[i];if(typeof o=="function")for(const b of n)o.apply(s,b)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new a.LinkedList,t.set(i,b)),(R,P,k)=>{const O=b.push([R,P,k]);return(0,r.toDisposable)(O)}}if(i in s)return s[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),s[i]=o),o},set(s,i,n){return l.value[i]=n,!0},getPrototypeOf(s){return m.prototype}})}else return this._createInstance(m,d,E)}_throwIfStrict(p,m){if(m&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=S;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,m){return p?new y(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(p,m){return p?new y(1,m.name):y._None}static{this._totals=0}constructor(p,m){this.type=p,this.name=m,this._start=Date.now(),this._dep=[]}branch(p,m){const d=new y(3,p.toString());return this._dep.push([p,m,d]),d}stop(){const p=Date.now()-this._start;y._totals+=p;let m=!1;function d(E,u){const t=[],l=new Array(E+1).join("	");for(const[s,i,n]of u._dep)if(i&&n){m=!0,t.push(`${l}CREATES -> ${s}`);const o=d(E+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(p>2||m)&&y.all.add(c.join(`
`))}}e.Trace=y}),define(ee[217],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,I.createDecorator)("issueService")}),define(ee[5],te([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(K,e,I,L,r,_,M,C,h,a,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function f(){return new Date().toISOString()}function y(R){return(0,a.isNumber)(R)}e.isLogLevel=y;var v;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function p(R,P,k){switch(P){case v.Trace:R.trace(k);break;case v.Debug:R.debug(k);break;case v.Info:R.info(k);break;case v.Warning:R.warn(k);break;case v.Error:R.error(k);break;case v.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=p;function m(R,P=!1){let k="";for(let O=0;O<R.length;O++){let F=R[O];if(F instanceof Error&&(F=(0,I.toErrorMessage)(F,P)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(O>0?" ":"")+F}return k}class d extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==v.Off&&this.level<=P}}e.AbstractLogger=d;class c extends d{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...k){this.checkLogLevel(v.Trace)&&this.log(v.Trace,m([P,...k],!0))}debug(P,...k){this.checkLogLevel(v.Debug)&&this.log(v.Debug,m([P,...k]))}info(P,...k){this.checkLogLevel(v.Info)&&this.log(v.Info,m([P,...k]))}warn(P,...k){this.checkLogLevel(v.Warning)&&this.log(v.Warning,m([P,...k]))}error(P,...k){if(this.checkLogLevel(v.Error))if(P instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=P.stack,this.log(v.Error,m(O))}else this.log(v.Error,m([P,...k]))}flush(){}}e.AbstractMessageLogger=c;class E extends d{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!C.isWindows}trace(P,...k){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...k):console.log(`[main ${f()}]`,P,...k))}debug(P,...k){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...k):console.log(`[main ${f()}]`,P,...k))}info(P,...k){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...k):console.log(`[main ${f()}]`,P,...k))}warn(P,...k){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,P,...k):console.warn(`[main ${f()}]`,P,...k))}error(P,...k){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,P,...k):console.error(`[main ${f()}]`,P,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class u extends d{constructor(P=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(P)}trace(P,...k){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...k):console.log(P,...k))}debug(P,...k){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...k):console.log(P,...k))}info(P,...k){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...k):console.log(P,...k))}warn(P,...k){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...k):console.log(P,...k))}error(P,...k){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...k):console.error(P,...k))}dispose(){}flush(){}}e.ConsoleLogger=u;class t extends d{constructor(P,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(k)}trace(P,...k){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(P),...k])}debug(P,...k){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(P),...k])}info(P,...k){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(P),...k])}warn(P,...k){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(P),...k])}error(P,...k){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(P),...k])}extractMessage(P){return typeof P=="string"?P:(0,I.toErrorMessage)(P,this.checkLogLevel(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class l extends d{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const k of this.loggers)k.setLevel(P);super.setLevel(P)}trace(P,...k){for(const O of this.loggers)O.trace(P,...k)}debug(P,...k){for(const O of this.loggers)O.debug(P,...k)}info(P,...k){for(const O of this.loggers)O.info(P,...k)}warn(P,...k){for(const O of this.loggers)O.warn(P,...k)}error(P,...k){for(const O of this.loggers)O.error(P,...k)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose()}}e.MultiplexLogger=l;class s extends _.Disposable{constructor(P,k,O){if(super(),this.logLevel=P,this.logsHome=k,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(P){return(0,a.isString)(P)?[...this._loggers.values()].find(k=>k.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,k){const O=this.toResource(P),F=(0,a.isString)(P)?P:k?.id??(0,r.hash)(O.toString()).toString(16);let $=this._loggers.get(O)?.logger;const re=k?.logLevel==="always"?v.Trace:k?.logLevel;$||($=this.doCreateLogger(O,re??this.getLogLevel(O)??this.logLevel,{...k,id:F}));const J={logger:$,info:{resource:O,id:F,logLevel:re,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(J.info),this._loggers.set(O,J),$}toResource(P){return(0,a.isString)(P)?(0,h.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,k){if(g.URI.isUri(P)){const O=P,F=k,$=this._loggers.get(O);$&&F!==$.info.logLevel&&($.info.logLevel=F===this.logLevel?void 0:F,$.logger?.setLevel(F),this._loggers.set($.info.resource,$),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=P;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,k){const O=this.getLoggerEntry(P);O&&k!==!O.info.hidden&&(O.info.hidden=!k,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,k]))}getLogLevel(P){let k;return P&&(k=this._loggers.get(P)?.info.logLevel),k??this.logLevel}registerLogger(P){const k=this._loggers.get(P.resource);k?k.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const k=this._loggers.get(P);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return v.Info}trace(P,...k){}debug(P,...k){}info(P,...k){}warn(P,...k){}error(P,...k){}critical(P,...k){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function o(R){if(R.verbose)return v.Trace;if(typeof R.logLevel=="string"){const P=D(R.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function b(R){switch(R){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=b;function D(R){switch(R){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",b(v.Info))});var Z=this&&this.__param||function(K,e){return function(I,L){e(I,L,K)}};define(ee[218],te([0,1,15,4,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const _=I.safeStorage;let M=class{constructor(h){this.logService=h,I.app.commandLine.getSwitchValue("password-store")==="basic"&&_.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(_.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.logService.error(a),a}}async decrypt(h){let a;try{if(a=JSON.parse(h),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const g=Buffer.from(a.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const w=_.decryptString(g);return this.logService.trace("[EncryptionMainService] Decrypted value."),w}catch(g){throw this.logService.error(g),g}}isEncryptionAvailable(){return Promise.resolve(_.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(_.getSelectedStorageBackend)try{const h=_.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!_.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");_.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=M,e.EncryptionMainService=M=Ee([Z(0,r.ILogService)],M)}),define(ee[219],te([0,1,23,8,14,3,2,9,76,5]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class g extends M.Disposable{constructor(S,f){super(),this.logService=S,this.options=f,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const y={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,I.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,h.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const y={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,I.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,C.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=g}),define(ee[220],te([0,1,23,8,18,22,3,55,69,2,56,13,65,19,62,173,16,118,5,14]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends a.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,l){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const s=new a.DisposableStore;return this.provider.set(t,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:l}),s.add(l.onDidChangeFile(i=>this._onDidFilesChange.fire(new p.FileChangesEvent(i,!this.isPathCaseSensitive(l))))),typeof l.onDidWatchError=="function"&&s.add(l.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:t}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:l}),this.provider.delete(t),(0,a.dispose)(s)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(s){l.push(s)}}),!this.provider.has(t)&&await L.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,l){const s=this.provider.get(t.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return h.Iterable.map(this.provider,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async withProvider(t){if(!(0,f.isAbsolutePath)(t))throw new p.FileOperationError((0,v.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const l=this.provider.get(t.scheme);if(!l){const s=new c.ErrorNoTelemetry;throw s.message=(0,v.localize)(1,null,t.toString()),s}return l}async withReadProvider(t){const l=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(l)||(0,p.hasReadWriteCapability)(l)||(0,p.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const l=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(l)||(0,p.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.doResolveFile(t,l)}catch(s){throw(0,p.toFileSystemProviderErrorCode)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,v.localize)(2,null,this.resourceForError(t)),1):(0,p.ensureFileSystemProviderError)(s)}}async doResolveFile(t,l){const s=await this.withProvider(t),i=this.isPathCaseSensitive(s),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,b=l?.resolveMetadata,D=await s.stat(t);let R;return this.toFileStat(s,t,D,void 0,!!b,(P,k)=>(R||(R=g.TernarySearchTree.forUris(()=>!i),R.set(t,!0),n&&R.fill(!0,n)),R.get(P.resource)||R.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&o?k===1:!1))}async toFileStat(t,l,s,i,n,o){const{providerExtUri:b}=this.getExtUri(t),D={resource:l,name:b.basename(l),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&p.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&o(D,i)){try{const R=await t.readdir(l),P=await L.Promises.settled(R.map(async([k,O])=>{try{const F=b.joinPath(l,k),$=n?await t.stat(F):{type:O};return await this.toFileStat(t,F,$,R.length,n,o)}catch(F){return this.logService.trace(F),null}}));D.children=(0,I.coalesce)(P)}catch(R){this.logService.trace(R),D.children=[]}return D}return D}async resolveAll(t){return L.Promises.settled(t.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.withProvider(t),s=await l.stat(t);return this.toFileStat(l,t,s,void 0,!0,()=>!1)}async exists(t){const l=await this.withProvider(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.doValidateCreateFile(t,l)}catch(s){return s}return!0}async doValidateCreateFile(t,l){if(!l?.overwrite&&await this.exists(t))throw new p.FileOperationError((0,v.localize)(3,null,this.resourceForError(t)),3,l)}async createFile(t,l=r.VSBuffer.fromString(""),s){await this.doValidateCreateFile(t,s);const i=await this.writeFile(t,l);return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,i)),i}async writeFile(t,l,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:n}=this.getExtUri(i);let o=s;if((0,p.hasFileAtomicWriteCapability)(i)&&!o?.atomic){const b=i.enforceAtomicWriteFile?.(t);b&&(o={...s,atomic:b})}try{await this.validateWriteFile(i,t,o)||await this.mkdirp(i,n.dirname(t));let D;if((0,p.hasReadWriteCapability)(i)&&!(l instanceof r.VSBuffer))if((0,y.isReadableStream)(l)){const R=await(0,y.peekStream)(l,3);R.ended?D=r.VSBuffer.concat(R.buffer):D=R}else D=(0,y.peekReadable)(l,R=>r.VSBuffer.concat(R),3);else D=l;!(0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)&&D instanceof r.VSBuffer||(0,p.hasReadWriteCapability)(i)&&(0,p.hasFileAtomicWriteCapability)(i)&&o?.atomic?await this.doWriteUnbuffered(i,t,o,D):await this.doWriteBuffered(i,t,o,D instanceof r.VSBuffer?(0,r.bufferToReadable)(D):D),this._onDidRunOperation.fire(new p.FileOperationEvent(t,4))}catch(b){throw new p.FileOperationError((0,v.localize)(4,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(b).toString()),(0,p.toFileOperationResult)(b),o)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,l,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(l)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.resourceForError(l)));if(!(t.capabilities&2))throw new Error((0,v.localize)(7,null,this.resourceForError(l)));if(i)throw new Error((0,v.localize)(8,null,this.resourceForError(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&p.FileType.Directory)throw new p.FileOperationError((0,v.localize)(9,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,p.etag)({mtime:s.mtime,size:o.size}))throw new p.FileOperationError((0,v.localize)(10,null),3,s);return o}async readFile(t,l,s){const i=await this.withReadProvider(t);return l?.atomic?this.doReadFileAtomic(i,t,l,s):this.doReadFile(i,t,l,s)}async doReadFileAtomic(t,l,s,i){return new Promise((n,o)=>{this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{try{const b=await this.doReadFile(t,l,s,i);n(b)}catch(b){o(b)}})})}async doReadFile(t,l,s,i){const n=await this.doReadFileStream(t,l,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,r.streamToBuffer)(n.value)}}async readFileStream(t,l,s){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,l,s)}async doReadFileStream(t,l,s,i){const n=new _.CancellationTokenSource(i);let o=s;(0,p.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(l)&&(o={...s,atomic:!0});const b=this.validateReadFile(l,o).then(R=>R,R=>{throw n.dispose(!0),R});let D;try{return typeof o?.etag=="string"&&o.etag!==p.ETAG_DISABLED&&await b,o?.atomic&&(0,p.hasFileAtomicReadCapability)(t)||!((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasFileReadStreamCapability)(t))||(0,p.hasReadWriteCapability)(t)&&o?.preferUnbuffered?D=this.readFileUnbuffered(t,l,o):(0,p.hasFileReadStreamCapability)(t)?D=this.readFileStreamed(t,l,n.token,o):D=this.readFileBuffered(t,l,n.token,o),D.on("end",()=>n.dispose()),D.on("error",()=>n.dispose()),{...await b,value:D}}catch(R){throw D&&await(0,y.consumeStream)(D),this.restoreReadError(R,l,o)}}restoreReadError(t,l,s){const i=(0,v.localize)(11,null,this.resourceForError(l),(0,p.ensureFileSystemProviderError)(t).toString());return t instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(i,t.stat,s):t instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new p.FileOperationError(i,(0,p.toFileOperationResult)(t),s)}readFileStreamed(t,l,s,i=Object.create(null)){const n=t.readFileStream(l,i,s);return(0,y.transform)(n,{data:o=>o instanceof r.VSBuffer?o:r.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,l,i)},o=>r.VSBuffer.concat(o))}readFileBuffered(t,l,s,i=Object.create(null)){const n=(0,r.newWriteableBufferStream)();return(0,m.readFileIntoStream)(t,l,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,l,i)},s),n}readFileUnbuffered(t,l,s){const i=(0,y.newWriteableStream)(n=>r.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,p.hasFileAtomicReadCapability)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(l,n.byteLength,s),i.end(r.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(t,l){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new p.FileOperationError((0,v.localize)(12,null,this.resourceForError(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==p.ETAG_DISABLED&&l.etag===s.etag)throw new p.NotModifiedSinceFileOperationError((0,v.localize)(13,null),s,l);return this.validateReadFileLimits(t,s.size,l),s}validateReadFileLimits(t,l,s){if(typeof s?.limits?.size=="number"&&l>s.limits.size)throw new p.TooLargeFileOperationError((0,v.localize)(14,null,this.resourceForError(t)),7,l,s)}async canMove(t,l,s){return this.doCanMoveCopy(t,l,"move",s)}async canCopy(t,l,s){return this.doCanMoveCopy(t,l,"copy",s)}async doCanMoveCopy(t,l,s,i){if(t.toString()!==l.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,t,o,l,s,i)}catch(n){return n}return!0}async move(t,l,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(i,t,n,l,"move",!!s),b=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,o==="move"?2:3,b)),b}async copy(t,l,s){const i=await this.withReadProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(i,t,n,l,"copy",!!s),b=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,o==="copy"?3:2,b)),b}async doMoveCopy(t,l,s,i,n,o){if(l.toString()===i.toString())return n;const{exists:b,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,l,s,i,n,o);if(b&&!D&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),n==="copy"){if(t===s&&(0,p.hasFileFolderCopyCapability)(t))await t.copy(l,i,{overwrite:o});else{const R=await this.resolve(l);R.isDirectory?await this.doCopyFolder(t,R,s,i):await this.doCopyFile(t,l,s,i)}return n}else return t===s?(await t.rename(l,i,{overwrite:o}),n):(await this.doMoveCopy(t,l,s,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(t,l,s,i){if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(t,l,s,i);if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(t,l,s,i);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(t,l,s,i);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasReadWriteCapability)(s))return this.doPipeUnbuffered(t,l,s,i)}async doCopyFolder(t,l,s,i){await s.mkdir(i),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async n=>{const o=this.getExtUri(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(t,await this.resolve(n.resource),s,o):this.doCopyFile(t,n.resource,s,o)}))}async doValidateMoveCopy(t,l,s,i,n,o){let b=!1;if(t===s){const{providerExtUri:R,isPathCaseSensitive:P}=this.getExtUri(t);if(P||(b=R.isEqual(l,i)),b&&n==="copy")throw new Error((0,v.localize)(15,null,this.resourceForError(l),this.resourceForError(i)));if(!b&&R.isEqualOrParent(i,l))throw new Error((0,v.localize)(16,null,this.resourceForError(l),this.resourceForError(i)))}const D=await this.exists(i);if(D&&!b){if(!o)throw new p.FileOperationError((0,v.localize)(17,null,this.resourceForError(l),this.resourceForError(i)),4);if(t===s){const{providerExtUri:R}=this.getExtUri(t);if(R.isEqualOrParent(l,i))throw new Error((0,v.localize)(18,null,this.resourceForError(l),this.resourceForError(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:b}}getExtUri(t){const l=this.isPathCaseSensitive(t);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(l,t);const s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,s)),s}async mkdirp(t,l){const s=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&p.FileType.Directory))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));break}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(l)),l=i.dirname(l)}for(let n=s.length-1;n>=0;n--){l=i.joinPath(l,s[n]);try{await t.mkdir(l)}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.doValidateDelete(t,l)}catch(s){return s}return!0}async doValidateDelete(t,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!l?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,v.localize)(20,null,this.resourceForError(t)));const n=l?.atomic;if(n&&!(s.capabilities&65536))throw new Error((0,v.localize)(21,null,this.resourceForError(t)));if(i&&n)throw new Error((0,v.localize)(22,null,this.resourceForError(t)));let o;try{o=await s.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new p.FileOperationError((0,v.localize)(23,null,this.resourceForError(t)),1);if(!!!l?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,v.localize)(24,null,this.resourceForError(t)))}return s}async del(t,l){const s=await this.doValidateDelete(t,l);let i=l;if((0,p.hasFileAtomicDeleteCapability)(s)&&!i?.atomic){const D=s.enforceAtomicDelete?.(t);D&&(i={...l,atomic:D})}const n=!!i?.useTrash,o=!!i?.recursive,b=i?.atomic??!1;await s.delete(t,{recursive:o,useTrash:n,atomic:b}),this._onDidRunOperation.fire(new p.FileOperationEvent(t,1))}async cloneFile(t,l){const s=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(t,l))return;if(s===i&&(0,p.hasFileCloneCapability)(s))return s.cloneFile(t,l);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(l));const n=this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri);return s===i&&(0,p.hasFileFolderCopyCapability)(s)?n.queue(()=>s.copy(t,l,{overwrite:!0})):n.queue(()=>this.doCopyFile(s,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const s=new a.DisposableStore;let i=!1,n=()=>{i=!0};return s.add((0,a.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(t,l);i?(0,a.dispose)(o):n=()=>(0,a.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(t,l){const s=await this.withProvider(t),i=(0,C.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(t),l]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:s.watch(t,l)},this.activeWatchers.set(i,n)),n.count+=1,(0,a.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,a.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,a.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,l,s,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,n,i):await this.doWriteReadableBufferedQueued(t,n,i)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await t.close(n)}})}async doWriteStreamBufferedQueued(t,l,s){let i=0,n;if((0,y.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=r.VSBuffer.concat(s.buffer);await this.doWriteBuffer(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((o,b)=>{(0,y.listenStream)(n,{onData:async D=>{n.pause();try{await this.doWriteBuffer(t,l,D,D.byteLength,i,0)}catch(R){return b(R)}i+=D.byteLength,setTimeout(()=>n.resume())},onError:D=>b(D),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(t,l,s){let i=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(t,l,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(t,l,s,i,n,o){let b=0;for(;b<i;){const D=await t.write(l,n+b,s.buffer,o+b,i-b);b+=D}}async doWriteUnbuffered(t,l,s,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,l,s,i))}async doWriteUnbufferedQueued(t,l,s,i){let n;i instanceof r.VSBuffer?n=i:(0,y.isReadableStream)(i)?n=await(0,r.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?n=await(0,r.bufferedStreamToBuffer)(i):n=(0,r.readableToBuffer)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,l,s,i))}async doPipeBufferedQueued(t,l,s,i){let n,o;try{n=await t.open(l,{create:!1}),o=await s.open(i,{create:!0,unlock:!1});const b=r.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,R=0,P=0;do P=await t.read(n,D,b.buffer,R,b.byteLength-R),await this.doWriteBuffer(s,o,b,P,D,R),D+=P,R+=P,R===b.byteLength&&(R=0);while(P>0)}catch(b){throw(0,p.ensureFileSystemProviderError)(b)}finally{await L.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,l,s,i))}async doPipeUnbufferedQueued(t,l,s,i){return s.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,l,s,i))}async doPipeUnbufferedToBufferedQueued(t,l,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.doWriteBuffer(s,n,r.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(t,l,s,i){const n=await(0,r.streamToBuffer)(this.readFileBuffered(t,l,_.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,n)}throwIfFileSystemIsReadonly(t,l){if(t.capabilities&2048)throw new p.FileOperationError((0,v.localize)(25,null,this.resourceForError(l)),6);return t}throwIfFileIsReadonly(t,l){if((l.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,v.localize)(26,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=E,e.FileService=E=Ee([Z(0,d.ILogService)],E)}),define(ee[92],te([0,1,45,309,8,31,18,3,33,2,9,4,19,62,21,177,16,118,219,49,215,214]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(l)}`)}})();class t extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new _.ResourceMap(n=>S.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await y.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let b;o.isSymbolicLink()?b=(await this.stat((0,S.joinPath)(s,o.name))).type:b=this.toType(o),n.push([o.name,b])}catch(b){this.logService.trace(b)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let n;return i?.dangling?n=p.FileType.Unknown:s.isFile()?n=p.FileType.File:s.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,i&&(n|=p.FileType.SymbolicLink),n}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new r.Barrier;return this.resourceLocks.set(s,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const o=this.toFilePath(s);return await y.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{n?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,n){const o=(0,f.newWriteableStream)(b=>M.VSBuffer.concat(b.map(D=>M.VSBuffer.wrap(D))).buffer);return(0,m.readFileIntoStream)(this,s,o,b=>b.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,S.joinPath)((0,S.dirname)(s),`${(0,S.basename)(s)}${n.atomic.postfix}`),i,n):this.doWriteFile(s,i,n)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,i,n,o){const b=new a.DisposableStore;try{b.add(await this.createResourceLock(s)),b.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,o,!0);try{await this.rename(i,s,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{b.dispose()}}async doWriteFile(s,i,n,o){let b;try{const D=this.toFilePath(s);if(!n.create||!n.overwrite){if(await y.Promises.exists(D)){if(!n.overwrite)throw(0,p.createFileSystemProviderError)((0,v.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.createFileSystemProviderError)((0,v.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(s,{create:!0,unlock:n.unlock},o),await this.write(b,0,i,0,i.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof b=="number"&&await this.close(b)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,n){const o=this.toFilePath(s);let b;(0,p.isFileOpenForWriteOptions)(i)&&!n&&(b=await this.createResourceLock(s));let D;try{if((0,p.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await y.SymlinkSupport.stat(o);P.mode&128||await y.Promises.chmod(o,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let R;if((0,p.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await y.Promises.truncate(o,0),R="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}R||(R="w")}else R="r";D=await y.Promises.open(o,R)}catch(R){throw b?.dispose(),(0,p.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,R):this.toFileSystemProviderError(R)}if(this.mapHandleToPos.set(D,0),(0,p.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(D,s),b){const R=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${o})`),this.mapHandleToLock.set(D,b),R&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${o})`),R.dispose())}return D}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await y.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await y.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,o,b){const D=this.normalizePos(s,i);let R=null;try{R=(await y.Promises.read(s,n,o,b,D)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(s,D,R)}return R}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,n){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,o+n):this.mapHandleToPos.delete(s)))}async write(s,i,n,o,b){return(0,r.retry)(()=>this.doWrite(s,i,n,o,b),100,3)}async doWrite(s,i,n,o,b){const D=this.normalizePos(s,i);let R=null;try{R=(await y.Promises.write(s,n,o,b,D)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),P)}finally{this.updatePos(s,D,R)}return R}async mkdir(s){try{await y.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const n=this.toFilePath(s);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,g.join)((0,g.dirname)(n),`${(0,g.basename)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let b=!1;try{const{stat:D,symbolicLink:R}=await y.SymlinkSupport.stat(n);b=D.isDirectory()&&!R}catch{}if(b)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i);if(o!==b)try{await this.validateMoveCopy(s,i,"move",n.overwrite),await y.Promises.rename(o,b)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(2,null,(0,g.basename)(o),(0,g.basename)((0,g.dirname)(b)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i);if(o!==b)try{await this.validateMoveCopy(s,i,"copy",n.overwrite),await y.Promises.copy(o,b,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(3,null,(0,g.basename)(o),(0,g.basename)((0,g.dirname)(b)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(s,i,n,o){const b=this.toFilePath(s),D=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,h.isEqual)(b,D,!0)),R){if(n==="copy")throw(0,p.createFileSystemProviderError)((0,v.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const k=await this.statIgnoreError(s);if(!k)throw(0,p.createFileSystemProviderError)((0,v.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(i);if(O){if(!o)throw(0,p.createFileSystemProviderError)((0,v.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);k.type&p.FileType.File&&O.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,h.isEqual)(o,b,!D))return;const R=new a.DisposableStore;try{R.add(await this.createResourceLock(s)),R.add(await this.createResourceLock(i)),n&&await y.Promises.mkdir((0,g.dirname)(b),{recursive:!0}),await y.Promises.copyFile(o,b)}catch(P){if(P.code==="ENOENT"&&!n)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(P)}finally{R.dispose()}}createUniversalWatcher(s,i,n){return new E.UniversalWatcherClient(o=>s(o),o=>i(o),n)}createNonRecursiveWatcher(s,i,n){return new u.NodeJSWatcherClient(o=>s(o),o=>i(o),n)}toFileSystemProviderError(s){if(s instanceof p.FileSystemProviderError)return s;let i=s,n;switch(s.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(s,i){let n=this.toFileSystemProviderError(i);if(s&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(n=(0,p.createFileSystemProviderError)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=t}),define(ee[221],te([0,1,3,92,2,18,62,22]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends r.Disposable{constructor(w,S){super(),this.provider=w,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(w,S,f){const y=this.getUriTransformer(w);switch(S){case"stat":return this.stat(y,f[0]);case"readdir":return this.readdir(y,f[0]);case"open":return this.open(y,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(y,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(y,f[0],f[1],f[2]);case"rename":return this.rename(y,f[0],f[1],f[2]);case"copy":return this.copy(y,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(y,f[0],f[1]);case"mkdir":return this.mkdir(y,f[0]);case"delete":return this.delete(y,f[0],f[1]);case"watch":return this.watch(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(w,S,f){const y=this.getUriTransformer(w);switch(S){case"fileChange":return this.onFileChange(y,f[0]);case"readFileStream":return this.onReadFileStream(y,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(w,S){const f=this.transformIncoming(w,S,!0);return this.provider.stat(f)}readdir(w,S){const f=this.transformIncoming(w,S);return this.provider.readdir(f)}async readFile(w,S,f){const y=this.transformIncoming(w,S,!0),v=await this.provider.readFile(y,f);return _.VSBuffer.wrap(v)}onReadFileStream(w,S,f){const y=this.transformIncoming(w,S,!0),v=new C.CancellationTokenSource,p=new I.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),m=this.provider.readFileStream(y,f,v.token);return(0,M.listenStream)(m,{onData:d=>p.fire(_.VSBuffer.wrap(d)),onError:d=>p.fire(d),onEnd:()=>{p.fire("end"),p.dispose(),v.dispose()}}),p.event}writeFile(w,S,f,y){const v=this.transformIncoming(w,S);return this.provider.writeFile(v,f.buffer,y)}open(w,S,f){const y=this.transformIncoming(w,S,!0);return this.provider.open(y,f)}close(w){return this.provider.close(w)}async read(w,S,f){const y=_.VSBuffer.alloc(f),v=0,p=await this.provider.read(w,S,y.buffer,v,f);return[y,p]}write(w,S,f,y,v){return this.provider.write(w,S,f.buffer,y,v)}mkdir(w,S){const f=this.transformIncoming(w,S);return this.provider.mkdir(f)}delete(w,S,f){const y=this.transformIncoming(w,S);return this.provider.delete(y,f)}rename(w,S,f,y){const v=this.transformIncoming(w,S),p=this.transformIncoming(w,f);return this.provider.rename(v,p,y)}copy(w,S,f,y){const v=this.transformIncoming(w,S),p=this.transformIncoming(w,f);return this.provider.copy(v,p,y)}cloneFile(w,S,f){const y=this.transformIncoming(w,S),v=this.transformIncoming(w,f);return this.provider.cloneFile(y,v)}onFileChange(w,S){const f=new I.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(w,f))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(w,S,f,y,v){const p=this.sessionToWatcher.get(S);if(p){const m=this.transformIncoming(w,y),d=p.watch(f,m,v);this.watchRequests.set(S+f,d)}}async unwatch(w,S){const f=w+S,y=this.watchRequests.get(f);y&&((0,r.dispose)(y),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,w]of this.watchRequests)w.dispose();this.watchRequests.clear();for(const[,w]of this.sessionToWatcher)w.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class a extends r.Disposable{constructor(w,S,f,y){super(),this.uriTransformer=w,this.logService=f,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(w){const S=this._register(new I.Emitter);this._register(S.event(f=>{w.fire(f.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>w.fire(f)))}getRecursiveWatcherOptions(w){}getExtraExcludes(w){}watch(w,S,f){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.watcherRequests.set(w,this.fileWatcher.watch(S,f)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(w)),this.watcherRequests.delete(w)})}dispose(){for(const[,w]of this.watcherRequests)w.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=a}),define(ee[222],te([0,1,15,176,4,7,16,9,221,153]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class g extends h.AbstractDiskFileSystemProviderChannel{constructor(f,y,v){super(f,y),this.environmentService=v}getUriTransformer(f){return a.DefaultURITransformer}transformIncoming(f,y){return _.URI.revive(y)}async delete(f,y,v){if(!v.useTrash)return super.delete(f,y,v);const p=this.transformIncoming(f,y),m=(0,C.normalize)(p.fsPath);try{await I.shell.trashItem(m)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,C.basename)(m)):(0,L.localize)(1,null,(0,C.basename)(m)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,y){return new w(f,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=g;class w extends h.AbstractSessionFileWatcher{watch(f,y,v){if(v.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,v)}}}),define(ee[223],te([0,1,5]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends I.AbstractMessageLogger{constructor(_=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(_),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(_){this._logger=_;for(const{level:M,message:C}of this.buffer)(0,I.log)(_,M,C);this.buffer=[]}log(_,M){this._logger?(0,I.log)(this._logger,_,M):this.getLevel()<=_&&this.buffer.push({level:_,message:M})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(ee[224],te([0,1,7,3,5,2]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends r.AbstractLoggerService{constructor(w,S,f,y,v){super(S,f,y),this.windowId=w,this.channel=v,this._register(v.listen("onDidChangeLogLevel",w)(p=>{(0,r.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(I.URI.revive(p[0]),p[1])})),this._register(v.listen("onDidChangeVisibility",w)(([p,m])=>super.setVisibility(I.URI.revive(p),m))),this._register(v.listen("onDidChangeLoggers",w)(({added:p,removed:m})=>{for(const d of p)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of m)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(w,S)=>{this.channel.call("consoleLog",[w,S])}})}registerLogger(w){super.registerLogger(w),this.channel.call("registerLogger",[w,this.windowId])}deregisterLogger(w){super.deregisterLogger(w),this.channel.call("deregisterLogger",[w,this.windowId])}setLogLevel(w,S){super.setLogLevel(w,S),this.channel.call("setLogLevel",[w,S])}setVisibility(w,S){super.setVisibility(w,S),this.channel.call("setVisibility",[this.toResource(w),S])}doCreateLogger(w,S,f){return new C(this.channel,w,S,f,this.windowId)}static setLogLevel(w,S,f){return w.call("setLogLevel",[S,f])}}e.LoggerChannelClient=M;class C extends r.AbstractMessageLogger{constructor(w,S,f,y,v){super(y?.logLevel==="always"),this.channel=w,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[S,y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,S){const f=[[w,S]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(w){this.channel.call("log",[this.file,w])}}class h{constructor(w,S){this.loggerService=w,this.getUriTransformer=S}listen(w,S){const f=this.getUriTransformer(w);switch(S){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(v=>this.transformLogger(v,f)),removed:[...y.removed].map(v=>this.transformLogger(v,f))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,r.isLogLevel)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${S}`)}async call(w,S,f){const y=this.getUriTransformer(w);switch(S){case"setLogLevel":return(0,r.isLogLevel)(f[0])?this.loggerService.setLogLevel(f[0]):this.loggerService.setLogLevel(I.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(v=>this.transformLogger(v,y)))}throw new Error(`Call not found: ${S}`)}transformLogger(w,S){return{...w,resource:S.transformOutgoingURI(w.resource)}}}e.LoggerChannel=h;class a extends _.Disposable{constructor(w,S){super(),S.call("setLogLevel",[w.getLogLevel()]),this._register(w.onDidChangeLogLevel(f=>S.call("setLogLevel",[f]))),S.call("getRegisteredLoggers").then(f=>{for(const y of f)w.registerLogger({...y,resource:I.URI.revive(y.resource)})}),this._register(S.listen("onDidChangeVisibility")(([f,y])=>w.setVisibility(I.URI.revive(f),y))),this._register(S.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const v of f)w.registerLogger({...v,resource:I.URI.revive(v.resource)});for(const v of y)w.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=a}),define(ee[225],te([0,1,2,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends I.Disposable{constructor(M,C=[]){super(),this.logger=new L.MultiplexLogger([M,...C]),this._register(M.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...C){this.logger.trace(M,...C)}debug(M,...C){this.logger.debug(M,...C)}info(M,...C){this.logger.info(M,...C)}warn(M,...C){this.logger.warn(M,...C)}error(M,...C){this.logger.error(M,...C)}flush(){this.logger.flush()}}e.LogService=r}),define(ee[226],te([0,1,31,7,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class _{constructor(C){this.loggerService=C,this.loggers=new I.ResourceMap}listen(C,h,a){switch(h){case"onDidChangeLoggers":return a?this.loggerService.getOnDidChangeLoggersEvent(a):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.loggerService.getOnDidChangeLogLevelEvent(a):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.loggerService.getOnDidChangeVisibilityEvent(a):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(C,h,a){switch(h){case"createLogger":this.createLogger(L.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.log(L.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1]);case"setLogLevel":return(0,r.isLogLevel)(a[0])?this.loggerService.setLogLevel(a[0]):this.loggerService.setLogLevel(L.URI.revive(a[0]),a[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(a[0]),a[1]);case"registerLogger":return this.loggerService.registerLogger({...a[0],resource:L.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(a[0]))}throw new Error(`Call not found: ${h}`)}createLogger(C,h,a){this.loggers.set(C,this.loggerService.createLogger(C,h,a))}consoleLog(C,h){let a=console.log;switch(C){case r.LogLevel.Error:a=console.error;break;case r.LogLevel.Warning:a=console.warn;break;case r.LogLevel.Info:a=console.info;break}a.call(console,...h)}log(C,h){const a=this.loggers.get(C);if(!a)throw new Error("Create the logger before logging");for(const[g,w]of h)(0,r.log)(a,g,w)}}e.LoggerChannel=_}),define(ee[227],te([0,1,16,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(r||(r={}));async function _(a,g,w,S,f){try{const y=await new Promise((p,m)=>{K(["@vscode/spdlog"],p,m)});y.setFlushOn(r.Trace);const v=await y.createAsyncRotatingLogger(a,g,w,S);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(y){console.error(y)}return null}function M(a,g,w){switch(g){case L.LogLevel.Trace:a.trace(w);break;case L.LogLevel.Debug:a.debug(w);break;case L.LogLevel.Info:a.info(w);break;case L.LogLevel.Warning:a.warn(w);break;case L.LogLevel.Error:a.error(w);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function C(a,g){switch(g){case L.LogLevel.Trace:a.setLevel(r.Trace);break;case L.LogLevel.Debug:a.setLevel(r.Debug);break;case L.LogLevel.Info:a.setLevel(r.Info);break;case L.LogLevel.Warning:a.setLevel(r.Warning);break;case L.LogLevel.Error:a.setLevel(r.Error);break;case L.LogLevel.Off:a.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class h extends L.AbstractMessageLogger{constructor(g,w,S,f,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(g,w,S,f),this._register(this.onDidChangeLogLevel(v=>{this._logger&&C(this._logger,v)}))}async _createSpdLogLogger(g,w,S,f){const y=S?6:1,v=30/y*I.ByteSize.MB,p=await _(g,w,v,y,f);if(p){this._logger=p,C(this._logger,this.getLevel());for(const{level:m,message:d}of this.buffer)M(this._logger,m,d);this.buffer=[]}}log(g,w){this._logger?M(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(ee[228],te([0,1,32,5,227]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class _ extends L.AbstractLoggerService{doCreateLogger(C,h,a){return new r.SpdLogLogger((0,I.generateUuid)(),C.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,h)}}e.LoggerService=_}),define(ee[66],te([0,1,31,3,6,5,228]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(_.ILoggerService);class C extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new I.ResourceMap}createLogger(a,g,w){w!==void 0&&this.loggerResourcesByWindow.set(this.toResource(a),w);try{return super.createLogger(a,g)}catch(S){throw this.loggerResourcesByWindow.delete(this.toResource(a)),S}}registerLogger(a,g){g!==void 0&&this.loggerResourcesByWindow.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.loggerResourcesByWindow.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const w of super.getRegisteredLoggers())a===this.loggerResourcesByWindow.get(w.resource)&&g.push(w);return g}getOnDidChangeLogLevelEvent(a){return L.Event.filter(this.onDidChangeLogLevel,g=>(0,_.isLogLevel)(g)||this.isInterestedLoggerResource(g[0],a))}getOnDidChangeVisibilityEvent(a){return L.Event.filter(this.onDidChangeVisibility,([g])=>this.isInterestedLoggerResource(g,a))}getOnDidChangeLoggersEvent(a){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(S=>this.isInterestedLoggerResource(S.resource,a)),removed:[...g.removed].filter(S=>this.isInterestedLoggerResource(S.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,w]of this.loggerResourcesByWindow)w===a&&this.deregisterLogger(g)}isInterestedLoggerResource(a,g){const w=this.loggerResourcesByWindow.get(a);return w===void 0||w===g}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=C}),define(ee[229],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function _(M){return!I(M)&&!L(M)&&!r(M)}e.isMenubarMenuItemAction=_}),define(ee[39],te([0,1,3,69,2,6]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,_.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const g=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},g!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),L.Iterable.reduce(this.policies.entries(),(w,[S,f])=>({...w,[S]:f}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[g,w])=>({...a,[g]:{definition:w,value:this.policies.get(g)}}),{})}}e.AbstractPolicyService=M;class C{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(ee[230],te([0,1,8,3,69,12,16,5,39]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(w,S){const f=[];for(const y of new Set(r.Iterable.concat(w.keys(),S.keys())))w.get(y)!==S.get(y)&&f.push(y);return f}let g=class extends h.AbstractPolicyService{constructor(S,f,y){super(),this.file=S,this.fileService=f,this.logService=y,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const v=L.Event.filter(f.onDidFilesChange,p=>p.affects(S));this._register(f.watch(S)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),y=JSON.parse(f.value.toString());if(!(0,_.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(y))this.policyDefinitions[v]&&S.set(v,y[v])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=a(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};e.FilePolicyService=g,e.FilePolicyService=g=Ee([Z(1,M.IFileService),Z(2,C.ILogService)],g)}),define(ee[231],te([0,1,3,2,39]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class _{constructor(h){this.service=h,this.disposables=new L.DisposableStore}listen(h,a){switch(a){case"onDidChange":return I.Event.map(this.service.onDidChange,g=>g.reduce((w,S)=>({...w,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${a}`)}call(h,a,g){switch(a){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=_;class M extends r.AbstractPolicyService{constructor(h,a){super(),this.channel=a;for(const g in h){const{definition:w,value:S}=h[g];this.policyDefinitions[g]=w,S!==void 0&&this.policies.set(g,S)}this.channel.listen("onDidChange")(g=>{for(const w in g){const S=g[w];S===null?this.policies.delete(w):this.policies.set(w,S)}this._onDidChange.fire(Object.keys(g))})}async _updatePolicyDefinitions(h){const a=await this.channel.call("updatePolicyDefinitions",h);for(const g in a)this.policies.set(g,a[g])}}e.PolicyChannelClient=M}),define(ee[232],te([0,1,39,8,310,2,5]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let C=class extends I.AbstractPolicyService{constructor(a,g){super(),this.logService=a,this.productName=g,this.throttler=new L.Throttler,this.watcher=this._register(new _.MutableDisposable)}async _updatePolicyDefinitions(a){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.throttler.queue(()=>new Promise((g,w)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,a,S=>{this._onDidPolicyChange(S),g()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),w(S)}}))}_onDidPolicyChange(a){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const w=a[g];w===void 0?this.policies.delete(g):this.policies.set(g,w)}this._onDidChange.fire(Object.keys(a))}};e.NativePolicyService=C,e.NativePolicyService=C=Ee([Z(0,M.ILogService)],C)}),define(ee[77],te([0,1,4,35]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const _=I.globals.vscode.context.configuration();if(_)r=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){r=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:_,searchUrl:M,itemUrl:C,controlUrl:h}=r.extensionsGallery||{};Object.assign(r,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||_,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||C,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const a=(...w)=>w.reduce((S,f)=>(Object.keys(f).forEach(y=>{Array.isArray(S[y])&&Array.isArray(f[y])?S[y]=f[y]:typeof S[y]=="object"&&typeof f[y]=="object"?S[y]=a(S[y],f[y]):S[y]=f[y]}),S),{}),g=globalThis._VSCODE_USER_PRODUCT_JSON||{};r=a(r,g)}catch{}if(L.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const a=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:a.version,release:a.release})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ee[24],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,8,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(M,C,h){this._window=M,this._sessionId=C,this._logService=h}async inspect(M){await this._connect();const C=this._window.webContents.debugger;await C.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(M);const h=await C.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=Ee([Z(2,L.ILogService)],r)}),define(ee[78],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[43],te([0,1,135,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(M,C){I.ok(L.isString(M)),I.ok(L.isObject(C)),I.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,C)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new r}),define(ee[234],te([0,1,3,43]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class _{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,a){this.schemasById[r(h)]=a,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new _;L.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[57],te([0,1,23,3,12,161,17,234,43]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=h.Registry.as(C.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const s=new Set;this.doRegisterConfigurations(t,l,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const l=new Set;this.doDeregisterConfigurations(t,l),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:t,remove:l}){const s=new Set;this.doDeregisterConfigurations(l,s),this.doRegisterConfigurations(t,!1,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const l=new Set;this.doRegisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,l){const s=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const b=this.configurationDefaultsOverrides.get(o),D=b?.valuesSources??new Map;if(n)for(const O of Object.keys(i[o]))D.set(O,n);const R={...b?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:R,valuesSources:D});const P=(0,M.getLanguageTagSettingPlainKey)(o),k={type:"object",default:R,description:_.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...v(o)),this.configurationProperties[o]=k,this.defaultLanguageConfigurationOverridesNode.properties[o]=k}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:n});const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const l=new Set;this.doDeregisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,l){for(const{overrides:s,source:i}of t)for(const n in s){const o=this.configurationDefaultsOverrides.get(n),b=r.isString(i)?i:i?.id,D=r.isString(o?.source)?o?.source:o?.source?.id;if(b===D)if(l.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const R=this.configurationProperties[n];R&&(this.updatePropertyDefaultValue(n,R),this.updateSchema(n,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let l=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),l=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),l=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const l of t)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,l,s){t.forEach(i=>{this.validateAndRegisterProperties(i,l,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,l){const s=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,l=!0,s,i,n=3,o){n=r.isUndefinedOrNull(t.scope)?n:t.scope;const b=t.properties;if(b)for(const R in b){const P=b[R];if(l&&c(R,P)){delete b[R];continue}if(P.source=s,P.defaultDefaultValue=b[R].default,this.updatePropertyDefaultValue(R,P),e.OVERRIDE_PROPERTY_REGEX.test(R)?P.scope=void 0:(P.scope=r.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=r.isUndefinedOrNull(P.restricted)?!!i?.includes(R):P.restricted),b[R].hasOwnProperty("included")&&!b[R].included){this.excludedConfigurationProperties[R]=b[R],delete b[R];continue}else this.configurationProperties[R]=b[R],b[R].policy?.name&&this.policyConfigurations.set(b[R].policy.name,R);!b[R].deprecationMessage&&b[R].markdownDeprecationMessage&&(b[R].deprecationMessage=b[R].markdownDeprecationMessage),o.add(R)}const D=t.allOf;if(D)for(const R of D)this.validateAndRegisterProperties(R,l,s,i,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const l=s=>{const i=s.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);s.allOf?.forEach(l)};l(t)}updateSchema(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.resourceLanguageSettingsSchema.properties[t]=l;break}}removeFromSchema(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const l=`[${t}]`,s={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,l){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,n=s?.source;r.isUndefined(i)&&(i=l.defaultDefaultValue,n=void 0),r.isUndefined(i)&&(i=m(l.type)),l.default=i,l.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let l=y.exec(u);for(;l?.length;){const s=l[1].trim();s&&t.push(s),l=y.exec(u)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=v;function p(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=p;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const d=new S;h.Registry.add(e.Extensions.Configuration,d);function c(u,t){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?_.localize(7,null,u):d.getConfigurationProperties()[u]!==void 0?_.localize(8,null,u):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?_.localize(9,null,u,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:_.localize(6,null)}e.validateProperty=c;function E(){const u=[],t=d.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=E}),define(ee[119],te([0,1,23,3,44,2,31,37,12,7,17,57,43]),function(K,e,I,L,r,_,M,C,h,a,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(l){return Object.isFrozen(l)?l:C.deepFreeze(l)}class y{constructor(s={},i=[],n=[],o){this._contents=s,this._keys=i,this._overrides=n,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof y)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=s.reduce((i,n)=>n===i?n:i.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,g.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const n=this.rawConfiguration.getValue(s),o=i?this.rawConfiguration.getOverrideValue(s,i):void 0,b=i?this.rawConfiguration.override(i).getValue(s):n;return{value:n,override:o,merged:b}}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,g.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),o=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of s)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const R of D.overrides){const[P]=n.filter(k=>I.equals(k.identifiers,R.identifiers));P?(this.mergeContents(P.contents,R.contents),P.keys.push(...R.keys),P.keys=I.distinct(P.keys)):n.push(C.deepClone(R))}for(const R of D.keys)o.indexOf(R)===-1&&o.push(R)}return new y(i,o,n,b.every(D=>D instanceof y)?void 0:b)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[o];const D=i[o];D&&(typeof b=="object"&&typeof D=="object"?(b=C.deepClone(b),this.mergeContents(b,D)):b=D),n[o]=b}return new y(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&h.isObject(s[n])&&h.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=C.deepClone(i[n])}}getContentsForOverrideIdentifer(s){let i=null,n=null;const o=b=>{b&&(n?this.mergeContents(n,b):n=C.deepClone(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?i=b.contents:b.identifiers.includes(s)&&o(b.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,g.removeFromValueTree)(this.contents,s),w.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>I.equals(n.identifiers,(0,w.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,n){(0,g.addToValueTree)(this.contents,s,i,o=>console.error(o)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),w.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,g.toValuesTree)(this.contents[s],o=>console.error(o))})}}e.ConfigurationModel=y;class v{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!h.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:o,overrides:b,restricted:D,hasExcludedProperties:R}=this.doParseRaw(s,i);this._configurationModel=new y(n,o,b,R?[s]:void 0),this._restrictedConfigurations=D||[]}doParseContent(s){let i={},n=null,o=[];const b=[],D=[];function R(k){Array.isArray(o)?o.push(k):n!==null&&(o[n]=k)}const P={onObjectBegin:()=>{const k={};R(k),b.push(o),o=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{o=b.pop()},onArrayBegin:()=>{const k=[];R(k),b.push(o),o=k,n=null},onArrayEnd:()=>{o=b.pop()},onLiteralValue:R,onError:(k,O,F)=>{D.push({error:k,offset:O,length:F})}};if(s)try{r.visit(s,P),i=o[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(s,i){const n=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,n,!0,i);s=o.raw;const b=(0,g.toValuesTree)(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),D=Object.keys(s),R=this.toOverrides(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:b,keys:D,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(s,i,n,o){let b=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const D={},R=[];for(const P in s)if(w.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const k=this.filter(s[P],i,!1,o);D[P]=k.raw,b=b||k.hasExcludedProperties,R.push(...k.restricted)}else{const k=i[P],O=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&R.push(P),!o.exclude?.includes(P)&&(o.include?.includes(P)||(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&!(o.skipRestricted&&k?.restricted))?D[P]=s[P]:b=!0}return{raw:D,restricted:R,hasExcludedProperties:b}}toOverrides(s,i){const n=[];for(const o of Object.keys(s))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const b={};for(const D in s[o])b[D]=s[o][D];n.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(b),contents:(0,g.toValuesTree)(b,i)})}return n}}e.ConfigurationModelParser=v;class p extends _.Disposable{constructor(s,i,n,o){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=o,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,b=>b.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(s,i,n,o,b,D,R,P,k,O,F,$,re){this.key=s,this.overrides=i,this._value=n,this.overrideIdentifiers=o,this.defaultConfiguration=b,this.policyConfiguration=D,this.applicationConfiguration=R,this.userConfiguration=P,this.localUserConfiguration=k,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=$,this.memoryConfigurationModel=re}get value(){return f(this._value)}inspect(s,i,n){const o=s.inspect(i,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,i,n,o,b=new y,D=new y,R=new M.ResourceMap,P=new y,k=new M.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=b,this._workspaceConfiguration=D,this._folderConfigurations=R,this._memoryConfiguration=P,this._memoryConfigurationByResource=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidatedConfigurationModel(s,i,n).getValue(s)}updateValue(s,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new y,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const o=this.getConsolidatedConfigurationModel(s,i,n),b=this.getFolderConfigurationModelForResource(i.resource,n),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const P of o.overrides)for(const k of P.identifiers)o.getOverrideValue(s,k)!==void 0&&R.add(k);return new m(s,i,o.getValue(s),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,b||void 0,D)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:o,updated:b,removed:D}=u(this._defaultConfiguration,s);i=[...o,...b,...D]}for(const o of i)for(const b of(0,w.overrideIdentifiersFromKey)(o)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(b),R=s.getKeysForOverrideIdentifier(b),P=[...R.filter(k=>D.indexOf(k)===-1),...D.filter(k=>R.indexOf(k)===-1),...D.filter(k=>!C.equals(this._defaultConfiguration.override(b).getValue(k),s.override(b).getValue(k)))];n.push([b,P])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,s),b=[...i,...n,...o];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.applicationConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.localUserConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.remoteUserConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.workspaceConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:o,updated:b,removed:D,overrides:R}=u(n,i),P=[...o,...b,...D];return(P.length||!n)&&this.updateFolderConfiguration(s,i),{keys:P,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:o,removed:b,overrides:D}=u(i,void 0);return{keys:[...n,...o,...b],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const b=this._memoryConfigurationByResource.get(s);b&&(n=n.merge(b))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=n.merge(o),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:o,keys:b}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:o,keys:b}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),o=this.parseConfigurationModel(s.application),b=this.parseConfigurationModel(s.user),D=this.parseConfigurationModel(s.workspace),R=s.folders.reduce((P,k)=>(P.set(a.URI.revive(k[0]),this.parseConfigurationModel(k[1])),P),new M.ResourceMap);return new d(i,n,o,b,new y,D,R,new y,new M.ResourceMap)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides)}}e.Configuration=d;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,i=new Map;for(const o of l)o.keys.forEach(b=>s.add(b)),o.overrides.forEach(([b,D])=>{const R=(0,M.getOrSet)(i,b,new Set);D.forEach(P=>R.add(P))});const n=[];return i.forEach((o,b)=>n.push([b,[...o.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=c;class E{constructor(s,i,n,o){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const b of s.keys)this.affectedKeys.add(b);for(const[,b]of s.overrides)for(const D of b)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const b of this.affectedKeys)this._affectsConfigStr+=b+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const n=this._marker+s,o=this._affectsConfigStr.indexOf(n);if(o<0)return!1;const b=o+n.length;if(b>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(b);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const R=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!C.equals(R,P)}return!0}}e.ConfigurationChangeEvent=E;function u(l,s){const{added:i,removed:n,updated:o}=t(s?.rawConfiguration,l?.rawConfiguration),b=[],D=l?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const P=R.filter(k=>!D.includes(k));for(const k of P)b.push([k,s.getKeysForOverrideIdentifier(k)])}if(l){const P=D.filter(k=>!R.includes(k));for(const k of P)b.push([k,l.getKeysForOverrideIdentifier(k)])}if(s&&l){for(const P of D)if(R.includes(P)){const k=t({contents:l.getOverrideValue(void 0,P)||{},keys:l.getKeysForOverrideIdentifier(P)},{contents:s.getOverrideValue(void 0,P)||{},keys:s.getKeysForOverrideIdentifier(P)});b.push([P,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:n,updated:o,overrides:b}}function t(l,s){const i=l?s?l.keys.filter(b=>s.keys.indexOf(b)===-1):[...l.keys]:[],n=s?l?s.keys.filter(b=>l.keys.indexOf(b)===-1):[...s.keys]:[],o=[];if(l&&s){for(const b of s.keys)if(l.keys.indexOf(b)!==-1){const D=(0,g.getConfigurationValue)(s.contents,b),R=(0,g.getConfigurationValue)(l.contents,b);C.equals(D,R)||o.push(b)}}return{added:i,removed:n,updated:o}}}),define(ee[235],te([0,1,23,3,2,37,12,119,57,5,39,43]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:m})=>this.onDidUpdateConfiguration(Array.from(p),m))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,m){this.updateConfigurationModel(p,w.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new C.ConfigurationModel;const p=w.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,m){const d=this.getConfigurationDefaultOverrides();for(const c of p){const E=d[c],u=m[c];E!==void 0?this._configurationModel.addValue(c,E):u?this._configurationModel.addValue(c,u.default):this._configurationModel.removeValue(c)}}}e.DefaultConfiguration=S;class f{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new C.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let y=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(p,m,d){super(),this.defaultConfiguration=p,this.policyService=m,this.logService=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const m={},d=[],c=w.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const E of p){const u=c[E];if(!u){d.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.logService.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}d.push(E),m[u.policy.name]={type:u.type}}}return(0,M.isEmptyObject)(m)||await this.policyService.updatePolicyDefinitions(m),d}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const m=w.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),d=(0,I.coalesce)(p.map(c=>m.get(c)));this.update(d,!0)}update(p,m){this.logService.trace("PolicyConfiguration#update",p);const d=w.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=[],E=this._configurationModel.isEmpty();for(const u of p){const t=d[u]?.policy?.name;if(t){const l=this.policyService.getPolicyValue(t);(E?l!==void 0:!(0,_.equals)(this._configurationModel.getValue(u),l))&&c.push([u,l])}else this._configurationModel.getValue(u)!==void 0&&c.push([u,void 0])}if(c.length){this.logService.trace("PolicyConfiguration#changed",c);const u=this._configurationModel;this._configurationModel=new C.ConfigurationModel;for(const t of u.keys)this._configurationModel.setValue(t,u.getValue(t));for(const[t,l]of c)l===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,l);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y,e.PolicyConfiguration=y=Ee([Z(1,g.IPolicyService),Z(2,a.ILogService)],y)}),define(ee[236],te([0,1,8,3,2,19,17,119,235,39]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class g extends r.Disposable{constructor(S,f,y,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=y instanceof a.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,y,v)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,{},_.extUriBiasedIgnorePathCase,f)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:m})=>this.onDidDefaultConfigurationChange(p,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(S,f,new C.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const y=typeof S=="string"?S:void 0,v=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(y,v,void 0)}updateValue(S,f,y,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,f,2)}onDidDefaultConfigurationChange(S,f){const y=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(v,y,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,f,7)}trigger(S,f,y){const v=new C.ConfigurationChangeEvent(S,{data:f},this.configuration);v.source=y,v.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=g}),define(ee[237],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class I{async routeCall(r,_,M){if(_!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${_}`);const C=M[0];if(C?.authority){const h=r.connections.find(a=>a.ctx===C.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(r,_){throw new Error(`Event not found: ${_}`)}}e.NodeRemoteResourceRouter=I}),define(ee[238],te([0,1,14,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class _{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=_;class M{constructor(w,S){this.host=w,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var C;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class h extends I.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof h&&w._code===C.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof h&&w._code===C.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof h&&w._code===C.NoResolverFound}static isInvalidAuthority(w){return w instanceof h&&w._code===C.InvalidAuthority}static isHandled(w){return w instanceof h&&w.isHandled}constructor(w,S=C.Unknown,f){super(w),this._message=w,this._code=S,this._detail=f,this.isHandled=S===C.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function a(g){const w=g.indexOf("+");return w===-1?g:g.substring(0,w)}e.getRemoteAuthorityPrefix=a}),define(ee[58],te([0,1,13]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(a){return a.scheme===I.Schemas.vscodeRemote?a.authority:void 0}e.getRemoteAuthority=L;function r(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.getRemoteName=r;function _(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.getRemoteServerRootPath=_;function M(a){const{host:g,port:w}=h(a);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:w}}e.parseAuthorityWithPort=M;function C(a,g){let{host:w,port:S}=h(a);return typeof S>"u"&&(S=g),{host:w,port:S}}e.parseAuthorityWithOptionalPort=C;function h(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const S=a.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:a,port:void 0}}}),define(ee[120],te([0,1,27,6,58]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(M||(e.ExtensionType=M={}));var C;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p>"u"||p===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){const d=typeof p=="string"?p:p.value,c=typeof m=="string"?m:m.value;return I.equalsIgnoreCase(d,c)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=h;class a{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const m of p)this.add(m)}add(p){this._set.add(h.toKey(p))}delete(p){return this._set.delete(h.toKey(p))}has(p){return this._set.has(h.toKey(p))}}e.ExtensionIdentifierSet=a;class g{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(h.toKey(p))}get(p){return this._map.get(h.toKey(p))}has(p){return this._map.has(h.toKey(p))}set(p,m){this._map.set(h.toKey(p),m)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=g;function w(v){return S(v)}e.isApplicationScopedExtension=w;function S(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function y(v,p){if(p){const m=`onResolveRemoteAuthority:${(0,r.getRemoteName)(p)}`;return!!v.activationEvents?.includes(m)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[239],te([0,1,8,18,22,14,3,2,65,70,32,109,238,58]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var v;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function p(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(N){const A=new r.CancellationTokenSource;return setTimeout(()=>A.cancel(),N),A.token}function d(N,A){if(N.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const T=new r.CancellationTokenSource;return N.onCancellationRequested(()=>T.cancel()),A.onCancellationRequested(()=>T.cancel()),T.token}class c{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((T,q)=>{this._resolvePromise=T,this._rejectPromise=q}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function E(N,A){const T=new c(A);return T.registerDisposable(N.onControlMessage(q=>{const B=JSON.parse(q.toString()),z=W(B);z?T.reject(z):T.resolve(B)})),T.promise}function u(N,A,T,q,B,z,j,ce){const fe=new c(ce),ue=a.StopWatch.create(!1);return N.info(`Creating a socket (${j})...`),h.mark(`code/willCreateSocket/${z}`),A.connect(T,q,B,j).then(he=>{fe.didTimeout?(h.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${j}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(h.mark(`code/didCreateSocketOK/${z}`),N.info(`Creating a socket (${j}) was successful after ${ue.elapsed()} ms.`),fe.resolve(he))},he=>{h.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${j}) returned an error after ${ue.elapsed()} ms.`),N.error(he),fe.reject(he)}),fe.promise}function t(N,A){const T=new c(A);return N.then(q=>{T.didTimeout||T.resolve(q)},q=>{T.didTimeout||T.reject(q)}),T.promise}async function l(N,A,T,q){const B=ie(N,A);N.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let z;try{z=await u(N.logService,N.remoteSocketFactoryService,N.connectTo,(0,f.getRemoteServerRootPath)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,p(A),`renderer-${p(A)}-${N.reconnectionToken}`,q)}catch(he){throw N.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),N.logService.error(he),he}N.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let j,ce;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(z,null),j=N.reconnectionProtocol,ce=!1):(j=new w.PersistentProtocol({socket:z}),ce=!0),N.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const fe=await t(N.signService.createNewMessage((0,g.generateUuid)()),q),ue={type:"auth",auth:N.connectionToken||"00000000000000000000",data:fe.data};j.sendControl(L.VSBuffer.fromString(JSON.stringify(ue)));try{const he=await E(j,d(q,m(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(N.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(N.signService.validate(fe,he.signedData),q)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const we=await t(N.signService.sign(he.data),q),Se={type:"connectionType",commit:N.commit,signedData:we,desiredConnectionType:A};return T&&(Se.args=T),N.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),j.sendControl(L.VSBuffer.fromString(JSON.stringify(Se))),{protocol:j,ownsProtocol:ce}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(N.logService.error(`${B} the handshake timed out. Error:`),N.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${B} received error control message when negotiating connection. Error:`),N.logService.error(he)),ce&&x(j),he}}async function s(N,A,T,q){const B=Date.now(),z=ie(N,A),{protocol:j,ownsProtocol:ce}=await l(N,A,T,q),fe=new c(q);return fe.registerDisposable(j.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ye=W(he);ye?(N.logService.error(`${z} received error control message when negotiating connection. Error:`),N.logService.error(ye),ce&&x(j),fe.reject(ye)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(B)}!`),fe.resolve({protocol:j,firstMessage:he}))})),fe.promise}async function i(N,A){const{protocol:T}=await s(N,1,void 0,A);return{protocol:T}}async function n(N,A,T){const{protocol:q,firstMessage:B}=await s(N,2,A,T),z=B&&B.debugPort;return{protocol:q,debugPort:z}}async function o(N,A,T){const q=Date.now(),B=ie(N,3),{protocol:z}=await l(N,3,A,T);return N.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${oe(q)}!`),z}async function b(N,A,T){const{connectTo:q,connectionToken:B}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,connectTo:q,connectionToken:B,reconnectionToken:A,reconnectionProtocol:T,remoteSocketFactoryService:N.remoteSocketFactoryService,signService:N.signService,logService:N.logService}}async function D(N,A,T){return P(N,async q=>{const{protocol:B}=await i(q,r.CancellationToken.None);return new G(N,A,T,q.reconnectionToken,B)})}e.connectRemoteAgentManagement=D;async function R(N,A){return P(N,async T=>{const{protocol:q,debugPort:B}=await n(T,A,r.CancellationToken.None);return new V(N,A,T.reconnectionToken,q,B)})}e.connectRemoteAgentExtensionHost=R;async function P(N,A){for(let q=1;;q++)try{const B=(0,g.generateUuid)(),z=await b(N,B,null);return await A(z)}catch(B){if(q<5)N.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),N.logService.error(B);else throw N.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error(B),se.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(B)),B}}async function k(N,A,T){const q=await b(N,(0,g.generateUuid)(),null);return await o(q,{host:A,port:T},r.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function O(N){return(0,I.createCancelablePromise)(A=>new Promise((T,q)=>{const B=setTimeout(T,N*1e3);A.onCancellationRequested(()=>{clearTimeout(B),T()})}))}var F;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class ${constructor(A,T){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=$;class re{constructor(A,T,q,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.durationSeconds=q,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=re;class J{constructor(A,T,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=J;class ae{constructor(A,T,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=q,this.type=4}}e.ConnectionGainEvent=ae;class ne{constructor(A,T,q,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=q,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class se extends C.Disposable{static triggerPermanentFailure(A,T,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=T,this._permanentFailureHandled=q,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor(A,T,q,B,z){super(),this._connectionType=A,this._options=T,this.reconnectionToken=q,this.protocol=B,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ae(this.reconnectionToken,0,0)),this._register(B.onSocketClose(j=>{const ce=Q(this._connectionType,this.reconnectionToken,!0);j?j.type===0?(this._options.logService.info(`${ce} received socket close event (hadError: ${j.hadError}).`),j.error&&this._options.logService.error(j.error)):(this._options.logService.info(`${ce} received socket close event (wasClean: ${j.wasClean}, code: ${j.code}, reason: ${j.reason}).`),j.event&&this._options.logService.error(j.event)):this._options.logService.info(`${ce} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(j=>{const ce=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${j.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${j.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${j.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,C.toDisposable)(()=>{const j=se._instances.indexOf(this);j>=0&&se._instances.splice(j,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const B=q<T.length?T[q]:T[T.length-1];try{if(B>0){const j=O(B);this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,j)),this._options.logService.info(`${A} waiting for ${B} seconds before reconnecting...`);try{await j}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${A} resolving connection...`);const z=await b(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${z.connectTo}...`),await this._reconnect(z,m(y)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,_.isCancellationError)(z)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,S.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,T,q){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(A,T,q):this._gotoPermanentFailure(A,T,q)}_gotoPermanentFailure(A,T,q){this._onDidStateChange.fire(new ne(this.reconnectionToken,A,T,q)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se;class G extends se{constructor(A,T,q,B,z){super(1,A,B,z,!0),this.client=this._register(new w.Client(z,{remoteAuthority:T,clientId:q},A.ipcLogger))}async _reconnect(A,T){await i(A,T)}}e.ManagementPersistentConnection=G;class V extends se{constructor(A,T,q,B,z){super(2,A,q,B,!1),this._startArguments=T,this.debugPort=z}async _reconnect(A,T){await n(A,this._startArguments,T)}}e.ExtensionHostPersistentConnection=V;function x(N){try{N.acceptDisconnect();const A=N.getSocket();N.dispose(),A.dispose()}catch(A){(0,_.onUnexpectedError)(A)}}function W(N){if(N&&N.type==="error"){const A=new Error(`Connection error: ${N.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function U(N,A){for(;N.length<A;)N+=" ";return N}function H(N,A){return`[remote-connection][${U(p(N),13)}][${A.substr(0,5)}\u2026]`}function Q(N,A,T){return`${H(N,A)}[${T?"reconnect":"initial"}]`}function ie(N,A){return`${Q(A,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.connectTo}]`}function oe(N){return`${Date.now()-N} ms`}}),define(ee[240],te([0,1,2,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(M,C){return this.factories[M]??=[],this.factories[M].push(C),(0,I.toDisposable)(()=>{const h=this.factories[M]?.indexOf(C);typeof h=="number"&&h>=0&&this.factories[M]?.splice(h,1)})}getSocketFactory(M){return(this.factories[M.type]||[]).find(h=>h.supports(M))}connect(M,C,h,a){const g=this.getSocketFactory(M);if(!g)throw new Error(`No socket factory found for ${M}`);return g.connect(M,C,h,a)}}e.RemoteSocketFactoryService=r}),define(ee[241],te([0,1,28,47,21,113]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function C(f=!1){return(M===void 0||f)&&(M=h()),M}e.hasWSLFeatureInstalled=C;async function h(){const f=a();if(f===void 0)return!1;if(f>=22e3){const y=w();if(y)return new Promise(v=>{L.execFile(y,["--status"],p=>v(!p))})}else{const y=S();if(y)try{if((await r.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(f)return parseInt(f[3])}function g(f){const y=process.env.SystemRoot;if(y){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return _.join(y,v?"Sysnative":"System32",f)}}function w(){return g("wsl.exe")}function S(){return g("lxss\\LxssManager.dll")}}),define(ee[50],te([0,1,18,14,2,181,57,6,5,43]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");class g{constructor(u){this.original=u}toJSON(){if(!this.headers){const u=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.original[t];this.headers=u}return this.headers}}class w extends r.Disposable{constructor(u){super(),this.counter=0,this.logger=u.createLogger("network",{name:(0,_.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(u,t,l){const s=`${u} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new g(t.headers??{}));try{const i=await l();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=w;function S(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=S;function f(E){return E.res.statusCode===204}e.hasNoContent=f;async function y(E){return f(E)?null:(await(0,I.streamToBuffer)(E.stream)).toString()}e.asText=y;async function v(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.asTextOrError=v;async function p(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const t=(await(0,I.streamToBuffer)(E.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.asJson=p;function m(E){c(E)}e.updateProxyConfigurationsScope=m;let d;function c(E){const u=a.Registry.as(M.Extensions.Configuration),t=d;d={id:"http",order:15,title:(0,_.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,_.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(6,null),(0,_.localize)(7,null),(0,_.localize)(8,null),(0,_.localize)(9,null)],default:"override",description:(0,_.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,_.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[d],remove:t?[t]:[]})}c(1)}),define(ee[242],te([0,1,18,22]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(C){this.service=C}listen(C,h){throw new Error("Invalid listen")}call(C,h,a,g=L.CancellationToken.None){switch(h){case"request":return this.service.request(a[0],g).then(async({res:w,stream:S})=>{const f=await(0,I.streamToBuffer)(S);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.service.resolveProxy(a[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class _{constructor(C){this.channel=C}async request(C,h){const[a,g]=await this.channel.call("request",[C],h);return{res:a,stream:(0,I.bufferToStream)(g)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=_}),define(ee[243],te([0,1,244,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,C){return M.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:M.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function _(M,C,h={}){const a=(0,I.parse)(M),g=h.proxyUrl||r(a,C);if(!g)return null;const w=(0,I.parse)(g);if(!/^https?:$/.test(w.protocol||""))return null;const S={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,y)=>{K(["http-proxy-agent"],f,y)}))(S):new(await new Promise((f,y)=>{K(["https-proxy-agent"],f,y)}))(S)}e.getProxyAgent=_}),define(ee[245],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ee[93],te([0,1,47,9,182,22,49,14,4,32,108,63,8,138]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function v(m,d,c,E){return c["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(E)&&!c["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(u,t)=>{const l=new _.CancellationTokenSource;let s=1e4;const i=m.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,f.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{u(await p(d,l.token))}catch(o){!(0,C.isCancellationError)(o)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(o)))):u({})}finally{clearTimeout(n),l.dispose()}})),y)}e.getResolvedShellEnv=v;async function p(m,d){const c=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",c);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",E);const u=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",l);const s=await(0,g.getSystemShell)(h.OS,l);return m.trace("getUnixShellEnvironment#shell",s),new Promise((i,n)=>{if(d.isCancellationRequested)return n(new C.CancellationError);const o=(0,L.basename)(s);let b,D;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(b=`& '${process.execPath}' ${R} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,D=["-Login","-Command"]):o==="nu"?(b=`^'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,D=["-i","-l","-c"]):(b=`'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),b);const P=(0,I.spawn)(s,[...D,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});d.onCancellationRequested(()=>(P.kill(),n(new C.CancellationError))),P.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(F)),n(F)});const k=[];P.stdout.on("data",F=>k.push(F));const O=[];P.stderr.on("data",F=>O.push(F)),P.on("close",(F,$)=>{const re=Buffer.concat(k).toString("utf8");m.trace("getUnixShellEnvironment#raw",re);const J=Buffer.concat(O).toString("utf8");if(J.trim()&&m.trace("getUnixShellEnvironment#stderr",J),F||$)return n(new Error((0,r.localize)(2,null,F,$)));const ae=t.exec(re),ne=ae?ae[1]:"{}";try{const se=JSON.parse(ne);c?se.ELECTRON_RUN_AS_NODE=c:delete se.ELECTRON_RUN_AS_NODE,E?se.ELECTRON_NO_ATTACH_CONSOLE=E:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){m.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(se)),n(se)}})})}}),define(ee[246],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const _=await this.getValidator();if(_){const M=String(I._nextId++);return this.validators.set(M,_),{id:M,data:_.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,_){if(!r.id)return!0;const M=this.validators.get(r.id);if(!M)return!1;this.validators.delete(r.id);try{return M.validate(_)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=I}),define(ee[94],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[247],te([0,1,246]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends I.AbstractSignService{getValidator(){return this.vsda().then(_=>new _.validator)}signValue(_){return this.vsda().then(M=>new M.signer().sign(_))}vsda(){return new Promise((_,M)=>K(["vsda"],_,M))}}e.SignService=L}),define(ee[34],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[121],te([0,1,8,18,2,12,36,16,5]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends r.Disposable{constructor(y,v,p,m){super(),this.storagePath=y,this.logService=p,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=v===0?void 0:this._register(new I.ThrottledDelayer(100))}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,v){const p=this.storage[y];return(0,_.isUndefinedOrNull)(p)?v:p}setItem(y,v){this.setItems([{key:y,data:v}])}setItems(y){let v=!1;for(const{key:p,data:m}of y)this.storage[p]!==m&&((0,_.isUndefinedOrNull)(m)?(0,_.isUndefined)(this.storage[p])||(this.storage[p]=void 0,v=!0):(this.storage[p]=m,v=!0));v&&this.save()}removeItem(y){(0,_.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=y}catch(v){this.logService.error(v)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=g;let w=class extends r.Disposable{constructor(y,v,p,m){super(),this.fileStorage=this._register(new g(v.stateResource,y,p,m))}async init(){await this.fileStorage.init()}getItem(y,v){return this.fileStorage.getItem(y,v)}};e.StateReadonlyService=w,e.StateReadonlyService=w=Ee([Z(1,M.IEnvironmentService),Z(2,h.ILogService),Z(3,C.IFileService)],w);class S extends w{setItem(y,v){this.fileStorage.setItem(y,v)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}}e.StateService=S}),define(ee[122],te([0,1,4,35,32]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(h){if(I.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function M(h,a,g,w,S,f,y,v){const p=Object.create(null);p["common.machineId"]=f,p.sessionID=(0,r.generateUuid)()+Date.now(),p.commitHash=w,p.version=S,p["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,I.PlatformToString)(I.platform),p["common.nodePlatform"]=L.platform,p["common.nodeArch"]=g,p["common.product"]=v||"desktop",y&&(p["common.msftInternal"]=y);let m=0;const d=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),I.isLinuxSnap&&(p["common.snap"]="true");const c=_(a);return c&&(p["common.platformDetail"]=c),p}e.resolveCommonProperties=M;function C(h){const a=L.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return h.some(w=>g===w)}e.verifyMicrosoftInternalDomain=C}),define(ee[26],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(ee[248],te([0,1,28,8,44,13,9,4,7,86,21,107,90,16,24,26]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function m(t,l){const s=`${t}::${l.join(":")}`,i=p.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,b=new Map,D=2e4;function R(k,O,F,$){const re=O.substring(k.length+1);return L.Promises.withAsyncBody(async J=>{let ae;try{ae=await g.Promises.readdir(O,{withFileTypes:!0})}catch{J();return}if($.count>=D){$.count+=ae.length,$.maxReached=!0,J();return}let ne=ae.length;if(ne===0){J();return}let se=ae;$.count+ae.length>D&&($.maxReached=!0,ne=D-$.count,se=ae.slice(0,ne)),$.count+=ae.length;for(const G of se)if(G.isDirectory()){if(F.includes(G.name)||await R(k,(0,M.join)(O,G.name),F,$),--ne===0){J();return}}else{const V=G.name.lastIndexOf(".");if(V>=0){const x=G.name.substring(V+1);x&&o.set(x,(o.get(x)??0)+1)}for(const x of n)x.relativePathPattern?.test(re)!==!1&&x.filePattern.test(G.name)&&b.set(x.tag,(b.get(x.tag)??0)+1);if(--ne===0){J();return}}})}const P=L.Promises.withAsyncBody(async k=>{const O={count:0,maxReached:!1};await R(t,t,l,O);const F=await E(t);k({configFiles:d(b),fileTypes:d(o),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return p.set(s,P),P}e.collectWorkspaceStats=m;function d(t){return Array.from(t.entries(),([l,s])=>({name:l,count:s})).sort((l,s)=>s.count-l.count)}function c(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.virtualMachineHint.value()*100)}%`},l=I.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.getMachineInfo=c;async function E(t){try{const l=new Map,s=(0,M.join)(t,".vscode","launch.json"),i=await g.Promises.readFile(s),n=[],o=(0,r.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(o)==="object"&&o.configurations)for(const b of o.configurations){const D=b.type;D&&(l.has(D)?l.set(D,l.get(D)+1):l.set(D,1))}return d(l)}catch{return[]}}e.collectLaunchConfigs=E;let u=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${I.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(a.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,w.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[n,o]=i,b=this.formatProcessList(l,n);return s.forEach(D=>{if((0,S.isRemoteDiagnosticError)(D))b+=`
${D.errorMessage}`,o+=`
${D.errorMessage}`;else if(b+=`

Remote: ${D.hostName}`,D.processes&&(b+=`
${this.formatProcessList(l,D.processes)}`),D.workspaceMetadata){o+=`
|  Remote: ${D.hostName}`;for(const R of Object.keys(D.workspaceMetadata)){const P=D.workspaceMetadata[R];let k=`${P.fileCount} files`;P.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${R}): ${k}`,o+=this.formatWorkspaceStats(P)}}}),{processInfo:b,workspaceInfo:o}})}async getSystemInfo(l,s){const{memory:i,vmHint:n,os:o,cpus:b}=c(),D={os:o,memory:i,cpus:b,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(D.load=`${I.loadavg().map(R=>Math.round(R)).join(", ")}`),C.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(l,s){const i=[];return(0,w.listProcesses)(l.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),s.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(l,o.processes)),o.workspaceMetadata)for(const b of Object.keys(o.workspaceMetadata)){const D=o.workspaceMetadata[b];let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${b}): ${R}`),i.push(this.formatWorkspaceStats(D))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const s=[];let n=0;const o=(P,k)=>{const O=` ${P}(${k})`;n+O.length>60?(s.push(b),b="|                 ",n=b.length):n+=O.length,b+=O};let b="|      File types:";const D=10,R=l.fileTypes.length>D?D:l.fileTypes.length;for(let P=0;P<R;P++){const k=l.fileTypes[P];o(k.name,k.count)}if(s.push(b),l.configFiles.length>=0&&(b="|      Conf files:",n=0,l.configFiles.forEach(P=>{o(P.name,P.count)}),s.push(b)),l.launchConfigFiles.length>0){let P="|      Launch Configs:";l.launchConfigFiles.forEach(k=>{const O=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;P+=O}),s.push(P)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const b=h.URI.revive(o);if(b.scheme===_.Schemas.file){const D=b.fsPath;i.push(m(D,["node_modules",".git"]).then(R=>{let P=`${R.fileCount} files`;R.maxFilesReached&&(P=`more than ${P}`),s.push(`|    Folder (${(0,M.basename)(D)}): ${P}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${R.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(l,s){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:b})=>i.set(o,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,i,n,s,0),n.join(`
`)}formatProcessItem(l,s,i,n,o){const b=o===0;let D;b?D=n.pid===l?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?D=s.get(n.pid):D=`${"  ".repeat(o)} ${n.name}`;const R=process.platform==="win32"?n.mem:I.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(P=>this.formatProcessItem(l,s,i,P,o+1))}async getWorkspaceFileExtensions(l){const s=new Set;for(const{uri:i}of l.folders){const n=h.URI.revive(i);if(n.scheme!==_.Schemas.file)continue;const o=n.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(D=>s.add(D.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const i=h.URI.revive(s);if(i.scheme!==_.Schemas.file)continue;const n=i.fsPath;try{const o=await m(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})}),o.launchConfigFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})}),o.configFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.DiagnosticsService=u,e.DiagnosticsService=u=Ee([Z(0,v.ITelemetryService),Z(1,y.IProductService)],u)}),define(ee[249],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(_){this.appenders=_}listen(_,M){throw new Error(`Event not found: ${M}`)}call(_,M,{eventName:C,data:h}){return this.appenders.forEach(a=>a.log(C,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class L{constructor(_){this.channel=_}log(_,M){return this.channel.call("log",{eventName:_,data:M}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[51],te([0,1,37,12,3,17,58,122,26]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=g,e.NullTelemetryService=new g;class w{async publicLog(n,o,b){}async publicLogError(n,o,b){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,n){return r.Event.debounce(n.onDidChangeConfiguration,(b,D)=>{const R=b?new Set([...b.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:R}},1e3,!0)(b=>{b.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,_.ConfigurationTargetToString)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.configurationTelemetry=S;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=f;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function v(i){const n=i.getValue(h.TELEMETRY_SETTING_ID),o=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function p(i){const n={},o={},b={};c(i,b);for(let D in b){D=D.length>150?D.substr(D.length-149):D;const R=b[D];typeof R=="number"?o[D]=R:typeof R=="boolean"?o[D]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${R.length}`),n[D]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[D]=R)}return{properties:n,measurements:o}}e.validateTelemetryData=p;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(i){if(!i)return"none";const n=(0,M.getRemoteName)(i);return m.has(n)?n:"other"}e.cleanRemoteAuthority=d;function c(i,n,o=0,b){if(i)for(const D of Object.getOwnPropertyNames(i)){const R=i[D],P=b?b+D:D;Array.isArray(R)?n[P]=(0,I.safeStringify)(R):R instanceof Date?n[P]=R.toISOString():(0,L.isObject)(R)?o<2?c(R,n,o+1,P+"."):n[P]=(0,I.safeStringify)(R):n[P]=R}}function E(i,n){const o=i.msftInternalDomains||[],b=n.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(o)||b}e.isInternalTelemetry=E;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const b=[];for(const k of n)for(;;){const O=k.exec(i);if(!O)break;b.push([O.index,k.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const k=R.exec(i);if(!k)break;const O=b.some(([F,$])=>k.index<$&&F<R.lastIndex);!D.test(k[0])&&!O&&(o+=i.substring(P,k.index)+"<REDACTED: user-file-path>",P=R.lastIndex)}return P<i.length&&(o+=i.substr(P)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function s(i,n){return(0,I.cloneAndChange)(i,o=>{if(o instanceof a||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let b=o.replaceAll("%20"," ");b=t(b,n);for(const D of n)b=b.replace(D,"");return b=l(b),b}})}e.cleanData=s}),define(ee[123],te([0,1,27,117,120,4,7,14,35,51]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function g(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,I.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=g;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,n,o)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?g(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const i=f.exec(s);return i&&i[1]?[p(i[1]),i[2]]:[p(s),void 0]}e.getIdAndVersion=y;function v(s,i){return`${s}.${i}`}e.getExtensionId=v;function p(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=p;function m(s,i){return p(v(s??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=m;function d(s,i){const n=[],o=b=>{for(const D of n)if(D.some(R=>g(i(R),i(b))))return D;return null};for(const b of s){const D=o(b);D?D.push(b):n.push([b])}return n}e.groupByExtension=d;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function E(s){return{id:new a.TelemetryTrustedValue(s.identifier.id),name:new a.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function u(s,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const b=o.shift();if(b&&n.every(D=>!g(D.identifier,{id:b}))){const D=s.filter(R=>g(R.identifier,{id:b}));D.length===1&&(n.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function t(s,i){if(!_.isLinux)return!1;let n;try{n=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,i){const n=await t(s,i),o=(0,L.getTargetPlatform)(n?"alpine":_.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=l}),define(ee[250],te([0,1,204,51]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(_,M,C,h,a,g,w){const S={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,C)&&(0,L.getTelemetryLevel)(h)===3){const f=await(0,I.getServiceMachineId)(C,a,g);S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=w.machineId||f}return S}e.resolveMarketplaceHeaders=r}),define(ee[251],te([0,1,2,37,4,27,183,17,57,77,24,43,26,51]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,d,c){this._configurationService=d,this._productService=c,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(S.TELEMETRY_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(m,d){this._experimentProperties[m]=d}_updateTelemetryLevel(){let m=(0,f.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const c=d.usage?3:d.error?2:0;m=Math.min(m,c)}this._telemetryLevel=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(m,d,c){this._telemetryLevel<d||(c=(0,L.mixin)(c,this._experimentProperties),c=(0,f.cleanData)(c,this._cleanupPatterns),c=(0,L.mixin)(c,this._commonProperties),this._appenders.forEach(E=>E.log(m,c)))}publicLog(m,d){this._log(m,3,d)}publicLog2(m,d){this.publicLog(m,d)}publicLogError(m,d){this._sendErrorTelemetry&&this._log(m,2,d)}publicLogError2(m,d){this.publicLogError(m,d)}};e.TelemetryService=y,e.TelemetryService=y=Ee([Z(1,C.IConfigurationService),Z(2,g.IProductService)],y);function v(){const p=(0,M.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=r.isWeb?"":(0,M.localize)(3,null),c=(0,M.localize)(4,null),E=(0,M.localize)(5,null),u=(0,M.localize)(6,null),t=(0,M.localize)(7,null),l=`
|       | ${c} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,M.localize)(8,null);return`
${p} ${m} ${d}

&nbsp;

${t}
${l}

&nbsp;

${s}
`}w.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,M.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,M.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,4,86,26]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function _(M,C){let h=M.getItem(r.machineIdKey);return(typeof h!="string"||I.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,L.getMachineId)(C.error.bind(C))),h}e.resolveMachineId=_}),define(ee[253],te([0,1,26,252]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(_,M){const C=await(0,L.resolveMachineId)(_,M);return _.setItem(I.machineIdKey,C),C}e.resolveMachineId=r}),define(ee[124],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var I;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(I||(e.EnvironmentVariableMutatorType=I={}))}),define(ee[254],te([0,1,4,124]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class _{constructor(g){this.collections=g,this.map=new Map,this.descriptionMap=new Map,g.forEach((w,S)=>{this.populateDescriptionMap(w,S);const f=w.map.entries();let y=f.next();for(;!y.done;){const v=y.value[1],p=y.value[0];let m=this.map.get(p);if(m||(m=[],this.map.set(p,m)),m.length>0&&m[0].type===L.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const d={extensionIdentifier:S,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};d.scope||delete d.scope,m.unshift(d),y=f.next()}})}async applyToProcessEnvironment(g,w,S){let f;I.isWindows&&(f={},Object.keys(g).forEach(y=>f[y.toLowerCase()]=y));for(const[y,v]of this.getVariableMap(w)){const p=I.isWindows&&f[y.toLowerCase()]||y;for(const m of v){const d=S?await S(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case L.EnvironmentVariableMutatorType.Append:g[p]=(g[p]||"")+d;break;case L.EnvironmentVariableMutatorType.Prepend:g[p]=d+(g[p]||"");break;case L.EnvironmentVariableMutatorType.Replace:g[p]=d;break}if(m.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${r.get(m.type)}`;g[c]=(g[c]?g[c]+":":"")+y+"="+this._encodeColons(d)}}}}_encodeColons(g){return g.replaceAll(":","\\x3a")}diff(g,w){const S=new Map,f=new Map,y=new Map;if(g.getVariableMap(w).forEach((v,p)=>{const m=this.getVariableMap(w).get(p),d=C(v,m);d&&S.set(p,d)}),this.getVariableMap(w).forEach((v,p)=>{const m=g.getVariableMap(w).get(p),d=C(v,m);d&&y.set(p,d)}),this.getVariableMap(w).forEach((v,p)=>{const m=g.getVariableMap(w).get(p),d=h(v,m);d&&f.set(p,d)}),!(S.size===0&&f.size===0&&y.size===0))return{added:S,changed:f,removed:y}}getVariableMap(g){const w=new Map;for(const S of this.map.values()){const f=S.filter(y=>M(y,g));f.length>0&&w.set(f[0].variable,f)}return w}getDescriptionMap(g){const w=new Map;for(const S of this.descriptionMap.values()){const f=S.filter(y=>M(y,g,!0));for(const y of f)w.set(y.extensionIdentifier,y.description)}return w}populateDescriptionMap(g,w){if(!g.descriptionMap)return;const S=g.descriptionMap.entries();let f=S.next();for(;!f.done;){const y=f.value[1],v=f.value[0];let p=this.descriptionMap.get(v);p||(p=[],this.descriptionMap.set(v,p));const m={extensionIdentifier:w,scope:y.scope,description:y.description};m.scope||delete m.scope,p.push(m),f=S.next()}}}e.MergedEnvironmentVariableCollection=_;function M(a,g,w=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):w?g===a.scope:!0}function C(a,g){if(!g)return a;const w=new Set;g.forEach(f=>w.add(f.extensionIdentifier));const S=[];return a.forEach(f=>{w.has(f.extensionIdentifier)||S.push(f)}),S.length===0?void 0:S}function h(a,g){if(!g)return;const w=new Map;g.forEach(f=>w.set(f.extensionIdentifier,f));const S=[];return a.forEach(f=>{const y=w.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&S.push(y)}),S.length===0?void 0:S}}),define(ee[255],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=I;function L(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=r;function _(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=_;function M(h){return Array.from(h.entries()).map(a=>[a[0],I(a[1].map),L(a[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function C(h){return new Map(h.map(a=>[a[0],{map:r(a[1]),descriptionMap:_(a[2])}]))}e.deserializeEnvironmentVariableCollections=C}),define(ee[256],te([0,1,8,22,3,2,5]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends _.Disposable{constructor(a,g){super(),this._logService=g,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=a===void 0?15e3:a,this._register((0,_.toDisposable)(()=>{for(const w of this._pendingRequestDisposables.values())(0,_.dispose)(w)}))}createRequest(a){return new Promise((g,w)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,g),this._onCreateRequest.fire({requestId:S,...a});const f=new L.CancellationTokenSource;(0,I.timeout)(this._timeout,f.token).then(()=>w(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,_.toDisposable)(()=>f.cancel())])})}acceptReply(a,g){const w=this._pendingRequests.get(a);w?(this._pendingRequests.delete(a),(0,_.dispose)(this._pendingRequestDisposables.get(a)||[]),this._pendingRequestDisposables.delete(a),w(g)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.RequestStore=C,e.RequestStore=C=Ee([Z(1,M.ILogService)],C)}),define(ee[125],te([0,1,6,114,43]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var _;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(_||(e.TerminalSettingPrefix=_={}));var M;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var C;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(C||(e.PosixShellType=C={}));var h;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var w;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.IPtyService=(0,I.createDecorator)("ptyService");var S;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S||(e.HeartbeatConstants=S={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var v;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var p;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var m;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var d;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const l=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this._backends.set(l,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new E),e.ILocalPtyService=(0,I.createDecorator)("localPtyService"),e.ITerminalLogService=(0,I.createDecorator)("terminalLogService")}),define(ee[257],te([0,1,72,7,185,102]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(S,f){const y=[{name:null,description:(0,r.localize)(0,null)}];return y.push(...S.map(v=>({name:v.profileName,description:C(v)}))),f&&y.push(...f.map(v=>({name:v.title,description:h(v)}))),{values:y.map(v=>v.name),markdownDescriptions:y.map(v=>v.description)}}e.createProfileSchemaEnums=M;function C(S){let f=`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:I.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?f+=`
- args: "${S.args}"`:f+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(f+=`
- overrideName: ${S.overrideName}`),S.color&&(f+=`
- color: ${S.color}`),S.env&&(f+=`
- env: ${JSON.stringify(S.env)}`),f}function h(S){return`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:I.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function a(S,f){if(!S&&!f)return!0;if(typeof S=="string"&&typeof f=="string")return S===f;if(Array.isArray(S)&&Array.isArray(f)){if(S.length!==f.length)return!1;for(let y=0;y<S.length;y++)if(S[y]!==f[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=a;function g(S,f){if(!S&&!f)return!0;if(!S||!f)return!1;if(_.ThemeIcon.isThemeIcon(S)&&_.ThemeIcon.isThemeIcon(f))return S.id===f.id&&S.color===f.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof f=="object"&&"light"in f&&"dark"in f){const y=S,v=f;if((L.URI.isUri(y.light)||w(y.light))&&(L.URI.isUri(y.dark)||w(y.dark))&&(L.URI.isUri(v.light)||w(v.light))&&(L.URI.isUri(v.dark)||w(v.dark)))return y.light.path===v.light.path&&y.dark.path===v.dark.path}if(L.URI.isUri(S)&&L.URI.isUri(f)||w(S)||w(f)){const y=S,v=f;return y.path===v.path&&y.scheme===v.scheme}return!1}e.terminalIconsEqual=g;function w(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=w}),define(ee[258],te([0,1,72,4,184,57,43,257]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,I.getAllCodicons)(),p=>p.id),markdownEnumDescriptions:Array.from((0,I.getAllCodicons)(),p=>`$(${p.id})`)};const h={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},g={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function w(p){const m=p===2?"linux":p===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(p),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const S={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...h}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...h}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...h}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){M.Registry.as(_.Extensions.Configuration).registerConfiguration(S),v()}e.registerTerminalPlatformConfiguration=f;let y;function v(p,m){const d=M.Registry.as(_.Extensions.Configuration);let c;p&&(c=(0,C.createProfileSchemaEnums)(p?.profiles,m));const E=y;y={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?c?.values:void 0,markdownEnumDescriptions:p?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?c?.values:void 0,markdownEnumDescriptions:p?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?c?.values:void 0,markdownEnumDescriptions:p?.os===1?c?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[y],remove:E?[E]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(ee[259],te([0,1,28,13,37,9,4,35,27,12,21,124,255,254]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.getWindowsBuildNumber=y;async function v(i,n,o,b=C.env,D=g.Promises.exists){if(_.isAbsolute(i))return await D(i)?i:void 0;if(n===void 0&&(n=C.cwd()),_.dirname(i)!=="."){const O=_.join(n,i);return await D(O)?O:void 0}const P=(0,r.getCaseInsensitive)(b,"PATH");if(o===void 0&&(0,a.isString)(P)&&(o=P.split(_.delimiter)),o===void 0||o.length===0){const O=_.join(n,i);return await D(O)?O:void 0}for(const O of o){let F;if(_.isAbsolute(O)?F=_.join(O,i):F=_.join(n,O,i),await D(F))return F;if(M.isWindows){let $=F+".com";if(await D($)||($=F+".exe",await D($)))return $}}const k=_.join(n,i);return await D(k)?k:void 0}e.findExecutable=v;function p(i,n,o,b,D){const R=M.isWindows&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||R)return;const P=i.args,k=C.platform==="win32"?_.basename(i.executable).toLowerCase():_.basename(i.executable),O=_.dirname(L.FileAccess.asFileUri("").fsPath);let F;const $={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&($.VSCODE_NONCE=n.shellIntegration.nonce),M.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!P||l(P)?F=c.get(d.WindowsPwsh):t(P)&&(F=c.get(d.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O,""),{newArgs:F,envMixin:$}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(k){case"bash":return!P||P.length===0?F=c.get(d.Bash):s(P)&&($.VSCODE_SHELL_LOGIN="1",m(n,$),F=c.get(d.Bash)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O),{newArgs:F,envMixin:$}):void 0;case"fish":{const re=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=_.join(O,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return $.XDG_DATA_DIRS=`${re}:${J}`,m(n,$),{newArgs:void 0,envMixin:$}}case"pwsh":return!P||l(P)?F=c.get(d.Pwsh):t(P)&&(F=c.get(d.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O,""),{newArgs:F,envMixin:$}):void 0;case"zsh":{if(!P||P.length===0?F=c.get(d.Zsh):s(P)?(F=c.get(d.ZshLogin),m(n,$)):(P===c.get(d.Zsh)||P===c.get(d.ZshLogin))&&(F=P),!F)return;F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O);let re;try{re=I.userInfo().username}catch{re="unknown"}const J=_.join(I.tmpdir(),`${re}-${D.applicationName}-zsh`);$.ZDOTDIR=J;const ae=o?.ZDOTDIR??I.homedir()??"~";$.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:_.join(J,".zshrc")}),ne.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:_.join(J,".zprofile")}),ne.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:_.join(J,".zshenv")}),ne.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:_.join(J,".zlogin")}),{newArgs:F,envMixin:$,filesToCopy:ne}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=p;function m(i,n){if(M.isMacintosh&&i.environmentVariableCollections){const o=(0,S.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),D=new f.MergedEnvironmentVariableCollection(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),R=[];if(D)for(const P of D)P.type===w.EnvironmentVariableMutatorType.Prepend&&R.push(P.value);R.length>0&&(n.VSCODE_PATH_PREFIX=R.join(""))}}var d;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(d||(d={}));const c=new Map;c.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(d.Zsh,["-i"]),c.set(d.ZshLogin,["-il"]),c.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function s(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,72,9,4,12,21,106,259,113]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let w,S=!0;function f(n,o,b,D,R=process.env,P,k,O,F){return P=P||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},_.isWindows?y(b,P,R,k,D.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:D.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:D.getValue("terminal.integrated.defaultProfile.windows"),F,O):l(P,k,b,n&&typeof n=="object"?{...n}:D.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:D.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,O,R)}e.detectAvailableProfiles=f;async function y(n,o,b,D,R,P,k,O,F){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let J=!1;(0,a.getWindowsBuildNumber)()>=16299&&(J=!0),await d(O);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const se=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",se],requiresPath:process.env.CMDER_ROOT?se:{path:se,isUnsafe:!0},isAutoDetected:!0})}s(P,ae);const ne=await v(ae.entries(),k,o,b,D,F);if(n&&R)try{const se=await u(`${re}\\${J?"wsl":"bash"}.exe`,k);for(const G of se)(!P||!(G.profileName in P))&&ne.push(G)}catch{S&&(D?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return ne}async function v(n,o,b,D=process.env,R,P){const k=[];for(const[O,F]of n)k.push(p(O,F,o,b,D,R,P));return(await Promise.all(k)).filter(O=>!!O)}async function p(n,o,b,D,R=process.env,P,k){if(o===null)return;let O,F,$;if("source"in o&&!("path"in o)){const ne=w?.get(o.source);if(!ne)return;O=ne.paths,F=o.args||ne.args,o.icon?$=m(o.icon):ne.icon&&($=ne.icon)}else O=Array.isArray(o.path)?o.path:[o.path],F=_.isWindows||Array.isArray(o.args)?o.args:void 0,$=m(o.icon);let re;if(k){const ne=O.map(G=>typeof G=="string"?G:G.path),se=await k(ne);re=new Array(O.length);for(let G=0;G<O.length;G++)typeof O[G]=="string"?re[G]=se[G]:re[G]={path:se[G],isUnsafe:!0}}else re=O.slice();let J;if(o.requiresPath){let ne;if((0,M.isString)(o.requiresPath)?ne=o.requiresPath:(ne=o.requiresPath.path,o.requiresPath.isUnsafe&&(J=ne)),!await D.existsFile(ne))return}const ae=await i(n,b,re,D,R,F,o.env,o.overrideName,o.isAutoDetected,J);if(!ae){P?.debug("Terminal profile not validated",n,O);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=$,ae.color=o.color,ae}function m(n){return typeof n=="string"?{id:n}:n}async function d(n){if(w&&!n)return;const[o,b]=await Promise.all([c(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:b,icon:L.Codicon.terminalPowershell})}async function c(){const n=new Set,o=await(0,a.findExecutable)("git.exe");if(o){const R=(0,g.dirname)(o);n.add((0,g.resolve)(R,"../.."))}function b(R,P){P&&R.add(P)}b(n,process.env.ProgramW6432),b(n,process.env.ProgramFiles),b(n,process.env["ProgramFiles(X86)"]),b(n,`${process.env.LocalAppData}\\Program`);const D=[];for(const R of n)D.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function E(){const n=[];for await(const o of(0,h.enumeratePowerShellInstallations)())n.push(o.exePath);return n}async function u(n,o){const b=[],D=await new Promise((k,O)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,$)=>{if(F)return O("Problem occurred when getting wsl distros");k($)})});if(!D)return[];const R=new RegExp(/[\r?\n]/),P=D.split(R).filter(k=>k.trim().length>0&&k!=="");for(const k of P){if(k===""||k.startsWith("docker-desktop"))continue;const O=`${k} (WSL)`,F={profileName:O,path:n,args:["-d",`${k}`],isDefault:O===o,icon:t(k),isAutoDetected:!1};b.push(F)}return b}function t(n){return n.includes("Ubuntu")?L.Codicon.terminalUbuntu:n.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function l(n,o,b,D,R,P,k,O){const F=new Map;if(b){const $=(await n.readFile("/etc/shells")).toString(),re=(P||$.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),J=new Map;for(const ae of re){let ne=(0,r.basename)(ae),se=J.get(ne)||0;se++,se>1&&(ne=`${ne} (${se})`),J.set(ne,se),F.set(ne,{path:ae,isAutoDetected:!0})}}return s(D,F),await v(F.entries(),R,n,O,o,k)}function s(n,o){if(n)for(const[b,D]of Object.entries(n))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?o.delete(b):(D.icon=D.icon||o.get(b)?.icon,o.set(b,D))}async function i(n,o,b,D,R,P,k,O,F,$){if(b.length===0)return Promise.resolve(void 0);const re=b.shift();if(re==="")return i(n,o,b,D,R,P,k,O,F);const J=typeof re!="string"&&re.isUnsafe,ae=typeof re=="string"?re:re.path,ne={profileName:n,path:ae,args:P,env:k,overrideName:O,isAutoDetected:F,isDefault:n===o,isUnsafePath:J,requiresUnsafePath:$};if((0,r.basename)(ae)===ae){const G=R.PATH?R.PATH.split(r.delimiter):void 0,V=await(0,a.findExecutable)(ae,void 0,G,void 0,D.existsFile);return V?(ne.path=V,ne.isFromPath=!0,ne):i(n,o,b,D,R,P)}return await D.existsFile((0,r.normalize)(ae))?ne:i(n,o,b,D,R,P,k,O,F)}}),define(ee[261],te([0,1,3,2,4,42,17,5,224,93,256,125,258,260,108,70]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let m=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(c,E,u,t){super(),this._ptyHostStarter=c,this._configurationService=E,this._logService=u,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new g.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&I.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,a.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c=this._ptyHostStarter.start(),E=c.client;this._logService.getLevel()===C.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),_.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(c.onDidProcessExit(l=>{this._onPtyHostExit.fire(l.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=_.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(l=>this._onProcessData.fire(l))),this._register(t.onProcessReady(l=>this._onProcessReady.fire(l))),this._register(t.onProcessExit(l=>this._onProcessExit.fire(l))),this._register(t.onDidChangeProperty(l=>this._onDidChangeProperty.fire(l))),this._register(t.onProcessReplay(l=>this._onProcessReplay.fire(l))),this._register(t.onProcessOrphanQuestion(l=>this._onProcessOrphanQuestion.fire(l))),this._register(t.onDidRequestDetach(l=>this._onDidRequestDetach.fire(l))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,E.getChannel(w.TerminalIpcChannels.Logger))),this.__connection=c,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[c,t]}async createProcess(c,E,u,t,l,s,i,n,o,b,D){const R=setTimeout(()=>this._handleUnresponsiveCreateProcess(),w.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(c,E,u,t,l,s,i,n,o,b,D);return clearTimeout(R),P}updateTitle(c,E,u){return this._proxy.updateTitle(c,E,u)}updateIcon(c,E,u,t){return this._proxy.updateIcon(c,E,u,t)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c,E){return this._proxy.detachFromProcess(c,E)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,E){return this._proxy.shutdown(c,E)}input(c,E){return this._proxy.input(c,E)}processBinary(c,E){return this._proxy.processBinary(c,E)}resize(c,E,u){return this._proxy.resize(c,E,u)}clearBuffer(c){return this._proxy.clearBuffer(c)}acknowledgeDataEvent(c,E){return this._proxy.acknowledgeDataEvent(c,E)}setUnicodeVersion(c,E){return this._proxy.setUnicodeVersion(c,E)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}async getLatency(){const c=new v.StopWatch,E=await this._proxy.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...E]}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,E){return this._proxy.installAutoReply(c,E)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._optionalProxy?.getDefaultSystemShell(c)??(0,y.getSystemShell)(c??r.OS,process.env)}async getProfiles(c,E,u,t=!1){const l=await this._resolveShellEnv();return(0,f.detectAvailableProfiles)(E,u,t,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,c))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(c,E){return this._proxy.getWslPath(c,E)}getRevivedPtyNewId(c,E){return this._proxy.getRevivedPtyNewId(c,E)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this._optionalProxy?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,E){return this._proxy.requestDetachInstance(c,E)}async acceptDetachInstanceReply(c,E){return this._proxy.acceptDetachInstanceReply(c,E)}async freePortKillProcess(c){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(c)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,E,u){return this._proxy.reviveTerminalProcesses(c,E,u)}async refreshProperty(c,E){return this._proxy.refreshProperty(c,E)}async updateProperty(c,E,u){return this._proxy.updateProperty(c,E,u)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(c){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,E){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:E})}async acceptPtyHostResolvedVariables(c,E){this._resolveVariablesRequestStore.acceptReply(c,E)}};e.PtyHostService=m,e.PtyHostService=m=Ee([Z(1,M.IConfigurationService),Z(2,C.ILogService),Z(3,C.ILoggerService)],m)}),define(ee[67],te([0,1,15,3,2,4,17,6,34]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const a="#FFFFFF",g="#1E1E1E",w="#000000",S="#FFFFFF",f="theme",y="themeBackground",v="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let p=class extends r.Disposable{constructor(d,c){super(),this.stateService=d,this.configurationService=c,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,I.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(_.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(_.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(_.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return d.dark?w:S;let c=this.stateService.getItem(y,null);if(!c)switch(this.stateService.getItem(f,"vs-dark").split(" ")[0]){case"vs":c=a;break;case"hc-black":c=w;break;case"hc-light":c=S;break;default:c=g}return _.isMacintosh&&c.toUpperCase()===g&&(c="#171717"),c}saveWindowSplash(d,c){this.stateService.setItems([{key:f,data:c.baseTheme},{key:y,data:c.colorInfo.background},{key:v,data:c}]),typeof d=="number"&&this.updateBackgroundColor(d,c)}updateBackgroundColor(d,c){for(const E of I.BrowserWindow.getAllWindows())if(E.id===d){E.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(v)}};e.ThemeMainService=p,e.ThemeMainService=p=Ee([Z(0,h.IStateService),Z(1,M.IConfigurationService)],p)}),define(ee[126],te([0,1,3,17,6,5]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(p){p.Http="http",p.Https="https"})(M||(e.TunnelProtocol=M={}));var C;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(C||(e.TunnelPrivacyId=C={}));function h(p){return!!p.forwardPort}e.isTunnelProvider=h;var a;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=S;function f(p,m,d,c){if(d===1)return!1;if(d===2&&S(m)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(E?.length===4&&parseInt(E[1])>=18)return!1}return p<1024}e.isPortPrivileged=f;class y{constructor(m,d,c){this.remoteAddress=m,this.localAddress=d,this._dispose=c,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let v=class{constructor(m,d){this.logService=m,this.configurationService=d,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],d=Array.from(this._tunnels.values());for(const c of d){const E=Array.from(c.values());for(const u of E){const t=await u.value;t&&typeof t!="string"&&m.push(t)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:d}of m.values())await d.then(c=>typeof c!="string"?c?.dispose():void 0);m.clear()}this._tunnels.clear()}setEnvironmentTunnel(m,d,c,E,u){this.addTunnelToMap(m,d,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:d,localAddress:c,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,d){(S(m)||w(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(m,d);if(c)return++c.refcount,c.value}openTunnel(m,d,c,E,u,t=!1,l,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${u}.`);const i=this._tunnelProvider??m;if(!i)return;if(d||(d="localhost"),E||(E=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(i,d,c,E,u,t,l,s);return n?n.then(o=>{if(o){if(typeof o=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,c),o}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.makeTunnel(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(b),b}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this._tunnels.get(m.tunnelRemoteHost);if(d){const c=d.get(m.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,c))}}}}async tryDisposeTunnel(m,d,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const E=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(d),E}}async closeTunnel(m,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const c=this._tunnels.get(m);if(c&&c.has(d)){const E=c.get(d);E.refcount=0,await this.tryDisposeTunnel(m,d,E)}}addTunnelToMap(m,d,c){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(d,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(m,d){const c=this._tunnels.get(m);if(c){const E=c.get(d),u=E?await E.value:void 0;(!u||typeof u=="string")&&c.delete(d),c.size===0&&this._tunnels.delete(m)}}getTunnelFromMap(m,d){const c=[m];w(m)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):S(m)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const E=c.map(u=>this._tunnels.get(u));for(const u of E){const t=u?.get(d);if(t)return t}}canTunnel(m){return!!g(m)}createWithProvider(m,d,c,E,u,t,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${E}.`);const s=c;this._factoryInProgress.add(s);const i=E===void 0?c:E,n={elevationRequired:u?this.isPortPrivileged(i):!1},o={remoteAddress:{host:d,port:c},localAddressPort:E,privacy:t,public:t?t!==C.Private:void 0,protocol:l},b=m.forwardPort(o,n);return b?(this.addTunnelToMap(d,c,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),b}};e.AbstractTunnelService=v,e.AbstractTunnelService=v=Ee([Z(0,_.ILogService),Z(1,L.IConfigurationService)],v)}),define(ee[48],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.Disabled="disabled",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L||(e.StateType=L={}));var r;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var _;(function(M){M[M.NotBuilt=0]="NotBuilt",M[M.DisabledByEnvironment=1]="DisabledByEnvironment",M[M.ManuallyDisabled=2]="ManuallyDisabled",M[M.MissingConfiguration=3]="MissingConfiguration",M[M.InvalidConfiguration=4]="InvalidConfiguration",M[M.RunningAsAdmin=5]="RunningAsAdmin"})(_||(e.DisablementReason=_={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:M=>({type:"disabled",reason:M}),Idle:(M,C)=>({type:"idle",updateType:M,error:C}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[262],te([0,1,4,186,57,43]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[263],te([0,1,3,48]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(C){this.service=C}listen(C,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(C,h,a){switch(h){case"checkForUpdates":return this.service.checkForUpdates(a);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(a)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=r;class _{get state(){return this._state}set state(C){this._state=C,this._onStateChange.fire(C)}constructor(C){this.channel=C,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(C){return this.channel.call("checkForUpdates",C)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(C){return this.channel.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=_}),define(ee[40],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[264],te([0,1,40,205,16,19,139,3,2]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(S){this.uri=S,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const f=new Map,y=v=>{let p=f.get(v.scheme);return p===void 0&&(p=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),f.set(v.scheme,p)),p};this._dispooables.add(C.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new _.ExtUri(y),this._canonicalUris=new M.SkipList((v,p)=>this.extUri.compare(v,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,_.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new a(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,v)=>y[1].time<v[1].time?1:y[1].time>v[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let y=0;y<f;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};e.UriIdentityService=g,e.UriIdentityService=g=Ee([Z(0,r.IFileService)],g),(0,L.registerSingleton)(I.IUriIdentityService,g,1)}),define(ee[127],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[265],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(C){this.handler=C}listen(C,h){throw new Error(`Event not found: ${h}`)}call(C,h,a){switch(h){case"handleURL":return this.handler.handleURL(I.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class r{constructor(C){this.channel=C}handleURL(C,h){return this.channel.call("handleURL",[C.toJSON(),h])}}e.URLHandlerChannelClient=r;class _{constructor(C,h){this.next=C,this.logService=h}async routeCall(C,h,a,g){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(a)&&a.length>0){const w=I.URI.revive(a[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const S=/\bwindowId=(\d+)/.exec(w.query);if(S){const f=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,w.toString(!0));const y=new RegExp(`window:${f}`),v=C.connections.find(p=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),y.test(p.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(C,h,a,g)}routeEvent(C,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=_}),define(ee[266],te([0,1,8,2,7,24]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(a,g){const w=[...this.handlers.values()];return(0,I.first)(w.map(S=>()=>S.handleURL(a,g)),void 0,!1).then(S=>S||!1)}registerHandler(a){return this.handlers.add(a),(0,L.toDisposable)(()=>this.handlers.delete(a))}}e.AbstractURLService=M;let C=class extends M{constructor(a){super(),this.productService=a}create(a){let{authority:g,path:w,query:S,fragment:f}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&w&&w.indexOf("/")!==0&&(w=`/${w}`),r.URI.from({scheme:this.productService.urlProtocol,authority:g,path:w,query:S,fragment:f})}};e.NativeURLService=C,e.NativeURLService=C=Ee([Z(0,_.IProductService)],C)}),define(ee[267],te([0,1,15,8,3,2,4,7]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h extends _.Disposable{constructor(g,w,S,f,y,v){if(super(),this.urlService=w,this.logService=v,this.uris=[],this.retryCount=0,g&&(v.trace("ElectronURLListener initialUrisToHandle:",g.map(d=>d.originalUrl)),this.uris=g),M.isWindows){const d=f.isBuilt?[]:[`"${f.appRoot}"`];d.push("--open-url","--"),I.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,d)}const p=r.Event.map(r.Event.fromNodeEventEmitter(I.app,"open-url",(d,c)=>({event:d,url:c})),({event:d,url:c})=>(d.preventDefault(),c));this._register(p(d=>{const c=this.uriFromRawUrl(d);c&&this.urlService.open(c,{originalUrl:d})})),S.getWindows().filter(d=>d.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(S.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(g){try{return C.URI.parse(g)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const w of this.uris)await this.urlService.open(w.uri,{originalUrl:w.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),g.push(w));g.length!==0&&(this.uris=g,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=h}),define(ee[268],te([0,1,3,2,16,56,31]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends L.Disposable{constructor(a,g,w,S,f,y){super(),this.fileSystemScheme=a,this.fileSystemProvider=g,this.userDataScheme=w,this.userDataProfilesService=S,this.uriIdentityService=f,this.logService=y,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new M.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(v))),this.updateAtomicReadWritesResources(),this._register(S.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(v=>this.handleFileChanges(v)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,g){return this.fileSystemProvider.open(this.toFileSystemResource(a),g)}close(a){return this.fileSystemProvider.close(a)}read(a,g,w,S,f){return this.fileSystemProvider.read(a,g,w,S,f)}write(a,g,w,S,f){return this.fileSystemProvider.write(a,g,w,S,f)}watch(a,g){this.watchResources.set(a,a);const w=this.fileSystemProvider.watch(this.toFileSystemResource(a),g);return(0,L.toDisposable)(()=>{this.watchResources.delete(a),w.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,g,w){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(g),w)}readFile(a,g){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),g)}readFileStream(a,g,w){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),g,w)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,g,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),g,w)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.fileSystemProvider.delete(this.toFileSystemResource(a),g)}copy(a,g,w){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(g),w);throw new Error("copy not supported")}cloneFile(a,g){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(g));throw new Error("clone not supported")}handleFileChanges(a){const g=[];for(const w of a){if(w.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(w.resource);this.watchResources.findSubstr(S)&&g.push({resource:S,type:w.type})}g.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(g))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(ee[269],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[271],te([0,1,15,2,13,7]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(r.Schemas.vscodeWebview,h)}handleWebviewRequest(h,a){try{const g=_.URI.parse(h.url),w=M.validWebviewFilePaths.get(g.path);if(typeof w=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${w}`,f=r.FileAccess.asFileUri(S);return a({path:f.fsPath,headers:{...r.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.WebviewProtocolProvider=M}),define(ee[59],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(g){return!!g.workspaceUri}e.isWorkspaceToOpen=L;function r(g){return!!g.folderUri}e.isFolderToOpen=r;function _(g){return!!g.fileUri}e.isFileToOpen=_;function M(g){const w=C(g),S=g.getValue("window.menuBarVisibility");return S==="default"||w==="native"&&S==="compact"||I.isMacintosh&&I.isNative?"classic":S}e.getMenuBarVisibility=M;function C(g){if(I.isWeb)return"custom";const w=g.getValue("window");if(w){if(I.isMacintosh&&w.nativeTabs===!0||I.isMacintosh&&w.nativeFullScreen===!1)return"native";const y=w.titleBarStyle;if(y==="native"||y==="custom")return y}return I.isLinux?"native":"custom"}e.getTitleBarStyle=C;function h(g){return!(!I.isWindows||I.isWeb||C(g)==="native")}e.useWindowControlsOverlay=h;function a(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=a}),define(ee[95],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(C){C[C.INITIAL=1]="INITIAL",C[C.LOAD=2]="LOAD",C[C.RELOAD=3]="RELOAD"})(I||(e.LoadReason=I={}));var L;(function(C){C[C.CLOSE=1]="CLOSE",C[C.QUIT=2]="QUIT",C[C.RELOAD=3]="RELOAD",C[C.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(C=1){return{width:1024,height:768,mode:C}};e.defaultWindowState=r;var _;(function(C){C[C.Maximized=0]="Maximized",C[C.Normal=1]="Normal",C[C.Minimized=2]="Minimized",C[C.Fullscreen=3]="Fullscreen"})(_||(e.WindowMode=_={}));var M;(function(C){C[C.UNRESPONSIVE=1]="UNRESPONSIVE",C[C.PROCESS_GONE=2]="PROCESS_GONE",C[C.LOAD=3]="LOAD"})(M||(e.WindowError=M={}))}),define(ee[272],te([0,1,8,3,2]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends r.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:h,getActiveWindowId:a}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(C,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>a()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ee[29],te([0,1,190,9,56,19,7,6,13]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=a;function g(i){return typeof i?.id=="string"&&!a(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=g,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=w;function S(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=v;function p(i){const n=i;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=p;class m{constructor(n,o,b,D,R){this._id=n,this._transient=b,this._configuration=D,this._ignorePathCasing=R,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class d{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,_.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function c(i){return new d({uri:i,index:0,name:(0,_.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,n){return _.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function u(i){let n;return M.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=u,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function l(i,n){return!E(i,n)&&!u(i)}e.isSavedWorkspace=l;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,_.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ee[60],te([0,1,15,8,55,46,2,84,4,21,165,115,6,5,24,29]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let p=class{constructor(d,c){this.logService=d,this.productService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(d,c){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},c)}pickFolder(d,c){return this.doPick({...d,pickFolders:!0,title:(0,g.localize)(1,null)},c)}pickFile(d,c){return this.doPick({...d,pickFiles:!0,title:(0,g.localize)(2,null)},c)}pickWorkspace(d,c){const E=(0,g.localize)(3,null),u=(0,_.mnemonicButtonLabel)((0,g.localize)(4,null)),t=v.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:E,filters:t,buttonLabel:u},c)}async doPick(d,c){const E={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(E.properties=void 0,d.pickFiles&&d.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,(c||I.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(d){if(d){let c=this.windowDialogQueues.get(d.id);return c||(c=new L.Queue,this.windowDialogQueues.set(d.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(d,c){return this.getWindowDialogQueue(c).queue(async()=>{const{options:E,buttonIndeces:u}=(0,w.massageMessageBoxOptions)(d,this.productService);let t;return c?t=await I.dialog.showMessageBox(c,E):t=await I.dialog.showMessageBox(E),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(d,c){const E=this.acquireFileDialogLock(d,c);if(!E)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(c).queue(async()=>{let u;return c?u=await I.dialog.showSaveDialog(c,d):u=await I.dialog.showSaveDialog(d),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,M.dispose)(E)}}normalizePath(d){return d&&h.isMacintosh&&(d=(0,C.normalizeNFC)(d)),d}normalizePaths(d){return d.map(c=>this.normalizePath(c))}async showOpenDialog(d,c){d.defaultPath&&(await a.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const E=this.acquireFileDialogLock(d,c);if(!E)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(c).queue(async()=>{let u;return c?u=await I.dialog.showOpenDialog(c,d):u=await I.dialog.showOpenDialog(d),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,M.dispose)(E)}}acquireFileDialogLock(d,c){if(!c)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let E=this.windowFileDialogLocks.get(c.id);E||(E=new Set,this.windowFileDialogLocks.set(c.id,E));const u=(0,r.hash)(d);if(!E.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),E.add(u),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),E?.delete(u),E?.size===0&&this.windowFileDialogLocks.delete(c.id)})}};e.DialogMainService=p,e.DialogMainService=p=Ee([Z(0,f.ILogService),Z(1,y.IProductService)],p)}),define(ee[273],te([0,1,3,2,74,29]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(h,a){super(),this.logService=h,this.storageMainService=a,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(a.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,a){this._register(I.Event.debounce(h.onDidChangeStorage,(g,w)=>(g?g.push(w):g=[w],g),M.STORAGE_CHANGE_DEBOUNCE_TIME)(g=>{g.length&&a.fire(this.serializeStorageChangeEvents(g,h))}))}serializeStorageChangeEvents(h,a){const g=new Map,w=new Set;return h.forEach(S=>{const f=a.get(S.key);typeof f=="string"?g.set(S.key,f):w.add(S.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(h,a,g){switch(a){case"onDidChangeStorage":{const w=g.profile?(0,r.revive)(g.profile):void 0;if(!w)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(w.id);return S||(S=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(w),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(w.id,S)),S.event}}throw new Error(`Event not found: ${a}`)}async call(h,a,g){const w=g.profile?(0,r.revive)(g.profile):void 0,S=(0,_.reviveIdentifier)(g.workspace),f=await this.withStorageInitialized(w,S);switch(a){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=g;if(y.insert)for(const[v,p]of y.insert)f.set(v,p);y.delete?.forEach(v=>f.delete(v));break}case"optimize":return f.optimize();case"isUsed":{const y=g.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async withStorageInitialized(h,a){let g;a?g=this.storageMainService.workspaceStorage(a):h?g=this.storageMainService.profileStorage(h):g=this.storageMainService.applicationStorage;try{await g.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${a?"workspace":h?"profile":"application"} storage due to ${w}`)}return g}}e.StorageDatabaseChannel=M}),define(ee[41],te([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,27,12]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&M.URI.isUri(n.location)&&M.URI.isUri(n.globalStorageHome)&&M.URI.isUri(n.settingsResource)&&M.URI.isUri(n.keybindingsResource)&&M.URI.isUri(n.tasksResource)&&M.URI.isUri(n.snippetsHome)&&M.URI.isUri(n.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,g.createDecorator)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:M.URI.revive(i.location).with({scheme:n}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:M.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:M.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=u;function t(i,n,o,b,D,R){return{id:i,name:n,location:o,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:R&&D?.useDefaultFlags?.globalState?R.globalStorageHome:(0,_.joinPath)(o,"globalStorage"),settingsResource:R&&D?.useDefaultFlags?.settings?R.settingsResource:(0,_.joinPath)(o,"settings.json"),keybindingsResource:R&&D?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,_.joinPath)(o,"keybindings.json"),tasksResource:R&&D?.useDefaultFlags?.tasks?R.tasksResource:(0,_.joinPath)(o,"tasks.json"),snippetsHome:R&&D?.useDefaultFlags?.snippets?R.snippetsHome:(0,_.joinPath)(o,"snippets"),extensionsResource:R&&D?.useDefaultFlags?.extensions?R.extensionsResource:(0,_.joinPath)(o,"extensions.json"),cacheHome:(0,_.joinPath)(b,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let l=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,b,D){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=b,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,_.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,_.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const R of this.getStoredProfiles()){if(!R.name||!(0,d.isString)(R.name)||!R.location){this.logService.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(t((0,_.basename)(R.location),R.name,R.location,this.profilesCacheHome,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.logService.error(R)}const b=new f.ResourceMap,D=new Map;if(o.length)try{const R=this.getStoredProfileAssociations();if(R.workspaces)for(const[P,k]of Object.entries(R.workspaces)){const O=M.URI.parse(P),F=o.find($=>$.id===k);F&&b.set(O,F)}if(R.emptyWindows)for(const[P,k]of Object.entries(R.emptyWindows)){const O=o.find(F=>F.id===k);O&&D.set(P,O)}}catch(R){this.logService.error(R)}this._profilesObject={profiles:o,workspaces:b,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,C.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",b=new RegExp(`${(0,m.escapeRegExpCharacters)(o)}\\s(\\d+)`);let D=0;for(const P of this.profiles){const k=b.exec(P.name),O=k?parseInt(k[1]):0;D=O>D?O:D}const R=`${o} ${D+1}`;return this.createProfile((0,I.hash)((0,p.generateUuid)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,b){return this.createProfile((0,I.hash)((0,p.generateUuid)()).toString(16),n,o,b)}async createProfile(n,o,b,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const R=await this.doCreateProfile(n,o,b);return D&&await this.setProfileForWorkspace(D,R),R}async doCreateProfile(n,o,b){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(o);return D||(D=(async()=>{try{const R=this.profiles.find(O=>O.name===o||O.id===n);if(R)return R;const P=t(n,o,(0,_.joinPath)(this.profilesHome,n),this.profilesCacheHome,b,this.defaultProfile);await this.fileService.createFolder(P.location);const k=[];return this._onWillCreateProfile.fire({profile:P,join(O){k.push(O)}}),await v.Promises.settled(k),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,D)),D}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(D=>D.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,o.name??b.name,b.location,this.profilesCacheHome,{shortName:o.shortName??b.shortName,icon:o.icon===null?void 0:o.icon??b.icon,transient:o.transient??b.isTransient,useDefaultFlags:o.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[b]),b}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(D=>D.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this._onWillRemoveProfile.fire({profile:o,join(D){b.push(D)}});try{await Promise.allSettled(b)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(D){(0,a.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(D=>D.id===o.id);if(!b)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,b)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(b=>!this.uriIdentityService.extUri.isEqual(b.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return M.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,b){const D=[...this.profiles,...n],R=[];this.transientProfilesObject.profiles=[];for(let P of D)P.isDefault||o.some(k=>P.id===k.id)||(P=b.find(k=>P.id===k.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):R.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(R),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,b)}triggerProfilesChanges(n,o,b){this._onDidChangeProfiles.fire({added:n,removed:o,updated:b,all:this.profiles})}updateWorkspaceAssociation(n,o,b){b=o?.isTransient?!0:b,b||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),R=b?this.transientProfilesObject:this.profilesObject;M.URI.isUri(D)?(R.workspaces.delete(D),o&&R.workspaces.set(D,o)):(R.emptyWindows.delete(D),o&&R.emptyWindows.set(D,o)),b||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[b,D]of this.profilesObject.workspaces.entries())n[b.toString()]=D.id;const o={};for(const[b,D]of this.profilesObject.emptyWindows.entries())o[b.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},b=this.createDefaultProfile();if(n.workspaces)for(const[R,P]of Object.entries(n.workspaces)){const k=M.URI.parse(P);o[R]=this.uriIdentityService.extUri.isEqual(k,b.location)?b.id:this.uriIdentityService.extUri.basename(k)}const D={};if(n.emptyWindows)for(const[R,P]of Object.entries(n.emptyWindows)){const k=M.URI.parse(P);D[R]=this.uriIdentityService.extUri.isEqual(k,b.location)?b.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:o,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=l,e.UserDataProfilesService=l=Ee([Z(0,h.IEnvironmentService),Z(1,a.IFileService),Z(2,y.IUriIdentityService),Z(3,w.ILogService)],l);class s extends l{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ee[79],te([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class c extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=c,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let E=class extends r.Disposable{constructor(s,i,n,o,b,D){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=b,this.logService=D,this._onAddExtensions=this._register(new _.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new _.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new _.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new _.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i){const n=[],o=[];try{return await this.withProfileExtensions(i,b=>{const D=[];for(const R of b)s.some(([P])=>(0,a.areSameExtensions)(P.identifier,R.identifier)&&P.manifest.version!==R.version)?n.push(R):D.push(R);for(const[R,P]of s){const k=D.findIndex(F=>(0,a.areSameExtensions)(F.identifier,R.identifier)&&F.version===R.manifest.version),O={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:P};k===-1?(o.push(O),D.push(O)):D.splice(k,1,O)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),D}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),o}catch(b){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:b,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(s,i){const n=[];return await this.withProfileExtensions(i,o=>{const b=[];for(const D of o){const R=s.find(([P])=>(0,a.areSameExtensions)(P.identifier,D.identifier)&&P.manifest.version===D.version);R&&(D.metadata={...D.metadata,...R[1]},n.push(D)),b.push(D)}return b}),n}async removeExtensionFromProfile(s,i){const n=[];try{await this.withProfileExtensions(i,o=>{const b=[];for(const D of o)(0,a.areSameExtensions)(D.identifier,s.identifier)?n.push(D):b.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),b}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:i}),o}}async withProfileExtensions(s,i,n){return this.getResourceAccessQueue(s).queue(async()=>{let o=[],b;try{const D=await this.fileService.readFile(s);b=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,g.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(b=await this.migrateFromOldDefaultProfileExtensionsLocation()),!b&&n?.bailOutWhenFileNotFound)throw new c((0,p.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.reportAndThrowInvalidConentError(s);let D=!1;for(const R of b){u(R)||this.reportAndThrowInvalidConentError(s);let P;if((0,v.isString)(R.relativeLocation)&&R.relativeLocation)P=this.resolveExtensionLocation(R.relativeLocation);else if((0,v.isString)(R.location))P=this.resolveExtensionLocation(R.location),D=!0,R.relativeLocation=R.location,R.location=P.toJSON();else{P=C.URI.revive(R.location);const k=this.toRelativePath(P);k&&(D=!0,R.relativeLocation=k)}o.push({identifier:R.identifier,location:P,version:R.version,metadata:R.metadata})}D&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(b)))}if(i){o=i(o);const D=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(D)))}return o})}reportAndThrowInvalidConentError(s){const i=new c(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(b){if((0,g.toFileOperationResult)(b)===1)return;throw b}this.logService.info("Migrating extensions from old default profile location",s.toString());let o;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(D=>u(D))?o=b:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.logService.error(b)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(b){if((0,g.toFileOperationResult)(b)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw b}try{await this.fileService.del(s)}catch(b){(0,g.toFileOperationResult)(b)!==1&&this.logService.error(b)}try{await this.fileService.del(i)}catch(b){(0,g.toFileOperationResult)(b)!==1&&this.logService.error(b)}return o})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new I.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=Ee([Z(1,g.IFileService),Z(2,f.IUserDataProfilesService),Z(3,y.IUriIdentityService),Z(4,m.ITelemetryService),Z(5,S.ILogService)],E);function u(l){return(0,v.isObject)(l)&&(0,h.isIExtensionIdentifier)(l.identifier)&&(t(l.location)||(0,v.isString)(l.location)&&l.location)&&((0,v.isUndefined)(l.relativeLocation)||(0,v.isString)(l.relativeLocation))&&l.version&&(0,v.isString)(l.version)}function t(l){return l?(0,v.isString)(l.path)&&(0,v.isString)(l.scheme):!1}}),define(ee[128],te([0,1,23,8,37,18,14,44,150,2,13,9,4,19,203,71,12,7,170,36,123,120,202,16,6,5,24,3,74,79,41,40,201]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(se){function G(V,x){if(V===x)return!0;const W=Object.keys(V),U=new Set;for(const H of Object.keys(x))U.add(H);if(W.length!==U.size)return!1;for(const H of W){if(V[H]!==x[H])return!1;U.delete(H)}return U.size===0}se.equals=G})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let F=class extends a.Disposable{constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=V,this.extensionsControlLocation=x,this.currentProfile=W,this.userDataProfilesService=U,this.extensionsProfileScannerService=H,this.fileService=Q,this.logService=ie,this.environmentService=oe,this.productService=N,this.uriIdentityService=A,this.instantiationService=T,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,V,x){const[W,U]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(V)]),H=x?await this.scanExtensionsUnderDevelopment(G,[...W,...U]):[];return this.dedupExtensions(W,U,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const V=[];V.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),V.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,W]=await Promise.all(V);return this.applyScanOptions([...x,...W],0,G,!1)}async scanUserExtensions(G){const V=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",V);const x=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(V,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,x),U=G.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await U.scanExtensions(W)}catch(Q){if(Q instanceof D.ExtensionsProfileScanningError&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),H=await U.scanExtensions(W);else throw Q}return H=await this.applyScanOptions(H,1,G,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(G,V){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===g.Schemas.file).map(async W=>{const U=await this.createExtensionScannerInput(W,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(Q=>(Q.type=V.find(ie=>(0,E.areSameExtensions)(ie.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,U)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,V,x){const W=await this.createExtensionScannerInput(G,!1,V,!0,x.language,!0,void 0),U=await this.extensionsScanner.scanExtension(W);return!U||!x.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(G,V,x){const W=await this.createExtensionScannerInput(G,!1,V,!0,x.language,!0,void 0),U=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(U,V,x,!0)}async scanMetadata(G){const V=(0,f.joinPath)(G,"package.json"),x=(await this.fileService.readFile(V)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,V){const x=(0,f.joinPath)(G,"package.json"),W=(await this.fileService.readFile(x)).value.toString(),U=JSON.parse(W);V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,U.__metadata={...U.__metadata,...V},await this.fileService.writeFile((0,f.joinPath)(G,"package.json"),_.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof D.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(V=>[V,V.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify([])))}catch(V){(0,l.toFileOperationResult)(V)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(V))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,V,x,W){return x.includeAllVersions||(G=this.dedupExtensions(V===0?G:void 0,V===1?G:void 0,V==="development"?G:void 0,await this.getTargetPlatform(),W)),x.includeInvalid||(G=G.filter(U=>U.isValid)),G.sort((U,H)=>{const Q=w.basename(U.location.fsPath),ie=w.basename(H.location.fsPath);return Q<ie?-1:Q>ie?1:0})}dedupExtensions(G,V,x,W,U){const H=(ie,oe,N)=>{if(ie.isValid&&!oe.isValid)return!1;if(ie.isValid===oe.isValid){if(U&&y.gt(ie.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(y.eq(ie.manifest.version,oe.manifest.version)){if(ie.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===W)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`),!0},Q=new u.ExtensionIdentifierMap;return G?.forEach(ie=>{const oe=Q.get(ie.identifier.id);(!oe||H(oe,ie,!1))&&Q.set(ie.identifier.id,ie)}),V?.forEach(ie=>{const oe=Q.get(ie.identifier.id);if(!oe&&G&&ie.type===0){this.logService.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!oe||H(oe,ie,!1))&&Q.set(ie.identifier.id,ie)}),x?.forEach(ie=>{const oe=Q.get(ie.identifier.id);(!oe||H(oe,ie,!0))&&Q.set(ie.identifier.id,ie),Q.set(ie.identifier.id,ie)}),[...Q.values()]}async scanDefaultSystemExtensions(G,V){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0),U=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(G,V){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=V?await this.getBuiltInExtensionControl():{},U=[],H=m.URI.file(w.normalize(w.join(g.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of x){const oe=W[ie.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":U.push((0,f.joinPath)(H,ie.name));break;default:U.push(m.URI.file(oe));break}}const Q=await Promise.all(U.map(async ie=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ie,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,I.coalesce)(Q)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,V,x,W,U,H,Q){const ie=await this.getTranslations(U??S.language),oe=await this.getMtime(G),N=V&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,A=N?await this.getMtime(N):void 0;return new $(G,oe,N,A,V,Q,x,W,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,ie)}async getMtime(G){try{const V=await this.fileService.stat(G);if(typeof V.mtime=="number")return V.mtime}catch{}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Ee([Z(4,R.IUserDataProfilesService),Z(5,D.IExtensionsProfileScannerService),Z(6,l.IFileService),Z(7,i.ILogService),Z(8,c.IEnvironmentService),Z(9,n.IProductService),Z(10,P.IUriIdentityService),Z(11,s.IInstantiationService)],F);class ${constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T,q,B,z){this.location=G,this.mtime=V,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=W,this.profile=U,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=ie,this.validate=oe,this.productVersion=N,this.productDate=A,this.productCommit=T,this.devMode=q,this.language=B,this.translations=z}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,V){return(0,f.isEqual)(G.location,V.location)&&G.mtime===V.mtime&&(0,f.isEqual)(G.applicationExtensionslocation,V.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&G.profile===V.profile&&r.equals(G.profileScanOptions,V.profileScanOptions)&&G.type===V.type&&G.excludeObsolete===V.excludeObsolete&&G.validate===V.validate&&G.productVersion===V.productVersion&&G.productDate===V.productDate&&G.productCommit===V.productCommit&&G.devMode===V.devMode&&G.language===V.language&&O.equals(G.translations,V.translations)}}e.ExtensionScannerInput=$;let re=class extends a.Disposable{constructor(G,V,x,W,U){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=V,this.uriIdentityService=x,this.fileService=W,this.logService=U}async scanExtensions(G){const V=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(W)}catch{}return(0,p.isEmptyObject)(x)?V:V.filter(W=>!x[E.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(G){const V=await this.fileService.resolve(G.location);if(!V.children?.length)return[];const x=await Promise.all(V.children.map(async W=>{if(!W.isDirectory||G.type===1&&(0,f.basename)(W.resource).indexOf(".")===0)return null;const U=new $(W.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(U)}));return(0,I.coalesce)(x).sort((W,U)=>W.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(G){let V=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){V=V.filter(W=>!W.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,G);V.push(...x)}return V}async scanExtensionsFromProfileResource(G,V,x){const W=await this.extensionsProfileScannerService.scanProfileExtensions(G,x.profileScanOptions);if(!W.length)return[];const U=await Promise.all(W.map(async H=>{if(V(H)){const Q=new $(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,I.coalesce)(U)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,f.joinPath)(G.location,"package.json"))){const V=await this.scanExtension(G);return V?[V]:[]}else return await this.scanExtensions(G)}catch(V){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,M.getErrorMessage)(V)),[]}}async scanExtension(G,V){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=u.UNDEFINED_PUBLISHER),V=V??x.__metadata,delete x.__metadata;const W=(0,E.getGalleryExtensionId)(x.publisher,x.name),U=V?.id?{id:W,uuid:V.id}:{id:W},H=V?.isSystem?0:G.type,Q=H===0||!!V?.isBuiltin;x=await this.translateManifest(G.location,x,$.createNlsConfiguration(G));const ie={type:H,identifier:U,manifest:x,location:G.location,isBuiltin:Q,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return G.validate?this.validate(ie,G):ie}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,V){let x=!0;const W=(0,t.validateExtensionManifest)(V.productVersion,V.productDate,V.location,G.manifest,G.isBuiltin);for(const[U,H]of W)U===v.default.Error&&(x=!1,this.logService.error(this.formatMessage(V.location,H)));return G.isValid=x,G.validations=W,G}async scanExtensionManifest(G){const V=(0,f.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(V)).value.toString()}catch(U){return(0,l.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(G,(0,d.localize)(0,null,V.path,U.message))),null}let W;try{W=JSON.parse(x)}catch{const H=[];(0,C.parse)(x,H);for(const Q of H)this.logService.error(this.formatMessage(G,(0,d.localize)(1,null,V.path,Q.offset,Q.length,(0,h.getParseErrorMessage)(Q.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(G,(0,d.localize)(2,null,V.path))),null):W}async translateManifest(G,V,x){const W=await this.getLocalizedMessages(G,V,x);if(W)try{const U=[],H=await this.resolveOriginalMessageBundle(W.default,U);if(U.length>0)return U.forEach(ie=>{this.logService.error(this.formatMessage(G,(0,d.localize)(3,null,W.default?.path,(0,h.getParseErrorMessage)(ie.error))))}),V;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(G,(0,d.localize)(4,null,W.default?.path))),V;const Q=W.values||Object.create(null);return(0,k.localizeManifest)(this.logService,V,Q,H)}catch{}return V}async getLocalizedMessages(G,V,x){const W=(0,f.joinPath)(G,"package.nls.json"),U=(oe,N)=>{N.forEach(A=>{this.logService.error(this.formatMessage(G,(0,d.localize)(5,null,oe?.path,(0,h.getParseErrorMessage)(A.error))))})},H=oe=>{this.logService.error(this.formatMessage(G,(0,d.localize)(6,null,oe?.path)))},Q=`${V.publisher}.${V.name}`,ie=x.translations[Q];if(ie)try{const oe=m.URI.file(ie),N=(await this.fileService.readFile(oe)).value.toString(),A=[],T=(0,C.parse)(N,A);return A.length>0?(U(oe,A),{values:void 0,default:W}):(0,C.getNodeType)(T)!=="object"?(H(oe),{values:void 0,default:W}):{values:T.contents?T.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let N;try{N=await this.findMessageBundles(G,x)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const A=(await this.fileService.readFile(N.localized)).value.toString(),T=[],q=(0,C.parse)(A,T);return T.length>0?(U(N.localized,T),{values:void 0,default:N.original}):(0,C.getNodeType)(q)!=="object"?(H(N.localized),{values:void 0,default:N.original}):{values:q,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(G,V){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,C.parse)(x,V)}catch{}}findMessageBundles(G,V){return new Promise((x,W)=>{const U=H=>{const Q=(0,f.joinPath)(G,`package.nls.${H}.json`);this.fileService.exists(Q).then(ie=>{ie&&x({localized:Q,original:(0,f.joinPath)(G,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?x({localized:(0,f.joinPath)(G,"package.nls.json"),original:null}):(H=H.substring(0,oe),U(H))})};if(V.devMode||V.pseudo||!V.language)return x({localized:(0,f.joinPath)(G,"package.nls.json"),original:null});U(V.language)})}formatMessage(G,V){return`[${G.path}]: ${V}`}};re=Ee([Z(1,D.IExtensionsProfileScannerService),Z(2,P.IUriIdentityService),Z(3,l.IFileService),Z(4,i.ILogService)],re);let J=class extends re{constructor(G,V,x,W,U,H,Q){super(V,W,U,H,Q),this.currentProfile=G,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const V=this.getCacheFile(G),x=await this.readExtensionCache(V);if(this.input=G,x&&x.input&&$.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(U=>(U.location=m.URI.revive(U.location),U));const W=await super.scanExtensions(G);return await this.writeExtensionCache(V,{input:G,result:W}),W}async readExtensionCache(G){try{const V=await this.fileService.readFile(G),x=JSON.parse(V.value.toString());return{result:x.result,input:(0,b.revive)(x.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",G.path,(0,M.getErrorMessage)(V))}return null}async writeExtensionCache(G,V){try{await this.fileService.writeFile(G,_.VSBuffer.fromString(JSON.stringify(V)))}catch(x){this.logService.debug("Error while writing the extension cache file:",G.path,(0,M.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),V=await this.readExtensionCache(G);if(!V)return;const x=V.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,x))try{this.logService.info("Invalidating Cache",x,W),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(U){this.logService.error(U)}}getCacheFile(G){const V=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(V.cacheHome,G.type===0?u.BUILTIN_MANIFEST_CACHE_FILE:u.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(V=>this.uriIdentityService.extUri.isEqual(G.location,V.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};J=Ee([Z(2,R.IUserDataProfilesService),Z(3,D.IExtensionsProfileScannerService),Z(4,P.IUriIdentityService),Z(5,l.IFileService),Z(6,i.ILogService)],J);function ae(se,G){const V=(0,E.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:V,identifier:new u.ExtensionIdentifier(V),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:G,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=ae;class ne extends F{constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T){super(G,V,(0,f.joinPath)(x,".vscode-oss-dev","extensions","control.json"),W,U,H,Q,ie,oe,N,A,T),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const q=await this.fileService.readFile(m.URI.file(S.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=ne}),define(ee[274],te([0,1,5,41,40,26,79,16,36,7]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let g=class extends M.AbstractExtensionsProfileScannerService{constructor(S,f,y,v,p,m){super(a.URI.file(S.extensionsPath),f,y,v,p,m)}};e.ExtensionsProfileScannerService=g,e.ExtensionsProfileScannerService=g=Ee([Z(0,h.INativeEnvironmentService),Z(1,C.IFileService),Z(2,L.IUserDataProfilesService),Z(3,r.IUriIdentityService),Z(4,_.ITelemetryService),Z(5,I.ILogService)],g)}),define(ee[275],te([0,1,7,36,79,128,16,6,5,24,40,41]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends _.NativeExtensionsScannerService{constructor(y,v,p,m,d,c,E,u){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,y.defaultProfile,y,v,p,m,d,c,E,u)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=Ee([Z(0,w.IUserDataProfilesService),Z(1,r.IExtensionsProfileScannerService),Z(2,M.IFileService),Z(3,h.ILogService),Z(4,L.INativeEnvironmentService),Z(5,a.IProductService),Z(6,g.IUriIdentityService),Z(7,C.IInstantiationService)],S)}),define(ee[276],te([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends L.Disposable{constructor(p,m,d){super(),this.environmentService=p,this.logService=d,this.validRoots=C.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:p}=I.session;p.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(m,d)=>this.handleResourceRequest(m,d)),p.protocol.interceptFileProtocol(r.Schemas.file,(m,d)=>this.handleFileRequest(m,d)),this._register((0,L.toDisposable)(()=>{p.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(p){const m=(0,_.normalize)(p);return this.validRoots.get(m)?L.Disposable.None:(this.validRoots.set(m,!0),(0,L.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(p,m){const d=h.URI.parse(p.url);return this.logService.error(`Refused to load resource ${d.fsPath} from ${r.Schemas.file}: protocol (original URL: ${p.url})`),m({error:-3})}handleResourceRequest(p,m){const d=this.requestToNormalizedFilePath(p);let c;return this.environmentService.crossOriginIsolated&&((0,_.basename)(d)==="workbench.html"||(0,_.basename)(d)==="workbench-dev.html"?c=r.COI.CoopAndCoep:c=r.COI.getHeadersFromQuery(p.url)),this.validRoots.findSubstr(d)?m({path:d,headers:c}):this.validExtensions.has((0,_.extname)(d).toLowerCase())?m({path:d}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),m({error:-3}))}requestToNormalizedFilePath(p){const m=h.URI.parse(p.url),d=r.FileAccess.uriToFileUri(m);return(0,_.normalize)(d.fsPath)}createIPCObjectUrl(){let p;const m=h.URI.from({scheme:"vscode",path:(0,a.generateUuid)()}),d=m.toString(),c=async()=>p;return g.validatedIpcMain.handle(d,c),this.logService.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:m,update:E=>p=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${d}.`),g.validatedIpcMain.removeHandler(d)}}}};e.ProtocolMainService=y,e.ProtocolMainService=y=Ee([Z(0,w.INativeEnvironmentService),Z(1,f.IUserDataProfilesService),Z(2,S.ILogService)],y)}),define(ee[96],te([0,1,8,3,2,65,12,111,6,41]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var g;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var S;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function f(d){const c=d.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=f;class y extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,E,u){return L.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(E===void 0||t.key===E),u)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,E){const{key:u,external:t}=E;if(u===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:u,target:this.getKeyTargets(c)[u],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,E,u){return this.getStorage(E)?.get(c,u)}getBoolean(c,E,u){return this.getStorage(E)?.getBoolean(c,u)}getNumber(c,E,u){return this.getStorage(E)?.getNumber(c,u)}getObject(c,E,u){return this.getStorage(E)?.getObject(c,u)}storeAll(c,E){this.withPausedEmitters(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,E)})}store(c,E,u,t,l=!1){if((0,M.isUndefinedOrNull)(E)){this.remove(c,u,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,u,t),this.getStorage(u)?.set(c,E,l)})}remove(c,E,u=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,E,void 0),this.getStorage(E)?.delete(c,u)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,E){const u=[],t=this.getKeyTargets(c);for(const l of Object.keys(t))t[l]===E&&u.push(l);return u}updateKeyTarget(c,E,u,t=!1){const l=this.getKeyTargets(E);typeof u=="number"?l[c]!==u&&(l[c]=u,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(l),t)):typeof l[c]=="number"&&(delete l[c],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(l),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const E=this.getStorage(c);return E?f(E):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=g.NONE){this._onWillSaveState.fire({reason:c});const E=this.getStorage(-1),u=this.getStorage(0),t=this.getStorage(1);switch(c){case g.NONE:await I.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await I.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return m(c,E,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,E){return this.emitWillSaveState(g.NONE),(0,a.isUserDataProfile)(c)?this.switchToProfile(c,E):this.switchToWorkspace(c,E)}canSwitchProfile(c,E){return!(c.id===E.id||v(E)&&v(c))}switchData(c,E,u){this.withPausedEmitters(()=>{const t=new Set;for(const[l,s]of c)t.add(l),E.get(l)!==s&&this.emitDidChangeValue(u,{key:l,external:!0});for(const[l]of E.items)t.has(l)||this.emitDidChangeValue(u,{key:l,external:!0})})}}e.AbstractStorageService=y;function v(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=v;class p extends y{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=p;async function m(d,c,E,u,t,l){const s=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,n=new Map;d.forEach((O,F)=>{i.set(F,O),n.set(F,s(O))});const o=new Map,b=new Map;c.forEach((O,F)=>{o.set(F,O),b.set(F,s(O))});const D=new Map,R=new Map;E.forEach((O,F)=>{D.set(F,O),R.set(F,s(O))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const P=[];if(i.forEach((O,F)=>{P.push({key:F,value:O})}),console.table(P),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];o.forEach((F,$)=>{O.push({key:$,value:F})}),console.table(O),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${l})`);const k=[];D.forEach((O,F)=>{k.push({key:F,value:O})}),console.table(k),console.groupEnd(),console.log(R)}e.logStorage=m}),define(ee[277],te([0,1,23,8,3,2,9,70,7,21,111,159,5,96,26,29,13]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends _.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=g.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===g.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const i=s.getBoolean(f.IS_NEW_KEY);i===void 0?s.set(f.IS_NEW_KEY,!0):i&&s.set(f.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=g.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new C.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([o,b])=>({key:o,length:b.length})),(o,b)=>b.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=g.StorageState.Closed,await this._storage.close()}}class d extends m{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,d.STORAGE_NAME)}constructor(s,i,n,o){super(n,o),this.profile=s,this.options=i}async doCreate(){return new g.Storage(new w.SQLiteStorageDatabase(this.path??w.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class c extends d{constructor(s,i,n,o){super(s,i,n,o)}}e.ProfileStorageMain=c;class E extends d{constructor(s,i,n,o){super(i.defaultProfile,s,n,o)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(y.firstSessionDateStorageKey,void 0)===void 0&&s.set(y.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();s.set(y.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=E;class u extends m{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}constructor(s,i,n,o,b){super(n,b),this.workspace=s,this.options=i,this.environmentService=o}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new g.Storage(new w.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:i?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:w.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.workspace.id),i=(0,M.join)(s,u.WORKSPACE_STORAGE_NAME);return await a.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await a.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,M.join)(s,u.WORKSPACE_META_NAME);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u;class t extends m{get path(){}async doCreate(){return new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(ee[278],te([0,1,3,2,96]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class _ extends L.Disposable{constructor(C,h,a){super(),this.storageMainService=C,this.userDataProfilesService=h,this.logService=a;const g=this._register(new L.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onWillAddFirstListener:()=>g.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>g.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const C=new L.DisposableStore;return C.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,a)=>(h?h.push(a.key):h=[a.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),C.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,a)=>{h||(h=new Map);let g=h.get(a.profile.id);return g||h.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),h},100)(h=>this.onDidChangeProfileStorage(h))),C}onDidChangeApplicationStorage(C){const h=C.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],a=[];if(C=C.filter(g=>g!==r.TARGET_KEY),C.length){const g=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);a.push({profile:this.userDataProfilesService.defaultProfile,changes:C.map(w=>({key:w,scope:0,target:g[w]}))})}this.triggerEvents(h,a)}onDidChangeProfileStorage(C){const h=[],a=new Map;for(const[g,w]of C.entries()){w.keys.includes(r.TARGET_KEY)&&h.push(w.profile);const S=w.keys.filter(f=>f!==r.TARGET_KEY);if(S.length){const f=(0,r.loadKeyTargets)(w.storage.storage);a.set(g,{profile:w.profile,changes:S.map(y=>({key:y,scope:0,target:f[y]}))})}}this.triggerEvents(h,[...a.values()])}triggerEvents(C,h){(C.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:C})}listen(C,h,a){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${h}`)}async call(C,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=_}),define(ee[279],te([0,1,7,36,16,5,34,40,41,12,121]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";var w,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let f=class extends h.UserDataProfilesService{static{w=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(m,d,c,E,u){super(c,E,d,u),this.stateReadonlyService=m,this.nativeEnvironmentService=c}getStoredProfiles(){return this.stateReadonlyService.getItem(w.PROFILES_KEY,[]).map(d=>({...d,location:(0,a.isString)(d.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,d.location):I.URI.revive(d.location)}))}getStoredProfileAssociations(){const m=this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?m:this.migrateStoredProfileAssociations(m)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=f,e.UserDataProfilesReadonlyService=f=w=Ee([Z(0,M.IStateReadService),Z(1,C.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,r.IFileService),Z(4,_.ILogService)],f);let y=S=class extends f{constructor(m,d,c,E,u){super(m,d,c,E,u),this.stateService=m}saveStoredProfiles(m){m.length?this.stateService.setItem(S.PROFILES_KEY,m.map(d=>({...d,location:this.uriIdentityService.extUri.basename(d.location)}))):this.stateService.removeItem(S.PROFILES_KEY)}getStoredProfiles(){const m=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(m),this.stateService.setItem("userDataProfilesMigration",!0)),m}saveStoredProfileAssociations(m){m.emptyWindows||m.workspaces?this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,m):this.stateService.removeItem(S.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",d=this.stateService.getItem(m,void 0);if(d){this.stateService.removeItem(m);const E=d.reduce((u,{workspace:t,profile:l})=>(u[I.URI.revive(t).toString()]=I.URI.revive(l).toString(),u),{});this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const c=super.getStoredProfileAssociations();return this.stateService.getItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(c),this.stateService.setItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),c}};e.UserDataProfilesService=y,e.UserDataProfilesService=y=S=Ee([Z(0,M.IStateService),Z(1,C.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,r.IFileService),Z(4,_.ILogService)],y);let v=class extends y{constructor(m,d,c,E){super(new g.StateService(0,d,E,c),m,d,c,E)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=v,e.ServerUserDataProfilesService=v=Ee([Z(0,C.IUriIdentityService),Z(1,L.INativeEnvironmentService),Z(2,r.IFileService),Z(3,_.ILogService)],v)}),define(ee[52],te([0,1,36,16,6,5,40,41,279,34]),function(K,e,I,L,r,_,M,C,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(C.IUserDataProfilesService);let g=class extends h.UserDataProfilesService{constructor(S,f,y,v,p){super(S,f,y,v,p)}getAssociatedEmptyWindows(){const S=[];for(const f of this.profilesObject.emptyWindows.keys())S.push({id:f});return S}};e.UserDataProfilesMainService=g,e.UserDataProfilesMainService=g=Ee([Z(0,a.IStateService),Z(1,M.IUriIdentityService),Z(2,I.INativeEnvironmentService),Z(3,L.IFileService),Z(4,_.ILogService)],g)}),define(ee[129],te([0,1,19,7,29]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function _(h,a,g){for(const S of h){const f=S.openedWorkspace;if((0,r.isWorkspaceIdentifier)(f)){const y=await g(f);if(y){if(y.folders.some(v=>I.extUriBiasedIgnorePathCase.isEqualOrParent(a,v.uri)))return S}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(a,f.configPath))return S}}const w=h.filter(S=>(0,r.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(a,S.openedWorkspace.uri));if(w.length)return w.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=_;function M(h,a){for(const g of h)if((0,r.isWorkspaceIdentifier)(g.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.configPath,a)||(0,r.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.uri,a))return g}e.findWindowOnWorkspaceOrFolder=M;function C(h,a){const g=w=>a.some(S=>I.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(w)));for(const w of h)if(w.config?.extensionDevelopmentPath?.some(S=>g(S)))return w}e.findWindowOnExtensionDevelopmentPath=C}),define(ee[97],te([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function y(R){return R.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function v(R){return R.hasOwnProperty("folderUri")}e.isRecentFolder=v;function p(R){return R.hasOwnProperty("fileUri")}e.isRecentFile=p;function m(R){return d(R)||c(R)}e.isStoredWorkspaceFolder=m;function d(R){const P=R;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function c(R){const P=R;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function E(R,P,k,O,F){if(R.scheme!==O.scheme)return{name:k,uri:R.toString(!0)};let $=P?void 0:F.relativePath(O,R);if($!==void 0)$.length===0?$=".":h.isWindows&&($=u($));else if(R.scheme===M.Schemas.file)$=R.fsPath,h.isWindows&&($=u($));else if(F.isEqualAuthority(R.authority,O.authority))$=R.path;else return{name:k,uri:R.toString(!0)};return{name:k,path:$}}e.getStoredWorkspaceFolder=E;function u(R){return R=(0,_.normalizeDriveLetter)(R),(0,I.isUNC)(R)||(R=(0,I.toSlashes)(R)),R}function t(R,P,k){const O=[],F=new Set,$=k.dirname(P);for(const re of R){let J;if(d(re))re.path&&(J=k.resolvePath($,re.path));else if(c(re))try{J=g.URI.parse(re.uri),J.path[0]!==C.posix.sep&&(J=J.with({path:C.posix.sep+J.path}))}catch(ae){console.warn(ae)}if(J){const ae=k.getComparisonKey(J);if(!F.has(ae)){F.add(ae);const ne=re.name||k.basenameOrAuthority(J);O.push(new f.WorkspaceFolder({uri:J,name:ne,index:O.length},re))}}}return O}e.toWorkspaceFolders=t;function l(R,P,k,O,F){const $=s(P,R),re=F.dirname(P),J=F.dirname(O),ae=[];for(const V of $.folders){const x=d(V)?F.resolvePath(re,V.path):g.URI.parse(V.uri);let W;k?W=!1:W=!d(V)||(0,C.isAbsolute)(V.path),ae.push(E(x,W,V.name,J,F))}const ne={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},se=r.setProperty(R,["folders"],ae,ne);let G=r.applyEdits(R,se);return(0,a.isEqualAuthority)($.remoteAuthority,(0,S.getRemoteAuthority)(O))&&(G=r.applyEdits(G,r.removeProperty(G,["remoteAuthority"],ne))),G}e.rewriteWorkspaceFileForNewLocation=l;function s(R,P){const k=L.parse(P);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(O=>m(O));else throw new Error(`${R} looks like an invalid workspace file.`);return k}function i(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function o(R){return typeof R.fileUri=="string"}function b(R,P){const k={workspaces:[],files:[]};if(R){const O=function($,re){for(let J=0;J<$.length;J++)try{re($[J],J)}catch(ae){P.warn(`Error restoring recent entry ${JSON.stringify($[J])}: ${ae.toString()}. Skip entry.`)}},F=R;Array.isArray(F.entries)&&O(F.entries,$=>{const re=$.label,J=$.remoteAuthority;i($)?k.workspaces.push({label:re,remoteAuthority:J,workspace:{id:$.workspace.id,configPath:g.URI.parse($.workspace.configPath)}}):n($)?k.workspaces.push({label:re,remoteAuthority:J,folderUri:g.URI.parse($.folderUri)}):o($)&&k.files.push({label:re,remoteAuthority:J,fileUri:g.URI.parse($.fileUri)})})}return k}e.restoreRecentlyOpened=b;function D(R){const P={entries:[]};for(const k of R.workspaces)v(k)?P.entries.push({folderUri:k.folderUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority}):P.entries.push({workspace:{id:k.workspace.id,configPath:k.workspace.configPath.toString()},label:k.label,remoteAuthority:k.remoteAuthority});for(const k of R.files)P.entries.push({fileUri:k.fileUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority});return P}e.toStoreData=D}),define(ee[98],te([0,1,85,13,4,19]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(a){function g(){let w=a.scheme===L.Schemas.file?(0,_.originalFSPath)(a):a.toString();return r.isLinux||(w=w.toLowerCase()),(0,I.createHash)("md5").update(w).digest("hex")}return{id:g(),configPath:a}}e.getWorkspaceIdentifier=M;function C(a,g){function w(){if(a.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let f;return r.isLinux?f=g.ino:r.isMacintosh?f=g.birthtime.getTime():r.isWindows&&(typeof g.birthtimeMs=="number"?f=Math.floor(g.birthtimeMs):f=g.birthtime.getTime()),(0,I.createHash)("md5").update(a.fsPath).update(f?String(f):"").digest("hex")}const S=w();if(typeof S=="string")return{id:S,uri:a}}e.getSingleFolderWorkspaceIdentifier=C;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(ee[99],te([0,1,85,87,28,280,18,14,3,2,9,4,32,42,109]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(P,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,k)}constructor(P,k=""){this._canWrite=!0,this.debugLabel=k,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,C.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(P){const k=O=>{this.traceSocketEvent("read",O),P(M.VSBuffer.wrap(O))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(P){const k=O=>{P({type:0,hadError:O,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(P){const k=()=>{P()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(P){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,C.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,C.onUnexpectedError)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=v;var p;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var m;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(m||(m={}));class d extends a.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,k){this.socket.traceSocketEvent(P,k)}constructor(P,k,O,F){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new c(this,k,O,F,this._onData,($,re)=>this._write($,re))),this._register(this._flowManager.onError($=>{console.error($),(0,C.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose(async $=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire($)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let k=0;for(;k<P.byteLength;)this._flowManager.writeMessage(P.slice(k,Math.min(k+262144,P.byteLength)),{compressed:!0,opcode:2}),k+=262144}_write(P,{compressed:k,opcode:O}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let F=2;P.byteLength<126?F+=0:P.byteLength<2**16?F+=2:F+=8;const $=M.VSBuffer.alloc(F),re=k?64:0,J=O&15;if($.writeUInt8(128|re|J,0),P.byteLength<126)$.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){$.writeUInt8(126,1);let ae=1;$.writeUInt8(P.byteLength>>>8&255,++ae),$.writeUInt8(P.byteLength>>>0&255,++ae)}else{$.writeUInt8(127,1);let ae=1;$.writeUInt8(0,++ae),$.writeUInt8(0,++ae),$.writeUInt8(0,++ae),$.writeUInt8(0,++ae),$.writeUInt8(P.byteLength>>>24&255,++ae),$.writeUInt8(P.byteLength>>>16&255,++ae),$.writeUInt8(P.byteLength>>>8&255,++ae),$.writeUInt8(P.byteLength>>>0&255,++ae)}this.socket.write(M.VSBuffer.concat([$,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),O=k.readUInt8(0),F=(O&128)>>>7,$=(O&64)>>>6,re=O&15,J=k.readUInt8(1),ae=(J&128)>>>7,ne=J&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!$),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=re,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),O=k.readUInt8(1),F=(O&128)>>>7;let $=O&127,re=1;$===126?$=k.readUInt8(++re)*2**8+k.readUInt8(++re):$===127&&($=k.readUInt8(++re)*0+k.readUInt8(++re)*0+k.readUInt8(++re)*0+k.readUInt8(++re)*0+k.readUInt8(++re)*2**24+k.readUInt8(++re)*2**16+k.readUInt8(++re)*2**8+k.readUInt8(++re));let J=0;F&&(J=k.readUInt8(++re)*2**24+k.readUInt8(++re)*2**16+k.readUInt8(++re)*2**8+k.readUInt8(++re)),this._state.state=3,this._state.readLen=$,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(k,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class c extends a.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(P,k,O,F,$,re){super(),this._tracer=P,this._onData=$,this._writeFn=re,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,k?(this._zlibInflateStream=this._register(new E(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(P,k){this._writeQueue.push({data:P,options:k}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:P,options:k}=this._writeQueue.shift();if(this._zlibDeflateStream&&k.compressed){const O=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(O,k)}else this._writeFn(P,{...k,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,k){return new Promise((O,F)=>{P.write(k),P.flush($=>O($))})}acceptFrame(P,k,O){this._readQueue.push({data:P,isCompressed:k,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const k=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(k)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(P,k,O){return new Promise((F,$)=>{P.write(k),O&&P.write(M.VSBuffer.fromByteArray([0,0,255,255])),P.flush(re=>F(re))})}}class E extends a.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}constructor(P,k,O,F){super(),this._tracer=P,this._recordInflateBytes=k,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,_.createInflateRaw)(F),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(M.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const k=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(k)})}}class u extends a.Disposable{constructor(P,k){super(),this._tracer=P,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,_.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(M.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let k=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.byteLength-4),P(k)})}}function t(R,P){if(P===0)return;const k=R.byteLength>>>2;for(let ae=0;ae<k;ae++){const ne=R.readUInt32BE(ae*4);R.writeUInt32BE(ne^P,ae*4)}const O=k*4,F=R.byteLength-O,$=P>>>24&255,re=P>>>16&255,J=P>>>8&255;F>=1&&R.writeUInt8(R.readUInt8(O)^$,O),F>=2&&R.writeUInt8(R.readUInt8(O+1)^re,O+1),F>=3&&R.writeUInt8(R.readUInt8(O+2)^J,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const R=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const P=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),k=(0,g.join)(P,`vscode-ipc-${R}.sock`);return n(k),k}e.createRandomIPCHandle=s;function i(R,P,k){const O=(0,I.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${P}-sock`;const F=k.substr(0,4),$=P.substr(0,6),re=O.substr(0,8);let J;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?J=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${re}-${F}-${$}.sock`):J=(0,g.join)(R,`${F}-${$}.sock`),n(J),J}e.createStaticIPCHandle=i;function n(R){const P=l[w.platform];typeof P=="number"&&R.length>=P&&console.warn(`WARNING: IPC handle "${R}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static toClientConnectionEvent(P){const k=h.Event.fromNodeEventEmitter(P,"connection");return h.Event.map(k,O=>({protocol:new y.Protocol(new v(O,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(O,"close"))}))}constructor(P){super(o.toClientConnectionEvent(P)),this.server=P}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function b(R){return new Promise((P,k)=>{const O=(0,L.createServer)();O.on("error",k),O.listen(R,()=>{O.removeListener("error",k),P(new o(O))})})}e.serve=b;function D(R,P){return new Promise((k,O)=>{const F=(0,L.createConnection)(R,()=>{F.removeListener("error",O),k(y.Client.fromSocket(new v(F,`ipc-client${P}`),P))});F.once("error",O)})}e.connect=D}),define(ee[25],te([0,1,54,9,4,99,36,89,6]),function(K,e,I,L,r,_,M,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(M.IEnvironmentService);class a extends C.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,_.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const S=w.slice(0,-17);if(this._snapEnv[S])continue;process.env[S]&&(this._snapEnv[S]=process.env[S]),process.env[w]?process.env[S]=process.env[w]:delete process.env[S]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const w in this._snapEnv)process.env[w]=this._snapEnv[w],delete this._snapEnv[w]}}e.EnvironmentMainService=a,Ee([I.memoize],a.prototype,"cachedLanguagesPath",null),Ee([I.memoize],a.prototype,"backupHome",null),Ee([I.memoize],a.prototype,"mainIPCHandle",null),Ee([I.memoize],a.prototype,"mainLockfile",null),Ee([I.memoize],a.prototype,"disableUpdates",null),Ee([I.memoize],a.prototype,"crossOriginIsolated",null),Ee([I.memoize],a.prototype,"codeCachePath",null),Ee([I.memoize],a.prototype,"useCodeCache",null)}),define(ee[281],te([0,1,85,33,13,9,4,19,21,194,17,25,34,16,5,193,29,98]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let c=class{static{d=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(u,t,l,s){this.environmentMainService=u,this.configurationService=t,this.logService=l,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=C.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,L.isEqual)(i,n,!M.isLinux)}}async initialize(){const u=this.stateService.getItem(d.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWindows),this.workspaces=await this.validateWorkspaces((0,a.deserializeWorkspaceInfos)(u)),this.folders=await this.validateFolders((0,a.deserializeFolderInfos)(u)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(u,t){this.workspaces.some(s=>u.workspace.id===s.workspace.id)||(this.workspaces.push(u),this.storeWorkspacesMetadata());const l=(0,_.join)(this.backupHome,u.workspace.id);return t?this.moveBackupFolder(l,t).then(()=>l):l}async moveBackupFolder(u,t){if(await h.Promises.exists(u)&&await this.convertToEmptyWindowBackup(u),await h.Promises.exists(t))try{await h.Promises.rename(t,u,!1)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.folders.some(t=>this.backupUriComparer.isEqual(u.folderUri,t.folderUri))||(this.folders.push(u),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,this.getFolderHash(u))}registerEmptyWindowBackup(u){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u.backupFolder))||(this.emptyWindows.push(u),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,u.backupFolder)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const s of u){const i=s.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,_.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?l.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const s of u){const i=s.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,_.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(o)?i.scheme!==r.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return t}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const s of u){const i=s.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,_.join)(this.backupHome,i);await this.doHasBackups(n)?t.push(s):await this.deleteStaleBackup(n)}}return t}async deleteStaleBackup(u){try{await h.Promises.rm(u,h.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let u=(0,m.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u.id));)u=(0,m.createEmptyWorkspaceIdentifier)();return{backupFolder:u.id}}async convertToEmptyWindowBackup(u){const t=this.prepareNewEmptyWindowBackup(),l=(0,_.join)(this.backupHome,t.backupFolder);try{await h.Promises.rename(u,l,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.workspaces)await this.hasBackups(t)&&u.push(t);for(const t of this.folders)await this.hasBackups(t)&&u.push(t);return u}hasBackups(u){let t;return(0,a.isEmptyWindowBackupInfo)(u)?t=(0,_.join)(this.backupHome,u.backupFolder):(0,v.isFolderBackupInfo)(u)?t=(0,_.join)(this.backupHome,this.getFolderHash(u)):t=(0,_.join)(this.backupHome,u.workspace.id),this.doHasBackups(t)}async doHasBackups(u){try{const t=await h.Promises.readdir(u);for(const l of t)try{if((await h.Promises.readdir((0,_.join)(u,l))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const u={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:l})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return l&&(s.remoteAuthority=l),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:l})=>{const s={folderUri:t.toString()};return l&&(s.remoteAuthority=l),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:l})=>{const s={backupFolder:t};return l&&(s.remoteAuthority=l),s})};this.stateService.setItem(d.backupWorkspacesMetadataStorageKey,u)}getFolderHash(u){const t=u.folderUri;let l;return t.scheme===r.Schemas.file?l=M.isLinux?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,I.createHash)("md5").update(l).digest("hex")}};e.BackupMainService=c,e.BackupMainService=c=d=Ee([Z(0,w.IEnvironmentMainService),Z(1,g.IConfigurationService),Z(2,y.ILogService),Z(3,S.IStateService)],c)}),define(ee[20],te([0,1,15,38,8,3,2,4,35,12,6,5,34,25]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var v;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var p;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let m=class extends M.Disposable{static{y=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(c,E,u){super(),this.logService=c,this.stateService=E,this.environmentMainService=u,this._onBeforeShutdown=this._register(new _.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new _.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new _.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(y.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(y.QUIT_AND_RESTART_KEY)}registerListeners(){const c=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",c);const E=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",E),I.app.once("will-quit",u=>{this.trace("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",c),I.app.removeListener("window-all-closed",E),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}fireOnWillShutdown(c){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const E=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const u=[];return this._onWillShutdown.fire({reason:c,join(t,l){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(u)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===c)return;this.trace(`lifecycle (main): phase changed (value: ${c})`),this._phase=c;const E=this.phaseWhen.get(this._phase);E&&(E.open(),this.phaseWhen.delete(this._phase))}async when(c){if(c<=this._phase)return;let E=this.phaseWhen.get(c);E||(E=new r.Barrier,this.phaseWhen.set(c,E)),await E.wait()}registerWindow(c){const E=new M.DisposableStore;this.windowCounter++,E.add(c.onWillLoad(t=>this._onWillLoadWindow.fire({window:c,workspace:t.workspace,reason:t.reason})));const u=(0,a.assertIsDefined)(c.win);u.on("close",t=>{const l=c.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.trace(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(s=>{if(s){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(c),c.close()})}),u.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.windowCounter--,E.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(c,E){await this.unload(c,3)||c.reload(E)}unload(c,E){const u=this.mapWindowIdToPendingUnload.get(c.id);if(u)return u;const t=this.doUnload(c,E).finally(()=>{this.mapWindowIdToPendingUnload.delete(c.id)});return this.mapWindowIdToPendingUnload.set(c.id,t),t}async doUnload(c,E){if(!c.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${c.id}`);const u=this._quitRequested?2:E,t=await this.onBeforeUnloadWindowInRenderer(c,u);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(c,u),!1)}handleWindowUnloadVeto(c){return c?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(c){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(c),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(c,E){return new Promise(u=>{const t=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${t}`,s=`vscode:cancel${t}`;L.validatedIpcMain.once(l,()=>{u(!1)}),L.validatedIpcMain.once(s,()=>{u(!0)}),c.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:s,reason:E})})}onWillUnloadWindowInRenderer(c,E){return new Promise(u=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(l,()=>u()),c.send("vscode:onWillUnload",{replyChannel:l,reason:E})})}quit(c){return this.doQuit(c).then(E=>{if(!E&&c)try{if(C.isWindows){const u=(0,h.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}return E})}doQuit(c){return this.trace(`Lifecycle#quit() - begin (willRestart: ${c})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(c&&this.stateService.setItem(y.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(E=>{this.pendingQuitPromiseResolve=E,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(c){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(c):this.logService.trace(c)}setRelaunchHandler(c){this.relaunchHandler=c}async relaunch(c){this.trace("Lifecycle#relaunch()");const E=process.argv.slice(1);if(c?.addArgs&&E.push(...c.addArgs),c?.removeArgs)for(const l of c.removeArgs){const s=E.indexOf(l);s>=0&&E.splice(s,1)}const u=()=>{this.relaunchHandler?.handleRelaunch(c)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:E}))};I.app.once("quit",u),await this.quit(!0)&&I.app.removeListener("quit",u)}async kill(c){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const E of I.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(t=>E.once("closed",t)):u=Promise.resolve(),E.destroy(),await u}})()]),I.app.exit(c)}};e.LifecycleMainService=m,e.LifecycleMainService=m=y=Ee([Z(0,w.ILogService),Z(1,S.IStateService),Z(2,f.IEnvironmentMainService)],m)}),define(ee[282],te([0,1,4,3,2,6,20]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,_.createDecorator)("keyboardLayoutMainService");let C=class extends r.Disposable{constructor(g){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((w,S)=>{K(["native-keymap"],w,S)});this._keyboardLayoutData=h(g),I.isCI||g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=C,e.KeyboardLayoutMainService=C=Ee([Z(0,M.ILifecycleMainService)],C);function h(a){const g=a.getKeyMap(),w=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:w}}}),define(ee[283],te([0,1,244,8,18,14,12,17,36,93,5,50,243,280]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=class extends w.AbstractRequestService{constructor(d,c,E,u){super(u),this.configurationService=d,this.environmentService=c,this.logService=E,this.configure(),this._register(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,c){const{proxyUrl:E,strictSSL:u}=this;let t;try{t=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,_.getErrorMessage)(i)))}const l={...process.env,...t},s=d.agent?d.agent:await(0,S.getProxyAgent)(d.url||"",l,{proxyUrl:E,strictSSL:u});return d.agent=s,d.strictSSL=u,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>p(d,c))}async resolveProxy(d){}};e.RequestService=y,e.RequestService=y=Ee([Z(0,C.IConfigurationService),Z(1,h.INativeEnvironmentService),Z(2,g.ILogService),Z(3,g.ILoggerService)],y);async function v(m){return((0,I.parse)(m.url).protocol==="https:"?await new Promise((E,u)=>{K(["https"],E,u)}):await new Promise((E,u)=>{K(["http"],E,u)})).request}async function p(m,d){return L.Promises.withAsyncBody(async(c,E)=>{const u=(0,I.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await v(m),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,M.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password);const s=t(l,i=>{const n=(0,M.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)p({...m,url:i.headers.location,followRedirects:n-1},d).then(c,E);else{let o=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),c({res:i,stream:(0,r.streamToBufferReadableStream)(o)})}});s.on("error",E),m.timeout&&s.setTimeout(m.timeout),m.isChromiumNetwork&&s.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&s.write(m.data),s.end(),d.onCancellationRequested(()=>{s.abort(),E(new _.CancellationError)})})}e.nodeRequest=p}),define(ee[284],te([0,1,15,283]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return I.net.request}class _ extends L.RequestService{request(C,h){return super.request({...C||{},getRawRequest:r,isChromiumNetwork:!0},h)}}e.RequestMainService=_}),define(ee[80],te([0,1,7,3,2,36,16,6,20,5,96,277,41,52,40,13]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let p=class extends r.Disposable{constructor(c,E,u,t,l,s){super(),this.logService=c,this.environmentService=E,this.userDataProfilesService=u,this.lifecycleMainService=t,this.fileService=l,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(c=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)c.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)c.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(c=>{c.join((async()=>{await this.fileService.exists(c.profile.globalStorageHome)||await this.fileService.createFolder(c.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(c=>{const E=this.mapProfileToStorage.get(c.profile.id);E&&c.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const c=new w.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(c.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,g.isProfileUsingDefaultStorage)(c))return this.applicationStorage;let E=this.mapProfileToStorage.get(c.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${c.name})`),E=this._register(this.createProfileStorage(c)),this.mapProfileToStorage.set(c.id,E);const u=this._register(E.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:E,profile:c})));this._register(L.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${c.name})`),this.mapProfileToStorage.delete(c.id),u.dispose()}))}return E}createProfileStorage(c){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.ProfileStorageMain(c,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(c){let E=this.mapWorkspaceToStorage.get(c.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${c.id})`),E=this._register(this.createWorkspaceStorage(c)),this.mapWorkspaceToStorage.set(c.id,E),this._register(L.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${c.id})`),this.mapWorkspaceToStorage.delete(c.id)}))),E}createWorkspaceStorage(c){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.WorkspaceStorageMain(c,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(c){const E=I.URI.file(c);for(const u of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(u.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(u.path),E))return!0;return!1}};e.StorageMainService=p,e.StorageMainService=p=Ee([Z(0,a.ILogService),Z(1,_.IEnvironmentService),Z(2,f.IUserDataProfilesMainService),Z(3,h.ILifecycleMainService),Z(4,M.IFileService),Z(5,y.IUriIdentityService)],p),e.IApplicationStorageMainService=(0,C.createDecorator)("applicationStorageMainService");let m=class extends g.AbstractStorageService{constructor(c,E){super(),this.userDataProfilesService=c,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(c){if(c===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(c){if(c===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=m,e.ApplicationStorageMainService=m=Ee([Z(0,S.IUserDataProfilesService),Z(1,e.IStorageMainService)],m)}),define(ee[285],te([0,1,87,28,103,99,8,2,4,17,5,24,239,240,94,126,18]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function m(t,l,s,i,n){let o;for(let b=3;b&&(o?.dispose(),o=await new d(t,l,s,i,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));b--);return o}class d extends C.Disposable{constructor(l,s,i,n,o){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=o,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=I.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=b=>this._onConnection(b),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const l=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,v.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,r.findFreePortFaster)(l,2,1e3,s),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(l){l.pause();const s=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,S.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n instanceof _.NodeSocket?n.socket.destroy():n.end()}),n instanceof _.NodeSocket?this._mirrorNodeSocket(l,n):this._mirrorGenericSocket(l,n),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),n.end()})}_mirrorGenericSocket(l,s){s.onClose(()=>l.destroy()),s.onEnd(()=>l.end()),s.onData(i=>l.write(i.buffer)),l.on("data",i=>s.write(p.VSBuffer.wrap(i))),l.resume()}_mirrorNodeSocket(l,s){const i=s.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.NodeRemoteTunnel=d;let c=class extends v.AbstractTunnelService{constructor(l,s,i,n,o){super(s,o),this.remoteSocketFactoryService=l,this.signService=i,this.productService=n}isPortPrivileged(l){return(0,v.isPortPrivileged)(l,this.defaultTunnelHost,h.OS,L.release())}retainOrCreateTunnel(l,s,i,n,o,b,D,R){const P=this.getTunnelFromMap(s,i);if(P)return++P.refcount,P.value;if((0,v.isTunnelProvider)(l))return this.createWithProvider(l,s,i,o,b,D,R);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${o}.`);const k={commit:this.productService.commit,quality:this.productService.quality,addressProvider:l,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},O=m(k,n,s,i,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,O),O}}};e.BaseTunnelService=c,e.BaseTunnelService=c=Ee([Z(0,f.IRemoteSocketFactoryService),Z(1,g.ILogService),Z(2,y.ISignService),Z(3,w.IProductService),Z(4,a.IConfigurationService)],c);let E=class extends c{constructor(l,s,i,n,o){super(l,s,i,n,o)}};e.TunnelService=E,e.TunnelService=E=Ee([Z(0,f.IRemoteSocketFactoryService),Z(1,g.ILogService),Z(2,y.ISignService),Z(3,w.IProductService),Z(4,a.IConfigurationService)],E);let u=class extends C.Disposable{constructor(l,s,i,n,o){super(),this.remoteSocketFactoryService=l,this.logService=s,this.productService=i,this.signService=n,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(l,s,i,n,o,b,D,R,P){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${b}.`),!this._tunnelServices.has(l)){const k=new E(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(k),this._tunnelServices.set(l,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(s,i,n,o,b,D,R,P)}};e.SharedTunnelsService=u,e.SharedTunnelsService=u=Ee([Z(0,f.IRemoteSocketFactoryService),Z(1,g.ILogService),Z(2,w.IProductService),Z(3,y.ISignService),Z(4,a.IConfigurationService)],u)}),define(ee[100],te([0,1,8,22,3,17,25,20,5,24,50,48]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,v,p){return`${p.updateUrl}/api/update/${y}/${v}/${p.commit}`}e.createUpdateURL=S;let f=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,p,m,d,c,E){this.lifecycleMainService=v,this.configurationService=p,this.environmentMainService=m,this.requestService=d,this.logService=c,this.productService=E,this._state=w.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,v.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(w.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(w.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(w.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),p=this.getProductQuality(v);if(!p){this.setState(w.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.setState(w.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(w.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,I.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(p){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(p);return}}async _applySpecificUpdate(v){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=f,e.AbstractUpdateService=f=Ee([Z(0,C.ILifecycleMainService),Z(1,_.IConfigurationService),Z(2,M.IEnvironmentMainService),Z(3,g.IRequestService),Z(4,h.ILogService),Z(5,a.IProductService)],f)}),define(ee[286],te([0,1,15,54,3,2,17,25,20,5,24,50,26,48,100]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends y.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"error",(m,d)=>d)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(m,d,c)=>({url:d,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(m,d,c,E)=>({releaseNotes:d,version:c,productVersion:c,date:E}))}constructor(m,d,c,E,u,t,l){super(m,d,E,u,t,l),this.telemetryService=c,this.disposables=new _.DisposableStore,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const d=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.setState(f.State.Idle(1,d))}buildUpdateFeedUrl(m){let d;this.productService.darwinUniversalAssetId?d=this.productService.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,y.createUpdateURL)(d,m,this.productService);try{I.autoUpdater.setFeedURL({url:c})}catch(E){this.logService.error("Failed to set update feed URL",E);return}return c}doCheckForUpdates(m){this.setState(f.State.CheckingForUpdates(m)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(f.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=v,Ee([L.memoize],v.prototype,"onRawError",null),Ee([L.memoize],v.prototype,"onRawUpdateNotAvailable",null),Ee([L.memoize],v.prototype,"onRawUpdateAvailable",null),Ee([L.memoize],v.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=v=Ee([Z(0,h.ILifecycleMainService),Z(1,M.IConfigurationService),Z(2,S.ITelemetryService),Z(3,C.IEnvironmentMainService),Z(4,w.IRequestService),Z(5,a.ILogService),Z(6,g.IProductService)],v)}),define(ee[287],te([0,1,47,45,8,3,9,25,20,5,26,48]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,p,m){if(this.lifecycleMainService=v,this.logService=m,this._state=w.State.Uninitialized,this._onStateChange=new _.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(w.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}scheduleCheckForUpdates(v=60*60*1e3){return(0,r.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(v){}};S=Ee([Z(0,h.ILifecycleMainService),Z(1,C.IEnvironmentMainService),Z(2,a.ILogService)],S);let f=class extends S{constructor(v,p,m,d,c,E){super(m,d,c),this.snap=v,this.snapRevision=p,this.telemetryService=E;const u=(0,L.watch)(M.dirname(this.snap)),t=_.Event.fromNodeEventEmitter(u,"change",(n,o)=>o),l=_.Event.filter(t,n=>n==="current"),i=_.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{i.dispose(),u.close()})}doCheckForUpdates(){this.setState(w.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(w.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((m,d)=>(0,L.realpath)(`${M.dirname(this.snap)}/current`,(c,E)=>c?d(c):m(E))),p=M.basename(v);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=f,e.SnapUpdateService=f=Ee([Z(2,h.ILifecycleMainService),Z(3,C.IEnvironmentMainService),Z(4,a.ILogService),Z(5,g.ITelemetryService)],f)}),define(ee[30],te([0,1,4,6,95,59,67,24,17,25,9]),function(K,e,I,L,r,_,M,C,h,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultBrowserWindowOptions=e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,L.createDecorator)("windowsMainService");var w;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(w||(e.OpenContext=w={}));function S(f,y=(0,r.defaultWindowState)(),v){const p=f.get(M.IThemeMainService),m=f.get(C.IProductService),d=f.get(h.IConfigurationService),c=f.get(a.IEnvironmentMainService),E=d.getValue("window"),u={width:y.width,height:y.height,x:y.x,y:y.y,backgroundColor:p.getBackgroundColor(),minWidth:_.WindowMinimumSize.WIDTH,minHeight:_.WindowMinimumSize.HEIGHT,title:m.nameLong,...v,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,_.zoomLevelToZoomFactor)(E?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...v?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return I.isLinux?u.icon=(0,g.join)(c.appRoot,"resources/linux/code.png"):I.isWindows&&!c.isBuilt&&(u.icon=(0,g.join)(c.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&(u.acceptFirstMouse=!0,E?.clickThroughInactive===!1&&(u.acceptFirstMouse=!1)),u}e.defaultBrowserWindowOptions=S}),define(ee[288],te([0,1,15,22,3,55,2,32,116,5,80,30]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let f=class extends M.Disposable{constructor(v,p,m,d){super(),this.logService=v,this.windowsMainService=p,this.encryptionMainService=m,this.applicationStorageMainService=d,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const v=r.Event.fromNodeEventEmitter(I.app,"login",(p,m,d,c,E)=>({event:p,webContents:m,req:d,authInfo:c,callback:E}));this._register(v(this.onLogin,this))}async onLogin({event:v,authInfo:p,req:m,callback:d}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(c?.username,c?.password)}async resolveProxyCredentials(v){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(v);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(v){this.logService.trace("auth#doResolveProxyCredentials - enter",v);const p=String((0,_.hash)({scheme:v.scheme,host:v.host,port:v.port}));let m,d;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+p,-1);if(t){const l=JSON.parse(await this.encryptionMainService.decrypt(t));m=l.username,d=l.password}}catch(t){this.logService.error(t)}if(this.state!==S.StoredCredentialsUsed&&typeof m=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:m,password:d};const c=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!c){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const E={authInfo:v,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,E),this.state=S.LoginDialogShown;const u=await new Promise(t=>{const l=async(s,i,n)=>{if(i===E.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const b=await this.encryptionMainService.encrypt(JSON.stringify(o));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+p,b,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+p,-1)}catch(b){this.logService.error(b)}t({username:o.username,password:o.password})}else t(void 0)};c.win?.webContents.on("ipc-message",l)});return this.sessionCredentials=u,u}};e.ProxyAuthHandler=f,e.ProxyAuthHandler=f=Ee([Z(0,a.ILogService),Z(1,w.IWindowsMainService),Z(2,h.IEncryptionMainService),Z(3,g.IApplicationStorageMainService)],f)}),define(ee[289],te([0,1,15,23,4,7,21,17,63,6,5,127,30]),function(K,e,I,L,r,_,M,C,h,a,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,a.createDecorator)(e.ID);let f=class{constructor(v,p,m,d){this.logService=v,this.windowsMainService=p,this.urlService=m,this.configurationService=d}async start(v,p){this.logService.trace("Received data from other instance: ",v,p),r.isMacintosh&&I.app.focus({steal:!0});const m=this.parseOpenUrl(v);if(m.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const c=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));c&&(d=c.ready())}d.then(()=>{for(const{uri:c,originalUrl:E}of m)this.urlService.open(c,{originalUrl:E})})}else return this.startOpenWindow(v,p)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,L.coalesce)(v._urls.map(p=>{try{return{uri:_.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async startOpenWindow(v,p){const m=(0,h.isLaunchedFromCli)(p)?0:4;let d=[];const c=v.wait&&v.waitMarkerFilePath?_.URI.file(v.waitMarkerFilePath):void 0,E=v.remote||void 0,u={context:m,cli:v,userEnv:p,waitMarkerFileURI:c,remoteAuthority:E,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,u);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)d=await this.windowsMainService.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,u),d=[l]):d=await this.windowsMainService.open({...u,forceEmpty:!0})}}else d=await this.windowsMainService.open({...u,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(c&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,M.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=f,e.LaunchMainService=f=Ee([Z(0,g.ILogService),Z(1,S.IWindowsMainService),Z(2,w.IURLService),Z(3,C.IConfigurationService)],f)}),define(ee[290],te([0,1,2,20,52,29,8,30]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends I.Disposable{constructor(g,w,S){super(),this.userDataProfilesService=w,this.windowsMainService=S,this._register(g.onWillLoadWindow(f=>{f.reason===2&&this.unsetProfileForWorkspace(f.window)})),this._register(g.onBeforeCloseWindow(f=>this.unsetProfileForWorkspace(f))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(g){const w=this.getWorkspace(g),S=this.userDataProfilesService.getProfileForWorkspace(w);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(w,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(g){return g.openedWorkspace??(0,_.toWorkspaceIdentifier)(g.backupPath,g.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const g=this.userDataProfilesService.getAssociatedEmptyWindows();if(g.length===0)return;const w=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of g)w.some(f=>f.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};e.UserDataProfilesHandler=h,e.UserDataProfilesHandler=h=Ee([Z(0,L.ILifecycleMainService),Z(1,r.IUserDataProfilesMainService),Z(2,C.IWindowsMainService)],h)}),define(ee[61],te([0,1,15,2,3,5,311,8,13,30,71,26,20,73,37,4,130]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function d(u){return typeof u.responseWindowId=="number"}let c=class extends L.Disposable{static{m=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(m.all.values())}constructor(t,l,s){super(),this.logService=t,this.telemetryService=l,this.lifecycleMainService=s,this.id=String(++m.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,l){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,l){case g.default.Error:this.logService.error(s);break;case g.default.Warning:this.logService.warn(s);break;case g.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const l=this.doStart(t);return l&&t.payload&&this.postMessage(t.payload),l}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const l=`${this.configuration.type}-${this.id}`,s=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],n=this.configuration.execArgv??[],o=this.configuration.allowLoadingUnsignedLibraries,b=this.configuration.forceAllocationsToV8Sandbox,D="pipe",R=this.createEnv(t);return this.log("creating new...",g.default.Info),this.process=I.utilityProcess.fork(s,i,{serviceName:l,env:R,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:b,stdio:D}),this.registerListeners(this.process,this.configuration,l),!0}createEnv(t){const l=t.env?{...t.env}:{...(0,y.deepClone)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.isWindows&&((0,p.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,f.removeDangerousEnvVariables)(l);for(const s of Object.keys(l))l[s]=String(l[s]);return l}registerListeners(t,l,s){if(t.stdout){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:i.write(n))))}this._register(r.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(r.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&m.all.set(t.pid,{pid:t.pid,name:d(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.log("successfully created",g.default.Info)})),this._register(r.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,g.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(I.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,g.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,l){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),l())}))}postMessage(t,l){this.process&&this.process.postMessage(t,l)}connect(t){const{port1:l,port2:s}=new I.MessageChannelMain;return this.postMessage(t,[s]),l}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",g.default.Info),this.process.kill()?(this.log("successfully killed the process",g.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",g.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&m.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",g.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,C.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.UtilityProcess=c,e.UtilityProcess=c=m=Ee([Z(0,_.ILogService),Z(1,w.ITelemetryService),Z(2,S.ILifecycleMainService)],c);let E=class extends c{constructor(t,l,s,i){super(t,s,i),this.windowsMainService=l}start(t){const l=this.windowsMainService.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,l){l.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=E,e.WindowUtilityProcess=E=Ee([Z(0,_.ILogService),Z(1,a.IWindowsMainService),Z(2,w.ITelemetryService),Z(3,S.ILifecycleMainService)],E)}),define(ee[291],te([0,1,14,5,20,8,61,30,26]),function(K,e,I,L,r,_,M,C,h){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class{static{a=this}static{this._lastId=0}constructor(S,f,y,v){this._logService=S,this._lifecycleMainService=f,this._windowsMainService=y,this._telemetryService=v,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(p=>{this._shutdown=!0,p.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(S){const f=this._extHosts.get(S);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(S){return this._getExtHost(S).onStdout}onDynamicStderr(S){return this._getExtHost(S).onStderr}onDynamicMessage(S){return this._getExtHost(S).onMessage}onDynamicExit(S){return this._getExtHost(S).onExit}async createExtensionHost(){if(this._shutdown)throw(0,I.canceled)();const S=String(++a._lastId),f=new M.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(S,f),f.onExit(({pid:y,code:v,signal:p})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${v}, signal: ${p}.`),setTimeout(()=>{f.dispose(),this._extHosts.delete(S)})}),{id:S}}async start(S,f){if(this._shutdown)throw(0,I.canceled)();this._getExtHost(S).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:S})}async enableInspectPort(S){if(this._shutdown)throw(0,I.canceled)();const f=this._extHosts.get(S);return f?f.enableInspectPort():!1}async kill(S){if(this._shutdown)throw(0,I.canceled)();const f=this._extHosts.get(S);f&&f.kill()}async _killAllNow(){for(const[,S]of this._extHosts)S.kill()}async _waitForAllExit(S){const f=[];for(const[,y]of this._extHosts)f.push(y.waitForExit(S));return _.Promises.settled(f).then(()=>{})}};e.ExtensionHostStarter=g,e.ExtensionHostStarter=g=a=Ee([Z(0,L.ILogService),Z(1,r.ILifecycleMainService),Z(2,C.IWindowsMainService),Z(3,h.ITelemetryService)],g)}),define(ee[292],te([0,1,38,8,2,25,20,5,41,39,66,61,51,89,12,245,24]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends r.Disposable{constructor(c,E,u,t,l,s,i,n){super(),this.machineId=c,this.environmentMainService=E,this.userDataProfilesService=u,this.lifecycleMainService=t,this.logService=l,this.loggerMainService=s,this.policyService=i,this.productService=n,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){I.validatedIpcMain.on(v.SharedProcessChannelConnection.request,(c,E)=>this.onWindowConnection(c,E,v.SharedProcessChannelConnection.response)),I.validatedIpcMain.on(v.SharedProcessRawConnection.request,(c,E)=>this.onWindowConnection(c,E,v.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,E,u){this.logService.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const t=await this.connect(u);if(c.sender.isDestroyed())return t.close();c.sender.postMessage(u,E,[t])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(v.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const c=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(v.SharedProcessLifecycle.initDone,()=>c.complete()):I.validatedIpcMain.once(v.SharedProcessLifecycle.initDone,()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const c=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(v.SharedProcessLifecycle.ipcReady,()=>c.complete()):I.validatedIpcMain.once(v.SharedProcessLifecycle.ipcReady,()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new w.UtilityProcess(this.logService,S.NullTelemetryService,this.lifecycleMainService));const c=(0,f.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let E;c.port&&(E=["--nolazy"],c.break?E.push(`--inspect-brk=${c.port}`):E.push(`--inspect=${c.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.productService.quality!=="stable"})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(c){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect(c)}};e.SharedProcess=m,e.SharedProcess=m=Ee([Z(1,_.IEnvironmentMainService),Z(2,h.IUserDataProfilesService),Z(3,M.ILifecycleMainService),Z(4,C.ILogService),Z(5,g.ILoggerMainService),Z(6,a.IPolicyService),Z(7,p.IProductService)],m)}),define(ee[293],te([0,1,25,89,20,5,51,61,110,38,2,3,37,17,13]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let v=class extends g.Disposable{constructor(m,d,c,E,u){super(),this._reconnectConstants=m,this._configurationService=d,this._environmentMainService=c,this._lifecycleMainService=E,this._logService=u,this.utilityProcess=void 0,this._onRequestConnection=new w.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new w.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),a.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,l)=>this._onWindowConnection(t,l)),this._register((0,g.toDisposable)(()=>{a.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new C.UtilityProcess(this._logService,M.NullTelemetryService,this._lifecycleMainService);const m=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),d=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const c=this.utilityProcess.connect(),E=new h.Client(c,"ptyHost"),u=new g.DisposableStore;return u.add(E),u.add((0,g.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:E,store:u,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const m={...(0,S.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&(m.VSCODE_LATENCY=String(d));const c=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(m.VSCODE_STARTUP_DELAY=String(c)),this._environmentMainService.restoreSnapExportedVariables(),m}_onWindowConnection(m,d){this._onRequestConnection.fire();const c=this.utilityProcess.connect();if(m.sender.isDestroyed()){c.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[c])}};e.ElectronPtyHostStarter=v,e.ElectronPtyHostStarter=v=Ee([Z(1,f.IConfigurationService),Z(2,I.IEnvironmentMainService),Z(3,r.ILifecycleMainService),Z(4,_.ILogService)],v)}),define(ee[294],te([0,1,2,6,5,30,61,26,55,3,8,20]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let S=class extends I.Disposable{constructor(v,p,m,d){super(),this.logService=v,this.windowsMainService=p,this.telemetryService=m,this.lifecycleMainService=d,this.workers=new Map}async createWorker(v){const p=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${p})`);const m=this.hash(v);this.workers.has(m)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(v));const d=new f(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,v);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(m,d);const c=new g.DeferredPromise;return a.Event.once(d.onDidTerminate)(E=>{E.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.workers.delete(m),c.complete({reason:E})}),c.p}hash(v){return(0,h.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const p=this.hash(v),m=this.workers.get(p);m&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),m.kill(),this.workers.delete(p))}};e.UtilityProcessWorkerMainService=S,e.UtilityProcessWorkerMainService=S=Ee([Z(0,r.ILogService),Z(1,_.IWindowsMainService),Z(2,C.ITelemetryService),Z(3,w.ILifecycleMainService)],S);let f=class extends I.Disposable{constructor(v,p,m,d,c){super(),this.logService=v,this.windowsMainService=p,this.telemetryService=m,this.lifecycleMainService=d,this.configuration=c,this._onDidTerminate=this._register(new a.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(v=>this._onDidTerminate.fire({code:v.code,signal:v.signal}))),this._register(this.utilityProcess.onCrash(v=>this._onDidTerminate.fire({code:v.code,signal:"ECRASH"})))}spawn(){const p=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};f=Ee([Z(0,r.ILogService),Z(1,_.IWindowsMainService),Z(2,C.ITelemetryService),Z(3,w.ILifecycleMainService)],f)}),define(ee[295],te([0,1,15,3,2,271,30]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends r.Disposable{constructor(a){super(),this.windowsMainService=a,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new _.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(a,g){let w;if(typeof a.windowId=="number"){const{windowId:S}=a,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);w=f.win.webContents}else{const{webContentsId:S}=a;if(w=I.webContents.fromId(S),!w)throw new Error(`Invalid webContentsId: ${S}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,w,S){const y=this.getFrameByName(a,g);if(typeof y.findInFrame=="function"){y.findInFrame(w,{findNext:S.findNext,forward:S.forward});const v=(p,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),y.removeListener("found-in-frame",v))};y.on("found-in-frame",v)}}async stopFindInFrame(a,g,w){const f=this.getFrameByName(a,g);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}getFrameByName(a,g){const w=this.windowsMainService.getWindowById(a.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${a}`);const S=w.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===g);if(!S)throw new Error(`Unknown frame: ${g}`);return S}};e.WebviewMainService=C,e.WebviewMainService=C=Ee([Z(0,M.IWindowsMainService)],C)}),define(ee[296],te([0,1,15,13,17,25,59,30]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let h=class{static open(g){return g.invokeFunction(C.defaultBrowserWindowOptions,void 0,{webPreferences:{preload:L.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}constructor(g,w,S){this.contents=g,this.configurationService=w,this.environmentMainService=S,this.create(),this.registerListeners()}create(){this.contents.on("dom-ready",()=>{const g=this.configurationService.getValue("window")?.zoomLevel??0;this.contents.setZoomLevel(g),this.contents.setZoomFactor((0,M.zoomLevelToZoomFactor)(g))}),this.environmentMainService.args["open-devtools"]===!0&&this.contents.openDevTools({mode:"bottom"})}registerListeners(){this.contents.ipc.on("vscode:focusAuxiliaryWindow",()=>{this.withWindow(g=>g.focus(),!0)}),this.contents.ipc.on("vscode:moveAuxiliaryWindowTop",()=>{this.withWindow(g=>g.moveTop(),!0)})}withWindow(g,w){const S=I.BrowserWindow.fromWebContents(this.contents);S&&(w&&S.isMinimized()&&S.restore(),g(S))}};e.AuxiliaryWindow=h,e.AuxiliaryWindow=h=Ee([Z(1,r.IConfigurationService),Z(2,_.IEnvironmentMainService)],h)}),define(ee[297],te([0,1,15,2,4,19,7,17,20,5,34,30,95,29]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class extends L.Disposable{static{y=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(u,t,l,s,i){super(),this.windowsMainService=u,this.stateService=t,this.lifecycleMainService=l,this.logService=s,this.configurationService=i,this._state=p(this.stateService.getItem(y.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?r.isMacintosh&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const s=d(t);this.stateService.setItem(y.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{const s=(0,f.isWorkspaceIdentifier)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&l.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(s||i)&&(l.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(u){return{windowId:u.id,workspace:(0,f.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(u){const t=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=u.workspace;if((0,f.isWorkspaceIdentifier)(b)){const R=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===b.id).map(P=>P.uiState);if(R.length)return R[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(b)){const R=this.state.openedWindows.filter(P=>P.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(P.folderUri,b.uri)).map(P=>P.uiState);if(R.length)return R[0]}else if(u.backupPath){const R=this.state.openedWindows.filter(P=>P.backupPath===u.backupPath).map(P=>P.uiState);if(R.length)return R[0]}const D=this.lastClosedState||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let l;const s=I.screen.getAllDisplays();if(s.length===1)l=s[0];else{if(r.isMacintosh){const b=I.screen.getCursorScreenPoint();l=I.screen.getDisplayNearestPoint(b)}!l&&t&&(l=I.screen.getDisplayMatching(t.getBounds())),l||(l=I.screen.getPrimaryDisplay()||s[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i=b,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.WindowsStateHandler=v,e.WindowsStateHandler=v=y=Ee([Z(0,w.IWindowsMainService),Z(1,g.IStateService),Z(2,h.ILifecycleMainService),Z(3,a.ILogService),Z(4,C.IConfigurationService)],v);function p(E){const u={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>m(l))),u}e.restoreWindowsState=p;function m(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=M.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:M.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function d(E){return{lastActiveWindow:E.lastActiveWindow&&c(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&c(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>c(u))}}e.getWindowsStateStoreData=d;function c(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ee[53],te([0,1,15,3,44,2,13,9,19,21,192,64,60,25,6,5,52,129,29,97,98]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let u=class extends _.Disposable{constructor(l,s,i,n,o){super(),this.environmentMainService=l,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=n,this.dialogMainService=o,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const l=(await a.Promises.readdir(this.untitledWorkspacesHome.with({scheme:M.Schemas.file}).fsPath)).map(s=>(0,h.joinPath)(this.untitledWorkspacesHome,s,d.UNTITLED_WORKSPACE_NAME));for(const s of l){const i=(0,E.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,s=>a.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(l,s){if(this.isWorkspacePath(l)&&l.scheme===M.Schemas.file)try{const i=s(l.fsPath);return i instanceof Promise?i.then(n=>this.doResolveWorkspace(l,n),n=>{}):this.doResolveWorkspace(l,i)}catch{return}}isWorkspacePath(l){return(0,d.isUntitledWorkspace)(l,this.environmentMainService)||(0,d.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,s){try{const i=this.doParseStoredWorkspace(l,s),n=(0,E.getWorkspaceIdentifier)(l);return{id:n.id,configPath:n.configPath,folders:(0,c.toWorkspaceFolders)(i.folders,n.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(l,s){const i=(0,r.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.isStoredWorkspaceFolder)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,s){const{workspace:i,storedWorkspace:n}=this.newUntitledWorkspace(l,s),o=i.configPath.fsPath;return await a.Promises.mkdir((0,C.dirname)(o),{recursive:!0}),await a.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(l=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.joinPath)(this.untitledWorkspacesHome,i),o=(0,h.joinPath)(n,d.UNTITLED_WORKSPACE_NAME),b=[];for(const D of l)b.push((0,c.getStoredWorkspaceFolder)(D.uri,!0,D.name,n,h.extUriBiasedIgnorePathCase));return{workspace:(0,E.getWorkspaceIdentifier)(o),storedWorkspace:{folders:b,remoteAuthority:s}}}async getWorkspaceIdentifier(l){return(0,E.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,d.isUntitledWorkspace)(l.configPath,this.environmentMainService)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.doDeleteUntitledWorkspace(l),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(l),this._onDidDeleteUntitledWorkspace.fire(l))}async doDeleteUntitledWorkspace(l){const s=(0,h.originalFSPath)(l.configPath);try{await a.Promises.rm((0,C.dirname)(s));const i=(0,C.join)(this.environmentMainService.workspaceStorageHome.with({scheme:M.Schemas.file}).fsPath,l.id);await a.Promises.exists(i)&&await a.Promises.writeFile((0,C.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==l.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(l,s,i){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,s,i))return;const o=await this.doEnterWorkspace(l,(0,E.getWorkspaceIdentifier)(i));if(o)return this._onDidEnterWorkspace.fire({window:l,workspace:o.workspace}),o}async isValidTargetWorkspacePath(l,s,i){return i?(0,d.isWorkspaceIdentifier)(l.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,i)?!1:(0,m.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,h.basename)(i)),detail:(0,g.localize)(2,null)},I.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(l,s){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:l.remoteAuthority})),(0,d.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=s,l.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=u,e.WorkspacesManagementMainService=u=Ee([Z(0,f.IEnvironmentMainService),Z(1,v.ILogService),Z(2,p.IUserDataProfilesMainService),Z(3,w.IBackupMainService),Z(4,S.IDialogMainService)],u)}),define(ee[131],te([0,1,15,38,22,6,30,29,53,12,5,61]),function(K,e,I,L,r,_,M,C,h,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,_.createDecorator)(e.ID);let S=class{constructor(y,v,p){this.windowsMainService=y,this.workspacesManagementMainService=v,this.logService=p}async getRemoteDiagnostics(y){const v=this.windowsMainService.getWindows();return(await Promise.all(v.map(async m=>{const d=m.remoteAuthority;if(!d)return;const c=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(m):void 0};return new Promise(u=>{m.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:c,args:E}),L.validatedIpcMain.once(c,(t,l)=>{l||u({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),u(l)}),setTimeout(()=>{u({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const p of I.BrowserWindow.getAllWindows()){const m=this.windowsMainService.getWindowById(p.id);m?y.push(await this.codeWindowToInfo(m)):y.push(this.browserWindowToInfo(p))}const v=[];for(const{pid:p,name:m}of w.UtilityProcess.getAll())v.push({pid:p,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:v,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const v=await this.getFolderURIs(y),p=(0,a.assertIsDefined)(y.win);return this.browserWindowToInfo(p,v,y.remoteAuthority)}browserWindowToInfo(y,v=[],p){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:v,remoteAuthority:p}}async getFolderURIs(y){const v=[],p=y.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(p))v.push(p.uri);else if((0,C.isWorkspaceIdentifier)(p)){const m=await this.workspacesManagementMainService.resolveLocalWorkspace(p.configPath);m&&m.folders.forEach(c=>{v.push(c.uri)})}return v}};e.DiagnosticsMainService=S,e.DiagnosticsMainService=S=Ee([Z(0,M.IWindowsMainService),Z(1,h.IWorkspacesManagementMainService),Z(2,g.ILogService)],S)}),define(ee[68],te([0,1,47,15,28,154,54,3,2,13,9,4,7,105,86,21,103,180,60,25,6,20,5,24,67,30,29,53,18,241,233]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let P=class extends h.Disposable{constructor(O,F,$,re,J,ae,ne,se){super(),this.windowsMainService=O,this.dialogMainService=F,this.lifecycleMainService=$,this.environmentMainService=re,this.logService=J,this.productService=ae,this.themeMainService=ne,this.workspacesManagementMainService=se,this.onDidOpenWindow=C.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=C.Event.filter(C.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:G,x:V,y:x})=>({windowId:G.id,x:V,y:x})),({windowId:G})=>!!this.windowsMainService.getWindowById(G)),this.onDidMaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new C.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(G,V,x)=>x),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),C.Event.fromNodeEventEmitter(L.screen,"display-added"),C.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,n.toWorkspaceIdentifier)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(O,F,$){return Array.isArray(F)?this.doOpenWindow(O,F,$):this.doOpenEmptyWindow(O,F)}async doOpenWindow(O,F,$=Object.create(null)){F.length>0&&await this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:$.forceNewWindow,forceReuseWindow:$.forceReuseWindow,preferNewWindow:$.preferNewWindow,diffMode:$.diffMode,mergeMode:$.mergeMode,addMode:$.addMode,gotoLineMode:$.gotoLineMode,noRecentEntry:$.noRecentEntry,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:$.remoteAuthority||void 0,forceProfile:$.forceProfile,forceTempProfile:$.forceTempProfile})}async doOpenEmptyWindow(O,F){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},F)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const F=this.windowById(O);return F?.win?F.win.isMaximized():!1}async maximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.maximize()}async unmaximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.unmaximize()}async minimizeWindow(O){const F=this.windowById(O);F?.win&&F.win.minimize()}async moveWindowTop(O){const F=this.windowById(O);F?.win&&F.win.moveTop()}async updateWindowControls(O,F){const $=this.windowById(O);$&&$.updateWindowControls(F)}async focusWindow(O,F){F&&typeof F.windowId=="number"&&(O=F.windowId),this.windowById(O)?.focus({force:F?.force??!1})}async setMinimumSize(O,F,$){const re=this.windowById(O);if(re?.win){const[J,ae]=re.win.getSize(),[ne,se]=re.win.getMinimumSize(),[G,V]=[F??ne,$??se],[x,W]=[Math.max(J,G),Math.max(ae,V)];(ne!==G||se!==V)&&re.win.setMinimumSize(G,V),(J!==x||ae!==W)&&re.win.setSize(x,W)}}async saveWindowSplash(O,F){this.themeMainService.saveWindowSplash(O,F)}async installShellCommand(O){const{source:F,target:$}=await this.getShellCommandLink();try{const{symbolicLink:re}=await v.SymlinkSupport.stat(F);if(re&&!re.dangling){const J=await(0,f.realpath)(F);if($===J)return}await v.Promises.unlink(F)}catch(re){if(re.code!=="ENOENT")throw re}try{await v.Promises.symlink($,F)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:J}=await this.showMessageBox(O,{type:"info",message:(0,m.localize)(0,null,this.productService.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(J===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${$}' '${F}'\\" with administrator privileges"`;await(0,_.promisify)(I.exec)(ae)}catch{throw new Error((0,m.localize)(3,null,F))}}}async uninstallShellCommand(O){const{source:F}=await this.getShellCommandLink();try{await v.Promises.unlink(F)}catch($){switch($.code){case"EACCES":{const{response:re}=await this.showMessageBox(O,{type:"info",message:(0,m.localize)(4,null,this.productService.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(re===0)try{const J=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,_.promisify)(I.exec)(J)}catch{throw new Error((0,m.localize)(7,null,F))}break}case"ENOENT":break;default:throw $}}}async getShellCommandLink(){const O=(0,g.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(O))throw new Error((0,m.localize)(8,null,O));return{source:F,target:O}}async showMessageBox(O,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(O))}async showSaveDialog(O,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(O))}async showOpenDialog(O,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(O))}toBrowserWindow(O){const F=this.windowById(O);if(F?.win)return F.win}async pickFileFolderAndOpen(O,F){const $=await this.dialogMainService.pickFileFolder(F);$&&await this.doOpenPicked(await Promise.all($.map(async re=>await v.SymlinkSupport.existsDirectory(re)?{folderUri:S.URI.file(re)}:{fileUri:S.URI.file(re)})),F,O)}async pickFolderAndOpen(O,F){const $=await this.dialogMainService.pickFolder(F);$&&await this.doOpenPicked($.map(re=>({folderUri:S.URI.file(re)})),F,O)}async pickFileAndOpen(O,F){const $=await this.dialogMainService.pickFile(F);$&&await this.doOpenPicked($.map(re=>({fileUri:S.URI.file(re)})),F,O)}async pickWorkspaceAndOpen(O,F){const $=await this.dialogMainService.pickWorkspace(F);$&&await this.doOpenPicked($.map(re=>({workspaceUri:S.URI.file(re)})),F,O)}async doOpenPicked(O,F,$){await this.windowsMainService.open({context:3,contextWindowId:$,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:F.forceNewWindow})}async showItemInFolder(O,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(O,F){this.windowById(O)?.setRepresentedFilename(F)}async setDocumentEdited(O,F){this.windowById(O)?.setDocumentEdited(F)}async openExternal(O,F){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(F),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(O,F){return L.shell.trashItem(F)}async isAdmin(){let O;return w.isWindows?O=(await new Promise((F,$)=>{K(["native-is-elevated"],F,$)}))():O=process.getuid?.()===0,O}async writeElevated(O,F,$,re){const J=await new Promise((ae,ne)=>{K(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const se=[`"${this.cliPath}"`];re?.unlock&&se.push("--file-chmod"),se.push("--file-write",`"${F.fsPath}"`,`"${$.fsPath}"`);const G={name:this.productService.nameLong.replace("-",""),icns:w.isMacintosh&&this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};J.exec(se.join(" "),G,(V,x,W)=>{x&&this.logService.trace(`[sudo-prompt] received stdout: ${x}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),V?ne(V):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.isLinux||w.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return w.isWindows?this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):w.isLinux?this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,g.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return w.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(O,F,$){process.kill(F,$)}async readClipboardText(O,F){return L.clipboard.readText(F)}async writeClipboardText(O,F,$){return L.clipboard.writeText(F,$)}async readClipboardFindText(O){return L.clipboard.readFindText()}async writeClipboardFindText(O,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(O,F,$,re){return L.clipboard.writeBuffer(F,Buffer.from($.buffer),re)}async readClipboardBuffer(O,F){return b.VSBuffer.wrap(L.clipboard.readBuffer(F))}async hasClipboard(O,F,$){return L.clipboard.has(F,$)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,F){this.windowById(O)?.updateTouchBar(F)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,F){return this.lifecycleMainService.relaunch(F)}async reload(O,F){const $=this.windowById(O);if($){if((0,n.isWorkspaceIdentifier)($.openedWorkspace)){const re=$.openedWorkspace.configPath;if(re.scheme===a.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow($.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload($,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,F){const $=this.windowById(F);if($?.win)return $.win.close()}async quit(O){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(O,F){await this.lifecycleMainService.kill(F)}async resolveProxy(O,F){return this.windowById(O)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(O,F,$,re,J=1){return(0,p.findFreePort)(F,$,re,J)}async openDevTools(O,F){const $=this.windowById(O);$?.win&&$.win.webContents.openDevTools(F)}async toggleDevTools(O){const F=this.windowById(O);F?.win&&F.win.webContents.toggleDevTools();for(const $ of L.BrowserWindow.getAllWindows())$.webContents.getURL()==="about:blank"&&$.webContents.toggleDevTools()}async sendInputEvent(O,F){const $=this.windowById(O);$?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&$.win.webContents.sendInputEvent(F)}async profileRenderer(O,F,$){const re=this.windowById(O);if(!re||!re.win)throw new Error;return await new R.WindowProfiler(re.win,F,this.logService).inspect($)}async windowsGetStringRegKey(O,F,$,re){if(!w.isWindows)return;const J=await new Promise((ae,ne)=>{K(["@vscode/windows-registry"],ae,ne)});try{return J.GetStringRegKey(F,$,re)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};e.NativeHostMainService=P,Ee([M.memoize],P.prototype,"cliPath",null),e.NativeHostMainService=P=Ee([Z(0,i.IWindowsMainService),Z(1,d.IDialogMainService),Z(2,u.ILifecycleMainService),Z(3,c.IEnvironmentMainService),Z(4,t.ILogService),Z(5,l.IProductService),Z(6,s.IThemeMainService),Z(7,o.IWorkspacesManagementMainService)],P)}),define(ee[298],te([0,1,15,38,28,2,13,4,107,178,90,131,60,25,5,68,77,24,78,59,33,34,61,22,7,30,8]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const b="issue.processExplorerWindowState";let D=class{static{o=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(k,O,F,$,re,J,ae,ne,se,G,V){this.userEnv=k,this.environmentMainService=O,this.logService=F,this.diagnosticsService=$,this.diagnosticsMainService=re,this.dialogMainService=J,this.nativeHostMainService=ae,this.protocolMainService=ne,this.productService=se,this.stateService=G,this.windowsMainService=V,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async k=>{const O=[];try{O.push({name:(0,a.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach($=>{(0,g.isRemoteDiagnosticError)($)?O.push({name:$.hostName,rootProcess:$}):$.processes&&O.push({name:$.hostName,rootProcess:$.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(k,"vscode:listProcessesResponse",O)}),L.validatedIpcMain.on("vscode:workbenchCommand",(k,O)=>{const{id:F,from:$,args:re}=O;let J;switch($){case"processExplorer":J=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${$}`)}J?.webContents.send("vscode:runAction",{id:F,from:$,args:re})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",k=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async k=>{const O=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const $ of O.windows)F.push([$.pid,`window [${$.id}] (${$.title})`]);for(const{pid:$,name:re}of t.UtilityProcess.getAll())F.push([$,re]);this.safeSend(k,"vscode:pidToNameResponse",F)})}async openReporter(k){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),$=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow($,F,{backgroundColor:k.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:k.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:k,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:p.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,O.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,O.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(k){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),$=this.stateService.getItem(b,void 0),re=R($)?$:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(re,F,{backgroundColor:k.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:k.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:k,product:p.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,O.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,O.dispose())});const J=()=>{if(!this.processExplorerWindow)return;const ae=this.processExplorerWindow.getSize(),ne=this.processExplorerWindow.getPosition();if(!ae||!ne)return;const se={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.stateService.setItem(b,se)};this.processExplorerWindow.on("moved",J),this.processExplorerWindow.on("resized",J)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const k=await I.contentTracing.stopRecording(`${(0,E.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,k),buttons:[(0,a.localize)(5,null)]},I.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,k)}async getSystemStatus(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(k,O)}async $getSystemInfo(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(k,O)}async $getPerformanceInfo(){try{const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(k,O)}catch(k){throw this.logService.warn("issueService#getPerformanceInfo ",k.message),k}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(k){this.logService.error(k)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.issueReporterWindow);k===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.issueReporterWindow);return k===0}return!1}async $getIssueReporterUri(k){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const O=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!O)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${O.id}`;return n.Promises.withAsyncBody(async($,re)=>{const J=new l.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:F,extensionId:k}),L.validatedIpcMain.once(F,(ae,ne)=>{$(s.URI.parse(ne))});try{await(0,n.timeout)(5e3),J.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(F)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(k){k.isMinimized()&&k.restore(),k.focus()}safeSend(k,O,...F){k.sender.isDestroyed()||k.sender.send(O,...F)}createBrowserWindow(k,O,F,$){const re=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:k.width,height:k.height,minWidth:300,minHeight:200,x:k.x,y:k.y,title:F.title,backgroundColor:F.backgroundColor||o.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}getWindowPosition(k,O,F){let $;const re=I.screen.getAllDisplays();if(re.length===1)$=re[0];else{if(C.isMacintosh){const ne=I.screen.getCursorScreenPoint();$=I.screen.getDisplayNearestPoint(ne)}!$&&k&&($=I.screen.getDisplayMatching(k.getBounds())),$||($=I.screen.getPrimaryDisplay()||re[0])}const J=$.bounds,ae={width:O,height:F,x:J.x+J.width/2-O/2,y:J.y+J.height/2-F/2};return J.width>0&&J.height>0&&(ae.x<J.x&&(ae.x=J.x),ae.y<J.y&&(ae.y=J.y),ae.x>J.x+J.width&&(ae.x=J.x),ae.y>J.y+J.height&&(ae.y=J.y),ae.width>J.width&&(ae.width=J.width),ae.height>J.height&&(ae.height=J.height)),ae}};e.IssueMainService=D,e.IssueMainService=D=o=Ee([Z(1,f.IEnvironmentMainService),Z(2,y.ILogService),Z(3,g.IDiagnosticsService),Z(4,w.IDiagnosticsMainService),Z(5,S.IDialogMainService),Z(6,v.INativeHostMainService),Z(7,d.IProtocolMainService),Z(8,m.IProductService),Z(9,u.IStateService),Z(10,i.IWindowsMainService)],D);function R(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(ee[299],te([0,1,22,17,25,20,5,68,24,50,26,48,100]),function(K,e,I,L,r,_,M,C,h,a,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(v,p,m,d,c,E,u,t){super(v,p,d,c,E,t),this.telemetryService=m,this.nativeHostMainService=u}buildUpdateFeedUrl(v){return(0,S.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){this.url&&(this.setState(w.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},I.CancellationToken.None).then(a.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(w.State.Idle(1))):this.setState(w.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const m=v?p.message||p:void 0;this.setState(w.State.Idle(1,m))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(w.State.Idle(1))}};e.LinuxUpdateService=f,e.LinuxUpdateService=f=Ee([Z(0,_.ILifecycleMainService),Z(1,L.IConfigurationService),Z(2,g.ITelemetryService),Z(3,r.IEnvironmentMainService),Z(4,a.IRequestService),Z(5,M.ILogService),Z(6,C.INativeHostMainService),Z(7,h.IProductService)],f)}),define(ee[300],te([0,1,47,45,28,8,22,54,9,7,142,21,17,25,16,20,5,68,24,50,26,48,100]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(o,b=1e3){for(;!o();)await(0,_.timeout)(b)}let s;function i(){return typeof s>"u"&&(L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?s=0:h.basename(h.normalize(h.join(process.execPath,"..","..")))==="Program Files"?s=3:s=1),s}let n=class extends t.AbstractUpdateService{get cachePath(){const b=h.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return w.Promises.mkdir(b,{recursive:!0}).then(()=>b)}constructor(b,D,R,P,k,O,F,$,re){super(b,D,P,k,O,re),this.telemetryService=R,this.fileService=F,this.nativeHostMainService=$,b.setRelaunchHandler(this)}handleRelaunch(b){return b?.addArgs||b?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(u.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(b){let D="win32";switch(process.arch!=="ia32"&&(D+=`-${process.arch}`),i()){case 1:D+="-archive";break;case 3:D+="-msi";break;default:this.productService.target==="user"&&(D+="-user")}return(0,t.createUpdateURL)(D,b,this.productService)}doCheckForUpdates(b){this.url&&(this.setState(u.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},M.CancellationToken.None).then(c.asJson).then(D=>{const R=i();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(P=>w.Promises.exists(P).then(k=>{if(k)return Promise.resolve(P);const O=D.url,F=D.hash,$=`${P}.tmp`;return this.requestService.request({url:O},M.CancellationToken.None).then(re=>this.fileService.writeFile(a.URI.file($),re.stream)).then(F?()=>(0,g.checksum)($,D.hash):()=>{}).then(()=>w.Promises.rename($,P,!1)).then(()=>P)})).then(P=>{const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:P},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const R=b?D.message||D:void 0;this.setState(u.State.Idle(i(),R))}))}async doDownloadUpdate(b){b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(u.State.Idle(i()))}async getUpdatePackagePath(b){const D=await this.cachePath;return h.join(D,`CodeSetup-${this.productService.quality}-${b}.exe`)}async cleanup(b=null){const D=b?O=>!new RegExp(`${this.productService.quality}-${b}\\.exe$`).test(O):()=>!0,R=await this.cachePath,k=(await w.Promises.readdir(R)).filter(D).map(async O=>{try{await w.Promises.unlink(h.join(R,O))}catch{}});await Promise.all(k)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const b=this.state.update;this.setState(u.State.Updating(b));const D=await this.cachePath;this.availableUpdate.updateFilePath=h.join(D,`CodeSetup-${this.productService.quality}-${b.version}.flag`),await w.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(i()))});const P=`${this.productService.win32MutexName}-ready`,k=await new Promise((O,F)=>{K(["@vscode/windows-mutex"],O,F)});l(()=>k.isActive(P)).then(()=>this.setState(u.State.Ready(b)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):i()==3?(0,I.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(b){if(this.state.type!=="idle")return;const D=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.setState(u.State.Downloading(R)),this.availableUpdate={packagePath:b},D?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(R)):this.setState(u.State.Ready(R))}};e.Win32UpdateService=n,Ee([C.memoize],n.prototype,"cachePath",null),e.Win32UpdateService=n=Ee([Z(0,v.ILifecycleMainService),Z(1,S.IConfigurationService),Z(2,E.ITelemetryService),Z(3,f.IEnvironmentMainService),Z(4,c.IRequestService),Z(5,p.ILogService),Z(6,y.IFileService),Z(7,m.INativeHostMainService),Z(8,d.IProductService)],n)}),define(ee[301],te([0,1,15,8,22,49,3,2,13,65,4,7,188,64,17,60,25,63,16,20,5,24,78,250,80,26,102,67,59,30,29,53,95,134,39,34,52,66,23,6]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R,P,k,O,F,$,re,J,ae,ne){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(G||(G={}));let V=class extends C.Disposable{static{se=this}static{this.windowControlHeightStateStorageKey="windowControlHeight"}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,R.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,U,H,Q,ie,oe,N,A,T,q,B,z,j,ce,fe,ue,he,ye,we,Se,De){super(),this.logService=U,this.loggerMainService=H,this.environmentMainService=Q,this.policyService=ie,this.userDataProfilesService=oe,this.fileService=N,this.applicationStorageMainService=A,this.storageMainService=T,this.configurationService=q,this.themeMainService=B,this.workspacesManagementMainService=z,this.backupMainService=j,this.telemetryService=ce,this.dialogMainService=fe,this.lifecycleMainService=ue,this.productService=he,this.protocolMainService=ye,this.windowsMainService=we,this.stateService=Se,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Ne,pe]=this.restoreWindowState(W.state);this.windowState=Ne,this.logService.trace("window#ctor: using window state",Ne);const ve=this.windowState.mode===0||this.windowState.mode===3,Y=this.configurationService.getValue("window"),le=De.invokeFunction(D.defaultBrowserWindowOptions,this.windowState,{show:!ve,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});g.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1);const ge=g.isMacintosh&&Y?.nativeTabs===!0;ge&&(le.tabbingIdentifier=this.productService.nameShort);const Me=(0,b.getTitleBarStyle)(this.configurationService)==="custom";if(Me&&(le.titleBarStyle="hidden",g.isMacintosh||(le.frame=!1),(0,b.useWindowControlsOverlay)(this.configurationService))){const Re=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Fe=O.Color.fromHex(Re).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:Re,symbolColor:Fe},this.hasWindowControlOverlay=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(le),(0,a.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,g.isMacintosh&&Me&&this._win.setSheetOffset(22),Me&&(g.isWindows&&(0,b.useWindowControlsOverlay)(this.configurationService)||g.isMacintosh)){const Re=this.stateService.getItem(se.windowControlHeightStateStorageKey);Re&&this.updateWindowControls({height:Re})}g.isWindows&&Me&&this._win.hookWindowMessage(278,()=>{const[Fe,Ae]=this._win.getPosition(),ze=I.screen.getCursorScreenPoint(),Be=ze.x-Fe,X=ze.y-Ae;return(()=>!(Be>30&&X>=0&&X<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Be,y:X})),0}),(g.isMacintosh||g.isWindows)&&pe&&(!ge||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Re=>typeof Re=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ve&&((0,a.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3?(this.logConditionally("WindowMode.Fullscreen"),this.setFullScreen(!0)):this.logConditionally("WindowMode.Maximized"),this._win.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}logConditionally(W){this.configurationService.getValue("window.logFullScreenTransitions")&&this.logService.info(`window-fullscreen-bug: ${W})`)}setRepresentedFilename(W){g.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){g.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){g.isMacintosh&&W?.force&&I.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function U(){H.dispose(),Q.dispose(),W()}const H=this.onDidClose(()=>U()),Q=this.onWillLoad(()=>U())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,H)=>this.onWindowError(2,{...H})),this._win.webContents.on("did-fail-load",(U,H,Q)=>this.onWindowError(3,{reason:Q,exitCode:H})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this._config&&(this._config.maximized=!0),I.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this._config&&(this._config.maximized=!1),I.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.logConditionally(`enter-full-screen: ${Date.now()}`),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.logConditionally(`leave-full-screen: ${Date.now()}`),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(U=>this.onConfigurationUpdated(U))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(U,H)=>{const Q=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,Q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,l.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,U){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:U?.reason,code:U?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,S.localize)(0,null),(0,S.localize)(1,null),(0,S.localize)(2,null)],message:(0,S.localize)(3,null),detail:(0,S.localize)(4,null),checkboxLabel:this._config?.workspace?(0,S.localize)(5,null):void 0},this._win);if(H!==2){const ie=H===0;await this.destroyWindow(ie,Q)}}else if(W===2){let H;U?H=(0,S.localize)(7,null,U.reason,U.exitCode??"<unknown>"):H=(0,S.localize)(6,null);const{response:Q,checkboxChecked:ie}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,S.localize)(8,null):(0,S.localize)(9,null),(0,S.localize)(10,null)],message:H,detail:this._config?.workspace?(0,S.localize)(11,null):(0,S.localize)(12,null),checkboxLabel:this._config?.workspace?(0,S.localize)(13,null):void 0},this._win),oe=Q===0;await this.destroyWindow(oe,ie)}break}}async destroyWindow(W,U){const H=this._config?.workspace;if(U&&H)try{const Q=this.storageMainService.workspaceStorage(H);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.logService.error(Q)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let Q,ie;(0,R.isSingleFolderWorkspaceIdentifier)(H)?Q={folderUri:H.uri}:(0,R.isWorkspaceIdentifier)(H)?Q={workspaceUri:H.configPath}:ie=!0,(0,ae.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:ie,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const U=this.getMenuBarVisibility();U!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=U,this.setMenuBarVisibility(U))}if(!W||W.affectsConfiguration("http.proxy")){let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=H;const Q=U||"",ie=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${Q}', bypassing '${ie}'`),this._win.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:ie,pacScript:""})}}}addTabbedWindow(W){g.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,U=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!U.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,U),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:U.isReload?3:H?2:1})}updateConfiguration(W,U){const H=(this._config??this.pendingLoadConfig)?.userEnv;if(H){const Q=(0,m.isLaunchedFromCli)(H)&&!(0,m.isLaunchedFromCli)(W.userEnv),ie=this.isExtensionDevelopmentHost;(Q||ie)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(W["disable-extensions"]=U.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),W.perfMarks=(0,a.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const U=Object.assign({},this._config);U.workspace=await this.validateWorkspaceBeforeReload(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&W&&(U.verbose=W.verbose,U.debugId=W.debugId,U.extensionEnvironment=W.extensionEnvironment,U["inspect-extensions"]=W["inspect-extensions"],U["inspect-brk-extensions"]=W["inspect-brk-extensions"],U["extensions-dir"]=W["extensions-dir"]),U.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.policyService.serialize(),U.continueOn=this.environmentMainService.continueOn,U.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},U.logLevel=this.loggerMainService.getLogLevel(),U.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,R.isWorkspaceIdentifier)(W.workspace)){const U=W.workspace.configPath;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}else if((0,R.isSingleFolderWorkspaceIdentifier)(W.workspace)){const U=W.workspace.uri;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,k.defaultWindowState)();if(this.isFullScreen){let H;try{H=I.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,k.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||Q.width,height:this.windowState.height||Q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let U;if(!g.isMacintosh&&this._win.isMaximized()?U=0:U=1,U===0?W.mode=0:W.mode=1,U===1||U===0){let H;U===1?H=this.getBounds():H=this._win.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}updateWindowControls(W){if(W.height&&this.stateService.setItem(se.windowControlHeightStateStorageKey,W.height),g.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(g.isMacintosh&&W.height!==void 0){const U=(W.height-15)/2;U?this._win.setWindowButtonPosition({x:U,y:U}):this._win.setWindowButtonPosition(null)}}restoreWindowState(W){(0,a.mark)("code/willRestoreCodeWindowState");let U=!1;if(W)try{const H=I.screen.getAllDisplays();U=H.length>1,W=this.validateWindowState(W,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[W||(0,k.defaultWindowState)(),U]}validateWindowState(W,U){if(this.logService.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const ie=this.getWorkingArea(U[0]);if(ie){let oe=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!ie||(W.x<ie.x&&(W.x=ie.x),W.y<ie.y&&(W.y=ie.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",ie),oe(),W.width>ie.width&&(W.width=ie.width),W.height>ie.height&&(W.height=ie.height),W.x>ie.x+ie.width-128&&(W.x=ie.x+ie.width-W.width),W.y>ie.y+ie.height-128&&(W.y=ie.y+ie.height-W.height),oe()}return W}if(W.display&&W.mode===3){const ie=U.find(oe=>oe.id===W.display);if(ie&&typeof ie.bounds?.x=="number"&&typeof ie.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,k.defaultWindowState)(3);return oe.x=ie.bounds.x,oe.y=ie.bounds.y,oe}}let H,Q;try{H=I.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),Q=this.getWorkingArea(H)}catch{}if(H&&Q&&W.x+W.width>Q.x&&W.y+W.height>Q.y&&W.x<Q.x+Q.width&&W.y<Q.y+Q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Q),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,U]=this._win.getPosition(),[H,Q]=this._win.getSize();return{x:W,y:U,width:H,height:Q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){if(this.logConditionally(`isFullScreen(): begin at ${Date.now()}`),g.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.logConditionally(`isFullScreen(): returning transientIsNativeFullScreen = ${this.transientIsNativeFullScreen}`),this.transientIsNativeFullScreen;const W=this._win.isFullScreen(),U=this._win.isSimpleFullScreen();return this.logConditionally(`isFullScreen(): returning natively, isFullScreen = ${W}, isSimpleFullScreen = ${U}`),W||U}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){g.isMacintosh&&(this.logConditionally(`doSetNativeFullScreen(${W}): begin at ${Date.now()}`),this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>{this.logConditionally(`doSetNativeFullScreen(${W}): finish at ${Date.now()}`),this.transientIsNativeFullScreen=void 0})),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,b.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,U=!0){g.isMacintosh||(W==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,S.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const U=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!U),this._win.autoHideMenuBar=U;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(W,U,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{U.isCancellationRequested||this.send(W,...H)})}send(W,...U){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...U)}catch(H){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,_.toErrorMessage)(H)}`)}}}updateTouchBar(W){g.isMacintosh&&this.touchBarGroups.forEach((U,H)=>{const Q=W[H];U.segments=this.createTouchBarGroupSegments(Q)})}createTouchBar(){if(g.isMacintosh){for(let W=0;W<10;W++){const U=this.createTouchBarGroup();this.touchBarGroups.push(U)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const U=this.createTouchBarGroupSegments(W),H=new I.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:H.segments[Q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(W=[]){return W.map(H=>{let Q;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===h.Schemas.file&&(Q=I.nativeImage.createFromPath(w.URI.revive(H.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let ie;return typeof H.title=="string"?ie=H.title:ie=H.title.value,{id:H.id,label:Q?void 0:ie,icon:Q}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};e.CodeWindow=V,e.CodeWindow=V=se=Ee([Z(1,E.ILogService),Z(2,J.ILoggerMainService),Z(3,p.IEnvironmentMainService),Z(4,F.IPolicyService),Z(5,re.IUserDataProfilesMainService),Z(6,d.IFileService),Z(7,s.IApplicationStorageMainService),Z(8,s.IStorageMainService),Z(9,y.IConfigurationService),Z(10,o.IThemeMainService),Z(11,P.IWorkspacesManagementMainService),Z(12,f.IBackupMainService),Z(13,i.ITelemetryService),Z(14,v.IDialogMainService),Z(15,c.ILifecycleMainService),Z(16,u.IProductService),Z(17,t.IProtocolMainService),Z(18,D.IWindowsMainService),Z(19,$.IStateService),Z(20,ne.IInstantiationService)],V)}),define(ee[81],te([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,80,97,29,53,31]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let l=class extends C.Disposable{static{t=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(i,n,o,b){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=o,this.applicationStorageMainService=b,this._onDidChangeRecentlyOpened=this._register(new _.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const D of i)if((0,d.isRecentWorkspace)(D))!this.workspacesManagementMainService.isUntitledWorkspace(D.workspace)&&!this.containsWorkspace(n,D.workspace)&&n.push(D);else if((0,d.isRecentFolder)(D))this.containsFolder(n,D.folderUri)||n.push(D);else{const R=this.containsFile(o,D.fileUri),P=D.fileUri.scheme===h.Schemas.file&&t.COMMON_FILES_FILTER.indexOf((0,g.basename)(D.fileUri))>=0;!R&&!P&&(o.push(D),a.isWindows&&D.fileUri.scheme===h.Schemas.file&&I.app.addRecentDocument(D.fileUri.fsPath))}const b=await this.mergeEntriesFromStorage({workspaces:n,files:o});n=b.workspaces,o=b.files,n.length>t.MAX_TOTAL_RECENT_ENTRIES&&(n.length=t.MAX_TOTAL_RECENT_ENTRIES),o.length>t.MAX_TOTAL_RECENT_ENTRIES&&(o.length=t.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:o}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=R=>{const P=this.location(R);for(const k of i)if(g.extUriBiasedIgnorePathCase.isEqual(k,P))return!1;return!0},o=await this.getRecentlyOpened(),b=o.workspaces.filter(n),D=o.files.filter(n);(b.length!==o.workspaces.length||D.length!==o.files.length)&&(await this.saveRecentlyOpened({files:D,workspaces:b}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new u.ResourceMap(D=>g.extUriBiasedIgnorePathCase.getComparisonKey(D));if(i?.workspaces)for(const D of i.workspaces)n.set(this.location(D),D);const o=new u.ResourceMap(D=>g.extUriBiasedIgnorePathCase.getComparisonKey(D));if(i?.files)for(const D of i.files)o.set(this.location(D),D);const b=await this.getRecentlyOpenedFromStorage();for(const D of b.workspaces){const R=n.get(this.location(D));R?R.label=R.label??D.label:n.set(this.location(D),D)}for(const D of b.files){const R=o.get(this.location(D));R?R.label=R.label??D.label:o.set(this.location(D),D)}return{workspaces:[...n.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(t.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,d.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(t.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(i)),-1,1)}location(i){return(0,d.isRecentFolder)(i)?i.folderUri:(0,d.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(o=>(0,d.isRecentWorkspace)(o)&&o.workspace.id===n.id)}containsFolder(i,n){return!!i.find(o=>(0,d.isRecentFolder)(o)&&g.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}containsFile(i,n){return!!i.find(o=>g.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){a.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!a.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const D of I.app.getJumpListSettings().removedItems){const R=D.args;if(R){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);P&&n.push(w.URI.parse(P[2]))}}await this.removeRecentlyOpened(n);let o=!1;const b=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,t.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(D=>{const R=(0,d.isRecentWorkspace)(D)?D.workspace:D.folderUri,{title:P,description:k}=this.getWindowsJumpListLabel(R,D.label);let O;return w.URI.isUri(R)?O=`--folder-uri "${R.toString()}"`:(o=!0,O=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:k.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));b.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:b})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,M.splitRecentLabel)(n).name,description:n};if(w.URI.isUri(i))return{title:(0,g.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,g.basename)(i.configPath);return o.endsWith(c.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,M.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!a.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let D=0;D<i.workspaces.length&&o<t.MAX_MACOS_DOCK_RECENT_WORKSPACES;D++){const R=this.location(i.workspaces[D]);if(R.scheme===h.Schemas.file){const P=(0,g.originalFSPath)(R);await S.Promises.exists(P)&&(n.push(P),o++)}}const b=[];for(let D=0;D<i.files.length&&o<t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;D++){const R=this.location(i.files[D]);if(R.scheme===h.Schemas.file){const P=(0,g.originalFSPath)(R);if(t.COMMON_FILES_FILTER.includes((0,g.basename)(R))||n.includes(P))continue;await S.Promises.exists(P)&&(b.push(P),o++)}}b.reverse().forEach(D=>I.app.addRecentDocument(D)),n.reverse().forEach(D=>I.app.addRecentDocument(D))}};e.WorkspacesHistoryMainService=l,e.WorkspacesHistoryMainService=l=t=Ee([Z(0,p.ILogService),Z(1,E.IWorkspacesManagementMainService),Z(2,v.ILifecycleMainService),Z(3,m.IApplicationStorageMainService)],l)}),define(ee[302],te([0,1,15,8,22,46,4,7,179,17,25,20,5,229,68,24,34,26,48,59,30,81]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const l="menu";let s=class{static{t=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(o,b,D,R,P,k,O,F,$,re,J){this.updateService=o,this.configurationService=b,this.windowsMainService=D,this.environmentMainService=R,this.telemetryService=P,this.workspacesHistoryMainService=k,this.stateService=O,this.lifecycleMainService=F,this.logService=$,this.nativeHostMainService=re,this.productService=J,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(t.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(k,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(k,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(k,O,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(k,O,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(k,O,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.youTubeUrl;o&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(o,"openYouTubeUrl"));const b=this.productService.requestFeatureUrl;b&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(b,"openUserVoiceUrl"));const D=this.productService.reportIssueUrl;D&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(D,"openReportIssues"));const R=this.productService.licenseUrl;R&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const k=R.indexOf("?")>0?"&":"?";this.openUrl(`${R}${k}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(R,"openLicenseUrl")});const P=this.productService.privacyStatementUrl;P&&R&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(P,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,b){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(t.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){M.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){M.isMacintosh&&(this.noActiveWindow=!I.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=I.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){I.Menu.setApplicationMenu(M.isMacintosh?new I.Menu:null);return}const b=new I.Menu;let D;if(M.isMacintosh){const P=new I.Menu;D=new I.MenuItem({label:this.productService.nameShort,submenu:P}),this.setMacApplicationMenu(P),b.append(D)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const P=new I.Menu;P.append(new I.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(P)}if(this.shouldDrawMenu("File")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:P});this.setMenuById(P,"File"),b.append(k)}if(this.shouldDrawMenu("Edit")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:P});this.setMenuById(P,"Edit"),b.append(k)}if(this.shouldDrawMenu("Selection")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:P});this.setMenuById(P,"Selection"),b.append(k)}if(this.shouldDrawMenu("View")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:P});this.setMenuById(P,"View"),b.append(k)}if(this.shouldDrawMenu("Go")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:P});this.setMenuById(P,"Go"),b.append(k)}if(this.shouldDrawMenu("Run")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:P});this.setMenuById(P,"Run"),b.append(k)}if(this.shouldDrawMenu("Terminal")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:P});this.setMenuById(P,"Terminal"),b.append(k)}let R;if(this.shouldDrawMenu("Window")){const P=new I.Menu;R=new I.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:P,role:"window"}),this.setMacWindowMenu(P)}if(R&&b.append(R),this.shouldDrawMenu("Help")){const P=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:P,role:"help"});this.setMenuById(P,"Help"),b.append(k)}b.items&&b.items.length>0?I.Menu.setApplicationMenu(b):I.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const b=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),D=this.getUpdateMenuItems();let R;if(this.shouldDrawMenu("Preferences")){const ae=new I.Menu;this.setMenuById(ae,"Preferences"),R=new I.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ae})}const P=new I.Menu,k=new I.MenuItem({label:h.localize(12,null),role:"services",submenu:P}),O=new I.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new I.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new I.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new I.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ae,ne,se)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||I.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.confirmBeforeQuit(se)&&this.nativeHostMainService.quit(void 0)}})),J=[b];J.push(...D),R&&J.push(i(),R),J.push(i(),k,i(),O,F,$,i(),re),J.forEach(ae=>o.append(ae))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const b=this.configurationService.getValue("window.confirmBeforeClose");if(b==="always"||b==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:D}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,b){b.forEach(D=>{if((0,f.isMenubarMenuItemSeparator)(D))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(D)){const R=new I.Menu,P=new I.MenuItem({label:this.mnemonicLabel(D.label),submenu:R});this.setMenu(R,D.submenu.items),o.append(P)}else(0,f.isMenubarMenuItemRecentAction)(D)?o.append(this.createOpenRecentMenuItem(D)):(0,f.isMenubarMenuItemAction)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[D.id]?o.append(new I.MenuItem(this.likeAction(D.id,{label:this.mnemonicLabel(D.label),click:this.fallbackMenuHandlers[D.id]}))):o.append(this.createMenuItem(D.label,D.id,!1,D.checked)):o.append(this.createMenuItem(D.label,D.id,D.enabled!==!1,!!D.checked)):o.append(this.createMenuItem(D.label,D.id,D.enabled!==!1,!!D.checked)))})}setMenuById(o,b){this.menubarMenus&&this.menubarMenus[b]&&this.setMenu(o,this.menubarMenus[b].items)}insertCheckForUpdatesItems(o){const b=this.getUpdateMenuItems();b.length&&(b.forEach(D=>o.append(D)),o.append(i()))}createOpenRecentMenuItem(o){const b=C.URI.revive(o.uri),D=o.id,R=D==="openRecentFile"?{fileUri:b}:D==="openRecentWorkspace"?{workspaceUri:b}:{folderUri:b};return new I.MenuItem(this.likeAction(D,{label:o.label,click:async(P,k,O)=>{const F=this.isOptionClick(O);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[R],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([b])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,b,D){const R={label:this.mnemonicLabel(o),role:D,enabled:!0};return new I.MenuItem(this.withKeybinding(b,R))}setMacWindowMenu(o){const b=new I.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),D=new I.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),R=new I.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),P=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),k=[];this.currentEnableNativeTabs&&(k.push(i()),k.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),k.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),k.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),k.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),k.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[b,D,i(),P,...k,i(),R].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new I.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(o,b,D,R){const P=this.mnemonicLabel(o),k=typeof b=="function"?b:(J,ae,ne)=>{const se=J?J.userSettingsLabel:null;let G=b;Array.isArray(b)&&(G=this.isOptionClick(ne)?b[1]:b[0]),se&&ne.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:se}):this.runActionInRenderer({type:"commandId",commandId:G})},O=typeof D=="boolean"?D:this.windowsMainService.getWindowCount()>0,F=typeof R=="boolean"?R:!1,$={label:P,click:k,enabled:O};F&&($.type="checkbox",$.checked=F);let re;return typeof b=="string"?re=b:Array.isArray(b)&&(re=b[0]),M.isMacintosh&&(re==="editor.action.clipboardCutAction"?$.role="cut":re==="editor.action.clipboardCopyAction"?$.role="copy":re==="editor.action.clipboardPasteAction"&&($.role="paste"),re==="undo"?$.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?$.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(re,$))}makeContextAwareClickHandler(o,b){return(D,R,P)=>{const k=I.BrowserWindow.getFocusedWindow();if(!k)return b.inNoWindow();if(k.webContents.isDevToolsFocused()&&k.webContents.devToolsWebContents)return b.inDevTools(k.webContents.devToolsWebContents);o(D,R||k,P)}}runActionInRenderer(o){let b=I.BrowserWindow.getFocusedWindow();if(!b){const R=this.windowsMainService.getLastActiveWindow();R?.isMinimized()&&(b=R.win)}const D=b?this.windowsMainService.getWindowById(b.id):void 0;if(D){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!D.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const R={id:o.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",r.CancellationToken.None,R)}else{const R={userSettingsLabel:o.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,R)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,b){const D=typeof o=="string"?this.keybindings[o]:void 0;if(D?.label){if(D.isNative!==!1)b.accelerator=D.label,b.userSettingsLabel=D.userSettingsLabel;else if(typeof b.label=="string"){const R=b.label.indexOf("[");R>=0?b.label=`${b.label.substr(0,R)} [${D.label}]`:b.label=`${b.label} [${D.label}]`}}else b.accelerator=void 0;return b}likeAction(o,b,D=!b.accelerator){D&&(b=this.withKeybinding(o,b));const R=b.click;return b.click=(P,k,O)=>{this.reportMenuActionTelemetry(o),R?.(P,k,O)},b}openUrl(o,b){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(b)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:l})}mnemonicLabel(o){return(0,_.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};e.Menubar=s,e.Menubar=s=t=Ee([Z(0,d.IUpdateService),Z(1,a.IConfigurationService),Z(2,E.IWindowsMainService),Z(3,g.IEnvironmentMainService),Z(4,m.ITelemetryService),Z(5,u.IWorkspacesHistoryMainService),Z(6,p.IStateService),Z(7,w.ILifecycleMainService),Z(8,S.ILogService),Z(9,y.INativeHostMainService),Z(10,v.IProductService)],s);function i(){return new I.MenuItem({type:"separator"})}}),define(ee[303],te([0,1,6,20,5,302]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let M=class{constructor(h,a,g){this.instantiationService=h,this.lifecycleMainService=a,this.logService=g,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(_.Menubar)}async updateMenubar(h,a){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(a,h)}};e.MenubarMainService=M,e.MenubarMainService=M=Ee([Z(0,I.IInstantiationService),Z(1,L.ILifecycleMainService),Z(2,r.ILogService)],M)}),define(ee[304],te([0,1,15,21,130,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,189,64,17,60,25,16,6,20,5,77,78,58,34,59,301,129,297,29,98,81,53,67,39,52,66]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R,P,k,O,F,$,re,J,ae,ne,se,G,V,x,W){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(oe){return(0,J.isWorkspaceIdentifier)(oe?.workspace)}function Q(oe){return(0,J.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ie=class extends w.Disposable{static{U=this}static{this.WINDOWS=[]}constructor(N,A,T,q,B,z,j,ce,fe,ue,he,ye,we,Se,De,Ne,pe,ve){super(),this.machineId=N,this.initialUserEnv=A,this.logService=T,this.loggerService=q,this.stateService=B,this.policyService=z,this.environmentMainService=j,this.userDataProfilesMainService=ce,this.lifecycleMainService=fe,this.backupMainService=ue,this.configurationService=he,this.workspacesHistoryMainService=ye,this.workspacesManagementMainService=we,this.instantiationService=Se,this.dialogMainService=De,this.fileService=Ne,this.protocolMainService=pe,this.themeMainService=ve,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new re.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(N=>this._onDidSignalReadyWindow.fire(N.window))),this._register(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const A=new w.DisposableStore;if(A.add(h.Event.any(N.onDidClose,N.onDidDestroy)(()=>A.dispose())),N.config.extensionDevelopmentPath)for(const T of N.config.extensionDevelopmentPath)A.add(this.protocolMainService.addValidFileRoot(T));N.config.extensionTestsPath&&A.add(this.protocolMainService.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,A){const T=this.environmentMainService.args,q=A?.remoteAuthority||void 0,B=!0,z=A?.forceReuseWindow,j=!z;return this.open({...N,cli:T,forceEmpty:B,forceNewWindow:j,forceReuseWindow:z,remoteAuthority:q})}openExistingWindow(N,A){N.focus(),this.handleWaitMarkerFile(A,[N])}async open(N){this.logService.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const A=[],T=[],q=[],B=[],z=[];let j,ce=0;const fe=await this.getPathsToOpen(N);this.logService.trace("windowsManager#open pathsToOpen",fe);for(const Se of fe)Q(Se)?N.addMode?A.push(Se):T.push(Se):H(Se)?q.push(Se):Se.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),j.filesToOpenOrCreate.push(Se)):Se.backupPath?z.push({backupFolder:(0,f.basename)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):ce++;N.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),N.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&N.waitMarkerFileURI&&(j.filesToWait={paths:(0,M.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(B.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...B),z.push(...this.backupMainService.getEmptyWindowBackups())):z.length=0;const{windows:ue,filesOpenedInWindow:he}=await this.doOpen(N,q,T,z,ce,j,A);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${T.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ce})`),ue.length>1)if(he)he.focus();else{const Se=this.windowsStateHandler.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let De=!0,Ne=!0;if(Se){const pe=ue.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),De=!1,Ne=!1)}if(De)for(let pe=ue.length-1;pe>=0;pe--){const ve=ue[pe];if(!(ve.openedWorkspace&&B.some(Y=>ve.openedWorkspace&&Y.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&z.some(Y=>ve.backupPath&&Y.backupFolder===(0,f.basename)(ve.backupPath)))){ve.focus(),Ne=!1;break}}Ne&&ue[ue.length-1].focus()}const ye=j&&j.filesToDiff.length>0,we=j&&j.filesToMerge.length>0;if(!ue.some(Se=>Se.isExtensionDevelopmentHost)&&!ye&&!we&&!N.noRecentEntry){const Se=[];for(const De of fe)H(De)&&!De.transient?Se.push({label:De.label,workspace:De.workspace,remoteAuthority:De.remoteAuthority}):Q(De)?Se.push({label:De.label,folderUri:De.workspace.uri,remoteAuthority:De.remoteAuthority}):De.fileUri&&Se.push({label:De.label,fileUri:De.fileUri,remoteAuthority:De.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Se)}return this.handleWaitMarkerFile(N,ue),ue}handleWaitMarkerFile(N,A){const T=N.waitMarkerFileURI;N.context===0&&T&&A.length===1&&A[0]&&(async()=>{await A[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}async doOpen(N,A,T,q,B,z,j){const ce=[];let fe;function ue(pe,ve){ce.push(pe),ve&&(fe=pe,z=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ye}=this.shouldOpenNewWindow(N);if(!N.initialStartup&&j.length>0){const pe=j[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(pe);ve&&ue(this.doAddFoldersToExistingWindow(ve,j.map(Y=>Y.workspace.uri)))}const we=T.length+A.length+q.length;if(z&&we===0){const pe=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],ve=this.getWindows().filter(le=>z&&(0,m.isEqualAuthority)(le.remoteAuthority,z.remoteAuthority));let Y;pe?.fileUri&&!ye&&((N.context===4||N.context===0||N.context===1)&&(Y=await(0,$.findWindowOnFile)(ve,pe.fileUri,async le=>le.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(le.configPath):void 0)),Y||(Y=this.doGetLastActiveWindow(ve))),Y?(0,J.isWorkspaceIdentifier)(Y.openedWorkspace)?A.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(Y.openedWorkspace)?T.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(N,Y,z),!0):ue(await this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const Se=(0,M.distinct)(A,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,M.coalesce)(Se.map(ve=>(0,$.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(pe.length>0){const ve=pe[0],Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;ue(this.doOpenFilesInExistingWindow(N,ve,Y),!!Y),he=!0}for(const ve of Se){if(pe.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===ve.workspace.id))continue;const Y=ve.remoteAuthority,le=(0,m.isEqualAuthority)(z?.remoteAuthority,Y)?z:void 0;ue(await this.doOpenFolderOrWorkspace(N,ve,he,le),!!le),he=!0}}const De=(0,M.distinct)(T,pe=>m.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(De.length>0){const pe=(0,M.coalesce)(De.map(ve=>(0,$.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(pe.length>0){const ve=pe[0],Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;ue(this.doOpenFilesInExistingWindow(N,ve,Y),!!Y),he=!0}for(const ve of De){if(pe.some(ge=>(0,J.isSingleFolderWorkspaceIdentifier)(ge.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(ge.openedWorkspace.uri,ve.workspace.uri)))continue;const Y=ve.remoteAuthority,le=(0,m.isEqualAuthority)(z?.remoteAuthority,Y)?z:void 0;ue(await this.doOpenFolderOrWorkspace(N,ve,he,le),!!le),he=!0}}const Ne=(0,M.distinct)(q,pe=>pe.backupFolder);if(Ne.length>0)for(const pe of Ne){const ve=pe.remoteAuthority,Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve)?z:void 0;ue(await this.doOpenEmpty(N,!0,ve,Y,pe),!!Y),he=!0}if(ce.length===0||z){z&&!B&&B++;const pe=z?z.remoteAuthority:N.remoteAuthority;for(let ve=0;ve<B;ve++)ue(await this.doOpenEmpty(N,he,pe,z),!!z),he=!0}return{windows:(0,M.distinct)(ce),filesOpenedInWindow:fe}}doOpenFilesInExistingWindow(N,A,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),A.focus();const q={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToMerge:T?.filesToMerge,filesToWait:T?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return A.sendWhenReady("vscode:openFiles",C.CancellationToken.None,q),A}doAddFoldersToExistingWindow(N,A){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:A}),N.focus();const T={foldersToAdd:A};return N.sendWhenReady("vscode:addFolders",C.CancellationToken.None,T),N}doOpenEmpty(N,A,T,q,B){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:T,filesToOpen:q,forceNewWindow:A});let z;return!A&&typeof N.contextWindowId=="number"&&(z=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:T,forceNewWindow:A,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:q,windowToUse:z,emptyWindowBackupInfo:B,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}doOpenFolderOrWorkspace(N,A,T,q,B){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:A,filesToOpen:q}),!T&&!B&&typeof N.contextWindowId=="number"&&(B=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({workspace:A.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:A.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:q,windowToUse:B,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async getPathsToOpen(N){let A,T=!1,q=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(A=await this.doExtractPathsFromAPI(N),T=!0):N.forceEmpty?A=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(A=await this.doExtractPathsFromCLI(N.cli),A.length===0&&A.push(Object.create(null)),T=!0):(A=await this.doGetPathsFromLastSession(),A.length===0&&A.push(Object.create(null)),q=!0),!N.addMode&&T){const B=A.filter(z=>Q(z));if(B.length>1){const z=B[0].remoteAuthority;if(B.every(j=>(0,m.isEqualAuthority)(j.remoteAuthority,z))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(B.map(ce=>({uri:ce.workspace.uri})));A.push({workspace:j,remoteAuthority:z}),A=A.filter(ce=>!Q(ce))}}}if(N.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const B=await this.doGetPathsFromLastSession();A.unshift(...B.filter(z=>H(z)||Q(z)||z.backupPath))}return A}async doExtractPathsFromAPI(N){const A={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},T=await Promise.all((0,M.coalesce)(N.urisToOpen||[]).map(async q=>{const B=await this.resolveOpenable(q,A);if(B)return B.label=q.label,B;const z=this.resourceFromOpenable(q);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:z.scheme===S.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:z.scheme===S.Schemas.file?(0,E.localize)(3,null,(0,g.getPathLabel)(z,{os:v.OS,tildify:this.environmentMainService})):(0,E.localize)(4,null,z.toString(!0))},I.BrowserWindow.getFocusedWindow()??void 0)}));return(0,M.coalesce)(T)}async doExtractPathsFromCLI(N){const A=[],T={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},q=N["folder-uri"];if(q){const j=await Promise.all(q.map(ce=>{const fe=this.cliArgToUri(ce);if(fe)return this.resolveOpenable({folderUri:fe},T)}));A.push(...(0,M.coalesce)(j))}const B=N["file-uri"];if(B){const j=await Promise.all(B.map(ce=>{const fe=this.cliArgToUri(ce);if(fe)return this.resolveOpenable((0,J.hasWorkspaceFileExtension)(ce)?{workspaceUri:fe}:{fileUri:fe},T)}));A.push(...(0,M.coalesce)(j))}const z=await Promise.all(N._.map(j=>T.remoteAuthority?this.doResolveRemotePath(j,T):this.doResolveFilePath(j,T)));return A.push(...(0,M.coalesce)(z)),A}cliArgToUri(N){try{const A=c.URI.parse(N);if(!A.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${N}`);return}return A.path?A:A.with({path:"/"})}catch(A){this.logService.error(`Invalid URI input string: ${N}, ${A.message}`)}}async doGetPathsFromLastSession(){const N=this.getRestoreWindowsSetting();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const A=[];N!=="one"&&A.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&A.push(this.windowsStateHandler.state.lastActiveWindow);const T=await Promise.all(A.map(async q=>{if(q.workspace){const B=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(H(B))return B}else if(q.folderUri){const B=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(Q(B))return B}else if(N!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,M.coalesce)(T)}}}getRestoreWindowsSetting(){let N;return this.lifecycleMainService.wasRestarted?N="all":(N=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async resolveOpenable(N,A=Object.create(null)){const T=this.resourceFromOpenable(N);return T.scheme===S.Schemas.file?((0,O.isFileToOpen)(N)&&(A={...A,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,A)):this.doResolveRemoteOpenable(N,A)}doResolveRemoteOpenable(N,A){let T=this.resourceFromOpenable(N);const q=(0,P.getRemoteAuthority)(T)||A.remoteAuthority;if(T=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(T)),(0,O.isFileToOpen)(N)){if(A.gotoLineMode){const{path:B,line:z,column:j}=(0,a.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:B}),options:{selection:z?{startLineNumber:z,startColumn:j||1}:void 0},remoteAuthority:q}}return{fileUri:T,remoteAuthority:q}}else if((0,O.isWorkspaceToOpen)(N))return{workspace:(0,ae.getWorkspaceIdentifier)(T),remoteAuthority:q};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:q}}resourceFromOpenable(N){return(0,O.isWorkspaceToOpen)(N)?N.workspaceUri:(0,O.isFolderToOpen)(N)?N.folderUri:N.fileUri}async doResolveFilePath(N,A,T){let q,B;A.gotoLineMode&&({path:N,line:q,column:B}=(0,a.parseLineAndColumnAware)(N)),N=(0,a.sanitizeFilePath)((0,f.normalize)(N),(0,p.cwd)());try{const z=await L.Promises.stat(N);if(z.isFile()){if(!A.forceOpenWorkspaceAsFile){const j=await this.workspacesManagementMainService.resolveLocalWorkspace(c.URI.file(N));if(j)return j.transient&&A.rejectTransientWorkspaces?void 0:{workspace:{id:j.id,configPath:j.configPath},type:i.FileType.File,exists:!0,remoteAuthority:j.remoteAuthority,transient:j.transient}}return{fileUri:c.URI.file(N),type:i.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:B||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(c.URI.file(N),z),type:i.FileType.Directory,exists:!0};if(!v.isWindows&&N==="/dev/null")return{fileUri:c.URI.file(N),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!T)return this.onUNCHostNotAllowed(N,A);const j=c.URI.file(N);if(this.workspacesHistoryMainService.removeRecentlyOpened([j]),A.ignoreFileNotFound)return{fileUri:j,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(N,A){const T=c.URI.file(N),{response:q,checkboxChecked:B}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,T.authority),detail:(0,E.localize)(9,null,(0,g.getPathLabel)(T,{os:v.OS,tildify:this.environmentMainService})),checkboxLabel:(0,E.localize)(10,null,T.authority),cancelId:1});if(q===0)return(0,r.addUNCHostToAllowlist)(T.authority),B&&this.sendToOpeningWindow("vscode:configureAllowedUNCHost",T.authority),this.doResolveFilePath(N,A,!0);if(q===2)return I.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(N,A)}doResolveRemotePath(N,A){const T=N.charCodeAt(0),q=A.remoteAuthority;let B,z;A.gotoLineMode&&({path:N,line:B,column:z}=(0,a.parseLineAndColumnAware)(N)),T!==47&&((0,a.isWindowsDriveLetter)(T)&&N.charCodeAt(N.charCodeAt(1))===58&&(N=(0,a.toSlashes)(N)),N=`/${N}`);const j=c.URI.from({scheme:S.Schemas.vscodeRemote,authority:q,path:N});if(N.charCodeAt(N.length-1)!==47){if((0,J.hasWorkspaceFileExtension)(N))return A.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:B?{startLineNumber:B,startColumn:z||1}:void 0},remoteAuthority:A.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(j),remoteAuthority:q};if(A.gotoLineMode||f.posix.basename(N).indexOf(".")!==-1)return{fileUri:j,options:{selection:B?{startLineNumber:B,startColumn:z||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:q}}shouldOpenNewWindow(N){const A=this.configurationService.getValue("window"),T=A?.openFoldersInNewWindow||"default",q=A?.openFilesInNewWindow||"off";let B=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(T==="on"||T==="off")&&(B=T==="on");let z=!1;return N.forceNewWindow||N.forceReuseWindow?z=!!N.forceNewWindow&&!N.forceReuseWindow:(v.isMacintosh?N.context===1&&(z=!0):N.context!==3&&N.context!==2&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!N.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(z=q==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(N,A){const T=(0,$.findWindowOnExtensionDevelopmentPath)(this.getWindows(),N);if(T)return this.lifecycleMainService.reload(T,A.cli),T.focus(),[T];let q=A.cli["folder-uri"]||[],B=A.cli["file-uri"]||[],z=A.cli._;if(!z.length&&!q.length&&!B.length&&!A.cli.extensionTestsPath){const fe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ue=fe?.workspace??fe?.folderUri;ue&&(c.URI.isUri(ue)?ue.scheme===S.Schemas.file?z=[ue.fsPath]:q=[ue.toString()]:ue.configPath.scheme===S.Schemas.file?z=[(0,m.originalFSPath)(ue.configPath)]:B=[ue.configPath.toString()])}let j=A.remoteAuthority;for(const fe of N)if(fe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=c.URI.parse(fe),he=(0,P.getRemoteAuthority)(ue);he&&(j?(0,m.isEqualAuthority)(he,j)||this.logService.error("more than one extension development path authority"):j=he)}z=z.filter(fe=>{const ue=c.URI.file(fe);return(0,$.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),j)}),q=q.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,$.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),j):!1}),B=B.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,$.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),j):!1}),A.cli._=z,A.cli["folder-uri"]=q,A.cli["file-uri"]=B;const ce={context:A.context,cli:A.cli,forceNewWindow:!0,forceEmpty:!z.length&&!q.length&&!B.length,userEnv:A.userEnv,noRecentEntry:!0,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:j,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile};return this.open(ce)}async openInBrowserWindow(N){const A=this.configurationService.getValue("window"),T=this.getLastActiveWindow(),q=T?.profile??this.userDataProfilesMainService.defaultProfile;let B;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(B=N.windowToUse||T,B&&B.focus());const z={...this.environmentMainService.args,...N.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:q},homeDir:this.environmentMainService.userHome.with({scheme:S.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:S.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.initialUserEnv,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:S.Schemas.file}).fsPath,product:D.default,isInitialStartup:N.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,_.release)(),hostname:(0,_.hostname)(),arch:(0,_.arch)()},zoomLevel:typeof A?.zoomLevel=="number"?A.zoomLevel:void 0,autoDetectHighContrast:A?.autoDetectHighContrast??!0,autoDetectColorScheme:A?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(B){const j=B.config;!z.extensionDevelopmentPath&&j?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=j.extensionDevelopmentPath,z.extensionDevelopmentKind=j.extensionDevelopmentKind,z["enable-proposed-api"]=j["enable-proposed-api"],z.verbose=j.verbose,z["inspect-extensions"]=j["inspect-extensions"],z["inspect-brk-extensions"]=j["inspect-brk-extensions"],z.debugId=j.debugId,z.extensionEnvironment=j.extensionEnvironment,z["extensions-dir"]=j["extensions-dir"],z["disable-extensions"]=j["disable-extensions"]),z.loggers={global:z.loggers.global,window:j?.loggers.window??z.loggers.window}}else{const j=this.windowsStateHandler.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const ce=B=this.instantiationService.createInstance(F.CodeWindow,{state:j,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),U.WINDOWS.push(ce),this._onDidOpenWindow.fire(ce),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const fe=new w.DisposableStore;fe.add(ce.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(ce))),fe.add(h.Event.once(ce.onDidClose)(()=>this.onWindowClosed(ce,fe))),fe.add(h.Event.once(ce.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ce))),fe.add(ce.onDidTriggerSystemContextMenu(({x:he,y:ye})=>this._onDidTriggerSystemContextMenu.fire({window:ce,x:he,y:ye})));const ue=(0,d.assertIsDefined)(ce.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ce)),this.lifecycleMainService.registerWindow(ce)}return z.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(async j=>{j||await this.doOpenInBrowserWindow(B,z,N,q)}):await this.doOpenInBrowserWindow(B,z,N,q),B}async doOpenInBrowserWindow(N,A,T,q){if(A.extensionDevelopmentPath||((0,J.isWorkspaceIdentifier)(A.workspace)?A.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:A.workspace,remoteAuthority:A.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(A.workspace)?A.backupPath=this.backupMainService.registerFolderBackup({folderUri:A.workspace.uri,remoteAuthority:A.remoteAuthority}):A.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:T.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:A.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const B=A.workspace??(0,J.toWorkspaceIdentifier)(A.backupPath,!1),z=this.resolveProfileForBrowserWindow(T,B,q),j=z instanceof Promise?await z:z;A.profiles.profile=j,A.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(B,j)}N.load(A)}resolveProfileForBrowserWindow(N,A,T){return N.forceProfile?this.userDataProfilesMainService.profiles.find(q=>q.name===N.forceProfile)??this.userDataProfilesMainService.createNamedProfile(N.forceProfile):N.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(A)??T}onWindowClosed(N,A){const T=U.WINDOWS.indexOf(N);U.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),A.dispose()}getFocusedWindow(){const N=I.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(N){return this.doGetLastActiveWindow(this.getWindows().filter(A=>(0,m.isEqualAuthority)(A.remoteAuthority,N)))}doGetLastActiveWindow(N){const A=Math.max.apply(Math,N.map(T=>T.lastFocusTime));return N.find(T=>T.lastFocusTime===A)}sendToFocused(N,...A){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,C.CancellationToken.None,...A)}sendToOpeningWindow(N,...A){this._register(h.Event.once(this.onDidSignalReadyWindow)(T=>{T.sendWhenReady(N,C.CancellationToken.None,...A)}))}sendToAll(N,A,T){for(const q of this.getWindows())T&&T.indexOf(q.id)>=0||q.sendWhenReady(N,C.CancellationToken.None,A)}getWindows(){return U.WINDOWS}getWindowCount(){return U.WINDOWS.length}getWindowById(N){const A=this.getWindows().filter(T=>T.id===N);return(0,M.firstOrDefault)(A)}getWindowByWebContents(N){const A=I.BrowserWindow.fromWebContents(N);if(A)return this.getWindowById(A.id)}};e.WindowsMainService=ie,e.WindowsMainService=ie=U=Ee([Z(2,b.ILogService),Z(3,W.ILoggerMainService),Z(4,k.IStateService),Z(5,V.IPolicyService),Z(6,s.IEnvironmentMainService),Z(7,x.IUserDataProfilesMainService),Z(8,o.ILifecycleMainService),Z(9,u.IBackupMainService),Z(10,t.IConfigurationService),Z(11,ne.IWorkspacesHistoryMainService),Z(12,se.IWorkspacesManagementMainService),Z(13,n.IInstantiationService),Z(14,l.IDialogMainService),Z(15,i.IFileService),Z(16,R.IProtocolMainService),Z(17,G.IThemeMainService)],ie)}),define(ee[305],te([0,1,64,30,81,53]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(h,a,g,w){this.workspacesManagementMainService=h,this.windowsMainService=a,this.workspacesHistoryMainService=g,this.backupMainService=w,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,a){const g=this.windowsMainService.getWindowById(h);if(g)return this.workspacesManagementMainService.enterWorkspace(g,this.windowsMainService.getWindows(),a)}createUntitledWorkspace(h,a,g){return this.workspacesManagementMainService.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(h,a){return this.workspacesManagementMainService.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(h,a){return this.workspacesManagementMainService.getWorkspaceIdentifier(a)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,a){return this.workspacesHistoryMainService.addRecentlyOpened(a)}removeRecentlyOpened(h,a){return this.workspacesHistoryMainService.removeRecentlyOpened(a)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=M,e.WorkspacesMainService=M=Ee([Z(0,_.IWorkspacesManagementMainService),Z(1,L.IWindowsMainService),Z(2,r.IWorkspacesHistoryMainService),Z(3,I.IBackupMainService)],M)}),define(ee[306],te([0,1,15,130,38,28,18,49,14,33,3,44,46,2,13,9,4,12,7,32,156,42,157,110,288,160,64,281,17,198,90,131,60,116,218,25,63,93,207,291,209,210,211,16,222,92,75,6,91,217,298,282,289,20,5,303,68,24,58,292,94,34,273,80,122,26,249,251,51,48,263,286,299,287,300,127,265,266,267,270,295,30,304,272,29,97,81,305,53,39,231,52,242,50,79,128,275,290,278,8,253,274,226,66,294,269,23,125,293,261,237,83,296]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R,P,k,O,F,$,re,J,ae,ne,se,G,V,x,W,U,H,Q,ie,oe,N,A,T,q,B,z,j,ce,fe,ue,he,ye,we,Se,De,Ne,pe,ve,Y,le,ge,Me,Re,Fe,Ae,ze,Be,X,de,me,be,Le,Ue,Oe,We,$e,He,je,Je,Xe,it,nt,pt,vt,wt,St,yt,bt,Et,st,Pt,It,Ct,kt,ot,Dt,dt,at,Mt,Rt,ct,Lt,ht){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ut=class extends f.Disposable{static{lt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,ke,Pe,Ie,_e,Te,qe,Qe,Ge,xe,Ve,Ke){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=ke,this.mainInstantiationService=Pe,this.logService=Ie,this.loggerService=_e,this.environmentMainService=Te,this.lifecycleMainService=qe,this.configurationService=Qe,this.stateService=Ge,this.fileService=xe,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const Ce=xe=>xe?.startsWith(`${y.Schemas.vscodeWebview}://`),ke=new Set(this.productService.quality==="stable"?[]:["media"]),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((xe,Ve,Ke,Ye)=>Ce(Ye.requestingUrl)?Ke(Pe.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.VSCODE_AUTHORITY}/`?Ke(ke.has(Ve)):Ke(!1)),I.session.defaultSession.setPermissionCheckHandler((xe,Ve,Ke,Ye)=>Ce(Ye.requestingUrl)?Pe.has(Ve):Ye.isMainFrame&&Ye.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.VSCODE_AUTHORITY}/`?ke.has(Ve):!1);const Ie=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),_e=xe=>{for(let Ve=xe;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Te=xe=>xe.resourceType==="xhr"||_e(xe.frame),qe=xe=>{const Ve=xe.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=I.BrowserWindow.getAllWindows();for(const Ye of Ke)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Qe=(xe,Ve)=>{if(xe.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&Ke.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((xe,Ve)=>{const Ke=d.URI.parse(xe.url);return Ke.scheme===y.Schemas.vscodeWebview&&!Qe(Ke,xe)?(this.logService.error("Blocked vscode-webview request",xe.url),Ve({cancel:!0})):Ke.scheme===y.Schemas.vscodeFileResource&&!qe(xe)?(this.logService.error("Blocked vscode-file request",xe.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Ie.has(Ke.scheme)?Ve({cancel:!Te(xe)}):Ve({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((xe,Ve)=>{const Ke=xe.responseHeaders,Ye=Ke["content-type"]||Ke["Content-Type"];if(Ye&&Array.isArray(Ye)){const Ze=d.URI.parse(xe.url);if(Ze.path.endsWith(".svg")&&Ie.has(Ze.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!Ze.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(et=>et.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(xe)})}return Ve({cancel:!1})});const Ge=I.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ge.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome")),p.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Pe=>this.onUnexpectedError(Pe)),process.on("uncaughtException",Pe=>{(0,h.isSigPipeError)(Pe)||(0,h.onUnexpectedError)(Pe)}),process.on("unhandledRejection",Pe=>(0,h.onUnexpectedError)(Pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Pe,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),I.app.on("activate",async(Pe,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Pe,Ie)=>{Ie?.opener?.url.startsWith(`${y.Schemas.vscodeFileResource}://${y.VSCODE_AUTHORITY}/`)&&this.mainInstantiationService.createInstance(ht.AuxiliaryWindow,Ie),Ie.on("will-navigate",Te=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Te.preventDefault()}),Ie.setWindowOpenHandler(Te=>Te.url==="about:blank"?(this.logService.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:ht.AuxiliaryWindow.open(this.mainInstantiationService)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Te.url}}`),this.nativeHostMainService?.openExternal(void 0,Te.url),{action:"deny"}))});let Ce=[],ke;I.app.on("open-file",(Pe,Ie)=>{this.logService.trace("app#open-file: ",Ie),Pe.preventDefault(),Ce.push((0,We.hasWorkspaceFileExtension)(Ie)?{workspaceUri:d.URI.file(Ie)}:{fileUri:d.URI.file(Ie)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],ke=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",Pe=>{const Ie=this.windowsMainService?.getWindowByWebContents(Pe.sender);let _e,Te;return Ie?.config?(_e=Ie.config,Te={...process.env,...Ie.config.userEnv}):(_e=this.environmentMainService.args,Te=process.env),this.resolveShellEnvironment(_e,Te,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Pe,Ie,_e)=>{const Te=this.validateNlsPath([Ie]);if(!Te||typeof _e!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Te,M.VSBuffer.fromString(_e))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Pe,...Ie)=>{const _e=this.validateNlsPath(Ie);if(!_e)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(_e)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Pe=>Pe.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Pe=>Pe.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Pe=>Pe.sender.reload())}validateNlsPath(Ce){let ke;for(const Pe of Ce)typeof Pe=="string"&&(typeof ke!="string"?ke=Pe:ke=(0,v.join)(ke,Pe));if(!(typeof ke!="string"||!(0,v.isAbsolute)(ke)||!(0,a.isEqualOrParent)(ke,this.environmentMainService.cachedLanguagesPath,!p.isLinux)))return d.URI.file(ke)}onUnexpectedError(Ce){if(Ce){const ke={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;p.isWindows&&Ce&&I.app.setAppUserModelId(Ce);try{p.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ge){this.logService.error(Ge)}const ke=new t.Server;this.lifecycleMainService.onWillShutdown(Ge=>{Ge.reason===2&&ke.dispose()}),this.logService.trace("Resolving machine identifier...");const Pe=await(0,Pt.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${Pe}`);const{sharedProcessReady:Ie,sharedProcessClient:_e}=this.setupSharedProcess(Pe),Te=await this.initServices(Pe,Ie);this._register(Te.createInstance(s.ProxyAuthHandler)),this._register(Te.createInstance(bt.UserDataProfilesHandler)),Te.invokeFunction(Ge=>this.initChannels(Ge,ke,_e));const qe=await Te.invokeFunction(Ge=>this.setupProtocolUrlHandlers(Ge,ke));this.setupManagedRemoteResourceUrlHandler(ke),this.lifecycleMainService.phase=2,await Te.invokeFunction(Ge=>this.openFirstWindow(Ge,qe)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new st.RunOnceScheduler(()=>{this._register((0,st.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ce,ke){const Pe=this.windowsMainService=Ce.get(Le.IWindowsMainService),Ie=Ce.get(ze.IURLService),_e=this.nativeHostMainService=Ce.get(j.INativeHostMainService),Te=Ce.get(k.IDialogMainService),qe=this;Ie.registerHandler({async handleURL(Ye,Ze){return qe.handleProtocolUrl(Pe,Te,Ie,Ye,Ze)}});const Qe=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:_e.onDidOpenWindow,onDidFocusWindow:_e.onDidFocusWindow,getActiveWindowId:()=>_e.getActiveWindowId(-1)})),Ge=new u.StaticRouter(Ye=>Qe.getActiveClientId().then(Ze=>Ye===Ze)),xe=new Be.URLHandlerRouter(Ge,this.logService),Ve=ke.getChannel("urlHandler",xe);Ie.registerHandler(new Be.URLHandlerChannelClient(Ve));const Ke=await this.resolveInitialProtocolUrls(Pe,Te);return this._register(new de.ElectronURLListener(Ke?.urls,Ie,Pe,this.environmentMainService,this.productService,this.logService)),Ke}setupManagedRemoteResourceUrlHandler(Ce){const ke=()=>({statusCode:404,data:"Not found"}),Pe=new Lt.Lazy(()=>Ce.getChannel(ct.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ct.NodeRemoteResourceRouter));I.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Ie,_e)=>{const Te=d.URI.parse(Ie.url);if(!Te.authority.startsWith("window:"))return _e(ke());Pe.value.call(ct.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Te]).then(qe=>_e({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.logService.warn("error dispatching remote resource call",qe),_e({statusCode:500,data:String(qe)})})})}async resolveInitialProtocolUrls(Ce,ke){const Pe=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Pe.length+Ie.length===0)return;const _e=[...Pe,...Ie].map(Qe=>{try{return{uri:d.URI.parse(Qe),originalUrl:Qe}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Qe);return}}),Te=[],qe=[];for(const Qe of _e){if(!Qe)continue;if(await this.shouldBlockURI(Qe.uri,Ce,ke)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Qe.uri.toString(!0));continue}const Ge=this.getWindowOpenableFromProtocolUrl(Qe.uri);Ge?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Qe.uri.toString(!0),Ge),Te.push(Ge)):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Qe.uri.toString(!0)),qe.push(Qe))}return{urls:qe,openables:Te}}async shouldBlockURI(Ce,ke,Pe){if(Ce.authority!==y.Schemas.file&&Ce.authority!==y.Schemas.vscodeRemote||this.configurationService.getValue(lt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Ce.authority])===!1)return!1;const{response:_e,checkboxChecked:Te}=await Pe.showMessageBox({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,Ce.authority===y.Schemas.file?(0,S.getPathLabel)(Ce,{os:p.OS,tildify:this.environmentMainService}):Ce.toString(!0),this.productService.nameShort),detail:(0,i.localize)(3,null),checkboxLabel:(0,i.localize)(4,null),cancelId:1});return _e!==0?!0:(Te&&ke.sendToOpeningWindow("vscode:disablePromptForProtocolHandling",Ce.authority===y.Schemas.file?"local":"remote"),!1)}getWindowOpenableFromProtocolUrl(Ce){if(Ce.path){if(Ce.authority===y.Schemas.file){const ke=d.URI.file(Ce.fsPath);return(0,We.hasWorkspaceFileExtension)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Ce.authority===y.Schemas.vscodeRemote){const ke=Ce.path.indexOf(v.posix.sep,1);if(ke!==-1){const Pe=Ce.path.substring(1,ke),Ie=Ce.path.substring(ke);let _e=Ce.query;const Te=new URLSearchParams(Ce.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),_e=Te.toString());const qe=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:Pe,path:Ie,query:_e,fragment:Ce.fragment});return(0,We.hasWorkspaceFileExtension)(Ie)?{workspaceUri:qe}:/:[\d]+$/.test(Ie)?{fileUri:qe}:{folderUri:qe}}}}}async handleProtocolUrl(Ce,ke,Pe,Ie,_e){if(this.logService.trace("app#handleProtocolUrl():",Ie.toString(!0),_e),Ie.scheme===this.productService.urlProtocol&&Ie.path==="workspace"&&(Ie=Ie.with({authority:"file",path:d.URI.parse(Ie.query).path,query:""})),await this.shouldBlockURI(Ie,Ce,ke))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Ie.toString(!0)),!0;let Te=!1;const qe=new URLSearchParams(Ie.query);qe.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ie.toString(!0)),qe.delete("windowId"),Ie=Ie.with({query:qe.toString()}),Te=!0):p.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ie.toString(!0)),Te=!0);const Qe=qe.get("continueOn");Qe!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ie.toString(!0)),qe.delete("continueOn"),Ie=Ie.with({query:qe.toString()}),this.environmentMainService.continueOn=Qe??void 0);const Ge=this.getWindowOpenableFromProtocolUrl(Ie);return Ge?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Ge,Ie.toString(!0)),(0,dt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Ge],forceNewWindow:Te,gotoLineMode:!0}))?.focus(),!0):Te?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ie.toString(!0)),await(0,dt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(Ie)}))?.ready(),Pe.open(Ie,_e)):(this.logService.trace("app#handleProtocolUrl(): not handled",Ie.toString(!0),_e),!1)}setupSharedProcess(Ce){const ke=this._register(this.mainInstantiationService.createInstance(ue.SharedProcess,Ce)),Pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const _e=await ke.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(_e,"main")})();return{sharedProcessReady:(async()=>(await ke.whenReady(),Pe))(),sharedProcessClient:Pe}}async initServices(Ce,ke){const Pe=new ie.ServiceCollection;switch(process.platform){case"win32":Pe.set(le.IUpdateService,new H.SyncDescriptor(Ae.Win32UpdateService));break;case"linux":p.isLinuxSnap?Pe.set(le.IUpdateService,new H.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(le.IUpdateService,new H.SyncDescriptor(Re.LinuxUpdateService));break;case"darwin":Pe.set(le.IUpdateService,new H.SyncDescriptor(Me.DarwinUpdateService));break}Pe.set(Le.IWindowsMainService,new H.SyncDescriptor(Ue.WindowsMainService,[Ce,this.userEnv],!1));const Ie=new k.DialogMainService(this.logService,this.productService);Pe.set(k.IDialogMainService,Ie),Pe.set(T.ILaunchMainService,new H.SyncDescriptor(T.LaunchMainService,void 0,!1)),Pe.set(P.IDiagnosticsMainService,new H.SyncDescriptor(P.DiagnosticsMainService,void 0,!1)),Pe.set(R.IDiagnosticsService,u.ProxyChannel.toService((0,u.getDelayedChannel)(ke.then(Ge=>Ge.getChannel("diagnostics"))))),Pe.set(oe.IIssueMainService,new H.SyncDescriptor(N.IssueMainService,[this.userEnv])),Pe.set(O.IEncryptionMainService,new H.SyncDescriptor(F.EncryptionMainService)),Pe.set(A.IKeyboardLayoutMainService,new H.SyncDescriptor(A.KeyboardLayoutMainService)),Pe.set(j.INativeHostMainService,new H.SyncDescriptor(j.NativeHostMainService,void 0,!1)),Pe.set(me.IWebviewManagerService,new H.SyncDescriptor(be.WebviewMainService)),Pe.set(z.IMenubarMainService,new H.SyncDescriptor(z.MenubarMainService)),Pe.set(ae.IExtensionHostStarter,new H.SyncDescriptor(ne.ExtensionHostStarter)),Pe.set(Se.IStorageMainService,new H.SyncDescriptor(Se.StorageMainService)),Pe.set(Se.IApplicationStorageMainService,new H.SyncDescriptor(Se.ApplicationStorageMainService));const _e=new Mt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Te=new Rt.PtyHostService(_e,this.configurationService,this.logService,this.loggerService);Pe.set(at.ILocalPtyService,Te),p.isWindows?Pe.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.WindowsExternalTerminalService)):p.isMacintosh?Pe.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.MacExternalTerminalService)):p.isLinux&&Pe.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.LinuxExternalTerminalService));const qe=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Pe.set(n.IBackupMainService,qe);const Qe=new Je.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,qe,Ie);if(Pe.set(Je.IWorkspacesManagementMainService,Qe),Pe.set($e.IWorkspacesService,new H.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Pe.set(He.IWorkspacesHistoryMainService,new H.SyncDescriptor(He.WorkspacesHistoryMainService,void 0,!1)),Pe.set(ze.IURLService,new H.SyncDescriptor(X.NativeURLService,void 0,!1)),(0,Y.supportsTelemetry)(this.productService,this.environmentMainService)){const Ge=(0,Y.isInternalTelemetry)(this.productService,this.configurationService),xe=(0,u.getDelayedChannel)(ke.then(et=>et.getChannel("telemetryAppender"))),Ve=new pe.TelemetryAppenderClient(xe),Ke=(0,De.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Ge),Ye=(0,Y.getPiiPathsFromEnvironment)(this.environmentMainService),Ze={appenders:[Ve],commonProperties:Ke,piiPaths:Ye,sendErrorTelemetry:!0};Pe.set(Ne.ITelemetryService,new H.SyncDescriptor(ve.TelemetryService,[Ze],!1))}else Pe.set(Ne.ITelemetryService,Y.NullTelemetryService);return Pe.set(wt.IExtensionsProfileScannerService,new H.SyncDescriptor(It.ExtensionsProfileScannerService,void 0,!0)),Pe.set(St.IExtensionsScannerService,new H.SyncDescriptor(yt.ExtensionsScannerService,void 0,!0)),Pe.set(ot.IUtilityProcessWorkerMainService,new H.SyncDescriptor(ot.UtilityProcessWorkerMainService,void 0,!0)),await st.Promises.settled([qe.initialize(),Qe.initialize()]),this.mainInstantiationService.createChild(Pe)}initChannels(Ce,ke,Pe){const Ie=this._register(new f.DisposableStore),_e=u.ProxyChannel.fromService(Ce.get(T.ILaunchMainService),Ie,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",_e);const Te=u.ProxyChannel.fromService(Ce.get(P.IDiagnosticsMainService),Ie,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Te);const qe=new it.PolicyChannel(Ce.get(Xe.IPolicyService));ke.registerChannel("policy",qe),Pe.then(tt=>tt.registerChannel("policy",qe));const Qe=this.fileService.getProvider(y.Schemas.file);(0,m.assertType)(Qe instanceof U.DiskFileSystemProvider);const Ge=new W.DiskFileSystemProviderChannel(Qe,this.logService,this.environmentMainService);ke.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ge),Pe.then(tt=>tt.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ge));const xe=u.ProxyChannel.fromService(Ce.get(nt.IUserDataProfilesMainService),Ie);ke.registerChannel("userDataProfiles",xe),Pe.then(tt=>tt.registerChannel("userDataProfiles",xe));const Ve=new pt.RequestChannel(Ce.get(vt.IRequestService));Pe.then(tt=>tt.registerChannel("request",Ve));const Ke=new ge.UpdateChannel(Ce.get(le.IUpdateService));ke.registerChannel("update",Ke);const Ye=u.ProxyChannel.fromService(Ce.get(oe.IIssueMainService),Ie);ke.registerChannel("issue",Ye);const Ze=u.ProxyChannel.fromService(Ce.get(O.IEncryptionMainService),Ie);ke.registerChannel("encryption",Ze);const et=u.ProxyChannel.fromService(Ce.get(he.ISignService),Ie);ke.registerChannel("sign",et);const rt=u.ProxyChannel.fromService(Ce.get(A.IKeyboardLayoutMainService),Ie);ke.registerChannel("keyboardLayout",rt),this.nativeHostMainService=Ce.get(j.INativeHostMainService);const ft=u.ProxyChannel.fromService(this.nativeHostMainService,Ie);ke.registerChannel("nativeHost",ft),Pe.then(tt=>tt.registerChannel("nativeHost",ft));const At=u.ProxyChannel.fromService(Ce.get($e.IWorkspacesService),Ie);ke.registerChannel("workspaces",At);const _t=u.ProxyChannel.fromService(Ce.get(z.IMenubarMainService),Ie);ke.registerChannel("menubar",_t);const Ot=u.ProxyChannel.fromService(Ce.get(ze.IURLService),Ie);ke.registerChannel("url",Ot);const Tt=u.ProxyChannel.fromService(Ce.get(me.IWebviewManagerService),Ie);ke.registerChannel("webview",Tt);const gt=this._register(new we.StorageDatabaseChannel(this.logService,Ce.get(Se.IStorageMainService)));ke.registerChannel("storage",gt),Pe.then(tt=>tt.registerChannel("storage",gt));const Wt=this._register(new Et.ProfileStorageChangesListenerChannel(Ce.get(Se.IStorageMainService),Ce.get(nt.IUserDataProfilesMainService),this.logService));Pe.then(tt=>tt.registerChannel("profileStorageListener",Wt));const Ft=u.ProxyChannel.fromService(Ce.get(at.ILocalPtyService),Ie);ke.registerChannel(at.TerminalIpcChannels.LocalPty,Ft);const Ut=u.ProxyChannel.fromService(Ce.get(se.IExternalTerminalMainService),Ie);ke.registerChannel("externalTerminal",Ut);const mt=new Ct.LoggerChannel(Ce.get(kt.ILoggerMainService));ke.registerChannel("logger",mt),Pe.then(tt=>tt.registerChannel("logger",mt));const Nt=new D.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Le.IWindowsMainService));ke.registerChannel("extensionhostdebugservice",Nt);const Bt=u.ProxyChannel.fromService(Ce.get(ae.IExtensionHostStarter),Ie);ke.registerChannel(ae.ipcExtensionHostStarterChannelName,Bt);const zt=u.ProxyChannel.fromService(Ce.get(ot.IUtilityProcessWorkerMainService),Ie);ke.registerChannel(Dt.ipcUtilityProcessWorkerChannelName,zt)}async openFirstWindow(Ce,ke){const Pe=this.windowsMainService=Ce.get(Le.IWindowsMainService),Ie=(0,re.isLaunchedFromCli)(process.env)?0:4,_e=this.environmentMainService.args;if(ke){if(ke.openables.length>0)return Pe.open({context:Ie,cli:_e,urisToOpen:ke.openables,gotoLineMode:!0,initialStartup:!0});if(ke.urls.length>0)for(const et of ke.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Pe.open({context:Ie,cli:_e,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,qe=_e._.length,Qe=!!_e["folder-uri"],Ge=!!_e["file-uri"],xe=_e["skip-add-to-recently-opened"]===!0,Ve=_e.wait&&_e.waitMarkerFilePath?d.URI.file(_e.waitMarkerFilePath):void 0,Ke=_e.remote||void 0,Ye=_e.profile,Ze=_e["profile-temp"];if(!qe&&!Qe&&!Ge){if(_e["new-window"]||Ye||Ze)return Pe.open({context:Ie,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:Ze});if(Te.length)return Pe.open({context:1,cli:_e,urisToOpen:Te.map(et=>(0,We.hasWorkspaceFileExtension)(et)?{workspaceUri:d.URI.file(et)}:{fileUri:d.URI.file(et)}),noRecentEntry:xe,waitMarkerFileURI:Ve,initialStartup:!0})}return Pe.open({context:Ie,cli:_e,forceNewWindow:_e["new-window"]||!qe&&_e["unity-launch"],diffMode:_e.diff,mergeMode:_e.merge,noRecentEntry:xe,waitMarkerFileURI:Ve,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:Ze})}afterWindowOpen(){this.installMutex(),I.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ce,ke)=>{ke({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),p.isMacintosh&&I.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ce=this.productService.win32MutexName;if(p.isWindows&&Ce)try{const ke=await new Promise((Ie,_e)=>{K(["@vscode/windows-mutex"],Ie,_e)}),Pe=new ke.Mutex(Ce);g.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(ke){this.logService.error(ke)}}async resolveShellEnvironment(Ce,ke,Pe){try{return await(0,J.getResolvedShellEnv)(this.configurationService,this.logService,Ce,ke)}catch(Ie){const _e=(0,C.toErrorMessage)(Ie);Pe?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",_e):this.logService.error(_e)}return{}}async updateCrashReporterEnablement(){try{const ke=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Pe=JSON.parse((0,w.stripComments)(ke)),_e=(0,Y.getTelemetryLevel)(this.configurationService)>=1;if(Pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],qe=ke.substring(0,ke.length-2).concat(`,
`,Te.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(qe))}else{const Te=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${_e},`);Te!==ke&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Te))}}catch(Ce){this.logService.error(Ce)}}};e.CodeApplication=ut,e.CodeApplication=ut=lt=Ee([Z(2,Q.IInstantiationService),Z(3,B.ILogService),Z(4,B.ILoggerService),Z(5,$.IEnvironmentMainService),Z(6,q.ILifecycleMainService),Z(7,b.IConfigurationService),Z(8,ye.IStateService),Z(9,x.IFileService),Z(10,ce.IProductService),Z(11,nt.IUserDataProfilesMainService)],ut)}),define(ee[312],te([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,306,10,17,236,248,25,63,200,16,220,92,75,216,91,20,223,5,77,24,78,276,126,285,50,284,94,247,34,51,67,52,39,232,230,2,40,264,66,225,115,121,268,262]),function(K,e,I,L,r,_,M,C,h,a,g,w,S,f,y,v,p,m,d,c,E,u,t,l,s,i,n,o,b,D,R,P,k,O,F,$,re,J,ae,ne,se,G,V,x,W,U,H,Q,ie,oe,N,A,T,q,B,z,j,ce,fe,ue,he,ye,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.startup()}catch(pe){console.error(pe.message),I.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[pe,ve,Y,le,ge,Me,Re,Fe]=this.createServices();try{try{await this.initServices(Y,Fe,le,ge,Re)}catch(Ae){throw this.handleStartupDataDirError(Y,Re,Ae),Ae}await pe.invokeFunction(async Ae=>{const ze=Ae.get(J.ILogService),Be=Ae.get($.ILifecycleMainService),X=Ae.get(D.IFileService),de=Ae.get(J.ILoggerService),me=await this.claimInstance(ze,Y,Be,pe,Re,!0);return d.Promises.writeFile(Y.mainLockfile,String(process.pid)).catch(be=>{ze.warn(`app#startup(): Error writing main lockfile: ${be.stack}`)}),Me.logger=de.createLogger("main",{name:(0,t.localize)(0,null)}),g.Event.once(Be.onWillShutdown)(be=>{X.dispose(),le.dispose(),be.join("instanceLockfile",d.Promises.unlink(Y.mainLockfile).catch(()=>{}))}),pe.createInstance(u.CodeApplication,me,ve).startup()})}catch(Ae){pe.invokeFunction(this.quit,Ae)}}createServices(){const pe=new F.ServiceCollection,ve=new z.DisposableStore;process.once("exit",()=>ve.dispose());const Y={_serviceBrand:void 0,...ae.default};pe.set(ne.IProductService,Y);const le=new n.EnvironmentMainService(this.resolveArgs(),Y),ge=this.patchEnvironment(le);pe.set(n.IEnvironmentMainService,le);const Me=new fe.LoggerMainService((0,J.getLogLevel)(le),le.logsHome);pe.set(fe.ILoggerMainService,Me);const Re=new re.BufferLogger(Me.getLogLevel()),Fe=ve.add(new ue.LogService(Re,[new J.ConsoleMainLogger(Me.getLogLevel())]));pe.set(J.ILogService,Fe);const Ae=new R.FileService(Fe);pe.set(D.IFileService,Ae);const ze=new P.DiskFileSystemProvider(Fe);Ae.registerProvider(S.Schemas.file,ze);const Be=new ce.UriIdentityService(Ae);pe.set(j.IUriIdentityService,Be);const X=new ye.StateService(1,le,Fe,Ae);pe.set(ie.IStateReadService,X),pe.set(ie.IStateService,X);const de=new A.UserDataProfilesMainService(X,Be,le,Ae,Fe);pe.set(A.IUserDataProfilesMainService,de),Ae.registerProvider(S.Schemas.vscodeUserData,new we.FileUserDataProvider(S.Schemas.file,ze,S.Schemas.vscodeUserData,de,Be,Fe));const me=v.isWindows&&Y.win32RegValueName?ve.add(new q.NativePolicyService(Fe,Y.win32RegValueName)):le.policyFile?ve.add(new B.FilePolicyService(le.policyFile,Ae,Fe)):new T.NullPolicyService;pe.set(T.IPolicyService,me);const be=new s.ConfigurationService(de.defaultProfile.settingsResource,Ae,me,Fe);return pe.set(l.IConfigurationService,be),pe.set($.ILifecycleMainService,new k.SyncDescriptor($.LifecycleMainService,void 0,!1)),pe.set(W.IRequestService,new k.SyncDescriptor(U.RequestMainService,void 0,!0)),pe.set(N.IThemeMainService,new k.SyncDescriptor(N.ThemeMainService)),pe.set(H.ISignService,new k.SyncDescriptor(Q.SignService,void 0,!1)),pe.set(V.ITunnelService,new k.SyncDescriptor(x.TunnelService)),pe.set(se.IProtocolMainService,new G.ProtocolMainService(le,de,Fe)),[new O.InstantiationService(pe,!0),ge,le,be,X,Re,Y,de]}patchEnvironment(pe){const ve={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Y=>{const le=process.env[Y];typeof le=="string"&&(ve[Y]=le)}),Object.assign(process.env,ve),ve}async initServices(pe,ve,Y,le,ge){await M.Promises.settled([Promise.all([pe.extensionsPath,pe.codeCachePath,pe.logsHome.with({scheme:S.Schemas.file}).fsPath,ve.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:S.Schemas.file}).fsPath,pe.backupHome].map(Me=>Me?d.Promises.mkdir(Me,{recursive:!0}):void 0)),le.init(),Y.initialize()]),ve.init()}async claimInstance(pe,ve,Y,le,ge,Me){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,E.serve)(ve.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),g.Event.once(Y.onWillShutdown)(()=>Re.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,ge,Fe),Fe;let Ae;try{Ae=await(0,E.connect)(ve.mainIPCHandle,"main")}catch(de){if(!Me||v.isWindows||de.code!=="ECONNREFUSED")throw de.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),de;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(me){throw pe.warn("Could not delete obsolete instance handle",me),me}return this.claimInstance(pe,ve,Y,le,ge,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const de=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw pe.error(de),Ae.dispose(),new Error(de)}let ze;!ve.args.wait&&!ve.args.status&&(ze=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Be=c.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),X=c.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return le.invokeFunction(async()=>{const de=new i.DiagnosticsService(oe.NullTelemetryService,ge),me=await X.getMainDiagnostics(),be=await X.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Le=await de.getDiagnostics(me,be);throw console.log(Le),new h.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow(Be,pe),pe.trace("Sending env to running instance..."),await Be.start(ve.args,process.env),Ae.dispose(),ze&&clearTimeout(ze),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}handleStartupDataDirError(pe,ve,Y){if(Y.code==="EACCES"||Y.code==="EPERM"){const le=(0,_.coalesce)([pe.userDataPath,pe.extensionsPath,E.XDG_RUNTIME_DIR]).map(ge=>(0,w.getPathLabel)(r.URI.file(ge),{os:v.OS,tildify:pe}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,C.toErrorMessage)(Y),le.join(`
`)),ve)}}showStartupWarningDialog(pe,ve,Y){I.dialog.showMessageBoxSync((0,he.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:pe,detail:ve},Y).options)}async windowsAllowSetForegroundWindow(pe,ve){if(v.isWindows){const Y=await pe.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Y);try{(await new Promise((le,ge)=>{K(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Y)}catch(le){ve.error(le)}}}quit(pe,ve){const Y=pe.get(J.ILogService),le=pe.get($.ILifecycleMainService);let ge=0;ve&&(ve.isExpected?ve.message&&Y.trace(ve.message):(ge=1,ve.stack?Y.error(ve.stack):Y.error(`Startup error: ${ve.toString()}`))),le.kill(ge)}resolveArgs(){const pe=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ve=(0,b.createWaitMarkerFileSync)(pe.verbose);ve&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ve),pe.waitMarkerFilePath=ve)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ve=this.doValidatePaths(pe._,pe.goto);pe._=ve}return pe}doValidatePaths(pe,ve){const Y=(0,p.cwd)(),le=pe.map(Re=>{let Fe=String(Re),Ae;ve&&(Ae=(0,a.parseLineAndColumnAware)(Fe),Fe=Ae.path),Fe&&(Fe=this.preparePath(Y,Fe));const ze=(0,a.sanitizeFilePath)(Fe,Y),Be=(0,f.basename)(ze);return Be&&!(0,a.isValidBasename)(Be)?null:ve&&Ae?(Ae.path=ze,this.toPath(Ae)):ze}),ge=v.isWindows||v.isMacintosh,Me=(0,_.distinct)(le,Re=>Re&&ge?Re.toLowerCase():Re||"");return(0,_.coalesce)(Me)}preparePath(pe,ve){return v.isWindows&&(ve=(0,m.rtrim)(ve,'"')),ve=(0,m.trim)((0,m.trim)(ve," "),"	"),v.isWindows&&(ve=(0,f.resolve)(pe,ve),ve=(0,m.rtrim)(ve,".")),ve}toPath(pe){const ve=[pe.path];return typeof pe.line=="number"&&ve.push(String(pe.line)),typeof pe.column=="number"&&ve.push(String(pe.column)),ve.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/032b38229264250bcce623b6412a0bb7bd9b4052/core/vs/code/electron-main/main.js.map
