/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(ge){for(var e=[],I=0,F=ge.length;I<F;I++)e[I]=De[ge[I]];return e};define(De[156],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class I{static get(){const h=new Map,R=new Map,A=new Map,v=new Map;function y(S,_){S.has(_.detail)||S.set(_.detail,-_.timestamp)}function E(S,_){const w=S.get(_.detail);w&&(w>=0||S.set(_.detail,w+_.timestamp))}let T=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(T=ge.getStats().slice(0).sort((S,_)=>S.timestamp-_.timestamp));for(const S of T)switch(S.type){case 10:y(h,S);break;case 11:case 12:E(h,S);break;case 21:y(R,S);break;case 22:E(R,S);break;case 33:y(A,S);break;case 34:E(A,S);break;case 31:y(v,S);break;case 32:E(v,S);break}let k=0;A.forEach(S=>k+=S);function b(S){const _=[];return S.forEach((w,u)=>_.push([u,w])),_}return{amdLoad:b(h),amdInvoke:b(R),nodeRequire:b(A),nodeEval:b(v),nodeRequireTotal:k}}static toMarkdownTable(h,R){let A="";const v=[];return h.forEach((y,E)=>{v[E]=y.length}),R.forEach(y=>{y.forEach((E,T)=>{typeof E>"u"&&(E=y[T]="-");const k=E.toString().length;v[T]=Math.max(k,v[T])})}),h.forEach((y,E)=>{A+=`| ${y+" ".repeat(v[E]-y.toString().length)} `}),A+=`|
`,h.forEach((y,E)=>{A+=`| ${"-".repeat(v[E])} `}),A+=`|
`,R.forEach(y=>{y.forEach((E,T)=>{typeof E<"u"&&(A+=`| ${E+" ".repeat(v[T]-E.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=I}),define(De[118],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(w,u,r){const o=F(w,u);if(o!==-1)return w[o]}e.findLast=I;function F(w,u,r=w.length-1){for(let o=r;o>=0;o--){const c=w[o];if(u(c))return o}return-1}e.findLastIdx=F;function h(w,u){const r=R(w,u);return r===-1?void 0:w[r]}e.findLastMonotonous=h;function R(w,u,r=0,o=w.length){let c=r,g=o;for(;c<g;){const d=Math.floor((c+g)/2);u(w[d])?c=d+1:g=d}return c-1}e.findLastIdxMonotonous=R;function A(w,u){const r=v(w,u);return r===w.length?void 0:w[r]}e.findFirstMonotonous=A;function v(w,u,r=0,o=w.length){let c=r,g=o;for(;c<g;){const d=Math.floor((c+g)/2);u(w[d])?g=d:c=d+1}return c}e.findFirstIdxMonotonousOrArrLen=v;function y(w,u,r=0,o=w.length){const c=v(w,u,r,o);return c===w.length?-1:c}e.findFirstIdxMonotonous=y;class E{static{this.assertInvariants=!1}constructor(u){this._array=u,this._findLastMonotonousLastIdx=0}findLastMonotonous(u){if(E.assertInvariants){if(this._prevFindLastPredicate){for(const o of this._array)if(this._prevFindLastPredicate(o)&&!u(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=u}const r=R(this._array,u,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=r+1,r===-1?void 0:this._array[r]}}e.MonotonousArray=E;function T(w,u){if(w.length===0)return;let r=w[0];for(let o=1;o<w.length;o++){const c=w[o];u(c,r)>0&&(r=c)}return r}e.findFirstMaxBy=T;function k(w,u){if(w.length===0)return;let r=w[0];for(let o=1;o<w.length;o++){const c=w[o];u(c,r)>=0&&(r=c)}return r}e.findLastMaxBy=k;function b(w,u){return T(w,(r,o)=>-u(r,o))}e.findFirstMinBy=b;function S(w,u){if(w.length===0)return-1;let r=0;for(let o=1;o<w.length;o++){const c=w[o];u(c,w[r])>0&&(r=o)}return r}e.findMaxIdxBy=S;function _(w,u){for(const r of w){const o=u(r);if(o!==void 0)return o}}e.mapFindFirst=_}),define(De[73],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(A,v){const y=Object.create(null);for(const E of A){const T=v(E);let k=y[T];k||(k=y[T]=[]),k.push(E)}return y}e.groupBy=I;function F(A,v){const y=[],E=[];for(const T of A)v.has(T)||y.push(T);for(const T of v)A.has(T)||E.push(T);return{removed:y,added:E}}e.diffSets=F;function h(A,v){const y=[],E=[];for(const[T,k]of A)v.has(T)||y.push(k);for(const[T,k]of v)A.has(T)||E.push(k);return{removed:y,added:E}}e.diffMaps=h;function R(A,v){const y=new Set;for(const E of v)A.has(E)&&y.add(E);return y}e.intersection=R}),define(De[57],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(A){return(v,y,E)=>{let T=null,k=null;if(typeof E.value=="function"?(T="value",k=E.value):typeof E.get=="function"&&(T="get",k=E.get),!k)throw new Error("not supported");E[T]=A(k,y)}}function F(A,v,y){let E=null,T=null;if(typeof y.value=="function"?(E="value",T=y.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(E="get",T=y.get),!T)throw new Error("not supported");const k=`$memoize$${v}`;y[E]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,b)}),this[k]}}e.memoize=F;function h(A,v,y){return I((E,T)=>{const k=`$debounce$${T}`,b=`$debounce$result$${T}`;return function(...S){this[b]||(this[b]=y?y():void 0),clearTimeout(this[k]),v&&(this[b]=v(this[b],...S),S=[this[b]]),this[k]=setTimeout(()=>{E.apply(this,S),this[b]=y?y():void 0},A)}})}e.debounce=h;function R(A,v,y){return I((E,T)=>{const k=`$throttle$timer$${T}`,b=`$throttle$result$${T}`,S=`$throttle$lastRun$${T}`,_=`$throttle$pending$${T}`;return function(...w){if(this[b]||(this[b]=y?y():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),v&&(this[b]=v(this[b],...w)),this[_])return;const u=this[S]+A;u<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[b]]),this[b]=y?y():void 0):(this[_]=!0,this[k]=setTimeout(()=>{this[_]=!1,this[S]=Date.now(),E.apply(this,[this[b]]),this[b]=y?y():void 0},u-Date.now()))}})}e.throttle=R}),define(De[8],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function F(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=F;function h(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=h;function R(d){E(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=R;function A(d){E(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=A;function v(d){if(d instanceof Error){const{name:t,message:n}=d,s=d.stacktrace||d.stack;return{$isError:!0,name:t,message:n,stack:s,noTelemetry:c.isErrorNoTelemetry(d)}}return d}e.transformErrorForSerialization=v;const y="Canceled";function E(d){return d instanceof T?!0:d instanceof Error&&d.name===y&&d.message===y}e.isCancellationError=E;class T extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=T;function k(){const d=new Error(y);return d.name=d.message,d}e.canceled=k;function b(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=b;function S(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=S;class _ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=_;function w(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=w;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=u;class r extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=r;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=o;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const n=new c;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.BugIndicatingError=g}),define(De[19],Ie([1,0,8,118]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function h(Z,ie=0){return Z[Z.length-(1+ie)]}e.tail=h;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function A(Z,ie,re=(ye,oe)=>ye===oe){if(Z===ie)return!0;if(!Z||!ie||Z.length!==ie.length)return!1;for(let ye=0,oe=Z.length;ye<oe;ye++)if(!re(Z[ye],ie[ye]))return!1;return!0}e.equals=A;function v(Z,ie){const re=Z.length-1;ie<re&&(Z[ie]=Z[re]),Z.pop()}e.removeFastWithoutKeepingOrder=v;function y(Z,ie,re){return E(Z.length,ye=>re(Z[ye],ie))}e.binarySearch=y;function E(Z,ie){let re=0,ye=Z-1;for(;re<=ye;){const oe=(re+ye)/2|0,de=ie(oe);if(de<0)re=oe+1;else if(de>0)ye=oe-1;else return oe}return-(re+1)}e.binarySearch2=E;function T(Z,ie,re){if(Z=Z|0,Z>=ie.length)throw new TypeError("invalid index");const ye=ie[Math.floor(ie.length*Math.random())],oe=[],de=[],ee=[];for(const ue of ie){const pe=re(ue,ye);pe<0?oe.push(ue):pe>0?de.push(ue):ee.push(ue)}return Z<oe.length?T(Z,oe,re):Z<oe.length+ee.length?ee[0]:T(Z-(oe.length+ee.length),de,re)}e.quickSelect=T;function k(Z,ie){const re=[];let ye;for(const oe of Z.slice(0).sort(ie))!ye||ie(ye[0],oe)!==0?(ye=[oe],re.push(ye)):ye.push(oe);return re}e.groupBy=k;function*b(Z,ie){let re,ye;for(const oe of Z)ye!==void 0&&ie(ye,oe)?re.push(oe):(re&&(yield re),re=[oe]),ye=oe;re&&(yield re)}e.groupAdjacentBy=b;function S(Z,ie){for(let re=0;re<=Z.length;re++)ie(re===0?void 0:Z[re-1],re===Z.length?void 0:Z[re])}e.forEachAdjacent=S;function _(Z,ie){for(let re=0;re<Z.length;re++)ie(re===0?void 0:Z[re-1],Z[re],re+1===Z.length?void 0:Z[re+1])}e.forEachWithNeighbors=_;function w(Z,ie,re){const ye=[];function oe(ue,pe,Pe){if(pe===0&&Pe.length===0)return;const $=ye[ye.length-1];$&&$.start+$.deleteCount===ue?($.deleteCount+=pe,$.toInsert.push(...Pe)):ye.push({start:ue,deleteCount:pe,toInsert:Pe})}let de=0,ee=0;for(;;){if(de===Z.length){oe(de,0,ie.slice(ee));break}if(ee===ie.length){oe(de,Z.length-de,[]);break}const ue=Z[de],pe=ie[ee],Pe=re(ue,pe);Pe===0?(de+=1,ee+=1):Pe<0?(oe(de,1,[]),de+=1):Pe>0&&(oe(de,0,[pe]),ee+=1)}return ye}e.sortedDiff=w;function u(Z,ie,re){const ye=w(Z,ie,re),oe=[],de=[];for(const ee of ye)oe.push(...Z.slice(ee.start,ee.start+ee.deleteCount)),de.push(...ee.toInsert);return{removed:oe,added:de}}e.delta=u;function r(Z,ie,re){if(re===0)return[];const ye=Z.slice(0,re).sort(ie);return c(Z,ie,ye,re,Z.length),ye}e.top=r;function o(Z,ie,re,ye,oe){return re===0?Promise.resolve([]):new Promise((de,ee)=>{(async()=>{const ue=Z.length,pe=Z.slice(0,re).sort(ie);for(let Pe=re,$=Math.min(re+ye,ue);Pe<ue;Pe=$,$=Math.min($+ye,ue)){if(Pe>re&&await new Promise(K=>setTimeout(K)),oe&&oe.isCancellationRequested)throw new I.CancellationError;c(Z,ie,pe,Pe,$)}return pe})().then(de,ee)})}e.topAsync=o;function c(Z,ie,re,ye,oe){for(const de=re.length;ye<oe;ye++){const ee=Z[ye];if(ie(ee,re[de-1])<0){re.pop();const ue=(0,F.findFirstIdxMonotonousOrArrLen)(re,pe=>ie(ee,pe)<0);re.splice(ue,0,ee)}}}function g(Z){return Z.filter(ie=>!!ie)}e.coalesce=g;function d(Z){let ie=0;for(let re=0;re<Z.length;re++)Z[re]&&(Z[ie]=Z[re],ie+=1);Z.length=ie}e.coalesceInPlace=d;function t(Z,ie,re){Z.splice(re,0,Z.splice(ie,1)[0])}e.move=t;function n(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=n;function s(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=s;function i(Z,ie=re=>re){const re=new Set;return Z.filter(ye=>{const oe=ie(ye);return re.has(oe)?!1:(re.add(oe),!0)})}e.distinct=i;function a(Z){const ie=new Set;return re=>{const ye=Z(re);return ie.has(ye)?!1:(ie.add(ye),!0)}}e.uniqueFilter=a;function l(Z,ie){return Z.length>0?Z[0]:ie}e.firstOrDefault=l;function C(Z,ie){return Z.length>0?Z[Z.length-1]:ie}e.lastOrDefault=C;function D(Z,ie,re=(ye,oe)=>ye===oe){let ye=0;for(let oe=0,de=Math.min(Z.length,ie.length);oe<de&&re(Z[oe],ie[oe]);oe++)ye++;return ye}e.commonPrefixLength=D;function p(Z){return[].concat(...Z)}e.flatten=p;function m(Z,ie){let re=typeof ie=="number"?Z:0;typeof ie=="number"?re=Z:(re=0,ie=Z);const ye=[];if(re<=ie)for(let oe=re;oe<ie;oe++)ye.push(oe);else for(let oe=re;oe>ie;oe--)ye.push(oe);return ye}e.range=m;function f(Z,ie,re){return Z.reduce((ye,oe)=>(ye[ie(oe)]=re?re(oe):oe,ye),Object.create(null))}e.index=f;function P(Z,ie){return Z.push(ie),()=>M(Z,ie)}e.insert=P;function M(Z,ie){const re=Z.indexOf(ie);if(re>-1)return Z.splice(re,1),ie}e.remove=M;function N(Z,ie,re){const ye=Z.slice(0,ie),oe=Z.slice(ie);return ye.concat(re,oe)}e.arrayInsert=N;function L(Z,ie){let re;if(typeof ie=="number"){let ye=ie;re=()=>{const oe=Math.sin(ye++)*179426549;return oe-Math.floor(oe)}}else re=Math.random;for(let ye=Z.length-1;ye>0;ye-=1){const oe=Math.floor(re()*(ye+1)),de=Z[ye];Z[ye]=Z[oe],Z[oe]=de}}e.shuffle=L;function U(Z,ie){const re=Z.indexOf(ie);re>-1&&(Z.splice(re,1),Z.unshift(ie))}e.pushToStart=U;function x(Z,ie){const re=Z.indexOf(ie);re>-1&&(Z.splice(re,1),Z.push(ie))}e.pushToEnd=x;function O(Z,ie){for(const re of ie)Z.push(re)}e.pushMany=O;function j(Z,ie){return Array.isArray(Z)?Z.map(ie):ie(Z)}e.mapArrayOrNot=j;function V(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=V;function fe(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=fe;function J(Z,ie,re){const ye=z(Z,ie),oe=Z.length,de=re.length;Z.length=oe+de;for(let ee=oe-1;ee>=ye;ee--)Z[ee+de]=Z[ee];for(let ee=0;ee<de;ee++)Z[ee+ye]=re[ee]}e.insertInto=J;function X(Z,ie,re,ye){const oe=z(Z,ie);let de=Z.splice(oe,re);return de===void 0&&(de=[]),J(Z,oe,ye),de}e.splice=X;function z(Z,ie){return ie<0?Math.max(ie+Z.length,0):Math.min(ie,Z.length)}var Q;(function(Z){function ie(de){return de<0}Z.isLessThan=ie;function re(de){return de<=0}Z.isLessThanOrEqual=re;function ye(de){return de>0}Z.isGreaterThan=ye;function oe(de){return de===0}Z.isNeitherLessOrGreaterThan=oe,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ve(Z,ie){return(re,ye)=>ie(Z(re),Z(ye))}e.compareBy=ve;function le(...Z){return(ie,re)=>{for(const ye of Z){const oe=ye(ie,re);if(!Q.isNeitherLessOrGreaterThan(oe))return oe}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const we=(Z,ie)=>Z-ie;e.numberComparator=we;const G=(Z,ie)=>(0,e.numberComparator)(Z?1:0,ie?1:0);e.booleanComparator=G;function B(Z){return(ie,re)=>-Z(ie,re)}e.reverseOrder=B;class H{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let re=this.firstIdx;for(;re<this.items.length&&ie(this.items[re]);)re++;const ye=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ye}takeFromEndWhile(ie){let re=this.lastIdx;for(;re>=0&&ie(this.items[re]);)re--;const ye=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ye}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const re=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,re}}e.ArrayQueue=H;class me{static{this.empty=new me(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(re=>(ie(re),!0))}toArray(){const ie=[];return this.iterate(re=>(ie.push(re),!0)),ie}filter(ie){return new me(re=>this.iterate(ye=>ie(ye)?re(ye):!0))}map(ie){return new me(re=>this.iterate(ye=>re(ie(ye))))}some(ie){let re=!1;return this.iterate(ye=>(re=ie(ye),!re)),re}findFirst(ie){let re;return this.iterate(ye=>ie(ye)?(re=ye,!1):!0),re}findLast(ie){let re;return this.iterate(ye=>(ie(ye)&&(re=ye),!0)),re}findLastMaxBy(ie){let re,ye=!0;return this.iterate(oe=>((ye||Q.isGreaterThan(ie(oe,re)))&&(ye=!1,re=oe),!0)),re}}e.CallbackIterable=me}),define(De[58],Ie([1,0,8]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function F(y,E){if(!y)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=F;function h(y,E="Unreachable"){throw new Error(E)}e.assertNever=h;function R(y){if(!y)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function A(y){if(!y()){debugger;y(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function v(y,E){let T=0;for(;T<y.length-1;){const k=y[T],b=y[T+1];if(!E(k,b))return!1;T++}return!0}e.checkAdjacentItems=v}),define(De[74],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(F){const h=this;let R=!1,A;return function(){return R||(R=!0,A=F.apply(h,arguments)),A}}e.createSingleCallFunction=I}),define(De[119],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(h){this._prefix=h,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(De[50],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function h(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}F.is=h;const R=Object.freeze([]);function A(){return R}F.empty=A;function*v(d){yield d}F.single=v;function y(d){return h(d)?d:v(d)}F.wrap=y;function E(d){return d||R}F.from=E;function*T(d){for(let t=d.length-1;t>=0;t--)yield d[t]}F.reverse=T;function k(d){return!d||d[Symbol.iterator]().next().done===!0}F.isEmpty=k;function b(d){return d[Symbol.iterator]().next().value}F.first=b;function S(d,t){for(const n of d)if(t(n))return!0;return!1}F.some=S;function _(d,t){for(const n of d)if(t(n))return n}F.find=_;function*w(d,t){for(const n of d)t(n)&&(yield n)}F.filter=w;function*u(d,t){let n=0;for(const s of d)yield t(s,n++)}F.map=u;function*r(...d){for(const t of d)for(const n of t)yield n}F.concat=r;function o(d,t,n){let s=n;for(const i of d)s=t(s,i);return s}F.reduce=o;function*c(d,t,n=d.length){for(t<0&&(t+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);t<n;t++)yield d[t]}F.slice=c;function g(d,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,d];const s=d[Symbol.iterator]();for(let i=0;i<t;i++){const a=s.next();if(a.done)return[n,F.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}F.consume=g})(I||(e.Iterable=I={}))}),define(De[157],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var h;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,n=!1){let s=0;const i=t.length;let a="",l=0,C=16,D=0;function p(U){let x=0,O=0;for(;x<U;){const j=t.charCodeAt(s);if(j>=48&&j<=57)O=O*16+j-48;else if(j>=65&&j<=70)O=O*16+j-65+10;else if(j>=97&&j<=102)O=O*16+j-97+10;else break;s++,x++}return x<U&&(O=-1),O}function m(U){s=U,a="",l=0,C=16,D=0}function f(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&E(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&E(t.charCodeAt(s)))for(s++;s<t.length&&E(t.charCodeAt(s));)s++;else return D=3,t.substring(U,s);let x=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&E(t.charCodeAt(s))){for(s++;s<t.length&&E(t.charCodeAt(s));)s++;x=s}else D=3;return t.substring(U,x)}function P(){let U="",x=s;for(;;){if(s>=i){U+=t.substring(x,s),D=2;break}const O=t.charCodeAt(s);if(O===34){U+=t.substring(x,s),s++;break}if(O===92){if(U+=t.substring(x,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=p(4);V>=0?U+=String.fromCharCode(V):D=4;break}default:D=5}x=s;continue}if(O>=0&&O<=31)if(y(O)){U+=t.substring(x,s),D=2;break}else D=6;s++}return U}function M(){if(a="",D=0,l=s,s>=i)return l=i,C=17;let U=t.charCodeAt(s);if(v(U)){do s++,a+=String.fromCharCode(U),U=t.charCodeAt(s);while(v(U));return C=15}if(y(U))return s++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),C=14;switch(U){case 123:return s++,C=1;case 125:return s++,C=2;case 91:return s++,C=3;case 93:return s++,C=4;case 58:return s++,C=6;case 44:return s++,C=5;case 34:return s++,a=P(),C=10;case 47:{const x=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(t.charCodeAt(s));)s++;return a=t.substring(x,s),C=12}if(t.charCodeAt(s+1)===42){s+=2;const O=i-1;let j=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,D=1),a=t.substring(x,s),C=13}return a+=String.fromCharCode(U),s++,C=16}case 45:if(a+=String.fromCharCode(U),s++,s===i||!E(t.charCodeAt(s)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=f(),C=11;default:for(;s<i&&N(U);)s++,U=t.charCodeAt(s);if(l!==s){switch(a=t.substring(l,s),a){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return a+=String.fromCharCode(U),s++,C=16}}function N(U){if(v(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=M();while(U>=12&&U<=15);return U}return{setPosition:m,getPosition:()=>s,scan:n?L:M,getToken:()=>C,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>D}}e.createScanner=A;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,n){const s=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function D(p,m,f,P){l.value=p,l.offset=m,l.length=f,l.type=P,l.colonOffset=void 0,a=l}try{c(t,{onObjectBegin:(p,m)=>{if(n<=p)throw i;a=void 0,C=n>p,s.push("")},onObjectProperty:(p,m,f)=>{if(n<m||(D(p,m,f,"property"),s[s.length-1]=p,n<=m+f))throw i},onObjectEnd:(p,m)=>{if(n<=p)throw i;a=void 0,s.pop()},onArrayBegin:(p,m)=>{if(n<=p)throw i;a=void 0,s.push(0)},onArrayEnd:(p,m)=>{if(n<=p)throw i;a=void 0,s.pop()},onLiteralValue:(p,m,f)=>{if(n<m||(D(p,m,f,d(p)),n<=m+f))throw i},onSeparator:(p,m,f)=>{if(n<=m)throw i;if(p===":"&&a&&a.type==="property")a.colonOffset=m,C=!1,a=void 0;else if(p===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(C=!0,s[s.length-1]=""),a=void 0}}})}catch(p){if(p!==i)throw p}return{path:s,previousNode:a,isAtPropertyKey:C,matches:p=>{let m=0;for(let f=0;m<p.length&&f<s.length;f++)if(p[m]===s[f]||p[m]==="*")m++;else if(p[m]!=="**")return!1;return m===p.length}}}e.getLocation=k;function b(t,n=[],s=R.DEFAULT){let i=null,a=[];const l=[];function C(p){Array.isArray(a)?a.push(p):i!==null&&(a[i]=p)}return c(t,{onObjectBegin:()=>{const p={};C(p),l.push(a),a=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const p=[];C(p),l.push(a),a=p,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:C,onError:(p,m,f)=>{n.push({error:p,offset:m,length:f})}},s),a[0]}e.parse=b;function S(t,n=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function l(p){return i.children.push(p),p}c(t,{onObjectBegin:p=>{i=l({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,m,f)=>{i=l({type:"property",offset:m,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:m,length:f,parent:i})},onObjectEnd:(p,m)=>{i.length=p+m-i.offset,i=i.parent,a(p+m)},onArrayBegin:(p,m)=>{i=l({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,m)=>{i.length=p+m-i.offset,i=i.parent,a(p+m)},onLiteralValue:(p,m,f)=>{l({type:d(p),offset:m,length:f,parent:i,value:p}),a(m+f)},onSeparator:(p,m,f)=>{i.type==="property"&&(p===":"?i.colonOffset=m:p===","&&a(m))},onError:(p,m,f)=>{n.push({error:p,offset:m,length:f})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=S;function _(t,n){if(!t)return;let s=t;for(const i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=_;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=w;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const n=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=u(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function r(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=r;function o(t,n,s=!1){if(r(t,n,s)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=o(i[a],n,s);if(l)return l}return t}}e.findNodeAtOffset=o;function c(t,n,s=R.DEFAULT){const i=A(t,!1);function a(ve){return ve?()=>ve(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(ve){return ve?le=>ve(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const C=a(n.onObjectBegin),D=l(n.onObjectProperty),p=a(n.onObjectEnd),m=a(n.onArrayBegin),f=a(n.onArrayEnd),P=l(n.onLiteralValue),M=l(n.onSeparator),N=a(n.onComment),L=l(n.onError),U=s&&s.disallowComments,x=s&&s.allowTrailingComma;function O(){for(;;){const ve=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:U||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ve){case 12:case 13:U?j(10):N();break;case 16:j(1);break;case 15:case 14:break;default:return ve}}}function j(ve,le=[],we=[]){if(L(ve),le.length+we.length>0){let G=i.getToken();for(;G!==17;){if(le.indexOf(G)!==-1){O();break}else if(we.indexOf(G)!==-1)break;G=O()}}}function V(ve){const le=i.getTokenValue();return ve?P(le):D(le),O(),!0}function fe(){switch(i.getToken()){case 11:{let ve=0;try{ve=JSON.parse(i.getTokenValue()),typeof ve!="number"&&(j(2),ve=0)}catch{j(2)}P(ve);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function J(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(M(":"),O(),Q()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function X(){C(),O();let ve=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ve||j(4,[],[]),M(","),O(),i.getToken()===2&&x)break}else ve&&j(6,[],[]);J()||j(4,[],[2,5]),ve=!0}return p(),i.getToken()!==2?j(7,[2],[]):O(),!0}function z(){m(),O();let ve=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ve||j(4,[],[]),M(","),O(),i.getToken()===4&&x)break}else ve&&j(6,[],[]);Q()||j(4,[],[4,5]),ve=!0}return f(),i.getToken()!==4?j(8,[4],[]):O(),!0}function Q(){switch(i.getToken()){case 3:return z();case 1:return X();case 10:return V(!0);default:return fe()}}return O(),i.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):Q()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=c;function g(t,n){const s=A(t),i=[];let a,l=0,C;do switch(C=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:l!==C&&i.push(t.substring(l,C)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),l=s.getPosition();break}while(a!==17);return i.join("")}e.stripComments=g;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(De[51],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(h){this.executor=h,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(h){this._error=h}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(De[75],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let R=this._first;for(;R!==I.Undefined;){const A=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=A}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,A){const v=new I(R);if(this._first===I.Undefined)this._first=v,this._last=v;else if(A){const E=this._last;this._last=v,v.prev=E,E.next=v}else{const E=this._first;this._first=v,v.next=E,E.prev=v}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(v))}}shift(){if(this._first!==I.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==I.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===I.Undefined&&R.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):R.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):R.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=F}),define(De[28],Ie([1,0]),function(ge,e){"use strict";var I,F,h;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(o,c,g){let d=o.get(c);return d===void 0&&(d=g,o.set(c,d)),d}e.getOrSet=R;function A(o){const c=[];return o.forEach((g,d)=>{c.push(`${d} => ${g}`)}),`Map(${o.size}) {${c.join(", ")}}`}e.mapToString=A;function v(o){const c=[];return o.forEach(g=>{c.push(g)}),`Set(${o.size}) {${c.join(", ")}}`}e.setToString=v;class y{constructor(c,g){this.uri=c,this.value=g}}function E(o){return Array.isArray(o)}class T{static{this.defaultToKey=c=>c.toString()}constructor(c,g){if(this[I]="ResourceMap",c instanceof T)this.map=new Map(c.map),this.toKey=g??T.defaultToKey;else if(E(c)){this.map=new Map,this.toKey=g??T.defaultToKey;for(const[d,t]of c)this.set(d,t)}else this.map=new Map,this.toKey=c??T.defaultToKey}set(c,g){return this.map.set(this.toKey(c),new y(c,g)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,g){typeof g<"u"&&(c=c.bind(g));for(const[d,t]of this.map)c(t.value,t.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=T;class k{constructor(c,g){this[F]="ResourceSet",!c||typeof c=="function"?this._map=new T(c):(this._map=new T(g),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,g){this._map.forEach((d,t)=>c.call(g,t,t,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=k;var b;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class S{constructor(){this[h]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,g=0){const d=this._map.get(c);if(d)return g!==0&&this.touch(d,g),d.value}set(c,g,d=0){let t=this._map.get(c);if(t)t.value=g,d!==0&&this.touch(t,d);else{switch(t={key:c,value:g,next:void 0,previous:void 0},d){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(c,t),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const g=this._map.get(c);if(g)return this._map.delete(c),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,g){const d=this._state;let t=this._head;for(;t;){if(g?c.bind(g)(t.value,t.key,this):c(t.value,t.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,g=this._state;let d=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:d.key,done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}values(){const c=this,g=this._state;let d=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:d.value,done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}entries(){const c=this,g=this._state;let d=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:[d.key,d.value],done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let g=this._head,d=this.size;for(;g&&d>c;)this._map.delete(g.key),g=g.next,d--;this._head=g,this._size=d,g&&(g.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const g=c.next,d=c.previous;if(!g||!d)throw new Error("Invalid list");g.previous=d,d.next=g}c.next=void 0,c.previous=void 0,this._state++}touch(c,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(c===this._head)return;const d=c.next,t=c.previous;c===this._tail?(t.next=void 0,this._tail=t):(d.previous=t,t.next=d),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(g===2){if(c===this._tail)return;const d=c.next,t=c.previous;c===this._head?(d.previous=void 0,this._head=d):(d.previous=t,t.next=d),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((g,d)=>{c.push([d,g])}),c}fromJSON(c){this.clear();for(const[g,d]of c)this.set(g,d)}}e.LinkedMap=S;class _ extends S{constructor(c,g=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,g=2){return super.get(c,g)}peek(c){return super.get(c,0)}set(c,g){return super.set(c,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_;class w{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let g=this.map.get(c)||0;return g===0?!1:(g--,g===0?this.map.delete(c):this.map.set(c,g),!0)}has(c){return this.map.has(c)}}e.CounterSet=w;class u{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[g,d]of c)this.set(g,d)}clear(){this._m1.clear(),this._m2.clear()}set(c,g){this._m1.set(c,g),this._m2.set(g,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const g=this._m1.get(c);return g===void 0?!1:(this._m1.delete(c),this._m2.delete(g),!0)}forEach(c,g){this._m1.forEach((d,t)=>{c.call(g,d,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=u;class r{constructor(){this.map=new Map}add(c,g){let d=this.map.get(c);d||(d=new Set,this.map.set(c,d)),d.add(g)}delete(c,g){const d=this.map.get(c);d&&(d.delete(g),d.size===0&&this.map.delete(c))}forEach(c,g){const d=this.map.get(c);d&&d.forEach(g)}get(c){const g=this.map.get(c);return g||new Set}}e.SetMap=r}),define(De[3],Ie([1,0,19,73,28,74,50]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const v=!1;let y=null;class E{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(f){let P=this.livingDisposables.get(f);return P||(P={parent:null,source:null,isSingleton:!1,value:f,idx:E.idx++},this.livingDisposables.set(f,P)),P}trackDisposable(f){const P=this.getDisposableData(f);P.source||(P.source=new Error().stack)}setParent(f,P){const M=this.getDisposableData(f);M.parent=P}markAsDisposed(f){this.livingDisposables.delete(f)}markAsSingleton(f){this.getDisposableData(f).isSingleton=!0}getRootParent(f,P){const M=P.get(f);if(M)return M;const N=f.parent?this.getRootParent(this.getDisposableData(f.parent),P):f;return P.set(f,N),N}getTrackedDisposables(){const f=new Map;return[...this.livingDisposables.entries()].filter(([,M])=>M.source!==null&&!this.getRootParent(M,f).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(f=10,P){let M;if(P)M=P;else{const O=new Map,j=[...this.livingDisposables.values()].filter(fe=>fe.source!==null&&!this.getRootParent(fe,O).isSingleton);if(j.length===0)return;const V=new Set(j.map(fe=>fe.value));if(M=j.filter(fe=>!(fe.parent&&V.has(fe.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function N(O){function j(fe,J){for(;fe.length>0&&J.some(X=>typeof X=="string"?X===fe[0]:fe[0].match(X));)fe.shift()}const V=O.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return j(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const L=new h.SetMap;for(const O of M){const j=N(O);for(let V=0;V<=j.length;V++)L.add(j.slice(0,V).join(`
`),O)}M.sort((0,I.compareBy)(O=>O.idx,I.numberComparator));let U="",x=0;for(const O of M.slice(0,f)){x++;const j=N(O),V=[];for(let fe=0;fe<j.length;fe++){let J=j[fe];J=`(shared with ${L.get(j.slice(0,fe+1).join(`
`)).size}/${M.length} leaks) at ${J}`;const z=L.get(j.slice(0,fe).join(`
`)),Q=(0,F.groupBy)([...z].map(ve=>N(ve)[fe]),ve=>ve);delete Q[j[fe]];for(const[ve,le]of Object.entries(Q))V.unshift(`    - stacktraces of ${le.length} other leaks continue with ${ve}`);V.unshift(J)}U+=`


==================== Leaking disposable ${x}/${M.length}: ${O.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return M.length>f&&(U+=`


... and ${M.length-f} more leaking disposables

`),{leaks:M,details:U}}}e.DisposableTracker=E;function T(m){y=m}if(e.setDisposableTracker=T,v){const m="__is_disposable_tracked__";T(new class{trackDisposable(f){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[m]||console.log(P)},3e3)}setParent(f,P){if(f&&f!==t.None)try{f[m]=!0}catch{}}markAsDisposed(f){if(f&&f!==t.None)try{f[m]=!0}catch{}}markAsSingleton(f){}})}function k(m){return y?.trackDisposable(m),m}e.trackDisposable=k;function b(m){y?.markAsDisposed(m)}e.markAsDisposed=b;function S(m,f){y?.setParent(m,f)}function _(m,f){if(y)for(const P of m)y.setParent(P,f)}function w(m){return y?.markAsSingleton(m),m}e.markAsSingleton=w;function u(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=u;function r(m){if(A.Iterable.is(m)){const f=[];for(const P of m)if(P)try{P.dispose()}catch(M){f.push(M)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=r;function o(m){for(const f of m)u(f)&&f.dispose();return[]}e.disposeIfDisposable=o;function c(...m){const f=g(()=>r(m));return _(m,f),f}e.combinedDisposable=c;function g(m){const f=k({dispose:(0,R.createSingleCallFunction)(()=>{b(f),m()})});return f}e.toDisposable=g;class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{r(this._toDispose)}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return S(f,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(f),f.dispose()}}deleteAndLeak(f){f&&this._toDispose.has(f)&&(this._toDispose.delete(f),S(f,null))}}e.DisposableStore=d;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new d,k(this),S(this._store,this)}dispose(){b(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}e.Disposable=t;class n{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){this._isDisposed||f===this._value||(this._value?.dispose(),f&&S(f,this),this._value=f)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&S(f,null),f}}e.MutableDisposable=n;class s{constructor(f){this._disposable=f,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(f){let P=f;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,b(this))},this}}e.SafeDisposable=i;class a{constructor(){this.references=new Map}acquire(f,...P){let M=this.references.get(f);M||(M={counter:0,object:this.createReferencedObject(f,...P)},this.references.set(f,M));const{object:N}=M,L=(0,R.createSingleCallFunction)(()=>{--M.counter===0&&(this.destroyReferencedObject(f,M.object),this.references.delete(f))});return M.counter++,{object:N,dispose:L}}}e.ReferenceCollection=a;class l{constructor(f){this.referenceCollection=f}async acquire(f,...P){const M=this.referenceCollection.acquire(f,...P);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(N){throw M.dispose(),N}}}e.AsyncReferenceCollection=l;class C{constructor(f){this.object=f}dispose(){}}e.ImmortalReference=C;function D(m){const f=new d;try{m(f)}finally{f.dispose()}}e.disposeOnReturn=D;class p{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{r(this._store.values())}finally{this._store.clear()}}has(f){return this._store.has(f)}get size(){return this._store.size}get(f){return this._store.get(f)}set(f,P,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(f)?.dispose(),this._store.set(f,P)}deleteAndDispose(f){this._store.get(f)?.dispose(),this._store.delete(f)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=p}),function(ge,e){typeof define=="function"&&define.amd?define(De[158],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ie,re){for(var ye=0;ye<re.length;ye++){var oe=re[ye];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ie,oe.key,oe)}}function I(ie,re,ye){return re&&e(ie.prototype,re),ye&&e(ie,ye),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function F(ie,re){if(ie){if(typeof ie=="string")return h(ie,re);var ye=Object.prototype.toString.call(ie).slice(8,-1);if(ye==="Object"&&ie.constructor&&(ye=ie.constructor.name),ye==="Map"||ye==="Set")return Array.from(ie);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return h(ie,re)}}function h(ie,re){(re==null||re>ie.length)&&(re=ie.length);for(var ye=0,oe=new Array(re);ye<re;ye++)oe[ye]=ie[ye];return oe}function R(ie,re){var ye=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(ye)return(ye=ye.call(ie)).next.bind(ye);if(Array.isArray(ie)||(ye=F(ie))||re&&ie&&typeof ie.length=="number"){ye&&(ie=ye);var oe=0;return function(){return oe>=ie.length?{done:!0}:{done:!1,value:ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=A();function v(ie){ge.defaults=ie}var y=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(re){return b[re]};function _(ie,re){if(re){if(y.test(ie))return ie.replace(E,S)}else if(T.test(ie))return ie.replace(k,S);return ie}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ie){return ie.replace(w,function(re,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var r=/(^|[^\[])\^/g;function o(ie,re){ie=typeof ie=="string"?ie:ie.source,re=re||"";var ye={replace:function(de,ee){return ee=ee.source||ee,ee=ee.replace(r,"$1"),ie=ie.replace(de,ee),ye},getRegex:function(){return new RegExp(ie,re)}};return ye}var c=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(ie,re,ye){if(ie){var oe;try{oe=decodeURIComponent(u(ye)).replace(c,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}re&&!g.test(ye)&&(ye=a(re,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},n=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ie,re){t[" "+ie]||(n.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=p(ie,"/",!0)),ie=t[" "+ie];var ye=ie.indexOf(":")===-1;return re.substring(0,2)==="//"?ye?re:ie.replace(s,"$1")+re:re.charAt(0)==="/"?ye?re:ie.replace(i,"$1")+re:ie+re}var l={exec:function(){}};function C(ie){for(var re=1,ye,oe;re<arguments.length;re++){ye=arguments[re];for(oe in ye)Object.prototype.hasOwnProperty.call(ye,oe)&&(ie[oe]=ye[oe])}return ie}function D(ie,re){var ye=ie.replace(/\|/g,function(ee,ue,pe){for(var Pe=!1,$=ue;--$>=0&&pe[$]==="\\";)Pe=!Pe;return Pe?"|":" |"}),oe=ye.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>re)oe.splice(re);else for(;oe.length<re;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function p(ie,re,ye){var oe=ie.length;if(oe===0)return"";for(var de=0;de<oe;){var ee=ie.charAt(oe-de-1);if(ee===re&&!ye)de++;else if(ee!==re&&ye)de++;else break}return ie.slice(0,oe-de)}function m(ie,re){if(ie.indexOf(re[1])===-1)return-1;for(var ye=ie.length,oe=0,de=0;de<ye;de++)if(ie[de]==="\\")de++;else if(ie[de]===re[0])oe++;else if(ie[de]===re[1]&&(oe--,oe<0))return de;return-1}function f(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ie,re){if(re<1)return"";for(var ye="";re>1;)re&1&&(ye+=ie),re>>=1,ie+=ie;return ye+ie}function M(ie,re,ye,oe){var de=re.href,ee=re.title?_(re.title):null,ue=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var pe={type:"link",raw:ye,href:de,title:ee,text:ue,tokens:oe.inlineTokens(ue)};return oe.state.inLink=!1,pe}return{type:"image",raw:ye,href:de,title:ee,text:_(ue)}}function N(ie,re){var ye=ie.match(/^(\s+)(?:```)/);if(ye===null)return re;var oe=ye[1];return re.split(`
`).map(function(de){var ee=de.match(/^\s+/);if(ee===null)return de;var ue=ee[0];return ue.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var L=function(){function ie(ye){this.options=ye||ge.defaults}var re=ie.prototype;return re.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},re.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:p(ee,`
`)}}},re.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var ee=de[0],ue=N(ee,de[3]||"");return{type:"code",raw:ee,lang:de[2]?de[2].trim():de[2],text:ue}}},re.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var ee=de[2].trim();if(/#$/.test(ee)){var ue=p(ee,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(ee=ue.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ee,tokens:this.lexer.inline(ee)}}},re.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},re.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var ee=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},re.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var ee,ue,pe,Pe,$,K,te,se,Y,he,Se,Ue,We=de[1].trim(),Ze=We.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+We.slice(0,-1):"",loose:!1,items:[]};We=Ze?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=Ze?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(Ue=!1,!(!(de=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=de[0],oe=oe.substring(ee.length),se=de[2].split(`
`,1)[0],Y=oe.split(`
`,1)[0],this.options.pedantic?(Pe=2,Se=se.trimLeft()):(Pe=de[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Se=se.slice(Pe),Pe+=de[1].length),K=!1,!se&&/^ *$/.test(Y)&&(ee+=Y+`
`,oe=oe.substring(Y.length+1),Ue=!0),!Ue)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Te=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");oe&&(he=oe.split(`
`,1)[0],se=he,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(se)||ze.test(se)||et.test(se)||Te.test(oe)));){if(se.search(/[^ ]/)>=Pe||!se.trim())Se+=`
`+se.slice(Pe);else if(!K)Se+=`
`+se;else break;!K&&!se.trim()&&(K=!0),ee+=he+`
`,oe=oe.substring(he.length+1)}Qe.loose||(te?Qe.loose=!0:/\n *\n *$/.test(ee)&&(te=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Se),ue&&(pe=ue[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ee,task:!!ue,checked:pe,loose:!1,text:Se}),Qe.raw+=ee}Qe.items[Qe.items.length-1].raw=ee.trimRight(),Qe.items[Qe.items.length-1].text=Se.trimRight(),Qe.raw=Qe.raw.trimRight();var Re=Qe.items.length;for($=0;$<Re;$++){this.lexer.state.top=!1,Qe.items[$].tokens=this.lexer.blockTokens(Qe.items[$].text,[]);var Xe=Qe.items[$].tokens.filter(function(ae){return ae.type==="space"}),ce=Xe.every(function(ae){for(var ke=ae.raw.split(""),He=0,xe=R(ke),Ye;!(Ye=xe()).done;){var rt=Ye.value;if(rt===`
`&&(He+=1),He>1)return!0}return!1});!Qe.loose&&Xe.length&&ce&&(Qe.loose=!0,Qe.items[$].loose=!0)}return Qe}},re.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(de[0]):_(de[0]);ee.type="paragraph",ee.text=ue,ee.tokens=this.lexer.inline(ue)}return ee}},re.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:de[0],href:de[2],title:de[3]}}},re.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var ee={type:"table",header:D(de[1]).map(function(te){return{text:te}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=de[0];var ue=ee.align.length,pe,Pe,$,K;for(pe=0;pe<ue;pe++)/^ *-+: *$/.test(ee.align[pe])?ee.align[pe]="right":/^ *:-+: *$/.test(ee.align[pe])?ee.align[pe]="center":/^ *:-+ *$/.test(ee.align[pe])?ee.align[pe]="left":ee.align[pe]=null;for(ue=ee.rows.length,pe=0;pe<ue;pe++)ee.rows[pe]=D(ee.rows[pe],ee.header.length).map(function(te){return{text:te}});for(ue=ee.header.length,Pe=0;Pe<ue;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(ue=ee.rows.length,Pe=0;Pe<ue;Pe++)for(K=ee.rows[Pe],$=0;$<K.length;$++)K[$].tokens=this.lexer.inline(K[$].text);return ee}}},re.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},re.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var ee=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ee,tokens:this.lexer.inline(ee)}}},re.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},re.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:_(de[1])}},re.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):_(de[0]):de[0]}},re.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var ee=de[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ue=p(ee.slice(0,-1),"\\");if((ee.length-ue.length)%2===0)return}else{var pe=m(de[2],"()");if(pe>-1){var Pe=de[0].indexOf("!")===0?5:4,$=Pe+de[1].length+pe;de[2]=de[2].substring(0,pe),de[0]=de[0].substring(0,$).trim(),de[3]=""}}var K=de[2],te="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);se&&(K=se[1],te=se[3])}else te=de[3]?de[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ee)?K=K.slice(1):K=K.slice(1,-1)),M(de,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:te&&te.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},re.reflink=function(oe,de){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var ue=(ee[2]||ee[1]).replace(/\s+/g," ");if(ue=de[ue.toLowerCase()],!ue||!ue.href){var pe=ee[0].charAt(0);return{type:"text",raw:pe,text:pe}}return M(ee,ue,ee[0],this.lexer)}},re.emStrong=function(oe,de,ee){ee===void 0&&(ee="");var ue=this.rules.inline.emStrong.lDelim.exec(oe);if(ue&&!(ue[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=ue[1]||ue[2]||"";if(!pe||pe&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=ue[0].length-1,$,K,te=Pe,se=0,Y=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,de=de.slice(-1*oe.length+Pe);(ue=Y.exec(de))!=null;)if($=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!$){if(K=$.length,ue[3]||ue[4]){te+=K;continue}else if((ue[5]||ue[6])&&Pe%3&&!((Pe+K)%3)){se+=K;continue}if(te-=K,!(te>0)){if(K=Math.min(K,K+te+se),Math.min(Pe,K)%2){var he=oe.slice(1,Pe+ue.index+K);return{type:"em",raw:oe.slice(0,Pe+ue.index+K+1),text:he,tokens:this.lexer.inlineTokens(he)}}var Se=oe.slice(2,Pe+ue.index+K-1);return{type:"strong",raw:oe.slice(0,Pe+ue.index+K+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},re.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var ee=de[2].replace(/\n/g," "),ue=/[^ ]/.test(ee),pe=/^ /.test(ee)&&/ $/.test(ee);return ue&&pe&&(ee=ee.substring(1,ee.length-1)),ee=_(ee,!0),{type:"codespan",raw:de[0],text:ee}}},re.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},re.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},re.autolink=function(oe,de){var ee=this.rules.inline.autolink.exec(oe);if(ee){var ue,pe;return ee[2]==="@"?(ue=_(this.options.mangle?de(ee[1]):ee[1]),pe="mailto:"+ue):(ue=_(ee[1]),pe=ue),{type:"link",raw:ee[0],text:ue,href:pe,tokens:[{type:"text",raw:ue,text:ue}]}}},re.url=function(oe,de){var ee;if(ee=this.rules.inline.url.exec(oe)){var ue,pe;if(ee[2]==="@")ue=_(this.options.mangle?de(ee[0]):ee[0]),pe="mailto:"+ue;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);ue=_(ee[0]),ee[1]==="www."?pe="http://"+ue:pe=ue}return{type:"link",raw:ee[0],text:ue,href:pe,tokens:[{type:"text",raw:ue,text:ue}]}}},re.inlineText=function(oe,de){var ee=this.rules.inline.text.exec(oe);if(ee){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):_(ee[0]):ee[0]:ue=_(this.options.smartypants?de(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},ie}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=o(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=o(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=o(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=o(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=o(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=o(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=C({},U),U.gfm=C({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=o(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=o(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=C({},U.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:o(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var x={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};x._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",x.punctuation=o(x.punctuation).replace(/punctuation/g,x._punctuation).getRegex(),x.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,x.escapedEmSt=/\\\*|\\_/g,x._comment=o(U._comment).replace("(?:-->|$)","-->").getRegex(),x.emStrong.lDelim=o(x.emStrong.lDelim).replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimAst=o(x.emStrong.rDelimAst,"g").replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimUnd=o(x.emStrong.rDelimUnd,"g").replace(/punct/g,x._punctuation).getRegex(),x._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,x._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,x._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,x.autolink=o(x.autolink).replace("scheme",x._scheme).replace("email",x._email).getRegex(),x._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,x.tag=o(x.tag).replace("comment",x._comment).replace("attribute",x._attribute).getRegex(),x._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,x._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,x._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,x.link=o(x.link).replace("label",x._label).replace("href",x._href).replace("title",x._title).getRegex(),x.reflink=o(x.reflink).replace("label",x._label).replace("ref",U._label).getRegex(),x.nolink=o(x.nolink).replace("ref",U._label).getRegex(),x.reflinkSearch=o(x.reflinkSearch,"g").replace("reflink",x.reflink).replace("nolink",x.nolink).getRegex(),x.normal=C({},x),x.pedantic=C({},x.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",x._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",x._label).getRegex()}),x.gfm=C({},x.normal,{escape:o(x.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),x.gfm.url=o(x.gfm.url,"i").replace("email",x.gfm._extended_email).getRegex(),x.breaks=C({},x.gfm,{br:o(x.br).replace("{2,}","*").getRegex(),text:o(x.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ie){var re="",ye,oe,de=ie.length;for(ye=0;ye<de;ye++)oe=ie.charCodeAt(ye),Math.random()>.5&&(oe="x"+oe.toString(16)),re+="&#"+oe+";";return re}var V=function(){function ie(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ge.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:U.normal,inline:x.normal};this.options.pedantic?(oe.block=U.pedantic,oe.inline=x.pedantic):this.options.gfm&&(oe.block=U.gfm,this.options.breaks?oe.inline=x.breaks:oe.inline=x.gfm),this.tokenizer.rules=oe}ie.lex=function(oe,de){var ee=new ie(de);return ee.lex(oe)},ie.lexInline=function(oe,de){var ee=new ie(de);return ee.inlineTokens(oe)};var re=ie.prototype;return re.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},re.blockTokens=function(oe,de){var ee=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(te,se,Y){return se+"    ".repeat(Y.length)});for(var ue,pe,Pe,$;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(te){return(ue=te.call({lexer:ee},oe,de))?(oe=oe.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.space(oe)){oe=oe.substring(ue.raw.length),ue.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ue);continue}if(ue=this.tokenizer.code(oe)){oe=oe.substring(ue.raw.length),pe=de[de.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ue.raw,pe.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(ue);continue}if(ue=this.tokenizer.fences(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.heading(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.hr(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.blockquote(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.list(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.html(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.def(oe)){oe=oe.substring(ue.raw.length),pe=de[de.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ue.raw,pe.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.lheading(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var te=1/0,se=oe.slice(1),Y=void 0;ee.options.extensions.startBlock.forEach(function(he){Y=he.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(te=Math.min(te,Y))}),te<1/0&&te>=0&&(Pe=oe.substring(0,te+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(Pe))){pe=de[de.length-1],$&&pe.type==="paragraph"?(pe.raw+=`
`+ue.raw,pe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(ue),$=Pe.length!==oe.length,oe=oe.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(oe)){oe=oe.substring(ue.raw.length),pe=de[de.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+ue.raw,pe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(ue);continue}if(oe){var K="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,de},re.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},re.inlineTokens=function(oe,de){var ee=this;de===void 0&&(de=[]);var ue,pe,Pe,$=oe,K,te,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec($))!=null;)Y.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&($=$.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+$.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec($))!=null;)$=$.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+$.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec($))!=null;)$=$.slice(0,K.index)+"++"+$.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(te||(se=""),te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(ue=Se.call({lexer:ee},oe,de))?(oe=oe.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.tag(oe)){oe=oe.substring(ue.raw.length),pe=de[de.length-1],pe&&ue.type==="text"&&pe.type==="text"?(pe.raw+=ue.raw,pe.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.link(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ue.raw.length),pe=de[de.length-1],pe&&ue.type==="text"&&pe.type==="text"?(pe.raw+=ue.raw,pe.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.emStrong(oe,$,se)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.codespan(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.br(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.del(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.autolink(oe,j)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(oe,j))){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,Ue=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(Ze){We=Ze.call({lexer:this},Ue),typeof We=="number"&&We>=0&&(Se=Math.min(Se,We))}),Se<1/0&&Se>=0&&(Pe=oe.substring(0,Se+1))}(),ue=this.tokenizer.inlineText(Pe,O)){oe=oe.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(se=ue.raw.slice(-1)),te=!0,pe=de[de.length-1],pe&&pe.type==="text"?(pe.raw+=ue.raw,pe.text+=ue.text):de.push(ue);continue}if(oe){var he="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return de},I(ie,null,[{key:"rules",get:function(){return{block:U,inline:x}}}]),ie}(),fe=function(){function ie(ye){this.options=ye||ge.defaults}var re=ie.prototype;return re.code=function(oe,de,ee){var ue=(de||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(oe,ue);pe!=null&&pe!==oe&&(ee=!0,oe=pe)}return oe=oe.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+_(ue,!0)+'">'+(ee?oe:_(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:_(oe,!0))+`</code></pre>
`},re.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},re.html=function(oe){return oe},re.heading=function(oe,de,ee,ue){if(this.options.headerIds){var pe=this.options.headerPrefix+ue.slug(ee);return"<h"+de+' id="'+pe+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(oe,de,ee){var ue=de?"ol":"ul",pe=de&&ee!==1?' start="'+ee+'"':"";return"<"+ue+pe+`>
`+oe+"</"+ue+`>
`},re.listitem=function(oe){return"<li>"+oe+`</li>
`},re.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(oe){return"<p>"+oe+`</p>
`},re.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},re.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},re.tablecell=function(oe,de){var ee=de.header?"th":"td",ue=de.align?"<"+ee+' align="'+de.align+'">':"<"+ee+">";return ue+oe+("</"+ee+`>
`)},re.strong=function(oe){return"<strong>"+oe+"</strong>"},re.em=function(oe){return"<em>"+oe+"</em>"},re.codespan=function(oe){return"<code>"+oe+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(oe){return"<del>"+oe+"</del>"},re.link=function(oe,de,ee){if(oe=d(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ue='<a href="'+_(oe)+'"';return de&&(ue+=' title="'+de+'"'),ue+=">"+ee+"</a>",ue},re.image=function(oe,de,ee){if(oe=d(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ue='<img src="'+oe+'" alt="'+ee+'"';return de&&(ue+=' title="'+de+'"'),ue+=this.options.xhtml?"/>":">",ue},re.text=function(oe){return oe},ie}(),J=function(){function ie(){}var re=ie.prototype;return re.strong=function(oe){return oe},re.em=function(oe){return oe},re.codespan=function(oe){return oe},re.del=function(oe){return oe},re.html=function(oe){return oe},re.text=function(oe){return oe},re.link=function(oe,de,ee){return""+ee},re.image=function(oe,de,ee){return""+ee},re.br=function(){return""},ie}(),X=function(){function ie(){this.seen={}}var re=ie.prototype;return re.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(oe,de){var ee=oe,ue=0;if(this.seen.hasOwnProperty(ee)){ue=this.seen[oe];do ue++,ee=oe+"-"+ue;while(this.seen.hasOwnProperty(ee))}return de||(this.seen[oe]=ue,this.seen[ee]=0),ee},re.slug=function(oe,de){de===void 0&&(de={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,de.dryrun)},ie}(),z=function(){function ie(ye){this.options=ye||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new X}ie.parse=function(oe,de){var ee=new ie(de);return ee.parse(oe)},ie.parseInline=function(oe,de){var ee=new ie(de);return ee.parseInline(oe)};var re=ie.prototype;return re.parse=function(oe,de){de===void 0&&(de=!0);var ee="",ue,pe,Pe,$,K,te,se,Y,he,Se,Ue,We,Ze,Qe,it,et,Te,Me,ze,Re=oe.length;for(ue=0;ue<Re;ue++){if(Se=oe[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(ze=this.options.extensions.renderers[Se.type].call({parser:this},Se),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){ee+=ze||"";continue}switch(Se.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,u(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(Y="",se="",$=Se.header.length,pe=0;pe<$;pe++)se+=this.renderer.tablecell(this.parseInline(Se.header[pe].tokens),{header:!0,align:Se.align[pe]});for(Y+=this.renderer.tablerow(se),he="",$=Se.rows.length,pe=0;pe<$;pe++){for(te=Se.rows[pe],se="",K=te.length,Pe=0;Pe<K;Pe++)se+=this.renderer.tablecell(this.parseInline(te[Pe].tokens),{header:!1,align:Se.align[Pe]});he+=this.renderer.tablerow(se)}ee+=this.renderer.table(Y,he);continue}case"blockquote":{he=this.parse(Se.tokens),ee+=this.renderer.blockquote(he);continue}case"list":{for(Ue=Se.ordered,We=Se.start,Ze=Se.loose,$=Se.items.length,he="",pe=0;pe<$;pe++)it=Se.items[pe],et=it.checked,Te=it.task,Qe="",it.task&&(Me=this.renderer.checkbox(et),Ze?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Me+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Me+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(it.tokens,Ze),he+=this.renderer.listitem(Qe,Te,et);ee+=this.renderer.list(he,Ue,We);continue}case"html":{ee+=this.renderer.html(Se.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(he=Se.tokens?this.parseInline(Se.tokens):Se.text;ue+1<Re&&oe[ue+1].type==="text";)Se=oe[++ue],he+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);ee+=de?this.renderer.paragraph(he):he;continue}default:{var Xe='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},re.parseInline=function(oe,de){de=de||this.renderer;var ee="",ue,pe,Pe,$=oe.length;for(ue=0;ue<$;ue++){if(pe=oe[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){ee+=Pe||"";continue}switch(pe.type){case"escape":{ee+=de.text(pe.text);break}case"html":{ee+=de.html(pe.text);break}case"link":{ee+=de.link(pe.href,pe.title,this.parseInline(pe.tokens,de));break}case"image":{ee+=de.image(pe.href,pe.title,pe.text);break}case"strong":{ee+=de.strong(this.parseInline(pe.tokens,de));break}case"em":{ee+=de.em(this.parseInline(pe.tokens,de));break}case"codespan":{ee+=de.codespan(pe.text);break}case"br":{ee+=de.br();break}case"del":{ee+=de.del(this.parseInline(pe.tokens,de));break}case"text":{ee+=de.text(pe.text);break}default:{var K='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ee},ie}();function Q(ie,re,ye){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof re=="function"&&(ye=re,re=null),re=C({},Q.defaults,re||{}),f(re),ye){var oe=re.highlight,de;try{de=V.lex(ie,re)}catch($){return ye($)}var ee=function(K){var te;if(!K)try{re.walkTokens&&Q.walkTokens(de,re.walkTokens),te=z.parse(de,re)}catch(se){K=se}return re.highlight=oe,K?ye(K):ye(null,te)};if(!oe||oe.length<3||(delete re.highlight,!de.length))return ee();var ue=0;Q.walkTokens(de,function($){$.type==="code"&&(ue++,setTimeout(function(){oe($.text,$.lang,function(K,te){if(K)return ee(K);te!=null&&te!==$.text&&($.text=te,$.escaped=!0),ue--,ue===0&&ee()})},0))}),ue===0&&ee();return}function pe($){if($.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+_($.message+"",!0)+"</pre>";throw $}try{var Pe=V.lex(ie,re);if(re.walkTokens){if(re.async)return Promise.all(Q.walkTokens(Pe,re.walkTokens)).then(function(){return z.parse(Pe,re)}).catch(pe);Q.walkTokens(Pe,re.walkTokens)}return z.parse(Pe,re)}catch($){pe($)}}Q.options=Q.setOptions=function(ie){return C(Q.defaults,ie),v(Q.defaults),Q},Q.getDefaults=A,Q.defaults=ge.defaults,Q.use=function(){for(var ie=arguments.length,re=new Array(ie),ye=0;ye<ie;ye++)re[ye]=arguments[ye];var oe=C.apply(void 0,[{}].concat(re)),de=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;re.forEach(function(ue){if(ue.extensions&&(ee=!0,ue.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var $=de.renderers?de.renderers[Pe.name]:null;$?de.renderers[Pe.name]=function(){for(var K=arguments.length,te=new Array(K),se=0;se<K;se++)te[se]=arguments[se];var Y=Pe.renderer.apply(this,te);return Y===!1&&(Y=$.apply(this,te)),Y}:de.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Pe.level]?de[Pe.level].unshift(Pe.tokenizer):de[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?de.startBlock?de.startBlock.push(Pe.start):de.startBlock=[Pe.start]:Pe.level==="inline"&&(de.startInline?de.startInline.push(Pe.start):de.startInline=[Pe.start]))}Pe.childTokens&&(de.childTokens[Pe.name]=Pe.childTokens)})),ue.renderer&&function(){var Pe=Q.defaults.renderer||new fe,$=function(se){var Y=Pe[se];Pe[se]=function(){for(var he=arguments.length,Se=new Array(he),Ue=0;Ue<he;Ue++)Se[Ue]=arguments[Ue];var We=ue.renderer[se].apply(Pe,Se);return We===!1&&(We=Y.apply(Pe,Se)),We}};for(var K in ue.renderer)$(K);oe.renderer=Pe}(),ue.tokenizer&&function(){var Pe=Q.defaults.tokenizer||new L,$=function(se){var Y=Pe[se];Pe[se]=function(){for(var he=arguments.length,Se=new Array(he),Ue=0;Ue<he;Ue++)Se[Ue]=arguments[Ue];var We=ue.tokenizer[se].apply(Pe,Se);return We===!1&&(We=Y.apply(Pe,Se)),We}};for(var K in ue.tokenizer)$(K);oe.tokenizer=Pe}(),ue.walkTokens){var pe=Q.defaults.walkTokens;oe.walkTokens=function(Pe){var $=[];return $.push(ue.walkTokens.call(this,Pe)),pe&&($=$.concat(pe.call(this,Pe))),$}}ee&&(oe.extensions=de),Q.setOptions(oe)})},Q.walkTokens=function(ie,re){for(var ye=[],oe=function(){var pe=ee.value;switch(ye=ye.concat(re.call(Q,pe)),pe.type){case"table":{for(var Pe=R(pe.header),$;!($=Pe()).done;){var K=$.value;ye=ye.concat(Q.walkTokens(K.tokens,re))}for(var te=R(pe.rows),se;!(se=te()).done;)for(var Y=se.value,he=R(Y),Se;!(Se=he()).done;){var Ue=Se.value;ye=ye.concat(Q.walkTokens(Ue.tokens,re))}break}case"list":{ye=ye.concat(Q.walkTokens(pe.items,re));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[pe.type]?Q.defaults.extensions.childTokens[pe.type].forEach(function(We){ye=ye.concat(Q.walkTokens(pe[We],re))}):pe.tokens&&(ye=ye.concat(Q.walkTokens(pe.tokens,re)))}},de=R(ie),ee;!(ee=de()).done;)oe();return ye},Q.parseInline=function(ie,re){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");re=C({},Q.defaults,re||{}),f(re);try{var ye=V.lexInline(ie,re);return re.walkTokens&&Q.walkTokens(ye,re.walkTokens),z.parseInline(ye,re)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+_(oe.message+"",!0)+"</pre>";throw oe}},Q.Parser=z,Q.parser=z.parse,Q.Renderer=fe,Q.TextRenderer=J,Q.Lexer=V,Q.lexer=V.lex,Q.Tokenizer=L,Q.Slugger=X,Q.parse=Q;var ve=Q.options,le=Q.setOptions,we=Q.use,G=Q.walkTokens,B=Q.parseInline,H=Q,me=z.parse,Z=V.lex;ge.Lexer=V,ge.Parser=z,ge.Renderer=fe,ge.Slugger=X,ge.TextRenderer=J,ge.Tokenizer=L,ge.getDefaults=A,ge.lexer=Z,ge.marked=Q,ge.options=ve,ge.parse=H,ge.parseInline=B,ge.parser=me,ge.setOptions=le,ge.use=we,ge.walkTokens=G,Object.defineProperty(ge,"__esModule",{value:!0})}),define(De[76],Ie([1,0,28]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new I.LRUCache(1e4);function h(E){return y(E,"NFC",F)}e.normalizeNFC=h;const R=new I.LRUCache(1e4);function A(E){return y(E,"NFD",R)}e.normalizeNFD=A;const v=/[^\u0000-\u0080]/;function y(E,T,k){if(!E)return E;const b=k.get(E);if(b)return b;let S;return v.test(E)?S=E.normalize(T):S=E,k.set(E,S),S}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(T){return A(T).replace(E,"")}}()}),define(De[120],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(v,y,E){return Math.min(Math.max(v,y),E)}e.clamp=I;function F(v,y){return(y+v%y)%y}e.rot=F;class h{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=h;class R{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class A{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const E=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=E,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function ge(h){const R=[];typeof h=="number"&&R.push("code/timeOrigin",h);function A(y){R.push(y,Date.now())}function v(){const y=[];for(let E=0;E<R.length;E+=2)y.push({name:R[E],startTime:R[E+1]});return y}return{mark:A,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(h+A.startTime)});return R}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:ge)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(F){if(e[F])return e[F].exports;var h=e[F]={i:F,l:!1,exports:{}};return ge[F].call(h.exports,h,h.exports,I),h.l=!0,h.exports}return I.m=ge,I.c=e,I.d=function(F,h,R){I.o(F,h)||Object.defineProperty(F,h,{enumerable:!0,get:R})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,h){if(1&h&&(F=I(F)),8&h||4&h&&typeof F=="object"&&F&&F.__esModule)return F;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:F}),2&h&&typeof F!="string")for(var A in F)I.d(R,A,function(v){return F[v]}.bind(null,A));return R},I.n=function(F){var h=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(h,"a",h),h},I.o=function(F,h){return Object.prototype.hasOwnProperty.call(F,h)},I.p="",I(I.s=0)}([function(ge,e,I){(function(F){var h;e=ge.exports=we,h=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],y=e.src=[],E=0,T=E++;y[T]="0|[1-9]\\d*";var k=E++;y[k]="[0-9]+";var b=E++;y[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;y[S]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var _=E++;y[_]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var w=E++;y[w]="(?:"+y[T]+"|"+y[b]+")";var u=E++;y[u]="(?:"+y[k]+"|"+y[b]+")";var r=E++;y[r]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var o=E++;y[o]="(?:-?("+y[u]+"(?:\\."+y[u]+")*))";var c=E++;y[c]="[0-9A-Za-z-]+";var g=E++;y[g]="(?:\\+("+y[c]+"(?:\\."+y[c]+")*))";var d=E++,t="v?"+y[S]+y[r]+"?"+y[g]+"?";y[d]="^"+t+"$";var n="[v=\\s]*"+y[_]+y[o]+"?"+y[g]+"?",s=E++;y[s]="^"+n+"$";var i=E++;y[i]="((?:<|>)?=?)";var a=E++;y[a]=y[k]+"|x|X|\\*";var l=E++;y[l]=y[T]+"|x|X|\\*";var C=E++;y[C]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[r]+")?"+y[g]+"?)?)?";var D=E++;y[D]="[v=\\s]*("+y[a]+")(?:\\.("+y[a]+")(?:\\.("+y[a]+")(?:"+y[o]+")?"+y[g]+"?)?)?";var p=E++;y[p]="^"+y[i]+"\\s*"+y[C]+"$";var m=E++;y[m]="^"+y[i]+"\\s*"+y[D]+"$";var f=E++;y[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;y[P]="(?:~>?)";var M=E++;y[M]="(\\s*)"+y[P]+"\\s+",v[M]=new RegExp(y[M],"g");var N=E++;y[N]="^"+y[P]+y[C]+"$";var L=E++;y[L]="^"+y[P]+y[D]+"$";var U=E++;y[U]="(?:\\^)";var x=E++;y[x]="(\\s*)"+y[U]+"\\s+",v[x]=new RegExp(y[x],"g");var O=E++;y[O]="^"+y[U]+y[C]+"$";var j=E++;y[j]="^"+y[U]+y[D]+"$";var V=E++;y[V]="^"+y[i]+"\\s*("+n+")$|^$";var fe=E++;y[fe]="^"+y[i]+"\\s*("+t+")$|^$";var J=E++;y[J]="(\\s*)"+y[i]+"\\s*("+n+"|"+y[C]+")",v[J]=new RegExp(y[J],"g");var X=E++;y[X]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var z=E++;y[z]="^\\s*("+y[D]+")\\s+-\\s+("+y[D]+")\\s*$";var Q=E++;y[Q]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)h(ve,y[ve]),v[ve]||(v[ve]=new RegExp(y[ve]));function le(Y,he){if(Y instanceof we)return Y;if(typeof Y!="string"||Y.length>R||!(he?v[s]:v[d]).test(Y))return null;try{return new we(Y,he)}catch{return null}}function we(Y,he){if(Y instanceof we){if(Y.loose===he)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof we))return new we(Y,he);h("SemVer",Y,he),this.loose=he;var Se=Y.trim().match(he?v[s]:v[d]);if(!Se)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var We=+Ue;if(We>=0&&We<A)return We}return Ue}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=le,e.valid=function(Y,he){var Se=le(Y,he);return Se?Se.version:null},e.clean=function(Y,he){var Se=le(Y.trim().replace(/^[=v]+/,""),he);return Se?Se.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Y){return h("SemVer.compare",this.version,this.loose,Y),Y instanceof we||(Y=new we(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},we.prototype.compareMain=function(Y){return Y instanceof we||(Y=new we(Y,this.loose)),B(this.major,Y.major)||B(this.minor,Y.minor)||B(this.patch,Y.patch)},we.prototype.comparePre=function(Y){if(Y instanceof we||(Y=new we(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var he=0;do{var Se=this.prerelease[he],Ue=Y.prerelease[he];if(h("prerelease compare",he,Se,Ue),Se===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Se===void 0)return-1;if(Se!==Ue)return B(Se,Ue)}while(++he)},we.prototype.inc=function(Y,he){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,he,Se,Ue){typeof Se=="string"&&(Ue=Se,Se=void 0);try{return new we(Y,Se).inc(he,Ue).version}catch{return null}},e.diff=function(Y,he){if(ie(Y,he))return null;var Se=le(Y),Ue=le(he);if(Se.prerelease.length||Ue.prerelease.length){for(var We in Se)if((We==="major"||We==="minor"||We==="patch")&&Se[We]!==Ue[We])return"pre"+We;return"prerelease"}for(var We in Se)if((We==="major"||We==="minor"||We==="patch")&&Se[We]!==Ue[We])return We},e.compareIdentifiers=B;var G=/^[0-9]+$/;function B(Y,he){var Se=G.test(Y),Ue=G.test(he);return Se&&Ue&&(Y=+Y,he=+he),Se&&!Ue?-1:Ue&&!Se?1:Y<he?-1:Y>he?1:0}function H(Y,he,Se){return new we(Y,Se).compare(new we(he,Se))}function me(Y,he,Se){return H(Y,he,Se)>0}function Z(Y,he,Se){return H(Y,he,Se)<0}function ie(Y,he,Se){return H(Y,he,Se)===0}function re(Y,he,Se){return H(Y,he,Se)!==0}function ye(Y,he,Se){return H(Y,he,Se)>=0}function oe(Y,he,Se){return H(Y,he,Se)<=0}function de(Y,he,Se,Ue){var We;switch(he){case"===":typeof Y=="object"&&(Y=Y.version),typeof Se=="object"&&(Se=Se.version),We=Y===Se;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof Se=="object"&&(Se=Se.version),We=Y!==Se;break;case"":case"=":case"==":We=ie(Y,Se,Ue);break;case"!=":We=re(Y,Se,Ue);break;case">":We=me(Y,Se,Ue);break;case">=":We=ye(Y,Se,Ue);break;case"<":We=Z(Y,Se,Ue);break;case"<=":We=oe(Y,Se,Ue);break;default:throw new TypeError("Invalid operator: "+he)}return We}function ee(Y,he){if(Y instanceof ee){if(Y.loose===he)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,he);h("comparator",Y,he),this.loose=he,this.parse(Y),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(Y,he){return B(he,Y)},e.major=function(Y,he){return new we(Y,he).major},e.minor=function(Y,he){return new we(Y,he).minor},e.patch=function(Y,he){return new we(Y,he).patch},e.compare=H,e.compareLoose=function(Y,he){return H(Y,he,!0)},e.rcompare=function(Y,he,Se){return H(he,Y,Se)},e.sort=function(Y,he){return Y.sort(function(Se,Ue){return e.compare(Se,Ue,he)})},e.rsort=function(Y,he){return Y.sort(function(Se,Ue){return e.rcompare(Se,Ue,he)})},e.gt=me,e.lt=Z,e.eq=ie,e.neq=re,e.gte=ye,e.lte=oe,e.cmp=de,e.Comparator=ee;var ue={};function pe(Y,he){if(Y instanceof pe)return Y.loose===he?Y:new pe(Y.raw,he);if(Y instanceof ee)return new pe(Y.value,he);if(!(this instanceof pe))return new pe(Y,he);if(this.loose=he,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function $(Y,he,Se,Ue,We,Ze,Qe,it,et,Te,Me,ze,Re){return((he=Pe(Se)?"":Pe(Ue)?">="+Se+".0.0":Pe(We)?">="+Se+"."+Ue+".0":">="+he)+" "+(it=Pe(et)?"":Pe(Te)?"<"+(+et+1)+".0.0":Pe(Me)?"<"+et+"."+(+Te+1)+".0":ze?"<="+et+"."+Te+"."+Me+"-"+ze:"<="+it)).trim()}function K(Y,he){for(var Se=0;Se<Y.length;Se++)if(!Y[Se].test(he))return!1;if(he.prerelease.length){for(Se=0;Se<Y.length;Se++)if(h(Y[Se].semver),Y[Se].semver!==ue&&Y[Se].semver.prerelease.length>0){var Ue=Y[Se].semver;if(Ue.major===he.major&&Ue.minor===he.minor&&Ue.patch===he.patch)return!0}return!1}return!0}function te(Y,he,Se){try{he=new pe(he,Se)}catch{return!1}return he.test(Y)}function se(Y,he,Se,Ue){var We,Ze,Qe,it,et;switch(Y=new we(Y,Ue),he=new pe(he,Ue),Se){case">":We=me,Ze=oe,Qe=Z,it=">",et=">=";break;case"<":We=Z,Ze=ye,Qe=me,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(te(Y,he,Ue))return!1;for(var Te=0;Te<he.set.length;++Te){var Me=he.set[Te],ze=null,Re=null;if(Me.forEach(function(Xe){Xe.semver===ue&&(Xe=new ee(">=0.0.0")),ze=ze||Xe,Re=Re||Xe,We(Xe.semver,ze.semver,Ue)?ze=Xe:Qe(Xe.semver,Re.semver,Ue)&&(Re=Xe)}),ze.operator===it||ze.operator===et||(!Re.operator||Re.operator===it)&&Ze(Y,Re.semver)||Re.operator===et&&Qe(Y,Re.semver))return!1}return!0}ee.prototype.parse=function(Y){var he=this.loose?v[V]:v[fe],Se=Y.match(he);if(!Se)throw new TypeError("Invalid comparator: "+Y);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new we(Se[2],this.loose):this.semver=ue},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return h("Comparator.test",Y,this.loose),this.semver===ue||(typeof Y=="string"&&(Y=new we(Y,this.loose)),de(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,he){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new pe(Y.value,he),te(this.value,Se,he);if(Y.operator==="")return Se=new pe(this.value,he),te(Y.semver,Se,he);var Ue=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ze=this.semver.version===Y.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=de(this.semver,"<",Y.semver,he)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=de(this.semver,">",Y.semver,he)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ue||We||Ze&&Qe||it||et},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(Y){var he=this.loose;Y=Y.trim(),h("range",Y,he);var Se=he?v[z]:v[X];Y=Y.replace(Se,$),h("hyphen replace",Y),Y=Y.replace(v[J],"$1$2$3"),h("comparator trim",Y,v[J]),Y=(Y=(Y=Y.replace(v[M],"$1~")).replace(v[x],"$1^")).split(/\s+/).join(" ");var Ue=he?v[V]:v[fe],We=Y.split(" ").map(function(Ze){return function(Qe,it){return h("comp",Qe),Qe=function(et,Te){return et.trim().split(/\s+/).map(function(Me){return function(ze,Re){h("caret",ze,Re);var Xe=Re?v[j]:v[O];return ze.replace(Xe,function(ce,ae,ke,He,xe){var Ye;return h("caret",ze,ce,ae,ke,He,xe),Pe(ae)?Ye="":Pe(ke)?Ye=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(He)?Ye=ae==="0"?">="+ae+"."+ke+".0 <"+ae+"."+(+ke+1)+".0":">="+ae+"."+ke+".0 <"+(+ae+1)+".0.0":xe?(h("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ye=ae==="0"?ke==="0"?">="+ae+"."+ke+"."+He+xe+" <"+ae+"."+ke+"."+(+He+1):">="+ae+"."+ke+"."+He+xe+" <"+ae+"."+(+ke+1)+".0":">="+ae+"."+ke+"."+He+xe+" <"+(+ae+1)+".0.0"):(h("no pr"),Ye=ae==="0"?ke==="0"?">="+ae+"."+ke+"."+He+" <"+ae+"."+ke+"."+(+He+1):">="+ae+"."+ke+"."+He+" <"+ae+"."+(+ke+1)+".0":">="+ae+"."+ke+"."+He+" <"+(+ae+1)+".0.0"),h("caret return",Ye),Ye})}(Me,Te)}).join(" ")}(Qe,it),h("caret",Qe),Qe=function(et,Te){return et.trim().split(/\s+/).map(function(Me){return function(ze,Re){var Xe=Re?v[L]:v[N];return ze.replace(Xe,function(ce,ae,ke,He,xe){var Ye;return h("tilde",ze,ce,ae,ke,He,xe),Pe(ae)?Ye="":Pe(ke)?Ye=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(He)?Ye=">="+ae+"."+ke+".0 <"+ae+"."+(+ke+1)+".0":xe?(h("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ye=">="+ae+"."+ke+"."+He+xe+" <"+ae+"."+(+ke+1)+".0"):Ye=">="+ae+"."+ke+"."+He+" <"+ae+"."+(+ke+1)+".0",h("tilde return",Ye),Ye})}(Me,Te)}).join(" ")}(Qe,it),h("tildes",Qe),Qe=function(et,Te){return h("replaceXRanges",et,Te),et.split(/\s+/).map(function(Me){return function(ze,Re){ze=ze.trim();var Xe=Re?v[m]:v[p];return ze.replace(Xe,function(ce,ae,ke,He,xe,Ye){h("xRange",ze,ce,ae,ke,He,xe,Ye);var rt=Pe(ke),ot=rt||Pe(He),Et=ot||Pe(xe);return ae==="="&&Et&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&Et?(ot&&(He=0),Et&&(xe=0),ae===">"?(ae=">=",ot?(ke=+ke+1,He=0,xe=0):Et&&(He=+He+1,xe=0)):ae==="<="&&(ae="<",ot?ke=+ke+1:He=+He+1),ce=ae+ke+"."+He+"."+xe):ot?ce=">="+ke+".0.0 <"+(+ke+1)+".0.0":Et&&(ce=">="+ke+"."+He+".0 <"+ke+"."+(+He+1)+".0"),h("xRange return",ce),ce})}(Me,Te)}).join(" ")}(Qe,it),h("xrange",Qe),Qe=function(et,Te){return h("replaceStars",et,Te),et.trim().replace(v[Q],"")}(Qe,it),h("stars",Qe),Qe}(Ze,he)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(Ze){return!!Ze.match(Ue)})),We=We.map(function(Ze){return new ee(Ze,he)})},pe.prototype.intersects=function(Y,he){if(!(Y instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Ue){return Y.set.some(function(We){return We.every(function(Ze){return Ue.intersects(Ze,he)})})})})},e.toComparators=function(Y,he){return new pe(Y,he).set.map(function(Se){return Se.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new we(Y,this.loose));for(var he=0;he<this.set.length;he++)if(K(this.set[he],Y))return!0;return!1},e.satisfies=te,e.maxSatisfying=function(Y,he,Se){var Ue=null,We=null;try{var Ze=new pe(he,Se)}catch{return null}return Y.forEach(function(Qe){Ze.test(Qe)&&(Ue&&We.compare(Qe)!==-1||(We=new we(Ue=Qe,Se)))}),Ue},e.minSatisfying=function(Y,he,Se){var Ue=null,We=null;try{var Ze=new pe(he,Se)}catch{return null}return Y.forEach(function(Qe){Ze.test(Qe)&&(Ue&&We.compare(Qe)!==1||(We=new we(Ue=Qe,Se)))}),Ue},e.validRange=function(Y,he){try{return new pe(Y,he).range||"*"}catch{return null}},e.ltr=function(Y,he,Se){return se(Y,he,"<",Se)},e.gtr=function(Y,he,Se){return se(Y,he,">",Se)},e.outside=se,e.prerelease=function(Y,he){var Se=le(Y,he);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(Y,he,Se){return Y=new pe(Y,Se),he=new pe(he,Se),Y.intersects(he)},e.coerce=function(Y){if(Y instanceof we)return Y;if(typeof Y!="string")return null;var he=Y.match(v[f]);return he==null?null:le((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,F,h=ge.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(u){if(I===setTimeout)return setTimeout(u,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(u,0);try{return I(u,0)}catch{try{return I.call(null,u,0)}catch{return I.call(this,u,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var y,E=[],T=!1,k=-1;function b(){T&&y&&(T=!1,y.length?E=y.concat(E):k=-1,E.length&&S())}function S(){if(!T){var u=v(b);T=!0;for(var r=E.length;r;){for(y=E,E=[];++k<r;)y&&y[k].run();k=-1,r=E.length}y=null,T=!1,function(o){if(F===clearTimeout)return clearTimeout(o);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(o);try{F(o)}catch{try{return F.call(null,o)}catch{return F.call(this,o)}}}(u)}}function _(u,r){this.fun=u,this.array=r}function w(){}h.nextTick=function(u){var r=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)r[o-1]=arguments[o];E.push(new _(u,r)),E.length!==1||T||v(S)},_.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=w,h.addListener=w,h.once=w,h.off=w,h.removeListener=w,h.removeAllListeners=w,h.emit=w,h.prependListener=w,h.prependOnceListener=w,h.listeners=function(u){return[]},h.binding=function(u){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(u){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(De[37],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(R){return new F(R)}constructor(R){this._now=I&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=F}),define(De[4],Ie([1,0,8,74,3,75,37]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const v=!1,y=!1;var E;(function(p){p.None=()=>h.Disposable.None;function m(de){if(y){const{onDidAddListener:ee}=de,ue=_.create();let pe=0;de.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),ee?.()}}}function f(de,ee){return fe(de,()=>{},0,void 0,!0,void 0,ee)}p.defer=f;function P(de){return(ee,ue=null,pe)=>{let Pe=!1,$;return $=de(K=>{if(!Pe)return $?$.dispose():Pe=!0,ee.call(ue,K)},null,pe),Pe&&$.dispose(),$}}p.once=P;function M(de,ee,ue){return j((pe,Pe=null,$)=>de(K=>pe.call(Pe,ee(K)),null,$),ue)}p.map=M;function N(de,ee,ue){return j((pe,Pe=null,$)=>de(K=>{ee(K),pe.call(Pe,K)},null,$),ue)}p.forEach=N;function L(de,ee,ue){return j((pe,Pe=null,$)=>de(K=>ee(K)&&pe.call(Pe,K),null,$),ue)}p.filter=L;function U(de){return de}p.signal=U;function x(...de){return(ee,ue=null,pe)=>{const Pe=(0,h.combinedDisposable)(...de.map($=>$(K=>ee.call(ue,K))));return V(Pe,pe)}}p.any=x;function O(de,ee,ue,pe){let Pe=ue;return M(de,$=>(Pe=ee(Pe,$),Pe),pe)}p.reduce=O;function j(de,ee){let ue;const pe={onWillAddFirstListener(){ue=de(Pe.fire,Pe)},onDidRemoveLastListener(){ue?.dispose()}};ee||m(pe);const Pe=new c(pe);return ee?.add(Pe),Pe.event}function V(de,ee){return ee instanceof Array?ee.push(de):ee&&ee.add(de),de}function fe(de,ee,ue=100,pe=!1,Pe=!1,$,K){let te,se,Y,he=0,Se;const Ue={leakWarningThreshold:$,onWillAddFirstListener(){te=de(Ze=>{he++,se=ee(se,Ze),pe&&!Y&&(We.fire(se),se=void 0),Se=()=>{const Qe=se;se=void 0,Y=void 0,(!pe||he>1)&&We.fire(Qe),he=0},typeof ue=="number"?(clearTimeout(Y),Y=setTimeout(Se,ue)):Y===void 0&&(Y=0,queueMicrotask(Se))})},onWillRemoveListener(){Pe&&he>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,te.dispose()}};K||m(Ue);const We=new c(Ue);return K?.add(We),We.event}p.debounce=fe;function J(de,ee=0,ue){return p.debounce(de,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],ee,void 0,!0,void 0,ue)}p.accumulate=J;function X(de,ee=(pe,Pe)=>pe===Pe,ue){let pe=!0,Pe;return L(de,$=>{const K=pe||!ee($,Pe);return pe=!1,Pe=$,K},ue)}p.latch=X;function z(de,ee,ue){return[p.filter(de,ee,ue),p.filter(de,pe=>!ee(pe),ue)]}p.split=z;function Q(de,ee=!1,ue=[],pe){let Pe=ue.slice(),$=de(se=>{Pe?Pe.push(se):te.fire(se)});pe&&pe.add($);const K=()=>{Pe?.forEach(se=>te.fire(se)),Pe=null},te=new c({onWillAddFirstListener(){$||($=de(se=>te.fire(se)),pe&&pe.add($))},onDidAddFirstListener(){Pe&&(ee?setTimeout(K):K())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return pe&&pe.add(te),te.event}p.buffer=Q;function ve(de,ee){return(pe,Pe,$)=>{const K=ee(new we);return de(function(te){const se=K.evaluate(te);se!==le&&pe.call(Pe,se)},void 0,$)}}p.chain=ve;const le=Symbol("HaltChainable");class we{constructor(){this.steps=[]}map(ee){return this.steps.push(ee),this}forEach(ee){return this.steps.push(ue=>(ee(ue),ue)),this}filter(ee){return this.steps.push(ue=>ee(ue)?ue:le),this}reduce(ee,ue){let pe=ue;return this.steps.push(Pe=>(pe=ee(pe,Pe),pe)),this}latch(ee=(ue,pe)=>ue===pe){let ue=!0,pe;return this.steps.push(Pe=>{const $=ue||!ee(Pe,pe);return ue=!1,pe=Pe,$?Pe:le}),this}evaluate(ee){for(const ue of this.steps)if(ee=ue(ee),ee===le)break;return ee}}function G(de,ee,ue=pe=>pe){const pe=(...te)=>K.fire(ue(...te)),Pe=()=>de.on(ee,pe),$=()=>de.removeListener(ee,pe),K=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:$});return K.event}p.fromNodeEventEmitter=G;function B(de,ee,ue=pe=>pe){const pe=(...te)=>K.fire(ue(...te)),Pe=()=>de.addEventListener(ee,pe),$=()=>de.removeEventListener(ee,pe),K=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:$});return K.event}p.fromDOMEventEmitter=B;function H(de){return new Promise(ee=>P(de)(ee))}p.toPromise=H;function me(de){const ee=new c;return de.then(ue=>{ee.fire(ue)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}p.fromPromise=me;function Z(de,ee){return ee(void 0),de(ue=>ee(ue))}p.runAndSubscribe=Z;function ie(de,ee){let ue=null;function pe($){ue?.dispose(),ue=new h.DisposableStore,ee($,ue)}pe(void 0);const Pe=de($=>pe($));return(0,h.toDisposable)(()=>{Pe.dispose(),ue?.dispose()})}p.runAndSubscribeWithStore=ie;class re{constructor(ee,ue){this._observable=ee,this._counter=0,this._hasChanged=!1;const pe={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ue||m(pe),this.emitter=new c(pe),ue&&ue.add(this.emitter)}beginUpdate(ee){this._counter++}handlePossibleChange(ee){}handleChange(ee,ue){this._hasChanged=!0}endUpdate(ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(de,ee){return new re(de,ee).emitter.event}p.fromObservable=ye;function oe(de){return ee=>{let ue=0,pe=!1;const Pe={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(de.reportChanges(),pe&&(pe=!1,ee()))},handlePossibleChange(){},handleChange(){pe=!0}};return de.addObserver(Pe),de.reportChanges(),{dispose(){de.removeObserver(Pe)}}}}p.fromObservableLight=oe})(E||(e.Event=E={}));class T{static{this.all=new Set}static{this._idPool=0}constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${T._idPool++}`,T.all.add(this)}start(m){this._stopWatch=new A.StopWatch,this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=T;let k=-1;function b(p){const m=k;return k=p,{dispose(){k=m}}}e.setGlobalLeakWarningThreshold=b;class S{constructor(m,f=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=f,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(m,f){const P=this.threshold;if(P<=0||f<P)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let N,L=0;for(const[U,x]of this._stacks)(!N||L<x)&&(N=U,L=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${L}):`),console.warn(N)}return()=>{const N=this._stacks.get(m.value)||0;this._stacks.set(m.value,N-1)}}}class _{static create(){return new _(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(m){this.value=m,this.id=w++}}const r=2,o=(p,m)=>{if(p instanceof u)m(p);else for(let f=0;f<p.length;f++){const P=p[f];P&&m(P)}};class c{constructor(m){this._size=0,this._options=m,this._leakageMon=k>0||this._options?.leakWarningThreshold?new S(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const m=this._listeners;queueMicrotask(()=>{o(m,f=>f.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(m,f,P)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.Disposable.None;if(this._disposed)return h.Disposable.None;f&&(m=m.bind(f));const M=new u(m);let N,L;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(M.stack=_.create(),N=this._leakageMon.check(M.stack,this._size+1)),v&&(M.stack=L??_.create()),this._listeners?this._listeners instanceof u?(this._deliveryQueue??=new d,this._listeners=[this._listeners,M]):this._listeners.push(M):(this._options?.onWillAddFirstListener?.(this),this._listeners=M,this._options?.onDidAddFirstListener?.(this)),this._size++;const U=(0,h.toDisposable)(()=>{N?.(),this._removeListener(M)});return P instanceof h.DisposableStore?P.add(U):Array.isArray(P)&&P.push(U),U},this._event}_removeListener(m){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const f=this._listeners,P=f.indexOf(m);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,f[P]=void 0;const M=this._deliveryQueue.current===this;if(this._size*r<=f.length){let N=0;for(let L=0;L<f.length;L++)f[L]?f[N++]=f[L]:M&&(this._deliveryQueue.end--,N<this._deliveryQueue.i&&this._deliveryQueue.i--);f.length=N}}_deliver(m,f){if(!m)return;const P=this._options?.onListenerError||I.onUnexpectedError;if(!P){m.value(f);return}try{m.value(f)}catch(M){P(M)}}_deliverQueue(m){const f=m.current._listeners;for(;m.i<m.end;)this._deliver(f[m.i++],m.value);m.reset()}fire(m){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,m);else{const f=this._deliveryQueue;f.enqueue(this,m,this._listeners.length),this._deliverQueue(f)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const g=()=>new d;e.createEventDeliveryQueue=g;class d{constructor(){this.i=-1,this.end=0}enqueue(m,f,P){this.i=0,this.end=P,this.current=m,this.value=f}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(m,f,P){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList),o(this._listeners,M=>this._asyncDeliveryQueue.push([M.value,m]));this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[M,N]=this._asyncDeliveryQueue.shift(),L=[],U={...N,token:f,waitUntil:x=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");P&&(x=P(x,M)),L.push(x)}};try{M(U)}catch(x){(0,I.onUnexpectedError)(x);continue}Object.freeze(L),await Promise.allSettled(L).then(x=>{for(const O of x)O.status==="rejected"&&(0,I.onUnexpectedError)(O.reason)})}}}e.AsyncEmitter=t;class n extends c{get isPaused(){return this._isPaused!==0}constructor(m){super(m),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._size&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=n;class s extends n{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=s;class i extends c{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this.hasListeners()&&(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const f={event:m,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const P=()=>{this.hasListeners&&this.unhook(f);const M=this.events.indexOf(f);this.events.splice(M,1)};return(0,h.toDisposable)((0,F.createSingleCallFunction)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(f=>this.emitter.fire(f))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class l{constructor(m,f,P,M){this._store=new h.DisposableStore;const N=this._store.add(new a),L=this._store.add(new h.DisposableMap);function U(x){L.set(x,N.add(M(x)))}for(const x of m)U(x);this._store.add(f(x=>{U(x)})),this._store.add(P(x=>{L.deleteAndDispose(x)})),this.event=N.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=l;class C{constructor(){this.buffers=[]}wrapEvent(m){return(f,P,M)=>m(N=>{const L=this.buffers[this.buffers.length-1];L?L.push(()=>f.call(P,N)):f.call(P,N)},void 0,M)}bufferEvents(m){const f=[];this.buffers.push(f);const P=m();return this.buffers.pop(),f.forEach(M=>M()),P}}e.EventBufferer=C;class D{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=h.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(De[21],Ie([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(v,y){const E=setTimeout(v.bind(y),0);return{dispose(){clearTimeout(E)}}});var h;(function(v){function y(E){return E===v.None||E===v.Cancelled||E instanceof R?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}v.isCancellationToken=y,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(h||(e.CancellationToken=h={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=h.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=h.None}}e.CancellationTokenSource=A}),define(De[159],Ie([1,0,21]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class F{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new I.CancellationTokenSource,y=this.task(v.token);return this.result={promise:y,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=F;class h{constructor(v){this.fn=v,this.lastCache=void 0,this.lastArgKey=void 0}get(v){const y=JSON.stringify(v);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(v)),this.lastCache}}e.LRUCachedFunction=h;class R{get cachedValues(){return this._map}constructor(v){this.fn=v,this._map=new Map}get(v){if(this._map.has(v))return this._map.get(v);const y=this.fn(v);return this._map.set(v,y),y}}e.CachedFunction=R}),define(De[96],Ie([1,0,8,3]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function h(g){const d=g;return d?typeof d.read=="function":!1}e.isReadable=h;function R(g){const d=g;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function A(g){const d=g;return d?R(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=A;function v(g,d){return new y(g,d)}e.newWriteableStream=v;class y{constructor(d,t){this.reducer=d,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(t=>t(d))}emitError(d){this.listeners.error.length===0?(0,I.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(t=>t(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,t){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(d,t){if(this.state.destroyed)return;let n;switch(d){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const s=n.indexOf(t);s>=0&&n.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(g,d){const t=[];let n;for(;(n=g.read())!==null;)t.push(n);return d(t)}e.consumeReadable=E;function T(g,d,t){const n=[];let s;for(;(s=g.read())!==null&&n.length<t;)n.push(s);return s===null&&n.length>0?d(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return g.read()}}}e.peekReadable=T;function k(g,d){return new Promise((t,n)=>{const s=[];b(g,{onData:i=>{d&&s.push(i)},onError:i=>{d?n(i):t(void 0)},onEnd:()=>{t(d?d(s):void 0)}})})}e.consumeStream=k;function b(g,d,t){g.on("error",n=>{t?.isCancellationRequested||d.onError(n)}),g.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),g.on("data",n=>{t?.isCancellationRequested||d.onData(n)})}e.listenStream=b;function S(g,d){return new Promise((t,n)=>{const s=new F.DisposableStore,i=[],a=D=>{if(i.push(D),i.length>d)return s.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},l=D=>(s.dispose(),n(D)),C=()=>(s.dispose(),t({stream:g,buffer:i,ended:!0}));s.add((0,F.toDisposable)(()=>g.removeListener("error",l))),g.on("error",l),s.add((0,F.toDisposable)(()=>g.removeListener("end",C))),g.on("end",C),s.add((0,F.toDisposable)(()=>g.removeListener("data",a))),g.on("data",a)})}e.peekStream=S;function _(g,d){const t=v(d);return t.end(g),t}e.toStream=_;function w(){const g=v(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=w;function u(g){let d=!1;return{read:()=>d?null:(d=!0,g)}}e.toReadable=u;function r(g,d,t){const n=v(t);return b(g,{onData:s=>n.write(d.data(s)),onError:s=>n.error(d.error?d.error(s):s),onEnd:()=>n.end()}),n}e.transform=r;function o(g,d,t){let n=!1;return{read:()=>{const s=d.read();return n?s:(n=!0,s!==null?t([g,s]):g)}}}e.prefixedReadable=o;function c(g,d,t){let n=!1;const s=v(t);return b(d,{onData:i=>n?s.write(i):(n=!0,s.write(t([g,i]))),onError:i=>s.error(i),onEnd:()=>{n||(n=!0,s.write(g)),s.end()}}),s}e.prefixedStream=c}),define(De[22],Ie([1,0,51,96]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const h=typeof Buffer<"u",R=new I.Lazy(()=>new Uint8Array(256));let A,v;class y{static alloc(f){return h?new y(Buffer.allocUnsafe(f)):new y(new Uint8Array(f))}static wrap(f){return h&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new y(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&h?new y(Buffer.from(f)):(A||(A=new TextEncoder),new y(A.encode(f)))}static fromByteArray(f){const P=y.alloc(f.length);for(let M=0,N=f.length;M<N;M++)P.buffer[M]=f[M];return P}static concat(f,P){if(typeof P>"u"){P=0;for(let L=0,U=f.length;L<U;L++)P+=f[L].byteLength}const M=y.alloc(P);let N=0;for(let L=0,U=f.length;L<U;L++){const x=f[L];M.set(x,N),N+=x.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=y.alloc(this.byteLength);return f.set(this),f}toString(){return h?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(f,P){return new y(this.buffer.subarray(f,P))}set(f,P){if(f instanceof y)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return b(this.buffer,f)}writeUInt32BE(f,P){S(this.buffer,f,P)}readUInt32LE(f){return _(this.buffer,f)}writeUInt32LE(f,P){w(this.buffer,f,P)}readUInt8(f){return u(this.buffer,f)}writeUInt8(f,P){r(this.buffer,f,P)}indexOf(f,P=0){return E(this.buffer,f instanceof y?f.buffer:f,P)}}e.VSBuffer=y;function E(m,f,P=0){const M=f.byteLength,N=m.byteLength;if(M===0)return 0;if(M===1)return m.indexOf(f[0]);if(M>N-P)return-1;const L=R.value;L.fill(f.length);for(let j=0;j<f.length;j++)L[f[j]]=f.length-j-1;let U=P+f.length-1,x=U,O=-1;for(;U<N;)if(m[U]===f[x]){if(x===0){O=U;break}U--,x--}else U+=Math.max(f.length-x,L[m[U]]),x=f.length-1;return O}e.binaryIndexOf=E;function T(m,f){return m[f+0]<<0>>>0|m[f+1]<<8>>>0}e.readUInt16LE=T;function k(m,f,P){m[P+0]=f&255,f=f>>>8,m[P+1]=f&255}e.writeUInt16LE=k;function b(m,f){return m[f]*2**24+m[f+1]*2**16+m[f+2]*2**8+m[f+3]}e.readUInt32BE=b;function S(m,f,P){m[P+3]=f,f=f>>>8,m[P+2]=f,f=f>>>8,m[P+1]=f,f=f>>>8,m[P]=f}e.writeUInt32BE=S;function _(m,f){return m[f+0]<<0>>>0|m[f+1]<<8>>>0|m[f+2]<<16>>>0|m[f+3]<<24>>>0}e.readUInt32LE=_;function w(m,f,P){m[P+0]=f&255,f=f>>>8,m[P+1]=f&255,f=f>>>8,m[P+2]=f&255,f=f>>>8,m[P+3]=f&255}e.writeUInt32LE=w;function u(m,f){return m[f]}e.readUInt8=u;function r(m,f,P){m[P]=f}e.writeUInt8=r;function o(m){return F.consumeReadable(m,f=>y.concat(f))}e.readableToBuffer=o;function c(m){return F.toReadable(m)}e.bufferToReadable=c;function g(m){return F.consumeStream(m,f=>y.concat(f))}e.streamToBuffer=g;async function d(m){return m.ended?y.concat(m.buffer):y.concat([...m.buffer,await g(m.stream)])}e.bufferedStreamToBuffer=d;function t(m){return F.toStream(m,f=>y.concat(f))}e.bufferToStream=t;function n(m){return F.transform(m,{data:f=>typeof f=="string"?y.fromString(f):y.wrap(f)},f=>y.concat(f))}e.streamToBufferReadableStream=n;function s(m){return F.newWriteableStream(f=>y.concat(f),m)}e.newWriteableBufferStream=s;function i(m,f){return F.prefixedReadable(m,f,P=>y.concat(P))}e.prefixedBufferReadable=i;function a(m,f){return F.prefixedStream(m,f,P=>y.concat(P))}e.prefixedBufferStream=a;function l(m){let f=0,P=0,M=0;const N=new Uint8Array(Math.floor(m.length/4*3)),L=x=>{switch(P){case 3:N[M++]=f|x,P=0;break;case 2:N[M++]=f|x>>>2,f=x<<6,P=3;break;case 1:N[M++]=f|x>>>4,f=x<<4,P=2;break;default:f=x<<2,P=1}};for(let x=0;x<m.length;x++){const O=m.charCodeAt(x);if(O>=65&&O<=90)L(O-65);else if(O>=97&&O<=122)L(O-97+26);else if(O>=48&&O<=57)L(O-48+52);else if(O===43||O===45)L(62);else if(O===47||O===95)L(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${m[x]}`)}}const U=M;for(;P>0;)L(0);return y.wrap(N).slice(0,U)}e.decodeBase64=l;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:m},f=!0,P=!1){const M=P?D:C;let N="";const L=m.byteLength%3;let U=0;for(;U<m.byteLength-L;U+=3){const x=m[U+0],O=m[U+1],j=m[U+2];N+=M[x>>>2],N+=M[(x<<4|O>>>4)&63],N+=M[(O<<2|j>>>6)&63],N+=M[j&63]}if(L===1){const x=m[U+0];N+=M[x>>>2],N+=M[x<<4&63],f&&(N+="==")}else if(L===2){const x=m[U+0],O=m[U+1];N+=M[x>>>2],N+=M[(x<<4|O>>>4)&63],N+=M[O<<2&63],f&&(N+="=")}return N}e.encodeBase64=p}),define(De[15],Ie([1,0,159,51]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function h(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}e.isFalsyOrWhitespace=h;const R=/{(\d+)}/g;function A(Te,...Me){return Me.length===0?Te:Te.replace(R,function(ze,Re){const Xe=parseInt(Re,10);return isNaN(Xe)||Xe<0||Xe>=Me.length?ze:Me[Xe]})}e.format=A;const v=/{([^}]+)}/g;function y(Te,Me){return Te.replace(v,(ze,Re)=>Me[Re]??ze)}e.format2=y;function E(Te){return Te.replace(/[<>&]/g,function(Me){switch(Me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Me}})}e.escape=E;function T(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function k(Te,Me){let ze=0;const Re=Me.charCodeAt(0);for(let Xe=Te.length-1;Xe>=0;Xe--)Te.charCodeAt(Xe)===Re&&ze++;return ze}e.count=k;function b(Te,Me,ze="\u2026"){return Te.length<=Me?Te:`${Te.substr(0,Me)}${ze}`}e.truncate=b;function S(Te,Me=" "){const ze=_(Te,Me);return w(ze,Me)}e.trim=S;function _(Te,Me){if(!Te||!Me)return Te;const ze=Me.length;if(ze===0||Te.length===0)return Te;let Re=0;for(;Te.indexOf(Me,Re)===Re;)Re=Re+ze;return Te.substring(Re)}e.ltrim=_;function w(Te,Me){if(!Te||!Me)return Te;const ze=Me.length,Re=Te.length;if(ze===0||Re===0)return Te;let Xe=Re,ce=-1;for(;ce=Te.lastIndexOf(Me,Xe-1),!(ce===-1||ce+ze!==Xe);){if(ce===0)return"";Xe=ce}return Te.substring(0,Xe)}e.rtrim=w;function u(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function r(Te){return Te.replace(/\*/g,"")}e.stripWildcards=r;function o(Te,Me,ze={}){if(!Te)throw new Error("Cannot create regex from empty string");Me||(Te=T(Te)),ze.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Re="";return ze.global&&(Re+="g"),ze.matchCase||(Re+="i"),ze.multiline&&(Re+="m"),ze.unicode&&(Re+="u"),new RegExp(Te,Re)}e.createRegExp=o;function c(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function g(Te){return Te.split(/\r\n|\r|\n/)}e.splitLines=g;function d(Te){for(let Me=0,ze=Te.length;Me<ze;Me++){const Re=Te.charCodeAt(Me);if(Re!==32&&Re!==9)return Me}return-1}e.firstNonWhitespaceIndex=d;function t(Te,Me=0,ze=Te.length){for(let Re=Me;Re<ze;Re++){const Xe=Te.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Te.substring(Me,Re)}return Te.substring(Me,ze)}e.getLeadingWhitespace=t;function n(Te,Me=Te.length-1){for(let ze=Me;ze>=0;ze--){const Re=Te.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.lastNonWhitespaceIndex=n;function s(Te,Me,ze){const Re=[];let Xe=0;for(const ce of Te.matchAll(Me)){if(Re.push(Te.slice(Xe,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Xe=ce.index+ce[0].length,Re.push(ze(ce[0],...ce.slice(1),ce.index,Te,ce.groups))}return Re.push(Te.slice(Xe)),Promise.all(Re).then(ce=>ce.join(""))}e.replaceAsync=s;function i(Te,Me){return Te<Me?-1:Te>Me?1:0}e.compare=i;function a(Te,Me,ze=0,Re=Te.length,Xe=0,ce=Me.length){for(;ze<Re&&Xe<ce;ze++,Xe++){const He=Te.charCodeAt(ze),xe=Me.charCodeAt(Xe);if(He<xe)return-1;if(He>xe)return 1}const ae=Re-ze,ke=ce-Xe;return ae<ke?-1:ae>ke?1:0}e.compareSubstring=a;function l(Te,Me){return C(Te,Me,0,Te.length,0,Me.length)}e.compareIgnoreCase=l;function C(Te,Me,ze=0,Re=Te.length,Xe=0,ce=Me.length){for(;ze<Re&&Xe<ce;ze++,Xe++){let He=Te.charCodeAt(ze),xe=Me.charCodeAt(Xe);if(He===xe)continue;if(He>=128||xe>=128)return a(Te.toLowerCase(),Me.toLowerCase(),ze,Re,Xe,ce);p(He)&&(He-=32),p(xe)&&(xe-=32);const Ye=He-xe;if(Ye!==0)return Ye}const ae=Re-ze,ke=ce-Xe;return ae<ke?-1:ae>ke?1:0}e.compareSubstringIgnoreCase=C;function D(Te){return Te>=48&&Te<=57}e.isAsciiDigit=D;function p(Te){return Te>=97&&Te<=122}e.isLowerAsciiLetter=p;function m(Te){return Te>=65&&Te<=90}e.isUpperAsciiLetter=m;function f(Te,Me){return Te.length===Me.length&&C(Te,Me)===0}e.equalsIgnoreCase=f;function P(Te,Me){const ze=Me.length;return Me.length>Te.length?!1:C(Te,Me,0,ze)===0}e.startsWithIgnoreCase=P;function M(Te,Me){const ze=Math.min(Te.length,Me.length);let Re;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Re)!==Me.charCodeAt(Re))return Re;return ze}e.commonPrefixLength=M;function N(Te,Me){const ze=Math.min(Te.length,Me.length);let Re;const Xe=Te.length-1,ce=Me.length-1;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Xe-Re)!==Me.charCodeAt(ce-Re))return Re;return ze}e.commonSuffixLength=N;function L(Te){return 55296<=Te&&Te<=56319}e.isHighSurrogate=L;function U(Te){return 56320<=Te&&Te<=57343}e.isLowSurrogate=U;function x(Te,Me){return(Te-55296<<10)+(Me-56320)+65536}e.computeCodePoint=x;function O(Te,Me,ze){const Re=Te.charCodeAt(ze);if(L(Re)&&ze+1<Me){const Xe=Te.charCodeAt(ze+1);if(U(Xe))return x(Re,Xe)}return Re}e.getNextCodePoint=O;function j(Te,Me){const ze=Te.charCodeAt(Me-1);if(U(ze)&&Me>1){const Re=Te.charCodeAt(Me-2);if(L(Re))return x(Re,ze)}return ze}class V{get offset(){return this._offset}constructor(Me,ze=0){this._str=Me,this._len=Me.length,this._offset=ze}setOffset(Me){this._offset=Me}prevCodePoint(){const Me=j(this._str,this._offset);return this._offset-=Me>=65536?2:1,Me}nextCodePoint(){const Me=O(this._str,this._len,this._offset);return this._offset+=Me>=65536?2:1,Me}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class fe{get offset(){return this._iterator.offset}constructor(Me,ze=0){this._iterator=new V(Me,ze)}nextGraphemeLength(){const Me=he.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Me.getGraphemeBreakType(ze.nextCodePoint());for(;!ze.eol();){const ce=ze.offset,ae=Me.getGraphemeBreakType(ze.nextCodePoint());if(se(Xe,ae)){ze.setOffset(ce);break}Xe=ae}return ze.offset-Re}prevGraphemeLength(){const Me=he.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Me.getGraphemeBreakType(ze.prevCodePoint());for(;ze.offset>0;){const ce=ze.offset,ae=Me.getGraphemeBreakType(ze.prevCodePoint());if(se(ae,Xe)){ze.setOffset(ce);break}Xe=ae}return Re-ze.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=fe;function J(Te,Me){return new fe(Te,Me).nextGraphemeLength()}e.nextCharLength=J;function X(Te,Me){return new fe(Te,Me).prevGraphemeLength()}e.prevCharLength=X;function z(Te,Me){Me>0&&U(Te.charCodeAt(Me))&&Me--;const ze=Me+J(Te,Me);return[ze-X(Te,ze),ze]}e.getCharContainingOffset=z;function Q(Te){const Me=new fe(Te);let ze=0;for(;!Me.eol();)ze++,Me.nextGraphemeLength();return ze}e.charCount=Q;let ve;function le(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Te){return ve||(ve=le()),ve.test(Te)}e.containsRTL=we;const G=/^[\t\n\r\x20-\x7E]*$/;function B(Te){return G.test(Te)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}e.containsUnusualLineTerminators=H;function me(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}e.isFullWidthCharacter=me;function Z(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}e.isEmojiImprecise=Z;function ie(Te,Me){if(Te.length<Me)return Te;const ze=/\b/g;let Re=0;for(;ze.test(Te)&&!(Te.length-ze.lastIndex<Me);)Re=ze.lastIndex,ze.lastIndex+=1;return Te.substring(Re).replace(/^\s/,"")}e.lcut=ie;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ye=/\x1b\].*?\x07/g;function oe(Te){return Te&&(Te=Te.replace(re,"").replace(ye,"")),Te}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function ee(Te){return de(Te)?Te.substr(1):Te}e.stripUTF8BOM=ee;function ue(Te,Me){if(!Te||!Me||Te.length<Me.length)return!1;const ze=Me.length,Re=Te.toLowerCase();let Xe=0,ce=-1;for(;Xe<ze;){const ae=Re.indexOf(Me[Xe],ce+1);if(ae<0)return!1;ce=ae,Xe++}return!0}e.fuzzyContains=ue;function pe(Te,Me=!1){return Te?(Me&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}e.containsUppercaseCharacter=pe;function Pe(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}e.uppercaseFirstLetter=Pe;function $(Te,Me=1){if(Me===0)return"";let ze=-1;do ze=Te.indexOf(`
`,ze+1),Me--;while(Me>0&&ze>=0);return ze===-1?Te:(Te[ze-1]==="\r"&&ze--,Te.substr(0,ze))}e.getNLines=$;function K(Te){return Te=Te%(2*26),Te<26?String.fromCharCode(97+Te):String.fromCharCode(65+Te-26)}e.singleLetterHash=K;function te(Te){return he.getInstance().getGraphemeBreakType(Te)}e.getGraphemeBreakType=te;function se(Te,Me){return Te===0?Me!==5&&Me!==7:Te===2&&Me===3?!1:Te===4||Te===2||Te===3||Me===4||Me===2||Me===3?!0:!(Te===8&&(Me===8||Me===9||Me===11||Me===12)||(Te===11||Te===9)&&(Me===9||Me===10)||(Te===12||Te===10)&&Me===10||Me===5||Me===13||Me===7||Te===1||Te===13&&Me===14||Te===6&&Me===6)}var Y;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class he{static{this._INSTANCE=null}static getInstance(){return he._INSTANCE||(he._INSTANCE=new he),he._INSTANCE}constructor(){this._data=Se()}getGraphemeBreakType(Me){if(Me<32)return Me===10?3:Me===13?2:4;if(Me<127)return 0;const ze=this._data,Re=ze.length/3;let Xe=1;for(;Xe<=Re;)if(Me<ze[3*Xe])Xe=2*Xe;else if(Me>ze[3*Xe+1])Xe=2*Xe+1;else return ze[3*Xe+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(Te,Me){if(Te===0)return 0;const ze=We(Te,Me);if(ze!==void 0)return ze;const Re=new V(Me,Te);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ue;function We(Te,Me){const ze=new V(Me,Te);let Re=ze.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(ze.offset===0)return;Re=ze.prevCodePoint()}if(!Z(Re))return;let Xe=ze.offset;return Xe>0&&ze.prevCodePoint()===8205&&(Xe=ze.offset),Xe}function Ze(Te){return 127995<=Te&&Te<=127999}var Qe;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(Me=>{function ze(Ye){const rt=new Map;for(let ot=0;ot<Ye.length;ot+=2)rt.set(Ye[ot],Ye[ot+1]);return rt}function Re(Ye,rt){const ot=new Map(Ye);for(const[Et,yt]of rt)ot.set(Et,yt);return ot}function Xe(Ye,rt){if(!Ye)return rt;const ot=new Map;for(const[Et,yt]of Ye)rt.has(Et)&&ot.set(Et,yt);return ot}const ce=this.ambiguousCharacterData.value;let ae=Me.filter(Ye=>!Ye.startsWith("_")&&Ye in ce);ae.length===0&&(ae=["_default"]);let ke;for(const Ye of ae){const rt=ze(ce[Ye]);ke=Xe(ke,rt)}const He=ze(ce._common),xe=Re(He,ke);return new it(xe)})}static getInstance(Me){return it.cache.get(Array.from(Me))}static{this._locales=new F.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(Me=>!Me.startsWith("_")))}static getLocales(){return it._locales.value}constructor(Me){this.confusableDictionary=Me}isAmbiguous(Me){return this.confusableDictionary.has(Me)}getPrimaryConfusable(Me){return this.confusableDictionary.get(Me)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(Me){return et.getData().has(Me)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et}),define(De[121],Ie([1,0,28,15]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function h(...ee){return function(ue,pe){for(let Pe=0,$=ee.length;Pe<$;Pe++){const K=ee[Pe](ue,pe);if(K)return K}return null}}e.or=h,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ee,ue,pe){if(!pe||pe.length<ue.length)return null;let Pe;return ee?Pe=F.startsWithIgnoreCase(pe,ue):Pe=pe.indexOf(ue)===0,Pe?ue.length>0?[{start:0,end:ue.length}]:[]:null}function A(ee,ue){const pe=ue.toLowerCase().indexOf(ee.toLowerCase());return pe===-1?null:[{start:pe,end:pe+ee.length}]}e.matchesContiguousSubString=A;function v(ee,ue){return y(ee.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=v;function y(ee,ue,pe,Pe){if(pe===ee.length)return[];if(Pe===ue.length)return null;if(ee[pe]===ue[Pe]){let $=null;return($=y(ee,ue,pe+1,Pe+1))?r({start:Pe,end:Pe+1},$):null}return y(ee,ue,pe,Pe+1)}function E(ee){return 97<=ee&&ee<=122}function T(ee){return 65<=ee&&ee<=90}e.isUpper=T;function k(ee){return 48<=ee&&ee<=57}function b(ee){return ee===32||ee===9||ee===10||ee===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>S.add(ee.charCodeAt(0)));function _(ee){return b(ee)||S.has(ee)}function w(ee,ue){return ee===ue||_(ee)&&_(ue)}function u(ee){return E(ee)||T(ee)||k(ee)}function r(ee,ue){return ue.length===0?ue=[ee]:ee.end===ue[0].start?ue[0].start=ee.start:ue.unshift(ee),ue}function o(ee,ue){for(let pe=ue;pe<ee.length;pe++){const Pe=ee.charCodeAt(pe);if(T(Pe)||k(Pe)||pe>0&&!u(ee.charCodeAt(pe-1)))return pe}return ee.length}function c(ee,ue,pe,Pe){if(pe===ee.length)return[];if(Pe===ue.length)return null;if(ee[pe]!==ue[Pe].toLowerCase())return null;{let $=null,K=Pe+1;for($=c(ee,ue,pe+1,Pe+1);!$&&(K=o(ue,K))<ue.length;)$=c(ee,ue,pe+1,K),K++;return $===null?null:r({start:Pe,end:Pe+1},$)}}function g(ee){let ue=0,pe=0,Pe=0,$=0,K=0;for(let Se=0;Se<ee.length;Se++)K=ee.charCodeAt(Se),T(K)&&ue++,E(K)&&pe++,u(K)&&Pe++,k(K)&&$++;const te=ue/ee.length,se=pe/ee.length,Y=Pe/ee.length,he=$/ee.length;return{upperPercent:te,lowerPercent:se,alphaPercent:Y,numericPercent:he}}function d(ee){const{upperPercent:ue,lowerPercent:pe}=ee;return pe===0&&ue>.6}function t(ee){const{upperPercent:ue,lowerPercent:pe,alphaPercent:Pe,numericPercent:$}=ee;return pe>.2&&ue<.8&&Pe>.6&&$<.2}function n(ee){let ue=0,pe=0,Pe=0,$=0;for(let K=0;K<ee.length;K++)Pe=ee.charCodeAt(K),T(Pe)&&ue++,E(Pe)&&pe++,b(Pe)&&$++;return(ue===0||pe===0)&&$===0?ee.length<=30:ue<=5}function s(ee,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!n(ee)||ue.length>60)return null;const pe=g(ue);if(!t(pe)){if(!d(pe))return null;ue=ue.toLowerCase()}let Pe=null,$=0;for(ee=ee.toLowerCase();$<ue.length&&(Pe=c(ee,ue,0,$))===null;)$=o(ue,$+1);return Pe}e.matchesCamelCase=s;function i(ee,ue,pe=!1){if(!ue||ue.length===0)return null;let Pe=null,$=0;for(ee=ee.toLowerCase(),ue=ue.toLowerCase();$<ue.length&&(Pe=a(ee,ue,0,$,pe))===null;)$=l(ue,$+1);return Pe}e.matchesWords=i;function a(ee,ue,pe,Pe,$){if(pe===ee.length)return[];if(Pe===ue.length)return null;if(w(ee.charCodeAt(pe),ue.charCodeAt(Pe))){let K=null,te=Pe+1;if(K=a(ee,ue,pe+1,Pe+1,$),!$)for(;!K&&(te=l(ue,te))<ue.length;)K=a(ee,ue,pe+1,te,$),te++;return K?ee.charCodeAt(pe)!==ue.charCodeAt(Pe)?K:r({start:Pe,end:Pe+1},K):null}else return null}function l(ee,ue){for(let pe=ue;pe<ee.length;pe++)if(_(ee.charCodeAt(pe))||pe>0&&_(ee.charCodeAt(pe-1)))return pe;return ee.length}const C=h(e.matchesPrefix,s,A),D=h(e.matchesPrefix,s,v),p=new I.LRUCache(1e4);function m(ee,ue,pe=!1){if(typeof ee!="string"||typeof ue!="string")return null;let Pe=p.get(ee);Pe||(Pe=new RegExp(F.convertSimple2RegExpPattern(ee),"i"),p.set(ee,Pe));const $=Pe.exec(ue);return $?[{start:$.index,end:$.index+$[0].length}]:pe?D(ee,ue):C(ee,ue)}e.matchesFuzzy=m;function f(ee,ue){const pe=me(ee,ee.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?M(pe):null}e.matchesFuzzy2=f;function P(ee,ue,pe,Pe,$,K){const te=Math.min(13,ee.length);for(;pe<te;pe++){const se=me(ee,ue,pe,Pe,$,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,K]}e.anyScore=P;function M(ee){if(typeof ee>"u")return[];const ue=[],pe=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const $=ee[Pe]+pe,K=ue[ue.length-1];K&&K.end===$?K.end=$+1:ue.push({start:$,end:$+1})}return ue}e.createMatches=M;const N=128;function L(){const ee=[],ue=[];for(let pe=0;pe<=N;pe++)ue[pe]=0;for(let pe=0;pe<=N;pe++)ee.push(ue.slice(0));return ee}function U(ee){const ue=[];for(let pe=0;pe<=ee;pe++)ue[pe]=0;return ue}const x=U(2*N),O=U(2*N),j=L(),V=L(),fe=L(),J=!1;function X(ee,ue,pe,Pe,$){function K(se,Y,he=" "){for(;se.length<Y;)se=he+se;return se}let te=` |   |${Pe.split("").map(se=>K(se,3)).join("|")}
`;for(let se=0;se<=pe;se++)se===0?te+=" |":te+=`${ue[se-1]}|`,te+=ee[se].slice(0,$+1).map(Y=>K(Y.toString(),3)).join("|")+`
`;return te}function z(ee,ue,pe,Pe){ee=ee.substr(ue),pe=pe.substr(Pe),console.log(X(V,ee,ee.length,pe,pe.length)),console.log(X(fe,ee,ee.length,pe,pe.length)),console.log(X(j,ee,ee.length,pe,pe.length))}function Q(ee,ue){if(ue<0||ue>=ee.length)return!1;const pe=ee.codePointAt(ue);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(pe)}}function ve(ee,ue){if(ue<0||ue>=ee.length)return!1;switch(ee.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function le(ee,ue,pe){return ue[ee]!==pe[ee]}function we(ee,ue,pe,Pe,$,K,te=!1){for(;ue<pe&&$<K;)ee[ue]===Pe[$]&&(te&&(x[ue]=$),ue+=1),$+=1;return ue===pe}e.isPatternInWord=we;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var B;(function(ee){ee.Default=[-100,0];function ue(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}ee.isDefault=ue})(B||(e.FuzzyScore=B={}));class H{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,pe){this.firstMatchCanBeWeak=ue,this.boostFullMatch=pe}}e.FuzzyScoreOptions=H;function me(ee,ue,pe,Pe,$,K,te=H.default){const se=ee.length>N?N:ee.length,Y=Pe.length>N?N:Pe.length;if(pe>=se||K>=Y||se-pe>Y-K||!we(ue,pe,se,$,K,Y,!0))return;Z(se,Y,pe,K,ue,$);let he=1,Se=1,Ue=pe,We=K;const Ze=[!1];for(he=1,Ue=pe;Ue<se;he++,Ue++){const Me=x[Ue],ze=O[Ue],Re=Ue+1<se?O[Ue+1]:Y;for(Se=Me-K+1,We=Me;We<Re;Se++,We++){let Xe=Number.MIN_SAFE_INTEGER,ce=!1;We<=ze&&(Xe=ie(ee,ue,Ue,pe,Pe,$,We,Y,K,j[he-1][Se-1]===0,Ze));let ae=0;Xe!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Xe+V[he-1][Se-1]);const ke=We>Me,He=ke?V[he][Se-1]+(j[he][Se-1]>0?-5:0):0,xe=We>Me+1&&j[he][Se-1]>0,Ye=xe?V[he][Se-2]+(j[he][Se-2]>0?-5:0):0;if(xe&&(!ke||Ye>=He)&&(!ce||Ye>=ae))V[he][Se]=Ye,fe[he][Se]=3,j[he][Se]=0;else if(ke&&(!ce||He>=ae))V[he][Se]=He,fe[he][Se]=2,j[he][Se]=0;else if(ce)V[he][Se]=ae,fe[he][Se]=1,j[he][Se]=j[he-1][Se-1]+1;else throw new Error("not possible")}}if(J&&z(ee,pe,Pe,K),!Ze[0]&&!te.firstMatchCanBeWeak)return;he--,Se--;const Qe=[V[he][Se],K];let it=0,et=0;for(;he>=1;){let Me=Se;do{const ze=fe[he][Me];if(ze===3)Me=Me-2;else if(ze===2)Me=Me-1;else break}while(Me>=1);it>1&&ue[pe+he-1]===$[K+Se-1]&&!le(Me+K-1,Pe,$)&&it+1>j[he][Me]&&(Me=Se),Me===Se?it++:it=1,et||(et=Me),he--,Se=Me-1,Qe.push(Se)}Y===se&&te.boostFullMatch&&(Qe[0]+=2);const Te=et-se;return Qe[0]-=Te,Qe}e.fuzzyScore=me;function Z(ee,ue,pe,Pe,$,K){let te=ee-1,se=ue-1;for(;te>=pe&&se>=Pe;)$[te]===K[se]&&(O[te]=se,te--),se--}function ie(ee,ue,pe,Pe,$,K,te,se,Y,he,Se){if(ue[pe]!==K[te])return Number.MIN_SAFE_INTEGER;let Ue=1,We=!1;return te===pe-Pe?Ue=ee[pe]===$[te]?7:5:le(te,$,K)&&(te===0||!le(te-1,$,K))?(Ue=ee[pe]===$[te]?7:5,We=!0):Q(K,te)&&(te===0||!Q(K,te-1))?Ue=5:(Q(K,te-1)||ve(K,te-1))&&(Ue=5,We=!0),Ue>1&&pe===Pe&&(Se[0]=!0),We||(We=le(te,$,K)||Q(K,te-1)||ve(K,te-1)),pe===Pe?te>Y&&(Ue-=We?3:5):he?Ue+=We?2:0:Ue+=We?0:1,te+1===se&&(Ue-=We?3:5),Ue}function re(ee,ue,pe,Pe,$,K,te){return oe(ee,ue,pe,Pe,$,K,!0,te)}e.fuzzyScoreGracefulAggressive=re;function ye(ee,ue,pe,Pe,$,K,te){return oe(ee,ue,pe,Pe,$,K,!1,te)}e.fuzzyScoreGraceful=ye;function oe(ee,ue,pe,Pe,$,K,te,se){let Y=me(ee,ue,pe,Pe,$,K,se);if(Y&&!te)return Y;if(ee.length>=3){const he=Math.min(7,ee.length-1);for(let Se=pe+1;Se<he;Se++){const Ue=de(ee,Se);if(Ue){const We=me(Ue,Ue.toLowerCase(),pe,Pe,$,K,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function de(ee,ue){if(ue+1>=ee.length)return;const pe=ee[ue],Pe=ee[ue+1];if(pe!==Pe)return ee.slice(0,ue)+Pe+pe+ee.slice(ue+2)}}),define(De[52],Ie([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(r){return h(r,0)}e.hash=F;function h(r,o){switch(typeof r){case"object":return r===null?R(349,o):Array.isArray(r)?y(r,o):E(r,o);case"string":return v(r,o);case"boolean":return A(r,o);case"number":return R(r,o);case"undefined":return R(937,o);default:return R(617,o)}}e.doHash=h;function R(r,o){return(o<<5)-o+r|0}e.numberHash=R;function A(r,o){return R(r?433:863,o)}function v(r,o){o=R(149417,o);for(let c=0,g=r.length;c<g;c++)o=R(r.charCodeAt(c),o);return o}e.stringHash=v;function y(r,o){return o=R(104579,o),r.reduce((c,g)=>h(g,c),o)}function E(r,o){return o=R(181387,o),Object.keys(r).sort().reduce((c,g)=>(c=v(g,c),h(r[g],c)),o)}class T{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=h(o,this._value),this._value}}e.Hasher=T;var k;(function(r){r[r.BLOCK_SIZE=64]="BLOCK_SIZE",r[r.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(r,o,c=32){const g=c-o,d=~((1<<g)-1);return(r<<o|(d&r)>>>g)>>>0}function S(r,o=0,c=r.byteLength,g=0){for(let d=0;d<c;d++)r[o+d]=g}function _(r,o,c="0"){for(;r.length<o;)r=c+r;return r}function w(r,o=32){return r instanceof ArrayBuffer?Array.from(new Uint8Array(r)).map(c=>c.toString(16).padStart(2,"0")).join(""):_((r>>>0).toString(16),o/4)}e.toHexString=w;class u{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const c=o.length;if(c===0)return;const g=this._buff;let d=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=o.charCodeAt(0),s=0);;){let i=n;if(I.isHighSurrogate(n))if(s+1<c){const a=o.charCodeAt(s+1);I.isLowSurrogate(a)?(s++,i=I.computeCodePoint(n,a)):i=65533}else{t=n;break}else I.isLowSurrogate(n)&&(i=65533);if(d=this._push(g,d,i),s++,s<c)n=o.charCodeAt(s);else break}this._buffLen=d,this._leftoverHighSurrogate=t}_push(o,c,g){return g<128?o[c++]=g:g<2048?(o[c++]=192|(g&1984)>>>6,o[c++]=128|(g&63)>>>0):g<65536?(o[c++]=224|(g&61440)>>>12,o[c++]=128|(g&4032)>>>6,o[c++]=128|(g&63)>>>0):(o[c++]=240|(g&1835008)>>>18,o[c++]=128|(g&258048)>>>12,o[c++]=128|(g&4032)>>>6,o[c++]=128|(g&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=u._bigBlock32,c=this._buffDV;for(let C=0;C<64;C+=4)o.setUint32(C,c.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)o.setUint32(C,b(o.getUint32(C-12,!1)^o.getUint32(C-32,!1)^o.getUint32(C-56,!1)^o.getUint32(C-64,!1),1),!1);let g=this._h0,d=this._h1,t=this._h2,n=this._h3,s=this._h4,i,a,l;for(let C=0;C<80;C++)C<20?(i=d&t|~d&n,a=1518500249):C<40?(i=d^t^n,a=1859775393):C<60?(i=d&t|d&n|t&n,a=2400959708):(i=d^t^n,a=3395469782),l=b(g,5)+i+s+a+o.getUint32(C*4,!1)&4294967295,s=n,n=t,t=b(d,30),d=g,g=l;this._h0=this._h0+g&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=u}),define(De[38],Ie([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(F||(F={})),function(h){const R="error",A="warning",v="warn",y="info",E="ignore";function T(b){return b?I.equalsIgnoreCase(R,b)?h.Error:I.equalsIgnoreCase(A,b)||I.equalsIgnoreCase(v,b)?h.Warning:I.equalsIgnoreCase(y,b)?h.Info:h.Ignore:h.Ignore}h.fromValue=T;function k(b){switch(b){case h.Error:return R;case h.Warning:return A;case h.Info:return y;default:return E}}h.toString=k}(F||(F={})),e.default=F}),define(De[160],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[77],Ie([1,0,19,15]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class h{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const _=S.charCodeAt(0),w=this._value.charCodeAt(this._pos);return _-w}value(){return this._value[this._pos]}}e.StringIterator=h;class R{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,F.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class A{constructor(S=!0,_=!0){this._splitOnBackslash=S,this._caseSensitive=_}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let _=S.length-1;_>=0;_--,this._valueLen--){const w=this._value.charCodeAt(_);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const _=this._value.charCodeAt(this._to);if(_===47||this._splitOnBackslash&&_===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,F.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var v;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(v||(v={}));class y{constructor(S,_){this._ignorePathCasing=S,this._ignoreQueryAndFragment=_,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,F.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(T||(T={}));class k{static forUris(S=()=>!1,_=()=>!1){return new k(new y(S,_))}static forPaths(S=!1){return new k(new A(void 0,!S))}static forStrings(){return new k(new h)}static forConfigKeys(){return new k(new R)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,_){if(_){const w=_.slice(0);(0,I.shuffle)(w);for(const u of w)this.set(u,S)}else{const w=S.slice(0);(0,I.shuffle)(w);for(const u of w)this.set(u[0],u[1])}}set(S,_){const w=this._iter.reset(S);let u;this._root||(this._root=new E,this._root.segment=w.value());const r=[];for(u=this._root;;){const c=w.cmp(u.segment);if(c>0)u.left||(u.left=new E,u.left.segment=w.value()),r.push([-1,u]),u=u.left;else if(c<0)u.right||(u.right=new E,u.right.segment=w.value()),r.push([1,u]),u=u.right;else if(w.hasNext())w.next(),u.mid||(u.mid=new E,u.mid.segment=w.value()),r.push([0,u]),u=u.mid;else break}const o=u.value;u.value=_,u.key=S;for(let c=r.length-1;c>=0;c--){const g=r[c][1];g.updateHeight();const d=g.balanceFactor();if(d<-1||d>1){const t=r[c][0],n=r[c+1][0];if(t===1&&n===1)r[c][1]=g.rotateLeft();else if(t===-1&&n===-1)r[c][1]=g.rotateRight();else if(t===1&&n===-1)g.right=r[c+1][1]=r[c+1][1].rotateRight(),r[c][1]=g.rotateLeft();else if(t===-1&&n===1)g.left=r[c+1][1]=r[c+1][1].rotateLeft(),r[c][1]=g.rotateRight();else throw new Error;if(c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this._root=r[0][1]}}return o}get(S){return this._getNode(S)?.value}_getNode(S){const _=this._iter.reset(S);let w=this._root;for(;w;){const u=_.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(_.hasNext())_.next(),w=w.mid;else break}return w}has(S){const _=this._getNode(S);return!(_?.value===void 0&&_?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,_){const w=this._iter.reset(S),u=[];let r=this._root;for(;r;){const o=w.cmp(r.segment);if(o>0)u.push([-1,r]),r=r.left;else if(o<0)u.push([1,r]),r=r.right;else if(w.hasNext())w.next(),u.push([0,r]),r=r.mid;else break}if(r){if(_?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const o=this._min(r.right);if(o.key){const{key:c,value:g,segment:d}=o;this._delete(o.key,!1),r.key=c,r.value=g,r.segment=d}}else{const o=r.left??r.right;if(u.length>0){const[c,g]=u[u.length-1];switch(c){case-1:g.left=o;break;case 0:g.mid=o;break;case 1:g.right=o;break}}else this._root=o}for(let o=u.length-1;o>=0;o--){const c=u[o][1];c.updateHeight();const g=c.balanceFactor();if(g>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),u[o][1]=c.rotateLeft()):g<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),u[o][1]=c.rotateRight()),o>0)switch(u[o-1][0]){case-1:u[o-1][1].left=u[o][1];break;case 1:u[o-1][1].right=u[o][1];break;case 0:u[o-1][1].mid=u[o][1];break}else this._root=u[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const _=this._iter.reset(S);let w=this._root,u;for(;w;){const r=_.cmp(w.segment);if(r>0)w=w.left;else if(r<0)w=w.right;else if(_.hasNext())_.next(),u=w.value||u,w=w.mid;else break}return w&&w.value||u}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,_){const w=this._iter.reset(S);let u=this._root;for(;u;){const r=w.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if(w.hasNext())w.next(),u=u.mid;else return u.mid?this._entries(u.mid):_?u.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[_,w]of this)S(w,_)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const _=[];return this._dfsEntries(S,_),_[Symbol.iterator]()}_dfsEntries(S,_){S&&(S.left&&this._dfsEntries(S.left,_),S.value&&_.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,_),S.right&&this._dfsEntries(S.right,_))}_isBalanced(){const S=_=>{if(!_)return!0;const w=_.balanceFactor();return w<-1||w>1?!1:S(_.left)&&S(_.right)};return S(this._root)}}e.TernarySearchTree=k}),define(De[18],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(d){return typeof d=="string"}e.isString=I;function F(d){return Array.isArray(d)&&d.every(t=>I(t))}e.isStringArray=F;function h(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=h;function R(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}e.isTypedArray=R;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function v(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=v;function y(d){return d===!0||d===!1}e.isBoolean=y;function E(d){return typeof d>"u"}e.isUndefined=E;function T(d){return!k(d)}e.isDefined=T;function k(d){return E(d)||d===null}e.isUndefinedOrNull=k;function b(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=b;function S(d){if(k(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=S;function _(...d){const t=[];for(let n=0;n<d.length;n++){const s=d[n];if(k(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=_;const w=Object.prototype.hasOwnProperty;function u(d){if(!h(d))return!1;for(const t in d)if(w.call(d,t))return!1;return!0}e.isEmptyObject=u;function r(d){return typeof d=="function"}e.isFunction=r;function o(...d){return d.length>0&&d.every(r)}e.areFunctions=o;function c(d,t){const n=Math.min(d.length,t.length);for(let s=0;s<n;s++)g(d[s],t[s])}e.validateConstraints=c;function g(d,t){if(I(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(r(t)){try{if(d instanceof t)return}catch{}if(!k(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g}),define(De[78],Ie([1,0,18]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const F=Object.create(null);function h(v,y){if((0,I.isString)(y)){const E=F[y];if(E===void 0)throw new Error(`${v} references an unknown codicon: ${y}`);y=E}return F[v]=y,{id:v}}function R(){return F}e.getCodiconFontCharacters=R;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),mic:h("mic",60434),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(De[23],Ie([1,0,18]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const o=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([c,g])=>{o[c]=g&&typeof g=="object"?F(g):g}),o}e.deepClone=F;function h(r){if(!r||typeof r!="object")return r;const o=[r];for(;o.length>0;){const c=o.shift();Object.freeze(c);for(const g in c)if(R.call(c,g)){const d=c[g];typeof d=="object"&&!Object.isFrozen(d)&&!(0,I.isTypedArray)(d)&&o.push(d)}}return r}e.deepFreeze=h;const R=Object.prototype.hasOwnProperty;function A(r,o){return v(r,o,new Set)}e.cloneAndChange=A;function v(r,o,c){if((0,I.isUndefinedOrNull)(r))return r;const g=o(r);if(typeof g<"u")return g;if(Array.isArray(r)){const d=[];for(const t of r)d.push(v(t,o,c));return d}if((0,I.isObject)(r)){if(c.has(r))throw new Error("Cannot clone recursive data-structure");c.add(r);const d={};for(const t in r)R.call(r,t)&&(d[t]=v(r[t],o,c));return c.delete(r),d}return r}function y(r,o,c=!0){return(0,I.isObject)(r)?((0,I.isObject)(o)&&Object.keys(o).forEach(g=>{g in r?c&&((0,I.isObject)(r[g])&&(0,I.isObject)(o[g])?y(r[g],o[g],c):r[g]=o[g]):r[g]=o[g]}),r):o}e.mixin=y;function E(r,o){if(r===o)return!0;if(r==null||o===null||o===void 0||typeof r!=typeof o||typeof r!="object"||Array.isArray(r)!==Array.isArray(o))return!1;let c,g;if(Array.isArray(r)){if(r.length!==o.length)return!1;for(c=0;c<r.length;c++)if(!E(r[c],o[c]))return!1}else{const d=[];for(g in r)d.push(g);d.sort();const t=[];for(g in o)t.push(g);if(t.sort(),!E(d,t))return!1;for(c=0;c<d.length;c++)if(!E(r[d[c]],o[d[c]]))return!1}return!0}e.equals=E;function T(r){const o=new Set;return JSON.stringify(r,(c,g)=>{if((0,I.isObject)(g)||Array.isArray(g)){if(o.has(g))return"[Circular]";o.add(g)}return g})}e.safeStringify=T;function k(r,o){const c=Object.create(null);return!r||!o||Object.keys(o).forEach(d=>{const t=r[d],n=o[d];E(t,n)||(c[d]=n)}),c}e.distinct=k;function b(r,o){const c=o.toLowerCase(),g=Object.keys(r).find(d=>d.toLowerCase()===c);return g?r[g]:r[o]}e.getCaseInsensitive=b;function S(r,o){const c=Object.create(null);for(const[g,d]of Object.entries(r))o(g,d)&&(c[g]=d);return c}e.filter=S;function _(r){let o=[];for(;Object.prototype!==r;)o=o.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return o}e.getAllPropertyNames=_;function w(r){const o=[];for(const c of _(r))typeof r[c]=="function"&&o.push(c);return o}e.getAllMethodNames=w;function u(r,o){const c=d=>function(){const t=Array.prototype.slice.call(arguments,0);return o(d,t)},g={};for(const d of r)g[d]=c(d);return g}e.createProxyObject=u}),define(De[59],Ie([1,0,78]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(A){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}A.isThemeColor=v})(F||(e.ThemeColor=F={}));function h(A){return{id:A}}e.themeColorFromId=h;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function y(o){const c=v.exec(o.id);if(!c)return y(I.Codicon.error);const[,g,d]=c,t=["codicon","codicon-"+g];return d&&t.push("codicon-modifier-"+d.substring(1)),t}A.asClassNameArray=y;function E(o){return y(o).join(" ")}A.asClassName=E;function T(o){return"."+y(o).join(".")}A.asCSSSelector=T;function k(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||F.isThemeColor(o.color))}A.isThemeIcon=k;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(o){const c=b.exec(o);if(!c)return;const[,g]=c;return{id:g}}A.fromString=S;function _(o){return{id:o}}A.fromId=_;function w(o,c){let g=o.id;const d=g.lastIndexOf("~");return d!==-1&&(g=g.substring(0,d)),c&&(g=`${g}~${c}`),{id:g}}A.modify=w;function u(o){const c=o.id.lastIndexOf("~");if(c!==-1)return o.id.substring(c+1)}A.getModifier=u;function r(o,c){return o.id===c.id&&o.color?.id===c.color?.id}A.isEqual=r})(R||(e.ThemeIcon=R={}))}),define(De[161],Ie([1,0,121,15,59]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${A.source}`,"g");function y(r){return r.replace(v,(o,c)=>c?o:`\\${o}`)}e.escapeIcons=y;const E=new RegExp(`\\\\${A.source}`,"g");function T(r){return r.replace(E,o=>`\\${o}`)}e.markdownEscapeEscapedIcons=T;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(r){return r.indexOf(R)===-1?r:r.replace(k,(o,c,g,d)=>g?o:c||d||"")}e.stripIcons=b;function S(r){return r?r.replace(/\$\((.*?)\)/g,(o,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=S;const _=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(r){_.lastIndex=0;let o="";const c=[];let g=0;for(;;){const d=_.lastIndex,t=_.exec(r),n=r.substring(d,t?.index);if(n.length>0){o+=n;for(let s=0;s<n.length;s++)c.push(g)}if(!t)break;g+=t[0].length}return{text:o,iconOffsets:c}}e.parseLabelWithIcons=w;function u(r,o,c=!1){const{text:g,iconOffsets:d}=o;if(!d||d.length===0)return(0,I.matchesFuzzy)(r,g,c);const t=(0,F.ltrim)(g," "),n=g.length-t.length,s=(0,I.matchesFuzzy)(r,t,c);if(s)for(const i of s){const a=d[i.start+n]+n;i.start+=a,i.end+=a}return s}e.matchesFuzzyIconAware=u}),define(De[122],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var I;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(R){return R<0?0:R>255?255:R|0}e.toUint8=F;function h(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=h}),define(De[31],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(h){return I.test(h)}e.isUUID=F,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(v){for(let y=0;y<v.length;y++)v[y]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){h(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,E="";return E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E+="-",E+=A[R[y++]],E+=A[R[y++]],E+="-",E+=A[R[y++]],E+=A[R[y++]],E+="-",E+=A[R[y++]],E+=A[R[y++]],E+="-",E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E+=A[R[y++]],E}}()}),define(De[162],Ie([1,0,19,50,31]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function R(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=R;function A(k,b,S){const _={id:(0,h.generateUuid)(),name:k,uri:b,data:S};return{asString:async()=>"",asFile:()=>_,value:void 0}}e.createFileDataTransferItem=A;class v{constructor(){this._entries=new Map}get size(){let b=0;for(const S of this._entries)b++;return b}has(b){return this._entries.has(this.toKey(b))}matches(b){const S=[...this._entries.keys()];return F.Iterable.some(this,([_,w])=>w.asFile())&&S.push("files"),T(y(b),S)}get(b){return this._entries.get(this.toKey(b))?.[0]}append(b,S){const _=this._entries.get(b);_?_.push(S):this._entries.set(this.toKey(b),[S])}replace(b,S){this._entries.set(this.toKey(b),[S])}delete(b){this._entries.delete(this.toKey(b))}*[Symbol.iterator](){for(const[b,S]of this._entries)for(const _ of S)yield[b,_]}toKey(b){return y(b)}}e.VSDataTransfer=v;function y(k){return k.toLowerCase()}function E(k,b){return T(y(k),b.map(y))}e.matchesMimeType=E;function T(k,b){if(k==="*/*")return b.length>0;if(b.includes(k))return!0;const S=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[_,w,u]=S;return u==="*"?b.some(r=>r.startsWith(w+"/")):!1}e.UriList=Object.freeze({create:k=>(0,I.distinct)(k.map(b=>b.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(b=>!b.startsWith("#"))})}),define(De[163],Ie([1,0,60]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function F(v,y,E,T=1){let k=!1;return new Promise(b=>{const S=setTimeout(()=>{if(!k)return k=!0,b(0)},E);h(v,y,T,_=>{if(!k)return k=!0,clearTimeout(S),b(_)})})}e.findFreePort=F;function h(v,y,E,T){if(y===0)return T(0);const k=new I.Socket;k.once("connect",()=>(A(k),h(v+E,y-1,E,T))),k.once("data",()=>{}),k.once("error",b=>(A(k),b.code!=="ECONNREFUSED"?h(v+E,y-1,E,T):T(v))),k.connect(v,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(v,y,E,T="127.0.0.1"){let k=!1,b,S=1;const _=I.createServer({pauseOnConnect:!0});function w(u,r){k||(k=!0,_.removeAllListeners(),_.close(),b&&clearTimeout(b),r(u))}return new Promise(u=>{b=setTimeout(()=>{w(0,u)},E),_.on("listening",()=>{w(v,u)}),_.on("error",r=>{r&&(r.code==="EADDRINUSE"||r.code==="EACCES")&&S<y?(v++,S++,_.listen(v,T)):w(0,u)}),_.on("close",()=>{w(0,u)}),_.listen(v,T)})}e.findFreePortFaster=R;function A(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(y){console.error(y)}}}),define(De[123],Ie([1,0,122]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(v){const y=(0,I.toUint8)(v);this._defaultValue=y,this._asciiMap=F._createAsciiMap(y),this._map=new Map}static _createAsciiMap(v){const y=new Uint8Array(256);return y.fill(v),y}set(v,y){const E=(0,I.toUint8)(y);v>=0&&v<256?this._asciiMap[v]=E:this._map.set(v,E)}get(v){return v>=0&&v<256?this._asciiMap[v]:this._map.get(v)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=F;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class R{constructor(){this._actual=new F(0)}add(v){this._actual.set(v,1)}has(v){return this._actual.get(v)===1}clear(){return this._actual.clear()}}e.CharacterSet=R}),define(De[61],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(h,R){this.lineNumber=h,this.column=R}with(h=this.lineNumber,R=this.column){return h===this.lineNumber&&R===this.column?this:new I(h,R)}delta(h=0,R=0){return this.with(this.lineNumber+h,this.column+R)}equals(h){return I.equals(this,h)}static equals(h,R){return!h&&!R?!0:!!h&&!!R&&h.lineNumber===R.lineNumber&&h.column===R.column}isBefore(h){return I.isBefore(this,h)}static isBefore(h,R){return h.lineNumber<R.lineNumber?!0:R.lineNumber<h.lineNumber?!1:h.column<R.column}isBeforeOrEqual(h){return I.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,R){return h.lineNumber<R.lineNumber?!0:R.lineNumber<h.lineNumber?!1:h.column<=R.column}static compare(h,R){const A=h.lineNumber|0,v=R.lineNumber|0;if(A===v){const y=h.column|0,E=R.column|0;return y-E}return A-v}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new I(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.Position=I}),define(De[34],Ie([1,0,61]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(R,A,v,y){R>v||R===v&&A>y?(this.startLineNumber=v,this.startColumn=y,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=v,this.endColumn=y)}isEmpty(){return F.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return F.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return F.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return F.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return F.plusRange(this,R)}static plusRange(R,A){let v,y,E,T;return A.startLineNumber<R.startLineNumber?(v=A.startLineNumber,y=A.startColumn):A.startLineNumber===R.startLineNumber?(v=A.startLineNumber,y=Math.min(A.startColumn,R.startColumn)):(v=R.startLineNumber,y=R.startColumn),A.endLineNumber>R.endLineNumber?(E=A.endLineNumber,T=A.endColumn):A.endLineNumber===R.endLineNumber?(E=A.endLineNumber,T=Math.max(A.endColumn,R.endColumn)):(E=R.endLineNumber,T=R.endColumn),new F(v,y,E,T)}intersectRanges(R){return F.intersectRanges(this,R)}static intersectRanges(R,A){let v=R.startLineNumber,y=R.startColumn,E=R.endLineNumber,T=R.endColumn;const k=A.startLineNumber,b=A.startColumn,S=A.endLineNumber,_=A.endColumn;return v<k?(v=k,y=b):v===k&&(y=Math.max(y,b)),E>S?(E=S,T=_):E===S&&(T=Math.min(T,_)),v>E||v===E&&y>T?null:new F(v,y,E,T)}equalsRange(R){return F.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(R){return new I.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(R){return new I.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new F(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new F(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(R){return new F(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(R){return new F(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new F(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new F(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new F(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const E=R.startLineNumber|0,T=A.startLineNumber|0;if(E===T){const k=R.startColumn|0,b=A.startColumn|0;if(k===b){const S=R.endLineNumber|0,_=A.endLineNumber|0;if(S===_){const w=R.endColumn|0,u=A.endColumn|0;return w-u}return S-_}return k-b}return E-T}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=F}),define(De[164],Ie([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class F{static insert(R,A){return{range:new I.Range(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.EditOperation=F}),define(De[165],Ie([1,0,61,34]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class R extends F.Range{constructor(v,y,E,T){super(v,y,E,T),this.selectionStartLineNumber=v,this.selectionStartColumn=y,this.positionLineNumber=E,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return R.selectionsEqual(this,v)}static selectionsEqual(v,y){return v.selectionStartLineNumber===y.selectionStartLineNumber&&v.selectionStartColumn===y.selectionStartColumn&&v.positionLineNumber===y.positionLineNumber&&v.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,v,y):new R(v,y,this.startLineNumber,this.startColumn)}getPosition(){return new I.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,y){return this.getDirection()===0?new R(v,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,v,y)}static fromPositions(v,y=v){return new R(v.lineNumber,v.column,y.lineNumber,y.column)}static fromRange(v,y){return y===0?new R(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new R(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new R(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,y){if(v&&!y||!v&&y)return!1;if(!v&&!y)return!0;if(v.length!==y.length)return!1;for(let E=0,T=v.length;E<T;E++)if(!this.selectionsEqual(v[E],y[E]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,y,E,T,k){return k===0?new R(v,y,E,T):new R(E,T,v,y)}}e.Selection=R}),define(De[166],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ie([1,0,123]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class h extends I.CharacterClassifier{constructor(v){super(0);for(let y=0,E=v.length;y<E;y++)this.set(v.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=h;function R(A){const v={};return y=>(v.hasOwnProperty(y)||(v[y]=A(y)),v[y])}e.getMapForWordSeparators=R(A=>new h(A))}),define(De[124],Ie([1,0,50,3,75]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.USUAL_WORD_SEPARATORS)k.indexOf(S)>=0||(b+="\\"+S);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=R();function A(k){let b=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)b=k;else{let S="g";k.ignoreCase&&(S+="i"),k.multiline&&(S+="m"),k.unicode&&(S+="u"),b=new RegExp(k.source,S)}return b.lastIndex=0,b}e.ensureValidWordDefinition=A;const v=new h.LinkedList;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(k){const b=v.unshift(k);return(0,F.toDisposable)(b)}e.setDefaultGetWordAtTextConfig=y;function E(k,b,S,_,w){if(w||(w=I.Iterable.first(v)),S.length>w.maxLen){let g=k-w.maxLen/2;return g<0?g=0:_+=g,S=S.substring(g,k+w.maxLen/2),E(k,b,S,_,w)}const u=Date.now(),r=k-1-_;let o=-1,c=null;for(let g=1;!(Date.now()-u>=w.timeBudget);g++){const d=r-w.windowSize*g;b.lastIndex=Math.max(0,d);const t=T(b,S,r,o);if(!t&&c||(c=t,d<=0))break;o=d}if(c){const g={word:c[0],startColumn:_+1+c.index,endColumn:_+1+c.index+c[0].length};return b.lastIndex=0,g}return null}e.getWordAtText=E;function T(k,b,S,_){let w;for(;w=k.exec(b);){const u=w.index||0;if(u<=S&&k.lastIndex>=S)return w;if(_>0&&u>_)return null}return null}}),define(De[168],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(v){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=v.open,this.close=v.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(v.notIn))for(let y=0,E=v.notIn.length;y<E;y++)switch(v.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(v,y){if(v.getTokenCount()===0)return!0;const E=v.findTokenIndexAtOffset(y-2),T=v.getStandardTokenType(E);return this.isOK(T)}_findNeutralCharacterInRange(v,y){for(let E=v;E<=y;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class h{constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of v)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=h;function R(A,v,y){A.has(v)?A.get(v).push(y):A.set(v,[y])}}),define(De[169],Ie([1,0,123]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var F;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class h{constructor(_,w,u){const r=new Uint8Array(_*w);for(let o=0,c=_*w;o<c;o++)r[o]=u;this._data=r,this.rows=_,this.cols=w}get(_,w){return this._data[_*this.cols+w]}set(_,w,u){this._data[_*this.cols+w]=u}}class R{constructor(_){let w=0,u=0;for(let o=0,c=_.length;o<c;o++){const[g,d,t]=_[o];d>w&&(w=d),g>u&&(u=g),t>u&&(u=t)}w++,u++;const r=new h(u,w,0);for(let o=0,c=_.length;o<c;o++){const[g,d,t]=_[o];r.set(g,d,t)}this._states=r,this._maxCharCode=w}nextState(_,w){return w<0||w>=this._maxCharCode?0:this._states.get(_,w)}}e.StateMachine=R;let A=null;function v(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var y;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let E=null;function T(){if(E===null){E=new I.CharacterClassifier(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<S.length;w++)E.set(S.charCodeAt(w),1);const _=".,;:";for(let w=0;w<_.length;w++)E.set(_.charCodeAt(w),2)}return E}class k{static _createLink(_,w,u,r,o){let c=o-1;do{const g=w.charCodeAt(c);if(_.get(g)!==2)break;c--}while(c>r);if(r>0){const g=w.charCodeAt(r-1),d=w.charCodeAt(c);(g===40&&d===41||g===91&&d===93||g===123&&d===125)&&c--}return{range:{startLineNumber:u,startColumn:r+1,endLineNumber:u,endColumn:c+2},url:w.substring(r,c+1)}}static computeLinks(_,w=v()){const u=T(),r=[];for(let o=1,c=_.getLineCount();o<=c;o++){const g=_.getLineContent(o),d=g.length;let t=0,n=0,s=0,i=1,a=!1,l=!1,C=!1,D=!1;for(;t<d;){let p=!1;const m=g.charCodeAt(t);if(i===13){let f;switch(m){case 40:a=!0,f=0;break;case 41:f=a?0:1;break;case 91:C=!0,l=!0,f=0;break;case 93:C=!1,f=l?0:1;break;case 123:D=!0,f=0;break;case 125:f=D?0:1;break;case 39:case 34:case 96:s===m?f=1:s===39||s===34||s===96?f=0:f=1;break;case 42:f=s===42?1:0;break;case 124:f=s===124?1:0;break;case 32:f=C?0:1;break;default:f=u.get(m)}f===1&&(r.push(k._createLink(u,g,o,n,t)),p=!0)}else if(i===12){let f;m===91?(l=!0,f=0):f=u.get(m),f===1?p=!0:i=13}else i=w.nextState(i,m),i===0&&(p=!0);p&&(i=1,a=!1,l=!1,D=!1,n=t+1,s=m),t++}i===13&&r.push(k._createLink(u,g,o,n,d))}return r}}e.LinkComputer=k;function b(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:k.computeLinks(S)}e.computeLinks=b}),define(De[125],Ie([1,0,23]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var h;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var R;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var v;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var y;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var E;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class T{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),d.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,d.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!d.insertSpaces,this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=!!d.trimAutoWhitespace,this.bracketPairColorizationOptions=d.bracketPairColorizationOptions}equals(d){return this.tabSize===d.tabSize&&this._indentSizeIsTabSize===d._indentSizeIsTabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace&&(0,I.equals)(this.bracketPairColorizationOptions,d.bracketPairColorizationOptions)}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class k{constructor(d,t){this._findMatchBrand=void 0,this.range=d,this.matches=t}}e.FindMatch=k;var b;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(e.TrackedRangeStickiness=b={}));function S(g){return g&&typeof g.read=="function"}e.isITextSnapshot=S;var _;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(_||(e.PositionAffinity=_={}));var w;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class u{constructor(d,t,n,s,i,a){this.identifier=d,this.range=t,this.text=n,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=i,this._isTracked=a}}e.ValidAnnotatedEditOperation=u;class r{constructor(d,t,n){this.regex=d,this.wordSeparators=t,this.simpleSearch=n}}e.SearchData=r;class o{constructor(d,t,n){this.reverseEdits=d,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=o;function c(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=c}),define(De[170],Ie([1,0,19,122]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class h{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,E){y=(0,F.toUint32)(y);const T=this.values,k=this.prefixSum,b=E.length;return b===0?!1:(this.values=new Uint32Array(T.length+b),this.values.set(T.subarray(0,y),0),this.values.set(T.subarray(y),y+b),this.values.set(E,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,E){return y=(0,F.toUint32)(y),E=(0,F.toUint32)(E),this.values[y]===E?!1:(this.values[y]=E,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,E){y=(0,F.toUint32)(y),E=(0,F.toUint32)(E);const T=this.values,k=this.prefixSum;if(y>=T.length)return!1;const b=T.length-y;return E>=b&&(E=b),E===0?!1:(this.values=new Uint32Array(T.length-E),this.values.set(T.subarray(0,y),0),this.values.set(T.subarray(y+E),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,F.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let E=this.prefixSumValidIndex[0]+1;E===0&&(this.prefixSum[0]=this.values[0],E++),y>=this.values.length&&(y=this.values.length-1);for(let T=E;T<=y;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let E=0,T=this.values.length-1,k=0,b=0,S=0;for(;E<=T;)if(k=E+(T-E)/2|0,b=this.prefixSum[k],S=b-this.values[k],y<S)T=k-1;else if(y>=b)E=k+1;else break;return new A(k,y-S)}}e.PrefixSumComputer=h;class R{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const E=this._indexBySum[y],T=E>0?this._prefixSum[E-1]:0;return new A(E,y-T)}removeValues(y,E){this._values.splice(y,E),this._invalidate(y)}insertValues(y,E){this._values=(0,I.arrayInsert)(this._values,y,E),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,E=this._values.length;y<E;y++){const T=this._values[y],k=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=k+T;for(let b=0;b<T;b++)this._indexBySum[k+b]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,E){this._values[y]!==E&&(this._values[y]=E,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=R;class A{constructor(y,E){this.index=y,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=E}}e.PrefixSumIndexOfResult=A}),define(De[171],Ie([1,0,15,61,170]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(v,y,E,T){this._uri=v,this._lines=y,this._eol=E,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const y=v.changes;for(const E of y)this._acceptDeleteRange(E.range),this._acceptInsertText(new F.Position(E.range.startLineNumber,E.range.startColumn),E.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,y=this._lines.length,E=new Uint32Array(y);for(let T=0;T<y;T++)E[T]=this._lines[T].length+v;this._lineStarts=new h.PrefixSumComputer(E)}}_setLineText(v,y){this._lines[v]=y,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,y){if(y.length===0)return;const E=(0,I.splitLines)(y);if(E.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+E[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}E[E.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+E[0]);const T=new Uint32Array(E.length-1);for(let k=1;k<E.length;k++)this._lines.splice(v.lineNumber+k-1,0,E[k]),T[k-1]=E[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,T)}}e.MirrorTextModel=R}),define(De[172],Ie([1,0,15,167,61,34,125]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const v=999;class y{constructor(o,c,g,d){this.searchString=o,this.isRegex=c,this.matchCase=g,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=E(this.searchString):o=this.searchString.indexOf(`
`)>=0;let c=null;try{c=I.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch{return null}if(!c)return null;let g=!this.isRegex&&!o;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new A.SearchData(c,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=y;function E(r){if(!r||r.length===0)return!1;for(let o=0,c=r.length;o<c;o++){const g=r.charCodeAt(o);if(g===10)return!0;if(g===92){if(o++,o>=c)break;const d=r.charCodeAt(o);if(d===110||d===114||d===87)return!0}}return!1}e.isMultilineRegexSource=E;function T(r,o,c){if(!c)return new A.FindMatch(r,null);const g=[];for(let d=0,t=o.length;d<t;d++)g[d]=o[d];return new A.FindMatch(r,g)}e.createFindMatch=T;class k{constructor(o){const c=[];let g=0;for(let d=0,t=o.length;d<t;d++)o.charCodeAt(d)===10&&(c[g++]=d);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(o){const c=this._lineFeedsOffsets;let g=0,d=c.length-1;if(d===-1||o<=c[0])return 0;for(;g<d;){const t=g+((d-g)/2>>0);c[t]>=o?d=t-1:c[t+1]>=o?(g=t,d=t):g=t+1}return g+1}}class b{static findMatches(o,c,g,d,t){const n=c.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,g,new u(n.wordSeparators,n.regex),d,t):this._doFindMatchesLineByLine(o,g,n,d,t):[]}static _getMultilineMatchRange(o,c,g,d,t,n){let s,i=0;d?(i=d.findLineFeedCountBeforeOffset(t),s=c+t+i):s=c+t;let a;if(d){const p=d.findLineFeedCountBeforeOffset(t+n.length)-i;a=s+n.length+p}else a=s+n.length;const l=o.getPositionAt(s),C=o.getPositionAt(a);return new R.Range(l.lineNumber,l.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(o,c,g,d,t){const n=o.getOffsetAt(c.getStartPosition()),s=o.getValueInRange(c,1),i=o.getEOL()===`\r
`?new k(s):null,a=[];let l=0,C;for(g.reset(0);C=g.next(s);)if(a[l++]=T(this._getMultilineMatchRange(o,n,s,i,C.index,C[0]),C,d),l>=t)return a;return a}static _doFindMatchesLineByLine(o,c,g,d,t){const n=[];let s=0;if(c.startLineNumber===c.endLineNumber){const a=o.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(g,a,c.startLineNumber,c.startColumn-1,s,n,d,t),n}const i=o.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(g,i,c.startLineNumber,c.startColumn-1,s,n,d,t);for(let a=c.startLineNumber+1;a<c.endLineNumber&&s<t;a++)s=this._findMatchesInLine(g,o.getLineContent(a),a,0,s,n,d,t);if(s<t){const a=o.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(g,a,c.endLineNumber,0,s,n,d,t)}return n}static _findMatchesInLine(o,c,g,d,t,n,s,i){const a=o.wordSeparators;if(!s&&o.simpleSearch){const D=o.simpleSearch,p=D.length,m=c.length;let f=-p;for(;(f=c.indexOf(D,f+p))!==-1;)if((!a||w(a,c,m,f,p))&&(n[t++]=new A.FindMatch(new R.Range(g,f+1+d,g,f+1+p+d),null),t>=i))return t;return t}const l=new u(o.wordSeparators,o.regex);let C;l.reset(0);do if(C=l.next(c),C&&(n[t++]=T(new R.Range(g,C.index+1+d,g,C.index+1+C[0].length+d),C,s),t>=i))return t;while(C);return t}static findNextMatch(o,c,g,d){const t=c.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(o,g,n,d):this._doFindNextMatchLineByLine(o,g,n,d)}static _doFindNextMatchMultiline(o,c,g,d){const t=new h.Position(c.lineNumber,1),n=o.getOffsetAt(t),s=o.getLineCount(),i=o.getValueInRange(new R.Range(t.lineNumber,t.column,s,o.getLineMaxColumn(s)),1),a=o.getEOL()===`\r
`?new k(i):null;g.reset(c.column-1);const l=g.next(i);return l?T(this._getMultilineMatchRange(o,n,i,a,l.index,l[0]),l,d):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(o,new h.Position(1,1),g,d):null}static _doFindNextMatchLineByLine(o,c,g,d){const t=o.getLineCount(),n=c.lineNumber,s=o.getLineContent(n),i=this._findFirstMatchInLine(g,s,n,c.column,d);if(i)return i;for(let a=1;a<=t;a++){const l=(n+a-1)%t,C=o.getLineContent(l+1),D=this._findFirstMatchInLine(g,C,l+1,1,d);if(D)return D}return null}static _findFirstMatchInLine(o,c,g,d,t){o.reset(d-1);const n=o.next(c);return n?T(new R.Range(g,n.index+1,g,n.index+1+n[0].length),n,t):null}static findPreviousMatch(o,c,g,d){const t=c.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(o,g,n,d):this._doFindPreviousMatchLineByLine(o,g,n,d)}static _doFindPreviousMatchMultiline(o,c,g,d){const t=this._doFindMatchesMultiline(o,new R.Range(1,1,c.lineNumber,c.column),g,d,10*v);if(t.length>0)return t[t.length-1];const n=o.getLineCount();return c.lineNumber!==n||c.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new h.Position(n,o.getLineMaxColumn(n)),g,d):null}static _doFindPreviousMatchLineByLine(o,c,g,d){const t=o.getLineCount(),n=c.lineNumber,s=o.getLineContent(n).substring(0,c.column-1),i=this._findLastMatchInLine(g,s,n,d);if(i)return i;for(let a=1;a<=t;a++){const l=(t+n-a-1)%t,C=o.getLineContent(l+1),D=this._findLastMatchInLine(g,C,l+1,d);if(D)return D}return null}static _findLastMatchInLine(o,c,g,d){let t=null,n;for(o.reset(0);n=o.next(c);)t=T(new R.Range(g,n.index+1,g,n.index+1+n[0].length),n,d);return t}}e.TextModelSearch=b;function S(r,o,c,g,d){if(g===0)return!0;const t=o.charCodeAt(g-1);if(r.get(t)!==0||t===13||t===10)return!0;if(d>0){const n=o.charCodeAt(g);if(r.get(n)!==0)return!0}return!1}function _(r,o,c,g,d){if(g+d===c)return!0;const t=o.charCodeAt(g+d);if(r.get(t)!==0||t===13||t===10)return!0;if(d>0){const n=o.charCodeAt(g+d-1);if(r.get(n)!==0)return!0}return!1}function w(r,o,c,g,d){return S(r,o,c,g,d)&&_(r,o,c,g,d)}e.isValidMatch=w;class u{constructor(o,c){this._wordSeparators=o,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const c=o.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(g=this._searchRegex.exec(o),!g))return null;const d=g.index,t=g[0].length;if(d===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){I.getNextCodePoint(o,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=d,this._prevMatchLength=t,!this._wordSeparators||w(this._wordSeparators,o,c,d,t))return g}while(g);return null}}e.Searcher=u}),define(De[173],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const A=this._dragOperations.get(R);return this._dragOperations.delete(R),A}}addDragOperationTransfer(R,A){this._dragOperations.set(R,A)}}e.TreeViewsDnDService=I;class F{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=F}),define(De[174],Ie([1,0,4,3]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class h{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,y){return this._tokenizationSupports.set(v,y),this.handleChange([v]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(v)===y&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,y){this._factories.get(v)?.dispose();const E=new R(this,v,y);return this._factories.set(v,E),(0,F.toDisposable)(()=>{const T=this._factories.get(v);!T||T!==E||(this._factories.delete(v),T.dispose())})}async getOrCreate(v){const y=this.get(v);if(y)return y;const E=this._factories.get(v);return!E||E.isResolved?null:(await E.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const E=this._factories.get(v);return!!(!E||E.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=h;class R extends F.Disposable{get isResolved(){return this._isResolved}constructor(v,y,E){super(),this._registry=v,this._languageId=y,this._factory=E,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),define(De[175],Ie([10,11]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(De[176],Ie([1,0,4,3,175]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends F.Disposable{constructor(b,S="",_="",w=!0,u){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=b,this._label=S,this._cssClass=_,this._enabled=w,this._actionCallback=u}get id(){return this._id}get label(){return this._label}set label(b){this._setLabel(b)}_setLabel(b){this._label!==b&&(this._label=b,this._onDidChange.fire({label:b}))}get tooltip(){return this._tooltip||""}set tooltip(b){this._setTooltip(b)}_setTooltip(b){this._tooltip!==b&&(this._tooltip=b,this._onDidChange.fire({tooltip:b}))}get class(){return this._cssClass}set class(b){this._setClass(b)}_setClass(b){this._cssClass!==b&&(this._cssClass=b,this._onDidChange.fire({class:b}))}get enabled(){return this._enabled}set enabled(b){this._setEnabled(b)}_setEnabled(b){this._enabled!==b&&(this._enabled=b,this._onDidChange.fire({enabled:b}))}get checked(){return this._checked}set checked(b){this._setChecked(b)}_setChecked(b){this._checked!==b&&(this._checked=b,this._onDidChange.fire({checked:b}))}async run(b,S){this._actionCallback&&await this._actionCallback(b)}}e.Action=R;class A extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(b,S){if(!b.enabled)return;this._onWillRun.fire({action:b});let _;try{await this.runAction(b,S)}catch(w){_=w}this._onDidRun.fire({action:b,error:_})}async runAction(b,S){await b.run(S)}}e.ActionRunner=A;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let S=[];for(const _ of b)_.length&&(S.length?S=[...S,new v,..._]:S=_);return S}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=v;class y{get actions(){return this._actions}constructor(b,S,_,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=S,this.class=w,this._actions=_}async run(){}}e.SubmenuAction=y;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,h.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=E;function T(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...b)=>k.run(...b),tooltip:k.label}}e.toAction=T}),define(De[177],Ie([10,11]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(De[178],Ie([1,0,177]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,h=F*60,R=h*24,A=R*7,v=R*30,y=R*365;function E(k,b,S,_){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,I.localize)(0,null,E(new Date().getTime()+w*1e3,!1));if(!_&&w<30)return(0,I.localize)(1,null);let u;return w<F?(u=w,b?u===1?S?(0,I.localize)(2,null,u):(0,I.localize)(3,null,u):S?(0,I.localize)(4,null,u):(0,I.localize)(5,null,u):u===1?S?(0,I.localize)(6,null,u):(0,I.localize)(7,null,u):S?(0,I.localize)(8,null,u):(0,I.localize)(9,null,u)):w<h?(u=Math.floor(w/F),b?u===1?S?(0,I.localize)(10,null,u):(0,I.localize)(11,null,u):S?(0,I.localize)(12,null,u):(0,I.localize)(13,null,u):u===1?S?(0,I.localize)(14,null,u):(0,I.localize)(15,null,u):S?(0,I.localize)(16,null,u):(0,I.localize)(17,null,u)):w<R?(u=Math.floor(w/h),b?u===1?S?(0,I.localize)(18,null,u):(0,I.localize)(19,null,u):S?(0,I.localize)(20,null,u):(0,I.localize)(21,null,u):u===1?S?(0,I.localize)(22,null,u):(0,I.localize)(23,null,u):S?(0,I.localize)(24,null,u):(0,I.localize)(25,null,u)):w<A?(u=Math.floor(w/R),b?u===1?(0,I.localize)(26,null,u):(0,I.localize)(27,null,u):u===1?(0,I.localize)(28,null,u):(0,I.localize)(29,null,u)):w<v?(u=Math.floor(w/A),b?u===1?S?(0,I.localize)(30,null,u):(0,I.localize)(31,null,u):S?(0,I.localize)(32,null,u):(0,I.localize)(33,null,u):u===1?S?(0,I.localize)(34,null,u):(0,I.localize)(35,null,u):S?(0,I.localize)(36,null,u):(0,I.localize)(37,null,u)):w<y?(u=Math.floor(w/v),b?u===1?S?(0,I.localize)(38,null,u):(0,I.localize)(39,null,u):S?(0,I.localize)(40,null,u):(0,I.localize)(41,null,u):u===1?S?(0,I.localize)(42,null,u):(0,I.localize)(43,null,u):S?(0,I.localize)(44,null,u):(0,I.localize)(45,null,u)):(u=Math.floor(w/y),b?u===1?S?(0,I.localize)(46,null,u):(0,I.localize)(47,null,u):S?(0,I.localize)(48,null,u):(0,I.localize)(49,null,u):u===1?S?(0,I.localize)(50,null,u):(0,I.localize)(51,null,u):S?(0,I.localize)(52,null,u):(0,I.localize)(53,null,u))}e.fromNow=E;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(De[179],Ie([10,11]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(De[46],Ie([1,0,19,18,179]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,b){return b&&(k.stack||k.stacktrace)?h.localize(0,null,v(k),A(k.stack)||A(k.stacktrace)):v(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function v(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?h.localize(1,null,k.message):k.message||h.localize(2,null)}function y(k=null,b=!1){if(!k)return h.localize(3,null);if(Array.isArray(k)){const S=I.coalesce(k),_=y(S[0],b);return S.length>1?h.localize(4,null,_,S.length):_}if(F.isString(k))return k;if(k.detail){const S=k.detail;if(S.error)return R(S.error,b);if(S.exception)return R(S.exception,b)}return k.stack?R(k,b):k.message?k.message:h.localize(5,null)}e.toErrorMessage=y;function E(k){const b=k;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=E;function T(k,b){let S;return typeof k=="string"?S=new Error(k):S=k,S.actions=b,S}e.createErrorWithActions=T}),define(De[180],Ie([10,11]),function(ge,e){return ge.create("vs/base/common/platform",e)}),define(De[12],Ie([1,0,180]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let F=!1,h=!1,R=!1,A=!1,v=!1,y=!1,E=!1,T=!1,k=!1,b=!1,S,_=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,u,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?o=e.globals.vscode.process:typeof process<"u"&&(o=process);const c=typeof o?.versions?.electron=="string",g=c&&o?.type==="renderer";if(typeof navigator=="object"&&!g)r=navigator.userAgent,F=r.indexOf("Windows")>=0,h=r.indexOf("Macintosh")>=0,T=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=r.indexOf("Linux")>=0,b=r?.indexOf("Mobi")>=0,y=!0,S=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,_=S,w=navigator.language;else if(typeof o=="object"){F=o.platform==="win32",h=o.platform==="darwin",R=o.platform==="linux",A=R&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,E=c,k=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,_=e.LANGUAGE_DEFAULT;const D=o.env.VSCODE_NLS_CONFIG;if(D)try{const p=JSON.parse(D),m=p.availableLanguages["*"];S=p.locale,w=p.osLocale,_=m||e.LANGUAGE_DEFAULT,u=p._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var d;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(d||(e.Platform=d={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let n=0;h?n=1:F?n=3:R&&(n=2),e.isWindows=F,e.isMacintosh=h,e.isLinux=R,e.isLinuxSnap=A,e.isNative=v,e.isElectron=E,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=b,e.isCI=k,e.platform=n,e.userAgent=r,e.language=_;var s;(function(D){function p(){return e.language}D.value=p;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=m;function f(){return e.language==="en"}D.isDefault=f})(s||(e.Language=s={})),e.locale=S,e.platformLocale=w,e.translationsConfigFile=u,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let f=0,P=D.length;f<P;f++){const M=D[f];if(M.id===m.data.vscodeScheduleAsyncWork){D.splice(f,1),M.callback();return}}});let p=0;return m=>{const f=++p;D.push({id:f,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=h||T?2:F?1:3;let a=!0,l=!1;function C(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,a=new Uint16Array(D.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=C,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[47],Ie([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const h=I.globals.vscode.process;F={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(De[16],Ie([1,0,47]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,h=97,R=90,A=122,v=46,y=47,E=92,T=58,k=63;class b extends Error{constructor(n,s,i){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let C=`The "${n}" ${l} ${a} of type ${s}`;C+=`. Received type ${typeof i}`,super(C),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,n){if(t===null||typeof t!="object")throw new b(n,"Object",t)}function _(t,n){if(typeof t!="string")throw new b(n,"string",t)}const w=I.platform==="win32";function u(t){return t===y||t===E}function r(t){return t===y}function o(t){return t>=F&&t<=R||t>=h&&t<=A}function c(t,n,s,i){let a="",l=0,C=-1,D=0,p=0;for(let m=0;m<=t.length;++m){if(m<t.length)p=t.charCodeAt(m);else{if(i(p))break;p=y}if(i(p)){if(!(C===m-1||D===1))if(D===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==v||a.charCodeAt(a.length-2)!==v){if(a.length>2){const f=a.lastIndexOf(s);f===-1?(a="",l=0):(a=a.slice(0,f),l=a.length-1-a.lastIndexOf(s)),C=m,D=0;continue}else if(a.length!==0){a="",l=0,C=m,D=0;continue}}n&&(a+=a.length>0?`${s}..`:"..",l=2)}else a.length>0?a+=`${s}${t.slice(C+1,m)}`:a=t.slice(C+1,m),l=m-C-1;C=m,D=0}else p===v&&D!==-1?++D:D=-1}return a}function g(t,n){S(n,"pathObject");const s=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return s?s===n.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let n="",s="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],_(l,"path"),l.length===0)continue}else n.length===0?l=I.cwd():(l=I.env[`=${n}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===E)&&(l=`${n}\\`));const C=l.length;let D=0,p="",m=!1;const f=l.charCodeAt(0);if(C===1)u(f)&&(D=1,m=!0);else if(u(f))if(m=!0,u(l.charCodeAt(1))){let P=2,M=P;for(;P<C&&!u(l.charCodeAt(P));)P++;if(P<C&&P!==M){const N=l.slice(M,P);for(M=P;P<C&&u(l.charCodeAt(P));)P++;if(P<C&&P!==M){for(M=P;P<C&&!u(l.charCodeAt(P));)P++;(P===C||P!==M)&&(p=`\\\\${N}\\${l.slice(M,P)}`,D=P)}}}else D=1;else o(f)&&l.charCodeAt(1)===T&&(p=l.slice(0,2),D=2,C>2&&u(l.charCodeAt(2))&&(m=!0,D=3));if(p.length>0)if(n.length>0){if(p.toLowerCase()!==n.toLowerCase())continue}else n=p;if(i){if(n.length>0)break}else if(s=`${l.slice(D)}\\${s}`,i=m,m&&n.length>0)break}return s=c(s,!i,"\\",u),i?`${n}\\${s}`:`${n}${s}`||"."},normalize(t){_(t,"path");const n=t.length;if(n===0)return".";let s=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return r(l)?"\\":t;if(u(l))if(a=!0,u(t.charCodeAt(1))){let D=2,p=D;for(;D<n&&!u(t.charCodeAt(D));)D++;if(D<n&&D!==p){const m=t.slice(p,D);for(p=D;D<n&&u(t.charCodeAt(D));)D++;if(D<n&&D!==p){for(p=D;D<n&&!u(t.charCodeAt(D));)D++;if(D===n)return`\\\\${m}\\${t.slice(p)}\\`;D!==p&&(i=`\\\\${m}\\${t.slice(p,D)}`,s=D)}}}else s=1;else o(l)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),s=2,n>2&&u(t.charCodeAt(2))&&(a=!0,s=3));let C=s<n?c(t.slice(s),!a,"\\",u):"";return C.length===0&&!a&&(C="."),C.length>0&&u(t.charCodeAt(n-1))&&(C+="\\"),i===void 0?a?`\\${C}`:C:a?`${i}\\${C}`:`${i}${C}`},isAbsolute(t){_(t,"path");const n=t.length;if(n===0)return!1;const s=t.charCodeAt(0);return u(s)||n>2&&o(s)&&t.charCodeAt(1)===T&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,s;for(let l=0;l<t.length;++l){const C=t[l];_(C,"path"),C.length>0&&(n===void 0?n=s=C:n+=`\\${C}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof s=="string"&&u(s.charCodeAt(0))){++a;const l=s.length;l>1&&u(s.charCodeAt(1))&&(++a,l>2&&(u(s.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&u(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.win32.normalize(n)},relative(t,n){if(_(t,"from"),_(n,"to"),t===n)return"";const s=e.win32.resolve(t),i=e.win32.resolve(n);if(s===i||(t=s.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===E;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===E;)l--;const C=l-a;let D=0;for(;D<n.length&&n.charCodeAt(D)===E;)D++;let p=n.length;for(;p-1>D&&n.charCodeAt(p-1)===E;)p--;const m=p-D,f=C<m?C:m;let P=-1,M=0;for(;M<f;M++){const L=t.charCodeAt(a+M);if(L!==n.charCodeAt(D+M))break;L===E&&(P=M)}if(M!==f){if(P===-1)return i}else{if(m>f){if(n.charCodeAt(D+M)===E)return i.slice(D+M+1);if(M===2)return i.slice(D+M)}C>f&&(t.charCodeAt(a+M)===E?P=M:M===2&&(P=3)),P===-1&&(P=0)}let N="";for(M=a+P+1;M<=l;++M)(M===l||t.charCodeAt(M)===E)&&(N+=N.length===0?"..":"\\..");return D+=P,N.length>0?`${N}${i.slice(D,p)}`:(i.charCodeAt(D)===E&&++D,i.slice(D,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===E){if(n.charCodeAt(1)===E){const s=n.charCodeAt(2);if(s!==k&&s!==v)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(o(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===E)return`\\\\?\\${n}`;return t},dirname(t){_(t,"path");const n=t.length;if(n===0)return".";let s=-1,i=0;const a=t.charCodeAt(0);if(n===1)return u(a)?t:".";if(u(a)){if(s=i=1,u(t.charCodeAt(1))){let D=2,p=D;for(;D<n&&!u(t.charCodeAt(D));)D++;if(D<n&&D!==p){for(p=D;D<n&&u(t.charCodeAt(D));)D++;if(D<n&&D!==p){for(p=D;D<n&&!u(t.charCodeAt(D));)D++;if(D===n)return t;D!==p&&(s=i=D+1)}}}}else o(a)&&t.charCodeAt(1)===T&&(s=n>2&&u(t.charCodeAt(2))?3:2,i=s);let l=-1,C=!0;for(let D=n-1;D>=i;--D)if(u(t.charCodeAt(D))){if(!C){l=D;break}}else C=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,n){n!==void 0&&_(n,"ext"),_(t,"path");let s=0,i=-1,a=!0,l;if(t.length>=2&&o(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(s=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let C=n.length-1,D=-1;for(l=t.length-1;l>=s;--l){const p=t.charCodeAt(l);if(u(p)){if(!a){s=l+1;break}}else D===-1&&(a=!1,D=l+1),C>=0&&(p===n.charCodeAt(C)?--C===-1&&(i=l):(C=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(u(t.charCodeAt(l))){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){_(t,"path");let n=0,s=-1,i=0,a=-1,l=!0,C=0;t.length>=2&&t.charCodeAt(1)===T&&o(t.charCodeAt(0))&&(n=i=2);for(let D=t.length-1;D>=n;--D){const p=t.charCodeAt(D);if(u(p)){if(!l){i=D+1;break}continue}a===-1&&(l=!1,a=D+1),p===v?s===-1?s=D:C!==1&&(C=1):s!==-1&&(C=-1)}return s===-1||a===-1||C===0||C===1&&s===a-1&&s===i+1?"":t.slice(s,a)},format:g.bind(null,"\\"),parse(t){_(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.length;let i=0,a=t.charCodeAt(0);if(s===1)return u(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(u(a)){if(i=1,u(t.charCodeAt(1))){let P=2,M=P;for(;P<s&&!u(t.charCodeAt(P));)P++;if(P<s&&P!==M){for(M=P;P<s&&u(t.charCodeAt(P));)P++;if(P<s&&P!==M){for(M=P;P<s&&!u(t.charCodeAt(P));)P++;P===s?i=P:P!==M&&(i=P+1)}}}}else if(o(a)&&t.charCodeAt(1)===T){if(s<=2)return n.root=n.dir=t,n;if(i=2,u(t.charCodeAt(2))){if(s===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,C=i,D=-1,p=!0,m=t.length-1,f=0;for(;m>=i;--m){if(a=t.charCodeAt(m),u(a)){if(!p){C=m+1;break}continue}D===-1&&(p=!1,D=m+1),a===v?l===-1?l=m:f!==1&&(f=1):l!==-1&&(f=-1)}return D!==-1&&(l===-1||f===0||f===1&&l===D-1&&l===C+1?n.base=n.name=t.slice(C,D):(n.name=t.slice(C,l),n.base=t.slice(C,D),n.ext=t.slice(l,D))),C>0&&C!==i?n.dir=t.slice(0,C-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(w){const t=/\\/g;return()=>{const n=I.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let n="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const a=i>=0?t[i]:d();_(a,"path"),a.length!==0&&(n=`${a}/${n}`,s=a.charCodeAt(0)===y)}return n=c(n,!s,"/",r),s?`/${n}`:n.length>0?n:"."},normalize(t){if(_(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===y,s=t.charCodeAt(t.length-1)===y;return t=c(t,!n,"/",r),t.length===0?n?"/":s?"./":".":(s&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return _(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let n;for(let s=0;s<t.length;++s){const i=t[s];_(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(_(t,"from"),_(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const s=1,i=t.length,a=i-s,l=1,C=n.length-l,D=a<C?a:C;let p=-1,m=0;for(;m<D;m++){const P=t.charCodeAt(s+m);if(P!==n.charCodeAt(l+m))break;P===y&&(p=m)}if(m===D)if(C>D){if(n.charCodeAt(l+m)===y)return n.slice(l+m+1);if(m===0)return n.slice(l+m)}else a>D&&(t.charCodeAt(s+m)===y?p=m:m===0&&(p=0));let f="";for(m=s+p+1;m<=i;++m)(m===i||t.charCodeAt(m)===y)&&(f+=f.length===0?"..":"/..");return`${f}${n.slice(l+p)}`},toNamespacedPath(t){return t},dirname(t){if(_(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===y;let s=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===y){if(!i){s=a;break}}else i=!1;return s===-1?n?"/":".":n&&s===1?"//":t.slice(0,s)},basename(t,n){n!==void 0&&_(n,"ext"),_(t,"path");let s=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let C=n.length-1,D=-1;for(l=t.length-1;l>=0;--l){const p=t.charCodeAt(l);if(p===y){if(!a){s=l+1;break}}else D===-1&&(a=!1,D=l+1),C>=0&&(p===n.charCodeAt(C)?--C===-1&&(i=l):(C=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===y){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){_(t,"path");let n=-1,s=0,i=-1,a=!0,l=0;for(let C=t.length-1;C>=0;--C){const D=t.charCodeAt(C);if(D===y){if(!a){s=C+1;break}continue}i===-1&&(a=!1,i=C+1),D===v?n===-1?n=C:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:g.bind(null,"/"),parse(t){_(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.charCodeAt(0)===y;let i;s?(n.root="/",i=1):i=0;let a=-1,l=0,C=-1,D=!0,p=t.length-1,m=0;for(;p>=i;--p){const f=t.charCodeAt(p);if(f===y){if(!D){l=p+1;break}continue}C===-1&&(D=!1,C=p+1),f===v?a===-1?a=p:m!==1&&(m=1):a!==-1&&(m=-1)}if(C!==-1){const f=l===0&&s?1:l;a===-1||m===0||m===1&&a===C-1&&a===l+1?n.base=n.name=t.slice(f,C):(n.name=t.slice(f,a),n.base=t.slice(f,C),n.ext=t.slice(a,C))}return l>0?n.dir=t.slice(0,l-1):s&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(De[126],Ie([1,0,51,16]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const h=new I.Lazy(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(D,p,m=!1){const f=D||"",P=p||"",M=h.value.collator.compare(f,P);return h.value.collatorIsNumeric&&M===0&&f!==P?f<P?-1:1:M}e.compareFileNames=v;function y(D,p){const m=R.value.collator;return D=D||"",p=p||"",g(m,D,p)}e.compareFileNamesDefault=y;function E(D,p){const m=R.value.collator;return D=D||"",p=p||"",s(D,p)||g(m,D,p)}e.compareFileNamesUpper=E;function T(D,p){const m=R.value.collator;return D=D||"",p=p||"",n(D,p)||g(m,D,p)}e.compareFileNamesLower=T;function k(D,p){return D=D||"",p=p||"",D===p?0:D<p?-1:1}e.compareFileNamesUnicode=k;function b(D,p){const[m,f]=o(D),[P,M]=o(p);let N=h.value.collator.compare(f,M);if(N===0){if(h.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(N=h.value.collator.compare(m,P),h.value.collatorIsNumeric&&N===0&&m!==P)return m<P?-1:1}return N}e.compareFileExtensions=b;function S(D,p){D=D||"",p=p||"";const m=c(D),f=c(p),P=R.value.collator,M=A.value.collator;return g(M,m,f)||g(P,D,p)}e.compareFileExtensionsDefault=S;function _(D,p){D=D||"",p=p||"";const m=c(D),f=c(p),P=R.value.collator,M=A.value.collator;return g(M,m,f)||s(D,p)||g(P,D,p)}e.compareFileExtensionsUpper=_;function w(D,p){D=D||"",p=p||"";const m=c(D),f=c(p),P=R.value.collator,M=A.value.collator;return g(M,m,f)||n(D,p)||g(P,D,p)}e.compareFileExtensionsLower=w;function u(D,p){D=D||"",p=p||"";const m=c(D).toLowerCase(),f=c(p).toLowerCase();return m!==f?m<f?-1:1:D!==p?D<p?-1:1:0}e.compareFileExtensionsUnicode=u;const r=/^(.*?)(\.([^.]*))?$/;function o(D,p=!1){const m=D?r.exec(D):[];let f=[m&&m[1]||"",m&&m[3]||""];return p&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function c(D){const p=D?r.exec(D):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function g(D,p,m){const f=D.compare(p,m);return f!==0?f:p.length!==m.length?p.length<m.length?-1:1:0}function d(D){const p=D.charAt(0);return p.toLocaleUpperCase()!==p}function t(D){const p=D.charAt(0);return p.toLocaleLowerCase()!==p}function n(D,p){return d(D)&&t(p)?-1:t(D)&&d(p)?1:0}function s(D,p){return t(D)&&d(p)?-1:d(D)&&t(p)?1:0}function i(D,p,m=!1){return m||(D=D&&D.toLowerCase(),p=p&&p.toLowerCase()),D===p?0:D<p?-1:1}function a(D,p,m=!1){const f=D.split(F.sep),P=p.split(F.sep),M=f.length-1,N=P.length-1;let L,U;for(let x=0;;x++){if(L=M===x,U=N===x,L&&U)return v(f[x],P[x],m);if(L)return-1;if(U)return 1;const O=i(f[x],P[x],m);if(O!==0)return O}}e.comparePaths=a;function l(D,p,m){const f=D.toLowerCase(),P=p.toLowerCase(),M=C(D,p,m);if(M)return M;const N=f.endsWith(m),L=P.endsWith(m);if(N!==L)return N?-1:1;const U=v(f,P);return U!==0?U:f.localeCompare(P)}e.compareAnything=l;function C(D,p,m){const f=D.toLowerCase(),P=p.toLowerCase(),M=f.startsWith(m),N=P.startsWith(m);if(M!==N)return M?-1:1;if(M&&N){if(f.length<P.length)return-1;if(f.length>P.length)return 1}return 0}e.compareByPrefix=C}),define(De[32],Ie([1,0,16,12,15,18]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(l){return l===47||l===92}e.isPathSeparator=A;function v(l){return l.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=v;function y(l){return l.indexOf("/")===-1&&(l=v(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function E(l,C=I.posix.sep){if(!l)return"";const D=l.length,p=l.charCodeAt(0);if(A(p)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let f=3;const P=f;for(;f<D&&!A(l.charCodeAt(f));f++);if(P!==f&&!A(l.charCodeAt(f+1))){for(f+=1;f<D;f++)if(A(l.charCodeAt(f)))return l.slice(0,f+1).replace(/[\\/]/g,C)}}return C}else if(r(p)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+C:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<D;m++)if(A(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.getRoot=E;function T(l){if(!F.isWindows||!l||l.length<5)return!1;let C=l.charCodeAt(0);if(C!==92||(C=l.charCodeAt(1),C!==92))return!1;let D=2;const p=D;for(;D<l.length&&(C=l.charCodeAt(D),C!==92);D++);return!(p===D||(C=l.charCodeAt(D+1),isNaN(C)||C===92))}e.isUNC=T;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(l,C=F.isWindows){const D=C?k:b;return!(!l||l.length===0||/^\s+$/.test(l)||(D.lastIndex=0,D.test(l))||C&&S.test(l)||l==="."||l===".."||C&&l[l.length-1]==="."||C&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=_;function w(l,C,D){const p=l===C;return!D||p?p:!l||!C?!1:(0,h.equalsIgnoreCase)(l,C)}e.isEqual=w;function u(l,C,D,p=I.sep){if(l===C)return!0;if(!l||!C||C.length>l.length)return!1;if(D){if(!(0,h.startsWithIgnoreCase)(l,C))return!1;if(C.length===l.length)return!0;let f=C.length;return C.charAt(C.length-1)===p&&f--,l.charAt(f)===p}return C.charAt(C.length-1)!==p&&(C+=p),l.indexOf(C)===0}e.isEqualOrParent=u;function r(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=r;function o(l,C){return F.isWindows&&l.endsWith(":")&&(l+=I.sep),(0,I.isAbsolute)(l)||(l=(0,I.join)(C,l)),l=(0,I.normalize)(l),F.isWindows?(l=(0,h.rtrim)(l,I.sep),l.endsWith(":")&&(l+=I.sep)):(l=(0,h.rtrim)(l,I.sep),l||(l=I.sep)),l}e.sanitizeFilePath=o;function c(l){const C=(0,I.normalize)(l);return F.isWindows?l.length>3?!1:g(C)&&(l.length===2||C.charCodeAt(2)===92):C===I.posix.sep}e.isRootOrDriveLetter=c;function g(l,C=F.isWindows){return C?r(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function d(l,C=F.isWindows){return g(l,C)?l[0]:void 0}e.getDriveLetter=d;function t(l,C,D){return C.length>l.length?-1:l===C?0:(D&&(l=l.toLowerCase(),C=C.toLowerCase()),l.indexOf(C))}e.indexOfPath=t;function n(l){const C=l.split(":");let D,p,m;for(const f of C){const P=Number(f);(0,R.isNumber)(P)?p===void 0?p=P:m===void 0&&(m=P):D=D?[D,f].join(":"):f}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:p!==void 0?p:void 0,column:m!==void 0?m:p!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,C,D=8){let p="";for(let f=0;f<D;f++){let P;f===0&&F.isWindows&&!C&&(D===3||D===4)?P=i:P=s,p+=P.charAt(Math.floor(Math.random()*P.length))}let m;return C?m=`${C}-${p}`:m=p,l?(0,I.join)(l,m):m}e.randomPath=a}),define(De[127],Ie([1,0,126,121,52,16,12,15]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,E=[y,[]];function T(j,V,fe,J){if(!j||!V)return E;const X=j.length,z=V.length;if(X<z)return E;const Q=j.toLowerCase();return k(V,fe,z,j,Q,X,J)}e.scoreFuzzy=T;function k(j,V,fe,J,X,z,Q){const ve=[],le=[];for(let H=0;H<fe;H++){const me=H*z,Z=me-z,ie=H>0,re=j[H],ye=V[H];for(let oe=0;oe<z;oe++){const de=oe>0,ee=me+oe,ue=ee-1,pe=Z+oe-1,Pe=de?ve[ue]:0,$=ie&&de?ve[pe]:0,K=ie&&de?le[pe]:0;let te;!$&&ie?te=0:te=b(re,ye,J,X,oe,K),te&&$+te>=Pe&&(Q||ie||X.startsWith(V,oe))?(le[ee]=K+1,ve[ee]=$+te):(le[ee]=y,ve[ee]=Pe)}}const we=[];let G=fe-1,B=z-1;for(;G>=0&&B>=0;){const H=G*z+B;le[H]===y||(we.push(B),G--),B--}return[ve[fe*z-1],we.reverse()]}function b(j,V,fe,J,X,z){let Q=0;if(!S(V,J[X]))return Q;if(Q+=1,z>0&&(Q+=z*5),j===fe[X]&&(Q+=1),X===0)Q+=8;else{const ve=_(fe.charCodeAt(X-1));ve?Q+=ve:(0,F.isUpper)(fe.charCodeAt(X))&&z===0&&(Q+=2)}return Q}function S(j,V){return j===V?!0:j==="/"||j==="\\"?V==="/"||V==="\\":!1}function _(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function u(j,V,fe=0,J=0){const X=V;return X.values&&X.values.length>1?r(j,X.values,fe,J):o(j,V,fe,J)}e.scoreFuzzy2=u;function r(j,V,fe,J){let X=0;const z=[];for(const Q of V){const[ve,le]=o(j,Q,fe,J);if(typeof ve!="number")return w;X+=ve,z.push(...le)}return[X,D(z)]}function o(j,V,fe,J){const X=(0,F.fuzzyScore)(V.original,V.originalLowercase,fe,j,j.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,F.createMatches)(X)]:w}const c=Object.freeze({score:0}),g=1<<18,d=1<<17,t=1<<16;function n(j,V,fe,J){const X=J.values?J.values:[J];return(0,h.hash)({[J.normalized]:{values:X.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:j,description:V,allowNonContiguousMatches:fe}})}function s(j,V,fe,J,X){if(!j||!V.normalized)return c;const z=J.getItemLabel(j);if(!z)return c;const Q=J.getItemDescription(j),ve=n(z,Q,fe,V),le=X[ve];if(le)return le;const we=i(z,Q,J.getItemPath(j),V,fe);return X[ve]=we,we}e.scoreItemFuzzy=s;function i(j,V,fe,J,X){const z=!fe||!J.containsPathSeparator;return fe&&(A.isLinux?J.pathNormalized===fe:(0,v.equalsIgnoreCase)(J.pathNormalized,fe))?{score:g,labelMatch:[{start:0,end:j.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:J.values&&J.values.length>1?a(j,V,fe,J.values,z,X):l(j,V,fe,J,z,X)}function a(j,V,fe,J,X,z){let Q=0;const ve=[],le=[];for(const we of J){const{score:G,labelMatch:B,descriptionMatch:H}=l(j,V,fe,we,X,z);if(G===y)return c;Q+=G,B&&ve.push(...B),H&&le.push(...H)}return{score:Q,labelMatch:D(ve),descriptionMatch:D(le)}}function l(j,V,fe,J,X,z){if(X||!V){const[Q,ve]=T(j,J.normalized,J.normalizedLowercase,z&&!J.expectContiguousMatch);if(Q){const le=(0,F.matchesPrefix)(J.normalized,j);let we;if(le){we=d;const G=Math.round(J.normalized.length/j.length*100);we+=G}else we=t;return{score:we+Q,labelMatch:le||C(ve)}}}if(V){let Q=V;fe&&(Q=`${V}${R.sep}`);const ve=Q.length,le=`${Q}${j}`,[we,G]=T(le,J.normalized,J.normalizedLowercase,z&&!J.expectContiguousMatch);if(we){const B=C(G),H=[],me=[];return B.forEach(Z=>{Z.start<ve&&Z.end>ve?(H.push({start:0,end:Z.end-ve}),me.push({start:Z.start,end:ve})):Z.start>=ve?H.push({start:Z.start-ve,end:Z.end-ve}):me.push(Z)}),{score:we,labelMatch:H,descriptionMatch:me}}}return c}function C(j){const V=[];if(!j)return V;let fe;for(const J of j)fe&&fe.end===J?fe.end+=1:(fe={start:J,end:J+1},V.push(fe));return V}function D(j){const V=j.sort((X,z)=>X.start-z.start),fe=[];let J;for(const X of V)!J||!p(J,X)?(J=X,fe.push(X)):(J.start=Math.min(J.start,X.start),J.end=Math.max(J.end,X.end));return fe}function p(j,V){return!(j.end<V.start||V.end<j.start)}function m(j,V,fe,J,X,z){const Q=s(j,fe,J,X,z),ve=s(V,fe,J,X,z),le=Q.score,we=ve.score;if((le===g||we===g)&&le!==we)return le===g?-1:1;if(le>t||we>t){if(le!==we)return le>we?-1:1;if(le<d&&we<d){const re=P(Q.labelMatch,ve.labelMatch);if(re!==0)return re}const Z=X.getItemLabel(j)||"",ie=X.getItemLabel(V)||"";if(Z.length!==ie.length)return Z.length-ie.length}if(le!==we)return le>we?-1:1;const G=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,B=Array.isArray(ve.labelMatch)&&ve.labelMatch.length>0;if(G&&!B)return-1;if(B&&!G)return 1;const H=f(j,Q,X),me=f(V,ve,X);return H&&me&&H!==me?me>H?-1:1:M(j,V,fe,X)}e.compareItemsByFuzzyScore=m;function f(j,V,fe){let J=-1,X=-1;if(V.descriptionMatch&&V.descriptionMatch.length?J=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(J=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(X=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const z=fe.getItemDescription(j);z&&(X+=z.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(X=V.descriptionMatch[V.descriptionMatch.length-1].end);return X-J}function P(j,V){if(!j&&!V||(!j||!j.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!j||!j.length)return 1;const fe=j[0].start,X=j[j.length-1].end-fe,z=V[0].start,ve=V[V.length-1].end-z;return X===ve?0:ve<X?1:-1}function M(j,V,fe,J){const X=J.getItemLabel(j)||"",z=J.getItemLabel(V)||"",Q=J.getItemDescription(j),ve=J.getItemDescription(V),le=X.length+(Q?Q.length:0),we=z.length+(ve?ve.length:0);if(le!==we)return le-we;const G=J.getItemPath(j),B=J.getItemPath(V);return G&&B&&G.length!==B.length?G.length-B.length:X!==z?(0,I.compareAnything)(X,z,fe.normalized):Q&&ve&&Q!==ve?(0,I.compareAnything)(Q,ve,fe.normalized):G&&B&&G!==B?(0,I.compareAnything)(G,B,fe.normalized):0}function N(j){return j.startsWith('"')&&j.endsWith('"')}const L=" ";function U(j){typeof j!="string"&&(j="");const V=j.toLowerCase(),{pathNormalized:fe,normalized:J,normalizedLowercase:X}=x(j),z=fe.indexOf(R.sep)>=0,Q=N(j);let ve;const le=j.split(L);if(le.length>1)for(const we of le){const G=N(we),{pathNormalized:B,normalized:H,normalizedLowercase:me}=x(we);H&&(ve||(ve=[]),ve.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:B,normalized:H,normalizedLowercase:me,expectContiguousMatch:G}))}return{original:j,originalLowercase:V,pathNormalized:fe,normalized:J,normalizedLowercase:X,values:ve,containsPathSeparator:z,expectContiguousMatch:Q}}e.prepareQuery=U;function x(j){let V;A.isWindows?V=j.replace(/\//g,R.sep):V=j.replace(/\\/g,R.sep);const fe=(0,v.stripWildcards)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function O(j){return Array.isArray(j)?U(j.map(V=>V.original).join(L)):U(j.original)}e.pieceToQuery=O}),define(De[97],Ie([1,0,16]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(T){const k=(0,I.extname)(T),b=F[k.toLowerCase()];return b!==void 0?b:A(T)}e.getMediaOrTextMime=R;function A(T){const k=(0,I.extname)(T);return h[k.toLowerCase()]}e.getMediaMime=A;function v(T){for(const k in h)if(h[k]===T)return k}e.getExtensionForMimeType=v;const y=/^(.+)\/(.+?)(;.+)?$/;function E(T,k){const b=y.exec(T);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:k?void 0:T}e.normalizeMimeType=E}),define(De[98],Ie([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var F;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(F||(e.Source=F={}));var h;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function R(v,...y){const E=y.reduce((b,S)=>(b[S]=!0,b),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(b=>!E[b]).forEach(b=>{for(let S=0;S<T.length;S++)if(b.search(T[S])!==-1){delete v[b];break}})}e.sanitizeProcessEnvironment=R;function A(v){v&&(delete v.DEBUG,I.isMacintosh&&delete v.DYLD_LIBRARY_PATH,I.isLinux&&delete v.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(De[2],Ie([1,0,16,12]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function v(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!h.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,a){return!i&&!a?"file":i}function E(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const T="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(a){return a instanceof S?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,C,D,p,m=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=y(a,m),this.authority=l||T,this.path=E(this.scheme,C||T),this.query=D||T,this.fragment=p||T,v(this,m))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:C,path:D,query:p,fragment:m}=a;return l===void 0?l=this.scheme:l===null&&(l=T),C===void 0?C=this.authority:C===null&&(C=T),D===void 0?D=this.path:D===null&&(D=T),p===void 0?p=this.query:p===null&&(p=T),m===void 0?m=this.fragment:m===null&&(m=T),l===this.scheme&&C===this.authority&&D===this.path&&p===this.query&&m===this.fragment?this:new u(l,C,D,p,m)}static parse(a,l=!1){const C=b.exec(a);return C?new u(C[2]||T,s(C[4]||T),s(C[5]||T),s(C[7]||T),s(C[9]||T),l):new u(T,T,T,T,T)}static file(a){let l=T;if(F.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const C=a.indexOf(k,2);C===-1?(l=a.substring(2),a=k):(l=a.substring(2,C),a=a.substring(C)||k)}return new u("file",l,a,T,T)}static from(a,l){return new u(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return F.isWindows&&a.scheme==="file"?C=S.file(I.win32.join(g(a,!0),...l)).path:C=I.posix.join(a.path,...l),a.with({path:C})}toString(a=!1){return d(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof S)return a;{const l=new u(a);return l._formatted=a.external??null,l._fsPath=a._sep===w?a.fsPath??null:null,l}}else return a}}e.URI=S;function _(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=_;const w=F.isWindows?1:void 0;class u extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=w),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(i,a,l){let C,D=-1;for(let p=0;p<i.length;p++){const m=i.charCodeAt(p);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||a&&m===47||l&&m===91||l&&m===93||l&&m===58)D!==-1&&(C+=encodeURIComponent(i.substring(D,p)),D=-1),C!==void 0&&(C+=i.charAt(p));else{C===void 0&&(C=i.substr(0,p));const f=r[m];f!==void 0?(D!==-1&&(C+=encodeURIComponent(i.substring(D,p)),D=-1),C+=f):D===-1&&(D=p)}}return D!==-1&&(C+=encodeURIComponent(i.substring(D))),C!==void 0?C:i}function c(i){let a;for(let l=0;l<i.length;l++){const C=i.charCodeAt(l);C===35||C===63?(a===void 0&&(a=i.substr(0,l)),a+=r[C]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function g(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,F.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=g;function d(i,a){const l=a?c:o;let C="",{scheme:D,authority:p,path:m,query:f,fragment:P}=i;if(D&&(C+=D,C+=":"),(p||D==="file")&&(C+=k,C+=k),p){let M=p.indexOf("@");if(M!==-1){const N=p.substr(0,M);p=p.substr(M+1),M=N.lastIndexOf(":"),M===-1?C+=l(N,!1,!1):(C+=l(N.substr(0,M),!1,!1),C+=":",C+=l(N.substr(M+1),!1,!0)),C+="@"}p=p.toLowerCase(),M=p.lastIndexOf(":"),M===-1?C+=l(p,!1,!0):(C+=l(p.substr(0,M),!1,!0),C+=p.substr(M))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const M=m.charCodeAt(1);M>=65&&M<=90&&(m=`/${String.fromCharCode(M+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const M=m.charCodeAt(0);M>=65&&M<=90&&(m=`${String.fromCharCode(M+32)}:${m.substr(2)}`)}C+=l(m,!0,!1)}return f&&(C+="?",C+=l(f,!1,!1)),P&&(C+="#",C+=a?P:o(P,!1,!1)),C}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(De[181],Ie([1,0,2]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function F(E){const T=E;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=F;function h(E){const T=[];let k;try{const b=JSON.parse(E.arguments),S=b[b.length-1];S&&S.__$stack&&(b.pop(),k=S.__$stack),T.push(...b)}catch{T.push("Unable to log remote console arguments",E.arguments)}return{args:T,stack:k}}e.parse=h;function R(E){if(typeof E!="string")return R(h(E).stack);const T=E;if(T){const k=A(T),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function A(E){if(!E)return E;const T=E.indexOf(`
`);return T===-1?E:E.substring(0,T)}function v(E,T){const{args:k,stack:b}=h(E),S=typeof k[0]=="string"&&k.length===1;let _=A(b);_&&(_=`(${_.trim()})`);let w=[];if(typeof k[0]=="string"?_&&S?w=[`%c[${T}] %c${k[0]} %c${_}`,y("blue"),y(""),y("grey")]:w=[`%c[${T}] %c${k[0]}`,y("blue"),y(""),...k.slice(1)]:w=[`%c[${T}]%`,y("blue"),...k],_&&!S&&w.push(_),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,w)}e.log=v;function y(E){return`color: ${E}`}}),define(De[62],Ie([1,0,22,2]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function h(y){return JSON.stringify(y,A)}e.stringify=h;function R(y){let E=JSON.parse(y);return E=v(E),E}e.parse=R;function A(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function v(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return F.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof I.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let T=0;T<y.length;++T)y[T]=v(y[T],E+1);else for(const T in y)Object.hasOwnProperty.call(y,T)&&(y[T]=v(y[T],E+1))}return y}e.revive=v}),define(De[17],Ie([1,0,8,12,2]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeManagedRemoteResource="vscode-managed-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.vscodeChatSesssion="vscode-chat-editor",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(T){this._preferredWebSchema=T}setDelegate(T){this._delegate=T}setServerRootPath(T){this._remoteResourcesPath=`${T}/${R.vscodeRemoteResource}`}set(T,k,b){this._hosts[T]=k,this._ports[T]=b}setConnectionToken(T,k){this._connectionTokens[T]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(T){if(this._delegate)try{return this._delegate(T)}catch(u){return I.onUnexpectedError(u),T}const k=T.authority;let b=this._hosts[k];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const S=this._ports[k],_=this._connectionTokens[k];let w=`path=${encodeURIComponent(T.path)}`;return typeof _=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),h.URI.from({scheme:F.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${S}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class v{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(T){const k=this.toUri(T,ge);return this.uriToBrowserUri(k)}uriToBrowserUri(T){return T.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===R.file&&(F.isNative||F.isWebWorker&&F.globals.origin===`${R.vscodeFileResource}://${v.FALLBACK_AUTHORITY}`)?T.with({scheme:R.vscodeFileResource,authority:T.authority||v.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(T){const k=this.toUri(T,ge);return this.uriToFileUri(k)}uriToFileUri(T){return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==v.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(T,k){return h.URI.isUri(T)?T:h.URI.parse(k.toUrl(T))}}e.FileAccess=new v;var y;(function(E){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(T.get("3"));const k="vscode-coi";function b(_){let w;typeof _=="string"?w=new URL(_).searchParams:_ instanceof URL?w=_.searchParams:h.URI.isUri(_)&&(w=new URL(_.toString(!0)).searchParams);const u=w?.get(k);if(u)return T.get(u)}E.getHeadersFromQuery=b;function S(_,w,u){if(!globalThis.crossOriginIsolated)return;const r=w&&u?"3":u?"2":"1";_ instanceof URLSearchParams?_.set(k,r):_[k]=r}E.addSearchParam=S})(y||(e.COI=y={}))}),define(De[182],Ie([1,0,156,17,12,2]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class A{constructor(b,S,_){this.id=b,this.dependencies=S,this.callback=_}}class v{static{this.INSTANCE=new v}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(b,S,_)=>{typeof b!="string"&&(_=S,S=b,b=null),(typeof S!="object"||!Array.isArray(S))&&(_=S,S=null),this._defineCalls.push(new A(b,S,_))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(b):this._isRenderer?this._rendererLoadScript(b):this._nodeJSLoadScript(b));if(!S)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(b){return new Promise((S,_)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const u=()=>{w.removeEventListener("load",r),w.removeEventListener("error",o)},r=c=>{u(),S(this._defineCalls.pop())},o=c=>{u(),_(c)};w.addEventListener("load",r),w.addEventListener("error",o),this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),w.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(w)})}_workerLoadScript(b){return new Promise((S,_)=>{try{this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),importScripts(b),S(this._defineCalls.pop())}catch(w){_(w)}})}async _nodeJSLoadScript(b){try{const S=globalThis._VSCODE_NODE_MODULES.fs,_=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,u=R.URI.parse(b).fsPath,r=S.readFileSync(u).toString(),o=w.wrap(r.replace(/^#!.*/,""));return new _.Script(o).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const y=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function T(k,b,S){if(I.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[k]&&(k=E[k]);const _=`${k}/${b}`;if(y.has(_))return y.get(_);let w;if(/^\w[\w\d+.-]*:\/\//.test(_))w=_;else{const c=`${S&&!h.isWeb?F.nodeModulesAsarPath:F.nodeModulesPath}/${_}`;w=F.FileAccess.asBrowserUri(c).toString(!0)}const u=v.INSTANCE.load(w);return y.set(_,u),u}else return await new Promise((_,w)=>{ge([k],_,w)})}e.importAMDNodeModule=T}),define(De[24],Ie([1,0,32,17,16,12,15,2]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(S){return(0,v.uriToFsPath)(S,!0)}e.originalFSPath=y;class E{constructor(_){this._ignorePathCasing=_}compare(_,w,u=!1){return _===w?0:(0,A.compare)(this.getComparisonKey(_,u),this.getComparisonKey(w,u))}isEqual(_,w,u=!1){return _===w?!0:!_||!w?!1:this.getComparisonKey(_,u)===this.getComparisonKey(w,u)}getComparisonKey(_,w=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,w,u=!1){if(_.scheme===w.scheme){if(_.scheme===F.Schemas.file)return I.isEqualOrParent(y(_),y(w),this._ignorePathCasing(_))&&_.query===w.query&&(u||_.fragment===w.fragment);if((0,e.isEqualAuthority)(_.authority,w.authority))return I.isEqualOrParent(_.path,w.path,this._ignorePathCasing(_),"/")&&_.query===w.query&&(u||_.fragment===w.fragment)}return!1}joinPath(_,...w){return v.URI.joinPath(_,...w)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return h.posix.basename(_.path)}extname(_){return h.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let w;return _.scheme===F.Schemas.file?w=v.URI.file(h.dirname(y(_))).path:(w=h.posix.dirname(_.path),_.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),w="/")),_.with({path:w})}normalizePath(_){if(!_.path.length)return _;let w;return _.scheme===F.Schemas.file?w=v.URI.file(h.normalize(y(_))).path:w=h.posix.normalize(_.path),_.with({path:w})}relativePath(_,w){if(_.scheme!==w.scheme||!(0,e.isEqualAuthority)(_.authority,w.authority))return;if(_.scheme===F.Schemas.file){const o=h.relative(y(_),y(w));return R.isWindows?I.toSlashes(o):o}let u=_.path||"/";const r=w.path||"/";if(this._ignorePathCasing(_)){let o=0;for(const c=Math.min(u.length,r.length);o<c&&!(u.charCodeAt(o)!==r.charCodeAt(o)&&u.charAt(o).toLowerCase()!==r.charAt(o).toLowerCase());o++);u=r.substr(0,o)+u.substr(o)}return h.posix.relative(u,r)}resolvePath(_,w){if(_.scheme===F.Schemas.file){const u=v.URI.file(h.resolve(y(_),w));return _.with({authority:u.authority,path:u.path})}return w=I.toPosixPath(w),_.with({path:h.posix.resolve(_.path,w)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,w){return _===w||_!==void 0&&w!==void 0&&(0,A.equalsIgnoreCase)(_,w)}hasTrailingPathSeparator(_,w=h.sep){if(_.scheme===F.Schemas.file){const u=y(_);return u.length>I.getRoot(u).length&&u[u.length-1]===w}else{const u=_.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,w=h.sep){return(0,e.hasTrailingPathSeparator)(_,w)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,w=h.sep){let u=!1;if(_.scheme===F.Schemas.file){const r=y(_);u=r!==void 0&&r.length===I.getRoot(r).length&&r[r.length-1]===w}else{w="/";const r=_.path;u=r.length===1&&r.charCodeAt(r.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(_,w)?_.with({path:_.path+"/"}):_}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(S=>S.scheme===F.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new E(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(S,_){const w=[];for(let u=0;u<S.length;u++){const r=_(S[u]);S.some((o,c)=>c===u?!1:(0,e.isEqualOrParent)(r,_(o)))||w.push(S[u])}return w}e.distinctParents=T;var k;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function _(w){const u=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[g,d]=c.split(":");g&&d&&u.set(g,d)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&u.set(S.META_DATA_MIME,o),u}S.parseMetaData=_})(k||(e.DataUri=k={}));function b(S,_,w){if(_){let u=S.path;return u&&u[0]!==h.posix.sep&&(u=h.posix.sep+u),S.with({scheme:w,authority:_,path:u})}return S.with({scheme:w})}e.toLocalResource=b}),define(De[9],Ie([1,0,21,8,4,3,24,12,160]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(B){return!!B&&typeof B.then=="function"}e.isThenable=E;function T(B){const H=new I.CancellationTokenSource,me=B(H.token),Z=new Promise((ie,re)=>{const ye=H.token.onCancellationRequested(()=>{ye.dispose(),H.dispose(),re(new F.CancellationError)});Promise.resolve(me).then(oe=>{ye.dispose(),H.dispose(),ie(oe)},oe=>{ye.dispose(),H.dispose(),re(oe)})});return new class{cancel(){H.cancel()}then(ie,re){return Z.then(ie,re)}catch(ie){return this.then(void 0,ie)}finally(ie){return Z.finally(ie)}}}e.createCancelablePromise=T;function k(B,H,me){return new Promise((Z,ie)=>{const re=H.onCancellationRequested(()=>{re.dispose(),Z(me)});B.then(Z,ie).finally(()=>re.dispose())})}e.raceCancellation=k;function b(B,H){return new Promise((me,Z)=>{const ie=H.onCancellationRequested(()=>{ie.dispose(),Z(new F.CancellationError)});B.then(me,Z).finally(()=>ie.dispose())})}e.raceCancellationError=b;async function S(B){let H=-1;const me=B.map((Z,ie)=>Z.then(re=>(H=ie,re)));try{return await Promise.race(me)}finally{B.forEach((Z,ie)=>{ie!==H&&Z.cancel()})}}e.raceCancellablePromises=S;function _(B,H,me){let Z;const ie=setTimeout(()=>{Z?.(void 0),me?.()},H);return Promise.race([B.finally(()=>clearTimeout(ie)),new Promise(re=>Z=re)])}e.raceTimeout=_;function w(B){return new Promise((H,me)=>{const Z=B();E(Z)?Z.then(H,me):H(Z)})}e.asPromise=w;class u{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const me=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(me,me).then(Z)})}return new Promise((me,Z)=>{this.queuedPromise.then(me,Z)})}return this.activePromise=H(),new Promise((me,Z)=>{this.activePromise.then(ie=>{this.activePromise=null,me(ie)},ie=>{this.activePromise=null,Z(ie)})})}dispose(){this.isDisposed=!0}}e.Throttler=u;class r{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=r;class o{constructor(){this.promiseMap=new Map}queue(H,me){const ie=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(H)===ie&&this.promiseMap.delete(H)});return this.promiseMap.set(H,ie),ie}}e.SequencerByKey=o;const c=(B,H)=>{let me=!0;const Z=setTimeout(()=>{me=!1,H()},B);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Z),me=!1}}},g=B=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,B())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class d{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,me=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,re)=>{this.doResolve=ie,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===y.MicrotaskDelay?g(Z):c(me,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class t{constructor(H){this.delayer=new d(H),this.throttler=new u}trigger(H,me){return this.delayer.trigger(()=>this.throttler.queue(H),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this._isOpen=!1,this._promise=new Promise((H,me)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(H){super(),this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(B,H){return H?new Promise((me,Z)=>{const ie=setTimeout(()=>{re.dispose(),me()},B),re=H.onCancellationRequested(()=>{clearTimeout(ie),re.dispose(),Z(new F.CancellationError)})}):T(me=>i(B,me))}e.timeout=i;function a(B,H=0,me){const Z=setTimeout(()=>{B(),me&&ie.dispose()},H),ie=(0,R.toDisposable)(()=>{clearTimeout(Z),me?.deleteAndLeak(ie)});return me?.add(ie),ie}e.disposableTimeout=a;function l(B){const H=[];let me=0;const Z=B.length;function ie(){return me<Z?B[me++]():null}function re(ye){ye!=null&&H.push(ye);const oe=ie();return oe?oe.then(re):Promise.resolve(H)}return Promise.resolve(null).then(re)}e.sequence=l;function C(B,H=Z=>!!Z,me=null){let Z=0;const ie=B.length,re=()=>{if(Z>=ie)return Promise.resolve(me);const ye=B[Z++];return Promise.resolve(ye()).then(de=>H(de)?Promise.resolve(de):re())};return re()}e.first=C;function D(B,H=Z=>!!Z,me=null){if(B.length===0)return Promise.resolve(me);let Z=B.length;const ie=()=>{Z=-1;for(const re of B)re.cancel?.()};return new Promise((re,ye)=>{for(const oe of B)oe.then(de=>{--Z>=0&&H(de)?(ie(),re(de)):Z===0&&re(me)}).catch(de=>{--Z>=0&&(ie(),ye(de))})})}e.firstParallel=D;class p{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new h.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){return this._size++,new Promise((me,Z)=>{this.outstandingPromises.push({factory:H,c:me,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const me=H.factory();me.then(H.c,H.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=p;class m extends p{constructor(){super(1)}}e.Queue=m;class f{constructor(){this.sequentializer=new fe,this.tasks=0}queue(H){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,H())):this.sequentializer.run(this.tasks++,H())}}e.LimitedQueue=f;class P{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const H=new z;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,me=A.extUri){const Z=me.getComparisonKey(H);let ie=this.queues.get(Z);if(!ie){ie=new m;const re=this.drainListenerCount++,ye=h.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.queues.delete(Z),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(re),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(re,ye),this.queues.set(Z,ie)}return ie}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=P;class M{constructor(H,me){this._token=-1,typeof H=="function"&&typeof me=="number"&&this.setIfNotSet(H,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},me)}setIfNotSet(H,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},me))}}e.TimeoutTimer=M;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,me){this.cancel(),this._token=setInterval(()=>{H()},me)}}e.IntervalTimer=N;class L{constructor(H,me){this.timeoutToken=-1,this.runner=H,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=L;class U{constructor(H,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=U;class x extends L{constructor(H,me){super(H,me),this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner?.(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class O extends R.Disposable{constructor(H,me){super(),this.options=H,this.handler=me,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const me of H)this.pendingWork.push(me);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,v.setTimeout0)(()=>{if(H)return;const me=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(B,H)=>{const me=requestIdleCallback(B,typeof H=="number"?{timeout:H}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(me))}}}}();class j{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function V(B,H,me){let Z;for(let ie=0;ie<me;ie++)try{return await B()}catch(re){Z=re,await i(H)}throw Z}e.retry=V;class fe{isRunning(H){return typeof H=="number"?this._running?.taskId===H:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(H,me,Z){return this._running={taskId:H,cancel:()=>Z?.(),promise:me},me.then(()=>this.doneRunning(H),()=>this.doneRunning(H)),me}doneRunning(H){this._running&&H===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const H=this._queued;this._queued=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this._queued)this._queued.run=H;else{let me,Z;const ie=new Promise((re,ye)=>{me=re,Z=ye});this._queued={run:H,promise:ie,promiseResolve:me,promiseReject:Z}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=fe;class J{constructor(H,me=()=>Date.now()){this.interval=H,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=J;var X;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(X||(X={}));class z{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((H,me)=>{this.completeCallback=H,this.errorCallback=me})}complete(H){return new Promise(me=>{this.completeCallback(H),this.outcome={outcome:0,value:H},me()})}error(H){return new Promise(me=>{this.errorCallback(H),this.outcome={outcome:1,value:H},me()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=z;var Q;(function(B){async function H(Z){let ie;const re=await Promise.all(Z.map(ye=>ye.then(oe=>oe,oe=>{ie||(ie=oe)})));if(typeof ie<"u")throw ie;return re}B.settled=H;function me(Z){return new Promise(async(ie,re)=>{try{await Z(ie,re)}catch(ye){re(ye)}})}B.withAsyncBody=me})(Q||(e.Promises=Q={}));var ve;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(ve||(ve={}));class le{static fromArray(H){return new le(me=>{me.emitMany(H)})}static fromPromise(H){return new le(async me=>{me.emitMany(await H)})}static fromPromises(H){return new le(async me=>{await Promise.all(H.map(async Z=>me.emitOne(await Z)))})}static merge(H){return new le(async me=>{await Promise.all(H.map(async Z=>{for await(const ie of Z)me.emitOne(ie)}))})}static{this.EMPTY=le.fromArray([])}constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new h.Emitter,queueMicrotask(async()=>{const me={emitOne:Z=>this.emitOne(Z),emitMany:Z=>this.emitMany(Z),reject:Z=>this.reject(Z)};try{await Promise.resolve(H(me)),this.resolve()}catch(Z){this.reject(Z)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await h.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,me){return new le(async Z=>{for await(const ie of H)Z.emitOne(me(ie))})}map(H){return le.map(this,H)}static filter(H,me){return new le(async Z=>{for await(const ie of H)me(ie)&&Z.emitOne(ie)})}filter(H){return le.filter(this,H)}static coalesce(H){return le.filter(H,me=>!!me)}coalesce(){return le.coalesce(this)}static async toPromise(H){const me=[];for await(const Z of H)me.push(Z);return me}toPromise(){return le.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=le;class we extends le{constructor(H,me){super(me),this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function G(B){const H=new I.CancellationTokenSource,me=B(H.token);return new we(H,async Z=>{const ie=H.token.onCancellationRequested(()=>{ie.dispose(),H.dispose(),Z.reject(new F.CancellationError)});try{for await(const re of me){if(H.token.isCancellationRequested)return;Z.emitOne(re)}ie.dispose(),H.dispose()}catch(re){ie.dispose(),H.dispose(),Z.reject(re)}})}e.createCancelableAsyncIterable=G}),define(De[35],Ie([1,0,19,9,32,28,16,12,15]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",k="[^/\\\\]",b=/\//g;function S(fe,J){switch(fe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${J?`|${T}${k}+`:""})*?`}}function _(fe,J){if(!fe)return[];const X=[];let z=!1,Q=!1,ve="";for(const le of fe){switch(le){case J:if(!z&&!Q){X.push(ve),ve="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ve+=le}return ve&&X.push(ve),X}e.splitGlobAware=_;function w(fe){if(!fe)return"";let J="";const X=_(fe,e.GLOB_SPLIT);if(X.every(z=>z===e.GLOBSTAR))J=".*";else{let z=!1;X.forEach((Q,ve)=>{if(Q===e.GLOBSTAR){if(z)return;J+=S(2,ve===X.length-1)}else{let le=!1,we="",G=!1,B="";for(const H of Q){if(H!=="}"&&le){we+=H;continue}if(G&&(H!=="]"||!B)){let me;H==="-"?me=H:(H==="^"||H==="!")&&!B?me="^":H===e.GLOB_SPLIT?me="":me=(0,y.escapeRegExpCharacters)(H),B+=me;continue}switch(H){case"{":le=!0;continue;case"[":G=!0;continue;case"}":{const Z=`(?:${_(we,",").map(ie=>w(ie)).join("|")})`;J+=Z,le=!1,we="";break}case"]":{J+="["+B+"]",G=!1,B="";break}case"?":J+=k;continue;case"*":J+=S(1);continue;default:J+=(0,y.escapeRegExpCharacters)(H)}}ve<X.length-1&&(X[ve+1]!==e.GLOBSTAR||ve+2<X.length)&&(J+=T)}z=Q===e.GLOBSTAR})}return J}const u=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(fe,J){if(!fe)return s;let X;typeof fe!="string"?X=fe.pattern:X=fe,X=X.trim();const z=`${X}_${!!J.trimForExclusions}`;let Q=t.get(z);if(Q)return a(Q,fe);let ve;return u.test(X)?Q=C(X.substr(4),X):(ve=r.exec(l(X,J)))?Q=D(ve[1],X):(J.trimForExclusions?c:o).test(X)?Q=p(X,J):(ve=g.exec(l(X,J)))?Q=m(ve[1].substr(1),X,!0):(ve=d.exec(l(X,J)))?Q=m(ve[1],X,!1):Q=f(X),t.set(z,Q),a(Q,fe)}function a(fe,J){if(typeof J=="string")return fe;const X=function(z,Q){return(0,h.isEqualOrParent)(z,J.base,!v.isLinux)?fe((0,y.ltrim)(z.substr(J.base.length),A.sep),Q):null};return X.allBasenames=fe.allBasenames,X.allPaths=fe.allPaths,X.basenames=fe.basenames,X.patterns=fe.patterns,X}function l(fe,J){return J.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function C(fe,J){return function(X,z){return typeof X=="string"&&X.endsWith(fe)?J:null}}function D(fe,J){const X=`/${fe}`,z=`\\${fe}`,Q=function(le,we){return typeof le!="string"?null:we?we===fe?J:null:le===fe||le.endsWith(X)||le.endsWith(z)?J:null},ve=[fe];return Q.basenames=ve,Q.patterns=[J],Q.allBasenames=ve,Q}function p(fe,J){const X=j(fe.slice(1,-1).split(",").map(we=>i(we,J)).filter(we=>we!==s),fe),z=X.length;if(!z)return s;if(z===1)return X[0];const Q=function(we,G){for(let B=0,H=X.length;B<H;B++)if(X[B](we,G))return fe;return null},ve=X.find(we=>!!we.allBasenames);ve&&(Q.allBasenames=ve.allBasenames);const le=X.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return le.length&&(Q.allPaths=le),Q}function m(fe,J,X){const z=A.sep===A.posix.sep,Q=z?fe:fe.replace(b,A.sep),ve=A.sep+Q,le=A.posix.sep+fe;let we;return X?we=function(G,B){return typeof G=="string"&&(G===Q||G.endsWith(ve)||!z&&(G===fe||G.endsWith(le)))?J:null}:we=function(G,B){return typeof G=="string"&&(G===Q||!z&&G===fe)?J:null},we.allPaths=[(X?"*/":"./")+fe],we}function f(fe){try{const J=new RegExp(`^${w(fe)}$`);return function(X){return J.lastIndex=0,typeof X=="string"&&J.test(X)?fe:null}}catch{return s}}function P(fe,J,X){return!fe||typeof J!="string"?!1:M(fe)(J,void 0,X)}e.match=P;function M(fe,J={}){if(!fe)return n;if(typeof fe=="string"||N(fe)){const X=i(fe,J);if(X===s)return n;const z=function(Q,ve){return!!X(Q,ve)};return X.allBasenames&&(z.allBasenames=X.allBasenames),X.allPaths&&(z.allPaths=X.allPaths),z}return x(fe,J)}e.parse=M;function N(fe){const J=fe;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=N;function L(fe){return fe.allBasenames||[]}e.getBasenameTerms=L;function U(fe){return fe.allPaths||[]}e.getPathTerms=U;function x(fe,J){const X=j(Object.getOwnPropertyNames(fe).map(we=>O(we,fe[we],J)).filter(we=>we!==s)),z=X.length;if(!z)return s;if(!X.some(we=>!!we.requiresSiblings)){if(z===1)return X[0];const we=function(H,me){let Z;for(let ie=0,re=X.length;ie<re;ie++){const ye=X[ie](H,me);if(typeof ye=="string")return ye;(0,F.isThenable)(ye)&&(Z||(Z=[]),Z.push(ye))}return Z?(async()=>{for(const ie of Z){const re=await ie;if(typeof re=="string")return re}return null})():null},G=X.find(H=>!!H.allBasenames);G&&(we.allBasenames=G.allBasenames);const B=X.reduce((H,me)=>me.allPaths?H.concat(me.allPaths):H,[]);return B.length&&(we.allPaths=B),we}const Q=function(we,G,B){let H,me;for(let Z=0,ie=X.length;Z<ie;Z++){const re=X[Z];re.requiresSiblings&&B&&(G||(G=(0,A.basename)(we)),H||(H=G.substr(0,G.length-(0,A.extname)(we).length)));const ye=re(we,G,H,B);if(typeof ye=="string")return ye;(0,F.isThenable)(ye)&&(me||(me=[]),me.push(ye))}return me?(async()=>{for(const Z of me){const ie=await Z;if(typeof ie=="string")return ie}return null})():null},ve=X.find(we=>!!we.allBasenames);ve&&(Q.allBasenames=ve.allBasenames);const le=X.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return le.length&&(Q.allPaths=le),Q}function O(fe,J,X){if(J===!1)return s;const z=i(fe,X);if(z===s)return s;if(typeof J=="boolean")return z;if(J){const Q=J.when;if(typeof Q=="string"){const ve=(le,we,G,B)=>{if(!B||!z(le,we))return null;const H=Q.replace("$(basename)",()=>G),me=B(H);return(0,F.isThenable)(me)?me.then(Z=>Z?fe:null):me?fe:null};return ve.requiresSiblings=!0,ve}}return z}function j(fe,J){const X=fe.filter(we=>!!we.basenames);if(X.length<2)return fe;const z=X.reduce((we,G)=>{const B=G.basenames;return B?we.concat(B):we},[]);let Q;if(J){Q=[];for(let we=0,G=z.length;we<G;we++)Q.push(J)}else Q=X.reduce((we,G)=>{const B=G.patterns;return B?we.concat(B):we},[]);const ve=function(we,G){if(typeof we!="string")return null;if(!G){let H;for(H=we.length;H>0;H--){const me=we.charCodeAt(H-1);if(me===47||me===92)break}G=we.substr(H)}const B=z.indexOf(G);return B!==-1?Q[B]:null};ve.basenames=z,ve.patterns=Q,ve.allBasenames=z;const le=fe.filter(we=>!we.basenames);return le.push(ve),le}function V(fe,J){return(0,I.equals)(fe,J,(X,z)=>typeof X=="string"&&typeof z=="string"?X===z:typeof X!="string"&&typeof z!="string"?X.base===z.base&&X.pattern===z.pattern:!1)}e.patternsEquals=V}),define(De[79],Ie([1,0,8,161,24,15,2]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class y{constructor(r="",o=!1){if(this.value=r,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(r,o=0){return this.value+=b(this.supportThemeIcons?(0,F.escapeIcons)(r):r).replace(/([ \t]+)/g,(c,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,o){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}appendLink(r,o,c){return this.value+="[",this.value+=this._escape(o,"]"),this.value+="](",this.value+=this._escape(String(r),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(r,o){const c=new RegExp((0,R.escapeRegExpCharacters)(o),"g");return r.replace(c,(g,d)=>r.charAt(d-1)!=="\\"?`\\${g}`:g)}}e.MarkdownString=y;function E(u){return T(u)?!u.value:Array.isArray(u)?u.every(E):!0}e.isEmptyMarkdownString=E;function T(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function k(u,r){return u===r?!0:!u||!r?!1:u.value===r.value&&u.isTrusted===r.isTrusted&&u.supportThemeIcons===r.supportThemeIcons&&u.supportHtml===r.supportHtml&&(u.baseUri===r.baseUri||!!u.baseUri&&!!r.baseUri&&(0,h.isEqual)(A.URI.from(u.baseUri),A.URI.from(r.baseUri)))}e.markdownStringEqual=k;function b(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function S(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=S;function _(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=_;function w(u){const r=[],o=u.split("|").map(g=>g.trim());u=o[0];const c=o[1];if(c){const g=/height=(\d+)/.exec(c),d=/width=(\d+)/.exec(c),t=g?g[1]:"",n=d?d[1]:"",s=isFinite(parseInt(n)),i=isFinite(parseInt(t));s&&r.push(`width="${n}"`),i&&r.push(`height="${t}"`)}return{href:u,dimensions:r}}e.parseHrefAndDimensions=w}),define(De[99],Ie([1,0,19,32,16,12,24,15]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(i,a){const{os:l,tildify:C,relative:D}=a;if(D){const f=E(i,D,l);if(typeof f=="string")return f}let p=i.fsPath;if(l===1&&!R.isWindows?p=p.replace(/\//g,"\\"):l!==1&&R.isWindows&&(p=p.replace(/\\/g,"/")),l!==1&&C?.userHome){const f=C.userHome.fsPath;let P;i.scheme!==C.userHome.scheme&&i.path.startsWith(h.posix.sep)?P=C.userHome.with({path:i.path}).fsPath:P=i.fsPath,p=b(P,f,l)}return(l===1?h.win32:h.posix).normalize(T(p,l===1))}e.getPathLabel=y;function E(i,a,l){const C=l===1?h.win32:h.posix,D=l===3?A.extUri:A.extUriIgnorePathCase,p=a.getWorkspace(),m=(0,I.firstOrDefault)(p.folders);if(!m)return;i.scheme!==m.uri.scheme&&i.path.startsWith(h.posix.sep)&&(i=m.uri.with({path:i.path}));const f=a.getWorkspaceFolder(i);if(!f)return;let P;if(D.isEqual(f.uri,i)?P="":P=D.relativePath(f.uri,i)??"",P&&(P=C.normalize(P)),p.folders.length>1&&!a.noPrefix){const M=f.name?f.name:D.basenameOrAuthority(f.uri);P=P?`${M} \u2022 ${P}`:M}return P}function T(i,a=R.isWindows){return(0,F.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let k=Object.create(null);function b(i,a,l=R.OS){if(l===1||!i||!a)return i;let C=k.original===a?k.normalized:void 0;C||(C=a,R.isWindows&&(C=(0,F.toSlashes)(C)),C=`${(0,v.rtrim)(C,h.posix.sep)}${h.posix.sep}`,k={original:a,normalized:C});let D=i;return R.isWindows&&(D=(0,F.toSlashes)(D)),(l===3?D.startsWith(C):(0,v.startsWithIgnoreCase)(D,C))?`~/${D.substr(C.length)}`:i}e.tildify=b;function S(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=S;const _="\u2026",w="\\\\",u="~";function r(i,a=h.sep){const l=new Array(i.length);let C=!1;for(let D=0;D<i.length;D++){const p=i[D];if(p===""){l[D]=`.${a}`;continue}if(!p){l[D]=p;continue}C=!0;let m="",f=p;f.indexOf(w)===0?(m=f.substr(0,f.indexOf(w)+w.length),f=f.substr(f.indexOf(w)+w.length)):f.indexOf(a)===0?(m=f.substr(0,f.indexOf(a)+a.length),f=f.substr(f.indexOf(a)+a.length)):f.indexOf(u)===0&&(m=f.substr(0,f.indexOf(u)+u.length),f=f.substr(f.indexOf(u)+u.length));const P=f.split(a);for(let M=1;C&&M<=P.length;M++)for(let N=P.length-M;C&&N>=0;N--){C=!1;let L=P.slice(N,N+M).join(a);for(let U=0;!C&&U<i.length;U++)if(U!==D&&i[U]&&i[U].indexOf(L)>-1){const x=N+M===P.length,O=N>0&&i[U].indexOf(a)>-1?a+L:L,j=i[U].endsWith(O);C=!x||j}if(!C){let U="";(P[0].endsWith(":")||m!=="")&&(N===1&&(N=0,M++,L=P[0]+a+L),N>0&&(U=P[0]+a),U=m+U),N>0&&(U=U+_+a),U=U+L,N+M<P.length&&(U=U+a+_),l[D]=U}}C&&(l[D]=p)}return l}e.shorten=r;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function c(i,a=Object.create(null)){const l=[];let C=!1,D="";for(const p of i)if(p==="$"||C&&p==="{")D&&l.push({value:D,type:o.TEXT}),D="",C=!0;else if(p==="}"&&C){const m=a[D];if(typeof m=="string")m.length&&l.push({value:m,type:o.VARIABLE});else if(m){const f=l[l.length-1];(!f||f.type!==o.SEPARATOR)&&l.push({value:m.label,type:o.SEPARATOR})}D="",C=!1}else D+=p;return D&&!C&&l.push({value:D,type:o.TEXT}),l.filter((p,m)=>{if(p.type===o.SEPARATOR){const f=l[m-1],P=l[m+1];return[f,P].every(M=>M&&(M.type===o.VARIABLE||M.type===o.TEXT)&&M.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=c;function g(i,a){return R.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function d(i,a){return R.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=d;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const l=s(i.substring(0,a));return{name:l.name,parentPath:l.parentPath+i.substring(a)}}}return s(i)}e.splitRecentLabel=n;function s(i){const a=i.indexOf("/")!==-1?h.posix:h.win32,l=a.basename(i),C=a.dirname(i);return l.length?{name:l,parentPath:C}:{name:C,parentPath:""}}}),define(De[128],Ie([1,0,22,2]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function h(k){return k.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const S=this._uriTransformer.transformIncoming(b);return S===b?b:h(F.URI.from(S))}transformOutgoing(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:h(F.URI.from(S))}transformOutgoingURI(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:F.URI.from(S)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,b,S){if(!k||S>200)return null;if(typeof k=="object"){if(k instanceof F.URI)return b.transformOutgoing(k);for(const _ in k)if(Object.hasOwnProperty.call(k,_)){const w=A(k[_],b,S+1);w!==null&&(k[_]=w)}}return null}function v(k,b){const S=A(k,b,0);return S===null?k:S}e.transformOutgoingURIs=v;function y(k,b,S,_){if(!k||_>200)return null;if(typeof k=="object"){if(k.$mid===1)return S?F.URI.revive(b.transformIncoming(k)):b.transformIncoming(k);if(k instanceof I.VSBuffer)return null;for(const w in k)if(Object.hasOwnProperty.call(k,w)){const u=y(k[w],b,S,_+1);u!==null&&(k[w]=u)}}return null}function E(k,b){const S=y(k,b,!1,0);return S===null?k:S}e.transformIncomingURIs=E;function T(k,b){const S=y(k,b,!0,0);return S===null?k:S}e.transformAndReviveIncomingURIs=T}),define(De[29],Ie([1,0,53,63,370,9,32,76,16,12,24,2]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function S(O,j=b.UNLINK,V){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return j===b.UNLINK?w(O):_(O,V)}async function _(O,j=(0,A.randomPath)((0,F.tmpdir)())){try{try{await I.promises.rename(O,j)}catch(V){return V.code==="ENOENT"?void 0:w(O)}w(j).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function w(O){return(0,h.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function u(O){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function r(O,j){return g(await(j?o(O):(0,h.promisify)(I.readdir)(O)))}async function o(O){try{return await(0,h.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const j=[],V=await r(O);for(const fe of V){let J=!1,X=!1,z=!1;try{const Q=await e.Promises.lstat((0,y.join)(O,fe));J=Q.isFile(),X=Q.isDirectory(),z=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}j.push({name:fe,isFile:()=>J,isDirectory:()=>X,isSymbolicLink:()=>z})}return j}function c(O){return g(I.readdirSync(O))}e.readdirSync=c;function g(O){return O.map(j=>typeof j=="string"?E.isMacintosh?(0,v.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,v.normalizeNFC)(j.name):j.name,j))}async function d(O){const j=await r(O),V=[];for(const fe of j)await n.existsDirectory((0,y.join)(O,fe))&&V.push(fe);return V}function t(O,j=1e3){return new Promise(V=>{let fe=!1;const J=setInterval(()=>{fe||(fe=!0,I.access(O,X=>{fe=!1,X&&(clearInterval(J),V(void 0))}))},j)})}e.whenDeleted=t;var n;(function(O){async function j(J){let X;try{if(X=await e.Promises.lstat(J),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(E.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw Q}throw z}}O.stat=j;async function V(J){try{const{stat:X,symbolicLink:z}=await O.stat(J);return X.isFile()&&z?.dangling!==!0}catch{}return!1}O.existsFile=V;async function fe(J){try{const{stat:X,symbolicLink:z}=await O.stat(J);return X.isDirectory()&&z?.dangling!==!0}catch{}return!1}O.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const s=new R.ResourceQueue;function i(O,j,V){return s.queueFor(k.URI.file(O),T.extUriBiasedIgnorePathCase).queue(()=>{const fe=p(V);return new Promise((J,X)=>C(O,j,fe,z=>z?X(z):J()))})}let a=!0;function l(O){a=O}e.configureFlushOnWrite=l;function C(O,j,V,fe){if(!a)return I.writeFile(O,j,{mode:V.mode,flag:V.flag},fe);I.open(O,V.flag,V.mode,(J,X)=>{if(J)return fe(J);I.writeFile(X,j,z=>{if(z)return I.close(X,()=>fe(z));I.fdatasync(X,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),l(!1)),I.close(X,ve=>fe(ve))))})})}function D(O,j,V){const fe=p(V);if(!a)return I.writeFileSync(O,j,{mode:fe.mode,flag:fe.flag});const J=I.openSync(O,fe.flag,fe.mode);try{I.writeFileSync(J,j);try{I.fdatasyncSync(J)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),l(!1)}}finally{I.closeSync(J)}}e.writeFileSync=D;function p(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function m(O,j,V=6e4){if(O!==j)try{E.isWindows&&typeof V=="number"?await f(O,j,Date.now(),V):await(0,h.promisify)(I.rename)(O,j)}catch(fe){if(O.toLowerCase()!==j.toLowerCase()&&fe.code==="EXDEV"||O.endsWith("."))await P(O,j,{preserveSymlinks:!1}),await S(O,b.MOVE);else throw fe}}async function f(O,j,V,fe,J=0){try{return await(0,h.promisify)(I.rename)(O,j)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-V>=fe)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${X}`),X;if(J===0){let z=!1;try{const{stat:Q}=await n.stat(j);Q.isFile()||(z=!0)}catch{}if(z)throw X}return await(0,R.timeout)(Math.min(100,J*10)),f(O,j,V,fe,J+1)}}async function P(O,j,V){return N(O,j,{root:{source:O,target:j},options:V,handledSourcePaths:new Set})}const M=511;async function N(O,j,V){if(V.handledSourcePaths.has(O))return;V.handledSourcePaths.add(O);const{stat:fe,symbolicLink:J}=await n.stat(O);if(J){if(V.options.preserveSymlinks)try{return await x(O,j,V)}catch(X){console.warn("[node.js fs] copy of symlink failed: ",X)}if(J.dangling)return}return fe.isDirectory()?L(O,j,fe.mode&M,V):U(O,j,fe.mode&M)}async function L(O,j,V,fe){await e.Promises.mkdir(j,{recursive:!0,mode:V});const J=await r(O);for(const X of J)await N((0,y.join)(O,X),(0,y.join)(j,X),fe)}async function U(O,j,V){await e.Promises.copyFile(O,j),await e.Promises.chmod(j,V)}async function x(O,j,V){let fe=await e.Promises.readlink(O);(0,A.isEqualOrParent)(fe,V.root.source,!E.isLinux)&&(fe=(0,y.join)(V.root.target,fe.substr(V.root.source.length+1))),await e.Promises.symlink(fe,j)}e.Promises=new class{get access(){return(0,h.promisify)(I.access)}get stat(){return(0,h.promisify)(I.stat)}get lstat(){return(0,h.promisify)(I.lstat)}get utimes(){return(0,h.promisify)(I.utimes)}get read(){return(O,j,V,fe,J)=>new Promise((X,z)=>{I.read(O,j,V,fe,J,(Q,ve,le)=>Q?z(Q):X({bytesRead:ve,buffer:le}))})}get readFile(){return(0,h.promisify)(I.readFile)}get write(){return(O,j,V,fe,J)=>new Promise((X,z)=>{I.write(O,j,V,fe,J,(Q,ve,le)=>Q?z(Q):X({bytesWritten:ve,buffer:le}))})}get appendFile(){return(0,h.promisify)(I.appendFile)}get fdatasync(){return(0,h.promisify)(I.fdatasync)}get truncate(){return(0,h.promisify)(I.truncate)}get copyFile(){return(0,h.promisify)(I.copyFile)}get open(){return(0,h.promisify)(I.open)}get close(){return(0,h.promisify)(I.close)}get symlink(){return(0,h.promisify)(I.symlink)}get readlink(){return(0,h.promisify)(I.readlink)}get chmod(){return(0,h.promisify)(I.chmod)}get mkdir(){return(0,h.promisify)(I.mkdir)}get unlink(){return(0,h.promisify)(I.unlink)}get rmdir(){return(0,h.promisify)(I.rmdir)}get realpath(){return(0,h.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return r}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return S}get rename(){return m}get copy(){return P}}}),define(De[100],Ie([1,0,53,16,12,15,29]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function v(b){if(h.isLinux)return b;const S=(0,F.dirname)(b);if(b===S)return b;const _=((0,F.basename)(b)||b).toLowerCase();try{const u=(0,A.readdirSync)(S).filter(r=>r.toLowerCase()===_);if(u.length===1){const r=v(S);if(r)return(0,F.join)(r,u[0])}else if(u.length>1){const r=u.indexOf(_);if(r>=0){const o=v(S);if(o)return(0,F.join)(o,u[r])}}}catch{}return null}e.realcaseSync=v;async function y(b){if(h.isLinux)return b;const S=(0,F.dirname)(b);if(b===S)return b;const _=((0,F.basename)(b)||b).toLowerCase();try{const u=(await A.Promises.readdir(S)).filter(r=>r.toLowerCase()===_);if(u.length===1){const r=await y(S);if(r)return(0,F.join)(r,u[0])}else if(u.length>1){const r=u.indexOf(_);if(r>=0){const o=await y(S);if(o)return(0,F.join)(o,u[r])}}}catch{}return null}e.realcase=y;async function E(b){try{return await A.Promises.realpath(b)}catch{const _=k(b);return await A.Promises.access(_,I.constants.R_OK),_}}e.realpath=E;function T(b){try{return I.realpathSync(b)}catch{const _=k(b);return I.accessSync(_,I.constants.R_OK),_}}e.realpathSync=T;function k(b){return(0,R.rtrim)((0,F.normalize)(b),F.sep)}}),define(De[101],Ie([1,0,16,12,47,98,18,29]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(k=h.env){return k.comspec||"cmd.exe"}e.getWindowsShell=y;function E(k){let b=[],S=!1;const _=function(w){if(S){b.push(w);return}(!k.send(w,r=>{if(r&&console.error(r),S=!1,b.length>0){const o=b.slice(0);b=[],o.forEach(c=>_(c))}})||F.isWindows)&&(S=!0)};return{send:_}}e.createQueuedSender=E;var T;(function(k){async function b(S,_,w){if(I.isAbsolute(S))return S;if(_===void 0&&(_=h.cwd()),I.dirname(S)!=="."||(w===void 0&&A.isString(h.env.PATH)&&(w=h.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(_,S);async function r(o){if(await v.Promises.exists(o)){let c;try{c=await v.Promises.stat(o)}catch(g){g.message.startsWith("EACCES")&&(c=await v.Promises.lstat(o))}return c?!c.isDirectory():!1}return!1}for(const o of w){let c;if(I.isAbsolute(o)?c=I.join(o,S):c=I.join(_,o,S),await r(c))return c;let g=c+".com";if(await r(g)||(g=c+".exe",await r(g)))return g}return I.join(_,S)}k.findExecutable=b})(T||(e.win32=T={}))});var je=this&&this.__decorate||function(ge,e,I,F){var h=arguments.length,R=h<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ge,e,I,F);else for(var v=ge.length-1;v>=0;v--)(A=ge[v])&&(R=(h<3?A(R):h>3?A(e,I,R):A(e,I))||R);return h>3&&R&&Object.defineProperty(e,I,R),R};define(De[80],Ie([1,0,19,9,22,21,57,8,4,3,62,15,18]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(S||(S={}));function _(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(w||(w={}));function u(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var r;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(r||(r={}));function o(J){let X=0;for(let z=0;;z+=7){const Q=J.read(1);if(X|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return X}}const c=s(0);function g(J,X){if(X===0){J.write(c);return}let z=0;for(let ve=X;ve!==0;ve=ve>>>7)z++;const Q=h.VSBuffer.alloc(z);for(let ve=0;X!==0;ve++)Q.buffer[ve]=X&127,X=X>>>7,X>0&&(Q.buffer[ve]|=128);J.write(Q)}class d{constructor(X){this.buffer=X,this.pos=0}read(X){const z=this.buffer.slice(this.pos,this.pos+X);return this.pos+=z.byteLength,z}}e.BufferReader=d;class t{constructor(){this.buffers=[]}get buffer(){return h.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}e.BufferWriter=t;var n;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(n||(n={}));function s(J){const X=h.VSBuffer.alloc(1);return X.writeUInt8(J,0),X}const i={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},a=typeof Buffer<"u";function l(J,X){if(typeof X>"u")J.write(i.Undefined);else if(typeof X=="string"){const z=h.VSBuffer.fromString(X);J.write(i.String),g(J,z.byteLength),J.write(z)}else if(a&&Buffer.isBuffer(X)){const z=h.VSBuffer.wrap(X);J.write(i.Buffer),g(J,z.byteLength),J.write(z)}else if(X instanceof h.VSBuffer)J.write(i.VSBuffer),g(J,X.byteLength),J.write(X);else if(Array.isArray(X)){J.write(i.Array),g(J,X.length);for(const z of X)l(J,z)}else if(typeof X=="number"&&(X|0)===X)J.write(i.Uint),g(J,X);else{const z=h.VSBuffer.fromString(JSON.stringify(X));J.write(i.Object),g(J,z.byteLength),J.write(z)}}e.serialize=l;function C(J){switch(J.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return J.read(o(J)).toString();case n.Buffer:return J.read(o(J)).buffer;case n.VSBuffer:return J.read(o(J));case n.Array:{const z=o(J),Q=[];for(let ve=0;ve<z;ve++)Q.push(C(J));return Q}case n.Object:return JSON.parse(J.read(o(J)).toString());case n.Int:return o(J)}}e.deserialize=C;class D{constructor(X,z,Q=null,ve=1e3){this.protocol=X,this.ctx=z,this.logger=Q,this.timeoutDelay=ve,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(X,z){this.channels.set(X,z),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const z=this.send([X.type]);this.logger?.logOutgoing(z,0,1,u(X.type));return}case 201:case 202:case 204:case 203:{const z=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(z,X.id,1,u(X.type),X.data);return}}}send(X,z=void 0){const Q=new t;return l(Q,X),l(Q,z),this.sendBuffer(Q.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const z=new d(X),Q=C(z),ve=C(z),le=Q[0];switch(le){case 100:return this.logger?.logIncoming(X.byteLength,Q[1],1,`${_(le)}: ${Q[2]}.${Q[3]}`,ve),this.onPromise({type:le,id:Q[1],channelName:Q[2],name:Q[3],arg:ve});case 102:return this.logger?.logIncoming(X.byteLength,Q[1],1,`${_(le)}: ${Q[2]}.${Q[3]}`,ve),this.onEventListen({type:le,id:Q[1],channelName:Q[2],name:Q[3],arg:ve});case 101:return this.logger?.logIncoming(X.byteLength,Q[1],1,`${_(le)}`),this.disposeActiveRequest({type:le,id:Q[1]});case 103:return this.logger?.logIncoming(X.byteLength,Q[1],1,`${_(le)}`),this.disposeActiveRequest({type:le,id:Q[1]})}}onPromise(X){const z=this.channels.get(X.channelName);if(!z){this.collectPendingRequest(X);return}const Q=new R.CancellationTokenSource;let ve;try{ve=z.call(this.ctx,X.name,X.arg,Q.token)}catch(G){ve=Promise.reject(G)}const le=X.id;ve.then(G=>{this.sendResponse({id:le,data:G,type:201})},G=>{G instanceof Error?this.sendResponse({id:le,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:le,data:G,type:203})}).finally(()=>{we.dispose(),this.activeRequests.delete(X.id)});const we=(0,E.toDisposable)(()=>Q.cancel());this.activeRequests.set(X.id,we)}onEventListen(X){const z=this.channels.get(X.channelName);if(!z){this.collectPendingRequest(X);return}const Q=X.id,le=z.listen(this.ctx,X.name,X.arg)(we=>this.sendResponse({id:Q,data:we,type:204}));this.activeRequests.set(X.id,le)}disposeActiveRequest(X){const z=this.activeRequests.get(X.id);z&&(z.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let z=this.pendingRequests.get(X.channelName);z||(z=[],this.pendingRequests.set(X.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:X,timeoutTimer:Q})}flushPendingRequests(X){const z=this.pendingRequests.get(X);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var p;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class m{constructor(X,z=null){this.protocol=X,this.isDisposed=!1,this.state=r.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=z}getChannel(X){const z=this;return{call(Q,ve,le){return z.isDisposed?Promise.reject(new v.CancellationError):z.requestPromise(X,Q,ve,le)},listen(Q,ve){return z.isDisposed?y.Event.None:z.requestEvent(X,Q,ve)}}}requestPromise(X,z,Q,ve=R.CancellationToken.None){const le=this.lastRequestId++,G={id:le,type:100,channelName:X,name:z,arg:Q};if(ve.isCancellationRequested)return Promise.reject(new v.CancellationError);let B;return new Promise((me,Z)=>{if(ve.isCancellationRequested)return Z(new v.CancellationError);const ie=()=>{const de=ee=>{switch(ee.type){case 201:this.handlers.delete(le),me(ee.data);break;case 202:{this.handlers.delete(le);const ue=new Error(ee.data.message);ue.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,ue.name=ee.data.name,Z(ue);break}case 203:this.handlers.delete(le),Z(ee.data);break}};this.handlers.set(le,de),this.sendRequest(G)};let re=null;this.state===r.Idle?ie():(re=(0,F.createCancelablePromise)(de=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const ye=()=>{re?(re.cancel(),re=null):this.sendRequest({id:le,type:101}),Z(new v.CancellationError)},oe=ve.onCancellationRequested(ye);B=(0,E.combinedDisposable)((0,E.toDisposable)(ye),oe),this.activeRequests.add(B)}).finally(()=>{B.dispose(),this.activeRequests.delete(B)})}requestEvent(X,z,Q){const ve=this.lastRequestId++,we={id:ve,type:102,channelName:X,name:z,arg:Q};let G=null;const B=new y.Emitter({onWillAddFirstListener:()=>{G=(0,F.createCancelablePromise)(me=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(B),this.sendRequest(we)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(B),this.sendRequest({id:ve,type:103}))}}),H=me=>B.fire(me.data);return this.handlers.set(ve,H),B.event}sendRequest(X){switch(X.type){case 100:case 102:{const z=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(z,X.id,0,`${_(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const z=this.send([X.type,X.id]);this.logger?.logOutgoing(z,X.id,0,_(X.type));return}}}send(X,z=void 0){const Q=new t;return l(Q,X),l(Q,z),this.sendBuffer(Q.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const z=new d(X),Q=C(z),ve=C(z),le=Q[0];switch(le){case 200:return this.logger?.logIncoming(X.byteLength,0,0,u(le)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,Q[1],0,u(le),ve),this.onResponse({type:Q[0],id:Q[1],data:ve})}}onResponse(X){if(X.type===200){this.state=r.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===r.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=m,je([A.memoize],m.prototype,"onDidInitializePromise",null);class f{get connections(){const X=[];return this._connections.forEach(z=>X.push(z)),X}constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new E.DisposableStore,this.disposables.add(X(({protocol:z,onDidClientDisconnect:Q})=>{const ve=y.Event.once(z.onMessage);this.disposables.add(ve(le=>{const we=new d(le),G=C(we),B=new D(z,G),H=new m(z);this.channels.forEach((Z,ie)=>B.registerChannel(ie,Z));const me={channelServer:B,channelClient:H,ctx:G};this._connections.add(me),this._onDidAddConnection.fire(me),this.disposables.add(Q(()=>{B.dispose(),H.dispose(),this._connections.delete(me),this._onDidRemoveConnection.fire(me)}))}))}))}getChannel(X,z){const Q=this;return{call(ve,le,we){let G;if((0,b.isFunction)(z)){const H=(0,I.getRandomElement)(Q.connections.filter(z));G=H?Promise.resolve(H):y.Event.toPromise(y.Event.filter(Q.onDidAddConnection,z))}else G=z.routeCall(Q,ve,le);const B=G.then(H=>H.channelClient.getChannel(X));return M(B).call(ve,le,we)},listen(ve,le){if((0,b.isFunction)(z))return Q.getMulticastEvent(X,z,ve,le);const we=z.routeEvent(Q,ve,le).then(G=>G.channelClient.getChannel(X));return M(we).listen(ve,le)}}}getMulticastEvent(X,z,Q,ve){const le=this;let we;const G=new y.Emitter({onWillAddFirstListener:()=>{we=new E.DisposableStore;const B=new y.EventMultiplexer,H=new Map,me=ie=>{const ye=ie.channelClient.getChannel(X).listen(Q,ve),oe=B.add(ye);H.set(ie,oe)},Z=ie=>{const re=H.get(ie);re&&(re.dispose(),H.delete(ie))};le.connections.filter(z).forEach(me),y.Event.filter(le.onDidAddConnection,z)(me,void 0,we),le.onDidRemoveConnection(Z,void 0,we),B.event(G.fire,G,we),we.add(B)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return G.event}registerChannel(X,z){this.channels.set(X,z);for(const Q of this._connections)Q.channelServer.registerChannel(X,z)}dispose(){this.disposables.dispose();for(const X of this._connections)X.channelClient.dispose(),X.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class P{constructor(X,z,Q=null){const ve=new t;l(ve,z),X.send(ve.buffer),this.channelClient=new m(X,Q),this.channelServer=new D(X,z,Q)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,z){this.channelServer.registerChannel(X,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function M(J){return{call(X,z,Q){return J.then(ve=>ve.call(X,z,Q))},listen(X,z){const Q=new y.Relay;return J.then(ve=>Q.input=ve.listen(X,z)),Q.event}}}e.getDelayedChannel=M;function N(J){let X=!1;return{call(z,Q,ve){return X?J.call(z,Q,ve):(0,F.timeout)(0).then(()=>X=!0).then(()=>J.call(z,Q,ve))},listen(z,Q){if(X)return J.listen(z,Q);const ve=new y.Relay;return(0,F.timeout)(0).then(()=>X=!0).then(()=>ve.input=J.listen(z,Q)),ve.event}}}e.getNextTickChannel=N;class L{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const z of X.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await y.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=L;var U;(function(J){function X(le,we,G){const B=le,H=G&&G.disableMarshalling,me=new Map;for(const Z in B)Q(Z)&&me.set(Z,y.Event.buffer(B[Z],!0,void 0,we));return new class{listen(Z,ie,re){const ye=me.get(ie);if(ye)return ye;if(ve(ie)){const oe=B[ie];if(typeof oe=="function")return oe.call(B,re)}throw new v.ErrorNoTelemetry(`Event not found: ${ie}`)}call(Z,ie,re){const ye=B[ie];if(typeof ye=="function"){if(!H&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,T.revive)(re[de]);let oe=ye.apply(B,re);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new v.ErrorNoTelemetry(`Method not found: ${ie}`)}}}J.fromService=X;function z(le,we){const G=we&&we.disableMarshalling;return new Proxy({},{get(B,H){if(typeof H=="string")return we?.properties?.has(H)?we.properties.get(H):ve(H)?function(me){return le.listen(H,me)}:Q(H)?le.listen(H):async function(...me){let Z;we&&!(0,b.isUndefinedOrNull)(we.context)?Z=[we.context,...me]:Z=me;const ie=await le.call(H,Z);return G?ie:(0,T.revive)(ie)};throw new v.ErrorNoTelemetry(`Property not found: ${String(H)}`)}})}J.toService=z;function Q(le){return le[0]==="o"&&le[1]==="n"&&k.isUpperAsciiLetter(le.charCodeAt(2))}function ve(le){return/^onDynamic/.test(le)&&k.isUpperAsciiLetter(le.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const X=J.toString();if(X!=="[object Object]")return X}return J}function j(J){return Array.isArray(J)?J.map(O):O(J)}function V(J,X,z,Q,ve,le,we){we=j(we);const G=x[ve],B=G[Q%G.length];let H=[`%c[${J}]%c[${String(X).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(le)?(H=H.concat(we),H.push(")")):H.push(we),console.log.apply(console,H)}class fe{constructor(X,z){this._outgoingPrefix=X,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,z,Q,ve,le){this._totalOutgoing+=X,V(this._outgoingPrefix,this._totalOutgoing,X,z,Q,ve,le)}logIncoming(X,z,Q,ve,le){this._totalIncoming+=X,V(this._incomingPrefix,this._totalIncoming,X,z,Q,ve,le)}}e.IPCLogger=fe}),define(De[81],Ie([1,0,22,4,3,80]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(i){i.enableDiagnostics=!1,i.records=[];const a=new WeakMap;let l=0;function C(p,m){if(!a.has(p)){const f=String(++l);a.set(p,f)}return a.get(p)}function D(p,m,f,P){if(!i.enableDiagnostics)return;const M=C(p,m);if(P instanceof I.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=I.VSBuffer.alloc(P.byteLength);N.set(P),i.records.push({timestamp:Date.now(),id:M,label:m,type:f,buff:N})}else i.records.push({timestamp:Date.now(),id:M,label:m,type:f,data:P})}i.traceSocketEvent=D})(v||(e.SocketDiagnostics=v={}));var y;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let E=null;function T(){return E||(E=I.VSBuffer.alloc(0)),E}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,l){if(a===0)return T();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const m=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=a),m}if(this._chunks[0].byteLength>a){const m=this._chunks[0].slice(0,a);return l&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),m}const C=I.VSBuffer.alloc(a);let D=0,p=0;for(;a>0;){const m=this._chunks[p];if(m.byteLength>a){const f=m.slice(0,a);C.set(f,D),D+=a,l&&(this._chunks[p]=m.slice(a),this._totalLength-=a),a-=a}else C.set(m,D),D+=m.byteLength,l?(this._chunks.shift(),this._totalLength-=m.byteLength):p++,a-=m.byteLength}return C}}e.ChunkStream=k;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var _;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(_||(e.ProtocolConstants=_={}));class w{constructor(a,l,C,D){this.type=a,this.id=l,this.ack=C,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends h.Disposable{constructor(a){super(),this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const C=this._state.messageType,D=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new w(C,D,p,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class r{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=I.VSBuffer.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(l,a.data)}_bufferAdd(a,l){const C=this._totalLength===0;return this._data.push(a,l),this._totalLength+=a.byteLength+l.byteLength,C}_bufferTake(){const a=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,l){this._bufferAdd(a,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class o extends h.Disposable{constructor(a){super(),this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new r(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new w(1,0,0,a))}}e.Protocol=o;class c extends R.IPCClient{static fromSocket(a,l){return new c(new o(a),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,l,C=null){super(a,l,C),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=c;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class d{constructor(a){this.data=a,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let a=0,l=this._first;for(;l;)l=l.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let l=0,C=this._first;for(;C;)a[l++]=C.data,C=C.next;return a}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const l=new d(a);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class n{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let l=0;l<n._HISTORY_LENGTH;l++)this.lastRuns[l]=a-1e3*l;setInterval(()=>{for(let l=n._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),l=(1+n._HISTORY_LENGTH)*1e3;let C=0;for(let D=0;D<n._HISTORY_LENGTH;D++)a-this.lastRuns[D]<=l&&C++;return 1-C/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a.loadEstimator??n.getInstance(),this._shouldSendKeepAlive=a.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new h.DisposableStore,this._socket=a.socket,this._socketWriter=this._socketDisposables.add(new r(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),a.initialChunk&&this._socketReader.acceptChunk(a.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new w(5,0,0,T());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new w(7,0,0,T());this._socketWriter.write(a)}sendResume(){const a=new w(8,0,0,T());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,l){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new h.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=this._socketDisposables.add(new r(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(C=>this._receiveMessage(C))),this._socketDisposables.add(this._socket.onClose(C=>this._onSocketClose.fire(C))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new w(3,0,this._incomingAckId,T());this._socketWriter.write(a);const l=this._outgoingUnackMsg.toArray();for(let C=0,D=l.length;C<D;C++)this._socketWriter.write(l[C]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new w(6,0,0,T())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let C=0,D=l.length;C<D;C++)this._socketWriter.write(l[C]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const C=new w(1,l,this._incomingAckId,a);this._outgoingUnackMsg.push(C),this._isReconnecting||(this._socketWriter.write(C),this._recvAckCheck())}sendControl(a){const l=new w(2,0,0,a);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),l=Date.now()-a.writtenTime,C=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&C>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:C});return}const p=Math.max(2e4-l,2e4-C,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new w(3,0,this._incomingAckId,T());this._socketWriter.write(a)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const a=new w(9,0,this._incomingAckId,T());this._socketWriter.write(a)}}e.PersistentProtocol=s}),define(De[183],Ie([1,0,48,9,22,21,181,8,4,3,23,101,98,80]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class _ extends S.ChannelServer{constructor(r){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",o=>h.VSBuffer.wrap(Buffer.from(o,"base64")))},r),process.once("disconnect",()=>this.dispose())}}e.Server=_;class w{constructor(r,o){this.modulePath=r,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new F.Delayer(c),this.child=null,this._client=null}getChannel(r){const o=this;return{call(c,g,d){return o.requestPromise(r,c,g,d)},listen(c,g){return o.requestEvent(r,c,g)}}}requestPromise(r,o,c,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const d=this.getCachedChannel(r),t=(0,F.createCancelablePromise)(i=>d.call(o,c,i)),n=g.onCancellationRequested(()=>t.cancel()),s=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(r,o,c){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let g;const d=new y.Emitter({onWillAddFirstListener:()=>{g=this.getCachedChannel(r).listen(o,c)(d.fire,d),this.activeRequests.add(g)},onDidRemoveLastListener:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return d.event}get client(){if(!this._client){const r=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(o.env={...o.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(o.env),this.child=(0,I.fork)(this.modulePath,r,o);const c=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,A.isRemoteConsoleLog)(a)){(0,A.log)(a,`IPC Library: ${this.options.serverName}`);return}c.fire(h.VSBuffer.wrap(Buffer.from(a,"base64")))});const d=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&d.send(a.buffer.toString("base64")),n=c.event,s={send:t,onMessage:n};this._client=new S.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,l)=>{process.removeListener("exit",i),this.activeRequests.forEach(C=>(0,E.dispose)(C)),this.activeRequests.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:l})})}return this._client}getCachedChannel(r){let o=this.channels.get(r);return o||(o=this.client.getChannel(r),this.channels.set(r,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(De[184],Ie([1,0,9,4,3,62,18]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var v;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function y(b){const S=b;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var E;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends h.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,_=Object.create(null)){super(),this.database=S,this.options=_,this._onDidChangeStorage=this._register(new F.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(T.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((_,w)=>this.acceptExternal(w,_)),S.deleted?.forEach(_=>this.acceptExternal(_,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,_){if(this.state===E.Closed)return;let w=!1;(0,A.isUndefinedOrNull)(_)?w=this.cache.delete(S):this.cache.get(S)!==_&&(this.cache.set(S,_),w=!0),w&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,_){const w=this.cache.get(S);return(0,A.isUndefinedOrNull)(w)?_:w}getBoolean(S,_){const w=this.get(S);return(0,A.isUndefinedOrNull)(w)?_:w==="true"}getNumber(S,_){const w=this.get(S);return(0,A.isUndefinedOrNull)(w)?_:parseInt(w,10)}getObject(S,_){const w=this.get(S);return(0,A.isUndefinedOrNull)(w)?_:(0,R.parse)(w)}async set(S,_,w=!1){if(this.state===E.Closed)return;if((0,A.isUndefinedOrNull)(_))return this.delete(S,w);const u=(0,A.isObject)(_)||Array.isArray(_)?(0,R.stringify)(_):String(_);if(this.cache.get(S)!==u)return this.cache.set(S,u),this.pendingInserts.set(S,u),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:w}),this.doFlush()}async delete(S,_=!1){if(!(this.state===E.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:_}),this.doFlush()}async optimize(){if(this.state!==E.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(this.hasPending)return this.doFlush(S)}async doFlush(S){return this.options.hint===v.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===v.STORAGE_IN_MEMORY}}e.Storage=T;class k{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((_,w)=>this.items.set(w,_)),S.delete?.forEach(_=>this.items.delete(_))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=k}),define(De[185],Ie([1,0,35,16]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function h(R,A,v,y,E,T){if(Array.isArray(R)){let k=0;for(const b of R){const S=h(b,A,v,y,E,T);if(S===10)return S;S>k&&(k=S)}return k}else{if(typeof R=="string")return y?R==="*"?5:R===v?10:0:0;if(R){const{language:k,pattern:b,scheme:S,hasAccessToAllModels:_,notebookType:w}=R;if(!y&&!_)return 0;w&&E&&(A=E);let u=0;if(S)if(S===A.scheme)u=10;else if(S==="*")u=5;else return 0;if(k)if(k===v)u=10;else if(k==="*")u=Math.max(u,5);else return 0;if(w)if(w===T)u=10;else if(w==="*"&&T!==void 0)u=Math.max(u,5);else return 0;if(b){let r;if(typeof b=="string"?r=b:r={...b,base:(0,F.normalize)(b.base)},r===A.fsPath||(0,I.match)(r,A.fsPath))u=10;else return 0}return u}else return 0}}e.score=h}),define(De[129],Ie([1,0,22,12]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var h;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(h||(h={}));function R(k){for(let b=0,S=k.length;b<S;b+=4){const _=k[b+0],w=k[b+1],u=k[b+2],r=k[b+3];k[b+0]=r,k[b+1]=u,k[b+2]=w,k[b+3]=_}}function A(k){const b=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||R(b),I.VSBuffer.wrap(b)}function v(k){const b=k.buffer;if(F.isLittleEndian()||R(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const S=new Uint8Array(b.byteLength);return S.set(b),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function y(k){const b=new Uint32Array(E(k));let S=0;if(b[S++]=k.id,k.type==="full")b[S++]=1,b[S++]=k.data.length,b.set(k.data,S),S+=k.data.length;else{b[S++]=2,b[S++]=k.deltas.length;for(const _ of k.deltas)b[S++]=_.start,b[S++]=_.deleteCount,_.data?(b[S++]=_.data.length,b.set(_.data,S),S+=_.data.length):b[S++]=0}return A(b)}e.encodeSemanticTokensDto=y;function E(k){let b=0;if(b+=1+1,k.type==="full")b+=1+k.data.length;else{b+=1,b+=(1+1+1)*k.deltas.length;for(const S of k.deltas)S.data&&(b+=S.data.length)}return b}function T(k){const b=v(k);let S=0;const _=b[S++];if(b[S++]===1){const o=b[S++],c=b.subarray(S,S+o);return S+=o,{id:_,type:"full",data:c}}const u=b[S++],r=[];for(let o=0;o<u;o++){const c=b[S++],g=b[S++],d=b[S++];let t;d>0&&(t=b.subarray(S,S+d),S+=d),r[o]={start:c,deleteCount:g,data:t}}return{id:_,type:"delta",deltas:r}}e.decodeSemanticTokensDto=T}),define(De[186],Ie([10,11]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ie([1,0,19,23,12,166,124,186]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(ae,ke,He,xe){this.id=ae,this.name=ke,this.defaultValue=He,this.schema=xe}applyUpdate(ae,ke){return S(ae,ke)}compute(ae,ke,He){return He}}class b{constructor(ae,ke){this.newValue=ae,this.didChange=ke}}e.ApplyUpdateResult=b;function S(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new b(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const He=Array.isArray(ce)&&Array.isArray(ae)&&I.equals(ce,ae);return new b(ae,!He)}let ke=!1;for(const He in ae)if(ae.hasOwnProperty(He)){const xe=S(ce[He],ae[He]);xe.didChange&&(ce[He]=xe.newValue,ke=!0)}return new b(ce,ke)}class _{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,ke){return S(ae,ke)}validate(ae){return this.defaultValue}}class w{constructor(ae,ke,He,xe){this.id=ae,this.name=ke,this.defaultValue=He,this.schema=xe}applyUpdate(ae,ke){return S(ae,ke)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,ke,He){return He}}function u(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=u;class r extends w{constructor(ae,ke,He,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=He),super(ae,ke,He,xe)}validate(ae){return u(ae,this.defaultValue)}}function o(ce,ae,ke,He){if(typeof ce>"u")return ae;let xe=parseInt(ce,10);return isNaN(xe)?ae:(xe=Math.max(ke,xe),xe=Math.min(He,xe),xe|0)}e.clampedInt=o;class c extends w{static clampedInt(ae,ke,He,xe){return o(ae,ke,He,xe)}constructor(ae,ke,He,xe,Ye,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=He,rt.minimum=xe,rt.maximum=Ye),super(ae,ke,He,rt),this.minimum=xe,this.maximum=Ye}validate(ae){return c.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function g(ce,ae,ke,He){if(typeof ce>"u")return ae;const xe=d.float(ce,ae);return d.clamp(xe,ke,He)}e.clampedFloat=g;class d extends w{static clamp(ae,ke,He){return ae<ke?ke:ae>He?He:ae}static float(ae,ke){if(typeof ae=="number")return ae;if(typeof ae>"u")return ke;const He=parseFloat(ae);return isNaN(He)?ke:He}constructor(ae,ke,He,xe,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=He),super(ae,ke,He,Ye),this.validationFn=xe}validate(ae){return this.validationFn(d.float(ae,this.defaultValue))}}class t extends w{static string(ae,ke){return typeof ae!="string"?ke:ae}constructor(ae,ke,He,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=He),super(ae,ke,He,xe)}validate(ae){return t.string(ae,this.defaultValue)}}function n(ce,ae,ke,He){return typeof ce!="string"?ae:He&&ce in He?He[ce]:ke.indexOf(ce)===-1?ae:ce}e.stringSet=n;class s extends w{constructor(ae,ke,He,xe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=xe,Ye.default=He),super(ae,ke,He,Ye),this._allowedValues=xe}validate(ae){return n(ae,this.defaultValue,this._allowedValues)}}class i extends k{constructor(ae,ke,He,xe,Ye,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Ye,ot.default=xe),super(ae,ke,He,ot),this._allowedValues=Ye,this._convert=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function a(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,ke,He){return He===0?ae.accessibilitySupport:He}}class C extends k{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{insertSpace:u(ke.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(ke.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function p(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function f(ce){switch(ce){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function P(ce){switch(ce){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class M extends _{constructor(){super(140)}compute(ae,ke,He){const xe=["monaco-editor"];return ke.get(39)&&xe.push(ke.get(39)),ae.extraEditorClassName&&xe.push(ae.extraEditorClassName),ke.get(73)==="default"?xe.push("mouse-default"):ke.get(73)==="copy"&&xe.push("mouse-copy"),ke.get(110)&&xe.push("showUnused"),ke.get(138)&&xe.push("showDeprecated"),xe.join(" ")}}class N extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ae,ke,He){return He&&ae.emptySelectionClipboard}}class L extends k{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:v.localize(16,null),included:h.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:v.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{cursorMoveOnType:u(ke.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":n(ke.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":n(ke.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(ke.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(ke.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(ke.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?U.OFF:ae==="true"?U.ON:ae:ae?U.ON:U.OFF}}e.EditorFontLigatures=U;class x extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?x.OFF:ae==="true"?x.TRANSLATE:ae:ae?x.TRANSLATE:x.OFF}compute(ae,ke,He){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=x;class O extends _{constructor(){super(50)}compute(ae,ke,He){return ae.fontInfo}}class j extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(ae){const ke=d.float(ae,this.defaultValue);return ke===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ke,6,100)}compute(ae,ke,He){return ae.fontInfo.fontSize}}class V extends k{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(c.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}class fe extends k{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ke={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...ke},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...ke},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...ke},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...ke},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...ke},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:He,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:He,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:He,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:He,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:He,description:v.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{multiple:n(ke.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ke.multipleDefinitions??n(ke.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ke.multipleTypeDefinitions??n(ke.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ke.multipleDeclarations??n(ke.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ke.multipleImplementations??n(ke.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ke.multipleReferences??n(ke.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ke.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ke.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ke.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ke.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ke.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends k{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:v.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),delay:c.clampedInt(ke.delay,this.defaultValue.delay,0,1e4),sticky:u(ke.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(ke.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(ke.above,this.defaultValue.above)}}}var X;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class z extends _{constructor(){super(143)}compute(ae,ke,He){return z.computeLayout(ke,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const ke=ae.height/ae.lineHeight,He=Math.floor(ae.paddingTop/ae.lineHeight);let xe=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(xe=Math.max(xe,ke-1));const Ye=(He+ae.viewLineCount+xe)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Ye);return{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:xe,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(ae,ke){const He=ae.outerWidth,xe=ae.outerHeight,Ye=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const rt=ke.stableMinimapLayoutInput,ot=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,Et=ae.lineHeight,yt=ae.typicalHalfwidthCharacterWidth,Qt=ae.scrollBeyondLastLine,Vt=ae.minimap.renderCharacters;let bt=Ye>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Bt=ae.minimap.maxColumn,Ot=ae.minimap.size,$t=ae.minimap.side,Pt=ae.verticalScrollbarWidth,Tt=ae.viewLineCount,Mt=ae.remainingWidth,Wt=ae.isViewportWrapping,jt=Vt?2:3;let zt=Math.floor(Ye*xe);const ct=zt/Ye;let ut=!1,Gt=!1,kt=jt*bt,_t=bt/Ye,ft=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Le,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:Ce,desiredRatio:ne,minimapLineCount:Oe}=z.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:Qt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:xe,lineHeight:Et,pixelRatio:Ye});if(Tt/Oe>1)ut=!0,Gt=!0,bt=1,kt=1,_t=bt/Ye;else{let Je=!1,Ge=bt+1;if(Ot==="fit"){const nt=Math.ceil((Fe+Tt+Ce)*kt);Wt&&ot&&Mt<=ke.stableFitRemainingWidth?(Je=!0,Ge=ke.stableFitMaxMinimapScale):Je=nt>zt}if(Ot==="fill"||Je){ut=!0;const nt=bt;kt=Math.min(Et*Ye,Math.max(1,Math.floor(1/ne))),Wt&&ot&&Mt<=ke.stableFitRemainingWidth&&(Ge=ke.stableFitMaxMinimapScale),bt=Math.min(Ge,Math.max(1,Math.floor(kt/jt))),bt>nt&&(ft=Math.min(2,bt/nt)),_t=bt/Ye/ft,zt=Math.ceil(Math.max(Le,Fe+Tt+Ce)*kt),Wt?(ke.stableMinimapLayoutInput=ae,ke.stableFitRemainingWidth=Mt,ke.stableFitMaxMinimapScale=bt):(ke.stableMinimapLayoutInput=null,ke.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Bt*_t),Ft=Math.min(Dt,Math.max(0,Math.floor((Mt-Pt-2)*_t/(yt+_t)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Ye*Ft);const qe=St/Ye;St=Math.floor(St*ft);const Nt=Vt?1:2,Ut=$t==="left"?0:He-Ft-Pt;return{renderMinimap:Nt,minimapLeft:Ut,minimapWidth:Ft,minimapHeightIsEditorHeight:ut,minimapIsSampling:Gt,minimapScale:bt,minimapLineHeight:kt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:ct}}static computeLayout(ae,ke){const He=ke.outerWidth|0,xe=ke.outerHeight|0,Ye=ke.lineHeight|0,rt=ke.lineNumbersDigitCount|0,ot=ke.typicalHalfwidthCharacterWidth,Et=ke.maxDigitWidth,yt=ke.pixelRatio,Qt=ke.viewLineCount,Vt=ae.get(135),bt=Vt==="inherit"?ae.get(134):Vt,Bt=bt==="inherit"?ae.get(130):bt,Ot=ae.get(133),$t=ke.isDominatedByLongLines,Pt=ae.get(57),Tt=ae.get(67).renderType!==0,Mt=ae.get(68),Wt=ae.get(104),jt=ae.get(83),zt=ae.get(72),ct=ae.get(102),ut=ct.verticalScrollbarSize,Gt=ct.verticalHasArrows,kt=ct.arrowSize,_t=ct.horizontalScrollbarSize,ft=ae.get(43),Dt=ae.get(109)!=="never";let Ft=ae.get(65);ft&&Dt&&(Ft+=16);let St=0;if(Tt){const mt=Math.max(rt,Mt);St=Math.round(mt*Et)}let qe=0;Pt&&(qe=Ye*ke.glyphMarginDecorationLaneCount);let Nt=0,Ut=Nt+qe,Le=Ut+St,Fe=Le+Ft;const Ce=He-qe-St-Ft;let ne=!1,Oe=!1,Ve=-1;bt==="inherit"&&$t?(ne=!0,Oe=!0):Bt==="on"||Bt==="bounded"?Oe=!0:Bt==="wordWrapColumn"&&(Ve=Ot);const Je=z._computeMinimapLayout({outerWidth:He,outerHeight:xe,lineHeight:Ye,typicalHalfwidthCharacterWidth:ot,pixelRatio:yt,scrollBeyondLastLine:Wt,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:zt,verticalScrollbarWidth:ut,viewLineCount:Qt,remainingWidth:Ce,isViewportWrapping:Oe},ke.memory||new T);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Nt+=Je.minimapWidth,Ut+=Je.minimapWidth,Le+=Je.minimapWidth,Fe+=Je.minimapWidth);const Ge=Ce-Je.minimapWidth,nt=Math.max(1,Math.floor((Ge-ut-2)/ot)),gt=Gt?kt:0;return Oe&&(Ve=Math.max(1,nt),Bt==="bounded"&&(Ve=Math.min(Ve,Ot))),{width:He,height:xe,glyphMarginLeft:Nt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:ke.glyphMarginDecorationLaneCount,lineNumbersLeft:Ut,lineNumbersWidth:St,decorationsLeft:Le,decorationsWidth:Ft,contentLeft:Fe,contentWidth:Ge,minimap:Je,viewportColumn:nt,isWordWrapMinified:ne,isViewportWrapping:Oe,wrappingColumn:Ve,verticalScrollbarWidth:ut,horizontalScrollbarHeight:_t,overviewRuler:{top:gt,width:ut,height:xe-2*gt,right:0}}}}e.EditorLayoutInfoComputer=z;class Q extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(ae){return n(ae,"simple",["simple","advanced"])}compute(ae,ke,He){return ke.get(2)===2?"advanced":He}}class ve extends k{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:v.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:u(ae.enabled,this.defaultValue.enabled)}}}class le extends k{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:v.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:v.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:v.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:v.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(ke.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(ke.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(ke.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends k{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:v.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(56,null),v.localize(57,null,h.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),v.localize(58,null,h.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),v.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:v.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:v.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:v.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return typeof ke.enabled=="boolean"&&(ke.enabled=ke.enabled?"on":"off"),{enabled:n(ke.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(ke.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),padding:u(ke.padding,this.defaultValue.padding)}}}class G extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):c.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,ke,He){return He<0?c.clampedInt(-He*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class B extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>d.clamp(ae,0,150),{markdownDescription:v.localize(63,null)})}compute(ae,ke,He){return ae.fontInfo.lineHeight}}class H extends k{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:v.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:v.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(66,null),v.localize(67,null),v.localize(68,null)],default:ae.size,description:v.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:v.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:v.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:v.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:v.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),autohide:u(ke.autohide,this.defaultValue.autohide),size:n(ke.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(ke.side,this.defaultValue.side,["right","left"]),showSlider:n(ke.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(ke.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ke.scale,1,1,3),maxColumn:c.clampedInt(ke.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(ce){return ce==="ctrlCmd"?h.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{top:c.clampedInt(ke.top,0,0,1e3),bottom:c.clampedInt(ke.bottom,0,0,1e3)}}}class ie extends k{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:v.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:v.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),cycle:u(ke.cycle,this.defaultValue.cycle)}}}class re extends _{constructor(){super(141)}compute(ae,ke,He){return ae.pixelRatio}}class ye extends k{constructor(){const ae={other:"on",comments:"off",strings:"off"},ke=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(79,null),v.localize(80,null),v.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ke,default:ae.strings,description:v.localize(82,null)},comments:{anyOf:ke,default:ae.comments,description:v.localize(83,null)},other:{anyOf:ke,default:ae.other,description:v.localize(84,null)}},default:ae,markdownDescription:v.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const yt=ae?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:ke,comments:He,strings:xe}=ae,Ye=["on","inline","off"];let rt,ot,Et;return typeof ke=="boolean"?rt=ke?"on":"off":rt=n(ke,this.defaultValue.other,Ye),typeof He=="boolean"?ot=He?"on":"off":ot=n(He,this.defaultValue.comments,Ye),typeof xe=="boolean"?Et=xe?"on":"off":Et=n(xe,this.defaultValue.strings,Ye),{other:rt,comments:ot,strings:Et}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(86,null),v.localize(87,null),v.localize(88,null),v.localize(89,null)],default:"on",description:v.localize(90,null)})}validate(ae){let ke=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(ke=4,He=ae):ae==="interval"?ke=3:ae==="relative"?ke=2:ae==="on"?ke=1:ke=0),{renderType:ke,renderFn:He}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class ue extends k{constructor(){const ae=[],ke={type:"number",description:v.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[ke,{type:["object"],properties:{column:ke,color:{type:"string",description:v.localize(92,null),format:"color-hex"}}}]},default:ae,description:v.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const ke=[];for(const He of ae)if(typeof He=="number")ke.push({column:c.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const xe=He;ke.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ke.sort((He,xe)=>He.column-xe.column),ke}return this.defaultValue}}class pe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Pe(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends k{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(94,null),v.localize(95,null),v.localize(96,null)],default:"auto",description:v.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(98,null),v.localize(99,null),v.localize(100,null)],default:"auto",description:v.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:v.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:v.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:v.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae,He=c.clampedInt(ke.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(ke.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ke.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(ke.vertical,this.defaultValue.vertical),horizontal:Pe(ke.horizontal,this.defaultValue.horizontal),useShadows:u(ke.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(ke.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(ke.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(ke.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(ke.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:c.clampedInt(ke.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(ke.verticalSliderSize,xe,0,1e3),scrollByPage:u(ke.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:v.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:v.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:v.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:v.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:v.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:v.localize(111,null)}})}applyUpdate(ae,ke){let He=!1;ke.allowedCharacters&&ae&&(F.equals(ae.allowedCharacters,ke.allowedCharacters)||(ae={...ae,allowedCharacters:ke.allowedCharacters},He=!0)),ke.allowedLocales&&ae&&(F.equals(ae.allowedLocales,ke.allowedLocales)||(ae={...ae,allowedLocales:ke.allowedLocales},He=!0));const xe=super.applyUpdate(ae,ke);return He?new b(xe.newValue,!0):xe}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{nonBasicASCII:he(ke.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(ke.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(ke.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(ke.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(ke.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,ke){if(typeof ae!="object"||!ae)return ke;const He={};for(const[xe,Ye]of Object.entries(ae))Ye===!0&&(He[xe]=!0);return He}}class te extends k{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:v.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[v.localize(113,null),v.localize(114,null)],description:v.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:v.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),mode:n(ke.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(ke.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(ke.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends k{constructor(){const ae={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:v.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:v.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(ke.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends k{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(119,null),v.localize(120,null),v.localize(121,null)],default:ae.bracketPairs,description:v.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(123,null),v.localize(124,null),v.localize(125,null)],default:ae.bracketPairsHorizontal,description:v.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:v.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:v.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:ae.highlightActiveIndentation,description:v.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{bracketPairs:he(ke.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(ke.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(ke.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(ke.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(ke.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ce,ae,ke){const He=ke.indexOf(ce);return He===-1?ae:ke[He]}class Se extends k{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(133,null),v.localize(134,null)],default:ae.insertMode,description:v.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:v.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:v.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:v.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(139,null),v.localize(140,null),v.localize(141,null),v.localize(142,null)],default:ae.selectionMode,markdownDescription:v.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:v.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:v.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:v.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:v.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:v.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{insertMode:n(ke.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(ke.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(ke.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(ke.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(ke.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(ke.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(ke.showIcons,this.defaultValue.showIcons),showStatusBar:u(ke.showStatusBar,this.defaultValue.showStatusBar),preview:u(ke.preview,this.defaultValue.preview),previewMode:n(ke.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(ke.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(ke.showMethods,this.defaultValue.showMethods),showFunctions:u(ke.showFunctions,this.defaultValue.showFunctions),showConstructors:u(ke.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(ke.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(ke.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(ke.showFields,this.defaultValue.showFields),showVariables:u(ke.showVariables,this.defaultValue.showVariables),showClasses:u(ke.showClasses,this.defaultValue.showClasses),showStructs:u(ke.showStructs,this.defaultValue.showStructs),showInterfaces:u(ke.showInterfaces,this.defaultValue.showInterfaces),showModules:u(ke.showModules,this.defaultValue.showModules),showProperties:u(ke.showProperties,this.defaultValue.showProperties),showEvents:u(ke.showEvents,this.defaultValue.showEvents),showOperators:u(ke.showOperators,this.defaultValue.showOperators),showUnits:u(ke.showUnits,this.defaultValue.showUnits),showValues:u(ke.showValues,this.defaultValue.showValues),showConstants:u(ke.showConstants,this.defaultValue.showConstants),showEnums:u(ke.showEnums,this.defaultValue.showEnums),showEnumMembers:u(ke.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(ke.showKeywords,this.defaultValue.showKeywords),showWords:u(ke.showWords,this.defaultValue.showWords),showColors:u(ke.showColors,this.defaultValue.showColors),showFiles:u(ke.showFiles,this.defaultValue.showFiles),showReferences:u(ke.showReferences,this.defaultValue.showReferences),showFolders:u(ke.showFolders,this.defaultValue.showFolders),showTypeParameters:u(ke.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(ke.showSnippets,this.defaultValue.showSnippets),showUsers:u(ke.showUsers,this.defaultValue.showUsers),showIssues:u(ke.showIssues,this.defaultValue.showIssues)}}}class Ue extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ze extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(183,null),v.localize(184,null),v.localize(185,null),v.localize(186,null)],description:v.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,ke,He){return ke.get(2)===2?0:He}}class Qe extends _{constructor(){super(144)}compute(ae,ke,He){const xe=ke.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class it extends k{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:v.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(190,null),v.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),showDropSelector:n(ke.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends k{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:v.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(194,null),v.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const ke=ae;return{enabled:u(ke.enabled,this.defaultValue.enabled),showPasteSelector:n(ke.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Te="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.isMacintosh?Me:h.isLinux?ze:Te,fontWeight:"normal",fontSize:h.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Xe;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(196,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(197,null),""],markdownDescription:v.localize(198,null)})),accessibilitySupport:Re(new l),accessibilityPageSize:Re(new c(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(199,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",v.localize(200,null))),ariaRequired:Re(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(202,null),v.localize(203,null),""],description:v.localize(204,null)})),autoClosingComments:Re(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(205,null),v.localize(206,null),""],description:v.localize(207,null)})),autoClosingDelete:Re(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(208,null),""],description:v.localize(209,null)})),autoClosingOvertype:Re(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(210,null),""],description:v.localize(211,null)})),autoClosingQuotes:Re(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(212,null),v.localize(213,null),""],description:v.localize(214,null)})),autoIndent:Re(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[v.localize(215,null),v.localize(216,null),v.localize(217,null),v.localize(218,null),v.localize(219,null)],description:v.localize(220,null)})),automaticLayout:Re(new r(13,"automaticLayout",!1)),autoSurround:Re(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),""],description:v.localize(224,null)})),bracketPairColorization:Re(new se),bracketPairGuides:Re(new Y),stickyTabStops:Re(new r(115,"stickyTabStops",!1,{description:v.localize(225,null)})),codeLens:Re(new r(17,"codeLens",!0,{description:v.localize(226,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:v.localize(227,null)})),codeLensFontSize:Re(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(228,null)})),colorDecorators:Re(new r(20,"colorDecorators",!0,{description:v.localize(229,null)})),colorDecoratorActivatedOn:Re(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(230,null),v.localize(231,null),v.localize(232,null)],description:v.localize(233,null)})),colorDecoratorsLimit:Re(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(234,null)})),columnSelection:Re(new r(22,"columnSelection",!1,{description:v.localize(235,null)})),comments:Re(new C),contextmenu:Re(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new r(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(236,null)})),cursorBlinking:Re(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:v.localize(237,null)})),cursorSmoothCaretAnimation:Re(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(238,null),v.localize(239,null),v.localize(240,null)],description:v.localize(241,null)})),cursorStyle:Re(new i(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:v.localize(242,null)})),cursorSurroundingLines:Re(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(243,null)})),cursorSurroundingLinesStyle:Re(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(244,null),v.localize(245,null)],markdownDescription:v.localize(246,null)})),cursorWidth:Re(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(247,null)})),disableLayerHinting:Re(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new r(34,"domReadOnly",!1)),dragAndDrop:Re(new r(35,"dragAndDrop",!0,{description:v.localize(248,null)})),emptySelectionClipboard:Re(new N),dropIntoEditor:Re(new it),stickyScroll:Re(new le),experimentalWhitespaceRendering:Re(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(249,null),v.localize(250,null),v.localize(251,null)],description:v.localize(252,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new d(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:v.localize(253,null)})),find:Re(new L),fixedOverflowWidgets:Re(new r(42,"fixedOverflowWidgets",!1)),folding:Re(new r(43,"folding",!0,{description:v.localize(254,null)})),foldingStrategy:Re(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(255,null),v.localize(256,null)],description:v.localize(257,null)})),foldingHighlight:Re(new r(45,"foldingHighlight",!0,{description:v.localize(258,null)})),foldingImportsByDefault:Re(new r(46,"foldingImportsByDefault",!1,{description:v.localize(259,null)})),foldingMaximumRegions:Re(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(260,null)})),unfoldOnClickAfterEndOfLine:Re(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(261,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(262,null)})),fontInfo:Re(new O),fontLigatures2:Re(new U),fontSize:Re(new j),fontWeight:Re(new V),fontVariations:Re(new x),formatOnPaste:Re(new r(55,"formatOnPaste",!1,{description:v.localize(263,null)})),formatOnType:Re(new r(56,"formatOnType",!1,{description:v.localize(264,null)})),glyphMargin:Re(new r(57,"glyphMargin",!0,{description:v.localize(265,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new r(59,"hideCursorInOverviewRuler",!1,{description:v.localize(266,null)})),hover:Re(new J),inDiffEditor:Re(new r(61,"inDiffEditor",!1)),letterSpacing:Re(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>d.clamp(ce,-5,20),{description:v.localize(267,null)})),lightbulb:Re(new ve),lineDecorationsWidth:Re(new G),lineHeight:Re(new B),lineNumbers:Re(new de),lineNumbersMinChars:Re(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new r(69,"linkedEditing",!1,{description:v.localize(268,null)})),links:Re(new r(70,"links",!0,{description:v.localize(269,null)})),matchBrackets:Re(new s(71,"matchBrackets","always",["always","near","never"],{description:v.localize(270,null)})),minimap:Re(new H),mouseStyle:Re(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new d(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:v.localize(271,null)})),mouseWheelZoom:Re(new r(75,"mouseWheelZoom",!1,{markdownDescription:v.localize(272,null)})),multiCursorMergeOverlapping:Re(new r(76,"multiCursorMergeOverlapping",!0,{description:v.localize(273,null)})),multiCursorModifier:Re(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[v.localize(274,null),v.localize(275,null)],markdownDescription:v.localize(276,null)})),multiCursorPaste:Re(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(277,null),v.localize(278,null)],markdownDescription:v.localize(279,null)})),multiCursorLimit:Re(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(280,null)})),occurrencesHighlight:Re(new r(80,"occurrencesHighlight",!0,{description:v.localize(281,null)})),overviewRulerBorder:Re(new r(81,"overviewRulerBorder",!0,{description:v.localize(282,null)})),overviewRulerLanes:Re(new c(82,"overviewRulerLanes",3,0,3)),padding:Re(new Z),pasteAs:Re(new et),parameterHints:Re(new ie),peekWidgetDefaultFocus:Re(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(283,null),v.localize(284,null)],description:v.localize(285,null)})),definitionLinkOpensInPeek:Re(new r(87,"definitionLinkOpensInPeek",!1,{description:v.localize(286,null)})),quickSuggestions:Re(new ye),quickSuggestionsDelay:Re(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(287,null)})),readOnly:Re(new r(90,"readOnly",!1)),readOnlyMessage:Re(new pe),renameOnType:Re(new r(92,"renameOnType",!1,{description:v.localize(288,null),markdownDeprecationMessage:v.localize(289,null)})),renderControlCharacters:Re(new r(93,"renderControlCharacters",!0,{description:v.localize(290,null),restricted:!0})),renderFinalNewline:Re(new s(94,"renderFinalNewline",h.isLinux?"dimmed":"on",["off","on","dimmed"],{description:v.localize(291,null)})),renderLineHighlight:Re(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(292,null)],description:v.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Re(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(294,null)})),renderValidationDecorations:Re(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(295,null),v.localize(296,null),v.localize(297,null),""],description:v.localize(298,null)})),revealHorizontalRightPadding:Re(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new r(100,"roundedSelection",!0,{description:v.localize(299,null)})),rulers:Re(new ue),scrollbar:Re(new $),scrollBeyondLastColumn:Re(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(300,null)})),scrollBeyondLastLine:Re(new r(104,"scrollBeyondLastLine",!0,{description:v.localize(301,null)})),scrollPredominantAxis:Re(new r(105,"scrollPredominantAxis",!0,{description:v.localize(302,null)})),selectionClipboard:Re(new r(106,"selectionClipboard",!0,{description:v.localize(303,null),included:h.isLinux})),selectionHighlight:Re(new r(107,"selectionHighlight",!0,{description:v.localize(304,null)})),selectOnLineNumbers:Re(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(305,null),v.localize(306,null),v.localize(307,null)],description:v.localize(308,null)})),showUnused:Re(new r(110,"showUnused",!0,{description:v.localize(309,null)})),showDeprecated:Re(new r(138,"showDeprecated",!0,{description:v.localize(310,null)})),inlayHints:Re(new we),snippetSuggestions:Re(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(311,null),v.localize(312,null),v.localize(313,null),v.localize(314,null)],description:v.localize(315,null)})),smartSelect:Re(new Ue),smoothScrolling:Re(new r(113,"smoothScrolling",!1,{description:v.localize(316,null)})),stopRenderingLineAfter:Re(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Se),inlineSuggest:Re(new te),inlineCompletionsAccessibilityVerbose:Re(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(317,null)})),suggestFontSize:Re(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new r(120,"suggestOnTriggerCharacters",!0,{description:v.localize(320,null)})),suggestSelection:Re(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null)],description:v.localize(324,null)})),tabCompletion:Re(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(325,null),v.localize(326,null),v.localize(327,null)],description:v.localize(328,null)})),tabIndex:Re(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new K),unusualLineTerminators:Re(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(329,null),v.localize(330,null),v.localize(331,null)],description:v.localize(332,null)})),useShadowDOM:Re(new r(126,"useShadowDOM",!0)),useTabStops:Re(new r(127,"useTabStops",!0,{description:v.localize(333,null)})),wordBreak:Re(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(334,null),v.localize(335,null)],description:v.localize(336,null)})),wordSeparators:Re(new t(129,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:v.localize(337,null)})),wordWrap:Re(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(338,null),v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(343,null)})),wordWrapOverride1:Re(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new M),defaultColorDecorators:Re(new r(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(344,null)})),pixelRatio:Re(new re),tabFocusMode:Re(new r(142,"tabFocusMode",!1,{markdownDescription:v.localize(345,null)})),layoutInfo:Re(new z),wrappingInfo:Re(new Qe),wrappingIndent:Re(new Ze),wrappingStrategy:Re(new Q)}}),define(De[187],Ie([10,11]),function(ge,e){return ge.create("vs/editor/common/languages",e)}),define(De[82],Ie([1,0,78,2,164,34,174,187]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(U,x,O){this.offset=U,this.type=x,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class E{constructor(U,x){this.tokens=U,this.endState=x,this._tokenizationResultBrand=void 0}}e.TokenizationResult=E;class T{constructor(U,x){this.tokens=U,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=T;var k;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var b;(function(L){const U=new Map;U.set(0,I.Codicon.symbolMethod),U.set(1,I.Codicon.symbolFunction),U.set(2,I.Codicon.symbolConstructor),U.set(3,I.Codicon.symbolField),U.set(4,I.Codicon.symbolVariable),U.set(5,I.Codicon.symbolClass),U.set(6,I.Codicon.symbolStruct),U.set(7,I.Codicon.symbolInterface),U.set(8,I.Codicon.symbolModule),U.set(9,I.Codicon.symbolProperty),U.set(10,I.Codicon.symbolEvent),U.set(11,I.Codicon.symbolOperator),U.set(12,I.Codicon.symbolUnit),U.set(13,I.Codicon.symbolValue),U.set(15,I.Codicon.symbolEnum),U.set(14,I.Codicon.symbolConstant),U.set(15,I.Codicon.symbolEnum),U.set(16,I.Codicon.symbolEnumMember),U.set(17,I.Codicon.symbolKeyword),U.set(27,I.Codicon.symbolSnippet),U.set(18,I.Codicon.symbolText),U.set(19,I.Codicon.symbolColor),U.set(20,I.Codicon.symbolFile),U.set(21,I.Codicon.symbolReference),U.set(22,I.Codicon.symbolCustomColor),U.set(23,I.Codicon.symbolFolder),U.set(24,I.Codicon.symbolTypeParameter),U.set(25,I.Codicon.account),U.set(26,I.Codicon.issues);function x(V){let fe=U.get(V);return fe||(console.info("No codicon found for CompletionItemKind "+V),fe=I.Codicon.symbolProperty),fe}L.toIcon=x;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function j(V,fe){let J=O.get(V);return typeof J>"u"&&!fe&&(J=9),J}L.fromString=j})(b||(e.CompletionItemKinds=b={}));var S;(function(L){L[L.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var _;(function(L){L[L.None=0]="None",L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(_||(e.CompletionItemInsertTextRule=_={}));var w;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var u;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class r{constructor(U,x,O,j){this.range=U,this.text=x,this.completionKind=O,this.isSnippetText=j}equals(U){return R.Range.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.SelectedSuggestionInfo=r;var o;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var c;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var g;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(g||(e.DocumentHighlightKind=g={}));function d(L){return L&&F.URI.isUri(L.uri)&&R.Range.isIRange(L.range)&&(R.Range.isIRange(L.originSelectionRange)||R.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=d;var t;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,v.localize)(0,null),[16]:(0,v.localize)(1,null),[4]:(0,v.localize)(2,null),[13]:(0,v.localize)(3,null),[8]:(0,v.localize)(4,null),[9]:(0,v.localize)(5,null),[21]:(0,v.localize)(6,null),[23]:(0,v.localize)(7,null),[7]:(0,v.localize)(8,null),[0]:(0,v.localize)(9,null),[11]:(0,v.localize)(10,null),[10]:(0,v.localize)(11,null),[19]:(0,v.localize)(12,null),[5]:(0,v.localize)(13,null),[1]:(0,v.localize)(14,null),[2]:(0,v.localize)(15,null),[20]:(0,v.localize)(16,null),[15]:(0,v.localize)(17,null),[18]:(0,v.localize)(18,null),[24]:(0,v.localize)(19,null),[3]:(0,v.localize)(20,null),[6]:(0,v.localize)(21,null),[14]:(0,v.localize)(22,null),[22]:(0,v.localize)(23,null),[25]:(0,v.localize)(24,null),[12]:(0,v.localize)(25,null)};function n(L,U){return(0,v.localize)(26,null,L,e.symbolKindNames[U])}e.getAriaLabelForSymbol=n;var s;(function(L){L[L.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var i;(function(L){const U=new Map;U.set(0,I.Codicon.symbolFile),U.set(1,I.Codicon.symbolModule),U.set(2,I.Codicon.symbolNamespace),U.set(3,I.Codicon.symbolPackage),U.set(4,I.Codicon.symbolClass),U.set(5,I.Codicon.symbolMethod),U.set(6,I.Codicon.symbolProperty),U.set(7,I.Codicon.symbolField),U.set(8,I.Codicon.symbolConstructor),U.set(9,I.Codicon.symbolEnum),U.set(10,I.Codicon.symbolInterface),U.set(11,I.Codicon.symbolFunction),U.set(12,I.Codicon.symbolVariable),U.set(13,I.Codicon.symbolConstant),U.set(14,I.Codicon.symbolString),U.set(15,I.Codicon.symbolNumber),U.set(16,I.Codicon.symbolBoolean),U.set(17,I.Codicon.symbolArray),U.set(18,I.Codicon.symbolObject),U.set(19,I.Codicon.symbolKey),U.set(20,I.Codicon.symbolNull),U.set(21,I.Codicon.symbolEnumMember),U.set(22,I.Codicon.symbolStruct),U.set(23,I.Codicon.symbolEvent),U.set(24,I.Codicon.symbolOperator),U.set(25,I.Codicon.symbolTypeParameter);function x(O){let j=U.get(O);return j||(console.info("No codicon found for SymbolKind "+O),j=I.Codicon.symbolProperty),j}L.toIcon=x})(i||(e.SymbolKinds=i={}));class a{static asEditOperation(U){return h.EditOperation.replace(R.Range.lift(U.range),U.text)}}e.TextEdit=a;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(U){switch(U){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(U)}constructor(U){this.value=U}}e.FoldingRangeKind=l;var C;(function(L){function U(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}L.is=U})(C||(e.Command=C={}));var D;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var p;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})(p||(e.CommentThreadState=p={}));var m;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var f;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(f||(e.CommentState=f={}));var P;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class M{constructor(U){this.createSupport=U,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=M,e.TokenizationRegistry=new A.TokenizationRegistry;var N;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[188],Ie([10,11]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ie([10,11]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ie([10,11]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ie([10,11]),function(ge,e){return ge.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ie([10,11]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ie([10,11]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ie([10,11]),function(ge,e){return ge.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ie([10,11]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(De[196],Ie([10,11]),function(ge,e){return ge.create("vs/platform/files/common/io",e)}),define(De[197],Ie([10,11]),function(ge,e){return ge.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ie([10,11]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(De[199],Ie([10,11]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ie([10,11]),function(ge,e){return ge.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ie([10,11]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(De[217],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(De[218],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ie([10,11]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ie([1,0,8,190]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var h;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(h||(e.TokenType=h={}));function R(...E){switch(E.length){case 1:return(0,F.localize)(0,null,E[0]);case 2:return(0,F.localize)(1,null,E[0],E[1]);case 3:return(0,F.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,F.localize)(3,null),v=(0,F.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(T){return this._input=T,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(R("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(R("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(T){return this._isAtEnd()||this._input.charCodeAt(this._current)!==T?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(T){this._tokens.push({type:T,offset:this._start})}_error(T){const k=this._start,b=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:b};this._errors.push({offset:k,lexeme:b,additionalInfo:T}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const T=this.stringRe.exec(this._input);if(T){this._current=this._start+T[0].length;const k=this._input.substring(this._start,this._current),b=y._keywords.get(k);b?this._addToken(b):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let T=this._current,k=!1,b=!1;for(;;){if(T>=this._input.length){this._current=T,this._error(v);return}const _=this._input.charCodeAt(T);if(k)k=!1;else if(_===47&&!b){T++;break}else _===91?b=!0:_===92?k=!0:_===93&&(b=!1);T++}for(;T<this._input.length&&y._regexFlags.has(this._input.charCodeAt(T));)T++;this._current=T;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(De[228],Ie([1,0,24,38,193,371]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function y(r){return r=r.trim(),r==="*"||A.test(r)}e.isValidVersionStr=y;function E(r){if(!y(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=r.match(A);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.parseVersion=E;function T(r){if(!r)return null;const o=r.majorBase,c=r.majorMustEqual,g=r.minorBase;let d=r.minorMustEqual;const t=r.patchBase;let n=r.patchMustEqual;r.hasCaret&&(o===0||(d=!1),n=!1);let s=0;if(r.preRelease){const i=v.exec(r.preRelease);if(i){const[,a,l,C]=i;s=Date.UTC(Number(a),Number(l)-1,Number(C))}}return{majorBase:o,majorMustEqual:c,minorBase:g,minorMustEqual:d,patchBase:t,patchMustEqual:n,isMinimum:r.hasGreaterEquals,notBefore:s}}e.normalizeVersion=T;function k(r,o,c){let g;typeof r=="string"?g=T(E(r)):g=r;let d;o instanceof Date?d=o.getTime():typeof o=="string"&&(d=new Date(o).getTime());let t;if(typeof c=="string"?t=T(E(c)):t=c,!g||!t)return!1;const n=g.majorBase,s=g.minorBase,i=g.patchBase;let a=t.majorBase,l=t.minorBase,C=t.patchBase;const D=t.notBefore;let p=t.majorMustEqual,m=t.minorMustEqual,f=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:s>l?!0:s<l||d&&d<D?!1:i>=C:(n===1&&a===0&&(!p||!m||!f)&&(a=1,l=0,C=0,p=!0,m=!1,f=!1),n<a?!1:n>a?!p:s<l?!1:s>l?!m:i<C?!1:i>C?!f:!(d&&d<D))}e.isValidVersion=k;function b(r,o,c,g,d){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([F.default.Error,h.localize(0,null)]),t;if(typeof g.name!="string")return t.push([F.default.Error,h.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([F.default.Error,h.localize(2,null,"version")]),t;if(!g.engines)return t.push([F.default.Error,h.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([F.default.Error,h.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!u(g.extensionDependencies))return t.push([F.default.Error,h.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!u(g.activationEvents))return t.push([F.default.Error,h.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([F.default.Error,h.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([F.default.Warning,h.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([F.default.Error,h.localize(9,null,"main")]),t;{const i=(0,I.joinPath)(c,g.main);(0,I.isEqualOrParent)(i,c)||t.push([F.default.Warning,h.localize(10,null,i.path,c.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([F.default.Error,h.localize(11,null,"browser")]),t;{const i=(0,I.joinPath)(c,g.browser);(0,I.isEqualOrParent)(i,c)||t.push([F.default.Warning,h.localize(12,null,i.path,c.path)])}}if(!R.valid(g.version))return t.push([F.default.Error,h.localize(13,null)]),t;const n=[];if(!S(r,o,g,d,n))for(const i of n)t.push([F.default.Error,i]);return t}e.validateExtensionManifest=b;function S(r,o,c,g,d){return g||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(r,o,c.engines.vscode,d)}e.isValidExtensionVersion=S;function _(r,o,c){return r==="*"||w(o,c,r)}e.isEngineValid=_;function w(r,o,c,g=[]){const d=T(E(c));if(!d)return g.push(h.localize(14,null,c)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return g.push(h.localize(15,null,c)),!1}else if(!d.majorMustEqual)return g.push(h.localize(16,null,c)),!1;return k(r,o,d)?!0:(g.push(h.localize(17,null,r,c)),!1)}function u(r){if(!Array.isArray(r))return!1;for(let o=0,c=r.length;o<c;o++)if(typeof r[o]!="string")return!1;return!0}}),define(De[102],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(h,R=[],A=!1){this.ctor=h,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(De[103],Ie([1,0,102]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const F=[];var h;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function R(v,y,E){y instanceof I.SyncDescriptor||(y=new I.SyncDescriptor(y,[],!!E)),F.push([v,y])}e.registerSingleton=R;function A(){return F}e.getSingletonServiceDescriptors=A}),define(De[229],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class F{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const A of this._nodes.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const v=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(A);v.outgoing.set(y.key,y),y.incoming.set(v.key,v)}removeNode(R){const A=this._hashFn(R);this._nodes.delete(A);for(const v of this._nodes.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(R){const A=this._hashFn(R);let v=this._nodes.get(A);return v||(v=new I(A,R),this._nodes.set(A,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[A,v]of this._nodes)R.push(`${A}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this._nodes){const v=new Set([R]),y=this._findCycle(A,v);if(y)return y}}_findCycle(R,A){for(const[v,y]of R.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const E=this._findCycle(y,A);if(E)return E;A.delete(v)}}}e.Graph=F}),define(De[5],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function v(y){return y[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=v})(I||(e._util=I={})),e.IInstantiationService=h("instantiationService");function F(A,v,y){v[I.DI_TARGET]===v?v[I.DI_DEPENDENCIES].push({id:A,index:y}):(v[I.DI_DEPENDENCIES]=[{id:A,index:y}],v[I.DI_TARGET]=v)}function h(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const v=function(y,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(v,y,T)};return v.toString=()=>A,I.serviceIds.set(A,v),v}e.createDecorator=h;function R(A){return A}e.refineServiceDecorator=R}),define(De[49],Ie([1,0,18,2,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,h.createDecorator)("configurationService");function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof F.URI)}e.isConfigurationOverrides=R;function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=A;var v;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function y(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function E(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.isConfigured=E;function T(r,o){const c=Object.create(null);for(const g in r)k(c,g,r[g],o);return c}e.toValuesTree=T;function k(r,o,c,g){const d=o.split("."),t=d.pop();let n=r;for(let s=0;s<d.length;s++){const i=d[s];let a=n[i];switch(typeof a){case"undefined":a=n[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${o} as ${d.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=c}catch{g(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=k;function b(r,o){const c=o.split(".");S(r,c)}e.removeFromValueTree=b;function S(r,o){const c=o.shift();if(o.length===0){delete r[c];return}if(Object.keys(r).indexOf(c)!==-1){const g=r[c];typeof g=="object"&&!Array.isArray(g)&&(S(g,o),Object.keys(g).length===0&&delete r[c])}}function _(r,o,c){function g(n,s){let i=n;for(const a of s){if(typeof i!="object"||i===null)return;i=i[a]}return i}const d=o.split("."),t=g(r,d);return typeof t>"u"?c:t}e.getConfigurationValue=_;function w(r,o,c){Object.keys(o).forEach(g=>{g!=="__proto__"&&(g in r?I.isObject(r[g])&&I.isObject(o[g])?w(r[g],o[g],c):c&&(r[g]=o[g]):r[g]=o[g])})}e.merge=w;function u(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(De[41],Ie([1,0,12,15,227,5,189,8]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",I.isMacintosh),y.set("isLinux",I.isLinux),y.set("isWindows",I.isWindows),y.set("isWeb",I.isWeb),y.set("isMacNative",I.isMacintosh&&!I.isWeb),y.set("isEdge",I.isEdge),y.set("isFirefox",I.isFirefox),y.set("isChrome",I.isChrome),y.set("isSafari",I.isSafari);function E(G,B){if(y.get(G)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(G,B)}e.setConstant=E;const T=Object.prototype.hasOwnProperty;var k;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const b={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),_=(0,A.localize)(1,null),w=(0,A.localize)(2,null),u=(0,A.localize)(3,null),r=(0,A.localize)(4,null),o=(0,A.localize)(5,null),c=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class d{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(B=b){this._config=B,this._scanner=new h.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(B){if(B===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:_});return}this._tokens=this._scanner.reset(B).scan(),this._current=0,this._parsingErrors=[];try{const H=this._expr();if(!this._isAtEnd()){const me=this._peek(),Z=me.type===17?o:void 0;throw this._parsingErrors.push({message:r,offset:me.offset,lexeme:h.Scanner.getLexeme(me),additionalInfo:Z}),d._parseError}return H}catch(H){if(H!==d._parseError)throw H;return}}_expr(){return this._or()}_or(){const B=[this._and()];for(;this._matchOne(16);){const H=this._and();B.push(H)}return B.length===1?B[0]:t.or(...B)}_and(){const B=[this._term()];for(;this._matchOne(15);){const H=this._term();B.push(H)}return B.length===1?B[0]:t.and(...B)}_term(){if(this._matchOne(2)){const B=this._peek();switch(B.type){case 11:return this._advance(),a.INSTANCE;case 12:return this._advance(),l.INSTANCE;case 0:{this._advance();const H=this._expr();return this._consume(1,u),H?.negate()}case 17:return this._advance(),P.create(B.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",B)}}return this._primary()}_primary(){const B=this._peek();switch(B.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const H=this._expr();return this._consume(1,u),H}case 17:{const H=B.lexeme;if(this._advance(),this._matchOne(9)){const Z=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Z.type!==10)throw this._errExpectedButGot("REGEX",Z);const ie=Z.lexeme,re=ie.lastIndexOf("/"),ye=re===ie.length-1?void 0:this._removeFlagsGY(ie.substring(re+1));let oe;try{oe=new RegExp(ie.substring(1,re),ye)}catch{throw this._errExpectedButGot("REGEX",Z)}return O.create(H,oe)}switch(Z.type){case 10:case 19:{const ie=[Z.lexeme];this._advance();let re=this._peek(),ye=0;for(let pe=0;pe<Z.lexeme.length;pe++)Z.lexeme.charCodeAt(pe)===40?ye++:Z.lexeme.charCodeAt(pe)===41&&ye--;for(;!this._isAtEnd()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let pe=0;pe<re.lexeme.length;pe++)re.lexeme.charCodeAt(pe)===40?ye++:Z.lexeme.charCodeAt(pe)===41&&ye--}if(ye<0)break;ie.push(h.Scanner.getLexeme(re)),this._advance(),re=this._peek()}const oe=ie.join(""),de=oe.lastIndexOf("/"),ee=de===oe.length-1?void 0:this._removeFlagsGY(oe.substring(de+1));let ue;try{ue=new RegExp(oe.substring(1,de),ee)}catch{throw this._errExpectedButGot("REGEX",Z)}return t.regex(H,ue)}case 18:{const ie=Z.lexeme;this._advance();let re=null;if(!(0,F.isFalsyOrWhitespace)(ie)){const ye=ie.indexOf("/"),oe=ie.lastIndexOf("/");if(ye!==oe&&ye>=0){const de=ie.slice(ye+1,oe),ee=ie[oe+1]==="i"?"i":"";try{re=new RegExp(de,ee)}catch{throw this._errExpectedButGot("REGEX",Z)}}}if(re===null)throw this._errExpectedButGot("REGEX",Z);return O.create(H,re)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const Z=this._value();return t.notIn(H,Z)}switch(this._peek().type){case 3:{this._advance();const Z=this._value();if(this._previous().type===18)return t.equals(H,Z);switch(Z){case"true":return t.has(H);case"false":return t.not(H);default:return t.equals(H,Z)}}case 4:{this._advance();const Z=this._value();if(this._previous().type===18)return t.notEquals(H,Z);switch(Z){case"true":return t.not(H);case"false":return t.has(H);default:return t.notEquals(H,Z)}}case 5:return this._advance(),U.create(H,this._value());case 6:return this._advance(),x.create(H,this._value());case 7:return this._advance(),N.create(H,this._value());case 8:return this._advance(),L.create(H,this._value());case 13:return this._advance(),t.in(H,this._value());default:return t.has(H)}}case 20:throw this._parsingErrors.push({message:c,offset:B.offset,lexeme:"",additionalInfo:g}),d._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const B=this._peek();switch(B.type){case 17:case 18:return this._advance(),B.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(B){return B.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(B){return this._check(B)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(B,H){if(this._check(B))return this._advance();throw this._errExpectedButGot(H,this._peek())}_errExpectedButGot(B,H,me){const Z=(0,A.localize)(8,null,B,h.Scanner.getLexeme(H)),ie=H.offset,re=h.Scanner.getLexeme(H);return this._parsingErrors.push({message:Z,offset:ie,lexeme:re,additionalInfo:me}),d._parseError}_check(B){return this._peek().type===B}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=d;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(B){return C.create(B)}static equals(B,H){return D.create(B,H)}static notEquals(B,H){return f.create(B,H)}static regex(B,H){return O.create(B,H)}static in(B,H){return p.create(B,H)}static notIn(B,H){return m.create(B,H)}static not(B){return P.create(B)}static and(...B){return fe.create(B,null,!0)}static or(...B){return J.create(B,null,!0)}static greater(B,H){return N.create(B,H)}static greaterEquals(B,H){return L.create(B,H)}static smaller(B,H){return U.create(B,H)}static smallerEquals(B,H){return x.create(B,H)}static{this._parser=new d({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this._parser.parse(B)}}e.ContextKeyExpr=t;function n(G){const B=new d({regexParsingWithErrorRecovery:!1});return G.map(H=>(B.parse(H),B.lexingErrors.length>0?B.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,A.localize)(9,null,me.additionalInfo):(0,A.localize)(10,null),offset:me.offset,length:me.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=n;function s(G,B){const H=G?G.substituteConstants():void 0,me=B?B.substituteConstants():void 0;return!H&&!me?!0:!H||!me?!1:H.equals(me)}e.expressionsAreEqualWithConstantSubstitution=s;function i(G,B){return G.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=a;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=l;class C{static create(B,H=null){const me=y.get(B);return typeof me=="boolean"?me?l.INSTANCE:a.INSTANCE:new C(B,H)}constructor(B,H){this.key=B,this.negated=H,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:z(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=y.get(this.key);return typeof B=="boolean"?B?l.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class D{static create(B,H,me=null){if(typeof H=="boolean")return H?C.create(B,me):P.create(B,me);const Z=y.get(B);return typeof Z=="boolean"?H===(Z?"true":"false")?l.INSTANCE:a.INSTANCE:new D(B,H,me)}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=y.get(this.key);if(typeof B=="boolean"){const H=B?"true":"false";return this.value===H?l.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(B){return B.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class p{static create(B,H){return new p(B,H)}constructor(B,H){this.key=B,this.valueKey=H,this.type=10,this.negated=null}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.valueKey,B.key,B.valueKey)}equals(B){return B.type===this.type?this.key===B.key&&this.valueKey===B.valueKey:!1}substituteConstants(){return this}evaluate(B){const H=B.getValue(this.valueKey),me=B.getValue(this.key);return Array.isArray(H)?H.includes(me):typeof me=="string"&&typeof H=="object"&&H!==null?T.call(H,me):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(B){return B.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class m{static create(B,H){return new m(B,H)}constructor(B,H){this.key=B,this.valueKey=H,this.type=11,this._negated=p.create(B,H)}cmp(B){return B.type!==this.type?this.type-B.type:this._negated.cmp(B._negated)}equals(B){return B.type===this.type?this._negated.equals(B._negated):!1}substituteConstants(){return this}evaluate(B){return!this._negated.evaluate(B)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(B){return B.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=m;class f{static create(B,H,me=null){if(typeof H=="boolean")return H?P.create(B,me):C.create(B,me);const Z=y.get(B);return typeof Z=="boolean"?H===(Z?"true":"false")?a.INSTANCE:l.INSTANCE:new f(B,H,me)}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=y.get(this.key);if(typeof B=="boolean"){const H=B?"true":"false";return this.value===H?a.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(B){return B.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class P{static create(B,H=null){const me=y.get(B);return typeof me=="boolean"?me?a.INSTANCE:l.INSTANCE:new P(B,H)}constructor(B,H){this.key=B,this.negated=H,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:z(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=y.get(this.key);return typeof B=="boolean"?B?a.INSTANCE:l.INSTANCE:this}evaluate(B){return!B.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(B){return B.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function M(G,B){if(typeof G=="string"){const H=parseFloat(G);isNaN(H)||(G=H)}return typeof G=="string"||typeof G=="number"?B(G):a.INSTANCE}class N{static create(B,H,me=null){return M(H,Z=>new N(B,Z,me))}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class L{static create(B,H,me=null){return M(H,Z=>new L(B,Z,me))}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=L;class U{static create(B,H,me=null){return M(H,Z=>new U(B,Z,me))}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class x{static create(B,H,me=null){return M(H,Z=>new x(B,Z,me))}constructor(B,H,me){this.key=B,this.value=H,this.negated=me,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=x;class O{static create(B,H){return new O(B,H)}constructor(B,H){this.key=B,this.regexp=H,this.type=7,this.negated=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.key<B.key)return-1;if(this.key>B.key)return 1;const H=this.regexp?this.regexp.source:"",me=B.regexp?B.regexp.source:"";return H<me?-1:H>me?1:0}equals(B){if(B.type===this.type){const H=this.regexp?this.regexp.source:"",me=B.regexp?B.regexp.source:"";return this.key===B.key&&H===me}return!1}substituteConstants(){return this}evaluate(B){const H=B.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const B=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${B}`}keys(){return[this.key]}map(B){return B.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=j.create(this)),this.negated}}e.ContextKeyRegexExpr=O;class j{static create(B){return new j(B)}constructor(B){this._actual=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this._actual.cmp(B._actual)}equals(B){return B.type===this.type?this._actual.equals(B._actual):!1}substituteConstants(){return this}evaluate(B){return!this._actual.evaluate(B)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(B){return new j(this._actual.map(B))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=j;function V(G){let B=null;for(let H=0,me=G.length;H<me;H++){const Z=G[H].substituteConstants();if(G[H]!==Z&&B===null){B=[];for(let ie=0;ie<H;ie++)B[ie]=G[ie]}B!==null&&(B[H]=Z)}return B===null?G:B}class fe{static create(B,H,me){return fe._normalizeArr(B,H,me)}constructor(B,H){this.expr=B,this.negated=H,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let H=0,me=this.expr.length;H<me;H++){const Z=i(this.expr[H],B.expr[H]);if(Z!==0)return Z}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let H=0,me=this.expr.length;H<me;H++)if(!this.expr[H].equals(B.expr[H]))return!1;return!0}return!1}substituteConstants(){const B=V(this.expr);return B===this.expr?this:fe.create(B,this.negated,!1)}evaluate(B){for(let H=0,me=this.expr.length;H<me;H++)if(!this.expr[H].evaluate(B))return!1;return!0}static _normalizeArr(B,H,me){const Z=[];let ie=!1;for(const re of B)if(re){if(re.type===1){ie=!0;continue}if(re.type===0)return a.INSTANCE;if(re.type===6){Z.push(...re.expr);continue}Z.push(re)}if(Z.length===0&&ie)return l.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(i);for(let re=1;re<Z.length;re++)Z[re-1].equals(Z[re])&&(Z.splice(re,1),re--);if(Z.length===1)return Z[0];for(;Z.length>1;){const re=Z[Z.length-1];if(re.type!==9)break;Z.pop();const ye=Z.pop(),oe=Z.length===0,de=J.create(re.expr.map(ee=>fe.create([ee,ye],null,me)),null,oe);de&&(Z.push(de),Z.sort(i))}if(Z.length===1)return Z[0];if(me){for(let re=0;re<Z.length;re++)for(let ye=re+1;ye<Z.length;ye++)if(Z[re].negate().equals(Z[ye]))return a.INSTANCE;if(Z.length===1)return Z[0]}return new fe(Z,H)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const H of this.expr)B.push(...H.keys());return B}map(B){return new fe(this.expr.map(H=>H.map(B)),null)}negate(){if(!this.negated){const B=[];for(const H of this.expr)B.push(H.negate());this.negated=J.create(B,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class J{static create(B,H,me){return J._normalizeArr(B,H,me)}constructor(B,H){this.expr=B,this.negated=H,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let H=0,me=this.expr.length;H<me;H++){const Z=i(this.expr[H],B.expr[H]);if(Z!==0)return Z}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let H=0,me=this.expr.length;H<me;H++)if(!this.expr[H].equals(B.expr[H]))return!1;return!0}return!1}substituteConstants(){const B=V(this.expr);return B===this.expr?this:J.create(B,this.negated,!1)}evaluate(B){for(let H=0,me=this.expr.length;H<me;H++)if(this.expr[H].evaluate(B))return!0;return!1}static _normalizeArr(B,H,me){let Z=[],ie=!1;if(B){for(let re=0,ye=B.length;re<ye;re++){const oe=B[re];if(oe){if(oe.type===0){ie=!0;continue}if(oe.type===1)return l.INSTANCE;if(oe.type===9){Z=Z.concat(oe.expr);continue}Z.push(oe)}}if(Z.length===0&&ie)return a.INSTANCE;Z.sort(i)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let re=1;re<Z.length;re++)Z[re-1].equals(Z[re])&&(Z.splice(re,1),re--);if(Z.length===1)return Z[0];if(me){for(let re=0;re<Z.length;re++)for(let ye=re+1;ye<Z.length;ye++)if(Z[re].negate().equals(Z[ye]))return l.INSTANCE;if(Z.length===1)return Z[0]}return new J(Z,H)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const H of this.expr)B.push(...H.keys());return B}map(B){return new J(this.expr.map(H=>H.map(B)),null)}negate(){if(!this.negated){const B=[];for(const H of this.expr)B.push(H.negate());for(;B.length>1;){const H=B.shift(),me=B.shift(),Z=[];for(const ie of we(H))for(const re of we(me))Z.push(fe.create([ie,re],null,!1));B.unshift(J.create(Z,null,!1))}this.negated=J.create(B,this,!0)}return this.negated}}e.ContextKeyOrExpr=J;class X extends C{static{this._info=[]}static all(){return X._info.values()}constructor(B,H,me){super(B,null),this._defaultValue=H,typeof me=="object"?X._info.push({...me,key:B}):me!==!0&&X._info.push({key:B,description:me,type:H!=null?typeof H:void 0})}bindTo(B){return B.createKey(this.key,this._defaultValue)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return f.create(this.key,B)}}e.RawContextKey=X,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function z(G,B){return G<B?-1:G>B?1:0}function Q(G,B,H,me){return G<H?-1:G>H?1:B<me?-1:B>me?1:0}function ve(G,B){if(G.type===0||B.type===1)return!0;if(G.type===9)return B.type===9?le(G.expr,B.expr):!1;if(B.type===9){for(const H of B.expr)if(ve(G,H))return!0;return!1}if(G.type===6){if(B.type===6)return le(B.expr,G.expr);for(const H of G.expr)if(ve(H,B))return!0;return!1}return G.equals(B)}e.implies=ve;function le(G,B){let H=0,me=0;for(;H<G.length&&me<B.length;){const Z=G[H].cmp(B[me]);if(Z<0)return!1;Z===0&&H++,me++}return H===G.length}function we(G){return G.type===9?G.expr:[G]}}),define(De[230],Ie([1,0,24,38,191,5,99,12,23]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var E;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(E||(E={}));class T{getConfirmationButtons(u){return this.getButtons(u,E.Confirmation)}getPromptButtons(u){return this.getButtons(u,E.Prompt)}getInputButtons(u){return this.getButtons(u,E.Input)}getButtons(u,r){const o=[];switch(r){case E.Confirmation:{const c=u;c.primaryButton?o.push(c.primaryButton):o.push((0,h.localize)(0,null)),c.cancelButton?o.push(c.cancelButton):o.push((0,h.localize)(1,null));break}case E.Prompt:{const c=u;Array.isArray(c.buttons)&&c.buttons.length>0&&o.push(...c.buttons.map(g=>g.label)),c.cancelButton&&(c.cancelButton===!0?o.push((0,h.localize)(2,null)):typeof c.cancelButton=="string"?o.push(c.cancelButton):c.cancelButton.label?o.push(c.cancelButton.label):o.push((0,h.localize)(3,null))),o.length===0&&o.push((0,h.localize)(4,null));break}case E.Input:{const c=u;c.primaryButton?o.push(c.primaryButton):o.push((0,h.localize)(5,null)),c.cancelButton?o.push(c.cancelButton):o.push((0,h.localize)(6,null));break}}return o}getDialogType(u){if(typeof u=="string")return u;if(typeof u=="number")return u===F.default.Info?"info":u===F.default.Error?"error":u===F.default.Warning?"warning":"none"}getPromptResult(u,r,o){const c=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&c.push(u.cancelButton);let g=c[r]?.run({checkboxChecked:o});return g instanceof Promise||(g=Promise.resolve(g)),{result:g,checkboxChecked:o}}}e.AbstractDialogHandler=T,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var k;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(k||(e.ConfirmResult=k={}));const b=10;function S(w){const u=[];return u.push(...w.slice(0,b).map(r=>typeof r=="string"?r:(0,I.basename)(r))),w.length>b&&(w.length-b===1?u.push((0,h.localize)(7,null)):u.push((0,h.localize)(8,null,w.length-b))),u.push(""),u.join(`
`)}e.getFileNamesMessage=S;function _(w,u){const r=(0,y.deepClone)(w);let o=(r.buttons??[]).map(t=>(0,A.mnemonicButtonLabel)(t)),c=(w.buttons||[]).map((t,n)=>n),g=0,d=r.cancelId??o.length-1;if(o.length>1){const t=typeof d=="number"?o[d]:void 0;if(v.isLinux||v.isMacintosh){if(typeof t=="string"&&o.length>1&&d!==1){o.splice(d,1),o.splice(1,0,t);const n=c[d];c.splice(d,1),c.splice(1,0,n),d=1}v.isLinux&&o.length>1&&(o=o.reverse(),c=c.reverse(),g=o.length-1,typeof t=="string"&&(d=g-1))}else if(v.isWindows&&typeof t=="string"&&o.length>1&&d!==o.length-1){o.splice(d,1),o.push(t);const n=c[d];c.splice(d,1),c.push(n),d=o.length-1}}return r.buttons=o,r.defaultId=g,r.cancelId=d,r.noLink=!0,r.title=r.title||u.nameLong,{options:r,buttonIndeces:c}}e.massageMessageBoxOptions=_}),define(De[131],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(De[132],Ie([1,0,192,5]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function h(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=h;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function v(o,c){return c==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=v;function y(o,c,g){return v(c,g)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===g?!0:E(g).includes(o)}e.isTargetPlatformCompatible=y;function E(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function T(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=T;var k;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var b;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var S;(function(o){o.Install="install",o.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var _;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(_||(e.InstallOperation=_={})),e.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var u;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class r extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(De[231],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(De[232],Ie([1,0,48,17,16,12,98,29,101,194,231]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=E.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends b{static{this.CMD="cmd.exe"}openTerminal(g,d){return this.spawnTerminal(I,g,y.getWindowsShell(),d)}spawnTerminal(g,d,t,n){const s=d.windowsExec||S.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=h.basename(s,".exe").toLowerCase();if(i==="cmder")return g.spawn(s,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),i==="wt"&&a.push("-d ."),new Promise((l,C)=>{const D=u(process),p=g.spawn(t,a,{cwd:n,env:D});p.on("error",C),p.on("exit",()=>l())})}runInTerminal(g,d,t,n,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((a,l)=>{const C=`"${d} - ${k}"`,D=`""${t.join('" "')}" & pause"`,p=Object.assign({},u(process),n);Object.keys(p).filter(N=>p[N]===null).forEach(N=>delete p[N]);const m={cwd:d,env:p,windowsVerbatimArguments:!0};let f,P;h.basename(i,".exe")==="wt"?(f=i,P=["-d",".",S.CMD,"/c",D]):(f=S.CMD,P=["/c","start",C,"/wait",i,"/c",D]),I.spawn(f,P,m).on("error",N=>{l(r(N))}),a(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S;class _ extends b{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(g,d){return this.spawnTerminal(I,g,d)}runInTerminal(g,d,t,n,s){const i=s.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((a,l)=>{if(i===T.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const C=i===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",g||k,"-w",d];for(const P of t)p.push("-a"),p.push(P);if(n){const P=Object.assign({},u(process),n);for(const M in P){const N=P[M];N===null?(p.push("-u"),p.push(M)):(p.push("-e"),p.push(`${M}=${N}`))}}let m="";const f=I.spawn(_.OSASCRIPT,p);f.on("error",P=>{l(r(P))}),f.stderr.on("data",P=>{m+=P.toString()}),f.on("exit",P=>{if(P===0)a(void 0);else if(m){const M=m.split(`
`,1);l(new Error(M[0]))}else l(new Error(E.localize(1,null,C,P)))})}else l(new Error(E.localize(2,null,i)))})}spawnTerminal(g,d,t){const n=d.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const a=["-a",n];t&&a.push(t);const l=u(process),C=g.spawn("/usr/bin/open",a,{cwd:t,env:l});C.on("error",i),C.on("exit",()=>s())})}}e.MacExternalTerminalService=_;class w extends b{static{this.WAIT_MESSAGE=E.localize(3,null)}openTerminal(g,d){return this.spawnTerminal(I,g,d)}runInTerminal(g,d,t,n,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((a,l)=>{const C=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const p=`${o(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;C.push(`''${p}''`);const m=Object.assign({},u(process),n);Object.keys(m).filter(N=>m[N]===null).forEach(N=>delete m[N]);const f={cwd:d,env:m};let P="";const M=I.spawn(D,C,f);M.on("error",N=>{l(r(N))}),M.stderr.on("data",N=>{P+=N.toString()}),M.on("exit",N=>{if(N===0)a(void 0);else if(P){const L=P.split(`
`,1);l(new Error(L[0]))}else l(new Error(E.localize(4,null,D,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await v.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(d=>{g?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,d,t){const n=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{n.then(a=>{const l=u(process),C=g.spawn(a,[],{cwd:t,env:l});C.on("error",i),C.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=w;function u(c){const g={...c.env};return(0,A.sanitizeProcessEnvironment)(g),g}function r(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(E.localize(5,null,c.path)):c}function o(c){let g="";for(const d of c)d.indexOf(" ")>=0?g+='"'+d+'"':g+=d,g+=" ";return g}}),define(De[30],Ie([1,0,77,16,15,18,2,195,5,12,17]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var b;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var S;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var _;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(_||(e.FileSystemProviderCapabilities=_={}));function w(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=w;function u(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=u;function r(z){return!!(z.capabilities&131072)}e.hasFileCloneCapability=r;function o(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function c(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=c;function g(z){return w(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;function d(z){return w(z)?!!(z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=d;function t(z){return!!(z.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function n(z){return!!(z.capabilities&2048)}e.hasReadonlyCapability=n;var s;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(Q,ve){const le=new i(Q.toString(),ve);return C(le,ve),le}constructor(Q,ve){super(Q),this.code=ve}}e.FileSystemProviderError=i;function a(z,Q){return i.create(z,Q)}e.createFileSystemProviderError=a;function l(z){return z||a((0,v.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=l;function C(z,Q){return z.name=Q?`${Q} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=C;function D(z){if(!z)return s.Unknown;if(z instanceof i)return z.code;const Q=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!Q)return s.Unknown;switch(Q[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=D;function p(z){if(z instanceof L)return z.fileOperationResult;switch(D(z)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=p;var m;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(m||(e.FileOperation=m={}));class f{constructor(Q,ve,le){this.resource=Q,this.operation=ve,this.target=le}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=f;var P;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class M{constructor(Q,ve){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const le=new Map;for(const we of Q){const G=le.get(we.type);switch(G?G.push([we.resource,we]):le.set(we.type,[[we.resource,we]]),we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}}for(const[we,G]of le)switch(we){case 1:this.added=I.TernarySearchTree.forUris(()=>ve),this.added.fill(G);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>ve),this.updated.fill(G);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>ve),this.deleted.fill(G);break}}contains(Q,...ve){return this.doContains(Q,{includeChildren:!1},...ve)}affects(Q,...ve){return this.doContains(Q,{includeChildren:!0},...ve)}doContains(Q,ve,...le){if(!Q)return!1;const we=le.length>0;return!!((!we||le.includes(1))&&(this.added?.get(Q)||ve.includeChildren&&this.added?.findSuperstr(Q))||(!we||le.includes(0))&&(this.updated?.get(Q)||ve.includeChildren&&this.updated?.findSuperstr(Q))||(!we||le.includes(2))&&(this.deleted?.findSubstr(Q)||ve.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function N(z,Q,ve){return!z||!Q||z===Q||Q.length>z.length?!1:(Q.charAt(Q.length-1)!==F.sep&&(Q+=F.sep),ve?(0,h.startsWithIgnoreCase)(z,Q):z.indexOf(Q)===0)}e.isParent=N;class L extends Error{constructor(Q,ve,le){super(Q),this.fileOperationResult=ve,this.options=le}}e.FileOperationError=L;class U extends L{constructor(Q,ve,le,we){super(Q,ve,we),this.fileOperationResult=ve,this.size=le}}e.TooLargeFileOperationError=U;class x extends L{constructor(Q,ve,le){super(Q,2,le),this.stat=ve}}e.NotModifiedSinceFileOperationError=x;var O;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var j;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(j||(e.FileKind=j={})),e.ETAG_DISABLED="";function V(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=V;async function fe(z,Q){if(!Q.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(ve=>{const le=Q.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===z.scheme&&we.added&&(le.dispose(),ve())})})}e.whenProviderRegistered=fe;class J{static{this.KB=1024}static{this.MB=J.KB*J.KB}static{this.GB=J.MB*J.KB}static{this.TB=J.GB*J.KB}static formatSize(Q){return(0,R.isNumber)(Q)||(Q=0),Q<J.KB?(0,v.localize)(1,null,Q.toFixed(0)):Q<J.MB?(0,v.localize)(2,null,(Q/J.KB).toFixed(2)):Q<J.GB?(0,v.localize)(3,null,(Q/J.MB).toFixed(2)):Q<J.TB?(0,v.localize)(4,null,(Q/J.GB).toFixed(2)):(0,v.localize)(5,null,(Q/J.TB).toFixed(2))}}e.ByteSize=J;function X(z){const Q=typeof z=="string"||z?.scheme===T.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===T.Schemas.file?1024*J.MB:Q?10*J.MB:E.isWeb?50*J.MB:1024*J.MB}e.getLargeFileConfirmationLimit=X}),define(De[233],Ie([1,0,22,8,196,30]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(T,k,b,S,_,w){let u;try{await v(T,k,b,S,_,w)}catch(r){u=r}finally{u&&_.errorTransformer&&(u=_.errorTransformer(u)),typeof u<"u"&&b.error(u),b.end()}}e.readFileIntoStream=A;async function v(T,k,b,S,_,w){y(w);const u=await T.open(k,{create:!1});try{y(w);let r=0,o=0,c=_&&typeof _.length=="number"?_.length:void 0,g=I.VSBuffer.alloc(Math.min(_.bufferSize,typeof c=="number"?c:_.bufferSize)),d=_&&typeof _.position=="number"?_.position:0,t=0;do o=await T.read(u,d,g.buffer,t,g.byteLength-t),d+=o,t+=o,r+=o,typeof c=="number"&&(c-=o),t===g.byteLength&&(await b.write(S(g)),g=I.VSBuffer.alloc(Math.min(_.bufferSize,typeof c=="number"?c:_.bufferSize)),t=0);while(o>0&&(typeof c!="number"||c>0)&&y(w)&&E(r,_));if(t>0){let n=t;typeof c=="number"&&(n=Math.min(t,c)),b.write(S(g.slice(0,n)))}}catch(r){throw(0,R.ensureFileSystemProviderError)(r)}finally{await T.close(u)}}function y(T){if(T.isCancellationRequested)throw(0,F.canceled)();return!0}function E(T,k){if(typeof k?.limits?.size=="number"&&T>k.limits.size)throw(0,R.createFileSystemProviderError)((0,h.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ie([1,0,35,3,16,12,2,30]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(r){return r.recursive===!0}e.isRecursiveWatchRequest=y;class E extends F.Disposable{static{this.MAX_RESTARTS=5}constructor(o,c,g,d){super(),this.onFileChanges=o,this.onLogMessage=c,this.verboseLogging=g,this.options=d,this.watcherDisposables=this._register(new F.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const o=new F.DisposableStore;this.watcherDisposables.value=o,this.watcher=this.createWatcher(o),this.watcher.setVerboseLogging(this.verboseLogging),o.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),o.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),o.add(this.watcher.onDidError(c=>this.onError(c)))}onError(o){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${o}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${o}`):this.error(o)}restart(o){this.restartCounter++,this.init(),this.watch(o)}async watch(o){this.requests=o,await this.watcher?.watch(o)}async setVerboseLogging(o){this.verboseLogging=o,await this.watcher?.setVerboseLogging(o)}error(o){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${o}`})}trace(o){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${o}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E;class T extends E{constructor(o,c,g){super(o,c,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class k extends E{constructor(o,c,g){super(o,c,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function b(r){return r.map(o=>({type:o.type,resource:A.URI.revive(o.resource)}))}e.toFileChanges=b;function S(r){const o=new u;for(const c of r)o.processEvent(c);return o.coalesce()}e.coalesceEvents=S;function _(r,o){return typeof o=="string"&&!o.startsWith(I.GLOBSTAR)&&!(0,h.isAbsolute)(o)?{base:r,pattern:o}:o}e.normalizeWatcherPattern=_;function w(r,o){const c=[];for(const g of o)c.push((0,I.parse)(_(r,g)));return c}e.parseWatcherPatterns=w;class u{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(o){return R.isLinux?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const c=this.mapPathToChange.get(this.toKey(o));let g=!1;if(c){const d=c.type,t=o.type;c.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?g=!0:d===1&&t===2?(this.mapPathToChange.delete(this.toKey(o)),this.coalesced.delete(c)):d===2&&t===1?c.type=0:d===1&&t===0||(c.type=t)}else g=!0;g&&(this.coalesced.add(o),this.mapPathToChange.set(this.toKey(o),o))}coalesce(){const o=[],c=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(o.push(g),!1):!0).sort((g,d)=>g.resource.fsPath.length-d.resource.fsPath.length).filter(g=>c.some(d=>(0,v.isParent)(g.resource.fsPath,d,!R.isLinux))?!1:(c.push(g.resource.fsPath),!0)).concat(o)}}}),define(De[234],Ie([1,0,53,9,21,32,3,76,16,12,2,100,29,83]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class _ extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(r,o,c,g){super(),this.request=r,this.onDidFilesChange=o,this.onLogMessage=c,this.verboseLogging=g,this.throttledFileChangesEmitter=this._register(new F.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d))),this.fileChangesAggregator=this._register(new F.RunOnceWorker(d=>this.handleFileChanges(d),_.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new h.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const r=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const o=await b.Promises.stat(r);this._register(await this.doWatch(r,o.isDirectory()))}catch(r){r.code!=="ENOENT"?this.error(r):this.trace(r)}}async normalizePath(r){let o=r.path;try{o=await b.Promises.realpath(r.path),r.path===o&&(o=await(0,k.realcase)(r.path)??r.path),r.path!==o&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${o})`)}catch{}return o}async doWatch(r,o){if(E.isMacintosh&&(0,R.isEqualOrParent)(r,"/Volumes/",!0))return this.error(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const c=new h.CancellationTokenSource(this.cts.token),g=new A.DisposableStore;try{const d=(0,y.basename)(r),t=(0,I.watch)(r);g.add((0,A.toDisposable)(()=>{t.removeAllListeners(),t.close()})),this.trace(`Started watching: '${r}'`);const n=new Set;if(o)try{for(const i of await b.Promises.readdir(r))n.add(i)}catch(i){this.error(i)}const s=new Map;g.add((0,A.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),t.on("error",(i,a)=>{this.error(`Failed to watch ${r} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),t.on("change",(i,a)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let l="";if(a&&(l=a.toString(),E.isMacintosh&&(l=(0,v.normalizeNFC)(l))),!(!l||i!=="change"&&i!=="rename"))if(o)if(i==="rename"){s.get(l)?.dispose();const C=setTimeout(async()=>{if(s.delete(l),l===d&&!await b.Promises.exists(r)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const D=await this.existsChildStrictCase((0,y.join)(r,l));if(c.token.isCancellationRequested)return;let p;D?n.has(l)?p=0:(p=1,n.add(l)):(n.delete(l),p=2),this.onFileChange({resource:T.URI.file((0,y.join)(this.request.path,l)),type:p})},_.FILE_DELETE_HANDLER_DELAY);s.set(l,(0,A.toDisposable)(()=>clearTimeout(C)))}else{let C;n.has(l)?C=0:(C=1,n.add(l)),this.onFileChange({resource:T.URI.file((0,y.join)(this.request.path,l)),type:C})}else if(i==="rename"||l!==d){const C=setTimeout(async()=>{const D=await b.Promises.exists(r);c.token.isCancellationRequested||(D?(this.onFileChange({resource:T.URI.file(this.request.path),type:0},!0),g.add(await this.doWatch(r,!1))):(this.onFileChange({resource:T.URI.file(this.request.path),type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},_.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(C)))}else this.onFileChange({resource:T.URI.file(this.request.path),type:0},!0)})}catch(d){await b.Promises.exists(r)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${r} for changes using fs.watch() (${d.toString()})`)}return(0,A.toDisposable)(()=>{c.dispose(!0),g.dispose()})}onFileChange(r,o=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`),!o&&this.excludes.some(c=>c(r.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${r.resource.fsPath}`):!o&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(r.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${r.resource.fsPath}`):this.fileChangesAggregator.work(r))}handleFileChanges(r){const o=(0,S.coalesceEvents)(r);if(o.length>0){if(this.verboseLogging)for(const g of o)this.trace(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`);this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(r){if(E.isLinux)return b.Promises.exists(r);try{const o=(0,y.basename)(r);return(await b.Promises.readdir((0,y.dirname)(r))).some(g=>g===o)}catch(o){return this.trace(o),!1}}setVerboseLogging(r){this.verboseLogging=r}error(r){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}warn(r){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}trace(r){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=_;async function w(u,r,o,c,g=512){const d=await b.Promises.open(u,"r"),t=Buffer.allocUnsafe(g),n=new h.CancellationTokenSource(c);let s,i=!1;const a={path:u,excludes:[],recursive:!1},l=new _(a,C=>{(async()=>{for(const{type:D}of C)if(D===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:p}=await b.Promises.read(d,t,0,g,null);if(!p||n.token.isCancellationRequested)break;r(t.slice(0,p))}}catch(p){s=new Error(p),n.dispose(!0)}finally{i=!1}}})()});return await l.ready,o(),new Promise((C,D)=>{n.token.onCancellationRequested(async()=>{l.dispose();try{await b.Promises.close(d)}catch(p){s=new Error(p)}s?D(s):C()})})}e.watchFileContents=w}),define(De[235],Ie([1,0,4,35,3,12,234]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends h.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const T=this.normalizeRequests(E),k=T.filter(S=>{const _=this.watchers.get(S.path);return _?!(0,F.patternsEquals)(_.request.excludes,S.excludes)||!(0,F.patternsEquals)(_.request.includes,S.includes):!0}),b=Array.from(this.watchers.values()).filter(({request:S})=>!T.find(_=>_.path===S.path&&(0,F.patternsEquals)(_.excludes,S.excludes)&&(0,F.patternsEquals)(_.includes,S.includes))).map(({request:S})=>S.path);k.length&&this.trace(`Request to start watching: ${k.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),b.length&&this.trace(`Request to stop watching: ${b.join(",")}`);for(const S of b)this.stopWatching(S);for(const S of k)this.startWatching(S)}startWatching(E){const T=new A.NodeJSFileWatcherLibrary(E,b=>this._onDidChangeFile.fire(b),b=>this._onDidLogMessage.fire(b),this.verboseLogging),k={request:E,instance:T};this.watchers.set(E.path,k)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const T=this.watchers.get(E);T&&(this.watchers.delete(E),T.instance.dispose())}normalizeRequests(E){const T=new Map;for(const k of E){const b=R.isLinux?k.path:k.path.toLowerCase();T.set(b,k)}return Array.from(T.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,T]of this.watchers)T.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,T){return T?`[File Watcher (node.js)] ${E} (path: ${T.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=v}),define(De[236],Ie([1,0,83,235]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class h extends I.AbstractNonRecursiveWatcherClient{constructor(A,v,y){super(A,v,y),this.init()}createWatcher(A){return A.add(new F.NodeJSWatcher)}}e.NodeJSWatcherClient=h}),define(De[237],Ie([1,0,17,80,183,83]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(y,E,T){super(y,E,T),this.init()}createWatcher(y){const E=y.add(new h.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(E.onDidProcessExit(({code:T,signal:k})=>this.onError(`terminated by itself with code ${T}, signal: ${k}`))),F.ProxyChannel.toService((0,F.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(De[104],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...h){this._entries=new Map;for(const[R,A]of h)this.set(R,A)}set(h,R){const A=this._entries.get(h);return this._entries.set(h,R),A}has(h){return this._entries.has(h)}get(h){return this._entries.get(h)}}e.ServiceCollection=I}),define(De[238],Ie([1,0,9,8,3,102,229,5,104,75]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class k extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class b{constructor(u=new y.ServiceCollection,r=!1,o,c=T){this._services=u,this._strict=r,this._parent=o,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(v.IInstantiationService,this),this._globalGraph=c?o?._globalGraph??new A.Graph(g=>g):void 0}createChild(u){return new b(u,this._strict,this,this._enableTracing)}invokeFunction(u,...r){const o=_.traceInvocation(this._enableTracing,u);let c=!1;try{return u({get:d=>{if(c)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(d,o);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...r)}finally{c=!0,o.stop()}}createInstance(u,...r){let o,c;return u instanceof R.SyncDescriptor?(o=_.traceCreation(this._enableTracing,u.ctor),c=this._createInstance(u.ctor,u.staticArguments.concat(r),o)):(o=_.traceCreation(this._enableTracing,u),c=this._createInstance(u,r,o)),o.stop(),c}_createInstance(u,r=[],o){const c=v._util.getServiceDependencies(u).sort((t,n)=>t.index-n.index),g=[];for(const t of c){const n=this._getOrCreateServiceInstance(t.id,o);n||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(n)}const d=c.length>0?c[0].index:r.length;if(r.length!==d){console.trace(`[createInstance] First service dependency of ${u.name} at position ${d+1} conflicts with ${r.length} static arguments`);const t=d-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,d)}return Reflect.construct(u,r.concat(g))}_setServiceInstance(u,r){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,r);else if(this._parent)this._parent._setServiceInstance(u,r);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const r=this._services.get(u);return!r&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):r}_getOrCreateServiceInstance(u,r){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const o=this._getServiceInstanceOrDescriptor(u);return o instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,o,r.branch(u,!0)):(r.branch(u,!1),o)}_safeCreateAndCacheServiceInstance(u,r,o){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,r,o)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,r,o){const c=new A.Graph(t=>t.id.toString());let g=0;const d=[{id:u,desc:r,_trace:o}];for(;d.length;){const t=d.pop();if(c.lookupOrInsertNode(t),g++>1e3)throw new k(c);for(const n of v._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(n.id);if(s||this._throwIfStrict(`[createInstance] ${u} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),s instanceof R.SyncDescriptor){const i={id:n.id,desc:s,_trace:t._trace.branch(n.id,!0)};c.insertEdge(t,i),d.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new k(c);break}for(const{data:n}of t){if(this._getServiceInstanceOrDescriptor(n.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,i)}c.removeNode(n)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,r,o=[],c,g){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(u,r,o,c,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,r,o,c,g);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}_createServiceInstance(u,r,o=[],c,g){if(c){const d=new b(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(u);const t=new Map,n=new I.IdleValue(()=>{const s=d._createInstance(r,o,g);for(const[i,a]of t){const l=s[i];if(typeof l=="function")for(const C of a)l.apply(s,C)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let C=t.get(i);return C||(C=new E.LinkedList,t.set(i,C)),(p,m,f)=>{const P=C.push([p,m,f]);return(0,h.toDisposable)(P)}}if(i in s)return s[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),s[i]=l),l},set(s,i,a){return n.value[i]=a,!0},getPrototypeOf(s){return r.prototype}})}else return this._createInstance(r,o,g)}_throwIfStrict(u,r){if(r&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=b;var S;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(S||(S={}));class _{static{this.all=new Set}static{this._None=new class extends _{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,r){return u?new _(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):_._None}static traceCreation(u,r){return u?new _(1,r.name):_._None}static{this._totals=0}constructor(u,r){this.type=u,this.name=r,this._start=Date.now(),this._dep=[]}branch(u,r){const o=new _(3,u.toString());return this._dep.push([u,r,o]),o}stop(){const u=Date.now()-this._start;_._totals+=u;let r=!1;function o(g,d){const t=[],n=new Array(g+1).join("	");for(const[s,i,a]of d._dep)if(i&&a){r=!0,t.push(`${n}CREATES -> ${s}`);const l=o(g+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(u>2||r)&&_.all.add(c.join(`
`))}}e.Trace=_}),define(De[13],Ie([1,0,46,4,52,3,28,12,24,18,2,41,5]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function S(){return new Date().toISOString()}function _(p){return(0,E.isNumber)(p)}e.isLogLevel=_;var w;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function u(p,m,f){switch(m){case w.Trace:p.trace(f);break;case w.Debug:p.debug(f);break;case w.Info:p.info(f);break;case w.Warning:p.warn(f);break;case w.Error:p.error(f);break;case w.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=u;function r(p,m=!1){let f="";for(let P=0;P<p.length;P++){let M=p[P];if(M instanceof Error&&(M=(0,I.toErrorMessage)(M,m)),typeof M=="object")try{M=JSON.stringify(M)}catch{}f+=(P>0?" ":"")+M}return f}class o extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(m){this.level!==m&&(this.level=m,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(m){return this.level!==w.Off&&this.level<=m}}e.AbstractLogger=o;class c extends o{constructor(m){super(),this.logAlways=m}checkLogLevel(m){return this.logAlways||super.checkLogLevel(m)}trace(m,...f){this.checkLogLevel(w.Trace)&&this.log(w.Trace,r([m,...f],!0))}debug(m,...f){this.checkLogLevel(w.Debug)&&this.log(w.Debug,r([m,...f]))}info(m,...f){this.checkLogLevel(w.Info)&&this.log(w.Info,r([m,...f]))}warn(m,...f){this.checkLogLevel(w.Warning)&&this.log(w.Warning,r([m,...f]))}error(m,...f){if(this.checkLogLevel(w.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.log(w.Error,r(P))}else this.log(w.Error,r([m,...f]))}flush(){}}e.AbstractMessageLogger=c;class g extends o{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.useColors=!v.isWindows}trace(m,...f){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...f):console.log(`[main ${S()}]`,m,...f))}debug(m,...f){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...f):console.log(`[main ${S()}]`,m,...f))}info(m,...f){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...f):console.log(`[main ${S()}]`,m,...f))}warn(m,...f){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,m,...f):console.warn(`[main ${S()}]`,m,...f))}error(m,...f){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,m,...f):console.error(`[main ${S()}]`,m,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends o{constructor(m=e.DEFAULT_LOG_LEVEL,f=!0){super(),this.useColors=f,this.setLevel(m)}trace(m,...f){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",m,...f):console.log(m,...f))}debug(m,...f){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",m,...f):console.log(m,...f))}info(m,...f){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",m,...f):console.log(m,...f))}warn(m,...f){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",m,...f):console.log(m,...f))}error(m,...f){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",m,...f):console.error(m,...f))}dispose(){}flush(){}}e.ConsoleLogger=d;class t extends o{constructor(m,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=m,this.setLevel(f)}trace(m,...f){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(m),...f])}debug(m,...f){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(m),...f])}info(m,...f){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(m),...f])}warn(m,...f){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(m),...f])}error(m,...f){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(m),...f])}extractMessage(m){return typeof m=="string"?m:(0,I.toErrorMessage)(m,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends o{constructor(m){super(),this.loggers=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const f of this.loggers)f.setLevel(m);super.setLevel(m)}trace(m,...f){for(const P of this.loggers)P.trace(m,...f)}debug(m,...f){for(const P of this.loggers)P.debug(m,...f)}info(m,...f){for(const P of this.loggers)P.info(m,...f)}warn(m,...f){for(const P of this.loggers)P.warn(m,...f)}error(m,...f){for(const P of this.loggers)P.error(m,...f)}flush(){for(const m of this.loggers)m.flush()}dispose(){for(const m of this.loggers)m.dispose()}}e.MultiplexLogger=n;class s extends R.Disposable{constructor(m,f,P){if(super(),this.logLevel=m,this.logsHome=f,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new F.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const M of P)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(m){return(0,E.isString)(m)?[...this._loggers.values()].find(f=>f.info.id===m):this._loggers.get(m)}getLogger(m){return this.getLoggerEntry(m)?.logger}createLogger(m,f){const P=this.toResource(m),M=(0,E.isString)(m)?m:f?.id??(0,h.hash)(P.toString()).toString(16);let N=this._loggers.get(P)?.logger;const L=f?.logLevel==="always"?w.Trace:f?.logLevel;N||(N=this.doCreateLogger(P,L??this.getLogLevel(P)??this.logLevel,{...f,id:M}));const U={logger:N,info:{resource:P,id:M,logLevel:L,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(U.info),this._loggers.set(P,U),N}toResource(m){return(0,E.isString)(m)?(0,y.joinPath)(this.logsHome,`${m}.log`):m}setLogLevel(m,f){if(T.URI.isUri(m)){const P=m,M=f,N=this._loggers.get(P);N&&M!==N.info.logLevel&&(N.info.logLevel=M===this.logLevel?void 0:M,N.logger?.setLevel(M),this._loggers.set(N.info.resource,N),this._onDidChangeLogLevel.fire([P,M]))}else{this.logLevel=m;for(const[P,M]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(m,f){const P=this.getLoggerEntry(m);P&&f!==!P.info.hidden&&(P.info.hidden=!f,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,f]))}getLogLevel(m){let f;return m&&(f=this._loggers.get(m)?.info.logLevel),f??this.logLevel}registerLogger(m){const f=this._loggers.get(m.resource);f?f.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this._loggers.set(m.resource,{info:m,logger:void 0}),this._onDidChangeLoggers.fire({added:[m],removed:[]}))}deregisterLogger(m){const f=this._loggers.get(m);f&&(f.logger&&f.logger.dispose(),this._loggers.delete(m),this._onDidChangeLoggers.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const m of this._loggers.values())yield m.info}getRegisteredLogger(m){return this._loggers.get(m)?.info}dispose(){this._loggers.forEach(m=>m.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(m){}getLevel(){return w.Info}trace(m,...f){}debug(m,...f){}info(m,...f){}warn(m,...f){}error(m,...f){}critical(m,...f){}dispose(){}flush(){}}e.NullLogger=i;class a extends i{}e.NullLogService=a;function l(p){if(p.verbose)return w.Trace;if(typeof p.logLevel=="string"){const m=D(p.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function C(p){switch(p){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=C;function D(p){switch(p){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",C(w.Info))}),define(De[239],Ie([1,0,19,9,8,4,3,16,83,13]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends A.Disposable{constructor(b,S){super(),this.logService=b,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new F.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new F.ThrottledDelayer(0))}watch(b,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(b,S):this.watchNonRecursive(b,S)}watchUniversal(b,S){const _={path:this.toFilePath(b),excludes:S.excludes,includes:S.includes,recursive:S.recursive},w=(0,I.insert)(this.universalPathsToWatch,_);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(b=>(0,h.onUnexpectedError)(b))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,y.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const b=this.options?.watcher?.recursive?.usePolling;if(b===!0)for(const S of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const S of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(S)&&b.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(b,S){const _={path:this.toFilePath(b),excludes:S.excludes,includes:S.includes,recursive:!1},w=(0,I.insert)(this.nonRecursivePathsToWatch,_);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(b=>(0,h.onUnexpectedError)(b))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(b=>this._onDidChangeFile.fire((0,y.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(b){b.type==="error"&&this._onDidWatchError.fire(b.message),this.logService[b.type](b.message)}toFilePath(b){return(0,v.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(De[240],Ie([1,0,53,372,9,28,22,4,32,3,16,12,24,96,29,197,30,233,239,46,237,236]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(n)}`)}})();class t extends o.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:a}=await _.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await _.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let C;l.isSymbolicLink()?C=(await this.stat((0,b.joinPath)(s,l.name))).type:C=this.toType(l),a.push([l.name,C])}catch(C){this.logService.trace(C)}})),a}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let a;return i?.dangling?a=u.FileType.Unknown:s.isFile()?a=u.FileType.File:s.isDirectory()?a=u.FileType.Directory:a=u.FileType.Unknown,i&&(a|=u.FileType.SymbolicLink),a}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new h.Barrier;return this.resourceLocks.set(s,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,E.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let a;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),a=await this.createResourceLock(s));const l=this.toFilePath(s);return await _.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{a?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,a){const l=(0,S.newWriteableStream)(C=>A.VSBuffer.concat(C.map(D=>A.VSBuffer.wrap(D))).buffer);return(0,r.readFileIntoStream)(this,s,l,C=>C.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(s,i,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,b.joinPath)((0,b.dirname)(s),`${(0,b.basename)(s)}${a.atomic.postfix}`),i,a):this.doWriteFile(s,i,a)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:a}=await _.SymlinkSupport.stat(i);if(a)return!1}catch{}return!0}async doWriteFileAtomic(s,i,a,l){const C=new E.DisposableStore;try{C.add(await this.createResourceLock(s)),C.add(await this.createResourceLock(i)),await this.doWriteFile(i,a,l,!0);try{await this.rename(i,s,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{C.dispose()}}async doWriteFile(s,i,a,l){let C;try{const D=this.toFilePath(s);if(!a.create||!a.overwrite){if(await _.Promises.exists(D)){if(!a.overwrite)throw(0,u.createFileSystemProviderError)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,u.createFileSystemProviderError)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}C=await this.open(s,{create:!0,unlock:a.unlock},l),await this.write(C,0,i,0,i.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof C=="number"&&await this.close(C)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,a){const l=this.toFilePath(s);let C;(0,u.isFileOpenForWriteOptions)(i)&&!a&&(C=await this.createResourceLock(s));let D;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:m}=await _.SymlinkSupport.stat(l);m.mode&128||await _.Promises.chmod(l,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}let p;if((0,u.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await _.Promises.truncate(l,0),p="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}p||(p="w")}else p="r";D=await _.Promises.open(l,p)}catch(p){throw C?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(D,0),(0,u.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(D,s),C){const p=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${l})`),this.mapHandleToLock.set(D,C),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${l})`),p.dispose())}return D}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await _.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.logService.error(a)}return await _.Promises.close(s)}catch(a){throw this.toFileSystemProviderError(a)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,a,l,C){const D=this.normalizePos(s,i);let p=null;try{p=(await _.Promises.read(s,a,l,C,D)).bytesRead}catch(m){throw this.toFileSystemProviderError(m)}finally{this.updatePos(s,D,p)}return p}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,a){const l=this.mapHandleToPos.get(s);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.mapHandleToPos.set(s,l+a):this.mapHandleToPos.delete(s)))}async write(s,i,a,l,C){return(0,h.retry)(()=>this.doWrite(s,i,a,l,C),100,3)}async doWrite(s,i,a,l,C){const D=this.normalizePos(s,i);let p=null;try{p=(await _.Promises.write(s,a,l,C,D)).bytesWritten}catch(m){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),m)}finally{this.updatePos(s,D,p)}return p}async mkdir(s){try{await _.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const a=this.toFilePath(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,T.join)((0,T.dirname)(a),`${(0,T.basename)(a)}${i.atomic.postfix}`)),await _.Promises.rm(a,_.RimRafMode.MOVE,l)}else try{await _.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let C=!1;try{const{stat:D,symbolicLink:p}=await _.SymlinkSupport.stat(a);C=D.isDirectory()&&!p}catch{}if(C)await _.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.toFileSystemProviderError(a)}}async rename(s,i,a){const l=this.toFilePath(s),C=this.toFilePath(i);if(l!==C)try{await this.validateMoveCopy(s,i,"move",a.overwrite),await _.Promises.rename(l,C)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(C)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(s,i,a){const l=this.toFilePath(s),C=this.toFilePath(i);if(l!==C)try{await this.validateMoveCopy(s,i,"copy",a.overwrite),await _.Promises.copy(l,C,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(C)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(s,i,a,l){const C=this.toFilePath(s),D=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,y.isEqual)(C,D,!0)),p){if(a==="copy")throw(0,u.createFileSystemProviderError)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const f=await this.statIgnoreError(s);if(!f)throw(0,u.createFileSystemProviderError)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(i);if(P){if(!l)throw(0,u.createFileSystemProviderError)((0,w.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);f.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,a){const l=this.toFilePath(s),C=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,y.isEqual)(l,C,!D))return;const p=new E.DisposableStore;try{p.add(await this.createResourceLock(s)),p.add(await this.createResourceLock(i)),a&&await _.Promises.mkdir((0,T.dirname)(C),{recursive:!0}),await _.Promises.copyFile(l,C)}catch(m){if(m.code==="ENOENT"&&!a)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(m)}finally{p.dispose()}}createUniversalWatcher(s,i,a){return new g.UniversalWatcherClient(l=>s(l),l=>i(l),a)}createNonRecursiveWatcher(s,i,a){return new d.NodeJSWatcherClient(l=>s(l),l=>i(l),a)}toFileSystemProviderError(s){if(s instanceof u.FileSystemProviderError)return s;let i=s,a;switch(s.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=u.FileSystemProviderErrorCode.Unknown;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(s,i){let a=this.toFileSystemProviderError(i);if(s&&a.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await _.SymlinkSupport.stat(this.toFilePath(s));l.mode&128||(a=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return a}}e.DiskFileSystemProvider=t}),define(De[241],Ie([1,0,3,13]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class h extends I.Disposable{constructor(A,v=[]){super(),this.logger=new F.MultiplexLogger([A,...v]),this._register(A.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...v){this.logger.trace(A,...v)}debug(A,...v){this.logger.debug(A,...v)}info(A,...v){this.logger.info(A,...v)}warn(A,...v){this.logger.warn(A,...v)}error(A,...v){this.logger.error(A,...v)}flush(){this.logger.flush()}}e.LogService=h}),define(De[242],Ie([1,0,30,13]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var h;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(h||(h={}));async function R(E,T,k,b,S){try{const _=await new Promise((u,r)=>{ge(["@vscode/spdlog"],u,r)});_.setFlushOn(h.Trace);const w=await _.createAsyncRotatingLogger(E,T,k,b);return S?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(_){console.error(_)}return null}function A(E,T,k){switch(T){case F.LogLevel.Trace:E.trace(k);break;case F.LogLevel.Debug:E.debug(k);break;case F.LogLevel.Info:E.info(k);break;case F.LogLevel.Warning:E.warn(k);break;case F.LogLevel.Error:E.error(k);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function v(E,T){switch(T){case F.LogLevel.Trace:E.setLevel(h.Trace);break;case F.LogLevel.Debug:E.setLevel(h.Debug);break;case F.LogLevel.Info:E.setLevel(h.Info);break;case F.LogLevel.Warning:E.setLevel(h.Warning);break;case F.LogLevel.Error:E.setLevel(h.Error);break;case F.LogLevel.Off:E.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class y extends F.AbstractMessageLogger{constructor(T,k,b,S,_){super(),this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(T,k,b,S),this._register(this.onDidChangeLogLevel(w=>{this._logger&&v(this._logger,w)}))}async _createSpdLogLogger(T,k,b,S){const _=b?6:1,w=30/_*I.ByteSize.MB,u=await R(T,k,w,_,S);if(u){this._logger=u,v(this._logger,this.getLevel());for(const{level:r,message:o}of this.buffer)A(this._logger,r,o);this.buffer=[]}}log(T,k){this._logger?A(this._logger,T,k):this.getLevel()<=T&&this.buffer.push({level:T,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[133],Ie([1,0,38,198,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(y){function E(_,w){return w-_}y.compare=E;const T=Object.create(null);T[y.Error]=(0,F.localize)(0,null),T[y.Warning]=(0,F.localize)(1,null),T[y.Info]=(0,F.localize)(2,null);function k(_){return T[_]||""}y.toString=k;function b(_){switch(_){case I.default.Error:return y.Error;case I.default.Warning:return y.Warning;case I.default.Info:return y.Info;case I.default.Ignore:return y.Hint}}y.fromSeverity=b;function S(_){switch(_){case y.Error:return I.default.Error;case y.Warning:return I.default.Warning;case y.Info:return I.default.Info;case y.Hint:return I.default.Ignore}}y.toSeverity=S}(A||(e.MarkerSeverity=A={}));var v;(function(y){const E="";function T(b){return k(b,!0)}y.makeKey=T;function k(b,S){const _=[E];return b.source?_.push(b.source.replace("\xA6","\\\xA6")):_.push(E),b.code?typeof b.code=="string"?_.push(b.code.replace("\xA6","\\\xA6")):_.push(b.code.value.replace("\xA6","\\\xA6")):_.push(E),b.severity!==void 0&&b.severity!==null?_.push(A.toString(b.severity)):_.push(E),b.message&&S?_.push(b.message.replace("\xA6","\\\xA6")):_.push(E),b.startLineNumber!==void 0&&b.startLineNumber!==null?_.push(b.startLineNumber.toString()):_.push(E),b.startColumn!==void 0&&b.startColumn!==null?_.push(b.startColumn.toString()):_.push(E),b.endLineNumber!==void 0&&b.endLineNumber!==null?_.push(b.endLineNumber.toString()):_.push(E),b.endColumn!==void 0&&b.endColumn!==null?_.push(b.endColumn.toString()):_.push(E),_.push(E),_.join("\xA6")}y.makeKeyOptionalMessage=k})(v||(e.IMarkerData=v={})),e.IMarkerService=(0,h.createDecorator)("markerService")}),define(De[243],Ie([1,0,4,38,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,h.createDecorator)("notificationService");var R;(function(T){T[T.DEFAULT=0]="DEFAULT",T[T.SILENT=1]="SILENT",T[T.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var v;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(v||(e.NotificationsFilter=v={}));class y{constructor(){this.progress=new E,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=y;class E{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=E}),define(De[134],Ie([1,0,15,2,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,h.createDecorator)("openerService");function R(E,T){return F.URI.isUri(E)?(0,I.equalsIgnoreCase)(E.scheme,T):(0,I.startsWithIgnoreCase)(E,T+":")}e.matchesScheme=R;function A(E,...T){return T.some(k=>R(E,k))}e.matchesSomeScheme=A;function v(E,T){return E.with({fragment:`${T.startLineNumber},${T.startColumn}${T.endLineNumber?`-${T.endLineNumber}${T.endColumn?`,${T.endColumn}`:""}`:""}`})}e.withSelection=v;function y(E){let T;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(E.fragment);return k&&(T={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},E=E.with({fragment:""})),{selection:T,uri:E}}e.extractSelection=y}),define(De[244],Ie([1,0,12,47]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const R=I.globals.vscode.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){h=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:R,searchUrl:A,itemUrl:v,controlUrl:y}=h.extensionsGallery||{};Object.assign(h,{extensionsGallery:{serviceUrl:F.env.VSCODE_GALLERY_SERVICE_URL||R,searchUrl:F.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:F.env.VSCODE_GALLERY_ITEM_URL||v,controlUrl:F.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const E=(...k)=>k.reduce((b,S)=>(Object.keys(S).forEach(_=>{Array.isArray(b[_])&&Array.isArray(S[_])?b[_]=S[_]:typeof b[_]=="object"&&typeof S[_]=="object"?b[_]=E(b[_],S[_]):b[_]=S[_]}),b),{}),T=globalThis._VSCODE_USER_PRODUCT_JSON||{};h=E(h,T)}catch{}if(F.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const E=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:E.version,release:E.release})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(De[135],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(ge,e){return function(I,F){e(I,F,ge)}};define(De[84],Ie([1,0,9,21,3,5]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var A;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(k,b){this.callback=k,this.report=b?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(k){this._value=k,this.callback(this._value)}_reportAsync(k){this._asyncQueue?this._asyncQueue.push(k):this._asyncQueue=[k],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const k=this._asyncQueue.shift();this._value=k,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const k=this._drainListener;this._drainListener=void 0,k?.()}}drain(){return this._processingAsyncQueue?new Promise(k=>{const b=this._drainListener;this._drainListener=()=>{b?.(),k()}}):Promise.resolve()}}e.Progress=v;let y=class extends h.Disposable{constructor(k,b){super(),this.deferred=new I.DeferredPromise,b.withProgress(k,S=>(this.reporter=S,this.lastStep&&S.report(this.lastStep),this.deferred.p)),this._register((0,h.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=je([$e(1,e.IProgressService)],y);class E extends h.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new h.DisposableStore)}start(k){this.stop();const b=++this.currentOperationId,S=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,h.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,h.toDisposable)(()=>S.cancel())),this.currentOperationDisposables.add((0,h.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:S.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=E,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(De[42],Ie([1,0,58,18]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class h{constructor(){this.data=new Map}add(A,v){I.ok(F.isString(A)),I.ok(F.isObject(v)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,v)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new h}),define(De[105],Ie([1,0,4,42]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function h(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,E){this.schemasById[h(y)]=E,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new R;F.Registry.add(e.Extensions.JSONContribution,A)}),define(De[136],Ie([1,0,19,4,18,188,49,105,42]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=y.Registry.as(v.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const s=new Set;this.doRegisterConfigurations(t,n,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const n=new Set;this.doDeregisterConfigurations(t,n),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const s=new Set;this.doDeregisterConfigurations(n,s),this.doRegisterConfigurations(t,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const n=new Set;this.doRegisterDefaultConfigurations(t,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,n){const s=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const C=this.configurationDefaultsOverrides.get(l),D=C?.valuesSources??new Map;if(a)for(const P of Object.keys(i[l]))D.set(P,a);const p={...C?.value||{},...i[l]};this.configurationDefaultsOverrides.set(l,{source:a,value:p,valuesSources:D});const m=(0,A.getLanguageTagSettingPlainKey)(l),f={type:"object",default:p,description:R.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:h.isString(a)?void 0:a,defaultValueSource:a};s.push(...w(l)),this.configurationProperties[l]=f,this.defaultLanguageConfigurationOverridesNode.properties[l]=f}else{this.configurationDefaultsOverrides.set(l,{value:i[l],source:a});const C=this.configurationProperties[l];C&&(this.updatePropertyDefaultValue(l,C),this.updateSchema(l,C))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const n=new Set;this.doDeregisterDefaultConfigurations(t,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,n){for(const{overrides:s,source:i}of t)for(const a in s){const l=this.configurationDefaultsOverrides.get(a),C=h.isString(i)?i:i?.id,D=h.isString(l?.source)?l?.source:l?.source?.id;if(C===D)if(n.add(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let n=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),n=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),n=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n,s){t.forEach(i=>{this.validateAndRegisterProperties(i,n,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,n){const s=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.configurationProperties[a];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,i.properties[a])}i.allOf?.forEach(a=>s(a))};for(const i of t){s(i);const a=this.configurationContributors.indexOf(i);a!==-1&&this.configurationContributors.splice(a,1)}}validateAndRegisterProperties(t,n=!0,s,i,a=3,l){a=h.isUndefinedOrNull(t.scope)?a:t.scope;const C=t.properties;if(C)for(const p in C){const m=C[p];if(n&&c(p,m)){delete C[p];continue}if(m.source=s,m.defaultDefaultValue=C[p].default,this.updatePropertyDefaultValue(p,m),e.OVERRIDE_PROPERTY_REGEX.test(p)?m.scope=void 0:(m.scope=h.isUndefinedOrNull(m.scope)?a:m.scope,m.restricted=h.isUndefinedOrNull(m.restricted)?!!i?.includes(p):m.restricted),C[p].hasOwnProperty("included")&&!C[p].included){this.excludedConfigurationProperties[p]=C[p],delete C[p];continue}else this.configurationProperties[p]=C[p],C[p].policy?.name&&this.policyConfigurations.set(C[p].policy.name,p);!C[p].deprecationMessage&&C[p].markdownDeprecationMessage&&(C[p].deprecationMessage=C[p].markdownDeprecationMessage),l.add(p)}const D=t.allOf;if(D)for(const p of D)this.validateAndRegisterProperties(p,n,s,i,a,l)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=s=>{const i=s.properties;if(i)for(const l in i)this.updateSchema(l,i[l]);s.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,s),e.allSettings.properties[n]=s,e.applicationSettings.properties[n]=s,e.machineSettings.properties[n]=s,e.machineOverridableSettings.properties[n]=s,e.windowSettings.properties[n]=s,e.resourceSettings.properties[n]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,a=s?.source;h.isUndefined(i)&&(i=n.defaultDefaultValue,a=void 0),h.isUndefined(i)&&(i=r(n.type)),n.default=i,n.defaultValueSource=a}}const S="\\[([^\\]]+)\\]",_=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(d){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let n=_.exec(d);for(;n?.length;){const s=n[1].trim();s&&t.push(s),n=_.exec(d)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function u(d){return d.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=u;function r(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=r;const o=new b;y.Registry.add(e.Extensions.Configuration,o);function c(d,t){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?R.localize(7,null,d):o.getConfigurationProperties()[d]!==void 0?R.localize(8,null,d):t.policy?.name&&o.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,d,t.policy?.name,o.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=c;function g(){const d=[],t=o.getConfigurationProperties();for(const n of Object.keys(t))d.push([n,t[n].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=g}),define(De[245],Ie([1,0,19,4,157,3,28,23,18,2,49,136,42]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(n){return Object.isFrozen(n)?n:v.deepFreeze(n)}class _{constructor(s={},i=[],a=[],l){this._contents=s,this._keys=i,this._overrides=a,this.raw=l,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof _)return i;const a=new w("");return a.parseRaw(i),a.configurationModel});this._rawConfiguration=s.reduce((i,a)=>a===i?a:i.merge(a),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,T.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const a=this.rawConfiguration.getValue(s),l=i?this.rawConfiguration.getOverrideValue(s,i):void 0,C=i?this.rawConfiguration.override(i).getValue(s):a;return{value:a,override:l,merged:C}}getOverrideValue(s,i){const a=this.getContentsForOverrideIdentifer(i);return a?s?(0,T.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const a of this.overrides)a.identifiers.includes(s)&&i.push(...a.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=v.deepClone(this.contents),a=v.deepClone(this.overrides),l=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const D of s)if(C.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const p of D.overrides){const[m]=a.filter(f=>I.equals(f.identifiers,p.identifiers));m?(this.mergeContents(m.contents,p.contents),m.keys.push(...p.keys),m.keys=I.distinct(m.keys)):a.push(v.deepClone(p))}for(const p of D.keys)l.indexOf(p)===-1&&l.push(p)}return new _(i,l,a,C.every(D=>D instanceof _)?void 0:C)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let C=this.contents[l];const D=i[l];D&&(typeof C=="object"&&typeof D=="object"?(C=v.deepClone(C),this.mergeContents(C,D)):C=D),a[l]=C}return new _(a,this.keys,this.overrides)}mergeContents(s,i){for(const a of Object.keys(i)){if(a in s&&y.isObject(s[a])&&y.isObject(i[a])){this.mergeContents(s[a],i[a]);continue}s[a]=v.deepClone(i[a])}}getContentsForOverrideIdentifer(s){let i=null,a=null;const l=C=>{C&&(a?this.mergeContents(a,C):a=v.deepClone(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===s?i=C.contents:C.identifiers.includes(s)&&l(C.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>I.equals(a.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,a){(0,T.addToValueTree)(this.contents,s,i,l=>console.error(l)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,T.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=_;class w{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!y.isUndefinedOrNull(s)){const a=this.doParseContent(s);this.parseRaw(a,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:a,keys:l,overrides:C,restricted:D,hasExcludedProperties:p}=this.doParseRaw(s,i);this._configurationModel=new _(a,l,C,p?[s]:void 0),this._restrictedConfigurations=D||[]}doParseContent(s){let i={},a=null,l=[];const C=[],D=[];function p(f){Array.isArray(l)?l.push(f):a!==null&&(l[a]=f)}const m={onObjectBegin:()=>{const f={};p(f),C.push(l),l=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{l=C.pop()},onArrayBegin:()=>{const f=[];p(f),C.push(l),l=f,a=null},onArrayEnd:()=>{l=C.pop()},onLiteralValue:p,onError:(f,P,M)=>{D.push({error:f,offset:P,length:M})}};if(s)try{h.visit(s,m),i=l[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return i}doParseRaw(s,i){const a=b.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=this.filter(s,a,!0,i);s=l.raw;const C=(0,T.toValuesTree)(s,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),D=Object.keys(s),p=this.toOverrides(s,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:C,keys:D,overrides:p,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(s,i,a,l){let C=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:C};const D={},p=[];for(const m in s)if(k.OVERRIDE_PROPERTY_REGEX.test(m)&&a){const f=this.filter(s[m],i,!1,l);D[m]=f.raw,C=C||f.hasExcludedProperties,p.push(...f.restricted)}else{const f=i[m],P=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&p.push(m),!l.exclude?.includes(m)&&(l.include?.includes(m)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&f?.restricted))?D[m]=s[m]:C=!0}return{raw:D,restricted:p,hasExcludedProperties:C}}toOverrides(s,i){const a=[];for(const l of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(l)){const C={};for(const D in s[l])C[D]=s[l][D];a.push({identifiers:(0,k.overrideIdentifiersFromKey)(l),keys:Object.keys(C),contents:(0,T.toValuesTree)(C,i)})}return a}}e.ConfigurationModelParser=w;class u extends R.Disposable{constructor(s,i,a,l){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=l,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.any(F.Event.filter(this.fileService.onDidFilesChange,C=>C.contains(this.userSettingsResource)),F.Event.filter(this.fileService.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&a.isEqual(C.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class r{constructor(s,i,a,l,C,D,p,m,f,P,M,N,L){this.key=s,this.overrides=i,this._value=a,this.overrideIdentifiers=l,this.defaultConfiguration=C,this.policyConfiguration=D,this.applicationConfiguration=p,this.userConfiguration=m,this.localUserConfiguration=f,this.remoteUserConfiguration=P,this.workspaceConfiguration=M,this.folderConfigurationModel=N,this.memoryConfigurationModel=L}get value(){return S(this._value)}inspect(s,i,a){const l=s.inspect(i,a);return{get value(){return S(l.value)},get override(){return S(l.override)},get merged(){return S(l.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class o{constructor(s,i,a,l,C=new _,D=new _,p=new A.ResourceMap,m=new _,f=new A.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=a,this._localUserConfiguration=l,this._remoteUserConfiguration=C,this._workspaceConfiguration=D,this._folderConfigurations=p,this._memoryConfiguration=m,this._memoryConfigurationByResource=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(s,i,a){return this.getConsolidatedConfigurationModel(s,i,a).getValue(s)}updateValue(s,i,a={}){let l;a.resource?(l=this._memoryConfigurationByResource.get(a.resource),l||(l=new _,this._memoryConfigurationByResource.set(a.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(s):l.setValue(s,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,a){const l=this.getConsolidatedConfigurationModel(s,i,a),C=this.getFolderConfigurationModelForResource(i.resource,a),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const m of l.overrides)for(const f of m.identifiers)l.getOverrideValue(s,f)!==void 0&&p.add(f);return new r(s,i,l.getValue(s),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this._workspaceConfiguration:void 0,C||void 0,D)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const a=[];if(!i){const{added:l,updated:C,removed:D}=d(this._defaultConfiguration,s);i=[...l,...C,...D]}for(const l of i)for(const C of(0,k.overrideIdentifiersFromKey)(l)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(C),p=s.getKeysForOverrideIdentifier(C),m=[...p.filter(f=>D.indexOf(f)===-1),...D.filter(f=>p.indexOf(f)===-1),...D.filter(f=>!v.equals(this._defaultConfiguration.override(C).getValue(f),s.override(C).getValue(f)))];a.push([C,m])}return this.updateDefaultConfiguration(s),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:a,removed:l}=d(this._policyConfiguration,s),C=[...i,...a,...l];return C.length&&this.updatePolicyConfiguration(s),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:a,removed:l,overrides:C}=d(this.applicationConfiguration,s),D=[...i,...a,...l];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:C}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:C}=d(this.localUserConfiguration,s),D=[...i,...a,...l];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:C}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:C}=d(this.remoteUserConfiguration,s),D=[...i,...a,...l];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:C}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:a,removed:l,overrides:C}=d(this.workspaceConfiguration,s),D=[...i,...a,...l];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:C}}compareAndUpdateFolderConfiguration(s,i){const a=this.folderConfigurations.get(s),{added:l,updated:C,removed:D,overrides:p}=d(a,i),m=[...l,...C,...D];return(m.length||!a)&&this.updateFolderConfiguration(s,i),{keys:m,overrides:p}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:l,removed:C,overrides:D}=d(i,void 0);return{keys:[...a,...l,...C],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,a){let l=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:s},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const l=i.getFolder(s);l&&(a=this.getFolderConsolidatedConfiguration(l.uri)||a);const C=this._memoryConfigurationByResource.get(s);C&&(a=a.merge(C))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(s);l?(i=a.merge(l),this._foldersConsolidatedConfigurations.set(s,i)):i=a}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const a=i.getFolder(s);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:a,overrides:l,keys:C}=this._folderConfigurations.get(i);return s.push([i,{contents:a,overrides:l,keys:C}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(a=>s.add(a))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),a=this.parseConfigurationModel(s.policy),l=this.parseConfigurationModel(s.application),C=this.parseConfigurationModel(s.user),D=this.parseConfigurationModel(s.workspace),p=s.folders.reduce((m,f)=>(m.set(E.URI.revive(f[0]),this.parseConfigurationModel(f[1])),m),new A.ResourceMap);return new o(i,a,l,C,new _,D,p,new _,new A.ResourceMap)}static parseConfigurationModel(s){return new _(s.contents,s.keys,s.overrides)}}e.Configuration=o;function c(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const l of n)l.keys.forEach(C=>s.add(C)),l.overrides.forEach(([C,D])=>{const p=(0,A.getOrSet)(i,C,new Set);D.forEach(m=>p.add(m))});const a=[];return i.forEach((l,C)=>a.push([C,[...l.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=c;class g{constructor(s,i,a,l){this.change=s,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=l,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const C of s.keys)this.affectedKeys.add(C);for(const[,C]of s.overrides)for(const D of C)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const C of this.affectedKeys)this._affectsConfigStr+=C+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=o.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const a=this._marker+s,l=this._affectsConfigStr.indexOf(a);if(l<0)return!1;const C=l+a.length;if(C>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(C);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!v.equals(p,m)}return!0}}e.ConfigurationChangeEvent=g;function d(n,s){const{added:i,removed:a,updated:l}=t(s?.rawConfiguration,n?.rawConfiguration),C=[],D=n?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const m=p.filter(f=>!D.includes(f));for(const f of m)C.push([f,s.getKeysForOverrideIdentifier(f)])}if(n){const m=D.filter(f=>!p.includes(f));for(const f of m)C.push([f,n.getKeysForOverrideIdentifier(f)])}if(s&&n){for(const m of D)if(p.includes(m)){const f=t({contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});C.push([m,[...f.added,...f.removed,...f.updated]])}}return{added:i,removed:a,updated:l,overrides:C}}function t(n,s){const i=n?s?n.keys.filter(C=>s.keys.indexOf(C)===-1):[...n.keys]:[],a=s?n?s.keys.filter(C=>n.keys.indexOf(C)===-1):[...s.keys]:[],l=[];if(n&&s){for(const C of s.keys)if(n.keys.indexOf(C)!==-1){const D=(0,T.getConfigurationValue)(s.contents,C),p=(0,T.getConfigurationValue)(n.contents,C);v.equals(D,p)||l.push(C)}}return{added:i,removed:a,updated:l}}}),define(De[246],Ie([1,0,22,4,3,81]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const A=(E,T,k)=>{const b=new Uint8Array(16);for(let w=0;w<16;w++)b[w]=Math.round(Math.random()*256);const S=(0,I.encodeBase64)(I.VSBuffer.wrap(b));return[`GET ws://localhost${E}?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=A,e.socketRawEndHeaderSequence=I.VSBuffer.fromString(`\r
\r
`);async function v(E,T,k,b,S){E.write(I.VSBuffer.fromString((0,e.makeRawSocketHeaders)(T,k,b)));const _=new h.DisposableStore;try{return await new Promise((w,u)=>{let r;_.add(E.onData(o=>{r?r=I.VSBuffer.concat([r,o],r.byteLength+o.byteLength):r=o;const c=r.indexOf(e.socketRawEndHeaderSequence);if(c===-1)return;w(E),E.pauseData();const g=r.slice(c+e.socketRawEndHeaderSequence.byteLength);g.byteLength&&S.onData.fire(g)})),_.add(E.onClose(o=>u(o??new Error("socket closed")))),_.add(E.onEnd(()=>u(new Error("socket ended"))))})}catch(w){throw E.dispose(),w}finally{_.dispose()}}e.connectManagedSocket=v;class y extends h.Disposable{constructor(T,k){super(),this.debugLabel=T,this.pausableDataEmitter=this._register(new F.PauseableEmitter),this.onData=(...b)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...b)),this.didDisposeEmitter=this._register(new F.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(k.onData),this._register(k.onData.event(b=>this.pausableDataEmitter.fire(b))),this.onClose=this._register(k.onClose).event,this.onEnd=this._register(k.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(T,k){R.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,T,k)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=y}),define(De[64],Ie([1,0,8,5]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,F.createDecorator)("remoteAuthorityResolverService");var h;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class R{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=R;class A{constructor(k,b){this.host=k,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var v;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class y extends I.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof y&&k._code===v.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof y&&k._code===v.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof y&&k._code===v.NoResolverFound}static isInvalidAuthority(k){return k instanceof y&&k._code===v.InvalidAuthority}static isHandled(k){return k instanceof y&&k.isHandled}constructor(k,b=v.Unknown,S){super(k),this._message=k,this._code=b,this._detail=S,this.isHandled=b===v.NotAvailable&&S===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function E(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}e.getRemoteAuthorityPrefix=E}),define(De[65],Ie([1,0,17]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function F(E){return E.scheme===I.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=F;function h(E){if(!E)return;const T=E.indexOf("+");return T<0?E:E.substr(0,T)}e.getRemoteName=h;function R(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(E){const{host:T,port:k}=y(E);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:k}}e.parseAuthorityWithPort=A;function v(E,T){let{host:k,port:b}=y(E);return typeof b>"u"&&(b=T),{host:k,port:b}}e.parseAuthorityWithOptionalPort=v;function y(E){const T=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const k=E.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const b=E.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:E,port:void 0}}}),define(De[25],Ie([1,0,15,5,65]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class y{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,r){if(typeof u>"u"||u===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof u=="string"||typeof r=="string"){const o=typeof u=="string"?u:u.value,c=typeof r=="string"?r:r.value;return I.equalsIgnoreCase(o,c)}return u._lower===r._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=y;class E{get size(){return this._set.size}constructor(u){if(this._set=new Set,u)for(const r of u)this.add(r)}add(u){this._set.add(y.toKey(u))}delete(u){return this._set.delete(y.toKey(u))}has(u){return this._set.has(y.toKey(u))}}e.ExtensionIdentifierSet=E;class T{constructor(){this._map=new Map}clear(){this._map.clear()}delete(u){this._map.delete(y.toKey(u))}get(u){return this._map.get(y.toKey(u))}has(u){return this._map.has(y.toKey(u))}set(u,r){this._map.set(y.toKey(u),r)}values(){return this._map.values()}forEach(u){this._map.forEach(u)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function k(w){return b(w)}e.isApplicationScopedExtension=k;function b(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function S(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function _(w,u){if(u){const r=`onResolveRemoteAuthority:${(0,h.getRemoteName)(u)}`;return!!w.activationEvents?.includes(r)}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[137],Ie([1,0,8,25]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class h{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,v){this._generators.set(A,v)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const v=Object.create(null);for(const y of A){const E=this.readActivationEvents(y);E.length>0&&(v[F.ExtensionIdentifier.toKey(y.identifier)]=E)}return v}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const v=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return v;for(const y in A.contributes){const E=this._generators.get(y);if(!E)continue;const T=A.contributes[y],k=Array.isArray(T)?T:[T];try{E(k,v)}catch(b){(0,I.onUnexpectedError)(b)}}return v}}e.ImplicitActivationEventsImpl=h,e.ImplicitActivationEvents=new h}),define(De[247],Ie([1,0,9,22,21,8,4,3,54,37,31,81,64,65]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const _=30*1e3;var w;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function u(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function r(G){const B=new h.CancellationTokenSource;return setTimeout(()=>B.cancel(),G),B.token}function o(G,B){if(G.isCancellationRequested||B.isCancellationRequested)return h.CancellationToken.Cancelled;const H=new h.CancellationTokenSource;return G.onCancellationRequested(()=>H.cancel()),B.onCancellationRequested(()=>H.cancel()),H.token}class c{get didTimeout(){return this._state==="timedout"}constructor(B){this._state="pending",this._disposables=new v.DisposableStore,this.promise=new Promise((H,me)=>{this._resolvePromise=H,this._rejectPromise=me}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function g(G,B){const H=new c(B);return H.registerDisposable(G.onControlMessage(me=>{const Z=JSON.parse(me.toString()),ie=X(Z);ie?H.reject(ie):H.resolve(Z)})),H.promise}function d(G,B,H,me,Z,ie,re,ye){const oe=new c(ye),de=E.StopWatch.create(!1);return G.info(`Creating a socket (${re})...`),y.mark(`code/willCreateSocket/${ie}`),B.connect(H,me,Z,re).then(ee=>{oe.didTimeout?(y.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${re}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(y.mark(`code/didCreateSocketOK/${ie}`),G.info(`Creating a socket (${re}) was successful after ${de.elapsed()} ms.`),oe.resolve(ee))},ee=>{y.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${re}) returned an error after ${de.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,B){const H=new c(B);return G.then(me=>{H.didTimeout||H.resolve(me)},me=>{H.didTimeout||H.reject(me)}),H.promise}async function n(G,B,H,me){const Z=le(G,B);G.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await d(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,S.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,u(B),`renderer-${u(B)}-${G.reconnectionToken}`,me)}catch(ee){throw G.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let re,ye;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ie,null),re=G.reconnectionProtocol,ye=!1):(re=new k.PersistentProtocol({socket:ie}),ye=!0),G.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,T.generateUuid)()),me),de={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};re.sendControl(F.VSBuffer.fromString(JSON.stringify(de)));try{const ee=await g(re,o(me,r(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const $=new Error("Unexpected handshake message");throw $.code="VSCODE_CONNECTION_ERROR",$}if(G.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),me)){const $=new Error("Refused to connect to unsupported server");throw $.code="VSCODE_CONNECTION_ERROR",$}const pe=await t(G.signService.sign(ee.data),me),Pe={type:"connectionType",commit:G.commit,signedData:pe,desiredConnectionType:B};return H&&(Pe.args=H),G.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(F.VSBuffer.fromString(JSON.stringify(Pe))),{protocol:re,ownsProtocol:ye}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${Z} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${Z} received error control message when negotiating connection. Error:`),G.logService.error(ee)),ye&&J(re),ee}}async function s(G,B,H,me){const Z=Date.now(),ie=le(G,B),{protocol:re,ownsProtocol:ye}=await n(G,B,H,me),oe=new c(me);return oe.registerDisposable(re.onControlMessage(de=>{const ee=JSON.parse(de.toString()),ue=X(ee);ue?(G.logService.error(`${ie} received error control message when negotiating connection. Error:`),G.logService.error(ue),ye&&J(re),oe.reject(ue)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${we(Z)}!`),oe.resolve({protocol:re,firstMessage:ee}))})),oe.promise}async function i(G,B){const{protocol:H}=await s(G,1,void 0,B);return{protocol:H}}async function a(G,B,H){const{protocol:me,firstMessage:Z}=await s(G,2,B,H),ie=Z&&Z.debugPort;return{protocol:me,debugPort:ie}}async function l(G,B,H){const me=Date.now(),Z=le(G,3),{protocol:ie}=await n(G,3,B,H);return G.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${we(me)}!`),ie}async function C(G,B,H){const{connectTo:me,connectionToken:Z}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:me,connectionToken:Z,reconnectionToken:B,reconnectionProtocol:H,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function D(G,B,H){return m(G,async me=>{const{protocol:Z}=await i(me,h.CancellationToken.None);return new V(G,B,H,me.reconnectionToken,Z)})}e.connectRemoteAgentManagement=D;async function p(G,B){return m(G,async H=>{const{protocol:me,debugPort:Z}=await a(H,B,h.CancellationToken.None);return new fe(G,B,H.reconnectionToken,me,Z)})}e.connectRemoteAgentExtensionHost=p;async function m(G,B){for(let me=1;;me++)try{const Z=(0,T.generateUuid)(),ie=await C(G,Z,null);return await B(ie)}catch(Z){if(me<5)G.logService.error(`[remote-connection][attempt ${me}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(Z);else throw G.logService.error(`[remote-connection][attempt ${me}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(Z),j.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(Z)),Z}}async function f(G,B,H){const me=await C(G,(0,T.generateUuid)(),null);return await l(me,{host:B,port:H},h.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function P(G){return(0,I.createCancelablePromise)(B=>new Promise((H,me)=>{const Z=setTimeout(H,G*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),H()})}))}var M;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class N{constructor(B,H){this.reconnectionToken=B,this.millisSinceLastIncomingData=H,this.type=0}}e.ConnectionLostEvent=N;class L{constructor(B,H,me,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=H,this.durationSeconds=me,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=L;class U{constructor(B,H,me){this.reconnectionToken=B,this.millisSinceLastIncomingData=H,this.attempt=me,this.type=2}}e.ReconnectionRunningEvent=U;class x{constructor(B,H,me){this.reconnectionToken=B,this.millisSinceLastIncomingData=H,this.attempt=me,this.type=4}}e.ConnectionGainEvent=x;class O{constructor(B,H,me,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=H,this.attempt=me,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=O;class j extends v.Disposable{static triggerPermanentFailure(B,H,me){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=H,this._permanentFailureHandled=me,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||j._permanentFailure}constructor(B,H,me,Z,ie){super(),this._connectionType=B,this._options=H,this.reconnectionToken=me,this.protocol=Z,this._reconnectionFailureIsFatal=ie,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(re=>{const ye=ve(this._connectionType,this.reconnectionToken,!0);re?re.type===0?(this._options.logService.info(`${ye} received socket close event (hadError: ${re.hadError}).`),re.error&&this._options.logService.error(re.error)):(this._options.logService.info(`${ye} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this._options.logService.error(re.event)):this._options.logService.info(`${ye} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(re=>{const ye=ve(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ye} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),j._instances.push(this),this._register((0,v.toDisposable)(()=>{const re=j._instances.indexOf(this);re>=0&&j._instances.splice(re,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(j._permanentFailureMillisSinceLastIncomingData,j._permanentFailureAttempt,j._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const B=ve(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let me=-1;do{me++;const Z=me<H.length?H[me]:H[H.length-1];try{if(Z>0){const re=P(Z);this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,re)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await re}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1)),this._options.logService.info(`${B} resolving connection...`);const ie=await C(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${ie.connectTo}...`),await this._reconnect(ie,r(_)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(me>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ie)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if((0,R.isCancellationError)(ie)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if(ie instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,b.RemoteAuthorityResolverError.isHandled(ie));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(B,H,me){this._reconnectionFailureIsFatal?j.triggerPermanentFailure(B,H,me):this._gotoPermanentFailure(B,H,me)}_gotoPermanentFailure(B,H,me){this._onDidStateChange.fire(new O(this.reconnectionToken,B,H,me)),J(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=j;class V extends j{constructor(B,H,me,Z,ie){super(1,B,Z,ie,!0),this.client=this._register(new k.Client(ie,{remoteAuthority:H,clientId:me},B.ipcLogger))}async _reconnect(B,H){await i(B,H)}}e.ManagementPersistentConnection=V;class fe extends j{constructor(B,H,me,Z,ie){super(2,B,me,Z,!1),this._startArguments=H,this.debugPort=ie}async _reconnect(B,H){await a(B,this._startArguments,H)}}e.ExtensionHostPersistentConnection=fe;function J(G){try{G.acceptDisconnect();const B=G.getSocket();G.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function X(G){if(G&&G.type==="error"){const B=new Error(`Connection error: ${G.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function z(G,B){for(;G.length<B;)G+=" ";return G}function Q(G,B){return`[remote-connection][${z(u(G),13)}][${B.substr(0,5)}\u2026]`}function ve(G,B,H){return`${Q(G,B)}[${H?"reconnect":"initial"}]`}function le(G,B){return`${ve(B,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function we(G){return`${Date.now()-G} ms`}}),define(De[248],Ie([1,0,3,5]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,F.createDecorator)("remoteSocketFactoryService");class h{constructor(){this.factories={}}register(A,v){return this.factories[A]??=[],this.factories[A].push(v),(0,I.toDisposable)(()=>{const y=this.factories[A]?.indexOf(v);typeof y=="number"&&y>=0&&this.factories[A]?.splice(y,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(y=>y.supports(A))}connect(A,v,y,E){const T=this.getSocketFactory(A);if(!T)throw new Error(`No socket factory found for ${A}`);return T.connect(A,v,y,E)}}e.RemoteSocketFactoryService=h}),define(De[249],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(h){try{const R=await this.getValidator();if(R){const A=String(I._nextId++);return this.validators.set(A,R),{id:A,data:R.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,R){if(!h.id)return!0;const A=this.validators.get(h.id);if(!A)return!1;this.validators.delete(h.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.signValue(h)}catch{}return h}}e.AbstractSignService=I}),define(De[106],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(De[138],Ie([1,0,249]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class F extends I.AbstractSignService{getValidator(){return this.vsda().then(R=>new R.validator)}signValue(R){return this.vsda().then(A=>new A.signer().sign(R))}vsda(){return new Promise((R,A)=>ge(["vsda"],R,A))}}e.SignService=F}),define(De[250],Ie([1,0,12,47,31]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(y){if(I.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function A(y,E,T,k,b,S,_,w){const u=Object.create(null);u["common.machineId"]=S,u.sessionID=(0,h.generateUuid)()+Date.now(),u.commitHash=k,u.version=b,u["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,I.PlatformToString)(I.platform),u["common.nodePlatform"]=F.platform,u["common.nodeArch"]=T,u["common.product"]=w||"desktop",_&&(u["common.msftInternal"]=_);let r=0;const o=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.isLinuxSnap&&(u["common.snap"]="true");const c=R(E);return c&&(u["common.platformDetail"]=c),u}e.resolveCommonProperties=A;function v(y){const E=F.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return y.some(k=>T===k)}e.verifyMicrosoftInternalDomain=v}),define(De[251],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var F;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var h;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(De[85],Ie([1,0,23,18,4,49,65,250,251]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class E{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=E;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class k{async publicLog(a,l,C){}async publicLogError(a,l,C){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,a){return h.Event.debounce(a.onDidChangeConfiguration,(C,D)=>{const p=C?new Set([...C.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:p}},1e3,!0)(C=>{C.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(C.source),configurationKeys:Array.from(C.affectedKeys)})})}e.configurationTelemetry=b;function S(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=S;function _(i,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=_;function w(i){const a=i.getValue(y.TELEMETRY_SETTING_ID),l=i.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function u(i){const a={},l={},C={};c(i,C);for(let D in C){D=D.length>150?D.substr(D.length-149):D;const p=C[D];typeof p=="number"?l[D]=p:typeof p=="boolean"?l[D]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${p.length}`),a[D]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(a[D]=p)}return{properties:a,measurements:l}}e.validateTelemetryData=u;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(i){if(!i)return"none";const a=(0,A.getRemoteName)(i);return r.has(a)?a:"other"}e.cleanRemoteAuthority=o;function c(i,a,l=0,C){if(i)for(const D of Object.getOwnPropertyNames(i)){const p=i[D],m=C?C+D:D;Array.isArray(p)?a[m]=(0,I.safeStringify)(p):p instanceof Date?a[m]=p.toISOString():(0,F.isObject)(p)?l<2?c(p,a,l+1,m+"."):a[m]=(0,I.safeStringify)(p):a[m]=p}}function g(i,a){const l=i.msftInternalDomains||[],C=a.getValue("telemetry.internalTesting");return(0,v.verifyMicrosoftInternalDomain)(l)||C}e.isInternalTelemetry=g;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=d;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const C=[];for(const f of a)for(;;){const P=f.exec(i);if(!P)break;C.push([P.index,f.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(l="";;){const f=p.exec(i);if(!f)break;const P=C.some(([M,N])=>f.index<N&&M<p.lastIndex);!D.test(f[0])&&!P&&(l+=i.substring(m,f.index)+"<REDACTED: user-file-path>",m=p.lastIndex)}return m<i.length&&(l+=i.substr(m)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function s(i,a){return(0,I.cloneAndChange)(i,l=>{if(l instanceof E||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let C=l.replaceAll("%20"," ");C=t(C,a);for(const D of a)C=C.replace(D,"");return C=n(C),C}})}e.cleanData=s}),define(De[252],Ie([1,0,15,132,25,12,2,8,47,85]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,I.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=T;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,a,l)}static parse(i){const a=k.exec(i);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(s){const i=S.exec(s);return i&&i[1]?[u(i[1]),i[2]]:[u(s),void 0]}e.getIdAndVersion=_;function w(s,i){return`${s}.${i}`}e.getExtensionId=w;function u(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=u;function r(s,i){return u(w(s??h.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=r;function o(s,i){const a=[],l=C=>{for(const D of a)if(D.some(p=>T(i(p),i(C))))return D;return null};for(const C of s){const D=l(C);D?D.push(C):a.push([C])}return a}e.groupByExtension=o;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function g(s){return{id:new E.TelemetryTrustedValue(s.identifier.id),name:new E.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new h.ExtensionIdentifier("pprice.better-merge");function d(s,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const C=l.shift();if(C&&a.every(D=>!T(D.identifier,{id:C}))){const D=s.filter(p=>T(p.identifier,{id:C}));D.length===1&&(a.push(D[0]),l.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=d;async function t(s,i){if(!R.isLinux)return!1;let a;try{a=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){i.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(C))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(s,i){const a=await t(s,i),l=(0,F.getTargetPlatform)(a?"alpine":R.platform,y.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=n}),define(De[253],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=I;function F(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=F;function h(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=h;function R(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=R;function A(y){return Array.from(y.entries()).map(E=>[E[0],I(E[1].map),F(E[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function v(y){return new Map(y.map(E=>[E[0],{map:h(E[1]),descriptionMap:R(E[2])}]))}e.deserializeEnvironmentVariableCollections=v}),define(De[254],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(h){this._callback=h,this._terminalBufferMap=new Map}dispose(){for(const h of this._terminalBufferMap.values())h.dispose()}startBuffering(h,R,A=5){const v=R(y=>{const E=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(h);if(T){T.data.push(E);return}const k=setTimeout(()=>this.flushBuffer(h),A);T={data:[E],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(h),v.dispose()}},this._terminalBufferMap.set(h,T)});return v}stopBuffering(h){this._terminalBufferMap.get(h)?.dispose()}flushBuffer(h){const R=this._terminalBufferMap.get(h);R&&(this._terminalBufferMap.delete(h),this._callback(h,R.data.join("")))}}e.TerminalDataBufferer=I}),define(De[255],Ie([1,0,9,78,59,4,18,2,199,105,42]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(g){function d(t,n){let s=t.defaults;for(;h.ThemeIcon.isThemeIcon(s);){const i=_.getIcon(s.id);if(!i)return;s=i.defaults}return s}g.getDefinition=d})(k||(e.IconContribution=k={}));var b;(function(g){function d(n){return{weight:n.weight,style:n.style,src:n.src.map(s=>({format:s.format,location:s.location.toString()}))}}g.toJSONObject=d;function t(n){const s=i=>(0,A.isString)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.isString)(i.format)&&(0,A.isString)(i.location)))return{weight:s(n.weight),style:s(n.style),src:n.src.map(i=>({format:i.format,location:v.URI.parse(i.location)}))}}g.fromJSONObject=t})(b||(e.IconFontDefinition=b={}));class S{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(d,t,n,s){const i=this.iconsById[d];if(i){if(n&&!i.description){i.description=n,this.iconSchema.properties[d].markdownDescription=`${n} $(${d})`;const C=this.iconReferenceSchema.enum.indexOf(d);C!==-1&&(this.iconReferenceSchema.enumDescriptions[C]=n),this._onDidChange.fire()}return i}const a={id:d,description:n,defaults:t,deprecationMessage:s};this.iconsById[d]=a;const l={$ref:"#/definitions/icons"};return s&&(l.deprecationMessage=s),n&&(l.markdownDescription=`${n}: $(${d})`),this.iconSchema.properties[d]=l,this.iconReferenceSchema.enum.push(d),this.iconReferenceSchema.enumDescriptions.push(n||""),this._onDidChange.fire(),{id:d}}deregisterIcon(d){delete this.iconsById[d],delete this.iconSchema.properties[d];const t=this.iconReferenceSchema.enum.indexOf(d);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(d=>this.iconsById[d])}getIcon(d){return this.iconsById[d]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(d,t){const n=this.iconFontsById[d];return n||(this.iconFontsById[d]=t,this._onDidChange.fire(),t)}deregisterIconFont(d){delete this.iconFontsById[d]}getIconFont(d){return this.iconFontsById[d]}toString(){const d=(i,a)=>i.id.localeCompare(a.id),t=i=>{for(;h.ThemeIcon.isThemeIcon(i.defaults);)i=this.iconsById[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(i=>this.iconsById[i]);for(const i of s.filter(a=>!!a.description).sort(d))n.push(`|<i class="${t(i)}"></i>|${i.id}|${h.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of s.filter(a=>!h.ThemeIcon.isThemeIcon(a.defaults)).sort(d))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const _=new S;T.Registry.add(e.Extensions.IconContribution,_);function w(g,d,t,n){return _.registerIcon(g,d,t,n)}e.registerIcon=w;function u(){return _}e.getIconRegistry=u;function r(){const g=(0,F.getCodiconFontCharacters)();for(const d in g){const t="\\"+g[d].toString(16);_.registerIcon(d,{fontCharacter:t})}}r(),e.iconsSchemaId="vscode://schemas/icons";const o=T.Registry.as(E.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,_.getIconSchema());const c=new I.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);_.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=w("widget-close",F.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=w("goto-previous-location",F.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=w("goto-next-location",F.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=h.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=h.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(De[86],Ie([1,0,4,49,5,13]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,h.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,h.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A||(e.TunnelProtocol=A={}));var v;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(v||(e.TunnelPrivacyId=v={}));function y(u){return!!u.forwardPort}e.isTunnelProvider=y;var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function T(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=b;function S(u,r,o,c){if(o===1)return!1;if(o===2&&b(r)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(g?.length===4&&parseInt(g[1])>=18)return!1}return u<1024}e.isPortPrivileged=S;class _{constructor(r,o,c){this.remoteAddress=r,this.localAddress=o,this._dispose=c,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let w=class{constructor(r,o){this.logService=r,this.configurationService=o,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const r=this.configurationService.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this._tunnelProvider=r,r?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this._canElevate=r.elevation,this._privacyOptions=r.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const r=[],o=Array.from(this._tunnels.values());for(const c of o){const g=Array.from(c.values());for(const d of g){const t=await d.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this._tunnels.values()){for(const{value:o}of r.values())await o.then(c=>typeof c!="string"?c?.dispose():void 0);r.clear()}this._tunnels.clear()}setEnvironmentTunnel(r,o,c,g,d){this.addTunnelToMap(r,o,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:o,localAddress:c,privacy:g,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,o){(b(r)||k(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(r,o);if(c)return++c.refcount,c.value}openTunnel(r,o,c,g,d,t=!1,n,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${c} on local port ${d}.`);const i=this._tunnelProvider??r;if(!i)return;if(o||(o="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.retainOrCreateTunnel(i,o,c,g,d,t,n,s);return a?a.then(l=>{if(l){if(typeof l=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(o,c),l}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(o,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(l);return(l.tunnelRemoteHost!==o||l.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&l.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const o=this._tunnels.get(r.tunnelRemoteHost);if(o){const c=o.get(r.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(r.tunnelRemoteHost,r.tunnelRemotePort,c))}}}}async tryDisposeTunnel(r,o,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${o}.`);const g=c.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(r)&&this._tunnels.get(r).delete(o),g}}async closeTunnel(r,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${o} `);const c=this._tunnels.get(r);if(c&&c.has(o)){const g=c.get(o);g.refcount=0,await this.tryDisposeTunnel(r,o,g)}}addTunnelToMap(r,o,c){this._tunnels.has(r)||this._tunnels.set(r,new Map),this._tunnels.get(r).set(o,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(r,o){const c=this._tunnels.get(r);if(c){const g=c.get(o),d=g?await g.value:void 0;(!d||typeof d=="string")&&c.delete(o),c.size===0&&this._tunnels.delete(r)}}getTunnelFromMap(r,o){const c=[r];k(r)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):b(r)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const g=c.map(d=>this._tunnels.get(d));for(const d of g){const t=d?.get(o);if(t)return t}}canTunnel(r){return!!T(r)}createWithProvider(r,o,c,g,d,t,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${c} on local port ${g}.`);const s=c;this._factoryInProgress.add(s);const i=g===void 0?c:g,a={elevationRequired:d?this.isPortPrivileged(i):!1},l={remoteAddress:{host:o,port:c},localAddressPort:g,privacy:t,public:t?t!==v.Private:void 0,protocol:n},C=r.forwardPort(l,a);return C?(this.addTunnelToMap(o,c,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),C}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=je([$e(0,R.ILogService),$e(1,F.IConfigurationService)],w)}),define(De[256],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(De[257],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var F;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(De[258],Ie([1,0,17]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function F(y){return y.scheme!==I.Schemas.file&&y.scheme!==I.Schemas.vscodeRemote}e.isVirtualResource=F;function h(y){if(y.folders.length)return y.folders.every(E=>F(E.uri))?y.folders[0].uri:void 0;if(y.configuration&&F(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=h;function R(y){return h(y)?.scheme}e.getVirtualWorkspaceScheme=R;function A(y){return h(y)?.authority}e.getVirtualWorkspaceAuthority=A;function v(y){return h(y)!==void 0}e.isVirtualWorkspace=v}),define(De[43],Ie([1,0,201,16,77,24,2,5,17]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,v.createDecorator)("contextService");function E(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=E;function T(i){return typeof i?.id=="string"&&!E(i)&&!b(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=k;function b(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=b;function S(i){const a=i;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=S;var _;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(_||(e.WorkbenchState=_={}));function w(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=w;function u(i){const a=i;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=u;class r{constructor(a,l,C,D,p){this._id=a,this._transient=C,this._configuration=D,this._ignorePathCasing=p,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=r;class o{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=o;function c(i){return new o({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(i,a){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function d(i){let a;return A.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=d,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,a){return!g(i,a)&&!d(i)}e.isSavedWorkspace=n;function s(i){return(typeof i=="string"?(0,F.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[259],Ie([1,0,52,4,3,24,2,200,131,30,5,13,43,28,256,9,31,15,18]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function g(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function d(i,a){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:a}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:a}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=d;function t(i,a,l,C,D,p){return{id:i,name:a,location:l,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:p&&D?.useDefaultFlags?.globalState?p.globalStorageHome:(0,R.joinPath)(l,"globalStorage"),settingsResource:p&&D?.useDefaultFlags?.settings?p.settingsResource:(0,R.joinPath)(l,"settings.json"),keybindingsResource:p&&D?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,R.joinPath)(l,"keybindings.json"),tasksResource:p&&D?.useDefaultFlags?.tasks?p.tasksResource:(0,R.joinPath)(l,"tasks.json"),snippetsHome:p&&D?.useDefaultFlags?.snippets?p.snippetsHome:(0,R.joinPath)(l,"snippets"),extensionsResource:p&&D?.useDefaultFlags?.extensions?p.extensionsResource:(0,R.joinPath)(l,"extensions.json"),cacheHome:(0,R.joinPath)(C,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let n=class extends h.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(a,l,C,D){super(),this.environmentService=a,this.fileService=l,this.uriIdentityService=C,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new F.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new F.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new F.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new F.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(a){this.enabled!==a&&(this._profilesObject=void 0,this.enabled=a)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const a=this.createDefaultProfile(),l=[a];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,o.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}l.push(t((0,R.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},a))}}catch(p){this.logService.error(p)}const C=new S.ResourceMap,D=new Map;if(l.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[m,f]of Object.entries(p.workspaces)){const P=A.URI.parse(m),M=l.find(N=>N.id===f);M&&C.set(P,M)}if(p.emptyWindows)for(const[m,f]of Object.entries(p.emptyWindows)){const P=l.find(M=>M.id===f);P&&D.set(m,P)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:l,workspaces:C,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const a=t("__default__profile__",(0,v.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...a,extensionsResource:this.getDefaultProfileExtensionsLocation()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",C=new RegExp(`${(0,r.escapeRegExpCharacters)(l)}\\s(\\d+)`);let D=0;for(const m of this.profiles){const f=C.exec(m.name),P=f?parseInt(f[1]):0;D=P>D?P:D}const p=`${l} ${D+1}`;return this.createProfile((0,I.hash)((0,u.generateUuid)()).toString(16),p,{transient:!0},a)}async createNamedProfile(a,l,C){return this.createProfile((0,I.hash)((0,u.generateUuid)()).toString(16),a,l,C)}async createProfile(a,l,C,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(a,l,C);return D&&await this.setProfileForWorkspace(D,p),p}async doCreateProfile(a,l,C){if(!(0,o.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(l);return D||(D=(async()=>{try{const p=this.profiles.find(P=>P.name===l||P.id===a);if(p)return p;const m=t(a,l,(0,R.joinPath)(this.profilesHome,a),this.profilesCacheHome,C,this.defaultProfile);await this.fileService.createFolder(m.location);const f=[];return this._onWillCreateProfile.fire({profile:m,join(P){f.push(P)}}),await w.Promises.settled(f),this.updateProfiles([m],[],[]),m}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,D)),D}async updateProfile(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let C=this.profiles.find(D=>D.id===a.id);if(!C)throw new Error(`Profile '${a.name}' does not exist`);return C=t(C.id,l.name??C.name,C.location,this.profilesCacheHome,{shortName:l.shortName??C.shortName,icon:l.icon===null?void 0:l.icon??C.icon,transient:l.transient??C.isTransient,useDefaultFlags:l.useDefaultFlags??C.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[C]),C}async removeProfile(a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(D=>D.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const C=[];this._onWillRemoveProfile.fire({profile:l,join(D){C.push(D)}});try{await Promise.allSettled(C)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{await this.fileService.del(l.cacheHome,{recursive:!0})}catch(D){(0,E.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=this.profiles.find(D=>D.id===l.id);if(!C)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(a,C)}unsetWorkspace(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(a,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const a=await this.fileService.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(C=>!this.uriIdentityService.extUri.isEqual(C.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const a=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.getWorkspace(a);return A.URI.isUri(l)?this.transientProfilesObject.workspaces.get(l)??this.profilesObject.workspaces.get(l):this.transientProfilesObject.emptyWindows.get(l)??this.profilesObject.emptyWindows.get(l)}getWorkspace(a){return(0,b.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,b.isWorkspaceIdentifier)(a)?a.configPath:a.id}isProfileAssociatedToWorkspace(a){return!!([...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location)))}updateProfiles(a,l,C){const D=[...this.profiles,...a],p=[];this.transientProfilesObject.profiles=[];for(let m of D)m.isDefault||l.some(f=>m.id===f.id)||(m=C.find(f=>m.id===f.id)??m,m.isTransient?this.transientProfilesObject.profiles.push(m):p.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(a,l,C)}triggerProfilesChanges(a,l,C){this._onDidChangeProfiles.fire({added:a,removed:l,updated:C,all:this.profiles})}updateWorkspaceAssociation(a,l,C){C=l?.isTransient?!0:C,C||this.updateWorkspaceAssociation(a,void 0,!0);const D=this.getWorkspace(a),p=C?this.transientProfilesObject:this.profilesObject;A.URI.isUri(D)?(p.workspaces.delete(D),l&&p.workspaces.set(D,l)):(p.emptyWindows.delete(D),l&&p.emptyWindows.set(D,l)),C||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const a={};for(const[C,D]of this.profilesObject.workspaces.entries())a[C.toString()]=D.id;const l={};for(const[C,D]of this.profilesObject.emptyWindows.entries())l[C.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:a,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(a){const l={},C=this.createDefaultProfile();if(a.workspaces)for(const[p,m]of Object.entries(a.workspaces)){const f=A.URI.parse(m);l[p]=this.uriIdentityService.extUri.isEqual(f,C.location)?C.id:this.uriIdentityService.extUri.basename(f)}const D={};if(a.emptyWindows)for(const[p,m]of Object.entries(a.emptyWindows)){const f=A.URI.parse(m);D[p]=this.uriIdentityService.extUri.isEqual(f,C.location)?C.id:this.uriIdentityService.extUri.basename(f)}return{workspaces:l,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(a){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(a){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=n,e.UserDataProfilesService=n=je([$e(0,y.IEnvironmentService),$e(1,E.IFileService),$e(2,_.IUriIdentityService),$e(3,k.ILogService)],n);class s extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(a){this.storedProfiles=a}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(a){this.storedProfileAssociations=a}}e.InMemoryUserDataProfilesService=s}),define(De[260],Ie([1,0,9,4,3,54,18,184,5,259]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,y.createDecorator)("storageService");var T;(function(o){o[o.NONE=0]="NONE",o[o.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var k;(function(o){o[o.APPLICATION=-1]="APPLICATION",o[o.PROFILE=0]="PROFILE",o[o.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var b;(function(o){o[o.USER=0]="USER",o[o.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function S(o){const c=o.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=S;class _ extends h.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:_.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new F.PauseableEmitter),this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new h.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,g,d){return F.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(g===void 0||t.key===g),d)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,h.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,g){const{key:d,external:t}=g;if(d===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:d,target:this.getKeyTargets(c)[d],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,g,d){return this.getStorage(g)?.get(c,d)}getBoolean(c,g,d){return this.getStorage(g)?.getBoolean(c,d)}getNumber(c,g,d){return this.getStorage(g)?.getNumber(c,d)}getObject(c,g,d){return this.getStorage(g)?.getObject(c,d)}storeAll(c,g){this.withPausedEmitters(()=>{for(const d of c)this.store(d.key,d.value,d.scope,d.target,g)})}store(c,g,d,t,n=!1){if((0,A.isUndefinedOrNull)(g)){this.remove(c,d,n);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,t),this.getStorage(d)?.set(c,g,n)})}remove(c,g,d=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,g,void 0),this.getStorage(g)?.delete(c,d)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,g){const d=[],t=this.getKeyTargets(c);for(const n of Object.keys(t))t[n]===g&&d.push(n);return d}updateKeyTarget(c,g,d,t=!1){const n=this.getKeyTargets(g);typeof d=="number"?n[c]!==d&&(n[c]=d,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n),t)):typeof n[c]=="number"&&(delete n[c],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const g=this.getStorage(c);return g?S(g):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=T.NONE){this._onWillSaveState.fire({reason:c});const g=this.getStorage(-1),d=this.getStorage(0),t=this.getStorage(1);switch(c){case T.NONE:await I.Promises.settled([g?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await I.Promises.settled([g?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,d=this.getStorage(1)?.items??new Map;return r(c,g,d,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,g){return this.emitWillSaveState(T.NONE),(0,E.isUserDataProfile)(c)?this.switchToProfile(c,g):this.switchToWorkspace(c,g)}canSwitchProfile(c,g){return!(c.id===g.id||w(g)&&w(c))}switchData(c,g,d){this.withPausedEmitters(()=>{const t=new Set;for(const[n,s]of c)t.add(n),g.get(n)!==s&&this.emitDidChangeValue(d,{key:n,external:!0});for(const[n]of g.items)t.has(n)||this.emitDidChangeValue(d,{key:n,external:!0})})}}e.AbstractStorageService=_;function w(o){return o.isDefault||!!o.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=w;class u extends _{constructor(){super(),this.applicationStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=u;async function r(o,c,g,d,t,n){const s=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,a=new Map;o.forEach((P,M)=>{i.set(M,P),a.set(M,s(P))});const l=new Map,C=new Map;c.forEach((P,M)=>{l.set(M,P),C.set(M,s(P))});const D=new Map,p=new Map;g.forEach((P,M)=>{D.set(M,P),p.set(M,s(P))}),console.group(d!==t?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const m=[];if(i.forEach((P,M)=>{m.push({key:M,value:P})}),console.table(m),console.groupEnd(),console.log(a),d!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((M,N)=>{P.push({key:N,value:M})}),console.table(P),console.groupEnd(),console.log(C)}console.group(`Storage: Workspace (path: ${n})`);const f=[];D.forEach((P,M)=>{f.push({key:M,value:P})}),console.table(f),console.groupEnd(),console.log(p)}e.logStorage=r}),define(De[107],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(h){this.id=h,this._data=new Map,this._idPool=1}add(h){const R=this._idPool++;return this._data.set(R,h),this.logDebugInfo(),R}get(h,R){return this._data.has(h)?this._data.get(h)[R]:void 0}delete(h){this._data.delete(h),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(De[55],Ie([1,0,17,24,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(v=>{const y=this._providerInfo.get(v.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(v,y){y===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,y)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,h.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(De[261],Ie([1,0,206,13,241,26]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends h.LogService{constructor(y,E,T){const k=T.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",b=T.remote.isRemote?(0,I.localize)(0,null):y?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(k,{name:b}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([$e(1,F.ILoggerService),$e(2,R.IExtHostInitDataService)],A)}),define(De[262],Ie([1,0,9]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,v,y){this._deferredPromises=new Map,this._id=A,this._shared=v,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(E=>(this._value=E,this)),this._storageListener=this._storage.onDidChangeStorage(E=>{E.shared===this._shared&&E.key===this._id&&(this._value=E.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const E=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of E.values())T.complete()}catch(T){for(const k of E.values())k.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,v){let y=this._value[A];return typeof y>"u"&&(y=v),y}update(A,v){this._value[A]=v;const y=this._deferredPromises.get(A);if(y!==void 0)return y.p;const E=new I.DeferredPromise;return this._deferredPromises.set(A,E),this._scheduler.isScheduled()||this._scheduler.schedule(),E.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class h extends F{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,v){super(A.identifier.value,!0,v),this._extension=A}}e.ExtensionGlobalMemento=h}),define(De[263],Ie([1,0,4,2]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class h{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,v,y,E){const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(v.value,y,E);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(A,v){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptDirty(v)}$acceptModelSaved(A){const v=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));this._onDidSaveNotebookDocument.fire(v.apiNotebook)}}e.ExtHostNotebookDocuments=h}),define(De[20],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class F{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=F}),define(De[264],Ie([1,0,25,4]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class h{#e;constructor(A,v){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(A.identifier),this.#e=v,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(A){return this.#e.get(this._id,A)}store(A,v){return this.#e.store(this._id,A,v)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=h}),define(De[66],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class F{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(De[265],Ie([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(y){let E=this.buffers.indexOf(y);return E<0&&(E=this.buffers.length,this.buffers.push(y)),E}}function h(v,y){if(y.serializeBuffersForPostMessage){const E=new F,k=JSON.stringify(v,(S,_)=>{if(_ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(_)};if(ArrayBuffer.isView(_)){const w=R(_);if(w)return{$$vscode_array_buffer_reference$$:!0,index:E.add(_.buffer),view:{type:w,byteLength:_.byteLength,byteOffset:_.byteOffset}}}return _}),b=E.buffers.map(S=>{const _=new Uint8Array(S);return I.VSBuffer.wrap(_)});return{message:k,buffers:b}}else return{message:JSON.stringify(v),buffers:[]}}e.serializeWebviewMessage=h;function R(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(v,y){const E=y.map(b=>{const S=new ArrayBuffer(b.byteLength);return new Uint8Array(S).set(b.buffer),S}),T=y.length?(b,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const _=S,{index:w}=_,u=E[w];if(_.view)switch(_.view.type){case 1:return new Int8Array(u,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return S}:void 0;return{message:JSON.parse(v,T),arrayBuffers:E}}e.deserializeWebviewMessage=A}),define(De[266],Ie([1,0,267,373,374,60,2,13,375]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const E=!1;function T(c,g,d,t,n,s){const i=s.environment.useHostProxy,a=typeof i=="boolean"?i:!s.remote.isRemote,l={resolveProxy:p=>c.resolveProxy(p),lookupProxyAuthorization:u.bind(void 0,t,n,g,{},s.remote.isRemote),getProxyURL:()=>g.getConfiguration("http").get("proxy"),getProxySupport:()=>g.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>b(g),getSystemCertificatesV2:()=>S(g),log:(p,m,...f)=>{switch(p){case y.LogLevel.Trace:t.trace(m,...f);break;case y.LogLevel.Debug:t.debug(m,...f);break;case y.LogLevel.Info:t.info(m,...f);break;case y.LogLevel.Warning:t.warn(m,...f);break;case y.LogLevel.Error:t.error(m,...f);break;case y.LogLevel.Critical:t.error(m,...f);break;case y.LogLevel.Off:break;default:P(p,m,f);break}function P(M,N,...L){t.error("Unknown log level",M),t.error(N,...L)}},getLogLevel:()=>{const p=t.getLevel();switch(p){case v.LogLevel.Trace:return y.LogLevel.Trace;case v.LogLevel.Debug:return y.LogLevel.Debug;case v.LogLevel.Info:return y.LogLevel.Info;case v.LogLevel.Warning:return y.LogLevel.Warning;case v.LogLevel.Error:return y.LogLevel.Error;case v.LogLevel.Off:return y.LogLevel.Off;default:return m(p)}function m(f){return t.error("Unknown log level",f),y.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},C=(0,y.createProxyResolver)(l),D=k(l,C);return w(d,D)}e.connectProxyResolver=T;function k(c,g){return{http:Object.assign(I,(0,y.createHttpPatch)(c,I,g)),https:Object.assign(F,(0,y.createHttpPatch)(c,F,g)),net:Object.assign(R,(0,y.createNetPatch)(c,R)),tls:Object.assign(h,(0,y.createTlsPatch)(c,h))}}function b(c){const g=c.getConfiguration("http");return!g.get("experimental.systemCertificatesV2",E)&&!!g.get("systemCertificates")}function S(c){const g=c.getConfiguration("http");return!!g.get("experimental.systemCertificatesV2",E)&&!!g.get("systemCertificates")}const _=new Map;function w(c,g){return c.getExtensionPathIndex().then(d=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,a,l){if(i==="net")return g.net;if(i==="tls")return g.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const C=d.findSubstr(A.URI.file(a.filename));let D=_.get(C);if(D||_.set(C,D={}),!D[i]){const p=g[i];D[i]={...p}}return D[i]}})}async function u(c,g,d,t,n,s,i,a){const l=t[s];i&&(t[s]=i),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${l}`);const C=i||l,D=Array.isArray(C)?C:typeof C=="string"?[C]:[];if(o(g,D,n),D.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const p=await new Promise((N,L)=>{ge(["kerberos"],N,L)}),m=new URL(s),f=d.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${f}`),"Negotiate "+await(await p.initializeClient(f)).step("")}catch(p){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let r=!1;function o(c,g,d){r||!g.length||(r=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:g.map(t=>t.split(" ")[0]).join(","),extensionHostType:d?"remote":"local"}))}}),define(De[268],Ie([1,0,128]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function F(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(R){return new I.URITransformer(F(R))}e.createURITransformer=h}),define(De[139],Ie([1,0,216,18,2,3,5,42,30,17,46,176,38]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var _;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(_||(e.EditorPaneSelectionCompareResult=_={}));function w(le){const we=le;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.isEditorPaneWithSelection=w;function u(le,we,G){for(const B of G.visibleEditorPanes)if(B.group.id===we&&le.matches(B.input))return B.getViewState()}e.findViewStateForEditor=u;function r(le){if(l(le))return!1;const we=le;return h.URI.isUri(we?.resource)}e.isResourceEditorInput=r;function o(le){if(l(le))return!1;const we=le;return we?.original!==void 0&&we.modified!==void 0}e.isResourceDiffEditorInput=o;function c(le){if(l(le)||o(le))return!1;const we=le;return we?.primary!==void 0&&we.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function g(le){if(l(le))return!1;const we=le;return we?we.resource===void 0||we.resource.scheme===E.Schemas.untitled||we.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function d(le){if(l(le))return!1;const we=le;return h.URI.isUri(we?.base?.resource)&&h.URI.isUri(we?.input1?.resource)&&h.URI.isUri(we?.input2?.resource)&&h.URI.isUri(we?.result?.resource)}e.isResourceMergeEditorInput=d;var t;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(we,G){let B=this.mapIdToSaveSource.get(we);return B||(B={source:we,label:G},this.mapIdToSaveSource.set(we,B)),B.source}getSourceLabel(we){return this.mapIdToSaveSource.get(we)?.label??we}}e.SaveSourceRegistry=new s;var i;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends R.Disposable{}e.AbstractEditorInput=a;function l(le){return le instanceof a}e.isEditorInput=l;function C(le){const we=le;return h.URI.isUri(we?.preferredResource)}function D(le){const we=le;return l(we?.primary)&&l(we?.secondary)}e.isSideBySideEditorInput=D;function p(le){const we=le;return l(we?.modified)&&l(we?.original)}e.isDiffEditorInput=p;function m(le,we,G,B,H){return ve(B,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const me={...G,limits:{size:Number.MAX_VALUE}};le.openEditor(we,me)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>H.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.createTooLargeFileError=m;function f(le){return l(le?.editor)}e.isEditorInputWithOptions=f;function P(le){const we=le;return f(le)&&we?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function M(le){const we=le;return typeof we?.groupId=="number"&&l(we.editor)}e.isEditorIdentifier=M;var N;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var L;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var U;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class x{getOriginalUri(we,G){if(!we)return;if(d(we))return e.EditorResourceAccessor.getOriginalUri(we.result,G);if(G?.supportSideBySide){const{primary:H,secondary:me}=this.getSideEditors(we);if(H&&me){if(G?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===U.ANY)return this.getOriginalUri(H,{filterByScheme:G.filterByScheme})??this.getOriginalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===U.PRIMARY?H:me}}if(o(we)||c(we)||d(we))return;const B=C(we)?we.preferredResource:we.resource;return!B||!G||!G.filterByScheme?B:this.filterUri(B,G.filterByScheme)}getSideEditors(we){return D(we)||c(we)?{primary:we.primary,secondary:we.secondary}:p(we)||o(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,G){if(!we)return;if(d(we))return e.EditorResourceAccessor.getCanonicalUri(we.result,G);if(G?.supportSideBySide){const{primary:H,secondary:me}=this.getSideEditors(we);if(H&&me){if(G?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===U.ANY)return this.getCanonicalUri(H,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===U.PRIMARY?H:me}}if(o(we)||c(we)||d(we))return;const B=we.resource;return!B||!G||!G.filterByScheme?B:this.filterUri(B,G.filterByScheme)}filterUri(we,G){if(Array.isArray(G)){if(G.some(B=>we.scheme===B))return we}else if(G===we.scheme)return we}}var O;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function j(le,we,G,B){if(!le.isSticky(we))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return G===O.MOUSE||G===O.KEYBOARD;case"mouse":return G===O.MOUSE;case"keyboard":return G===O.KEYBOARD}return!1}e.preventEditorClose=j,e.EditorResourceAccessor=new x;var V;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class fe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(we){const G=this.instantiationService=we.get(A.IInstantiationService);for(const[B,H]of this.editorSerializerConstructors)this.createEditorSerializer(B,H,G);this.editorSerializerConstructors.clear()}createEditorSerializer(we,G,B){const H=B.createInstance(G);this.editorSerializerInstances.set(we,H)}registerFileEditorFactory(we){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=we}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(we,G){if(this.editorSerializerConstructors.has(we)||this.editorSerializerInstances.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.instantiationService?this.createEditorSerializer(we,G,this.instantiationService):this.editorSerializerConstructors.set(we,G),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(we),this.editorSerializerInstances.delete(we)})}getEditorSerializer(we){return this.editorSerializerInstances.get(typeof we=="string"?we:we.typeId)}}v.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function J(le,we,G){return!le||!le.length?[]:await Promise.all(le.map(async B=>{const H=h.URI.revive(B.fileUri);if(!H){G.info("Cannot resolve the path because it is not valid.",B);return}if(!await we.canHandleResource(H)){G.info("Cannot resolve the path because it cannot be handled",B);return}let Z=B.exists,ie=B.type;if(typeof Z!="boolean"||typeof ie!="number")try{ie=(await we.stat(H)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Z=!0}catch(ye){G.error(ye),Z=!1}if(!Z&&B.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",B);return}if(ie===y.FileType.Directory){G.info("Cannot resolve the path because it is a directory",B);return}const re={...B.options,pinned:!0};return Z?{resource:H,options:re}:{resource:H,options:re,forceUntitled:!0}}))}e.pathsToEditors=J;var X;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function z(le){const we=le;if(!we)return!1;const G=we;if(G.modified)return z(G.modified);const B=we;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.isTextEditorViewState=z;function Q(le){return(0,T.isErrorWithActions)(le)}e.isEditorOpenError=Q;function ve(le,we,G){const B=(0,T.createErrorWithActions)(le,we);return B.forceMessage=G?.forceMessage,B.forceSeverity=G?.forceSeverity,B.allowDialog=G?.allowDialog,B}e.createEditorOpenError=ve}),define(De[269],Ie([1,0,4,217,5,3,28,42,19,23,78,255]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,k.registerIcon)("default-view-icon",T.Codicon.window,(0,F.localize)(0,null));var b;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var S;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.ViewContainerLocations=[0,1,2];function _(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=_;class w extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(s,i,a){const l=this.get(s.id);if(l)return l;const C=s;return C.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.getOrSet)(this.viewContainers,i,[]).push(C),a?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:i}),C}deregisterViewContainer(s){for(const i of this.viewContainers.keys()){const a=this.viewContainers.get(i),l=a?.indexOf(s);if(l!==-1){a?.splice(l,1),a.length===0&&this.viewContainers.delete(i),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:i});return}}}get(s){return this.all.filter(i=>i.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(i=>this.getViewContainers(i).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(i=>this.getViewContainerLocation(i)===s)}}v.Registry.add(b.ViewContainersRegistry,new w);var u;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(u||(e.ViewContentGroups=u={}));function r(n,s){const i=n.group??u.More,a=s.group??u.More;return i!==a?i.localeCompare(a):(n.order??5)-(s.order??5)}class o extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(s,i){this.registerViews2([{views:s,viewContainer:i}])}registerViews2(s){s.forEach(({views:i,viewContainer:a})=>this.addViews(i,a)),this._onViewsRegistered.fire(s)}deregisterViews(s,i){const a=this.removeViews(s,i);a.length&&this._onViewsDeregistered.fire({views:a,viewContainer:i})}moveViews(s,i){for(const a of this._views.keys())if(a!==i){const l=this.removeViews(s,a);l.length&&(this.addViews(l,i),this._onDidChangeContainer.fire({views:l,from:a,to:i}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const i of this._viewContainers){const a=(this._views.get(i)||[]).filter(l=>l.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const i of this._viewContainers)if((this._views.get(i)||[]).filter(l=>l.id===s)[0])return i;return null}registerViewWelcomeContent(s,i){return this._viewWelcomeContents.add(s,i),this._onDidChangeViewWelcomeContent.fire(s),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(s,i),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,i){const a=new Map;for(const[l,C]of i)this._viewWelcomeContents.add(s,C),a.set(l,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(s,C),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),a}getViewWelcomeContent(s){const i=[];return this._viewWelcomeContents.forEach(s,a=>i.push(a)),i.sort(r)}addViews(s,i){let a=this._views.get(i);a||(a=[],this._views.set(i,a),this._viewContainers.push(i));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,F.localize)(1,null,l.id));a.push(l)}}removeViews(s,i){const a=this._views.get(i);if(!a)return[];const l=[],C=[];for(const D of a)s.includes(D)?l.push(D):C.push(D);return l.length&&(C.length?this._views.set(i,C):(this._views.delete(i),this._viewContainers.splice(this._viewContainers.indexOf(i),1))),l}}v.Registry.add(b.ViewsRegistry,new o),e.IViewsService=(0,h.createDecorator)("viewsService"),e.IViewDescriptorService=(0,h.createDecorator)("viewDescriptorService");var c;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class d{constructor(s,i){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,s),this._hasResolve=!!i,this.resolve=async a=>{if(i&&!this.resolved){const l=await i(a);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}a.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=d;class t extends Error{constructor(s){super((0,F.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(De[140],Ie([1,0,4,9,218]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(v){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=v}onEvent(v){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=v}onRequest(v){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=v}sendResponse(v){v.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.internalSend("response",v)}sendRequest(v,y,E,T){const k={command:v};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const b=setTimeout(()=>{clearTimeout(b);const S=this.pendingRequests.get(k.seq);if(S){this.pendingRequests.delete(k.seq);const _={type:"response",seq:0,request_seq:k.seq,success:!1,command:v,message:(0,h.localize)(0,null,T,v)};S(_)}},T)}return E&&this.pendingRequests.set(k.seq,E),k.seq}acceptMessage(v){this.messageCallback?this.messageCallback(v):(this.queue.push(v),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(v,y){return v.type!=="event"||y.type!=="event"}async processQueue(){let v;for(;this.queue.length;){if((!v||this.needsTaskBoundaryBetween(this.queue[0],v))&&await(0,F.timeout)(0),v=this.queue.shift(),!v)return;switch(v.type){case"event":this.eventCallback?.(v);break;case"request":this.requestCallback?.(v);break;case"response":{const y=v,E=this.pendingRequests.get(y.request_seq);E&&(this.pendingRequests.delete(y.request_seq),E(y));break}}}}internalSend(v,y){y.type=v,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const v=new Map;this.pendingRequests.forEach((y,E)=>v.set(E,y)),await(0,F.timeout)(500),v.forEach((y,E)=>{y({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(E)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(De[270],Ie([1,0,219,41,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new F.RawContextKey("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new F.RawContextKey("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new F.RawContextKey("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new F.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:I.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new F.RawContextKey("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new F.RawContextKey("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new F.RawContextKey("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new F.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new F.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new F.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new F.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new F.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new F.RawContextKey("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new F.RawContextKey("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new F.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new F.RawContextKey("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new F.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new F.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new F.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new F.RawContextKey("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new F.RawContextKey("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new F.RawContextKey("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new F.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new F.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new F.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new F.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new F.RawContextKey("stepBackSupported",!1,{type:"boolean",description:I.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new F.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new F.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new F.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new F.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new F.RawContextKey("breakpointsExist",!1,{type:"boolean",description:I.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new F.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:I.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new F.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new F.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new F.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new F.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new F.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new F.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new F.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new F.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new F.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new F.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new F.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:I.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new F.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new F.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:I.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new F.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:I.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new F.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new F.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new F.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new F.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(50,null)});const R=b=>I.localize(51,null,b);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(52,null)};var A;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(A||(e.State=A={}));function v(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=v;var y;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var E;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var T;(function(b){b.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,h.createDecorator)("debugService");var k;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(De[271],Ie([1,0,15,2,16,23,17,34,21,19]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function k(D,p,m){return D.replace(T,function(f,P){return p&&P.length>0&&P[0]!=="_"?f:m&&m.hasOwnProperty(P)?m[P]:f})}e.formatPII=k;function b(D){const p={};for(const m of Object.keys(D))m.startsWith("!")||(p[m]=D[m]);return p}e.filterExceptionsFromTelemetry=b;function S(D){return D.configuration.request==="attach"&&!_(D)&&(!D.parentSession||S(D.parentSession))}e.isSessionAttach=S;function _(D){let p=D.configuration.type;if(p)return p==="vslsShare"&&(p=D.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(p,"extensionhost")||(0,I.equalsIgnoreCase)(p,"pwa-extensionhost")?D:D.parentSession?_(D.parentSession):void 0}e.getExtensionHostDebugSession=_;function w(D){return D.type&&(D.label||D.program||D.runtime)}e.isDebuggerMainContribution=w;function u(D,p,m){let f,P=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(D);){const L=N.index+1,U=L+N[0].length;if(L<=p&&U>=m){f=N[0],P=L;break}}if(f){const L=/\w+/g;let U=null;for(;(U=L.exec(f))&&!(U.index+1+P+U[0].length>=m););U&&(f=f.substring(0,L.lastIndex))}return f?{start:P,end:P+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;async function r(D,p,m,f){if(D.evaluatableExpressionProvider.has(p)){const P=D.evaluatableExpressionProvider.ordered(p),M=(0,E.coalesce)(await Promise.all(P.map(async N=>{try{return await N.provideEvaluatableExpression(p,m,f??y.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=p.getLineContent(m.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const P=p.getLineContent(m.lineNumber),{start:M,end:N}=u(P,m.column,m.column),L=P.substring(M-1,N);return{matchingExpression:L,range:new v.Range(m.lineNumber,M,m.lineNumber,M+L.length)}}return null}e.getEvaluatableExpressionAtPosition=r;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(D){return!!(D&&D.match(o))}e.isUri=c;function g(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(c(D.path))return F.URI.parse(D.path);if((0,h.isAbsolute)(D.path))return F.URI.file(D.path)}return D.path}function d(D){if(typeof D.path=="object"){const p=F.URI.revive(D.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return D.path}function t(D,p){const m=p?g:d,f=(0,R.deepClone)(D);return s(f,(P,M)=>{P&&M&&(M.path=m(M))}),f}e.convertToDAPaths=t;function n(D,p){const m=p?g:d,f=(0,R.deepClone)(D);return s(f,(P,M)=>{!P&&M&&(M.path=m(M))}),f}e.convertToVSCPaths=n;function s(D,p){switch(D.type){case"event":{const m=D;switch(m.event){case"output":p(!1,m.body.source);break;case"loadedSource":p(!1,m.body.source);break;case"breakpoint":p(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=D;switch(m.command){case"setBreakpoints":p(!0,m.arguments.source);break;case"breakpointLocations":p(!0,m.arguments.source);break;case"source":p(!0,m.arguments.source);break;case"gotoTargets":p(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(f=>p(!1,f));break;default:break}break}case"response":{const m=D;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(f=>p(!1,f.source));break;case"loadedSources":m.body.sources.forEach(f=>p(!1,f));break;case"scopes":m.body.scopes.forEach(f=>p(!1,f.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(f=>p(!1,f.source));break;case"setBreakpoints":m.body.breakpoints.forEach(f=>p(!1,f.source));break;case"disassemble":m.body?.instructions.forEach(P=>p(!1,P.location));break;default:break}break}}}function i(D){return D.filter(p=>!p.presentation?.hidden).sort((p,m)=>p.presentation?m.presentation?p.presentation.group?m.presentation.group?p.presentation.group!==m.presentation.group?p.presentation.group.localeCompare(m.presentation.group):a(p.presentation.order,m.presentation.order):-1:m.presentation.group?1:a(p.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=i;function a(D,p){return typeof D!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:D-p}async function l(D,p){const m=D.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(m!=="none"&&(await p.saveAll(),m==="allEditorsInActiveGroup")){const f=p.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:f.input,groupId:f.group.id})}await D.reloadConfiguration()}e.saveAllBeforeDebugStart=l;const C=(D,p)=>!D||!p?D===p:D.name===p.name&&D.path===p.path&&D.sourceReference===p.sourceReference;e.sourcesEqual=C}),define(De[272],Ie([1,0,48,60,23,16,12,15,29,220,140]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends T.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(r,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,r.on("data",c=>this.handleData(c))}sendMessage(r){if(this.outputStream){const o=JSON.stringify(r);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${k.TWO_CRLF}${o}`,"utf8")}}handleData(r){for(this.rawData=Buffer.concat([this.rawData,r]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+o))}continue}}else{const o=this.rawData.indexOf(k.TWO_CRLF);if(o!==-1){const g=this.rawData.toString("utf8",0,o).split(k.HEADER_LINESEPARATOR);for(const d of g){const t=d.split(k.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(o+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k;class b extends k{startSession(){return new Promise((r,o)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),r(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",g=>{c?this._onError.fire(g):o(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class S extends b{constructor(r){super(),this.adapterServer=r}createConnection(r){return F.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",r)}}e.SocketDebugAdapter=S;class _ extends b{constructor(r){super(),this.adapterServer=r}createConnection(r){return F.createConnection(this.adapterServer.path,r)}}e.NamedPipeDebugAdapter=_;class w extends k{constructor(r,o){super(),this.adapterExecutable=r,this.debugType=o}async startSession(){const r=this.adapterExecutable.command,o=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(r)if(R.isAbsolute(r)){if(!await y.Promises.exists(r))throw new Error(E.localize(0,null,r))}else r.indexOf("/")<0&&r.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.debugType));let g=process.env;if(c.env&&Object.keys(c.env).length>0&&(g=h.mixin(h.deepClone(process.env),c.env)),r==="node")if(Array.isArray(o)&&o.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:g,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const n=I.fork(o[0],o.slice(1),t);if(!n.pid)throw new Error(E.localize(2,null,o[0]));this.serverProcess=n}else throw new Error(E.localize(3,null));else{const d={env:g};c.cwd&&(d.cwd=c.cwd),this.serverProcess=I.spawn(r,o,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,t)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((r,o)=>{const c=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,d,t){if(g)return o(g)});c.on("exit",r),c.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(r,o){if(!r)return;const c=Object.create(null);r.runtime&&(r.runtime.indexOf("./")===0?c.runtime=R.join(o,r.runtime):c.runtime=r.runtime),r.runtimeArgs&&(c.runtimeArgs=r.runtimeArgs),r.program&&(R.isAbsolute(r.program)?c.program=r.program:c.program=R.join(o,r.program)),r.args&&(c.args=r.args);const g=r;return g.win&&(c.win=w.extract(g.win,o)),g.winx86&&(c.winx86=w.extract(g.winx86,o)),g.windows&&(c.windows=w.extract(g.windows,o)),g.osx&&(c.osx=w.extract(g.osx,o)),g.linux&&(c.linux=w.extract(g.linux,o)),c}static platformAdapterExecutable(r,o){let c=Object.create(null);o=o.toLowerCase();for(const i of r)if(i.contributes){const a=i.contributes.debuggers;a&&a.length>0&&a.filter(l=>typeof l.type=="string"&&v.equalsIgnoreCase(l.type,o)).forEach(l=>{const C=w.extract(l,i.extensionLocation.fsPath);c=h.mixin(c,C,i.isBuiltin)})}let g;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=c.winx86||c.win||c.windows:A.isWindows?g=c.win||c.windows:A.isMacintosh?g=c.osx:A.isLinux&&(g=c.linux),g=g||c;const d=g.program||c.program,t=g.args||c.args,n=g.runtime||c.runtime,s=g.runtimeArgs||c.runtimeArgs;if(n)return{type:"executable",command:n,args:(s||[]).concat(typeof d=="string"?[d]:[]).concat(t||[])};if(d)return{type:"executable",command:d,args:t||[]}}}e.ExecutableDebugAdapter=w}),define(De[273],Ie([1,0,48,32,12]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(E,T){return new Promise((k,b)=>{let S="";const _=I.spawn(E,T);_.pid&&_.stdout.on("data",w=>{S+=w.toString()}),_.on("error",w=>{b(w)}),_.on("close",w=>{k(S)})})}async function A(E){if(E)if(h.isWindows){const T=await new Promise((k,b)=>{ge(["@vscode/windows-process-tree"],k,b)});return new Promise(k=>{T.getProcessTree(E,b=>{k(!!b&&b.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(E)]).then(T=>{const k=T.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},T=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var v;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(v||(v={}));function y(E,T,k,b,S){E=E.trim().toLowerCase();let _;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?_=1:E.indexOf("cmd.exe")>=0?_=0:E.indexOf("bash")>=0?_=2:h.isWindows?_=0:_=2;let w,u=" ";switch(_){case 1:if(w=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),b){const r=(0,F.getDriveLetter)(b);r&&(u+=`${r}:; `),u+=`cd ${w(b)}; `}if(S)for(const r in S){const o=S[r];o===null?u+=`Remove-Item env:${r}; `:u+=`\${env:${r}}='${o}'; `}if(T.length>0){const r=T.shift(),o=k?r:w(r);u+=o[0]==="'"?`& ${o} `:`${o} `;for(const c of T)u+=c==="<"||c===">"||k?c:w(c),u+=" "}break;case 0:if(w=r=>(r=r.replace(/\"/g,'""'),r=r.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>r.includes(o))||r.length===0?`"${r}"`:r),b){const r=(0,F.getDriveLetter)(b);r&&(u+=`${r}: && `),u+=`cd ${w(b)} && `}if(S){u+='cmd /C "';for(const r in S){let o=S[r];o===null?u+=`set "${r}=" && `:(o=o.replace(/[&^|<>]/g,c=>`^${c}`),u+=`set "${r}=${o}" && `)}}for(const r of T)u+=r==="<"||r===">"||k?r:w(r),u+=" ";S&&(u+='"');break;case 2:{w=o=>(o=o.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),o.length===0?'""':o);const r=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(b&&(u+=`cd ${w(b)} ; `),S){u+="/usr/bin/env";for(const o in S){const c=S[o];c===null?u+=` -u ${r(o)}`:u+=` ${r(`${o}=${c}`)}`}u+=" "}for(const o of T)u+=o==="<"||o===">"||k?o:w(o),u+=" ";break}}return u}e.prepareCommand=y}),define(De[108],Ie([1,0,22,35,50,97,17,16,12,41]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var S;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var _;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(_||(e.NotebookRendererMatch=_={}));var w;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var r;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var o;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var c;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const j=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${j.join("")}]+`),fe=7;function J(we,G){const B=G.toString(fe),me=`${B.length<j.length?j[B.length-1]:"z"}${B}s${(0,I.encodeBase64)(I.VSBuffer.fromString(we.scheme),!0,!0)}`;return we.with({scheme:O.scheme,fragment:me})}O.generate=J;function X(we){if(we.scheme!==O.scheme)return;const G=we.fragment.indexOf("s");if(G<0)return;const B=parseInt(we.fragment.substring(0,G).replace(V,""),fe),H=(0,I.decodeBase64)(we.fragment.substring(G+1)).toString();if(!isNaN(B))return{handle:B,notebook:we.with({scheme:H,fragment:null})}}O.parse=X;function z(we,G){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}O.generateCellOutputUri=z;function Q(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!G)return;const B=G[1]&&G[1]!==""?G[1]:void 0,H=G[2];return{outputId:B,notebook:we.with({scheme:H||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=Q;function ve(we,G,B){return O.generate(we,G).with({scheme:B})}O.generateCellPropertyUri=ve;function le(we,G){if(we.scheme===G)return O.parse(we.with({scheme:O.scheme}))}O.parseCellPropertyUri=le})(c||(e.CellUri=c={}));const g=O=>y.isWindows?O.replace(/\//g,"\\"):O;class d{constructor(j=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=V,this.order=[...new Set(j)].map(fe=>({pattern:fe,matches:F.parse(g(fe))}))}sort(j){const V=new Map(h.Iterable.map(j,J=>[J,g(J)]));let fe=[];for(const{matches:J}of this.order)for(const[X,z]of V)if(J(z)){fe.push(X),V.delete(X);break}return V.size&&(fe=fe.concat([...V.keys()].sort((J,X)=>this.defaultOrder.indexOf(J)-this.defaultOrder.indexOf(X)))),fe}prioritize(j,V){const fe=this.findIndex(j);if(fe===-1){this.order.unshift({pattern:j,matches:F.parse(g(j))});return}const J=new Set(V.map(z=>this.findIndex(z,fe)));J.delete(-1);const X=Array.from(J).sort();this.order.splice(fe+1,0,...X.map(z=>this.order[z]));for(let z=X.length-1;z>=0;z--)this.order.splice(X[z],1)}toArray(){return this.order.map(j=>j.pattern)}findIndex(j,V=this.order.length){const fe=g(j);for(let J=0;J<V;J++)if(this.order[J].matches(fe))return J;return-1}}e.MimeTypeDisplayOrder=d;function t(O,j,V,fe=(J,X)=>J===X){const J=[];function X(ve,le,we){if(le===0&&we.length===0)return;const G=J[J.length-1];G&&G.start+G.deleteCount===ve?(G.deleteCount+=le,G.toInsert.push(...we)):J.push({start:ve,deleteCount:le,toInsert:we})}let z=0,Q=0;for(;;){if(z===O.length){X(z,0,j.slice(Q));break}if(Q===j.length){X(z,O.length-z,[]);break}const ve=O[z],le=j[Q];if(fe(ve,le)){z+=1,Q+=1;continue}V(le)?(X(z,1,[]),z+=1):(X(z,0,[le]),Q+=1)}return J}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtLineBoundary","none");var n;(function(O){O.default="default",O.option="option"})(n||(e.NotebookEditorPriority=n={}));function s(O){const j=O;return!!((typeof j.include=="string"||F.isRelativePattern(j.include))&&(typeof j.exclude=="string"||F.isRelativePattern(j.exclude)))}e.isDocumentExcludePattern=s;function i(O,j,V){if(Array.isArray(O.viewType)&&O.viewType.indexOf(j)>=0||O.viewType===j)return!0;if(O.filenamePattern){const fe=s(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,J=s(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(F.match(fe,(0,v.basename)(V.fsPath).toLowerCase()))return!(J&&F.match(J,(0,v.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static{this._prefix="notebook/"}static create(j){return`${l._prefix}${j}`}static parse(j){if(j.startsWith(l._prefix))return j.substring(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l;function C(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.isTextStreamMime=C;const D=new TextDecoder;function p(O){const j=[];let V=!1;for(const z of O)(j.length===0||V)&&(j.push(z),V=!0);let fe=P(j);const J=I.VSBuffer.concat(j.map(z=>I.VSBuffer.wrap(z))),X=x(J);return fe=fe||X.byteLength!==J.byteLength,{data:X,didCompression:fe}}e.compressOutputItemStreams=p,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const m=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(O=>O.charCodeAt(0)),f=10;function P(O){let j=!1;return O.forEach((V,fe)=>{if(fe===0||V.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const J=O[fe-1],X=V.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(X[0]===m[0]&&X[1]===m[1]&&X[2]===m[2]){const z=J.lastIndexOf(f);if(z===-1)return;j=!0,O[fe-1]=J.subarray(0,z),O[fe]=V.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),j}function M(O){let j=O;do O=j,j=O.replace(/[^\n]\x08/gm,"");while(j.length<O.length);return O}function N(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const j=O.match(/^(.*)\r+/m)[1];let V=O.match(/\r+(.*)$/m)[1];V=V+j.slice(V.length,j.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return O}const L="\b".charCodeAt(0),U="\r".charCodeAt(0);function x(O){return!O.buffer.includes(L)&&!O.buffer.includes(U)?O:I.VSBuffer.fromString(N(M(D.decode(O.buffer))))}}),define(De[7],Ie([1,0,19,8,79,28,97,15,18,2,31,25,30,64,108]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_){"use strict";var w,u,r,o,c,g,d,t,n,s,i,a,l,C,D,p,m,f;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(q){return Object.assign(q,{apply:function(...be){if(be.length===0)return Reflect.construct(q,[]);{const Ae=be.length===1?[]:be[1];return Reflect.construct(q,Ae,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(q,[]);{const[Ae,...Ke]=be;return Reflect.construct(q,Ke,Ae.constructor)}}})}var M;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var N;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let L=w=class{static from(...W){let be=W;return new w(function(){if(be){for(const Ae of be)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();be=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=w=je([P],L);let U=u=class{static Min(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isBefore(be)&&(be=Ke)}return be}static Max(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isAfter(be)&&(be=Ke)}return be}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:be,character:Ae}=W;return typeof be=="number"&&typeof Ae=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,be){if(W<0)throw(0,F.illegalArgument)("line must be non-negative");if(be<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=W,this._character=be}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,be=0){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return typeof W>"u"?Ae=0:typeof W=="number"?Ae=W:(Ae=typeof W.lineDelta=="number"?W.lineDelta:0,be=typeof W.characterDelta=="number"?W.characterDelta:0),Ae===0&&be===0?this:new u(this.line+Ae,this.character+be)}with(W,be=this.character){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return typeof W>"u"?Ae=this.line:typeof W=="number"?Ae=W:(Ae=typeof W.line=="number"?W.line:this.line,be=typeof W.character=="number"?W.character:this.character),Ae===this.line&&be===this.character?this:new u(Ae,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=U,e.Position=U=u=je([P],U);let x=r=class{static isRange(W){return W instanceof r?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,be,Ae,Ke){let tt,at;if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new U(W,be),at=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(be)&&(tt=U.of(W),at=U.of(be)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const be=U.Max(W.start,this._start),Ae=U.Min(W.end,this._end);if(!be.isAfter(Ae))return new r(be,Ae)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const be=U.Min(W.start,this._start),Ae=U.Max(W.end,this.end);return new r(be,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,be=this.end){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return W?U.isPosition(W)?Ae=W:(Ae=W.start||this.start,be=W.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&be.isEqual(this.end)?this:new r(Ae,be)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=r=je([P],x);let O=o=class extends x{static isSelection(W){return W instanceof o?!0:W?x.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,be,Ae,Ke){let tt,at;if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new U(W,be),at=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(be)&&(tt=U.of(W),at=U.of(be)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this._anchor=tt,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=O,e.Selection=O=o=je([P],O);const j=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,F.illegalArgument)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be,Ae){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,F.illegalArgument)("port");typeof Ae<"u"&&j(Ae),this.host=W,this.port=Math.round(be),this.connectionToken=Ae}}e.ResolvedAuthority=V;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be){this.makeConnection=W,this.connectionToken=be,typeof be<"u"&&j(be)}}e.ManagedResolvedAuthority=fe;class J extends Error{static NotAvailable(W,be){return new J(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(W){return new J(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,be=S.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(W),this._message=W,this._code=be,this._detail=Ae,Object.setPrototypeOf(this,J.prototype)}}e.RemoteAuthorityResolverError=J;var X;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var z;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let Q=c=class{static isTextEdit(W){return W instanceof c?!0:W?x.isRange(W)&&typeof W.newText=="string":!1}static replace(W,be){return new c(W,be)}static insert(W,be){return c.replace(new x(W,W),be)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const be=new c(new x(new U(0,0),new U(0,0)),"");return be.newEol=W,be}get range(){return this._range}set range(W){if(W&&!x.isRange(W))throw(0,F.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,F.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,F.illegalArgument)("newEol");this._newEol=W}constructor(W,be){this._range=W,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Q,e.TextEdit=Q=c=je([P],Q);let ve=g=class{static isNotebookCellEdit(W){return W instanceof g?!0:W?Jt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,be){return new g(W,be)}static insertCells(W,be){return new g(new Jt(W,W),be)}static deleteCells(W){return new g(W,[])}static updateCellMetadata(W,be){const Ae=new g(new Jt(W,W),[]);return Ae.newCellMetadata=be,Ae}static updateNotebookMetadata(W){const be=new g(new Jt(0,0),[]);return be.newNotebookMetadata=W,be}constructor(W,be){this.range=W,this.newCells=be}};e.NotebookEdit=ve,e.NotebookEdit=ve=g=je([P],ve);class le{static isSnippetTextEdit(W){return W instanceof le?!0:W?x.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,be){return new le(W,be)}static insert(W,be){return le.replace(new x(W,W),be)}constructor(W,be){this.range=W,this.snippet=be}}e.SnippetTextEdit=le;var we;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,be,Ae,Ke){this._edits.push({_type:1,from:W,to:be,options:Ae,metadata:Ke})}createFile(W,be,Ae){this._edits.push({_type:1,from:void 0,to:W,options:be,metadata:Ae})}deleteFile(W,be,Ae){this._edits.push({_type:1,from:W,to:void 0,options:be,metadata:Ae})}replaceNotebookMetadata(W,be,Ae){this._edits.push({_type:3,metadata:Ae,uri:W,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells(W,be,Ae,Ke){const tt=be.start,at=be.end;(tt!==at||Ae.length>0)&&this._edits.push({_type:5,uri:W,index:tt,count:at-tt,cells:Ae,metadata:Ke})}replaceNotebookCellMetadata(W,be,Ae,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:3,index:be,metadata:Ae}})}replace(W,be,Ae,Ke){this._edits.push({_type:2,uri:W,edit:new Q(be,Ae),metadata:Ke})}insert(W,be,Ae,Ke){this.replace(W,new x(be,be),Ae,Ke)}delete(W,be,Ae){this.replace(W,be,"",Ae)}has(W){return this._edits.some(be=>be._type===2&&be.uri.toString()===W.toString())}set(W,be){if(be)for(const Ae of be){if(!Ae)continue;let Ke,tt;Array.isArray(Ae)?(Ke=Ae[0],tt=Ae[1]):Ke=Ae,ve.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(W,Ke.range.start,Ke.newCellMetadata,tt):Ke.newNotebookMetadata?this.replaceNotebookMetadata(W,Ke.newNotebookMetadata,tt):this.replaceNotebookCells(W,Ke.range,Ke.newCells,tt):le.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:tt}):this._edits.push({_type:2,uri:W,edit:Ke,metadata:tt})}else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ke=this._edits[Ae];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this._edits[Ae]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get(W){const be=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===W.toString()&&be.push(Ae.edit);return be}entries(){const W=new R.ResourceMap;for(const be of this._edits)if(be._type===2){let Ae=W.get(be.uri);Ae||(Ae=[be.uri,[]],W.set(be.uri,Ae)),Ae[1].push(be.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=G,e.WorkspaceEdit=G=je([P],G);let B=d=class{static isSnippetString(W){return W instanceof d?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=d._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,be=this._tabstop++){if(typeof W=="function"){const Ae=new d;Ae._tabstop=this._tabstop,W(Ae),this._tabstop=Ae._tabstop,W=Ae.value}else W=d._escape(W);return this.value+="${",this.value+=be,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,be=this._tabstop++){const Ae=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(W,be){if(typeof be=="function"){const Ae=new d;Ae._tabstop=this._tabstop,be(Ae),this._tabstop=Ae._tabstop,be=Ae.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=B,e.SnippetString=B=d=je([P],B);var H;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var me;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let Z=t=class{static isLocation(W){return W instanceof t?!0:W?x.isRange(W.range)&&E.URI.isUri(W.uri):!1}constructor(W,be){if(this.uri=W,be)if(x.isRange(be))this.range=x.of(be);else if(U.isPosition(be))this.range=new x(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Z,e.Location=Z=t=je([P],Z);let ie=class{static is(W){return W?typeof W.message=="string"&&W.location&&x.isRange(W.location.range)&&E.URI.isUri(W.location.uri):!1}constructor(W,be){this.location=W,this.message=be}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.location.range.isEqual(be.location.range)&&W.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=ie,e.DiagnosticRelatedInformation=ie=je([P],ie);let re=class{constructor(W,be,Ae=me.Error){if(!x.isRange(W))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=W,this.message=be,this.severity=Ae}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.severity===be.severity&&W.code===be.code&&W.severity===be.severity&&W.source===be.source&&W.range.isEqual(be.range)&&(0,I.equals)(W.tags,be.tags)&&(0,I.equals)(W.relatedInformation,be.relatedInformation,ie.isEqual)}};e.Diagnostic=re,e.Diagnostic=re=je([P],re);let ye=class{constructor(W,be){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=be}};e.Hover=ye,e.Hover=ye=je([P],ye);var oe;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(W,be=oe.Text){this.range=W,this.kind=be}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=je([P],de);var ee;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var ue;(function(q){q[q.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let pe=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,be,Ae,Ke,tt){this.name=W,this.kind=be,this.containerName=tt,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof Z?this.location=Ke:Ae instanceof x&&(this.location=new Z(Ke,Ae)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=pe,e.SymbolInformation=pe=n=je([P],pe);let Pe=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,be,Ae,Ke,tt){this.name=W,this.detail=be,this.kind=Ae,this.range=Ke,this.selectionRange=tt,this.children=[],s.validate(this)}};e.DocumentSymbol=Pe,e.DocumentSymbol=Pe=s=je([P],Pe);var $;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})($||(e.CodeActionTriggerKind=$={}));let K=class{constructor(W,be){this.title=W,this.kind=be}};e.CodeAction=K,e.CodeAction=K=je([P],K);let te=class{static{i=this}static{this.sep="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};e.CodeActionKind=te,e.CodeActionKind=te=i=je([P],te),te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorMove=te.Refactor.append("move"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll"),te.Notebook=te.Empty.append("notebook");let se=class{constructor(W,be){if(this.range=W,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=se,e.SelectionRange=se=je([P],se);class Y{constructor(W,be,Ae,Ke,tt,at){this.kind=W,this.name=be,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Y;class he{constructor(W,be){this.fromRanges=be,this.from=W}}e.CallHierarchyIncomingCall=he;class Se{constructor(W,be){this.fromRanges=be,this.to=W}}e.CallHierarchyOutgoingCall=Se;var Ue;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let We=class{constructor(W,be){this.range=W,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=We,e.CodeLens=We=je([P],We);let Ze=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,be=!1){this.#e=new h.MarkdownString(W,{supportThemeIcons:be})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,be){return this.#e.appendCodeblock(be??"",W),this}};e.MarkdownString=Ze,e.MarkdownString=Ze=a=je([P],Ze);let Qe=class{constructor(W,be){this.label=W,this.documentation=be}};e.ParameterInformation=Qe,e.ParameterInformation=Qe=je([P],Qe);let it=class{constructor(W,be){this.label=W,this.documentation=be,this.parameters=[]}};e.SignatureInformation=it,e.SignatureInformation=it=je([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=et,e.SignatureHelp=et=je([P],et);var Te;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var Me;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Me||(e.InlayHintKind=Me={}));let ze=class{constructor(W){this.value=W}};e.InlayHintLabelPart=ze,e.InlayHintLabelPart=ze=je([P],ze);let Re=class{constructor(W,be,Ae){this.position=W,this.label=be,this.kind=Ae}};e.InlayHint=Re,e.InlayHint=Re=je([P],Re);var Xe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var ce;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(q){q[q.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let ke=class{constructor(W,be){this.label=W,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ke,e.CompletionItem=ke=je([P],ke);let He=class{constructor(W=[],be=!1){this.items=W,this.isIncomplete=be}};e.CompletionList=He,e.CompletionList=He=je([P],He);let xe=class{constructor(W,be,Ae){this.insertText=W,this.range=be,this.command=Ae}};e.InlineSuggestion=xe,e.InlineSuggestion=xe=je([P],xe);let Ye=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.InlineSuggestionList=Ye,e.InlineSuggestionList=Ye=je([P],Ye);var rt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function Et(q,W){return`${k.ExtensionIdentifier.toKey(q)}.${W}`}e.asStatusBarItemIdentifier=Et;var yt;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Qt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var Vt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var bt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var Bt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Bt||(e.TextDocumentChangeReason=Bt={}));var Ot;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(q){function W(be){switch(be){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(bt||(e.TextEditorSelectionChangeKind=bt={}));var $t;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(q){function W(be){switch(be){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=W}($t||(e.SyntaxTokenType=$t={}));let Pt=class{constructor(W,be){if(be&&!E.URI.isUri(be))throw(0,F.illegalArgument)("target");if(!x.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.target=be}};e.DocumentLink=Pt,e.DocumentLink=Pt=je([P],Pt);let Tt=class{constructor(W,be,Ae,Ke){this.red=W,this.green=be,this.blue=Ae,this.alpha=Ke}};e.Color=Tt,e.Color=Tt=je([P],Tt);let Mt=class{constructor(W,be){if(be&&!(be instanceof Tt))throw(0,F.illegalArgument)("color");if(!x.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.color=be}};e.ColorInformation=Mt,e.ColorInformation=Mt=je([P],Mt);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.illegalArgument)("label");this.label=W}};e.ColorPresentation=Wt,e.ColorPresentation=Wt=je([P],Wt);var jt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var zt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(zt||(e.SourceControlInputBoxValidationType=zt={}));var ct;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class ut{constructor(W,be,Ae){if(this.startIndex=W,this.length=be,this.tooltip=Ae,typeof W!="number"||W<0)throw(0,F.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,F.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ut;class Gt{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Gt;class kt{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=kt;var _t;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(_t||(e.TerminalLocation=_t={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.illegalArgument)("options")}}e.TerminalProfile=ft;var Dt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var Ft;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let St=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,be){if(this.label=be,typeof W!="string"||typeof be!="string")throw(0,F.illegalArgument)("name");this._id=W}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=l=je([P],St);function qe(q){let W="";for(let be=0;be<q.length;be++)W+=q[be].replace(/,/g,",,")+",";return W}let Nt=class{constructor(W,be,Ae){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=W,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Ae):this._options=be)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const be of this._args)W.push(be);return qe(W)}};e.ProcessExecution=Nt,e.ProcessExecution=Nt=je([P],Nt);let Ut=class{constructor(W,be,Ae){if(this._args=[],Array.isArray(be)){if(!W)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W,this._args=be,this._options=Ae}else{if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W,this._options=be}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)W.push(typeof be=="string"?be:be.value);return qe(W)}};e.ShellExecution=Ut,e.ShellExecution=Ut=je([P],Ut);var Le;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Le||(e.ShellQuoting=Le={}));var Fe;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Fe||(e.TaskScope=Fe={}));class Ce{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ce;let ne=class{static{C=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(W,be,Ae,Ke,tt,at){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Ae,this.execution=Ke,dt=tt,this.__deprecated=!0):be===Fe.Global||be===Fe.Workspace?(this.target=be,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,dt=at):(this.target=be,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Nt?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ut?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof Ce?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const be=this._definition.type;(C.EmptyType===be||C.ProcessType===be||C.ShellType===be||C.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};e.Task=ne,e.Task=ne=C=je([P],ne);var Oe;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Oe||(e.ProgressLocation=Oe={}));var Ve;(function(q){function W(be){const Ae=be;return(0,y.isNumber)(Ae.value)?Ae.tooltip&&!(0,y.isString)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}q.isViewBadge=W})(Ve||(e.ViewBadge=Ve={}));let Je=D=class{static isTreeItem(W,be){const Ae=W;if(Ae.checkboxState!==void 0){const Ke=(0,y.isNumber)(Ae.checkboxState)?Ae.checkboxState:(0,y.isObject)(Ae.checkboxState)&&(0,y.isNumber)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,tt=!(0,y.isNumber)(Ae.checkboxState)&&(0,y.isObject)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==nt.Checked&&Ke!==nt.Unchecked||tt!==void 0&&!(0,y.isString)(tt))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(W instanceof D)return!0;if(Ae.label!==void 0&&!(0,y.isString)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,y.isString)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,y.isString)(Ae.iconPath)&&!E.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,y.isString)(Ae.iconPath.id))){const Ke=Ae.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,y.isString)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!E.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,y.isString)(Ae.tooltip)&&!(Ae.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<Ge.None&&Ae.collapsibleState>Ge.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,y.isString)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(W,be=Ge.None){this.collapsibleState=be,E.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.TreeItem=Je,e.TreeItem=Je=D=je([P],Je);var Ge;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ge||(e.TreeItemCollapsibleState=Ge={}));var nt;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.DataTransferItem=gt,e.DataTransferItem=gt=je([P],gt);class mt extends gt{}e.InternalDataTransferItem=mt;class vt extends mt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.InternalFileDataTransferItem=vt;class ht{constructor(W,be,Ae,Ke){this.name=W,this.uri=be,this._itemId=Ae,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=ht;let At=class{#e=new Map;constructor(W){for(const[be,Ae]of W??[]){const Ke=this.#e.get(this.#t(be));Ke?Ke.push(Ae):this.#e.set(this.#t(be),[Ae])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,be){this.#e.set(this.#t(W),[be])}forEach(W,be){for(const[Ae,Ke]of this.#e)for(const tt of Ke)W.call(be,tt,Ae,this)}*[Symbol.iterator](){for(const[W,be]of this.#e)for(const Ae of be)yield[W,Ae]}#t(W){return W.toLowerCase()}};e.DataTransfer=At,e.DataTransfer=At=je([P],At);let qt=class{constructor(W){this.insertText=W}};e.DocumentDropEdit=qt,e.DocumentDropEdit=qt=je([P],qt);let yi=class{constructor(W,be){this.label=be,this.insertText=W}};e.DocumentPasteEdit=yi,e.DocumentPasteEdit=yi=je([P],yi);let Ht=class{constructor(W,be){this.id=W,this.color=be}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.ThemeIcon=Ht,e.ThemeIcon=Ht=je([P],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let gi=class{constructor(W){this.id=W}};e.ThemeColor=gi,e.ThemeColor=gi=je([P],gi);var It;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let _i=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=E.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,be){if(typeof W!="string"&&(!W||!E.URI.isUri(W)&&!E.URI.isUri(W.uri)))throw(0,F.illegalArgument)("base");if(typeof be!="string")throw(0,F.illegalArgument)("pattern");typeof W=="string"?this.baseUri=E.URI.file(W):E.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=_i,e.RelativePattern=_i=je([P],_i);const zi=new WeakMap;function Ct(q,W){zi.set(q,W)}e.setBreakpointId=Ct;let ii=class{constructor(W,be,Ae,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof be=="string"&&(this.condition=be),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=zi.get(this)??(0,T.generateUuid)()),this._id}};e.Breakpoint=ii,e.Breakpoint=ii=je([P],ii);let pi=class extends ii{constructor(W,be,Ae,Ke,tt){if(super(be,Ae,Ke,tt),W===null)throw(0,F.illegalArgument)("location");this.location=W}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=je([P],pi);let oi=class extends ii{constructor(W,be,Ae,Ke,tt){super(be,Ae,Ke,tt),this.functionName=W}};e.FunctionBreakpoint=oi,e.FunctionBreakpoint=oi=je([P],oi);let Ci=class extends ii{constructor(W,be,Ae,Ke,tt,at,dt){if(super(Ke,tt,at,dt),!be)throw(0,F.illegalArgument)("dataId");this.label=W,this.dataId=be,this.canPersist=Ae}};e.DataBreakpoint=Ci,e.DataBreakpoint=Ci=je([P],Ci);let Di=class{constructor(W,be,Ae){this.command=W,this.args=be||[],this.options=Ae}};e.DebugAdapterExecutable=Di,e.DebugAdapterExecutable=Di=je([P],Di);let Rt=class{constructor(W,be){this.port=W,this.host=be}};e.DebugAdapterServer=Rt,e.DebugAdapterServer=Rt=je([P],Rt);let vi=class{constructor(W){this.path=W}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=je([P],vi);let Ii=class{constructor(W){this.implementation=W}};e.DebugAdapterInlineImplementation=Ii,e.DebugAdapterInlineImplementation=Ii=je([P],Ii);let ai=class{constructor(W,be,Ae){this.session=W,this.threadId=be,this.frameId=Ae}};e.StackFrameFocus=ai,e.StackFrameFocus=ai=je([P],ai);let ci=class{constructor(W,be){this.session=W,this.threadId=be}};e.ThreadFocus=ci,e.ThreadFocus=ci=je([P],ci);let lt=class{constructor(W,be){this.range=W,this.expression=be}};e.EvaluatableExpression=lt,e.EvaluatableExpression=lt=je([P],lt);var Hi;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let Yt=class{constructor(W,be){this.range=W,this.text=be}};e.InlineValueText=Yt,e.InlineValueText=Yt=je([P],Yt);let ni=class{constructor(W,be,Ae=!0){this.range=W,this.variableName=be,this.caseSensitiveLookup=Ae}};e.InlineValueVariableLookup=ni,e.InlineValueVariableLookup=ni=je([P],ni);let Ei=class{constructor(W,be){this.range=W,this.expression=be}};e.InlineValueEvaluatableExpression=Ei,e.InlineValueEvaluatableExpression=Ei=je([P],Ei);let ki=class{constructor(W,be){this.frameId=W,this.stoppedLocation=be}};e.InlineValueContext=ki,e.InlineValueContext=ki=je([P],ki);var Vi;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Pi=p=class extends Error{static FileExists(W){return new p(W,b.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(W){return new p(W,b.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(W){return new p(W,b.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(W){return new p(W,b.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(W){return new p(W,b.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(W){return new p(W,b.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(W,be=b.FileSystemProviderErrorCode.Unknown,Ae){super(E.URI.isUri(W)?W.toString(!0):W),this.code=Ae?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.FileSystemError=Pi,e.FileSystemError=Pi=p=je([P],Pi);let bi=class{constructor(W,be,Ae){this.start=W,this.end=be,this.kind=Ae}};e.FoldingRange=bi,e.FoldingRange=bi=je([P],bi);var ji;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(ji||(e.FoldingRangeKind=ji={}));var Ti;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var li;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var qi;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(qi||(e.CommentState=qi={}));var wi;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ai{constructor(W,be=[]){this.tokenTypes=W,this.tokenModifiers=be}}e.SemanticTokensLegend=Ai;function cn(q){return typeof q>"u"||(0,y.isStringArray)(q)}class Ri{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let be=0,Ae=W.tokenTypes.length;be<Ae;be++)this._tokenTypeStrToInt.set(W.tokenTypes[be],be);for(let be=0,Ae=W.tokenModifiers.length;be<Ae;be++)this._tokenModifierStrToInt.set(W.tokenModifiers[be],be)}}push(W,be,Ae,Ke,tt){if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(W,be,Ae,Ke,tt);if(x.isRange(W)&&typeof be=="string"&&cn(Ae))return this._push(W,be,Ae);throw(0,F.illegalArgument)()}_push(W,be,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(be);let xt=0;if(Ae)for(const Xt of Ae){if(!this._tokenModifierStrToInt.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this._tokenModifierStrToInt.get(Xt);xt|=1<<ei>>>0}this._pushEncoded(Ke,tt,at,dt,xt)}_pushEncoded(W,be,Ae,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<xt;ti++){let si=this._data[5*ti],$i=this._data[5*ti+1];si===0?(si=Xt,$i+=ei):si+=Xt,this._data[5*ti]=si,this._data[5*ti+1]=$i,Xt=si,ei=$i}}let at=W,dt=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=W,this._prevChar=be}static _sortAndDeltaEncode(W){const be=[],Ae=W.length/5|0;for(let dt=0;dt<Ae;dt++)be[dt]=dt;be.sort((dt,xt)=>{const Xt=W[5*dt],ei=W[5*xt];if(Xt===ei){const ti=W[5*dt+1],si=W[5*xt+1];return ti-si}return Xt-ei});const Ke=new Uint32Array(W.length);let tt=0,at=0;for(let dt=0;dt<Ae;dt++){const xt=5*be[dt],Xt=W[xt+0],ei=W[xt+1],ti=W[xt+2],si=W[xt+3],$i=W[xt+4],wn=Xt-tt,Rn=wn===0?ei-at:ei,Wi=5*dt;Ke[Wi+0]=wn,Ke[Wi+1]=Rn,Ke[Wi+2]=ti,Ke[Wi+3]=si,Ke[Wi+4]=$i,tt=Xt,at=ei}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new ri(new Uint32Array(this._data),W):new ri(Ri._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ri;class ri{constructor(W,be){this.resultId=be,this.data=W}}e.SemanticTokens=ri;class ln{constructor(W,be,Ae){this.start=W,this.deleteCount=be,this.data=Ae}}e.SemanticTokensEdit=ln;class un{constructor(W,be){this.resultId=be,this.edits=W}}e.SemanticTokensEdits=un;var Gi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Ht("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=je([P],fi);var Ki;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var Xi;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var mi;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(mi||(e.ExtensionKind=mi={}));class Qi{static validate(W){if(typeof W.badge=="string"){let be=(0,v.nextCharLength)(W.badge,0);if(be<W.badge.length&&(be+=(0,v.nextCharLength)(W.badge,be)),W.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ht.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,be,Ae){this.badge=W,this.tooltip=be,this.color=Ae}}e.FileDecoration=Qi;let Li=class{constructor(W){this.kind=W}};e.ColorTheme=Li,e.ColorTheme=Li=je([P],Li);var Yi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Jt{static isNotebookRange(W){return W instanceof Jt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,be){if(W<0)throw(0,F.illegalArgument)("start must be positive");if(be<0)throw(0,F.illegalArgument)("end must be positive");W<=be?(this._start=W,this._end=be):(this._start=be,this._end=W)}with(W){let be=this._start,Ae=this._end;return W.start!==void 0&&(be=W.start),W.end!==void 0&&(Ae=W.end),be===this._start&&Ae===this._end?this:new Jt(be,Ae)}}e.NotebookRange=Jt;class Si{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(be=>Si.isNotebookCellData(be))}static isNotebookCellData(W){return!0}constructor(W,be,Ae,Ke,tt,at,dt){this.kind=W,this.value=be,this.languageId=Ae,this.mime=Ke,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Si.validate(this)}}e.NotebookCellData=Si;class dn{constructor(W){this.cells=W}}e.NotebookData=dn;class Kt{static isNotebookCellOutputItem(W){return W instanceof Kt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const be={name:W.name,message:W.message,stack:W.stack};return Kt.json(be,"application/vnd.code.notebook.error")}static stdout(W){return Kt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Kt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,be="application/octet-stream"){return new Kt(W,be)}static#e=new TextEncoder;static text(W,be=A.Mimes.text){const Ae=Kt.#e.encode(String(W));return new Kt(Ae,be)}static json(W,be="text/x-json"){const Ae=JSON.stringify(W,void 0,"	");return Kt.text(Ae,be)}constructor(W,be){this.data=W,this.mime=be;const Ae=(0,A.normalizeMimeType)(be,!0);if(!Ae)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.NotebookCellOutputItem=Kt;class ui{static isNotebookCellOutput(W){return W instanceof ui?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,be=!1){const Ae=new Set,Ke=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],dt=(0,A.normalizeMimeType)(at.mime);if(!Ae.has(dt)||(0,_.isTextStreamMime)(dt)){Ae.add(dt);continue}Ke.add(tt),be&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?W:W.filter((tt,at)=>!Ke.has(at))}constructor(W,be,Ae){this.items=ui.ensureUniqueMimeTypes(W,!0),typeof be=="string"?(this.id=be,this.metadata=Ae):(this.id=(0,T.generateUuid)(),this.metadata=be??Ae)}}e.NotebookCellOutput=ui;var Fi;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Be;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Be||(e.NotebookCellExecutionState=Be={}));var Zt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Zt||(e.NotebookCellStatusBarAlignment=Zt={}));var Oi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Oi||(e.NotebookEditorRevealType=Oi={}));class pt{constructor(W,be){this.text=W,this.alignment=be}}e.NotebookCellStatusBarItem=pt;var Ji;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ji||(e.NotebookControllerAffinity=Ji={}));var Zi;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class en{constructor(W,be=[]){this.uri=W,this.provides=(0,I.asArray)(be)}}e.NotebookRendererScript=en;class hn{constructor(W){this.label=W}}e.NotebookKernelSourceAction=hn;let di=class{constructor(W,be){this.label=W,this.timestamp=be}};e.TimelineItem=di,e.TimelineItem=di=je([P],di);var tn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,be){this.ranges=W,this.wordPattern=be}}e.LinkedEditingRanges=sn;class fn{constructor(W){this._autoForwardAction=W}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor(W=void 0,be=void 0,Ae=void 0,Ke=!1){this.include=W,this.exclude=be,this.profile=Ae,this.continuous=Ke}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=je([P],Mi);let Ni=m=class{static diff(W,be,Ae){const Ke=new m(W);return Ke.expectedOutput=be,Ke.actualOutput=Ae,Ke}constructor(W){this.message=W}};e.TestMessage=Ni,e.TestMessage=Ni=m=je([P],Ni);let Ui=class{constructor(W){this.id=W}};e.TestTag=Ui,e.TestTag=Ui=je([P],Ui);let hi=class{constructor(W,be){this.covered=W,this.total=be}};e.CoveredCount=hi,e.CoveredCount=hi=je([P],hi);let xi=f=class{static fromDetails(W,be){const Ae=new hi(0,0),Ke=new hi(0,0),tt=new hi(0,0);for(const dt of be)if("branches"in dt){Ae.total+=1,Ae.covered+=dt.executionCount>0?1:0;for(const xt of dt.branches)Ke.total+=1,Ke.covered+=xt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new f(W,Ae,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=be,at}constructor(W,be,Ae,Ke){this.uri=W,this.statementCoverage=be,this.branchCoverage=Ae,this.functionCoverage=Ke}};e.FileCoverage=xi,e.FileCoverage=xi=f=je([P],xi);let Bi=class{constructor(W,be,Ae=[]){this.executionCount=W,this.location=be,this.branches=Ae}};e.StatementCoverage=Bi,e.StatementCoverage=Bi=je([P],Bi);let Ee=class{constructor(W,be){this.executionCount=W,this.location=be}};e.BranchCoverage=Ee,e.BranchCoverage=Ee=je([P],Ee);let _e=class{constructor(W,be){this.executionCount=W,this.location=be}};e.FunctionCoverage=_e,e.FunctionCoverage=_e=je([P],_e);var Ne;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Ne||(e.ExternalUriOpenerPriority=Ne={}));var st;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var wt;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Lt{constructor(W,be,Ae,Ke,tt,at){this.kind=W,this.name=be,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Lt;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,be){this.original=W,this.modified=be}}e.TextDiffTabInput=yn;class _n{constructor(W,be,Ae,Ke){this.base=W,this.input1=be,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=_n;class Cn{constructor(W,be){this.uri=W,this.viewType=be}}e.CustomEditorTabInput=Cn;class Dn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Dn;class In{constructor(W,be){this.uri=W,this.notebookType=be}}e.NotebookEditorTabInput=In;class kn{constructor(W,be,Ae){this.original=W,this.modified=be,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(W,be){this.uri=W,this.inputBoxUri=be}}e.InteractiveWindowInput=Tn;var mn;(function(q){q[q.Up=1]="Up",q[q.Down=2]="Down"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var gn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(gn||(e.InteractiveSessionCopyKind=gn={}));var pn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var vn;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.Assistant=2]="Assistant",q[q.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var En;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class An{constructor(W,be){this.role=W,this.content=be}}e.ChatMessage=An;var bn;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(De[141],Ie([1,0,58,17,15,171,124,7,19]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const E=new Map;function T(_,w){w?E.set(_,w):E.delete(_)}e.setWordDefinitionFor=T;function k(_){return E.get(_)}class b extends R.MirrorTextModel{constructor(w,u,r,o,c,g,d,t){super(u,r,o,c),this._proxy=w,this._languageId=g,this._isDirty=d,this.notebook=t,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,y.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===F.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},save(){return w._save()},getText(u){return u?w._getTextInRange(u):w.getText()},get eol(){return w._eol===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(u){return w._lineAt(u)},offsetAt(u){return w._offsetAt(u)},positionAt(u){return w._positionAt(u)},validateRange(u){return w._validateRange(u)},validatePosition(u){return w._validatePosition(u)},getWordRangeAtPosition(u,r){return w._getWordRangeAtPosition(u,r)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,I.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,I.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const u=this._validateRange(w);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const r=this._eol,o=u.start.line,c=u.end.line,g=[];g.push(this._lines[o].substring(u.start.character));for(let d=o+1;d<c;d++)g.push(this._lines[d]);return g.push(this._lines[c].substring(0,u.end.character)),g.join(r)}_lineAt(w){let u;if(w instanceof v.Position?u=w.line:typeof w=="number"&&(u=w),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new S(u,this._lines[u],u===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(w),r=this._lines[u.index].length;return new v.Position(u.index,Math.min(u.remainder,r))}_validateRange(w){if(!(w instanceof v.Range))throw new Error("Invalid argument");const u=this._validatePosition(w.start),r=this._validatePosition(w.end);return u===w.start&&r===w.end?w:new v.Range(u.line,u.character,r.line,r.character)}_validatePosition(w){if(!(w instanceof v.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:u,character:r}=w,o=!1;if(u<0)u=0,r=0,o=!0;else if(u>=this._lines.length)u=this._lines.length-1,r=this._lines[u].length,o=!0;else{const c=this._lines[u].length;r<0?(r=0,o=!0):r>c&&(r=c,o=!0)}return o?new v.Position(u,r):w}_getWordRangeAtPosition(w,u){const r=this._validatePosition(w);if(!u)u=k(this._languageId);else if((0,h.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const o=(0,A.getWordAtText)(r.character+1,(0,A.ensureValidWordDefinition)(u),this._lines[r.line],0);if(o)return new v.Range(r.line,o.startColumn-1,r.line,o.endColumn-1)}}e.ExtHostDocumentData=b;class S{constructor(w,u,r){this._line=w,this._text=u,this._isLastLine=r}get lineNumber(){return this._line}get text(){return this._text}get range(){return new v.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new v.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(De[274],Ie([1,0,7,20,4]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(v){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new h.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(v){let y;switch(v){case"light":y=I.ColorThemeKind.Light;break;case"hcDark":y=I.ColorThemeKind.HighContrast;break;case"hcLight":y=I.ColorThemeKind.HighContrastLight;break;default:y=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R,e.ExtHostTheming=R=je([$e(0,F.IExtHostRpcService)],R)}),define(De[275],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(De[67],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(R){R.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class h{static fromExtHostTestItem(A,v,y=A.parent){if(A._isRoot)return new h([v]);const E=[A.id];for(let T=y;T&&T.id!==v;T=T.parent)E.push(T.id);return E.push(v),new h(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const v=A.indexOf("\0");return v===-1?A:A.slice(0,v)}static fromString(A){return new h(A.split("\0"))}static join(A,v){return new h([...A.path,v])}static joinToString(A,v){return A.toString()+"\0"+v}static parentId(A){const v=A.lastIndexOf("\0");return v===-1?void 0:A.slice(0,v)}static localId(A){const v=A.lastIndexOf("\0");return v===-1?A:A.slice(v+1)}static isChild(A,v){return v.startsWith(A)&&v[A.length]==="\0"}static compare(A,v){return A===v?0:h.isChild(A,v)?2:h.isChild(v,A)?3:1}constructor(A,v=A.length){if(this.path=A,this.viewEnd=v,A.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.viewEnd>1?new h(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let v=0;v<A.viewEnd&&v<this.viewEnd;v++)if(A.path[v]!==this.path[v])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=h}),define(De[87],Ie([1,0,2,34,67]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var v;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=D=>"runId"in D;e.isStartControllerTests=y;var E;(function(D){D.serialize=p=>({range:p.range.toJSON(),uri:p.uri.toJSON()}),D.deserialize=p=>({range:F.Range.lift(p.range),uri:I.URI.revive(p.uri)})})(E||(e.IRichLocation=E={}));var T;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(T||(e.TestMessageType=T={}));var k;(function(D){D.serialize=p=>({message:p.message,type:0,expected:p.expected,actual:p.actual,contextValue:p.contextValue,location:p.location&&E.serialize(p.location)}),D.deserialize=p=>({message:p.message,type:0,expected:p.expected,actual:p.actual,contextValue:p.contextValue,location:p.location&&E.deserialize(p.location)})})(k||(e.ITestErrorMessage=k={}));const b=(D,p)=>`${p?"s":"e"}${D}`;e.getMarkId=b;var S;(function(D){D.serialize=p=>({message:p.message,type:1,offset:p.offset,length:p.length,location:p.location&&E.serialize(p.location)}),D.deserialize=p=>({message:p.message,type:1,offset:p.offset,length:p.length,location:p.location&&E.deserialize(p.location)})})(S||(e.ITestOutputMessage=S={}));var _;(function(D){D.serialize=p=>p.type===0?k.serialize(p):S.serialize(p),D.deserialize=p=>p.type===0?k.deserialize(p):S.deserialize(p)})(_||(e.ITestMessage=_={}));var w;(function(D){D.serializeWithoutMessages=p=>({state:p.state,duration:p.duration,messages:[]}),D.serialize=p=>({state:p.state,duration:p.duration,messages:p.messages.map(_.serialize)}),D.deserialize=p=>({state:p.state,duration:p.duration,messages:p.messages.map(_.deserialize)})})(w||(e.ITestTaskState=w={}));const u="\0",r=(D,p)=>D+u+p;e.namespaceTestTag=r;const o=D=>{const p=D.indexOf(u);return{ctrlId:D.slice(0,p),tagId:D.slice(p+1)}};e.denamespaceTestTag=o;var c;(function(D){D.serialize=p=>({extId:p.extId,label:p.label,tags:p.tags,busy:p.busy,children:void 0,uri:p.uri?.toJSON(),range:p.range?.toJSON()||null,description:p.description,error:p.error,sortText:p.sortText}),D.deserialize=p=>({extId:p.extId,label:p.label,tags:p.tags,busy:p.busy,children:void 0,uri:p.uri?I.URI.revive(p.uri):void 0,range:p.range?F.Range.lift(p.range):null,description:p.description,error:p.error,sortText:p.sortText})})(c||(e.ITestItem=c={}));var g;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var d;(function(D){D.serialize=p=>({expand:p.expand,item:c.serialize(p.item)}),D.deserialize=p=>({controllerId:h.TestId.root(p.item.extId),expand:p.expand,item:c.deserialize(p.item)})})(d||(e.InternalTestItem=d={}));var t;(function(D){D.serialize=p=>{let m;return p.item&&(m={},p.item.label!==void 0&&(m.label=p.item.label),p.item.tags!==void 0&&(m.tags=p.item.tags),p.item.busy!==void 0&&(m.busy=p.item.busy),p.item.uri!==void 0&&(m.uri=p.item.uri?.toJSON()),p.item.range!==void 0&&(m.range=p.item.range?.toJSON()),p.item.description!==void 0&&(m.description=p.item.description),p.item.error!==void 0&&(m.error=p.item.error),p.item.sortText!==void 0&&(m.sortText=p.item.sortText)),{extId:p.extId,expand:p.expand,item:m}},D.deserialize=p=>{let m;return p.item&&(m={},p.item.label!==void 0&&(m.label=p.item.label),p.item.tags!==void 0&&(m.tags=p.item.tags),p.item.busy!==void 0&&(m.busy=p.item.busy),p.item.range!==void 0&&(m.range=p.item.range?F.Range.lift(p.item.range):null),p.item.description!==void 0&&(m.description=p.item.description),p.item.error!==void 0&&(m.error=p.item.error),p.item.sortText!==void 0&&(m.sortText=p.item.sortText)),{extId:p.extId,expand:p.expand,item:m}}})(t||(e.ITestItemUpdate=t={}));const n=(D,p)=>{p.expand!==void 0&&(D.expand=p.expand),p.item!==void 0&&(D.item=D.item?Object.assign(D.item,p.item):p.item)};e.applyTestItemUpdate=n;var s;(function(D){D.serializeWithoutMessages=p=>({...d.serialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.serializeWithoutMessages)}),D.serialize=p=>({...d.serialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.serialize)}),D.deserialize=p=>({...d.deserialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(D){D.deserialize=p=>p.op===0?{op:p.op,item:d.deserialize(p.item)}:p.op===1?{op:p.op,item:t.deserialize(p.item)}:p.op===2?{op:p.op,uri:I.URI.revive(p.uri),docv:p.docv}:p,D.serialize=p=>p.op===0?{op:p.op,item:d.serialize(p.item)}:p.op===1?{op:p.op,item:t.serialize(p.item)}:p})(l||(e.TestsDiffOp=l={}));class C{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(p){const m=this.createChangeCollector();for(const f of p)switch(f.op){case 0:this.add(d.deserialize(f.item),m);break;case 1:this.update(t.deserialize(f.item),m);break;case 3:this.remove(f.itemId,m);break;case 5:this.retireTest(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this._tags.set(f.tag.id,f.tag);break;case 7:this._tags.delete(f.id);break}m.complete?.()}add(p,m){const f=h.TestId.parentId(p.item.extId)?.toString();let P;if(!f)P=this.createItem(p),this.roots.add(P),this.items.set(p.item.extId,P);else if(this.items.has(f)){const M=this.items.get(f);M.children.add(p.item.extId),P=this.createItem(p,M),this.items.set(p.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(p)}`);return}return m.add?.(P),p.expand===2&&this.busyControllerCount++,P}update(p,m){const f=this.items.get(p.extId);if(f)return p.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,p),m.update?.(f),f}remove(p,m){const f=this.items.get(p);if(!f)return;const P=h.TestId.parentId(f.item.extId)?.toString();P?this.items.get(P).children.delete(f.item.extId):this.roots.delete(f);const M=[[p]];for(;M.length;)for(const N of M.pop()){const L=this.items.get(N);L&&(M.push(L.children),this.items.delete(N),m.remove?.(L,L!==f),L.expand===2&&this.busyControllerCount--)}}retireTest(p){}updatePendingRoots(p){this.pendingRootCount+=p}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=C}),define(De[109],Ie([1,0,9,4,3,58,87,67]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk",o[o.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const E=(o,c)=>o===c,k=Object.entries({range:(o,c)=>o===c?!0:!o||!c?!1:o.equalsRange(c),busy:E,label:E,description:E,error:E,sortText:E,tags:(o,c)=>!(o.length!==c.length||o.some(g=>!c.includes(g)))}),b=(o,c)=>{let g;for(const[d,t]of k)t(o[d],c[d])||(g?g[d]=c[d]:g={[d]:c[d]});return g};class S extends h.Disposable{get root(){return this.options.root}constructor(c){super(),this.options=c,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const g of this.tree.values())this.updateExpandability(g)}get resolveHandler(){return this._resolveHandler}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){switch(c.op){case 2:{for(const g of this.diff)if(g.op===2&&g.uri===c.uri){g.docv=c.docv;return}break}case 1:{const g=this.diff[this.diff.length-1];if(g){if(g.op===1&&g.item.extId===c.item.extId){(0,A.applyTestItemUpdate)(g.item,c.item);return}if(g.op===0&&g.item.item.extId===c.item.extId){(0,A.applyTestItemUpdate)(g.item,c.item);return}}break}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,g){const d=this.tree.get(c);if(d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const t=this.resolveChildren(d);return t.isOpen()?this.expandChildren(d,g-1):t.wait().then(()=>this.expandChildren(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,g-1)):this.expandChildren(d,g-1)}}dispose(){for(const c of this.tree.values())this.options.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,g){switch(g.op){case 3:this.removeItem(v.TestId.joinToString(c.fullId,g.id));break;case 0:this.upsertItem(g.item,c);break;case 5:for(const d of g.ops)this.onTestItemEvent(c,d);break;case 1:this.diffTagRefs(g.new,g.old,c.fullId.toString());break;case 2:this.updateExpandability(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:g.update}});break;case 6:this.documentSynced(c.actual.uri);break;default:(0,R.assertNever)(g)}}documentSynced(c){c&&this.pushDiff({op:2,uri:c,docv:this.options.getDocumentVersion(c)})}upsertItem(c,g){const d=v.TestId.fromExtHostTestItem(c,this.root.id,g?.actual),t=this.options.getApiFor(c);t.parent&&t.parent!==g?.actual&&this.options.getChildren(t.parent).delete(c.id);let n=this.tree.get(d.toString());if(!n){n={fullId:d,actual:c,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(c,g),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(c)}}),this.connectItemAndChildren(c,n,g);return}if(n.actual===c){this.connectItem(c,n,g);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.removeItem(d.toString()),this.upsertItem(c,g);const s=this.options.getChildren(n.actual),i=n.actual,a=b(this.options.toITestItem(i),this.options.toITestItem(c));this.options.getApiFor(i).listener=void 0,n.actual=c,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.diffTagRefs(c.tags,i.tags,d.toString()),delete a.tags),this.onTestItemEvent(n,{op:4,update:a})),this.connectItemAndChildren(c,n,g);for(const[l,C]of s)this.options.getChildren(c).get(C.id)||this.removeItem(v.TestId.joinToString(d,C.id));this.documentSynced(n.actual.uri)}diffTagRefs(c,g,d){const t=new Set(g.map(n=>n.id));for(const n of c)t.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:d,item:{tags:c.map(n=>(0,A.namespaceTestTag)(this.options.controllerId,n.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const g=this.tags.get(c.id);g?g.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,c.id)}}))}decrementTagRefs(c){const g=this.tags.get(c);g&&!--g.refCount&&(this.tags.delete(c),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,c)}))}setItemParent(c,g){this.options.getApiFor(c).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(c,g,d){this.setItemParent(c,d);const t=this.options.getApiFor(c);t.parent=d?.actual,t.listener=n=>this.onTestItemEvent(g,n),this.updateExpandability(g)}connectItemAndChildren(c,g,d){this.connectItem(c,g,d);for(const[t,n]of this.options.getChildren(c))this.upsertItem(n,g)}updateExpandability(c){let g;this._resolveHandler?c.resolveBarrier?g=c.resolveBarrier.isOpen()?3:2:g=c.actual.canResolveChildren?1:0:g=0,g!==c.expand&&(c.expand=g,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:g}}),g===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,g){if(g<0)return;const d=[];for(const[t,n]of this.options.getChildren(c.actual)){const s=this.expand(v.TestId.joinToString(c.fullId,n.id),g);(0,I.isThenable)(s)&&d.push(s)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const n=new I.Barrier;return n.open(),n}c.expand=2,this.pushExpandStateUpdate(c);const g=c.resolveBarrier=new I.Barrier,d=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let t;try{t=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(n){d(n)}return(0,I.isThenable)(t)?t.catch(d).then(()=>{g.open(),this.updateExpandability(c)}):(g.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}removeItem(c){const g=this.tree.get(c);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const d=[g];for(;d.length;){const t=d.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(t.fullId.toString());for(const[n,s]of this.options.getChildren(t.actual))d.push(this.tree.get(v.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.TestItemCollection=S;class _ extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=_;class w extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class u extends Error{constructor(c,g,d){super(`TestItem with ID "${c}" is from controller "${g}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=u;const r=(o,c,g)=>{let d=new Map;return{get size(){return d.size},forEach(t,n){for(const s of d.values())t.call(n,s,this)},[Symbol.iterator](){return d.entries()},replace(t){const n=new Map,s=new Set(d.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof g))throw new w(a.id);const l=c(a).controllerId;if(l!==o.controllerId)throw new u(a.id,l,o.controllerId);if(n.has(a.id))throw new _(a.id);n.set(a.id,a),s.delete(a.id),i.ops.push({op:0,item:a})}for(const a of s.keys())i.ops.push({op:3,id:a});o.listener?.(i),d=n},add(t){if(!(t instanceof g))throw new w(t.id);d.set(t.id,t),o.listener?.({op:0,item:t})},delete(t){d.delete(t)&&o.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=r}),define(De[142],Ie([1,0,109]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const F=new WeakMap,h=(A,v)=>{const y={controllerId:v};return F.set(A,y),y};e.createPrivateApiFor=h;const R=A=>{const v=F.get(A);if(!v)throw new I.InvalidTestItemError(A?.id||"<unknown>");return v};e.getPrivateApiFor=R}),define(De[110],Ie([1,0,17,2]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function h(v,y){return v.scheme===I.Schemas.http||v.scheme===I.Schemas.https?v:(y&&y.authority&&y.isRemote&&v.scheme===I.Schemas.file&&(v=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:y.authority,path:v.path})),F.URI.from({scheme:I.Schemas.https,authority:`${v.scheme}+${R(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}e.asWebviewUri=h;function R(v){return v.replace(/./g,y=>{const E=y.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?y:"-"+E.toString(16).padStart(4,"0")})}function A(v){return v.replace(/-([0-9a-f]{4})/g,(y,E)=>String.fromCharCode(parseInt(E,16)))}e.decodeAuthority=A}),define(De[276],Ie([1,0,4,3,110]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(v,y,E){this._proxy=v,this._editors=y,this._remoteInfo=E,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const T=y.getVisibleTextEditors();for(const k of this._insets.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(v=>v.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(v,y,E,T,k){let b;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===v){b=c;break}if(!b)throw new Error("not a visible editor");const S=this,_=this._handlePool++,w=new I.Emitter,u=new I.Emitter,r=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,h.asWebviewUri)(c,S._remoteInfo)}get cspSource(){return h.webviewGenericCspSource}set options(c){this._options=c,S._proxy.$setOptions(_,c)}get options(){return this._options}set html(c){this._html=c,S._proxy.$setHtml(_,c)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(c){return S._proxy.$postMessage(_,c)}},o=new class{constructor(){this.editor=v,this.line=y,this.height=E,this.webview=r,this.onDidDispose=u.event}dispose(){S._insets.has(_)&&(S._insets.delete(_),S._proxy.$disposeEditorInset(_),u.fire(),u.dispose(),w.dispose())}};return this._proxy.$createEditorInset(_,b.id,b.value.document.uri,y+1,E,T||{},k.identifier,k.extensionLocation),this._insets.set(_,{editor:v,inset:o,onDidReceiveMessage:w}),o}$onDidDispose(v){const y=this._insets.get(v);y&&y.inset.dispose()}$onDidReceiveMessage(v,y){this._insets.get(v)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(De[277],Ie([1,0,5]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var F;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class h extends Error{constructor(A,v){super(v),this.variable=A}}e.VariableError=h}),define(De[278],Ie([1,0,16,47,18,23,12,99,223,277,15]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,_,w,u){this._contributedVariables=new Map,this._context=S,this._labelService=_,this._userHomePromise=w,u&&(this._envVariablesPromise=u.then(r=>this.prepareEnv(r)))}prepareEnv(S){if(A.isWindows){const _=Object.create(null);return Object.keys(S).forEach(w=>{_[w.toLowerCase()]=S[w]}),_}return S}resolveWithEnvironment(S,_,w){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},_?_.uri:void 0,w)}async resolveAsync(S,_){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,S?S.uri:void 0,_)}async resolveAnyBase(S,_,w,u){const r=R.deepClone(_);A.isWindows&&r.windows?Object.keys(r.windows).forEach(c=>r[c]=r.windows[c]):A.isMacintosh&&r.osx?Object.keys(r.osx).forEach(c=>r[c]=r.osx[c]):A.isLinux&&r.linux&&Object.keys(r.linux).forEach(c=>r[c]=r.linux[c]),delete r.windows,delete r.osx,delete r.linux;const o={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(o,S?S.uri:void 0,r,w,u)}async resolveAnyAsync(S,_,w){return this.resolveAnyBase(S,_,w)}async resolveAnyMap(S,_,w){const u=new Map;return{newConfig:await this.resolveAnyBase(S,_,w,u),resolvedVariables:u}}resolveWithInteractionReplace(S,_,w,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,_,w,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,_){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,_)}async recursiveResolve(S,_,w,u,r){if(h.isString(w))return this.resolveString(S,_,w,u,r);if(Array.isArray(w))return Promise.all(w.map(o=>this.recursiveResolve(S,_,o,u,r)));if(h.isObject(w)){const o=Object.create(null),c=await Promise.all(Object.keys(w).map(async g=>[await this.resolveString(S,_,g,u,r),await this.recursiveResolve(S,_,w[g],u,r)]));for(const[g,d]of c)o[g]=d;return o}return w}resolveString(S,_,w,u,r){return(0,T.replaceAsync)(w,k.VARIABLE_REGEXP,async(o,c)=>{if(c.includes(k.VARIABLE_LHS))return o;let g=await this.evaluateSingleVariable(S,o,c,_,u);return r?.set(c,g),g!==o&&h.isString(g)&&g.match(k.VARIABLE_REGEXP)&&(g=await this.resolveString(S,_,g,u,r)),g})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,_,w,u,r){let o;const c=w.split(":");c.length>1&&(w=c[0],o=c[1]);const g=n=>{const s=this._context.getFilePath();if(s)return(0,v.normalizeDriveLetter)(s);throw new E.VariableError(n,(0,y.localize)(0,null,_))},d=n=>{const s=g(n);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return(0,v.normalizeDriveLetter)(i)}throw new E.VariableError(n,(0,y.localize)(1,null,_,I.basename(s)))},t=n=>{if(o){const s=this._context.getFolderUri(o);if(s)return s;throw new E.VariableError(n,(0,y.localize)(2,null,_,o))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new E.VariableError(n,(0,y.localize)(3,null,_)):new E.VariableError(n,(0,y.localize)(4,null,_))};switch(w){case"env":if(o){if(S.env){const n=S.env[A.isWindows?o.toLowerCase():o];if(h.isString(n))return n}return""}throw new E.VariableError(E.VariableKind.Env,(0,y.localize)(5,null,_));case"config":if(o){const n=this._context.getConfigurationValue(u,o);if(h.isUndefinedOrNull(n))throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(6,null,_,o));if(h.isObject(n))throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(7,null,_,o));return n}throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(8,null,_));case"command":return this.resolveFromMap(E.VariableKind.Command,_,o,r,"command");case"input":return this.resolveFromMap(E.VariableKind.Input,_,o,r,"input");case"extensionInstallFolder":if(o){const n=await this._context.getExtension(o);if(!n)throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,_,o));return this.fsPath(n.extensionLocation)}throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,_));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,v.normalizeDriveLetter)(this.fsPath(t(E.VariableKind.WorkspaceFolder)));case"cwd":return u||o?(0,v.normalizeDriveLetter)(this.fsPath(t(E.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.normalizeDriveLetter)(I.basename(this.fsPath(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.VariableError(E.VariableKind.UserHome,(0,y.localize)(11,null,_))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new E.VariableError(E.VariableKind.LineNumber,(0,y.localize)(12,null,_))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new E.VariableError(E.VariableKind.SelectedText,(0,y.localize)(13,null,_))}case"file":return g(E.VariableKind.File);case"fileWorkspaceFolder":return d(E.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||o?I.relative(this.fsPath(t(E.VariableKind.RelativeFile)),g(E.VariableKind.RelativeFile)):g(E.VariableKind.RelativeFile);case"relativeFileDirname":{const n=I.dirname(g(E.VariableKind.RelativeFileDirname));if(u||o){const s=I.relative(this.fsPath(t(E.VariableKind.RelativeFileDirname)),n);return s.length===0?".":s}return n}case"fileDirname":return I.dirname(g(E.VariableKind.FileDirname));case"fileExtname":return I.extname(g(E.VariableKind.FileExtname));case"fileBasename":return I.basename(g(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=I.basename(g(E.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-I.extname(n).length)}case"fileDirnameBasename":return I.basename(I.dirname(g(E.VariableKind.FileDirnameBasename)));case"execPath":{const n=this._context.getExecPath();return n||_}case"execInstallFolder":{const n=this._context.getAppRoot();return n||_}case"pathSeparator":return I.sep;default:try{const n=o?`${w}:${o}`:w;return this.resolveFromMap(E.VariableKind.Unknown,_,n,r,void 0)}catch{return _}}}}resolveFromMap(S,_,w,u,r){if(w&&u){const o=r===void 0?u[w]:u[r+":"+w];if(typeof o=="string")return o;throw new E.VariableError(S,(0,y.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=k}),define(De[143],Ie([1,0,5,139]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var h;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var R;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var v;(function(_){_[_.MAXIMIZE=0]="MAXIMIZE",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(v||(e.GroupsArrangement=v={}));var y;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function E(_){const w=_;return(0,F.isEditorInput)(w?.editor)&&(0,F.isEditorInput)(w?.replacement)}e.isEditorReplacement=E;var T;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function b(_){const w=_;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=b;function S(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(De[279],Ie([1,0,5,143]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function h(R){const A=R;return typeof R=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=h}),define(De[14],Ie([1,0,19,22,162,74,79,28,158,62,97,23,18,2,34,82,133,142,139,108,67,87,279,7]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Le){function Fe(ne){const{selectionStartLineNumber:Oe,selectionStartColumn:Ve,positionLineNumber:Je,positionColumn:Ge}=ne,nt=new n.Position(Oe-1,Ve-1),gt=new n.Position(Je-1,Ge-1);return new n.Selection(nt,gt)}Le.to=Fe;function Ce(ne){const{anchor:Oe,active:Ve}=ne;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Le.from=Ce})(s||(e.Selection=s={}));var i;(function(Le){function Fe(ne){if(!ne)return;const{start:Oe,end:Ve}=ne;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Le.from=Fe;function Ce(ne){if(!ne)return;const{startLineNumber:Oe,startColumn:Ve,endLineNumber:Je,endColumn:Ge}=ne;return new n.Range(Oe-1,Ve-1,Je-1,Ge-1)}Le.to=Ce})(i||(e.Range=i={}));var a;(function(Le){function Fe(Ce){switch(Ce){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Le.to=Fe})(a||(e.TokenType=a={}));var l;(function(Le){function Fe(ne){return new n.Position(ne.lineNumber-1,ne.column-1)}Le.to=Fe;function Ce(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Le.from=Ce})(l||(e.Position=l={}));var C;(function(Le){function Fe(Oe,Ve,Je){return(0,I.coalesce)((0,I.asArray)(Oe).map(Ge=>Ce(Ge,Ve,Je)))}Le.from=Fe;function Ce(Oe,Ve,Je){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Je?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ne(Oe.scheme,Ve),pattern:Xe.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Je?.isBuiltin}}function ne(Oe,Ve){return Ve&&typeof Oe=="string"?Ve.transformOutgoingScheme(Oe):Oe}})(C||(e.DocumentSelector=C={}));var D;(function(Le){function Fe(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function Ce(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Le.to=Ce})(D||(e.DiagnosticTag=D={}));var p;(function(Le){function Fe(ne){let Oe;return ne.code&&((0,b.isString)(ne.code)||(0,b.isNumber)(ne.code)?Oe=String(ne.code):Oe={value:String(ne.code.value),target:ne.code.target}),{...i.from(ne.range),message:ne.message,source:ne.source,code:Oe,severity:f.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(m.from),tags:Array.isArray(ne.tags)?(0,I.coalesce)(ne.tags.map(D.from)):void 0}}Le.from=Fe;function Ce(ne){const Oe=new n.Diagnostic(i.to(ne),ne.message,f.to(ne.severity));return Oe.source=ne.source,Oe.code=(0,b.isString)(ne.code)?ne.code:ne.code?.value,Oe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(m.to),Oe.tags=ne.tags&&(0,I.coalesce)(ne.tags.map(D.to)),Oe}Le.to=Ce})(p||(e.Diagnostic=p={}));var m;(function(Le){function Fe(ne){return{...i.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Le.from=Fe;function Ce(ne){return new n.DiagnosticRelatedInformation(new n.Location(ne.resource,i.to(ne)),ne.message)}Le.to=Ce})(m||(e.DiagnosticRelatedInformation=m={}));var f;(function(Le){function Fe(ne){switch(ne){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Le.from=Fe;function Ce(ne){switch(ne){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Le.to=Ce})(f||(e.DiagnosticSeverity=f={}));var P;(function(Le){function Fe(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Fe;function Ce(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ce})(P||(e.ViewColumn=P={}));function M(Le){return typeof Le.range<"u"}function N(Le){return Le.length===0?!0:!!M(Le[0])}e.isDecorationOptionsArr=N;var L;(function(Le){function Fe(Ge){return Ge.map(Le.from)}Le.fromMany=Fe;function Ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ne(Ge){let nt;if(Ce(Ge)){const{language:ht,value:At}=Ge;nt={value:"```"+ht+`
`+At+"\n```\n"}}else n.MarkdownString.isMarkdownString(Ge)?nt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?nt={value:Ge}:nt={value:""};const gt=Object.create(null);nt.uris=gt;const mt=ht=>{try{let At=S.URI.parse(ht,!0);At=At.with({query:Oe(At.query,gt)}),gt[ht]=At}catch{}return""},vt=new y.marked.Renderer;return vt.link=mt,vt.image=ht=>typeof ht=="string"?mt(A.parseHrefAndDimensions(ht).href):"",(0,y.marked)(nt.value,{renderer:vt}),nt}Le.from=ne;function Oe(Ge,nt){if(!Ge)return Ge;let gt;try{gt=(0,E.parse)(Ge)}catch{}if(!gt)return Ge;let mt=!1;return gt=(0,k.cloneAndChange)(gt,vt=>{if(S.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ht]=vt,mt=!0,ht}else return}),mt?JSON.stringify(gt):Ge}function Ve(Ge){const nt=new n.MarkdownString(Ge.value,Ge.supportThemeIcons);return nt.isTrusted=Ge.isTrusted,nt.supportHtml=Ge.supportHtml,nt.baseUri=Ge.baseUri?S.URI.from(Ge.baseUri):void 0,nt}Le.to=Ve;function Je(Ge){if(Ge)return typeof Ge=="string"?Ge:Le.from(Ge)}Le.fromStrict=Je})(L||(e.MarkdownString=L={}));function U(Le){return N(Le)?Le.map(Fe=>({range:i.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?L.fromMany(Fe.hoverMessage):Fe.hoverMessage?L.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:i.from(Fe)}))}e.fromRangeOrRangeWithMessage=U;function x(Le){return typeof Le>"u"?Le:typeof Le=="string"?S.URI.file(Le):Le}e.pathOrURIToURI=x;var O;(function(Le){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?x(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Le.from=Fe})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var j;(function(Le){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?x(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?O.from(Ce.before):void 0,after:Ce.after?O.from(Ce.after):void 0}}Le.from=Fe})(j||(e.ThemableDecorationRenderOptions=j={}));var V;(function(Le){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(V||(e.DecorationRangeBehavior=V={}));var fe;(function(Le){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?V.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?j.from(Ce.light):void 0,dark:Ce.dark?j.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?x(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?O.from(Ce.before):void 0,after:Ce.after?O.from(Ce.after):void 0}}Le.from=Fe})(fe||(e.DecorationRenderOptions=fe={}));var J;(function(Le){function Fe(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:i.from(ne.range)}}Le.from=Fe;function Ce(ne){const Oe=new n.TextEdit(i.to(ne.range),ne.text);return Oe.newEol=typeof ne.eol>"u"?void 0:et.to(ne.eol),Oe}Le.to=Ce})(J||(e.TextEdit=J={}));var X;(function(Le){function Fe(ne,Oe){const Ve={edits:[]};if(ne instanceof n.WorkspaceEdit){const Je=new v.ResourceSet;for(const Ge of ne._allEntries())Ge._type===1&&S.URI.isUri(Ge.to)&&Ge.from===void 0&&Je.add(Ge.to);for(const Ge of ne._allEntries())if(Ge._type===1){let nt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?nt={type:"base64",value:(0,F.encodeBase64)(F.VSBuffer.wrap(Ge.options.contents))}:nt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:nt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:J.from(Ge.edit),versionId:Je.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:i.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Je.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return Ve}Le.from=Fe;function Ce(ne){const Oe=new n.WorkspaceEdit,Ve=new v.ResourceMap;for(const Je of ne.edits)if(Je.textEdit){const Ge=Je,nt=S.URI.revive(Ge.resource),gt=i.to(Ge.textEdit.range),mt=Ge.textEdit.text,vt=Ge.textEdit.insertAsSnippet;let ht;vt?ht=n.SnippetTextEdit.replace(gt,new n.SnippetString(mt)):ht=n.TextEdit.replace(gt,mt);const At=Ve.get(nt);At?At.push(ht):Ve.set(nt,[ht])}else Oe.renameFile(S.URI.revive(Je.oldResource),S.URI.revive(Je.newResource),Je.options);for(const[Je,Ge]of Ve)Oe.set(Je,Ge);return Oe}Le.to=Ce})(X||(e.WorkspaceEdit=X={}));var z;(function(Le){const Fe=Object.create(null);Fe[n.SymbolKind.File]=0,Fe[n.SymbolKind.Module]=1,Fe[n.SymbolKind.Namespace]=2,Fe[n.SymbolKind.Package]=3,Fe[n.SymbolKind.Class]=4,Fe[n.SymbolKind.Method]=5,Fe[n.SymbolKind.Property]=6,Fe[n.SymbolKind.Field]=7,Fe[n.SymbolKind.Constructor]=8,Fe[n.SymbolKind.Enum]=9,Fe[n.SymbolKind.Interface]=10,Fe[n.SymbolKind.Function]=11,Fe[n.SymbolKind.Variable]=12,Fe[n.SymbolKind.Constant]=13,Fe[n.SymbolKind.String]=14,Fe[n.SymbolKind.Number]=15,Fe[n.SymbolKind.Boolean]=16,Fe[n.SymbolKind.Array]=17,Fe[n.SymbolKind.Object]=18,Fe[n.SymbolKind.Key]=19,Fe[n.SymbolKind.Null]=20,Fe[n.SymbolKind.EnumMember]=21,Fe[n.SymbolKind.Struct]=22,Fe[n.SymbolKind.Event]=23,Fe[n.SymbolKind.Operator]=24,Fe[n.SymbolKind.TypeParameter]=25;function Ce(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Le.from=Ce;function ne(Oe){for(const Ve in Fe)if(Fe[Ve]===Oe)return Number(Ve);return n.SymbolKind.Property}Le.to=ne})(z||(e.SymbolKind=z={}));var Q;(function(Le){function Fe(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Le.from=Fe;function Ce(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Le.to=Ce})(Q||(e.SymbolTag=Q={}));var ve;(function(Le){function Fe(ne){return{name:ne.name,kind:z.from(ne.kind),tags:ne.tags&&ne.tags.map(Q.from),containerName:ne.containerName,location:H.from(ne.location)}}Le.from=Fe;function Ce(ne){const Oe=new n.SymbolInformation(ne.name,z.to(ne.kind),ne.containerName,H.to(ne.location));return Oe.tags=ne.tags&&ne.tags.map(Q.to),Oe}Le.to=Ce})(ve||(e.WorkspaceSymbol=ve={}));var le;(function(Le){function Fe(ne){const Oe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),kind:z.from(ne.kind),tags:ne.tags?.map(Q.from)??[]};return ne.children&&(Oe.children=ne.children.map(Fe)),Oe}Le.from=Fe;function Ce(ne){const Oe=new n.DocumentSymbol(ne.name,ne.detail,z.to(ne.kind),i.to(ne.range),i.to(ne.selectionRange));return(0,I.isNonEmptyArray)(ne.tags)&&(Oe.tags=ne.tags.map(Q.to)),ne.children&&(Oe.children=ne.children.map(Ce)),Oe}Le.to=Ce})(le||(e.DocumentSymbol=le={}));var we;(function(Le){function Fe(ne){const Oe=new n.CallHierarchyItem(z.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Le.to=Fe;function Ce(ne,Oe,Ve){if(Oe=Oe??ne._sessionId,Ve=Ve??ne._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,name:ne.name,detail:ne.detail,kind:z.from(ne.kind),uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(Q.from)}}Le.from=Ce})(we||(e.CallHierarchyItem=we={}));var G;(function(Le){function Fe(Ce){return new n.CallHierarchyIncomingCall(we.to(Ce.from),Ce.fromRanges.map(ne=>i.to(ne)))}Le.to=Fe})(G||(e.CallHierarchyIncomingCall=G={}));var B;(function(Le){function Fe(Ce){return new n.CallHierarchyOutgoingCall(we.to(Ce.to),Ce.fromRanges.map(ne=>i.to(ne)))}Le.to=Fe})(B||(e.CallHierarchyOutgoingCall=B={}));var H;(function(Le){function Fe(ne){return{range:ne.range&&i.from(ne.range),uri:ne.uri}}Le.from=Fe;function Ce(ne){return new n.Location(S.URI.revive(ne.uri),i.to(ne.range))}Le.to=Ce})(H||(e.location=H={}));var me;(function(Le){function Fe(ne){const Oe=ne,Ve=ne;return{originSelectionRange:Oe.originSelectionRange?i.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ve.uri,range:i.from(Oe.targetRange?Oe.targetRange:Ve.range),targetSelectionRange:Oe.targetSelectionRange?i.from(Oe.targetSelectionRange):void 0}}Le.from=Fe;function Ce(ne){return{targetUri:S.URI.revive(ne.uri),targetRange:i.to(ne.range),targetSelectionRange:ne.targetSelectionRange?i.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?i.to(ne.originSelectionRange):void 0}}Le.to=Ce})(me||(e.DefinitionLink=me={}));var Z;(function(Le){function Fe(ne){return{range:i.from(ne.range),contents:L.fromMany(ne.contents)}}Le.from=Fe;function Ce(ne){return new n.Hover(ne.contents.map(L.to),i.to(ne.range))}Le.to=Ce})(Z||(e.Hover=Z={}));var ie;(function(Le){function Fe(ne){return{range:i.from(ne.range),expression:ne.expression}}Le.from=Fe;function Ce(ne){return new n.EvaluatableExpression(i.to(ne.range),ne.expression)}Le.to=Ce})(ie||(e.EvaluatableExpression=ie={}));var re;(function(Le){function Fe(ne){if(ne instanceof n.InlineValueText)return{type:"text",range:i.from(ne.range),text:ne.text};if(ne instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function Ce(ne){switch(ne.type){case"text":return{range:i.to(ne.range),text:ne.text};case"variable":return{range:i.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:i.to(ne.range),expression:ne.expression}}}Le.to=Ce})(re||(e.InlineValue=re={}));var ye;(function(Le){function Fe(ne){return{frameId:ne.frameId,stoppedLocation:i.from(ne.stoppedLocation)}}Le.from=Fe;function Ce(ne){return new n.InlineValueContext(ne.frameId,i.to(ne.stoppedLocation))}Le.to=Ce})(ye||(e.InlineValueContext=ye={}));var oe;(function(Le){function Fe(ne){return{range:i.from(ne.range),kind:ne.kind}}Le.from=Fe;function Ce(ne){return new n.DocumentHighlight(i.to(ne.range),ne.kind)}Le.to=Ce})(oe||(e.DocumentHighlight=oe={}));var de;(function(Le){function Fe(Ce){switch(Ce){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Le.to=Fe})(de||(e.CompletionTriggerKind=de={}));var ee;(function(Le){function Fe(Ce){return{triggerKind:de.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Le.to=Fe})(ee||(e.CompletionContext=ee={}));var ue;(function(Le){function Fe(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function Ce(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Le.to=Ce})(ue||(e.CompletionItemTag=ue={}));var pe;(function(Le){const Fe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Ce(Ve){return Fe.get(Ve)??9}Le.from=Ce;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Oe(Ve){return ne.get(Ve)??n.CompletionItemKind.Property}Le.to=Oe})(pe||(e.CompletionItemKind=pe={}));var Pe;(function(Le){function Fe(Ce,ne){const Oe=new n.CompletionItem(Ce.label);return Oe.insertText=Ce.insertText,Oe.kind=pe.to(Ce.kind),Oe.tags=Ce.tags?.map(ue.to),Oe.detail=Ce.detail,Oe.documentation=A.isMarkdownString(Ce.documentation)?L.to(Ce.documentation):Ce.documentation,Oe.sortText=Ce.sortText,Oe.filterText=Ce.filterText,Oe.preselect=Ce.preselect,Oe.commitCharacters=Ce.commitCharacters,_.Range.isIRange(Ce.range)?Oe.range=i.to(Ce.range):typeof Ce.range=="object"&&(Oe.range={inserting:i.to(Ce.range.insert),replacing:i.to(Ce.range.replace)}),Oe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Oe.insertText=new n.SnippetString(Ce.insertText):(Oe.insertText=Ce.insertText,Oe.textEdit=Oe.range instanceof n.Range?new n.TextEdit(Oe.range,Oe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>J.to(Ve))),Oe.command=ne&&Ce.command?ne.fromInternal(Ce.command):void 0,Oe}Le.to=Fe})(Pe||(e.CompletionItem=Pe={}));var $;(function(Le){function Fe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:L.fromStrict(ne.documentation)}}Le.from=Fe;function Ce(ne){return{label:ne.label,documentation:A.isMarkdownString(ne.documentation)?L.to(ne.documentation):ne.documentation}}Le.to=Ce})($||(e.ParameterInformation=$={}));var K;(function(Le){function Fe(ne){return{label:ne.label,documentation:L.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map($.from):[],activeParameter:ne.activeParameter}}Le.from=Fe;function Ce(ne){return{label:ne.label,documentation:A.isMarkdownString(ne.documentation)?L.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map($.to):[],activeParameter:ne.activeParameter}}Le.to=Ce})(K||(e.SignatureInformation=K={}));var te;(function(Le){function Fe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(K.from):[]}}Le.from=Fe;function Ce(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(K.to):[]}}Le.to=Ce})(te||(e.SignatureHelp=te={}));var se;(function(Le){function Fe(Ce,ne){const Oe=new n.InlayHint(l.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Y.to.bind(void 0,Ce)),ne.kind&&he.to(ne.kind));return Oe.textEdits=ne.textEdits&&ne.textEdits.map(J.to),Oe.tooltip=A.isMarkdownString(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,Oe.paddingLeft=ne.paddingLeft,Oe.paddingRight=ne.paddingRight,Oe}Le.to=Fe})(se||(e.InlayHint=se={}));var Y;(function(Le){function Fe(Ce,ne){const Oe=new n.InlayHintLabelPart(ne.label);return Oe.tooltip=A.isMarkdownString(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,w.Command.is(ne.command)&&(Oe.command=Ce.fromInternal(ne.command)),ne.location&&(Oe.location=H.to(ne.location)),Oe}Le.to=Fe})(Y||(e.InlayHintLabelPart=Y={}));var he;(function(Le){function Fe(ne){return ne}Le.from=Fe;function Ce(ne){return ne}Le.to=Ce})(he||(e.InlayHintKind=he={}));var Se;(function(Le){function Fe(ne){return{range:i.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Le.from=Fe;function Ce(ne){let Oe;if(ne.url)try{Oe=typeof ne.url=="string"?S.URI.parse(ne.url,!0):S.URI.revive(ne.url)}catch{}return new n.DocumentLink(i.to(ne.range),Oe)}Le.to=Ce})(Se||(e.DocumentLink=Se={}));var Ue;(function(Le){function Fe(ne){const Oe=new n.ColorPresentation(ne.label);return ne.textEdit&&(Oe.textEdit=J.to(ne.textEdit)),ne.additionalTextEdits&&(Oe.additionalTextEdits=ne.additionalTextEdits.map(Ve=>J.to(Ve))),Oe}Le.to=Fe;function Ce(ne){return{label:ne.label,textEdit:ne.textEdit?J.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Oe=>J.from(Oe)):void 0}}Le.from=Ce})(Ue||(e.ColorPresentation=Ue={}));var We;(function(Le){function Fe(ne){return new n.Color(ne[0],ne[1],ne[2],ne[3])}Le.to=Fe;function Ce(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Le.from=Ce})(We||(e.Color=We={}));var Ze;(function(Le){function Fe(ne){return{range:i.from(ne.range)}}Le.from=Fe;function Ce(ne){return new n.SelectionRange(i.to(ne.range))}Le.to=Ce})(Ze||(e.SelectionRange=Ze={}));var Qe;(function(Le){function Fe(Ce){switch(Ce){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var it;(function(Le){function Fe(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function Ce(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Le.to=Ce})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Le){function Fe(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Le.from=Fe;function Ce(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Le.to=Ce})(et||(e.EndOfLine=et={}));var Te;(function(Le){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Te||(e.ProgressLocation=Te={}));var Me;(function(Le){function Fe(ne){const Oe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Oe.kind=ze.from(ne.kind)),Oe}Le.from=Fe;function Ce(ne){const Oe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Oe.kind=ze.to(ne.kind)),Oe}Le.to=Ce})(Me||(e.FoldingRange=Me={}));var ze;(function(Le){function Fe(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Le.from=Fe;function Ce(ne){if(ne)switch(ne.value){case w.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}Le.to=Ce})(ze||(e.FoldingRangeKind=ze={}));var Re;(function(Le){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?i.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?o.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Fe})(Re||(e.TextEditorOpenOptions=Re={}));var Xe;(function(Le){function Fe(Ve){return Ve instanceof n.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||ne(Ve)?new n.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Le.from=Fe;function Ce(Ve){const Je=Ve;return Je?S.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function ne(Ve){const Je=Ve;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Oe(Ve){return typeof Ve=="string"?Ve:new n.RelativePattern(S.URI.revive(Ve.baseUri),Ve.pattern)}Le.to=Oe})(Xe||(e.GlobPattern=Xe={}));var ce;(function(Le){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const ne=Ce;return{language:ne.language,scheme:ne.scheme,pattern:Xe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Le.from=Fe})(ce||(e.LanguageSelector=ce={}));var ae;(function(Le){function Fe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&S.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Je=>Je instanceof n.Range)))}Le.is=Fe;function Ce(ne){return{documents:ne.documents.map(Oe=>Oe.map(Ve=>({uri:S.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Je=>i.from(Je))})))}}Le.from=Ce})(ae||(e.MappedEditsContext=ae={}));var ke;(function(Le){function Fe(ne){return{start:ne.start,end:ne.end}}Le.from=Fe;function Ce(ne){return new n.NotebookRange(ne.start,ne.end)}Le.to=Ce})(ke||(e.NotebookRange=ke={}));var He;(function(Le){function Fe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Le.to=Fe;function Ce(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Le.from=Ce})(He||(e.NotebookCellExecutionSummary=He={}));var xe;(function(Le){function Fe(Ce){if(Ce===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Ce===c.NotebookCellExecutionState.Pending)return;if(Ce===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Le.to=Fe})(xe||(e.NotebookCellExecutionState=xe={}));var Ye;(function(Le){function Fe(ne){switch(ne){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Le.from=Fe;function Ce(ne){switch(ne){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Le.to=Ce})(Ye||(e.NotebookCellKind=Ye={}));var rt;(function(Le){function Fe(ne){const Oe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)n.NotebookCellData.validate(Ve),Oe.cells.push(ot.from(Ve));return Oe}Le.from=Fe;function Ce(ne){const Oe=new n.NotebookData(ne.cells.map(ot.to));return(0,b.isEmptyObject)(ne.metadata)||(Oe.metadata=ne.metadata),Oe}Le.to=Ce})(rt||(e.NotebookData=rt={}));var ot;(function(Le){function Fe(ne){return{cellKind:Ye.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:He.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(yt.from):[]}}Le.from=Fe;function Ce(ne){return new n.NotebookCellData(Ye.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(yt.to):void 0,ne.metadata,ne.internalMetadata?He.to(ne.internalMetadata):void 0)}Le.to=Ce})(ot||(e.NotebookCellData=ot={}));var Et;(function(Le){function Fe(ne){return{mime:ne.mime,valueBytes:F.VSBuffer.wrap(ne.data)}}Le.from=Fe;function Ce(ne){return new n.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Le.to=Ce})(Et||(e.NotebookCellOutputItem=Et={}));var yt;(function(Le){function Fe(ne){return{outputId:ne.id,items:ne.items.map(Et.from),metadata:ne.metadata}}Le.from=Fe;function Ce(ne){const Oe=ne.items.map(Et.to);return new n.NotebookCellOutput(Oe,ne.outputId,ne.metadata)}Le.to=Ce})(yt||(e.NotebookCellOutput=yt={}));var Qt;(function(Le){function Fe(Oe){return ne(Oe)?{include:Xe.from(Oe.include)??void 0,exclude:Xe.from(Oe.exclude)??void 0}:Xe.from(Oe)??void 0}Le.from=Fe;function Ce(Oe){return ne(Oe)?{include:Xe.to(Oe.include),exclude:Xe.to(Oe.exclude)}:Xe.to(Oe)}Le.to=Ce;function ne(Oe){const Ve=Oe;return Ve?!(0,b.isUndefinedOrNull)(Ve.include)&&!(0,b.isUndefinedOrNull)(Ve.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Le){function Fe(Ce,ne,Oe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Oe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Le.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var bt;(function(Le){function Fe(Ce,ne,Oe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ne.toInternal(Ve,Oe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Le.from=Fe})(bt||(e.NotebookKernelSourceAction=bt={}));var Bt;(function(Le){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Le.from=Fe})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var Ot;(function(Le){function Fe(ne){return{uri:ne.uri,provides:ne.provides}}Le.from=Fe;function Ce(ne){return new n.NotebookRendererScript(S.URI.revive(ne.uri),ne.provides)}Le.to=Ce})(Ot||(e.NotebookRendererScript=Ot={}));var $t;(function(Le){function Fe(ne){return{message:L.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:i.from(ne.location.range),uri:ne.location.uri}}}Le.from=Fe;function Ce(ne){const Oe=new n.TestMessage(typeof ne.message=="string"?ne.message:L.to(ne.message));return Oe.actualOutput=ne.actual,Oe.expectedOutput=ne.expected,Oe.contextValue=ne.contextValue,Oe.location=ne.location?H.to(ne.location):void 0,Oe}Le.to=Ce})($t||(e.TestMessage=$t={}));var Pt;(function(Le){Le.namespace=d.namespaceTestTag,Le.denamespace=d.denamespaceTestTag})(Pt||(e.TestTag=Pt={}));var Tt;(function(Le){function Fe(ne){const Oe=(0,r.getPrivateApiFor)(ne).controllerId;return{extId:g.TestId.fromExtHostTestItem(ne,Oe).toString(),label:ne.label,uri:S.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>Pt.namespace(Oe,Ve.id)),range:_.Range.lift(i.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&L.fromStrict(ne.error)||null}}Le.from=Fe;function Ce(ne){return{parent:void 0,error:void 0,id:g.TestId.fromString(ne.extId).localId,label:ne.label,uri:S.URI.revive(ne.uri),tags:(ne.tags||[]).map(Oe=>{const{tagId:Ve}=Pt.denamespace(Oe);return new n.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Le.toPlain=Ce})(Tt||(e.TestItem=Tt={})),function(Le){function Fe(ne){return{id:ne.id}}Le.from=Fe;function Ce(ne){return new n.TestTag(ne.id)}Le.to=Ce}(Pt||(e.TestTag=Pt={}));var Mt;(function(Le){const Fe=(ne,Oe)=>{const Ve=[];for(const[Ge,nt]of Oe)g.TestId.compare(nt.item.extId,Ge)===2&&(Oe.delete(Ge),Ve.push(nt));const Je={...Tt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(nt=>nt.type===0).map($t.to)})),children:Ve.map(Ge=>Fe(Ge,Oe))};for(const Ge of Je.children)Ge.parent=Je;return Je};function Ce(ne){const Oe=[],Ve=new Map;for(const Je of ne.items){Ve.set(Je.item.extId,Je);const Ge=g.TestId.root(Je.item.extId);ne.request.targets.some(nt=>nt.controllerId===Ge&&nt.testIds.includes(Je.item.extId))&&Oe.push(Je)}return{completedAt:ne.completedAt,results:Oe.map(Je=>Fe(Je,Ve))}}Le.to=Ce})(Mt||(e.TestResults=Mt={}));var Wt;(function(Le){function Fe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ce(Ve){return"line"in Ve?l.from(Ve):i.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Ce(Je.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ce(Ve.location)}}Le.fromDetailed=ne;function Oe(Ve){return{uri:Ve.uri,statement:Fe(Ve.statementCoverage),branch:Ve.branchCoverage&&Fe(Ve.branchCoverage),function:Ve.functionCoverage&&Fe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ne)}}Le.fromFile=Oe})(Wt||(e.TestCoverage=Wt={}));var jt;(function(Le){function Fe(Ce){switch(Ce){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Le.to=Fe})(jt||(e.CodeActionTriggerKind=jt={}));var zt;(function(Le){function Fe(ne){const Oe=new n.TypeHierarchyItem(z.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Le.to=Fe;function Ce(ne,Oe,Ve){if(Oe=Oe??ne._sessionId,Ve=Ve??ne._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,kind:z.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(Q.from)}}Le.from=Ce})(zt||(e.TypeHierarchyItem=zt={}));var ct;(function(Le){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Le.from=Fe})(ct||(e.ViewBadge=ct={}));var ut;(function(Le){function Fe(Ve,Je,Ge){const nt=Je.fileData;return nt?new n.InternalFileDataTransferItem(new n.DataTransferFile(nt.name,S.URI.revive(nt.uri),nt.id,(0,R.createSingleCallFunction)(()=>Ge(nt.id)))):Ve===T.Mimes.uriList&&Je.uriListData?new n.InternalDataTransferItem(Oe(Je.uriListData)):new n.InternalDataTransferItem(Je.asString)}Le.to=Fe;async function Ce(Ve,Je){const Ge=await Je.asString();if(Ve===T.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:ne(Ge)};const nt=Je.asFile();return{asString:Ge,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Le.from=Ce;function ne(Ve){return h.UriList.split(Ve).map(Je=>{if(Je.startsWith("#"))return Je;try{return S.URI.parse(Je)}catch{}return Je})}function Oe(Ve){return h.UriList.create(Ve.map(Je=>typeof Je=="string"?Je:S.URI.revive(Je)))}})(ut||(e.DataTransferItem=ut={}));var Gt;(function(Le){function Fe(ne,Oe){const Ve=ne.items.map(([Je,Ge])=>[Je,ut.to(Je,Ge,Oe)]);return new n.DataTransfer(Ve)}Le.toDataTransfer=Fe;async function Ce(ne){const Oe={items:[]},Ve=[];for(const[Je,Ge]of ne)Ve.push((async()=>{Oe.items.push([Je,await ut.from(Je,Ge)])})());return await Promise.all(Ve),Oe}Le.from=Ce})(Gt||(e.DataTransfer=Gt={}));var kt;(function(Le){function Fe(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.to=Fe;function Ce(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.from=Ce})(kt||(e.ChatReplyFollowup=kt={}));var _t;(function(Le){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:kt.from(Ce)}Le.from=Fe})(_t||(e.ChatFollowup=_t={}));var ft;(function(Le){function Fe(ne){const Oe=new n.ChatMessage(Dt.to(ne.role),ne.content);return Oe.name=ne.name,Oe}Le.to=Fe;function Ce(ne){return{role:Dt.from(ne.role),content:ne.content,name:ne.name}}Le.from=Ce})(ft||(e.ChatMessage=ft={}));var Dt;(function(Le){function Fe(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Le.to=Fe;function Ce(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Le.from=Ce})(Dt||(e.ChatMessageRole=Dt={}));var Ft;(function(Le){function Fe(ne){return{level:St.to(ne.level),value:ne.value,description:ne.description}}Le.to=Fe;function Ce(ne){return{level:St.from(ne.level),value:ne.value,description:ne.description}}Le.from=Ce})(Ft||(e.ChatVariable=Ft={}));var St;(function(Le){function Fe(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Le.to=Fe;function Ce(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Le.from=Ce})(St||(e.ChatVariableLevel=St={}));var qe;(function(Le){function Fe(Ce){switch(Ce){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Le.to=Fe})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Nt;(function(Le){function Fe(Ce){return"placeholder"in Ce&&"resolvedContent"in Ce?{placeholder:Ce.placeholder}:"responseId"in Ce?{requestId:Ce.responseId}:"content"in Ce?{content:typeof Ce.content=="string"?Ce.content:L.from(Ce.content)}:"documents"in Ce?{documents:Ce.documents.map(ne=>({uri:ne.uri,version:ne.version,ranges:ne.ranges.map(Oe=>i.from(Oe))}))}:"reference"in Ce?{reference:"uri"in Ce.reference?{uri:Ce.reference.uri,range:i.from(Ce.reference.range)}:Ce.reference}:Ce}Le.from=Fe})(Nt||(e.ChatResponseProgress=Nt={}));var Ut;(function(Le){function Fe(Ce,ne,Oe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ne.toInternal(Ce,Oe)}Le.from=Fe})(Ut||(e.TerminalQuickFix=Ut={}))}),define(De[280],Ie([1,0,2,8,7,14,75]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(E,T,k,b={timeout:1500,errors:3}){this._logService=E,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=b,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(E){return(T,k,b)=>{const _={dispose:this._callbacks.push([T,k,E])};return Array.isArray(b)&&b.push(_),_}}async $participateInSave(E,T){const k=I.URI.revive(E);let b=!1;const S=setTimeout(()=>b=!0,this._thresholds.timeout),_=[];try{for(const w of[...this._callbacks]){if(b)break;const u=this._documents.getDocument(k),r=await this._deliverEventAsyncAndBlameBadListeners(w,{document:u,reason:R.TextDocumentSaveReason.to(T)});_.push(r)}}finally{clearTimeout(S)}return _}_deliverEventAsyncAndBlameBadListeners([E,T,k],b){const S=this._badListeners.get(E);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,E,T,b).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const w=this._badListeners.get(E);this._badListeners.set(E,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(E,T,k,b){const S=[],_=Date.now(),{document:w,reason:u}=b,{version:r}=w,o=Object.freeze({document:w,reason:u,waitUntil(c){if(Object.isFrozen(S))throw(0,F.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(c))}});try{T.apply(k,[o])}catch(c){return Promise.reject(c)}return Object.freeze(S),new Promise((c,g)=>{const d=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(d),c(t)}).catch(t=>{clearTimeout(d),g(t)})}).then(c=>{const g={edits:[]};for(const d of c)if(Array.isArray(d)&&d.every(t=>t instanceof h.TextEdit))for(const{newText:t,newEol:n,range:s}of d)g.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:t,eol:n&&R.EndOfLine.from(n)}});if(g.edits.length!==0)return r===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(De[281],Ie([1,0,17,2,14,7,108]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class v{constructor(k,b,S,_){this.start=k,this.deletedCount=b,this.deletedItems=S,this.items=_}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(k,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,b,S){this.notebook=k,this._extHostDocument=b,this._cellData=S,this.handle=S.handle,this.uri=F.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(h.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(h.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,b=this._extHostDocument.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:h.NotebookCellKind.to(this._cellData.cellKind),document:b.document,get mime(){return k._mime},set mime(_){k._mime=_},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(k){this._outputs=k.map(h.NotebookCellOutput.to)}setOutputItems(k,b,S){const _=S.map(h.NotebookCellOutputItem.to),w=this._outputs.find(u=>u.id===k);if(w&&(b||(w.items.length=0),w.items.push(..._),w.items.length>1&&w.items.every(u=>A.isTextStreamMime(u.mime)))){const u=new Map,r=[];w.items.forEach(o=>{let c;u.has(o.mime)?c=u.get(o.mime):(c=[],u.set(o.mime,c),r.push(o.mime)),c.push(o.data)}),w.items.length=0,r.forEach(o=>{const c=A.compressOutputItemStreams(u.get(o));w.items.push({mime:o,data:c.data.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(h.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=y;class E{static{this._handlePool=0}constructor(k,b,S,_,w){this._proxy=k,this._textDocumentsAndEditors=b,this._textDocuments=S,this.uri=_,this.handle=E._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0,void 0),this._versionId=w.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const k=this,b={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===I.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(S){return S=k._validateIndex(S),k._cells[S].apiCell},getCells(S){return(S?k._getCells(S):k._cells).map(w=>w.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(b)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,b,S){this._versionId=k.versionId,this._isDirty=b,this.acceptDocumentPropertiesChanged({metadata:S});const _={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},w=[];for(const r of k.rawEvents)r.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1,_.contentChanges):r.kind===A.NotebookCellsChangeType.Move?this._moveCells(r.index,r.length,r.newIdx,_.contentChanges):r.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(r.index,r.outputs),w.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems),w.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(r.index,r.language),w.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document})):r.kind===A.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document}):r.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(r.index,r.metadata),w.push({cell:this._cells[r.index].apiCell,metadata:this._cells[r.index].apiCell.metadata})):r.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(r.index,r.internalMetadata),w.push({cell:this._cells[r.index].apiCell,executionSummary:this._cells[r.index].apiCell.executionSummary}));const u=new Map;for(let r=0;r<w.length;r++){const o=w[r],c=u.get(o.cell);if(c===void 0){const g=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...o});u.set(o.cell,g-1)}else _.cellChanges[c]={..._.cellChanges[c],...o}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let b=k.start|0,S=k.end|0;return b<0&&(b=0),S>this._cells.length&&(S=this._cells.length),k.with({start:b,end:S})}_getCells(k){k=this._validateRange(k);const b=[];for(let S=k.start;S<k.end;S++)b.push(this._cells[S]);return b}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,b,S){if(this._disposed)return;const _=[],w=[],u=[];if(k.reverse().forEach(r=>{const c=r[2].map(t=>{const n=new y(this,this._textDocumentsAndEditors,t);return b||w.push(y.asModelAddData(this.apiNotebook,t)),n}),g=new v(r[0],r[1],[],c),d=this._cells.splice(r[0],r[1],...c);for(const t of d)u.push(t.uri),g.deletedItems.push(t.apiCell);_.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:u}),S)for(const r of _)S.push(r.asApiEvent())}_moveCells(k,b,S,_){const w=this._cells.splice(k,b);this._cells.splice(S,0,...w);const u=[new v(k,b,w.map(r=>r.apiCell),[]),new v(S,0,[],w)];for(const r of u)_.push(r.asApiEvent())}_setCellOutputs(k,b){this._cells[k].setOutputs(b)}_setCellOutputItems(k,b,S,_){this._cells[k].setOutputItems(b,S,_)}_changeCellLanguage(k,b){const S=this._cells[k];S.apiCell.document.languageId!==b&&this._textDocuments.$acceptModelLanguageChanged(S.uri,b)}_changeCellMime(k,b){const S=this._cells[k];S.apiCell.mime=b}_changeCellMetadata(k,b){this._cells[k].setMetadata(b)}_changeCellInternalMetadata(k,b){this._cells[k].setInternalMetadata(b)}getCellFromApiCell(k){return this._cells.find(b=>b.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(b=>b.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=E}),define(De[282],Ie([1,0,4,2,14,7]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(y,E,T,k={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=E,this._mainThreadBulkEdits=T,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(E,T,k)=>{const b=function(_){E.call(T,_)};return b.extension=y,this._onWillSaveNotebookDocumentEvent.event(b,void 0,k)}}async $participateInSave(y,E,T){const k=F.URI.revive(y),b=this._notebooksAndEditors.getNotebookDocument(k);if(!b)throw new Error("Unable to resolve notebook document");const S=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:b.apiNotebook,reason:h.TextDocumentSaveReason.to(E)},T,async(w,u)=>{const r=Date.now(),o=await await Promise.resolve(w);Date.now()-r>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!T.isCancellationRequested&&o&&(o instanceof R.WorkspaceEdit?S.push(o):this._logService.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),T.isCancellationRequested)return!1;if(S.length===0)return!0;const _={edits:[]};for(const w of S){const{edits:u}=h.WorkspaceEdit.from(w);_.edits=_.edits.concat(u)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(De[144],Ie([1,0,8,14,7]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,y,E,T,k,b){this.id=v,this._proxy=y,this.notebookData=E,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=T,this._viewColumn=b}get apiEditor(){if(!this._editor){const v=this;this._editor={get notebook(){return v.notebookData.apiNotebook},get selection(){return v._selections[0]},set selection(y){this.selections=[y]},get selections(){return v._selections},set selections(y){if(!Array.isArray(y)||!y.every(h.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");v._selections=y,v._trySetSelections(y)},get visibleRanges(){return v._visibleRanges},revealRange(y,E){v._proxy.$tryRevealRange(v.id,F.NotebookRange.from(y),E??h.NotebookEditorRevealType.Default)},get viewColumn(){return v._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(v){this._visible=v}_acceptVisibleRanges(v){this._visibleRanges=v}_acceptSelections(v){this._selections=v}_trySetSelections(v){this._proxy.$trySetSelections(this.id,v.map(F.NotebookRange.from))}_acceptViewColumn(v){this._viewColumn=v}}e.ExtHostNotebookEditor=R}),define(De[283],Ie([1,0,8,4,13,14]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(y,E){this._logService=y,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new F.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new F.Emitter({onListenerError:I.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,E);const T=this._notebooksAndEditors.getEditorById(y);E.visibleRanges&&T._acceptVisibleRanges(E.visibleRanges.ranges.map(R.NotebookRange.to)),E.selections&&T._acceptSelections(E.selections.selections.map(R.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const E in y)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(R.ViewColumn.to(y[E]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=je([$e(0,h.ILogService)],A)}),define(De[284],Ie([1,0,14,84,208,21,57,8]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}async withProgress(b,S,_){const w=this._handles++,{title:u,location:r,cancellable:o}=S,c={label:(0,h.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(w,{location:I.ProgressLocation.from(r),title:u,source:c,cancellable:o},b.isUnderDevelopment?void 0:b.identifier.value).catch(v.onUnexpectedExternalError),this._withProgress(w,_,!!o)}_withProgress(b,S,_){let w;_&&(w=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,w));const u=o=>{this._proxy.$progressEnd(o),this._mapHandleToCancellationSource.delete(o),w?.dispose()};let r;try{r=S(new T(this._proxy,b),_&&w?w.token:R.CancellationToken.None)}catch(o){throw u(b),o}return r.then(o=>u(b),o=>u(b)),r}$acceptProgressCanceled(b){const S=this._mapHandleToCancellationSource.get(b);S&&(S.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=y;function E(k,b){return k.message=b.message,typeof b.increment=="number"&&(typeof k.increment=="number"?k.increment+=b.increment:k.increment=b.increment),k}class T extends F.Progress{constructor(b,S){super(_=>this.throttledReport(_)),this._proxy=b,this._handle=S}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}je([(0,A.throttle)(100,(k,b)=>E(k,b),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(De[145],Ie([1,0,34,142,67,109,87,14,2]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const E=(c,g,d,t)=>{let n=g;return{enumerable:!0,configurable:!1,get(){return n},set(s){if(!d(n,s)){const i=n;n=s,c.listener?.(t(s,i))}}}},T=(c,g)=>c===g,k={range:(c,g)=>c===g?!0:!c||!g?!1:c.isEqual(g),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(c,g)=>!(c.length!==g.length||c.some(d=>!g.find(t=>d.id===t.id)))},b=c=>g=>({op:4,update:c(g)}),S=(c,g)=>({range:(()=>{let d;const t=b(n=>({range:I.Range.lift(v.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return d},set(n){c.listener?.({op:6}),k.range(d,n)||(d=n,c.listener?.(t(n)))}}})(),label:E(c,g,k.label,b(d=>({label:d}))),description:E(c,void 0,k.description,b(d=>({description:d}))),sortText:E(c,void 0,k.sortText,b(d=>({sortText:d}))),canResolveChildren:E(c,!1,k.canResolveChildren,d=>({op:2,state:d})),busy:E(c,!1,k.busy,b(d=>({busy:d}))),error:E(c,void 0,k.error,b(d=>({error:v.MarkdownString.fromStrict(d)||null}))),tags:E(c,[],k.tags,(d,t)=>({op:1,new:d.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),_=c=>{const g=h.TestId.fromString(c.extId),d=new u(g.controllerId,g.localId,c.label,y.URI.revive(c.uri)||void 0);return d.range=v.Range.to(c.range||void 0),d.description=c.description||void 0,d.sortText=c.sortText||void 0,d.tags=c.tags.map(t=>v.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),d},w=c=>{let g;for(const d of c.tests){const t=_(d.item);(0,F.getPrivateApiFor)(t).parent=g,g=t}return g};e.toItemFromContext=w;class u{constructor(g,d,t,n){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const s=(0,F.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof r?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,F.getPrivateApiFor,u),enumerable:!0,writable:!1},...S(s,t)})}}e.TestItemImpl=u;class r extends u{constructor(g,d){super(g,g,d,void 0),this._isRoot=!0}}e.TestItemRootImpl=r;class o extends R.TestItemCollection{constructor(g,d,t){super({controllerId:g,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:F.getPrivateApiFor,getChildren:n=>n.children,root:new r(g,d),toITestItem:v.TestItem.from})}}e.ExtHostTestItemCollection=o}),define(De[146],Ie([1,0,58,8,119,14,7]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class v{static{this._Keys=new h.IdGenerator("TextEditorDecorationType")}constructor(b,S,_){const w=v._Keys.nextId();b.$registerTextEditorDecorationType(S.identifier,w,R.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:w,dispose(){b.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=v;class y{constructor(b,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,S){this._throwIfFinalized();let _=null;if(b instanceof A.Position)_=new A.Range(b,b);else if(b instanceof A.Range)_=b;else throw new Error("Unrecognized location");this._pushEdit(_,S,!1)}insert(b,S){this._throwIfFinalized(),this._pushEdit(new A.Range(b,b),S,!0)}delete(b){this._throwIfFinalized();let S=null;if(b instanceof A.Range)S=b;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(b,S,_){const w=this._document.validateRange(b);this._collectedEdits.push({range:w,text:S,forceMoveMarkers:_})}setEndOfLine(b){if(this._throwIfFinalized(),b!==A.EndOfLine.LF&&b!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=b}}class E{constructor(b,S,_,w){this._proxy=b,this._id=S,this._accept(_),this._logService=w;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(r){u._setTabSize(r)},get indentSize(){return u._indentSize},set indentSize(r){u._setIndentSize(r)},get insertSpaces(){return u._insertSpaces},set insertSpaces(r){u._setInsertSpaces(r)},get cursorStyle(){return u._cursorStyle},set cursorStyle(r){u._setCursorStyle(r)},get lineNumbers(){return u._lineNumbers},set lineNumbers(r){u._setLineNumbers(r)}}}_accept(b){this._tabSize=b.tabSize,this._indentSize=b.indentSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const S=Math.floor(b);return S>0?S:null}if(typeof b=="string"){const S=parseInt(b,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(b){const S=this._validateTabSize(b);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateIndentSize(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const S=Math.floor(b);return S>0?S:null}if(typeof b=="string"){const S=parseInt(b,10);return isNaN(S)?null:S>0?S:null}return null}_setIndentSize(b){const S=this._validateIndentSize(b);if(S!==null){if(typeof S=="number"){if(this._indentSize===S)return;this._indentSize=S}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:S}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:!!b}_setInsertSpaces(b){const S=this._validateInsertSpaces(b);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(b)})))}assign(b){const S={};let _=!1;if(typeof b.tabSize<"u"){const w=this._validateTabSize(b.tabSize);w==="auto"?(_=!0,S.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,_=!0,S.tabSize=w)}if(typeof b.indentSize<"u"){const w=this._validateIndentSize(b.indentSize);w==="tabSize"?(_=!0,S.indentSize=w):typeof w=="number"&&this._indentSize!==w&&(this._indentSize=w,_=!0,S.indentSize=w)}if(typeof b.insertSpaces<"u"){const w=this._validateInsertSpaces(b.insertSpaces);w==="auto"?(_=!0,S.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,_=!0,S.insertSpaces=w)}typeof b.cursorStyle<"u"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,_=!0,S.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,_=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from(b.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(b,S){S.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=E;class T{constructor(b,S,_,w,u,r,o,c){this.id=b,this._proxy=S,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new E(this._proxy,this.id,r,_),this._visibleRanges=o,this._viewColumn=c;const g=this;this.value=Object.freeze({get document(){return w.value},set document(d){throw new F.ReadonlyError("document")},get selection(){return g._selections&&g._selections[0]},set selection(d){if(!(d instanceof A.Selection))throw(0,F.illegalArgument)("selection");g._selections=[d],g._trySetSelection()},get selections(){return g._selections},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");g._selections=d,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(d){throw new F.ReadonlyError("visibleRanges")},get options(){return g._options.value},set options(d){g._disposed||g._options.assign(d)},get viewColumn(){return g._viewColumn},set viewColumn(d){throw new F.ReadonlyError("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(w.value,t);return d(n),g._applyEdit(n)},insertSnippet(d,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=g._selections.map(i=>R.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:a}=R.Position.from(t);s=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.Range)s=[R.Range.from(t)];else{s=[];for(const i of t)if(i instanceof A.Range)s.push(R.Range.from(i));else{const{lineNumber:a,column:l}=R.Position.from(i);s.push({startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l})}}return S.$tryInsertSnippet(b,w.value.version,d.value,s,n)},setDecorations(d,t){const n=t.length===0;n&&!g._hasDecorationsForKey.has(d.key)||(n?g._hasDecorationsForKey.delete(d.key):g._hasDecorationsForKey.add(d.key),g._runOnProxy(()=>{if(R.isDecorationOptionsArr(t))return S.$trySetDecorations(b,d.key,R.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const l=t[i];s[4*i]=l.start.line+1,s[4*i+1]=l.start.character+1,s[4*i+2]=l.end.line+1,s[4*i+3]=l.end.character+1}return S.$trySetDecorationsFast(b,d.key,s)}}))},revealRange(d,t){g._runOnProxy(()=>S.$tryRevealRange(b,R.Range.from(d),t||A.TextEditorRevealType.Default))},show(d){S.$tryShowEditor(b,R.ViewColumn.from(d))},hide(){S.$tryHideEditor(b)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,I.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,I.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,I.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,I.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const S=b.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const _=S.edits.map(u=>u.range);_.sort((u,r)=>u.end.line===r.end.line?u.end.character===r.end.character?u.start.line===r.start.line?u.start.character-r.start.character:u.start.line-r.start.line:u.end.character-r.end.character:u.end.line-r.end.line);for(let u=0,r=_.length-1;u<r;u++){const o=_[u].end;if(_[u+1].start.isBefore(o))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=S.edits.map(u=>({range:R.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,w,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=T}),define(De[147],Ie([1,0,5,131]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(F.IEnvironmentService)}),define(De[148],Ie([1,0,25,4,16,3]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(r,o){this.versionId=r,this.removedDueToLooping=o}}e.DeltaExtensionsResult=A;class v{static isHostExtension(r,o,c){if(o.getExtensionDescription(r))return!1;const g=c.getExtensionDescription(r);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(r,o){this._activationEventsReader=r,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=o,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this._extensionsMap.set(r.identifier,r),this._extensionsArr.push(r);const o=this._activationEventsReader.readActivationEvents(r);if(Array.isArray(o))for(let c of o)c==="onUri"&&(c=`onUri:${I.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(r)}}set(r){return this._extensionDescriptions=r,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(r,o){this._extensionDescriptions=w(this._extensionDescriptions,o),this._extensionDescriptions=this._extensionDescriptions.concat(r);const c=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=w(this._extensionDescriptions,c.map(g=>g.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,c)}static _findLoopingExtensions(r){const o=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(n){this._nodesSet.has(n)||(this._nodesSet.add(n),this._nodesArr.push(n))}addArc(n,s){this.addNode(n),this.addNode(s),this._arcs.has(n)?this._arcs.get(n).push(s):this._arcs.set(n,[s])}getArcs(n){return this._arcs.has(n)?this._arcs.get(n):[]}hasOnlyGoodArcs(n,s){const i=o.getArcs(n);for(let a=0;a<i.length;a++)if(!s.has(i[a]))return!1;return!0}getNodes(){return this._nodesArr}},c=new I.ExtensionIdentifierMap;for(const n of r)if(c.set(n.identifier,n),n.extensionDependencies)for(const s of n.extensionDependencies)o.addArc(I.ExtensionIdentifier.toKey(n.identifier),I.ExtensionIdentifier.toKey(s));const g=new Set;o.getNodes().filter(n=>o.getArcs(n).length===0).forEach(n=>g.add(n));const d=o.getNodes().filter(n=>!g.has(n));let t;do{t=!1;for(let n=0;n<d.length;n++){const s=d[n];o.hasOnlyGoodArcs(s,g)&&(d.splice(n,1),n--,g.add(s),t=!0)}}while(t);return d.map(n=>c.get(n))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(r)}getExtensionDescriptionsForActivationEvent(r){const o=this._activationMap.get(r);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(r){const o=this._extensionsMap.get(r);return o||void 0}getExtensionDescriptionByUUID(r){for(const o of this._extensionsArr)if(o.uuid===r)return o}getExtensionDescriptionByIdOrUUID(r,o){return this.getExtensionDescription(r)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.ExtensionDescriptionRegistry=v;class y{constructor(r,o){this.versionId=r,this.extensions=o}}e.ExtensionDescriptionRegistrySnapshot=y,e.basicActivationEventsReader={readActivationEvents:u=>u.activationEvents};class E{constructor(r){this._lock=new b,this._actual=new v(r,[])}async acquireLock(r){const o=await this._lock.acquire(r);return new T(this,o)}deltaExtensions(r,o,c){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(o,c)}containsActivationEvent(r){return this._actual.containsActivationEvent(r)}containsExtension(r){return this._actual.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this._actual.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(r){return this._actual.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this._actual.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,o){return this._actual.getExtensionDescriptionByIdOrUUID(r,o)}}e.LockableExtensionDescriptionRegistry=E;class T extends R.Disposable{constructor(r,o){super(),this._registry=r,this._isDisposed=!1,this._register(o)}isAcquiredFor(r){return!this._isDisposed&&this._registry===r}}e.ExtensionDescriptionRegistryLock=T;class k{constructor(r){this.name=r,this.promise=new Promise((o,c)=>{this._resolve=o})}resolve(r){this._resolve(r)}}class b{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(r){const o=new k(r);return this._pendingCustomers.push(o),this._advance(),o.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const r=this._pendingCustomers.shift();this._isLocked=!0;let o=!0;const c=setTimeout(()=>{o&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{o&&(clearTimeout(c),o=!1,this._isLocked=!1,this._advance())};r.resolve((0,R.toDisposable)(g))}}var S;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(S||(S={}));function _(u,r){const o=u.isBuiltin?0:u.isUnderDevelopment?2:1,c=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(o!==c)return o-c;const g=h.posix.basename(u.extensionLocation.path),d=h.posix.basename(r.extensionLocation.path);return g<d?-1:g>d?1:0}function w(u,r){const o=new I.ExtensionIdentifierSet(r);return u.filter(c=>!o.has(c.identifier))}}),define(De[285],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var I;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[F.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=F;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[h.ENV_KEY]="1"}}e.SocketExtHostConnection=h;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R;function A(T){delete T[F.ENV_KEY],delete T[h.ENV_KEY],delete T[R.ENV_KEY]}function v(T,k){A(k),T.serialize(k)}e.writeExtHostConnection=v;function y(T){if(T[F.ENV_KEY])return E(T,new F(T[F.ENV_KEY]));if(T[h.ENV_KEY])return E(T,new h);if(T[R.ENV_KEY])return E(T,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function E(T,k){return A(T),k}}),define(De[111],Ie([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(F||(e.UIKind=F={}));var h;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(E){const T=I.VSBuffer.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=A;function v(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=v;var y;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(De[88],Ie([1,0,5,4,13,26,111,65,85,23,2,3,210]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class extends k.Disposable{constructor(r,o){super(),this.initData=r,this.loggerService=o,this._onDidChangeTelemetryEnabled=this._register(new F.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new F.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=T.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=o.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,b.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(o.onDidChangeLogLevel(c=>{(0,h.isLogLevel)(c)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(r,o,c){const g=this.getTelemetryDetails(),d=new _(o,c,r,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(r),{isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}),t=this._telemetryLoggers.get(r.identifier.value)??[];return this._telemetryLoggers.set(r.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(r,o,c){this._level=r,this._telemetryIsSupported=o,this._productConfig=c??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(r){const o=Object.create(null);switch(o["common.extname"]=`${r.publisher}.${r.name}`,o["common.extversion"]=r.version,o["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,o["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,o["common.vscodeversion"]=this.initData.version,o["common.isnewappinstall"]=w(this.initData.telemetryInfo.firstSessionDate),o["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:o["common.uikind"]="web";break;case A.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,v.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),o}$onDidChangeTelemetryLevel(r){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=r;const o=this.getTelemetryDetails();this._telemetryLoggers.forEach((c,g)=>{const d=c.filter(t=>!t.isDisposed);d.length===0?this._telemetryLoggers.delete(g):this._telemetryLoggers.set(g,d)}),this._telemetryLoggers.forEach(c=>{for(const g of c)g.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(r,o){const g=this._telemetryLoggers.get(r.value)?.filter(t=>!t.isDisposed);if(!g)return this._telemetryLoggers.delete(r.value),!1;let d=!1;for(const t of g)t.ignoreUnhandledExtHostErrors||(t.logError(o),d=!0);return d}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=je([$e(0,R.IExtHostInitDataService),$e(1,h.ILoggerService)],S);class _{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,o,c,g,d,t,n){this._extension=c,this._logger=g,this._inLoggingOnlyMode=d,this._commonProperties=t,this._onDidChangeEnableStates=new F.Emitter,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=o?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=o?.additionalCommonProperties,this._sender=r,this._telemetryEnablements={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(r,o){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:r,isErrorsEnabled:o},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(r){let o="properties"in r?r.properties??{}:r;return o=(0,y.cleanData)(o,[]),this._additionalCommonProperties&&(o=(0,E.mixin)(o,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(o=(0,E.mixin)(o,this._commonProperties)),"properties"in r?r.properties=o:r=o,r}logEvent(r,o){this._sender&&(this._extension.publisher==="vscode"?r=this._extension.name+"/"+r:r=this._extension.identifier.value+"/"+r,o=this.mixInCommonPropsAndCleanData(o||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(r,o),this._logger.trace(r,o))}logUsage(r,o){this._telemetryEnablements.isUsageEnabled&&this.logEvent(r,o)}logError(r,o){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof r=="string")this.logEvent(r,o);else{const c={name:r.name,message:r.message,stack:r.stack,cause:r.cause},g=(0,y.cleanData)(c,[]),d=new Error(g.message,{cause:g.cause});d.stack=g.stack,d.name=g.name,o=this.mixInCommonPropsAndCleanData(o||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(d,o),this._logger.trace("exception",o)}}get apiTelemetryLogger(){if(!this._apiObject){const r=this,o={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return r._telemetryEnablements.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r._onDidChangeEnableStates.event.bind(r)};this._apiObject=Object.freeze(o)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let r=this._sender;this._sender=void 0,Promise.resolve(r.flush()).then(r=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=_;function w(u){const r=Date.now()-new Date(u).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.isNewAppInstall=w,e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,4,2,252,137,25,5]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,v.createDecorator)("extensionService");class y{constructor(d){this.dependency=d}}e.MissingExtensionDependency=y;var E;(function(g){g[g.EagerAutoStart=1]="EagerAutoStart",g[g.EagerManualStart=2]="EagerManualStart",g[g.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(d,t,n){this._versionId=d,this._allExtensions=t.slice(0),this._myExtensions=n.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(d,t,n){if(this._versionId>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this._versionId})`);const s=[],i=[],a=[],l=[],C=k(this._allExtensions),D=k(t),p=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this._allExtensions){const L=D.get(N.identifier);if(!L){s.push(N.identifier),C.delete(N.identifier);continue}if(!p(N,L)){s.push(N.identifier),C.delete(N.identifier);continue}}for(const N of t){const L=C.get(N.identifier);if(!L){i.push(N);continue}if(!p(L,N)){s.push(L.identifier),C.delete(L.identifier);continue}}const m=new A.ExtensionIdentifierSet(this._myExtensions),f=new A.ExtensionIdentifierSet(n);for(const N of this._myExtensions)f.has(N)||a.push(N);for(const N of n)m.has(N)||l.push(N);const P=R.ImplicitActivationEvents.createActivationEventsMap(i),M={versionId:d,toRemove:s,toAdd:i,addActivationEvents:P,myToRemove:a,myToAdd:l};return this.delta(M),M}delta(d){if(this._versionId>=d.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:s,myToAdd:i}=d,a=new A.ExtensionIdentifierSet(t),l=new A.ExtensionIdentifierSet(s);for(let C=0;C<this._allExtensions.length;C++)a.has(this._allExtensions[C].identifier)&&(this._allExtensions.splice(C,1),C--);for(let C=0;C<this._myExtensions.length;C++)l.has(this._myExtensions[C])&&(this._myExtensions.splice(C,1),C--);for(const C of n)this._allExtensions.push(C);for(const C of i)this._myExtensions.push(C);return d}containsExtension(d){for(const t of this._myExtensions)if(A.ExtensionIdentifier.equals(t,d))return!0;return!1}}e.ExtensionHostExtensions=T;function k(g){const d=new A.ExtensionIdentifierMap;for(const t of g)d.set(t.identifier,t);return d}function b(g,d){return g.enabledApiProposals?g.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=b;function S(g,d){if(!b(g,d))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.checkProposedApiEnabled=S;class _{constructor(d,t,n,s){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=s}}e.ActivationTimes=_;class w{constructor(d,t){this.description=d,this.value=t}}e.ExtensionPointContribution=w;var u;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function r(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,h.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation,targetPlatform:g.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function o(g,d){return{identifier:new A.ExtensionIdentifier((0,h.getExtensionId)(g.manifest.publisher,g.manifest.name)),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!d,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid,targetPlatform:g.targetPlatform}}e.toExtensionDescription=o;class c{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(De[286],Ie([1,0,8,148,25,27,13,9]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(r,o,c,g){this.startup=r,this.codeLoadingTime=o,this.activateCallTime=c,this.activateResolvedTime=g}}e.ExtensionActivationTimes=y;class E{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,o){return r===-1||o===-1?-1:o-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class T{constructor(r,o,c,g,d,t){this.activationFailed=r,this.activationFailedError=o,this.activationTimes=c,this.module=g,this.exports=d,this.subscriptions=t}}e.ActivatedExtension=T;class k extends T{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class b extends T{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class S extends T{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let _=class{constructor(r,o,c,g){this._logService=g,this._registry=r,this._globalRegistry=o,this._host=c,this._operations=new h.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[r,o]of this._operations)o.dispose()}async waitForActivatingExtensions(){const r=[];for(const[o,c]of this._operations)r.push(c.wait());await Promise.all(r)}isActivated(r){const o=this._operations.get(r);return!!(o&&o.value)}getActivatedExtension(r){const o=this._operations.get(r);if(!o||!o.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return o.value}async activateByEvent(r,o){if(this._alreadyActivatedEvents[r])return;const c=this._registry.getExtensionDescriptionsForActivationEvent(r);await this._activateExtensions(c.map(g=>({id:g.identifier,reason:{startup:o,extensionId:g.identifier,activationEvent:r}}))),this._alreadyActivatedEvents[r]=!0}activateById(r,o){const c=this._registry.getExtensionDescription(r);if(!c)throw new Error(`Extension '${r}' is not known`);return this._activateExtensions([{id:c.identifier,reason:o}])}async _activateExtensions(r){const o=r.filter(c=>!this.isActivated(c.id)).map(c=>this._handleActivationRequest(c));await Promise.all(o.map(c=>c.wait()))}_handleActivationRequest(r){if(this._operations.has(r.id))return this._operations.get(r.id);if(this._isHostExtension(r.id))return this._createAndSaveOperation(r,null,[],null);const o=this._registry.getExtensionDescription(r.id);if(!o){const d=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this._createAndSaveOperation(r,null,[],new S(d));return this._host.onExtensionActivationError(r.id,d,new R.MissingExtensionDependency(r.id.value)),t}const c=[],g=typeof o.extensionDependencies>"u"?[]:o.extensionDependencies;for(const d of g){if(this._isResolvedExtension(d))continue;const t=this._operations.get(d);if(t){c.push(t);continue}if(this._isHostExtension(d)){c.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(d).identifier,reason:r.reason}));continue}const n=this._registry.getExtensionDescription(d);if(n){if(!n.main&&!n.browser)continue;c.push(this._handleActivationRequest({id:n.identifier,reason:r.reason}));continue}const s=o.displayName||o.identifier.value,i=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${d}'`),a=this._createAndSaveOperation(r,o.displayName,[],new S(i));return this._host.onExtensionActivationError(o.identifier,i,new R.MissingExtensionDependency(d)),a}return this._createAndSaveOperation(r,o.displayName,c,null)}_createAndSaveOperation(r,o,c,g){const d=new w(r.id,o,r.reason,c,g,this._host,this._logService);return this._operations.set(r.id,d),d}_isHostExtension(r){return F.ExtensionDescriptionRegistry.isHostExtension(r,this._registry,this._globalRegistry)}_isResolvedExtension(r){const o=this._globalRegistry.getExtensionDescription(r);return o?!o.main&&!o.browser:!1}};e.ExtensionsActivator=_,e.ExtensionsActivator=_=je([$e(3,A.ILogService)],_);let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(r,o,c,g,d,t,n){this._id=r,this._displayName=o,this._reason=c,this._deps=g,this._value=d,this._host=t,this._logService=n,this._barrier=new v.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let r=0;r<this._deps.length;r++){const o=this._deps[r];if(o.value&&!o.value.activationFailed){this._deps.splice(r,1),r--;continue}if(o.value&&o.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);c.detail=o.value.activationFailedError,this._value=new S(c),this._host.onExtensionActivationError(this._id,c,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(r=>r.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(r){const o=new Error;if(r&&r.name&&(o.name=r.name),r&&r.message?o.message=`Activating extension '${this._id.value}' failed: ${r.message}.`:o.message=`Activating extension '${this._id.value}' failed: ${r}.`,r&&r.stack&&(o.stack=r.stack),this._value=new S(o),this._isDisposed&&I.isCancellationError(r))return;this._host.onExtensionActivationError(this._id,o,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(r)}}};w=je([$e(6,A.ILogService)],w)}),define(De[287],Ie([1,0,212,24,2,4,3,269,9,7,18,19,14,79,21,173,27]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(g,d){if((0,T.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let t;return Array.isArray(g.highlights)&&(t=g.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:g.label,highlights:t}}}class o extends A.Disposable{constructor(d,t,n){super(),this._proxy=d,this.commands=t,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeViewsDnDService;function s(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>s(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(a=>s(a)?this.convertArgument(a):a):i})}registerTreeDataProvider(d,t,n){const s=this.createTreeView(d,{treeDataProvider:t},n);return{dispose:()=>s.dispose()}}createTreeView(d,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,C=this.createExtHostTreeView(d,t,n),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:i,hasHandleDrag:a,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this._proxy.$registerTreeViewDataProvider(d,D),m={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,u.checkProposedApiEnabled)(n,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,u.checkProposedApiEnabled)(n,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(f){(0,S.isMarkdownString)(f)&&(0,u.checkProposedApiEnabled)(n,"treeViewMarkdownMessage"),C.message=f},get title(){return C.title},set title(f){C.title=f},get description(){return C.description},set description(f){C.description=f},get badge(){return C.badge},set badge(f){f!==void 0&&E.ViewBadge.isViewBadge(f)?C.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(C.badge=void 0)},reveal:(f,P)=>C.reveal(f,P),dispose:async()=>{await p,this.treeViews.delete(d),C.dispose()}};return this._register(m),m}$getChildren(d,t){const n=this.treeViews.get(d);return n?n.getChildren(t):Promise.reject(new v.NoTreeViewError(d))}async $handleDrop(d,t,n,s,i,a,l,C){const D=this.treeViews.get(d);if(!D)return Promise.reject(new v.NoTreeViewError(d));const p=b.DataTransfer.toDataTransfer(n,async m=>(await this._proxy.$resolveDropFileData(d,t,m)).buffer);return l===d&&C&&await this.addAdditionalTransferItems(p,D,C,i,a),D.onDrop(p,s,i)}async addAdditionalTransferItems(d,t,n,s,i){const a=this.treeDragAndDropService.removeDragOperationTransfer(i);if(a)(await a)?.forEach((l,C)=>{l&&d.set(C,l)});else if(i&&t.handleDrag){const l=t.handleDrag(n,d,s);this.treeDragAndDropService.addDragOperationTransfer(i,l),await l}return d}async $handleDrag(d,t,n,s){const i=this.treeViews.get(d);if(!i)return Promise.reject(new v.NoTreeViewError(d));const a=await this.addAdditionalTransferItems(new E.DataTransfer,i,t,s,n);if(!(!a||s.isCancellationRequested))return b.DataTransfer.from(a)}async $hasResolve(d){const t=this.treeViews.get(d);if(!t)throw new v.NoTreeViewError(d);return t.hasResolve}$resolve(d,t,n){const s=this.treeViews.get(d);if(!s)throw new v.NoTreeViewError(d);return s.resolveTreeItem(t,n)}$setExpanded(d,t,n){const s=this.treeViews.get(d);if(!s)throw new v.NoTreeViewError(d);s.setExpanded(t,n)}$setSelectionAndFocus(d,t,n){const s=this.treeViews.get(d);if(!s)throw new v.NoTreeViewError(d);s.setSelectionAndFocus(t,n)}$setVisible(d,t){const n=this.treeViews.get(d);if(!n){if(!t)return;throw new v.NoTreeViewError(d)}n.setVisible(t)}$changeCheckboxState(d,t){const n=this.treeViews.get(d);if(!n)throw new v.NoTreeViewError(d);n.setCheckboxState(t)}createExtHostTreeView(d,t,n){const s=this._register(new c(d,t,this._proxy,this.commands.converter,this.logService,n));return this.treeViews.set(d,s),s}convertArgument(d){const t=this.treeViews.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=o;class c extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,T.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,t,n,s,i,a){if(super(),this.viewId=d,this.proxy=n,this.commands=s,this.logService=i,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new R.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const m of a.contributes.views[p])m.id===d&&(this._title=m.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let l,C;const D=R.Event.debounce(this._onDidChangeData.event,(p,m)=>(p||(p={message:!1,elements:[]}),m.element!==!1&&(l||(l=new Promise(f=>C=f),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(m.element)?p.elements.push(...m.element):p.elements.push(m.element)),m.message&&(p.message=!0),p),200,!0);this._register(D(({message:p,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=C;return l=null,this.refresh(m).then(()=>f())})),p&&this.proxy.$setMessage(this.viewId,b.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(d);return n||(n=await this.fetchChildrenNodes(t)),n?n.map(s=>s.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const n=(0,T.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,T.isUndefinedOrNull)(t.focus)?!1:t.focus,i=(0,T.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(a=>this.resolveTreeNode(d,a[a.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:a.map(C=>C.item)},{select:n,focus:s,expand:i})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:s,expand:i})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=b.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,t){const n=this.getExtensionElement(d);n&&(t?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelectionAndFocus(d,t){const n=!(0,k.equals)(this._selectedHandles,d);this._selectedHandles=d;const s=this._focusedHandle!==t;this._focusedHandle=t,n&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async n=>{const s=this.getExtensionElement(n.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:n.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(d,t,n){const s=[];for(const i of d){const a=this.getExtensionElement(i);a&&s.push(a)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,t,n),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,t,n){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,d,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,t){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(d);if(n){const s=this.nodes.get(n);if(s){const i=await this.dataProvider.resolveTreeItem(s.extensionItem,n,t)??s.extensionItem;return this.validateTreeItem(i),s.item.tooltip=this.getTooltip(i.tooltip),s.item.command=this.getCommand(s.disposableStore,i.command),s.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(t=>t?this.resolveUnknownParentChain(t).then(n=>this.resolveTreeNode(t,n[n.length-1]).then(s=>(n.push(s),n))):Promise.resolve([]))}resolveParent(d){const t=this.nodes.get(d);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,t){const n=this.nodes.get(d);return n?Promise.resolve(n):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(s=>this.createHandle(d,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(s);if(i){const a=this.nodes.get(i);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(d){if(d){let t;if(typeof d=="string"){const n=this.getExtensionElement(d);t=n?this.nodes.get(n):void 0}else t=d;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const t=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=d?this.nodes.get(d):void 0,s=await this.dataProvider.getChildren(d);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,k.coalesce)(s||[]).map(async a=>{const l=await this.dataProvider.getTreeItem(a);return l&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(a,l,n):null}));return t.token.isCancellationRequested?void 0:(0,k.coalesce)(i)}finally{t.dispose()}}refresh(d){if(d.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(d);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const t=new Set,n=d.map(i=>this.nodes.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let a=i;for(;a&&a.parent&&n.findIndex(l=>a&&a.parent&&l&&l.item.handle===a.parent.item.handle)===-1;){const l=this.elements.get(a.parent.item.handle);a=l?this.nodes.get(l):void 0}a&&!a.parent&&t.add(i.item.handle)}const s=[];return t.forEach(i=>{const a=this.elements.get(i);if(a){const l=this.nodes.get(a);l&&(!l.parent||!t.has(l.parent.item.handle))&&s.push(i)}}),s}refreshHandles(d){const t={};return Promise.all(d.map(n=>this.refreshNode(n).then(s=>{s&&(t[n]=s.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(d){const t=this.getExtensionElement(d);if(t){const n=this.nodes.get(t);if(n)return this.clearChildren(t),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(s=>{if(s){const i=this.createTreeNode(t,s,n.parent);return this.updateNodeCache(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,t,n){const s=this.createTreeNode(d,t,n);if(t.id&&this.elements.has(s.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.addNodeToCache(d,s),this.addNodeToParentCache(s,n),s}getTooltip(d){return E.MarkdownString.isMarkdownString(d)?b.MarkdownString.from(d):d}getCommand(d,t){return t?{...this.commands.toInternal(t,d),originalId:t.command}:void 0}getCheckbox(d){if(d.checkboxState===void 0)return;let t,n,s;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,n=d.checkboxState.tooltip,s=d.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:s}}validateTreeItem(d){if(!E.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,t,n){this.validateTreeItem(t);const s=this._register(new A.DisposableStore),i=this.createHandle(d,t,n),a=this.getLightIconPath(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:r(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(s,t.command),contextValue:t.contextValue,icon:a,iconDark:this.getDarkIconPath(t)||a,themeIcon:this.getThemeIcon(t),collapsibleState:(0,T.isUndefinedOrNull)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:n,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(d){return d.iconPath instanceof E.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:t,label:n,resourceUri:s},i,a){if(t)return`${c.ID_HANDLE_PREFIX}/${t}`;const l=r(n,this.extension),C=i?i.item.handle:c.LABEL_HANDLE_PREFIX;let D=l?l.label:s?(0,F.basename)(s):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const p=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,m=this.getChildrenNodes(i)||[];let f,P=0;do{if(f=`${C}/${P}:${D}`,a||!this.elements.has(f)||p===f)break;P++}while(P<=m.length);return f}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof E.ThemeIcon))return typeof d.iconPath=="string"||h.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof E.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return h.URI.isUri(d)?d:h.URI.file(d)}addNodeToCache(d,t){this.elements.set(t.item.handle,d),this.nodes.set(d,t)}updateNodeCache(d,t,n,s){this.elements.delete(t.item.handle),this.nodes.delete(d),t.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(d,t);const i=this.getChildrenNodes(s)||[],a=i.filter(l=>l.item.handle===n.item.handle)[0];a&&i.splice(i.indexOf(a),1,t)}addNodeToParentCache(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const t=this.nodes.get(d);if(t){if(t.children)for(const n of t.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}t.children=void 0}}else this.clearAll()}clear(d){const t=this.nodes.get(d);if(t){if(t.children)for(const n of t.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}this.nodes.delete(d),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(De[288],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ie([1,0,224,8,38,132,105,42,25,288,135,137]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=v.Registry.as(A.Extensions.JSONContribution);class S{constructor(d,t,n){this._messageHandler=d,this._extension=t,this._extensionPointId=n}_msg(d,t){this._messageHandler({type:d,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(h.default.Error,d)}warn(d){this._msg(h.default.Warning,d)}info(d){this._msg(h.default.Info,d)}}e.ExtensionMessageCollector=S;class _{static _toSet(d){const t=new y.ExtensionIdentifierSet;for(let n=0,s=d.length;n<s;n++)t.add(d[n].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new _(t,[]);if(!t||!t.length)return new _([],d);const n=this._toSet(d),s=this._toSet(t),i=t.filter(l=>!n.has(l.description.identifier)),a=d.filter(l=>!s.has(l.description.identifier));return new _(i,a)}constructor(d,t){this.added=d,this.removed=t}}e.ExtensionPointUserDelta=_;class w{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=_.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,F.onUnexpectedError)(d)}}}e.ExtensionPoint=w;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class o{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new w(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,t),d.activationEventsGenerator&&k.ImplicitActivationEvents.register(d.extensionPoint,d.activationEventsGenerator),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,b.registerSchema(r,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=o;const c={ExtensionsRegistry:"ExtensionsRegistry"};v.Registry.add(c.ExtensionsRegistry,new o),e.ExtensionsRegistry=v.Registry.as(c.ExtensionsRegistry),b.registerSchema(r,e.schema),b.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(De[290],Ie([1,0,221,18,23,289,41,4]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(b){function S(_,w,u){if(!_)return;const r=F.isString(_.type)?_.type:void 0;if(!r||r.length===0){u.error(I.localize(3,null));return}const o=[];if(Array.isArray(_.required))for(const c of _.required)F.isString(c)&&o.push(c);return{extensionId:w.value,taskType:r,required:o,properties:_.properties?h.deepClone(_.properties):{},when:_.when?A.ContextKeyExpr.deserialize(_.when):void 0}}b.from=S})(E||(E={}));const T=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,S)=>{for(const _ of b)_.type&&S.push(`onTaskType:${_.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:y}});class k{constructor(){this._onDefinitionsChanged=new v.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,_)=>{T.setHandler((w,u)=>{this._schema=void 0;try{for(const r of u.removed){const o=r.value;for(const c of o)this.taskTypes&&c.type&&this.taskTypes[c.type]&&delete this.taskTypes[c.type]}for(const r of u.added){const o=r.value;for(const c of o){const g=E.from(c,r.description.identifier,r.collector);g&&(this.taskTypes[g.taskType]=g)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){const S=[];for(const _ of this.all()){const w={type:"object",additionalProperties:!1};_.required.length>0&&(w.required=_.required.slice(0)),_.properties!==void 0?w.properties=h.deepClone(_.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[_.taskType]},S.push(w)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(De[291],Ie([1,0,222,18,24,23,41,290]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY={value:I.localize(1,null),original:"Tasks"};var y;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(x){function O(j){if(!j)return x.Strong;switch(j.toLowerCase()){case"escape":return x.Escape;case"strong":return x.Strong;case"weak":return x.Weak;default:return x.Strong}}x.from=O}(y||(e.ShellQuoting=y={}));var E;(function(x){x.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(T||(e.RevealKind=T={})),function(x){function O(j){switch(j.toLowerCase()){case"always":return x.Always;case"silent":return x.Silent;case"never":return x.Never;default:return x.Always}}x.fromString=O}(T||(e.RevealKind=T={}));var k;(function(x){x[x.Never=1]="Never",x[x.OnProblem=2]="OnProblem",x[x.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(x){function O(j){switch(j.toLowerCase()){case"always":return x.Always;case"never":return x.Never;case"onproblem":return x.OnProblem;default:return x.OnProblem}}x.fromString=O}(k||(e.RevealProblemKind=k={}));var b;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(b||(e.PanelKind=b={})),function(x){function O(j){switch(j.toLowerCase()){case"shared":return x.Shared;case"dedicated":return x.Dedicated;case"new":return x.New;default:return x.Shared}}x.fromString=O}(b||(e.PanelKind=b={}));var S;(function(x){x.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var _;(function(x){x[x.Shell=1]="Shell",x[x.Process=2]="Process",x[x.CustomExecution=3]="CustomExecution"})(_||(e.RuntimeType=_={})),function(x){function O(V){switch(V.toLowerCase()){case"shell":return x.Shell;case"process":return x.Process;case"customExecution":return x.CustomExecution;default:return x.Process}}x.fromString=O;function j(V){switch(V){case x.Shell:return"shell";case x.Process:return"process";case x.CustomExecution:return"customExecution";default:return"process"}}x.toString=j}(_||(e.RuntimeType=_={}));var w;(function(x){function O(j){return F.isString(j)?j:j.value}x.value=O})(w||(e.CommandString=w={}));var u;(function(x){x.Clean={_id:"clean",isDefault:!1},x.Build={_id:"build",isDefault:!1},x.Rebuild={_id:"rebuild",isDefault:!1},x.Test={_id:"test",isDefault:!1};function O(V){return V===x.Clean._id||V===x.Build._id||V===x.Rebuild._id||V===x.Test._id}x.is=O;function j(V){if(V!==void 0)return F.isString(V)?O(V)?{_id:V,isDefault:!1}:void 0:V}x.from=j})(u||(e.TaskGroup=u={}));var r;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var o;(function(x){x.Workspace="workspace",x.Extension="extension",x.InMemory="inMemory",x.WorkspaceFile="workspaceFile",x.User="user";function O(j){switch(j){case x.User:return 2;case x.WorkspaceFile:return 5;default:return 6}}x.toConfigurationTarget=O})(o||(e.TaskSourceKind=o={}));var c;(function(x){x.parallel="parallel",x.sequence="sequence"})(c||(e.DependsOrder=c={}));var g;(function(x){x[x.default=1]="default",x[x.folderOpen=2]="folderOpen"})(g||(e.RunOnOptions=g={}));var d;(function(x){x.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(O,j,V,fe,J,X){this._label="",this._id=O,j&&(this._label=j),V&&(this.type=V),this.runOptions=fe,this.configurationProperties=J,this._source=X}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.getFolderId(),id:this._id};return JSON.stringify(O)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,j=!1){if(O===void 0)return!1;if(F.isString(O))return O===this._label||O===this.configurationProperties.identifier||j&&O===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),O&&(this._taskLoadMessages=this._taskLoadMessages.concat(O))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class n extends t{constructor(O,j,V,fe,J,X,z,Q){super(O,V,void 0,z,Q,j),this.command={},this._source=j,this.hasDefinedMatchers=X,J&&(this.command=J)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case _.Shell:j="shell";break;case _.Process:j="process";break;case _.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(O){return O instanceof n}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===o.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==o.Workspace&&(j+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:j};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(O){return new n(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.CustomTask=n;class s extends t{constructor(O,j,V,fe,J,X,z){super(O,V,fe,X,z,j),this._source=j,this.configures=J}static is(O){return O instanceof s}fromObject(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===o.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==o.Workspace&&(j+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:j};return JSON.stringify(V)}}e.ConfiguringTask=s;class i extends t{constructor(O,j,V,fe,J,X,z,Q,ve){super(O,V,fe,Q,ve,j),this.defines=J,this.hasDefinedMatchers=z,this.command=X,this.icon=ve.icon,this.hide=ve.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof i}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.getFolderId(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(O){return new i(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.ContributedTask=i;class a extends t{constructor(O,j,V,fe,J,X){super(O,V,fe,J,X,j),this._source=j}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.InMemoryTask=a;var l;(function(x){x[x.Process=1]="Process",x[x.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(x){x._default=x.Terminal}(l||(e.ExecutionEngine=l={}));var C;(function(x){x[x.V0_1_0=1]="V0_1_0",x[x.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class D{constructor(O){this._order=new Map;for(let j=0;j<O.length;j++)this._order.set(O[j].uri.toString(),j)}compare(O,j){const V=O.getWorkspaceFolder(),fe=j.getWorkspaceFolder();if(V&&fe){let J=this._order.get(V.uri.toString());J=J===void 0?0:J+1;let X=this._order.get(fe.uri.toString());return X=X===void 0?0:X+1,J===X?O._label.localeCompare(j._label):J-X}else return!V&&fe?-1:V&&!fe?1:0}}e.TaskSorter=D;var p;(function(x){x.DependsOnStarted="dependsOnStarted",x.AcquiredInput="acquiredInput",x.Start="start",x.ProcessStarted="processStarted",x.Active="active",x.Inactive="inactive",x.Changed="changed",x.Terminated="terminated",x.ProcessEnded="processEnded",x.End="end"})(p||(e.TaskEventKind=p={}));var m;(function(x){x.SingleRun="singleRun",x.Background="background"})(m||(e.TaskRunType=m={}));var f;(function(x){x[x.System=0]="System",x[x.User=1]="User",x[x.FolderOpen=2]="FolderOpen",x[x.ConfigurationChange=3]="ConfigurationChange",x[x.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var P;(function(x){function O(Q){return{taskId:Q._id,taskName:Q.configurationProperties.name,runType:Q.configurationProperties.isBackground?"background":"singleRun",group:Q.configurationProperties.group,__task:Q}}function j(Q,ve,le){return{...O(Q),kind:"start",terminalId:ve,resolvedVariables:le}}x.start=j;function V(Q,ve,le){return{...O(Q),kind:"processStarted",terminalId:ve,processId:le}}x.processStarted=V;function fe(Q,ve,le){return{...O(Q),kind:"processEnded",terminalId:ve,exitCode:le}}x.processEnded=fe;function J(Q,ve,le){return{...O(Q),kind:"terminated",exitReason:le,terminalId:ve}}x.terminated=J;function X(Q,ve,le){return{...O(ve),kind:Q,terminalId:le}}x.general=X;function z(){return{kind:"changed"}}x.changed=z})(P||(e.TaskEvent=P={}));var M;(function(x){function O(V){const fe=Object.keys(V).sort();let J="";for(const X of fe){let z=V[X];z instanceof Object?z=O(z):typeof z=="string"&&(z=z.replace(/,/g,",,")),J+=X+","+z+","}return J}function j(V){const J={_key:O(V),type:V.taskType};return Object.assign(J,V),J}x.create=j})(M||(e.KeyedTaskIdentifier=M={}));var N;(function(x){x.AutoDetect="task.autoDetect",x.SaveBeforeRun="task.saveBeforeRun",x.ShowDecorations="task.showDecorations",x.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",x.SlowProviderWarning="task.slowProviderWarning",x.QuickOpenHistory="task.quickOpen.history",x.QuickOpenDetail="task.quickOpen.detail",x.QuickOpenSkip="task.quickOpen.skip",x.QuickOpenShowAll="task.quickOpen.showAll",x.AllowAutomaticTasks="task.allowAutomaticTasks",x.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var L;(function(x){x.Tasks="tasks",x.SuppressTaskName="tasks.suppressTaskName",x.Windows="tasks.windows",x.Osx="tasks.osx",x.Linux="tasks.linux",x.ShowOutput="tasks.showOutput",x.IsShellCommand="tasks.isShellCommand",x.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var U;(function(x){function O(j,V){const fe=v.TaskDefinitionRegistry.get(j.type);if(fe===void 0){const Q=R.deepClone(j);return delete Q._key,M.create(Q)}const J=Object.create(null);J.type=fe.taskType;const X=new Set;fe.required.forEach(Q=>X.add(Q));const z=fe.properties;for(const Q of Object.keys(z)){const ve=j[Q];if(ve!=null)J[Q]=ve;else if(X.has(Q)){const le=z[Q];if(le.default!==void 0)J[Q]=R.deepClone(le.default);else switch(le.type){case"boolean":J[Q]=!1;break;case"number":case"integer":J[Q]=0;break;case"string":J[Q]="";break;default:V.error(I.localize(2,null,JSON.stringify(j,void 0,0),Q));return}}}return M.create(J)}x.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(De[292],Ie([1,0,8]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,v)=>{this._actualOk=A,this._actualErr=v,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,I.onUnexpectedError)(A))}then(A,v){return this._ensureActual().then(A,v)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F;class h extends F{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=h}),define(De[68],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++I.count}}e.ProxyIdentifier=I;const F=[];function h(v){const y=new I(v);return F[y.nid]=y,y}e.createProxyIdentifier=h;function R(v){return F[v].sid}e.getStringIdentifierForProxy=R;class A{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=A}),define(De[6],Ie([1,0,68]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var h;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var v;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var E;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static{this._n=0}static mixin(u){return u._id=k._n++,u}}e.IdObject=k;var b;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var S;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var _;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(_||(e.ExtHostTestingResource=_={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,I.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,I.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.createProxyIdentifier)("ExtHostIssueReporter")}}),define(De[293],Ie([1,0,6,7]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class h{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,v,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const E=this._relatedInformationProviders.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(v,y)??[]}getRelatedInformation(A,v,y){return this._proxy.$getAiRelatedInformation(v,y)}registerRelatedInformationProvider(A,v,y){const E=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(E,y),this._proxy.$registerAiRelatedInformationProvider(E,v),new F.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(E),this._relatedInformationProviders.delete(E)})}}e.ExtHostRelatedInformation=h}),define(De[89],Ie([1,0,5,13,6,20]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(y,E){this._extHostLogService=E,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(h.MainContext.MainThreadTelemetry)}report(y,E,T){const k=this.getUsageKey(y,E);this._reportedUsages.has(k)||(this._reportedUsages.add(k),E.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:y}))}getUsageKey(y,E){return`${y}-${E.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=je([$e(0,R.IExtHostRpcService),$e(1,F.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(v,y,E){}})}),define(De[294],Ie([1,0,4,6,7,25]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new v,this._getSessionsTaskSingler=new v,this._proxy=E.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,T,k,b={}){const S=R.ExtensionIdentifier.toKey(E.identifier),_=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${S} ${T} ${_}`,async()=>{await this._proxy.$ensureProvider(T);const w=E.displayName||E.name;return this._proxy.$getSession(T,k,S,w,b)})}async getSessions(E,T,k){const b=R.ExtensionIdentifier.toKey(E.identifier),S=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${b} ${S}`,async()=>{await this._proxy.$ensureProvider(T);const _=E.displayName||E.name;return this._proxy.$getSessions(T,k,b,_)})}async removeSession(E,T){const k=this._authenticationProviders.get(E);return k?k.provider.removeSession(T):this._proxy.$removeSession(E,T)}registerAuthenticationProvider(E,T,k,b){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:T,provider:k,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===E)||this._providers.push({id:E,label:T});const S=k.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(E,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,T,b?.supportsMultipleAccounts??!1),new h.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(E);const _=this._providers.findIndex(w=>w.id===E);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,T,k){const b=this._authenticationProviders.get(E);if(b)return Promise.resolve(b.provider.createSession(T,k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,T){const k=this._authenticationProviders.get(E);if(k)return Promise.resolve(k.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,T){const k=this._authenticationProviders.get(E);if(k)return Promise.resolve(k.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,T){return this._onDidChangeSessions.fire({provider:{id:E,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=A;class v{constructor(){this._inFlightPromises=new Map}getOrCreate(E,T){const k=this._inFlightPromises.get(E);if(k)return k;const b=T().finally(()=>this._inFlightPromises.delete(E));return this._inFlightPromises.set(E,b),b}}}),define(De[295],Ie([1,0,6,20,14]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(v,y){this._proxy=v.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:E=>y.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,y,E){const T=h.WorkspaceEdit.from(v,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(T,void 0,E?.isRefactoring??!1)}};e.ExtHostBulkEdits=R,e.ExtHostBulkEdits=R=je([$e(0,F.IExtHostRpcService)],R)}),define(De[296],Ie([1,0,9,4,50,3,37,202,6,14]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class T{static{this._pool=0}constructor(S,_){this.extension=S,this.provider=_,this.handle=T._pool++}}class k{static{this._nextId=0}constructor(S,_){this.logService=_,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new F.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=S.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(S,_,w){const u=new T(S,w);return this._chatProvider.set(u.handle,u),this._proxy.$registerChatProvider(u.handle,_),(0,R.toDisposable)(()=>{this._proxy.$unregisterChatProvider(u.handle),this._chatProvider.delete(u.handle)})}transferChatSession(S,_){const w=h.Iterable.find(this._chatSessions.keys(),u=>this._chatSessions.get(u)===S)??0;typeof w=="number"&&this._proxy.$transferChatSession(w,_)}sendInteractiveRequestToProvider(S,_){this._proxy.$sendRequestToProvider(S,_)}async $prepareChat(S,_,w){const u=this._chatProvider.get(S);if(!u)return;const r=await u.provider.prepareSession(_,w);if(!r)return;const o=k._nextId++;return this._chatSessions.set(o,r),{id:o,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $provideWelcomeMessage(S,_){const w=this._chatProvider.get(S);if(!w||!w.provider.provideWelcomeMessage)return;const u=await w.provider.provideWelcomeMessage(_);if(u)return u.map(r=>typeof r=="string"?r:r.map(o=>E.ChatReplyFollowup.from(o)))}async $provideFollowups(S,_,w){const u=this._chatProvider.get(S);if(!u)return;const r=this._chatSessions.get(_);return!r||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(r,w))?.map(c=>E.ChatFollowup.from(c))}$removeRequest(S,_,w){const u=this._chatProvider.get(S);if(!u)return;const r=this._chatSessions.get(_);r&&u.provider.removeRequest&&u.provider.removeRequest(r,w)}async $provideReply(S,_,w,u){const r=this._chatProvider.get(S);if(!r)return;const o=this._chatSessions.get(_);if(!o)return;const c={session:o,message:typeof w.message=="string"?w.message:E.ChatReplyFollowup.to(w.message),variables:{}};if(w.variables)for(const i of Object.keys(w.variables))c.variables[i]=w.variables[i].map(E.ChatVariable.to);const g=A.StopWatch.create(!1);let d;const t={report:i=>{if(u.isCancellationRequested)return;typeof d>"u"&&(d=g.elapsed());const a=E.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const l=Promise.all([this._proxy.$acceptResponseProgress(S,_,a),i.resolvedContent]);(0,I.raceCancellation)(l,u).then(C=>{if(!C)return;const[D,p]=C;this._proxy.$acceptResponseProgress(S,_,p,D??void 0)})}else this._proxy.$acceptResponseProgress(S,_,a)}};let n;try{n=await r.provider.provideResponseWithProgress(c,t,u),n||(n={errorDetails:{message:(0,v.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,v.localize)(1,null,i.message),responseIsIncomplete:!0}},this.logService.error(i)}try{if(o.saveState&&this._chatSessions.has(_)){const i=o.saveState();this._proxy.$acceptChatState(_,i)}}catch(i){this.logService.warn(i)}const s={firstProgress:d??0,totalElapsed:g.elapsed()};return{errorDetails:n.errorDetails,timings:s}}async $provideSlashCommands(S,_,w){const u=this._chatProvider.get(S);if(!u)return;const r=this._chatSessions.get(_);return!r||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(r,w))?.map(c=>({...c,kind:E.CompletionItemKind.from(c.kind)}))}$releaseSession(S){this._chatSessions.delete(S)}async $onDidPerformUserAction(S){this._onDidPerformUserAction.fire(S)}}e.ExtHostChat=k}),define(De[297],Ie([1,0,9,3,84,6,14,7]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class y{static{this._idPool=0}constructor(k,b,S){this._extHostChatProvider=b,this._logService=S,this._agents=new Map,this._proxy=k.getProxy(R.MainContext.MainThreadChatAgents)}registerAgent(k,b,S,_){const w=y._idPool++;return this._agents.set(w,{extension:k,agent:S}),this._proxy.$registerAgent(w,b,_),(0,F.toDisposable)(()=>{this._proxy.$unregisterAgent(w),this._agents.delete(w)})}async $invokeAgent(k,b,S,_,w){const u=this._agents.get(k);if(!u){this._logService.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let r=!1;function o(){if(r)throw new Error("Only valid while executing the command")}const c=new I.DeferredPromise;w.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(u.extension,c.p);const g=u.agent({role:v.ChatMessageRole.User,content:S},{history:_.history.map(A.ChatMessage.to)},new h.Progress(d=>{o(),this._proxy.$handleProgressChunk(b,{content:E(d.message)?d.message:d.message.value})}),w);try{return await(0,I.raceCancellation)(Promise.resolve(g).then(d=>{if(d&&"followUp"in d)return{followUp:d?.followUp?.map(n=>A.ChatFollowup.from(n))}}),w)}finally{r=!0,c.complete()}}}e.ExtHostChatAgents=y;function E(T){return!!T&&typeof T=="object"&&"treeData"in T}}),define(De[298],Ie([1,0,3,6,14,84,25]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class v{static{this._idPool=1}constructor(E,T){this._logService=T,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new A.ExtensionIdentifierMap,this._proxy=E.getProxy(F.MainContext.MainThreadChatProvider)}registerProvider(E,T,k,b){const S=v._idPool++;return this._providers.set(S,{extension:E,provider:k}),this._proxy.$registerProvider(S,T,{extension:E,displayName:b.name??E.value}),(0,I.toDisposable)(()=>{this._proxy.$unregisterProvider(S),this._providers.delete(S)})}async $provideChatResponse(E,T,k,b,S){const _=this._providers.get(E);if(!_)return;const w=new R.Progress(async u=>{if(S.isCancellationRequested){this._logService.warn(`[CHAT](${_.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(T,{index:u.index,part:u.part})},{async:!0});return _.provider.provideChatResponse(k.map(h.ChatMessage.to),b,w,S)}allowListExtensionWhile(E,T){this._chatAccessAllowList.set(E,T),T.finally(()=>this._chatAccessAllowList.delete(E))}async requestChatResponseProvider(E,T){if(!this._chatAccessAllowList.has(E))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k._chatAccessAllowList.has(E)},async makeRequest(b,S,_,w){if(!k._chatAccessAllowList.has(E))throw new Error("Access to chat has been revoked");const u=Math.random()*1e6|0;k._pendingRequest.set(u,_);try{await k._proxy.$fetchResponse(E,T,u,b.map(h.ChatMessage.from),S,w)}finally{k._pendingRequest.delete(u)}}}}async $handleResponseFragment(E,T){this._pendingRequest.get(E)?.report(T)}}e.ExtHostChatProvider=v}),define(De[299],Ie([1,0,3,6,8,14]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class A{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadChatVariables)}async $resolveVariable(y,E,T){const k=this._resolver.get(y);if(k)try{const b=await k.resolver.resolve(k.data.name,{message:E},T);if(b)return b.map(R.ChatVariable.from)}catch(b){(0,h.onUnexpectedExternalError)(b)}}registerVariableResolver(y,E,T,k){const b=A._idPool++;return this._resolver.set(b,{extension:y.identifier,data:{name:E,description:T},resolver:k}),this._proxy.$registerVariable(b,{name:E,description:T}),(0,I.toDisposable)(()=>{this._resolver.delete(b),this._proxy.$unregisterVariable(b)})}}e.ExtHostChatVariables=A}),define(De[300],Ie([1,0,6]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(R){const A=R.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(v){return A.$writeText(v)}})}}e.ExtHostClipboard=F}),define(De[33],Ie([1,0,18,7,14,23,6,19,13,62,34,61,2,3,5,20,145,22,68,46,37,85,88]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{#e;#t;#i;constructor(D,p,m){this._commands=new Map,this._apiCommands=new Map,this.#e=D.getProxy(A.MainContext.MainThreadCommands),this._logService=p,this.#i=m,this.#t=D.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new s(this,f=>{const P=this._apiCommands.get(f);return P?.result===a.Void?P:void 0},p),this._argumentProcessors=[{processArgument(f){return(0,E.revive)(f)}},{processArgument(f){return(0,R.cloneAndChange)(f,function(P){if(T.Range.isIRange(P))return h.Range.to(P);if(k.Position.isIPosition(P))return h.Position.to(P);if(T.Range.isIRange(P.range)&&b.URI.isUri(P.uri))return h.location.to(P);if(P instanceof r.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(D){this._argumentProcessors.push(D)}registerApiCommand(D){const p=this.registerCommand(!1,D.id,async(...m)=>{const f=D.args.map((M,N)=>{if(!M.validate(m[N]))throw new Error(`Invalid argument '${M.name}' when running '${D.id}', received: ${typeof m[N]=="object"?JSON.stringify(m[N],null,"	"):m[N]} `);return M.convert(m[N])}),P=await this.executeCommand(D.internalId,...f);return D.result.convert(P,m,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this._apiCommands.set(D.id,D),new F.Disposable(()=>{p.dispose(),this._apiCommands.delete(D.id)})}registerCommand(D,p,m,f,P,M){if(this._logService.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this._commands.has(p))throw new Error(`command '${p}' already exists`);return this._commands.set(p,{callback:m,thisArg:f,metadata:P,extension:M}),D&&this.#e.$registerCommand(p),new F.Disposable(()=>{this._commands.delete(p)&&D&&this.#e.$unregisterCommand(p)})}executeCommand(D,...p){return this._logService.trace("ExtHostCommands#executeCommand",D),this._doExecuteCommand(D,p,!0)}async _doExecuteCommand(D,p,m){if(this._commands.has(D))return this.#e.$fireCommandActivationEvent(D),this._executeContributedCommand(D,p,!1);{let f=!1;const P=(0,R.cloneAndChange)(p,function(M){if(M instanceof F.Position)return h.Position.from(M);if(M instanceof F.Range)return h.Range.from(M);if(M instanceof F.Location)return h.location.from(M);if(F.NotebookRange.isNotebookRange(M))return h.NotebookRange.from(M);if(M instanceof ArrayBuffer)return f=!0,r.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return f=!0,r.VSBuffer.wrap(M);if(M instanceof r.VSBuffer)return f=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(D,f?new o.SerializableObjectWithBuffers(P):P,m);return(0,E.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(D,p,!1);throw M}}}async _executeContributedCommand(D,p,m){const f=this._commands.get(D);if(!f)throw new Error("Unknown command");const{callback:P,thisArg:M,metadata:N}=f;if(N?.args)for(let U=0;U<N.args.length;U++)try{(0,I.validateConstraint)(p[U],N.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${N.args[U].name}' - ${N.args[U].description}`)}const L=g.StopWatch.create();try{return await P.apply(M,p)}catch(U){if(D===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...p);x&&(D=x.command)}if(this._logService.error(U,D,f.extension?.identifier),!m)throw U;if(f.extension?.identifier){const x=this.#i.onExtensionError(f.extension.identifier,U);this._logService.trace("forwarded error to extension?",x,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.toErrorMessage)(U)),this.id=D,this.source=f.extension?.displayName??f.extension?.name}}}finally{this._reportTelemetry(f,D,L.elapsed())}}_reportTelemetry(D,p,m){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new d.TelemetryTrustedValue(p),duration:m})}$executeContributedCommand(D,...p){this._logService.trace("ExtHostCommands#$executeContributedCommand",D);const m=this._commands.get(D);return m?(p=p.map(f=>this._argumentProcessors.reduce((P,M)=>M.processArgument(P,m.extension?.identifier),f)),this._executeContributedCommand(D,p,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this._logService.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(p=>(D&&(p=p.filter(m=>m[0]!=="_")),p))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[p,m]of this._commands){const{metadata:f}=m;f&&(D[p]=f)}return Promise.resolve(D)}};e.ExtHostCommands=n,e.ExtHostCommands=n=je([$e(0,w.IExtHostRpcService),$e(1,y.ILogService),$e(2,t.IExtHostTelemetry)],n),e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class s{constructor(D,p,m){this._commands=D,this._lookupApiCommand=p,this._logService=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(D,p){if(!D)return;const m={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return m;const f=this._lookupApiCommand(D.command);if(f)m.id=f.internalId,m.arguments=f.args.map((P,M)=>P.convert(D.arguments&&D.arguments[M]));else if((0,v.isNonEmptyArray)(D.arguments)){const P=`${D.command} /${++this._cachIdPool}`;this._cache.set(P,D),p.add((0,S.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this._logService.trace("CommandsConverter#CREATE",D.command,P)}return m}fromInternal(D){return typeof D.$ident=="string"?this._cache.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this._cache.get(D[0])}_executeConvertedCommand(...D){const p=this.getActualCommand(...D);return this._logService.trace("CommandsConverter#EXECUTE",D[0],p?p.command:"MISSING"),p?this._commands.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.CommandsConverter=s;class i{static{this.Uri=new i("uri","Uri of a text document",D=>b.URI.isUri(D),D=>D)}static{this.Position=new i("position","A position in a text document",D=>F.Position.isPosition(D),h.Position.from)}static{this.Range=new i("range","A range in a text document",D=>F.Range.isRange(D),h.Range.from)}static{this.Selection=new i("selection","A selection in a text document",D=>F.Selection.isSelection(D),h.Selection.from)}static{this.Number=new i("number","",D=>typeof D=="number",D=>D)}static{this.String=new i("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=i.Arr(i.String)}static Arr(D){return new i(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,p=>Array.isArray(p)&&p.every(m=>D.validate(m)),p=>p.map(m=>D.convert(m)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",D=>D instanceof F.CallHierarchyItem,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",D=>D instanceof F.TypeHierarchyItem,h.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VSCodium TestItem",D=>D instanceof u.TestItemImpl,h.TestItem.from)}constructor(D,p,m,f){this.name=D,this.description=p,this.validate=m,this.convert=f}optional(){return new i(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,p){return new i(D??this.name,p??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i;class a{static{this.Void=new a("no result",D=>D)}constructor(D,p){this.description=D,this.convert=p}}e.ApiCommandResult=a;class l{constructor(D,p,m,f,P){this.id=D,this.internalId=p,this.description=m,this.args=f,this.result=P}}e.ApiCommand=l}),define(De[301],Ie([1,0,19,17,2,82,129,41,134,33,14,7]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(T.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,r)=>{if((0,I.isFalsyOrEmpty)(u))return;class o extends k.SymbolInformation{static to(g){const d=new o(g.name,T.SymbolKind.to(g.kind),g.containerName||"",new k.Location(r[0],T.Range.to(g.range)));return d.detail=g.detail,d.range=d.location.range,d.selectionRange=T.Range.to(g.selectionRange),d.children=g.children?g.children.map(o.to):[],d}}return u.map(o.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(T.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(T.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(T.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(T.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(T.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(r=>k.Position.isPosition(r)),u=>u.map(T.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(r=>{let o;for(const c of r.reverse())o=new k.SelectionRange(T.Range.to(c),o);return o}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(T.WorkspaceSymbol.to))),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(T.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(T.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(T.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:T.Range.to(u.range),placeholder:u.text}})),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return T.WorkspaceEdit.to(u)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(T.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new k.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const r=(0,A.decodeSemanticTokensDto)(u);if(r.type==="full")return new k.SemanticTokens(r.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range.optional()],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new k.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const r=(0,A.decodeSemanticTokensDto)(u);if(r.type==="full")return new k.SemanticTokens(r.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,r,o)=>{if(!u)return new k.CompletionList([]);const c=u.suggestions.map(g=>T.CompletionItem.to(g,o));return new k.CompletionList(c,u.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return T.SignatureHelp.to(u)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,r,o)=>_(c=>new k.CodeLens(T.Range.to(c.range),c.command&&o.fromInternal(c.command)))(u))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>k.Range.isRange(u),u=>k.Selection.isSelection(u)?T.Selection.from(u):T.Range.from(u)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,r,o)=>_(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(c.command)}else{const g=new k.CodeAction(c.title,c.kind?new k.CodeActionKind(c.kind):void 0);return c.edit&&(g.edit=T.WorkspaceEdit.to(c.edit)),c.command&&(g.command=o.fromInternal(c.command)),g.isPreferred=c.isPreferred,g}})(u))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(r=>new k.ColorInformation(T.Range.to(r.range),T.Color.to(r.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",u=>u instanceof k.Color,T.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:T.Range.from(u.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(T.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,r,o)=>u.map(T.InlayHint.to.bind(void 0,o)))),new E.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(u,r)=>{if(u)return u.map(T.FoldingRange.to)})),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(r=>T.NotebookExclusiveDocumentPattern.to(r))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof k.Range,u=>T.InlineValueContext.from(u))],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(T.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new E.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>h.URI.isUri(u)||typeof u=="string"&&(0,y.matchesSomeScheme)(u,F.Schemas.http,F.Schemas.https),u=>u),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[T.ViewColumn.from(u),void 0]:[T.ViewColumn.from(u.viewColumn),T.TextEditorOpenOptions.from(u)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[T.ViewColumn.from(u),void 0]:[T.ViewColumn.from(u.viewColumn),T.TextEditorOpenOptions.from(u)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[T.ViewColumn.from(u.viewColumn),T.TextEditorOpenOptions.from(u)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(T.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(T.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(T.TypeHierarchyItem.to))),new E.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[E.ApiCommandArgument.TestItem],E.ApiCommandResult.Void),new E.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[E.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],E.ApiCommandResult.Void),new E.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[E.ApiCommandArgument.String.with("name","The context key name"),new E.ApiCommandArgument("value","The context key value",()=>!0,u=>u)],E.ApiCommandResult.Void),new E.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.StringArray,new E.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",u=>T.MappedEditsContext.is(u),u=>T.MappedEditsContext.from(u))],new E.ApiCommandResult("A promise that resolves to a workspace edit or null",u=>u?T.WorkspaceEdit.to(u):null))];class S{static register(r){b.forEach(r.registerApiCommand,r),this._registerValidateWhenClausesCommand(r)}static _registerValidateWhenClausesCommand(r){r.registerCommand(!1,"_validateWhenClauses",v.validateWhenClauses)}}e.ExtHostApiCommands=S;function _(u){return r=>{if(Array.isArray(r))return r.map(u)}}function w(u){if(!Array.isArray(u))return;const r=[];for(const o of u)R.isLocationLink(o)?r.push(T.DefinitionLink.to(o)):r.push(T.location.to(o));return r}}),define(De[302],Ie([1,0,9,57,4,3,2,82,25,14,7,6,27]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(_,w,u){const r=_.getProxy(k.MainContext.MainThreadComments);class o{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,w.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const C=this._commentControllers.get(l.handle);return C?C.value:l}else if(l&&l.$mid===7){const C=this._commentControllers.get(l.commentControlHandle);if(!C)return l;const D=C.getCommentThread(l.commentThreadHandle);return D?D.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const C=this._commentControllers.get(l.thread.commentControlHandle);if(!C)return l;const D=C.getCommentThread(l.thread.commentThreadHandle);return D?l.$mid===8?D.value:{thread:D.value,text:l.text}:l}else if(l&&l.$mid===10){const C=this._commentControllers.get(l.thread.commentControlHandle);if(!C)return l;const D=C.getCommentThread(l.thread.commentThreadHandle);if(!D)return l;const p=l.commentUniqueId,m=D.getCommentByUniqueId(p);return m||l}else if(l&&l.$mid===11){const C=this._commentControllers.get(l.thread.commentControlHandle);if(!C)return l;const D=C.getCommentThread(l.thread.commentThreadHandle);if(!D)return l;const p=l.text,m=l.commentUniqueId,f=D.getCommentByUniqueId(m);return f?(typeof f.body=="string"?f.body=p:f.body=new T.MarkdownString(p),f):l}return l}})}createCommentController(l,C,D){const p=o.handlePool++,m=new g(l,p,C,D);this._commentControllers.set(m.handle,m);const f=this._commentControllersByExtension.get(l.identifier)||[];return f.push(m),this._commentControllersByExtension.set(l.identifier,f),m.value}$createCommentThreadTemplate(l,C,D){const p=this._commentControllers.get(l);p&&p.$createCommentThreadTemplate(C,D)}async $updateCommentThreadTemplate(l,C,D){const p=this._commentControllers.get(l);p&&p.$updateCommentThreadTemplate(C,D)}$deleteCommentThread(l,C){this._commentControllers.get(l)?.$deleteCommentThread(C)}$provideCommentingRanges(l,C,D){const p=this._commentControllers.get(l);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const m=u.getDocument(A.URI.revive(C));return(0,I.asPromise)(async()=>{const f=await p.commentingRangeProvider.provideCommentingRanges(m,D);let P;return Array.isArray(f)?P={ranges:f,fileComments:!1}:f?P={ranges:f.ranges||[],fileComments:f.fileComments||!1}:P=f??void 0,P}).then(f=>{let P;return f&&(P={ranges:f.ranges.map(M=>E.Range.from(M)),fileComments:f.fileComments}),P})}$toggleReaction(l,C,D,p,m){const f=this._commentControllers.get(l);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const P=f.getCommentThread(C);if(P){const M=P.getCommentByUniqueId(p.uniqueIdInThread);if(f!==void 0&&M&&f.reactionHandler)return f.reactionHandler(M,n(m))}return Promise.resolve(void 0)})}}class c{static{this._handlePool=0}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){(l===void 0!=(this._range===void 0)||!l||!this._range||!l.isEqual(this._range))&&(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(l){this._state=l,this.modifications.state=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(l,C,D,p,m,f,P,M){this._commentControllerHandle=C,this._id=D,this._uri=p,this._range=m,this._comments=f,this.extensionDescription=P,this._isTemplate=M,this.handle=c._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new h.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${l}.${this.handle}`),r.$createCommentThread(C,this.handle,this._id,this._uri,E.Range.from(this._range),P.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{r.$deleteCommentThread(C,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(L){N.range=L},get comments(){return N.comments},set comments(L){N.comments=L},get collapsibleState(){return N.collapsibleState},set collapsibleState(L){N.collapsibleState=L},get canReply(){return N.canReply},set canReply(L){N.canReply=L},get contextValue(){return N.contextValue},set contextValue(L){N.contextValue=L},get label(){return N.label},set label(L){N.label=L},get state(){return N.state},set state(L){N.state=L},dispose:()=>{N.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const l=D=>Object.prototype.hasOwnProperty.call(this.modifications,D),C={};l("range")&&(C.range=E.Range.from(this._range)),l("label")&&(C.label=this.label),l("contextValue")&&(C.contextValue=this.contextValue??null),l("comments")&&(C.comments=this._comments.map(D=>d(this,D,this._commentsMap,this.extensionDescription))),l("collapsibleState")&&(C.collapseState=s(this._collapseState)),l("canReply")&&(C.canReply=this.canReply),l("state")&&(C.state=i(this._state)),l("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},r.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(l){for(const C of this._commentsMap){const D=C[0],p=C[1];if(l===p)return D}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose())}}je([(0,F.debounce)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(l){this._commentingRangeProvider=l,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,r.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(l,C,D,p){this._extension=l,this._handle=C,this._id=D,this._label=p,this._threads=new Map,r.$registerCommentController(this.handle,D,p,this._extension.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(f){m.options=f},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(f){m.commentingRangeProvider=f},get reactionHandler(){return m.reactionHandler},set reactionHandler(f){m.reactionHandler=f},createCommentThread(f,P,M){return m.createCommentThread(f,P,M).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(l,C,D){C===void 0&&(0,b.checkProposedApiEnabled)(this._extension,"fileComments");const p=new c(this.id,this.handle,void 0,l,C,D,this._extension,!1);return this._threads.set(p.handle,p),p}$createCommentThreadTemplate(l,C){const D=new c(this.id,this.handle,void 0,A.URI.revive(l),E.Range.to(C),[],this._extension,!0);return D.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(D.handle,D),D}$updateCommentThreadTemplate(l,C){const D=this._threads.get(l);D&&(D.range=E.Range.to(C))}$deleteCommentThread(l){this._threads.get(l)?.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._localDisposables.forEach(l=>l.dispose())}}function d(a,l,C,D){let p=C.get(l);return p||(p=++a.commentHandle,C.set(l,p)),l.state!==void 0&&(0,b.checkProposedApiEnabled)(D,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:p,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(m=>t(m)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?E.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function s(a){if(a!==void 0)switch(a){case T.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case T.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new o}e.createExtHostComments=S}),define(De[303],Ie([1,0,23,6,26,20]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(T,k){this._mainThreadConsole=T.getProxy(F.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(T,k){const b=this,S=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){b._handleConsoleCall(T,k,S,arguments)}})}_handleConsoleCall(T,k,b,S){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:y(S,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(T,b,S)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=je([$e(0,R.IExtHostRpcService),$e(1,h.IExtHostInitDataService)],A);const v=1e5;function y(E,T){const k=[];if(E.length)for(let b=0;b<E.length;b++){let S=E[b];if(typeof S>"u")S="undefined";else if(S instanceof Error){const _=S;_.stack?S=_.stack:S=_.toString()}k.push(S)}if(T){const b=new Error().stack;b&&k.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,I.safeStringify)(k);return b.length>v?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(De[149],Ie([1,0,2,6,7,5,20,13,19,15,16,27]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class{static{b=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(w,u){this._logService=u,this._provider=new Map,this._proxy=w.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,u){const r=b._handlePool++;this._provider.set(r,{provider:w,extensionDescription:u}),this._proxy.$registerDecorationProvider(r,u.identifier.value);const o=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(r,null);return}const g=(0,y.asArray)(c);if(g.length<=b._maxEventSize){this._proxy.$onDidChange(r,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,g.length);const d=g.map(s=>({uri:s,rank:(0,E.count)(s.path,"/")})),t=(0,y.groupBy)(d,(s,i)=>s.rank-i.rank||(0,E.compare)(s.uri.path,i.uri.path)),n=[];e:for(const s of t){let i;for(const a of s){const l=(0,T.dirname)(a.uri.path);if(i!==l&&(i=l,n.push(a.uri)>=b._maxEventSize))break e}}this._proxy.$onDidChange(r,n)});return new h.Disposable(()=>{o?.dispose(),this._proxy.$unregisterDecorationProvider(r),this._provider.delete(r)})}async $provideDecorations(w,u,r){if(!this._provider.has(w))return Object.create(null);const o=Object.create(null),{provider:c,extensionDescription:g}=this._provider.get(w);return await Promise.all(u.map(async d=>{try{const{uri:t,id:n}=d,s=await Promise.resolve(c.provideFileDecoration(I.URI.revive(t),r));if(!s)return;try{h.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.checkProposedApiEnabled)(g,"codiconDecoration"),o[n]=[s.propagate,s.tooltip,s.badge,s.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${g.identifier.value}': ${i}`)}}catch(t){this._logService.error(t)}})),o}};e.ExtHostDecorations=S,e.ExtHostDecorations=S=b=je([$e(0,A.IExtHostRpcService),$e(1,v.ILogService)],S),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")}),define(De[304],Ie([1,0,203,133,2,6,7,14,4,13,28,55]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class S{#e;#t;#i;constructor(u,r,o,c,g,d,t,n){this._name=u,this._owner=r,this._maxDiagnosticsTotal=o,this._maxDiagnosticsPerFile=c,this._modelVersionIdProvider=g,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(c,o),this.#i=new T.ResourceMap(s=>d.getComparisonKey(s)),this.#e=t,this.#t=n}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,r){if(!u){this.clear();return}this._checkDisposed();let o=[];if(h.URI.isUri(u)){if(!r){this.delete(u);return}this.#i.set(u,r.slice()),o=[u]}else if(Array.isArray(u)){o=[];let d;u=[...u].sort(S._compareIndexedTuplesByUri);for(const t of u){const[n,s]=t;if((!d||n.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=n,o.push(n),this.#i.set(n,[])),s)this.#i.get(n)?.push(...s);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(o),!this.#e)return;const c=[];let g=0;for(const d of o){let t=[];const n=this.#i.get(d);if(n)if(n.length>this._maxDiagnosticsPerFile){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const a of n)if(a.severity===s[i]&&t.push({...v.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(d)})===this._maxDiagnosticsPerFile)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(s=>({...v.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(d)}));if(c.push([d,t]),g+=t.length,g>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,c)}delete(u){this._checkDisposed(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(u,r){this._checkDisposed();for(const[o,c]of this)u.call(r,o,c,this)}*[Symbol.iterator](){this._checkDisposed();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this._checkDisposed();const r=this.#i.get(u);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this.#i.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,r){return u[0].toString()<r[0].toString()?-1:u[0].toString()>r[0].toString()?1:0}}e.DiagnosticCollection=S;let _=class{static{b=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*b._maxDiagnosticsPerFile}static _mapper(u){const r=new T.ResourceMap;for(const o of u)r.set(o,o);return{uris:Object.freeze(Array.from(r.values()))}}constructor(u,r,o,c){this._logService=r,this._fileSystemInfoService=o,this._extHostDocumentsAndEditors=c,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,b._mapper),this._proxy=u.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(u,r){const{_collections:o,_proxy:c,_onDidChangeDiagnostics:g,_logService:d,_fileSystemInfoService:t,_extHostDocumentsAndEditors:n}=this,s=new class{$changeMany(l,C){c.$changeMany(l,C),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,l,C.length===0?"CLEARING":C)}$clear(l){c.$clear(l),d.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,l)}dispose(){c.dispose()}};let i;if(!r)r="_generated_diagnostic_collection_name_#"+b._idPool++,i=r;else if(!o.has(r))i=r;else{this._logService.warn(`DiagnosticCollection with name '${r}' does already exist.`);do i=r+b._idPool++;while(o.has(i))}return new class extends S{constructor(){super(r,i,b._maxDiagnosticsTotal,b._maxDiagnosticsPerFile,l=>n.getDocument(l)?.version,t.extUri,s,g),o.set(i,this)}dispose(){super.dispose(),o.delete(i)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const r=new Map,o=[];for(const c of this._collections.values())c.forEach((g,d)=>{let t=r.get(g.toString());typeof t>"u"&&(t=o.length,r.set(g.toString(),t),o.push([g,[]])),o[t][1]=o[t][1].concat(...d)});return o}}_getDiagnostics(u){let r=[];for(const o of this._collections.values())o.has(u)&&(r=r.concat(o.get(u)));return r}$acceptMarkersChange(u){if(!this._mirrorCollection){const r="_generated_mirror",o=new S(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(r,o),this._mirrorCollection=o}for(const[r,o]of u)this._mirrorCollection.set(h.URI.revive(r),o.map(v.Diagnostic.to))}};e.ExtHostDiagnostics=_,e.ExtHostDiagnostics=_=b=je([$e(1,E.ILogService),$e(2,k.IExtHostFileSystemInfo)],_)}),define(De[305],Ie([1,0,2,6,27]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(v){this._proxy=v.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(v,y){return y?.allowUIResources&&(0,h.checkProposedApiEnabled)(v,"showLocal"),this._proxy.$showOpenDialog(y).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(v){return this._proxy.$showSaveDialog(v).then(y=>y?I.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(De[306],Ie([1,0,8,2,7,6,17,21,15]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class E{static{this._handlePool=0}constructor(k,b,S){this._documentsAndEditors=b,this._logService=S,this._documentContentProviders=new Map,this._proxy=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,b){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const S=E._handlePool++;this._documentContentProviders.set(S,b),this._proxy.$registerTextContentProvider(S,k);let _;return typeof b.onDidChange=="function"&&(_=b.onDidChange(w=>{if(w.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(S,w).then(u=>{if(!u&&typeof u!="string")return;const r=this._documentsAndEditors.getDocument(w);if(!r)return;const o=(0,y.splitLines)(u);if(!r.equalLines(o))return this._proxy.$onVirtualDocumentChange(w,u)},I.onUnexpectedError)})),new h.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(k,b){const S=this._documentContentProviders.get(k);return S?Promise.resolve(S.provideTextDocumentContent(F.URI.revive(b),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=E}),define(De[307],Ie([1,0,4,3,2,6,141,14,18,23,7,8]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(_,w){this._onDidAddDocument=new I.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidRemoveDocument=new I.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeDocument=new I.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidSaveDocument=new I.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const r of u)this._onDidRemoveDocument.fire(r.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const r of u)this._onDidAddDocument.fire(r.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const w=this._documentsAndEditors.getDocument(_);if(w)return w}getDocument(_){const w=this.getDocumentData(_);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return w.document}ensureDocumentData(_){const w=this._documentsAndEditors.getDocument(_);if(w)return Promise.resolve(w);let u=this._documentLoader.get(_.toString());return u||(u=this._proxy.$tryOpenDocument(_).then(r=>{this._documentLoader.delete(_.toString());const o=h.URI.revive(r);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(o))},r=>(this._documentLoader.delete(_.toString()),Promise.reject(r))),this._documentLoader.set(_.toString(),u)),u}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(w=>h.URI.revive(w))}$acceptModelLanguageChanged(_,w){const u=h.URI.revive(_),r=this._documentsAndEditors.getDocument(u);if(!r)throw new Error("unknown document");this._onDidRemoveDocument.fire(r.document),r._acceptLanguageId(w),this._onDidAddDocument.fire(r.document)}$acceptModelSaved(_){const w=h.URI.revive(_),u=this._documentsAndEditors.getDocument(w);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(_,w){const u=h.URI.revive(_),r=this._documentsAndEditors.getDocument(u);if(!r)throw new Error("unknown document");r._acceptIsDirty(w),this._onDidChangeDocument.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,w,u){const r=h.URI.revive(_),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(w);let c;w.isUndoing?c=T.TextDocumentChangeReason.Undo:w.isRedoing&&(c=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,E.deepFreeze)({document:o.document,contentChanges:w.changes.map(g=>({range:v.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:c}))}setWordDefinitionFor(_,w){(0,A.setWordDefinitionFor)(_,w)}}e.ExtHostDocuments=b}),define(De[69],Ie([1,0,58,4,3,2,5,6,141,20,146,14,13,28,17,50,51]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class r{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let o=class{constructor(g,d){this._extHostRpc=g,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const d=[],t=[],n=[];if(g.removedDocuments)for(const s of g.removedDocuments){const i=R.URI.revive(s),a=this._documents.get(i);a?.unref()&&(this._documents.delete(i),d.push(a.value))}if(g.addedDocuments)for(const s of g.addedDocuments){const i=R.URI.revive(s.uri);let a=this._documents.get(i);if(a&&i.scheme!==_.Schemas.vscodeNotebookCell&&i.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new r(new y.ExtHostDocumentData(this._extHostRpc.getProxy(v.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(g.removedEditors)for(const s of g.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&n.push(i)}if(g.addedEditors)for(const s of g.addedEditors){const i=R.URI.revive(s.documentUri);I.ok(this._documents.has(i),`document '${i}' does not exist`),I.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(i).value,l=new T.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(v.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>a.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(C=>k.Range.to(C)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,l)}g.newActiveEditor!==void 0&&(I.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,h.dispose)(d),(0,h.dispose)(n),g.removedDocuments&&this._onDidRemoveDocuments.fire(d),g.addedDocuments&&this._onDidAddDocuments.fire(t),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return g?d:d?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=o,e.ExtHostDocumentsAndEditors=o=je([$e(0,E.IExtHostRpcService),$e(1,b.ILogService)],o),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[70],Ie([1,0,14,6,2,4,5,7,20,18,73]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class k{constructor(u,r,o){this._activeTabIdGetter=o,this._parentGroup=r,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,r={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(r)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new v.TextTabInput(h.URI.revive(this._dto.input.uri));case 2:return new v.TextDiffTabInput(h.URI.revive(this._dto.input.original),h.URI.revive(this._dto.input.modified));case 3:return new v.TextMergeTabInput(h.URI.revive(this._dto.input.base),h.URI.revive(this._dto.input.input1),h.URI.revive(this._dto.input.input2),h.URI.revive(this._dto.input.result));case 6:return new v.CustomEditorTabInput(h.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new v.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new v.NotebookEditorTabInput(h.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new v.NotebookDiffEditorTabInput(h.URI.revive(this._dto.input.original),h.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new v.TerminalEditorTabInput;case 9:return new v.InteractiveWindowInput(h.URI.revive(this._dto.input.uri),h.URI.revive(this._dto.input.inputBoxUri));default:return}}}class b{constructor(u,r){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=r;for(const o of u.tabs)o.isActive&&(this._activeTabId=o.id),this._tabs.push(new k(o,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,r={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return I.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(o=>o.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(o=>o.apiObject))}};this._apiObject=Object.freeze(r)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===0){const o=new k(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,o),u.tabDto.isActive&&(this._activeTabId=o.tabId),o}else if(u.kind===1){const o=this._tabs.splice(u.index,1)[0];if(!o)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return o.tabId===this._activeTabId&&(this._activeTabId=""),o}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const o=this._tabs.splice(u.oldIndex,1)[0];if(!o)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,o),o}const r=this._tabs.find(o=>o.tabId===u.tabDto.id);if(!r)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),r.acceptDtoUpdate(u.tabDto),r}activeTabId(){return this._activeTabId}}let S=class{constructor(u){this._onDidChangeTabs=new R.Emitter,this._onDidChangeTabGroups=new R.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(F.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,r={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(o=>o.apiObject))},get activeTabGroup(){const o=u._activeGroupId;return(0,E.assertIsDefined)(u._extHostTabGroups.find(g=>g.groupId===o)?.apiObject)},close:async(o,c)=>{const g=Array.isArray(o)?o:[o];return g.length?_(g[0])?this._closeGroups(g,c):this._closeTabs(g,c):!0}};this._apiObject=Object.freeze(r)}return this._apiObject}$acceptEditorTabModel(u){const r=new Set(this._extHostTabGroups.map(s=>s.groupId)),o=new Set(u.map(s=>s.groupId)),c=(0,T.diffSets)(r,o),g=this._extHostTabGroups.filter(s=>c.removed.includes(s.groupId)).map(s=>s.apiObject),d=[],t=[];this._extHostTabGroups=u.map(s=>{const i=new b(s,()=>this._activeGroupId);return c.added.includes(i.groupId)?d.push(i.apiObject):t.push(i.apiObject),i});const n=(0,E.assertIsDefined)(u.find(s=>s.isActive===!0)?.groupId);n!==void 0&&this._activeGroupId!==n&&(this._activeGroupId=n),this._onDidChangeTabGroups.fire(Object.freeze({opened:d,closed:g,changed:t}))}$acceptTabGroupUpdate(u){const r=this._extHostTabGroups.find(o=>o.groupId===u.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const r=this._extHostTabGroups.find(c=>c.groupId===u.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const o=r.acceptTabOperation(u);switch(u.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[o.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[o.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[o.apiObject]}));return}}_findExtHostTabFromApi(u){for(const r of this._extHostTabGroups)for(const o of r.tabs)if(o.apiObject===u)return o}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(r=>r.apiObject===u)}async _closeTabs(u,r){const o=[];for(const c of u){const g=this._findExtHostTabFromApi(c);if(!g)throw new Error("Tab close: Invalid tab not found!");o.push(g.tabId)}return this._proxy.$closeTab(o,r)}async _closeGroups(u,r){const o=[];for(const c of u){const g=this._findExtHostTabGroupFromApi(c);if(!g)throw new Error("Group close: Invalid group not found!");o.push(g.groupId)}return this._proxy.$closeGroup(o,r)}};e.ExtHostEditorTabs=S,e.ExtHostEditorTabs=S=je([$e(0,y.IExtHostRpcService)],S);function _(w){return w.tabs!==void 0}}),define(De[308],Ie([1,0,6,7]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class h{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,v,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const E=this._AiEmbeddingVectorProviders.get(A);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(v,y);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,v,y){const E=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(E,y),this._proxy.$registerAiEmbeddingVectorProvider(v,E),new F.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(E),this._AiEmbeddingVectorProviders.delete(E)})}}e.ExtHostAiEmbeddingVector=h}),define(De[309],Ie([1,0,2,6,3,7,14,169,15,22,27,79]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const u=this._schemes.indexOf(w);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),u=[];let r,o,c=14,g=14;for(const d of w){let t=r?(0,y.commonPrefixLength)(r,d):0;for(t===0?o=1:o=g;t<d.length;t++)t+1===d.length?(c=g,g=9):g+=1,u.push([o,d.toUpperCase().charCodeAt(t),g]),u.push([o,d.toLowerCase().charCodeAt(t),g]),o=g;r=d,g=c}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new v.StateMachine(u)}}provideDocumentLinks(w){this._initStateMachine();const u=[],r=v.LinkComputer.computeLinks({getLineContent(o){return w.lineAt(o-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const o of r){const c=A.DocumentLink.to(o);c.target&&u.push(c)}return u}}class S{constructor(w,u){this._extHostLanguageFeatures=u,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,u,r,o={}){if(S._validateFileSystemProvider(r),this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const c=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(c,r);let g=2;o.isCaseSensitive&&(g+=1024),o.isReadonly&&(g+=2048),typeof r.copy=="function"&&(g+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,T.checkProposedApiEnabled)(w,"fsChunks"),g+=4);let d;o.isReadonly&&(0,k.isMarkdownString)(o.isReadonly)&&((0,T.checkProposedApiEnabled)(w,"readonlyMessage"),d={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this._proxy.$registerFileSystemProvider(c,u,g,d).catch(n=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${u}`),console.error(n)});const t=r.onDidChangeFile(n=>{const s=[];for(const i of n){const{uri:a,type:l}=i;if(a.scheme!==u)continue;let C;switch(l){case R.FileChangeType.Changed:C=0;break;case R.FileChangeType.Created:C=1;break;case R.FileChangeType.Deleted:C=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:C})}this._proxy.$onFileSystemChange(c,s)});return(0,h.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(c),this._proxy.$unregisterProvider(c)})}static _validateFileSystemProvider(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(w){const{type:u,ctime:r,mtime:o,size:c,permissions:g}=w;return{type:u,ctime:r,mtime:o,size:c,permissions:g}}$stat(w,u){return Promise.resolve(this._getFsProvider(w).stat(I.URI.revive(u))).then(r=>S._asIStat(r))}$readdir(w,u){return Promise.resolve(this._getFsProvider(w).readDirectory(I.URI.revive(u)))}$readFile(w,u){return Promise.resolve(this._getFsProvider(w).readFile(I.URI.revive(u))).then(r=>E.VSBuffer.wrap(r))}$writeFile(w,u,r,o){return Promise.resolve(this._getFsProvider(w).writeFile(I.URI.revive(u),r.buffer,o))}$delete(w,u,r){return Promise.resolve(this._getFsProvider(w).delete(I.URI.revive(u),r))}$rename(w,u,r,o){return Promise.resolve(this._getFsProvider(w).rename(I.URI.revive(u),I.URI.revive(r),o))}$copy(w,u,r,o){const c=this._getFsProvider(w);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(I.URI.revive(u),I.URI.revive(r),o))}$mkdir(w,u){return Promise.resolve(this._getFsProvider(w).createDirectory(I.URI.revive(u)))}$watch(w,u,r,o){const c=this._getFsProvider(w).watch(I.URI.revive(r),o);this._watches.set(u,c)}$unwatch(w,u){const r=this._watches.get(u);r&&(r.dispose(),this._watches.delete(u))}$open(w,u,r){const o=this._getFsProvider(w);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(I.URI.revive(u),r))}$close(w,u){const r=this._getFsProvider(w);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(u))}$read(w,u,r,o){const c=this._getFsProvider(w);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const g=E.VSBuffer.alloc(o);return Promise.resolve(c.read(u,r,g.buffer,0,o)).then(d=>g.slice(0,d))}$write(w,u,r,o){const c=this._getFsProvider(w);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(u,r,o.buffer,0,o.byteLength))}_getFsProvider(w){const u=this._fsProvider.get(w);if(!u){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return u}}e.ExtHostFileSystem=S}),define(De[71],Ie([1,0,6,30,7,22,5,20,55,3,9,24,17]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let _=S=class{constructor(u,r){this._fileSystemProvider=new Map,this._writeQueue=new T.ResourceQueue,this._proxy=u.getProxy(I.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(c){try{let g;const d=o._fileSystemProvider.get(c.scheme);return d?(await o._proxy.$ensureActivation(c.scheme),g=await d.impl.stat(c)):g=await o._proxy.$stat(c),{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===F.FilePermission.Readonly?1:void 0}}catch(g){S._handleError(g)}},async readDirectory(c){try{const g=o._fileSystemProvider.get(c.scheme);return g?(await o._proxy.$ensureActivation(c.scheme),(await g.impl.readDirectory(c)).slice()):await o._proxy.$readdir(c)}catch(g){return S._handleError(g)}},async createDirectory(c){try{const g=o._fileSystemProvider.get(c.scheme);return g&&!g.isReadonly?(await o._proxy.$ensureActivation(c.scheme),await o.mkdirp(g.impl,g.extUri,c)):await o._proxy.$mkdir(c)}catch(g){return S._handleError(g)}},async readFile(c){try{const g=o._fileSystemProvider.get(c.scheme);return g?(await o._proxy.$ensureActivation(c.scheme),(await g.impl.readFile(c)).slice()):(await o._proxy.$readFile(c)).buffer}catch(g){return S._handleError(g)}},async writeFile(c,g){try{const d=o._fileSystemProvider.get(c.scheme);return d&&!d.isReadonly?(await o._proxy.$ensureActivation(c.scheme),await o.mkdirp(d.impl,d.extUri,d.extUri.dirname(c)),await o._writeQueue.queueFor(c).queue(()=>Promise.resolve(d.impl.writeFile(c,g,{create:!0,overwrite:!0})))):await o._proxy.$writeFile(c,R.VSBuffer.wrap(g))}catch(d){return S._handleError(d)}},async delete(c,g){try{const d=o._fileSystemProvider.get(c.scheme);return d&&!d.isReadonly?(await o._proxy.$ensureActivation(c.scheme),await d.impl.delete(c,{recursive:!1,...g})):await o._proxy.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...g})}catch(d){return S._handleError(d)}},async rename(c,g,d){try{return await o._proxy.$rename(c,g,{overwrite:!1,...d})}catch(t){return S._handleError(t)}},async copy(c,g,d){try{return await o._proxy.$copy(c,g,{overwrite:!1,...d})}catch(t){return S._handleError(t)}},isWritableFileSystem(c){const g=r.getCapabilities(c);if(typeof g=="number")return!(g&2048)}})}async mkdirp(u,r,o){const c=[];for(;!r.isEqual(o,r.dirname(o));)try{if(!((await u.stat(o)).type&F.FileType.Directory))throw h.FileSystemError.FileExists(`Unable to create folder '${o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}' that already exists but is not a directory`);break}catch(g){if(F.toFileSystemProviderErrorCode(g)!==F.FileSystemProviderErrorCode.FileNotFound)throw g;c.push(r.basename(o)),o=r.dirname(o)}for(let g=c.length-1;g>=0;g--){o=r.joinPath(o,c[g]);try{await u.createDirectory(o)}catch(d){if(F.toFileSystemProviderErrorCode(d)!==F.FileSystemProviderErrorCode.FileExists)throw d}}}static _handleError(u){if(u instanceof h.FileSystemError)throw u;if(u instanceof F.FileSystemProviderError)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw h.FileSystemError.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.FileSystemError.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.FileSystemError.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.FileSystemError.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.FileSystemError.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.FileSystemError.Unavailable(u.message);default:throw new h.FileSystemError(u.message,u.name)}if(!(u instanceof Error))throw new h.FileSystemError(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw h.FileSystemError.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw h.FileSystemError.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.FileSystemError.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.FileSystemError.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.FileSystemError.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.FileSystemError.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.FileSystemError.Unavailable(u.message);default:throw new h.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,r,o){return this._fileSystemProvider.set(u,{impl:r,extUri:o?.isCaseSensitive?k.extUri:k.extUriIgnorePathCase,isReadonly:!!o?.isReadonly}),(0,E.toDisposable)(()=>this._fileSystemProvider.delete(u))}getFileSystemProviderExtUri(u){return this._fileSystemProvider.get(u)?.extUri??k.extUri}};e.ExtHostConsumerFileSystem=_,e.ExtHostConsumerFileSystem=_=S=je([$e(0,v.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],_),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(De[310],Ie([1,0,4,35,2,6,14,7,51]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(S,_,w,u,r,o,c,g){this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter;const d=this.ensureWatching(S,w,r);this._config=0,o&&(this._config+=1),c&&(this._config+=2),g&&(this._config+=4);const t=(0,F.parse)(r),n=typeof r=="string",s=u(i=>{if(!o)for(const a of i.created){const l=h.URI.revive(a);t(l.fsPath)&&(!n||_.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!c)for(const a of i.changed){const l=h.URI.revive(a);t(l.fsPath)&&(!n||_.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!g)for(const a of i.deleted){const l=h.URI.revive(a);t(l.fsPath)&&(!n||_.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=v.Disposable.from(d,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}ensureWatching(S,_,w){const u=v.Disposable.from();if(typeof w=="string")return u;const r=S.getProxy(R.MainContext.MainThreadFileSystem);let o=!1;(w.pattern.includes(F.GLOBSTAR)||w.pattern.includes(F.GLOB_SPLIT))&&(o=!0);const c=Math.random();return r.$watch(_.identifier.value,c,w.baseUri,{recursive:o,excludes:[]}),v.Disposable.from({dispose:()=>r.$unwatch(c)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(S){this._events=S,this._created=new y.Lazy(()=>this._events.created.map(h.URI.revive)),this._changed=new y.Lazy(()=>this._events.changed.map(h.URI.revive)),this._deleted=new y.Lazy(()=>this._events.deleted.map(h.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class k{constructor(S,_,w){this._mainContext=S,this._logService=_,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,_,w,u,r,o){return new E(this._mainContext,S,_,this._onFileSystemEvent.event,A.GlobPattern.from(w),u,r,o)}$onFileEvent(S){this._onFileSystemEvent.fire(new T(S))}$onDidRunFileOperation(S,_){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(w=>({oldUri:h.URI.revive(w.source),newUri:h.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(w=>h.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(w=>h.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,_){return(w,u,r)=>{const o=function(g){w.call(u,g)};return o.extension=S,_.event(o,void 0,r)}}async $onWillRunFileOperation(S,_,w,u){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(r=>({oldUri:h.URI.revive(r.source),newUri:h.URI.revive(r.target)}))},w,u);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(r=>h.URI.revive(r.target))},w,u);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(r=>h.URI.revive(r.target))},w,u)}}async _fireWillEvent(S,_,w,u){const r=new Set,o=[];if(await S.fireAsync(_,u,async(g,d)=>{const t=Date.now(),n=await Promise.resolve(g);n instanceof v.WorkspaceEdit&&(o.push([d.extension,n]),r.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-t>w&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),u.isCancellationRequested||o.length===0)return;const c={edits:[]};for(const[,g]of o){const{edits:d}=A.WorkspaceEdit.from(g,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(d)}return{edit:c,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=k}),define(De[311],Ie([1,0,3,2,6,14,7,33,9]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class E{static{this._pool=0}constructor(S,_){this.extension=S,this.provider=_,this.handle=E._pool++}}class T{constructor(S){this.session=S,this.responses=[]}}class k{static{this._nextId=0}constructor(S,_,w,u){this._documents=w,this._logService=u,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=S.getProxy(h.MainContext.MainThreadInlineChat),_.registerApiCommand(new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?R.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?R.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?R.Position.from(r.position):void 0}})],v.ApiCommandResult.Void))}registerProvider(S,_,w){const u=new E(S,_);return this._inputProvider.set(u.handle,u),this._proxy.$registerInteractiveEditorProvider(u.handle,w.label,S.identifier.value,typeof _.handleInteractiveEditorResponseFeedback=="function"),(0,I.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(u.handle),this._inputProvider.delete(u.handle)})}async $prepareSession(S,_,w,u){const r=this._inputProvider.get(S);if(!r){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const o=this._documents.getDocument(F.URI.revive(_)),c=R.Selection.to(w),g=await r.provider.prepareInteractiveEditorSession({document:o,selection:c},u);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=k._nextId++;return this._inputSessions.set(d,new T(g)),{id:d,placeholder:g.placeholder,slashCommands:g.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(g.wholeRange),message:g.message}}async $provideResponse(S,_,w,u){const r=this._inputProvider.get(S);if(!r)return;const o=this._inputSessions.get(_.id);if(!o)return;const c={prompt:w.prompt,selection:R.Selection.to(w.selection),wholeRange:R.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let g=!1;const d={report:async l=>{if(!w.live)throw new Error("Progress reporting is only supported for live sessions");g||u.isCancellationRequested||await this._proxy.$handleProgressChunk(w.requestId,{message:l.message,edits:l.edits?.map(R.TextEdit.from),slashCommand:l.slashCommand?.command})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(o.session,c,d,u));let n;try{n=await(0,y.raceCancellation)(t,u)}finally{g=!0}if(!n)return;const s=o.responses.push(n)-1,i={wholeRange:R.Range.from(n.wholeRange),placeholder:n.placeholder};if(k._isMessageResponse(n))return{...i,id:s,type:"message",message:R.MarkdownString.from(n.contents)};const{edits:a}=n;return a instanceof A.WorkspaceEdit?{...i,id:s,type:"bulkEdit",edits:R.WorkspaceEdit.from(a)}:{...i,id:s,type:"editorEdit",edits:a.map(R.TextEdit.from)}}$handleFeedback(S,_,w,u){const r=this._inputProvider.get(S),o=this._inputSessions.get(_),c=o?.responses[w];if(r&&c){const g=R.InteractiveEditorResponseFeedbackKind.to(u);r.provider.handleInteractiveEditorResponseFeedback?.(o.session,c,g)}}$releaseSession(S,_){}static _isMessageResponse(S){return typeof S=="object"&&typeof S.contents=="object"}}e.ExtHostInteractiveEditor=k}),define(De[312],Ie([1,0,2,33]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class h{constructor(A,v,y,E,T){this._extHostNotebooks=v,this._textDocumentsAndEditors=y,this._commands=E;const k=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new F.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new F.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new F.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new F.ApiCommandResult("Notebook and input URI",b=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(b.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:I.URI.revive(b.notebookUri),inputUri:I.URI.revive(b.inputUri),notebookEditor:S.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:I.URI.revive(b.notebookUri),inputUri:I.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(A,v,y,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:y,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(I.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,v){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=h}),define(De[313],Ie([1,0,6,7]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class h{constructor(A){this._IssueUriRequestHandlers=new Map,this._proxy=A.getProxy(I.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,v){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(A);if(!y)throw new Error("Issue request handler not found");const E=await y.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}registerIssueUriRequestHandler(A,v){const y=A.identifier.value;return this._IssueUriRequestHandlers.set(y,v),this._proxy.$registerIssueUriRequestHandler(y),new F.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=h}),define(De[314],Ie([1,0,3,6]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class h{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const v=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(v,A),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(v)})}}e.ExtHostLabelService=h}),define(De[315],Ie([1,0,2,23,14,7,82,6,15,34,19,18,165,21,25,3,129,119,107,37,8,9,27,205]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const te=this._documents.getDocument($),se=await this._provider.provideDocumentSymbols(te,K);if(!(0,T.isFalsyOrEmpty)(se))return se[0]instanceof R.DocumentSymbol?se.map(h.DocumentSymbol.from):s._asDocumentSymbolTree(se)}static _asDocumentSymbolTree($){$=$.slice(0).sort((se,Y)=>{let he=se.location.range.start.compareTo(Y.location.range.start);return he===0&&(he=Y.location.range.end.compareTo(se.location.range.end)),he});const K=[],te=[];for(const se of $){const Y={name:se.name||"!!MISSING: name!!",kind:h.SymbolKind.from(se.kind),tags:se.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:h.Range.from(se.location.range),selectionRange:h.Range.from(se.location.range),children:[]};for(;;){if(te.length===0){te.push(Y),K.push(Y);break}const he=te[te.length-1];if(E.Range.containsRange(he.range,Y.range)&&!E.Range.equalsRange(he.range,Y.range)){he.children?.push(Y),te.push(Y);break}te.pop()}}return K}}class i{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor($,K,te){this._documents=$,this._commands=K,this._provider=te,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const te=this._documents.getDocument($),se=await this._provider.provideCodeLenses(te,K);if(!se||K.isCancellationRequested)return;const Y=this._cache.add(se),he=new w.DisposableStore;this._disposables.set(Y,he);const Se={cacheId:Y,lenses:[]};for(let Ue=0;Ue<se.length;Ue++)Se.lenses.push({cacheId:[Y,Ue],range:h.Range.from(se[Ue].range),command:this._commands.toInternal(se[Ue].command,he)});return Se}async resolveCodeLens($,K){const te=$.cacheId&&this._cache.get(...$.cacheId);if(!te)return;let se;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?se=te:se=await this._provider.resolveCodeLens(te,K),se||(se=te),K.isCancellationRequested)return;const Y=$.cacheId&&this._disposables.get($.cacheId[0]);if(Y)return $.command=this._commands.toInternal(se.command??i._badCmd,Y),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}function a(Pe){return Array.isArray(Pe)?Pe.map(h.DefinitionLink.from):Pe?[h.DefinitionLink.from(Pe)]:[]}class l{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideDefinition(se,Y,te);return a(he)}}class C{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideDeclaration(se,Y,te);return a(he)}}class D{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideImplementation(se,Y,te);return a(he)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideTypeDefinition(se,Y,te);return a(he)}}class m{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideHover(se,Y,te);if(!(!he||(0,T.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=se.getWordRangeAtPosition(Y)),he.range||(he.range=new R.Range(Y,Y)),h.Hover.from(he)}}class f{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideEvaluatableExpression(se,Y,te);if(he)return h.EvaluatableExpression.from(he)}}class P{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,te,se){const Y=this._documents.getDocument($),he=await this._provider.provideInlineValues(Y,h.Range.to(K),h.InlineValueContext.to(te),se);if(Array.isArray(he))return he.map(Se=>h.InlineValue.from(Se))}}class M{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideDocumentHighlights(se,Y,te);if(Array.isArray(he))return he.map(h.DocumentHighlight.from)}}class N{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.provideLinkedEditingRanges(se,Y,te);if(he&&Array.isArray(he.ranges))return{ranges:(0,T.coalesce)(he.ranges.map(h.Range.from)),wordPattern:he.wordPattern}}}class L{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,te,se){const Y=this._documents.getDocument($),he=h.Position.to(K),Se=await this._provider.provideReferences(Y,he,te,se);if(Array.isArray(Se))return Se.map(h.location.from)}}class U{static{this._maxCodeActionsPerFile=1e3}constructor($,K,te,se,Y,he,Se){this._documents=$,this._commands=K,this._diagnostics=te,this._provider=se,this._logService=Y,this._extension=he,this._apiDeprecation=Se,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,te,se){const Y=this._documents.getDocument($),he=b.Selection.isISelection(K)?h.Selection.to(K):h.Range.to(K),Se=[];for(const et of this._diagnostics.getDiagnostics($))if(he.intersection(et.range)&&Se.push(et)>U._maxCodeActionsPerFile)break;const Ue={diagnostics:Se,only:te.only?new R.CodeActionKind(te.only):void 0,triggerKind:h.CodeActionTriggerKind.to(te.trigger)},We=await this._provider.provideCodeActions(Y,he,Ue,se);if(!(0,T.isNonEmptyArray)(We)||se.isCancellationRequested)return;const Ze=this._cache.add(We),Qe=new w.DisposableStore;this._disposables.set(Ze,Qe);const it=[];for(let et=0;et<We.length;et++){const Te=We[et];Te&&(U._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Qe)})):(Ue.only&&(Te.kind?Ue.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ze,et],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Qe),diagnostics:Te.diagnostics&&Te.diagnostics.map(h.Diagnostic.from),edit:Te.edit&&h.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?Te.isAI:!1,disabled:Te.disabled?.reason})))}return{cacheId:Ze,actions:it}}async resolveCodeAction($,K){const[te,se]=$,Y=this._cache.get(te,se);if(!Y||U._isCommand(Y))return{};if(!this._provider.resolveCodeAction)return{};const he=await this._provider.resolveCodeAction(Y,K)??Y;let Se;he.edit&&(Se=h.WorkspaceEdit.from(he.edit,void 0));let Ue;if(he.command){const We=this._disposables.get(te);We&&(Ue=this._commands.toInternal(he.command,We))}return{edit:Se,command:Ue}}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}class x{static toInternalProviderId($,K){return $+"."+K}constructor($,K,te,se,Y){this._proxy=$,this._documents=K,this._provider=te,this._handle=se,this._extension=Y}async prepareDocumentPaste($,K,te,se){if(!this._provider.prepareDocumentPaste)return;const Y=this._documents.getDocument($),he=K.map(We=>h.Range.to(We)),Se=h.DataTransfer.toDataTransfer(te,()=>{throw new g.NotImplementedError});if(await this._provider.prepareDocumentPaste(Y,he,Se,se),se.isCancellationRequested)return;const Ue=Array.from(Se).filter(([,We])=>!(We instanceof R.InternalDataTransferItem));return h.DataTransfer.from(Ue)}async providePasteEdits($,K,te,se,Y){if(!this._provider.provideDocumentPasteEdits)return;const he=this._documents.getDocument(K),Se=te.map(Ze=>h.Range.to(Ze)),Ue=h.DataTransfer.toDataTransfer(se,async Ze=>(await this._proxy.$resolvePasteFileData(this._handle,$,Ze)).buffer),We=await this._provider.provideDocumentPasteEdits(he,Se,Ue,Y);if(We)return{label:We.label??(0,n.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:x.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?h.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,te){const se=this._documents.getDocument($),Y=await this._provider.provideDocumentFormattingEdits(se,K,te);if(Array.isArray(Y))return Y.map(h.TextEdit.from)}}class j{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,te,se){const Y=this._documents.getDocument($),he=h.Range.to(K),Se=await this._provider.provideDocumentRangeFormattingEdits(Y,he,te,se);if(Array.isArray(Se))return Se.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits($,K,te,se){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this._documents.getDocument($),he=K.map(h.Range.to),Se=await this._provider.provideDocumentRangesFormattingEdits(Y,he,te,se);if(Array.isArray(Se))return Se.map(h.TextEdit.from)}}class V{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,te,se,Y){const he=this._documents.getDocument($),Se=h.Position.to(K),Ue=await this._provider.provideOnTypeFormattingEdits(he,Se,te,se,Y);if(Array.isArray(Ue))return Ue.map(h.TextEdit.from)}}class fe{constructor($,K){this._provider=$,this._logService=K,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols($,K){const te=await this._provider.provideWorkspaceSymbols($,K);if(!(0,T.isNonEmptyArray)(te))return{symbols:[]};const se=this._cache.add(te),Y={cacheId:se,symbols:[]};for(let he=0;he<te.length;he++){const Se=te[he];if(!Se||!Se.name){this._logService.warn("INVALID SymbolInformation",Se);continue}Y.symbols.push({...h.WorkspaceSymbol.from(Se),cacheId:[se,he]})}return Y}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!$.cacheId)return $;const te=this._cache.get(...$.cacheId);if(te){const se=await this._provider.resolveWorkspaceSymbol(te,K);return se&&(0,F.mixin)($,h.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){this._cache.delete($)}}class J{static supportsResolving($){return typeof $.prepareRename=="function"}constructor($,K,te){this._documents=$,this._provider=K,this._logService=te}async provideRenameEdits($,K,te,se){const Y=this._documents.getDocument($),he=h.Position.to(K);try{const Se=await this._provider.provideRenameEdits(Y,he,te,se);return Se?h.WorkspaceEdit.from(Se):void 0}catch(Se){const Ue=J._asMessage(Se);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation($,K,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),Y=h.Position.to(K);try{const he=await this._provider.prepareRename(se,Y,te);let Se,Ue;if(R.Range.isRange(he)?(Se=he,Ue=se.getText(he)):(0,k.isObject)(he)&&(Se=he.range,Ue=he.placeholder),!Se||!Ue)return;if(Se.start.line>Y.line||Se.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(Se),text:Ue}}catch(he){const Se=J._asMessage(he);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(he)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class X{constructor($,K){this.resultId=$,this.tokens=K}}class z{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,te){const se=this._documents.getDocument($),Y=K!==0?this._previousResults.get(K):null;let he=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,Y.resultId,te):await this._provider.provideDocumentSemanticTokens(se,te);return Y&&this._previousResults.delete(K),he?(he=z._fixProvidedSemanticTokens(he),this._send(z._convertToEdits(Y,he),he)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new R.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new R.SemanticTokensEdits($.edits.map(K=>new R.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!z._isSemanticTokens(K)||!$||!$.tokens)return K;const te=$.tokens,se=te.length,Y=K.data,he=Y.length;let Se=0;const Ue=Math.min(se,he);for(;Se<Ue&&te[Se]===Y[Se];)Se++;if(Se===se&&Se===he)return new R.SemanticTokensEdits([],K.resultId);let We=0;const Ze=Ue-Se;for(;We<Ze&&te[se-We-1]===Y[he-We-1];)We++;return new R.SemanticTokensEdits([{start:Se,deleteCount:se-Se-We,data:Y.subarray(Se,he-We)}],K.resultId)}_send($,K){if(z._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new X($.resultId,$.data)),(0,u.encodeSemanticTokensDto)({id:te,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const te=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(te,new X(K.resultId,K.data)):this._previousResults.set(te,new X($.resultId)),(0,u.encodeSemanticTokensDto)({id:te,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class Q{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,te){const se=this._documents.getDocument($),Y=await this._provider.provideDocumentRangeSemanticTokens(se,h.Range.to(K),te);return Y?this._send(Y):null}_send($){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}class ve{static supportsResolving($){return typeof $.resolveCompletionItem=="function"}constructor($,K,te,se,Y){this._documents=$,this._commands=K,this._provider=te,this._apiDeprecation=se,this._extension=Y,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems($,K,te,se){const Y=this._documents.getDocument($),he=h.Position.to(K),Se=Y.getWordRangeAtPosition(he)||new R.Range(he,he),Ue=Se.with({end:he}),We=new c.StopWatch,Ze=await this._provider.provideCompletionItems(Y,he,se,h.CompletionContext.to(te));if(!Ze||se.isCancellationRequested)return;const Qe=Array.isArray(Ze)?new R.CompletionList(Ze):Ze,it=ve.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),et=new w.DisposableStore;this._disposables.set(it,et);const Te=[],Me={x:it,b:Te,a:{replace:h.Range.from(Se),insert:h.Range.from(Ue)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let ze=0;ze<Qe.items.length;ze++){const Re=Qe.items[ze],Xe=this._convertCompletionItem(Re,[it,ze],Ue,Se);Te.push(Xe)}return Me}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...$);if(!te)return;const se=this._convertCompletionItem(te,$),Y=await this._provider.resolveCompletionItem(te,K);if(!Y)return;const he=this._convertCompletionItem(Y,$);return(se.h!==he.h||se.i!==he.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==he.n||se.o!==he.o||!(0,F.equals)(se.p,he.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,te,se){const Y=this._disposables.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const he=this._commands.toInternal($.command,Y),Se={x:K,a:$.label,b:$.kind!==void 0?h.CompletionItemKind.from($.kind):void 0,m:$.tags&&$.tags.map(h.CompletionItemTag.from),c:$.detail,d:typeof $.documentation>"u"?void 0:h.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters?.join(""),l:$.additionalTextEdits&&$.additionalTextEdits.map(h.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=$.textEdit.newText):typeof $.insertText=="string"?Se.h=$.insertText:$.insertText instanceof R.SnippetString&&(Se.h=$.insertText.value,Se.i|=4);let Ue;return $.textEdit?Ue=$.textEdit.range:$.range&&(Ue=$.range),R.Range.isRange(Ue)?Se.j=h.Range.from(Ue):Ue&&(!te?.isEqual(Ue.inserting)||!se?.isEqual(Ue.replacing))&&(Se.j={insert:h.Range.from(Ue.inserting),replace:h.Range.from(Ue.replacing)}),Se}}class le{async provideInlineCompletions($,K,te,se){}disposeCompletions($){}handleDidShowCompletionItem($,K,te){}handlePartialAccept($,K,te){}}class we extends le{constructor($,K,te,se){super(),this._extension=$,this._documents=K,this._provider=te,this._commands=se,this._references=new G,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions($,K,te,se){const Y=this._documents.getDocument($),he=h.Position.to(K),Se=await this._provider.provideInlineCompletionItems(Y,he,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:h.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[te.triggerKind]},se);if(!Se||se.isCancellationRequested)return;const Ue=Array.isArray(Se)?Se:Se.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(Se)?[]:Se.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(Se)?Se.enableForwardStability:void 0;let Qe;return{pid:this._references.createReferenceId({dispose(){Qe?.dispose()},items:Ue}),items:Ue.map((et,Te)=>{let Me;et.command&&(Qe||(Qe=new w.DisposableStore),Me=this._commands.toInternal(et.command,Qe));const ze=et.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:et.filterText,range:et.range?h.Range.from(et.range):void 0,command:Me,idx:Te,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:We.map(et=>(Qe||(Qe=new w.DisposableStore),this._commands.toInternal(et,Qe))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions($){this._references.disposeReferenceId($)?.dispose()}handleDidShowCompletionItem($,K,te){const se=this._references.get($)?.items[K];se&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(se,te)}handlePartialAccept($,K,te){const se=this._references.get($)?.items[K];se&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(se,te)}}class G{constructor(){this._references=new Map,this._idPool=1}createReferenceId($){const K=this._idPool++;return this._references.set(K,$),K}disposeReferenceId($){const K=this._references.get($);return this._references.delete($),K}get($){return this._references.get($)}}class B{constructor($,K){this._documents=$,this._provider=K,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp($,K,te,se){const Y=this._documents.getDocument($),he=h.Position.to(K),Se=this.reviveContext(te),Ue=await this._provider.provideSignatureHelp(Y,he,se,Se);if(Ue){const We=this._cache.add([Ue]);return{...h.SignatureHelp.from(Ue),id:We}}}reviveContext($){let K;if($.activeSignatureHelp){const te=h.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=te.activeSignature,K.activeParameter=te.activeParameter):K=te}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class H{constructor($,K,te,se,Y){this._documents=$,this._commands=K,this._provider=te,this._logService=se,this._extension=Y,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints($,K,te){const se=this._documents.getDocument($),Y=h.Range.to(K),he=await this._provider.provideInlayHints(se,Y,te);if(!Array.isArray(he)||he.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(te.isCancellationRequested)return;const Se=this._cache.add(he);this._disposables.set(Se,new w.DisposableStore);const Ue={hints:[],cacheId:Se};for(let We=0;We<he.length;We++)this._isValidInlayHint(he[We],Y)&&Ue.hints.push(this._convertInlayHint(he[We],[Se,We]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),Ue}async resolveInlayHint($,K){if(typeof this._provider.resolveInlayHint!="function")return;const te=this._cache.get(...$);if(!te)return;const se=await this._provider.resolveInlayHint(te,K);if(se&&this._isValidInlayHint(se))return this._convertInlayHint(se,$)}releaseHints($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_isValidInlayHint($,K){return $.label.length===0||Array.isArray($.label)&&$.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",$),!1):!(K&&!K.contains($.position))}_convertInlayHint($,K){const te=this._disposables.get(K[0]);if(!te)throw Error("DisposableStore is missing...");const se={label:"",cacheId:K,tooltip:h.MarkdownString.fromStrict($.tooltip),position:h.Position.from($.position),textEdits:$.textEdits&&$.textEdits.map(h.TextEdit.from),kind:$.kind&&h.InlayHintKind.from($.kind),paddingLeft:$.paddingLeft,paddingRight:$.paddingRight};return typeof $.label=="string"?se.label=$.label:se.label=$.label.map(Y=>{const he={label:Y.value};return he.tooltip=h.MarkdownString.fromStrict(Y.tooltip),R.Location.isLocation(Y.location)&&(he.location=h.location.from(Y.location)),Y.command&&(he.command=this._commands.toInternal(Y.command,te)),he}),se}}class me{constructor($,K){this._documents=$,this._provider=K,this._cache=new o.Cache("DocumentLink")}async provideLinks($,K){const te=this._documents.getDocument($),se=await this._provider.provideDocumentLinks(te,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(me._validateLink).map(h.DocumentLink.from)};{const Y=this._cache.add(se),he={links:[],cacheId:Y};for(let Se=0;Se<se.length;Se++){if(!me._validateLink(se[Se]))continue;const Ue=h.DocumentLink.from(se[Se]);Ue.cacheId=[Y,Se],he.links.push(Ue)}return he}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...$);if(!te)return;const se=await this._provider.resolveDocumentLink(te,K);if(!(!se||!me._validateLink(se)))return h.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class Z{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const te=this._documents.getDocument($),se=await this._provider.provideDocumentColors(te,K);return Array.isArray(se)?se.map(he=>({color:h.Color.from(he.color),range:h.Range.from(he.range)})):[]}async provideColorPresentations($,K,te){const se=this._documents.getDocument($),Y=h.Range.to(K.range),he=h.Color.to(K.color),Se=await this._provider.provideColorPresentations(he,{document:se,range:Y},te);if(Array.isArray(Se))return Se.map(h.ColorPresentation.from)}}class ie{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,te){const se=this._documents.getDocument($),Y=await this._provider.provideFoldingRanges(se,K,te);if(Array.isArray(Y))return Y.map(h.FoldingRange.from)}}class re{constructor($,K,te){this._documents=$,this._provider=K,this._logService=te}async provideSelectionRanges($,K,te){const se=this._documents.getDocument($),Y=K.map(h.Position.to),he=await this._provider.provideSelectionRanges(se,Y,te);if(!(0,T.isNonEmptyArray)(he))return[];if(he.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Ue=0;Ue<Y.length;Ue++){const We=[];Se.push(We);let Ze=Y[Ue],Qe=he[Ue];for(;;){if(!Qe.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(h.SelectionRange.from(Qe)),!Qe.parent)break;Ze=Qe.range,Qe=Qe.parent}}return Se}}class ye{constructor($,K){this._documents=$,this._provider=K,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.prepareCallHierarchy(se,Y,te);if(!he)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(he)?he.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,he)]}async provideCallsTo($,K,te){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(se,te);if(Y)return Y.map(he=>({from:this._cacheAndConvertItem($,he.from),fromRanges:he.fromRanges.map(Se=>h.Range.from(Se))}))}async provideCallsFrom($,K,te){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(se,te);if(Y)return Y.map(he=>({to:this._cacheAndConvertItem($,he.to),fromRanges:he.fromRanges.map(Se=>h.Range.from(Se))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const te=this._cache.get($),se=h.CallHierarchyItem.from(K,$,te.size.toString(36));return te.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class oe{constructor($,K){this._documents=$,this._provider=K,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession($,K,te){const se=this._documents.getDocument($),Y=h.Position.to(K),he=await this._provider.prepareTypeHierarchy(se,Y,te);if(!he)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(he)?he.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,he)]}async provideSupertypes($,K,te){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(se,te);if(Y)return Y.map(he=>this._cacheAndConvertItem($,he))}async provideSubtypes($,K,te){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(se,te);if(Y)return Y.map(he=>this._cacheAndConvertItem($,he))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const te=this._cache.get($),se=h.TypeHierarchyItem.from(K,$,te.size.toString(36));return te.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class de{static toInternalProviderId($,K){return $+"."+K}constructor($,K,te,se,Y){this._proxy=$,this._documents=K,this._provider=te,this._handle=se,this._extension=Y}async provideDocumentOnDropEdits($,K,te,se,Y){const he=this._documents.getDocument(K),Se=h.Position.to(te),Ue=h.DataTransfer.toDataTransfer(se,async Ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,$,Ze)).buffer),We=await this._provider.provideDocumentDropEdits(he,Se,Ue,Y);if(We)return{label:We.label??(0,n.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?h.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor($,K){this._documents=$,this._provider=K}async provideMappedEdits($,K,te,se){const Y=I.URI.revive($),he=this._documents.getDocument(Y),Se=te.documents.map(Ze=>Ze.map(Qe=>({uri:I.URI.revive(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(it=>h.Range.to(it))}))),Ue={documents:Se,selections:Se[0]?.[0]?.ranges??[]},We=await this._provider.provideMappedEdits(he,K,Ue,se);return We?h.WorkspaceEdit.from(We):null}}class ue{constructor($,K){this.adapter=$,this.extension=K}}class pe{static{this._handlePool=0}constructor($,K,te,se,Y,he,Se,Ue){this._uriTransformer=K,this._documents=te,this._commands=se,this._diagnostics=Y,this._logService=he,this._apiDeprecation=Se,this._extensionTelemetry=Ue,this._adapter=new Map,this._proxy=$.getProxy(v.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector($,K){return h.DocumentSelector.from($,this._uriTransformer,K)}_createDisposable($){return new R.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return pe._handlePool++}async _withAdapter($,K,te,se,Y,he=!1){const Se=this._adapter.get($);if(!Se||!(Se.adapter instanceof K))return se;const Ue=Date.now();he||this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const We=te(Se.adapter,Se.extension);return Promise.resolve(We).catch(Ze=>{(0,g.isCancellationError)(Ze)||(this._logService.error(`[${Se.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(Se.extension.identifier,Ze))}).finally(()=>{he||this._logService.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),S.CancellationToken.isCancellationToken(Y)?(0,d.raceCancellationError)(We,Y):We}_addNewAdapter($,K){const te=this._nextHandle();return this._adapter.set(te,new ue($,K)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,te,se){const Y=this._addNewAdapter(new s(this._documents,te),$),he=se&&se.label||pe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(K,$),he),this._createDisposable(Y)}$provideDocumentSymbols($,K,te){return this._withAdapter($,s,se=>se.provideDocumentSymbols(I.URI.revive(K),te),void 0,te)}registerCodeLensProvider($,K,te){const se=this._nextHandle(),Y=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new ue(new i(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K,$),Y);let he=this._createDisposable(se);if(Y!==void 0){const Se=te.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(Y));he=R.Disposable.from(he,Se)}return he}$provideCodeLenses($,K,te){return this._withAdapter($,i,se=>se.provideCodeLenses(I.URI.revive(K),te),void 0,te)}$resolveCodeLens($,K,te){return this._withAdapter($,i,se=>se.resolveCodeLens(K,te),void 0,void 0)}$releaseCodeLenses($,K){this._withAdapter($,i,te=>Promise.resolve(te.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider($,K,te){const se=this._addNewAdapter(new l(this._documents,te),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDefinition($,K,te,se){return this._withAdapter($,l,Y=>Y.provideDefinition(I.URI.revive(K),te,se),[],se)}registerDeclarationProvider($,K,te){const se=this._addNewAdapter(new C(this._documents,te),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDeclaration($,K,te,se){return this._withAdapter($,C,Y=>Y.provideDeclaration(I.URI.revive(K),te,se),[],se)}registerImplementationProvider($,K,te){const se=this._addNewAdapter(new D(this._documents,te),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideImplementation($,K,te,se){return this._withAdapter($,D,Y=>Y.provideImplementation(I.URI.revive(K),te,se),[],se)}registerTypeDefinitionProvider($,K,te){const se=this._addNewAdapter(new p(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideTypeDefinition($,K,te,se){return this._withAdapter($,p,Y=>Y.provideTypeDefinition(I.URI.revive(K),te,se),[],se)}registerHoverProvider($,K,te,se){const Y=this._addNewAdapter(new m(this._documents,te),$);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(K,$)),this._createDisposable(Y)}$provideHover($,K,te,se){return this._withAdapter($,m,Y=>Y.provideHover(I.URI.revive(K),te,se),void 0,se)}registerEvaluatableExpressionProvider($,K,te,se){const Y=this._addNewAdapter(new f(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(K,$)),this._createDisposable(Y)}$provideEvaluatableExpression($,K,te,se){return this._withAdapter($,f,Y=>Y.provideEvaluatableExpression(I.URI.revive(K),te,se),void 0,se)}registerInlineValuesProvider($,K,te,se){const Y=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new P(this._documents,te),$);this._proxy.$registerInlineValuesProvider(he,this._transformDocumentSelector(K,$),Y);let Se=this._createDisposable(he);if(Y!==void 0){const Ue=te.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Y));Se=R.Disposable.from(Se,Ue)}return Se}$provideInlineValues($,K,te,se,Y){return this._withAdapter($,P,he=>he.provideInlineValues(I.URI.revive(K),te,se,Y),void 0,Y)}registerDocumentHighlightProvider($,K,te){const se=this._addNewAdapter(new M(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDocumentHighlights($,K,te,se){return this._withAdapter($,M,Y=>Y.provideDocumentHighlights(I.URI.revive(K),te,se),void 0,se)}registerLinkedEditingRangeProvider($,K,te){const se=this._addNewAdapter(new N(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideLinkedEditingRanges($,K,te,se){return this._withAdapter($,N,async Y=>{const he=await Y.provideLinkedEditingRanges(I.URI.revive(K),te,se);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?pe._serializeRegExp(he.wordPattern):void 0}},void 0,se)}registerReferenceProvider($,K,te){const se=this._addNewAdapter(new L(this._documents,te),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideReferences($,K,te,se,Y){return this._withAdapter($,L,he=>he.provideReferences(I.URI.revive(K),te,se,Y),void 0,Y)}registerCodeActionProvider($,K,te,se){const Y=new w.DisposableStore,he=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(he,this._transformDocumentSelector(K,$),{providedKinds:se?.providedCodeActionKinds?.map(Se=>Se.value),documentation:se?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,Y)}))},pe._extLabel($),!!te.resolveCodeAction),Y.add(this._createDisposable(he)),Y}$provideCodeActions($,K,te,se,Y){return this._withAdapter($,U,he=>he.provideCodeActions(I.URI.revive(K),te,se,Y),void 0,Y)}$resolveCodeAction($,K,te){return this._withAdapter($,U,se=>se.resolveCodeAction(K,te),{},void 0)}$releaseCodeActions($,K){this._withAdapter($,U,te=>Promise.resolve(te.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider($,K,te){const se=this._addNewAdapter(new O(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K,$),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,K,te,se){return this._withAdapter($,O,Y=>Y.provideDocumentFormattingEdits(I.URI.revive(K),te,se),void 0,se)}registerDocumentRangeFormattingEditProvider($,K,te){const se=typeof te.provideDocumentRangesFormattingEdits=="function",Y=this._addNewAdapter(new j(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(Y,this._transformDocumentSelector(K,$),$.identifier,$.displayName||$.name,se),this._createDisposable(Y)}$provideDocumentRangeFormattingEdits($,K,te,se,Y){return this._withAdapter($,j,he=>he.provideDocumentRangeFormattingEdits(I.URI.revive(K),te,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits($,K,te,se,Y){return this._withAdapter($,j,he=>he.provideDocumentRangesFormattingEdits(I.URI.revive(K),te,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider($,K,te,se){const Y=this._addNewAdapter(new V(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(K,$),se,$.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits($,K,te,se,Y,he){return this._withAdapter($,V,Se=>Se.provideOnTypeFormattingEdits(I.URI.revive(K),te,se,Y,he),void 0,he)}registerWorkspaceSymbolProvider($,K){const te=this._addNewAdapter(new fe(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(te)}$provideWorkspaceSymbols($,K,te){return this._withAdapter($,fe,se=>se.provideWorkspaceSymbols(K,te),{symbols:[]},te)}$resolveWorkspaceSymbol($,K,te){return this._withAdapter($,fe,se=>se.resolveWorkspaceSymbol(K,te),void 0,void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,fe,te=>te.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider($,K,te){const se=this._addNewAdapter(new J(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K,$),J.supportsResolving(te)),this._createDisposable(se)}$provideRenameEdits($,K,te,se,Y){return this._withAdapter($,J,he=>he.provideRenameEdits(I.URI.revive(K),te,se,Y),void 0,Y)}$resolveRenameLocation($,K,te,se){return this._withAdapter($,J,Y=>Y.resolveRenameLocation(I.URI.revive(K),te,se),void 0,se)}registerDocumentSemanticTokensProvider($,K,te,se){const Y=this._addNewAdapter(new z(this._documents,te),$),he=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(K,$),se,he);let Se=this._createDisposable(Y);if(he){const Ue=te.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(he));Se=R.Disposable.from(Se,Ue)}return Se}$provideDocumentSemanticTokens($,K,te,se){return this._withAdapter($,z,Y=>Y.provideDocumentSemanticTokens(I.URI.revive(K),te,se),null,se)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,z,te=>te.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider($,K,te,se){const Y=this._addNewAdapter(new Q(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(K,$),se),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens($,K,te,se){return this._withAdapter($,Q,Y=>Y.provideDocumentRangeSemanticTokens(I.URI.revive(K),te,se),null,se)}registerCompletionItemProvider($,K,te,se){const Y=this._addNewAdapter(new ve(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerCompletionsProvider(Y,this._transformDocumentSelector(K,$),se,ve.supportsResolving(te),$.identifier),this._createDisposable(Y)}$provideCompletionItems($,K,te,se,Y){return this._withAdapter($,ve,he=>he.provideCompletionItems(I.URI.revive(K),te,se,Y),void 0,Y)}$resolveCompletionItem($,K,te){return this._withAdapter($,ve,se=>se.resolveCompletionItem(K,te),void 0,te)}$releaseCompletionItems($,K){this._withAdapter($,ve,te=>te.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider($,K,te,se){const Y=new we($,this._documents,te,this._commands.converter),he=this._addNewAdapter(Y,$);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(K,$),Y.supportsHandleEvents,_.ExtensionIdentifier.toKey($.identifier.value),se?.yieldTo?.map(Se=>_.ExtensionIdentifier.toKey(Se))||[]),this._createDisposable(he)}$provideInlineCompletions($,K,te,se,Y){return this._withAdapter($,le,he=>he.provideInlineCompletions(I.URI.revive(K),te,se,Y),void 0,Y)}$handleInlineCompletionDidShow($,K,te,se){this._withAdapter($,le,async Y=>{Y.handleDidShowCompletionItem(K,te,se)},void 0,void 0)}$handleInlineCompletionPartialAccept($,K,te,se){this._withAdapter($,le,async Y=>{Y.handlePartialAccept(K,te,se)},void 0,void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,le,async te=>{te.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider($,K,te,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,he=this._addNewAdapter(new B(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(he,this._transformDocumentSelector(K,$),Y),this._createDisposable(he)}$provideSignatureHelp($,K,te,se,Y){return this._withAdapter($,B,he=>he.provideSignatureHelp(I.URI.revive(K),te,se,Y),void 0,Y)}$releaseSignatureHelp($,K){this._withAdapter($,B,te=>te.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider($,K,te){const se=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new H(this._documents,this._commands.converter,te,this._logService,$),$);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(K,$),typeof te.resolveInlayHint=="function",se,pe._extLabel($));let he=this._createDisposable(Y);if(se!==void 0){const Se=te.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(se));he=R.Disposable.from(he,Se)}return he}$provideInlayHints($,K,te,se){return this._withAdapter($,H,Y=>Y.provideInlayHints(I.URI.revive(K),te,se),void 0,se)}$resolveInlayHint($,K,te){return this._withAdapter($,H,se=>se.resolveInlayHint(K,te),void 0,te)}$releaseInlayHints($,K){this._withAdapter($,H,te=>te.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider($,K,te){const se=this._addNewAdapter(new me(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K,$),typeof te.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,K,te){return this._withAdapter($,me,se=>se.provideLinks(I.URI.revive(K),te),void 0,te,K.scheme==="output")}$resolveDocumentLink($,K,te){return this._withAdapter($,me,se=>se.resolveLink(K,te),void 0,void 0,!0)}$releaseDocumentLinks($,K){this._withAdapter($,me,te=>te.releaseLinks(K),void 0,void 0,!0)}registerColorProvider($,K,te){const se=this._addNewAdapter(new Z(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDocumentColors($,K,te){return this._withAdapter($,Z,se=>se.provideColors(I.URI.revive(K),te),[],te)}$provideColorPresentations($,K,te,se){return this._withAdapter($,Z,Y=>Y.provideColorPresentations(I.URI.revive(K),te,se),void 0,se)}registerFoldingRangeProvider($,K,te){const se=this._nextHandle(),Y=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new ue(new ie(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K,$),$.identifier,Y);let he=this._createDisposable(se);if(Y!==void 0){const Se=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));he=R.Disposable.from(he,Se)}return he}$provideFoldingRanges($,K,te,se){return this._withAdapter($,ie,Y=>Y.provideFoldingRanges(I.URI.revive(K),te,se),void 0,se)}registerSelectionRangeProvider($,K,te){const se=this._addNewAdapter(new re(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideSelectionRanges($,K,te,se){return this._withAdapter($,re,Y=>Y.provideSelectionRanges(I.URI.revive(K),te,se),[],se)}registerCallHierarchyProvider($,K,te){const se=this._addNewAdapter(new ye(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$prepareCallHierarchy($,K,te,se){return this._withAdapter($,ye,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(K),te,se)),void 0,se)}$provideCallHierarchyIncomingCalls($,K,te,se){return this._withAdapter($,ye,Y=>Y.provideCallsTo(K,te,se),void 0,se)}$provideCallHierarchyOutgoingCalls($,K,te,se){return this._withAdapter($,ye,Y=>Y.provideCallsFrom(K,te,se),void 0,se)}$releaseCallHierarchy($,K){this._withAdapter($,ye,te=>Promise.resolve(te.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider($,K,te){const se=this._addNewAdapter(new oe(this._documents,te),$);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$prepareTypeHierarchy($,K,te,se){return this._withAdapter($,oe,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(K),te,se)),void 0,se)}$provideTypeHierarchySupertypes($,K,te,se){return this._withAdapter($,oe,Y=>Y.provideSupertypes(K,te,se),void 0,se)}$provideTypeHierarchySubtypes($,K,te,se){return this._withAdapter($,oe,Y=>Y.provideSubtypes(K,te,se),void 0,se)}$releaseTypeHierarchy($,K){this._withAdapter($,oe,te=>Promise.resolve(te.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider($,K,te,se){const Y=this._nextHandle();this._adapter.set(Y,new ue(new de(this._proxy,this._documents,te,Y,$),$));const he=(0,t.isProposedApiEnabled)($,"dropMetadata")&&se?de.toInternalProviderId($.identifier.value,se.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(Y,this._transformDocumentSelector(K,$),he,(0,t.isProposedApiEnabled)($,"dropMetadata")?se:void 0),this._createDisposable(Y)}$provideDocumentOnDropEdits($,K,te,se,Y,he){return this._withAdapter($,de,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(K,I.URI.revive(te),se,Y,he)),void 0,void 0)}registerMappedEditsProvider($,K,te){const se=this._addNewAdapter(new ee(this._documents,te),$);return this._proxy.$registerMappedEditsProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideMappedEdits($,K,te,se,Y){return this._withAdapter($,ee,he=>Promise.resolve(he.provideMappedEdits(K,te,se,Y)),null,Y)}registerDocumentPasteEditProvider($,K,te,se){const Y=this._nextHandle();this._adapter.set(Y,new ue(new x(this._proxy,this._documents,te,Y,$),$));const he=x.toInternalProviderId($.identifier.value,se.id);return this._proxy.$registerPasteEditProvider(Y,this._transformDocumentSelector(K,$),he,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this._createDisposable(Y)}$prepareDocumentPaste($,K,te,se,Y){return this._withAdapter($,x,he=>he.prepareDocumentPaste(I.URI.revive(K),te,se,Y),void 0,Y)}$providePasteEdits($,K,te,se,Y,he){return this._withAdapter($,x,Se=>Se.providePasteEdits(K,I.URI.revive(te),se,Y,he),void 0,he)}static _serializeRegExp($){return{pattern:$.source,flags:$.flags}}static _serializeIndentationRule($){return{decreaseIndentPattern:pe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:pe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?pe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?pe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:pe._serializeRegExp($.beforeText),afterText:$.afterText?pe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?pe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(pe._serializeOnEnterRule)}static _serializeAutoClosingPair($){return{open:$.open,close:$.close,notIn:$.notIn?$.notIn.map(K=>R.SyntaxTokenType.toString(K)):void 0}}static _serializeAutoClosingPairs($){return $.map(pe._serializeAutoClosingPair)}setLanguageConfiguration($,K,te){const{wordPattern:se}=te;if(se&&(0,y.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const Y=this._nextHandle(),he={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?pe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?pe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?pe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?pe._serializeAutoClosingPairs(te.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(Y,K,he),this._createDisposable(Y)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=pe}),define(De[316],Ie([1,0,6,14,7,38,9,3]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(T,k,b,S){this._documents=k,this._commands=b,this._uriTransformer=S,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,k){await this._proxy.$changeLanguage(T,k);const b=this._documents.getDocumentData(T);if(!b)throw new Error(`document '${T.toString()}' NOT found`);return b.document}async tokenAtPosition(T,k){const b=T.version,S=F.Position.from(k),_=await this._proxy.$tokensAtPosition(T.uri,S),w={type:h.StandardTokenType.Other,range:T.getWordRangeAtPosition(k)??new h.Range(k.line,k.character,k.line,k.character)};if(!_)return w;const u={range:F.Range.to(_.range),type:F.TokenType.to(_.type)};return!u.range.contains(k)||b!==T.version?w:u}createLanguageStatusItem(T,k,b){const S=this._handlePool++,_=this._proxy,w=this._ids,u=`${T.identifier.value}/${k}`;if(w.has(u))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);w.add(u);const r={selector:b,id:k,name:T.displayName??T.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new v.DisposableStore,g=()=>{if(o?.dispose(),!w.has(u)){console.warn(`LanguageStatusItem (${k}) from ${T.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(S,{id:u,name:r.name??T.displayName??T.name,source:T.displayName??T.name,selector:F.DocumentSelector.from(r.selector,this._uriTransformer),label:r.text,detail:r.detail??"",severity:r.severity===h.LanguageStatusSeverity.Error?R.default.Error:r.severity===h.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:r.command&&this._commands.toInternal(r.command,c),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},d={dispose(){c.dispose(),o?.dispose(),_.$removeLanguageStatus(S),w.delete(u)},get id(){return r.id},get name(){return r.name},set name(t){r.name=t,g()},get selector(){return r.selector},set selector(t){r.selector=t,g()},get text(){return r.text},set text(t){r.text=t,g()},get detail(){return r.detail},set detail(t){r.detail=t,g()},get severity(){return r.severity},set severity(t){r.severity=t,g()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(t){r.accessibilityInformation=t,g()},get command(){return r.command},set command(t){r.command=t,g()},get busy(){return r.busy},set busy(t){r.busy=t,g()}};return g(),d}}e.ExtHostLanguages=y}),define(De[112],Ie([1,0,12,15,2,5,13,6,26,20]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=class{constructor(b,S,_){this.logService=_,this.bundleCache=new Map,this._proxy=S.getProxy(v.MainContext.MainThreadLocalization),this.currentLanguage=b.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(b,S){const{message:_,args:w,comment:u}=S;if(this.isDefaultLanguage)return(0,F.format2)(_,w??{});let r=_;u&&u.length>0&&(r+=`/${Array.isArray(u)?u.join(""):u}`);const o=this.bundleCache.get(b)?.contents[r];return o||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,F.format2)(o??_,w??{})}getBundle(b){return this.bundleCache.get(b)?.contents}getBundleUri(b){return this.bundleCache.get(b)?.uri}async initializeLocalizedMessages(b){if(this.isDefaultLanguage||!b.l10n&&!b.isBuiltin||this.bundleCache.has(b.identifier.value))return;let S;const _=await this.getBundleLocation(b);if(!_){this.logService.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const w=await this._proxy.$fetchBundleContents(_),u=JSON.parse(w);S=b.isBuiltin?u.contents?.bundle:u}catch(w){this.logService.error(`Failed to load translations for ${b.identifier.value} from ${_}: ${w.message}`);return}S&&this.bundleCache.set(b.identifier.value,{contents:S,uri:_})}async getBundleLocation(b){if(b.isBuiltin){const S=await this._proxy.$fetchBuiltInBundleUri(b.identifier.value,this.currentLanguage);return h.URI.revive(S)}return b.l10n?h.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=T,e.ExtHostLocalizationService=T=je([$e(0,y.IExtHostInitDataService),$e(1,E.IExtHostRpcService),$e(2,A.ILogService)],T),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(De[150],Ie([1,0,13,6,26,20,2,62]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends I.AbstractLoggerService{constructor(k,b){super(b.logLevel,b.logsLocation,b.loggers.map(S=>(0,v.revive)(S))),this._proxy=k.getProxy(F.MainContext.MainThreadLogger)}$setLogLevel(k,b){b?this.setLogLevel(A.URI.revive(b),k):this.setLogLevel(k)}setVisibility(k,b){super.setVisibility(k,b),this._proxy.$setVisibility(k,b)}doCreateLogger(k,b,S){return new E(this._proxy,k,b,S)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=je([$e(0,R.IExtHostRpcService),$e(1,h.IExtHostInitDataService)],y);class E extends I.AbstractMessageLogger{constructor(k,b,S,_){super(_?.logLevel==="always"),this.proxy=k,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(b,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,b){const S=[[k,b]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(De[113],Ie([1,0,6,5,3,20,22]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,F.createDecorator)("IExtHostManagedSockets");let v=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(k,b){for(const S of this._managedRemoteSockets.values())S.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(k,b),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const b=++this._remoteSocketIdCounter,S=await this._factory.makeConnection(),_=new h.DisposableStore;return this._managedRemoteSockets.set(b,new E(b,S,_)),_.add((0,h.toDisposable)(()=>this._managedRemoteSockets.delete(b))),_.add(S.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(b),_.dispose()})),_.add(S.onDidClose(w=>{this._proxy.$onDidManagedSocketClose(b,w?.stack??w?.message),_.dispose()})),_.add(S.onDidReceiveMessage(w=>this._proxy.$onDidManagedSocketHaveData(b,A.VSBuffer.wrap(w)))),b}$remoteSocketWrite(k,b){this._managedRemoteSockets.get(k)?.actual.send(b.buffer)}$remoteSocketEnd(k){const b=this._managedRemoteSockets.get(k);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=v,e.ExtHostManagedSockets=v=je([$e(0,R.IExtHostRpcService)],v);class y{constructor(k,b){this.socketFactoryId=k,this.makeConnection=b}}class E extends h.Disposable{constructor(k,b,S){super(),this.socketId=k,this.actual=b,this._register(S)}}}),define(De[317],Ie([1,0,6,13,27]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(v){return v&&v.title}let A=class{constructor(y,E){this._logService=E,this._proxy=y.getProxy(I.MainContext.MainThreadMessageService)}showMessage(y,E,T,k,b){const S={source:{identifier:y.identifier,label:y.displayName||y.name}};let _;typeof k=="string"||R(k)?_=[k,...b]:(S.modal=k?.modal,S.useCustom=k?.useCustom,S.detail=k?.detail,_=b),S.useCustom&&(0,h.checkProposedApiEnabled)(y,"resolvers");const w=[];for(let u=0;u<_.length;u++){const r=_[u];if(typeof r=="string")w.push({title:r,handle:u,isCloseAffordance:!1});else if(typeof r=="object"){const{title:o,isCloseAffordance:c}=r;w.push({title:o,isCloseAffordance:!!c,handle:u})}else this._logService.warn("Invalid message item:",r)}return this._proxy.$showMessage(E,T,S,w).then(u=>{if(typeof u=="number")return _[u]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=je([$e(1,F.ILogService)],A)}),define(De[318],Ie([1,0,207,22,4,3,28,15,18,2,30,107,6,33,14,7,68,281,144,8,23,17]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class t{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}constructor(s,i,a,l,C){this._textDocumentsAndEditors=a,this._textDocuments=l,this._extHostFileSystem=C,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new h.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new h.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new h.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new h.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=s.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=i.converter,i.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const p=D.notebookEditor?.notebookUri,m=D.cell.handle,P=this._documents.get(p)?.getCell(m);if(P)return P.apiCell}if(D&&D.$mid===14){const p=D.uri,m=this._documents.get(p);if(m)return m.apiNotebook}return D}}),t._registerApiCommands(i)}getEditorById(s){const i=this._editors.get(s);if(!i)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return i}getIdByEditor(s){for(const[i,a]of this._editors)if(a.apiEditor===s)return i}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,i){const a=this._documents.get(s);if(!a&&!i)throw new Error(`NO notebook document for '${s}'`);return a}static _convertNotebookRegistrationData(s,i){if(!i)return;const a=i.filenamePattern.map(l=>_.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(i.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:i.displayName,filenamePattern:a,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,i,a){const l=t._notebookStatusBarItemProviderHandlePool++,C=typeof a.onDidChangeCellStatusBarItems=="function"?t._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,a),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,C,i);let D;return C!==void 0&&(D=a.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(C))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,C),D?.dispose()})}async createNotebookDocument(s){const i=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&_.NotebookData.from(s.content)});return E.URI.revive(i)}async openNotebookDocument(s){const i=this._documents.get(s);if(i)return i.apiNotebook;const a=await this._notebookDocumentsProxy.$tryOpenNotebook(s),l=this._documents.get(E.URI.revive(a));return(0,y.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(s,i){E.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let a;typeof i=="object"?a={position:_.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(_.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:a={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,a),C=l&&this._editors.get(l)?.apiEditor;if(C)return C;throw l?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,i,a,l){const C=this._notebookStatusBarItemProviders.get(s),D=E.URI.revive(i),p=this._documents.get(D);if(!p||!C)return;const m=p.getCellFromIndex(a);if(!m)return;const f=await C.provideCellStatusBarItems(m.apiCell,l);if(!f)return;const P=new R.DisposableStore,M=this._statusBarCache.add([P]),L=(Array.isArray(f)?f:[f]).map(U=>_.NotebookStatusBarItem.from(U,this._commandsConverter,P));return{cacheId:M,items:L}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,i,a,l,C){if((0,v.isFalsyOrWhitespace)(i))throw new Error("viewType cannot be empty or just whitespace");const D=this._handlePool++;return this._notebookSerializer.set(D,{viewType:i,serializer:a,options:l}),this._notebookProxy.$registerNotebookSerializer(D,{id:s.identifier,location:s.extensionLocation},i,_.NotebookDocumentContentOptions.from(l),t._convertNotebookRegistrationData(s,C)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(D)})}async $dataToNotebook(s,i,a){const l=this._notebookSerializer.get(s);if(!l)throw new Error("NO serializer found");const C=await l.serializer.deserializeNotebook(i.buffer,a);return new u.SerializableObjectWithBuffers(_.NotebookData.from(C))}async $notebookToData(s,i,a){const l=this._notebookSerializer.get(s);if(!l)throw new Error("NO serializer found");const C=await l.serializer.serializeNotebook(_.NotebookData.to(i.value),a);return F.VSBuffer.wrap(C)}async $saveNotebook(s,i,a,l,C){const D=E.URI.revive(i),p=this._notebookSerializer.get(s);if(!p)throw new Error("NO serializer found");const m=this._documents.get(D);if(!m)throw new Error("Document NOT found");if(m.versionId!==a)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(D.scheme))throw new T.FileOperationError((0,I.localize)(0,null,this._resourceForError(D)),6);await this._validateWriteFile(D,l);const f={metadata:(0,g.filter)(m.apiNotebook.metadata,U=>!(p.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of m.apiNotebook.getCells()){const x=new w.NotebookCellData(U.kind,U.document.getText(),U.document.languageId,U.mime,p.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);x.metadata=(0,g.filter)(U.metadata,O=>!(p.options?.transientCellMetadata??{})[O]),f.cells.push(x)}const P=await p.serializer.serializeNotebook(f,C);await this._extHostFileSystem.value.writeFile(D,P);const M=this._extHostFileSystem.getFileSystemProviderExtUri(D.scheme),N=await this._extHostFileSystem.value.stat(D);return{name:M.basename(D),isFile:(N.type&T.FileType.File)!==0,isDirectory:(N.type&T.FileType.Directory)!==0,isSymbolicLink:(N.type&T.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&T.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(D.scheme),locked:!!((N.permissions??0)&T.FilePermission.Locked),etag:T.etag({mtime:N.mtime,size:N.size}),children:void 0}}async _validateWriteFile(s,i){const a=await this._extHostFileSystem.value.stat(s);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==T.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==T.etag({mtime:i.mtime,size:a.size}))throw new T.FileOperationError((0,I.localize)(1,null),3,i)}_resourceForError(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString()}_createExtHostEditor(s,i,a){if(this._editors.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const l=new o.ExtHostNotebookEditor(i,this._notebookEditorsProxy,s,a.visibleRanges.map(_.NotebookRange.to),a.selections.map(_.NotebookRange.to),typeof a.viewColumn=="number"?_.ViewColumn.to(a.viewColumn):void 0);this._editors.set(i,l)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const a of s.value.removedDocuments){const l=E.URI.revive(a),C=this._documents.get(l);C&&(C.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:C.apiNotebook.getCells().map(D=>D.document.uri)}),this._onDidCloseNotebookDocument.fire(C.apiNotebook));for(const D of this._editors.values())D.notebookData.uri.toString()===l.toString()&&this._editors.delete(D.id)}if(s.value.addedDocuments){const a=[];for(const l of s.value.addedDocuments){const C=E.URI.revive(l.uri);if(this._documents.has(C))throw new Error(`adding EXISTING notebook ${C} `);const D=new r.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,C,l);a.push(...l.cells.map(p=>r.ExtHostCell.asModelAddData(D.apiNotebook,p))),this._documents.get(C)?.dispose(),this._documents.set(C,D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(D.apiNotebook)}}if(s.value.addedEditors)for(const a of s.value.addedEditors){if(this._editors.has(a.id))return;const l=E.URI.revive(a.documentUri),C=this._documents.get(l);C&&this._createExtHostEditor(C,a.id,a)}const i=[];if(s.value.removedEditors)for(const a of s.value.removedEditors){const l=this._editors.get(a);l&&(this._editors.delete(a),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),i.push(l))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const a=new Set;this._visibleNotebookEditors.forEach(l=>a.add(l.id));for(const l of this._editors.values()){const C=a.has(l.id);l._acceptVisibility(C)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._editors.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(s){const i=S.ApiCommandArgument.String.with("notebookType","A notebook type"),a=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new S.ApiCommandArgument("data","Bytes to convert to data",C=>C instanceof Uint8Array,C=>F.VSBuffer.wrap(C))],new S.ApiCommandResult("Notebook Data",C=>_.NotebookData.to(C.value))),l=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",C=>!0,C=>new u.SerializableObjectWithBuffers(_.NotebookData.from(C)))],new S.ApiCommandResult("Bytes",C=>C.buffer));s.registerApiCommand(a),s.registerApiCommand(l)}}e.ExtHostNotebookController=t}),define(De[319],Ie([1,0,19,9,21,4,3,28,2,25,13,6,33,14,7,110,275,27,68]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let c=class{constructor(l,C,D,p,m){this._initData=C,this._extHostNotebook=D,this._commands=p,this._logService=m,this._activeExecutions=new v.ResourceMap,this._activeNotebookExecutions=new v.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(k.MainContext.MainThreadNotebookKernels);const f=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const M=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:M}}else if(P&&"notebookEditor"in P){const M=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return P})],b.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(l,C,D,p,m,f){for(const Q of this._kernelData.values())if(Q.controller.id===C&&E.ExtensionIdentifier.equals(l.identifier,Q.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const P=this._handlePool++,M=this;this._logService.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${C}`);const N=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let L=!1;const U=new R.Emitter,x=new R.Emitter,O={id:i(l.identifier,C),notebookType:D,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:p||l.identifier.value,preloads:f?f.map(S.NotebookRendererScript.from):[]};let j=m??N,V;this._proxy.$addKernel(P,O).catch(Q=>{console.log(Q),L=!0});let fe=0;const J=()=>{if(L)return;const Q=++fe;Promise.resolve().then(()=>{Q===fe&&this._proxy.$updateKernel(P,O)})},X=new v.ResourceMap,z={get id(){return C},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return O.label},set label(Q){O.label=Q??l.displayName??l.name,J()},get detail(){return O.detail??""},set detail(Q){O.detail=Q,J()},get description(){return O.description??""},set description(Q){O.description=Q,J()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(Q){O.supportedLanguages=Q,J()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){O.supportsExecutionOrder=Q,J()},get rendererScripts(){return O.preloads?O.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(Q){j=Q??N},get interruptHandler(){return V},set interruptHandler(Q){V=Q,O.supportsInterrupt=!!Q,J()},createNotebookCellExecution(Q){if(L)throw new Error("notebook controller is DISPOSED");if(!X.has(Q.notebook.uri))throw M._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return M._createNotebookCellExecution(Q,i(l.identifier,this.id))},createNotebookExecution(Q){if((0,r.checkProposedApiEnabled)(l,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!X.has(Q.uri))throw M._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.uri.toString()}`);return M._createNotebookExecution(Q,i(l.identifier,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${P}], DISPOSED`),L=!0,this._kernelData.delete(P),U.dispose(),x.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(Q,ve){ve===_.NotebookControllerAffinity2.Hidden&&(0,r.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),M._proxy.$updateNotebookPriority(P,Q.uri,ve)},onDidReceiveMessage:x.event,postMessage(Q,ve){return(0,r.checkProposedApiEnabled)(l,"notebookMessaging"),M._proxy.$postMessage(P,ve&&M._extHostNotebook.getIdByEditor(ve),Q)},asWebviewUri(Q){return(0,r.checkProposedApiEnabled)(l,"notebookMessaging"),(0,w.asWebviewUri)(Q,M._initData.remote)}};return this._kernelData.set(P,{extensionId:l.identifier,controller:z,onDidReceiveMessage:x,onDidChangeSelection:U,associatedNotebooks:X}),z}getIdByController(l){for(const[C,D]of this._kernelData)if(D.controller===l)return i(D.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,C){const D=this._kernelDetectionTaskHandlePool++,p=this;this._logService.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelDetectionTask(D,C);const m={dispose:()=>{this._kernelDetectionTask.delete(D),p._proxy.$removeKernelDetectionTask(D)}};return this._kernelDetectionTask.set(D,m),m}registerKernelSourceActionProvider(l,C,D){const p=this._kernelSourceActionProviderHandlePool++,m=typeof D.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,f=this;this._kernelSourceActionProviders.set(p,D),this._logService.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelSourceActionProvider(p,p,C);let P;return m!==void 0&&(P=D.onDidChangeNotebookKernelSourceActions(M=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this._kernelSourceActionProviders.delete(p),f._proxy.$removeKernelSourceActionProvider(p,p),P?.dispose()}}}async $provideKernelSourceActions(l,C){const D=this._kernelSourceActionProviders.get(l);if(D){const p=new A.DisposableStore;return(await D.provideNotebookKernelSourceActions(C)??[]).map(f=>S.NotebookKernelSourceAction.from(f,this._commands.converter,p))}return[]}$acceptNotebookAssociation(l,C,D){const p=this._kernelData.get(l);if(p){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(C));D?p.associatedNotebooks.set(m.uri,!0):p.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,m.uri.toString(),D),p.onDidChangeSelection.fire({selected:D,notebook:m.apiNotebook})}}async $executeCells(l,C,D){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(C)),f=[];for(const P of D){const M=m.getCell(P);M&&f.push(M.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,m.uri.toString(),f.length),await p.controller.executeHandler.call(p.controller,f,m.apiNotebook,p.controller)}catch(P){this._logService.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,C,D){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(C));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,m.apiNotebook);else for(const f of D){const P=m.getCell(f);P&&this._activeExecutions.get(P.uri)?.cancel()}if(p.controller.interruptHandler){const f=this._activeNotebookExecutions.get(m.uri);D.length&&Array.isArray(f)&&f.length&&f.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(l,C,D){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getEditorById(C);p.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:D}))}$cellExecutionChanged(l,C,D){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)).getCell(C);if(m){const f=D?S.NotebookCellExecutionState.to(D):_.NotebookCellExecutionState.Idle;f!==void 0&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:f})}}_createNotebookCellExecution(l,C){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const m=new d(C,p,this._proxy);this._activeExecutions.set(p.uri,m);const f=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),f.dispose(),this._activeExecutions.delete(p.uri))});return m.asApiObject()}_createNotebookExecution(l,C){const D=this._extHostNotebook.getNotebookDocument(l.uri),p=l.getCells().find(P=>{const M=D.getCellFromApiCell(P);return M&&this._activeExecutions.has(M.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this._activeNotebookExecutions.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const m=new n(C,D,this._proxy),f=m.onDidChangeState(()=>{m.state===t.Resolved&&(m.dispose(),f.dispose(),this._activeNotebookExecutions.delete(D.uri))});return this._activeNotebookExecutions.set(D.uri,[m,f]),m.asApiObject()}};e.ExtHostNotebookKernels=c,e.ExtHostNotebookKernels=c=je([$e(4,T.ILogService)],c);var g;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(g||(g={}));class d extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,C,D){super(),this._cell=C,this._proxy=D,this._handle=d.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=g.Init,this._tokenSource=this._register(new h.CancellationTokenSource),this._collector=new s(10,p=>this.update(p)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const C=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new o.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===g.Init)throw new Error("Must call start before modifying cell output");if(this._state===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let C=this._cell;if(l&&(C=this._cell.notebook.getCellFromApiCell(l)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(l){return l.map(C=>{const D=_.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return D===C.items?S.NotebookCellOutput.from(C):S.NotebookCellOutput.from({items:D,id:C.id,metadata:C.metadata})})}async updateOutputs(l,C,D){const p=this.cellIndexToHandle(C),m=this.validateAndConvertOutputs((0,I.asArray)(l));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:p,append:D,outputs:m})}async updateOutputItems(l,C,D){return l=_.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(l),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:l.map(S.NotebookCellOutputItem.from),outputId:C.id,append:D})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(D){l._executionOrder=D,l.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(D){if(l._state===g.Resolved||l._state===g.Started)throw new Error("Cannot call start again");l._state=g.Started,l._onDidChangeState.fire(),l.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,p){if(l._state===g.Resolved)throw new Error("Cannot call resolve twice");l._state=g.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new o.SerializableObjectWithBuffers({runEndTime:p,lastRunSuccess:D}))},clearOutput(D){return l.verifyStateForOutput(),l.updateOutputs([],D,!1)},appendOutput(D,p){return l.verifyStateForOutput(),l.updateOutputs(D,p,!0)},replaceOutput(D,p){return l.verifyStateForOutput(),l.updateOutputs(D,p,!1)},appendOutputItems(D,p){return l.verifyStateForOutput(),l.updateOutputItems(D,p,!0)},replaceOutputItems(D,p){return l.verifyStateForOutput(),l.updateOutputItems(D,p,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,C,D){super(),this._notebook=C,this._proxy=D,this._handle=n.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new h.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,l,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===t.Resolved||this._state===t.Started)throw new Error("Cannot call start again");this._state=t.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===t.Resolved)throw new Error("Cannot call resolve twice");this._state=t.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(l,C){this.delay=l,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>l.complete())}}function i(a,l){return`${a.value}/${l}`}e.createKernelId=i}),define(De[320],Ie([1,0,4,6,144]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(v,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=v.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(v,y,E){const T=this._extHostNotebook.getEditorById(v);this._rendererMessageEmitters.get(y)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(v,y){if(!v.contributes?.notebookRenderer?.some(T=>T.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(T,k,b)=>this.getOrCreateEmitterFor(y).event(T,k,b),postMessage:(T,k)=>{h.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const b=k&&h.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(b?.id,y,T)}}}getOrCreateEmitterFor(v){let y=this._rendererMessageEmitters.get(v);return y||(y=new I.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(v)}}),this._rendererMessageEmitters.set(v,y),y)}}e.ExtHostNotebookRenderers=R}),define(De[321],Ie([1,0,3,18,2,27,6]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class v{constructor(E){this.handlers=new Map,this.proxy=E.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(E,T,k){if((0,R.checkProposedApiEnabled)(E,"profileContentHandlers"),this.handlers.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.handlers.set(T,k),this.proxy.$registerProfileContentHandler(T,k.name,k.description,E.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(T),this.proxy.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,k,b){const S=this.handlers.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(T,k,b)}async $readProfile(E,T,k){const b=this.handlers.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.readProfile((0,F.isString)(T)?T:h.URI.revive(T),k)}}e.ExtHostProfileContentHandlers=v}),define(De[322],Ie([1,0,2,6,9,14]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(y,E){this.uriTransformer=E,this.providers=new Map,this.proxy=y.getProxy(F.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,E,T){const k=I.URI.revive(E),b=this.providers.get(y);return b?(0,h.asPromise)(()=>b.provideOriginalResource(k,T)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(y,E,T,k){const b=A.handlePool++;return this.providers.set(b,E),this.proxy.$registerQuickDiffProvider(b,R.DocumentSelector.from(y,this.uriTransformer),T,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(b),this.providers.delete(b)}}}}e.ExtHostQuickDiff=A}),define(De[323],Ie([1,0,21,4,3,6,2,7,8,19,38,59,27,14]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(w,u,r){const o=w.getProxy(R.MainContext.MainThreadQuickOpen);class c{constructor(C,D){this._sessions=new Map,this._instances=0,this._workspace=C,this._commands=D}showQuickPick(C,D,p,m=I.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(D),P=++this._instances,M=o.$show(P,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},m),N={},L=M.then(()=>N);return Promise.race([L,f]).then(U=>{if(U===N)return;const x=(0,b.isProposedApiEnabled)(C,"quickPickItemTooltip");return f.then(O=>{const j=[];for(let V=0;V<O.length;V++){const fe=O[V];if(typeof fe=="string")j.push({label:fe,handle:V});else if(fe.kind===v.QuickPickItemKind.Separator)j.push({type:"separator",label:fe.label});else{fe.tooltip&&!x&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const J=fe.iconPath?s(fe.iconPath):void 0;j.push({label:fe.label,iconPath:J?.iconPath,iconClass:J?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:x?S.MarkdownString.fromStrict(fe.tooltip):void 0,handle:V})}}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{p.onDidSelectItem(O[V])}),o.$setItems(P,j),M.then(V=>{if(typeof V=="number")return O[V];if(Array.isArray(V))return V.map(fe=>O[fe])})})}).then(void 0,U=>{if(!(0,y.isCancellationError)(U))return o.$setError(P,U),Promise.reject(U)})}$onItemSelected(C){this._onDidSelectItem?.(C)}showInput(C,D=I.CancellationToken.None){return this._validateInput=C?.validateInput,o.$input(C,typeof this._validateInput=="function",D).then(void 0,p=>{if(!(0,y.isCancellationError)(p))return Promise.reject(p)})}async $validateInput(C){if(!this._validateInput)return;const D=await this._validateInput(C);if(!D||typeof D=="string")return D;let p;switch(D.severity){case v.InputBoxValidationSeverity.Info:p=T.default.Info;break;case v.InputBoxValidationSeverity.Warning:p=T.default.Warning;break;case v.InputBoxValidationSeverity.Error:p=T.default.Error;break;default:p=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:p}}async showWorkspaceFolderPick(C,D=I.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!p)return;const m=await this._workspace.getWorkspaceFolders2();if(m)return m.find(f=>f.uri.toString()===p.uri.toString())}createQuickPick(C){const D=new i(C,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(C){const D=new a(C,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}$onDidChangeValue(C,D){this._sessions.get(C)?._fireDidChangeValue(D)}$onDidAccept(C){this._sessions.get(C)?._fireDidAccept()}$onDidChangeActive(C,D){const p=this._sessions.get(C);p instanceof i&&p._fireDidChangeActive(D)}$onDidChangeSelection(C,D){const p=this._sessions.get(C);p instanceof i&&p._fireDidChangeSelection(D)}$onDidTriggerButton(C,D){this._sessions.get(C)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(C,D,p){const m=this._sessions.get(C);m instanceof i&&m._fireDidTriggerItemButton(D,p)}$onDidHide(C){this._sessions.get(C)?._fireDidHide()}}class g{static{this._nextId=1}constructor(C,D){this._extensionId=C,this._onDidDispose=D,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new F.Emitter,this._onDidChangeValueEmitter=new F.Emitter,this._onDidTriggerButtonEmitter=new F.Emitter,this._onDidHideEmitter=new F.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(C){this._title=C,this.update({title:C})}get step(){return this._steps}set step(C){this._steps=C,this.update({step:C})}get totalSteps(){return this._totalSteps}set totalSteps(C){this._totalSteps=C,this.update({totalSteps:C})}get enabled(){return this._enabled}set enabled(C){this._enabled=C,this.update({enabled:C})}get busy(){return this._busy}set busy(C){this._busy=C,this.update({busy:C})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(C){this._ignoreFocusOut=C,this.update({ignoreFocusOut:C})}get value(){return this._value}set value(C){this._value=C,this.update({value:C})}get placeholder(){return this._placeholder}set placeholder(C){this._placeholder=C,this.update({placeholder:C})}get buttons(){return this._buttons}set buttons(C){this._buttons=C.slice(),this._handlesToButtons.clear(),C.forEach((D,p)=>{const m=D===v.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(m,D)}),this.update({buttons:C.map((D,p)=>({...s(D.iconPath),tooltip:D.tooltip,handle:D===v.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(C){this._value=C,this._onDidChangeValueEmitter.fire(C)}_fireDidTriggerButton(C){const D=this._handlesToButtons.get(C);D&&this._onDidTriggerButtonEmitter.fire(D)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,h.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),o.$dispose(this._id))}update(C){if(!this._disposed){for(const D of Object.keys(C)){const p=C[D];this._pendingUpdate[D]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){o.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function d(l){if(l instanceof v.ThemeIcon)return{id:l.id};const C=n(l),D=t(l);return{dark:typeof C=="string"?A.URI.file(C):C,light:typeof D=="string"?A.URI.file(D):D}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function n(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const C=d(l);let D,p;return"id"in C?p=k.ThemeIcon.asClassName(C):D=C,{iconPath:D,iconClass:p}}class i extends g{constructor(C,D){super(C.identifier,D),this.extension=C,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new F.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new F.Emitter,this._onDidTriggerItemButtonEmitter=new F.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(C){this._items=C.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),C.forEach((m,f)=>{this._handlesToItems.set(f,m),this._itemsToHandles.set(m,f)});const D=(0,b.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),p=[];for(let m=0;m<C.length;m++){const f=C[m];if(f.kind===v.QuickPickItemKind.Separator)p.push({type:"separator",label:f.label});else{f.tooltip&&!D&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=f.iconPath?s(f.iconPath):void 0;p.push({handle:m,label:f.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,N)=>({...s(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.update({items:p})}get canSelectMany(){return this._canSelectMany}set canSelectMany(C){this._canSelectMany=C,this.update({canSelectMany:C})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(C){this._matchOnDescription=C,this.update({matchOnDescription:C})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(C){this._matchOnDetail=C,this.update({matchOnDetail:C})}get sortByLabel(){return this._sortByLabel}set sortByLabel(C){this._sortByLabel=C,this.update({sortByLabel:C})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(C){this._keepScrollPosition=C,this.update({keepScrollPosition:C})}get activeItems(){return this._activeItems}set activeItems(C){this._activeItems=C.filter(D=>this._itemsToHandles.has(D)),this.update({activeItems:this._activeItems.map(D=>this._itemsToHandles.get(D))})}get selectedItems(){return this._selectedItems}set selectedItems(C){this._selectedItems=C.filter(D=>this._itemsToHandles.has(D)),this.update({selectedItems:this._selectedItems.map(D=>this._itemsToHandles.get(D))})}_fireDidChangeActive(C){const D=(0,E.coalesce)(C.map(p=>this._handlesToItems.get(p)));this._activeItems=D,this._onDidChangeActiveEmitter.fire(D)}_fireDidChangeSelection(C){const D=(0,E.coalesce)(C.map(p=>this._handlesToItems.get(p)));this._selectedItems=D,this._onDidChangeSelectionEmitter.fire(D)}_fireDidTriggerItemButton(C,D){const p=this._handlesToItems.get(C);if(!p||!p.buttons||!p.buttons.length)return;const m=p.buttons[D];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:p})}}class a extends g{constructor(C,D){super(C.identifier,D),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(C){this._password=C,this.update({password:C})}get prompt(){return this._prompt}set prompt(C){this._prompt=C,this.update({prompt:C})}get valueSelection(){return this._valueSelection}set valueSelection(C){this._valueSelection=C,this.update({valueSelection:C})}get validationMessage(){return this._validationMessage}set validationMessage(C){this._validationMessage=C,C?typeof C=="string"?this.update({validationMessage:C,severity:T.default.Error}):this.update({validationMessage:C.message,severity:C.severity??T.default.Error}):this.update({validationMessage:void 0,severity:T.default.Ignore})}}return new c(u,r)}e.createExtHostQuickOpen=_}),define(De[324],Ie([1,0,2,4,57,3,9,6,19,126,13,25,59,14,27,17]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function r(m){if(m)return typeof m.iconPath=="string"?I.URI.file(m.iconPath):I.URI.isUri(m.iconPath)||b.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function o(m){if(m.icon){if(I.URI.isUri(m.icon))return m.icon;if(b.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const f=m.icon;return{light:f.light,dark:f.dark}}}else return}function c(m,f){if(!m.iconPath&&!f.iconPath)return 0;if(m.iconPath){if(!f.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:I.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,M=typeof f.iconPath=="string"?f.iconPath:I.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,E.comparePaths)(P,M)}function g(m,f){let P=0;if(m.strikeThrough!==f.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==f.faded)return m.faded?1:-1;if(m.tooltip!==f.tooltip)return(m.tooltip||"").localeCompare(f.tooltip||"");if(P=c(m,f),P!==0)return P;if(m.light&&f.light)P=c(m.light,f.light);else{if(m.light)return 1;if(f.light)return-1}if(P!==0)return P;if(m.dark&&f.dark)P=c(m.dark,f.dark);else{if(m.dark)return 1;if(f.dark)return-1}return P}function d(m,f){if(m.command!==f.command)return m.command<f.command?-1:1;if(m.title!==f.title)return m.title<f.title?-1:1;if(m.tooltip!==f.tooltip){if(m.tooltip!==void 0&&f.tooltip!==void 0)return m.tooltip<f.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(m.arguments===f.arguments)return 0;if(m.arguments)if(f.arguments){if(m.arguments.length!==f.arguments.length)return m.arguments.length-f.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const M=m.arguments[P],N=f.arguments[P];if(M!==N)return M<N?-1:1}return 0}function t(m,f){let P=(0,E.comparePaths)(m.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&f.command)P=d(m.command,f.command);else{if(m.command)return 1;if(f.command)return-1}if(P!==0)return P;if(m.decorations&&f.decorations)P=g(m.decorations,f.decorations);else{if(m.decorations)return 1;if(f.decorations)return-1}return P}function n(m,f){for(let P=0;P<m.length;P++)if(m[P]!==f[P])return!1;return!0}function s(m,f){return m.command===f.command&&m.title===f.title&&m.tooltip===f.tooltip&&(m.arguments&&f.arguments?n(m.arguments,f.arguments):m.arguments===f.arguments)}function i(m,f){return(0,y.equals)(m,f,s)}function a(m,f){return m===f?!0:!m||!f?!1:m.id===f.id&&m.label===f.label&&m.upstream?.id===f.upstream?.id&&m.upstream?.label===f.upstream?.label}class l{#e;#t;get value(){return this._value}set value(f){f=f??"",this.#e.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,this.#e.$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this.#e.$setInputBoxVisibility(this._sourceControlHandle,f))}get document(){return(0,_.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(f,P,M,N,L){this._extension=f,this._sourceControlHandle=N,this._documentUri=L,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=P,this.#e=M}showValidationMessage(f,P){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,f,P)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=l;class C{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}constructor(f,P,M,N,L){this._proxy=f,this._commands=P,this._sourceControlHandle=M,this._id=N,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=C._handlePool++}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,P){const M=this._resourceStatesCommandsMap.get(f);return M?(0,A.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(t),M=(0,y.sortedDiff)(this._resourceSnapshot,f,t).map(U=>{const x=U.toInsert.map(O=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,O);const V=O.resourceUri;let fe;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const H=new R.DisposableStore;fe=this._commands.converter.toInternal(O.command,H),this._resourceStatesDisposablesMap.set(j,H)}else this._resourceStatesCommandsMap.set(j,O.command);const J=r(O.decorations),X=O.decorations&&r(O.decorations.light)||J,z=O.decorations&&r(O.decorations.dark)||J,Q=[X,z],ve=O.decorations&&O.decorations.tooltip||"",le=O.decorations&&!!O.decorations.strikeThrough,we=O.decorations&&!!O.decorations.faded,G=O.contextValue||"";return{rawResource:[j,V,Q,ve,le,we,G,fe],handle:j}});return{start:U.start,deleteCount:U.deleteCount,toInsert:x}}),N=M.map(({start:U,deleteCount:x,toInsert:O})=>[U,x,O.map(j=>j.rawResource)]),L=M.reverse();for(const{start:U,deleteCount:x,toInsert:O}of L){const j=O.map(fe=>fe.handle),V=this._handlesSnapshot.splice(U,x,...j);for(const fe of V)this._resourceStatesMap.delete(fe),this._resourceStatesCommandsMap.delete(fe),this._resourceStatesDisposablesMap.get(fe)?.dispose(),this._resourceStatesDisposablesMap.delete(fe)}return this._resourceSnapshot=f,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class D{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this.#e.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f;let P;(0,_.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(P=f?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f,quickDiffLabel:P})}get historyProvider(){return(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(f){(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=f,this._historyProviderDisposable.value=new R.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!f}),f&&(this._historyProviderDisposable.value.add(f.onDidChangeCurrentHistoryItemGroup(()=>{a(this._historyProviderCurrentHistoryItemGroup,f?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=f?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(f.onDidChangeActionButton(()=>{(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new R.DisposableStore;const P=f.actionButton!==void 0?{command:this._commands.converter.toInternal(f.actionButton.command,this._historyProviderActionButtonDisposable.value),description:f.actionButton.description,enabled:f.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,P??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this.#e.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=f;const P=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=f;const P=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(M=>M.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&i(this._statusBarCommands,f))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=f;const P=(f||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(f,P,M,N,L,U,x){this._extension=f,this._commands=N,this._id=L,this._label=U,this._rootUri=x,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new R.MutableDisposable,this._historyProviderActionButtonDisposable=new R.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=D._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=M;const O=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${L}/scm${this.handle}/input`,query:x?`rootUri=${encodeURIComponent(x.toString())}`:void 0});this._inputBox=new l(f,P,this.#e,this.handle,O),this.#e.$registerSourceControl(this.handle,L,U,x,O)}createResourceGroup(f,P){const M=new C(this.#e,this._commands,this.handle,f,P),N=F.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,N),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const f=[],P=[];for(const[M,N]of this.createdResourceGroups){N.dispose();const L=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});F.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),L.dispose(),this._groups.delete(M.handle),this.#e.$unregisterGroup(this.handle,M.handle)}),f.push([M.handle,M.id,M.label,M.features]);const U=M._takeResourceStateSnapshot();U.length>0&&P.push([M.handle,U]),this._groups.set(M.handle,M)}this.#e.$registerGroups(this.handle,f,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&f.push([P.handle,M])}),f.length>0&&this.#e.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,h.debounce)(100)],D.prototype,"eventuallyAddResourceGroups",null),je([(0,h.debounce)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let p=class{static{u=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(f,P,M,N){this._commands=P,this._extHostDocuments=M,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=f.getProxy(v.MainContext.MainThreadSCM),this._telemetry=f.getProxy(v.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const U=this._sourceControls.get(L.sourceControlHandle);if(!U)return L;const x=U.getResourceGroup(L.groupHandle);return x?x.getResourceState(L.handle):L}else if(L&&L.$mid===4){const U=this._sourceControls.get(L.sourceControlHandle);return U?U.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const U=this._sourceControls.get(L.handle);return U||L}return L}})}createSourceControl(f,P,M,N){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,P,M,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const L=u._handlePool++,U=new D(f,this._extHostDocuments,this._proxy,this._commands,P,M,N);this._sourceControls.set(L,U);const x=this._sourceControlsByExtension.get(f.identifier)||[];return x.push(U),this._sourceControlsByExtension.set(f.identifier,x),U}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const P=this._sourceControlsByExtension.get(f.identifier),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(f,P,M){const N=I.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,N.toString());const L=this._sourceControls.get(f);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(N,M)).then(U=>U||null)}$onInputBoxValueChange(f,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const M=this._sourceControls.get(f);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(f,P,M,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,P,M);const L=this._sourceControls.get(f);if(!L)return Promise.resolve(void 0);const U=L.getResourceGroup(P);return U?U.$executeResourceCommand(M,N):Promise.resolve(void 0)}$validateInput(f,P,M){this.logService.trace("ExtHostSCM#$validateInput",f);const N=this._sourceControls.get(f);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>N.inputBox.validateInput(P,M)).then(L=>{if(!L)return Promise.resolve(void 0);const U=S.MarkdownString.fromStrict(L.message);return U?Promise.resolve([U,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(f,P,M){return await this._sourceControls.get(f)?.historyProvider?.resolveHistoryItemGroupBase(P,M)??void 0}async $resolveHistoryItemGroupCommonAncestor(f,P,M,N){return await this._sourceControls.get(f)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,M,N)??void 0}async $provideHistoryItems(f,P,M,N){return(await this._sourceControls.get(f)?.historyProvider?.provideHistoryItems(P,M,N))?.map(x=>({id:x.id,parentIds:x.parentIds,label:x.label,description:x.description,icon:o(x),timestamp:x.timestamp}))??void 0}async $provideHistoryItemChanges(f,P,M){return await this._sourceControls.get(f)?.historyProvider?.provideHistoryItemChanges(P,M)??void 0}};e.ExtHostSCM=p,e.ExtHostSCM=p=u=je([$e(3,T.ILogService)],p)}),define(De[114],Ie([1,0,6,4,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(v){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=v.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(v){this._onDidChangePassword.fire(v)}get(v,y){return this._proxy.$getPassword(v,y)}store(v,y,E){return this._proxy.$setPassword(v,y,E)}delete(v,y){return this._proxy.$deletePassword(v,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,h.createDecorator)("IExtHostSecretState")}),define(De[325],Ie([1,0,6,14,2]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class R{static{this.handlePool=0}constructor(v,y){this.uriTransformer=y,this.providers=new Map,this.proxy=v.getProxy(I.MainContext.MainThreadShare)}async $provideShare(v,y,E){return await this.providers.get(v)?.provideShare({selection:F.Range.to(y.selection),resourceUri:h.URI.revive(y.resourceUri)},E)??void 0}registerShareProvider(v,y){const E=R.handlePool++;return this.providers.set(E,y),this.proxy.$registerShareProvider(E,F.DocumentSelector.from(v,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(E),this.providers.delete(E)}}}}e.ExtHostShare=R}),define(De[326],Ie([1,0,7,6,209,3,14,18]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(b,S,_,w,u,r=I.StatusBarAlignment.Left,o){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,this.#e=b,this.#t=S,u&&w){this._entryId=(0,I.asStatusBarItemIdentifier)(w.identifier,u);const c=_.get(this._entryId);c&&(r=c.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,o=c.priority,this._visible=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=w,this._id=u,this._alignment=r,this._priority=this.validatePriority(o)}validatePriority(b){if((0,v.isNumber)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set name(b){this._name=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!y.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){this._command?.fromApi!==b&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof b=="string"?this._command={fromApi:b,internal:this.#t.toInternal({title:"",command:b},this._latestCommandRegistration)}:b?this._command={fromApi:b,internal:this.#t.toInternal(b,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let b;this._extension?this._id?b=`${this._extension.identifier.value}.${this._id}`:b=this._extension.identifier.value:b=this._id;let S;this._name?S=this._name:S=(0,h.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,b,this._extension?.identifier.value,S,this._text,w,this._command?.internal,_,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class E{constructor(b){this._messages=[],this._item=b.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,h.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const S={message:b};return this._messages.unshift(S),this._update(),new I.Disposable(()=>{const _=this._messages.indexOf(S);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(b,S){this._existingItems=new Map,this._proxy=b.getProxy(F.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new E(this)}$acceptStaticEntries(b){for(const S of b)this._existingItems.set(S.entryId,S)}createStatusBarEntry(b,S,_,w){return new y(this._proxy,this._commands,this._existingItems,b,S,_,w)}setStatusBarMessage(b,S){const _=this._statusMessage.setMessage(b);let w;return typeof S=="number"?w=setTimeout(()=>_.dispose(),S):typeof S<"u"&&S.then(()=>_.dispose(),()=>_.dispose()),new I.Disposable(()=>{_.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=T}),define(De[115],Ie([1,0,6,4,5]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(v,y){this._logService=y,this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=v.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(v,y){this._proxy.$registerExtensionStorageKeysToSync(v,y)}async initializeExtensionStorage(v,y,E){const T=await this._proxy.$initializeExtensionStorage(v,y);let k;return T&&(k=this.safeParseValue(v,y,T)),k||E}setValue(v,y,E){return this._proxy.$setValue(v,y,E)}$acceptValue(v,y,E){const T=this.safeParseValue(v,y,E);T&&this._onDidChangeStorage.fire({shared:v,key:y,value:T})}safeParseValue(v,y,E){try{return JSON.parse(E)}catch(T){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${v}): ${T}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,h.createDecorator)("IExtHostStorage")}),define(De[90],Ie([1,0,5,26,13,71,2]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let v=class{constructor(E,T,k){this._logService=T,this._extHostFileSystem=k,this._workspace=E.workspace??void 0,this._environment=E.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(b=>this._value=b)}async _getWorkspaceStorageURI(E){return A.URI.joinPath(this._environment.workspaceStorageHome,E)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const E=this._workspace.id,T=await this._getWorkspaceStorageURI(E);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(E){if(this._value)return A.URI.joinPath(this._value,E.identifier.value)}globalValue(E){return A.URI.joinPath(this._environment.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=v,e.ExtensionStoragePaths=v=je([$e(0,F.IExtHostInitDataService),$e(1,h.ILogService),$e(2,R.IExtHostConsumerFileSystem)],v)}),define(De[44],Ie([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,14,33]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,h.createDecorator)("IExtHostTerminalService");class c{constructor(p,m,f,P){this._proxy=p,this._id=m,this._creationOptions=f,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},get selection(){return M._selection},sendText(N,L=!0){M._checkDisposed(),M._proxy.$sendText(M._id,N,L)},show(N){M._checkDisposed(),M._proxy.$show(M._id,N)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(p,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??void 0,env:p.env??void 0,icon:a(p.iconPath)??void 0,color:w.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this._serializeParentTerminal(p.location,m?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,m,f,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:w.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(p,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(p,m){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in p?{viewColumn:r.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(p){this._name=p}setExitStatus(p,m){this._exitStatus=Object.freeze({code:p,reason:m})}setDimensions(p,m){return p===this._cols&&m===this._rows||p===0||m===0?!1:(this._cols=p,this._rows=m,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(p){this._selection=p}_setProcessId(p){this._pidPromiseComplete?(this._pidPromiseComplete(p),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==p&&(this._pidPromise=Promise.resolve(p))})}}e.ExtHostTerminal=c;class g{get onProcessReady(){return this._onProcessReady.event}constructor(p){this._pty=p,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${m}`)}async start(){}shutdown(){this._pty.close()}input(p){this._pty.handleInput?.(p)}resize(p,m){this._pty.setDimensions?.({columns:p,rows:m})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose?.((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions?.(m=>{m&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this._pty.onDidChangeName?.(m=>{this._onDidChangeProperty.fire({type:"title",value:m})}),this._pty.open(p||void 0),p&&this._pty.setDimensions?.(p),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends v.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(p=>p.value)}constructor(p,m,f){super(),this._extHostCommands=m,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new v.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=f.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(p),this._extHostCommands.registerArgumentProcessor({processArgument:P=>{const M=N=>{const L=N;return this._getTerminalById(L.instanceId)?.value};switch(P?.$mid){case 15:return M(P);default:{if(Array.isArray(P))for(let N=0;N<P.length&&P[N].$mid===15;N++)P[N]=M(P[N]);return P}}}}),this._register({dispose:()=>{for(const[P,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(p,m){const f=new c(this._proxy,(0,S.generateUuid)(),p,p.name),P=new g(p.pty);return f.createExtensionTerminal(p.location,this._serializeParentTerminal(p,m).resolvedExtHostIdentifier,a(p.iconPath),l(p.color)).then(M=>{const N=this._setupExtHostProcessListeners(M,P);this._terminalProcessDisposables[M]=N}),this._terminals.push(f),f.value}_serializeParentTerminal(p,m){if(m=m||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const f=p.location.parentTerminal;if(f){const P=this._terminals.find(M=>M.value===f);P&&(m.resolvedExtHostIdentifier=P._id)}}else p.location&&typeof p.location!="object"?m.location=p.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(p,m){if(!this._getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const P=new g(m),M=this._setupExtHostProcessListeners(p,P);this._terminalProcessDisposables[p]=M}async $acceptActiveTerminalChanged(p){const m=this._activeTerminal;if(p===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(p);f&&(this._activeTerminal=f,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(p,m){const f=this._getTerminalById(p);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:m})}async $acceptTerminalDimensions(p,m,f){const P=this._getTerminalById(p);P&&P.setDimensions(m,f)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(p,m){const f=this._getTerminalById(p);f&&this._onDidExecuteCommand.fire({terminal:f.value,...m})}async $acceptTerminalMaximumDimensions(p,m,f){this._terminalProcesses.get(p)?.resize(m,f)}async $acceptTerminalTitleChange(p,m){const f=this._getTerminalById(p);f&&(f.name=m)}async $acceptTerminalClosed(p,m,f){const P=this._getTerminalObjectIndexById(this._terminals,p);if(P!==null){const M=this._terminals.splice(P,1)[0];M.setExitStatus(m,f),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(p,m,f,P){if(m){const L=this._getTerminalObjectIndexById(this._terminals,m);if(L!==null){this._terminals[L]._id=p,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const M={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},N=new c(this._proxy,p,M,f);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(p,m){this._getTerminalById(p)?._setProcessId(m)}async $startExtensionTerminal(p,m){const f=this._getTerminalById(p);if(!f)return{message:(0,E.localize)(0,null,p)};f.isOpen||await new Promise(M=>{const N=this.onDidOpenTerminal(async L=>{L===f.value&&(N.dispose(),M())})});const P=this._terminalProcesses.get(p);P?P.startSendingEvents(m):this._extensionTerminalAwaitingStart[p]={initialDimensions:m}}_setupExtHostProcessListeners(p,m){const f=new v.DisposableStore;f.add(m.onProcessReady(M=>this._proxy.$sendProcessReady(p,M.pid,M.cwd,M.windowsPty))),f.add(m.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(p,M))),this._bufferer.startBuffering(p,m.onProcessData),f.add(m.onProcessExit(M=>this._onProcessExit(p,M))),this._terminalProcesses.set(p,m);const P=this._extensionTerminalAwaitingStart[p];return P&&m instanceof g&&(m.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[p]),f}$acceptProcessAckDataEvent(p,m){this._terminalProcesses.get(p)?.acknowledgeDataEvent(m)}$acceptProcessInput(p,m){this._terminalProcesses.get(p)?.input(m)}$acceptTerminalInteraction(p){const m=this._getTerminalById(p);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptTerminalSelection(p,m){this._getTerminalById(p)?.setSelection(m)}$acceptProcessResize(p,m,f){try{this._terminalProcesses.get(p)?.resize(m,f)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(p,m){this._terminalProcesses.get(p)?.shutdown(m)}$acceptProcessRequestInitialCwd(p){this._terminalProcesses.get(p)?.getInitialCwd().then(m=>this._proxy.$sendProcessProperty(p,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(p){this._terminalProcesses.get(p)?.getCwd().then(m=>this._proxy.$sendProcessProperty(p,{type:"cwd",value:m}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this._linkProviders.add(p),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(p),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(p,m,f){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,f),this._proxy.$registerProfileProvider(m,p.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(p,m,f){if(this._quickFixProviders.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this._quickFixProviders.set(p,f),this._proxy.$registerQuickFixProvider(p,m),new y.Disposable(()=>{this._quickFixProviders.delete(p),this._proxy.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,m){const f=new b.CancellationTokenSource().token;if(f.isCancellationRequested)return;const P=this._quickFixProviders.get(p);if(!P)return;const M=await P.provideTerminalQuickFixes(m,f);if(M===null||Array.isArray(M)&&M.length===0)return;const N=new v.DisposableStore;if(this._lastQuickFixCommands.value=N,!Array.isArray(M))return M?r.TerminalQuickFix.from(M,this._extHostCommands.converter,N):void 0;const L=[];for(const U of M){const x=r.TerminalQuickFix.from(U,this._extHostCommands.converter,N);x&&L.push(x)}return L}async $createContributedProfileTerminal(p,m){const f=new b.CancellationTokenSource().token;let P=await this._profileProviders.get(p)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(p,m){const f=this._getTerminalById(p);if(!f)return[];this._terminalLinkCache.delete(p),this._terminalLinkCancellationSource.get(p)?.dispose(!0);const M=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(p,M);const N=[],L={terminal:f.value,line:m},U=[];for(const j of this._linkProviders)U.push(u.Promises.withAsyncBody(async V=>{M.token.onCancellationRequested(()=>V({provider:j,links:[]}));const fe=await j.provideTerminalLinks(L,M.token)||[];M.token.isCancellationRequested||V({provider:j,links:fe})}));const x=await Promise.all(U);if(M.token.isCancellationRequested)return[];const O=new Map;for(const j of x)j&&j.links.length>0&&N.push(...j.links.map(V=>{const fe={id:d++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return O.set(fe.id,{provider:j.provider,link:V}),fe}));return this._terminalLinkCache.set(p,O),N}$activateLink(p,m){const f=this._terminalLinkCache.get(p)?.get(m);f&&f.provider.handleTerminalLink(f.link)}_onProcessExit(p,m){this._bufferer.stopBuffering(p),this._terminalProcesses.delete(p),delete this._extensionTerminalAwaitingStart[p];const f=this._terminalProcessDisposables[p];f&&(f.dispose(),delete this._terminalProcessDisposables[p]),this._proxy.$sendProcessExit(p,m)}_getTerminalById(p){return this._getTerminalObjectById(this._terminals,p)}_getTerminalObjectById(p,m){const f=this._getTerminalObjectIndexById(p,m);return f!==null?p[f]:null}_getTerminalObjectIndexById(p,m){const f=p.findIndex(P=>P._id===m);return f===-1?null:f}getEnvironmentVariableCollection(p){let m=this._environmentVariableCollections.get(p.identifier.value);return m||(m=new n,this._setEnvironmentVariableCollection(p.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(p,m){const f=(0,k.serializeEnvironmentVariableCollection)(m.map),P=(0,k.serializeEnvironmentDescriptionMap)(m.descriptionMap);this._proxy.$setEnvironmentVariableCollection(p,m.persistent,f.length===0?void 0:f,P)}$initEnvironmentVariableCollections(p){p.forEach(m=>{const f=m[0],P=new n(m[1]);this._setEnvironmentVariableCollection(f,P)})}$acceptDefaultProfile(p,m){const f=this._defaultProfile;this._defaultProfile=p,this._defaultAutomationProfile=m,f?.path!==p.path&&this._onDidChangeShell.fire(p.path)}_setEnvironmentVariableCollection(p,m){this._environmentVariableCollections.set(p,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(p,m)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=je([$e(1,o.IExtHostCommands),$e(2,A.IExtHostRpcService)],t);class n{get persistent(){return this._persistent}set persistent(p){this._persistent=p,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const m=this.getScopeKey(p);let f=this.scopedCollections.get(m);return f||(f=new s(this,p),this.scopedCollections.set(m,f),f.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),f}replace(p,m,f,P){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Replace,options:f??{applyAtProcessCreation:!0},scope:P})}append(p,m,f,P){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Append,options:f??{applyAtProcessCreation:!0},scope:P})}prepend(p,m,f,P){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Prepend,options:f??{applyAtProcessCreation:!0},scope:P})}_setIfDiffers(p,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const f=this.getKey(p,m.scope),P=this.map.get(f),M=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==M.applyAtProcessCreation||P.options?.applyAtShellIntegration!==M.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const N=this.getKey(p,m.scope),L={variable:p,...m,options:M};this.map.set(N,L),this._onDidChangeCollection.fire()}}get(p,m){const f=this.getKey(p,m),P=this.map.get(f);return P?C(P):void 0}getKey(p,m){const f=this.getScopeKey(m);return f.length?`${p}:::${f}`:p}getScopeKey(p){return this.getWorkspaceKey(p?.workspaceFolder)??""}getWorkspaceKey(p){return p?p.uri.toString():void 0}getVariableMap(p){const m=new Map;for(const[f,P]of this.map)this.getScopeKey(P.scope)===this.getScopeKey(p)&&m.set(P.variable,C(P));return m}delete(p,m){const f=this.getKey(p,m);this.map.delete(f),this._onDidChangeCollection.fire()}clear(p){if(p?.workspaceFolder){for(const[m,f]of this.map)f.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(m);this.clearDescription(p)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(p,m){const f=this.getScopeKey(m),P=this.descriptionMap.get(f);if(!P||P.description!==p){let M;typeof p=="string"?M=p:M=p?.value.split(`

`)[0];const N={description:M,scope:m};this.descriptionMap.set(f,N),this._onDidChangeCollection.fire()}}getDescription(p){const m=this.getScopeKey(p);return this.descriptionMap.get(m)?.description}clearDescription(p){const m=this.getScopeKey(p);this.descriptionMap.delete(m)}}class s{get persistent(){return this.collection.persistent}set persistent(p){this.collection.persistent=p}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p,m){this.collection=p,this.scope=m,this._onDidChangeCollection=new I.Emitter}getScoped(p){return this.collection.getScopedEnvironmentVariableCollection(p)}replace(p,m,f){this.collection.replace(p,m,f,this.scope)}append(p,m,f){this.collection.append(p,m,f,this.scope)}prepend(p,m,f){this.collection.prepend(p,m,f,this.scope)}get(p){return this.collection.get(p,this.scope)}forEach(p,m){this.collection.getVariableMap(this.scope).forEach((f,P)=>p.call(m,P,f,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(p){this.collection.delete(p,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(p){this.collection.setDescription(p,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let i=class extends t{constructor(p,m){super(!1,p,m)}createTerminal(p,m,f){throw new T.NotSupportedError}createTerminalFromOptions(p,m){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=i,e.WorkerExtHostTerminalService=i=je([$e(0,o.IExtHostCommands),$e(1,A.IExtHostRpcService)],i);function a(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function l(D){return w.ThemeColor.isThemeColor(D)?D:void 0}function C(D){const p={...D};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(De[327],Ie([1,0,118,9,22,21,4,74,52,3,23,18,31,6,20,145,14,7,67,109,87,27]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(L,U,x){this.editors=x,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(S.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new a(this.proxy),U.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const j=O,V=j.tests[j.tests.length-1].item.extId;return this.controllers.get(o.TestId.root(V))?.collection.tree.get(V)?.actual??(0,w.toItemFromContext)(O)}case 18:{const{extId:j,message:V}=O;return{test:this.controllers.get(o.TestId.root(j))?.collection.tree.get(j)?.actual,message:u.TestMessage.to(V)}}default:return O}}}),U.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await U.executeCommand("_testing.getExplorerSelection"),j=V=>{const fe=this.controllers.get(o.TestId.root(V));if(fe)return o.TestId.isRoot(V)?fe.controller:fe.collection.tree.get(V)?.actual};return{include:O?.include.map(j).filter(k.isDefined)||[],exclude:O?.exclude.map(j).filter(k.isDefined)||[]}})}createTestController(L,U,x,O){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const j=new E.DisposableStore,V=j.add(new w.ExtHostTestItemCollection(U,x,this.editors));V.root.label=x;const fe=new Map,J=this.proxy,X={items:V.root.children,get label(){return x},set label(Q){x=Q,V.root.label=Q,J.$updateController(U,{label:x})},get refreshHandler(){return O},set refreshHandler(Q){O=Q,J.$updateController(U,{canRefresh:!!Q})},get id(){return U},createRunProfile:(Q,ve,le,we,G,B)=>{let H=(0,y.hash)(Q);for(;fe.has(H);)H++;return new P(this.proxy,fe,U,H,Q,ve,le,we,G,B)},createTestItem(Q,ve,le){return new w.TestItemImpl(U,Q,ve,le)},createTestRun:(Q,ve,le=!0)=>this.runTracker.createTestRun(L,U,V,Q,ve,le),invalidateTestResults:Q=>{if(Q===void 0)this.proxy.$markTestRetired(void 0);else{const ve=Q instanceof Array?Q:[Q];this.proxy.$markTestRetired(ve.map(le=>o.TestId.fromExtHostTestItem(le,U).toString()))}},set resolveHandler(Q){V.resolveHandler=Q},get resolveHandler(){return V.resolveHandler},dispose:()=>{j.dispose()}};J.$registerTestController(U,x,!!O),j.add((0,E.toDisposable)(()=>J.$unregisterTestController(U)));const z={controller:X,collection:V,profiles:fe,extension:L};return this.controllers.set(U,z),j.add((0,E.toDisposable)(()=>this.controllers.delete(U))),j.add(V.onDidGenerateDiff(Q=>J.$publishDiff(U,Q.map(g.TestsDiffOp.serialize)))),X}createTestObserver(){return this.observer.checkout()}async runTests(L,U=R.CancellationToken.None){const x=l(L);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(x.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(j=>o.TestId.fromExtHostTestItem(j,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:M[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:L.exclude?.map(j=>j.id)},U)}$syncTests(){for(const{collection:L}of this.controllers.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,U,x){return(0,I.mapFindFirst)(this.runTracker.trackers,j=>j.id===L?j.getCoverage(U):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(L,U,x,O){return(0,I.mapFindFirst)(this.runTracker.trackers,V=>V.id===L?V.getCoverage(U):void 0)?.resolveFileCoverage(x,O)??Promise.resolve([])}$configureRunProfile(L,U){this.controllers.get(L)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(L,U){await this.controllers.get(L)?.controller.refreshHandler?.(U)}$publishTestResults(L){this.results=Object.freeze(L.map(U=>(0,T.deepFreeze)(u.TestResults.to(U))).concat(this.results).sort((U,x)=>x.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,U){const x=this.controllers.get(o.TestId.fromString(L).controllerId)?.collection;x&&(await x.expand(L,U<0?1/0:U),x.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(g.TestsDiffOp.deserialize))}async $runControllerTests(L,U){return Promise.all(L.map(x=>this.runControllerTestRequest(x,!1,U)))}async $startContinuousRun(L,U){const x=new R.CancellationTokenSource(U),O=await Promise.all(L.map(j=>this.runControllerTestRequest(j,!0,x.token)));return!U.isCancellationRequested&&!O.some(j=>j.error)&&await new Promise(j=>U.onCancellationRequested(j)),x.dispose(!0),O}async runControllerTestRequest(L,U,x){const O=this.controllers.get(L.controllerId);if(!O)return{};const{collection:j,profiles:V,extension:fe}=O,J=V.get(L.profileId);if(!J)return{};const X=L.testIds.map(le=>j.tree.get(le)).filter(k.isDefined),z=L.excludeExtIds.map(le=>O.collection.tree.get(le)).filter(k.isDefined).filter(le=>X.some(we=>we.fullId.compare(le.fullId)===2));if(!X.length)return{};const Q=new r.TestRunRequest(X.some(le=>le.actual instanceof w.TestItemRootImpl)?void 0:X.map(le=>le.actual),z.map(le=>le.actual),J,U),ve=(0,g.isStartControllerTests)(L)&&this.runTracker.prepareForMainThreadTestRun(Q,C.fromInternal(L,O.collection),fe,x);try{return await J.runHandler(Q,x),{}}catch(le){return{error:String(le)}}finally{ve&&(ve.hasRunningTasks&&!x.isCancellationRequested&&await A.Event.toPromise(ve.onEnd),ve.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};e.ExtHostTesting=t,e.ExtHostTesting=t=je([$e(0,_.IExtHostRpcService)],t);const n=1e4;var s;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(s||(s={}));class i extends E.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(L,U,x,O){super(),this.dto=L,this.proxy=U,this.extension=x,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(O));const j=this._register(new F.RunOnceScheduler(()=>this.forciblyEndTasks(),n));this._register(this.cts.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const U=this.dto.id,x=this.dto.controllerId,O=(0,b.generateUuid)(),j=new D(this.proxy,U,O),V=z=>(Q,...ve)=>{if(J){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Q)&&(this.ensureTestIsKnown(Q),z(Q,...ve))},fe=(z,Q)=>{const ve=Q instanceof Array?Q.map(u.TestMessage.from):[u.TestMessage.from(Q)];if(ve.some(le=>le.contextValue!==void 0)&&(0,d.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),z.uri&&z.range){const le={range:u.Range.from(z.range),uri:z.uri};for(const we of ve)we.location=we.location||le}this.proxy.$appendTestMessagesInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),ve)};let J=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return j.coverageProvider},set coverageProvider(z){j.coverageProvider=z},enqueued:V(z=>{this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),1)}),skipped:V(z=>{this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),5)}),started:V(z=>{this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),2)}),errored:V((z,Q,ve)=>{fe(z,Q),this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),6,ve)}),failed:V((z,Q,ve)=>{fe(z,Q),this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,x).toString(),4,ve)}),passed:V((z,Q)=>{this.proxy.$updateTestStateInRun(U,O,o.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,Q)}),appendOutput:(z,Q,ve)=>{J||(ve&&(this.dto.isIncluded(ve)?this.ensureTestIsKnown(ve):ve=void 0),this.proxy.$appendOutputToRun(U,O,h.VSBuffer.fromString(z),Q&&u.location.from(Q),ve&&o.TestId.fromExtHostTestItem(ve,x).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask(U,O),this.tasks.delete(O),this.tasks.size||this.markEnded())}};return this.tasks.set(O,{run:X,coverage:j}),this.proxy.$startedTestRunTask(U,{id:O,name:L,running:!0}),X}forciblyEndTasks(){for(const{run:L}of this.tasks.values())L.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(L){if(!(L instanceof w.TestItemImpl))throw new c.InvalidTestItemError(L.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const U=[],x=this.dto.colllection.root;for(;;){const O=u.TestItem.from(L);if(U.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),L===x))break;L=L.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}dispose(){this.markEnded(),super.dispose()}}class a{get trackers(){return this.tracked.values()}constructor(L){this.proxy=L,this.tracked=new Map}prepareForMainThreadTestRun(L,U,x,O){return this.getTracker(L,U,x,O)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.cancel();return}}cancelAllRuns(){for(const L of this.tracked.values())L.cancel()}createTestRun(L,U,x,O,j,V){const fe=this.tracked.get(O);if(fe)return fe.createRun(j);const J=C.fromPublic(U,x,O,V),X=l(O);this.proxy.$startedExtensionTestRun({controllerId:U,continuous:!!O.continuous,profile:X&&{group:M[X.kind],id:X.profileId},exclude:O.exclude?.map(Q=>o.TestId.fromExtHostTestItem(Q,x.root.id).toString())??[],id:J.id,include:O.include?.map(Q=>o.TestId.fromExtHostTestItem(Q,x.root.id).toString())??[x.root.id],persist:V});const z=this.getTracker(O,J,L);return A.Event.once(z.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(J.id),z.dispose()}),z.createRun(j)}getTracker(L,U,x,O){const j=new i(U,this.proxy,x,O);return this.tracked.set(L,j),A.Event.once(j.onEnd)(()=>this.tracked.delete(L)),j}}e.TestRunCoordinator=a;const l=N=>{if(N.profile){if(!(N.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class C{static fromPublic(L,U,x,O){return new C(L,(0,b.generateUuid)(),x.include?.map(j=>o.TestId.fromExtHostTestItem(j,L).toString())??[L],x.exclude?.map(j=>o.TestId.fromExtHostTestItem(j,L).toString())??[],O,U)}static fromInternal(L,U){return new C(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,U)}constructor(L,U,x,O,j,V){this.controllerId=L,this.id=U,this.isPersisted=j,this.colllection=V,this.includePrefix=x.map(fe=>fe+"\0"),this.excludePrefix=O.map(fe=>fe+"\0")}isIncluded(L){const U=o.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(U===x||U.startsWith(x))return!1;for(const x of this.includePrefix)if(U===x||U.startsWith(x))return!0;return!1}}e.TestRunDto=C;class D{set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(L,U,x){this.proxy=L,this.runId=U,this.taskId=x}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(L,U){const x=await this.fileCoverage;let O=x?.[L];return!this._coverageProvider||!x||!O?[]:(O.detailedCoverage||(O=x[L]=await this._coverageProvider.resolveFileCoverage?.(O,U)??O),O.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class p{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(L){this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(L){this.added.add(L)}update(L){Object.assign(L.revived,u.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}this.updated.delete(L);const U=o.TestId.parentId(L.item.extId);if(U&&this.alreadyRemoved.has(U.toString())){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:x}=this;return{get added(){return[...L].map(O=>O.revived)},get updated(){return[...U].map(O=>O.revived)},get removed(){return[...x].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return{...L,revived:u.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new p(this.changeEmitter)}}class f{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:(0,v.createSingleCallFunction)(()=>{--L.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class P{#e;#t;get label(){return this._label}set label(L){L!==this._label&&(this._label=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(L){L!==this._supportsContinuousRun&&(this._supportsContinuousRun=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?u.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,U,x,O,j,V,fe,J=!1,X=void 0,z=!1){this.controllerId=x,this.profileId=O,this._label=j,this.kind=V,this.runHandler=fe,this._isDefault=J,this._tag=X,this._supportsContinuousRun=z,this.#e=L,this.#t=U,U.set(O,this);const Q=M[V];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);this.#e.$publishTestRunProfile({profileId:O,controllerId:x,tag:X?u.TestTag.namespace(this.controllerId,X.id):null,label:j,group:Q,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P;const M={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(De[328],Ie([1,0,19,8,4,6,146,14,7]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(k,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new h.Emitter({onListenerError:F.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const b=this._extHostDocumentsAndEditors.allEditors();return k?b:b.map(S=>S.value)}async showTextDocument(k,b,S){let _;typeof b=="number"?_={position:v.ViewColumn.from(b),preserveFocus:S}:typeof b=="object"?_={position:v.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?v.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:_={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(k.uri,_),u=w&&this._extHostDocumentsAndEditors.getEditor(w);if(u)return u.value;throw w?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,b){return new A.TextEditorDecorationType(this._proxy,k,b).value}$acceptEditorPropertiesChanged(k,b){const S=this._extHostDocumentsAndEditors.getEditor(k);if(!S)throw new Error("unknown text editor");if(b.options&&S._acceptOptions(b.options),b.selections){const _=b.selections.selections.map(v.Selection.to);S._acceptSelections(_)}if(b.visibleRanges){const _=I.coalesce(b.visibleRanges.map(v.Range.to));S._acceptVisibleRanges(_)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...b.options,lineNumbers:v.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const _=y.TextEditorSelectionChangeKind.fromValue(b.selections.source),w=b.selections.selections.map(v.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:w,kind:_})}if(b.visibleRanges){const _=I.coalesce(b.visibleRanges.map(v.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:_})}}$acceptEditorPositionData(k){for(const b in k){const S=this._extHostDocumentsAndEditors.getEditor(b);if(!S)throw new Error("Unknown text editor");const _=v.ViewColumn.to(k[b]);S.value.viewColumn!==_&&(S._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:_}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=E}),define(De[329],Ie([1,0,2,5,6,3,7,14,25,18]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class T{constructor(S,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(h.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:(w,u)=>{if(w&&w.$mid===12)if(this._providers.get(w.source)&&y.ExtensionIdentifier.equals(u,this._providers.get(w.source)?.extension)){const r=w.uri===void 0?void 0:I.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(k(r))?.get(w.handle)}else return;return w}})}async $getTimeline(S,_,w,u){return this._providers.get(S)?.provider.provideTimeline(I.URI.revive(_),w,u)}registerTimelineProvider(S,_,w,u){const r=new R.DisposableStore,o=this.convertTimelineItem(_.id,u,r).bind(this);let c;_.onDidChange&&(c=_.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:_.id}),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:S,onDidChange:void 0,async provideTimeline(d,t,n){t?.resetCache&&(r.clear(),g.get(_.id)?.clear());const s=await _.provideTimeline(d,t,n);if(s==null)return;const i=o(d,t);return{...s,source:_.id,items:s.items.map(i)}},dispose(){for(const d of g.values())d.get(_.id)?.clear();c?.dispose(),r.dispose()}},w)}convertTimelineItem(S,_,w){return(u,r)=>{let o;if(r?.cacheResults){let c=this._itemsBySourceAndUriMap.get(S);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(S,c));const g=k(u);o=c.get(g),o===void 0&&(o=new Map,c.set(g,o))}return c=>{const{iconPath:g,...d}=c,t=`${S}|${c.id??c.timestamp}`;o?.set(t,c);let n,s,i;c.iconPath&&(g instanceof A.ThemeIcon?i={id:g.id,color:g.color}:I.URI.isUri(g)?(n=g,s=g):{light:n,dark:s}=g);let a;return A.MarkdownString.isMarkdownString(d.tooltip)?a=v.MarkdownString.from(d.tooltip):(0,E.isString)(d.tooltip)?a=d.tooltip:A.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=v.MarkdownString.from(d.detail)):(0,E.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=d.detail),{...d,id:d.id??void 0,handle:t,source:S,command:c.command?_.toInternal(c.command,w):void 0,icon:n,iconDark:s,themeIcon:i,tooltip:a,accessibilityInformation:c.accessibilityInformation}}}}registerTimelineProviderCore(S,_){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:_}),(0,R.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=T;function k(b){return b?.toString()}}),define(De[72],Ie([1,0,21,4,3,213,5,13,86,6,26,20,7]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class S extends y.DisposableTunnel{}var _;(function(u){function r(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:c.protocol}}u.fromApiTunnel=r;function o(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==y.TunnelPrivacyId.ConstantPrivate&&c.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}u.fromServiceTunnel=o})(_||(e.TunnelDtoConverter=_={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let w=class extends h.Disposable{constructor(r,o,c){super(),this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new F.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=r.getProxy(E.MainContext.MainThreadTunnelService)}async openTunnel(r,o){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${o.remoteAddress.host}:${o.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(o,r.displayName);if(c){const g=new S(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(g),g}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(r,o){const c=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(c,{selector:r,provider:o}),this._proxy.$registerPortsAttributesProvider(r,c),new b.Disposable(()=>{this._portAttributesProviders.delete(c),this._proxy.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(r,o,c,g,d){const t=[];for(const s of r){const i=this._portAttributesProviders.get(s);if(!i)return[];t.push(...await Promise.all(o.map(async a=>{let l;try{l=await i.provider.providePortAttributes({port:a,pid:c,commandLine:g},d)}catch{l=await i.provider.providePortAttributes(a,c,g,d)}return{providedAttributes:l,port:a}})))}const n=t.filter(s=>!!s.providedAttributes);return n.length>0?n.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,o){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(g,d)=>await r.provideTunnel(g,d,new I.CancellationTokenSource().token)??void 0;const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,privacyOptions:o.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(c),Promise.resolve((0,h.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,o){if(r){r.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this._showCandidatePort=r.showCandidatePort,this._proxy.$setCandidateFilter());const c=r.tunnelFactory??(o?this.makeManagedTunnelFactory(o):void 0);if(c){this._forwardPortProvider=c;let g=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&g.length===0&&(g=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const d=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:g}:void 0;this._proxy.$setTunnelProvider(d)}}else this._forwardPortProvider=void 0;return(0,h.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(r){}async $closeTunnel(r,o){if(this._extensionTunnels.has(r.host)){const c=this._extensionTunnels.get(r.host);c.has(r.port)&&(o&&c.get(r.port).disposeListener.dispose(),await c.get(r.port).tunnel.dispose(),c.delete(r.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(r,o){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(r,o);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const g=await c;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),g===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(r.remoteAddress.host)||this._extensionTunnels.set(r.remoteAddress.host,new Map);const d=this._register(g.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(g.remoteAddress))));return this._extensionTunnels.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:g,disposeListener:d}),_.fromApiTunnel(g)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(r){const o=await Promise.all(r.map(g=>this._showCandidatePort(g.host,g.port,g.detail??""))),c=r.filter((g,d)=>o[d]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(g=>g.port).join(", ")} to ${c.map(g=>g.port).join(", ")}`),c}};e.ExtHostTunnelService=w,e.ExtHostTunnelService=w=je([$e(0,k.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,v.ILogService)],w)}),define(De[330],Ie([1,0,3,17,2,6]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,E,T,k){if(this._openers.has(E))throw new Error(`Opener with id '${E}' already registered`);const b=k.schemes.find(S=>!A.supportedSchemes.has(S));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(E,T),this._proxy.$registerUriOpener(E,k.schemes,y,k.label),(0,I.toDisposable)(()=>{this._openers.delete(E),this._proxy.$unregisterUriOpener(E)})}async $canOpenUri(y,E,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const b=h.URI.revive(E);return k.canOpenExternalUri(b,T)}async $openUri(y,E,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(h.URI.revive(E.resolvedUri),{sourceUri:h.URI.revive(E.sourceUri)},T)}}e.ExtHostUriOpeners=A}),define(De[331],Ie([1,0,6,2,3,8,25]),function(ge,e,I,F,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class v{static{this.HandlePool=0}constructor(E){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(E,T){const k=E.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const b=v.HandlePool++;return this.handles.add(k),this.handlers.set(b,T),this._proxy.$registerUriHandler(b,k,E.displayName||E.name),(0,h.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(E,T){const k=this.handlers.get(E);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(T))}catch(b){(0,R.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(E){return F.URI.revive(await this._proxy.$createAppUri(E))}}e.ExtHostUrls=v}),define(De[91],Ie([1,0,4,3,17,23,2,228,265,110,6]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class k{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(g,d,t,n,s,i,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=g,this.#t=d,this.#r=t,this.#u=n,this.#l=s,this.#n=i,this.#c=b(i),this.#h=S(i),this.#i=a}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return this.#a=!0,(0,E.asWebviewUri)(g,this.#u)}get cspSource(){const g=this.#n.extensionLocation;if(g.scheme===h.Schemas.https||g.scheme===h.Schemas.http){let d=g.toString();return d.endsWith("/")||(d+="/"),d+" "+E.webviewGenericCspSource}return E.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(g){this.assertNotDisposed(),this.#s!==g&&(this.#s=g,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(g)))}get options(){return this.assertNotDisposed(),this.#r}set options(g){this.assertNotDisposed(),R.equals(this.#r,g)||this.#t.$setOptions(this.#e,u(this.#n,this.#l,g)),this.#r=g}async postMessage(g){if(this.#o)return!1;const d=(0,y.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(g){if(!this.#h)return g;const d=this.#n.extensionLocation?.scheme===h.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===h.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,s,i,a,l,C)=>{const D=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),p=(0,E.asWebviewUri)(D,{isRemote:d,authority:t}).toString();return`${s}${p}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,s,i,a,l,C)=>{const D=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),p=(0,E.asWebviewUri)(D,{isRemote:d,authority:t}).toString();return`${s}${p}${C}`})}}e.ExtHostWebview=k;function b(c){try{const g=(0,v.normalizeVersion)((0,v.parseVersion)(c.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=b;function S(c){try{const g=(0,v.normalizeVersion)((0,v.parseVersion)(c.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class _ extends F.Disposable{constructor(g,d,t,n,s){super(),this.remoteInfo=d,this.workspace=t,this._logService=n,this._deprecationService=s,this._webviews=new Map,this._webviewProxy=g.getProxy(T.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const g of this._webviews.values())g.dispose();this._webviews.clear()}$onMessage(g,d,t){const n=this.getWebview(g);if(n){const{message:s}=(0,y.deserializeWebviewMessage)(d,t.value);n._onMessageEmitter.fire(s)}}$onMissingCsp(g,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,d,t){const n=new k(g,this._webviewProxy,r(d),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(g,n);const s=n._onDidDispose(()=>{s.dispose(),this.deleteWebview(g)});return n}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=_;function w(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=w;function u(c,g,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||o(c,g)}}e.serializeWebviewOptions=u;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(g=>A.URI.from(g))}}function o(c,g){return[...(g?.getWorkspaceFolders()||[]).map(d=>d.uri),c.extensionLocation]}}),define(De[332],Ie([1,0,21,52,3,17,24,2,14,91,107,6,7]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(n,s){this.document=n,this._storagePath=s,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,s){await this.getEdit(n).undo(),s||this.disposeBackup()}async redo(n,s){await this.getEdit(n).redo(),s||this.disposeBackup()}disposeEdits(n){for(const s of n)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=d(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const s=this._edits.get(n,0);if(!s)throw new Error("No edit found");return s}}class _{constructor(){this._documents=new Map}get(n,s){return this._documents.get(this.key(n,s))}add(n,s,i){const a=this.key(n,s.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${n} resource:${s.uri}`);const l=new S(s,i);return this._documents.set(a,l),l}delete(n,s){const i=this.key(n,s.uri);this._documents.delete(i)}key(n,s){return`${n}@@@${s}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class u{constructor(){this._providers=new Map}addTextProvider(n,s,i){return this.add(0,n,s,i)}addCustomProvider(n,s,i){return this.add(1,n,s,i)}get(n){return this._providers.get(n)}add(n,s,i,a){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:n,extension:i,provider:a}),new b.Disposable(()=>this._providers.delete(s))}}class r{constructor(n,s,i,a,l){this._extHostDocuments=s,this._extensionStoragePaths=i,this._extHostWebview=a,this._extHostWebviewPanels=l,this._editorProviders=new u,this._documents=new _,this._proxy=n.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,s,i,a){const l=new h.DisposableStore;return c(i)?(l.add(this._editorProviders.addTextProvider(s,n,i)),this._proxy.$registerTextEditorProvider((0,E.toExtensionData)(n),s,a.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,E.shouldSerializeBuffersForPostMessage)(n))):(l.add(this._editorProviders.addCustomProvider(s,n,i)),o(i)&&l.add(i.onDidChangeCustomDocument(C=>{const D=this.getCustomDocumentEntry(s,C.document.uri);if(g(C)){const p=D.addEdit(C);this._proxy.$onDidEdit(C.document.uri,s,p,C.label)}else this._proxy.$onContentChange(C.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,E.toExtensionData)(n),s,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,E.shouldSerializeBuffersForPostMessage)(n))),b.Disposable.from(l,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(n,s,i,a,l){const C=this._editorProviders.get(s);if(!C)throw new Error(`No provider found for '${s}'`);if(C.type!==1)throw new Error(`Invalid provide type for '${s}'`);const D=v.URI.revive(n),p=await C.provider.openCustomDocument(D,{backupId:i,untitledDocumentData:a?.buffer},l);let m;return o(C.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(C.extension)??this._extensionStoragePaths.globalValue(C.extension)),this._documents.add(s,p,m),{editable:o(C.provider)}}async $disposeCustomDocument(n,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${s}'`);const a=v.URI.revive(n),{document:l}=this.getCustomDocumentEntry(s,a);this._documents.delete(s,l),l.dispose()}async $resolveCustomEditor(n,s,i,a,l,C){const D=this._editorProviders.get(i);if(!D)throw new Error(`No provider found for '${i}'`);const p=y.ViewColumn.to(l),m=this._extHostWebview.createNewWebview(s,a.contentOptions,D.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(s,i,a.title,p,a.options,m,a.active),P=v.URI.revive(n);switch(D.type){case 1:{const{document:M}=this.getCustomDocumentEntry(i,P);return D.provider.resolveCustomEditor(M,f,C)}case 0:{const M=this._extHostDocuments.getDocument(P);return D.provider.resolveCustomTextEditor(M,f,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,s,i){this.getCustomDocumentEntry(s,n).disposeEdits(i)}async $onMoveCustomEditor(n,s,i){const a=this._editorProviders.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this._extHostWebviewPanels.getWebviewPanel(n);if(!l)throw new Error("No webview found");const C=v.URI.revive(s),D=this._extHostDocuments.getDocument(C);await a.provider.moveCustomTextEditor(D,l,I.CancellationToken.None)}async $undo(n,s,i,a){return this.getCustomDocumentEntry(s,n).undo(i,a)}async $redo(n,s,i,a){return this.getCustomDocumentEntry(s,n).redo(i,a)}async $revert(n,s,i){const a=this.getCustomDocumentEntry(s,n);await this.getCustomEditorProvider(s).revertCustomDocument(a.document,i),a.disposeBackup()}async $onSave(n,s,i){const a=this.getCustomDocumentEntry(s,n);await this.getCustomEditorProvider(s).saveCustomDocument(a.document,i),a.disposeBackup()}async $onSaveAs(n,s,i,a){const l=this.getCustomDocumentEntry(s,n);return this.getCustomEditorProvider(s).saveCustomDocumentAs(l.document,v.URI.revive(i),a)}async $backup(n,s,i){const a=this.getCustomDocumentEntry(s,n),C=await this.getCustomEditorProvider(s).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},i);return a.updateBackup(C),C.id}getCustomDocumentEntry(n,s){const i=this._documents.get(n,v.URI.revive(s));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(n){const i=this._editorProviders.get(n)?.provider;if(!i||!o(i))throw new Error("Custom document is not editable");return i}}e.ExtHostCustomEditors=r;function o(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function g(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const n=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,F.hash)(n)+""}}),define(De[333],Ie([1,0,4,3,2,31,14,91,6,7]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends F.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(_,w,u,r){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=_,this.#t=w,this.#u=u,this.#i=r.viewType,this.#l=r.panelOptions,this.#r=r.viewColumn,this.#n=r.title,this.#a=r.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(_){this.assertNotDisposed(),this.#n!==_&&(this.#n=_,this.#t.$setTitle(this.#e,_))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#t.$setIconPath(this.#e,h.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(_){this.#c||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(this.#a=_.active,this.#o=_.visible,this.#r=_.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(_,w){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof _>"u"?void 0:A.ViewColumn.from(_),preserveFocus:!!w})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class k extends F.Disposable{static newHandle(){return(0,R.generateUuid)()}constructor(_,w,u){super(),this.webviews=w,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(_=>_.dispose()),this._webviewPanels.clear()}createWebviewPanel(_,w,u,r,o={}){const c=typeof r=="object"?r.viewColumn:r,g={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof r=="object"&&!!r.preserveFocus},d=(0,v.shouldSerializeBuffersForPostMessage)(_),t=k.newHandle();this._proxy.$createWebviewPanel((0,v.toExtensionData)(_),t,w,{title:u,panelOptions:b(o),webviewOptions:(0,v.serializeWebviewOptions)(_,this.workspace,o),serializeBuffersForPostMessage:d},g);const n=this.webviews.createNewWebview(t,o,_);return this.createNewWebviewPanel(t,w,u,c,o,n,!0)}$onDidChangeWebviewPanelViewStates(_){const w=Object.keys(_);w.sort((u,r)=>{const o=_[u],c=_[r];return o.active?1:c.active?-1:+o.visible-+c.visible});for(const u of w){const r=this.getWebviewPanel(u);if(!r)continue;const o=_[u];r._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(_){this.getWebviewPanel(_)?.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,w,u){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:u,extension:_}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,v.shouldSerializeBuffersForPostMessage)(_)}),new E.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(_,w,u,r){const o=this._serializers.get(w);if(!o)throw new Error(`No serializer found for '${w}'`);const{serializer:c,extension:g}=o,d=this.webviews.createNewWebview(_,u.webviewOptions,g),t=this.createNewWebviewPanel(_,w,u.title,r,u.panelOptions,d,u.active);await c.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(_,w,u,r,o,c,g){const d=new T(_,this._proxy,c,{viewType:w,title:u,viewColumn:r,panelOptions:o,active:g});return this._webviewPanels.set(_,d),d}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=k;function b(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(De[334],Ie([1,0,4,3,91,14,6,7]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends F.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(k,b,S,_,w,u){super(),this.#l=!1,this.#a=this._register(new I.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new I.Emitter),this.onDidDispose=this.#c.event,this.#i=S,this.#s=_,this.#e=k,this.#t=b,this.#u=w,this.#n=u}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(k){this.assertNotDisposed(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.assertNotDisposed(),this.#r}set description(k){this.assertNotDisposed(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#l||(this.#n=k,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(k){this.assertNotDisposed(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.assertNotDisposed(),this.#t.$show(this.#e,!!k)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class E{constructor(k,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(k,b,S,_){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:S,extension:k}),this._proxy.$registerWebviewViewProvider((0,h.toExtensionData)(k),b,{retainContextWhenHidden:_?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.shouldSerializeBuffersForPostMessage)(k)}),new v.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(k,b,S,_,w){const u=this._viewProviders.get(b);if(!u)throw new Error(`No view provider found for '${b}'`);const{provider:r,extension:o}=u,c=this._extHostWebview.createNewWebview(k,{},o),g=new y(k,this._proxy,b,S,c,!0);this._webviewViews.set(k,g),await r.resolveWebviewView(g,{state:_},w)}async $onDidChangeWebviewViewVisibility(k,b){this.getWebviewView(k)._setVisible(b)}async $disposeWebviewView(k){const b=this.getWebviewView(k);this._webviewViews.delete(k),b.dispose(),this._extHostWebview.deleteWebview(k)}getWebviewView(k){const b=this._webviewViews.get(k);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=E}),define(De[151],Ie([1,0,4,6,2,17,15,5,20,27]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class{static{T=this}static{this.InitialState={focused:!0,active:!0}}getState(S){const _=this._state;return{get focused(){return _.focused},get active(){return(0,E.checkProposedApiEnabled)(S,"windowActivity"),_.active}}}constructor(S){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=T.InitialState,this._proxy=S.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:_,isActive:w})=>{this.onDidChangeWindowProperty("focused",_),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,_){_!==this._state[S]&&(this._state={...this._state,[S]:_},this._onDidChangeWindowState.fire(this._state))}openUri(S,_){let w;if(typeof S=="string"){w=S;try{S=h.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,w,_)}async asExternalUri(S,_){if((0,A.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(S,_);return h.URI.from(w)}};e.ExtHostWindow=k,e.ExtHostWindow=k=T=je([$e(0,y.IExtHostRpcService)],k),e.IExtHostWindow=(0,v.createDecorator)("IExtHostWindow")}),define(De[335],Ie([1,0,303,26,20]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let A=class extends I.AbstractExtHostConsoleForwarder{constructor(y,E){super(y,E),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,E,T){const k=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),E.apply(console,T),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,E){const T=process[y],k=T.write;let b="";Object.defineProperty(T,"write",{set:()=>{},get:()=>(S,_,w)=>{if(!this._isMakingConsoleCall){b+=S.toString(_);const u=b.length>R?b.length:b.lastIndexOf(`
`);u!==-1&&(console[E](b.slice(0,u)),b=b.slice(u+1))}k.call(T,S,_,w)}})}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=je([$e(0,h.IExtHostRpcService),$e(1,F.IExtHostInitDataService)],A)}),define(De[336],Ie([1,0,71,17,13,240,30,12]),function(ge,e,I,F,h,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let y=class{constructor(k,b){k.addFileSystemProvider(F.Schemas.file,new E(b),{isCaseSensitive:v.isLinux})}};e.ExtHostDiskFileSystemProvider=y,e.ExtHostDiskFileSystemProvider=y=je([$e(0,I.IExtHostConsumerFileSystem),$e(1,h.ILogService)],y);class E{constructor(k){this.logService=k,this.impl=new R.DiskFileSystemProvider(this.logService)}async stat(k){const b=await this.impl.stat(k);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(k){return this.impl.readdir(k)}createDirectory(k){return this.impl.mkdir(k)}readFile(k){return this.impl.readFile(k)}writeFile(k,b,S){return this.impl.writeFile(k,b,{...S,unlock:!1,atomic:!1})}delete(k,b){return this.impl.delete(k,{...b,useTrash:!1,atomic:!1})}rename(k,b,S){return this.impl.rename(k,b,S)}copy(k,b,S){return this.impl.copy(k,b,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(k,b){throw new Error("Method not implemented.")}}}),define(De[337],Ie([1,0,16,63,31,33,3,6,2,20]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends A.Disposable{constructor(b,S){super();const _=b.getProxy(v.MainContext.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async w=>{const u=y.URI.file((0,I.join)((0,F.tmpdir)(),(0,h.generateUuid)()));return await _.$download(w,u),u})}};e.ExtHostDownloadService=T,e.ExtHostDownloadService=T=je([$e(0,E.IExtHostRpcService),$e(1,R.IExtHostCommands)],T)}),define(De[338],Ie([1,0,150,17,242,31]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends I.ExtHostLoggerService{doCreateLogger(y,E,T){return y.scheme===F.Schemas.file?new h.SpdLogLogger(T?.name||(0,R.generateUuid)(),y.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,E):super.doCreateLogger(y,E,T)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=A}),define(De[339],Ie([1,0,53,16,2,90,3,17,9,29]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends R.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const n=await super._getWorkspaceStorageURI(t);if(n.scheme!==v.Schemas.file)return n;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const s=n.fsPath;let i=0;do{let a;i===0?a=s:a=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await k(a);const l=F.join(a,"vscode.lock"),C=await w(this._logService,l,!1);if(C)return this._workspaceStorageLock=C,process.on("exit",()=>{C.dispose()}),h.URI.file(a);i++}while(i<10);return n}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function k(d){try{await E.Promises.stat(d);return}catch{}try{await E.Promises.mkdir(d,{recursive:!0})}catch{}}const b=1e3,S=10*60*1e3;class _ extends A.Disposable{constructor(t,n){super(),this.logService=t,this.filename=n,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await u(t,n);(!s||s.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this._timer.cancel());try{await E.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{I.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.filename,JSON.stringify(n),{flag:"w"})}catch(n){this.logService.error(n)}}}async function w(d,t,n){try{const i={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){d.error(i)}const s=await u(d,t);return!s||s.pid!==process.pid?n?(d.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(d.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(d,t)):(d.info(`Lock '${t}': Lock acquired.`),new _(d,t))}async function u(d,t){let n;try{n=await E.Promises.readFile(t)}catch(s){return d.error(s),null}try{return JSON.parse(String(n))}catch(s){return d.error(s),null}}async function r(d,t){let n;try{n=await E.Promises.stat(t)}catch(s){return d.error(s),0}return n.mtime.getTime()}function o(d){try{return process.kill(d,0),!0}catch{return!1}}async function c(d,t){const n=await u(d,t);if(!n)return d.info(`Lock '${t}': Could not read pid of lock holder.`),g(d,t);if(n.willReleaseAt){let C=n.willReleaseAt-Date.now();if(C<5e3){for(C>0?d.info(`Lock '${t}': The lockfile is scheduled to be released in ${C} ms.`):d.info(`Lock '${t}': The lockfile is scheduled to have been released.`);C>0;){if(await(0,y.timeout)(Math.min(100,C)),await r(d,t)===0)return g(d,t);C=n.willReleaseAt-Date.now()}return g(d,t)}}if(!o(n.pid))return d.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),g(d,t);const s=await r(d,t),i=Date.now()-s;if(i<=S)return d.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;d.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const a=await r(d,t),l=Date.now()-a;return l<=S?(d.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(d.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),g(d,t))}async function g(d,t){d.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return w(d,t,!0)}}),define(De[340],Ie([1,0,31,20,44,33]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends h.BaseExtHostTerminalService{constructor(y,E){super(!0,y,E)}createTerminal(y,E,T){return this.createTerminalFromOptions({name:y,shellPath:E,shellArgs:T})}createTerminalFromOptions(y,E){const T=new h.ExtHostTerminal(this._proxy,(0,I.generateUuid)(),y,y.name);return this._terminals.push(T),T.create(y,this._serializeParentTerminal(y,E)),T.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=je([$e(0,R.IExtHostCommands),$e(1,F.IExtHostRpcService)],A)}),define(De[341],Ie([1,0,9,22,21,8,4,3,128,292,68]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function b(f,P){try{return JSON.stringify(f,P)}catch{return"null"}}const S="$$ref$$",_={[S]:-1};class w{constructor(P,M){this.jsonString=P,this.referencedBuffers=M}}function u(f,P=null,M=!1){const N=[];return{jsonString:(M?b:JSON.stringify)(f,(U,x)=>{if(typeof x>"u")return _;if(typeof x=="object"){if(x instanceof F.VSBuffer){const O=N.push(x)-1;return{[S]:O}}if(P)return P(U,x)}return x}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=u;function r(f,P,M){return JSON.parse(f,(N,L)=>{if(L){const U=L[S];if(typeof U=="number")return P[U];if(M&&L.$mid===1)return M.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=r;function o(f,P){return JSON.stringify(f,P)}function c(f){return f?(P,M)=>M&&M.$mid===1?f.transformOutgoing(M):M:null}var g;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var d;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},n=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends v.Disposable{static{k=n}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(P,M=null,N=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=M,this._uriTransformer=N,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,U=T.ProxyIdentifier.count;L<U;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{const M=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],M.resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:M,sid:N}=P;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,N)),this._proxies[M]}_createProxy(P,M){const N={get:(L,U)=>(typeof U=="string"&&!L[U]&&U.charCodeAt(0)===36&&(L[U]=(...x)=>this._remoteCall(P,U,x)),U===s?M:L[U])};return new Proxy(Object.create(null),N)}set(P,M){return this._locals[P.nid]=M,M}assertRegistered(P){for(let M=0,N=P.length;M<N;M++){const L=P[M];if(!this._locals[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const M=P.byteLength,N=l.read(P,0),L=N.readUInt8(),U=N.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:O,args:j}=D.deserializeRequestJSONArgs(N);this._uriTransformer&&(j=(0,y.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(M,U,x,O,j,L===2);break}case 3:case 4:{let{rpcId:x,method:O,args:j}=D.deserializeRequestMixedArgs(N);this._uriTransformer&&(j=(0,y.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(M,U,x,O,j,L===4);break}case 5:{this._logger?.logIncoming(M,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(M,U);break}case 7:{this._receiveReply(M,U,void 0);break}case 9:{let x=D.deserializeReplyOKJSON(N);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(M,U,x);break}case 10:{const x=D.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(M,U,x);break}case 8:{const x=D.deserializeReplyOKVSBuffer(N);this._receiveReply(M,U,x);break}case 11:{let x=D.deserializeReplyErrError(N);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(M,U,x);break}case 12:{this._receiveReplyErr(M,U,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,M,N,L,U,x){this._logger?.logIncoming(P,M,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(N)}.${L}(`,U);const O=String(M);let j,V;if(x){const J=new h.CancellationTokenSource;U.push(J.token),j=this._invokeHandler(N,L,U),V=()=>J.cancel()}else j=this._invokeHandler(N,L,U),V=t;this._cancelInvokedHandlers[O]=V;const fe=D.serializeAcknowledged(M);this._logger?.logOutgoing(fe.byteLength,M,1,"ack"),this._protocol.send(fe),j.then(J=>{delete this._cancelInvokedHandlers[O];const X=D.serializeReplyOK(M,J,this._uriReplacer);this._logger?.logOutgoing(X.byteLength,M,1,"reply:",J),this._protocol.send(X)},J=>{delete this._cancelInvokedHandlers[O];const X=D.serializeReplyErr(M,J);this._logger?.logOutgoing(X.byteLength,M,1,"replyErr:",J),this._protocol.send(X)})}_receiveCancel(P,M){this._logger?.logIncoming(P,M,1,"receiveCancel");const N=String(M);this._cancelInvokedHandlers[N]?.()}_receiveReply(P,M,N){this._logger?.logIncoming(P,M,0,"receiveReply:",N);const L=String(M);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],U.resolveOk(N)}_receiveReplyErr(P,M,N){this._logger?.logIncoming(P,M,0,"receiveReplyErr:",N);const L=String(M);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;N&&(N.$isError?(x=new Error,x.name=N.name,x.message=N.message,x.stack=N.stack):x=N),U.resolveErr(x)}_invokeHandler(P,M,N){try{return Promise.resolve(this._doInvokeHandler(P,M,N))}catch(L){return Promise.reject(L)}}_doInvokeHandler(P,M,N){const L=this._locals[P];if(!L)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(P));const U=L[M];if(typeof U!="function")throw new Error("Unknown method "+M+" on actor "+(0,T.getStringIdentifierForProxy)(P));return U.apply(L,N)}_remoteCall(P,M,N){if(this._isDisposed)return new E.CanceledLazyPromise;let L=null;if(N.length>0&&h.CancellationToken.isCancellationToken(N[N.length-1])&&(L=N.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const U=D.serializeRequestArguments(N,this._uriReplacer),x=++this._lastMessageId,O=String(x),j=new E.LazyPromise,V=new v.DisposableStore;L&&V.add(L.onCancellationRequested(()=>{const J=D.serializeCancel(x);this._logger?.logOutgoing(J.byteLength,x,0,"cancel"),this._protocol.send(D.serializeCancel(x))})),this._pendingRPCReplies[O]=new a(j,V),this._onWillSendRequest(x);const fe=D.serializeRequest(x,P,M,U,!!L);return this._logger?.logOutgoing(fe.byteLength,x,0,`request: ${(0,T.getStringIdentifierForProxy)(P)}.${M}(`,N),this._protocol.send(fe),j}}e.RPCProtocol=i;class a{constructor(P,M){this._promise=P,this._disposable=M}resolveOk(P){this._promise.resolveOk(P),this._disposable.dispose()}resolveErr(P){this._promise.resolveErr(P),this._disposable.dispose()}}class l{static alloc(P,M,N){const L=new l(F.VSBuffer.alloc(N+1+4),0);return L.writeUInt8(P),L.writeUInt32(M),L}static read(P,M){return new l(P,M)}get buffer(){return this._buff}constructor(P,M){this._buff=P,this._offset=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,N}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,N}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,M}static sizeMixedArray(P){let M=0;M+=1;for(let N=0,L=P.length;N<L;N++){const U=P[N];switch(M+=1,U.type){case 1:M+=this.sizeLongString(U.value);break;case 2:M+=this.sizeVSBuffer(U.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(U.value);for(let x=0;x<U.buffers.length;++x)M+=this.sizeVSBuffer(U.buffers[x]);break;case 4:break}}return M}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let M=0,N=P.length;M<N;M++){const L=P[M];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let U=0;U<L.buffers.length;++U)this.writeBuffer(L.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(P);for(let N=0;N<P;N++)switch(this.readUInt8()){case 1:M[N]=this.readLongString();break;case 2:M[N]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),x=this.readLongString(),O=[];for(let j=0;j<U;++j)O.push(this.readVSBuffer());M[N]=new T.SerializableObjectWithBuffers(r(x,O,null));break}case 4:M[N]=void 0;break}return M}}var C;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(C||(C={}));class D{static _useMixedArgSerialization(P){for(let M=0,N=P.length;M<N;M++)if(P[M]instanceof F.VSBuffer||P[M]instanceof T.SerializableObjectWithBuffers||typeof P[M]>"u")return!0;return!1}static serializeRequestArguments(P,M){if(this._useMixedArgSerialization(P)){const N=[];for(let L=0,U=P.length;L<U;L++){const x=P[L];if(x instanceof F.VSBuffer)N[L]={type:2,value:x};else if(typeof x>"u")N[L]={type:4};else if(x instanceof T.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:j}=u(x.value,M);N[L]={type:3,value:F.VSBuffer.fromString(O),buffers:j}}else N[L]={type:1,value:F.VSBuffer.fromString(o(x,M))}}return{type:1,args:N}}return{type:0,args:o(P,M)}}static serializeRequest(P,M,N,L,U){switch(L.type){case 0:return this._requestJSONArgs(P,M,N,L.args,U);case 1:return this._requestMixedArgs(P,M,N,L.args,U)}}static _requestJSONArgs(P,M,N,L,U){const x=F.VSBuffer.fromString(N),O=F.VSBuffer.fromString(L);let j=0;j+=l.sizeUInt8(),j+=l.sizeShortString(x),j+=l.sizeLongString(O);const V=l.alloc(U?2:1,P,j);return V.writeUInt8(M),V.writeShortString(x),V.writeLongString(O),V.buffer}static deserializeRequestJSONArgs(P){const M=P.readUInt8(),N=P.readShortString(),L=P.readLongString();return{rpcId:M,method:N,args:JSON.parse(L)}}static _requestMixedArgs(P,M,N,L,U){const x=F.VSBuffer.fromString(N);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(x),O+=l.sizeMixedArray(L);const j=l.alloc(U?4:3,P,O);return j.writeUInt8(M),j.writeShortString(x),j.writeMixedArray(L),j.buffer}static deserializeRequestMixedArgs(P){const M=P.readUInt8(),N=P.readShortString(),L=P.readMixedArray(),U=new Array(L.length);for(let x=0,O=L.length;x<O;x++){const j=L[x];typeof j=="string"?U[x]=JSON.parse(j):U[x]=j}return{rpcId:M,method:N,args:U}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,M,N){if(typeof M>"u")return this._serializeReplyOKEmpty(P);if(M instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(P,M);if(M instanceof T.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:U}=u(M.value,N,!0);return this._serializeReplyOKJSONWithBuffers(P,L,U)}else return this._serializeReplyOKJSON(P,b(M,N))}static _serializeReplyOKEmpty(P){return l.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,M){let N=0;N+=l.sizeVSBuffer(M);const L=l.alloc(8,P,N);return L.writeVSBuffer(M),L.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,M){const N=F.VSBuffer.fromString(M);let L=0;L+=l.sizeLongString(N);const U=l.alloc(9,P,L);return U.writeLongString(N),U.buffer}static _serializeReplyOKJSONWithBuffers(P,M,N){const L=F.VSBuffer.fromString(M);let U=0;U+=l.sizeUInt32,U+=l.sizeLongString(L);for(const O of N)U+=l.sizeVSBuffer(O);const x=l.alloc(10,P,U);x.writeUInt32(N.length),x.writeLongString(L);for(const O of N)x.writeBuffer(O);return x.buffer}static deserializeReplyOKJSON(P){const M=P.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(P,M){const N=P.readUInt32(),L=P.readLongString(),U=[];for(let x=0;x<N;++x)U.push(P.readVSBuffer());return new T.SerializableObjectWithBuffers(r(L,U,M))}static serializeReplyErr(P,M){const N=M?b(R.transformErrorForSerialization(M),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(P);const L=F.VSBuffer.fromString(N);let U=0;U+=l.sizeLongString(L);const x=l.alloc(11,P,U);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(P){const M=P.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(P){return l.alloc(12,P,0).buffer}}var p;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var m;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(m||(m={}))}),define(De[342],Ie([1,0,4,42,41,5]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new h.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new h.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new h.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var A;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(T=>E.push(T)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}F.Registry.add(e.Extensions.OutputChannels,new v),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new h.RawContextKey("activeOutputChannel","")}),define(De[152],Ie([1,0,6,5,20,25,13,342,71,26,55,178,22,18,30,4,3]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class r extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(d,t,n,s,i){super(),this.id=d,this.name=t,this.logger=n,this.proxy=s,this.extension=i,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(n.getLevel()),this._register(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.offset;this.info(d),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(d,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.proxy.$close(this.id)}log(d,t){this.offset+=b.VSBuffer.fromString(t).byteLength,(0,A.log)(this.logger,d,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class o extends r{appendLine(d){this.append(d)}}let c=class{constructor(d,t,n,s,i,a){this.initData=t,this.extHostFileSystem=n,this.extHostFileSystemInfo=s,this.loggerService=i,this.logService=a,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[t,n]of this.channels)n.visible=t===this.visibleChannelId}createOutputChannel(d,t,n){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,i=(0,S.isString)(t)?t:void 0;if((0,S.isString)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const l=this.initData.environment.extensionLogLevel?.find(([D])=>R.ExtensionIdentifier.equals(n.identifier,D))?.[1];l&&(a=(0,A.parseLogLevel)(l));const C=s?this.doCreateLogOutputChannel(d,a,n):this.doCreateOutputChannel(d,i,n);return C.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(d,a??this.logService.getLevel(),C):this.createExtHostOutputChannel(d,C)}async doCreateOutputChannel(d,t,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,i=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.proxy.$register(d,i,t,n.identifier.value);return new r(l,d,a,this.proxy,n)}async doCreateLogOutputChannel(d,t,n){const s=await this.createExtensionLogDirectory(n),i=d.replace(/[\\/:\*\?"<>\|]/g,""),a=this.extHostFileSystemInfo.extUri.joinPath(s,`${i}.log`),l=`${n.identifier.value}.${i}`,C=this.loggerService.createLogger(a,{id:l,name:d,logLevel:t,extensionId:n.identifier.value});return new o(l,d,C,this.proxy,n)}createExtensionLogDirectory(d){let t=this.extensionLogDirectoryPromise.get(d.identifier.value);if(!t){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,d.identifier.value);this.extensionLogDirectoryPromise.set(d.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(s){if((0,_.toFileSystemProviderErrorCode)(s)!==_.FileSystemProviderErrorCode.FileExists)throw s}return n})())}return t}createExtHostOutputChannel(d,t){let n=!1;const s=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return d},append(i){s(),t.then(a=>a.append(i))},appendLine(i){s(),t.then(a=>a.appendLine(i))},clear(){s(),t.then(i=>i.clear())},replace(i){s(),t.then(a=>a.replace(i))},show(i,a){s(),t.then(l=>l.show(i,a))},hide(){s(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}createExtHostLogOutputChannel(d,t,n){const s=new u.DisposableStore,i=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},a=s.add(new w.Emitter);function l(C){t=C,a.fire(C)}return n.then(C=>{s.add(C),C.logLevel!==t&&l(C.logLevel),s.add(C.onDidChangeLogLevel(D=>l(D)))}),{...this.createExtHostOutputChannel(d,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(C,...D){i(),n.then(p=>p.trace(C,...D))},debug(C,...D){i(),n.then(p=>p.debug(C,...D))},info(C,...D){i(),n.then(p=>p.info(C,...D))},warn(C,...D){i(),n.then(p=>p.warn(C,...D))},error(C,...D){i(),n.then(p=>p.error(C,...D))},dispose(){s.dispose()}}}};e.ExtHostOutputService=c,e.ExtHostOutputService=c=je([$e(0,h.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,T.IExtHostFileSystemInfo),$e(4,A.ILoggerService),$e(5,A.ILogService)],c),e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(De[343],Ie([1,0,5,9]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let R=1/0;for(let v=0;v<this.maxSampleCount;v++){const y=await h.getRoundTripTime();if(y===void 0)return;R=Math.min(R,y/2),await(0,F.timeout)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((v,y)=>v+y,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((v,y)=>v+y,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ie([1,0,32,17,16,12,24,2,5,258,43,147,343]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let _=S=class{constructor(u,r,o,c){this.localUserHome=u,this.remoteAgentService=r,this.environmentService=o,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome??u})()}hasValidBasename(u,r,o){return typeof r=="string"||typeof r>"u"?this.resolveOS.then(c=>this.doHasValidBasename(u,c,r)):this.doHasValidBasename(u,r,o)}doHasValidBasename(u,r,o){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,I.isValidBasename)(o??(0,A.basename)(u),r===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,r){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const o=(0,E.getVirtualWorkspaceScheme)(r.getWorkspace());if(o)return o;const c=r.getWorkspace().folders[0];if(c)return c.uri.scheme;const g=r.getWorkspace().configuration;return g?g.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?h.win32:h.posix)}async fileURI(u){let r="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const c=u.indexOf("/",2);c===-1?(r=u.substring(2),u="/"):(r=u.substring(2,c),u=u.substring(c)||"/")}return v.URI.from({scheme:F.Schemas.file,authority:r,path:u,query:"",fragment:""})}};e.AbstractPathService=_,e.AbstractPathService=_=S=je([$e(1,b.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,T.IWorkspaceContextService)],_)}),define(De[345],Ie([1,0,225,19,57,4,52,3,2,49,230,13,64,260,86,43,147,27,21,18,23,41]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new d.RawContextKey("forwardedPortsViewEnabled",!1,I.localize(0,null));function s(M){const N=M.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.parseAddress=s;var i;(function(M){M.Other="Other",M.User="User",M.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var a;(function(M){M[M.User=0]="User",M[M.Auto=1]="Auto",M[M.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.UserTunnelSource={source:a.User,description:I.localize(1,null)},e.AutoTunnelSource={source:a.Auto,description:I.localize(2,null)};function l(M,N,L){const U=M.get(D(N,L));if(U)return U;if((0,_.isLocalhost)(N))for(const x of _.LOCALHOST_ADDRESSES){const O=D(x,L);if(M.has(O))return M.get(O)}else if((0,_.isAllInterfaces)(N))for(const x of _.ALL_INTERFACES_ADDRESSES){const O=D(x,L);if(M.has(O))return M.get(O)}}e.mapHasAddress=l;function C(M,N,L){const U=l(M,N,L);if(U)return U;const x=(0,_.isAllInterfaces)(N)?"localhost":(0,_.isLocalhost)(N)?"0.0.0.0":void 0;if(x)return l(M,x,L)}e.mapHasAddressLocalhostOrAllInterfaces=C;function D(M,N){return M+":"+N}e.makeAddress=D;var p;(function(M){M.Notify="notify",M.OpenBrowser="openBrowser",M.OpenBrowserOnce="openBrowserOnce",M.OpenPreview="openPreview",M.Silent="silent",M.Ignore="ignore"})(p||(e.OnPortForward=p={}));function m(M){return M&&"host"in M&&typeof M.host=="string"&&"port"in M&&typeof M.port=="number"&&(!("detail"in M)||typeof M.detail=="string")&&(!("pid"in M)||typeof M.pid=="string")}e.isCandidatePort=m;class f extends v.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.configurationService=N,this.portsAttributes=[],this._onDidChangeAttributes=new R.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(N.onDidChangeConfiguration(L=>{(L.affectsConfiguration(f.SETTING)||L.affectsConfiguration(f.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(N,L,U){let x=this.findNextIndex(N,L,U,this.portsAttributes,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;x>=0;){const j=this.portsAttributes[x];j.key===N?(O.onAutoForward=j.onAutoForward??O.onAutoForward,O.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:O.elevateIfNeeded,O.label=j.label??O.label,O.requireLocalPort=j.requireLocalPort,O.protocol=j.protocol):(O.onAutoForward=O.onAutoForward??j.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:j.elevateIfNeeded,O.label=O.label??j.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??j.protocol),x=this.findNextIndex(N,L,U,this.portsAttributes,x+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.getOtherAttributes()}hasStartEnd(N){return N.start!==void 0&&N.end!==void 0}hasHostAndPort(N){return N.host!==void 0&&N.port!==void 0&&(0,c.isString)(N.host)&&(0,c.isNumber)(N.port)}findNextIndex(N,L,U,x,O){if(O>=x.length)return-1;const j=!(0,_.isLocalhost)(L)&&!(0,_.isAllInterfaces)(L),fe=x.slice(O).findIndex(J=>(0,c.isNumber)(J.key)?j?!1:J.key===N:this.hasStartEnd(J.key)?j?!1:N>=J.key.start&&N<=J.key.end:this.hasHostAndPort(J.key)?N===J.key.port&&L===J.key.host:U?J.key.test(U):!1);return fe>=0?fe+O:-1}readSetting(){const N=this.configurationService.getValue(f.SETTING);if(!N||!(0,c.isObject)(N))return[];const L=[];for(const x in N){if(x===void 0)continue;const O=N[x];let j;if(Number(x))j=Number(x);else if((0,c.isString)(x))if(f.RANGE.test(x)){const V=x.match(f.RANGE);j={start:Number(V[1]),end:Number(V[2])}}else if(f.HOST_AND_PORT.test(x)){const V=x.match(f.HOST_AND_PORT);j={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(x)}catch{}V&&(j=V)}j&&L.push({key:j,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const U=this.configurationService.getValue(f.DEFAULTS);return U&&(this.defaultPortAttributes={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.sortAttributes(L)}sortAttributes(N){function L(U,x){return(0,c.isNumber)(U.key)?U.key:x.hasStartEnd(U.key)?U.key.start:x.hasHostAndPort(U.key)?U.key.port:Number.MAX_VALUE}return N.sort((U,x)=>L(U,this)-L(x,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(N){switch(N){case _.ProvidedOnAutoForward.Notify:return p.Notify;case _.ProvidedOnAutoForward.OpenBrowser:return p.OpenBrowser;case _.ProvidedOnAutoForward.OpenBrowserOnce:return p.OpenBrowserOnce;case _.ProvidedOnAutoForward.OpenPreview:return p.OpenPreview;case _.ProvidedOnAutoForward.Silent:return p.Silent;case _.ProvidedOnAutoForward.Ignore:return p.Ignore;default:return}}async addAttributes(N,L,U){const O=this.configurationService.inspect(f.SETTING).userRemoteValue;let j;!O||!(0,c.isObject)(O)?j={}:j=(0,g.deepClone)(O),j[`${N}`]||(j[`${N}`]={});for(const V in L)j[`${N}`][V]=L[V];return this.configurationService.updateValue(f.SETTING,j,U)}}e.PortsAttributes=f;let P=class extends v.Disposable{constructor(N,L,U,x,O,j,V,fe,J,X){super(),this.tunnelService=N,this.storageService=L,this.configurationService=U,this.environmentService=x,this.remoteAuthorityResolverService=O,this.workspaceContextService=j,this.logService=V,this.dialogService=fe,this.extensionService=J,this.contextKeyService=X,this.inProgress=new Map,this._onForwardPort=new R.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new R.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new R.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new R.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new R.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new R.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new f(U),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async z=>{const Q=await this.getAttributes(z.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of z)if(ve.localAddress){const le=D(ve.tunnelRemoteHost,ve.tunnelRemotePort),we=C(this._candidates??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(le,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:Q?.get(ve.tunnelRemotePort)?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(ve.localAddress,Q?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:ve.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(le,ve)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async z=>{const Q=D(z.tunnelRemoteHost,z.tunnelRemotePort);if(!C(this.forwarded,z.tunnelRemoteHost,z.tunnelRemotePort)&&!C(this.detected,z.tunnelRemoteHost,z.tunnelRemotePort)&&!C(this.inProgress,z.tunnelRemoteHost,z.tunnelRemotePort)&&z.localAddress){const ve=C(this._candidates??new Map,z.tunnelRemoteHost,z.tunnelRemotePort),le=(await this.getAttributes([{port:z.tunnelRemotePort,host:z.tunnelRemoteHost}]))?.get(z.tunnelRemotePort);this.forwarded.set(Q,{remoteHost:z.tunnelRemoteHost,remotePort:z.tunnelRemotePort,localAddress:z.localAddress,protocol:le?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(z.localAddress,le),localPort:z.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:z.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(Q,z),this._onForwardPort.fire(this.forwarded.get(Q))})),this._register(this.tunnelService.onTunnelClosed(z=>this.onTunnelClosed(z,i.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(N=>N.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const N=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&N.dispose()}))}async onTunnelClosed(N,L){const U=D(N.host,N.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.storeForwarded(),this._onClosePort.fire(N))}makeLocalUri(N,L){if(N.startsWith("http"))return y.URI.parse(N);const U=L?.protocol??"http";return y.URI.parse(`${U}://${N}`)}async getStorageKey(){const N=this.workspaceContextService.getWorkspace(),L=N.configuration?(0,A.hash)(N.configuration.path):N.folders.length>0?(0,A.hash)(N.folders[0].uri.path):void 0;if(L===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.environmentService.remoteAuthority}.${L}`}async getTunnelRestoreValue(){const N=this.storageService.get(n,1);if(N)return this.storageService.remove(n,1),await this.storeForwarded(),N;const L=await this.getStorageKey();if(L)return this.storageService.get(L,0)}async restoreForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const N=await this.tunnelRestoreValue;if(N&&N!==this.knownPortsRestoreValue){const L=JSON.parse(N)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${L.map(U=>U.remotePort).join(", ")}`);for(const U of L){const x=C(this.detected,U.remoteHost,U.remotePort);U.source.source!==a.Extension&&!x||U.source.source===a.Extension&&x?await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===a.Extension&&!x&&this.unrestoredExtensionTunnels.set(D(U.remoteHost,U.remotePort),U)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const N=await this.getStorageKey();this.restoreListener=this._register(new v.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async L=>{L.key===N&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(N,0)),await this.restoreForwarded())}))}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.knownPortsRestoreValue){this.knownPortsRestoreValue=N;const L=await this.getStorageKey();L&&this.storageService.store(L,this.knownPortsRestoreValue,0,0)}}}async showPortMismatchModalIfNeeded(N,L,U){if(!N.tunnelLocalPort||!U?.requireLocalPort||N.tunnelLocalPort===L)return;const x=new Date;if(this.mismatchCooldown.getTime()+t>x.getTime())return;this.mismatchCooldown=x;const O=I.localize(3,null,L,N.tunnelRemotePort,N.tunnelLocalPort);return this.dialogService.info(O)}async forward(N,L){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await R.Event.toPromise(this.onRestoreComplete.event),this.doForward(N,L)}async doForward(N,L){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const U=C(this.forwarded,N.remote.host,N.remote.port);L=L??(L!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const x=N.local!==void 0?N.local:N.remote.port;let O;if(U)return this.mergeAttributesIntoExistingTunnel(U,N,L);{const j=this.environmentService.remoteAuthority,V=j?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(j)).authority}:void 0,fe=D(N.remote.host,N.remote.port);this.inProgress.set(fe,!0),N=this.mergeCachedAndUnrestoredProperties(fe,N);const J=await this.tunnelService.openTunnel(V,N.remote.host,N.remote.port,void 0,x,N.elevateIfNeeded?N.elevateIfNeeded:L?.elevateIfNeeded,N.privacy,L?.protocol);if(typeof J=="string")O=J;else if(J&&J.localAddress){const X=C(this._candidates??new Map,N.remote.host,N.remote.port),z=J.protocol?J.protocol===_.TunnelProtocol.Https?_.TunnelProtocol.Https:_.TunnelProtocol.Http:L?.protocol??_.TunnelProtocol.Http,Q={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:L?.label??N.name,closeable:!0,localAddress:J.localAddress,protocol:z,localUri:await this.makeLocalUri(J.localAddress,L),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:N.source??e.UserTunnelSource,privacy:J.privacy};return this.forwarded.set(fe,Q),this.remoteTunnels.set(fe,J),this.inProgress.delete(fe),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(J,x,L),this._onForwardPort.fire(Q),J}this.inProgress.delete(fe)}return O}mergeCachedAndUnrestoredProperties(N,L){const U=this.unrestoredExtensionTunnels.has(N)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(N)?this.sessionCachedProperties:void 0;if(U){const x=U.get(N);U.delete(N),x&&(L.name=x.name??L.name,L.local=("local"in x?x.local:"localPort"in x?x.localPort:void 0)??L.local,L.privacy=x.privacy??L.privacy)}return L}async mergeAttributesIntoExistingTunnel(N,L,U){const x=U?.label??L.name;let O;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(O||(O={}));let j=O.None;switch(x!==N.name&&(N.name=x,j=O.Fire),(U?.protocol||N.protocol!==_.TunnelProtocol.Http)&&U?.protocol!==N.protocol&&(L.source=N.source,j=O.Reopen),L.privacy&&N.privacy!==L.privacy&&(j=O.Reopen),j){case O.Fire:{this._onForwardPort.fire();break}case O.Reopen:await this.close(N.remoteHost,N.remotePort,i.User),await this.doForward(L,U)}return C(this.remoteTunnels,L.remote.host,L.remote.port)}async name(N,L,U){const x=C(this.forwarded,N,L),O=D(N,L);if(x){x.name=U,await this.storeForwarded(),this._onPortName.fire({host:N,port:L});return}else this.detected.has(O)&&(this.detected.get(O).name=U,this._onPortName.fire({host:N,port:L}))}async close(N,L,U){const x=D(N,L),O=this.forwarded.get(x);return U===i.AutoForwardEnd&&O&&O.source.source===a.Auto&&this.sessionCachedProperties.set(x,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.tunnelService.closeTunnel(N,L),this.onTunnelClosed({host:N,port:L},U)}address(N,L){const U=D(N,L);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(N){if(N)for(const L of N){const U=C(this._candidates??new Map,L.remoteAddress.host,L.remoteAddress.port),x=typeof L.localAddress=="string"?L.localAddress:D(L.localAddress.host,L.localAddress.port);this.detected.set(D(L.remoteAddress.host,L.remoteAddress.port),{remoteHost:L.remoteAddress.host,remotePort:L.remoteAddress.port,localAddress:x,protocol:_.TunnelProtocol.Http,localUri:this.makeLocalUri(x),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:_.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:I.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(L.remoteAddress.host,L.remoteAddress.port,x,_.TunnelPrivacyId.ConstantPrivate,_.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(N){this._candidateFilter=N}async setCandidates(N){let L=N;this._candidateFilter&&(L=await this._candidateFilter(N));const U=this.updateInResponseToCandidates(L);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(x=>x.port).join(", ")}`),this._onCandidatesChanged.fire(U)}updateInResponseToCandidates(N){const L=this._candidates??new Map,U=new Map;return this._candidates=U,N.forEach(x=>{const O=D(x.host,x.port);U.set(O,{host:x.host,port:x.port,detail:x.detail,pid:x.pid}),L.has(O)&&L.delete(O);const j=C(this.forwarded,x.host,x.port);j&&(j.runningProcess=x.detail,j.hasRunningProcess=!0,j.pid=x.pid)}),L.forEach((x,O)=>{const j=s(O);if(!j)return;const V=C(this.forwarded,j.host,j.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const fe=C(this.detected,j.host,j.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),L}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const N=Array.from(this.forwarded.values()),L=await this.getAttributes(N.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(L)for(const U of N){const x=L.get(U.remotePort);(x?.protocol||U.protocol!==_.TunnelProtocol.Http)&&x?.protocol!==U.protocol&&await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},x),x&&x.label&&x.label!==U.name&&await this.name(U.remoteHost,U.remotePort,x.label)}}async getAttributes(N,L=!0){const U=new Map,x=new Map;N.forEach(J=>{const X=C(this._candidates??new Map,_.LOCALHOST_ADDRESSES[0],J.port)??J;if(X){U.set(J.port,X);const z=m(X)?X.pid:void 0;x.has(z)||x.set(z,[]),x.get(z)?.push(J.port)}});const O=new Map;if(N.forEach(J=>{const X=this.configPortsAttributes.getAttributes(J.port,J.host,U.get(J.port)?.detail);X&&O.set(J.port,X)}),this.portAttributesProviders.length===0||!L)return O.size>0?O:void 0;const j=await Promise.all((0,F.flatten)(this.portAttributesProviders.map(J=>Array.from(x.entries()).map(X=>{const z=X[1],Q=U.get(z[0]);return J.providePortAttributes(z,Q?.pid,Q?.detail,new o.CancellationTokenSource().token)})))),V=new Map;if(j.forEach(J=>J.forEach(X=>{X&&V.set(X.port,X)})),!O&&!V)return;const fe=new Map;return N.forEach(J=>{const X=O.get(J.port),z=V.get(J.port);fe.set(J.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??f.providedActionToAction(z?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),fe}addAttributesProvider(N){this.portAttributesProviders.push(N)}};e.TunnelModel=P,je([(0,h.debounce)(1e3)],P.prototype,"storeForwarded",null),e.TunnelModel=P=je([$e(0,_.ITunnelService),$e(1,S.IStorageService),$e(2,E.IConfigurationService),$e(3,u.IWorkbenchEnvironmentService),$e(4,b.IRemoteAuthorityResolverService),$e(5,w.IWorkspaceContextService),$e(6,k.ILogService),$e(7,T.IDialogService),$e(8,r.IExtensionService),$e(9,d.IContextKeyService)],P)}),define(De[92],Ie([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(A,v){this.line=A,this.character=v}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,v){return new I(0,0)}with(A){return new I(0,0)}}e.Position=I;class F{constructor(A,v,y,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,v),this.end=new I(y,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var h;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(De[36],Ie([1,0,19,35,23,32,15,5,16,8,92,9]),function(ge,e,I,F,h,R,A,v,y,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const b="\u27EA ",S=" characters skipped \u27EB",_=(b.length+S.length+5)*2;e.ISearchService=(0,v.createDecorator)("searchService");var w;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(w||(e.SearchProviderType=w={}));var u;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(u||(e.QueryType=u={}));function r(z){return!!z.preview}e.resultIsMatch=r;function o(z){return!!z.resource}e.isFileMatch=o;function c(z){return!!z.message}e.isProgressMessage=c;var g;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(g||(e.SearchCompletionExitCode=g={}));class d{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=d;class t{constructor(Q,ve,le,we){this.ranges=ve,this.webviewIndex=we;const G=Array.isArray(ve)?ve:[ve];if(le&&le.matchLines===1&&n(G)){Q=(0,A.getNLines)(Q,le.matchLines);let B="",H=0,me=0;const Z=Math.floor(le.charsPerLine/5),ie=[];for(const re of G){const ye=Math.max(re.startColumn-Z,0),oe=re.startColumn+le.charsPerLine;if(ye>me+Z+_){const de=b+(ye-me)+S;B+=de+Q.slice(ye,oe),H+=ye-(me+de.length)}else B+=Q.slice(me,oe);ie.push(new i(0,re.startColumn-H,re.endColumn-H)),me=oe}this.preview={text:B,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const B=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:Q,matches:(0,I.mapArrayOrNot)(ve,H=>new s(H.startLineNumber-B,H.startColumn,H.endLineNumber-B,H.endColumn))}}}}e.TextSearchMatch=t;function n(z){const Q=z[0].startLineNumber;for(const ve of z)if(ve.startLineNumber!==Q||ve.endLineNumber!==Q)return!1;return!0}class s{constructor(Q,ve,le,we){this.startLineNumber=Q,this.startColumn=ve,this.endLineNumber=le,this.endColumn=we}}e.SearchRange=s;class i extends s{constructor(Q,ve,le){super(Q,ve,Q,le)}}e.OneLineRange=i;var a;(function(z){z.List="list",z.Tree="tree"})(a||(e.ViewMode=a={}));var l;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function C(z,Q=!0){const ve=z&&z.files&&z.files.exclude,le=Q&&z&&z.search&&z.search.exclude;if(!ve&&!le)return;if(!ve||!le)return ve||le;let we=Object.create(null);return we=h.mixin(we,h.deepClone(ve)),we=h.mixin(we,h.deepClone(le),!0),we}e.getExcludes=C;function D(z,Q){return z.excludePattern&&F.match(z.excludePattern,Q)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&F.match(z.includePattern,Q)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(ve=>{const le=ve.folder.fsPath;if(R.isEqualOrParent(Q,le)){const we=y.relative(le,Q);return!ve.includePattern||!!F.match(ve.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=D;var p;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class m extends Error{constructor(Q,ve){super(Q),this.code=ve}}e.SearchError=m;function f(z){const Q=z.message;if((0,E.isCancellationError)(z))return new m(Q,p.canceled);try{const ve=JSON.parse(Q);return new m(ve.message,ve.code)}catch{return new m(Q,p.other)}}e.deserializeSearchError=f;function P(z){const Q={message:z.message,code:z.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=P;function M(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=M;function N(z){return z.type==="success"}e.isSerializedSearchSuccess=N;function L(z){return!!z.path}e.isSerializedFileMatch=L;function U(z,Q){const ve=z.searchPath?z.searchPath:z.relativePath;return(0,A.fuzzyContains)(ve,Q)}e.isFilePatternMatch=U;class x{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function O(z,Q){const ve={...z||{},...Q||{}};return Object.keys(ve).filter(le=>{const we=ve[le];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=O;class j{constructor(Q,ve){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...ve.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let le=Q.includePattern;ve.includePattern&&(le?le={...le,...ve.includePattern}:le=ve.includePattern),le&&(this._parsedIncludeExpression=F.parse(le))}matchesExcludesSync(Q,ve,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,ve,le))}includedInQuerySync(Q,ve,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,ve,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,ve,le))}includedInQuery(Q,ve,le){const we=this._parsedExcludeExpression(Q,ve,le),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Q,ve,le):!0;return(0,k.isThenable)(we)?we.then(B=>B?!1:G()):G()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=j;function V(z){for(const Q in z)if(typeof z[Q]!="boolean")return!0;return!1}function fe(z){if(!z)return;let Q;return ve=>(Q||(Q=(z()||Promise.resolve([])).then(le=>le?X(le):{})),Q.then(le=>!!le[ve]))}e.hasSiblingPromiseFn=fe;function J(z){if(!z)return;let Q;return ve=>{if(!Q){const le=z();Q=le?X(le):{}}return!!Q[ve]}}e.hasSiblingFn=J;function X(z){const Q={};for(const ve of z)Q[ve]=!0;return Q}}),define(De[39],Ie([1,0,19,9,21,4,3,77,17,120,24,15,2,214,5,13,243,43,55,26,20,14,7,66,36,6]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(M,N,L){return new T.ExtUri(U=>p(U,L)).isEqual(M,N)}function l(M,N,L){return a(M.uri,N.uri,L)?0:(0,k.compare)(M.uri.toString(),N.uri.toString())}function C(M,N,L){return M.index!==N.index?M.index<N.index?-1:1:a(M.uri,N.uri,L)?(0,k.compare)(M.name,N.name):(0,k.compare)(M.uri.toString(),N.uri.toString())}function D(M,N,L,U){const x=M.slice(0).sort((j,V)=>L(j,V,U)),O=N.slice(0).sort((j,V)=>L(j,V,U));return(0,I.delta)(x,O,(j,V)=>L(j,V,U))}function p(M,N){const L=N.getCapabilities(M.scheme);return!(L&&L&1024)}class m extends r.Workspace{static toExtHostWorkspace(N,L,U,x){if(!N)return{workspace:null,added:[],removed:[]};const{id:O,name:j,folders:V,configuration:fe,transient:J,isUntitled:X}=N,z=[],Q=L;L?V.forEach((G,B)=>{const H=b.URI.revive(G.uri),me=m._findFolder(U||L,H,x);me?(me.name=G.name,me.index=G.index,z.push(me)):z.push({uri:H,name:G.name,index:B})}):z.push(...V.map(({uri:G,name:B,index:H})=>({uri:b.URI.revive(G),name:B,index:H}))),z.sort((G,B)=>G.index<B.index?-1:1);const ve=new m(O,j,z,!!J,fe?b.URI.revive(fe):null,!!X,G=>p(G,x)),{added:le,removed:we}=D(Q?Q.workspaceFolders:[],ve.workspaceFolders,l,x);return{workspace:ve,added:le,removed:we}}static _findFolder(N,L,U){for(let x=0;x<N.folders.length;x++){const O=N.workspaceFolders[x];if(a(O.uri,L,U))return O}}constructor(N,L,U,x,O,j,V){super(N,U.map(fe=>new r.WorkspaceFolder(fe)),x,O,V),this._name=L,this._isUntitled=j,this._workspaceFolders=[],this._structure=v.TernarySearchTree.forUris(V),U.forEach(fe=>{this._workspaceFolders.push(fe),this._structure.set(fe.uri,fe)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,L){return L&&this._structure.get(N)&&(N=(0,T.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let f=class{constructor(N,L,U,x,O){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=x,this._extHostFileSystemInfo=U,this._uriTransformerService=O,this._requestIdProvider=new E.Counter,this._barrier=new F.Barrier,this._proxy=N.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(i.MainContext.MainThreadMessageService);const j=L.workspace;this._confirmedWorkspace=j?new m(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,V=>p(V,U)):void 0}$initializeWorkspace(N,L){this._trusted=L,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,L,U,...x){const O=[];if(Array.isArray(x)&&x.forEach(X=>{b.URI.isUri(X.uri)&&!O.some(z=>a(z.uri,X.uri,this._extHostFileSystemInfo))&&O.push({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[L,U].some(X=>typeof X!="number"||X<0)||U===0&&O.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+U>j.length)return!1;const V=j.slice(0);V.splice(L,U,...O.map(X=>({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<V.length;X++){const z=V[X];if(V.some((Q,ve)=>ve!==X&&a(z.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((X,z)=>X.index=z);const{added:fe,removed:J}=D(j,V,C,this._extHostFileSystemInfo);if(fe.length===0&&J.length===0)return!1;if(this._proxy){const X=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(X,L,U,O).then(void 0,z=>{this._unconfirmedWorkspace=void 0;const Q={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(u.Severity.Error,(0,S.localize)(0,null,X,z.toString()),Q,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(N,L){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,L)}async getWorkspaceFolder2(N,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,L)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,L){let U,x="";if(typeof N=="string"?(U=b.URI.file(N),x=N):typeof N<"u"&&(U=N,x=N.fsPath),!U)return x;const O=this.getWorkspaceFolder(U,!0);if(!O)return x;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let j=(0,T.relativePath)(O.uri,U);return L&&O.name&&(j=`${O.name}/${j}`),j}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:L,added:U,removed:x}=m.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:x}))}findFiles(N,L,U,x,O=h.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let j;if(L===null?j=!1:L&&(typeof L=="string"?j=L:j=L.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:fe}=P(d.GlobPattern.from(N));return this._proxy.$startFileSearch(V??null,fe??null,j??null,U??null,O).then(J=>Array.isArray(J)?J.map(X=>b.URI.revive(X)):[])}async findTextInFiles(N,L,U,x,O=h.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),V=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:fe,folder:J}=P(d.GlobPattern.from(L.include)),X=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,z={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:V,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:fe,excludePattern:X},Q=!1;if(this._activeSearchCallbacks[j]=ve=>{if(Q)return;const le=b.URI.revive(ve.resource);ve.results.forEach(we=>{(0,s.resultIsMatch)(we)?U({uri:le,preview:{text:we.preview.text,matches:(0,I.mapArrayOrNot)(we.preview.matches,G=>new t.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,I.mapArrayOrNot)(we.ranges,G=>new t.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):U({uri:le,text:we.text,lineNumber:we.lineNumber})})},O.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(N,J??null,z,j,O);return delete this._activeSearchCallbacks[j],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[j],ve}}$handleTextSearchResult(N,L){this._activeSearchCallbacks[L]?.(N)}async save(N){const L=await this._proxy.$save(N,{saveAs:!1});return b.URI.revive(L)}async saveAs(N){const L=await this._proxy.$save(N,{saveAs:!0});return b.URI.revive(L)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(N,L){if(this._editSessionIdentityProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._editSessionIdentityProviders.set(N,L);const U=this._uriTransformerService.transformOutgoingScheme(N),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,U),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(N),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(N,L){this._logService.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const x=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!x),!x)return;const O=await x.provideEditSessionIdentity(U,L);if(this._logService.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(N,L,U,x){this._logService.info("Getting edit session identifier for workspaceFolder",N);const O=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const j=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!j),!j)return;const V=await j.provideEditSessionIdentityMatch?.(L,U,x);if(this._logService.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(N){return(L,U,x)=>{const O=function(V){L.call(U,V)};return O.extension=N,this._onWillCreateEditSessionIdentityEvent.event(O,void 0,x)}}async $onWillCreateEditSessionIdentity(N,L,U){const x=await this.resolveWorkspaceFolder(b.URI.revive(N));if(x===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:x},L,async(O,j)=>{const V=Date.now();await Promise.resolve(O),Date.now()-V>U&&this._logService.warn("SLOW edit session create-participant",j.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(N,L){if(this._canonicalUriProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._canonicalUriProviders.set(N,L);const U=this._uriTransformerService.transformOutgoingScheme(N),x=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(x,U),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(N),this._proxy.$unregisterCanonicalUriProvider(x)})}async provideCanonicalUri(N,L,U){const x=this._canonicalUriProviders.get(N.scheme);if(!x)return;const O=await x.provideCanonicalUri?.(b.URI.revive(N),L,U);if(O)return O}async $provideCanonicalUri(N,L,U){return this.provideCanonicalUri(b.URI.revive(N),{targetScheme:L},U)}};e.ExtHostWorkspace=f,e.ExtHostWorkspace=f=je([$e(0,g.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,o.IExtHostFileSystemInfo),$e(3,w.ILogService),$e(4,n.IURITransformerService)],f),e.IExtHostWorkspace=(0,_.createDecorator)("IExtHostWorkspace");function P(M){let N,L;return M&&(typeof M=="string"?N=M:(N=M.pattern,L=b.URI.revive(M.baseUri))),{includePattern:N,folder:L}}}),define(De[40],Ie([1,0,23,4,39,6,7,245,136,18,9,5,20,13,2]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(n,s){if(s){const i=s.split(".");let a=n;for(let l=0;a&&l<i.length;l++)a=a[i[l]];return a}}function u(n){return n instanceof _.URI}function r(n){return n&&n.uri instanceof _.URI&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof _.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function g(n){if(u(n))return{resource:n};if(r(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(o(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let d=class{constructor(s,i,a){this._proxy=s.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,i))}};e.ExtHostConfiguration=d,e.ExtHostConfiguration=d=je([$e(0,b.IExtHostRpcService),$e(1,h.IExtHostWorkspace),$e(2,S.ILogService)],d);class t{constructor(s,i,a,l){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=l,this._extHostWorkspace=i,this._configuration=v.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(s,i,a){const l=g(i)||{},C=this._toReadonlyValue(s?w(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,l,a?.identifier);function D(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(m){return typeof w(C,m)<"u"},get:(m,f)=>{this._validateConfigurationAccess(s?`${s}.${m}`:m,l,a?.identifier);let P=w(C,m);if(typeof P>"u")P=f;else{let M;const N=(L,U)=>{if((0,E.isObject)(L)){let x;const O=()=>{M=M||(0,I.deepClone)(C),x=x||w(M,U)};return new Proxy(L,{get:(j,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return O(),()=>x;if(M)return x=x||w(M,U),x[V];const fe=j[V];return typeof V=="string"?N(fe,`${U}.${V}`):fe},set:(j,V,fe)=>(O(),x&&(x[V]=fe),!0),deleteProperty:(j,V)=>(O(),x&&delete x[V],!0),defineProperty:(j,V,fe)=>(O(),x&&Object.defineProperty(x,V,fe),!0)})}return Array.isArray(L)?(0,I.deepClone)(L):L};P=N(P,m)}return P},update:(m,f,P,M)=>{m=s?`${s}.${m}`:m;const N=D(P);return f!==void 0?this._proxy.$updateConfigurationOption(N,m,f,l,M):this._proxy.$removeConfigurationOption(N,m,l,M)},inspect:m=>{m=s?`${s}.${m}`:m;const f=this._configuration.inspect(m,l,this._extHostWorkspace.workspace);if(f)return{key:m,defaultValue:(0,I.deepClone)(f.policy?.value??f.default?.value),globalValue:(0,I.deepClone)(f.user?.value??f.application?.value),workspaceValue:(0,I.deepClone)(f.workspace?.value),workspaceFolderValue:(0,I.deepClone)(f.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(f.default?.override),globalLanguageValue:(0,I.deepClone)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,I.deepClone)(f.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(f.workspaceFolder?.override),languageIds:(0,I.deepClone)(f.overrideIdentifiers)}}};return typeof C=="object"&&(0,I.mixin)(p,C,!1),Object.freeze(p)}_toReadonlyValue(s){const i=a=>(0,E.isObject)(a)?new Proxy(a,{get:(l,C)=>i(l[C]),set:(l,C,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(l,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(l,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(s)}_validateConfigurationAccess(s,i,a){const l=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),C=a?`[${a.value}] `:"";if(l===4){typeof i?.resource>"u"&&this._logService.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this._logService.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const a=new v.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,C)=>a.affectsConfiguration(l,g(C))})}_toMap(s){return s.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")}),define(De[93],Ie([1,0,2,9,4,6,7,39,69,40,21,44,20,26,5,17,12,13,89,291,8]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(d||(d={}));var t;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(t||(t={}));var n;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(n||(n={}));var s;(function(N){function L(O){if(O){const j=O;return j&&!!j.process}else return!1}N.is=L;function U(O){if(O==null)return;const j={process:O.process,args:O.args};return O.options&&(j.options=n.from(O.options)),j}N.from=U;function x(O){if(O!=null)return new A.ProcessExecution(O.process,O.args,O.options)}N.to=x})(s||(s={}));var i;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(i||(i={}));var a;(function(N){function L(O){if(O){const j=O;return j&&(!!j.commandLine||!!j.command)}else return!1}N.is=L;function U(O){if(O==null)return;const j={};return O.commandLine!==void 0?j.commandLine=O.commandLine:(j.command=O.command,j.args=O.args),O.options&&(j.options=i.from(O.options)),j}N.from=U;function x(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.ShellExecution(O.commandLine,O.options):new A.ShellExecution(O.command,O.args?O.args:[],O.options)}N.to=x})(a||(a={}));var l;(function(N){function L(O){if(O){const j=O;return j&&j.customExecution==="customExecution"}else return!1}N.is=L;function U(O){return{customExecution:"customExecution"}}N.from=U;function x(O,j){return j.get(O)}N.to=x})(l||(e.CustomExecutionDTO=l={}));var C;(function(N){function L(U,x){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===A.TaskScope.Workspace&&x&&x.workspaceFile?O=x.workspaceFile:O=c.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:O}}N.from=L})(C||(e.TaskHandleDTO=C={}));var D;(function(N){function L(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}N.from=L})(D||(D={}));var p;(function(N){function L(O,j){if(O==null)return[];const V=[];for(const fe of O){const J=U(fe,j);J&&V.push(J)}return V}N.fromMany=L;function U(O,j){if(O==null)return;let V;O.execution instanceof A.ProcessExecution?V=s.from(O.execution):O.execution instanceof A.ShellExecution?V=a.from(O.execution):O.execution&&O.execution instanceof A.CustomExecution&&(V=l.from(O.execution));const fe=d.from(O.definition);let J;return O.scope?typeof O.scope=="number"?J=O.scope:J=O.scope.uri:J=A.TaskScope.Workspace,!fe||!J?void 0:{_id:O._id,definition:fe,name:O.name,source:{extensionId:j.identifier.value,label:O.source,scope:J},execution:V,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}N.from=U;async function x(O,j,V){if(O==null)return;let fe;s.is(O.execution)?fe=s.to(O.execution):a.is(O.execution)?fe=a.to(O.execution):l.is(O.execution)&&(fe=l.to(O._id,V));const J=d.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await j.resolveWorkspaceFolder(I.URI.revive(O.source.scope)):X=A.TaskScope.Workspace),!J||!X)return;const z=new A.Task(J,X,O.name,O.source.label,fe,O.problemMatchers);return O.isBackground!==void 0&&(z.isBackground=O.isBackground),O.group!==void 0&&(z.group=A.TaskGroup.from(O.group._id),z.group&&O.group.isDefault&&(z.group=new A.TaskGroup(z.group.id,z.group.label),O.group.isDefault===!0&&(z.group.isDefault=O.group.isDefault))),O.presentationOptions&&(z.presentationOptions=t.to(O.presentationOptions)),O._id&&(z._id=O._id),O.detail&&(z.detail=O.detail),z}N.to=x})(p||(e.TaskDTO=p={}));var m;(function(N){function L(x){return x}N.from=L;function U(x){if(x)return Object.assign(Object.create(null),x)}N.to=U})(m||(m={}));class f{#e;constructor(L,U,x){this._id=U,this._task=x,this.#e=L}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let P=class{constructor(L,U,x,O,j,V,fe,J){this._onDidExecuteTask=new h.Emitter,this._onDidTerminateTask=new h.Emitter,this._onDidTaskProcessStarted=new h.Emitter,this._onDidTaskProcessEnded=new h.Emitter,this._proxy=L.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=O,this._configurationService=j,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=fe,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(L,U,x){if(!x)return new A.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:U,provider:x,extension:L}),this._proxy.$registerTaskProvider(O,U),new A.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(L,U){this._proxy.$registerTaskSystem(L,U)}fetchTasks(L){return this._proxy.$fetchTasks(m.from(L)).then(async U=>{const x=[];for(const O of U){const j=await p.to(O,this._workspaceProvider,this._providedCustomExecutions2);j&&x.push(j)}return x})}get taskExecutions(){const L=[];return this._taskExecutions.forEach(U=>L.push(U)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(L._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(L,U,x){const O=this._providedCustomExecutions2.get(L.id);O&&(this._activeCustomExecutions2.set(L.id,O),this._terminalService.attachPtyToTerminal(U,await O.callback(x))),this._lastStartedTask=L.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(L)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(L){const U=await this.getTaskExecution(L);this._taskExecutionPromises.delete(L.id),this._taskExecutions.delete(L.id),this.customExecutionComplete(L),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessStarted.fire({execution:U,processId:L.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:L.exitCode})}$provideTasks(L,U){const x=this._handlers.get(L);if(!x)return Promise.reject(new Error("no handler found"));const O=[],j=(0,F.asPromise)(()=>x.provider.provideTasks(T.CancellationToken.None)).then(V=>this.provideTasksInternal(U,O,x,V));return new Promise(V=>{j.then(fe=>{Promise.all(O).then(()=>{V(fe)})})})}async $resolveTask(L,U){const x=this._handlers.get(L);if(!x)return Promise.reject(new Error("no handler found"));if(U.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${x.type}].`);const O=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const j=await x.provider.resolveTask(O,T.CancellationToken.None);if(!j)return;this.checkDeprecation(j,x);const V=p.from(j,x.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(V.execution)&&await this.addCustomExecution(V,j,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(L,U,x){const O=await this._proxy.$createTaskId(L);!x&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,U.execution)),this._providedCustomExecutions2.set(O,U.execution)}async getTaskExecution(L,U){if(typeof L=="string"){const j=this._taskExecutionPromises.get(L);if(!j)throw new g.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const x=this._taskExecutionPromises.get(L.id);if(x)return x;const O=new Promise((j,V)=>{function fe(J,X,z){z?j(new f(J,X.id,z)):V("Unexpected: Task does not exist.")}U?fe(this,L,U):p.to(L.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>fe(this,L,J))});return this._taskExecutionPromises.set(L.id,O),O.then(j=>(this._taskExecutions.set(L.id,j),j),j=>Promise.reject(j))}checkDeprecation(L,U){L._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(L){this._activeCustomExecutions2.get(L.id)&&this._activeCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.has(L.id)&&this._lastStartedTask!==L.id&&(this._providedCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.delete(L.id));const x=this._notProvidedCustomExecutions.values();let O=x.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=x.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=je([$e(0,b.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,v.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,r.ILogService),$e(7,o.IExtHostApiDeprecationService)],P);let M=class extends P{constructor(L,U,x,O,j,V,fe,J){super(L,U,x,O,j,V,fe,J),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(L,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const x=p.from(U,L);if(x===void 0)throw new Error("Task is not valid");if(l.is(x.execution))await this.addCustomExecution(x,U,!1);else throw new g.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),U);return this._proxy.$executeTask(x).catch(j=>{throw new Error(j)}),O}provideTasksInternal(L,U,x,O){const j=[];if(O)for(const V of O){this.checkDeprecation(V,x),(!V.definition||!L[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=p.from(V,x.extension);fe&&l.is(fe.execution)?(j.push(fe),U.push(this.addCustomExecution(fe,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:x.extension}}async resolveTaskInternal(L){if(l.is(L.execution))return L;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(L,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,U,x){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=je([$e(0,b.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,v.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,r.ILogService),$e(7,o.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(De[346],Ie([1,0,16,21,46,35,24,37,36]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class E{constructor(b,S,_){this.config=b,this.provider=S,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=b.filePattern,this.includePattern=b.includePattern&&R.parse(b.includePattern),this.maxResults=b.maxResults||void 0,this.exists=b.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=b.excludePattern&&R.parse(b.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(b=>b.cancel()),this.activeCancellationTokens=new Set}search(b){const S=this.config.folderQueries||[];return new Promise((_,w)=>{const u=r=>{this.resultCount++,b(r)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(r=>{const o=r.toString(),c=I.basename(o);this.globalExcludePattern&&this.globalExcludePattern(o,c)||this.matchFile(u,{base:r,basename:c})}),Promise.all(S.map(r=>this.searchInFolder(r,u))).then(r=>{_({limitHit:this.isLimitHit,stats:r[0]||void 0})},r=>{w(new Error((0,h.toErrorMessage)(r)))})})}async searchInFolder(b,S){const _=new F.CancellationTokenSource,w=this.getSearchOptionsForFolder(b),u=this.initDirectoryTree(),r=new y.QueryGlobTester(this.config,b),o=!r.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(_),c=v.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,_.token),d=c.elapsed(),t=v.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(n=>{const s=I.posix.relative(b.folder.path,n.path);if(o){const i=I.basename(n.path);this.matchFile(S,{base:b.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(u,b.folder,s,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,r,S),{providerTime:d,postProcessTime:t.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(b){const S=(0,y.resolvePatternsForProvider)(this.config.includePattern,b.includePattern),_=(0,y.resolvePatternsForProvider)(this.config.excludePattern,b.excludePattern);return{folder:b.folder,excludes:_,includes:S,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}addDirectoryEntries({pathToEntries:b},S,_,w){if(_===this.filePattern){const r=I.basename(this.filePattern);this.matchFile(w,{base:S,relativePath:this.filePattern,basename:r})}function u(r){const o=I.basename(r),c=I.dirname(r);let g=b[c];g||(g=b[c]=[],u(c)),g.push({base:S,relativePath:r,basename:o})}u(_)}matchDirectoryTree({rootEntries:b,pathToEntries:S},_,w){const u=this,r=this.filePattern;function o(c){const g=(0,y.hasSiblingFn)(()=>c.map(d=>d.basename));for(let d=0,t=c.length;d<t;d++){const n=c[d],{relativePath:s,basename:i}=n;if(_.matchesExcludesSync(s,i,r!==i?g:void 0))continue;const a=S[s];if(a)o(a);else{if(s===r)continue;u.matchFile(w,n)}if(u.isLimitHit)break}}o(b)}matchFile(b,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||b(S))}}class T{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(b,S,_,w){const u=this.getSessionTokenSource(b.cacheKey),r=new E(b,S,u&&u.token);let o=0;const c=g=>{o+=g.length,_(g.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(r,T.BATCH_SIZE,c,w).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:o,detailStats:g.stats}}))}clearCache(b){this.getSessionTokenSource(b)?.cancel()}getSessionTokenSource(b){if(b)return this.sessions.has(b)||this.sessions.set(b,new F.CancellationTokenSource),this.sessions.get(b)}rawMatchToSearchItem(b){return b.relativePath?{resource:A.joinPath(b.base,b.relativePath)}:{resource:b.base}}doSearch(b,S,_,w){const u=w.onCancellationRequested(()=>{b.cancel()}),r=c=>{c&&(o.push(c),S>0&&o.length>=S&&(_(o),o=[]))};let o=[];return b.search(r).then(c=>(o.length&&_(o),u.dispose(),c),c=>(o.length&&_(o),u.dispose(),Promise.reject(c)))}}e.FileSearchManager=T}),define(De[347],Ie([1,0,19,73,35,99,28,17,16,24,15,18,2,172,226,49,13,43,143,344,36]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(m,f,P,M,N){this.configurationService=m,this.workspaceContextService=f,this.editorGroupsService=P,this.logService=M,this.pathService=N}text(m,f,P={}){m=this.getContentPattern(m,P);const M=this.configurationService.getValue(),N=f&&f.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(f?.map(r.toWorkspaceFolder),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(m,f){const P=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const M={...m,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(m,f)&&(M.isCaseSensitive=!0),this.isMultiline(m)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(m,f={}){return{...this.commonQuery(m,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(m,f){return m?(m=Array.isArray(m)?m.map(a):a(m),f?this.parseSearchPaths(m):{pattern:n(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],f={}){const P=this.handleIncludeExclude(f.includePattern,f.expandPatterns),M=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),N=m.length>1,L=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,f,M)):m.map(O=>this.getFolderQueryForRoot(O,f,M,N))).filter(O=>!!O),U={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:P.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const O=I.coalesce(I.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(J=>J.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const j=O.filter(fe=>(0,g.pathIncludedInQuery)(U,fe.fsPath)),V=this.commonQueryFromFileList(j);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...U,...V}}const x=f.extraFileResources&&f.extraFileResources.filter(O=>(0,g.pathIncludedInQuery)(U,O.fsPath));return U.extraFileResources=x&&x.length?x:void 0,U}commonQueryFromFileList(m){const f=[],P=new A.ResourceMap,M={};let N=!1;return m.forEach(L=>{if(L.scheme===v.Schemas.walkThrough)return;if((0,E.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:y.dirname(L.fsPath)});let O=P.get(x);O||(N=!0,O={folder:x,includePattern:{}},f.push(O),P.set(x,O));const j=y.relative(x.fsPath,L.fsPath);(0,k.assertIsDefined)(O.includePattern)[j.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(m,f){if(f.isSmartCase){if(m.isRegExp){if(T.containsUppercaseCharacter(m.pattern,!0))return!0}else if(T.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,S.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const f=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),M=(Array.isArray(m)?m:s(m)).map(V=>{const fe=this.pathService.resolvedUserHome;return fe?(0,R.untildify)(V,fe.scheme===v.Schemas.file?fe.fsPath:fe.path):V}),N=F.groupBy(M,V=>f(V)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(V=>T.rtrim(V,"/")).map(V=>T.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),U={},x=this.expandSearchPathPatterns(N.searchPaths||[]);x&&x.length&&(U.searchPaths=x);const O=I.flatten(L),j=n(...O);return j&&(U.pattern=j),U}getExcludesForFolder(m,f){return f.disregardExcludeSettings?void 0:(0,g.getExcludes)(m,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const f=m.flatMap(M=>{let{pathPortion:N,globPortion:L}=t(M);return L&&(L=l(L)),this.expandOneSearchPath(N).flatMap(x=>this.resolveOneSearchPathPattern(x,L))}),P=new Map;return f.forEach(M=>{const N=M.searchPath.toString(),L=P.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):P.set(N,{searchPath:M.searchPath,pattern:M.pattern?n(M.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(m){if(y.isAbsolute(m)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==v.Schemas.file?[{searchPath:f[0].uri.with({path:m})}]:[{searchPath:b.URI.file(y.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=a(m),m.startsWith("../")||m===".."){const M=y.posix.resolve(f.path,m);return[{searchPath:f.with({path:M})}]}const P=l(m);return[{searchPath:f,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const f=m.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${T.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(k.isDefined);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&l(L)}});{const N=m.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:m,U=_.localize(0,null,L);throw new Error(U)}}}}resolveOneSearchPathPattern(m,f){const P=m.pattern&&f?`${m.pattern}/${f}`:m.pattern||f,M=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&M.push({searchPath:m.searchPath,pattern:P+"/**"}),M}getFolderQueryForSearchPath(m,f,P){const M=this.getFolderQueryForRoot((0,r.toWorkspaceFolder)(m.searchPath),f,P,!1);return M?{...M,includePattern:m.pattern}:null}getFolderQueryForRoot(m,f,P,M){let N;const L=b.URI.isUri(m)?m:m.uri;if(P.searchPaths){const V=P.searchPaths.filter(fe=>(0,E.isEqual)(fe.searchPath,L))[0];if(V&&!V.pattern)return null;V&&(N=V.pattern)}const U=this.configurationService.getValue({resource:L}),O={...this.getExcludesForFolder(U,f)||{},...N||{}},j=b.URI.isUri(m)?(0,E.basename)(m):m.name;return{folder:L,folderName:M?j:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=d,e.QueryBuilder=d=je([$e(0,w.IConfigurationService),$e(1,r.IWorkspaceContextService),$e(2,o.IEditorGroupsService),$e(3,u.ILogService),$e(4,c.IPathService)],d);function t(p){const m=p.match(/[\*\{\}\(\)\[\]\?]/);if(m){const f=m.index,P=p.substr(0,f).match(/[/|\\][^/\\]*$/);if(P){let M=p.substr(0,P.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:p.substr((P.index||0)+1)}}}return{pathPortion:p}}function n(...p){return p.length?p.reduce((m,f)=>(m[f]=!0,m),Object.create(null)):void 0}function s(p){return h.splitGlobAware(p,",").map(m=>m.trim()).filter(m=>!!m.length)}function i(p){return[`**/${p}/**`,`**/${p}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function a(p){return p.replace(/\\/g,"/")}function l(p){return a(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(p){return p.replace(/([?*[\]])/g,"[$1]")}function D(p,m){p=I.distinct(p,M=>M.toString());const f=[],P=m.getWorkspace();return p&&p.forEach(M=>{let N;if(m.getWorkbenchState()===2)N=(0,E.relativePath)(P.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=m.getWorkspaceFolder(M);if(L){const U=L.name;if(P.folders.filter(O=>O.name===U).length===1){const O=(0,E.relativePath)(L.uri,M);O===""?N=`./${L.name}`:N=`./${L.name}/${O}`}else N=M.fsPath}}N&&f.push(C(N))}),f}e.resolveResourcesForSearchIncludes=D}),define(De[348],Ie([1,0,24,2,21,8,5,347,36,43]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(w,u){const r=u.activationEvents;if(!r)return Promise.resolve(void 0);const o=[],c=[];for(const i of r)if(/^workspaceContains:/.test(i)){const a=i.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||w.forceUsingSearch?c.push(a):o.push(a)}if(o.length===0&&c.length===0)return Promise.resolve(void 0);let g;const d=new Promise((i,a)=>{g=i}),t=i=>g({activationEvent:i}),n=Promise.all(o.map(i=>b(w,i,t))).then(()=>{}),s=S(w,u.identifier,c,t);return Promise.all([n,s]).then(()=>{g(void 0)}),d}e.checkActivateWorkspaceContainsExtension=k;async function b(w,u,r){for(const o of w.folders)if(await w.exists(I.joinPath(F.URI.revive(o),u))){r(`workspaceContains:${u}`);return}}async function S(w,u,r,o){if(r.length===0)return Promise.resolve(void 0);const c=new h.CancellationTokenSource,g=w.checkExists(w.folders,r,c.token),d=setTimeout(async()=>{c.cancel(),w.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},T);let t=!1;try{t=await g}catch(n){R.isCancellationError(n)||R.onUnexpectedError(n)}c.dispose(),clearTimeout(d),t&&o(`workspaceContains:${r.join(",")}`)}function _(w,u,r,o){const c=w.get(A.IInstantiationService),g=w.get(y.ISearchService),t=c.createInstance(v.QueryBuilder).file(u.map(n=>(0,E.toWorkspaceFolder)(F.URI.revive(n))),{_reason:"checkExists",includePattern:r,exists:!0});return g.fileSearch(t,o).then(n=>!!n.limitHit,n=>R.isCancellationError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=_}),define(De[45],Ie([1,0,204,16,54,24,9,3,77,2,13,6,40,286,115,39,27,148,8,25,22,262,7,64,5,26,90,20,104,72,44,4,348,114,264,17,112,37,12,113]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n,s,i,a,l,C,D,p,m,f,P,M,N,L,U,x,O){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=j=class extends v.Disposable{constructor(G,B,H,me,Z,ie,re,ye,oe,de,ee,ue){super(),this._extHostManagedSockets=ue,this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=B,this._extHostContext=H,this._initData=re,this._extHostWorkspace=me,this._extHostConfiguration=Z,this._logService=ie,this._extHostTunnelService=oe,this._extHostTerminalService=de,this._extHostLocalizationService=ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new le(this._initData.extensions.activationEvents),this._globalRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const pe=new c.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,Q(this._globalRegistry,pe)),x.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${X(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${X(this._myRegistry)}`)),this._storage=new _.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=G.createChild(new C.ServiceCollection([_.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Pe,$,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Pe,o.transformErrorForSerialization($),K)},actualActivateExtension:async(Pe,$)=>{if(r.ExtensionDescriptionRegistry.isHostExtension(Pe,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Pe,$),new S.HostExtension;const K=this._myRegistry.getExtensionDescription(Pe);return this._activateExtension(K,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),h.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){o.onUnexpectedError(G)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._myRegistry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(G)}terminate(G,B=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${G}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),o.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const H=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),H]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${B}`):this._logService.info(`Extension host exiting with code ${B}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(B)})}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}async getExtension(G){const B=await this._mainThreadExtensionsProxy.$getExtension(G);return B&&{...B,identifier:new c.ExtensionIdentifier(B.identifier.value),extensionLocation:E.URI.revive(B.extensionLocation)}}_activateByEvent(G,B){return this._activator.activateByEvent(G,B)}_activateById(G,B){return this._activator.activateById(G,B)}activateByIdWithErrors(G,B){return this._activateById(G,B).then(()=>{const H=this._activator.getActivatedExtension(G);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._myRegistry)}getExtensionExports(G){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(G).exports;try{return this._activator.getActivatedExtension(G).exports}catch{return null}}async _realPathExtensionUri(G){if(G.scheme===N.Schemas.file&&this._hostUtils.fsRealpath){const B=await this._hostUtils.fsRealpath(G.fsPath);return E.URI.file(B)}return G}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(G=>new ve(G))),this._extensionPathIndex}async _createExtensionPathIndex(G){const B=y.TernarySearchTree.forUris(H=>R.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(G.map(async H=>{if(this._getEntryPoint(H)){const me=await this._realPathExtensionUri(H.extensionLocation);B.set(me,H)}})),B}_deactivate(G){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return B;const H=this._activator.getActivatedExtension(G);if(!H)return B;try{typeof H.module.deactivate=="function"&&(B=Promise.resolve(H.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(me)}try{(0,v.dispose)(H.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(me)}return B}async _activateExtension(G,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,B).then(H=>{const me=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,B),this._logExtensionActivationTimes(G,B,"success",me),H},H=>{throw this._logExtensionActivationTimes(G,B,"failure"),H})}_logExtensionActivationTimes(G,B,H,me){const Z=J(G,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...me||{},outcome:H})}_doActivateExtension(G,B){const H=J(G,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const me=this._getEntryPoint(G);if(!me)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${G.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this._logService.flush();const Z=new S.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(G,(0,R.joinPath)(G.extensionLocation,me),Z),this._loadExtensionContext(G)]).then(ie=>(h.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),j._callActivate(this._logService,G.identifier,ie[0],ie[1],Z))).then(ie=>(h.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ie))}_loadExtensionContext(G){const B=new d.ExtensionGlobalMemento(G,this._storage),H=new d.ExtensionMemento(G.identifier.value,!1,this._storage),me=new M.ExtensionSecrets(G,this._secretState),Z=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([B.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const re=this;let ye,oe;const de=(0,u.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(c.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:H,secrets:me,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return F.join(G.extensionLocation.fsPath,ee)},get storagePath(){return re._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return re._storagePath.globalValue(G).fsPath},get logPath(){return F.join(re._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return E.URI.joinPath(re._initData.logsLocation,G.identifier.value)},get storageUri(){return re._storagePath.workspaceValue(G)},get globalStorageUri(){return re._storagePath.globalValue(G)},get extensionMode(){return Z},get extension(){return ye===void 0&&(ye=new z(re,G.identifier,G,ie,!1)),ye},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(G,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!de)return;const ee=m.Event.buffer(m.Event.fromDOMEventEmitter(de,"message",ue=>ue.data));de.start(),oe={onDidReceiveMessage:ee,postMessage:de.postMessage.bind(de)}}return oe}})})}static _callActivate(G,B,H,me,Z){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,B,H,me,Z).then(ie=>new S.ActivatedExtension(!1,null,Z.build(),H,ie,me.subscriptions))}static _callActivateOptional(G,B,H,me,Z){if(typeof H.activate=="function")try{Z.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ie=typeof global=="object"?global:self,re=H.activate.apply(ie,[me]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(re).then(ye=>(Z.activateResolveStop(),ye))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(H)}_activateOneStartupFinished(G,B){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:B}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinishedDeferred(G,B=0){const me=Date.now();(0,x.setTimeout0)(()=>{for(let Z=B;Z<G.length;Z+=1){const ie=G[Z];for(const re of ie.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-me>50){this._activateAllStartupFinishedDeferred(G,Z);break}else this._activateOneStartupFinished(ie,re)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(h.getMarks()),this._extHostConfiguration.getConfigProvider().then(G=>{const B=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),H=this._myRegistry.getAllExtensionDescriptions();if(B)this._activateAllStartupFinishedDeferred(H);else for(const me of H)if(me.activationEvents)for(const Z of me.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(me,Z)})}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(B),me=this._handleRemoteResolverEagerExtensions(),Z=Promise.all([me,G,H]).then(()=>{});return Promise.race([Z,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(G,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,B){if(this.isActivated(B.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:G.map(ie=>ie.uri),forceUsingSearch:H||!this._hostUtils.fsExists,exists:ie=>this._hostUtils.fsExists(ie.fsPath),checkExists:(ie,re,ye)=>this._mainThreadWorkspaceProxy.$checkExists(ie,re,ye)},Z=await(0,f.checkActivateWorkspaceContainsExtension)(me,B);if(Z)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Z.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:B}=this._initData.environment;if(!G||!B)throw new Error(I.localize(0,null));const H=await this._loadCommonJSModule(null,B,new S.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(I.localize(1,null,B.toString()));return new Promise((me,Z)=>{const ie=(oe,de)=>{oe?(x.isCI&&this._logService.error("Test runner called back with error",oe),Z(oe)):(x.isCI&&(de?this._logService.info(`Test runner called back with ${de} failures.`):this._logService.info("Test runner called back with successful outcome.")),me(typeof de=="number"&&de>0?1:0))},re=(0,R.originalFSPath)(B),ye=H.run(re,ie);ye&&ye.then&&ye.then(()=>{x.isCI&&this._logService.info("Test runner finished successfully."),me(0)}).catch(oe=>{x.isCI&&this._logService.error("Test runner finished with error",oe),Z(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,B){return this._resolvers[G]=B,(0,v.toDisposable)(()=>{delete this._resolvers[G]})}async getRemoteExecServer(G){const{resolver:B}=await this._activateAndGetResolver(G);return B?.resolveExecServer?.(G,{resolveAttempt:0})}async _activateAndGetResolver(G){const B=G.indexOf("+");if(B===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const H=G.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(G,B){const H=U.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,n.getRemoteAuthorityPrefix)(G)},${B})][${H.elapsed()}ms] `,Z=se=>this._logService.info(`${me()}${se}`),ie=se=>this._logService.warn(`${me()}${se}`),re=(se,Y=void 0)=>this._logService.error(`${me()}${se}`,Y),ye=se=>{if(se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},oe=async se=>{Z(`activating resolver for ${se}...`);const{resolver:Y,authorityPrefix:he}=await this._activateAndGetResolver(se);if(!Y)throw re(`no resolver for ${he}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${he}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:he,remoteAuthority:se}},de=G.split(/@|%40/g).reverse();Z(`activating remote resolvers ${de.join(" -> ")}`);let ee;try{ee=await Promise.all(de.map(oe)).catch(async se=>{if(!(se instanceof t.RemoteAuthorityResolverError)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ie(`resolving nested authorities failed: ${se.message}`),[await oe(G)]})}catch(se){return ye(se)}const ue=new A.IntervalTimer;ue.cancelAndSet(()=>Z("waiting..."),1e3);let pe,Pe;for(const[se,{authorityPrefix:Y,resolver:he,remoteAuthority:Se}]of ee.entries())try{if(se===ee.length-1)Z("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${Y}`),pe=await he.resolve(Se,{resolveAttempt:B,execServer:Pe}),h.mark(`code/extHost/didResolveAuthorityOK/${Y}`),Z("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(he,t.ManagedResolvedAuthority.isManagedResolvedAuthority(pe)?pe:void 0));else{if(Z(`invoking resolveExecServer() for ${Se}`),h.mark(`code/extHost/willResolveExecServer/${Y}`),Pe=await he.resolveExecServer?.(Se,{resolveAttempt:B,execServer:Pe}),!Pe)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${Se}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(Ue){return h.mark(`code/extHost/didResolveAuthorityError/${Y}`),re("returned an error",Ue),ue.dispose(),ye(Ue)}ue.dispose();const $={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},K={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let te;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(pe)){const se=B;this._extHostManagedSockets.setFactory(se,pe.makeConnection),te={authority:G,connectTo:new n.ManagedRemoteConnection(se),connectionToken:pe.connectionToken}}else te={authority:G,connectTo:new n.WebSocketRemoteConnection(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:te,options:K,tunnelInformation:$}}}async $getCanonicalURI(G,B){this._logService.info(`$getCanonicalURI invoked for authority (${(0,n.getRemoteAuthorityPrefix)(G)})`);const{resolver:H}=await this._activateAndGetResolver(G);if(!H)return null;const me=E.URI.revive(B);if(typeof H.getCanonicalURI>"u")return me;const Z=await(0,A.asPromise)(()=>H.getCanonicalURI(me));return Z||me}$startExtensionHost(G){G.toAdd.forEach(me=>me.extensionLocation=E.URI.revive(me.extensionLocation));const{globalRegistry:B,myExtensions:H}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,G);return this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(H),x.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${X(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(G,B){return B===1?this._almostReadyToRunExtensions.wait().then(H=>this._activateByEvent(G,!1)):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(G,!1))}async $activate(G,B){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(G)?(await this._activateById(G,B),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ie=>ie.extensionLocation=E.URI.revive(ie.extensionLocation));const{globalRegistry:B,myExtensions:H}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),me=await this._createExtensionPathIndex(H);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(H),x.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${X(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const B=g.VSBuffer.alloc(G),H=Math.random()%256;for(let me=0;me<G;me++)B.writeUInt8(H,me);return B}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=V,e.AbstractExtHostExtensionService=V=j=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,b.IExtHostConfiguration),$e(5,T.ILogService),$e(6,i.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,D.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,L.IExtHostLocalizationService),$e(11,O.IExtHostManagedSockets)],V);function fe(we,G,B,H){we.addActivationEvents(H.addActivationEvents);const me=new r.ExtensionDescriptionRegistry(we,G.getAllExtensionDescriptions());me.deltaExtensions(H.toAdd,H.toRemove);const Z=new c.ExtensionIdentifierSet(B.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of H.myToRemove)Z.delete(re);for(const re of H.myToAdd)Z.add(re);const ie=Q(me,Z);return{globalRegistry:me,myExtensions:ie}}function J(we,G){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function X(we){return we.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class z{#e;#t;#i;constructor(G,B,H,me,Z){this.#e=G,this.#t=B,this.#i=H.identifier,this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=F.normalize((0,R.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=me,this.isFromDifferentExtensionHost=Z}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=z;function Q(we,G){return we.getAllExtensionDescriptions().filter(B=>G.has(B.identifier))}class ve{constructor(G){this._searchTree=G}setSearchTree(G){this._searchTree=G}findSubstr(G){return this._searchTree.findSubstr(G)}forEach(G){return this._searchTree.forEach(G)}}e.ExtensionPaths=ve;class le{constructor(G){this._map=new c.ExtensionIdentifierMap,this.addActivationEvents(G)}readActivationEvents(G){return this._map.get(G.identifier)}addActivationEvents(G){for(const B of Object.keys(G))this._map.set(B,G[B])}}}),define(De[349],Ie([1,0,54,2,6,40,27,25,20,26,5,45,13,15]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(g,d,t,n,s,i,a){this._apiFactory=g,this._extensionRegistry=d,this._instaService=t,this._extHostConfiguration=n,this._extHostExtensionService=s,this._initData=i,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new r(this._apiFactory,d,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(o,d,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const d of g.nodeModuleName)this._factories.set(d,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(d=>g.alternativeModuleName(d))}};e.RequireInterceptor=w,e.RequireInterceptor=w=je([$e(2,T.IInstantiationService),$e(3,R.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,E.IExtHostInitDataService),$e(6,b.ILogService)],w);let u=class{static{_=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(g){if(g.environment.appRoot&&_.aliased.size){const d=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${d}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const d=this.re.exec(this.forceForwardSlashes(g));if(!d)return;const[,t,n,s]=d,i=_.aliased.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+s}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};u=_=je([$e(0,E.IExtHostInitDataService)],u);class r{constructor(g,d,t,n,s){this._apiFactory=g,this._extensionPaths=d,this._extensionRegistry=t,this._configProvider=n,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new v.ExtensionIdentifierMap}load(g,d){const t=this._extensionPaths.findSubstr(d);if(t){let n=this._extApiImpl.get(t.identifier);return n||(n=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((s,i)=>n+=`	${i} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let o=class{constructor(g,d,t){this._extensionPaths=g,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(h.MainContext.MainThreadTelemetry);const n=t.getProxy(h.MainContext.MainThreadWindow);this._impl=(s,i)=>{const a=F.URI.parse(s);return i?this.callOriginal(s,i):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,s,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?n.$openUri(a,s,{}):this.callOriginal(s,i)}}load(g,d,t){const n=this._extensionPaths.findSubstr(d);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=t(g),this._impl}callOriginal(g,d){return this.sendNoForwardTelemetry(),this._original(g,d)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};o=je([$e(2,y.IExtHostRpcService)],o)}),define(De[56],Ie([1,0,51,3,16,47,5,69,70,45,7,39,278,40]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class _ extends b.AbstractVariableResolverService{constructor(r,o,c,g,d,t,n){function s(){if(c){const i=c.activeEditor();if(i)return i.document.uri;const a=g.tabGroups.all.find(l=>l.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof T.TextDiffTabInput||a.input instanceof T.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof T.TextTabInput||a.input instanceof T.NotebookEditorTabInput||a.input instanceof T.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:i=>{const a=t.folders.filter(l=>l.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,a)=>d.getConfiguration(void 0,i).get(a),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return h.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(o){const i=s();if(i){const a=o.getWorkspaceFolder(i);if(a)return h.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(c){const i=c.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(c){const i=c.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>r.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let w=class extends F.Disposable{constructor(r,o,c,g,d){super(),this.extensionService=r,this.workspaceService=o,this.editorService=c,this.configurationService=g,this.editorTabs=d,this._resolver=new I.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=w,e.ExtHostVariableResolverProviderService=w=je([$e(0,E.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,v.IExtHostDocumentsAndEditors),$e(3,S.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],w)}),define(De[94],Ie([1,0,9,4,2,5,6,70,45,20,7,39,140,271,40,56]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,s,i,a,l,C){this._workspaceService=s,this._extensionService=i,this._configurationService=a,this._editorTabs=l,this._variableResolver=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new F.Emitter,this._onDidTerminateDebugSession=new F.Emitter,this._onDidChangeActiveDebugSession=new F.Emitter,this._onDidReceiveDebugSessionCustomEvent=new F.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new F.Emitter,this._onDidChangeStackFrameFocus=new F.Emitter,this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(D=>{D.onDidChange(p=>{this.registerAllDebugTypes(D)}),this.registerAllDebugTypes(D)})}asDebugSourceUri(n,s){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let a=`debug:${encodeURIComponent(i.path||"")}`,l="?";return s&&(a+=`${l}session=${encodeURIComponent(s.id)}`,l="&"),a+=`${l}ref=${i.sourceReference}`,h.URI.parse(a)}else{if(i.path)return h.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const s=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const a=i.contributes.debuggers;if(a&&a.length>0)for(const l of a)(0,S.isDebuggerMainContribution)(l)&&s.push(l.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const n=[];return this._breakpoints.forEach(s=>n.push(s)),n}addBreakpoints(n){const s=n.filter(l=>{const C=l.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,l),!0)});this.fireBreakpointChanges(s,[],[]);const i=[],a=new Map;for(const l of s)if(l instanceof T.SourceBreakpoint){let C=a.get(l.location.uri.toString());C||(C={type:"sourceMulti",uri:l.location.uri,lines:[]},a.set(l.location.uri.toString(),C),i.push(C)),C.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof T.FunctionBreakpoint&&i.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(n){const s=n.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],s,[]);const i=s.filter(C=>C instanceof T.SourceBreakpoint).map(C=>C.id),a=s.filter(C=>C instanceof T.FunctionBreakpoint).map(C=>C.id),l=s.filter(C=>C instanceof T.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(i,a,l)}startDebugging(n,s,i){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,s,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,i){if(!s)return new T.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:a,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,i,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,a),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,s,i){if(!i)return new T.Disposable(()=>{});if(!this.definesDebugType(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:a,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,a),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new T.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:i,factory:s}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let i;const a=await this.getFolder(n);return a&&(i={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,s)}createDebugAdapter(n,s){if(n.type==="implementation")return new g(n.implementation)}createSignService(){}async $startDASession(n,s){const i=this,a=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const C=this.convertToDto(l),D=this.createDebugAdapter(C,a);if(!D)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const p=D;return this._debugAdapters.set(n,p),this.getDebugAdapterTrackers(a).then(m=>(m&&this._debugAdaptersTrackers.set(n,m),p.onMessage(async f=>{if(f.type==="request"&&f.command==="handshake"){const P=f,M={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(P.arguments.value);M.body={signature:N},p.sendResponse(M)}else throw new Error("no signer")}catch(N){M.success=!1,M.message=N.message,p.sendResponse(M)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(f),f=(0,S.convertToVSCPaths)(f,!0),i._debugServiceProxy.$acceptDAMessage(n,f)}),p.onError(f=>{m&&m.onError&&m.onError(f),this._debugServiceProxy.$acceptDAError(n,f.name,f.message,f.stack)}),p.onExit(f=>{m&&m.onExit&&m.onExit(f??void 0,void 0),this._debugServiceProxy.$acceptDAExit(n,f??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),p.startSession()))})}$sendDAMessage(n,s){s=(0,S.convertToDAPaths)(s,!1);const i=this._debugAdaptersTrackers.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(s),this._debugAdapters.get(n)?.sendMessage(s)}$stopDASession(n){const s=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const i=this._debugAdapters.get(n);return this._debugAdapters.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],i=[],a=[];if(n.added)for(const l of n.added){const C=l.id;if(C&&!this._breakpoints.has(C)){let D;if(l.type==="function")D=new T.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")D=new T.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const p=h.URI.revive(l.uri);D=new T.SourceBreakpoint(new T.Location(p,new T.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,T.setBreakpointId)(D,C),this._breakpoints.set(C,D),s.push(D)}}if(n.removed)for(const l of n.removed){const C=this._breakpoints.get(l);C&&(this._breakpoints.delete(l),i.push(C))}if(n.changed){for(const l of n.changed)if(l.id){const C=this._breakpoints.get(l.id);if(C){if(C instanceof T.FunctionBreakpoint&&l.type==="function"){const D=C;D.enabled=l.enabled,D.condition=l.condition,D.hitCondition=l.hitCondition,D.logMessage=l.logMessage,D.functionName=l.functionName}else if(C instanceof T.SourceBreakpoint&&l.type==="source"){const D=C;D.enabled=l.enabled,D.condition=l.condition,D.hitCondition=l.hitCondition,D.logMessage=l.logMessage,D.location=new T.Location(h.URI.revive(l.uri),new T.Position(l.line,l.character))}a.push(C)}}}this.fireBreakpointChanges(s,i,a)}async $acceptStackFrameFocus(n){let s;const i=n.sessionId?await this.getSession(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new T.ThreadFocus(i,n.threadId):s=new T.StackFrameFocus(i,n.threadId,n.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(n,s,i){return(0,I.asPromise)(async()=>{const a=this.getConfigProviderByHandle(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(s);return a.provideDebugConfigurations(l,i)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,s,i,a){return(0,I.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(s);return l.resolveDebugConfiguration(C,i,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,i,a){return(0,I.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(s);return l.resolveDebugConfigurationWithSubstitutedVariables(C,i,a)})}async $provideDebugAdapter(n,s){const i=this.getAdapterDescriptorFactoryByHandle(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(s);return this.getAdapterDescriptor(i,a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(n){const s=await this.getSession(n);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.getSession(n);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,s){(await this.getSession(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const a={session:await this.getSession(n),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(n){if(n instanceof T.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof T.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const s=this._adapterFactories.filter(i=>i.type===n);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(n){const s=this._adapterFactories.filter(i=>i.handle===n);if(s.length>0)return s[0].factory}getConfigProviderByHandle(n){const s=this._configProviders.filter(i=>i.handle===n);if(s.length>0)return s[0].provider}definesDebugType(n,s){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const a of i)if(a.label&&a.type&&a.type===s)return!0}}return!1}getDebugAdapterTrackers(n){const i=n.configuration.type,a=this._trackerFactories.filter(l=>l.type===i||l.type==="*").map(l=>(0,I.asPromise)(()=>l.factory.createDebugAdapterTracker(n)).then(C=>C,C=>null));return Promise.race([Promise.all(a).then(l=>{const C=l.filter(D=>!!D);if(C.length>0)return new c(C)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async getAdapterDescriptor(n,s){const i=s.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new T.DebugAdapterServer(i));if(n){const l=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>n.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,l))).then(C=>{if(C)return C})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,a))}daExecutableFromPackage(n,s){}fireBreakpointChanges(n,s,i){(n.length>0||s.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:s,changed:i}))}async getSession(n){if(n)if(typeof n=="string"){const s=this._debugSessions.get(n);if(s)return s}else{let s=this._debugSessions.get(n.id);if(!s){const i=await this.getFolder(n.folderUri),a=n.parent?this._debugSessions.get(n.parent):void 0;s=new r(this._debugServiceProxy,n.id,n.type,n.name,i,n.configuration,a),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(n){if(n){const s=h.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=u,e.ExtHostDebugServiceBase=u=je([$e(0,E.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,_.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],u);class r{constructor(n,s,i,a,l,C,D){this._debugServiceProxy=n,this._id=s,this._type=i,this._name=a,this._workspaceFolder=l,this._configuration=C,this._parentSession=D}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,s)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=r;class o{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=o;class c{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.trackers.forEach(i=>i.onExit?i.onExit(n,s):void 0)}}class g extends b.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends u{constructor(n,s,i,a,l,C){super(n,s,i,a,l,C)}};e.WorkerExtHostDebugService=d,e.WorkerExtHostDebugService=d=je([$e(0,E.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,_.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],d)}),define(De[350],Ie([1,0,8,54,2,6,341,13,103,104,26,238,20,66,45,88]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class u{static async installEarlyHandler(c){Error.stackTraceLimit=100;const g=c.get(v.ILogService),t=c.get(b.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(n=>{g.error(n);const s=I.transformErrorForSerialization(n);t.$onUnexpectedError(s)})}static async installFullHandler(c){const g=c.get(v.ILogService),d=c.get(b.IExtHostRpcService),t=c.get(_.IExtHostExtensionService),n=c.get(w.IExtHostTelemetry),s=d.getProxy(R.MainContext.MainThreadExtensionService),i=d.getProxy(R.MainContext.MainThreadErrors),a=await t.getExtensionPathIndex(),l=new WeakMap;function C(m,f){if(l.has(m))return l.get(m).stack;let P="",M,N;for(const U of f)P+=`
	at ${U.toString()}`,N=U.getFileName(),!M&&N&&(M=a.findSubstr(h.URI.file(N)));const L=`${m.name||"Error"}: ${m.message||""}${P}`;return l.set(m,{extensionIdentifier:M?.identifier,stack:L}),L}const D=Symbol("prepareStackTrace wrapped");let p=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(m){if(m===C||!m||m[D]){p=m||C;return}p=function(f,P){return C(f,P),m.call(Error,f,P)},Object.assign(p,{[D]:!0})}}),I.setUnexpectedErrorHandler(m=>{g.error(m);const f=I.transformErrorForSerialization(m),P=l.get(m);if(!P?.extensionIdentifier){i.$onUnexpectedError(f);return}s.$onExtensionRuntimeError(P.extensionIdentifier,f);const M=n.onExtensionError(P.extensionIdentifier,m);g.trace("forwarded error to extension?",M,P)})}}e.ErrorHandler=u;class r{constructor(c,g,d,t,n){this._hostUtils=d,this._rpcProtocol=new A.RPCProtocol(c,null,t),g=r._transform(g,this._rpcProtocol);const s=new E.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:n}),s.set(b.IExtHostRpcService,new b.ExtHostRpcService(this._rpcProtocol)),s.set(S.IURITransformerService,new S.URITransformerService(t)),s.set(_.IHostUtils,d);const i=new k.InstantiationService(s,!0);i.invokeFunction(u.installEarlyHandler),this._logService=i.invokeFunction(a=>a.get(v.ILogService)),F.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=i.invokeFunction(a=>a.get(_.IExtHostExtensionService)),this._extensionService.initialize(),i.invokeFunction(u.installFullHandler)}async asBrowserUri(c){const g=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return h.URI.revive(await g.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,g){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=h.URI.revive(g.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=h.URI.revive(g.transformIncomingURIs(c.environment.appRoot));const d=c.environment.extensionDevelopmentLocationURI;return d&&(c.environment.extensionDevelopmentLocationURI=d.map(t=>h.URI.revive(g.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=h.URI.revive(g.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=h.URI.revive(g.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=h.URI.revive(g.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=h.URI.revive(g.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=h.URI.revive(g.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=h.URI.revive(g.transformIncomingURIs(c.logsLocation)),c.workspace=g.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=r}),define(De[351],Ie([1,0,9,12,215,232,138,94,70,45,20,44,7,56,39,272,273,40]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let o=class extends v.ExtHostDebugServiceBase{constructor(n,s,i,a,l,C,D){super(n,s,i,a,C,D),this._terminalService=l,this._integratedTerminalInstances=new d}createDebugAdapter(n,s){switch(n.type){case"server":return new w.SocketDebugAdapter(n);case"pipeServer":return new w.NamedPipeDebugAdapter(n);case"executable":return new w.ExecutableDebugAdapter(n,s.type)}return super.createDebugAdapter(n,s)}daExecutableFromPackage(n,s){const i=w.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),n.type);if(i)return new b.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new A.SignService}async $runInTerminal(n,s){if(n.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const i=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),l=this._terminalService.getDefaultShellArgs(!0),C=n.title||h.localize(0,null),D=JSON.stringify({shell:a,shellArgs:l});let p=await this._integratedTerminalInstances.checkout(D,C),m,f=!1;if(p)m=n.cwd;else{const L={shellPath:a,shellArgs:l,cwd:n.cwd,name:C,iconPath:new b.ThemeIcon("debug")};f=!0,p=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,D)}p.show(!0);const P=await p.processId;f?await new Promise(L=>setTimeout(L,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):F.isWindows?p.sendText("cls"):p.sendText("clear"));const M=(0,u.prepareCommand)(a,n.args,!!n.argsCanBeInterpretedByShell,m,n.env);p.sendText(M);const N=this.onDidTerminateDebugSession(L=>{L.id===s&&(this._integratedTerminalInstances.free(p),N.dispose())});return P}else if(n.kind==="external")return g(n,await this._configurationService.getConfigProvider());return super.$runInTerminal(n,s)}};e.ExtHostDebugService=o,e.ExtHostDebugService=o=je([$e(0,T.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,E.IExtHostExtensionService),$e(3,r.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,y.IExtHostEditorTabs),$e(6,S.IExtHostVariableResolverProvider)],o);let c;function g(t,n){if(!c)if(F.isWindows)c=new R.WindowsExternalTerminalService;else if(F.isMacintosh)c=new R.MacExternalTerminalService;else if(F.isLinux)c=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=n.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class d{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(n,s){const a=[...this._terminalInstances.entries()].map(([l,C])=>(0,I.createCancelablePromise)(async D=>{if(l.name!==s||C.lastUsedAt!==-1&&await(0,u.hasChildProcesses)(await l.processId))return null;const p=Date.now();return C.lastUsedAt+d.minUseDelay>p||D.isCancellationRequested||C.config!==n?null:(C.lastUsedAt=p,l)}));return await(0,I.firstParallel)(a,l=>!!l)}insert(n,s){this._terminalInstances.set(n,{lastUsedAt:Date.now(),config:s})}free(n){const s=this._terminalInstances.get(n);s&&(s.lastUsedAt=-1)}onTerminalClosed(n){this._terminalInstances.delete(n)}}}),define(De[352],Ie([1,0,16,2,101,39,69,40,43,44,20,26,93,17,13,89,24,63,56]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends b.ExtHostTaskBase{constructor(d,t,n,s,i,a,l,C,D){super(d,t,n,s,i,a,l,C),this.workspaceService=n,this.variableResolver=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const s=b.TaskHandleDTO.from(n,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(i,t);return this._proxy.$executeTask(s).catch(()=>{}),a}else{const s=b.TaskDTO.from(t,d);if(s===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,t,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),t);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(d,t,n,s){const i=[];if(s)for(const a of s){this.checkDeprecation(a,n),(!a.definition||!d[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const l=b.TaskDTO.from(a,n.extension);l&&(i.push(l),b.CustomExecutionDTO.is(l.execution)&&t.push(this.addCustomExecution(l,a,!0)))}return{tasks:i,extension:n.extension}}async resolveTaskInternal(d){return d}async getAFolder(d){let t=d&&d.length>0?d[0]:void 0;if(!t){const n=F.URI.file((0,r.homedir)());t=new y.WorkspaceFolder({uri:n,name:u.basename(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(d,t){const n=F.URI.revive(d),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(n),a=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.variableResolver.getResolver(),C=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(const D of t.variables)s.variables[D]=await l.resolveAsync(C,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.delimiter);for(let p=0;p<D.length;p++)D[p]=await l.resolveAsync(C,D[p])}s.process=await h.win32.findExecutable(await l.resolveAsync(C,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(C,t.process.cwd):void 0,D)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(d,t,n){return h.win32.findExecutable(d,t,n)}};e.ExtHostTask=c,e.ExtHostTask=c=je([$e(0,T.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,A.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,_.ILogService),$e(7,w.IExtHostApiDeprecationService),$e(8,o.IExtHostVariableResolverProvider)],c)}),define(De[353],Ie([1,0,63,56]),function(ge,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class h extends F.ExtHostVariableResolverProviderService{homeDir(){return(0,I.homedir)()}}e.NodeExtHostVariableResolverProviderService=h}),define(De[153],Ie([1,0,19,9,21,46,17,16,24,2,36]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(o,c,g,d){this.query=o,this.provider=c,this.fileUtils=g,this.processType=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,c){const g=this.query.folderQueries||[],d=new h.CancellationTokenSource(c);return new Promise((t,n)=>{this.collector=new S(o);let s=!1;const i=(a,l)=>{if(!s&&!this.isLimitHit){const C=this.resultSize(a);w(a)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,s=!0,d.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const D=this.resultSize(a);this.resultCount+=D,(D>0||!w(a))&&this.collector.add(a,l)}};Promise.all(g.map((a,l)=>this.searchInFolder(a,C=>i(C,l),d.token))).then(a=>{d.dispose(),this.collector.flush();const l=a.some(C=>!!C&&!!C.limitHit);t({limitHit:this.isLimitHit||l,messages:(0,I.flatten)(a.map(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},a=>{d.dispose();const l=(0,R.toErrorMessage)(a);n(new Error(l))})})}resultSize(o){return w(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,c){const g=Array.isArray(o.ranges)?o.ranges:[o.ranges],d=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:g.slice(0,c),preview:{matches:d.slice(0,c),text:o.preview.text},uri:o.uri}}async searchInFolder(o,c,g){const d=new T.QueryGlobTester(this.query,o),t=[],n={report:a=>{if(!this.validateProviderResult(a))return;const l=o.folder.scheme===A.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(a.uri))):void 0,C=y.relativePath(o.folder,a.uri);if(C){const D=d.includedInQuery(C,v.basename(C),l);(0,F.isThenable)(D)?t.push(D.then(p=>{p&&c(a)})):D&&c(a)}}},s=this.getSearchOptionsForFolder(o),i=await this.provider.provideTextSearchResults(b(this.query.contentPattern),s,n,g);return t.length&&await Promise.all(t),i}validateProviderResult(o){if(w(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const c=(0,T.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),g=(0,T.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),d={folder:E.URI.from(o.folder),excludes:g,includes:c,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return d.usePCRE2=this.query.usePCRE2,d}}e.TextSearchManager=k;function b(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class S{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,c=>this.sendItems(c))}add(o,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(_(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=S;function _(r){return w(r)?{preview:{matches:(0,I.mapArrayOrNot)(r.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:r.preview.text},ranges:(0,I.mapArrayOrNot)(r.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function w(r){return!!r.preview}e.extensionResultIsMatch=w;class u{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(o,c){this.maxBatchSize=o,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,c){o&&this.addItemToBatch(o,c)}addItems(o,c){o&&this.addItemsToBatch(o,c)}addItemToBatch(o,c){this.batch.push(o),this.batchSize+=c,this.onUpdate()}addItemsToBatch(o,c){this.batch=this.batch.concat(o),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u}),define(De[95],Ie([1,0,3,6,5,346,20,66,13,2,153]),function(ge,e,I,F,h,R,A,v,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,h.createDecorator)("IExtHostSearch");let k=class{constructor(w,u,r){this.extHostRpc=w,this._uriTransformer=u,this._logService=r,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,u){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const r=this._handlePool++;return this._textSearchProvider.set(r,u),this._proxy.$registerTextSearchProvider(r,this._transformScheme(w)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}registerFileSearchProvider(w,u){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const r=this._handlePool++;return this._fileSearchProvider.set(r,u),this._proxy.$registerFileSearchProvider(r,this._transformScheme(w)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(w,u,r,o){const c=b(r),g=this._fileSearchProvider.get(w);if(g)return this._fileSearchManager.fileSearch(c,g,d=>{this._proxy.$handleFileMatch(w,u,d.map(t=>t.resource))},o);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,u,r,o){const c=this._textSearchProvider.get(w);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const g=b(r);return this.createTextSearchManager(g,c).search(t=>this._proxy.$handleTextMatch(w,u,t),o)}$enableExtensionHostSearch(){}createTextSearchManager(w,u){return new T.TextSearchManager(w,u,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.ExtHostSearch=k,e.ExtHostSearch=k=je([$e(0,A.IExtHostRpcService),$e(1,v.IURITransformerService),$e(2,y.ILogService)],k);function b(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(S),extraFileResources:_.extraFileResources&&_.extraFileResources.map(w=>E.URI.revive(w))}}e.reviveQuery=b;function S(_){return{..._,folder:E.URI.revive(_.folder)}}}),define(De[354],Ie([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,69,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,14,7,85,331,91,151,39,25,276,314,65,149,93,94,95,13,66,20,26,318,274,72,89,294,329,90,71,334,332,333,295,55,327,330,114,70,88,319,92,320,17,134,283,263,312,3,27,270,112,257,321,322,296,311,282,313,113,325,298,299,293,308,297]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n,s,i,a,l,C,D,p,m,f,P,M,N,L,U,x,O,j,V,fe,J,X,z,Q,ve,le,we,G,B,H,me,Z,ie,re,ye,oe,de,ee,ue,pe,Pe,$,K,te,se,Y,he,Se,Ue,We,Ze,Qe,it,et,Te,Me,ze,Re,Xe,ce,ae,ke,He,xe,Ye,rt,ot,Et,yt,Qt,Vt,bt,Bt,Ot,$t,Pt,Tt,Mt,Wt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function zt(ct){const ut=ct.get(oe.IExtHostInitDataService),Gt=ct.get(Ue.IExtHostFileSystemInfo),kt=ct.get(te.IExtHostConsumerFileSystem),_t=ct.get(i.IExtHostExtensionService),ft=ct.get(Q.IExtHostWorkspace),Dt=ct.get(et.IExtHostTelemetry),Ft=ct.get(o.IExtHostConfiguration),St=ct.get(re.IURITransformerService),qe=ct.get(ye.IExtHostRpcService),Nt=ct.get(L.IExtHostStorage),Ut=ct.get(K.IExtensionStoragePaths),Le=ct.get(ie.ILoggerService),Fe=ct.get(ie.ILogService),Ce=ct.get(ue.IExtHostTunnelService),ne=ct.get(pe.IExtHostApiDeprecationService),Oe=ct.get(z.IExtHostWindow),Ve=ct.get(Qe.IExtHostSecretState),Je=ct.get(it.IExtHostEditorTabs),Ge=ct.get(Ot.IExtHostManagedSockets);qe.set(b.ExtHostContext.ExtHostFileSystemInfo,Gt),qe.set(b.ExtHostContext.ExtHostLogLevelServiceShape,Le),qe.set(b.ExtHostContext.ExtHostWorkspace,ft),qe.set(b.ExtHostContext.ExtHostConfiguration,Ft),qe.set(b.ExtHostContext.ExtHostExtensionService,_t),qe.set(b.ExtHostContext.ExtHostStorage,Nt),qe.set(b.ExtHostContext.ExtHostTunnelService,Ce),qe.set(b.ExtHostContext.ExtHostWindow,Oe),qe.set(b.ExtHostContext.ExtHostSecretState,Ve),qe.set(b.ExtHostContext.ExtHostTelemetry,Dt),qe.set(b.ExtHostContext.ExtHostEditorTabs,Je),qe.set(b.ExtHostContext.ExtHostManagedSockets,Ge);const nt=qe.set(b.ExtHostContext.ExtHostDecorations,ct.get(B.IExtHostDecorations)),gt=qe.set(b.ExtHostContext.ExtHostDocumentsAndEditors,ct.get(s.IExtHostDocumentsAndEditors)),mt=qe.set(b.ExtHostContext.ExtHostCommands,ct.get(u.IExtHostCommands)),vt=qe.set(b.ExtHostContext.ExtHostTerminalService,ct.get(U.IExtHostTerminalService)),ht=qe.set(b.ExtHostContext.ExtHostDebugService,ct.get(me.IExtHostDebugService)),At=qe.set(b.ExtHostContext.ExtHostSearch,ct.get(Z.IExtHostSearch)),qt=qe.set(b.ExtHostContext.ExtHostTask,ct.get(H.IExtHostTask)),yi=qe.set(b.ExtHostContext.ExtHostOutputService,ct.get(m.IExtHostOutputService)),Ht=qe.set(b.ExtHostContext.ExtHostLocalization,ct.get(rt.IExtHostLocalizationService)),gi=qe.set(b.ExtHostContext.ExtHostUrls,new J.ExtHostUrls(qe)),It=qe.set(b.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(qe,gt)),_i=qe.set(b.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(qe,gt,Fe)),zi=qe.set(b.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Fe,It,qe.getProxy(b.MainContext.MainThreadBulkEdits))),Ct=qe.set(b.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(qe,mt,gt,It,kt)),ii=qe.set(b.ExtHostContext.ExtHostNotebookDocuments,new ae.ExtHostNotebookDocuments(Ct)),pi=qe.set(b.ExtHostContext.ExtHostNotebookEditors,new ce.ExtHostNotebookEditors(Fe,Ct)),oi=qe.set(b.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(qe,ut,Ct,mt,Fe)),Ci=qe.set(b.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(qe,Ct)),Di=qe.set(b.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new bt.ExtHostNotebookDocumentSaveParticipant(Fe,Ct,qe.getProxy(b.MainContext.MainThreadBulkEdits))),Rt=qe.set(b.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(qe,gt)),vi=qe.set(b.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(qe.getProxy(b.MainContext.MainThreadTreeViews),mt,Fe)),Ii=qe.set(b.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(qe.getProxy(b.MainContext.MainThreadEditorInsets),Rt,ut.remote)),ai=qe.set(b.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(qe,Fe,Gt,gt)),ci=qe.set(b.ExtHostContext.ExtHostLanguages,new D.ExtHostLanguages(qe,It,mt.converter,St)),lt=qe.set(b.ExtHostContext.ExtHostLanguageFeatures,new C.ExtHostLanguageFeatures(qe,St,It,mt,ai,Fe,ne,Dt)),Hi=qe.set(b.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(qe,lt)),Yt=qe.set(b.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(qe,Fe,gt)),ni=qe.set(b.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(qe,ft,mt)),Ei=qe.set(b.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(qe,mt,It,Fe)),ki=qe.set(b.ExtHostContext.ExtHostQuickDiff,new yt.ExtHostQuickDiff(qe,St)),Vi=qe.set(b.ExtHostContext.ExtHostShare,new $t.ExtHostShare(qe,St)),Pi=qe.set(b.ExtHostContext.ExtHostComments,(0,r.createExtHostComments)(qe,mt,It)),bi=qe.set(b.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(qe.getProxy(b.MainContext.MainThreadProgress))),ji=qe.set(b.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(qe)),Ti=qe.set(b.ExtHostContext.ExtHostTheming,new ee.ExtHostTheming(qe)),li=qe.set(b.ExtHostContext.ExtHostAuthentication,new Pe.ExtHostAuthentication(qe)),qi=qe.set(b.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(qe,mt)),wi=qe.set(b.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(qe,ut.remote,ft,Fe,ne)),Ai=qe.set(b.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(qe,wi,ft)),cn=qe.set(b.ExtHostContext.ExtHostCustomEditors,new Y.ExtHostCustomEditors(qe,It,Ut,wi,Ai)),Ri=qe.set(b.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(qe,wi)),ri=qe.set(b.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(qe,mt,gt)),ln=qe.set(b.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(qe)),un=qe.set(b.ExtHostContext.ExtHostProfileContentHandlers,new Et.ExtHostProfileContentHandlers(qe));qe.set(b.ExtHostContext.ExtHostInteractive,new ke.ExtHostInteractive(qe,Ct,gt,mt,Fe));const Gi=qe.set(b.ExtHostContext.ExtHostInlineChat,new Vt.ExtHostInteractiveEditor(qe,mt,It,Fe)),fi=qe.set(b.ExtHostContext.ExtHostChatProvider,new Pt.ExtHostChatProvider(qe,Fe)),Ki=qe.set(b.ExtHostContext.ExtHostChatAgents,new jt.ExtHostChatAgents(qe,fi,Fe)),Xi=qe.set(b.ExtHostContext.ExtHostChatVariables,new Tt.ExtHostChatVariables(qe)),mi=qe.set(b.ExtHostContext.ExtHostChat,new Qt.ExtHostChat(qe,Fe)),Qi=qe.set(b.ExtHostContext.ExtHostAiRelatedInformation,new Mt.ExtHostRelatedInformation(qe)),Li=qe.set(b.ExtHostContext.ExtHostAiEmbeddingVector,new Wt.ExtHostAiEmbeddingVector(qe)),Yi=qe.set(b.ExtHostContext.ExtHostIssueReporter,new Bt.ExtHostIssueReporter(qe)),Jt=qe.set(b.ExtHostContext.ExtHostStatusBar,new N.ExtHostStatusBar(qe,mt.converter)),Si=Object.values(b.ExtHostContext);qe.assertRegistered(Si);const dn=new Se.ExtHostBulkEdits(qe,gt),Kt=new w.ExtHostClipboard(qe),ui=new p.ExtHostMessageService(qe,Fe),Fi=new g.ExtHostDialogs(qe);return _.ExtHostApiCommands.register(mt),function(Be,Zt,Oi){const pt=function(){let Ee=!Be.isUnderDevelopment;function _e(){Ee||(Fe.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Ee=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")_e();else{const wt=st;typeof wt.scheme>"u"&&_e(),typeof wt.exclusive=="boolean"&&(0,xe.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return st}}(),Ji={getSession(Ee,_e,Ne){return li.getSession(Be,Ee,_e,Ne)},getSessions(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"authGetSessions"),li.getSessions(Be,Ee,_e)},async hasSession(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"authSession"),!!await li.getSession(Be,Ee,_e,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(Ee,_e,Ne,st){return li.registerAuthenticationProvider(Ee,_e,Ne,st)}},Zi={registerCommand(Ee,_e,Ne){return mt.registerCommand(!0,Ee,_e,Ne,void 0,Be)},registerTextEditorCommand(Ee,_e,Ne){return mt.registerCommand(!0,Ee,(...st)=>{const wt=Rt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+Ee+" because there is no active text editor.");return}return wt.edit(Lt=>{_e.apply(Ne,[wt,Lt,...st])}).then(Lt=>{Lt||Fe.warn("Edits from command "+Ee+" were not applied.")},Lt=>{Fe.warn("An error occurred while running command "+Ee,Lt)})},void 0,void 0,Be)},registerDiffInformationCommand:(Ee,_e,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"diffCommand"),mt.registerCommand(!0,Ee,async(...st)=>{const wt=gt.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+Ee+" because there is no active text editor.");return}const Lt=await Rt.getDiffInformation(wt.id);_e.apply(Ne,[Lt,...st])},void 0,void 0,Be)),executeCommand(Ee,..._e){return mt.executeCommand(Ee,..._e)},getCommands(Ee=!1){return mt.getCommands(Ee)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Kt.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Be,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Be,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(Ee,_e){return et.ExtHostTelemetryLogger.validateSender(Ee),Dt.instantiateLogger(Be,Ee,_e)},openExternal(Ee,_e){return Oe.openUri(Ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(Ee){if(Ee.scheme===ut.environment.appUriScheme)return gi.createAppUri(Ee);try{return await Oe.asExternalUri(Ee,{allowTunneling:!!ut.remote.authority})}catch(_e){if((0,Xe.matchesScheme)(Ee,Re.Schemas.http)||(0,Xe.matchesScheme)(Ee,Re.Schemas.https))return Ee;throw _e}},get remoteName(){return(0,G.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,xe.checkProposedApiEnabled)(Be,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(Ee){return(0,xe.checkProposedApiEnabled)(Be,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Be,Ee)},get appQuality(){return(0,xe.checkProposedApiEnabled)(Be,"resolvers"),ut.quality},get appCommit(){return(0,xe.checkProposedApiEnabled)(Be,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const hn={createTestController(Ee,_e,Ne){return ri.createTestController(Be,Ee,_e,Ne)},createTestObserver(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.createTestObserver()},runTests(Ee){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.runTests(Ee)},get onDidChangeTestResults(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.onResultsChanged},get testResults(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.results}},di=ut.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,tn={getExtension(Ee,_e){(0,xe.isProposedApiEnabled)(Be,"extensionsAny")||(_e=!1);const Ne=Zt.mine.getExtensionDescription(Ee);if(Ne)return new i.Extension(_t,Be.identifier,Ne,di,!1);if(_e){const st=Zt.all.getExtensionDescription(Ee);if(st)return new i.Extension(_t,Be.identifier,st,di,!0)}},get all(){const Ee=[];for(const _e of Zt.mine.getAllExtensionDescriptions())Ee.push(new i.Extension(_t,Be.identifier,_e,di,!1));return Ee},get allAcrossExtensionHosts(){(0,xe.checkProposedApiEnabled)(Be,"extensionsAny");const Ee=new ve.ExtensionIdentifierSet(Zt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),_e=[];for(const Ne of Zt.all.getAllExtensionDescriptions()){const st=!Ee.has(Ne.identifier);_e.push(new i.Extension(_t,Be.identifier,Ne,di,st))}return _e},get onDidChange(){return(0,xe.isProposedApiEnabled)(Be,"extensionsAny")?h.Event.any(Zt.mine.onDidChange,Zt.all.onDidChange):Zt.mine.onDidChange}},nn={createDiagnosticCollection(Ee){return ai.createDiagnosticCollection(Be.identifier,Ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:Ee=>ai.getDiagnostics(Ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(Ee,_e){return ci.changeLanguage(Ee.uri,_e)},match(Ee,_e){const Ne=It.getDocumentData(_e.uri)?.notebook;return(0,T.score)(j.LanguageSelector.from(Ee),_e.uri,_e.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(Ee,_e,Ne){return lt.registerCodeActionProvider(Be,pt(Ee),_e,Ne)},registerDocumentPasteEditProvider(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"documentPaste"),lt.registerDocumentPasteEditProvider(Be,pt(Ee),_e,Ne)},registerCodeLensProvider(Ee,_e){return lt.registerCodeLensProvider(Be,pt(Ee),_e)},registerDefinitionProvider(Ee,_e){return lt.registerDefinitionProvider(Be,pt(Ee),_e)},registerDeclarationProvider(Ee,_e){return lt.registerDeclarationProvider(Be,pt(Ee),_e)},registerImplementationProvider(Ee,_e){return lt.registerImplementationProvider(Be,pt(Ee),_e)},registerTypeDefinitionProvider(Ee,_e){return lt.registerTypeDefinitionProvider(Be,pt(Ee),_e)},registerHoverProvider(Ee,_e){return lt.registerHoverProvider(Be,pt(Ee),_e,Be.identifier)},registerEvaluatableExpressionProvider(Ee,_e){return lt.registerEvaluatableExpressionProvider(Be,pt(Ee),_e,Be.identifier)},registerInlineValuesProvider(Ee,_e){return lt.registerInlineValuesProvider(Be,pt(Ee),_e,Be.identifier)},registerDocumentHighlightProvider(Ee,_e){return lt.registerDocumentHighlightProvider(Be,pt(Ee),_e)},registerLinkedEditingRangeProvider(Ee,_e){return lt.registerLinkedEditingRangeProvider(Be,pt(Ee),_e)},registerReferenceProvider(Ee,_e){return lt.registerReferenceProvider(Be,pt(Ee),_e)},registerRenameProvider(Ee,_e){return lt.registerRenameProvider(Be,pt(Ee),_e)},registerDocumentSymbolProvider(Ee,_e,Ne){return lt.registerDocumentSymbolProvider(Be,pt(Ee),_e,Ne)},registerWorkspaceSymbolProvider(Ee){return lt.registerWorkspaceSymbolProvider(Be,Ee)},registerDocumentFormattingEditProvider(Ee,_e){return lt.registerDocumentFormattingEditProvider(Be,pt(Ee),_e)},registerDocumentRangeFormattingEditProvider(Ee,_e){return lt.registerDocumentRangeFormattingEditProvider(Be,pt(Ee),_e)},registerOnTypeFormattingEditProvider(Ee,_e,Ne,...st){return lt.registerOnTypeFormattingEditProvider(Be,pt(Ee),_e,[Ne].concat(st))},registerDocumentSemanticTokensProvider(Ee,_e,Ne){return lt.registerDocumentSemanticTokensProvider(Be,pt(Ee),_e,Ne)},registerDocumentRangeSemanticTokensProvider(Ee,_e,Ne){return lt.registerDocumentRangeSemanticTokensProvider(Be,pt(Ee),_e,Ne)},registerSignatureHelpProvider(Ee,_e,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(Be,pt(Ee),_e,Ne):lt.registerSignatureHelpProvider(Be,pt(Ee),_e,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(Ee,_e,...Ne){return lt.registerCompletionItemProvider(Be,pt(Ee),_e,Ne)},registerInlineCompletionItemProvider(Ee,_e,Ne){return _e.handleDidShowCompletionItem&&(0,xe.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,xe.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),Ne&&(0,xe.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Be,pt(Ee),_e,Ne)},registerDocumentLinkProvider(Ee,_e){return lt.registerDocumentLinkProvider(Be,pt(Ee),_e)},registerColorProvider(Ee,_e){return lt.registerColorProvider(Be,pt(Ee),_e)},registerFoldingRangeProvider(Ee,_e){return lt.registerFoldingRangeProvider(Be,pt(Ee),_e)},registerSelectionRangeProvider(Ee,_e){return lt.registerSelectionRangeProvider(Be,Ee,_e)},registerCallHierarchyProvider(Ee,_e){return lt.registerCallHierarchyProvider(Be,Ee,_e)},registerTypeHierarchyProvider(Ee,_e){return lt.registerTypeHierarchyProvider(Be,Ee,_e)},setLanguageConfiguration:(Ee,_e)=>lt.setLanguageConfiguration(Be,Ee,_e),getTokenInformationAtPosition(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"tokenInformation"),ci.tokenAtPosition(Ee,_e)},registerInlayHintsProvider(Ee,_e){return lt.registerInlayHintsProvider(Be,Ee,_e)},createLanguageStatusItem(Ee,_e){return ci.createLanguageStatusItem(Be,Ee,_e)},registerDocumentDropEditProvider(Ee,_e,Ne){return lt.registerDocumentOnDropEditProvider(Be,Ee,_e,(0,xe.isProposedApiEnabled)(Be,"dropMetadata")?Ne:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(Ee,_e,Ne){const st=await(A.URI.isUri(Ee)?Promise.resolve(sn.openTextDocument(Ee)):Promise.resolve(Ee));return Rt.showTextDocument(st,_e,Ne)},createTextEditorDecorationType(Ee){return Rt.createTextEditorDecorationType(Be,Ee)},onDidChangeActiveTextEditor(Ee,_e,Ne){return Rt.onDidChangeActiveTextEditor(Ee,_e,Ne)},onDidChangeVisibleTextEditors(Ee,_e,Ne){return Rt.onDidChangeVisibleTextEditors(Ee,_e,Ne)},onDidChangeTextEditorSelection(Ee,_e,Ne){return Rt.onDidChangeTextEditorSelection(Ee,_e,Ne)},onDidChangeTextEditorOptions(Ee,_e,Ne){return Rt.onDidChangeTextEditorOptions(Ee,_e,Ne)},onDidChangeTextEditorVisibleRanges(Ee,_e,Ne){return Rt.onDidChangeTextEditorVisibleRanges(Ee,_e,Ne)},onDidChangeTextEditorViewColumn(Ee,_e,Ne){return Rt.onDidChangeTextEditorViewColumn(Ee,_e,Ne)},onDidCloseTerminal(Ee,_e,Ne){return vt.onDidCloseTerminal(Ee,_e,Ne)},onDidOpenTerminal(Ee,_e,Ne){return vt.onDidOpenTerminal(Ee,_e,Ne)},onDidChangeActiveTerminal(Ee,_e,Ne){return vt.onDidChangeActiveTerminal(Ee,_e,Ne)},onDidChangeTerminalDimensions(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"terminalDimensions"),vt.onDidChangeTerminalDimensions(Ee,_e,Ne)},onDidChangeTerminalState(Ee,_e,Ne){return vt.onDidChangeTerminalState(Ee,_e,Ne)},onDidWriteTerminalData(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(Ee,_e,Ne)},onDidExecuteTerminalCommand(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(Ee,_e,Ne)},get state(){return Oe.getState(Be)},onDidChangeWindowState(Ee,_e,Ne){return Oe.onDidChangeWindowState(Ee,_e,Ne)},showInformationMessage(Ee,..._e){return ui.showMessage(Be,R.default.Info,Ee,_e[0],_e.slice(1))},showWarningMessage(Ee,..._e){return ui.showMessage(Be,R.default.Warning,Ee,_e[0],_e.slice(1))},showErrorMessage(Ee,..._e){return ui.showMessage(Be,R.default.Error,Ee,_e[0],_e.slice(1))},showQuickPick(Ee,_e,Ne){return ni.showQuickPick(Be,Ee,_e,Ne)},showWorkspaceFolderPick(Ee){return ni.showWorkspaceFolderPick(Ee)},showInputBox(Ee,_e){return ni.showInput(Ee,_e)},showOpenDialog(Ee){return Fi.showOpenDialog(Be,Ee)},showSaveDialog(Ee){return Fi.showSaveDialog(Ee)},createStatusBarItem(Ee,_e,Ne){let st,wt,Lt;return typeof Ee=="string"?(st=Ee,wt=_e,Lt=Ne):(wt=Ee,Lt=_e),Jt.createStatusBarEntry(Be,st,wt,Lt)},setStatusBarMessage(Ee,_e){return Jt.setStatusBarMessage(Ee,_e)},withScmProgress(Ee){return ne.report("window.withScmProgress",Be,"Use 'withProgress' instead."),bi.withProgress(Be,{location:V.ProgressLocation.SourceControl},(_e,Ne)=>Ee({report(st){}}))},withProgress(Ee,_e){return bi.withProgress(Be,Ee,_e)},createOutputChannel(Ee,_e){return yi.createOutputChannel(Ee,_e,Be)},createWebviewPanel(Ee,_e,Ne,st){return Ai.createWebviewPanel(Be,Ee,_e,Ne,st)},createWebviewTextEditorInset(Ee,_e,Ne,st){return(0,xe.checkProposedApiEnabled)(Be,"editorInsets"),Ii.createWebviewEditorInset(Ee,_e,Ne,st,Be)},createTerminal(Ee,_e,Ne){return typeof Ee=="object"?"pty"in Ee?vt.createExtensionTerminal(Ee):vt.createTerminalFromOptions(Ee):vt.createTerminal(Ee,_e,Ne)},registerTerminalLinkProvider(Ee){return vt.registerLinkProvider(Ee)},registerTerminalProfileProvider(Ee,_e){return vt.registerProfileProvider(Be,Ee,_e)},registerTerminalQuickFixProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(Ee,Be.identifier.value,_e)},registerTreeDataProvider(Ee,_e){return vi.registerTreeDataProvider(Ee,_e,Be)},createTreeView(Ee,_e){return vi.createTreeView(Ee,_e,Be)},registerWebviewPanelSerializer:(Ee,_e)=>Ai.registerWebviewPanelSerializer(Be,Ee,_e),registerCustomEditorProvider:(Ee,_e,Ne={})=>cn.registerCustomEditorProvider(Be,Ee,_e,Ne),registerFileDecorationProvider(Ee){return nt.registerFileDecorationProvider(Ee,Be)},registerUriHandler(Ee){return gi.registerUriHandler(Be,Ee)},createQuickPick(){return ni.createQuickPick(Be)},createInputBox(){return ni.createInputBox(Be)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(Ee,_e,Ne){return Ti.onDidChangeActiveColorTheme(Ee,_e,Ne)},registerWebviewViewProvider(Ee,_e,Ne){return Ri.registerWebviewViewProvider(Be,Ee,_e,Ne?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(Ee,_e,Ne){return Ct.onDidChangeActiveNotebookEditor(Ee,_e,Ne)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Ee,_e,Ne){return pi.onDidChangeNotebookEditorSelection(Ee,_e,Ne)},onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne)},showNotebookDocument(Ee,_e){return Ct.showNotebookDocument(Ee,_e)},registerExternalUriOpener(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,Ee,_e,Ne)},registerProfileContentHandler(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"profileContentHandlers"),un.registrProfileContentHandler(Be,Ee,_e)},registerQuickDiffProvider(Ee,_e,Ne,st){return(0,xe.checkProposedApiEnabled)(Be,"quickDiffProvider"),ki.registerQuickDiffProvider(pt(Ee),_e,Ne,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"shareProvider"),Vi.registerShareProvider(pt(Ee),_e)}},sn={get rootPath(){return ne.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(Ee){throw new F.ReadonlyError("rootPath")},getWorkspaceFolder(Ee){return ft.getWorkspaceFolder(Ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(Ee){throw new F.ReadonlyError("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(Ee){throw new F.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(Ee,_e,...Ne)=>ft.updateWorkspaceFolders(Be,Ee,_e||0,...Ne),onDidChangeWorkspaceFolders:function(Ee,_e,Ne){return ft.onDidChangeWorkspace(Ee,_e,Ne)},asRelativePath:(Ee,_e)=>ft.getRelativePath(Ee,_e),findFiles:(Ee,_e,Ne,st)=>ft.findFiles(Ee,_e,Ne,Be.identifier,st),findTextInFiles:(Ee,_e,Ne,st)=>{(0,xe.checkProposedApiEnabled)(Be,"findTextInFiles");let wt,Lt;return typeof _e=="object"?(wt=_e,Lt=Ne):(wt={},Lt=_e,st=Ne),ft.findTextInFiles(Ee,wt||{},Lt,Be.identifier,st)},save:Ee=>((0,xe.checkProposedApiEnabled)(Be,"saveEditor"),ft.save(Ee)),saveAs:Ee=>((0,xe.checkProposedApiEnabled)(Be,"saveEditor"),ft.saveAs(Ee)),saveAll:Ee=>ft.saveAll(Ee),applyEdit(Ee,_e){return dn.applyWorkspaceEdit(Ee,Be,_e)},createFileSystemWatcher:(Ee,_e,Ne,st)=>Yt.createFileSystemWatcher(ft,Be,Ee,_e,Ne,st),get textDocuments(){return It.getAllDocumentData().map(Ee=>Ee.document)},set textDocuments(Ee){throw new F.ReadonlyError("textDocuments")},openTextDocument(Ee){let _e;const Ne=Ee;if(typeof Ee=="string")_e=Promise.resolve(A.URI.file(Ee));else if(A.URI.isUri(Ee))_e=Promise.resolve(Ee);else if(!Ne||typeof Ne=="object")_e=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(st=>It.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Ee,_e,Ne)=>It.onDidAddDocument(Ee,_e,Ne),onDidCloseTextDocument:(Ee,_e,Ne)=>It.onDidRemoveDocument(Ee,_e,Ne),onDidChangeTextDocument:(Ee,_e,Ne)=>It.onDidChangeDocument(Ee,_e,Ne),onDidSaveTextDocument:(Ee,_e,Ne)=>It.onDidSaveDocument(Ee,_e,Ne),onWillSaveTextDocument:(Ee,_e,Ne)=>zi.getOnWillSaveTextDocumentEvent(Be)(Ee,_e,Ne),get notebookDocuments(){return Ct.notebookDocuments.map(Ee=>Ee.apiNotebook)},async openNotebookDocument(Ee,_e){let Ne;if(A.URI.isUri(Ee))Ne=Ee,await Ct.openNotebookDocument(Ee);else if(typeof Ee=="string")Ne=A.URI.revive(await Ct.createNotebookDocument({viewType:Ee,content:_e}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(Ee,_e,Ne){return ii.onDidSaveNotebookDocument(Ee,_e,Ne)},onDidChangeNotebookDocument(Ee,_e,Ne){return ii.onDidChangeNotebookDocument(Ee,_e,Ne)},onWillSaveNotebookDocument(Ee,_e,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Be)(Ee,_e,Ne)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(Ee,_e,Ne,st){return Ct.registerNotebookSerializer(Be,Ee,_e,Ne,(0,xe.isProposedApiEnabled)(Be,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(Ee,_e,Ne)=>Oi.onDidChangeConfiguration(Ee,_e,Ne),getConfiguration(Ee,_e){return _e=arguments.length===1?void 0:_e,Oi.getConfiguration(Ee,_e,Be)},registerTextDocumentContentProvider(Ee,_e){return _i.registerTextDocumentContentProvider(Ee,_e)},registerTaskProvider:(Ee,_e)=>(ne.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Be,Ee,_e)),registerFileSystemProvider(Ee,_e,Ne){return(0,He.combinedDisposable)(Hi.registerFileSystemProvider(Be,Ee,_e,Ne),kt.addFileSystemProvider(Ee,_e,Ne))},get fs(){return kt.value},registerFileSearchProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"fileSearchProvider"),At.registerFileSearchProvider(Ee,_e)),registerTextSearchProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"textSearchProvider"),At.registerTextSearchProvider(Ee,_e)),registerRemoteAuthorityResolver:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"resolvers"),_t.registerRemoteAuthorityResolver(Ee,_e)),registerResourceLabelFormatter:Ee=>((0,xe.checkProposedApiEnabled)(Be,"resolvers"),ji.$registerResourceLabelFormatter(Ee)),getRemoteExecServer:Ee=>((0,xe.checkProposedApiEnabled)(Be,"resolvers"),_t.getRemoteExecServer(Ee)),onDidCreateFiles:(Ee,_e,Ne)=>Yt.onDidCreateFile(Ee,_e,Ne),onDidDeleteFiles:(Ee,_e,Ne)=>Yt.onDidDeleteFile(Ee,_e,Ne),onDidRenameFiles:(Ee,_e,Ne)=>Yt.onDidRenameFile(Ee,_e,Ne),onWillCreateFiles:(Ee,_e,Ne)=>Yt.getOnWillCreateFileEvent(Be)(Ee,_e,Ne),onWillDeleteFiles:(Ee,_e,Ne)=>Yt.getOnWillDeleteFileEvent(Be)(Ee,_e,Ne),onWillRenameFiles:(Ee,_e,Ne)=>Yt.getOnWillRenameFileEvent(Be)(Ee,_e,Ne),openTunnel:Ee=>((0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ce.openTunnel(Be,Ee).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(Ee,_e,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ce.onDidChangeTunnels(Ee,_e,Ne)),registerPortAttributesProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"portsAttributes"),Ce.registerPortsAttributesProvider(Ee,_e)),registerTunnelProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"tunnelFactory"),Ce.registerTunnelProvider(Ee,_e)),registerTimelineProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"timeline"),qi.registerTimelineProvider(Ee,_e,Be.identifier,mt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:Ee=>((0,xe.checkProposedApiEnabled)(Be,"workspaceTrust"),ft.requestWorkspaceTrust(Ee)),onDidGrantWorkspaceTrust:(Ee,_e,Ne)=>ft.onDidGrantWorkspaceTrust(Ee,_e,Ne),registerEditSessionIdentityProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(Ee,_e)),onWillCreateEditSessionIdentity:(Ee,_e,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Be)(Ee,_e,Ne)),registerCanonicalUriProvider:(Ee,_e)=>((0,xe.checkProposedApiEnabled)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider(Ee,_e)),getCanonicalUri:(Ee,_e,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"canonicalUriProvider"),ft.provideCanonicalUri(Ee,_e,Ne))},fn={get inputBox(){return ne.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Be)},createSourceControl(Ee,_e,Ne){return Ei.createSourceControl(Be,Ee,_e,Ne)}},on={createCommentController(Ee,_e){return Pi.createCommentController(Be,Ee,_e)}},an={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(Ee,_e,Ne){return ht.onDidStartDebugSession(Ee,_e,Ne)},onDidTerminateDebugSession(Ee,_e,Ne){return ht.onDidTerminateDebugSession(Ee,_e,Ne)},onDidChangeActiveDebugSession(Ee,_e,Ne){return ht.onDidChangeActiveDebugSession(Ee,_e,Ne)},onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne){return ht.onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne)},onDidChangeBreakpoints(Ee,_e,Ne){return ht.onDidChangeBreakpoints(Ee,_e,Ne)},onDidChangeStackFrameFocus(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"debugFocus"),ht.onDidChangeStackFrameFocus(Ee,_e,Ne)},registerDebugConfigurationProvider(Ee,_e,Ne){return ht.registerDebugConfigurationProvider(Ee,_e,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Ee,_e){return ht.registerDebugAdapterDescriptorFactory(Be,Ee,_e)},registerDebugAdapterTrackerFactory(Ee,_e){return ht.registerDebugAdapterTrackerFactory(Ee,_e)},startDebugging(Ee,_e,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?ht.startDebugging(Ee,_e,{parentSession:Ne}):ht.startDebugging(Ee,_e,Ne||{})},stopDebugging(Ee){return ht.stopDebugging(Ee)},addBreakpoints(Ee){return ht.addBreakpoints(Ee)},removeBreakpoints(Ee){return ht.removeBreakpoints(Ee)},asDebugSourceUri(Ee,_e){return ht.asDebugSourceUri(Ee,_e)}},Mi={registerTaskProvider:(Ee,_e)=>qt.registerTaskProvider(Be,Ee,_e),fetchTasks:Ee=>qt.fetchTasks(Ee),executeTask:Ee=>qt.executeTask(Be,Ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(Ee,_e,Ne)=>qt.onDidStartTask(Ee,_e,Ne),onDidEndTask:(Ee,_e,Ne)=>qt.onDidEndTask(Ee,_e,Ne),onDidStartTaskProcess:(Ee,_e,Ne)=>qt.onDidStartTaskProcess(Ee,_e,Ne),onDidEndTaskProcess:(Ee,_e,Ne)=>qt.onDidEndTaskProcess(Ee,_e,Ne)},Ni={createNotebookController(Ee,_e,Ne,st,wt){return oi.createNotebookController(Be,Ee,_e,Ne,st,(0,xe.isProposedApiEnabled)(Be,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(Ee,_e)=>Ct.registerNotebookCellStatusBarItemProvider(Be,Ee,_e),createRendererMessaging(Ee){return Ci.createRendererMessaging(Be,Ee)},createNotebookControllerDetectionTask(Ee){return(0,xe.checkProposedApiEnabled)(Be,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Be,Ee)},registerKernelSourceActionProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Be,Ee,_e)},onDidChangeNotebookCellExecutionState(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(Ee,_e,Ne)}},Ui={t(...Ee){if(typeof Ee[0]=="string"){const _e=Ee.shift(),Ne=!Ee||typeof Ee[0]!="object"?Ee:Ee[0];return Ht.getMessage(Be.identifier.value,{message:_e,args:Ne})}return Ht.getMessage(Be.identifier.value,Ee[0])},get bundle(){return Ht.getBundle(Be.identifier.value)},get uri(){return Ht.getBundleUri(Be.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"interactive"),Gi.registerProvider(Be,Ee,_e={label:_e?.label??Be.displayName??Be.name})},registerInteractiveSessionProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"interactive"),mi.registerChatProvider(Be,Ee,_e)},sendInteractiveRequestToProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"interactive"),mi.sendInteractiveRequestToProvider(Ee,_e)},get onDidPerformUserAction(){return(0,xe.checkProposedApiEnabled)(Be,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"interactive"),mi.transferChatSession(Ee,_e)}},xi={getRelatedInformation(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Qi.getRelatedInformation(Be,Ee,_e)},registerRelatedInformationProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Be,Ee,_e)},registerEmbeddingVectorProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Be,Ee,_e)}},Bi={registerChatResponseProvider(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"chatProvider"),fi.registerProvider(Be.identifier,Ee,_e,Ne)},requestChatAccess(Ee){return(0,xe.checkProposedApiEnabled)(Be,"chatRequestAccess"),fi.requestChatResponseProvider(Be.identifier,Ee)},registerVariable(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"chatVariables"),Xi.registerVariableResolver(Be,Ee,_e,Ne)},registerMappedEditsProvider(Ee,_e){return(0,xe.checkProposedApiEnabled)(Be,"mappedEditsProvider"),lt.registerMappedEditsProvider(Be,Ee,_e)},registerAgent(Ee,_e,Ne){return(0,xe.checkProposedApiEnabled)(Be,"chatAgents"),Ki.registerAgent(Be.identifier,Ee,_e,Ne)}};return{version:ut.version,ai:xi,authentication:Ji,commands:Zi,comments:on,chat:Bi,debug:an,env:en,extensions:tn,interactive:hi,l10n:Ui,languages:nn,notebooks:Ni,scm:fn,tasks:Mi,tests:hn,window:rn,workspace:sn,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatMessage:V.ChatMessage,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:b.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:h.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:E.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixExecuteTerminalCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:v.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:S.UIKind,Uri:A.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,ManagedResolvedAuthority:V.ManagedResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestMessage2:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:ie.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.StackFrameFocus,ThreadFocus:V.ThreadFocus,RelatedInformationType:V.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=zt}),define(De[355],Ie([1,0,103,152,39,149,40,33,69,44,93,94,95,115,72,89,151,71,55,114,88,70,150,13,56,112,113]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n,s,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,I.registerSingleton)(n.ILoggerService,t.ExtHostLoggerService,1),(0,I.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(v.IExtHostCommands,v.ExtHostCommands,0),(0,I.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,I.registerSingleton)(r.IExtHostConsumerFileSystem,r.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,I.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,I.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(a.IExtHostManagedSockets,a.ExtHostManagedSockets,0),(0,I.registerSingleton)(o.IExtHostFileSystemInfo,o.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService,1),(0,I.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch,0),(0,I.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,I.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,0),(0,I.registerSingleton)(E.IExtHostTerminalService,E.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService,0),(0,I.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,0),(0,I.registerSingleton)(h.IExtHostWorkspace,h.ExtHostWorkspace,0),(0,I.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState,0),(0,I.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry,0),(0,I.registerSingleton)(d.IExtHostEditorTabs,d.ExtHostEditorTabs,0),(0,I.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(De[116],Ie([1,0,19,13,36,92]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function v(k,b,S,_){const w=(0,I.mapArrayOrNot)(S,y),u=new h.TextSearchMatch(b,w,_),r=u.preview.matches;return{ranges:(0,I.mapArrayOrNot)(w,E),uri:k,preview:{text:u.preview.text,matches:(0,I.mapArrayOrNot)(r,E)}}}e.createTextSearchResult=v;function y(k){return new h.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function E(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(b,S){this.prefix=b,this.logService=S}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};e.OutputChannel=T,e.OutputChannel=T=je([$e(1,F.ILogService)],T)}),define(De[356],Ie([1,0,48,16,76,32,12,15,116,357]),function(ge,e,I,F,h,R,A,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const T=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,g,d,t){const n=b(c,g,d,t),s=g.folder.fsPath;return{cmd:I.spawn(T,n.args,{cwd:s}),rgDiskPath:T,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=k;function b(c,g,d,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];_([g],d,!1).forEach(i=>{const a=(0,y.anchorGlob)(i);if(n.push("-g",a),A.isMacintosh){const l=(0,h.normalizeNFD)(a);l!==a&&n.push("-g",l)}});const s=S([g],t,void 0,!1);return s.globArgs.forEach(i=>{const a=`!${(0,y.anchorGlob)(i)}`;if(n.push("-g",a),A.isMacintosh){const l=(0,h.normalizeNFD)(a);l!==a&&n.push("-g",l)}}),g.disregardIgnoreFiles!==!1?n.push("--no-ignore"):g.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),g.ignoreSymlinks||n.push("--follow"),c.exists&&n.push("--quiet"),n.push("--no-config"),g.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function S(c,g,d,t=!0){const n=[];let s={};return c.forEach(i=>{const a=Object.assign({},i.excludePattern||{},g||{}),l=w(a,t?i.folder.fsPath:void 0,d);n.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:n,siblingClauses:s}}function _(c,g,d=!0){const t=[];return c.forEach(n=>{const s=Object.assign({},g||{},n.includePattern||{}),i=w(s,d?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function w(c,g,d){const t=[],n={};return Object.keys(c).forEach(s=>{if(d&&d.has(s)||!s)return;const i=c[s];s=r(g?u(g,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(o(s))):i&&i.when&&(n[s]=i)}),{globArgs:t,siblingClauses:n}}function u(c,g){return F.isAbsolute(g)?g:F.join(c,g)}e.getAbsoluteGlob=u;function r(c){return c=v.rtrim(c,"\\"),v.rtrim(c,"/")}function o(c){return R.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=o}),define(De[358],Ie([1,0,48,53,16,359,19,46,35,76,32,12,37,15,18,29,36,356,127]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class g{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,o.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const l=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),C=a.folder.fsPath;i.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==C).forEach(D=>{(0,T.isEqualOrParent)(D,C)&&(l[h.relative(C,D)]=!0)}),this.folderExcludePatterns.set(C,new t(l,C))})}cancel(){this.isCanceled=!0,c.forEach(i=>i())}walk(i,a,l,C,D){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return D(null,this.isLimitHit);a.forEach(p=>{const m=h.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,m)||this.matchFile(l,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(i,(p,m)=>{this.call(this.cmdTraversal,this,p,l,C,f=>{if(f){const P=(0,v.toErrorMessage)(f);console.error(P),this.errors.push(P),m(f,void 0)}else m(null,void 0)})},(p,m)=>{this.fileWalkSW.stop();const f=p?A.coalesce(p)[0]:null;D(f,this.isLimitHit)})}parallel(i,a,l){const C=new Array(i.length),D=new Array(i.length);let p=!1,m=0;if(i.length===0)return l(null,[]);i.forEach((f,P)=>{a(f,(M,N)=>{if(M?(p=!0,C[P]=null,D[P]=M):(C[P]=N,D[P]=null),++m===i.length)return l(p?D:null,C)})})}call(i,a,...l){try{i.apply(a,l)}catch(C){l[l.length-1](C)}}cmdTraversal(i,a,l,C){const D=i.folder.fsPath,p=k.isMacintosh,m=()=>L&&L.kill();c.add(m);let f=j=>{c.delete(m),f=()=>{},C(j)},P="";const M=this.initDirectoryTree(),N=(0,r.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),L=N.cmd,U=!Object.keys(N.siblingClauses).length,x=N.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let O=`${N.rgDiskPath} ${x}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),l({message:O}),this.cmdResultCount=0,this.collectStdout(L,"utf8",l,(j,V,fe)=>{if(j){f(j);return}if(this.isLimitHit){f();return}const X=(P+(p?E.normalizeNFC(V||""):V)).split(`
`);if(fe){const z=X.length;X[z-1]=X[z-1].trim(),X[z-1]||X.pop()}else P=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){f(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=X.length,U){for(const z of X)if(this.matchFile(a,{base:D,relativePath:z,searchPath:this.getSearchPath(i,z)}),this.isLimitHit){m();break}(fe||this.isLimitHit)&&f();return}this.addDirectoryEntries(i,M,D,X,a),fe&&(this.matchDirectoryTree(M,D,a),f())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),l=a.getBasenameTerms(),C=a.getPathTerms(),D=["-L","."];if(l.length||C.length){D.push("-not","(","(");for(const p of l)D.push("-name",p),D.push("-o");for(const p of C)D.push("-path",p),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:i.folder.fsPath})}readStdout(i,a,l){let C="";this.collectStdout(i,a,()=>{},(D,p,m)=>{if(D){l(D);return}C+=p,m&&l(null,C)})}collectStdout(i,a,l,C){let D=(f,P,M)=>{(f||M)&&(D=()=>{},this.cmdSW?.stop()),C(f,P,M)},p=!1;i.stdout?(this.forwardData(i.stdout,a,D),i.stdout.once("data",()=>p=!0)):l({message:"stdout is null"});let m;i.stderr?m=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",f=>{D(f)}),i.on("close",f=>{let P;!p&&(P=this.decodeData(m,a))&&n(P)?D(new Error(`command failed with error code ${f}: ${this.decodeData(m,a)}`)):(this.exists&&f===0&&(this.isLimitHit=!0),D(null,"",!0))})}forwardData(i,a,l){const C=new R.StringDecoder(a);return i.on("data",D=>{l(null,C.write(D))}),C}collectData(i){const a=[];return i.on("data",l=>{a.push(l)}),a}decodeData(i,a){const l=new R.StringDecoder(a);return i.map(C=>l.write(C)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},l,C,D){C.indexOf(this.filePattern)!==-1&&this.matchFile(D,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const p=m=>{const f=h.basename(m),P=h.dirname(m);let M=a[P];M||(M=a[P]=[],p(P)),M.push({base:l,relativePath:m,basename:f,searchPath:this.getSearchPath(i,m)})};C.forEach(p)}matchDirectoryTree({rootEntries:i,pathToEntries:a},l,C){const D=this,p=this.folderExcludePatterns.get(l),m=this.filePattern;function f(P){D.directoriesWalked++;const M=(0,u.hasSiblingFn)(()=>P.map(N=>N.basename));for(let N=0,L=P.length;N<L;N++){const U=P[N],{relativePath:x,basename:O}=U;if(p.test(x,O,m!==O?M:void 0))continue;const j=a[x];if(j)f(j);else{if(D.filesWalked++,x===m)continue;D.matchFile(C,U)}if(D.isLimitHit)break}}f(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,l,C,D){const p=i.folder,m=(0,u.hasSiblingFn)(()=>l);this.parallel(l,(f,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const M=a?[a,f].join(h.sep):f;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,f,this.config.filePattern!==f?m:void 0))return P(null);const N=[p.fsPath,M].join(h.sep);F.lstat(N,(L,U)=>{if(L||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(N,U,(x,O)=>x||this.isCanceled||this.isLimitHit?P(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,U,(j,V)=>j||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?P(null):(this.walkedPaths[V]=!0,w.Promises.readdir(N).then(fe=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(i,M,fe,C,J=>P(J||null))},fe=>{P(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&_.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(C,{base:p.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),P(null,void 0)))})},f=>{const P=f&&A.coalesce(f);return D(P&&P.length>0?P[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,h.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,u.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,l){return a.isSymbolicLink()?F.stat(i,l):l(null,a)}realPathIfNeeded(i,a,l){return a.isSymbolicLink()?F.realpath(i,(C,D)=>C?l(C):l(null,D)):l(null,i)}getSearchPath(i,a){return i.folderName?h.join(i.folderName,a):a}}e.FileWalker=g;class d{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new g(i)}search(i,a,l){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(C,D)=>{l(C,{limitHit:D,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=d;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,l;Object.keys(i).filter(C=>i[C]).forEach(C=>{h.isAbsolute(C)?(a=a||y.getEmptyExpression(),a[C]=i[C]):(l=l||y.getEmptyExpression(),l[C]=i[C])}),this.absoluteParsedExpr=a&&y.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=l&&y.parse(l,{trimForExclusions:!0})}test(i,a,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(h.join(this.root,i),a,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function n(s){const i=s.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return S.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(De[360],Ie([1,0,96,22,182,21]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===a)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const v=512,y=512,E=512*8,T=512*128;var k;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k||(e.DecodeStreamErrorKind=k={}));class b extends Error{constructor(l,C){super(l),this.decodeStreamErrorKind=C}}e.DecodeStreamError=b;class S{static async create(l){let C;if(l!==e.UTF8)C=(await(0,h.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(l));else{const D=new TextDecoder;C={write(p){return D.decode(p,{stream:!0})},end(){return D.decode()}}}return new S(C)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function _(a,l){const C=l.minBytesRequiredForDetection??l.guessEncoding?E:y;return new Promise((D,p)=>{const m=(0,I.newWriteableStream)(U=>U.join("")),f=[];let P=0,M;const N=new R.CancellationTokenSource,L=async()=>{try{const U=await i({buffer:F.VSBuffer.concat(f),bytesRead:P},l.guessEncoding);if(U.seemsBinary&&l.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);U.encoding=await l.overwriteEncoding(U.encoding),M=await S.create(U.encoding);const x=M.write(F.VSBuffer.concat(f).buffer);m.write(x),f.length=0,P=0,D({stream:m,detected:U})}catch(U){N.cancel(),m.destroy(),p(U)}};(0,I.listenStream)(a,{onData:async U=>{M?m.write(M.write(U.buffer)):(f.push(U),P+=U.byteLength,P>=C&&(a.pause(),await L(),setTimeout(()=>a.resume())))},onError:U=>m.error(U),onEnd:async()=>{M||await L(),m.end(M?.end())}},N.token)})}e.toDecodeStream=_;async function w(a,l,C){const p=(await(0,h.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(l),C);let m=!1,f=!1;return{read(){if(f)return null;const P=a.read();if(typeof P!="string"){if(f=!0,!m&&C?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const M=p.end();return M&&M.length>0?(m=!0,F.VSBuffer.wrap(M)):null}return m=!0,F.VSBuffer.wrap(p.write(P))}}}e.toEncodeReadable=w;async function u(a){return(await(0,h.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(a))}e.encodingExists=u;function r(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=r;function o(a,l){if(!a||l<e.UTF16be_BOM.length)return null;const C=a.readUInt8(0),D=a.readUInt8(1);if(C===e.UTF16be_BOM[0]&&D===e.UTF16be_BOM[1])return e.UTF16be;if(C===e.UTF16le_BOM[0]&&D===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const p=a.readUInt8(2);return C===e.UTF8_BOM[0]&&D===e.UTF8_BOM[1]&&p===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const c=["ascii","utf-16","utf-32"];async function g(a){const l=await(0,h.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),C=a.slice(0,T),D=n(C.buffer),p=l.detect(D);if(!p||!p.encoding)return null;const m=p.encoding.toLowerCase();return 0<=c.indexOf(m)?null:t(p.encoding)}const d={ibm866:"cp866",big5:"cp950"};function t(a){const l=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return d[l]||l}function n(a){let l="";for(let C=0;C<a.length;C++)l+=String.fromCharCode(a[C]);return l}function s(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=a.match(/windows(\d+)/);return l?"windows-"+l[1]:a}}}e.toCanonicalName=s;function i({buffer:a,bytesRead:l},C){let D=o(a,l),p=!1;if(D!==e.UTF16be&&D!==e.UTF16le&&a){let m=!0,f=!0,P=!1;for(let M=0;M<l&&M<v;M++){const N=M%2===1,L=a.readUInt8(M)===0;if(L&&(P=!0),m&&(N&&!L||!N&&L)&&(m=!1),f&&(N&&L||!N&&!L)&&(f=!1),L&&!m&&!f)break}P&&(m?D=e.UTF16le:f?D=e.UTF16be:p=!0)}return C&&!p&&!D&&a?g(a.slice(0,l)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:p,encoding:D}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ie([1,0,360,29,153]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends h.TextSearchManager{constructor(v,y,E=F,T="searchProcess"){super(v,y,{readdir:k=>E.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,I.toCanonicalName)(k)},T)}}e.NativeTextSearchManager=R}),define(De[155],Ie([1,0,48,376,359,19,73,35,16,15,2,36,92,377,357,116]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const u=_.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class r{constructor(f){this.outputChannel=f}provideTextSearchResults(f,P,M,N){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((L,U)=>{N.onCancellationRequested(()=>z());const x=n(f,P),O=P.folder.fsPath,j=x.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.outputChannel.appendLine(`${u} ${j}
 - cwd: ${O}`);let V=I.spawn(u,x,{cwd:O});V.on("error",G=>{console.error(G),this.outputChannel.appendLine("Error: "+(G&&G.message)),U((0,k.serializeSearchError)(new k.SearchError(G&&G.message,k.SearchErrorCode.rgProcessError)))});let fe=!1;const J=new g(P.maxResults,O,P.previewOptions);J.on("result",G=>{fe=!0,ve="",M.report(G)});let X=!1;const z=()=>{X=!0,V?.kill(),J?.cancel()};let Q=!1;J.on("hitLimit",()=>{Q=!0,z()});let ve="";V.stdout.on("data",G=>{J.handleData(G),fe||(ve+=G)});let le=!1;V.stdout.once("data",()=>le=!0);let we="";V.stderr.on("data",G=>{const B=G.toString();this.outputChannel.appendLine(B),we.length+B.length<1e6&&(we+=B)}),V.on("close",()=>{if(this.outputChannel.appendLine(le?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(fe?"Got result from parser":"No result from parser"),ve&&this.outputChannel.appendLine(`Got data without result: ${ve}`),this.outputChannel.appendLine(""),X)L({limitHit:Q});else{J.flush(),V=null;let G;we&&!le&&(G=o(we))?U((0,k.serializeSearchError)(new k.SearchError(G.message,G.code))):L({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=r;function o(m){const f=m.split(`
`),P=f[0].trim();if(f.some(N=>N.startsWith("regex parse error")))return new k.SearchError(c(f),k.SearchErrorCode.regexParseError);const M=P.match(/grep config error: unknown encoding: (.*)/);if(M)return new k.SearchError(`Unknown encoding: ${M[1]}`,k.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(P,k.SearchErrorCode.regexParseError)}function c(m){const f=["Regex parse error"],P=m.filter(M=>M.startsWith("PCRE2:"));if(P.length>=1){const M=P[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const N=M.split(":")[1];f.push(":"+N)}}return f.join("")}class g extends F.EventEmitter{constructor(f,P,M){super(),this.maxResults=f,this.rootFolder=P,this.previewOptions=M,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new h.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,P){return super.on(f,P),this}handleData(f){if(this.isDone)return;const P=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(P)}handleDecodedData(f){let P=f.indexOf(`
`);const M=this.remainder+f;if(P>=0)P+=this.remainder.length;else{this.remainder=M;return}let N=0;for(;P>=0;)this.handleLine(M.substring(N,P).trim()),N=P+1,P=M.indexOf(`
`,N);this.remainder=M.substring(N)}handleLine(f){if(this.isDone||!f)return;let P;try{P=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(P.type==="match"){const M=d(P.data.path),N=T.URI.file(y.join(this.rootFolder,M)),L=this.createTextSearchMatch(P.data,N);this.onResult(L),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const M=d(P.data.path),N=T.URI.file(y.join(this.rootFolder,M));this.createTextSearchContext(P.data,N).forEach(U=>this.onResult(U))}}createTextSearchMatch(f,P){const M=f.line_number-1,N=d(f.lines),L=Buffer.from(N);let U=0,x=0,O=M;f.submatches.length===0&&f.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.coalesce)(f.submatches.map((V,fe)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const J=d(V.match),X=L.slice(U,V.start).toString(),z=t(X),Q=z.numLines>0?z.lastLineLength:z.lastLineLength+x,ve=t(J),le=z.numLines+O,we=ve.numLines+le,G=ve.numLines>0?ve.lastLineLength:ve.lastLineLength+Q;return U=V.end,x=G,O=we,new b.Range(le,Q,we,G)}));return(0,w.createTextSearchResult)(P,N,j,this.previewOptions)}createTextSearchContext(f,P){const M=d(f.lines),N=f.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((L,U)=>({text:L,uri:P,lineNumber:N+U}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=g;function d(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function t(m){const f=/\n/g;let P=0,M=-1,N;for(;N=f.exec(m);)P++,M=N.index;const L=M>=0?m.length-M-1:m.length;return{numLines:P,lastLineLength:L}}function n(m,f){const P=["--hidden","--no-require-git"];P.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:N}=(0,A.groupBy)(f.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const U=new Set;N.forEach(x=>{U.add(x)}),P.push("-g","!*"),U.forEach(x=>{s(x).map(w.anchorGlob).forEach(O=>{P.push("-g",O)})})}M&&M.length&&M.forEach(U=>{P.push("-g",U)}),f.excludes.map(w.anchorGlob).forEach(U=>P.push("-g",`!${U}`)),f.maxFileSize&&P.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),f.followSymlinks&&P.push("--follow"),f.encoding&&f.encoding!=="utf8"&&P.push("--encoding",f.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,E.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),f.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),m.isRegExp&&(m.pattern=i(m.pattern),P.push("--engine","auto"));let L;if(m.isWordMatch){const x=(0,E.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",x)}else if(m.isRegExp){let U=l(m.pattern);U=C(U),P.push("--regexp",U)}else L=m.pattern,P.push("--fixed-strings");return P.push("--no-config"),f.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),m.isMultiline&&P.push("--multiline"),f.beforeContext&&P.push("--before-context",f.beforeContext+""),f.afterContext&&P.push("--after-context",f.afterContext+""),P.push("--"),L&&P.push(L),P.push("."),P}e.getRgArgs=n;function s(m){return p(m).flatMap(P=>{const M=(0,v.splitGlobAware)(P,"/");return M.map((N,L)=>M.slice(0,L+1).join("/"))})}function i(m){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(f);)m=m.replace(f,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(P);)m=m.replace(P,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=i;const a=m=>m.type==="Assertion"&&m.kind==="lookbehind";function l(m){let f;try{f=new S.RegExpParser().parsePattern(m)}catch{return m}let P="",M=0;const N=(x,O,j)=>{P+=m.slice(M,x)+j,M=O},L=[];return new S.RegExpVisitor({onCharacterEnter(x){if(x.raw!=="\\n")return;const O=L[0];if(!O)N(x.start,x.end,"\\r?\\n");else if(!L.some(a))if(O.type==="CharacterClass")if(O.negate){const j=m.slice(O.start+2,x.start)+m.slice(x.end,O.end-1);O.parent?.type==="Quantifier"?N(O.start,O.end,j?`[^${j}]`:"."):N(O.start,O.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(O.start+1,x.start)+m.slice(x.end,O.end-1);N(O.start,O.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else O.type==="Quantifier"&&N(x.start,x.end,"(?:\\r?\\n)")},onQuantifierEnter(x){L.unshift(x)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(x){L.unshift(x)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(x){L.unshift(x)},onCharacterClassLeave(){L.shift()},onAssertionEnter(x){a(x)&&L.push(x)},onAssertionLeave(x){L[0]===x&&L.shift()}}).visit(f),P+=m.slice(M),P}e.fixRegexNewline=l;function C(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=C;function D(m){let f=!1,P=!1,M="",N="";for(let L=0;L<m.length;L++){const U=m[L];switch(U){case"\\":P?(f?N+="\\"+U:M+="\\"+U,P=!1):P=!0;break;case"{":if(P)f?N+=U:M+=U,P=!1;else{if(f)return{strInBraces:M+"{"+N+"{"+m.substring(L+1)};f=!0}break;case"}":if(P)f?N+=U:M+=U,P=!1;else{if(f)return{fixedStart:M,strInBraces:N,fixedEnd:m.substring(L+1)};M+=U}break;default:f?N+=(P?"\\":"")+U:M+=(P?"\\":"")+U,P=!1;break}}return{strInBraces:M+(f?"{"+N:"")}}function p(m){const{fixedStart:f,strInBraces:P,fixedEnd:M}=D(m);if(f===void 0||M===void 0)return[P];let N=(0,v.splitGlobAware)(P,",");N.length||(N=[""]);const L=p(M);return N.flatMap(U=>{const x=f+U;return L.map(O=>x+O)})}e.performBraceExpansionForRipgrep=p}),define(De[361],Ie([1,0,21,155,84,17]),function(ge,e,I,F,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(E){this.outputChannel=E,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(E,T,k,b){const S=new F.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===R.Schemas.vscodeUserData){const _={...T,folder:T.folder.with({scheme:R.Schemas.file})},w=new h.Progress(u=>k.report({...u,uri:u.uri.with({scheme:T.folder.scheme})}));return this.withToken(b,u=>S.provideTextSearchResults(E,_,w,u))}else return this.withToken(b,_=>S.provideTextSearchResults(E,T,k,_))}async withToken(E,T){const k=v(E);this.inProgress.add(k);const b=await T(k.token);return this.inProgress.delete(k),b}dispose(){this.inProgress.forEach(E=>E.cancel())}}e.RipgrepSearchProvider=A;function v(y){const E=new I.CancellationTokenSource;return y.onCancellationRequested(()=>E.cancel()),E}}),define(De[362],Ie([1,0,29,155,154]),function(ge,e,I,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.query=y}search(y,E,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(S){T({message:S})}},b=new h.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(k),I);return new Promise((S,_)=>b.search(w=>{E(w.map(A))},y).then(w=>S({limitHit:w.limitHit,type:"success",stats:w.stats}),_))}}e.TextSearchEngineAdapter=R;function A(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce((y,E)=>{if(E.ranges){const T=E;return y+(Array.isArray(T.ranges)?T.ranges.length:1)}else return y+1},0)}}}),define(De[363],Ie([1,0,19,9,8,4,127,16,37,2,30,36,358,362]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{static{this.BATCH_SIZE=512}constructor(g="searchProcess"){this.processType=g,this.caches=Object.create(null)}fileSearch(g){let d;const t=r(g),n=new R.Emitter({onDidAddFirstListener:()=>{d=(0,F.createCancelablePromise)(s=>this.doFileSearchWithEngine(b.Engine,t,i=>n.fire(i),s)),d.then(s=>n.fire(s),s=>n.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return n.event}textSearch(g){let d;const t=r(g),n=new R.Emitter({onDidAddFirstListener:()=>{d=(0,F.createCancelablePromise)(s=>this.ripgrepTextSearch(t,i=>n.fire(i),s)),d.then(s=>n.fire(s),s=>n.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return n.event}ripgrepTextSearch(g,d,t){return g.maxFileSize=this.getPlatformFileLimits().maxFileSize,new S.TextSearchEngineAdapter(g).search(t,d,d)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*T.ByteSize.MB:16*T.ByteSize.GB}}doFileSearch(g,d,t){return this.doFileSearchWithEngine(b.Engine,g,d,t)}doFileSearchWithEngine(g,d,t,n,s=_.BATCH_SIZE){let i=0;const a=C=>{Array.isArray(C)?(i+=C.length,t(C.map(D=>this.rawMatchToSearchItem(D)))):C.relativePath?(i++,t(this.rawMatchToSearchItem(C))):t(C)};if(d.sortByScore){let C=this.trySortedSearchFromCache(d,a,n);if(!C){const D=d.maxResults?Object.assign({},d,{maxResults:null}):d,p=new g(D);C=this.doSortedSearch(p,d,t,a,n)}return new Promise((D,p)=>{C.then(([m,f])=>{const P=f.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(P,t,s),D(m)},p)})}const l=new g(d);return this.doSearch(l,a,s,n).then(C=>({limitHit:C.limitHit,type:"success",stats:{detailStats:C.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(g){return{path:g.base?(0,v.join)(g.base,g.relativePath):g.relativePath}}doSortedSearch(g,d,t,n,s){const i=new R.Emitter;let a=(0,F.createCancelablePromise)(C=>{let D=[];const p=m=>{Array.isArray(m)?D=m:(n(m),i.fire(m))};return this.doSearch(g,p,-1,C).then(m=>[m,D])}),l;if(d.cacheKey){l=this.getOrCreateCache(d.cacheKey);const C={promise:a,event:i.event,resolved:!1};l.resultsToSearchCache[d.filePattern||""]=C,a.then(()=>{C.resolved=!0},D=>{delete l.resultsToSearchCache[d.filePattern||""]}),a=this.preventCancellation(a)}return a.then(([C,D])=>{const p=l?l.scorerCache:Object.create(null),m=(typeof d.maxResults!="number"||d.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(d,D,p,s).then(f=>{const P=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:C.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:d.folderQueries.length,resultCount:f.length},messages:C.messages,limitHit:C.limitHit||typeof d.maxResults=="number"&&D.length>d.maxResults},f]})})}getOrCreateCache(g){const d=this.caches[g];return d||(this.caches[g]=new w)}trySortedSearchFromCache(g,d,t){const n=g.cacheKey&&this.caches[g.cacheKey];if(!n)return;const s=this.getResultsFromCache(n,g.filePattern||"",d,t);if(s)return s.then(([i,a,l])=>{const C=y.StopWatch.create(!1);return this.sortResults(g,a,n.scorerCache,t).then(D=>{const p=C.elapsed(),m={fromCache:!0,detailStats:l,type:this.processType,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:i.limitHit||typeof g.maxResults=="number"&&a.length>g.maxResults,stats:m},D]})})}sortResults(g,d,t,n){const s=(0,A.prepareQuery)(g.filePattern||""),i=(l,C)=>(0,A.compareItemsByFuzzyScore)(l,C,s,!0,u,t),a=typeof g.maxResults=="number"?g.maxResults:Number.MAX_VALUE;return I.topAsync(d,i,a,1e4,n)}sendProgress(g,d,t){if(t&&t>0)for(let n=0;n<g.length;n+=t)d(g.slice(n,n+t));else d(g)}getResultsFromCache(g,d,t,n){const s=y.StopWatch.create(!1),i=d.indexOf(v.sep)>=0;let a;for(const p in g.resultsToSearchCache)if(d.startsWith(p)){if(i&&p.indexOf(v.sep)<0&&p!=="")continue;const m=g.resultsToSearchCache[p];a={promise:this.preventCancellation(m.promise),event:m.event,resolved:m.resolved};break}if(!a)return null;const l=s.elapsed(),C=y.StopWatch.create(!1),D=a.event(t);return n&&n.onCancellationRequested(()=>{D.dispose()}),a.promise.then(([p,m])=>{if(n&&n.isCancellationRequested)throw(0,h.canceled)();const f=[],P=(0,A.prepareQuery)(d).normalizedLowercase;for(const M of m)(0,k.isFilePatternMatch)(M,P)&&f.push(M);return[p,f,{cacheWasResolved:a.resolved,cacheLookupTime:l,cacheFilterTime:C.elapsed(),cacheEntryCount:m.length}]})}doSearch(g,d,t,n){return new Promise((s,i)=>{let a=[];n?.onCancellationRequested(()=>g.cancel()),g.search(l=>{l&&(t?(a.push(l),t>0&&a.length>=t&&(d(a),a=[])):d(l))},l=>{d(l)},(l,C)=>{a.length&&d(a),l?i(l):s(C)})})}clearCache(g){return delete this.caches[g],Promise.resolve(void 0)}preventCancellation(g){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(d,t){return g.then(d,t)}catch(d){return this.then(void 0,d)}finally(d){return g.finally(d)}}}}e.SearchService=_;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(c){return(0,v.basename)(c.relativePath)}getItemDescription(c){return(0,v.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function r(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(o),extraFileResources:c.extraFileResources&&c.extraFileResources.map(g=>E.URI.revive(g))}}function o(c){return{...c,folder:E.URI.revive(c.folder)}}}),define(De[364],Ie([1,0,3,17,2,29,13,26,20,95,66,36,363,361,116,154]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let u=class extends E.ExtHostSearch{constructor(o,c,g,d){super(o,g,d),this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new I.DisposableStore;const t=new _.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new S.RipgrepSearchProvider(t))),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const o=new _.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.file,new S.RipgrepSearchProvider(o))),this._disposables.add(this.registerInternalFileSearchProvider(F.Schemas.file,new b.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(o,c){const g=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=g,this._proxy.$registerFileSearchProvider(g,this._transformScheme(o)),(0,I.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(o,c,g,d){const t=(0,E.reviveQuery)(g);return o===this._internalFileSearchHandle?this.doInternalFileSearch(o,c,t,d):super.$provideFileSearchResults(o,c,g,d)}doInternalFileSearch(o,c,g,d){const t=n=>{if((0,k.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(o,c,n.map(s=>h.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(g,t,d)}$clearCache(o){return this._internalFileSearchProvider?.clearCache(o),super.$clearCache(o)}createTextSearchManager(o,c){return new w.NativeTextSearchManager(o,c,void 0,"textSearchProvider")}};e.NativeExtHostSearch=u,e.NativeExtHostSearch=u=je([$e(0,y.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,T.IURITransformerService),$e(3,A.ILogService)],u)}),define(De[117],Ie([1,0,378,60,63,379,22,8,4,3,16,12,31,80,81]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(m,f){_.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,f)}constructor(m,f=""){this._canWrite=!0,this.debugLabel=f,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,v.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(m){const f=P=>{this.traceSocketEvent("read",P),m(A.VSBuffer.wrap(P))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(m){const f=P=>{m({type:0,hadError:P,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(m){const f=()=>{m()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(m){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,v.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,v.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=w;var u;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var r;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(r||(r={}));class o extends E.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(m,f){this.socket.traceSocketEvent(m,f)}constructor(m,f,P,M){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:P?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new c(this,f,P,M,this._onData,(N,L)=>this._write(N,L))),this._register(this._flowManager.onError(N=>{console.error(N),(0,v.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new _.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let f=0;for(;f<m.byteLength;)this._flowManager.writeMessage(m.slice(f,Math.min(f+262144,m.byteLength)),{compressed:!0,opcode:2}),f+=262144}_write(m,{compressed:f,opcode:P}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let M=2;m.byteLength<126?M+=0:m.byteLength<2**16?M+=2:M+=8;const N=A.VSBuffer.alloc(M),L=f?64:0,U=P&15;if(N.writeUInt8(128|L|U,0),m.byteLength<126)N.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){N.writeUInt8(126,1);let x=1;N.writeUInt8(m.byteLength>>>8&255,++x),N.writeUInt8(m.byteLength>>>0&255,++x)}else{N.writeUInt8(127,1);let x=1;N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(m.byteLength>>>24&255,++x),N.writeUInt8(m.byteLength>>>16&255,++x),N.writeUInt8(m.byteLength>>>8&255,++x),N.writeUInt8(m.byteLength>>>0&255,++x)}this.socket.write(A.VSBuffer.concat([N,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),P=f.readUInt8(0),M=(P&128)>>>7,N=(P&64)>>>6,L=P&15,U=f.readUInt8(1),x=(U&128)>>>7,O=U&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!M,this._state.mask=0,this._state.opcode=L,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),P=f.readUInt8(1),M=(P&128)>>>7;let N=P&127,L=1;N===126?N=f.readUInt8(++L)*2**8+f.readUInt8(++L):N===127&&(N=f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*2**24+f.readUInt8(++L)*2**16+f.readUInt8(++L)*2**8+f.readUInt8(++L));let U=0;M&&(U=f.readUInt8(++L)*2**24+f.readUInt8(++L)*2**16+f.readUInt8(++L)*2**8+f.readUInt8(++L)),this._state.state=3,this._state.readLen=N,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),t(f,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(f,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(f,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=o;class c extends E.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(m,f,P,M,N,L){super(),this._tracer=m,this._onData=N,this._writeFn=L,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,f?(this._zlibInflateStream=this._register(new g(this._tracer,M,P,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(m,f){this._writeQueue.push({data:m,options:f}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:m,options:f}=this._writeQueue.shift();if(this._zlibDeflateStream&&f.compressed){const P=await this._deflateMessage(this._zlibDeflateStream,m);this._writeFn(P,f)}else this._writeFn(m,{...f,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(m,f){return new Promise((P,M)=>{m.write(f),m.flush(N=>P(N))})}acceptFrame(m,f,P){this._readQueue.push({data:m,isCompressed:f,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const m=this._readQueue.shift();if(this._zlibInflateStream&&m.isCompressed){const f=await this._inflateFrame(this._zlibInflateStream,m.data,m.isLastFrameOfMessage);this._onData.fire(f)}else this._onData.fire(m.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(m,f,P){return new Promise((M,N)=>{m.write(f),P&&m.write(A.VSBuffer.fromByteArray([0,0,255,255])),m.flush(L=>M(L))})}}class g extends E.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(m,f,P,M){super(),this._tracer=m,this._recordInflateBytes=f,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,R.createInflateRaw)(M),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(A.VSBuffer.wrap(N))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(m){this._recordInflateBytes&&this._recordedInflateBytes.push(m.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",m),this._zlibInflate.write(m.buffer)}flush(m){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const f=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,m(f)})}}class d extends E.Disposable{constructor(m,f){super(),this._tracer=m,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,R.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(A.VSBuffer.wrap(P))})}write(m){this._tracer.traceSocketEvent("zlibDeflateWrite",m.buffer),this._zlibDeflate.write(m.buffer)}flush(m){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let f=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.byteLength-4),m(f)})}}function t(p,m){if(m===0)return;const f=p.byteLength>>>2;for(let x=0;x<f;x++){const O=p.readUInt32BE(x*4);p.writeUInt32BE(O^m,x*4)}const P=f*4,M=p.byteLength-P,N=m>>>24&255,L=m>>>16&255,U=m>>>8&255;M>=1&&p.writeUInt8(p.readUInt8(P)^N,P),M>=2&&p.writeUInt8(p.readUInt8(P+1)^L,P+1),M>=3&&p.writeUInt8(p.readUInt8(P+2)^U,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function s(){const p=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const m=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,h.tmpdir)(),f=(0,T.join)(m,`vscode-ipc-${p}.sock`);return a(f),f}e.createRandomIPCHandle=s;function i(p,m,f){const P=(0,I.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${f}-${m}-sock`;const M=f.substr(0,4),N=m.substr(0,6),L=P.substr(0,8);let U;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${L}-${M}-${N}.sock`):U=(0,T.join)(p,`${M}-${N}.sock`),a(U),U}e.createStaticIPCHandle=i;function a(p){const m=n[k.platform];typeof m=="number"&&p.length>=m&&console.warn(`WARNING: IPC handle "${p}" is longer than ${m} chars, try a shorter --user-data-dir`)}class l extends S.IPCServer{static toClientConnectionEvent(m){const f=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(f,P=>({protocol:new _.Protocol(new w(P,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(P,"close"))}))}constructor(m){super(l.toClientConnectionEvent(m)),this.server=m}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function C(p){return new Promise((m,f)=>{const P=(0,F.createServer)();P.on("error",f),P.listen(p,()=>{P.removeListener("error",f),m(new l(P))})})}e.serve=C;function D(p,m){return new Promise((f,P)=>{const M=(0,F.createConnection)(p,()=>{M.removeListener("error",P),f(_.Client.fromSocket(new w(M,`ipc-client${m}`),m))});M.once("error",P)})}e.connect=D}),define(De[365],Ie([1,0,60,63,163,117,9,3,12,49,13,135,247,248,106,86,22]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function r(t,n,s,i,a){let l;for(let C=3;C&&(l?.dispose(),l=await new o(t,n,s,i,a).waitForReady(),!(a&&h.BROWSER_RESTRICTED_PORTS[a]||!h.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));C--);return l}class o extends v.Disposable{constructor(n,s,i,a,l){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=l,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=n,this._server=I.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=C=>this._onConnection(C),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const n=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,w.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,h.findFreePortFaster)(n,2,1e3,s),a=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(n){n.pause();const s=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),a=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&n.write(l.buffer),n.on("end",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),a instanceof R.NodeSocket?a.socket.destroy():a.end()}),a instanceof R.NodeSocket?this._mirrorNodeSocket(n,a):this._mirrorGenericSocket(n,a),n.localAddress&&this._socketsDispose.set(n.localAddress,()=>{n.end(),a.end()})}_mirrorGenericSocket(n,s){s.onClose(()=>n.destroy()),s.onEnd(()=>n.end()),s.onData(i=>n.write(i.buffer)),n.on("data",i=>s.write(u.VSBuffer.wrap(i))),n.resume()}_mirrorNodeSocket(n,s){const i=s.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.NodeRemoteTunnel=o;let c=class extends w.AbstractTunnelService{constructor(n,s,i,a,l){super(s,l),this.remoteSocketFactoryService=n,this.signService=i,this.productService=a}isPortPrivileged(n){return(0,w.isPortPrivileged)(n,this.defaultTunnelHost,y.OS,F.release())}retainOrCreateTunnel(n,s,i,a,l,C,D,p){const m=this.getTunnelFromMap(s,i);if(m)return++m.refcount,m.value;if((0,w.isTunnelProvider)(n))return this.createWithProvider(n,s,i,l,C,D,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${l}.`);const f={commit:this.productService.commit,quality:this.productService.quality,addressProvider:n,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},P=r(f,a,s,i,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,P),P}}};e.BaseTunnelService=c,e.BaseTunnelService=c=je([$e(0,S.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,_.ISignService),$e(3,k.IProductService),$e(4,E.IConfigurationService)],c);let g=class extends c{constructor(n,s,i,a,l){super(n,s,i,a,l)}};e.TunnelService=g,e.TunnelService=g=je([$e(0,S.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,_.ISignService),$e(3,k.IProductService),$e(4,E.IConfigurationService)],g);let d=class extends v.Disposable{constructor(n,s,i,a,l){super(),this.remoteSocketFactoryService=n,this.logService=s,this.productService=i,this.signService=a,this.configurationService=l,this._tunnelServices=new Map}async openTunnel(n,s,i,a,l,C,D,p,m){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${a} on local port ${C}.`),!this._tunnelServices.has(n)){const f=new g(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(f),this._tunnelServices.set(n,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this._tunnelServices.delete(n))})}return this._tunnelServices.get(n).openTunnel(s,i,a,l,C,D,p,m)}};e.SharedTunnelsService=d,e.SharedTunnelsService=d=je([$e(0,S.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,k.IProductService),$e(3,_.ISignService),$e(4,E.IConfigurationService)],d)}),define(De[366],Ie([1,0,117,267,53,33,2,13,43]),function(ge,e,I,F,h,R,A,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class E{constructor(b,S,_){this._commands=b,this.logService=S,this._ipcHandlePath=_,this._server=F.createServer((w,u)=>this.onRequest(w,u)),this.setup().catch(w=>(S.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,S){const _=(u,r)=>{S.writeHead(u,{"content-type":"application/json"}),S.end(JSON.stringify(r||null),o=>o&&this.logService.error(o))},w=[];b.setEncoding("utf8"),b.on("data",u=>w.push(u)),b.on("end",async()=>{try{const u=JSON.parse(w.join(""));let r;switch(u.type){case"open":r=await this.open(u);break;case"openExternal":r=await this.openExternal(u);break;case"status":r=await this.getStatus(u);break;case"extensionManagement":r=await this.manageExtensions(u);break;default:_(404,`Unknown message type: ${u.type}`);break}_(200,r)}catch(u){const r=u instanceof Error?u.message:JSON.stringify(u);_(500,r),this.logService.error("Error while processing pipe request",u)}})}async open(b){const{fileURIs:S,folderURIs:_,forceNewWindow:w,diffMode:u,mergeMode:r,addMode:o,forceReuseWindow:c,gotoLineMode:g,waitMarkerFilePath:d,remoteAuthority:t}=b,n=[];if(Array.isArray(_))for(const l of _)try{n.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(S))for(const l of S)try{(0,y.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:A.URI.parse(l)}):n.push({fileUri:A.URI.parse(l)})}catch{}const s=d?A.URI.file(d):void 0,a={forceNewWindow:w,diffMode:u,mergeMode:r,addMode:o,gotoLineMode:g,forceReuseWindow:c,preferNewWindow:!c&&!s&&!o,waitMarkerFileURI:s,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",n,a)}async openExternal(b){for(const S of b.uris){const _=A.URI.parse(S),w=_.scheme==="file"?_:S;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(b){const S=w=>w?.map(u=>/\.vsix$/i.test(u)?A.URI.parse(u):u),_={list:b.list,install:S(b.install),uninstall:S(b.uninstall),force:b.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(b){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&h.existsSync(this._ipcHandlePath)&&h.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=E;let T=class extends E{constructor(b,S){super(b,S,(0,I.createRandomIPCHandle)())}};e.CLIServer=T,e.CLIServer=T=je([$e(0,R.IExtHostCommands),$e(1,v.ILogService)],T)}),define(De[367],Ie([1,0,54,354,349,266,45,337,2,17,7,366,100,335,336]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends h.RequireInterceptor{_installInterceptor(){const o=this,c=globalThis._VSCODE_NODE_MODULES.module,g=c._load;c._load=function(s,i,a){return s=t(s),o._factories.has(s)?o._factories.get(s).load(s,y.URI.file((0,b.realpathSync)(i.filename)),l=>g.apply(this,[l,i,a])):g.apply(this,arguments)};const d=c._resolveLookupPaths;c._resolveLookupPaths=(n,s)=>d.call(this,t(n),s);const t=n=>{for(const s of o._alternatives){const i=s(n);if(i){n=i;break}}return n}}}class u extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(S.ExtHostConsoleForwarder);const o=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(v.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const d=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=d.ipcHandlePath}this._instaService.createInstance(_.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(w,o,{mine:this._myRegistry,all:this._globalRegistry}).install(),I.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),I.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(o){return o.main}async _loadCommonJSModule(o,c,g){if(c.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let d=null;g.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this._logService.flush();const t=o?.identifier.value;o&&await this._extHostLocalizationService.initializeLocalizedMessages(o);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),d=ge.__$__nodeRequire(c.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}return d}async $setRemoteEnvironment(o){if(this._initData.remote.isRemote)for(const c in o){const g=o[c];g===null?delete process.env[c]:process.env[c]=g}}}e.ExtHostExtensionService=u}),define(De[368],Ie([1,0,48,22,4,3,120,12,24,2,29,13,246,64,106,86,365,26,20,72,345]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function d(m){const f=m.trim().split(`
`),P=[];return f.forEach(N=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);L&&L.length>=3&&P.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),P.reduce((N,L)=>(N[L.socket]=L,N),{})}e.getSockets=d;function t(...m){const f=[].concat(...m.map(s));return[...new Map(f.filter(P=>P.st==="0A").map(P=>{const M=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(M[0]),port:parseInt(M[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.loadListeningPorts=t;function n(m){let f="";if(m.length===8)for(let P=m.length-2;P>=0;P-=2)f+=parseInt(m.substr(P,2),16),P!==0&&(f+=".");else for(let P=0;P<m.length;P+=8){const M=m.substring(P,P+8);let N="";for(let L=8;L>=2;L-=2)N+=M.substring(L-2,L),(L===6||L===2)&&(N=parseInt(N,16).toString(16),f+=`${N}`,N="",P+L!==m.length-6&&(f+=":"))}return f}e.parseIpAddress=n;function s(m){const f=m.trim().split(`
`),P=f.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return f.map(N=>N.trim().split(/\s+/).reduce((L,U,x)=>(L[P[x]||x]=U,L),{}))}e.loadConnectionTable=s;function i(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function a(m){const f=m.trim().split(`
`),P=[];return f.forEach(M=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(M);N&&N.length>=4&&P.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),P}e.getRootProcesses=a;async function l(m,f,P){const M=P.reduce((L,U)=>(L[U.pid]=U,L),{}),N=[];return m.forEach(({socket:L,ip:U,port:x})=>{const O=f[L]?f[L].pid:void 0,j=O?M[O]?.cmd:void 0;O&&j&&!i(j)&&N.push({host:U,port:x,detail:j,pid:O})}),N}e.findPorts=l;function C(m,f,P){const M=new Map,N=a(f);for(const L of m){const U=P.get(L.port);if(U){M.set(L.port,U);continue}const x=N.find(O=>O.cmd.includes(`${L.port}`));if(x){let O=x,j;do j=N.find(V=>V.ppid===O.pid),j&&(O=j);while(j);M.set(L.port,{host:L.ip,port:L.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else M.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return M}e.tryFindRootPorts=C;let D=class extends c.ExtHostTunnelService{constructor(f,P,M,N){super(f,P,M),this.initData=P,this.signService=N,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,v.isLinux&&P.remote.isRemote&&P.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let P;this._initialCandidates&&(P=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const M=new A.MovingAverage;let N=0;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),U=(await this.findCandidatePorts()).filter(j=>(0,w.isLocalhost)(j.host)||(0,w.isAllInterfaces)(j.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(j=>j.port).join(", ")}`);const x=new Date().getTime()-L;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${x} ms.`),N++>3&&M.update(x),(!P||JSON.stringify(P)!==JSON.stringify(U))&&(P=U,await this._proxy.$onFoundNewCandidates(P));const O=this.calculateDelay(M.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(j=>setTimeout(()=>j(),O))}}calculateDelay(f){return Math.max(f*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(f=>f.port).join(", ")}`)}async findCandidatePorts(){let f="",P="";try{f=await T.Promises.readFile("/proc/net/tcp","utf8"),P=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const M=t(f,P),N=await new Promise(J=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,z,Q)=>{J(z)})}),L=d(N),U=await T.Promises.readdir("/proc"),x=[];for(const J of U)try{const X=Number(J),z=y.joinPath(E.URI.file("/proc"),J);if((await T.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(X)){const ve=await T.Promises.readlink(y.joinPath(z,"cwd").fsPath),le=await T.Promises.readFile(y.joinPath(z,"cmdline").fsPath,"utf8");x.push({pid:X,cwd:ve,cmd:le})}}catch{}const O=[],j=M.filter(J=>{const X=L[J.socket];return X||O.push(J),X}),V=l(j,L,x);let fe;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const J=await new Promise(X=>{(0,I.exec)("ps -F -A -l | grep root",(z,Q,ve)=>{X(Q)})});this._foundRootPorts=C(O,J,this._foundRootPorts),fe=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(X=>X.port).join(", ")}`)}return V.then(J=>fe?J.concat(fe):J)}makeManagedTunnelFactory(f){return async P=>{const M=new u.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(L,U,x,O){const j=await f.makeConnection();return p.connect(j,U,x,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.ManagedRemoteConnection(0),connectionToken:f.connectionToken})}},signService:this.signService},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await M.waitForReady();const N=new h.Emitter;return{localAddress:(0,g.parseAddress)(M.localAddress)??M.localAddress,remoteAddress:{port:M.tunnelRemotePort,host:M.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{M.dispose(),N.fire(),N.dispose()}}}}};e.NodeExtHostTunnelService=D,e.NodeExtHostTunnelService=D=je([$e(0,o.IExtHostRpcService),$e(1,r.IExtHostInitDataService),$e(2,k.ILogService),$e(3,_.ISignService)],D);class p extends b.ManagedSocket{static connect(f,P,M,N){const L=new R.DisposableStore,U={onClose:L.add(new h.Emitter),onData:L.add(new h.Emitter),onEnd:L.add(new h.Emitter)};L.add(f.onDidReceiveMessage(O=>U.onData.fire(F.VSBuffer.wrap(O)))),L.add(f.onDidEnd(()=>U.onEnd.fire())),L.add(f.onDidClose(O=>U.onClose.fire({type:0,error:O,hadError:!!O})));const x=new p(f,N,U);return x._register(L),(0,b.connectManagedSocket)(x,P,M,N,U)}constructor(f,P,M){super(P,M),this.passing=f}write(f){this.passing.send(f.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(De[369],Ie([1,0,103,340,352,351,364,367,368,94,45,95,93,44,72,90,339,338,13,353,56,261,102,106,138]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r,o,c,g,d,t,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(T.IExtHostExtensionService,v.ExtHostExtensionService,0),(0,I.registerSingleton)(o.ILoggerService,r.ExtHostLoggerService,1),(0,I.registerSingleton)(o.ILogService,new t.SyncDescriptor(d.ExtHostLogService,[!1],!0)),(0,I.registerSingleton)(n.ISignService,s.SignService,1),(0,I.registerSingleton)(w.IExtensionStoragePaths,u.ExtensionStoragePaths,0),(0,I.registerSingleton)(E.IExtHostDebugService,R.ExtHostDebugService,0),(0,I.registerSingleton)(k.IExtHostSearch,A.NativeExtHostSearch,0),(0,I.registerSingleton)(b.IExtHostTask,h.ExtHostTask,0),(0,I.registerSingleton)(S.IExtHostTerminalService,F.ExtHostTerminalService,0),(0,I.registerSingleton)(_.IExtHostTunnelService,y.NodeExtHostTunnelService,0),(0,I.registerSingleton)(g.IExtHostVariableResolverProvider,c.NodeExtHostVariableResolverProviderService,0)}),define(De[380],Ie([1,0,60,381,54,8,81,117,244,111,350,22,29,100,9,130,268,285,355,369]),function(ge,e,I,F,h,R,A,v,y,E,T,k,b,S,_,w,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const o=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,l=a._load;a._load=function(C){if(C==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const c=process.exit.bind(process);function g(a){process.exit=function(l){if(a)c(l);else{const C=new Error("An extension called process.exit() and this was prevented.");console.warn(C.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let d=function(a){c()};function t(){const a=(0,r.readExtHostConnection)(process.env);if(a.type===3)return new Promise((l,C)=>{const D=p=>{const m=p[0],f=new A.BufferedEmitter;m.on("message",P=>f.fire(k.VSBuffer.wrap(P.data))),m.on("close",()=>{d("renderer closed the MessagePort")}),m.start(),l({onMessage:f.event,send:P=>m.postMessage(P.buffer)})};process.parentPort.on("message",p=>D(p.ports))});if(a.type===2)return new Promise((l,C)=>{let D=null;const p=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),m=108e5,f=3e5,P=new _.ProcessTimeRunOnceScheduler(()=>d("renderer disconnected for too long (1)"),m),M=new _.ProcessTimeRunOnceScheduler(()=>d("renderer disconnected for too long (2)"),f);process.on("message",(L,U)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const x=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let O;if(L.skipWebSocketFrames)O=new v.NodeSocket(U,"extHost-socket");else{const j=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));O=new v.WebSocketNodeSocket(new v.NodeSocket(U,"extHost-socket"),L.permessageDeflate,j,!1)}D?(P.cancel(),M.cancel(),D.beginAcceptReconnection(O,x),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(p),D=new A.PersistentProtocol({socket:O,initialChunk:x}),D.sendResume(),D.onDidDispose(()=>d("renderer disconnected")),l(D),D.onSocketClose(()=>{P.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;P.isScheduled()&&M.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const l=a.pipeName;return new Promise((C,D)=>{const p=I.createConnection(l,()=>{p.removeListener("error",D);const m=new A.PersistentProtocol({socket:new v.NodeSocket(p,"extHost-renderer")});m.sendResume(),C(m)});p.once("error",D),p.on("close",()=>{d("renderer closed the socket")})})}}async function n(){const a=await t();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(l=>{(0,E.isMessageOfType)(l,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||a.send(l)}async drain(){if(a.drain)return a.drain()}}}function s(a){return new Promise(l=>{const C=a.onMessage(D=>{C.dispose();const p=JSON.parse(D.toString()),m=p.commit,f=y.default.commit;if(m&&f&&m!==f&&c(55),p.parentPid){let P=0;setInterval(function(){try{process.kill(p.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&d(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):d(`parent process ${p.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(p.parentPid)}catch(N){(0,R.onUnexpectedError)(N)}}a.send((0,E.createMessageOfType)(0)),l({protocol:a,initData:p})});a.send((0,E.createMessageOfType)(1))})}async function i(){const a=[];process.on("unhandledRejection",(P,M)=>{a.push(M),setTimeout(()=>{const N=a.indexOf(M);N>=0&&M.catch(L=>{a.splice(N,1),(0,R.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),P&&(0,R.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const M=a.indexOf(P);M>=0&&a.splice(M,1)}),process.on("uncaughtException",function(P){(0,R.isSigPipeError)(P)||(0,R.onUnexpectedError)(P)}),h.mark("code/extHost/willConnectToRenderer");const l=await n();h.mark("code/extHost/didConnectToRenderer");const C=await s(l);h.mark("code/extHost/didWaitForInitData");const{initData:D}=C;g(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=o.useHostProxy!==void 0?o.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,w.boolean)(o.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(M){c(M)}fsExists(M){return b.Promises.exists(M)}fsRealpath(M){return(0,S.realpath)(M)}};let m=null;D.remote.authority&&o.transformURIs&&(m=(0,u.createURITransformer)(D.remote.authority));const f=new T.ExtensionHostMain(C.protocol,D,p,m);d=P=>f.terminate(P)}i().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/032b38229264250bcce623b6412a0bb7bd9b4052/core/vs/workbench/api/node/extensionHostProcess.js.map
