/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,R=be.length;w<R;w++)e[w]=Ae[be[w]];return e};define(Ae[64],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(A){return(u,y,m)=>{let P=null,D=null;if(typeof m.value=="function"?(P="value",D=m.value):typeof m.get=="function"&&(P="get",D=m.get),!D)throw new Error("not supported");m[P]=A(D,y)}}function R(A,u,y){let m=null,P=null;if(typeof y.value=="function"?(m="value",P=y.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",P=y.get),!P)throw new Error("not supported");const D=`$memoize$${u}`;y[m]=function(...a){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[D]}}e.memoize=R;function k(A,u,y){return w((m,P)=>{const D=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...v){this[a]||(this[a]=y?y():void 0),clearTimeout(this[D]),u&&(this[a]=u(this[a],...v),v=[this[a]]),this[D]=setTimeout(()=>{m.apply(this,v),this[a]=y?y():void 0},A)}})}e.debounce=k;function L(A,u,y){return w((m,P)=>{const D=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),u&&(this[a]=u(this[a],...f)),this[p])return;const t=this[v]+A;t<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[a]]),this[a]=y?y():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),m.apply(this,[this[a]]),this[a]=y?y():void 0},t-Date.now()))}})}e.throttle=L}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var R;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(r,s=!1){let n=0;const o=r.length;let S="",h=0,I=16,C=0;function l($){let N=0,M=0;for(;N<$;){const te=r.charCodeAt(n);if(te>=48&&te<=57)M=M*16+te-48;else if(te>=65&&te<=70)M=M*16+te-65+10;else if(te>=97&&te<=102)M=M*16+te-97+10;else break;n++,N++}return N<$&&(M=-1),M}function g($){n=$,S="",h=0,I=16,C=0}function d(){const $=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&m(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&m(r.charCodeAt(n)))for(n++;n<r.length&&m(r.charCodeAt(n));)n++;else return C=3,r.substring($,n);let N=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&m(r.charCodeAt(n))){for(n++;n<r.length&&m(r.charCodeAt(n));)n++;N=n}else C=3;return r.substring($,N)}function T(){let $="",N=n;for(;;){if(n>=o){$+=r.substring(N,n),C=2;break}const M=r.charCodeAt(n);if(M===34){$+=r.substring(N,n),n++;break}if(M===92){if($+=r.substring(N,n),n++,n>=o){C=2;break}switch(r.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const Q=l(4);Q>=0?$+=String.fromCharCode(Q):C=4;break}default:C=5}N=n;continue}if(M>=0&&M<=31)if(y(M)){$+=r.substring(N,n),C=2;break}else C=6;n++}return $}function z(){if(S="",C=0,h=n,n>=o)return h=o,I=17;let $=r.charCodeAt(n);if(u($)){do n++,S+=String.fromCharCode($),$=r.charCodeAt(n);while(u($));return I=15}if(y($))return n++,S+=String.fromCharCode($),$===13&&r.charCodeAt(n)===10&&(n++,S+=`
`),I=14;switch($){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,S=T(),I=10;case 47:{const N=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<o&&!y(r.charCodeAt(n));)n++;return S=r.substring(N,n),I=12}if(r.charCodeAt(n+1)===42){n+=2;const M=o-1;let te=!1;for(;n<M;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,te=!0;break}n++}return te||(n++,C=1),S=r.substring(N,n),I=13}return S+=String.fromCharCode($),n++,I=16}case 45:if(S+=String.fromCharCode($),n++,n===o||!m(r.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return S+=d(),I=11;default:for(;n<o&&H($);)n++,$=r.charCodeAt(n);if(h!==n){switch(S=r.substring(h,n),S){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return S+=String.fromCharCode($),n++,I=16}}function H($){if(u($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let $;do $=z();while($>=12&&$<=15);return $}return{setPosition:g,getPosition:()=>n,scan:s?x:z,getToken:()=>I,getTokenValue:()=>S,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>C}}e.createScanner=A;function u(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function m(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function D(r,s){const n=[],o=new Object;let S;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function C(l,g,d,T){h.value=l,h.offset=g,h.length=d,h.type=T,h.colonOffset=void 0,S=h}try{b(r,{onObjectBegin:(l,g)=>{if(s<=l)throw o;S=void 0,I=s>l,n.push("")},onObjectProperty:(l,g,d)=>{if(s<g||(C(l,g,d,"property"),n[n.length-1]=l,s<=g+d))throw o},onObjectEnd:(l,g)=>{if(s<=l)throw o;S=void 0,n.pop()},onArrayBegin:(l,g)=>{if(s<=l)throw o;S=void 0,n.push(0)},onArrayEnd:(l,g)=>{if(s<=l)throw o;S=void 0,n.pop()},onLiteralValue:(l,g,d)=>{if(s<g||(C(l,g,d,E(l)),s<=g+d))throw o},onSeparator:(l,g,d)=>{if(s<=g)throw o;if(l===":"&&S&&S.type==="property")S.colonOffset=g,I=!1,S=void 0;else if(l===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(I=!0,n[n.length-1]=""),S=void 0}}})}catch(l){if(l!==o)throw l}return{path:n,previousNode:S,isAtPropertyKey:I,matches:l=>{let g=0;for(let d=0;g<l.length&&d<n.length;d++)if(l[g]===n[d]||l[g]==="*")g++;else if(l[g]!=="**")return!1;return g===l.length}}}e.getLocation=D;function a(r,s=[],n=L.DEFAULT){let o=null,S=[];const h=[];function I(l){Array.isArray(S)?S.push(l):o!==null&&(S[o]=l)}return b(r,{onObjectBegin:()=>{const l={};I(l),h.push(S),S=l,o=null},onObjectProperty:l=>{o=l},onObjectEnd:()=>{S=h.pop()},onArrayBegin:()=>{const l=[];I(l),h.push(S),S=l,o=null},onArrayEnd:()=>{S=h.pop()},onLiteralValue:I,onError:(l,g,d)=>{s.push({error:l,offset:g,length:d})}},n),S[0]}e.parse=a;function v(r,s=[],n=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function S(l){o.type==="property"&&(o.length=l-o.offset,o=o.parent)}function h(l){return o.children.push(l),l}b(r,{onObjectBegin:l=>{o=h({type:"object",offset:l,length:-1,parent:o,children:[]})},onObjectProperty:(l,g,d)=>{o=h({type:"property",offset:g,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:l,offset:g,length:d,parent:o})},onObjectEnd:(l,g)=>{o.length=l+g-o.offset,o=o.parent,S(l+g)},onArrayBegin:(l,g)=>{o=h({type:"array",offset:l,length:-1,parent:o,children:[]})},onArrayEnd:(l,g)=>{o.length=l+g-o.offset,o=o.parent,S(l+g)},onLiteralValue:(l,g,d)=>{h({type:E(l),offset:g,length:d,parent:o,value:l}),S(g+d)},onSeparator:(l,g,d)=>{o.type==="property"&&(l===":"?o.colonOffset=g:l===","&&S(g))},onError:(l,g,d)=>{s.push({error:l,offset:g,length:d})}},n);const C=o.children[0];return C&&delete C.parent,C}e.parseTree=v;function p(r,s){if(!r)return;let n=r;for(const o of s)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let S=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],S=!0;break}if(!S)return}else{const S=o;if(n.type!=="array"||S<0||!Array.isArray(n.children)||S>=n.children.length)return;n=n.children[S]}return n}e.findNodeAtLocation=p;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;s.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&s.push(n)}return s}e.getNodePath=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const n of r.children){const o=n.children[1];o&&(s[n.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=t;function i(r,s,n=!1){return s>=r.offset&&s<r.offset+r.length||n&&s===r.offset+r.length}e.contains=i;function c(r,s,n=!1){if(i(r,s,n)){const o=r.children;if(Array.isArray(o))for(let S=0;S<o.length&&o[S].offset<=s;S++){const h=c(o[S],s,n);if(h)return h}return r}}e.findNodeAtOffset=c;function b(r,s,n=L.DEFAULT){const o=A(r,!1);function S(Ce){return Ce?()=>Ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(Ce){return Ce?le=>Ce(le,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=S(s.onObjectBegin),C=h(s.onObjectProperty),l=S(s.onObjectEnd),g=S(s.onArrayBegin),d=S(s.onArrayEnd),T=h(s.onLiteralValue),z=h(s.onSeparator),H=S(s.onComment),x=h(s.onError),$=n&&n.disallowComments,N=n&&n.allowTrailingComma;function M(){for(;;){const Ce=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:$||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(Ce){case 12:case 13:$?te(10):H();break;case 16:te(1);break;case 15:case 14:break;default:return Ce}}}function te(Ce,le=[],pe=[]){if(x(Ce),le.length+pe.length>0){let ie=o.getToken();for(;ie!==17;){if(le.indexOf(ie)!==-1){M();break}else if(pe.indexOf(ie)!==-1)break;ie=M()}}}function Q(Ce){const le=o.getTokenValue();return Ce?T(le):C(le),M(),!0}function Se(){switch(o.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(o.getTokenValue()),typeof Ce!="number"&&(te(2),Ce=0)}catch{te(2)}T(Ce);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return M(),!0}function _e(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(Q(!1),o.getToken()===6?(z(":"),M(),ae()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function Pe(){I(),M();let Ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ce||te(4,[],[]),z(","),M(),o.getToken()===2&&N)break}else Ce&&te(6,[],[]);_e()||te(4,[],[2,5]),Ce=!0}return l(),o.getToken()!==2?te(7,[2],[]):M(),!0}function Y(){g(),M();let Ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ce||te(4,[],[]),z(","),M(),o.getToken()===4&&N)break}else Ce&&te(6,[],[]);ae()||te(4,[],[4,5]),Ce=!0}return d(),o.getToken()!==4?te(8,[4],[]):M(),!0}function ae(){switch(o.getToken()){case 3:return Y();case 1:return Pe();case 10:return Q(!0);default:return Se()}}return M(),o.getToken()===17?n.allowEmptyContent?!0:(te(4,[],[]),!1):ae()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=b;function _(r,s){const n=A(r),o=[];let S,h=0,I;do switch(I=n.getPosition(),S=n.scan(),S){case 12:case 13:case 17:h!==I&&o.push(r.substring(h,I)),s!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,s)),h=n.getPosition();break}while(S!==17);return o.join("")}e.stripComments=_;function E(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(Ee,ge){for(var ye=0;ye<ge.length;ye++){var re=ge[ye];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Ee,re.key,re)}}function w(Ee,ge,ye){return ge&&e(Ee.prototype,ge),ye&&e(Ee,ye),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function R(Ee,ge){if(Ee){if(typeof Ee=="string")return k(Ee,ge);var ye=Object.prototype.toString.call(Ee).slice(8,-1);if(ye==="Object"&&Ee.constructor&&(ye=Ee.constructor.name),ye==="Map"||ye==="Set")return Array.from(Ee);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return k(Ee,ge)}}function k(Ee,ge){(ge==null||ge>Ee.length)&&(ge=Ee.length);for(var ye=0,re=new Array(ge);ye<ge;ye++)re[ye]=Ee[ye];return re}function L(Ee,ge){var ye=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(ye)return(ye=ye.call(Ee)).next.bind(ye);if(Array.isArray(Ee)||(ye=R(Ee))||ge&&Ee&&typeof Ee.length=="number"){ye&&(Ee=ye);var re=0;return function(){return re>=Ee.length?{done:!0}:{done:!1,value:Ee[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function u(Ee){be.defaults=Ee}var y=/[&<>"']/,m=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ge){return a[ge]};function p(Ee,ge){if(ge){if(y.test(Ee))return Ee.replace(m,v)}else if(P.test(Ee))return Ee.replace(D,v);return Ee}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Ee){return Ee.replace(f,function(ge,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(Ee,ge){Ee=typeof Ee=="string"?Ee:Ee.source,ge=ge||"";var ye={replace:function(de,se){return se=se.source||se,se=se.replace(i,"$1"),Ee=Ee.replace(de,se),ye},getRegex:function(){return new RegExp(Ee,ge)}};return ye}var b=/[^\w:]/g,_=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(Ee,ge,ye){if(Ee){var re;try{re=decodeURIComponent(t(ye)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}ge&&!_.test(ye)&&(ye=S(ge,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var r={},s=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function S(Ee,ge){r[" "+Ee]||(s.test(Ee)?r[" "+Ee]=Ee+"/":r[" "+Ee]=l(Ee,"/",!0)),Ee=r[" "+Ee];var ye=Ee.indexOf(":")===-1;return ge.substring(0,2)==="//"?ye?ge:Ee.replace(n,"$1")+ge:ge.charAt(0)==="/"?ye?ge:Ee.replace(o,"$1")+ge:Ee+ge}var h={exec:function(){}};function I(Ee){for(var ge=1,ye,re;ge<arguments.length;ge++){ye=arguments[ge];for(re in ye)Object.prototype.hasOwnProperty.call(ye,re)&&(Ee[re]=ye[re])}return Ee}function C(Ee,ge){var ye=Ee.replace(/\|/g,function(se,oe,he){for(var Ie=!1,O=oe;--O>=0&&he[O]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=ye.split(/ \|/),de=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>ge)re.splice(ge);else for(;re.length<ge;)re.push("");for(;de<re.length;de++)re[de]=re[de].trim().replace(/\\\|/g,"|");return re}function l(Ee,ge,ye){var re=Ee.length;if(re===0)return"";for(var de=0;de<re;){var se=Ee.charAt(re-de-1);if(se===ge&&!ye)de++;else if(se!==ge&&ye)de++;else break}return Ee.slice(0,re-de)}function g(Ee,ge){if(Ee.indexOf(ge[1])===-1)return-1;for(var ye=Ee.length,re=0,de=0;de<ye;de++)if(Ee[de]==="\\")de++;else if(Ee[de]===ge[0])re++;else if(Ee[de]===ge[1]&&(re--,re<0))return de;return-1}function d(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Ee,ge){if(ge<1)return"";for(var ye="";ge>1;)ge&1&&(ye+=Ee),ge>>=1,Ee+=Ee;return ye+Ee}function z(Ee,ge,ye,re){var de=ge.href,se=ge.title?p(ge.title):null,oe=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){re.state.inLink=!0;var he={type:"link",raw:ye,href:de,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,he}return{type:"image",raw:ye,href:de,title:se,text:p(oe)}}function H(Ee,ge){var ye=Ee.match(/^(\s+)(?:```)/);if(ye===null)return ge;var re=ye[1];return ge.split(`
`).map(function(de){var se=de.match(/^\s+/);if(se===null)return de;var oe=se[0];return oe.length>=re.length?de.slice(re.length):de}).join(`
`)}var x=function(){function Ee(ye){this.options=ye||be.defaults}var ge=Ee.prototype;return ge.space=function(re){var de=this.rules.block.newline.exec(re);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ge.code=function(re){var de=this.rules.block.code.exec(re);if(de){var se=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?se:l(se,`
`)}}},ge.fences=function(re){var de=this.rules.block.fences.exec(re);if(de){var se=de[0],oe=H(se,de[3]||"");return{type:"code",raw:se,lang:de[2]?de[2].trim():de[2],text:oe}}},ge.heading=function(re){var de=this.rules.block.heading.exec(re);if(de){var se=de[2].trim();if(/#$/.test(se)){var oe=l(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:se,tokens:this.lexer.inline(se)}}},ge.hr=function(re){var de=this.rules.block.hr.exec(re);if(de)return{type:"hr",raw:de[0]}},ge.blockquote=function(re){var de=this.rules.block.blockquote.exec(re);if(de){var se=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},ge.list=function(re){var de=this.rules.block.list.exec(re);if(de){var se,oe,he,Ie,O,V,K,G,q,Z,ce,Le,xe=de[1].trim(),Ge=xe.length>1,je={type:"list",raw:"",ordered:Ge,start:Ge?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ge?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ge?xe:"[*+-]");for(var Je=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Le=!1,!(!(de=Je.exec(re))||this.rules.block.hr.test(re)));){if(se=de[0],re=re.substring(se.length),G=de[2].split(`
`,1)[0],q=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=G.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=G.slice(Ie),Ie+=de[1].length),V=!1,!G&&/^ *$/.test(q)&&(se+=q+`
`,re=re.substring(q.length+1),Le=!0),!Le)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ze=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(Z=re.split(`
`,1)[0],G=Z,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(G)||tt.test(G)||Ye.test(G)||Ze.test(re)));){if(G.search(/[^ ]/)>=Ie||!G.trim())ce+=`
`+G.slice(Ie);else if(!V)ce+=`
`+G;else break;!V&&!G.trim()&&(V=!0),se+=Z+`
`,re=re.substring(Z.length+1)}je.loose||(K?je.loose=!0:/\n *\n *$/.test(se)&&(K=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(he=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:se,task:!!oe,checked:he,loose:!1,text:ce}),je.raw+=se}je.items[je.items.length-1].raw=se.trimRight(),je.items[je.items.length-1].text=ce.trimRight(),je.raw=je.raw.trimRight();var Ue=je.items.length;for(O=0;O<Ue;O++){this.lexer.state.top=!1,je.items[O].tokens=this.lexer.blockTokens(je.items[O].text,[]);var st=je.items[O].tokens.filter(function(X){return X.type==="space"}),J=st.every(function(X){for(var ve=X.raw.split(""),Be=0,Ne=L(ve),Xe;!(Xe=Ne()).done;){var rt=Xe.value;if(rt===`
`&&(Be+=1),Be>1)return!0}return!1});!je.loose&&st.length&&J&&(je.loose=!0,je.items[O].loose=!0)}return je}},ge.html=function(re){var de=this.rules.block.html.exec(re);if(de){var se={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},ge.def=function(re){var de=this.rules.block.def.exec(re);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var se=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:de[0],href:de[2],title:de[3]}}},ge.table=function(re){var de=this.rules.block.table.exec(re);if(de){var se={type:"table",header:C(de[1]).map(function(K){return{text:K}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=de[0];var oe=se.align.length,he,Ie,O,V;for(he=0;he<oe;he++)/^ *-+: *$/.test(se.align[he])?se.align[he]="right":/^ *:-+: *$/.test(se.align[he])?se.align[he]="center":/^ *:-+ *$/.test(se.align[he])?se.align[he]="left":se.align[he]=null;for(oe=se.rows.length,he=0;he<oe;he++)se.rows[he]=C(se.rows[he],se.header.length).map(function(K){return{text:K}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(V=se.rows[Ie],O=0;O<V.length;O++)V[O].tokens=this.lexer.inline(V[O].text);return se}}},ge.lheading=function(re){var de=this.rules.block.lheading.exec(re);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ge.paragraph=function(re){var de=this.rules.block.paragraph.exec(re);if(de){var se=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:se,tokens:this.lexer.inline(se)}}},ge.text=function(re){var de=this.rules.block.text.exec(re);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ge.escape=function(re){var de=this.rules.inline.escape.exec(re);if(de)return{type:"escape",raw:de[0],text:p(de[1])}},ge.tag=function(re){var de=this.rules.inline.tag.exec(re);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]):de[0]}},ge.link=function(re){var de=this.rules.inline.link.exec(re);if(de){var se=de[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=l(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var he=g(de[2],"()");if(he>-1){var Ie=de[0].indexOf("!")===0?5:4,O=Ie+de[1].length+he;de[2]=de[2].substring(0,he),de[0]=de[0].substring(0,O).trim(),de[3]=""}}var V=de[2],K="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);G&&(V=G[1],K=G[3])}else K=de[3]?de[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(se)?V=V.slice(1):V=V.slice(1,-1)),z(de,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ge.reflink=function(re,de){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=de[oe.toLowerCase()],!oe||!oe.href){var he=se[0].charAt(0);return{type:"text",raw:he,text:he}}return z(se,oe,se[0],this.lexer)}},ge.emStrong=function(re,de,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var he=oe[1]||oe[2]||"";if(!he||he&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,O,V,K=Ie,G=0,q=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*re.length+Ie);(oe=q.exec(de))!=null;)if(O=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!O){if(V=O.length,oe[3]||oe[4]){K+=V;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+V)%3)){G+=V;continue}if(K-=V,!(K>0)){if(V=Math.min(V,V+K+G),Math.min(Ie,V)%2){var Z=re.slice(1,Ie+oe.index+V);return{type:"em",raw:re.slice(0,Ie+oe.index+V+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var ce=re.slice(2,Ie+oe.index+V-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+V+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},ge.codespan=function(re){var de=this.rules.inline.code.exec(re);if(de){var se=de[2].replace(/\n/g," "),oe=/[^ ]/.test(se),he=/^ /.test(se)&&/ $/.test(se);return oe&&he&&(se=se.substring(1,se.length-1)),se=p(se,!0),{type:"codespan",raw:de[0],text:se}}},ge.br=function(re){var de=this.rules.inline.br.exec(re);if(de)return{type:"br",raw:de[0]}},ge.del=function(re){var de=this.rules.inline.del.exec(re);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ge.autolink=function(re,de){var se=this.rules.inline.autolink.exec(re);if(se){var oe,he;return se[2]==="@"?(oe=p(this.options.mangle?de(se[1]):se[1]),he="mailto:"+oe):(oe=p(se[1]),he=oe),{type:"link",raw:se[0],text:oe,href:he,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.url=function(re,de){var se;if(se=this.rules.inline.url.exec(re)){var oe,he;if(se[2]==="@")oe=p(this.options.mangle?de(se[0]):se[0]),he="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=p(se[0]),se[1]==="www."?he="http://"+oe:he=oe}return{type:"link",raw:se[0],text:oe,href:he,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.inlineText=function(re,de){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):p(se[0]):se[0]:oe=p(this.options.smartypants?de(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},Ee}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=c($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=c(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=c($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=c($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=c($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=c($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=I({},$),$.gfm=I({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=c($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=c($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=I({},$.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:c($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=c(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=I({},N),N.pedantic=I({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=I({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=I({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(Ee){var ge="",ye,re,de=Ee.length;for(ye=0;ye<de;ye++)re=Ee.charCodeAt(ye),Math.random()>.5&&(re="x"+re.toString(16)),ge+="&#"+re+";";return ge}var Q=function(){function Ee(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||be.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:$.normal,inline:N.normal};this.options.pedantic?(re.block=$.pedantic,re.inline=N.pedantic):this.options.gfm&&(re.block=$.gfm,this.options.breaks?re.inline=N.breaks:re.inline=N.gfm),this.tokenizer.rules=re}Ee.lex=function(re,de){var se=new Ee(de);return se.lex(re)},Ee.lexInline=function(re,de){var se=new Ee(de);return se.inlineTokens(re)};var ge=Ee.prototype;return ge.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ge.blockTokens=function(re,de){var se=this;de===void 0&&(de=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(K,G,q){return G+"    ".repeat(q.length)});for(var oe,he,Ie,O;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(oe=K.call({lexer:se},re,de))?(re=re.substring(oe.raw.length),de.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),he=de[de.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):de.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),he=de[de.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,G=re.slice(1),q=void 0;se.options.extensions.startBlock.forEach(function(Z){q=Z.call({lexer:this},G),typeof q=="number"&&q>=0&&(K=Math.min(K,q))}),K<1/0&&K>=0&&(Ie=re.substring(0,K+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){he=de[de.length-1],O&&he.type==="paragraph"?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):de.push(oe),O=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),he=de[de.length-1],he&&he.type==="text"?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):de.push(oe);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,de},ge.inline=function(re,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:re,tokens:de}),de},ge.inlineTokens=function(re,de){var se=this;de===void 0&&(de=[]);var oe,he,Ie,O=re,V,K,G;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,V.index)+"["+T("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,V.index)+"["+T("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,V.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(K||(G=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:se},re,de))?(re=re.substring(oe.raw.length),de.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),he=de[de.length-1],he&&oe.type==="text"&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):de.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),he=de[de.length-1],he&&oe.type==="text"&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):de.push(oe);continue}if(oe=this.tokenizer.emStrong(re,O,G)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.autolink(re,te)){re=re.substring(oe.raw.length),de.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,te))){re=re.substring(oe.raw.length),de.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Le=re.slice(1),xe=void 0;se.options.extensions.startInline.forEach(function(Ge){xe=Ge.call({lexer:this},Le),typeof xe=="number"&&xe>=0&&(ce=Math.min(ce,xe))}),ce<1/0&&ce>=0&&(Ie=re.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(Ie,M)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(G=oe.raw.slice(-1)),K=!0,he=de[de.length-1],he&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):de.push(oe);continue}if(re){var Z="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return de},w(Ee,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),Ee}(),Se=function(){function Ee(ye){this.options=ye||be.defaults}var ge=Ee.prototype;return ge.code=function(re,de,se){var oe=(de||"").match(/\S*/)[0];if(this.options.highlight){var he=this.options.highlight(re,oe);he!=null&&he!==re&&(se=!0,re=he)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+p(oe,!0)+'">'+(se?re:p(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:p(re,!0))+`</code></pre>
`},ge.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},ge.html=function(re){return re},ge.heading=function(re,de,se,oe){if(this.options.headerIds){var he=this.options.headerPrefix+oe.slug(se);return"<h"+de+' id="'+he+'">'+re+"</h"+de+`>
`}return"<h"+de+">"+re+"</h"+de+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(re,de,se){var oe=de?"ol":"ul",he=de&&se!==1?' start="'+se+'"':"";return"<"+oe+he+`>
`+re+"</"+oe+`>
`},ge.listitem=function(re){return"<li>"+re+`</li>
`},ge.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(re){return"<p>"+re+`</p>
`},ge.table=function(re,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+de+`</table>
`},ge.tablerow=function(re){return`<tr>
`+re+`</tr>
`},ge.tablecell=function(re,de){var se=de.header?"th":"td",oe=de.align?"<"+se+' align="'+de.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},ge.strong=function(re){return"<strong>"+re+"</strong>"},ge.em=function(re){return"<em>"+re+"</em>"},ge.codespan=function(re){return"<code>"+re+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(re){return"<del>"+re+"</del>"},ge.link=function(re,de,se){if(re=E(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+p(re)+'"';return de&&(oe+=' title="'+de+'"'),oe+=">"+se+"</a>",oe},ge.image=function(re,de,se){if(re=E(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return de&&(oe+=' title="'+de+'"'),oe+=this.options.xhtml?"/>":">",oe},ge.text=function(re){return re},Ee}(),_e=function(){function Ee(){}var ge=Ee.prototype;return ge.strong=function(re){return re},ge.em=function(re){return re},ge.codespan=function(re){return re},ge.del=function(re){return re},ge.html=function(re){return re},ge.text=function(re){return re},ge.link=function(re,de,se){return""+se},ge.image=function(re,de,se){return""+se},ge.br=function(){return""},Ee}(),Pe=function(){function Ee(){this.seen={}}var ge=Ee.prototype;return ge.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(re,de){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return de||(this.seen[re]=oe,this.seen[se]=0),se},ge.slug=function(re,de){de===void 0&&(de={});var se=this.serialize(re);return this.getNextSafeSlug(se,de.dryrun)},Ee}(),Y=function(){function Ee(ye){this.options=ye||be.defaults,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _e,this.slugger=new Pe}Ee.parse=function(re,de){var se=new Ee(de);return se.parse(re)},Ee.parseInline=function(re,de){var se=new Ee(de);return se.parseInline(re)};var ge=Ee.prototype;return ge.parse=function(re,de){de===void 0&&(de=!0);var se="",oe,he,Ie,O,V,K,G,q,Z,ce,Le,xe,Ge,je,Je,Ye,Ze,it,tt,Ue=re.length;for(oe=0;oe<Ue;oe++){if(ce=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){se+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(q="",G="",O=ce.header.length,he=0;he<O;he++)G+=this.renderer.tablecell(this.parseInline(ce.header[he].tokens),{header:!0,align:ce.align[he]});for(q+=this.renderer.tablerow(G),Z="",O=ce.rows.length,he=0;he<O;he++){for(K=ce.rows[he],G="",V=K.length,Ie=0;Ie<V;Ie++)G+=this.renderer.tablecell(this.parseInline(K[Ie].tokens),{header:!1,align:ce.align[Ie]});Z+=this.renderer.tablerow(G)}se+=this.renderer.table(q,Z);continue}case"blockquote":{Z=this.parse(ce.tokens),se+=this.renderer.blockquote(Z);continue}case"list":{for(Le=ce.ordered,xe=ce.start,Ge=ce.loose,O=ce.items.length,Z="",he=0;he<O;he++)Je=ce.items[he],Ye=Je.checked,Ze=Je.task,je="",Je.task&&(it=this.renderer.checkbox(Ye),Ge?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=it+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=it+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:it}):je+=it),je+=this.parse(Je.tokens,Ge),Z+=this.renderer.listitem(je,Ze,Ye);se+=this.renderer.list(Z,Le,xe);continue}case"html":{se+=this.renderer.html(ce.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(Z=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<Ue&&re[oe+1].type==="text";)ce=re[++oe],Z+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);se+=de?this.renderer.paragraph(Z):Z;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},ge.parseInline=function(re,de){de=de||this.renderer;var se="",oe,he,Ie,O=re.length;for(oe=0;oe<O;oe++){if(he=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Ie=this.options.extensions.renderers[he.type].call({parser:this},he),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type))){se+=Ie||"";continue}switch(he.type){case"escape":{se+=de.text(he.text);break}case"html":{se+=de.html(he.text);break}case"link":{se+=de.link(he.href,he.title,this.parseInline(he.tokens,de));break}case"image":{se+=de.image(he.href,he.title,he.text);break}case"strong":{se+=de.strong(this.parseInline(he.tokens,de));break}case"em":{se+=de.em(this.parseInline(he.tokens,de));break}case"codespan":{se+=de.codespan(he.text);break}case"br":{se+=de.br();break}case"del":{se+=de.del(this.parseInline(he.tokens,de));break}case"text":{se+=de.text(he.text);break}default:{var V='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return se},Ee}();function ae(Ee,ge,ye){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof ge=="function"&&(ye=ge,ge=null),ge=I({},ae.defaults,ge||{}),d(ge),ye){var re=ge.highlight,de;try{de=Q.lex(Ee,ge)}catch(O){return ye(O)}var se=function(V){var K;if(!V)try{ge.walkTokens&&ae.walkTokens(de,ge.walkTokens),K=Y.parse(de,ge)}catch(G){V=G}return ge.highlight=re,V?ye(V):ye(null,K)};if(!re||re.length<3||(delete ge.highlight,!de.length))return se();var oe=0;ae.walkTokens(de,function(O){O.type==="code"&&(oe++,setTimeout(function(){re(O.text,O.lang,function(V,K){if(V)return se(V);K!=null&&K!==O.text&&(O.text=K,O.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function he(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+p(O.message+"",!0)+"</pre>";throw O}try{var Ie=Q.lex(Ee,ge);if(ge.walkTokens){if(ge.async)return Promise.all(ae.walkTokens(Ie,ge.walkTokens)).then(function(){return Y.parse(Ie,ge)}).catch(he);ae.walkTokens(Ie,ge.walkTokens)}return Y.parse(Ie,ge)}catch(O){he(O)}}ae.options=ae.setOptions=function(Ee){return I(ae.defaults,Ee),u(ae.defaults),ae},ae.getDefaults=A,ae.defaults=be.defaults,ae.use=function(){for(var Ee=arguments.length,ge=new Array(Ee),ye=0;ye<Ee;ye++)ge[ye]=arguments[ye];var re=I.apply(void 0,[{}].concat(ge)),de=ae.defaults.extensions||{renderers:{},childTokens:{}},se;ge.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var O=de.renderers?de.renderers[Ie.name]:null;O?de.renderers[Ie.name]=function(){for(var V=arguments.length,K=new Array(V),G=0;G<V;G++)K[G]=arguments[G];var q=Ie.renderer.apply(this,K);return q===!1&&(q=O.apply(this,K)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ae.defaults.renderer||new Se,O=function(G){var q=Ie[G];Ie[G]=function(){for(var Z=arguments.length,ce=new Array(Z),Le=0;Le<Z;Le++)ce[Le]=arguments[Le];var xe=oe.renderer[G].apply(Ie,ce);return xe===!1&&(xe=q.apply(Ie,ce)),xe}};for(var V in oe.renderer)O(V);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ae.defaults.tokenizer||new x,O=function(G){var q=Ie[G];Ie[G]=function(){for(var Z=arguments.length,ce=new Array(Z),Le=0;Le<Z;Le++)ce[Le]=arguments[Le];var xe=oe.tokenizer[G].apply(Ie,ce);return xe===!1&&(xe=q.apply(Ie,ce)),xe}};for(var V in oe.tokenizer)O(V);re.tokenizer=Ie}(),oe.walkTokens){var he=ae.defaults.walkTokens;re.walkTokens=function(Ie){var O=[];return O.push(oe.walkTokens.call(this,Ie)),he&&(O=O.concat(he.call(this,Ie))),O}}se&&(re.extensions=de),ae.setOptions(re)})},ae.walkTokens=function(Ee,ge){for(var ye=[],re=function(){var he=se.value;switch(ye=ye.concat(ge.call(ae,he)),he.type){case"table":{for(var Ie=L(he.header),O;!(O=Ie()).done;){var V=O.value;ye=ye.concat(ae.walkTokens(V.tokens,ge))}for(var K=L(he.rows),G;!(G=K()).done;)for(var q=G.value,Z=L(q),ce;!(ce=Z()).done;){var Le=ce.value;ye=ye.concat(ae.walkTokens(Le.tokens,ge))}break}case"list":{ye=ye.concat(ae.walkTokens(he.items,ge));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[he.type]?ae.defaults.extensions.childTokens[he.type].forEach(function(xe){ye=ye.concat(ae.walkTokens(he[xe],ge))}):he.tokens&&(ye=ye.concat(ae.walkTokens(he.tokens,ge)))}},de=L(Ee),se;!(se=de()).done;)re();return ye},ae.parseInline=function(Ee,ge){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");ge=I({},ae.defaults,ge||{}),d(ge);try{var ye=Q.lexInline(Ee,ge);return ge.walkTokens&&ae.walkTokens(ye,ge.walkTokens),Y.parseInline(ye,ge)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+p(re.message+"",!0)+"</pre>";throw re}},ae.Parser=Y,ae.parser=Y.parse,ae.Renderer=Se,ae.TextRenderer=_e,ae.Lexer=Q,ae.lexer=Q.lex,ae.Tokenizer=x,ae.Slugger=Pe,ae.parse=ae;var Ce=ae.options,le=ae.setOptions,pe=ae.use,ie=ae.walkTokens,U=ae.parseInline,W=ae,ue=Y.parse,we=Q.lex;be.Lexer=Q,be.Parser=Y,be.Renderer=Se,be.Slugger=Pe,be.TextRenderer=_e,be.Tokenizer=x,be.getDefaults=A,be.lexer=we,be.marked=ae,be.options=Ce,be.parse=W,be.parseInline=U,be.parser=ue,be.setOptions=le,be.use=pe,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(u,y,m){return Math.min(Math.max(u,y),m)}e.clamp=w;function R(u,y){return(y+u%y)%y}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class L{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class A{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const m=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function be(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function A(y){L.push(y,Date.now())}function u(){const y=[];for(let m=0;m<L.length;m+=2)y.push({name:L[m],startTime:L[m+1]});return y}return{mark:A,getMarks:u}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(k+A.startTime)});return L}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var R in w)(typeof exports=="object"?exports:be)[R]=w[R]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return be[R].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=be,w.c=e,w.d=function(R,k,L){w.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:L})},w.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},w.t=function(R,k){if(1&k&&(R=w(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(w.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var A in R)w.d(L,A,function(u){return R[u]}.bind(null,A));return L},w.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return w.d(k,"a",k),k},w.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},w.p="",w(w.s=0)}([function(be,e,w){(function(R){var k;e=be.exports=pe,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,u=e.re=[],y=e.src=[],m=0,P=m++;y[P]="0|[1-9]\\d*";var D=m++;y[D]="[0-9]+";var a=m++;y[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=m++;y[v]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var p=m++;y[p]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var f=m++;y[f]="(?:"+y[P]+"|"+y[a]+")";var t=m++;y[t]="(?:"+y[D]+"|"+y[a]+")";var i=m++;y[i]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var c=m++;y[c]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var b=m++;y[b]="[0-9A-Za-z-]+";var _=m++;y[_]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var E=m++,r="v?"+y[v]+y[i]+"?"+y[_]+"?";y[E]="^"+r+"$";var s="[v=\\s]*"+y[p]+y[c]+"?"+y[_]+"?",n=m++;y[n]="^"+s+"$";var o=m++;y[o]="((?:<|>)?=?)";var S=m++;y[S]=y[D]+"|x|X|\\*";var h=m++;y[h]=y[P]+"|x|X|\\*";var I=m++;y[I]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[i]+")?"+y[_]+"?)?)?";var C=m++;y[C]="[v=\\s]*("+y[S]+")(?:\\.("+y[S]+")(?:\\.("+y[S]+")(?:"+y[c]+")?"+y[_]+"?)?)?";var l=m++;y[l]="^"+y[o]+"\\s*"+y[I]+"$";var g=m++;y[g]="^"+y[o]+"\\s*"+y[C]+"$";var d=m++;y[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=m++;y[T]="(?:~>?)";var z=m++;y[z]="(\\s*)"+y[T]+"\\s+",u[z]=new RegExp(y[z],"g");var H=m++;y[H]="^"+y[T]+y[I]+"$";var x=m++;y[x]="^"+y[T]+y[C]+"$";var $=m++;y[$]="(?:\\^)";var N=m++;y[N]="(\\s*)"+y[$]+"\\s+",u[N]=new RegExp(y[N],"g");var M=m++;y[M]="^"+y[$]+y[I]+"$";var te=m++;y[te]="^"+y[$]+y[C]+"$";var Q=m++;y[Q]="^"+y[o]+"\\s*("+s+")$|^$";var Se=m++;y[Se]="^"+y[o]+"\\s*("+r+")$|^$";var _e=m++;y[_e]="(\\s*)"+y[o]+"\\s*("+s+"|"+y[I]+")",u[_e]=new RegExp(y[_e],"g");var Pe=m++;y[Pe]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var Y=m++;y[Y]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var ae=m++;y[ae]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)k(Ce,y[Ce]),u[Ce]||(u[Ce]=new RegExp(y[Ce]));function le(q,Z){if(q instanceof pe)return q;if(typeof q!="string"||q.length>L||!(Z?u[n]:u[E]).test(q))return null;try{return new pe(q,Z)}catch{return null}}function pe(q,Z){if(q instanceof pe){if(q.loose===Z)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof pe))return new pe(q,Z);k("SemVer",q,Z),this.loose=Z;var ce=q.trim().match(Z?u[n]:u[E]);if(!ce)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var xe=+Le;if(xe>=0&&xe<A)return xe}return Le}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=le,e.valid=function(q,Z){var ce=le(q,Z);return ce?ce.version:null},e.clean=function(q,Z){var ce=le(q.trim().replace(/^[=v]+/,""),Z);return ce?ce.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(q){return k("SemVer.compare",this.version,this.loose,q),q instanceof pe||(q=new pe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},pe.prototype.compareMain=function(q){return q instanceof pe||(q=new pe(q,this.loose)),U(this.major,q.major)||U(this.minor,q.minor)||U(this.patch,q.patch)},pe.prototype.comparePre=function(q){if(q instanceof pe||(q=new pe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Z=0;do{var ce=this.prerelease[Z],Le=q.prerelease[Z];if(k("prerelease compare",Z,ce,Le),ce===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ce===void 0)return-1;if(ce!==Le)return U(ce,Le)}while(++Z)},pe.prototype.inc=function(q,Z){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Z,ce,Le){typeof ce=="string"&&(Le=ce,ce=void 0);try{return new pe(q,ce).inc(Z,Le).version}catch{return null}},e.diff=function(q,Z){if(Ee(q,Z))return null;var ce=le(q),Le=le(Z);if(ce.prerelease.length||Le.prerelease.length){for(var xe in ce)if((xe==="major"||xe==="minor"||xe==="patch")&&ce[xe]!==Le[xe])return"pre"+xe;return"prerelease"}for(var xe in ce)if((xe==="major"||xe==="minor"||xe==="patch")&&ce[xe]!==Le[xe])return xe},e.compareIdentifiers=U;var ie=/^[0-9]+$/;function U(q,Z){var ce=ie.test(q),Le=ie.test(Z);return ce&&Le&&(q=+q,Z=+Z),ce&&!Le?-1:Le&&!ce?1:q<Z?-1:q>Z?1:0}function W(q,Z,ce){return new pe(q,ce).compare(new pe(Z,ce))}function ue(q,Z,ce){return W(q,Z,ce)>0}function we(q,Z,ce){return W(q,Z,ce)<0}function Ee(q,Z,ce){return W(q,Z,ce)===0}function ge(q,Z,ce){return W(q,Z,ce)!==0}function ye(q,Z,ce){return W(q,Z,ce)>=0}function re(q,Z,ce){return W(q,Z,ce)<=0}function de(q,Z,ce,Le){var xe;switch(Z){case"===":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),xe=q===ce;break;case"!==":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),xe=q!==ce;break;case"":case"=":case"==":xe=Ee(q,ce,Le);break;case"!=":xe=ge(q,ce,Le);break;case">":xe=ue(q,ce,Le);break;case">=":xe=ye(q,ce,Le);break;case"<":xe=we(q,ce,Le);break;case"<=":xe=re(q,ce,Le);break;default:throw new TypeError("Invalid operator: "+Z)}return xe}function se(q,Z){if(q instanceof se){if(q.loose===Z)return q;q=q.value}if(!(this instanceof se))return new se(q,Z);k("comparator",q,Z),this.loose=Z,this.parse(q),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(q,Z){return U(Z,q)},e.major=function(q,Z){return new pe(q,Z).major},e.minor=function(q,Z){return new pe(q,Z).minor},e.patch=function(q,Z){return new pe(q,Z).patch},e.compare=W,e.compareLoose=function(q,Z){return W(q,Z,!0)},e.rcompare=function(q,Z,ce){return W(Z,q,ce)},e.sort=function(q,Z){return q.sort(function(ce,Le){return e.compare(ce,Le,Z)})},e.rsort=function(q,Z){return q.sort(function(ce,Le){return e.rcompare(ce,Le,Z)})},e.gt=ue,e.lt=we,e.eq=Ee,e.neq=ge,e.gte=ye,e.lte=re,e.cmp=de,e.Comparator=se;var oe={};function he(q,Z){if(q instanceof he)return q.loose===Z?q:new he(q.raw,Z);if(q instanceof se)return new he(q.value,Z);if(!(this instanceof he))return new he(q,Z);if(this.loose=Z,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function O(q,Z,ce,Le,xe,Ge,je,Je,Ye,Ze,it,tt,Ue){return((Z=Ie(ce)?"":Ie(Le)?">="+ce+".0.0":Ie(xe)?">="+ce+"."+Le+".0":">="+Z)+" "+(Je=Ie(Ye)?"":Ie(Ze)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+Ze+1)+".0":tt?"<="+Ye+"."+Ze+"."+it+"-"+tt:"<="+Je)).trim()}function V(q,Z){for(var ce=0;ce<q.length;ce++)if(!q[ce].test(Z))return!1;if(Z.prerelease.length){for(ce=0;ce<q.length;ce++)if(k(q[ce].semver),q[ce].semver!==oe&&q[ce].semver.prerelease.length>0){var Le=q[ce].semver;if(Le.major===Z.major&&Le.minor===Z.minor&&Le.patch===Z.patch)return!0}return!1}return!0}function K(q,Z,ce){try{Z=new he(Z,ce)}catch{return!1}return Z.test(q)}function G(q,Z,ce,Le){var xe,Ge,je,Je,Ye;switch(q=new pe(q,Le),Z=new he(Z,Le),ce){case">":xe=ue,Ge=re,je=we,Je=">",Ye=">=";break;case"<":xe=we,Ge=ye,je=ue,Je="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(q,Z,Le))return!1;for(var Ze=0;Ze<Z.set.length;++Ze){var it=Z.set[Ze],tt=null,Ue=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,Ue=Ue||st,xe(st.semver,tt.semver,Le)?tt=st:je(st.semver,Ue.semver,Le)&&(Ue=st)}),tt.operator===Je||tt.operator===Ye||(!Ue.operator||Ue.operator===Je)&&Ge(q,Ue.semver)||Ue.operator===Ye&&je(q,Ue.semver))return!1}return!0}se.prototype.parse=function(q){var Z=this.loose?u[Q]:u[Se],ce=q.match(Z);if(!ce)throw new TypeError("Invalid comparator: "+q);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new pe(ce[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(q){return k("Comparator.test",q,this.loose),this.semver===oe||(typeof q=="string"&&(q=new pe(q,this.loose)),de(q,this.operator,this.semver,this.loose))},se.prototype.intersects=function(q,Z){if(!(q instanceof se))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new he(q.value,Z),K(this.value,ce,Z);if(q.operator==="")return ce=new he(this.value,Z),K(q.semver,ce,Z);var Le=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ge=this.semver.version===q.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Je=de(this.semver,"<",q.semver,Z)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=de(this.semver,">",q.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Le||xe||Ge&&je||Je||Ye},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(q){var Z=this.loose;q=q.trim(),k("range",q,Z);var ce=Z?u[Y]:u[Pe];q=q.replace(ce,O),k("hyphen replace",q),q=q.replace(u[_e],"$1$2$3"),k("comparator trim",q,u[_e]),q=(q=(q=q.replace(u[z],"$1~")).replace(u[N],"$1^")).split(/\s+/).join(" ");var Le=Z?u[Q]:u[Se],xe=q.split(" ").map(function(Ge){return function(je,Je){return k("comp",je),je=function(Ye,Ze){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){k("caret",tt,Ue);var st=Ue?u[te]:u[M];return tt.replace(st,function(J,X,ve,Be,Ne){var Xe;return k("caret",tt,J,X,ve,Be,Ne),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=X==="0"?">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+".0 <"+(+X+1)+".0.0":Ne?(k("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+Ne+" <"+(+X+1)+".0.0"):(k("no pr"),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+" <"+(+X+1)+".0.0"),k("caret return",Xe),Xe})}(it,Ze)}).join(" ")}(je,Je),k("caret",je),je=function(Ye,Ze){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){var st=Ue?u[x]:u[H];return tt.replace(st,function(J,X,ve,Be,Ne){var Xe;return k("tilde",tt,J,X,ve,Be,Ne),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":Ne?(k("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+(+ve+1)+".0"):Xe=">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0",k("tilde return",Xe),Xe})}(it,Ze)}).join(" ")}(je,Je),k("tildes",je),je=function(Ye,Ze){return k("replaceXRanges",Ye,Ze),Ye.split(/\s+/).map(function(it){return function(tt,Ue){tt=tt.trim();var st=Ue?u[g]:u[l];return tt.replace(st,function(J,X,ve,Be,Ne,Xe){k("xRange",tt,J,X,ve,Be,Ne,Xe);var rt=Ie(ve),gt=rt||Ie(Be),wt=gt||Ie(Ne);return X==="="&&wt&&(X=""),rt?J=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(gt&&(Be=0),wt&&(Ne=0),X===">"?(X=">=",gt?(ve=+ve+1,Be=0,Ne=0):wt&&(Be=+Be+1,Ne=0)):X==="<="&&(X="<",gt?ve=+ve+1:Be=+Be+1),J=X+ve+"."+Be+"."+Ne):gt?J=">="+ve+".0.0 <"+(+ve+1)+".0.0":wt&&(J=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),k("xRange return",J),J})}(it,Ze)}).join(" ")}(je,Je),k("xrange",je),je=function(Ye,Ze){return k("replaceStars",Ye,Ze),Ye.trim().replace(u[ae],"")}(je,Je),k("stars",je),je}(Ge,Z)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ge){return!!Ge.match(Le)})),xe=xe.map(function(Ge){return new se(Ge,Z)})},he.prototype.intersects=function(q,Z){if(!(q instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Le){return q.set.some(function(xe){return xe.every(function(Ge){return Le.intersects(Ge,Z)})})})})},e.toComparators=function(q,Z){return new he(q,Z).set.map(function(ce){return ce.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},he.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new pe(q,this.loose));for(var Z=0;Z<this.set.length;Z++)if(V(this.set[Z],q))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(q,Z,ce){var Le=null,xe=null;try{var Ge=new he(Z,ce)}catch{return null}return q.forEach(function(je){Ge.test(je)&&(Le&&xe.compare(je)!==-1||(xe=new pe(Le=je,ce)))}),Le},e.minSatisfying=function(q,Z,ce){var Le=null,xe=null;try{var Ge=new he(Z,ce)}catch{return null}return q.forEach(function(je){Ge.test(je)&&(Le&&xe.compare(je)!==1||(xe=new pe(Le=je,ce)))}),Le},e.validRange=function(q,Z){try{return new he(q,Z).range||"*"}catch{return null}},e.ltr=function(q,Z,ce){return G(q,Z,"<",ce)},e.gtr=function(q,Z,ce){return G(q,Z,">",ce)},e.outside=G,e.prerelease=function(q,Z){var ce=le(q,Z);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(q,Z,ce){return q=new he(q,ce),Z=new he(Z,ce),q.intersects(Z)},e.coerce=function(q){if(q instanceof pe)return q;if(typeof q!="string")return null;var Z=q.match(u[d]);return Z==null?null:le((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,w(1))},function(be,e){var w,R,k=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function u(t){if(w===setTimeout)return setTimeout(t,0);if((w===L||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:L}catch{w=L}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var y,m=[],P=!1,D=-1;function a(){P&&y&&(P=!1,y.length?m=y.concat(m):D=-1,m.length&&v())}function v(){if(!P){var t=u(a);P=!0;for(var i=m.length;i;){for(y=m,m=[];++D<i;)y&&y[D].run();D=-1,i=m.length}y=null,P=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}k.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];m.push(new p(t,i)),m.length!==1||P||u(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=f,k.addListener=f,k.once=f,k.off=f,k.removeListener=f,k.removeAllListeners=f,k.emit=f,k.prependListener=f,k.prependOnceListener=f,k.listeners=function(t){return[]},k.binding=function(t){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(t){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(_){const E=_;return E?typeof E.read=="function":!1}e.isReadable=k;function L(_){const E=_;return E?[E.on,E.pause,E.resume,E.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function A(_){const E=_;return E?L(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=A;function u(_,E){return new y(_,E)}e.newWriteableStream=u;class y{constructor(E,r){this.reducer=E,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(r=>r(E))}emitError(E){this.listeners.error.length===0?(0,w.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(r=>r(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,r){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(E,r){if(this.state.destroyed)return;let s;switch(E){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const n=s.indexOf(r);n>=0&&s.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(_,E){const r=[];let s;for(;(s=_.read())!==null;)r.push(s);return E(r)}e.consumeReadable=m;function P(_,E,r){const s=[];let n;for(;(n=_.read())!==null&&s.length<r;)s.push(n);return n===null&&s.length>0?E(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return _.read()}}}e.peekReadable=P;function D(_,E){return new Promise((r,s)=>{const n=[];a(_,{onData:o=>{E&&n.push(o)},onError:o=>{E?s(o):r(void 0)},onEnd:()=>{r(E?E(n):void 0)}})})}e.consumeStream=D;function a(_,E,r){_.on("error",s=>{r?.isCancellationRequested||E.onError(s)}),_.on("end",()=>{r?.isCancellationRequested||E.onEnd()}),_.on("data",s=>{r?.isCancellationRequested||E.onData(s)})}e.listenStream=a;function v(_,E){return new Promise((r,s)=>{const n=new R.DisposableStore,o=[],S=C=>{if(o.push(C),o.length>E)return n.dispose(),_.pause(),r({stream:_,buffer:o,ended:!1})},h=C=>(n.dispose(),s(C)),I=()=>(n.dispose(),r({stream:_,buffer:o,ended:!0}));n.add((0,R.toDisposable)(()=>_.removeListener("error",h))),_.on("error",h),n.add((0,R.toDisposable)(()=>_.removeListener("end",I))),_.on("end",I),n.add((0,R.toDisposable)(()=>_.removeListener("data",S))),_.on("data",S)})}e.peekStream=v;function p(_,E){const r=u(E);return r.end(_),r}e.toStream=p;function f(){const _=u(()=>{throw new Error("not supported")});return _.end(),_}e.emptyStream=f;function t(_){let E=!1;return{read:()=>E?null:(E=!0,_)}}e.toReadable=t;function i(_,E,r){const s=u(r);return a(_,{onData:n=>s.write(E.data(n)),onError:n=>s.error(E.error?E.error(n):n),onEnd:()=>s.end()}),s}e.transform=i;function c(_,E,r){let s=!1;return{read:()=>{const n=E.read();return s?n:(s=!0,n!==null?r([_,n]):_)}}}e.prefixedReadable=c;function b(_,E,r){let s=!1;const n=u(r);return a(E,{onData:o=>s?n.write(o):(s=!0,n.write(r([_,o]))),onError:o=>n.error(o),onEnd:()=>{s||(s=!0,n.write(_)),n.end()}}),n}e.prefixedStream=b}),define(Ae[25],Re([1,0,48,118]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",L=new w.Lazy(()=>new Uint8Array(256));let A,u;class y{static alloc(d){return k?new y(Buffer.allocUnsafe(d)):new y(new Uint8Array(d))}static wrap(d){return k&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new y(d)}static fromString(d,T){return!(T?.dontUseNodeBuffer||!1)&&k?new y(Buffer.from(d)):(A||(A=new TextEncoder),new y(A.encode(d)))}static fromByteArray(d){const T=y.alloc(d.length);for(let z=0,H=d.length;z<H;z++)T.buffer[z]=d[z];return T}static concat(d,T){if(typeof T>"u"){T=0;for(let x=0,$=d.length;x<$;x++)T+=d[x].byteLength}const z=y.alloc(T);let H=0;for(let x=0,$=d.length;x<$;x++){const N=d[x];z.set(N,H),H+=N.byteLength}return z}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=y.alloc(this.byteLength);return d.set(this),d}toString(){return k?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(d,T){return new y(this.buffer.subarray(d,T))}set(d,T){if(d instanceof y)this.buffer.set(d.buffer,T);else if(d instanceof Uint8Array)this.buffer.set(d,T);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),T);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return a(this.buffer,d)}writeUInt32BE(d,T){v(this.buffer,d,T)}readUInt32LE(d){return p(this.buffer,d)}writeUInt32LE(d,T){f(this.buffer,d,T)}readUInt8(d){return t(this.buffer,d)}writeUInt8(d,T){i(this.buffer,d,T)}indexOf(d,T=0){return m(this.buffer,d instanceof y?d.buffer:d,T)}}e.VSBuffer=y;function m(g,d,T=0){const z=d.byteLength,H=g.byteLength;if(z===0)return 0;if(z===1)return g.indexOf(d[0]);if(z>H-T)return-1;const x=L.value;x.fill(d.length);for(let te=0;te<d.length;te++)x[d[te]]=d.length-te-1;let $=T+d.length-1,N=$,M=-1;for(;$<H;)if(g[$]===d[N]){if(N===0){M=$;break}$--,N--}else $+=Math.max(d.length-N,x[g[$]]),N=d.length-1;return M}e.binaryIndexOf=m;function P(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0}e.readUInt16LE=P;function D(g,d,T){g[T+0]=d&255,d=d>>>8,g[T+1]=d&255}e.writeUInt16LE=D;function a(g,d){return g[d]*2**24+g[d+1]*2**16+g[d+2]*2**8+g[d+3]}e.readUInt32BE=a;function v(g,d,T){g[T+3]=d,d=d>>>8,g[T+2]=d,d=d>>>8,g[T+1]=d,d=d>>>8,g[T]=d}e.writeUInt32BE=v;function p(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0|g[d+2]<<16>>>0|g[d+3]<<24>>>0}e.readUInt32LE=p;function f(g,d,T){g[T+0]=d&255,d=d>>>8,g[T+1]=d&255,d=d>>>8,g[T+2]=d&255,d=d>>>8,g[T+3]=d&255}e.writeUInt32LE=f;function t(g,d){return g[d]}e.readUInt8=t;function i(g,d,T){g[T]=d}e.writeUInt8=i;function c(g){return R.consumeReadable(g,d=>y.concat(d))}e.readableToBuffer=c;function b(g){return R.toReadable(g)}e.bufferToReadable=b;function _(g){return R.consumeStream(g,d=>y.concat(d))}e.streamToBuffer=_;async function E(g){return g.ended?y.concat(g.buffer):y.concat([...g.buffer,await _(g.stream)])}e.bufferedStreamToBuffer=E;function r(g){return R.toStream(g,d=>y.concat(d))}e.bufferToStream=r;function s(g){return R.transform(g,{data:d=>typeof d=="string"?y.fromString(d):y.wrap(d)},d=>y.concat(d))}e.streamToBufferReadableStream=s;function n(g){return R.newWriteableStream(d=>y.concat(d),g)}e.newWriteableBufferStream=n;function o(g,d){return R.prefixedReadable(g,d,T=>y.concat(T))}e.prefixedBufferReadable=o;function S(g,d){return R.prefixedStream(g,d,T=>y.concat(T))}e.prefixedBufferStream=S;function h(g){let d=0,T=0,z=0;const H=new Uint8Array(Math.floor(g.length/4*3)),x=N=>{switch(T){case 3:H[z++]=d|N,T=0;break;case 2:H[z++]=d|N>>>2,d=N<<6,T=3;break;case 1:H[z++]=d|N>>>4,d=N<<4,T=2;break;default:d=N<<2,T=1}};for(let N=0;N<g.length;N++){const M=g.charCodeAt(N);if(M>=65&&M<=90)x(M-65);else if(M>=97&&M<=122)x(M-97+26);else if(M>=48&&M<=57)x(M-48+52);else if(M===43||M===45)x(62);else if(M===47||M===95)x(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${g[N]}`)}}const $=z;for(;T>0;)x(0);return y.wrap(H).slice(0,$)}e.decodeBase64=h;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:g},d=!0,T=!1){const z=T?C:I;let H="";const x=g.byteLength%3;let $=0;for(;$<g.byteLength-x;$+=3){const N=g[$+0],M=g[$+1],te=g[$+2];H+=z[N>>>2],H+=z[(N<<4|M>>>4)&63],H+=z[(M<<2|te>>>6)&63],H+=z[te&63]}if(x===1){const N=g[$+0];H+=z[N>>>2],H+=z[N<<4&63],d&&(H+="==")}else if(x===2){const N=g[$+0],M=g[$+1];H+=z[N>>>2],H+=z[(N<<4|M>>>4)&63],H+=z[M<<2&63],d&&(H+="=")}return H}e.encodeBase64=l}),define(Ae[119],Re([1,0,28,15]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...se){return function(oe,he){for(let Ie=0,O=se.length;Ie<O;Ie++){const V=se[Ie](oe,he);if(V)return V}return null}}e.or=k,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(se,oe,he){if(!he||he.length<oe.length)return null;let Ie;return se?Ie=R.startsWithIgnoreCase(he,oe):Ie=he.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const he=oe.toLowerCase().indexOf(se.toLowerCase());return he===-1?null:[{start:he,end:he+se.length}]}e.matchesContiguousSubString=A;function u(se,oe){return y(se.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=u;function y(se,oe,he,Ie){if(he===se.length)return[];if(Ie===oe.length)return null;if(se[he]===oe[Ie]){let O=null;return(O=y(se,oe,he+1,Ie+1))?i({start:Ie,end:Ie+1},O):null}return y(se,oe,he,Ie+1)}function m(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.isUpper=P;function D(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>v.add(se.charCodeAt(0)));function p(se){return a(se)||v.has(se)}function f(se,oe){return se===oe||p(se)&&p(oe)}function t(se){return m(se)||P(se)||D(se)}function i(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let he=oe;he<se.length;he++){const Ie=se.charCodeAt(he);if(P(Ie)||D(Ie)||he>0&&!t(se.charCodeAt(he-1)))return he}return se.length}function b(se,oe,he,Ie){if(he===se.length)return[];if(Ie===oe.length)return null;if(se[he]!==oe[Ie].toLowerCase())return null;{let O=null,V=Ie+1;for(O=b(se,oe,he+1,Ie+1);!O&&(V=c(oe,V))<oe.length;)O=b(se,oe,he+1,V),V++;return O===null?null:i({start:Ie,end:Ie+1},O)}}function _(se){let oe=0,he=0,Ie=0,O=0,V=0;for(let ce=0;ce<se.length;ce++)V=se.charCodeAt(ce),P(V)&&oe++,m(V)&&he++,t(V)&&Ie++,D(V)&&O++;const K=oe/se.length,G=he/se.length,q=Ie/se.length,Z=O/se.length;return{upperPercent:K,lowerPercent:G,alphaPercent:q,numericPercent:Z}}function E(se){const{upperPercent:oe,lowerPercent:he}=se;return he===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:he,alphaPercent:Ie,numericPercent:O}=se;return he>.2&&oe<.8&&Ie>.6&&O<.2}function s(se){let oe=0,he=0,Ie=0,O=0;for(let V=0;V<se.length;V++)Ie=se.charCodeAt(V),P(Ie)&&oe++,m(Ie)&&he++,a(Ie)&&O++;return(oe===0||he===0)&&O===0?se.length<=30:oe<=5}function n(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const he=_(oe);if(!r(he)){if(!E(he))return null;oe=oe.toLowerCase()}let Ie=null,O=0;for(se=se.toLowerCase();O<oe.length&&(Ie=b(se,oe,0,O))===null;)O=c(oe,O+1);return Ie}e.matchesCamelCase=n;function o(se,oe,he=!1){if(!oe||oe.length===0)return null;let Ie=null,O=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();O<oe.length&&(Ie=S(se,oe,0,O,he))===null;)O=h(oe,O+1);return Ie}e.matchesWords=o;function S(se,oe,he,Ie,O){if(he===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(he),oe.charCodeAt(Ie))){let V=null,K=Ie+1;if(V=S(se,oe,he+1,Ie+1,O),!O)for(;!V&&(K=h(oe,K))<oe.length;)V=S(se,oe,he+1,K,O),K++;return V?se.charCodeAt(he)!==oe.charCodeAt(Ie)?V:i({start:Ie,end:Ie+1},V):null}else return null}function h(se,oe){for(let he=oe;he<se.length;he++)if(p(se.charCodeAt(he))||he>0&&p(se.charCodeAt(he-1)))return he;return se.length}const I=k(e.matchesPrefix,n,A),C=k(e.matchesPrefix,n,u),l=new w.LRUCache(1e4);function g(se,oe,he=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=l.get(se);Ie||(Ie=new RegExp(R.convertSimple2RegExpPattern(se),"i"),l.set(se,Ie));const O=Ie.exec(oe);return O?[{start:O.index,end:O.index+O[0].length}]:he?C(se,oe):I(se,oe)}e.matchesFuzzy=g;function d(se,oe){const he=ue(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return he?z(he):null}e.matchesFuzzy2=d;function T(se,oe,he,Ie,O,V){const K=Math.min(13,se.length);for(;he<K;he++){const G=ue(se,oe,he,Ie,O,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,V]}e.anyScore=T;function z(se){if(typeof se>"u")return[];const oe=[],he=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const O=se[Ie]+he,V=oe[oe.length-1];V&&V.end===O?V.end=O+1:oe.push({start:O,end:O+1})}return oe}e.createMatches=z;const H=128;function x(){const se=[],oe=[];for(let he=0;he<=H;he++)oe[he]=0;for(let he=0;he<=H;he++)se.push(oe.slice(0));return se}function $(se){const oe=[];for(let he=0;he<=se;he++)oe[he]=0;return oe}const N=$(2*H),M=$(2*H),te=x(),Q=x(),Se=x(),_e=!1;function Pe(se,oe,he,Ie,O){function V(G,q,Z=" "){for(;G.length<q;)G=Z+G;return G}let K=` |   |${Ie.split("").map(G=>V(G,3)).join("|")}
`;for(let G=0;G<=he;G++)G===0?K+=" |":K+=`${oe[G-1]}|`,K+=se[G].slice(0,O+1).map(q=>V(q.toString(),3)).join("|")+`
`;return K}function Y(se,oe,he,Ie){se=se.substr(oe),he=he.substr(Ie),console.log(Pe(Q,se,se.length,he,he.length)),console.log(Pe(Se,se,se.length,he,he.length)),console.log(Pe(te,se,se.length,he,he.length))}function ae(se,oe){if(oe<0||oe>=se.length)return!1;const he=se.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(he)}}function Ce(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function le(se,oe,he){return oe[se]!==he[se]}function pe(se,oe,he,Ie,O,V,K=!1){for(;oe<he&&O<V;)se[oe]===Ie[O]&&(K&&(N[oe]=O),oe+=1),O+=1;return oe===he}e.isPatternInWord=pe;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var U;(function(se){se.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}se.isDefault=oe})(U||(e.FuzzyScore=U={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,he){this.firstMatchCanBeWeak=oe,this.boostFullMatch=he}}e.FuzzyScoreOptions=W;function ue(se,oe,he,Ie,O,V,K=W.default){const G=se.length>H?H:se.length,q=Ie.length>H?H:Ie.length;if(he>=G||V>=q||G-he>q-V||!pe(oe,he,G,O,V,q,!0))return;we(G,q,he,V,oe,O);let Z=1,ce=1,Le=he,xe=V;const Ge=[!1];for(Z=1,Le=he;Le<G;Z++,Le++){const it=N[Le],tt=M[Le],Ue=Le+1<G?M[Le+1]:q;for(ce=it-V+1,xe=it;xe<Ue;ce++,xe++){let st=Number.MIN_SAFE_INTEGER,J=!1;xe<=tt&&(st=Ee(se,oe,Le,he,Ie,O,xe,q,V,te[Z-1][ce-1]===0,Ge));let X=0;st!==Number.MAX_SAFE_INTEGER&&(J=!0,X=st+Q[Z-1][ce-1]);const ve=xe>it,Be=ve?Q[Z][ce-1]+(te[Z][ce-1]>0?-5:0):0,Ne=xe>it+1&&te[Z][ce-1]>0,Xe=Ne?Q[Z][ce-2]+(te[Z][ce-2]>0?-5:0):0;if(Ne&&(!ve||Xe>=Be)&&(!J||Xe>=X))Q[Z][ce]=Xe,Se[Z][ce]=3,te[Z][ce]=0;else if(ve&&(!J||Be>=X))Q[Z][ce]=Be,Se[Z][ce]=2,te[Z][ce]=0;else if(J)Q[Z][ce]=X,Se[Z][ce]=1,te[Z][ce]=te[Z-1][ce-1]+1;else throw new Error("not possible")}}if(_e&&Y(se,he,Ie,V),!Ge[0]&&!K.firstMatchCanBeWeak)return;Z--,ce--;const je=[Q[Z][ce],V];let Je=0,Ye=0;for(;Z>=1;){let it=ce;do{const tt=Se[Z][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);Je>1&&oe[he+Z-1]===O[V+ce-1]&&!le(it+V-1,Ie,O)&&Je+1>te[Z][it]&&(it=ce),it===ce?Je++:Je=1,Ye||(Ye=it),Z--,ce=it-1,je.push(ce)}q===G&&K.boostFullMatch&&(je[0]+=2);const Ze=Ye-G;return je[0]-=Ze,je}e.fuzzyScore=ue;function we(se,oe,he,Ie,O,V){let K=se-1,G=oe-1;for(;K>=he&&G>=Ie;)O[K]===V[G]&&(M[K]=G,K--),G--}function Ee(se,oe,he,Ie,O,V,K,G,q,Z,ce){if(oe[he]!==V[K])return Number.MIN_SAFE_INTEGER;let Le=1,xe=!1;return K===he-Ie?Le=se[he]===O[K]?7:5:le(K,O,V)&&(K===0||!le(K-1,O,V))?(Le=se[he]===O[K]?7:5,xe=!0):ae(V,K)&&(K===0||!ae(V,K-1))?Le=5:(ae(V,K-1)||Ce(V,K-1))&&(Le=5,xe=!0),Le>1&&he===Ie&&(ce[0]=!0),xe||(xe=le(K,O,V)||ae(V,K-1)||Ce(V,K-1)),he===Ie?K>q&&(Le-=xe?3:5):Z?Le+=xe?2:0:Le+=xe?0:1,K+1===G&&(Le-=xe?3:5),Le}function ge(se,oe,he,Ie,O,V,K){return re(se,oe,he,Ie,O,V,!0,K)}e.fuzzyScoreGracefulAggressive=ge;function ye(se,oe,he,Ie,O,V,K){return re(se,oe,he,Ie,O,V,!1,K)}e.fuzzyScoreGraceful=ye;function re(se,oe,he,Ie,O,V,K,G){let q=ue(se,oe,he,Ie,O,V,G);if(q&&!K)return q;if(se.length>=3){const Z=Math.min(7,se.length-1);for(let ce=he+1;ce<Z;ce++){const Le=de(se,ce);if(Le){const xe=ue(Le,Le.toLowerCase(),he,Ie,O,V,G);xe&&(xe[0]-=3,(!q||xe[0]>q[0])&&(q=xe))}}}return q}function de(se,oe){if(oe+1>=se.length)return;const he=se[oe],Ie=se[oe+1];if(he!==Ie)return se.slice(0,oe)+Ie+he+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const L="error",A="warning",u="warn",y="info",m="ignore";function P(a){return a?w.equalsIgnoreCase(L,a)?k.Error:w.equalsIgnoreCase(A,a)||w.equalsIgnoreCase(u,a)?k.Warning:w.equalsIgnoreCase(y,a)?k.Info:k.Ignore:k.Ignore}k.fromValue=P;function D(a){switch(a){case k.Error:return L;case k.Warning:return A;case k.Info:return y;default:return m}}k.toString=D}(R||(R={})),e.default=R}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,15]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(v){return this._value=v,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(v){const p=v.charCodeAt(0),f=this._value.charCodeAt(this._pos);return p-f}value(){return this._value[this._pos]}}e.StringIterator=k;class L{constructor(v=!0){this._caseSensitive=v}reset(v){return this._value=v,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let v=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(v)this._from++;else break;else v=!1;return this}cmp(v){return this._caseSensitive?(0,R.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class A{constructor(v=!0,p=!0){this._splitOnBackslash=v,this._caseSensitive=p}reset(v){this._from=0,this._to=0,this._value=v,this._valueLen=v.length;for(let p=v.length-1;p>=0;p--,this._valueLen--){const f=this._value.charCodeAt(p);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let v=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(v)this._from++;else break;else v=!1}return this}cmp(v){return this._caseSensitive?(0,R.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var u;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(u||(u={}));class y{constructor(v,p){this._ignorePathCasing=v,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(v){return this._value=v,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(v)),this._pathIterator.reset(v.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(v)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(v){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(v,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(v,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(v);if(this._states[this._stateIdx]===4)return(0,R.compare)(v,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(v,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class D{static forUris(v=()=>!1,p=()=>!1){return new D(new y(v,p))}static forPaths(v=!1){return new D(new A(void 0,!v))}static forStrings(){return new D(new k)}static forConfigKeys(){return new D(new L)}constructor(v){this._iter=v}clear(){this._root=void 0}fill(v,p){if(p){const f=p.slice(0);(0,w.shuffle)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,w.shuffle)(f);for(const t of f)this.set(t[0],t[1])}}set(v,p){const f=this._iter.reset(v);let t;this._root||(this._root=new m,this._root.segment=f.value());const i=[];for(t=this._root;;){const b=f.cmp(t.segment);if(b>0)t.left||(t.left=new m,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new m,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new m,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=p,t.key=v;for(let b=i.length-1;b>=0;b--){const _=i[b][1];_.updateHeight();const E=_.balanceFactor();if(E<-1||E>1){const r=i[b][0],s=i[b+1][0];if(r===1&&s===1)i[b][1]=_.rotateLeft();else if(r===-1&&s===-1)i[b][1]=_.rotateRight();else if(r===1&&s===-1)_.right=i[b+1][1]=i[b+1][1].rotateRight(),i[b][1]=_.rotateLeft();else if(r===-1&&s===1)_.left=i[b+1][1]=i[b+1][1].rotateLeft(),i[b][1]=_.rotateRight();else throw new Error;if(b>0)switch(i[b-1][0]){case-1:i[b-1][1].left=i[b][1];break;case 1:i[b-1][1].right=i[b][1];break;case 0:i[b-1][1].mid=i[b][1];break}else this._root=i[0][1]}}return c}get(v){return this._getNode(v)?.value}_getNode(v){const p=this._iter.reset(v);let f=this._root;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(v){const p=this._getNode(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this._delete(v,!1)}deleteSuperstr(v){return this._delete(v,!0)}_delete(v,p){const f=this._iter.reset(v),t=[];let i=this._root;for(;i;){const c=f.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this._min(i.right);if(c.key){const{key:b,value:_,segment:E}=c;this._delete(c.key,!1),i.key=b,i.value=_,i.segment=E}}else{const c=i.left??i.right;if(t.length>0){const[b,_]=t[t.length-1];switch(b){case-1:_.left=c;break;case 0:_.mid=c;break;case 1:_.right=c;break}}else this._root=c}for(let c=t.length-1;c>=0;c--){const b=t[c][1];b.updateHeight();const _=b.balanceFactor();if(_>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[c][1]=b.rotateLeft()):_<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[c][1]=b.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this._root=t[0][1]}}}_min(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this._iter.reset(v);let f=this._root,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this._findSuperstrOrElement(v,!1)}_findSuperstrOrElement(v,p){const f=this._iter.reset(v);let t=this._root;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this._entries(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this._findSuperstrOrElement(v,!0)!==void 0}forEach(v){for(const[p,f]of this)v(f,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(v){const p=[];return this._dfsEntries(v,p),p[Symbol.iterator]()}_dfsEntries(v,p){v&&(v.left&&this._dfsEntries(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this._dfsEntries(v.mid,p),v.right&&this._dfsEntries(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:v(p.left)&&v(p.right)};return v(this._root)}}e.TernarySearchTree=D}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(A){function u(y){return y&&typeof y=="object"&&typeof y.id=="string"}A.isThemeColor=u})(R||(e.ThemeColor=R={}));function k(A){return{id:A}}e.themeColorFromId=k;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const u=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function y(c){const b=u.exec(c.id);if(!b)return y(w.Codicon.error);const[,_,E]=b,r=["codicon","codicon-"+_];return E&&r.push("codicon-modifier-"+E.substring(1)),r}A.asClassNameArray=y;function m(c){return y(c).join(" ")}A.asClassName=m;function P(c){return"."+y(c).join(".")}A.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||R.isThemeColor(c.color))}A.isThemeIcon=D;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function v(c){const b=a.exec(c);if(!b)return;const[,_]=b;return{id:_}}A.fromString=v;function p(c){return{id:c}}A.fromId=p;function f(c,b){let _=c.id;const E=_.lastIndexOf("~");return E!==-1&&(_=_.substring(0,E)),b&&(_=`${_}~${b}`),{id:_}}A.modify=f;function t(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}A.getModifier=t;function i(c,b){return c.id===b.id&&c.color?.id===b.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Ae[121],Re([1,0,119,15,40]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",A=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),u=new RegExp(`(\\\\)?${A.source}`,"g");function y(i){return i.replace(u,(c,b)=>b?c:`\\${c}`)}e.escapeIcons=y;const m=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(m,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(i){return i.indexOf(L)===-1?i:i.replace(D,(c,b,_,E)=>_?c:b||E||"")}e.stripIcons=a;function v(i){return i?i.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=v;const p=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let c="";const b=[];let _=0;for(;;){const E=p.lastIndex,r=p.exec(i),s=i.substring(E,r?.index);if(s.length>0){c+=s;for(let n=0;n<s.length;n++)b.push(_)}if(!r)break;_+=r[0].length}return{text:c,iconOffsets:b}}e.parseLabelWithIcons=f;function t(i,c,b=!1){const{text:_,iconOffsets:E}=c;if(!E||E.length===0)return(0,w.matchesFuzzy)(i,_,b);const r=(0,R.ltrim)(_," "),s=_.length-r.length,n=(0,w.matchesFuzzy)(i,r,b);if(n)for(const o of n){const S=E[o.start+s]+s;o.start+=S,o.end+=S}return n}e.matchesFuzzyIconAware=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return w.test(k)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(u){for(let y=0;y<u.length;y++)u[y]=Math.floor(Math.random()*256);return u};const L=new Uint8Array(16),A=[];for(let u=0;u<256;u++)A.push(u.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,m="";return m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m+="-",m+=A[L[y++]],m+=A[L[y++]],m+="-",m+=A[L[y++]],m+=A[L[y++]],m+="-",m+=A[L[y++]],m+=A[L[y++]],m+="-",m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m+=A[L[y++]],m}}()}),define(Ae[122],Re([1,0,18,65,36]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=L;function A(D,a,v){const p={id:(0,k.generateUuid)(),name:D,uri:a,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.createFileDataTransferItem=A;class u{constructor(){this._entries=new Map}get size(){let a=0;for(const v of this._entries)a++;return a}has(a){return this._entries.has(this.toKey(a))}matches(a){const v=[...this._entries.keys()];return R.Iterable.some(this,([p,f])=>f.asFile())&&v.push("files"),P(y(a),v)}get(a){return this._entries.get(this.toKey(a))?.[0]}append(a,v){const p=this._entries.get(a);p?p.push(v):this._entries.set(this.toKey(a),[v])}replace(a,v){this._entries.set(this.toKey(a),[v])}delete(a){this._entries.delete(this.toKey(a))}*[Symbol.iterator](){for(const[a,v]of this._entries)for(const p of v)yield[a,p]}toKey(a){return y(a)}}e.VSDataTransfer=u;function y(D){return D.toLowerCase()}function m(D,a){return P(y(D),a.map(y))}e.matchesMimeType=m;function P(D,a){if(D==="*/*")return a.length>0;if(a.includes(D))return!0;const v=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,f,t]=v;return t==="*"?a.some(i=>i.startsWith(f+"/")):!1}e.UriList=Object.freeze({create:D=>(0,w.distinct)(D.map(a=>a.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class R{constructor(u){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=u.open,this.close=u.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(u.notIn))for(let y=0,m=u.notIn.length;y<m;y++)switch(u.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(u){switch(u){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(u,y){if(u.getTokenCount()===0)return!0;const m=u.findTokenIndexAtOffset(y-2),P=u.getStandardTokenType(m);return this.isOK(P)}_findNeutralCharacterInRange(u,y){for(let m=u;m<=y;m++){const P=String.fromCharCode(m);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=R;class k{constructor(u){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of u)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function L(A,u,y){A.has(u)?A.get(u).push(y):A.set(u,[y])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class w{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(L){if(L&&this._dragOperations.has(L)){const A=this._dragOperations.get(L);return this._dragOperations.delete(L),A}}addDragOperationTransfer(L,A){this._dragOperations.set(L,A)}}e.TreeViewsDnDService=w;class R{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=R}),define(Ae[126],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends R.Disposable{constructor(a,v="",p="",f=!0,t){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=v,this._cssClass=p,this._enabled=f,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,v){this._actionCallback&&await this._actionCallback(a)}}e.Action=L;class A extends R.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event}async run(a,v){if(!a.enabled)return;this._onWillRun.fire({action:a});let p;try{await this.runAction(a,v)}catch(f){p=f}this._onDidRun.fire({action:a,error:p})}async runAction(a,v){await a.run(v)}}e.ActionRunner=A;class u{constructor(){this.id=u.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let v=[];for(const p of a)p.length&&(v.length?v=[...v,new u,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=u;class y{get actions(){return this._actions}constructor(a,v,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=v,this.class=f,this._actions=p}async run(){}}e.SubmenuAction=y;class m extends L{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,k.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...a)=>D.run(...a),tooltip:D.label}}e.toAction=P}),define(Ae[128],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,L=k*24,A=L*7,u=L*30,y=L*365;function m(D,a,v,p){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,w.localize)(0,null,m(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,w.localize)(1,null);let t;return f<R?(t=f,a?t===1?v?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):v?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?v?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):v?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<k?(t=Math.floor(f/R),a?t===1?v?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):v?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?v?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):v?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<L?(t=Math.floor(f/k),a?t===1?v?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):v?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?v?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):v?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<A?(t=Math.floor(f/L),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<u?(t=Math.floor(f/A),a?t===1?v?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):v?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?v?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):v?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<y?(t=Math.floor(f/u),a?t===1?v?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):v?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?v?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):v?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/y),a?t===1?v?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):v?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?v?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):v?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.fromNow=m;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Ae[130],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,130]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,a){return a&&(D.stack||D.stacktrace)?k.localize(0,null,u(D),A(D.stack)||A(D.stacktrace)):u(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function u(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?k.localize(1,null,D.message):D.message||k.localize(2,null)}function y(D=null,a=!1){if(!D)return k.localize(3,null);if(Array.isArray(D)){const v=w.coalesce(D),p=y(v[0],a);return v.length>1?k.localize(4,null,p,v.length):p}if(R.isString(D))return D;if(D.detail){const v=D.detail;if(v.error)return L(v.error,a);if(v.exception)return L(v.exception,a)}return D.stack?L(D,a):D.message?D.message:k.localize(5,null)}e.toErrorMessage=y;function m(D){const a=D;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=m;function P(D,a){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=a,v}e.createErrorWithActions=P}),define(Ae[131],Re([1,0,48,19]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new w.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function u(C,l,g=!1){const d=C||"",T=l||"",z=k.value.collator.compare(d,T);return k.value.collatorIsNumeric&&z===0&&d!==T?d<T?-1:1:z}e.compareFileNames=u;function y(C,l){const g=L.value.collator;return C=C||"",l=l||"",_(g,C,l)}e.compareFileNamesDefault=y;function m(C,l){const g=L.value.collator;return C=C||"",l=l||"",n(C,l)||_(g,C,l)}e.compareFileNamesUpper=m;function P(C,l){const g=L.value.collator;return C=C||"",l=l||"",s(C,l)||_(g,C,l)}e.compareFileNamesLower=P;function D(C,l){return C=C||"",l=l||"",C===l?0:C<l?-1:1}e.compareFileNamesUnicode=D;function a(C,l){const[g,d]=c(C),[T,z]=c(l);let H=k.value.collator.compare(d,z);if(H===0){if(k.value.collatorIsNumeric&&d!==z)return d<z?-1:1;if(H=k.value.collator.compare(g,T),k.value.collatorIsNumeric&&H===0&&g!==T)return g<T?-1:1}return H}e.compareFileExtensions=a;function v(C,l){C=C||"",l=l||"";const g=b(C),d=b(l),T=L.value.collator,z=A.value.collator;return _(z,g,d)||_(T,C,l)}e.compareFileExtensionsDefault=v;function p(C,l){C=C||"",l=l||"";const g=b(C),d=b(l),T=L.value.collator,z=A.value.collator;return _(z,g,d)||n(C,l)||_(T,C,l)}e.compareFileExtensionsUpper=p;function f(C,l){C=C||"",l=l||"";const g=b(C),d=b(l),T=L.value.collator,z=A.value.collator;return _(z,g,d)||s(C,l)||_(T,C,l)}e.compareFileExtensionsLower=f;function t(C,l){C=C||"",l=l||"";const g=b(C).toLowerCase(),d=b(l).toLowerCase();return g!==d?g<d?-1:1:C!==l?C<l?-1:1:0}e.compareFileExtensionsUnicode=t;const i=/^(.*?)(\.([^.]*))?$/;function c(C,l=!1){const g=C?i.exec(C):[];let d=[g&&g[1]||"",g&&g[3]||""];return l&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function b(C){const l=C?i.exec(C):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function _(C,l,g){const d=C.compare(l,g);return d!==0?d:l.length!==g.length?l.length<g.length?-1:1:0}function E(C){const l=C.charAt(0);return l.toLocaleUpperCase()!==l}function r(C){const l=C.charAt(0);return l.toLocaleLowerCase()!==l}function s(C,l){return E(C)&&r(l)?-1:r(C)&&E(l)?1:0}function n(C,l){return r(C)&&E(l)?-1:E(C)&&r(l)?1:0}function o(C,l,g=!1){return g||(C=C&&C.toLowerCase(),l=l&&l.toLowerCase()),C===l?0:C<l?-1:1}function S(C,l,g=!1){const d=C.split(R.sep),T=l.split(R.sep),z=d.length-1,H=T.length-1;let x,$;for(let N=0;;N++){if(x=z===N,$=H===N,x&&$)return u(d[N],T[N],g);if(x)return-1;if($)return 1;const M=o(d[N],T[N],g);if(M!==0)return M}}e.comparePaths=S;function h(C,l,g){const d=C.toLowerCase(),T=l.toLowerCase(),z=I(C,l,g);if(z)return z;const H=d.endsWith(g),x=T.endsWith(g);if(H!==x)return H?-1:1;const $=u(d,T);return $!==0?$:d.localeCompare(T)}e.compareAnything=h;function I(C,l,g){const d=C.toLowerCase(),T=l.toLowerCase(),z=d.startsWith(g),H=T.startsWith(g);if(z!==H)return z?-1:1;if(z&&H){if(d.length<T.length)return-1;if(d.length>T.length)return 1}return 0}e.compareByPrefix=I}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(h){return h===47||h===92}e.isPathSeparator=A;function u(h){return h.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=u;function y(h){return h.indexOf("/")===-1&&(h=u(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=y;function m(h,I=w.posix.sep){if(!h)return"";const C=h.length,l=h.charCodeAt(0);if(A(l)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let d=3;const T=d;for(;d<C&&!A(h.charCodeAt(d));d++);if(T!==d&&!A(h.charCodeAt(d+1))){for(d+=1;d<C;d++)if(A(h.charCodeAt(d)))return h.slice(0,d+1).replace(/[\\/]/g,I)}}return I}else if(i(l)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+I:h.slice(0,2);let g=h.indexOf("://");if(g!==-1){for(g+=3;g<C;g++)if(A(h.charCodeAt(g)))return h.slice(0,g+1)}return""}e.getRoot=m;function P(h){if(!R.isWindows||!h||h.length<5)return!1;let I=h.charCodeAt(0);if(I!==92||(I=h.charCodeAt(1),I!==92))return!1;let C=2;const l=C;for(;C<h.length&&(I=h.charCodeAt(C),I!==92);C++);return!(l===C||(I=h.charCodeAt(C+1),isNaN(I)||I===92))}e.isUNC=P;const D=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(h,I=R.isWindows){const C=I?D:a;return!(!h||h.length===0||/^\s+$/.test(h)||(C.lastIndex=0,C.test(h))||I&&v.test(h)||h==="."||h===".."||I&&h[h.length-1]==="."||I&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=p;function f(h,I,C){const l=h===I;return!C||l?l:!h||!I?!1:(0,k.equalsIgnoreCase)(h,I)}e.isEqual=f;function t(h,I,C,l=w.sep){if(h===I)return!0;if(!h||!I||I.length>h.length)return!1;if(C){if(!(0,k.startsWithIgnoreCase)(h,I))return!1;if(I.length===h.length)return!0;let d=I.length;return I.charAt(I.length-1)===l&&d--,h.charAt(d)===l}return I.charAt(I.length-1)!==l&&(I+=l),h.indexOf(I)===0}e.isEqualOrParent=t;function i(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=i;function c(h,I){return R.isWindows&&h.endsWith(":")&&(h+=w.sep),(0,w.isAbsolute)(h)||(h=(0,w.join)(I,h)),h=(0,w.normalize)(h),R.isWindows?(h=(0,k.rtrim)(h,w.sep),h.endsWith(":")&&(h+=w.sep)):(h=(0,k.rtrim)(h,w.sep),h||(h=w.sep)),h}e.sanitizeFilePath=c;function b(h){const I=(0,w.normalize)(h);return R.isWindows?h.length>3?!1:_(I)&&(h.length===2||I.charCodeAt(2)===92):I===w.posix.sep}e.isRootOrDriveLetter=b;function _(h,I=R.isWindows){return I?i(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=_;function E(h,I=R.isWindows){return _(h,I)?h[0]:void 0}e.getDriveLetter=E;function r(h,I,C){return I.length>h.length?-1:h===I?0:(C&&(h=h.toLowerCase(),I=I.toLowerCase()),h.indexOf(I))}e.indexOfPath=r;function s(h){const I=h.split(":");let C,l,g;for(const d of I){const T=Number(d);(0,L.isNumber)(T)?l===void 0?l=T:g===void 0&&(g=T):C=C?[C,d].join(":"):d}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:l!==void 0?l:void 0,column:g!==void 0?g:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(h,I,C=8){let l="";for(let d=0;d<C;d++){let T;d===0&&R.isWindows&&!I&&(C===3||C===4)?T=o:T=n,l+=T.charAt(Math.floor(Math.random()*T.length))}let g;return I?g=`${I}-${l}`:g=l,h?(0,w.join)(h,g):g}e.randomPath=S}),define(Ae[66],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const D=(0,w.extname)(P),a=R[D.toLowerCase()];return a!==void 0?a:A(P)}e.getMediaOrTextMime=L;function A(P){const D=(0,w.extname)(P);return k[D.toLowerCase()]}e.getMediaMime=A;function u(P){for(const D in k)if(k[D]===P)return D}e.getExtensionForMimeType=u;const y=/^(.+)\/(.+?)(;.+)?$/;function m(P,D){const a=y.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:D?void 0:P}e.normalizeMimeType=m}),define(Ae[67],Re([1,0,25,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,A)}e.stringify=k;function L(y){let m=JSON.parse(y);return m=u(m),m}e.parse=L;function A(y,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function u(y,m=0){if(!y||m>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return R.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof w.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=u(y[P],m+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=u(y[P],m+1))}return y}e.revive=u}),define(Ae[13],Re([1,0,9,22,2]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${L.vscodeRemoteResource}`}set(P,D,a){this._hosts[P]=D,this._ports[P]=a}setConnectionToken(P,D){this._connectionTokens[P]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(t){return w.onUnexpectedError(t),P}const D=P.authority;let a=this._hosts[D];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const v=this._ports[D],p=this._connectionTokens[D];let f=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),k.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${a}:${v}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class u{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(P){const D=this.toUri(P,be);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${L.vscodeFileResource}://${u.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||u.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const D=this.toUri(P,be);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==u.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,D){return k.URI.isUri(P)?P:k.URI.parse(D.toUrl(P))}}e.FileAccess=new u;var y;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function a(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:k.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(D);if(t)return P.get(t)}m.getHeadersFromQuery=a;function v(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,i):p[D]=i}m.addSearchParam=v})(y||(e.COI=y={}))}),define(Ae[23],Re([1,0,42,13,19,22,15,2]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(v){return(0,u.uriToFsPath)(v,!0)}e.originalFSPath=y;class m{constructor(p){this._ignorePathCasing=p}compare(p,f,t=!1){return p===f?0:(0,A.compare)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===R.Schemas.file)return w.isEqualOrParent(y(p),y(f),this._ignorePathCasing(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.isEqualAuthority)(p.authority,f.authority))return w.isEqualOrParent(p.path,f.path,this._ignorePathCasing(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return u.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return k.posix.basename(p.path)}extname(p){return k.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===R.Schemas.file?f=u.URI.file(k.dirname(y(p))).path:(f=k.posix.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===R.Schemas.file?f=u.URI.file(k.normalize(y(p))).path:f=k.posix.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.isEqualAuthority)(p.authority,f.authority))return;if(p.scheme===R.Schemas.file){const c=k.relative(y(p),y(f));return L.isWindows?w.toSlashes(c):c}let t=p.path||"/";const i=f.path||"/";if(this._ignorePathCasing(p)){let c=0;for(const b=Math.min(t.length,i.length);c<b&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return k.posix.relative(t,i)}resolvePath(p,f){if(p.scheme===R.Schemas.file){const t=u.URI.file(k.resolve(y(p),f));return p.with({authority:t.authority,path:t.path})}return f=w.toPosixPath(f),p.with({path:k.posix.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,A.equalsIgnoreCase)(p,f)}hasTrailingPathSeparator(p,f=k.sep){if(p.scheme===R.Schemas.file){const t=y(p);return t.length>w.getRoot(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=k.sep){return(0,e.hasTrailingPathSeparator)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=k.sep){let t=!1;if(p.scheme===R.Schemas.file){const i=y(p);t=i!==void 0&&i.length===w.getRoot(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,f)?p.with({path:p.path+"/"}):p}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(v=>v.scheme===R.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new m(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(v,p){const f=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((c,b)=>b===t?!1:(0,e.isEqualOrParent)(i,p(c)))||f.push(v[t])}return f}e.distinctParents=P;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[_,E]=b.split(":");_&&E&&t.set(_,E)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(v.META_DATA_MIME,c),t}v.parseMetaData=p})(D||(e.DataUri=D={}));function a(v,p,f){if(p){let t=v.path;return t&&t[0]!==k.posix.sep&&(t=k.posix.sep+t),v.with({scheme:f,authority:p,path:t})}return v.with({scheme:f})}e.toLocalResource=a}),define(Ae[12],Re([1,0,21,9,5,6,23,22,120]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(U){return!!U&&typeof U.then=="function"}e.isThenable=m;function P(U){const W=new w.CancellationTokenSource,ue=U(W.token),we=new Promise((Ee,ge)=>{const ye=W.token.onCancellationRequested(()=>{ye.dispose(),W.dispose(),ge(new R.CancellationError)});Promise.resolve(ue).then(re=>{ye.dispose(),W.dispose(),Ee(re)},re=>{ye.dispose(),W.dispose(),ge(re)})});return new class{cancel(){W.cancel()}then(Ee,ge){return we.then(Ee,ge)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return we.finally(Ee)}}}e.createCancelablePromise=P;function D(U,W,ue){return new Promise((we,Ee)=>{const ge=W.onCancellationRequested(()=>{ge.dispose(),we(ue)});U.then(we,Ee).finally(()=>ge.dispose())})}e.raceCancellation=D;function a(U,W){return new Promise((ue,we)=>{const Ee=W.onCancellationRequested(()=>{Ee.dispose(),we(new R.CancellationError)});U.then(ue,we).finally(()=>Ee.dispose())})}e.raceCancellationError=a;async function v(U){let W=-1;const ue=U.map((we,Ee)=>we.then(ge=>(W=Ee,ge)));try{return await Promise.race(ue)}finally{U.forEach((we,Ee)=>{Ee!==W&&we.cancel()})}}e.raceCancellablePromises=v;function p(U,W,ue){let we;const Ee=setTimeout(()=>{we?.(void 0),ue?.()},W);return Promise.race([U.finally(()=>clearTimeout(Ee)),new Promise(ge=>we=ge)])}e.raceTimeout=p;function f(U){return new Promise((W,ue)=>{const we=U();m(we)?we.then(W,ue):W(we)})}e.asPromise=f;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ue=()=>{if(this.queuedPromise=null,this.isDisposed)return;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ue,ue).then(we)})}return new Promise((ue,we)=>{this.queuedPromise.then(ue,we)})}return this.activePromise=W(),new Promise((ue,we)=>{this.activePromise.then(Ee=>{this.activePromise=null,ue(Ee)},Ee=>{this.activePromise=null,we(Ee)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class i{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=i;class c{constructor(){this.promiseMap=new Map}queue(W,ue){const Ee=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.promiseMap.get(W)===Ee&&this.promiseMap.delete(W)});return this.promiseMap.set(W,Ee),Ee}}e.SequencerByKey=c;const b=(U,W)=>{let ue=!0;const we=setTimeout(()=>{ue=!1,W()},U);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(we),ue=!1}}},_=U=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,U())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class E{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ue=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ee,ge)=>{this.doResolve=Ee,this.doReject=ge}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ee=this.task;return this.task=null,Ee()}}));const we=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ue===y.MicrotaskDelay?_(we):b(ue,we),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class r{constructor(W){this.delayer=new E(W),this.throttler=new t}trigger(W,ue){return this.delayer.trigger(()=>this.throttler.queue(W),ue)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class s{constructor(){this._isOpen=!1,this._promise=new Promise((W,ue)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class n extends s{constructor(W){super(),this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function o(U,W){return W?new Promise((ue,we)=>{const Ee=setTimeout(()=>{ge.dispose(),ue()},U),ge=W.onCancellationRequested(()=>{clearTimeout(Ee),ge.dispose(),we(new R.CancellationError)})}):P(ue=>o(U,ue))}e.timeout=o;function S(U,W=0,ue){const we=setTimeout(()=>{U(),ue&&Ee.dispose()},W),Ee=(0,L.toDisposable)(()=>{clearTimeout(we),ue?.deleteAndLeak(Ee)});return ue?.add(Ee),Ee}e.disposableTimeout=S;function h(U){const W=[];let ue=0;const we=U.length;function Ee(){return ue<we?U[ue++]():null}function ge(ye){ye!=null&&W.push(ye);const re=Ee();return re?re.then(ge):Promise.resolve(W)}return Promise.resolve(null).then(ge)}e.sequence=h;function I(U,W=we=>!!we,ue=null){let we=0;const Ee=U.length,ge=()=>{if(we>=Ee)return Promise.resolve(ue);const ye=U[we++];return Promise.resolve(ye()).then(de=>W(de)?Promise.resolve(de):ge())};return ge()}e.first=I;function C(U,W=we=>!!we,ue=null){if(U.length===0)return Promise.resolve(ue);let we=U.length;const Ee=()=>{we=-1;for(const ge of U)ge.cancel?.()};return new Promise((ge,ye)=>{for(const re of U)re.then(de=>{--we>=0&&W(de)?(Ee(),ge(de)):we===0&&ge(ue)}).catch(de=>{--we>=0&&(Ee(),ye(de))})})}e.firstParallel=C;class l{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((ue,we)=>{this.outstandingPromises.push({factory:W,c:ue,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ue=W.factory();ue.then(W.c,W.e),ue.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class g extends l{constructor(){super(1)}}e.Queue=g;class d{constructor(){this.sequentializer=new Se,this.tasks=0}queue(W){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,W())):this.sequentializer.run(this.tasks++,W())}}e.LimitedQueue=d;class T{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const W=new Y;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,ue=A.extUri){const we=ue.getComparisonKey(W);let Ee=this.queues.get(we);if(!Ee){Ee=new g;const ge=this.drainListenerCount++,ye=k.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.queues.delete(we),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ge),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(ge,ye),this.queues.set(we,Ee)}return Ee}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=T;class z{constructor(W,ue){this._token=-1,typeof W=="function"&&typeof ue=="number"&&this.setIfNotSet(W,ue)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ue){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ue)}setIfNotSet(W,ue){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ue))}}e.TimeoutTimer=z;class H{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ue){this.cancel(),this._token=setInterval(()=>{W()},ue)}}e.IntervalTimer=H;class x{constructor(W,ue){this.timeoutToken=-1,this.runner=W,this.timeout=ue,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class ${constructor(W,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ue,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class N extends x{constructor(W,ue){super(W,ue),this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner?.(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class M extends L.Disposable{constructor(W,ue){super(),this.options=W,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ue of W)this.pendingWork.push(ue);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,u.setTimeout0)(()=>{if(W)return;const ue=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(U,W)=>{const ue=requestIdleCallback(U,typeof W=="number"?{timeout:W}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ue))}}}}();class te{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ue){this._error=ue}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function Q(U,W,ue){let we;for(let Ee=0;Ee<ue;Ee++)try{return await U()}catch(ge){we=ge,await o(W)}throw we}e.retry=Q;class Se{isRunning(W){return typeof W=="number"?this._running?.taskId===W:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(W,ue,we){return this._running={taskId:W,cancel:()=>we?.(),promise:ue},ue.then(()=>this.doneRunning(W),()=>this.doneRunning(W)),ue}doneRunning(W){this._running&&W===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const W=this._queued;this._queued=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}queue(W){if(this._queued)this._queued.run=W;else{let ue,we;const Ee=new Promise((ge,ye)=>{ue=ge,we=ye});this._queued={run:W,promise:Ee,promiseResolve:ue,promiseReject:we}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Se;class _e{constructor(W,ue=()=>Date.now()){this.interval=W,this.nowFn=ue,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=_e;var Pe;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Pe||(Pe={}));class Y{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((W,ue)=>{this.completeCallback=W,this.errorCallback=ue})}complete(W){return new Promise(ue=>{this.completeCallback(W),this.outcome={outcome:0,value:W},ue()})}error(W){return new Promise(ue=>{this.errorCallback(W),this.outcome={outcome:1,value:W},ue()})}cancel(){return this.error(new R.CancellationError)}}e.DeferredPromise=Y;var ae;(function(U){async function W(we){let Ee;const ge=await Promise.all(we.map(ye=>ye.then(re=>re,re=>{Ee||(Ee=re)})));if(typeof Ee<"u")throw Ee;return ge}U.settled=W;function ue(we){return new Promise(async(Ee,ge)=>{try{await we(Ee,ge)}catch(ye){ge(ye)}})}U.withAsyncBody=ue})(ae||(e.Promises=ae={}));var Ce;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(Ce||(Ce={}));class le{static fromArray(W){return new le(ue=>{ue.emitMany(W)})}static fromPromise(W){return new le(async ue=>{ue.emitMany(await W)})}static fromPromises(W){return new le(async ue=>{await Promise.all(W.map(async we=>ue.emitOne(await we)))})}static merge(W){return new le(async ue=>{await Promise.all(W.map(async we=>{for await(const Ee of we)ue.emitOne(Ee)}))})}static{this.EMPTY=le.fromArray([])}constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const ue={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(W(ue)),this.resolve()}catch(we){this.reject(we)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,ue){return new le(async we=>{for await(const Ee of W)we.emitOne(ue(Ee))})}map(W){return le.map(this,W)}static filter(W,ue){return new le(async we=>{for await(const Ee of W)ue(Ee)&&we.emitOne(Ee)})}filter(W){return le.filter(this,W)}static coalesce(W){return le.filter(W,ue=>!!ue)}coalesce(){return le.coalesce(this)}static async toPromise(W){const ue=[];for await(const we of W)ue.push(we);return ue}toPromise(){return le.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=le;class pe extends le{constructor(W,ue){super(ue),this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function ie(U){const W=new w.CancellationTokenSource,ue=U(W.token);return new pe(W,async we=>{const Ee=W.token.onCancellationRequested(()=>{Ee.dispose(),W.dispose(),we.reject(new R.CancellationError)});try{for await(const ge of ue){if(W.token.isCancellationRequested)return;we.emitOne(ge)}Ee.dispose(),W.dispose()}catch(ge){Ee.dispose(),W.dispose(),we.reject(ge)}})}e.createCancelableAsyncIterable=ie}),define(Ae[37],Re([1,0,18,12,42,28,19,22,15]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",D="[^/\\\\]",a=/\//g;function v(Se,_e){switch(Se){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${_e?`|${P}${D}+`:""})*?`}}function p(Se,_e){if(!Se)return[];const Pe=[];let Y=!1,ae=!1,Ce="";for(const le of Se){switch(le){case _e:if(!Y&&!ae){Pe.push(Ce),Ce="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}Ce+=le}return Ce&&Pe.push(Ce),Pe}e.splitGlobAware=p;function f(Se){if(!Se)return"";let _e="";const Pe=p(Se,e.GLOB_SPLIT);if(Pe.every(Y=>Y===e.GLOBSTAR))_e=".*";else{let Y=!1;Pe.forEach((ae,Ce)=>{if(ae===e.GLOBSTAR){if(Y)return;_e+=v(2,Ce===Pe.length-1)}else{let le=!1,pe="",ie=!1,U="";for(const W of ae){if(W!=="}"&&le){pe+=W;continue}if(ie&&(W!=="]"||!U)){let ue;W==="-"?ue=W:(W==="^"||W==="!")&&!U?ue="^":W===e.GLOB_SPLIT?ue="":ue=(0,y.escapeRegExpCharacters)(W),U+=ue;continue}switch(W){case"{":le=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${p(pe,",").map(Ee=>f(Ee)).join("|")})`;_e+=we,le=!1,pe="";break}case"]":{_e+="["+U+"]",ie=!1,U="";break}case"?":_e+=D;continue;case"*":_e+=v(1);continue;default:_e+=(0,y.escapeRegExpCharacters)(W)}}Ce<Pe.length-1&&(Pe[Ce+1]!==e.GLOBSTAR||Ce+2<Pe.length)&&(_e+=P)}Y=ae===e.GLOBSTAR})}return _e}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,_=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),s=function(){return!1},n=function(){return null};function o(Se,_e){if(!Se)return n;let Pe;typeof Se!="string"?Pe=Se.pattern:Pe=Se,Pe=Pe.trim();const Y=`${Pe}_${!!_e.trimForExclusions}`;let ae=r.get(Y);if(ae)return S(ae,Se);let Ce;return t.test(Pe)?ae=I(Pe.substr(4),Pe):(Ce=i.exec(h(Pe,_e)))?ae=C(Ce[1],Pe):(_e.trimForExclusions?b:c).test(Pe)?ae=l(Pe,_e):(Ce=_.exec(h(Pe,_e)))?ae=g(Ce[1].substr(1),Pe,!0):(Ce=E.exec(h(Pe,_e)))?ae=g(Ce[1],Pe,!1):ae=d(Pe),r.set(Y,ae),S(ae,Se)}function S(Se,_e){if(typeof _e=="string")return Se;const Pe=function(Y,ae){return(0,k.isEqualOrParent)(Y,_e.base,!u.isLinux)?Se((0,y.ltrim)(Y.substr(_e.base.length),A.sep),ae):null};return Pe.allBasenames=Se.allBasenames,Pe.allPaths=Se.allPaths,Pe.basenames=Se.basenames,Pe.patterns=Se.patterns,Pe}function h(Se,_e){return _e.trimForExclusions&&Se.endsWith("/**")?Se.substr(0,Se.length-2):Se}function I(Se,_e){return function(Pe,Y){return typeof Pe=="string"&&Pe.endsWith(Se)?_e:null}}function C(Se,_e){const Pe=`/${Se}`,Y=`\\${Se}`,ae=function(le,pe){return typeof le!="string"?null:pe?pe===Se?_e:null:le===Se||le.endsWith(Pe)||le.endsWith(Y)?_e:null},Ce=[Se];return ae.basenames=Ce,ae.patterns=[_e],ae.allBasenames=Ce,ae}function l(Se,_e){const Pe=te(Se.slice(1,-1).split(",").map(pe=>o(pe,_e)).filter(pe=>pe!==n),Se),Y=Pe.length;if(!Y)return n;if(Y===1)return Pe[0];const ae=function(pe,ie){for(let U=0,W=Pe.length;U<W;U++)if(Pe[U](pe,ie))return Se;return null},Ce=Pe.find(pe=>!!pe.allBasenames);Ce&&(ae.allBasenames=Ce.allBasenames);const le=Pe.reduce((pe,ie)=>ie.allPaths?pe.concat(ie.allPaths):pe,[]);return le.length&&(ae.allPaths=le),ae}function g(Se,_e,Pe){const Y=A.sep===A.posix.sep,ae=Y?Se:Se.replace(a,A.sep),Ce=A.sep+ae,le=A.posix.sep+Se;let pe;return Pe?pe=function(ie,U){return typeof ie=="string"&&(ie===ae||ie.endsWith(Ce)||!Y&&(ie===Se||ie.endsWith(le)))?_e:null}:pe=function(ie,U){return typeof ie=="string"&&(ie===ae||!Y&&ie===Se)?_e:null},pe.allPaths=[(Pe?"*/":"./")+Se],pe}function d(Se){try{const _e=new RegExp(`^${f(Se)}$`);return function(Pe){return _e.lastIndex=0,typeof Pe=="string"&&_e.test(Pe)?Se:null}}catch{return n}}function T(Se,_e,Pe){return!Se||typeof _e!="string"?!1:z(Se)(_e,void 0,Pe)}e.match=T;function z(Se,_e={}){if(!Se)return s;if(typeof Se=="string"||H(Se)){const Pe=o(Se,_e);if(Pe===n)return s;const Y=function(ae,Ce){return!!Pe(ae,Ce)};return Pe.allBasenames&&(Y.allBasenames=Pe.allBasenames),Pe.allPaths&&(Y.allPaths=Pe.allPaths),Y}return N(Se,_e)}e.parse=z;function H(Se){const _e=Se;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}e.isRelativePattern=H;function x(Se){return Se.allBasenames||[]}e.getBasenameTerms=x;function $(Se){return Se.allPaths||[]}e.getPathTerms=$;function N(Se,_e){const Pe=te(Object.getOwnPropertyNames(Se).map(pe=>M(pe,Se[pe],_e)).filter(pe=>pe!==n)),Y=Pe.length;if(!Y)return n;if(!Pe.some(pe=>!!pe.requiresSiblings)){if(Y===1)return Pe[0];const pe=function(W,ue){let we;for(let Ee=0,ge=Pe.length;Ee<ge;Ee++){const ye=Pe[Ee](W,ue);if(typeof ye=="string")return ye;(0,R.isThenable)(ye)&&(we||(we=[]),we.push(ye))}return we?(async()=>{for(const Ee of we){const ge=await Ee;if(typeof ge=="string")return ge}return null})():null},ie=Pe.find(W=>!!W.allBasenames);ie&&(pe.allBasenames=ie.allBasenames);const U=Pe.reduce((W,ue)=>ue.allPaths?W.concat(ue.allPaths):W,[]);return U.length&&(pe.allPaths=U),pe}const ae=function(pe,ie,U){let W,ue;for(let we=0,Ee=Pe.length;we<Ee;we++){const ge=Pe[we];ge.requiresSiblings&&U&&(ie||(ie=(0,A.basename)(pe)),W||(W=ie.substr(0,ie.length-(0,A.extname)(pe).length)));const ye=ge(pe,ie,W,U);if(typeof ye=="string")return ye;(0,R.isThenable)(ye)&&(ue||(ue=[]),ue.push(ye))}return ue?(async()=>{for(const we of ue){const Ee=await we;if(typeof Ee=="string")return Ee}return null})():null},Ce=Pe.find(pe=>!!pe.allBasenames);Ce&&(ae.allBasenames=Ce.allBasenames);const le=Pe.reduce((pe,ie)=>ie.allPaths?pe.concat(ie.allPaths):pe,[]);return le.length&&(ae.allPaths=le),ae}function M(Se,_e,Pe){if(_e===!1)return n;const Y=o(Se,Pe);if(Y===n)return n;if(typeof _e=="boolean")return Y;if(_e){const ae=_e.when;if(typeof ae=="string"){const Ce=(le,pe,ie,U)=>{if(!U||!Y(le,pe))return null;const W=ae.replace("$(basename)",()=>ie),ue=U(W);return(0,R.isThenable)(ue)?ue.then(we=>we?Se:null):ue?Se:null};return Ce.requiresSiblings=!0,Ce}}return Y}function te(Se,_e){const Pe=Se.filter(pe=>!!pe.basenames);if(Pe.length<2)return Se;const Y=Pe.reduce((pe,ie)=>{const U=ie.basenames;return U?pe.concat(U):pe},[]);let ae;if(_e){ae=[];for(let pe=0,ie=Y.length;pe<ie;pe++)ae.push(_e)}else ae=Pe.reduce((pe,ie)=>{const U=ie.patterns;return U?pe.concat(U):pe},[]);const Ce=function(pe,ie){if(typeof pe!="string")return null;if(!ie){let W;for(W=pe.length;W>0;W--){const ue=pe.charCodeAt(W-1);if(ue===47||ue===92)break}ie=pe.substr(W)}const U=Y.indexOf(ie);return U!==-1?ae[U]:null};Ce.basenames=Y,Ce.patterns=ae,Ce.allBasenames=Y;const le=Se.filter(pe=>!pe.basenames);return le.push(Ce),le}function Q(Se,_e){return(0,w.equals)(Se,_e,(Pe,Y)=>typeof Pe=="string"&&typeof Y=="string"?Pe===Y:typeof Pe!="string"&&typeof Y!="string"?Pe.base===Y.base&&Pe.pattern===Y.pattern:!1)}e.patternsEquals=Q}),define(Ae[50],Re([1,0,9,121,23,15,2]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var u;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(u||(e.MarkdownStringTextNewlineStyle=u={}));class y{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=a(this.supportThemeIcons?(0,R.escapeIcons)(i):i).replace(/([ \t]+)/g,(b,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,b){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(i),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(i,c){const b=new RegExp((0,L.escapeRegExpCharacters)(c),"g");return i.replace(b,(_,E)=>i.charAt(E-1)!=="\\"?`\\${_}`:_)}}e.MarkdownString=y;function m(t){return P(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function P(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,k.isEqual)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.markdownStringEqual=D;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=a;function v(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function f(t){const i=[],c=t.split("|").map(_=>_.trim());t=c[0];const b=c[1];if(b){const _=/height=(\d+)/.exec(b),E=/width=(\d+)/.exec(b),r=_?_[1]:"",s=E?E[1]:"",n=isFinite(parseInt(s)),o=isFinite(parseInt(r));n&&i.push(`width="${s}"`),o&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.parseHrefAndDimensions=f}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,S){const{os:h,tildify:I,relative:C}=S;if(C){const d=m(o,C,h);if(typeof d=="string")return d}let l=o.fsPath;if(h===1&&!L.isWindows?l=l.replace(/\//g,"\\"):h!==1&&L.isWindows&&(l=l.replace(/\\/g,"/")),h!==1&&I?.userHome){const d=I.userHome.fsPath;let T;o.scheme!==I.userHome.scheme&&o.path.startsWith(k.posix.sep)?T=I.userHome.with({path:o.path}).fsPath:T=o.fsPath,l=a(T,d,h)}return(h===1?k.win32:k.posix).normalize(P(l,h===1))}e.getPathLabel=y;function m(o,S,h){const I=h===1?k.win32:k.posix,C=h===3?A.extUri:A.extUriIgnorePathCase,l=S.getWorkspace(),g=(0,w.firstOrDefault)(l.folders);if(!g)return;o.scheme!==g.uri.scheme&&o.path.startsWith(k.posix.sep)&&(o=g.uri.with({path:o.path}));const d=S.getWorkspaceFolder(o);if(!d)return;let T;if(C.isEqual(d.uri,o)?T="":T=C.relativePath(d.uri,o)??"",T&&(T=I.normalize(T)),l.folders.length>1&&!S.noPrefix){const z=d.name?d.name:C.basenameOrAuthority(d.uri);T=T?`${z} \u2022 ${T}`:z}return T}function P(o,S=L.isWindows){return(0,R.hasDriveLetter)(o,S)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let D=Object.create(null);function a(o,S,h=L.OS){if(h===1||!o||!S)return o;let I=D.original===S?D.normalized:void 0;I||(I=S,L.isWindows&&(I=(0,R.toSlashes)(I)),I=`${(0,u.rtrim)(I,k.posix.sep)}${k.posix.sep}`,D={original:S,normalized:I});let C=o;return L.isWindows&&(C=(0,R.toSlashes)(C)),(h===3?C.startsWith(I):(0,u.startsWithIgnoreCase)(C,I))?`~/${C.substr(I.length)}`:o}e.tildify=a;function v(o,S){return o.replace(/^~($|\/|\\)/,`${S}$1`)}e.untildify=v;const p="\u2026",f="\\\\",t="~";function i(o,S=k.sep){const h=new Array(o.length);let I=!1;for(let C=0;C<o.length;C++){const l=o[C];if(l===""){h[C]=`.${S}`;continue}if(!l){h[C]=l;continue}I=!0;let g="",d=l;d.indexOf(f)===0?(g=d.substr(0,d.indexOf(f)+f.length),d=d.substr(d.indexOf(f)+f.length)):d.indexOf(S)===0?(g=d.substr(0,d.indexOf(S)+S.length),d=d.substr(d.indexOf(S)+S.length)):d.indexOf(t)===0&&(g=d.substr(0,d.indexOf(t)+t.length),d=d.substr(d.indexOf(t)+t.length));const T=d.split(S);for(let z=1;I&&z<=T.length;z++)for(let H=T.length-z;I&&H>=0;H--){I=!1;let x=T.slice(H,H+z).join(S);for(let $=0;!I&&$<o.length;$++)if($!==C&&o[$]&&o[$].indexOf(x)>-1){const N=H+z===T.length,M=H>0&&o[$].indexOf(S)>-1?S+x:x,te=o[$].endsWith(M);I=!N||te}if(!I){let $="";(T[0].endsWith(":")||g!=="")&&(H===1&&(H=0,z++,x=T[0]+S+x),H>0&&($=T[0]+S),$=g+$),H>0&&($=$+p+S),$=$+x,H+z<T.length&&($=$+S+p),h[C]=$}}I&&(h[C]=l)}return h}e.shorten=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(o,S=Object.create(null)){const h=[];let I=!1,C="";for(const l of o)if(l==="$"||I&&l==="{")C&&h.push({value:C,type:c.TEXT}),C="",I=!0;else if(l==="}"&&I){const g=S[C];if(typeof g=="string")g.length&&h.push({value:g,type:c.VARIABLE});else if(g){const d=h[h.length-1];(!d||d.type!==c.SEPARATOR)&&h.push({value:g.label,type:c.SEPARATOR})}C="",I=!1}else C+=l;return C&&!I&&h.push({value:C,type:c.TEXT}),h.filter((l,g)=>{if(l.type===c.SEPARATOR){const d=h[g-1],T=h[g+1];return[d,T].every(z=>z&&(z.type===c.VARIABLE||z.type===c.TEXT)&&z.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=b;function _(o,S){return L.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=_;function E(o,S){return L.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,""):L.isWindows?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=E;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){if(o.endsWith("]")){const S=o.lastIndexOf(" [",o.length-2);if(S!==-1){const h=n(o.substring(0,S));return{name:h.name,parentPath:h.parentPath+o.substring(S)}}}return n(o)}e.splitRecentLabel=s;function n(o){const S=o.indexOf("/")!==-1?k.posix:k.win32,h=S.basename(o),I=S.dirname(o);return h.length?{name:h,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(D){return D.toJSON()}class L{constructor(a){this._uriTransformer=a}transformIncoming(a){const v=this._uriTransformer.transformIncoming(a);return v===a?a:k(R.URI.from(v))}transformOutgoing(a){const v=this._uriTransformer.transformOutgoing(a);return v===a?a:k(R.URI.from(v))}transformOutgoingURI(a){const v=this._uriTransformer.transformOutgoing(a);return v===a?a:R.URI.from(v)}transformOutgoingScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,a,v){if(!D||v>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return a.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const f=A(D[p],a,v+1);f!==null&&(D[p]=f)}}return null}function u(D,a){const v=A(D,a,0);return v===null?D:v}e.transformOutgoingURIs=u;function y(D,a,v,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return v?R.URI.revive(a.transformIncoming(D)):a.transformIncoming(D);if(D instanceof w.VSBuffer)return null;for(const f in D)if(Object.hasOwnProperty.call(D,f)){const t=y(D[f],a,v,p+1);t!==null&&(D[f]=t)}}return null}function m(D,a){const v=y(D,a,!1,0);return v===null?D:v}e.transformIncomingURIs=m;function P(D,a){const v=y(D,a,!0,0);return v===null?D:v}e.transformAndReviveIncomingURIs=P}),define(Ae[133],Re([1,0,37,19]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(L,A,u,y,m,P){if(Array.isArray(L)){let D=0;for(const a of L){const v=k(a,A,u,y,m,P);if(v===10)return v;v>D&&(D=v)}return D}else{if(typeof L=="string")return y?L==="*"?5:L===u?10:0:0;if(L){const{language:D,pattern:a,scheme:v,hasAccessToAllModels:p,notebookType:f}=L;if(!y&&!p)return 0;f&&m&&(A=m);let t=0;if(v)if(v===A.scheme)t=10;else if(v==="*")t=5;else return 0;if(D)if(D===u)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,R.normalize)(a.base)},i===A.fsPath||(0,w.match)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.score=k}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(k||(k={}));function L(D){for(let a=0,v=D.length;a<v;a+=4){const p=D[a+0],f=D[a+1],t=D[a+2],i=D[a+3];D[a+0]=i,D[a+1]=t,D[a+2]=f,D[a+3]=p}}function A(D){const a=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return R.isLittleEndian()||L(a),w.VSBuffer.wrap(a)}function u(D){const a=D.buffer;if(R.isLittleEndian()||L(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const v=new Uint8Array(a.byteLength);return v.set(a),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function y(D){const a=new Uint32Array(m(D));let v=0;if(a[v++]=D.id,D.type==="full")a[v++]=1,a[v++]=D.data.length,a.set(D.data,v),v+=D.data.length;else{a[v++]=2,a[v++]=D.deltas.length;for(const p of D.deltas)a[v++]=p.start,a[v++]=p.deleteCount,p.data?(a[v++]=p.data.length,a.set(p.data,v),v+=p.data.length):a[v++]=0}return A(a)}e.encodeSemanticTokensDto=y;function m(D){let a=0;if(a+=1+1,D.type==="full")a+=1+D.data.length;else{a+=1,a+=(1+1+1)*D.deltas.length;for(const v of D.deltas)v.data&&(a+=v.data.length)}return a}function P(D){const a=u(D);let v=0;const p=a[v++];if(a[v++]===1){const c=a[v++],b=a.subarray(v,v+c);return v+=c,{id:p,type:"full",data:b}}const t=a[v++],i=[];for(let c=0;c<t;c++){const b=a[v++],_=a[v++],E=a[v++];let r;E>0&&(r=a.subarray(v,v+E),v+=E),i[c]={start:b,deleteCount:_,data:r}}return{id:p,type:"delta",deltas:i}}e.decodeSemanticTokensDto=P}),define(Ae[134],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=m;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(X,ve,Be,Ne){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,ve){return v(X,ve)}compute(X,ve,Be){return Be}}class a{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=a;function v(J,X){if(typeof J!="object"||typeof X!="object"||!J||!X)return new a(X,J!==X);if(Array.isArray(J)||Array.isArray(X)){const Be=Array.isArray(J)&&Array.isArray(X)&&w.equals(J,X);return new a(X,!Be)}let ve=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Ne=v(J[Be],X[Be]);Ne.didChange&&(J[Be]=Ne.newValue,ve=!0)}return new a(J,ve)}class p{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return v(X,ve)}validate(X){return this.defaultValue}}class f{constructor(X,ve,Be,Ne){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,ve){return v(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Be){return Be}}function t(J,X){return typeof J>"u"?X:J==="false"?!1:!!J}e.boolean=t;class i extends f{constructor(X,ve,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(X,ve,Be,Ne)}validate(X){return t(X,this.defaultValue)}}function c(J,X,ve,Be){if(typeof J>"u")return X;let Ne=parseInt(J,10);return isNaN(Ne)?X:(Ne=Math.max(ve,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=c;class b extends f{static clampedInt(X,ve,Be,Ne){return c(X,ve,Be,Ne)}constructor(X,ve,Be,Ne,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Ne,rt.maximum=Xe),super(X,ve,Be,rt),this.minimum=Ne,this.maximum=Xe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function _(J,X,ve,Be){if(typeof J>"u")return X;const Ne=E.float(J,X);return E.clamp(Ne,ve,Be)}e.clampedFloat=_;class E extends f{static clamp(X,ve,Be){return X<ve?ve:X>Be?Be:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Be=parseFloat(X);return isNaN(Be)?ve:Be}constructor(X,ve,Be,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(X,ve,Be,Xe),this.validationFn=Ne}validate(X){return this.validationFn(E.float(X,this.defaultValue))}}class r extends f{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(X,ve,Be,Ne)}validate(X){return r.string(X,this.defaultValue)}}function s(J,X,ve,Be){return typeof J!="string"?X:Be&&J in Be?Be[J]:ve.indexOf(J)===-1?X:J}e.stringSet=s;class n extends f{constructor(X,ve,Be,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Be),super(X,ve,Be,Xe),this._allowedValues=Ne}validate(X){return s(X,this.defaultValue,this._allowedValues)}}class o extends D{constructor(X,ve,Be,Ne,Xe,rt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Xe,gt.default=Ne),super(X,ve,Be,gt),this._allowedValues=Xe,this._convert=rt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function S(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",tags:["accessibility"],description:u.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Be){return Be===0?X.accessibilitySupport:Be}}class I extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:u.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function l(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function d(J){switch(J){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function T(J){switch(J){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class z extends p{constructor(){super(140)}compute(X,ve,Be){const Ne=["monaco-editor"];return ve.get(39)&&Ne.push(ve.get(39)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),ve.get(73)==="default"?Ne.push("mouse-default"):ve.get(73)==="copy"&&Ne.push("mouse-copy"),ve.get(110)&&Ne.push("showUnused"),ve.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(X,ve,Be){return Be&&X.emptySelectionClipboard}}class x extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:u.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:u.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class $ extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?$.OFF:X==="true"?$.ON:X:X?$.ON:$.OFF}}e.EditorFontLigatures=$;class N extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:u.localize(22,null)},{type:"string",description:u.localize(23,null)}],description:u.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?N.OFF:X==="true"?N.TRANSLATE:X:X?N.TRANSLATE:N.OFF}compute(X,ve,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class M extends p{constructor(){super(50)}compute(X,ve,Be){return X.fontInfo}}class te extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(25,null)})}validate(X){const ve=E.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(ve,6,100)}compute(X,ve,Be){return X.fontInfo.fontSize}}class Q extends D{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.MINIMUM_VALUE,maximum:Q.MAXIMUM_VALUE,errorMessage:u.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.MINIMUM_VALUE,Q.MAXIMUM_VALUE))}}class Se extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[u.localize(28,null),u.localize(29,null),u.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:u.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:u.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:u.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:u.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:u.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:u.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:u.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:u.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:s(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??s(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??s(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??s(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??s(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??s(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _e extends D{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:u.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:u.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:u.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:u.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:u.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:b.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ve.above,this.defaultValue.above)}}}var Pe;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Y extends p{constructor(){super(143)}compute(X,ve,Be){return Y.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,ve-1));const Xe=(Be+X.viewLineCount+Ne)/(X.pixelRatio*X.height),rt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:rt}}static _computeMinimapLayout(X,ve){const Be=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const rt=ve.stableMinimapLayoutInput,gt=rt&&X.outerHeight===rt.outerHeight&&X.lineHeight===rt.lineHeight&&X.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&X.pixelRatio===rt.pixelRatio&&X.scrollBeyondLastLine===rt.scrollBeyondLastLine&&X.paddingTop===rt.paddingTop&&X.paddingBottom===rt.paddingBottom&&X.minimap.enabled===rt.minimap.enabled&&X.minimap.side===rt.minimap.side&&X.minimap.size===rt.minimap.size&&X.minimap.showSlider===rt.minimap.showSlider&&X.minimap.renderCharacters===rt.minimap.renderCharacters&&X.minimap.maxColumn===rt.minimap.maxColumn&&X.minimap.scale===rt.minimap.scale&&X.verticalScrollbarWidth===rt.verticalScrollbarWidth&&X.isViewportWrapping===rt.isViewportWrapping,wt=X.lineHeight,kt=X.typicalHalfwidthCharacterWidth,Qt=X.scrollBeyondLastLine,Vt=X.minimap.renderCharacters;let Et=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Bt=X.minimap.maxColumn,Lt=X.minimap.size,$t=X.minimap.side,Pt=X.verticalScrollbarWidth,Tt=X.viewLineCount,Mt=X.remainingWidth,zt=X.isViewportWrapping,qt=Vt?2:3;let Ht=Math.floor(Xe*Ne);const at=Ht/Xe;let lt=!1,Kt=!1,It=qt*Et,_t=Et/Xe,ht=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:Te,extraLinesBeyondLastLine:me,desiredRatio:j,minimapLineCount:Oe}=Y.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:Qt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Xe});if(Tt/Oe>1)lt=!0,Kt=!0,Et=1,It=1,_t=Et/Xe;else{let Ke=!1,We=Et+1;if(Lt==="fit"){const et=Math.ceil((Te+Tt+me)*It);zt&&gt&&Mt<=ve.stableFitRemainingWidth?(Ke=!0,We=ve.stableFitMaxMinimapScale):Ke=et>Ht}if(Lt==="fill"||Ke){lt=!0;const et=Et;It=Math.min(wt*Xe,Math.max(1,Math.floor(1/j))),zt&&gt&&Mt<=ve.stableFitRemainingWidth&&(We=ve.stableFitMaxMinimapScale),Et=Math.min(We,Math.max(1,Math.floor(It/qt))),Et>et&&(ht=Math.min(2,Et/et)),_t=Et/Xe/ht,Ht=Math.ceil(Math.max(ke,Te+Tt+me)*It),zt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Mt,ve.stableFitMaxMinimapScale=Et):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Bt*_t),Ft=Math.min(Dt,Math.max(0,Math.floor((Mt-Pt-2)*_t/(kt+_t)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Xe*Ft);const He=St/Xe;St=Math.floor(St*ht);const Nt=Vt?1:2,Ut=$t==="left"?0:Be-Ft-Pt;return{renderMinimap:Nt,minimapLeft:Ut,minimapWidth:Ft,minimapHeightIsEditorHeight:lt,minimapIsSampling:Kt,minimapScale:Et,minimapLineHeight:It,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:Ht,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:at}}static computeLayout(X,ve){const Be=ve.outerWidth|0,Ne=ve.outerHeight|0,Xe=ve.lineHeight|0,rt=ve.lineNumbersDigitCount|0,gt=ve.typicalHalfwidthCharacterWidth,wt=ve.maxDigitWidth,kt=ve.pixelRatio,Qt=ve.viewLineCount,Vt=X.get(135),Et=Vt==="inherit"?X.get(134):Vt,Bt=Et==="inherit"?X.get(130):Et,Lt=X.get(133),$t=ve.isDominatedByLongLines,Pt=X.get(57),Tt=X.get(67).renderType!==0,Mt=X.get(68),zt=X.get(104),qt=X.get(83),Ht=X.get(72),at=X.get(102),lt=at.verticalScrollbarSize,Kt=at.verticalHasArrows,It=at.arrowSize,_t=at.horizontalScrollbarSize,ht=X.get(43),Dt=X.get(109)!=="never";let Ft=X.get(65);ht&&Dt&&(Ft+=16);let St=0;if(Tt){const ft=Math.max(rt,Mt);St=Math.round(ft*wt)}let He=0;Pt&&(He=Xe*ve.glyphMarginDecorationLaneCount);let Nt=0,Ut=Nt+He,ke=Ut+St,Te=ke+Ft;const me=Be-He-St-Ft;let j=!1,Oe=!1,$e=-1;Et==="inherit"&&$t?(j=!0,Oe=!0):Bt==="on"||Bt==="bounded"?Oe=!0:Bt==="wordWrapColumn"&&($e=Lt);const Ke=Y._computeMinimapLayout({outerWidth:Be,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:gt,pixelRatio:kt,scrollBeyondLastLine:zt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Ht,verticalScrollbarWidth:lt,viewLineCount:Qt,remainingWidth:me,isViewportWrapping:Oe},ve.memory||new P);Ke.renderMinimap!==0&&Ke.minimapLeft===0&&(Nt+=Ke.minimapWidth,Ut+=Ke.minimapWidth,ke+=Ke.minimapWidth,Te+=Ke.minimapWidth);const We=me-Ke.minimapWidth,et=Math.max(1,Math.floor((We-lt-2)/gt)),mt=Kt?It:0;return Oe&&($e=Math.max(1,et),Bt==="bounded"&&($e=Math.min($e,Lt))),{width:Be,height:Ne,glyphMarginLeft:Nt,glyphMarginWidth:He,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:Ut,lineNumbersWidth:St,decorationsLeft:ke,decorationsWidth:Ft,contentLeft:Te,contentWidth:We,minimap:Ke,viewportColumn:et,isWordWrapMinified:j,isViewportWrapping:Oe,wrappingColumn:$e,verticalScrollbarWidth:lt,horizontalScrollbarHeight:_t,overviewRuler:{top:mt,width:lt,height:Ne-2*mt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ae extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[u.localize(47,null),u.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:u.localize(49,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,ve,Be){return ve.get(2)===2?"advanced":Be}}class Ce extends D{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:u.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class le extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:u.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:u.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:u.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:u.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:u.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(56,null),u.localize(57,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),u.localize(58,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),u.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:u.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:u.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:u.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:s(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Be){return Be<0?b.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class U extends E{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>E.clamp(X,0,150),{markdownDescription:u.localize(63,null)})}compute(X,ve,Be){return X.fontInfo.lineHeight}}class W extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:u.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:u.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null)],default:X.size,description:u.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:u.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:u.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:u.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:u.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:s(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ve.side,this.defaultValue.side,["right","left"]),showSlider:s(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ve.scale,1,1,3),maxColumn:b.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(J){return J==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:b.clampedInt(ve.top,0,0,1e3),bottom:b.clampedInt(ve.bottom,0,0,1e3)}}}class Ee extends D{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:u.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:u.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(141)}compute(X,ve,Be){return X.pixelRatio}}class ye extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(79,null),u.localize(80,null),u.localize(81,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:u.localize(82,null)},comments:{anyOf:ve,default:X.comments,description:u.localize(83,null)},other:{anyOf:ve,default:X.other,description:u.localize(84,null)}},default:X,markdownDescription:u.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const kt=X?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Ne}=X,Xe=["on","inline","off"];let rt,gt,wt;return typeof ve=="boolean"?rt=ve?"on":"off":rt=s(ve,this.defaultValue.other,Xe),typeof Be=="boolean"?gt=Be?"on":"off":gt=s(Be,this.defaultValue.comments,Xe),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,Xe),{other:rt,comments:gt,strings:wt}}}var re;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class de extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(86,null),u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"on",description:u.localize(90,null)})}validate(X){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Be=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function se(J){const X=J.get(97);return X==="editable"?J.get(90):X!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const X=[],ve={type:"number",description:u.localize(91,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:u.localize(92,null),format:"color-hex"}}}]},default:X,description:u.localize(93,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Be of X)if(typeof Be=="number")ve.push({column:b.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;ve.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Be,Ne)=>Be.column-Ne.column),ve}return this.defaultValue}}class he extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(J,X){if(typeof J!="string")return X;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(94,null),u.localize(95,null),u.localize(96,null)],default:"auto",description:u.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(98,null),u.localize(99,null),u.localize(100,null)],default:"auto",description:u.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:u.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:u.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:u.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Be=b.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ve.vertical,this.defaultValue.vertical),horizontal:Ie(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:b.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:u.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:u.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:u.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:u.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:u.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:u.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:u.localize(111,null)}})}applyUpdate(X,ve){let Be=!1;ve.allowedCharacters&&X&&(R.equals(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&X&&(R.equals(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Be=!0));const Ne=super.applyUpdate(X,ve);return Be?new a(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:Z(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,ve){if(typeof X!="object"||!X)return ve;const Be={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&(Be[Ne]=!0);return Be}}class K extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:u.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[u.localize(113,null),u.localize(114,null)],description:u.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:u.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:s(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends D{constructor(){const X={enabled:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:u.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:u.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(119,null),u.localize(120,null),u.localize(121,null)],default:X.bracketPairs,description:u.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(123,null),u.localize(124,null),u.localize(125,null)],default:X.bracketPairsHorizontal,description:u.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:u.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:u.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(129,null),u.localize(130,null),u.localize(131,null)],default:X.highlightActiveIndentation,description:u.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:Z(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(J,X,ve){const Be=ve.indexOf(J);return Be===-1?X:ve[Be]}class ce extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(133,null),u.localize(134,null)],default:X.insertMode,description:u.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:u.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:u.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:u.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[u.localize(139,null),u.localize(140,null),u.localize(141,null),u.localize(142,null)],default:X.selectionMode,markdownDescription:u.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:u.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:u.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:u.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:u.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:u.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(180,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:s(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:s(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class Le extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:u.localize(182,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var xe;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(xe||(e.WrappingIndent=xe={}));class Ge extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[u.localize(183,null),u.localize(184,null),u.localize(185,null),u.localize(186,null)],description:u.localize(187,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Be){return ve.get(2)===2?0:Be}}class je extends p{constructor(){super(144)}compute(X,ve,Be){const Ne=ve.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Je extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:u.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:u.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[u.localize(190,null),u.localize(191,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showDropSelector:s(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:u.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:u.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[u.localize(194,null),u.localize(195,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showPasteSelector:s(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ze="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?it:k.isLinux?tt:Ze,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(J){return e.editorOptionsRegistry[J.id]=J,J}var st;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.ariaRequired=5]="ariaRequired",J[J.autoClosingBrackets=6]="autoClosingBrackets",J[J.autoClosingComments=7]="autoClosingComments",J[J.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",J[J.autoClosingDelete=9]="autoClosingDelete",J[J.autoClosingOvertype=10]="autoClosingOvertype",J[J.autoClosingQuotes=11]="autoClosingQuotes",J[J.autoIndent=12]="autoIndent",J[J.automaticLayout=13]="automaticLayout",J[J.autoSurround=14]="autoSurround",J[J.bracketPairColorization=15]="bracketPairColorization",J[J.guides=16]="guides",J[J.codeLens=17]="codeLens",J[J.codeLensFontFamily=18]="codeLensFontFamily",J[J.codeLensFontSize=19]="codeLensFontSize",J[J.colorDecorators=20]="colorDecorators",J[J.colorDecoratorsLimit=21]="colorDecoratorsLimit",J[J.columnSelection=22]="columnSelection",J[J.comments=23]="comments",J[J.contextmenu=24]="contextmenu",J[J.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",J[J.cursorBlinking=26]="cursorBlinking",J[J.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",J[J.cursorStyle=28]="cursorStyle",J[J.cursorSurroundingLines=29]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",J[J.cursorWidth=31]="cursorWidth",J[J.disableLayerHinting=32]="disableLayerHinting",J[J.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",J[J.domReadOnly=34]="domReadOnly",J[J.dragAndDrop=35]="dragAndDrop",J[J.dropIntoEditor=36]="dropIntoEditor",J[J.emptySelectionClipboard=37]="emptySelectionClipboard",J[J.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",J[J.extraEditorClassName=39]="extraEditorClassName",J[J.fastScrollSensitivity=40]="fastScrollSensitivity",J[J.find=41]="find",J[J.fixedOverflowWidgets=42]="fixedOverflowWidgets",J[J.folding=43]="folding",J[J.foldingStrategy=44]="foldingStrategy",J[J.foldingHighlight=45]="foldingHighlight",J[J.foldingImportsByDefault=46]="foldingImportsByDefault",J[J.foldingMaximumRegions=47]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=49]="fontFamily",J[J.fontInfo=50]="fontInfo",J[J.fontLigatures=51]="fontLigatures",J[J.fontSize=52]="fontSize",J[J.fontWeight=53]="fontWeight",J[J.fontVariations=54]="fontVariations",J[J.formatOnPaste=55]="formatOnPaste",J[J.formatOnType=56]="formatOnType",J[J.glyphMargin=57]="glyphMargin",J[J.gotoLocation=58]="gotoLocation",J[J.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",J[J.hover=60]="hover",J[J.inDiffEditor=61]="inDiffEditor",J[J.inlineSuggest=62]="inlineSuggest",J[J.letterSpacing=63]="letterSpacing",J[J.lightbulb=64]="lightbulb",J[J.lineDecorationsWidth=65]="lineDecorationsWidth",J[J.lineHeight=66]="lineHeight",J[J.lineNumbers=67]="lineNumbers",J[J.lineNumbersMinChars=68]="lineNumbersMinChars",J[J.linkedEditing=69]="linkedEditing",J[J.links=70]="links",J[J.matchBrackets=71]="matchBrackets",J[J.minimap=72]="minimap",J[J.mouseStyle=73]="mouseStyle",J[J.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=75]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",J[J.multiCursorModifier=77]="multiCursorModifier",J[J.multiCursorPaste=78]="multiCursorPaste",J[J.multiCursorLimit=79]="multiCursorLimit",J[J.occurrencesHighlight=80]="occurrencesHighlight",J[J.overviewRulerBorder=81]="overviewRulerBorder",J[J.overviewRulerLanes=82]="overviewRulerLanes",J[J.padding=83]="padding",J[J.pasteAs=84]="pasteAs",J[J.parameterHints=85]="parameterHints",J[J.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",J[J.quickSuggestions=88]="quickSuggestions",J[J.quickSuggestionsDelay=89]="quickSuggestionsDelay",J[J.readOnly=90]="readOnly",J[J.readOnlyMessage=91]="readOnlyMessage",J[J.renameOnType=92]="renameOnType",J[J.renderControlCharacters=93]="renderControlCharacters",J[J.renderFinalNewline=94]="renderFinalNewline",J[J.renderLineHighlight=95]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=97]="renderValidationDecorations",J[J.renderWhitespace=98]="renderWhitespace",J[J.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",J[J.roundedSelection=100]="roundedSelection",J[J.rulers=101]="rulers",J[J.scrollbar=102]="scrollbar",J[J.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=104]="scrollBeyondLastLine",J[J.scrollPredominantAxis=105]="scrollPredominantAxis",J[J.selectionClipboard=106]="selectionClipboard",J[J.selectionHighlight=107]="selectionHighlight",J[J.selectOnLineNumbers=108]="selectOnLineNumbers",J[J.showFoldingControls=109]="showFoldingControls",J[J.showUnused=110]="showUnused",J[J.snippetSuggestions=111]="snippetSuggestions",J[J.smartSelect=112]="smartSelect",J[J.smoothScrolling=113]="smoothScrolling",J[J.stickyScroll=114]="stickyScroll",J[J.stickyTabStops=115]="stickyTabStops",J[J.stopRenderingLineAfter=116]="stopRenderingLineAfter",J[J.suggest=117]="suggest",J[J.suggestFontSize=118]="suggestFontSize",J[J.suggestLineHeight=119]="suggestLineHeight",J[J.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",J[J.suggestSelection=121]="suggestSelection",J[J.tabCompletion=122]="tabCompletion",J[J.tabIndex=123]="tabIndex",J[J.unicodeHighlighting=124]="unicodeHighlighting",J[J.unusualLineTerminators=125]="unusualLineTerminators",J[J.useShadowDOM=126]="useShadowDOM",J[J.useTabStops=127]="useTabStops",J[J.wordBreak=128]="wordBreak",J[J.wordSeparators=129]="wordSeparators",J[J.wordWrap=130]="wordWrap",J[J.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=133]="wordWrapColumn",J[J.wordWrapOverride1=134]="wordWrapOverride1",J[J.wordWrapOverride2=135]="wordWrapOverride2",J[J.wrappingIndent=136]="wrappingIndent",J[J.wrappingStrategy=137]="wrappingStrategy",J[J.showDeprecated=138]="showDeprecated",J[J.inlayHints=139]="inlayHints",J[J.editorClassName=140]="editorClassName",J[J.pixelRatio=141]="pixelRatio",J[J.tabFocusMode=142]="tabFocusMode",J[J.layoutInfo=143]="layoutInfo",J[J.wrappingInfo=144]="wrappingInfo",J[J.defaultColorDecorators=145]="defaultColorDecorators",J[J.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",J[J.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(196,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(197,null),""],markdownDescription:u.localize(198,null)})),accessibilitySupport:Ue(new h),accessibilityPageSize:Ue(new b(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(199,null),tags:["accessibility"]})),ariaLabel:Ue(new r(4,"ariaLabel",u.localize(200,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:u.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(202,null),u.localize(203,null),""],description:u.localize(204,null)})),autoClosingComments:Ue(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(205,null),u.localize(206,null),""],description:u.localize(207,null)})),autoClosingDelete:Ue(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(208,null),""],description:u.localize(209,null)})),autoClosingOvertype:Ue(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(210,null),""],description:u.localize(211,null)})),autoClosingQuotes:Ue(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(212,null),u.localize(213,null),""],description:u.localize(214,null)})),autoIndent:Ue(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[u.localize(215,null),u.localize(216,null),u.localize(217,null),u.localize(218,null),u.localize(219,null)],description:u.localize(220,null)})),automaticLayout:Ue(new i(13,"automaticLayout",!1)),autoSurround:Ue(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(221,null),u.localize(222,null),u.localize(223,null),""],description:u.localize(224,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new q),stickyTabStops:Ue(new i(115,"stickyTabStops",!1,{description:u.localize(225,null)})),codeLens:Ue(new i(17,"codeLens",!0,{description:u.localize(226,null)})),codeLensFontFamily:Ue(new r(18,"codeLensFontFamily","",{description:u.localize(227,null)})),codeLensFontSize:Ue(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(228,null)})),colorDecorators:Ue(new i(20,"colorDecorators",!0,{description:u.localize(229,null)})),colorDecoratorActivatedOn:Ue(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[u.localize(230,null),u.localize(231,null),u.localize(232,null)],description:u.localize(233,null)})),colorDecoratorsLimit:Ue(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:u.localize(234,null)})),columnSelection:Ue(new i(22,"columnSelection",!1,{description:u.localize(235,null)})),comments:Ue(new I),contextmenu:Ue(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(25,"copyWithSyntaxHighlighting",!0,{description:u.localize(236,null)})),cursorBlinking:Ue(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(237,null)})),cursorSmoothCaretAnimation:Ue(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),cursorStyle:Ue(new o(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:u.localize(242,null)})),cursorSurroundingLines:Ue(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(243,null)})),cursorSurroundingLinesStyle:Ue(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(244,null),u.localize(245,null)],markdownDescription:u.localize(246,null)})),cursorWidth:Ue(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(247,null)})),disableLayerHinting:Ue(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(34,"domReadOnly",!1)),dragAndDrop:Ue(new i(35,"dragAndDrop",!0,{description:u.localize(248,null)})),emptySelectionClipboard:Ue(new H),dropIntoEditor:Ue(new Je),stickyScroll:Ue(new le),experimentalWhitespaceRendering:Ue(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[u.localize(249,null),u.localize(250,null),u.localize(251,null)],description:u.localize(252,null)})),extraEditorClassName:Ue(new r(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new E(40,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:u.localize(253,null)})),find:Ue(new x),fixedOverflowWidgets:Ue(new i(42,"fixedOverflowWidgets",!1)),folding:Ue(new i(43,"folding",!0,{description:u.localize(254,null)})),foldingStrategy:Ue(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),foldingHighlight:Ue(new i(45,"foldingHighlight",!0,{description:u.localize(258,null)})),foldingImportsByDefault:Ue(new i(46,"foldingImportsByDefault",!1,{description:u.localize(259,null)})),foldingMaximumRegions:Ue(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(260,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(261,null)})),fontFamily:Ue(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(262,null)})),fontInfo:Ue(new M),fontLigatures2:Ue(new $),fontSize:Ue(new te),fontWeight:Ue(new Q),fontVariations:Ue(new N),formatOnPaste:Ue(new i(55,"formatOnPaste",!1,{description:u.localize(263,null)})),formatOnType:Ue(new i(56,"formatOnType",!1,{description:u.localize(264,null)})),glyphMargin:Ue(new i(57,"glyphMargin",!0,{description:u.localize(265,null)})),gotoLocation:Ue(new Se),hideCursorInOverviewRuler:Ue(new i(59,"hideCursorInOverviewRuler",!1,{description:u.localize(266,null)})),hover:Ue(new _e),inDiffEditor:Ue(new i(61,"inDiffEditor",!1)),letterSpacing:Ue(new E(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>E.clamp(J,-5,20),{description:u.localize(267,null)})),lightbulb:Ue(new Ce),lineDecorationsWidth:Ue(new ie),lineHeight:Ue(new U),lineNumbers:Ue(new de),lineNumbersMinChars:Ue(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(69,"linkedEditing",!1,{description:u.localize(268,null)})),links:Ue(new i(70,"links",!0,{description:u.localize(269,null)})),matchBrackets:Ue(new n(71,"matchBrackets","always",["always","near","never"],{description:u.localize(270,null)})),minimap:Ue(new W),mouseStyle:Ue(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new E(74,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:u.localize(271,null)})),mouseWheelZoom:Ue(new i(75,"mouseWheelZoom",!1,{markdownDescription:u.localize(272,null)})),multiCursorMergeOverlapping:Ue(new i(76,"multiCursorMergeOverlapping",!0,{description:u.localize(273,null)})),multiCursorModifier:Ue(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[u.localize(274,null),u.localize(275,null)],markdownDescription:u.localize(276,null)})),multiCursorPaste:Ue(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(277,null),u.localize(278,null)],markdownDescription:u.localize(279,null)})),multiCursorLimit:Ue(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:u.localize(280,null)})),occurrencesHighlight:Ue(new i(80,"occurrencesHighlight",!0,{description:u.localize(281,null)})),overviewRulerBorder:Ue(new i(81,"overviewRulerBorder",!0,{description:u.localize(282,null)})),overviewRulerLanes:Ue(new b(82,"overviewRulerLanes",3,0,3)),padding:Ue(new we),pasteAs:Ue(new Ye),parameterHints:Ue(new Ee),peekWidgetDefaultFocus:Ue(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(283,null),u.localize(284,null)],description:u.localize(285,null)})),definitionLinkOpensInPeek:Ue(new i(87,"definitionLinkOpensInPeek",!1,{description:u.localize(286,null)})),quickSuggestions:Ue(new ye),quickSuggestionsDelay:Ue(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(287,null)})),readOnly:Ue(new i(90,"readOnly",!1)),readOnlyMessage:Ue(new he),renameOnType:Ue(new i(92,"renameOnType",!1,{description:u.localize(288,null),markdownDeprecationMessage:u.localize(289,null)})),renderControlCharacters:Ue(new i(93,"renderControlCharacters",!0,{description:u.localize(290,null),restricted:!0})),renderFinalNewline:Ue(new n(94,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:u.localize(291,null)})),renderLineHighlight:Ue(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(292,null)],description:u.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(294,null)})),renderValidationDecorations:Ue(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(295,null),u.localize(296,null),u.localize(297,null),""],description:u.localize(298,null)})),revealHorizontalRightPadding:Ue(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(100,"roundedSelection",!0,{description:u.localize(299,null)})),rulers:Ue(new oe),scrollbar:Ue(new O),scrollBeyondLastColumn:Ue(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(300,null)})),scrollBeyondLastLine:Ue(new i(104,"scrollBeyondLastLine",!0,{description:u.localize(301,null)})),scrollPredominantAxis:Ue(new i(105,"scrollPredominantAxis",!0,{description:u.localize(302,null)})),selectionClipboard:Ue(new i(106,"selectionClipboard",!0,{description:u.localize(303,null),included:k.isLinux})),selectionHighlight:Ue(new i(107,"selectionHighlight",!0,{description:u.localize(304,null)})),selectOnLineNumbers:Ue(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(305,null),u.localize(306,null),u.localize(307,null)],description:u.localize(308,null)})),showUnused:Ue(new i(110,"showUnused",!0,{description:u.localize(309,null)})),showDeprecated:Ue(new i(138,"showDeprecated",!0,{description:u.localize(310,null)})),inlayHints:Ue(new pe),snippetSuggestions:Ue(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(311,null),u.localize(312,null),u.localize(313,null),u.localize(314,null)],description:u.localize(315,null)})),smartSelect:Ue(new Le),smoothScrolling:Ue(new i(113,"smoothScrolling",!1,{description:u.localize(316,null)})),stopRenderingLineAfter:Ue(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ce),inlineSuggest:Ue(new K),inlineCompletionsAccessibilityVerbose:Ue(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:u.localize(317,null)})),suggestFontSize:Ue(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(120,"suggestOnTriggerCharacters",!0,{description:u.localize(320,null)})),suggestSelection:Ue(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(321,null),u.localize(322,null),u.localize(323,null)],description:u.localize(324,null)})),tabCompletion:Ue(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(325,null),u.localize(326,null),u.localize(327,null)],description:u.localize(328,null)})),tabIndex:Ue(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new V),unusualLineTerminators:Ue(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(329,null),u.localize(330,null),u.localize(331,null)],description:u.localize(332,null)})),useShadowDOM:Ue(new i(126,"useShadowDOM",!0)),useTabStops:Ue(new i(127,"useTabStops",!0,{description:u.localize(333,null)})),wordBreak:Ue(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[u.localize(334,null),u.localize(335,null)],description:u.localize(336,null)})),wordSeparators:Ue(new r(129,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:u.localize(337,null)})),wordWrap:Ue(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(338,null),u.localize(339,null),u.localize(340,null),u.localize(341,null)],description:u.localize(342,null)})),wordWrapBreakAfterCharacters:Ue(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(343,null)})),wordWrapOverride1:Ue(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new z),defaultColorDecorators:Ue(new i(145,"defaultColorDecorators",!1,{markdownDescription:u.localize(344,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new i(142,"tabFocusMode",!1,{markdownDescription:u.localize(345,null)})),layoutInfo:Ue(new Y),wrappingInfo:Ue(new je),wrappingIndent:Ue(new Ge),wrappingStrategy:Ue(new ae)}}),define(Ae[137],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...m){switch(m.length){case 1:return(0,R.localize)(0,null,m[0]);case 2:return(0,R.localize)(1,null,m[0],m[1]);case 3:return(0,R.localize)(2,null,m[0],m[1],m[2]);default:return}}const A=(0,R.localize)(3,null),u=(0,R.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const D=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:D})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const D=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:D})}else this._match(126)?this._addToken(9):this._error(L("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(L("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const D=this._start,a=this._input.substring(this._start,this._current),v={type:19,offset:this._start,lexeme:a};this._errors.push({offset:D,lexeme:a,additionalInfo:P}),this._tokens.push(v)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const D=this._input.substring(this._start,this._current),a=y._keywords.get(D);a?this._addToken(a):this._tokens.push({type:17,lexeme:D,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,D=!1,a=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(u);return}const p=this._input.charCodeAt(P);if(D)D=!1;else if(p===47&&!a){P++;break}else p===91?a=!0:p===92?D=!0:p===93&&(a=!1);P++}for(;P<this._input.length&&y._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const v=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:v,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(Ae[169],Re([1,0,23,29,141,276]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,u=/^-(\d{4})(\d{2})(\d{2})$/;function y(i){return i=i.trim(),i==="*"||A.test(i)}e.isValidVersionStr=y;function m(i){if(!y(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=m;function P(i){if(!i)return null;const c=i.majorBase,b=i.majorMustEqual,_=i.minorBase;let E=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(c===0||(E=!1),s=!1);let n=0;if(i.preRelease){const o=u.exec(i.preRelease);if(o){const[,S,h,I]=o;n=Date.UTC(Number(S),Number(h)-1,Number(I))}}return{majorBase:c,majorMustEqual:b,minorBase:_,minorMustEqual:E,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function D(i,c,b){let _;typeof i=="string"?_=P(m(i)):_=i;let E;c instanceof Date?E=c.getTime():typeof c=="string"&&(E=new Date(c).getTime());let r;if(typeof b=="string"?r=P(m(b)):r=b,!_||!r)return!1;const s=_.majorBase,n=_.minorBase,o=_.patchBase;let S=r.majorBase,h=r.minorBase,I=r.patchBase;const C=r.notBefore;let l=r.majorMustEqual,g=r.minorMustEqual,d=r.patchMustEqual;return r.isMinimum?s>S?!0:s<S?!1:n>h?!0:n<h||E&&E<C?!1:o>=I:(s===1&&S===0&&(!l||!g||!d)&&(S=1,h=0,I=0,l=!0,g=!1,d=!1),s<S?!1:s>S?!l:n<h?!1:n>h?!g:o<I?!1:o>I?!d:!(E&&E<C))}e.isValidVersion=D;function a(i,c,b,_,E){const r=[];if(typeof _.publisher<"u"&&typeof _.publisher!="string")return r.push([R.default.Error,k.localize(0,null)]),r;if(typeof _.name!="string")return r.push([R.default.Error,k.localize(1,null,"name")]),r;if(typeof _.version!="string")return r.push([R.default.Error,k.localize(2,null,"version")]),r;if(!_.engines)return r.push([R.default.Error,k.localize(3,null,"engines")]),r;if(typeof _.engines.vscode!="string")return r.push([R.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof _.extensionDependencies<"u"&&!t(_.extensionDependencies))return r.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof _.activationEvents<"u"){if(!t(_.activationEvents))return r.push([R.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof _.main>"u"&&typeof _.browser>"u")return r.push([R.default.Error,k.localize(7,null,"activationEvents","main","browser")]),r}if(typeof _.extensionKind<"u"&&typeof _.main>"u"&&r.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof _.main<"u"){if(typeof _.main!="string")return r.push([R.default.Error,k.localize(9,null,"main")]),r;{const o=(0,w.joinPath)(b,_.main);(0,w.isEqualOrParent)(o,b)||r.push([R.default.Warning,k.localize(10,null,o.path,b.path)])}}if(typeof _.browser<"u"){if(typeof _.browser!="string")return r.push([R.default.Error,k.localize(11,null,"browser")]),r;{const o=(0,w.joinPath)(b,_.browser);(0,w.isEqualOrParent)(o,b)||r.push([R.default.Warning,k.localize(12,null,o.path,b.path)])}}if(!L.valid(_.version))return r.push([R.default.Error,k.localize(13,null)]),r;const s=[];if(!v(i,c,_,E,s))for(const o of s)r.push([R.default.Error,o]);return r}e.validateExtensionManifest=a;function v(i,c,b,_,E){return _||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(i,c,b.engines.vscode,E)}e.isValidExtensionVersion=v;function p(i,c,b){return i==="*"||f(c,b,i)}e.isEngineValid=p;function f(i,c,b,_=[]){const E=P(m(b));if(!E)return _.push(k.localize(14,null,b)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return _.push(k.localize(15,null,b)),!1}else if(!E.majorMustEqual)return _.push(k.localize(16,null,b)),!1;return D(i,c,E)?!0:(_.push(k.localize(17,null,i,b)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,b=i.length;c<b;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[68],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,L=[],A=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=w}),define(Ae[69],Re([1,0,68]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var k;(function(u){u[u.Eager=0]="Eager",u[u.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function L(u,y,m){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],!!m)),R.push([u,y])}e.registerSingleton=L;function A(){return R}e.getSingletonServiceDescriptors=A}),define(Ae[170],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class R{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const u=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(A);u.outgoing.set(y.key,y),y.incoming.set(u.key,u)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const u of this._nodes.values())u.outgoing.delete(A),u.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let u=this._nodes.get(A);return u||(u=new w(A,L),this._nodes.set(A,u)),u}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,u]of this._nodes)L.push(`${A}
	(-> incoming)[${[...u.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...u.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const u=new Set([L]),y=this._findCycle(A,u);if(y)return y}}_findCycle(L,A){for(const[u,y]of L.outgoing){if(A.has(u))return[...A,u].join(" -> ");A.add(u);const m=this._findCycle(y,A);if(m)return m;A.delete(u)}}}e.Graph=R}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function u(y){return y[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=u})(w||(e._util=w={})),e.IInstantiationService=k("instantiationService");function R(A,u,y){u[w.DI_TARGET]===u?u[w.DI_DEPENDENCIES].push({id:A,index:y}):(u[w.DI_DEPENDENCIES]=[{id:A,index:y}],u[w.DI_TARGET]=u)}function k(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const u=function(y,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(u,y,P)};return u.toString=()=>A,w.serviceIds.set(A,u),u}e.createDecorator=k;function L(A){return A}e.refineServiceDecorator=L}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=A;var u;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(u||(e.ConfigurationTarget=u={}));function y(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function m(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.isConfigured=m;function P(i,c){const b=Object.create(null);for(const _ in i)D(b,_,i[_],c);return b}e.toValuesTree=P;function D(i,c,b,_){const E=c.split("."),r=E.pop();let s=i;for(let n=0;n<E.length;n++){const o=E[n];let S=s[o];switch(typeof S){case"undefined":S=s[o]=Object.create(null);break;case"object":break;default:_(`Ignoring ${c} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(S)}`);return}s=S}if(typeof s=="object"&&s!==null)try{s[r]=b}catch{_(`Ignoring ${c} as ${E.join(".")} is ${JSON.stringify(s)}`)}else _(`Ignoring ${c} as ${E.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=D;function a(i,c){const b=c.split(".");v(i,b)}e.removeFromValueTree=a;function v(i,c){const b=c.shift();if(c.length===0){delete i[b];return}if(Object.keys(i).indexOf(b)!==-1){const _=i[b];typeof _=="object"&&!Array.isArray(_)&&(v(_,c),Object.keys(_).length===0&&delete i[b])}}function p(i,c,b){function _(s,n){let o=s;for(const S of n){if(typeof o!="object"||o===null)return;o=o[S]}return o}const E=c.split("."),r=_(i,E);return typeof r>"u"?b:r}e.getConfigurationValue=p;function f(i,c,b){Object.keys(c).forEach(_=>{_!=="__proto__"&&(_ in i?w.isObject(i[_])&&w.isObject(c[_])?f(i[_],c[_],b):b&&(i[_]=c[_]):i[_]=c[_])})}e.merge=f;function t(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Ae[32],Re([1,0,22,15,168,4,138,9]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",w.isMacintosh),y.set("isLinux",w.isLinux),y.set("isWindows",w.isWindows),y.set("isWeb",w.isWeb),y.set("isMacNative",w.isMacintosh&&!w.isWeb),y.set("isEdge",w.isEdge),y.set("isFirefox",w.isFirefox),y.set("isChrome",w.isChrome),y.set("isSafari",w.isSafari);function m(ie,U){if(y.get(ie)!==void 0)throw(0,u.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(ie,U)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const a={regexParsingWithErrorRecovery:!0},v=(0,A.localize)(0,null),p=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),b=(0,A.localize)(6,null),_=(0,A.localize)(7,null);class E{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(U=a){this._config=U,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(U){if(U===""){this._parsingErrors.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(U).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const ue=this._peek(),we=ue.type===17?c:void 0;throw this._parsingErrors.push({message:i,offset:ue.offset,lexeme:k.Scanner.getLexeme(ue),additionalInfo:we}),E._parseError}return W}catch(W){if(W!==E._parseError)throw W;return}}_expr(){return this._or()}_or(){const U=[this._and()];for(;this._matchOne(16);){const W=this._and();U.push(W)}return U.length===1?U[0]:r.or(...U)}_and(){const U=[this._term()];for(;this._matchOne(15);){const W=this._term();U.push(W)}return U.length===1?U[0]:r.and(...U)}_term(){if(this._matchOne(2)){const U=this._peek();switch(U.type){case 11:return this._advance(),S.INSTANCE;case 12:return this._advance(),h.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,t),W?.negate()}case 17:return this._advance(),T.create(U.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",U)}}return this._primary()}_primary(){const U=this._peek();switch(U.type){case 11:return this._advance(),r.true();case 12:return this._advance(),r.false();case 0:{this._advance();const W=this._expr();return this._consume(1,t),W}case 17:{const W=U.lexeme;if(this._advance(),this._matchOne(9)){const we=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),we.type!==10)throw this._errExpectedButGot("REGEX",we);const Ee=we.lexeme,ge=Ee.lastIndexOf("/"),ye=ge===Ee.length-1?void 0:this._removeFlagsGY(Ee.substring(ge+1));let re;try{re=new RegExp(Ee.substring(1,ge),ye)}catch{throw this._errExpectedButGot("REGEX",we)}return M.create(W,re)}switch(we.type){case 10:case 19:{const Ee=[we.lexeme];this._advance();let ge=this._peek(),ye=0;for(let he=0;he<we.lexeme.length;he++)we.lexeme.charCodeAt(he)===40?ye++:we.lexeme.charCodeAt(he)===41&&ye--;for(;!this._isAtEnd()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let he=0;he<ge.lexeme.length;he++)ge.lexeme.charCodeAt(he)===40?ye++:we.lexeme.charCodeAt(he)===41&&ye--}if(ye<0)break;Ee.push(k.Scanner.getLexeme(ge)),this._advance(),ge=this._peek()}const re=Ee.join(""),de=re.lastIndexOf("/"),se=de===re.length-1?void 0:this._removeFlagsGY(re.substring(de+1));let oe;try{oe=new RegExp(re.substring(1,de),se)}catch{throw this._errExpectedButGot("REGEX",we)}return r.regex(W,oe)}case 18:{const Ee=we.lexeme;this._advance();let ge=null;if(!(0,R.isFalsyOrWhitespace)(Ee)){const ye=Ee.indexOf("/"),re=Ee.lastIndexOf("/");if(ye!==re&&ye>=0){const de=Ee.slice(ye+1,re),se=Ee[re+1]==="i"?"i":"";try{ge=new RegExp(de,se)}catch{throw this._errExpectedButGot("REGEX",we)}}}if(ge===null)throw this._errExpectedButGot("REGEX",we);return M.create(W,ge)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,f);const we=this._value();return r.notIn(W,we)}switch(this._peek().type){case 3:{this._advance();const we=this._value();if(this._previous().type===18)return r.equals(W,we);switch(we){case"true":return r.has(W);case"false":return r.not(W);default:return r.equals(W,we)}}case 4:{this._advance();const we=this._value();if(this._previous().type===18)return r.notEquals(W,we);switch(we){case"true":return r.not(W);case"false":return r.has(W);default:return r.notEquals(W,we)}}case 5:return this._advance(),$.create(W,this._value());case 6:return this._advance(),N.create(W,this._value());case 7:return this._advance(),H.create(W,this._value());case 8:return this._advance(),x.create(W,this._value());case 13:return this._advance(),r.in(W,this._value());default:return r.has(W)}}case 20:throw this._parsingErrors.push({message:b,offset:U.offset,lexeme:"",additionalInfo:_}),E._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const U=this._peek();switch(U.type){case 17:case 18:return this._advance(),U.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(U){return U.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(U){return this._check(U)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(U,W){if(this._check(U))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(U,W,ue){const we=(0,A.localize)(8,null,U,k.Scanner.getLexeme(W)),Ee=W.offset,ge=k.Scanner.getLexeme(W);return this._parsingErrors.push({message:we,offset:Ee,lexeme:ge,additionalInfo:ue}),E._parseError}_check(U){return this._peek().type===U}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=E;class r{static false(){return S.INSTANCE}static true(){return h.INSTANCE}static has(U){return I.create(U)}static equals(U,W){return C.create(U,W)}static notEquals(U,W){return d.create(U,W)}static regex(U,W){return M.create(U,W)}static in(U,W){return l.create(U,W)}static notIn(U,W){return g.create(U,W)}static not(U){return T.create(U)}static and(...U){return Se.create(U,null,!0)}static or(...U){return _e.create(U,null,!0)}static greater(U,W){return H.create(U,W)}static greaterEquals(U,W){return x.create(U,W)}static smaller(U,W){return $.create(U,W)}static smallerEquals(U,W){return N.create(U,W)}static{this._parser=new E({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this._parser.parse(U)}}e.ContextKeyExpr=r;function s(ie){const U=new E({regexParsingWithErrorRecovery:!1});return ie.map(W=>(U.parse(W),U.lexingErrors.length>0?U.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.validateWhenClauses=s;function n(ie,U){const W=ie?ie.substituteConstants():void 0,ue=U?U.substituteConstants():void 0;return!W&&!ue?!0:!W||!ue?!1:W.equals(ue)}e.expressionsAreEqualWithConstantSubstitution=n;function o(ie,U){return ie.cmp(U)}class S{static{this.INSTANCE=new S}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=S;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=h;class I{static create(U,W=null){const ue=y.get(U);return typeof ue=="boolean"?ue?h.INSTANCE:S.INSTANCE:new I(U,W)}constructor(U,W){this.key=U,this.negated=W,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=y.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:S.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class C{static create(U,W,ue=null){if(typeof W=="boolean")return W?I.create(U,ue):T.create(U,ue);const we=y.get(U);return typeof we=="boolean"?W===(we?"true":"false")?h.INSTANCE:S.INSTANCE:new C(U,W,ue)}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=y.get(this.key);if(typeof U=="boolean"){const W=U?"true":"false";return this.value===W?h.INSTANCE:S.INSTANCE}return this}evaluate(U){return U.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(U){return U.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class l{static create(U,W){return new l(U,W)}constructor(U,W){this.key=U,this.valueKey=W,this.type=10,this.negated=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.valueKey,U.key,U.valueKey)}equals(U){return U.type===this.type?this.key===U.key&&this.valueKey===U.valueKey:!1}substituteConstants(){return this}evaluate(U){const W=U.getValue(this.valueKey),ue=U.getValue(this.key);return Array.isArray(W)?W.includes(ue):typeof ue=="string"&&typeof W=="object"&&W!==null?P.call(W,ue):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(U){return U.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=l;class g{static create(U,W){return new g(U,W)}constructor(U,W){this.key=U,this.valueKey=W,this.type=11,this._negated=l.create(U,W)}cmp(U){return U.type!==this.type?this.type-U.type:this._negated.cmp(U._negated)}equals(U){return U.type===this.type?this._negated.equals(U._negated):!1}substituteConstants(){return this}evaluate(U){return!this._negated.evaluate(U)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(U){return U.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class d{static create(U,W,ue=null){if(typeof W=="boolean")return W?T.create(U,ue):I.create(U,ue);const we=y.get(U);return typeof we=="boolean"?W===(we?"true":"false")?S.INSTANCE:h.INSTANCE:new d(U,W,ue)}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=y.get(this.key);if(typeof U=="boolean"){const W=U?"true":"false";return this.value===W?S.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(U){return U.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class T{static create(U,W=null){const ue=y.get(U);return typeof ue=="boolean"?ue?S.INSTANCE:h.INSTANCE:new T(U,W)}constructor(U,W){this.key=U,this.negated=W,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=y.get(this.key);return typeof U=="boolean"?U?S.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(U){return U.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function z(ie,U){if(typeof ie=="string"){const W=parseFloat(ie);isNaN(W)||(ie=W)}return typeof ie=="string"||typeof ie=="number"?U(ie):S.INSTANCE}class H{static create(U,W,ue=null){return z(W,we=>new H(U,we,ue))}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class x{static create(U,W,ue=null){return z(W,we=>new x(U,we,ue))}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class ${static create(U,W,ue=null){return z(W,we=>new $(U,we,ue))}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=$;class N{static create(U,W,ue=null){return z(W,we=>new N(U,we,ue))}constructor(U,W,ue){this.key=U,this.value=W,this.negated=ue,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class M{static create(U,W){return new M(U,W)}constructor(U,W){this.key=U,this.regexp=W,this.type=7,this.negated=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.key<U.key)return-1;if(this.key>U.key)return 1;const W=this.regexp?this.regexp.source:"",ue=U.regexp?U.regexp.source:"";return W<ue?-1:W>ue?1:0}equals(U){if(U.type===this.type){const W=this.regexp?this.regexp.source:"",ue=U.regexp?U.regexp.source:"";return this.key===U.key&&W===ue}return!1}substituteConstants(){return this}evaluate(U){const W=U.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const U=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${U}`}keys(){return[this.key]}map(U){return U.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=te.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class te{static create(U){return new te(U)}constructor(U){this._actual=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this._actual.cmp(U._actual)}equals(U){return U.type===this.type?this._actual.equals(U._actual):!1}substituteConstants(){return this}evaluate(U){return!this._actual.evaluate(U)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(U){return new te(this._actual.map(U))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=te;function Q(ie){let U=null;for(let W=0,ue=ie.length;W<ue;W++){const we=ie[W].substituteConstants();if(ie[W]!==we&&U===null){U=[];for(let Ee=0;Ee<W;Ee++)U[Ee]=ie[Ee]}U!==null&&(U[W]=we)}return U===null?ie:U}class Se{static create(U,W,ue){return Se._normalizeArr(U,W,ue)}constructor(U,W){this.expr=U,this.negated=W,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let W=0,ue=this.expr.length;W<ue;W++){const we=o(this.expr[W],U.expr[W]);if(we!==0)return we}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let W=0,ue=this.expr.length;W<ue;W++)if(!this.expr[W].equals(U.expr[W]))return!1;return!0}return!1}substituteConstants(){const U=Q(this.expr);return U===this.expr?this:Se.create(U,this.negated,!1)}evaluate(U){for(let W=0,ue=this.expr.length;W<ue;W++)if(!this.expr[W].evaluate(U))return!1;return!0}static _normalizeArr(U,W,ue){const we=[];let Ee=!1;for(const ge of U)if(ge){if(ge.type===1){Ee=!0;continue}if(ge.type===0)return S.INSTANCE;if(ge.type===6){we.push(...ge.expr);continue}we.push(ge)}if(we.length===0&&Ee)return h.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];for(;we.length>1;){const ge=we[we.length-1];if(ge.type!==9)break;we.pop();const ye=we.pop(),re=we.length===0,de=_e.create(ge.expr.map(se=>Se.create([se,ye],null,ue)),null,re);de&&(we.push(de),we.sort(o))}if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ye=ge+1;ye<we.length;ye++)if(we[ge].negate().equals(we[ye]))return S.INSTANCE;if(we.length===1)return we[0]}return new Se(we,W)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const W of this.expr)U.push(...W.keys());return U}map(U){return new Se(this.expr.map(W=>W.map(U)),null)}negate(){if(!this.negated){const U=[];for(const W of this.expr)U.push(W.negate());this.negated=_e.create(U,this,!0)}return this.negated}}e.ContextKeyAndExpr=Se;class _e{static create(U,W,ue){return _e._normalizeArr(U,W,ue)}constructor(U,W){this.expr=U,this.negated=W,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let W=0,ue=this.expr.length;W<ue;W++){const we=o(this.expr[W],U.expr[W]);if(we!==0)return we}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let W=0,ue=this.expr.length;W<ue;W++)if(!this.expr[W].equals(U.expr[W]))return!1;return!0}return!1}substituteConstants(){const U=Q(this.expr);return U===this.expr?this:_e.create(U,this.negated,!1)}evaluate(U){for(let W=0,ue=this.expr.length;W<ue;W++)if(this.expr[W].evaluate(U))return!0;return!1}static _normalizeArr(U,W,ue){let we=[],Ee=!1;if(U){for(let ge=0,ye=U.length;ge<ye;ge++){const re=U[ge];if(re){if(re.type===0){Ee=!0;continue}if(re.type===1)return h.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&Ee)return S.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ye=ge+1;ye<we.length;ye++)if(we[ge].negate().equals(we[ye]))return h.INSTANCE;if(we.length===1)return we[0]}return new _e(we,W)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const W of this.expr)U.push(...W.keys());return U}map(U){return new _e(this.expr.map(W=>W.map(U)),null)}negate(){if(!this.negated){const U=[];for(const W of this.expr)U.push(W.negate());for(;U.length>1;){const W=U.shift(),ue=U.shift(),we=[];for(const Ee of pe(W))for(const ge of pe(ue))we.push(Se.create([Ee,ge],null,!1));U.unshift(_e.create(we,null,!1))}this.negated=_e.create(U,this,!0)}return this.negated}}e.ContextKeyOrExpr=_e;class Pe extends I{static{this._info=[]}static all(){return Pe._info.values()}constructor(U,W,ue){super(U,null),this._defaultValue=W,typeof ue=="object"?Pe._info.push({...ue,key:U}):ue!==!0&&Pe._info.push({key:U,description:ue,type:W!=null?typeof W:void 0})}bindTo(U){return U.createKey(this.key,this._defaultValue)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return C.create(this.key,U)}notEqualsTo(U){return d.create(this.key,U)}}e.RawContextKey=Pe,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function Y(ie,U){return ie<U?-1:ie>U?1:0}function ae(ie,U,W,ue){return ie<W?-1:ie>W?1:U<ue?-1:U>ue?1:0}function Ce(ie,U){if(ie.type===0||U.type===1)return!0;if(ie.type===9)return U.type===9?le(ie.expr,U.expr):!1;if(U.type===9){for(const W of U.expr)if(Ce(ie,W))return!0;return!1}if(ie.type===6){if(U.type===6)return le(U.expr,ie.expr);for(const W of ie.expr)if(Ce(W,U))return!0;return!1}return ie.equals(U)}e.implies=Ce;function le(ie,U){let W=0,ue=0;for(;W<ie.length&&ue<U.length;){const we=ie[W].cmp(U[ue]);if(we<0)return!1;we===0&&W++,ue++}return W===ie.length}function pe(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[171],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[92],Re([1,0,140,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function u(c,b){return b==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=u;function y(c,b,_){return u(b,_)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===_?!0:m(_).includes(c)}e.isTargetPlatformCompatible=y;function m(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var v;(function(c){c.Install="install",c.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var p;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(b,_){super(b),this.code=_,this.name=_}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,49,19,15,16,2,142,4,22,13]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function D(Y){return Y.create===!0}e.isFileOpenForWriteOptions=D;var a;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var v;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var p;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function f(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=f;function t(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=t;function i(Y){return!!(Y.capabilities&131072)}e.hasFileCloneCapability=i;function c(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function b(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=b;function _(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=_;function E(Y){return f(Y)?!!(Y.capabilities&32768):!1}e.hasFileAtomicWriteCapability=E;function r(Y){return!!(Y.capabilities&65536)}e.hasFileAtomicDeleteCapability=r;function s(Y){return!!(Y.capabilities&2048)}e.hasReadonlyCapability=s;var n;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class o extends Error{static create(ae,Ce){const le=new o(ae.toString(),Ce);return I(le,Ce),le}constructor(ae,Ce){super(ae),this.code=Ce}}e.FileSystemProviderError=o;function S(Y,ae){return o.create(Y,ae)}e.createFileSystemProviderError=S;function h(Y){return Y||S((0,u.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=h;function I(Y,ae){return Y.name=ae?`${ae} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=I;function C(Y){if(!Y)return n.Unknown;if(Y instanceof o)return Y.code;const ae=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!ae)return n.Unknown;switch(ae[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=C;function l(Y){if(Y instanceof x)return Y.fileOperationResult;switch(C(Y)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=l;var g;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(g||(e.FileOperation=g={}));class d{constructor(ae,Ce,le){this.resource=ae,this.operation=Ce,this.target=le}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=d;var T;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class z{constructor(ae,Ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const le=new Map;for(const pe of ae){const ie=le.get(pe.type);switch(ie?ie.push([pe.resource,pe]):le.set(pe.type,[[pe.resource,pe]]),pe.type){case 1:this.rawAdded.push(pe.resource);break;case 0:this.rawUpdated.push(pe.resource);break;case 2:this.rawDeleted.push(pe.resource);break}}for(const[pe,ie]of le)switch(pe){case 1:this.added=w.TernarySearchTree.forUris(()=>Ce),this.added.fill(ie);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>Ce),this.updated.fill(ie);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>Ce),this.deleted.fill(ie);break}}contains(ae,...Ce){return this.doContains(ae,{includeChildren:!1},...Ce)}affects(ae,...Ce){return this.doContains(ae,{includeChildren:!0},...Ce)}doContains(ae,Ce,...le){if(!ae)return!1;const pe=le.length>0;return!!((!pe||le.includes(1))&&(this.added?.get(ae)||Ce.includeChildren&&this.added?.findSuperstr(ae))||(!pe||le.includes(0))&&(this.updated?.get(ae)||Ce.includeChildren&&this.updated?.findSuperstr(ae))||(!pe||le.includes(2))&&(this.deleted?.findSubstr(ae)||Ce.includeChildren&&this.deleted?.findSuperstr(ae)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=z;function H(Y,ae,Ce){return!Y||!ae||Y===ae||ae.length>Y.length?!1:(ae.charAt(ae.length-1)!==R.sep&&(ae+=R.sep),Ce?(0,k.startsWithIgnoreCase)(Y,ae):Y.indexOf(ae)===0)}e.isParent=H;class x extends Error{constructor(ae,Ce,le){super(ae),this.fileOperationResult=Ce,this.options=le}}e.FileOperationError=x;class $ extends x{constructor(ae,Ce,le,pe){super(ae,Ce,pe),this.fileOperationResult=Ce,this.size=le}}e.TooLargeFileOperationError=$;class N extends x{constructor(ae,Ce,le){super(ae,2,le),this.stat=Ce}}e.NotModifiedSinceFileOperationError=N;var M;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var te;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.ETAG_DISABLED="";function Q(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=Q;async function Se(Y,ae){if(!ae.hasProvider(A.URI.from({scheme:Y.scheme})))return new Promise(Ce=>{const le=ae.onDidChangeFileSystemProviderRegistrations(pe=>{pe.scheme===Y.scheme&&pe.added&&(le.dispose(),Ce())})})}e.whenProviderRegistered=Se;class _e{static{this.KB=1024}static{this.MB=_e.KB*_e.KB}static{this.GB=_e.MB*_e.KB}static{this.TB=_e.GB*_e.KB}static formatSize(ae){return(0,L.isNumber)(ae)||(ae=0),ae<_e.KB?(0,u.localize)(1,null,ae.toFixed(0)):ae<_e.MB?(0,u.localize)(2,null,(ae/_e.KB).toFixed(2)):ae<_e.GB?(0,u.localize)(3,null,(ae/_e.MB).toFixed(2)):ae<_e.TB?(0,u.localize)(4,null,(ae/_e.GB).toFixed(2)):(0,u.localize)(5,null,(ae/_e.TB).toFixed(2))}}e.ByteSize=_e;function Pe(Y){const ae=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*_e.MB:ae?10*_e.MB:m.isWeb?50*_e.MB:1024*_e.MB}e.getLargeFileConfirmationLimit=Pe}),define(Ae[70],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[L,A]of k)this.set(L,A)}set(k,L){const A=this._entries.get(k);return this._entries.set(k,L),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(Ae[172],Re([1,0,12,9,6,68,170,4,70,173]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new y.ServiceCollection,i=!1,c,b=P){this._services=t,this._strict=i,this._parent=c,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(u.IInstantiationService,this),this._globalGraph=b?c?._globalGraph??new A.Graph(_=>_):void 0}createChild(t){return new a(t,this._strict,this,this._enableTracing)}invokeFunction(t,...i){const c=p.traceInvocation(this._enableTracing,t);let b=!1;try{return t({get:E=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(E,c);if(!r)throw new Error(`[invokeFunction] unknown service '${E}'`);return r}},...i)}finally{b=!0,c.stop()}}createInstance(t,...i){let c,b;return t instanceof L.SyncDescriptor?(c=p.traceCreation(this._enableTracing,t.ctor),b=this._createInstance(t.ctor,t.staticArguments.concat(i),c)):(c=p.traceCreation(this._enableTracing,t),b=this._createInstance(t,i,c)),c.stop(),b}_createInstance(t,i=[],c){const b=u._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),_=[];for(const r of b){const s=this._getOrCreateServiceInstance(r.id,c);s||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),_.push(s)}const E=b.length>0?b[0].index:i.length;if(i.length!==E){console.trace(`[createInstance] First service dependency of ${t.name} at position ${E+1} conflicts with ${i.length} static arguments`);const r=E-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,E)}return Reflect.construct(t,i.concat(_))}_setServiceInstance(t,i){if(this._services.get(t)instanceof L.SyncDescriptor)this._services.set(t,i);else if(this._parent)this._parent._setServiceInstance(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const i=this._services.get(t);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):i}_getOrCreateServiceInstance(t,i){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const c=this._getServiceInstanceOrDescriptor(t);return c instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}_safeCreateAndCacheServiceInstance(t,i,c){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,i,c)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,i,c){const b=new A.Graph(r=>r.id.toString());let _=0;const E=[{id:t,desc:i,_trace:c}];for(;E.length;){const r=E.pop();if(b.lookupOrInsertNode(r),_++>1e3)throw new D(b);for(const s of u._util.getServiceDependencies(r.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(s.id);if(n||this._throwIfStrict(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),n instanceof L.SyncDescriptor){const o={id:s.id,desc:n,_trace:r._trace.branch(s.id,!0)};b.insertEdge(r,o),E.push(o)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const o=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,o)}b.removeNode(s)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,i,c=[],b,_){if(this._services.get(t)instanceof L.SyncDescriptor)return this._createServiceInstance(t,i,c,b,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,i,c,b,_);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(t,i,c=[],b,_){if(b){const E=new a(void 0,this._strict,this,this._enableTracing);E._globalGraphImplicitDependency=String(t);const r=new Map,s=new w.IdleValue(()=>{const n=E._createInstance(i,c,_);for(const[o,S]of r){const h=n[o];if(typeof h=="function")for(const I of S)h.apply(n,I)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=r.get(o);return I||(I=new m.LinkedList,r.set(o,I)),(l,g,d)=>{const T=I.push([l,g,d]);return(0,k.toDisposable)(T)}}if(o in n)return n[o];const S=s.value;let h=S[o];return typeof h!="function"||(h=h.bind(S),n[o]=h),h},set(n,o,S){return s.value[o]=S,!0},getPrototypeOf(n){return i.prototype}})}else return this._createInstance(i,c,_)}_throwIfStrict(t,i){if(i&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=a;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(t,i){return t?new p(1,i.name):p._None}static{this._totals=0}constructor(t,i){this.type=t,this.name=i,this._start=Date.now(),this._dep=[]}branch(t,i){const c=new p(3,t.toString());return this._dep.push([t,i,c]),c}stop(){const t=Date.now()-this._start;p._totals+=t;let i=!1;function c(_,E){const r=[],s=new Array(_+1).join("	");for(const[n,o,S]of E._dep)if(o&&S){i=!0,r.push(`${s}CREATES -> ${n}`);const h=c(_+1,S);h&&r.push(h)}else r.push(`${s}uses -> ${n}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||i)&&p.all.add(b.join(`
`))}}e.Trace=p}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,a.createDecorator)("logService"),e.ILoggerService=(0,a.createDecorator)("loggerService");function v(){return new Date().toISOString()}function p(l){return(0,m.isNumber)(l)}e.isLogLevel=p;var f;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(f||(e.LogLevel=f={})),e.DEFAULT_LOG_LEVEL=f.Info;function t(l,g,d){switch(g){case f.Trace:l.trace(d);break;case f.Debug:l.debug(d);break;case f.Info:l.info(d);break;case f.Warning:l.warn(d);break;case f.Error:l.error(d);break;case f.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=t;function i(l,g=!1){let d="";for(let T=0;T<l.length;T++){let z=l[T];if(z instanceof Error&&(z=(0,w.toErrorMessage)(z,g)),typeof z=="object")try{z=JSON.stringify(z)}catch{}d+=(T>0?" ":"")+z}return d}class c extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(g){this.level!==g&&(this.level=g,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(g){return this.level!==f.Off&&this.level<=g}}e.AbstractLogger=c;class b extends c{constructor(g){super(),this.logAlways=g}checkLogLevel(g){return this.logAlways||super.checkLogLevel(g)}trace(g,...d){this.checkLogLevel(f.Trace)&&this.log(f.Trace,i([g,...d],!0))}debug(g,...d){this.checkLogLevel(f.Debug)&&this.log(f.Debug,i([g,...d]))}info(g,...d){this.checkLogLevel(f.Info)&&this.log(f.Info,i([g,...d]))}warn(g,...d){this.checkLogLevel(f.Warning)&&this.log(f.Warning,i([g,...d]))}error(g,...d){if(this.checkLogLevel(f.Error))if(g instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=g.stack,this.log(f.Error,i(T))}else this.log(f.Error,i([g,...d]))}flush(){}}e.AbstractMessageLogger=b;class _ extends c{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.useColors=!u.isWindows}trace(g,...d){this.checkLogLevel(f.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,g,...d):console.log(`[main ${v()}]`,g,...d))}debug(g,...d){this.checkLogLevel(f.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,g,...d):console.log(`[main ${v()}]`,g,...d))}info(g,...d){this.checkLogLevel(f.Info)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,g,...d):console.log(`[main ${v()}]`,g,...d))}warn(g,...d){this.checkLogLevel(f.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,g,...d):console.warn(`[main ${v()}]`,g,...d))}error(g,...d){this.checkLogLevel(f.Error)&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,g,...d):console.error(`[main ${v()}]`,g,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class E extends c{constructor(g=e.DEFAULT_LOG_LEVEL,d=!0){super(),this.useColors=d,this.setLevel(g)}trace(g,...d){this.checkLogLevel(f.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",g,...d):console.log(g,...d))}debug(g,...d){this.checkLogLevel(f.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",g,...d):console.log(g,...d))}info(g,...d){this.checkLogLevel(f.Info)&&(this.useColors?console.log("%c INFO","color: #33f",g,...d):console.log(g,...d))}warn(g,...d){this.checkLogLevel(f.Warning)&&(this.useColors?console.log("%c WARN","color: #993",g,...d):console.log(g,...d))}error(g,...d){this.checkLogLevel(f.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",g,...d):console.error(g,...d))}dispose(){}flush(){}}e.ConsoleLogger=E;class r extends c{constructor(g,d=e.DEFAULT_LOG_LEVEL){super(),this.adapter=g,this.setLevel(d)}trace(g,...d){this.checkLogLevel(f.Trace)&&this.adapter.log(f.Trace,[this.extractMessage(g),...d])}debug(g,...d){this.checkLogLevel(f.Debug)&&this.adapter.log(f.Debug,[this.extractMessage(g),...d])}info(g,...d){this.checkLogLevel(f.Info)&&this.adapter.log(f.Info,[this.extractMessage(g),...d])}warn(g,...d){this.checkLogLevel(f.Warning)&&this.adapter.log(f.Warning,[this.extractMessage(g),...d])}error(g,...d){this.checkLogLevel(f.Error)&&this.adapter.log(f.Error,[this.extractMessage(g),...d])}extractMessage(g){return typeof g=="string"?g:(0,w.toErrorMessage)(g,this.checkLogLevel(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=r;class s extends c{constructor(g){super(),this.loggers=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const d of this.loggers)d.setLevel(g);super.setLevel(g)}trace(g,...d){for(const T of this.loggers)T.trace(g,...d)}debug(g,...d){for(const T of this.loggers)T.debug(g,...d)}info(g,...d){for(const T of this.loggers)T.info(g,...d)}warn(g,...d){for(const T of this.loggers)T.warn(g,...d)}error(g,...d){for(const T of this.loggers)T.error(g,...d)}flush(){for(const g of this.loggers)g.flush()}dispose(){for(const g of this.loggers)g.dispose()}}e.MultiplexLogger=s;class n extends L.Disposable{constructor(g,d,T){if(super(),this.logLevel=g,this.logsHome=d,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new R.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const z of T)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(g){return(0,m.isString)(g)?[...this._loggers.values()].find(d=>d.info.id===g):this._loggers.get(g)}getLogger(g){return this.getLoggerEntry(g)?.logger}createLogger(g,d){const T=this.toResource(g),z=(0,m.isString)(g)?g:d?.id??(0,k.hash)(T.toString()).toString(16);let H=this._loggers.get(T)?.logger;const x=d?.logLevel==="always"?f.Trace:d?.logLevel;H||(H=this.doCreateLogger(T,x??this.getLogLevel(T)??this.logLevel,{...d,id:z}));const $={logger:H,info:{resource:T,id:z,logLevel:x,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId,when:d?.when}};return this.registerLogger($.info),this._loggers.set(T,$),H}toResource(g){return(0,m.isString)(g)?(0,y.joinPath)(this.logsHome,`${g}.log`):g}setLogLevel(g,d){if(P.URI.isUri(g)){const T=g,z=d,H=this._loggers.get(T);H&&z!==H.info.logLevel&&(H.info.logLevel=z===this.logLevel?void 0:z,H.logger?.setLevel(z),this._loggers.set(H.info.resource,H),this._onDidChangeLogLevel.fire([T,z]))}else{this.logLevel=g;for(const[T,z]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(g,d){const T=this.getLoggerEntry(g);T&&d!==!T.info.hidden&&(T.info.hidden=!d,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,d]))}getLogLevel(g){let d;return g&&(d=this._loggers.get(g)?.info.logLevel),d??this.logLevel}registerLogger(g){const d=this._loggers.get(g.resource);d?d.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this._loggers.set(g.resource,{info:g,logger:void 0}),this._onDidChangeLoggers.fire({added:[g],removed:[]}))}deregisterLogger(g){const d=this._loggers.get(g);d&&(d.logger&&d.logger.dispose(),this._loggers.delete(g),this._onDidChangeLoggers.fire({added:[],removed:[d.info]}))}*getRegisteredLoggers(){for(const g of this._loggers.values())yield g.info}getRegisteredLogger(g){return this._loggers.get(g)?.info}dispose(){this._loggers.forEach(g=>g.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class o{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(g){}getLevel(){return f.Info}trace(g,...d){}debug(g,...d){}info(g,...d){}warn(g,...d){}error(g,...d){}critical(g,...d){}dispose(){}flush(){}}e.NullLogger=o;class S extends o{}e.NullLogService=S;function h(l){if(l.verbose)return f.Trace;if(typeof l.logLevel=="string"){const g=C(l.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function I(l){switch(l){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=I;function C(l){switch(l){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",I(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends w.Disposable{constructor(A,u=[]){super(),this.logger=new R.MultiplexLogger([A,...u]),this._register(A.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...u){this.logger.trace(A,...u)}debug(A,...u){this.logger.debug(A,...u)}info(A,...u){this.logger.info(A,...u)}warn(A,...u){this.logger.warn(A,...u)}error(A,...u){this.logger.error(A,...u)}flush(){this.logger.flush()}}e.LogService=k}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(y){function m(p,f){return f-p}y.compare=m;const P=Object.create(null);P[y.Error]=(0,R.localize)(0,null),P[y.Warning]=(0,R.localize)(1,null),P[y.Info]=(0,R.localize)(2,null);function D(p){return P[p]||""}y.toString=D;function a(p){switch(p){case w.default.Error:return y.Error;case w.default.Warning:return y.Warning;case w.default.Info:return y.Info;case w.default.Ignore:return y.Hint}}y.fromSeverity=a;function v(p){switch(p){case y.Error:return w.default.Error;case y.Warning:return w.default.Warning;case y.Info:return w.default.Info;case y.Hint:return w.default.Ignore}}y.toSeverity=v}(A||(e.MarkerSeverity=A={}));var u;(function(y){const m="";function P(a){return D(a,!0)}y.makeKey=P;function D(a,v){const p=[m];return a.source?p.push(a.source.replace("\xA6","\\\xA6")):p.push(m),a.code?typeof a.code=="string"?p.push(a.code.replace("\xA6","\\\xA6")):p.push(a.code.value.replace("\xA6","\\\xA6")):p.push(m),a.severity!==void 0&&a.severity!==null?p.push(A.toString(a.severity)):p.push(m),a.message&&v?p.push(a.message.replace("\xA6","\\\xA6")):p.push(m),a.startLineNumber!==void 0&&a.startLineNumber!==null?p.push(a.startLineNumber.toString()):p.push(m),a.startColumn!==void 0&&a.startColumn!==null?p.push(a.startColumn.toString()):p.push(m),a.endLineNumber!==void 0&&a.endLineNumber!==null?p.push(a.endLineNumber.toString()):p.push(m),a.endColumn!==void 0&&a.endColumn!==null?p.push(a.endColumn.toString()):p.push(m),p.push(m),p.join("\xA6")}y.makeKeyOptionalMessage=D})(u||(e.IMarkerData=u={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,k.createDecorator)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var u;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(u||(e.NotificationsFilter=u={}));class y{constructor(){this.progress=new m,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=y;class m{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=m}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function L(m,P){return R.URI.isUri(m)?(0,w.equalsIgnoreCase)(m.scheme,P):(0,w.startsWithIgnoreCase)(m,P+":")}e.matchesScheme=L;function A(m,...P){return P.some(D=>L(m,D))}e.matchesSomeScheme=A;function u(m,P){return m.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.withSelection=u;function y(m){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},m=m.with({fragment:""})),{selection:P,uri:m}}e.extractSelection=y}),define(Ae[176],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(be,e,w,R){var k=arguments.length,L=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,w,R);else for(var u=be.length-1;u>=0;u--)(A=be[u])&&(L=(k<3?A(L):k>3?A(e,w,L):A(e,w))||L);return k>3&&L&&Object.defineProperty(e,w,L),L},ze=this&&this.__param||function(be,e){return function(w,R){e(w,R,be)}};define(Ae[71],Re([1,0,12,21,6,4]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class u{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(D,a){this.callback=D,this.report=a?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(D){this._value=D,this.callback(this._value)}_reportAsync(D){this._asyncQueue?this._asyncQueue.push(D):this._asyncQueue=[D],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const D=this._asyncQueue.shift();this._value=D,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const D=this._drainListener;this._drainListener=void 0,D?.()}}drain(){return this._processingAsyncQueue?new Promise(D=>{const a=this._drainListener;this._drainListener=()=>{a?.(),D()}}):Promise.resolve()}}e.Progress=u;let y=class extends k.Disposable{constructor(D,a){super(),this.deferred=new w.DeferredPromise,a.withProgress(D,v=>(this.reporter=v,this.lastStep&&v.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ve([ze(1,e.IProgressService)],y);class m extends k.Disposable{constructor(D){super(),this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(D){this.stop();const a=++this.currentOperationId,v=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>v.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:v.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,u){w.ok(R.isString(A)),w.ok(R.isObject(u)),w.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,u)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(Ae[72],Re([1,0,5,30]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(u){return u.length>0&&u.charAt(u.length-1)==="#"?u.substring(0,u.length-1):u}class L{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,m){this.schemasById[k(y)]=m,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;R.Registry.add(e.Extensions.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,137,43,72,30]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=y.Registry.as(u.Extensions.JSONContribution);class a{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const n=new Set;this.doRegisterConfigurations(r,s,n),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const s=new Set;this.doDeregisterConfigurations(r,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:r,remove:s}){const n=new Set;this.doDeregisterConfigurations(s,n),this.doRegisterConfigurations(r,!1,n),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(r){const s=new Set;this.doRegisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,s){const n=[];for(const{overrides:o,source:S}of r)for(const h in o)if(s.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const I=this.configurationDefaultsOverrides.get(h),C=I?.valuesSources??new Map;if(S)for(const T of Object.keys(o[h]))C.set(T,S);const l={...I?.value||{},...o[h]};this.configurationDefaultsOverrides.set(h,{source:S,value:l,valuesSources:C});const g=(0,A.getLanguageTagSettingPlainKey)(h),d={type:"object",default:l,description:L.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:k.isString(S)?void 0:S,defaultValueSource:S};n.push(...f(h)),this.configurationProperties[h]=d,this.defaultLanguageConfigurationOverridesNode.properties[h]=d}else{this.configurationDefaultsOverrides.set(h,{value:o[h],source:S});const I=this.configurationProperties[h];I&&(this.updatePropertyDefaultValue(h,I),this.updateSchema(h,I))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(r){const s=new Set;this.doDeregisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,s){for(const{overrides:n,source:o}of r)for(const S in n){const h=this.configurationDefaultsOverrides.get(S),I=k.isString(o)?o:o?.id,C=k.isString(h?.source)?h?.source:h?.source?.id;if(I===C)if(s.add(S),this.configurationDefaultsOverrides.delete(S),e.OVERRIDE_PROPERTY_REGEX.test(S))delete this.configurationProperties[S],delete this.defaultLanguageConfigurationOverridesNode.properties[S];else{const l=this.configurationProperties[S];l&&(this.updatePropertyDefaultValue(S,l),this.updateSchema(S,l))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let s=!1;const n=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,n),s=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,n),s=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,n),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const s of r)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,s,n){r.forEach(o=>{this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties,void 0,n),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(r,s){const n=o=>{if(o.properties)for(const S in o.properties){s.add(S);const h=this.configurationProperties[S];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[S],this.removeFromSchema(S,o.properties[S])}o.allOf?.forEach(S=>n(S))};for(const o of r){n(o);const S=this.configurationContributors.indexOf(o);S!==-1&&this.configurationContributors.splice(S,1)}}validateAndRegisterProperties(r,s=!0,n,o,S=3,h){S=k.isUndefinedOrNull(r.scope)?S:r.scope;const I=r.properties;if(I)for(const l in I){const g=I[l];if(s&&b(l,g)){delete I[l];continue}if(g.source=n,g.defaultDefaultValue=I[l].default,this.updatePropertyDefaultValue(l,g),e.OVERRIDE_PROPERTY_REGEX.test(l)?g.scope=void 0:(g.scope=k.isUndefinedOrNull(g.scope)?S:g.scope,g.restricted=k.isUndefinedOrNull(g.restricted)?!!o?.includes(l):g.restricted),I[l].hasOwnProperty("included")&&!I[l].included){this.excludedConfigurationProperties[l]=I[l],delete I[l];continue}else this.configurationProperties[l]=I[l],I[l].policy?.name&&this.policyConfigurations.set(I[l].policy.name,l);!I[l].deprecationMessage&&I[l].markdownDeprecationMessage&&(I[l].deprecationMessage=I[l].markdownDeprecationMessage),h.add(l)}const C=r.allOf;if(C)for(const l of C)this.validateAndRegisterProperties(l,s,n,o,S,h)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const s=n=>{const o=n.properties;if(o)for(const h in o)this.updateSchema(h,o[h]);n.allOf?.forEach(s)};s(r)}updateSchema(r,s){switch(e.allSettings.properties[r]=s,s.scope){case 1:e.applicationSettings.properties[r]=s;break;case 2:e.machineSettings.properties[r]=s;break;case 6:e.machineOverridableSettings.properties[r]=s;break;case 3:e.windowSettings.properties[r]=s;break;case 4:e.resourceSettings.properties[r]=s;break;case 5:e.resourceSettings.properties[r]=s,this.resourceLanguageSettingsSchema.properties[r]=s;break}}removeFromSchema(r,s){switch(delete e.allSettings.properties[r],s.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const s=`[${r}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,n),e.allSettings.properties[s]=n,e.applicationSettings.properties[s]=n,e.machineSettings.properties[s]=n,e.machineOverridableSettings.properties[s]=n,e.windowSettings.properties[s]=n,e.resourceSettings.properties[s]=n}}registerOverridePropertyPatternKey(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,s){const n=this.configurationDefaultsOverrides.get(r);let o=n?.value,S=n?.source;k.isUndefined(o)&&(o=s.defaultDefaultValue,S=void 0),k.isUndefined(o)&&(o=i(s.type)),s.default=o,s.defaultValueSource=S}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(E){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let s=p.exec(E);for(;s?.length;){const n=s[1].trim();n&&r.push(n),s=p.exec(E)}}return(0,w.distinct)(r)}e.overrideIdentifiersFromKey=f;function t(E){return E.reduce((r,s)=>`${r}[${s}]`,"")}e.keyFromOverrideIdentifiers=t;function i(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=i;const c=new a;y.Registry.add(e.Extensions.Configuration,c);function b(E,r){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?L.localize(7,null,E):c.getConfigurationProperties()[E]!==void 0?L.localize(8,null,E):r.policy?.name&&c.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,E,r.policy?.name,c.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function _(){const E=[],r=c.getConfigurationProperties();for(const s of Object.keys(r))E.push([s,r[s].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=_}),define(Ae[177],Re([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(s){return Object.isFrozen(s)?s:u.deepFreeze(s)}class p{constructor(n={},o=[],S=[],h){this._contents=n,this._keys=o,this._overrides=S,this.raw=h,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof p)return o;const S=new f("");return S.parseRaw(o),S.configurationModel});this._rawConfiguration=n.reduce((o,S)=>S===o?S:o.merge(S),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,o){const S=this.rawConfiguration.getValue(n),h=o?this.rawConfiguration.getOverrideValue(n,o):void 0,I=o?this.rawConfiguration.override(o).getValue(n):S;return{value:S,override:h,merged:I}}getOverrideValue(n,o){const S=this.getContentsForOverrideIdentifer(o);return S?n?(0,P.getConfigurationValue)(S,n):S:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const S of this.overrides)S.identifiers.includes(n)&&o.push(...S.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return w.distinct(n)}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=u.deepClone(this.contents),S=u.deepClone(this.overrides),h=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const C of n)if(I.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(o,C.contents);for(const l of C.overrides){const[g]=S.filter(d=>w.equals(d.identifiers,l.identifiers));g?(this.mergeContents(g.contents,l.contents),g.keys.push(...l.keys),g.keys=w.distinct(g.keys)):S.push(u.deepClone(l))}for(const l of C.keys)h.indexOf(l)===-1&&h.push(l)}return new p(o,h,S,I.every(C=>C instanceof p)?void 0:I)}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const S={};for(const h of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[h];const C=o[h];C&&(typeof I=="object"&&typeof C=="object"?(I=u.deepClone(I),this.mergeContents(I,C)):I=C),S[h]=I}return new p(S,this.keys,this.overrides)}mergeContents(n,o){for(const S of Object.keys(o)){if(S in n&&y.isObject(n[S])&&y.isObject(o[S])){this.mergeContents(n[S],o[S]);continue}n[S]=u.deepClone(o[S])}}getContentsForOverrideIdentifer(n){let o=null,S=null;const h=I=>{I&&(S?this.mergeContents(S,I):S=u.deepClone(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?o=I.contents:I.identifiers.includes(n)&&h(I.contents);return h(o),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.updateValue(n,o,!0)}setValue(n,o){this.updateValue(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,P.removeFromValueTree)(this.contents,n),D.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(S=>w.equals(S.identifiers,(0,D.overrideIdentifiersFromKey)(n))),1))}updateValue(n,o,S){(0,P.addToValueTree)(this.contents,n,o,h=>console.error(h)),S=S||this.keys.indexOf(n)===-1,S&&this.keys.push(n),D.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],h=>console.error(h))})}}e.ConfigurationModel=p;class f{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!y.isUndefinedOrNull(n)){const S=this.doParseContent(n);this.parseRaw(S,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:S,keys:h,overrides:I,restricted:C,hasExcludedProperties:l}=this.doParseRaw(n,o);this._configurationModel=new p(S,h,I,l?[n]:void 0),this._restrictedConfigurations=C||[]}doParseContent(n){let o={},S=null,h=[];const I=[],C=[];function l(d){Array.isArray(h)?h.push(d):S!==null&&(h[S]=d)}const g={onObjectBegin:()=>{const d={};l(d),I.push(h),h=d,S=null},onObjectProperty:d=>{S=d},onObjectEnd:()=>{h=I.pop()},onArrayBegin:()=>{const d=[];l(d),I.push(h),h=d,S=null},onArrayEnd:()=>{h=I.pop()},onLiteralValue:l,onError:(d,T,z)=>{C.push({error:d,offset:T,length:z})}};if(n)try{k.visit(n,g),o=h[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return o}doParseRaw(n,o){const S=a.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),h=this.filter(n,S,!0,o);n=h.raw;const I=(0,P.toValuesTree)(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),C=Object.keys(n),l=this.toOverrides(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:I,keys:C,overrides:l,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}filter(n,o,S,h){let I=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const C={},l=[];for(const g in n)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&S){const d=this.filter(n[g],o,!1,h);C[g]=d.raw,I=I||d.hasExcludedProperties,l.push(...d.restricted)}else{const d=o[g],T=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&l.push(g),!h.exclude?.includes(g)&&(h.include?.includes(g)||(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&!(h.skipRestricted&&d?.restricted))?C[g]=n[g]:I=!0}return{raw:C,restricted:l,hasExcludedProperties:I}}toOverrides(n,o){const S=[];for(const h of Object.keys(n))if(D.OVERRIDE_PROPERTY_REGEX.test(h)){const I={};for(const C in n[h])I[C]=n[h][C];S.push({identifiers:(0,D.overrideIdentifiersFromKey)(h),keys:Object.keys(I),contents:(0,P.toValuesTree)(I,o)})}return S}}e.ConfigurationModelParser=f;class t extends L.Disposable{constructor(n,o,S,h){super(),this.userSettingsResource=n,this.parseOptions=o,this.fileService=h,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this._register(this.fileService.watch(S.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,I=>I.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&S.isEqual(I.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class i{constructor(n,o,S,h,I,C,l,g,d,T,z,H,x){this.key=n,this.overrides=o,this._value=S,this.overrideIdentifiers=h,this.defaultConfiguration=I,this.policyConfiguration=C,this.applicationConfiguration=l,this.userConfiguration=g,this.localUserConfiguration=d,this.remoteUserConfiguration=T,this.workspaceConfiguration=z,this.folderConfigurationModel=H,this.memoryConfigurationModel=x}get value(){return v(this._value)}inspect(n,o,S){const h=n.inspect(o,S);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(n,o,S,h,I=new p,C=new p,l=new A.ResourceMap,g=new p,d=new A.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=o,this._applicationConfiguration=S,this._localUserConfiguration=h,this._remoteUserConfiguration=I,this._workspaceConfiguration=C,this._folderConfigurations=l,this._memoryConfiguration=g,this._memoryConfigurationByResource=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,o,S){return this.getConsolidatedConfigurationModel(n,o,S).getValue(n)}updateValue(n,o,S={}){let h;S.resource?(h=this._memoryConfigurationByResource.get(S.resource),h||(h=new p,this._memoryConfigurationByResource.set(S.resource,h))):h=this._memoryConfiguration,o===void 0?h.removeValue(n):h.setValue(n,o),S.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,S){const h=this.getConsolidatedConfigurationModel(n,o,S),I=this.getFolderConfigurationModelForResource(o.resource,S),C=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=new Set;for(const g of h.overrides)for(const d of g.identifiers)h.getOverrideValue(n,d)!==void 0&&l.add(d);return new i(n,o,h.getValue(n),l.size?[...l]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this._workspaceConfiguration:void 0,I||void 0,C)}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const S=[];if(!o){const{added:h,updated:I,removed:C}=E(this._defaultConfiguration,n);o=[...h,...I,...C]}for(const h of o)for(const I of(0,D.overrideIdentifiersFromKey)(h)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(I),l=n.getKeysForOverrideIdentifier(I),g=[...l.filter(d=>C.indexOf(d)===-1),...C.filter(d=>l.indexOf(d)===-1),...C.filter(d=>!u.equals(this._defaultConfiguration.override(I).getValue(d),n.override(I).getValue(d)))];S.push([I,g])}return this.updateDefaultConfiguration(n),{keys:o,overrides:S}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:S,removed:h}=E(this._policyConfiguration,n),I=[...o,...S,...h];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:S,removed:h,overrides:I}=E(this.applicationConfiguration,n),C=[...o,...S,...h];return C.length&&this.updateApplicationConfiguration(n),{keys:C,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:S,removed:h,overrides:I}=E(this.localUserConfiguration,n),C=[...o,...S,...h];return C.length&&this.updateLocalUserConfiguration(n),{keys:C,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:S,removed:h,overrides:I}=E(this.remoteUserConfiguration,n),C=[...o,...S,...h];return C.length&&this.updateRemoteUserConfiguration(n),{keys:C,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:S,removed:h,overrides:I}=E(this.workspaceConfiguration,n),C=[...o,...S,...h];return C.length&&this.updateWorkspaceConfiguration(n),{keys:C,overrides:I}}compareAndUpdateFolderConfiguration(n,o){const S=this.folderConfigurations.get(n),{added:h,updated:I,removed:C,overrides:l}=E(S,o),g=[...h,...I,...C];return(g.length||!S)&&this.updateFolderConfiguration(n,o),{keys:g,overrides:l}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:S,updated:h,removed:I,overrides:C}=E(o,void 0);return{keys:[...S,...h,...I],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,o,S){let h=this.getConsolidatedConfigurationModelForResource(o,S);return o.overrideIdentifier&&(h=h.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(h=h.merge(this._policyConfiguration)),h}getConsolidatedConfigurationModelForResource({resource:n},o){let S=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const h=o.getFolder(n);h&&(S=this.getFolderConsolidatedConfiguration(h.uri)||S);const I=this._memoryConfigurationByResource.get(n);I&&(S=S.merge(I))}return S}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const S=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(n);h?(o=S.merge(h),this._foldersConsolidatedConfigurations.set(n,o)):o=S}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const S=o.getFolder(n);if(S)return this._folderConfigurations.get(S.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:S,overrides:h,keys:I}=this._folderConfigurations.get(o);return n.push([o,{contents:S,overrides:h,keys:I}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this._workspaceConfiguration.keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.keys.forEach(S=>n.add(S))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getAllOverrideIdentifiers().forEach(S=>n.add(S))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(S=>o.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(S=>o.add(S)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(S=>o.add(S)),this._folderConfigurations.forEach(S=>S.getKeysForOverrideIdentifier(n).forEach(h=>o.add(h))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),S=this.parseConfigurationModel(n.policy),h=this.parseConfigurationModel(n.application),I=this.parseConfigurationModel(n.user),C=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((g,d)=>(g.set(m.URI.revive(d[0]),this.parseConfigurationModel(d[1])),g),new A.ResourceMap);return new c(o,S,h,I,new p,C,l,new p,new A.ResourceMap)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides)}}e.Configuration=c;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const n=new Set,o=new Map;for(const h of s)h.keys.forEach(I=>n.add(I)),h.overrides.forEach(([I,C])=>{const l=(0,A.getOrSet)(o,I,new Set);C.forEach(g=>l.add(g))});const S=[];return o.forEach((h,I)=>S.push([I,[...h.values()]])),{keys:[...n.values()],overrides:S}}e.mergeChanges=b;class _{constructor(n,o,S,h){this.change=n,this.previous=o,this.currentConfiguraiton=S,this.currentWorkspace=h,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const C of I)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const I of this.affectedKeys)this._affectsConfigStr+=I+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){const S=this._marker+n,h=this._affectsConfigStr.indexOf(S);if(h<0)return!1;const I=h+S.length;if(I>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(I);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(o){const l=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!u.equals(l,g)}return!0}}e.ConfigurationChangeEvent=_;function E(s,n){const{added:o,removed:S,updated:h}=r(n?.rawConfiguration,s?.rawConfiguration),I=[],C=s?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const g=l.filter(d=>!C.includes(d));for(const d of g)I.push([d,n.getKeysForOverrideIdentifier(d)])}if(s){const g=C.filter(d=>!l.includes(d));for(const d of g)I.push([d,s.getKeysForOverrideIdentifier(d)])}if(n&&s){for(const g of C)if(l.includes(g)){const d=r({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:n.getOverrideValue(void 0,g)||{},keys:n.getKeysForOverrideIdentifier(g)});I.push([g,[...d.added,...d.removed,...d.updated]])}}return{added:o,removed:S,updated:h,overrides:I}}function r(s,n){const o=s?n?s.keys.filter(I=>n.keys.indexOf(I)===-1):[...s.keys]:[],S=n?s?n.keys.filter(I=>s.keys.indexOf(I)===-1):[...n.keys]:[],h=[];if(s&&n){for(const I of n.keys)if(s.keys.indexOf(I)!==-1){const C=(0,P.getConfigurationValue)(n.contents,I),l=(0,P.getConfigurationValue)(s.contents,I);u.equals(C,l)||h.push(I)}}return{added:o,removed:S,updated:h}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var k;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class A{constructor(D,a){this.host=D,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var u;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(u||(e.RemoteAuthorityResolverErrorCode=u={}));class y extends w.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof y&&D._code===u.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof y&&D._code===u.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof y&&D._code===u.NoResolverFound}static isInvalidAuthority(D){return D instanceof y&&D._code===u.InvalidAuthority}static isHandled(D){return D instanceof y&&D.isHandled}constructor(D,a=u.Unknown,v){super(D),this._message=D,this._code=a,this._detail=v,this.isHandled=a===u.NotAvailable&&v===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function m(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.getRemoteAuthorityPrefix=m}),define(Ae[52],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=R;function k(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=k;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(m){const{host:P,port:D}=y(m);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.parseAuthorityWithPort=A;function u(m,P){let{host:D,port:a}=y(m);return typeof a>"u"&&(a=P),{host:D,port:a}}e.parseAuthorityWithOptionalPort=u;function y(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=m.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const a=m.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:m,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var u;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.LINUX_PPC64LE="linux-ppc64le",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(u||(e.TargetPlatform=u={}));class y{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,b=typeof i=="string"?i:i.value;return w.equalsIgnoreCase(c,b)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=y;class m{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const i of t)this.add(i)}add(t){this._set.add(y.toKey(t))}delete(t){return this._set.delete(y.toKey(t))}has(t){return this._set.has(y.toKey(t))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(y.toKey(t))}get(t){return this._map.get(y.toKey(t))}has(t){return this._map.has(y.toKey(t))}set(t,i){this._map.set(y.toKey(t),i)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function D(f){return a(f)}e.isApplicationScopedExtension=D;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=a;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,k.getRemoteName)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,u){this._generators.set(A,u)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const u=Object.create(null);for(const y of A){const m=this.readActivationEvents(y);m.length>0&&(u[R.ExtensionIdentifier.toKey(y.identifier)]=m)}return u}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const u=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return u;for(const y in A.contributes){const m=this._generators.get(y);if(!m)continue;const P=A.contributes[y],D=Array.isArray(P)?P:[P];try{m(D,u)}catch(a){(0,w.onUnexpectedError)(a)}}return u}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ae[178],Re([1,0,22,73,36]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(y){if(w.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function A(y,m,P,D,a,v,p,f){const t=Object.create(null);t["common.machineId"]=v,t.sessionID=(0,k.generateUuid)()+Date.now(),t.commitHash=D,t.version=a,t["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.PlatformToString)(w.platform),t["common.nodePlatform"]=R.platform,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",p&&(t["common.msftInternal"]=p);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.isLinuxSnap&&(t["common.snap"]="true");const b=L(m);return b&&(t["common.platformDetail"]=b),t}e.resolveCommonProperties=A;function u(y){const m=R.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return y.some(D=>P===D)}e.verifyMicrosoftInternalDomain=u}),define(Ae[179],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,178,179]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(S){this.value=S,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class D{async publicLog(S,h,I){}async publicLogError(S,h,I){}}e.NullEndpointTelemetryService=D,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,S){return k.Event.debounce(S.onDidChangeConfiguration,(I,C)=>{const l=I?new Set([...I.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:l}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.configurationTelemetry=a;function v(o,S){return!S.isBuilt&&!S.disableTelemetry?!0:!(S.disableTelemetry||!o.enableTelemetry)}e.supportsTelemetry=v;function p(o,S){return S.extensionTestsLocationURI?!0:!(S.isBuilt||S.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=p;function f(o){const S=o.getValue(y.TELEMETRY_SETTING_ID),h=o.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(o){const S={},h={},I={};b(o,I);for(let C in I){C=C.length>150?C.substr(C.length-149):C;const l=I[C];typeof l=="number"?h[C]=l:typeof l=="boolean"?h[C]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${l.length}`),S[C]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(S[C]=l)}return{properties:S,measurements:h}}e.validateTelemetryData=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const S=(0,A.getRemoteName)(o);return i.has(S)?S:"other"}e.cleanRemoteAuthority=c;function b(o,S,h=0,I){if(o)for(const C of Object.getOwnPropertyNames(o)){const l=o[C],g=I?I+C:C;Array.isArray(l)?S[g]=(0,w.safeStringify)(l):l instanceof Date?S[g]=l.toISOString():(0,R.isObject)(l)?h<2?b(l,S,h+1,g+"."):S[g]=(0,w.safeStringify)(l):S[g]=l}}function _(o,S){const h=o.msftInternalDomains||[],I=S.getValue("telemetry.internalTesting");return(0,u.verifyMicrosoftInternalDomain)(h)||I}e.isInternalTelemetry=_;function E(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=E;function r(o,S){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const I=[];for(const d of S)for(;;){const T=d.exec(o);if(!T)break;I.push([T.index,d.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(h="";;){const d=l.exec(o);if(!d)break;const T=I.some(([z,H])=>d.index<H&&z<l.lastIndex);!C.test(d[0])&&!T&&(h+=o.substring(g,d.index)+"<REDACTED: user-file-path>",g=l.lastIndex)}return g<o.length&&(h+=o.substr(g)),h}function s(o){if(!o)return o;const S=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of S)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return o}function n(o,S){return(0,w.cloneAndChange)(o,h=>{if(h instanceof m||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let I=h.replaceAll("%20"," ");I=r(I,S);for(const C of S)I=I.replace(C,"");return I=s(I),I}})}e.cleanData=n}),define(Ae[180],Re([1,0,15,92,20,22,2,9,73,53]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,w.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const S=o.manifest?o.manifest.version:o.version,h=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,S,h)}static parse(o){const S=D.exec(o);return S&&S[1]&&S[2]?new a({id:S[1]},S[2],S[4]||void 0):null}constructor(o,S,h="undefined"){this.version=S,this.targetPlatform=h,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=a;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const o=v.exec(n);return o&&o[1]?[t(o[1]),o[2]]:[t(n),void 0]}e.getIdAndVersion=p;function f(n,o){return`${n}.${o}`}e.getExtensionId=f;function t(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=t;function i(n,o){return t(f(n??k.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=i;function c(n,o){const S=[],h=I=>{for(const C of S)if(C.some(l=>P(o(l),o(I))))return C;return null};for(const I of n){const C=h(I);C?C.push(I):S.push([I])}return S}e.groupByExtension=c;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function _(n){return{id:new m.TelemetryTrustedValue(n.identifier.id),name:new m.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function E(n,o){const S=[],h=o.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const I=h.shift();if(I&&S.every(C=>!P(C.identifier,{id:I}))){const C=n.filter(l=>P(l.identifier,{id:I}));C.length===1&&(S.push(C[0]),h.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=E;async function r(n,o){if(!L.isLinux)return!1;let S;try{S=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{S=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,u.getErrorMessage)(I))}}return!!S&&(S.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(n,o){const S=await r(n,o),h=(0,R.getTargetPlatform)(S?"alpine":L.platform,y.arch);return o.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=s}),define(Ae[181],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=w;function R(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=R;function k(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=k;function L(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=L;function A(y){return Array.from(y.entries()).map(m=>[m[0],w(m[1].map),R(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function u(y){return new Map(y.map(m=>[m[0],{map:k(m[1]),descriptionMap:L(m[2])}]))}e.deserializeEnvironmentVariableCollections=u}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,L,A=5){const u=L(y=>{const m=typeof y=="string"?y:y.data;let P=this._terminalBufferMap.get(k);if(P){P.data.push(m);return}const D=setTimeout(()=>this.flushBuffer(k),A);P={data:[m],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(k),u.dispose()}},this._terminalBufferMap.set(k,P)});return u}stopBuffering(k){this._terminalBufferMap.get(k)?.dispose()}flushBuffer(k){const L=this._terminalBufferMap.get(k);L&&(this._terminalBufferMap.delete(k),this._callback(k,L.data.join("")))}}e.TerminalDataBufferer=w}),define(Ae[183],Re([1,0,12,89,40,5,16,2,144,72,30]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(_){function E(r,s){let n=r.defaults;for(;k.ThemeIcon.isThemeIcon(n);){const o=p.getIcon(n.id);if(!o)return;n=o.defaults}return n}_.getDefinition=E})(D||(e.IconContribution=D={}));var a;(function(_){function E(s){return{weight:s.weight,style:s.style,src:s.src.map(n=>({format:n.format,location:n.location.toString()}))}}_.toJSONObject=E;function r(s){const n=o=>(0,A.isString)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.isString)(o.format)&&(0,A.isString)(o.location)))return{weight:n(s.weight),style:n(s.style),src:s.src.map(o=>({format:o.format,location:u.URI.parse(o.location)}))}}_.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class v{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${k.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(E,r,s,n){const o=this.iconsById[E];if(o){if(s&&!o.description){o.description=s,this.iconSchema.properties[E].markdownDescription=`${s} $(${E})`;const I=this.iconReferenceSchema.enum.indexOf(E);I!==-1&&(this.iconReferenceSchema.enumDescriptions[I]=s),this._onDidChange.fire()}return o}const S={id:E,description:s,defaults:r,deprecationMessage:n};this.iconsById[E]=S;const h={$ref:"#/definitions/icons"};return n&&(h.deprecationMessage=n),s&&(h.markdownDescription=`${s}: $(${E})`),this.iconSchema.properties[E]=h,this.iconReferenceSchema.enum.push(E),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:E}}deregisterIcon(E){delete this.iconsById[E],delete this.iconSchema.properties[E];const r=this.iconReferenceSchema.enum.indexOf(E);r!==-1&&(this.iconReferenceSchema.enum.splice(r,1),this.iconReferenceSchema.enumDescriptions.splice(r,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(E=>this.iconsById[E])}getIcon(E){return this.iconsById[E]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(E,r){const s=this.iconFontsById[E];return s||(this.iconFontsById[E]=r,this._onDidChange.fire(),r)}deregisterIconFont(E){delete this.iconFontsById[E]}getIconFont(E){return this.iconFontsById[E]}toString(){const E=(o,S)=>o.id.localeCompare(S.id),r=o=>{for(;k.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of n.filter(S=>!!S.description).sort(E))s.push(`|<i class="${r(o)}"></i>|${o.id}|${k.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of n.filter(S=>!k.ThemeIcon.isThemeIcon(S.defaults)).sort(E))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const p=new v;P.Registry.add(e.Extensions.IconContribution,p);function f(_,E,r,s){return p.registerIcon(_,E,r,s)}e.registerIcon=f;function t(){return p}e.getIconRegistry=t;function i(){const _=(0,R.getCodiconFontCharacters)();for(const E in _){const r="\\"+_[E].toString(16);p.registerIcon(E,{fontCharacter:r})}}i(),e.iconsSchemaId="vscode://schemas/icons";const c=P.Registry.as(m.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,p.getIconSchema());const b=new w.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=k.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=k.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Ae[184],Re([1,0,5,43,4,14]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var u;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(u||(e.TunnelPrivacyId=u={}));function y(t){return!!t.forwardPort}e.isTunnelProvider=y;var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=a;function v(t,i,c,b){if(c===1)return!1;if(c===2&&a(i)){const _=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(_?.length===4&&parseInt(_[1])>=18)return!1}return t<1024}e.isPortPrivileged=v;class p{constructor(i,c,b){this.remoteAddress=i,this.localAddress=c,this._dispose=b,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let f=class{constructor(i,c){this.logService=i,this.configurationService=c,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],c=Array.from(this._tunnels.values());for(const b of c){const _=Array.from(b.values());for(const E of _){const r=await E.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:c}of i.values())await c.then(b=>typeof b!="string"?b?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,c,b,_,E){this.addTunnelToMap(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:b,privacy:_,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(a(i)||D(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const b=this.getTunnelFromMap(i,c);if(b)return++b.refcount,b.value}openTunnel(i,c,b,_,E,r=!1,s,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${E}.`);const o=this._tunnelProvider??i;if(!o)return;if(c||(c="localhost"),_||(_=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(b)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.retainOrCreateTunnel(o,c,b,_,E,r,s,n);return S?S.then(h=>{if(h){if(typeof h=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(c,b),h}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(c,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.makeTunnel(h);return(h.tunnelRemoteHost!==c||h.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&h.privacy!==s&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(I),I}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this._tunnels.get(i.tunnelRemoteHost);if(c){const b=c.get(i.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,b))}}}}async tryDisposeTunnel(i,c,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const _=b.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(c),_}}async closeTunnel(i,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const b=this._tunnels.get(i);if(b&&b.has(c)){const _=b.get(c);_.refcount=0,await this.tryDisposeTunnel(i,c,_)}}addTunnelToMap(i,c,b){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(c,{refcount:1,value:b})}async removeEmptyOrErrorTunnelFromMap(i,c){const b=this._tunnels.get(i);if(b){const _=b.get(c),E=_?await _.value:void 0;(!E||typeof E=="string")&&b.delete(c),b.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,c){const b=[i];D(i)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):a(i)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const _=b.map(E=>this._tunnels.get(E));for(const E of _){const r=E?.get(c);if(r)return r}}canTunnel(i){return!!P(i)}createWithProvider(i,c,b,_,E,r,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${_}.`);const n=b;this._factoryInProgress.add(n);const o=_===void 0?b:_,S={elevationRequired:E?this.isPortPrivileged(o):!1},h={remoteAddress:{host:c,port:b},localAddressPort:_,privacy:r,public:r?r!==u.Private:void 0,protocol:s},I=i.forwardPort(h,S);return I?(this.addTunnelToMap(c,b,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),I}};e.AbstractTunnelService=f,e.AbstractTunnelService=f=Ve([ze(0,L.ILogService),ze(1,R.IConfigurationService)],f)}),define(Ae[185],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,w.createDecorator)("editSessionIdentityService");var R;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ae[186],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(y){return y.scheme!==w.Schemas.file&&y.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=R;function k(y){if(y.folders.length)return y.folders.every(m=>R(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&R(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=k;function L(y){return k(y)?.scheme}e.getVirtualWorkspaceScheme=L;function A(y){return k(y)?.authority}e.getVirtualWorkspaceAuthority=A;function u(y){return k(y)!==void 0}e.isVirtualWorkspace=u}),define(Ae[54],Re([1,0,145,19,49,23,2,4,13]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,u.createDecorator)("contextService");function m(o){const S=o;return typeof S?.id=="string"&&A.URI.isUri(S.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(o){return typeof o?.id=="string"&&!m(o)&&!a(o)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(o,S){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.basename)(o)}:S?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const h=o;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.toWorkspaceIdentifier=D;function a(o){const S=o;return typeof S?.id=="string"&&A.URI.isUri(S.configPath)}e.isWorkspaceIdentifier=a;function v(o){const S=o;if(S?.uri)return{id:S.id,uri:A.URI.revive(S.uri)};const h=o;if(h?.configPath)return{id:h.id,configPath:A.URI.revive(h.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=v;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(o){const S=o;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=f;function t(o){const S=o;return!!(S&&typeof S=="object"&&A.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=t;class i{constructor(S,h,I,C,l){this._id=S,this._transient=I,this._configuration=C,this._ignorePathCasing=l,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=h}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=i;class c{constructor(S,h){this.raw=h,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,L.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function b(o){return new c({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(o,S){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,S.untitledWorkspacesHome)}e.isUntitledWorkspace=_;function E(o){let S;return A.URI.isUri(o)?S=o:S=o.configuration,S?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=E,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=r;function s(o,S){return!_(o,S)&&!E(o)}e.isSavedWorkspace=s;function n(o){return(typeof o=="string"?(0,R.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Ae[74],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{static{this.enableDebugLogging=!1}constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const L=this._idPool++;return this._data.set(L,k),this.logDebugInfo(),L}get(k,L){return this._data.has(k)?this._data.get(k)[L]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){w.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=w}),define(Ae[39],Re([1,0,13,23,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map,this.extUri=new R.ExtUri(u=>{const y=this._providerInfo.get(u.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(u,y){y===null?this._providerInfo.delete(u.scheme):this._providerInfo.set(u.scheme,y)}isFreeScheme(u){return!this._providerInfo.has(u)&&!this._systemSchemes.has(u)}getCapabilities(u){return this._providerInfo.get(u)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends k.LogService{constructor(y,m,P){const D=P.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):y?(0,w.localize)(1,null):(0,w.localize)(2,null);super(m.createLogger(D,{name:a}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=Ve([ze(1,R.ILoggerService),ze(2,L.IExtHostInitDataService)],A)}),define(Ae[188],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,u,y){this._deferredPromises=new Map,this._id=A,this._shared=u,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of m.values())P.complete()}catch(P){for(const D of m.values())D.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,u){let y=this._value[A];return typeof y>"u"&&(y=u),y}update(A,u){this._value[A]=u;const y=this._deferredPromises.get(A);if(y!==void 0)return y.p;const m=new w.DeferredPromise;return this._deferredPromises.set(A,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,u){super(A.identifier.value,!0,u),this._extension=A}}e.ExtensionGlobalMemento=k}),define(Ae[189],Re([1,0,5,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new w.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new w.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,u,y,m){const D=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(u.value,y,m);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(A,u){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(A)).acceptDirty(u)}$acceptModelSaved(A){const u=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(A));this._onDidSaveNotebookDocument.fire(u.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=R}),define(Ae[190],Re([1,0,20,5]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{#e;constructor(A,u){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(A.identifier),this.#e=u,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(A){return this.#e.get(this._id,A)}store(A,u){return this.#e.store(this._id,A,u)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=k}),define(Ae[55],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class R{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(Ae[191],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function k(u,y){if(y.serializeBuffersForPostMessage){const m=new R,D=JSON.stringify(u,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(p)};if(ArrayBuffer.isView(p)){const f=L(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:m.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),a=m.buffers.map(v=>{const p=new Uint8Array(v);return w.VSBuffer.wrap(p)});return{message:D,buffers:a}}else return{message:JSON.stringify(u),buffers:[]}}e.serializeWebviewMessage=k;function L(u){switch(u.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(u,y){const m=y.map(a=>{const v=new ArrayBuffer(a.byteLength);return new Uint8Array(v).set(a.buffer),v}),P=y.length?(a,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:f}=p,t=m[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse(u,P),arrayBuffers:m}}e.deserializeWebviewMessage=A}),define(Ae[99],Re([1,0,159,16,2,6,4,30,38,13,41,127,29]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(le){const pe=le;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.isEditorPaneWithSelection=f;function t(le,pe,ie){for(const U of ie.visibleEditorPanes)if(U.group.id===pe&&le.matches(U.input))return U.getViewState()}e.findViewStateForEditor=t;function i(le){if(h(le))return!1;const pe=le;return k.URI.isUri(pe?.resource)}e.isResourceEditorInput=i;function c(le){if(h(le))return!1;const pe=le;return pe?.original!==void 0&&pe.modified!==void 0}e.isResourceDiffEditorInput=c;function b(le){if(h(le)||c(le))return!1;const pe=le;return pe?.primary!==void 0&&pe.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function _(le){if(h(le))return!1;const pe=le;return pe?pe.resource===void 0||pe.resource.scheme===m.Schemas.untitled||pe.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;function E(le){if(h(le))return!1;const pe=le;return k.URI.isUri(pe?.base?.resource)&&k.URI.isUri(pe?.input1?.resource)&&k.URI.isUri(pe?.input2?.resource)&&k.URI.isUri(pe?.result?.resource)}e.isResourceMergeEditorInput=E;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class n{constructor(){this.mapIdToSaveSource=new Map}registerSource(pe,ie){let U=this.mapIdToSaveSource.get(pe);return U||(U={source:pe,label:ie},this.mapIdToSaveSource.set(pe,U)),U.source}getSourceLabel(pe){return this.mapIdToSaveSource.get(pe)?.label??pe}}e.SaveSourceRegistry=new n;var o;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class S extends L.Disposable{}e.AbstractEditorInput=S;function h(le){return le instanceof S}e.isEditorInput=h;function I(le){const pe=le;return k.URI.isUri(pe?.preferredResource)}function C(le){const pe=le;return h(pe?.primary)&&h(pe?.secondary)}e.isSideBySideEditorInput=C;function l(le){const pe=le;return h(pe?.modified)&&h(pe?.original)}e.isDiffEditorInput=l;function g(le,pe,ie,U,W){return Ce(U,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ue={...ie,limits:{size:Number.MAX_VALUE}};le.openEditor(pe,ue)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>W.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.createTooLargeFileError=g;function d(le){return h(le?.editor)}e.isEditorInputWithOptions=d;function T(le){const pe=le;return d(le)&&pe?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function z(le){const pe=le;return typeof pe?.groupId=="number"&&h(pe.editor)}e.isEditorIdentifier=z;var H;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var x;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var $;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})($||(e.SideBySideEditor=$={}));class N{getOriginalUri(pe,ie){if(!pe)return;if(E(pe))return e.EditorResourceAccessor.getOriginalUri(pe.result,ie);if(ie?.supportSideBySide){const{primary:W,secondary:ue}=this.getSideEditors(pe);if(W&&ue){if(ie?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===$.ANY)return this.getOriginalUri(W,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme});pe=ie.supportSideBySide===$.PRIMARY?W:ue}}if(c(pe)||b(pe)||E(pe))return;const U=I(pe)?pe.preferredResource:pe.resource;return!U||!ie||!ie.filterByScheme?U:this.filterUri(U,ie.filterByScheme)}getSideEditors(pe){return C(pe)||b(pe)?{primary:pe.primary,secondary:pe.secondary}:l(pe)||c(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,ie){if(!pe)return;if(E(pe))return e.EditorResourceAccessor.getCanonicalUri(pe.result,ie);if(ie?.supportSideBySide){const{primary:W,secondary:ue}=this.getSideEditors(pe);if(W&&ue){if(ie?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===$.ANY)return this.getCanonicalUri(W,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme});pe=ie.supportSideBySide===$.PRIMARY?W:ue}}if(c(pe)||b(pe)||E(pe))return;const U=pe.resource;return!U||!ie||!ie.filterByScheme?U:this.filterUri(U,ie.filterByScheme)}filterUri(pe,ie){if(Array.isArray(ie)){if(ie.some(U=>pe.scheme===U))return pe}else if(ie===pe.scheme)return pe}}var M;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function te(le,pe,ie,U){if(!le.isSticky(pe))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return ie===M.MOUSE||ie===M.KEYBOARD;case"mouse":return ie===M.MOUSE;case"keyboard":return ie===M.KEYBOARD}return!1}e.preventEditorClose=te,e.EditorResourceAccessor=new N;var Q;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class Se{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(pe){const ie=this.instantiationService=pe.get(A.IInstantiationService);for(const[U,W]of this.editorSerializerConstructors)this.createEditorSerializer(U,W,ie);this.editorSerializerConstructors.clear()}createEditorSerializer(pe,ie,U){const W=U.createInstance(ie);this.editorSerializerInstances.set(pe,W)}registerFileEditorFactory(pe){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=pe}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(pe,ie){if(this.editorSerializerConstructors.has(pe)||this.editorSerializerInstances.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.instantiationService?this.createEditorSerializer(pe,ie,this.instantiationService):this.editorSerializerConstructors.set(pe,ie),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(pe),this.editorSerializerInstances.delete(pe)})}getEditorSerializer(pe){return this.editorSerializerInstances.get(typeof pe=="string"?pe:pe.typeId)}}u.Registry.add(e.EditorExtensions.EditorFactory,new Se);async function _e(le,pe,ie){return!le||!le.length?[]:await Promise.all(le.map(async U=>{const W=k.URI.revive(U.fileUri);if(!W){ie.info("Cannot resolve the path because it is not valid.",U);return}if(!await pe.canHandleResource(W)){ie.info("Cannot resolve the path because it cannot be handled",U);return}let we=U.exists,Ee=U.type;if(typeof we!="boolean"||typeof Ee!="number")try{Ee=(await pe.stat(W)).isDirectory?y.FileType.Directory:y.FileType.Unknown,we=!0}catch(ye){ie.error(ye),we=!1}if(!we&&U.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",U);return}if(Ee===y.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",U);return}const ge={...U.options,pinned:!0};return we?{resource:W,options:ge}:{resource:W,options:ge,forceUntitled:!0}}))}e.pathsToEditors=_e;var Pe;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Y(le){const pe=le;if(!pe)return!1;const ie=pe;if(ie.modified)return Y(ie.modified);const U=pe;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.isTextEditorViewState=Y;function ae(le){return(0,P.isErrorWithActions)(le)}e.isEditorOpenError=ae;function Ce(le,pe,ie){const U=(0,P.createErrorWithActions)(le,pe);return U.forceMessage=ie?.forceMessage,U.forceSeverity=ie?.forceSeverity,U.allowDialog=ie?.allowDialog,U}e.createEditorOpenError=Ce}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,D.registerIcon)("default-view-icon",P.Codicon.window,(0,R.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.ViewContainerLocations=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;class f extends L.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(n,o,S){const h=this.get(n.id);if(h)return h;const I=n;return I.openCommandActionDescriptor=S?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.getOrSet)(this.viewContainers,o,[]).push(I),S?.isDefault&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(n){for(const o of this.viewContainers.keys()){const S=this.viewContainers.get(o),h=S?.indexOf(n);if(h!==-1){S?.splice(h,1),S.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:n,viewContainerLocation:o});return}}}get(n){return this.all.filter(o=>o.id===n)[0]}getViewContainers(n){return[...this.viewContainers.get(n)||[]]}getViewContainerLocation(n){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(S=>S?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===n)}}u.Registry.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,n){const o=s.group??t.More,S=n.group??t.More;return o!==S?o.localeCompare(S):(s.order??5)-(n.order??5)}class c extends L.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(n,o){this.registerViews2([{views:n,viewContainer:o}])}registerViews2(n){n.forEach(({views:o,viewContainer:S})=>this.addViews(o,S)),this._onViewsRegistered.fire(n)}deregisterViews(n,o){const S=this.removeViews(n,o);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:o})}moveViews(n,o){for(const S of this._views.keys())if(S!==o){const h=this.removeViews(n,S);h.length&&(this.addViews(h,o),this._onDidChangeContainer.fire({views:h,from:S,to:o}))}}getViews(n){return this._views.get(n)||[]}getView(n){for(const o of this._viewContainers){const S=(this._views.get(o)||[]).filter(h=>h.id===n)[0];if(S)return S}return null}getViewContainer(n){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(h=>h.id===n)[0])return o;return null}registerViewWelcomeContent(n,o){return this._viewWelcomeContents.add(n,o),this._onDidChangeViewWelcomeContent.fire(n),(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(n,o),this._onDidChangeViewWelcomeContent.fire(n)})}registerViewWelcomeContent2(n,o){const S=new Map;for(const[h,I]of o)this._viewWelcomeContents.add(n,I),S.set(h,(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(n,I),this._onDidChangeViewWelcomeContent.fire(n)}));return this._onDidChangeViewWelcomeContent.fire(n),S}getViewWelcomeContent(n){const o=[];return this._viewWelcomeContents.forEach(n,S=>o.push(S)),o.sort(i)}addViews(n,o){let S=this._views.get(o);S||(S=[],this._views.set(o,S),this._viewContainers.push(o));for(const h of n){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(1,null,h.id));S.push(h)}}removeViews(n,o){const S=this._views.get(o);if(!S)return[];const h=[],I=[];for(const C of S)n.includes(C)?h.push(C):I.push(C);return h.length&&(I.length?this._views.set(o,I):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),h}}u.Registry.add(a.ViewsRegistry,new c),e.IViewsService=(0,k.createDecorator)("viewsService"),e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var b;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var _;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(_||(e.TreeItemCollapsibleState=_={}));class E{constructor(n,o){this.resolved=!1,this._hasResolve=!1,(0,m.mixin)(this,n),this._hasResolve=!!o,this.resolve=async S=>{if(o&&!this.resolved){const h=await o(S);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=E;class r extends Error{constructor(n){super((0,R.localize)(2,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.NoTreeViewError=r}),define(Ae[193],Re([1,0,5,12,161]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(u){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=u}onEvent(u){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=u}onRequest(u){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=u}sendResponse(u){u.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${u.command}`)):this.internalSend("response",u)}sendRequest(u,y,m,P){const D={command:u};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.internalSend("request",D),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const v=this.pendingRequests.get(D.seq);if(v){this.pendingRequests.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:u,message:(0,k.localize)(0,null,P,u)};v(p)}},P)}return m&&this.pendingRequests.set(D.seq,m),D.seq}acceptMessage(u){this.messageCallback?this.messageCallback(u):(this.queue.push(u),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(u,y){return u.type!=="event"||y.type!=="event"}async processQueue(){let u;for(;this.queue.length;){if((!u||this.needsTaskBoundaryBetween(this.queue[0],u))&&await(0,R.timeout)(0),u=this.queue.shift(),!u)return;switch(u.type){case"event":this.eventCallback?.(u);break;case"request":this.requestCallback?.(u);break;case"response":{const y=u,m=this.pendingRequests.get(y.request_seq);m&&(this.pendingRequests.delete(y.request_seq),m(y));break}}}}internalSend(u,y){y.type=u,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const u=new Map;this.pendingRequests.forEach((y,m)=>u.set(m,y)),await(0,R.timeout)(500),u.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(Ae[194],Re([1,0,162,32,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:w.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const L=a=>w.localize(51,null,a);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function u(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=u;var y;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.IDebugService=(0,k.createDecorator)("debugService");var D;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[195],Re([1,0,15,2,19,24,13,44,21,18]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(C,l,g){return C.replace(P,function(d,T){return l&&T.length>0&&T[0]!=="_"?d:g&&g.hasOwnProperty(T)?g[T]:d})}e.formatPII=D;function a(C){const l={};for(const g of Object.keys(C))g.startsWith("!")||(l[g]=C[g]);return l}e.filterExceptionsFromTelemetry=a;function v(C){return C.configuration.request==="attach"&&!p(C)&&(!C.parentSession||v(C.parentSession))}e.isSessionAttach=v;function p(C){let l=C.configuration.type;if(l)return l==="vslsShare"&&(l=C.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(l,"extensionhost")||(0,w.equalsIgnoreCase)(l,"pwa-extensionhost")?C:C.parentSession?p(C.parentSession):void 0}e.getExtensionHostDebugSession=p;function f(C){return C.type&&(C.label||C.program||C.runtime)}e.isDebuggerMainContribution=f;function t(C,l,g){let d,T=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=z.exec(C);){const x=H.index+1,$=x+H[0].length;if(x<=l&&$>=g){d=H[0],T=x;break}}if(d){const x=/\w+/g;let $=null;for(;($=x.exec(d))&&!($.index+1+T+$[0].length>=g););$&&(d=d.substring(0,x.lastIndex))}return d?{start:T,end:T+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function i(C,l,g,d){if(C.evaluatableExpressionProvider.has(l)){const T=C.evaluatableExpressionProvider.ordered(l),z=(0,m.coalesce)(await Promise.all(T.map(async H=>{try{return await H.provideEvaluatableExpression(l,g,d??y.CancellationToken.None)}catch{return}})));if(z.length>0){let H=z[0].expression;const x=z[0].range;return H||(H=l.getLineContent(g.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:H}}}else{const T=l.getLineContent(g.lineNumber),{start:z,end:H}=t(T,g.column,g.column),x=T.substring(z-1,H);return{matchingExpression:x,range:new u.Range(g.lineNumber,z,g.lineNumber,z+x.length)}}return null}e.getEvaluatableExpressionAtPosition=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(C){return!!(C&&C.match(c))}e.isUri=b;function _(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(b(C.path))return R.URI.parse(C.path);if((0,k.isAbsolute)(C.path))return R.URI.file(C.path)}return C.path}function E(C){if(typeof C.path=="object"){const l=R.URI.revive(C.path);if(l)return l.scheme===A.Schemas.file?l.fsPath:l.toString()}return C.path}function r(C,l){const g=l?_:E,d=(0,L.deepClone)(C);return n(d,(T,z)=>{T&&z&&(z.path=g(z))}),d}e.convertToDAPaths=r;function s(C,l){const g=l?_:E,d=(0,L.deepClone)(C);return n(d,(T,z)=>{!T&&z&&(z.path=g(z))}),d}e.convertToVSCPaths=s;function n(C,l){switch(C.type){case"event":{const g=C;switch(g.event){case"output":l(!1,g.body.source);break;case"loadedSource":l(!1,g.body.source);break;case"breakpoint":l(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=C;switch(g.command){case"setBreakpoints":l(!0,g.arguments.source);break;case"breakpointLocations":l(!0,g.arguments.source);break;case"source":l(!0,g.arguments.source);break;case"gotoTargets":l(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(d=>l(!1,d));break;default:break}break}case"response":{const g=C;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(d=>l(!1,d.source));break;case"loadedSources":g.body.sources.forEach(d=>l(!1,d));break;case"scopes":g.body.scopes.forEach(d=>l(!1,d.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(d=>l(!1,d.source));break;case"setBreakpoints":g.body.breakpoints.forEach(d=>l(!1,d.source));break;case"disassemble":g.body?.instructions.forEach(T=>l(!1,T.location));break;default:break}break}}}function o(C){return C.filter(l=>!l.presentation?.hidden).sort((l,g)=>l.presentation?g.presentation?l.presentation.group?g.presentation.group?l.presentation.group!==g.presentation.group?l.presentation.group.localeCompare(g.presentation.group):S(l.presentation.order,g.presentation.order):-1:g.presentation.group?1:S(l.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=o;function S(C,l){return typeof C!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:C-l}async function h(C,l){const g=C.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(g!=="none"&&(await l.saveAll(),g==="allEditorsInActiveGroup")){const d=l.activeEditorPane;d&&d.input.resource?.scheme===A.Schemas.untitled&&await l.save({editor:d.input,groupId:d.group.id})}await C.reloadConfiguration()}e.saveAllBeforeDebugStart=h;const I=(C,l)=>!C||!l?C===l:C.name===l.name&&C.path===l.path&&C.sourceReference===l.sourceReference;e.sourcesEqual=I}),define(Ae[75],Re([1,0,25,37,65,66,13,19,22,32]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var P;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(P||(e.CellKind=P={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var a;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var v;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var b;(function(M){M.scheme=A.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${te.join("")}]+`),Se=7;function _e(pe,ie){const U=ie.toString(Se),ue=`${U.length<te.length?te[U.length-1]:"z"}${U}s${(0,w.encodeBase64)(w.VSBuffer.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:M.scheme,fragment:ue})}M.generate=_e;function Pe(pe){if(pe.scheme!==M.scheme)return;const ie=pe.fragment.indexOf("s");if(ie<0)return;const U=parseInt(pe.fragment.substring(0,ie).replace(Q,""),Se),W=(0,w.decodeBase64)(pe.fragment.substring(ie+1)).toString();if(!isNaN(U))return{handle:U,notebook:pe.with({scheme:W,fragment:null})}}M.parse=Pe;function Y(pe,ie){return pe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${pe.scheme!==A.Schemas.file?pe.scheme:""}`})}M.generateCellOutputUri=Y;function ae(pe){if(pe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!ie)return;const U=ie[1]&&ie[1]!==""?ie[1]:void 0,W=ie[2];return{outputId:U,notebook:pe.with({scheme:W||A.Schemas.file,fragment:null})}}M.parseCellOutputUri=ae;function Ce(pe,ie,U){return M.generate(pe,ie).with({scheme:U})}M.generateCellPropertyUri=Ce;function le(pe,ie){if(pe.scheme===ie)return M.parse(pe.with({scheme:M.scheme}))}M.parseCellPropertyUri=le})(b||(e.CellUri=b={}));const _=M=>y.isWindows?M.replace(/\//g,"\\"):M;class E{constructor(te=[],Q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Q,this.order=[...new Set(te)].map(Se=>({pattern:Se,matches:R.parse(_(Se))}))}sort(te){const Q=new Map(k.Iterable.map(te,_e=>[_e,_(_e)]));let Se=[];for(const{matches:_e}of this.order)for(const[Pe,Y]of Q)if(_e(Y)){Se.push(Pe),Q.delete(Pe);break}return Q.size&&(Se=Se.concat([...Q.keys()].sort((_e,Pe)=>this.defaultOrder.indexOf(_e)-this.defaultOrder.indexOf(Pe)))),Se}prioritize(te,Q){const Se=this.findIndex(te);if(Se===-1){this.order.unshift({pattern:te,matches:R.parse(_(te))});return}const _e=new Set(Q.map(Y=>this.findIndex(Y,Se)));_e.delete(-1);const Pe=Array.from(_e).sort();this.order.splice(Se+1,0,...Pe.map(Y=>this.order[Y]));for(let Y=Pe.length-1;Y>=0;Y--)this.order.splice(Pe[Y],1)}toArray(){return this.order.map(te=>te.pattern)}findIndex(te,Q=this.order.length){const Se=_(te);for(let _e=0;_e<Q;_e++)if(this.order[_e].matches(Se))return _e;return-1}}e.MimeTypeDisplayOrder=E;function r(M,te,Q,Se=(_e,Pe)=>_e===Pe){const _e=[];function Pe(Ce,le,pe){if(le===0&&pe.length===0)return;const ie=_e[_e.length-1];ie&&ie.start+ie.deleteCount===Ce?(ie.deleteCount+=le,ie.toInsert.push(...pe)):_e.push({start:Ce,deleteCount:le,toInsert:pe})}let Y=0,ae=0;for(;;){if(Y===M.length){Pe(Y,0,te.slice(ae));break}if(ae===te.length){Pe(Y,M.length-Y,[]);break}const Ce=M[Y],le=te[ae];if(Se(Ce,le)){Y+=1,ae+=1;continue}Q(le)?(Pe(Y,1,[]),Y+=1):(Pe(Y,0,[le]),ae+=1)}return _e}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtLineBoundary","none");var s;(function(M){M.default="default",M.option="option"})(s||(e.NotebookEditorPriority=s={}));function n(M){const te=M;return!!((typeof te.include=="string"||R.isRelativePattern(te.include))&&(typeof te.exclude=="string"||R.isRelativePattern(te.exclude)))}e.isDocumentExcludePattern=n;function o(M,te,Q){if(Array.isArray(M.viewType)&&M.viewType.indexOf(te)>=0||M.viewType===te)return!0;if(M.filenamePattern){const Se=n(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,_e=n(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(R.match(Se,(0,u.basename)(Q.fsPath).toLowerCase()))return!(_e&&R.match(_e,(0,u.basename)(Q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var S;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class h{static{this._prefix="notebook/"}static create(te){return`${h._prefix}${te}`}static parse(te){if(te.startsWith(h._prefix))return te.substring(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h;function I(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.isTextStreamMime=I;const C=new TextDecoder;function l(M){const te=[];let Q=!1;for(const Y of M)(te.length===0||Q)&&(te.push(Y),Q=!0);let Se=T(te);const _e=w.VSBuffer.concat(te.map(Y=>w.VSBuffer.wrap(Y))),Pe=N(_e);return Se=Se||Pe.byteLength!==_e.byteLength,{data:Pe,didCompression:Se}}e.compressOutputItemStreams=l,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const g=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(M=>M.charCodeAt(0)),d=10;function T(M){let te=!1;return M.forEach((Q,Se)=>{if(Se===0||Q.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const _e=M[Se-1],Pe=Q.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Pe[0]===g[0]&&Pe[1]===g[1]&&Pe[2]===g[2]){const Y=_e.lastIndexOf(d);if(Y===-1)return;te=!0,M[Se-1]=_e.subarray(0,Y),M[Se]=Q.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),te}function z(M){let te=M;do M=te,te=M.replace(/[^\n]\x08/gm,"");while(te.length<M.length);return M}function H(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const te=M.match(/^(.*)\r+/m)[1];let Q=M.match(/\r+(.*)$/m)[1];Q=Q+te.slice(Q.length,te.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return M}const x="\b".charCodeAt(0),$="\r".charCodeAt(0);function N(M){return!M.buffer.includes(x)&&!M.buffer.includes($)?M:w.VSBuffer.fromString(H(z(C.decode(M.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,66,15,16,2,36,20,38,97,75]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p){"use strict";var f,t,i,c,b,_,E,r,s,n,o,S,h,I,C,l,g,d;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const De=ne.length===1?[]:ne[1];return Reflect.construct(B,De,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[De,...qe]=ne;return Reflect.construct(B,qe,De.constructor)}}})}var z;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var H;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let x=f=class{static from(...F){let ne=F;return new f(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=x,e.Disposable=x=f=Ve([T],x);let $=t=class{static Min(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let De=1;De<F.length;De++){const qe=F[De];qe.isBefore(ne)&&(ne=qe)}return ne}static Max(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let De=1;De<F.length;De++){const qe=F[De];qe.isAfter(ne)&&(ne=qe)}return ne}static isPosition(F){if(!F)return!1;if(F instanceof t)return!0;const{line:ne,character:De}=F;return typeof ne=="number"&&typeof De=="number"}static of(F){if(F instanceof t)return F;if(this.isPosition(F))return new t(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,ne){if(F<0)throw(0,R.illegalArgument)("line must be non-negative");if(ne<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=F,this._character=ne}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ne=0){if(F===null||ne===null)throw(0,R.illegalArgument)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,ne=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&ne===0?this:new t(this.line+De,this.character+ne)}with(F,ne=this.character){if(F===null||ne===null)throw(0,R.illegalArgument)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,ne=typeof F.character=="number"?F.character:this.character),De===this.line&&ne===this.character?this:new t(De,ne)}toJSON(){return{line:this.line,character:this.character}}};e.Position=$,e.Position=$=t=Ve([T],$);let N=i=class{static isRange(F){return F instanceof i?!0:F?$.isPosition(F.start)&&$.isPosition(F.end):!1}static of(F){if(F instanceof i)return F;if(this.isRange(F))return new i(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,ne,De,qe){let Qe,ot;if(typeof F=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof qe=="number"?(Qe=new $(F,ne),ot=new $(De,qe)):$.isPosition(F)&&$.isPosition(ne)&&(Qe=$.of(F),ot=$.of(ne)),!Qe||!ot)throw new Error("Invalid arguments");Qe.isBefore(ot)?(this._start=Qe,this._end=ot):(this._start=ot,this._end=Qe)}contains(F){return i.isRange(F)?this.contains(F.start)&&this.contains(F.end):$.isPosition(F)?!($.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ne=$.Max(F.start,this._start),De=$.Min(F.end,this._end);if(!ne.isAfter(De))return new i(ne,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ne=$.Min(F.start,this._start),De=$.Max(F.end,this.end);return new i(ne,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ne=this.end){if(F===null||ne===null)throw(0,R.illegalArgument)();let De;return F?$.isPosition(F)?De=F:(De=F.start||this.start,ne=F.end||this.end):De=this.start,De.isEqual(this._start)&&ne.isEqual(this.end)?this:new i(De,ne)}toJSON(){return[this.start,this.end]}};e.Range=N,e.Range=N=i=Ve([T],N);let M=c=class extends N{static isSelection(F){return F instanceof c?!0:F?N.isRange(F)&&$.isPosition(F.anchor)&&$.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,ne,De,qe){let Qe,ot;if(typeof F=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof qe=="number"?(Qe=new $(F,ne),ot=new $(De,qe)):$.isPosition(F)&&$.isPosition(ne)&&(Qe=$.of(F),ot=$.of(ne)),!Qe||!ot)throw new Error("Invalid arguments");super(Qe,ot),this._anchor=Qe,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=M,e.Selection=M=c=Ve([T],M);const te=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,R.illegalArgument)("connectionToken")};class Q{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ne,De){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.illegalArgument)("port");typeof De<"u"&&te(De),this.host=F,this.port=Math.round(ne),this.connectionToken=De}}e.ResolvedAuthority=Q;class Se{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ne){this.makeConnection=F,this.connectionToken=ne,typeof ne<"u"&&te(ne)}}e.ManagedResolvedAuthority=Se;class _e extends Error{static NotAvailable(F,ne){return new _e(F,v.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(F){return new _e(F,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ne=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=ne,this._detail=De,Object.setPrototypeOf(this,_e.prototype)}}e.RemoteAuthorityResolverError=_e;var Pe;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Y;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let ae=b=class{static isTextEdit(F){return F instanceof b?!0:F?N.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ne){return new b(F,ne)}static insert(F,ne){return b.replace(new N(F,F),ne)}static delete(F){return b.replace(F,"")}static setEndOfLine(F){const ne=new b(new N(new $(0,0),new $(0,0)),"");return ne.newEol=F,ne}get range(){return this._range}set range(F){if(F&&!N.isRange(F))throw(0,R.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,R.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,R.illegalArgument)("newEol");this._newEol=F}constructor(F,ne){this._range=F,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ae,e.TextEdit=ae=b=Ve([T],ae);let Ce=_=class{static isNotebookCellEdit(F){return F instanceof _?!0:F?Jt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ne){return new _(F,ne)}static insertCells(F,ne){return new _(new Jt(F,F),ne)}static deleteCells(F){return new _(F,[])}static updateCellMetadata(F,ne){const De=new _(new Jt(F,F),[]);return De.newCellMetadata=ne,De}static updateNotebookMetadata(F){const ne=new _(new Jt(0,0),[]);return ne.newNotebookMetadata=F,ne}constructor(F,ne){this.range=F,this.newCells=ne}};e.NotebookEdit=Ce,e.NotebookEdit=Ce=_=Ve([T],Ce);class le{static isSnippetTextEdit(F){return F instanceof le?!0:F?N.isRange(F.range)&&U.isSnippetString(F.snippet):!1}static replace(F,ne){return new le(F,ne)}static insert(F,ne){return le.replace(new N(F,F),ne)}constructor(F,ne){this.range=F,this.snippet=ne}}e.SnippetTextEdit=le;var pe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ne,De,qe){this._edits.push({_type:1,from:F,to:ne,options:De,metadata:qe})}createFile(F,ne,De){this._edits.push({_type:1,from:void 0,to:F,options:ne,metadata:De})}deleteFile(F,ne,De){this._edits.push({_type:1,from:F,to:void 0,options:ne,metadata:De})}replaceNotebookMetadata(F,ne,De){this._edits.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(F,ne,De,qe){const Qe=ne.start,ot=ne.end;(Qe!==ot||De.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:ot-Qe,cells:De,metadata:qe})}replaceNotebookCellMetadata(F,ne,De,qe){this._edits.push({_type:3,metadata:qe,uri:F,edit:{editType:3,index:ne,metadata:De}})}replace(F,ne,De,qe){this._edits.push({_type:2,uri:F,edit:new ae(ne,De),metadata:qe})}insert(F,ne,De,qe){this.replace(F,new N(ne,ne),De,qe)}delete(F,ne,De){this.replace(F,ne,"",De)}has(F){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===F.toString())}set(F,ne){if(ne)for(const De of ne){if(!De)continue;let qe,Qe;Array.isArray(De)?(qe=De[0],Qe=De[1]):qe=De,Ce.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(F,qe.range.start,qe.newCellMetadata,Qe):qe.newNotebookMetadata?this.replaceNotebookMetadata(F,qe.newNotebookMetadata,Qe):this.replaceNotebookCells(F,qe.range,qe.newCells,Qe):le.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:F,range:qe.range,edit:qe.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:qe,metadata:Qe})}else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===F.toString()&&(this._edits[De]=void 0);break}}(0,w.coalesceInPlace)(this._edits)}}get(F){const ne=[];for(const De of this._edits)De._type===2&&De.uri.toString()===F.toString()&&ne.push(De.edit);return ne}entries(){const F=new L.ResourceMap;for(const ne of this._edits)if(ne._type===2){let De=F.get(ne.uri);De||(De=[ne.uri,[]],F.set(ne.uri,De)),De[1].push(ne.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ie,e.WorkspaceEdit=ie=Ve([T],ie);let U=E=class{static isSnippetString(F){return F instanceof E?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=E._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ne=this._tabstop++){if(typeof F=="function"){const De=new E;De._tabstop=this._tabstop,F(De),this._tabstop=De._tabstop,F=De.value}else F=E._escape(F);return this.value+="${",this.value+=ne,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ne=this._tabstop++){const De=F.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,ne){if(typeof ne=="function"){const De=new E;De._tabstop=this._tabstop,ne(De),this._tabstop=De._tabstop,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.SnippetString=U,e.SnippetString=U=E=Ve([T],U);var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ue;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let we=r=class{static isLocation(F){return F instanceof r?!0:F?N.isRange(F.range)&&m.URI.isUri(F.uri):!1}constructor(F,ne){if(this.uri=F,ne)if(N.isRange(ne))this.range=N.of(ne);else if($.isPosition(ne))this.range=new N(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=we,e.Location=we=r=Ve([T],we);let Ee=class{static is(F){return F?typeof F.message=="string"&&F.location&&N.isRange(F.location.range)&&m.URI.isUri(F.location.uri):!1}constructor(F,ne){this.location=F,this.message=ne}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.location.range.isEqual(ne.location.range)&&F.location.uri.toString()===ne.location.uri.toString()}};e.DiagnosticRelatedInformation=Ee,e.DiagnosticRelatedInformation=Ee=Ve([T],Ee);let ge=class{constructor(F,ne,De=ue.Error){if(!N.isRange(F))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=F,this.message=ne,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.severity===ne.severity&&F.code===ne.code&&F.severity===ne.severity&&F.source===ne.source&&F.range.isEqual(ne.range)&&(0,w.equals)(F.tags,ne.tags)&&(0,w.equals)(F.relatedInformation,ne.relatedInformation,Ee.isEqual)}};e.Diagnostic=ge,e.Diagnostic=ge=Ve([T],ge);let ye=class{constructor(F,ne){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ne}};e.Hover=ye,e.Hover=ye=Ve([T],ye);var re;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let de=class{constructor(F,ne=re.Text){this.range=F,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=Ve([T],de);var se;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(B){B[B.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let he=s=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ne,De,qe,Qe){this.name=F,this.kind=ne,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),qe instanceof we?this.location=qe:De instanceof N&&(this.location=new we(qe,De)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=he,e.SymbolInformation=he=s=Ve([T],he);let Ie=n=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(n.validate)}constructor(F,ne,De,qe,Qe){this.name=F,this.detail=ne,this.kind=De,this.range=qe,this.selectionRange=Qe,this.children=[],n.validate(this)}};e.DocumentSymbol=Ie,e.DocumentSymbol=Ie=n=Ve([T],Ie);var O;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(O||(e.CodeActionTriggerKind=O={}));let V=class{constructor(F,ne){this.title=F,this.kind=ne}};e.CodeAction=V,e.CodeAction=V=Ve([T],V);let K=class{static{o=this}static{this.sep="."}constructor(F){this.value=F}append(F){return new o(this.value?this.value+o.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+o.sep)}};e.CodeActionKind=K,e.CodeActionKind=K=o=Ve([T],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let G=class{constructor(F,ne){if(this.range=F,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=G,e.SelectionRange=G=Ve([T],G);class q{constructor(F,ne,De,qe,Qe,ot){this.kind=F,this.name=ne,this.detail=De,this.uri=qe,this.range=Qe,this.selectionRange=ot}}e.CallHierarchyItem=q;class Z{constructor(F,ne){this.fromRanges=ne,this.from=F}}e.CallHierarchyIncomingCall=Z;class ce{constructor(F,ne){this.fromRanges=ne,this.to=F}}e.CallHierarchyOutgoingCall=ce;var Le;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let xe=class{constructor(F,ne){this.range=F,this.command=ne}get isResolved(){return!!this.command}};e.CodeLens=xe,e.CodeLens=xe=Ve([T],xe);let Ge=S=class{#e;static isMarkdownString(F){return F instanceof S?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ne=!1){this.#e=new k.MarkdownString(F,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,ne){return this.#e.appendCodeblock(ne??"",F),this}};e.MarkdownString=Ge,e.MarkdownString=Ge=S=Ve([T],Ge);let je=class{constructor(F,ne){this.label=F,this.documentation=ne}};e.ParameterInformation=je,e.ParameterInformation=je=Ve([T],je);let Je=class{constructor(F,ne){this.label=F,this.documentation=ne,this.parameters=[]}};e.SignatureInformation=Je,e.SignatureInformation=Je=Ve([T],Je);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ye,e.SignatureHelp=Ye=Ve([T],Ye);var Ze;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Ze||(e.SignatureHelpTriggerKind=Ze={}));var it;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(F){this.value=F}};e.InlayHintLabelPart=tt,e.InlayHintLabelPart=tt=Ve([T],tt);let Ue=class{constructor(F,ne,De){this.position=F,this.label=ne,this.kind=De}};e.InlayHint=Ue,e.InlayHint=Ue=Ve([T],Ue);var st;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var J;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(J||(e.CompletionItemKind=J={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let ve=class{constructor(F,ne){this.label=F,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ve,e.CompletionItem=ve=Ve([T],ve);let Be=class{constructor(F=[],ne=!1){this.items=F,this.isIncomplete=ne}};e.CompletionList=Be,e.CompletionList=Be=Ve([T],Be);let Ne=class{constructor(F,ne,De){this.insertText=F,this.range=ne,this.command=De}};e.InlineSuggestion=Ne,e.InlineSuggestion=Ne=Ve([T],Ne);let Xe=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=Xe,e.InlineSuggestionList=Xe=Ve([T],Xe);var rt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var gt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(gt||(e.StatusBarAlignment=gt={}));function wt(B,F){return`${D.ExtensionIdentifier.toKey(B)}.${F}`}e.asStatusBarItemIdentifier=wt;var kt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(kt||(e.TextEditorLineNumbersStyle=kt={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var Vt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var Et;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Bt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Bt||(e.TextDocumentChangeReason=Bt={}));var Lt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Lt||(e.DecorationRangeBehavior=Lt={})),function(B){function F(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(Et||(e.TextEditorSelectionChangeKind=Et={}));var $t;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(B){function F(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}($t||(e.SyntaxTokenType=$t={}));let Pt=class{constructor(F,ne){if(ne&&!m.URI.isUri(ne))throw(0,R.illegalArgument)("target");if(!N.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.target=ne}};e.DocumentLink=Pt,e.DocumentLink=Pt=Ve([T],Pt);let Tt=class{constructor(F,ne,De,qe){this.red=F,this.green=ne,this.blue=De,this.alpha=qe}};e.Color=Tt,e.Color=Tt=Ve([T],Tt);let Mt=class{constructor(F,ne){if(ne&&!(ne instanceof Tt))throw(0,R.illegalArgument)("color");if(!N.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.color=ne}};e.ColorInformation=Mt,e.ColorInformation=Mt=Ve([T],Mt);let zt=class{constructor(F){if(!F||typeof F!="string")throw(0,R.illegalArgument)("label");this.label=F}};e.ColorPresentation=zt,e.ColorPresentation=zt=Ve([T],zt);var qt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var at;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class lt{constructor(F,ne,De){if(this.startIndex=F,this.length=ne,this.tooltip=De,typeof F!="number"||F<0)throw(0,R.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,R.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=lt;class Kt{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=Kt;class It{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=It;var _t;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(_t||(e.TerminalLocation=_t={}));class ht{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=ht;var Dt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var Ft;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let St=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(F){switch(F){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(F,ne){if(this.label=ne,typeof F!="string"||typeof ne!="string")throw(0,R.illegalArgument)("name");this._id=F}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=h=Ve([T],St);function He(B){let F="";for(let ne=0;ne<B.length;ne++)F+=B[ne].replace(/,/g,",,")+",";return F}let Nt=class{constructor(F,ne,De){if(typeof F!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=F,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=De):this._options=ne)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,R.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)F.push(ne);return He(F)}};e.ProcessExecution=Nt,e.ProcessExecution=Nt=Ve([T],Nt);let Ut=class{constructor(F,ne,De){if(this._args=[],Array.isArray(ne)){if(!F)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this._command=F,this._args=ne,this._options=De}else{if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=F,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)F.push(typeof ne=="string"?ne:ne.value);return He(F)}};e.ShellExecution=Ut,e.ShellExecution=Ut=Ve([T],Ut);var ke;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ke||(e.ShellQuoting=ke={}));var Te;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class me{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=me;let j=class{static{I=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(F,ne,De,qe,Qe,ot){this.__deprecated=!1,this._definition=this.definition=F;let ut;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=De,this.execution=qe,ut=Qe,this.__deprecated=!0):ne===Te.Global||ne===Te.Workspace?(this.target=ne,this._name=this.name=De,this._source=this.source=qe,this.execution=Qe,ut=ot):(this.target=ne,this._name=this.name=De,this._source=this.source=qe,this.execution=Qe,ut=ot),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Nt?this._definition={type:I.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ut?this._definition={type:I.ShellType,id:this._execution.computeId()}:this._execution instanceof me?this._definition={type:I.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:I.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ne=this._definition.type;(I.EmptyType===ne||I.ProcessType===ne||I.ShellType===ne||I.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};e.Task=j,e.Task=j=I=Ve([T],j);var Oe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Oe||(e.ProgressLocation=Oe={}));var $e;(function(B){function F(ne){const De=ne;return(0,y.isNumber)(De.value)?De.tooltip&&!(0,y.isString)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=F})($e||(e.ViewBadge=$e={}));let Ke=C=class{static isTreeItem(F,ne){const De=F;if(De.checkboxState!==void 0){const qe=(0,y.isNumber)(De.checkboxState)?De.checkboxState:(0,y.isObject)(De.checkboxState)&&(0,y.isNumber)(De.checkboxState.state)?De.checkboxState.state:void 0,Qe=!(0,y.isNumber)(De.checkboxState)&&(0,y.isObject)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(qe===void 0||qe!==et.Checked&&qe!==et.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof C)return!0;if(De.label!==void 0&&!(0,y.isString)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,y.isString)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,y.isString)(De.iconPath)&&!m.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,y.isString)(De.iconPath.id))){const qe=De.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!m.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!m.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,y.isString)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!m.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,y.isString)(De.tooltip)&&!(De.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<We.None&&De.collapsibleState>We.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,y.isString)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,ne=We.None){this.collapsibleState=ne,m.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=Ke,e.TreeItem=Ke=C=Ve([T],Ke);var We;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(We||(e.TreeItemCollapsibleState=We={}));var et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let mt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=mt,e.DataTransferItem=mt=Ve([T],mt);class ft extends mt{}e.InternalDataTransferItem=ft;class vt extends ft{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.InternalFileDataTransferItem=vt;class dt{constructor(F,ne,De,qe){this.name=F,this.uri=ne,this._itemId=De,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=dt;let At=class{#e=new Map;constructor(F){for(const[ne,De]of F??[]){const qe=this.#e.get(this.#t(ne));qe?qe.push(De):this.#e.set(this.#t(ne),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,ne){this.#e.set(this.#t(F),[ne])}forEach(F,ne){for(const[De,qe]of this.#e)for(const Qe of qe)F.call(ne,Qe,De,this)}*[Symbol.iterator](){for(const[F,ne]of this.#e)for(const De of ne)yield[F,De]}#t(F){return F.toLowerCase()}};e.DataTransfer=At,e.DataTransfer=At=Ve([T],At);let jt=class{constructor(F){this.insertText=F}};e.DocumentDropEdit=jt,e.DocumentDropEdit=jt=Ve([T],jt);let _i=class{constructor(F,ne){this.label=ne,this.insertText=F}};e.DocumentPasteEdit=_i,e.DocumentPasteEdit=_i=Ve([T],_i);let Wt=class{constructor(F,ne){this.id=F,this.color=ne}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=Wt,e.ThemeIcon=Wt=Ve([T],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let gi=class{constructor(F){this.id=F}};e.ThemeColor=gi,e.ThemeColor=gi=Ve([T],gi);var Ct;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let yi=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=m.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,ne){if(typeof F!="string"&&(!F||!m.URI.isUri(F)&&!m.URI.isUri(F.uri)))throw(0,R.illegalArgument)("base");if(typeof ne!="string")throw(0,R.illegalArgument)("pattern");typeof F=="string"?this.baseUri=m.URI.file(F):m.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=yi,e.RelativePattern=yi=Ve([T],yi);const Hi=new WeakMap;function yt(B,F){Hi.set(B,F)}e.setBreakpointId=yt;let ii=class{constructor(F,ne,De,qe){this.enabled=typeof F=="boolean"?F:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=Hi.get(this)??(0,P.generateUuid)()),this._id}};e.Breakpoint=ii,e.Breakpoint=ii=Ve([T],ii);let pi=class extends ii{constructor(F,ne,De,qe,Qe){if(super(ne,De,qe,Qe),F===null)throw(0,R.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=Ve([T],pi);let oi=class extends ii{constructor(F,ne,De,qe,Qe){super(ne,De,qe,Qe),this.functionName=F}};e.FunctionBreakpoint=oi,e.FunctionBreakpoint=oi=Ve([T],oi);let Di=class extends ii{constructor(F,ne,De,qe,Qe,ot,ut){if(super(qe,Qe,ot,ut),!ne)throw(0,R.illegalArgument)("dataId");this.label=F,this.dataId=ne,this.canPersist=De}};e.DataBreakpoint=Di,e.DataBreakpoint=Di=Ve([T],Di);let Ci=class{constructor(F,ne,De){this.command=F,this.args=ne||[],this.options=De}};e.DebugAdapterExecutable=Ci,e.DebugAdapterExecutable=Ci=Ve([T],Ci);let Rt=class{constructor(F,ne){this.port=F,this.host=ne}};e.DebugAdapterServer=Rt,e.DebugAdapterServer=Rt=Ve([T],Rt);let vi=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=Ve([T],vi);let Ii=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=Ii,e.DebugAdapterInlineImplementation=Ii=Ve([T],Ii);let ai=class{constructor(F,ne,De){this.session=F,this.threadId=ne,this.frameId=De}};e.StackFrameFocus=ai,e.StackFrameFocus=ai=Ve([T],ai);let ci=class{constructor(F,ne){this.session=F,this.threadId=ne}};e.ThreadFocus=ci,e.ThreadFocus=ci=Ve([T],ci);let ct=class{constructor(F,ne){this.range=F,this.expression=ne}};e.EvaluatableExpression=ct,e.EvaluatableExpression=ct=Ve([T],ct);var Wi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let Yt=class{constructor(F,ne){this.range=F,this.text=ne}};e.InlineValueText=Yt,e.InlineValueText=Yt=Ve([T],Yt);let ni=class{constructor(F,ne,De=!0){this.range=F,this.variableName=ne,this.caseSensitiveLookup=De}};e.InlineValueVariableLookup=ni,e.InlineValueVariableLookup=ni=Ve([T],ni);let Ei=class{constructor(F,ne){this.range=F,this.expression=ne}};e.InlineValueEvaluatableExpression=Ei,e.InlineValueEvaluatableExpression=Ei=Ve([T],Ei);let ki=class{constructor(F,ne){this.frameId=F,this.stoppedLocation=ne}};e.InlineValueContext=ki,e.InlineValueContext=ki=Ve([T],ki);var Vi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Pi=l=class extends Error{static FileExists(F){return new l(F,a.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(F){return new l(F,a.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(F){return new l(F,a.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(F){return new l(F,a.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(F){return new l(F,a.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(F){return new l(F,a.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}constructor(F,ne=a.FileSystemProviderErrorCode.Unknown,De){super(m.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,a.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.FileSystemError=Pi,e.FileSystemError=Pi=l=Ve([T],Pi);let bi=class{constructor(F,ne,De){this.start=F,this.end=ne,this.kind=De}};e.FoldingRange=bi,e.FoldingRange=bi=Ve([T],bi);var qi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ti;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var li;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var ji;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ai{constructor(F,ne=[]){this.tokenTypes=F,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ai;function cn(B){return typeof B>"u"||(0,y.isStringArray)(B)}class Ri{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ne=0,De=F.tokenTypes.length;ne<De;ne++)this._tokenTypeStrToInt.set(F.tokenTypes[ne],ne);for(let ne=0,De=F.tokenModifiers.length;ne<De;ne++)this._tokenModifierStrToInt.set(F.tokenModifiers[ne],ne)}}push(F,ne,De,qe,Qe){if(typeof F=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,ne,De,qe,Qe);if(N.isRange(F)&&typeof ne=="string"&&cn(De))return this._push(F,ne,De);throw(0,R.illegalArgument)()}_push(F,ne,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const qe=F.start.line,Qe=F.start.character,ot=F.end.character-F.start.character,ut=this._tokenTypeStrToInt.get(ne);let xt=0;if(De)for(const Xt of De){if(!this._tokenModifierStrToInt.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this._tokenModifierStrToInt.get(Xt);xt|=1<<ei>>>0}this._pushEncoded(qe,Qe,ot,ut,xt)}_pushEncoded(F,ne,De,qe,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<xt;ti++){let si=this._data[5*ti],$i=this._data[5*ti+1];si===0?(si=Xt,$i+=ei):si+=Xt,this._data[5*ti]=si,this._data[5*ti+1]=$i,Xt=si,ei=$i}}let ot=F,ut=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=ne}static _sortAndDeltaEncode(F){const ne=[],De=F.length/5|0;for(let ut=0;ut<De;ut++)ne[ut]=ut;ne.sort((ut,xt)=>{const Xt=F[5*ut],ei=F[5*xt];if(Xt===ei){const ti=F[5*ut+1],si=F[5*xt+1];return ti-si}return Xt-ei});const qe=new Uint32Array(F.length);let Qe=0,ot=0;for(let ut=0;ut<De;ut++){const xt=5*ne[ut],Xt=F[xt+0],ei=F[xt+1],ti=F[xt+2],si=F[xt+3],$i=F[xt+4],wn=Xt-Qe,Rn=wn===0?ei-ot:ei,zi=5*ut;qe[zi+0]=wn,qe[zi+1]=Rn,qe[zi+2]=ti,qe[zi+3]=si,qe[zi+4]=$i,Qe=Xt,ot=ei}return qe}build(F){return this._dataIsSortedAndDeltaEncoded?new ri(new Uint32Array(this._data),F):new ri(Ri._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ri;class ri{constructor(F,ne){this.resultId=ne,this.data=F}}e.SemanticTokens=ri;class ln{constructor(F,ne,De){this.start=F,this.deleteCount=ne,this.data=De}}e.SemanticTokensEdit=ln;class un{constructor(F,ne){this.resultId=ne,this.edits=F}}e.SemanticTokensEdits=un;var Ki;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ki||(e.DebugConsoleMode=Ki={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=Ve([T],fi);var Gi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var Xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var mi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(mi||(e.ExtensionKind=mi={}));class Qi{static validate(F){if(typeof F.badge=="string"){let ne=(0,u.nextCharLength)(F.badge,0);if(ne<F.badge.length&&(ne+=(0,u.nextCharLength)(F.badge,ne)),F.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Wt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ne,De){this.badge=F,this.tooltip=ne,this.color=De}}e.FileDecoration=Qi;let Oi=class{constructor(F){this.kind=F}};e.ColorTheme=Oi,e.ColorTheme=Oi=Ve([T],Oi);var Yi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Jt{static isNotebookRange(F){return F instanceof Jt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,ne){if(F<0)throw(0,R.illegalArgument)("start must be positive");if(ne<0)throw(0,R.illegalArgument)("end must be positive");F<=ne?(this._start=F,this._end=ne):(this._start=ne,this._end=F)}with(F){let ne=this._start,De=this._end;return F.start!==void 0&&(ne=F.start),F.end!==void 0&&(De=F.end),ne===this._start&&De===this._end?this:new Jt(ne,De)}}e.NotebookRange=Jt;class Si{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ne=>Si.isNotebookCellData(ne))}static isNotebookCellData(F){return!0}constructor(F,ne,De,qe,Qe,ot,ut){this.kind=F,this.value=ne,this.languageId=De,this.mime=qe,this.outputs=Qe??[],this.metadata=ot,this.executionSummary=ut,Si.validate(this)}}e.NotebookCellData=Si;class dn{constructor(F){this.cells=F}}e.NotebookData=dn;class Gt{static isNotebookCellOutputItem(F){return F instanceof Gt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ne={name:F.name,message:F.message,stack:F.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(F){return Gt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Gt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ne="application/octet-stream"){return new Gt(F,ne)}static#e=new TextEncoder;static text(F,ne=A.Mimes.text){const De=Gt.#e.encode(String(F));return new Gt(De,ne)}static json(F,ne="text/x-json"){const De=JSON.stringify(F,void 0,"	");return Gt.text(De,ne)}constructor(F,ne){this.data=F,this.mime=ne;const De=(0,A.normalizeMimeType)(ne,!0);if(!De)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.NotebookCellOutputItem=Gt;class ui{static isNotebookCellOutput(F){return F instanceof ui?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ne=!1){const De=new Set,qe=new Set;for(let Qe=0;Qe<F.length;Qe++){const ot=F[Qe],ut=(0,A.normalizeMimeType)(ot.mime);if(!De.has(ut)||(0,p.isTextStreamMime)(ut)){De.add(ut);continue}qe.add(Qe),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return qe.size===0?F:F.filter((Qe,ot)=>!qe.has(ot))}constructor(F,ne,De){this.items=ui.ensureUniqueMimeTypes(F,!0),typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=(0,P.generateUuid)(),this.metadata=ne??De)}}e.NotebookCellOutput=ui;var Fi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Me;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Me||(e.NotebookCellExecutionState=Me={}));var Zt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Zt||(e.NotebookCellStatusBarAlignment=Zt={}));var Li;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class pt{constructor(F,ne){this.text=F,this.alignment=ne}}e.NotebookCellStatusBarItem=pt;var Ji;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Ji||(e.NotebookControllerAffinity=Ji={}));var Zi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class en{constructor(F,ne=[]){this.uri=F,this.provides=(0,w.asArray)(ne)}}e.NotebookRendererScript=en;class hn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=hn;let di=class{constructor(F,ne){this.label=F,this.timestamp=ne}};e.TimelineItem=di,e.TimelineItem=di=Ve([T],di);var tn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(F,ne){this.ranges=F,this.wordPattern=ne}}e.LinkedEditingRanges=sn;class fn{constructor(F){this._autoForwardAction=F}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor(F=void 0,ne=void 0,De=void 0,qe=!1){this.include=F,this.exclude=ne,this.profile=De,this.continuous=qe}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=Ve([T],Mi);let Ni=g=class{static diff(F,ne,De){const qe=new g(F);return qe.expectedOutput=ne,qe.actualOutput=De,qe}constructor(F){this.message=F}};e.TestMessage=Ni,e.TestMessage=Ni=g=Ve([T],Ni);let Ui=class{constructor(F){this.id=F}};e.TestTag=Ui,e.TestTag=Ui=Ve([T],Ui);let hi=class{constructor(F,ne){this.covered=F,this.total=ne}};e.CoveredCount=hi,e.CoveredCount=hi=Ve([T],hi);let xi=d=class{static fromDetails(F,ne){const De=new hi(0,0),qe=new hi(0,0),Qe=new hi(0,0);for(const ut of ne)if("branches"in ut){De.total+=1,De.covered+=ut.executionCount>0?1:0;for(const xt of ut.branches)qe.total+=1,qe.covered+=xt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ut.executionCount>0?1:0;const ot=new d(F,De,qe.total>0?qe:void 0,Qe.total>0?Qe:void 0);return ot.detailedCoverage=ne,ot}constructor(F,ne,De,qe){this.uri=F,this.statementCoverage=ne,this.branchCoverage=De,this.functionCoverage=qe}};e.FileCoverage=xi,e.FileCoverage=xi=d=Ve([T],xi);let Bi=class{constructor(F,ne,De=[]){this.executionCount=F,this.location=ne,this.branches=De}};e.StatementCoverage=Bi,e.StatementCoverage=Bi=Ve([T],Bi);let ee=class{constructor(F,ne){this.executionCount=F,this.location=ne}};e.BranchCoverage=ee,e.BranchCoverage=ee=Ve([T],ee);let fe=class{constructor(F,ne){this.executionCount=F,this.location=ne}};e.FunctionCoverage=fe,e.FunctionCoverage=fe=Ve([T],fe);var Fe;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Fe||(e.ExternalUriOpenerPriority=Fe={}));var nt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var bt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class Ot{constructor(F,ne,De,qe,Qe,ot){this.kind=F,this.name=ne,this.detail=De,this.uri=qe,this.range=Qe,this.selectionRange=ot}}e.TypeHierarchyItem=Ot;class Sn{constructor(F){this.uri=F}}e.TextTabInput=Sn;class _n{constructor(F,ne){this.original=F,this.modified=ne}}e.TextDiffTabInput=_n;class yn{constructor(F,ne,De,qe){this.base=F,this.input1=ne,this.input2=De,this.result=qe}}e.TextMergeTabInput=yn;class Dn{constructor(F,ne){this.uri=F,this.viewType=ne}}e.CustomEditorTabInput=Dn;class Cn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Cn;class In{constructor(F,ne){this.uri=F,this.notebookType=ne}}e.NotebookEditorTabInput=In;class kn{constructor(F,ne,De){this.original=F,this.modified=ne,this.notebookType=De}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(F,ne){this.uri=F,this.inputBoxUri=ne}}e.InteractiveWindowInput=Tn;var mn;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var gn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(gn||(e.InteractiveSessionCopyKind=gn={}));var pn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var vn;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class An{constructor(F,ne){this.role=F,this.content=ne}}e.ChatMessage=An;var bn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Ae[100],Re([1,0,51,13,15,277,136,7,18]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function P(p,f){f?m.set(p,f):m.delete(p)}e.setWordDefinitionFor=P;function D(p){return m.get(p)}class a extends L.MirrorTextModel{constructor(f,t,i,c,b,_,E,r){super(t,i,c,b),this._proxy=f,this._languageId=_,this._isDirty=E,this.notebook=r,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,y.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},save(){return f._save()},getText(t){return t?f._getTextInRange(t):f.getText()},get eol(){return f._eol===`
`?u.EndOfLine.LF:u.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(t){return f._lineAt(t)},offsetAt(t){return f._offsetAt(t)},positionAt(t){return f._positionAt(t)},validateRange(t){return f._validateRange(t)},validatePosition(t){return f._validatePosition(t)},getWordRangeAtPosition(t,i){return f._getWordRangeAtPosition(t,i)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,w.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,w.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const t=this._validateRange(f);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const i=this._eol,c=t.start.line,b=t.end.line,_=[];_.push(this._lines[c].substring(t.start.character));for(let E=c+1;E<b;E++)_.push(this._lines[E]);return _.push(this._lines[b].substring(0,t.end.character)),_.join(i)}_lineAt(f){let t;if(f instanceof u.Position?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this._lines[t],t===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(f),i=this._lines[t.index].length;return new u.Position(t.index,Math.min(t.remainder,i))}_validateRange(f){if(!(f instanceof u.Range))throw new Error("Invalid argument");const t=this._validatePosition(f.start),i=this._validatePosition(f.end);return t===f.start&&i===f.end?f:new u.Range(t.line,t.character,i.line,i.character)}_validatePosition(f){if(!(f instanceof u.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:t,character:i}=f,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this._lines.length)t=this._lines.length-1,i=this._lines[t].length,c=!0;else{const b=this._lines[t].length;i<0?(i=0,c=!0):i>b&&(i=b,c=!0)}return c?new u.Position(t,i):f}_getWordRangeAtPosition(f,t){const i=this._validatePosition(f);if(!t)t=D(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.getWordAtText)(i.character+1,(0,A.ensureValidWordDefinition)(t),this._lines[i.line],0);if(c)return new u.Range(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.ExtHostDocumentData=a;class v{constructor(f,t,i){this._line=f,this._text=t,this._isLastLine=i}get lineNumber(){return this._line}get text(){return this._text}get range(){return new u.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new u.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=v}),define(Ae[196],Re([1,0,7,17,5]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(u){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(u){let y;switch(u){case"light":y=w.ColorThemeKind.Light;break;case"hcDark":y=w.ColorThemeKind.HighContrast;break;case"hcLight":y=w.ColorThemeKind.HighContrastLight;break;default:y=w.ColorThemeKind.Dark}this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=L,e.ExtHostTheming=L=Ve([ze(0,R.IExtHostRpcService)],L)}),define(Ae[197],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.INotebookExecutionService=(0,w.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(L){L.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class k{static fromExtHostTestItem(A,u,y=A.parent){if(A._isRoot)return new k([u]);const m=[A.id];for(let P=y;P&&P.id!==u;P=P.parent)m.push(P.id);return m.push(u),new k(m.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const u=A.indexOf("\0");return u===-1?A:A.slice(0,u)}static fromString(A){return new k(A.split("\0"))}static join(A,u){return new k([...A.path,u])}static joinToString(A,u){return A.toString()+"\0"+u}static parentId(A){const u=A.lastIndexOf("\0");return u===-1?void 0:A.slice(0,u)}static localId(A){const u=A.lastIndexOf("\0");return u===-1?A:A.slice(u+1)}static isChild(A,u){return u.startsWith(A)&&u[A.length]==="\0"}static compare(A,u){return A===u?0:k.isChild(A,u)?2:k.isChild(u,A)?3:1}constructor(A,u=A.length){if(this.path=A,this.viewEnd=u,A.length===0||u<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new k(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new k(this.path,A)}compare(A){if(typeof A=="string")return k.compare(this.toString(),A);for(let u=0;u<A.viewEnd&&u<this.viewEnd;u++)if(A.path[u]!==this.path[u])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=k}),define(Ae[56],Re([1,0,2,44,45]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var u;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(u||(e.TestRunProfileBitset=u={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=C=>"runId"in C;e.isStartControllerTests=y;var m;(function(C){C.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),C.deserialize=l=>({range:R.Range.lift(l.range),uri:w.URI.revive(l.uri)})})(m||(e.IRichLocation=m={}));var P;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(C){C.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&m.serialize(l.location)}),C.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&m.deserialize(l.location)})})(D||(e.ITestErrorMessage=D={}));const a=(C,l)=>`${l?"s":"e"}${C}`;e.getMarkId=a;var v;(function(C){C.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&m.serialize(l.location)}),C.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&m.deserialize(l.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(C){C.serialize=l=>l.type===0?D.serialize(l):v.serialize(l),C.deserialize=l=>l.type===0?D.deserialize(l):v.deserialize(l)})(p||(e.ITestMessage=p={}));var f;(function(C){C.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),C.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(p.serialize)}),C.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(C,l)=>C+t+l;e.namespaceTestTag=i;const c=C=>{const l=C.indexOf(t);return{ctrlId:C.slice(0,l),tagId:C.slice(l+1)}};e.denamespaceTestTag=c;var b;(function(C){C.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),C.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?w.URI.revive(l.uri):void 0,range:l.range?R.Range.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(b||(e.ITestItem=b={}));var _;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(_||(e.TestItemExpandState=_={}));var E;(function(C){C.serialize=l=>({expand:l.expand,item:b.serialize(l.item)}),C.deserialize=l=>({controllerId:k.TestId.root(l.item.extId),expand:l.expand,item:b.deserialize(l.item)})})(E||(e.InternalTestItem=E={}));var r;(function(C){C.serialize=l=>{let g;return l.item&&(g={},l.item.label!==void 0&&(g.label=l.item.label),l.item.tags!==void 0&&(g.tags=l.item.tags),l.item.busy!==void 0&&(g.busy=l.item.busy),l.item.uri!==void 0&&(g.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&(g.range=l.item.range?.toJSON()),l.item.description!==void 0&&(g.description=l.item.description),l.item.error!==void 0&&(g.error=l.item.error),l.item.sortText!==void 0&&(g.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:g}},C.deserialize=l=>{let g;return l.item&&(g={},l.item.label!==void 0&&(g.label=l.item.label),l.item.tags!==void 0&&(g.tags=l.item.tags),l.item.busy!==void 0&&(g.busy=l.item.busy),l.item.range!==void 0&&(g.range=l.item.range?R.Range.lift(l.item.range):null),l.item.description!==void 0&&(g.description=l.item.description),l.item.error!==void 0&&(g.error=l.item.error),l.item.sortText!==void 0&&(g.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:g}}})(r||(e.ITestItemUpdate=r={}));const s=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=s;var n;(function(C){C.serializeWithoutMessages=l=>({...E.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serializeWithoutMessages)}),C.serialize=l=>({...E.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serialize)}),C.deserialize=l=>({...E.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(o||(e.DetailType=o={}));var S;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(S||(e.TestDiffOpType=S={}));var h;(function(C){C.deserialize=l=>l.op===0?{op:l.op,item:E.deserialize(l.item)}:l.op===1?{op:l.op,item:r.deserialize(l.item)}:l.op===2?{op:l.op,uri:w.URI.revive(l.uri),docv:l.docv}:l,C.serialize=l=>l.op===0?{op:l.op,item:E.serialize(l.item)}:l.op===1?{op:l.op,item:r.serialize(l.item)}:l})(h||(e.TestsDiffOp=h={}));class I{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const g=this.createChangeCollector();for(const d of l)switch(d.op){case 0:this.add(E.deserialize(d.item),g);break;case 1:this.update(r.deserialize(d.item),g);break;case 3:this.remove(d.itemId,g);break;case 5:this.retireTest(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this._tags.set(d.tag.id,d.tag);break;case 7:this._tags.delete(d.id);break}g.complete?.()}add(l,g){const d=k.TestId.parentId(l.item.extId)?.toString();let T;if(!d)T=this.createItem(l),this.roots.add(T),this.items.set(l.item.extId,T);else if(this.items.has(d)){const z=this.items.get(d);z.children.add(l.item.extId),T=this.createItem(l,z),this.items.set(l.item.extId,T)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(l)}`);return}return g.add?.(T),l.expand===2&&this.busyControllerCount++,T}update(l,g){const d=this.items.get(l.extId);if(d)return l.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,l),g.update?.(d),d}remove(l,g){const d=this.items.get(l);if(!d)return;const T=k.TestId.parentId(d.item.extId)?.toString();T?this.items.get(T).children.delete(d.item.extId):this.roots.delete(d);const z=[[l]];for(;z.length;)for(const H of z.pop()){const x=this.items.get(H);x&&(z.push(x.children),this.items.delete(H),g.remove?.(x,x!==d),x.expand===2&&this.busyControllerCount--)}}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=I}),define(Ae[76],Re([1,0,12,5,6,51,56,45]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const m=(c,b)=>c===b,D=Object.entries({range:(c,b)=>c===b?!0:!c||!b?!1:c.equalsRange(b),busy:m,label:m,description:m,error:m,sortText:m,tags:(c,b)=>!(c.length!==b.length||c.some(_=>!b.includes(_)))}),a=(c,b)=>{let _;for(const[E,r]of D)r(c[E],b[E])||(_?_[E]=b[E]:_={[E]:b[E]});return _};class v extends k.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const _ of this.tree.values())this.updateExpandability(_)}get resolveHandler(){return this._resolveHandler}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const _ of this.diff)if(_.op===2&&_.uri===b.uri){_.docv=b.docv;return}break}case 1:{const _=this.diff[this.diff.length-1];if(_){if(_.op===1&&_.item.extId===b.item.extId){(0,A.applyTestItemUpdate)(_.item,b.item);return}if(_.op===0&&_.item.item.extId===b.item.extId){(0,A.applyTestItemUpdate)(_.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,_){const E=this.tree.get(b);if(E){if((E.expandLevels===void 0||_>E.expandLevels)&&(E.expandLevels=_),E.expand===1){const r=this.resolveChildren(E);return r.isOpen()?this.expandChildren(E,_-1):r.wait().then(()=>this.expandChildren(E,_-1))}else if(E.expand===3)return E.resolveBarrier?.isOpen()===!1?E.resolveBarrier.wait().then(()=>this.expandChildren(E,_-1)):this.expandChildren(E,_-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,_){switch(_.op){case 3:this.removeItem(u.TestId.joinToString(b.fullId,_.id));break;case 0:this.upsertItem(_.item,b);break;case 5:for(const E of _.ops)this.onTestItemEvent(b,E);break;case 1:this.diffTagRefs(_.new,_.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:_.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,L.assertNever)(_)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,_){const E=u.TestId.fromExtHostTestItem(b,this.root.id,_?.actual),r=this.options.getApiFor(b);r.parent&&r.parent!==_?.actual&&this.options.getChildren(r.parent).delete(b.id);let s=this.tree.get(E.toString());if(!s){s={fullId:E,actual:b,expandLevels:_?.expandLevels?_.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(b,_),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,s,_);return}if(s.actual===b){this.connectItem(b,s,_);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.removeItem(E.toString()),this.upsertItem(b,_);const n=this.options.getChildren(s.actual),o=s.actual,S=a(this.options.toITestItem(o),this.options.toITestItem(b));this.options.getApiFor(o).listener=void 0,s.actual=b,s.expand=0,S&&(S.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,o.tags,E.toString()),delete S.tags),this.onTestItemEvent(s,{op:4,update:S})),this.connectItemAndChildren(b,s,_);for(const[h,I]of n)this.options.getChildren(b).get(I.id)||this.removeItem(u.TestId.joinToString(E,I.id));this.documentSynced(s.actual.uri)}diffTagRefs(b,_,E){const r=new Set(_.map(s=>s.id));for(const s of b)r.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:E,item:{tags:b.map(s=>(0,A.namespaceTestTag)(this.options.controllerId,s.id))}}}),r.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const _=this.tags.get(b.id);_?_.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const _=this.tags.get(b);_&&!--_.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,_){this.options.getApiFor(b).parent=_&&_.actual!==this.root?_.actual:void 0}connectItem(b,_,E){this.setItemParent(b,E);const r=this.options.getApiFor(b);r.parent=E?.actual,r.listener=s=>this.onTestItemEvent(_,s),this.updateExpandability(_)}connectItemAndChildren(b,_,E){this.connectItem(b,_,E);for(const[r,s]of this.options.getChildren(b))this.upsertItem(s,_)}updateExpandability(b){let _;this._resolveHandler?b.resolveBarrier?_=b.resolveBarrier.isOpen()?3:2:_=b.actual.canResolveChildren?1:0:_=0,_!==b.expand&&(b.expand=_,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:_}}),_===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,_){if(_<0)return;const E=[];for(const[r,s]of this.options.getChildren(b.actual)){const n=this.expand(u.TestId.joinToString(b.fullId,s.id),_);(0,w.isThenable)(n)&&E.push(n)}if(E.length)return Promise.all(E).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const s=new w.Barrier;return s.open(),s}b.expand=2,this.pushExpandStateUpdate(b);const _=b.resolveBarrier=new w.Barrier,E=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let r;try{r=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(s){E(s)}return(0,w.isThenable)(r)?r.catch(E).then(()=>{_.open(),this.updateExpandability(b)}):(_.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const _=this.tree.get(b);if(!_)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const E=[_];for(;E.length;){const r=E.pop();if(r){this.options.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(r.fullId.toString());for(const[s,n]of this.options.getChildren(r.actual))E.push(this.tree.get(u.TestId.joinToString(r.fullId,n.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=v;class p extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=p;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class t extends Error{constructor(b,_,E){super(`TestItem with ID "${b}" is from controller "${_}" and cannot be added as a child of an item from controller "${E}".`)}}e.MixedTestItemController=t;const i=(c,b,_)=>{let E=new Map;return{get size(){return E.size},forEach(r,s){for(const n of E.values())r.call(s,n,this)},[Symbol.iterator](){return E.entries()},replace(r){const s=new Map,n=new Set(E.keys()),o={op:5,ops:[]};for(const S of r){if(!(S instanceof _))throw new f(S.id);const h=b(S).controllerId;if(h!==c.controllerId)throw new t(S.id,h,c.controllerId);if(s.has(S.id))throw new p(S.id);s.set(S.id,S),n.delete(S.id),o.ops.push({op:0,item:S})}for(const S of n.keys())o.ops.push({op:3,id:S});c.listener?.(o),E=s},add(r){if(!(r instanceof _))throw new f(r.id);E.set(r.id,r),c.listener?.({op:0,item:r})},delete(r){E.delete(r)&&c.listener?.({op:3,id:r})},get(r){return E.get(r)},toJSON(){return Array.from(E.values())}}};e.createTestItemChildren=i}),define(Ae[101],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,k=(A,u)=>{const y={controllerId:u};return R.set(A,y),y};e.createPrivateApiFor=k;const L=A=>{const u=R.get(A);if(!u)throw new w.InvalidTestItemError(A?.id||"<unknown>");return u};e.getPrivateApiFor=L}),define(Ae[77],Re([1,0,13,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(u,y){return u.scheme===w.Schemas.http||u.scheme===w.Schemas.https?u:(y&&y.authority&&y.isRemote&&u.scheme===w.Schemas.file&&(u=R.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:u.path})),R.URI.from({scheme:w.Schemas.https,authority:`${u.scheme}+${L(u.authority)}.${e.webviewRootResourceAuthority}`,path:u.path,fragment:u.fragment,query:u.query}))}e.asWebviewUri=k;function L(u){return u.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function A(u){return u.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=A}),define(Ae[198],Re([1,0,5,6,77]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(u,y,m){this._proxy=u,this._editors=y,this._remoteInfo=m,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const P=y.getVisibleTextEditors();for(const D of this._insets.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(u=>u.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(u,y,m,P,D){let a;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===u){a=b;break}if(!a)throw new Error("not a visible editor");const v=this,p=this._handlePool++,f=new w.Emitter,t=new w.Emitter,i=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,k.asWebviewUri)(b,v._remoteInfo)}get cspSource(){return k.webviewGenericCspSource}set options(b){this._options=b,v._proxy.$setOptions(p,b)}get options(){return this._options}set html(b){this._html=b,v._proxy.$setHtml(p,b)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(b){return v._proxy.$postMessage(p,b)}},c=new class{constructor(){this.editor=u,this.line=y,this.height=m,this.webview=i,this.onDidDispose=t.event}dispose(){v._insets.has(p)&&(v._insets.delete(p),v._proxy.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this._proxy.$createEditorInset(p,a.id,a.value.document.uri,y+1,m,P||{},D.identifier,D.extensionLocation),this._insets.set(p,{editor:u,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(u){const y=this._insets.get(u);y&&y.inset.dispose()}$onDidReceiveMessage(u,y){this._insets.get(u)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(Ae[199],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class k extends Error{constructor(A,u){super(u),this.variable=A}}e.VariableError=k}),define(Ae[200],Re([1,0,19,73,16,24,22,90,165,199,15]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,f,t){this._contributedVariables=new Map,this._context=v,this._labelService=p,this._userHomePromise=f,t&&(this._envVariablesPromise=t.then(i=>this.prepareEnv(i)))}prepareEnv(v){if(A.isWindows){const p=Object.create(null);return Object.keys(v).forEach(f=>{p[f.toLowerCase()]=v[f]}),p}return v}resolveWithEnvironment(v,p,f){return this.recursiveResolve({env:this.prepareEnv(v),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(v,p){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,v?v.uri:void 0,p)}async resolveAnyBase(v,p,f,t){const i=L.deepClone(p);A.isWindows&&i.windows?Object.keys(i.windows).forEach(b=>i[b]=i.windows[b]):A.isMacintosh&&i.osx?Object.keys(i.osx).forEach(b=>i[b]=i.osx[b]):A.isLinux&&i.linux&&Object.keys(i.linux).forEach(b=>i[b]=i.linux[b]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,v?v.uri:void 0,i,f,t)}async resolveAnyAsync(v,p,f){return this.resolveAnyBase(v,p,f)}async resolveAnyMap(v,p,f){const t=new Map;return{newConfig:await this.resolveAnyBase(v,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,p)}async recursiveResolve(v,p,f,t,i){if(k.isString(f))return this.resolveString(v,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(c=>this.recursiveResolve(v,p,c,t,i)));if(k.isObject(f)){const c=Object.create(null),b=await Promise.all(Object.keys(f).map(async _=>[await this.resolveString(v,p,_,t,i),await this.recursiveResolve(v,p,f[_],t,i)]));for(const[_,E]of b)c[_]=E;return c}return f}resolveString(v,p,f,t,i){return(0,P.replaceAsync)(f,D.VARIABLE_REGEXP,async(c,b)=>{if(b.includes(D.VARIABLE_LHS))return c;let _=await this.evaluateSingleVariable(v,c,b,p,t);return i?.set(b,_),_!==c&&k.isString(_)&&_.match(D.VARIABLE_REGEXP)&&(_=await this.resolveString(v,p,_,t,i)),_})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}async evaluateSingleVariable(v,p,f,t,i){let c;const b=f.split(":");b.length>1&&(f=b[0],c=b[1]);const _=s=>{const n=this._context.getFilePath();if(n)return(0,u.normalizeDriveLetter)(n);throw new m.VariableError(s,(0,y.localize)(0,null,p))},E=s=>{const n=_(s);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,u.normalizeDriveLetter)(o)}throw new m.VariableError(s,(0,y.localize)(1,null,p,w.basename(n)))},r=s=>{if(c){const n=this._context.getFolderUri(c);if(n)return n;throw new m.VariableError(s,(0,y.localize)(2,null,p,c))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(s,(0,y.localize)(3,null,p)):new m.VariableError(s,(0,y.localize)(4,null,p))};switch(f){case"env":if(c){if(v.env){const s=v.env[A.isWindows?c.toLowerCase():c];if(k.isString(s))return s}return""}throw new m.VariableError(m.VariableKind.Env,(0,y.localize)(5,null,p));case"config":if(c){const s=this._context.getConfigurationValue(t,c);if(k.isUndefinedOrNull(s))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(6,null,p,c));if(k.isObject(s))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(7,null,p,c));return s}throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(8,null,p));case"command":return this.resolveFromMap(m.VariableKind.Command,p,c,i,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,p,c,i,"input");case"extensionInstallFolder":if(c){const s=await this._context.getExtension(c);if(!s)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,p,c));return this.fsPath(s.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,u.normalizeDriveLetter)(this.fsPath(r(m.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,u.normalizeDriveLetter)(this.fsPath(r(m.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,u.normalizeDriveLetter)(w.basename(this.fsPath(r(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,y.localize)(11,null,p))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new m.VariableError(m.VariableKind.LineNumber,(0,y.localize)(12,null,p))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new m.VariableError(m.VariableKind.SelectedText,(0,y.localize)(13,null,p))}case"file":return _(m.VariableKind.File);case"fileWorkspaceFolder":return E(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.relative(this.fsPath(r(m.VariableKind.RelativeFile)),_(m.VariableKind.RelativeFile)):_(m.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.dirname(_(m.VariableKind.RelativeFileDirname));if(t||c){const n=w.relative(this.fsPath(r(m.VariableKind.RelativeFileDirname)),s);return n.length===0?".":n}return s}case"fileDirname":return w.dirname(_(m.VariableKind.FileDirname));case"fileExtname":return w.extname(_(m.VariableKind.FileExtname));case"fileBasename":return w.basename(_(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.basename(_(m.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.extname(s).length)}case"fileDirnameBasename":return w.basename(w.dirname(_(m.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||p}case"execInstallFolder":{const s=this._context.getAppRoot();return s||p}case"pathSeparator":return w.sep;default:try{const s=c?`${f}:${c}`:f;return this.resolveFromMap(m.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}resolveFromMap(v,p,f,t,i){if(f&&t){const c=i===void 0?t[f]:t[i+":"+f];if(typeof c=="string")return c;throw new m.VariableError(v,(0,y.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=D}),define(Ae[102],Re([1,0,4,99]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var L;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var u;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(u||(e.GroupsArrangement=u={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function m(p){const f=p;return(0,R.isEditorInput)(f?.editor)&&(0,R.isEditorInput)(f?.replacement)}e.isEditorReplacement=m;var P;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function a(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=a;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(Ae[201],Re([1,0,4,102]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(L){const A=L;return typeof L=="number"||(0,R.isEditorGroup)(A)}e.isPreferredGroup=k}),define(Ae[8],Re([1,0,18,25,122,202,50,28,116,67,66,24,16,2,44,78,94,101,99,75,45,56,201,7]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(ke){function Te(j){const{selectionStartLineNumber:Oe,selectionStartColumn:$e,positionLineNumber:Ke,positionColumn:We}=j,et=new s.Position(Oe-1,$e-1),mt=new s.Position(Ke-1,We-1);return new s.Selection(et,mt)}ke.to=Te;function me(j){const{anchor:Oe,active:$e}=j;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}ke.from=me})(n||(e.Selection=n={}));var o;(function(ke){function Te(j){if(!j)return;const{start:Oe,end:$e}=j;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}ke.from=Te;function me(j){if(!j)return;const{startLineNumber:Oe,startColumn:$e,endLineNumber:Ke,endColumn:We}=j;return new s.Range(Oe-1,$e-1,Ke-1,We-1)}ke.to=me})(o||(e.Range=o={}));var S;(function(ke){function Te(me){switch(me){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ke.to=Te})(S||(e.TokenType=S={}));var h;(function(ke){function Te(j){return new s.Position(j.lineNumber-1,j.column-1)}ke.to=Te;function me(j){return{lineNumber:j.line+1,column:j.character+1}}ke.from=me})(h||(e.Position=h={}));var I;(function(ke){function Te(Oe,$e,Ke){return(0,w.coalesce)((0,w.asArray)(Oe).map(We=>me(We,$e,Ke)))}ke.from=Te;function me(Oe,$e,Ke){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ke?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:j(Oe.scheme,$e),pattern:st.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ke?.isBuiltin}}function j(Oe,$e){return $e&&typeof Oe=="string"?$e.transformOutgoingScheme(Oe):Oe}})(I||(e.DocumentSelector=I={}));var C;(function(ke){function Te(j){switch(j){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ke.from=Te;function me(j){switch(j){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ke.to=me})(C||(e.DiagnosticTag=C={}));var l;(function(ke){function Te(j){let Oe;return j.code&&((0,a.isString)(j.code)||(0,a.isNumber)(j.code)?Oe=String(j.code):Oe={value:String(j.code.value),target:j.code.target}),{...o.from(j.range),message:j.message,source:j.source,code:Oe,severity:d.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(g.from),tags:Array.isArray(j.tags)?(0,w.coalesce)(j.tags.map(C.from)):void 0}}ke.from=Te;function me(j){const Oe=new s.Diagnostic(o.to(j),j.message,d.to(j.severity));return Oe.source=j.source,Oe.code=(0,a.isString)(j.code)?j.code:j.code?.value,Oe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(g.to),Oe.tags=j.tags&&(0,w.coalesce)(j.tags.map(C.to)),Oe}ke.to=me})(l||(e.Diagnostic=l={}));var g;(function(ke){function Te(j){return{...o.from(j.location.range),message:j.message,resource:j.location.uri}}ke.from=Te;function me(j){return new s.DiagnosticRelatedInformation(new s.Location(j.resource,o.to(j)),j.message)}ke.to=me})(g||(e.DiagnosticRelatedInformation=g={}));var d;(function(ke){function Te(j){switch(j){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ke.from=Te;function me(j){switch(j){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ke.to=me})(d||(e.DiagnosticSeverity=d={}));var T;(function(ke){function Te(j){return typeof j=="number"&&j>=s.ViewColumn.One?j-1:j===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ke.from=Te;function me(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=me})(T||(e.ViewColumn=T={}));function z(ke){return typeof ke.range<"u"}function H(ke){return ke.length===0?!0:!!z(ke[0])}e.isDecorationOptionsArr=H;var x;(function(ke){function Te(We){return We.map(ke.from)}ke.fromMany=Te;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function j(We){let et;if(me(We)){const{language:dt,value:At}=We;et={value:"```"+dt+`
`+At+"\n```\n"}}else s.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const mt=Object.create(null);et.uris=mt;const ft=dt=>{try{let At=v.URI.parse(dt,!0);At=At.with({query:Oe(At.query,mt)}),mt[dt]=At}catch{}return""},vt=new y.marked.Renderer;return vt.link=ft,vt.image=dt=>typeof dt=="string"?ft(A.parseHrefAndDimensions(dt).href):"",(0,y.marked)(et.value,{renderer:vt}),et}ke.from=j;function Oe(We,et){if(!We)return We;let mt;try{mt=(0,m.parse)(We)}catch{}if(!mt)return We;let ft=!1;return mt=(0,D.cloneAndChange)(mt,vt=>{if(v.URI.isUri(vt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[dt]=vt,ft=!0,dt}else return}),ft?JSON.stringify(mt):We}function $e(We){const et=new s.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?v.URI.from(We.baseUri):void 0,et}ke.to=$e;function Ke(We){if(We)return typeof We=="string"?We:ke.from(We)}ke.fromStrict=Ke})(x||(e.MarkdownString=x={}));function $(ke){return H(ke)?ke.map(Te=>({range:o.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?x.fromMany(Te.hoverMessage):Te.hoverMessage?x.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ke.map(Te=>({range:o.from(Te)}))}e.fromRangeOrRangeWithMessage=$;function N(ke){return typeof ke>"u"?ke:typeof ke=="string"?v.URI.file(ke):ke}e.pathOrURIToURI=N;var M;(function(ke){function Te(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?N(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}ke.from=Te})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var te;(function(ke){function Te(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?N(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}ke.from=Te})(te||(e.ThemableDecorationRenderOptions=te={}));var Q;(function(ke){function Te(me){if(typeof me>"u")return me;switch(me){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ke.from=Te})(Q||(e.DecorationRangeBehavior=Q={}));var Se;(function(ke){function Te(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?te.from(me.light):void 0,dark:me.dark?te.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?N(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}ke.from=Te})(Se||(e.DecorationRenderOptions=Se={}));var _e;(function(ke){function Te(j){return{text:j.newText,eol:j.newEol&&Ye.from(j.newEol),range:o.from(j.range)}}ke.from=Te;function me(j){const Oe=new s.TextEdit(o.to(j.range),j.text);return Oe.newEol=typeof j.eol>"u"?void 0:Ye.to(j.eol),Oe}ke.to=me})(_e||(e.TextEdit=_e={}));var Pe;(function(ke){function Te(j,Oe){const $e={edits:[]};if(j instanceof s.WorkspaceEdit){const Ke=new u.ResourceSet;for(const We of j._allEntries())We._type===1&&v.URI.isUri(We.to)&&We.from===void 0&&Ke.add(We.to);for(const We of j._allEntries())if(We._type===1){let et;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?et={type:"base64",value:(0,R.encodeBase64)(R.VSBuffer.wrap(We.options.contents))}:et={type:"dataTransferItem",id:We.options.contents._itemId}),$e.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:et},metadata:We.metadata})}else We._type===2?$e.edits.push({resource:We.uri,textEdit:_e.from(We.edit),versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?$e.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?$e.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&$e.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return $e}ke.from=Te;function me(j){const Oe=new s.WorkspaceEdit,$e=new u.ResourceMap;for(const Ke of j.edits)if(Ke.textEdit){const We=Ke,et=v.URI.revive(We.resource),mt=o.to(We.textEdit.range),ft=We.textEdit.text,vt=We.textEdit.insertAsSnippet;let dt;vt?dt=s.SnippetTextEdit.replace(mt,new s.SnippetString(ft)):dt=s.TextEdit.replace(mt,ft);const At=$e.get(et);At?At.push(dt):$e.set(et,[dt])}else Oe.renameFile(v.URI.revive(Ke.oldResource),v.URI.revive(Ke.newResource),Ke.options);for(const[Ke,We]of $e)Oe.set(Ke,We);return Oe}ke.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var Y;(function(ke){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function me(Oe){return typeof Te[Oe]=="number"?Te[Oe]:6}ke.from=me;function j(Oe){for(const $e in Te)if(Te[$e]===Oe)return Number($e);return s.SymbolKind.Property}ke.to=j})(Y||(e.SymbolKind=Y={}));var ae;(function(ke){function Te(j){switch(j){case s.SymbolTag.Deprecated:return 1}}ke.from=Te;function me(j){switch(j){case 1:return s.SymbolTag.Deprecated}}ke.to=me})(ae||(e.SymbolTag=ae={}));var Ce;(function(ke){function Te(j){return{name:j.name,kind:Y.from(j.kind),tags:j.tags&&j.tags.map(ae.from),containerName:j.containerName,location:W.from(j.location)}}ke.from=Te;function me(j){const Oe=new s.SymbolInformation(j.name,Y.to(j.kind),j.containerName,W.to(j.location));return Oe.tags=j.tags&&j.tags.map(ae.to),Oe}ke.to=me})(Ce||(e.WorkspaceSymbol=Ce={}));var le;(function(ke){function Te(j){const Oe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:o.from(j.range),selectionRange:o.from(j.selectionRange),kind:Y.from(j.kind),tags:j.tags?.map(ae.from)??[]};return j.children&&(Oe.children=j.children.map(Te)),Oe}ke.from=Te;function me(j){const Oe=new s.DocumentSymbol(j.name,j.detail,Y.to(j.kind),o.to(j.range),o.to(j.selectionRange));return(0,w.isNonEmptyArray)(j.tags)&&(Oe.tags=j.tags.map(ae.to)),j.children&&(Oe.children=j.children.map(me)),Oe}ke.to=me})(le||(e.DocumentSymbol=le={}));var pe;(function(ke){function Te(j){const Oe=new s.CallHierarchyItem(Y.to(j.kind),j.name,j.detail||"",v.URI.revive(j.uri),o.to(j.range),o.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}ke.to=Te;function me(j,Oe,$e){if(Oe=Oe??j._sessionId,$e=$e??j._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,name:j.name,detail:j.detail,kind:Y.from(j.kind),uri:j.uri,range:o.from(j.range),selectionRange:o.from(j.selectionRange),tags:j.tags?.map(ae.from)}}ke.from=me})(pe||(e.CallHierarchyItem=pe={}));var ie;(function(ke){function Te(me){return new s.CallHierarchyIncomingCall(pe.to(me.from),me.fromRanges.map(j=>o.to(j)))}ke.to=Te})(ie||(e.CallHierarchyIncomingCall=ie={}));var U;(function(ke){function Te(me){return new s.CallHierarchyOutgoingCall(pe.to(me.to),me.fromRanges.map(j=>o.to(j)))}ke.to=Te})(U||(e.CallHierarchyOutgoingCall=U={}));var W;(function(ke){function Te(j){return{range:j.range&&o.from(j.range),uri:j.uri}}ke.from=Te;function me(j){return new s.Location(v.URI.revive(j.uri),o.to(j.range))}ke.to=me})(W||(e.location=W={}));var ue;(function(ke){function Te(j){const Oe=j,$e=j;return{originSelectionRange:Oe.originSelectionRange?o.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:$e.uri,range:o.from(Oe.targetRange?Oe.targetRange:$e.range),targetSelectionRange:Oe.targetSelectionRange?o.from(Oe.targetSelectionRange):void 0}}ke.from=Te;function me(j){return{targetUri:v.URI.revive(j.uri),targetRange:o.to(j.range),targetSelectionRange:j.targetSelectionRange?o.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?o.to(j.originSelectionRange):void 0}}ke.to=me})(ue||(e.DefinitionLink=ue={}));var we;(function(ke){function Te(j){return{range:o.from(j.range),contents:x.fromMany(j.contents)}}ke.from=Te;function me(j){return new s.Hover(j.contents.map(x.to),o.to(j.range))}ke.to=me})(we||(e.Hover=we={}));var Ee;(function(ke){function Te(j){return{range:o.from(j.range),expression:j.expression}}ke.from=Te;function me(j){return new s.EvaluatableExpression(o.to(j.range),j.expression)}ke.to=me})(Ee||(e.EvaluatableExpression=Ee={}));var ge;(function(ke){function Te(j){if(j instanceof s.InlineValueText)return{type:"text",range:o.from(j.range),text:j.text};if(j instanceof s.InlineValueVariableLookup)return{type:"variable",range:o.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Te;function me(j){switch(j.type){case"text":return{range:o.to(j.range),text:j.text};case"variable":return{range:o.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:o.to(j.range),expression:j.expression}}}ke.to=me})(ge||(e.InlineValue=ge={}));var ye;(function(ke){function Te(j){return{frameId:j.frameId,stoppedLocation:o.from(j.stoppedLocation)}}ke.from=Te;function me(j){return new s.InlineValueContext(j.frameId,o.to(j.stoppedLocation))}ke.to=me})(ye||(e.InlineValueContext=ye={}));var re;(function(ke){function Te(j){return{range:o.from(j.range),kind:j.kind}}ke.from=Te;function me(j){return new s.DocumentHighlight(o.to(j.range),j.kind)}ke.to=me})(re||(e.DocumentHighlight=re={}));var de;(function(ke){function Te(me){switch(me){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ke.to=Te})(de||(e.CompletionTriggerKind=de={}));var se;(function(ke){function Te(me){return{triggerKind:de.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}ke.to=Te})(se||(e.CompletionContext=se={}));var oe;(function(ke){function Te(j){switch(j){case s.CompletionItemTag.Deprecated:return 1}}ke.from=Te;function me(j){switch(j){case 1:return s.CompletionItemTag.Deprecated}}ke.to=me})(oe||(e.CompletionItemTag=oe={}));var he;(function(ke){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function me($e){return Te.get($e)??9}ke.from=me;const j=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Oe($e){return j.get($e)??s.CompletionItemKind.Property}ke.to=Oe})(he||(e.CompletionItemKind=he={}));var Ie;(function(ke){function Te(me,j){const Oe=new s.CompletionItem(me.label);return Oe.insertText=me.insertText,Oe.kind=he.to(me.kind),Oe.tags=me.tags?.map(oe.to),Oe.detail=me.detail,Oe.documentation=A.isMarkdownString(me.documentation)?x.to(me.documentation):me.documentation,Oe.sortText=me.sortText,Oe.filterText=me.filterText,Oe.preselect=me.preselect,Oe.commitCharacters=me.commitCharacters,p.Range.isIRange(me.range)?Oe.range=o.to(me.range):typeof me.range=="object"&&(Oe.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Oe.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Oe.insertText=new s.SnippetString(me.insertText):(Oe.insertText=me.insertText,Oe.textEdit=Oe.range instanceof s.Range?new s.TextEdit(Oe.range,Oe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Oe.additionalTextEdits=me.additionalTextEdits.map($e=>_e.to($e))),Oe.command=j&&me.command?j.fromInternal(me.command):void 0,Oe}ke.to=Te})(Ie||(e.CompletionItem=Ie={}));var O;(function(ke){function Te(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:x.fromStrict(j.documentation)}}ke.from=Te;function me(j){return{label:j.label,documentation:A.isMarkdownString(j.documentation)?x.to(j.documentation):j.documentation}}ke.to=me})(O||(e.ParameterInformation=O={}));var V;(function(ke){function Te(j){return{label:j.label,documentation:x.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(O.from):[],activeParameter:j.activeParameter}}ke.from=Te;function me(j){return{label:j.label,documentation:A.isMarkdownString(j.documentation)?x.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(O.to):[],activeParameter:j.activeParameter}}ke.to=me})(V||(e.SignatureInformation=V={}));var K;(function(ke){function Te(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(V.from):[]}}ke.from=Te;function me(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(V.to):[]}}ke.to=me})(K||(e.SignatureHelp=K={}));var G;(function(ke){function Te(me,j){const Oe=new s.InlayHint(h.to(j.position),typeof j.label=="string"?j.label:j.label.map(q.to.bind(void 0,me)),j.kind&&Z.to(j.kind));return Oe.textEdits=j.textEdits&&j.textEdits.map(_e.to),Oe.tooltip=A.isMarkdownString(j.tooltip)?x.to(j.tooltip):j.tooltip,Oe.paddingLeft=j.paddingLeft,Oe.paddingRight=j.paddingRight,Oe}ke.to=Te})(G||(e.InlayHint=G={}));var q;(function(ke){function Te(me,j){const Oe=new s.InlayHintLabelPart(j.label);return Oe.tooltip=A.isMarkdownString(j.tooltip)?x.to(j.tooltip):j.tooltip,f.Command.is(j.command)&&(Oe.command=me.fromInternal(j.command)),j.location&&(Oe.location=W.to(j.location)),Oe}ke.to=Te})(q||(e.InlayHintLabelPart=q={}));var Z;(function(ke){function Te(j){return j}ke.from=Te;function me(j){return j}ke.to=me})(Z||(e.InlayHintKind=Z={}));var ce;(function(ke){function Te(j){return{range:o.from(j.range),url:j.target,tooltip:j.tooltip}}ke.from=Te;function me(j){let Oe;if(j.url)try{Oe=typeof j.url=="string"?v.URI.parse(j.url,!0):v.URI.revive(j.url)}catch{}return new s.DocumentLink(o.to(j.range),Oe)}ke.to=me})(ce||(e.DocumentLink=ce={}));var Le;(function(ke){function Te(j){const Oe=new s.ColorPresentation(j.label);return j.textEdit&&(Oe.textEdit=_e.to(j.textEdit)),j.additionalTextEdits&&(Oe.additionalTextEdits=j.additionalTextEdits.map($e=>_e.to($e))),Oe}ke.to=Te;function me(j){return{label:j.label,textEdit:j.textEdit?_e.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Oe=>_e.from(Oe)):void 0}}ke.from=me})(Le||(e.ColorPresentation=Le={}));var xe;(function(ke){function Te(j){return new s.Color(j[0],j[1],j[2],j[3])}ke.to=Te;function me(j){return[j.red,j.green,j.blue,j.alpha]}ke.from=me})(xe||(e.Color=xe={}));var Ge;(function(ke){function Te(j){return{range:o.from(j.range)}}ke.from=Te;function me(j){return new s.SelectionRange(o.to(j.range))}ke.to=me})(Ge||(e.SelectionRange=Ge={}));var je;(function(ke){function Te(me){switch(me){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ke.to=Te})(je||(e.TextDocumentSaveReason=je={}));var Je;(function(ke){function Te(j){switch(j){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ke.from=Te;function me(j){switch(j){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ke.to=me})(Je||(e.TextEditorLineNumbersStyle=Je={}));var Ye;(function(ke){function Te(j){if(j===s.EndOfLine.CRLF)return 1;if(j===s.EndOfLine.LF)return 0}ke.from=Te;function me(j){if(j===1)return s.EndOfLine.CRLF;if(j===0)return s.EndOfLine.LF}ke.to=me})(Ye||(e.EndOfLine=Ye={}));var Ze;(function(ke){function Te(me){if(typeof me=="object")return me.viewId;switch(me){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ke.from=Te})(Ze||(e.ProgressLocation=Ze={}));var it;(function(ke){function Te(j){const Oe={start:j.start+1,end:j.end+1};return j.kind&&(Oe.kind=tt.from(j.kind)),Oe}ke.from=Te;function me(j){const Oe={start:j.start-1,end:j.end-1};return j.kind&&(Oe.kind=tt.to(j.kind)),Oe}ke.to=me})(it||(e.FoldingRange=it={}));var tt;(function(ke){function Te(j){if(j)switch(j){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}ke.from=Te;function me(j){if(j)switch(j.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}ke.to=me})(tt||(e.FoldingRangeKind=tt={}));var Ue;(function(ke){function Te(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ke.from=Te})(Ue||(e.TextEditorOpenOptions=Ue={}));var st;(function(ke){function Te($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:me($e)||j($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}ke.from=Te;function me($e){const Ke=$e;return Ke?v.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function j($e){const Ke=$e;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Oe($e){return typeof $e=="string"?$e:new s.RelativePattern(v.URI.revive($e.baseUri),$e.pattern)}ke.to=Oe})(st||(e.GlobPattern=st={}));var J;(function(ke){function Te(me){if(me){if(Array.isArray(me))return me.map(Te);if(typeof me=="string")return me;{const j=me;return{language:j.language,scheme:j.scheme,pattern:st.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}ke.from=Te})(J||(e.LanguageSelector=J={}));var X;(function(ke){function Te(j){return!!j&&typeof j=="object"&&"documents"in j&&Array.isArray(j.documents)&&j.documents.every(Oe=>Array.isArray(Oe)&&Oe.every($e=>$e&&typeof $e=="object"&&"uri"in $e&&v.URI.isUri($e.uri)&&"version"in $e&&typeof $e.version=="number"&&"ranges"in $e&&Array.isArray($e.ranges)&&$e.ranges.every(Ke=>Ke instanceof s.Range)))}ke.is=Te;function me(j){return{documents:j.documents.map(Oe=>Oe.map($e=>({uri:v.URI.from($e.uri),version:$e.version,ranges:$e.ranges.map(Ke=>o.from(Ke))})))}}ke.from=me})(X||(e.MappedEditsContext=X={}));var ve;(function(ke){function Te(j){return{start:j.start,end:j.end}}ke.from=Te;function me(j){return new s.NotebookRange(j.start,j.end)}ke.to=me})(ve||(e.NotebookRange=ve={}));var Be;(function(ke){function Te(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ke.to=Te;function me(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}ke.from=me})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ne;(function(ke){function Te(me){if(me===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(me===b.NotebookCellExecutionState.Pending)return;if(me===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}ke.to=Te})(Ne||(e.NotebookCellExecutionState=Ne={}));var Xe;(function(ke){function Te(j){switch(j){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}ke.from=Te;function me(j){switch(j){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}ke.to=me})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(ke){function Te(j){const Oe={metadata:j.metadata??Object.create(null),cells:[]};for(const $e of j.cells)s.NotebookCellData.validate($e),Oe.cells.push(gt.from($e));return Oe}ke.from=Te;function me(j){const Oe=new s.NotebookData(j.cells.map(gt.to));return(0,a.isEmptyObject)(j.metadata)||(Oe.metadata=j.metadata),Oe}ke.to=me})(rt||(e.NotebookData=rt={}));var gt;(function(ke){function Te(j){return{cellKind:Xe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Be.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(kt.from):[]}}ke.from=Te;function me(j){return new s.NotebookCellData(Xe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(kt.to):void 0,j.metadata,j.internalMetadata?Be.to(j.internalMetadata):void 0)}ke.to=me})(gt||(e.NotebookCellData=gt={}));var wt;(function(ke){function Te(j){return{mime:j.mime,valueBytes:R.VSBuffer.wrap(j.data)}}ke.from=Te;function me(j){return new s.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}ke.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var kt;(function(ke){function Te(j){return{outputId:j.id,items:j.items.map(wt.from),metadata:j.metadata}}ke.from=Te;function me(j){const Oe=j.items.map(wt.to);return new s.NotebookCellOutput(Oe,j.outputId,j.metadata)}ke.to=me})(kt||(e.NotebookCellOutput=kt={}));var Qt;(function(ke){function Te(Oe){return j(Oe)?{include:st.from(Oe.include)??void 0,exclude:st.from(Oe.exclude)??void 0}:st.from(Oe)??void 0}ke.from=Te;function me(Oe){return j(Oe)?{include:st.to(Oe.include),exclude:st.to(Oe.exclude)}:st.to(Oe)}ke.to=me;function j(Oe){const $e=Oe;return $e?!(0,a.isUndefinedOrNull)($e.include)&&!(0,a.isUndefinedOrNull)($e.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(ke){function Te(me,j,Oe){const $e=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal($e,Oe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}ke.from=Te})(Vt||(e.NotebookStatusBarItem=Vt={}));var Et;(function(ke){function Te(me,j,Oe){const $e=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:j.toInternal($e,Oe),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}ke.from=Te})(Et||(e.NotebookKernelSourceAction=Et={}));var Bt;(function(ke){function Te(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}ke.from=Te})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var Lt;(function(ke){function Te(j){return{uri:j.uri,provides:j.provides}}ke.from=Te;function me(j){return new s.NotebookRendererScript(v.URI.revive(j.uri),j.provides)}ke.to=me})(Lt||(e.NotebookRendererScript=Lt={}));var $t;(function(ke){function Te(j){return{message:x.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:o.from(j.location.range),uri:j.location.uri}}}ke.from=Te;function me(j){const Oe=new s.TestMessage(typeof j.message=="string"?j.message:x.to(j.message));return Oe.actualOutput=j.actual,Oe.expectedOutput=j.expected,Oe.contextValue=j.contextValue,Oe.location=j.location?W.to(j.location):void 0,Oe}ke.to=me})($t||(e.TestMessage=$t={}));var Pt;(function(ke){ke.namespace=E.namespaceTestTag,ke.denamespace=E.denamespaceTestTag})(Pt||(e.TestTag=Pt={}));var Tt;(function(ke){function Te(j){const Oe=(0,i.getPrivateApiFor)(j).controllerId;return{extId:_.TestId.fromExtHostTestItem(j,Oe).toString(),label:j.label,uri:v.URI.revive(j.uri),busy:j.busy,tags:j.tags.map($e=>Pt.namespace(Oe,$e.id)),range:p.Range.lift(o.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&x.fromStrict(j.error)||null}}ke.from=Te;function me(j){return{parent:void 0,error:void 0,id:_.TestId.fromString(j.extId).localId,label:j.label,uri:v.URI.revive(j.uri),tags:(j.tags||[]).map(Oe=>{const{tagId:$e}=Pt.denamespace(Oe);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}ke.toPlain=me})(Tt||(e.TestItem=Tt={})),function(ke){function Te(j){return{id:j.id}}ke.from=Te;function me(j){return new s.TestTag(j.id)}ke.to=me}(Pt||(e.TestTag=Pt={}));var Mt;(function(ke){const Te=(j,Oe)=>{const $e=[];for(const[We,et]of Oe)_.TestId.compare(et.item.extId,We)===2&&(Oe.delete(We),$e.push(et));const Ke={...Tt.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map($t.to)})),children:$e.map(We=>Te(We,Oe))};for(const We of Ke.children)We.parent=Ke;return Ke};function me(j){const Oe=[],$e=new Map;for(const Ke of j.items){$e.set(Ke.item.extId,Ke);const We=_.TestId.root(Ke.item.extId);j.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(Ke.item.extId))&&Oe.push(Ke)}return{completedAt:j.completedAt,results:Oe.map(Ke=>Te(Ke,$e))}}ke.to=me})(Mt||(e.TestResults=Mt={}));var zt;(function(ke){function Te($e){return{covered:$e.covered,total:$e.covered}}function me($e){return"line"in $e?h.from($e):o.from($e)}function j($e){return"branches"in $e?{count:$e.executionCount,location:me($e.location),type:1,branches:$e.branches.length?$e.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&me(Ke.location)})):void 0}:{type:0,count:$e.executionCount,location:me($e.location)}}ke.fromDetailed=j;function Oe($e){return{uri:$e.uri,statement:Te($e.statementCoverage),branch:$e.branchCoverage&&Te($e.branchCoverage),function:$e.functionCoverage&&Te($e.functionCoverage),details:$e.detailedCoverage?.map(j)}}ke.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var qt;(function(ke){function Te(me){switch(me){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ke.to=Te})(qt||(e.CodeActionTriggerKind=qt={}));var Ht;(function(ke){function Te(j){const Oe=new s.TypeHierarchyItem(Y.to(j.kind),j.name,j.detail||"",v.URI.revive(j.uri),o.to(j.range),o.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}ke.to=Te;function me(j,Oe,$e){if(Oe=Oe??j._sessionId,$e=$e??j._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,kind:Y.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:o.from(j.range),selectionRange:o.from(j.selectionRange),tags:j.tags?.map(ae.from)}}ke.from=me})(Ht||(e.TypeHierarchyItem=Ht={}));var at;(function(ke){function Te(me){if(me)return{value:me.value,tooltip:me.tooltip}}ke.from=Te})(at||(e.ViewBadge=at={}));var lt;(function(ke){function Te($e,Ke,We){const et=Ke.fileData;return et?new s.InternalFileDataTransferItem(new s.DataTransferFile(et.name,v.URI.revive(et.uri),et.id,(0,L.createSingleCallFunction)(()=>We(et.id)))):$e===P.Mimes.uriList&&Ke.uriListData?new s.InternalDataTransferItem(Oe(Ke.uriListData)):new s.InternalDataTransferItem(Ke.asString)}ke.to=Te;async function me($e,Ke){const We=await Ke.asString();if($e===P.Mimes.uriList)return{asString:We,fileData:void 0,uriListData:j(We)};const et=Ke.asFile();return{asString:We,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}ke.from=me;function j($e){return k.UriList.split($e).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return v.URI.parse(Ke)}catch{}return Ke})}function Oe($e){return k.UriList.create($e.map(Ke=>typeof Ke=="string"?Ke:v.URI.revive(Ke)))}})(lt||(e.DataTransferItem=lt={}));var Kt;(function(ke){function Te(j,Oe){const $e=j.items.map(([Ke,We])=>[Ke,lt.to(Ke,We,Oe)]);return new s.DataTransfer($e)}ke.toDataTransfer=Te;async function me(j){const Oe={items:[]},$e=[];for(const[Ke,We]of j)$e.push((async()=>{Oe.items.push([Ke,await lt.from(Ke,We)])})());return await Promise.all($e),Oe}ke.from=me})(Kt||(e.DataTransfer=Kt={}));var It;(function(ke){function Te(j){return{message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}ke.to=Te;function me(j){return{kind:"reply",message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}ke.from=me})(It||(e.ChatReplyFollowup=It={}));var _t;(function(ke){function Te(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:It.from(me)}ke.from=Te})(_t||(e.ChatFollowup=_t={}));var ht;(function(ke){function Te(j){const Oe=new s.ChatMessage(Dt.to(j.role),j.content);return Oe.name=j.name,Oe}ke.to=Te;function me(j){return{role:Dt.from(j.role),content:j.content,name:j.name}}ke.from=me})(ht||(e.ChatMessage=ht={}));var Dt;(function(ke){function Te(j){switch(j){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}ke.to=Te;function me(j){switch(j){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}ke.from=me})(Dt||(e.ChatMessageRole=Dt={}));var Ft;(function(ke){function Te(j){return{level:St.to(j.level),value:j.value,description:j.description}}ke.to=Te;function me(j){return{level:St.from(j.level),value:j.value,description:j.description}}ke.from=me})(Ft||(e.ChatVariable=Ft={}));var St;(function(ke){function Te(j){switch(j){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}ke.to=Te;function me(j){switch(j){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}ke.from=me})(St||(e.ChatVariableLevel=St={}));var He;(function(ke){function Te(me){switch(me){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}ke.to=Te})(He||(e.InteractiveEditorResponseFeedbackKind=He={}));var Nt;(function(ke){function Te(me){return"placeholder"in me&&"resolvedContent"in me?{placeholder:me.placeholder}:"responseId"in me?{requestId:me.responseId}:"content"in me?{content:typeof me.content=="string"?me.content:x.from(me.content)}:"documents"in me?{documents:me.documents.map(j=>({uri:j.uri,version:j.version,ranges:j.ranges.map(Oe=>o.from(Oe))}))}:"reference"in me?{reference:"uri"in me.reference?{uri:me.reference.uri,range:o.from(me.reference.range)}:me.reference}:me}ke.from=Te})(Nt||(e.ChatResponseProgress=Nt={}));var Ut;(function(ke){function Te(me,j,Oe){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:j.toInternal(me,Oe)}ke.from=Te})(Ut||(e.TerminalQuickFix=Ut={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class u{constructor(m,P,D,a={timeout:1500,errors:3}){this._logService=m,this._documents=P,this._mainThreadBulkEdits=D,this._thresholds=a,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(P,D,a)=>{const p={dispose:this._callbacks.push([P,D,m])};return Array.isArray(a)&&a.push(p),p}}async $participateInSave(m,P){const D=w.URI.revive(m);let a=!1;const v=setTimeout(()=>a=!0,this._thresholds.timeout),p=[];try{for(const f of[...this._callbacks]){if(a)break;const t=this._documents.getDocument(D),i=await this._deliverEventAsyncAndBlameBadListeners(f,{document:t,reason:L.TextDocumentSaveReason.to(P)});p.push(i)}}finally{clearTimeout(v)}return p}_deliverEventAsyncAndBlameBadListeners([m,P,D],a){const v=this._badListeners.get(m);return typeof v=="number"&&v>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,m,P,a).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this._badListeners.get(m);this._badListeners.set(m,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,P,D,a){const v=[],p=Date.now(),{document:f,reason:t}=a,{version:i}=f,c=Object.freeze({document:f,reason:t,waitUntil(b){if(Object.isFrozen(v))throw(0,R.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(b))}});try{P.apply(D,[c])}catch(b){return Promise.reject(b)}return Object.freeze(v),new Promise((b,_)=>{const E=setTimeout(()=>_(new Error("timeout")),this._thresholds.timeout);return Promise.all(v).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(E),b(r)}).catch(r=>{clearTimeout(E),_(r)})}).then(b=>{const _={edits:[]};for(const E of b)if(Array.isArray(E)&&E.every(r=>r instanceof k.TextEdit))for(const{newText:r,newEol:s,range:n}of E)_.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:r,eol:s&&L.EndOfLine.from(s)}});if(_.edits.length!==0)return i===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=u}),define(Ae[204],Re([1,0,13,2,8,7,75]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class u{constructor(D,a,v,p){this.start=D,this.deletedCount=a,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(D,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,a,v){this.notebook=D,this._extHostDocument=a,this._cellData=v,this.handle=v.handle,this.uri=R.URI.revive(v.uri),this.cellKind=v.cellKind,this._outputs=v.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=v.internalMetadata??{},this._metadata=Object.freeze(v.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,a=this._extHostDocument.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:a.document,get mime(){return D._mime},set mime(p){D._mime=p},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(v)}return this._apiCell}setOutputs(D){this._outputs=D.map(k.NotebookCellOutput.to)}setOutputItems(D,a,v){const p=v.map(k.NotebookCellOutputItem.to),f=this._outputs.find(t=>t.id===D);if(f&&(a||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>A.isTextStreamMime(t.mime)))){const t=new Map,i=[];f.items.forEach(c=>{let b;t.has(c.mime)?b=t.get(c.mime):(b=[],t.set(c.mime,b),i.push(c.mime)),b.push(c.data)}),f.items.length=0,i.forEach(c=>{const b=A.compressOutputItemStreams(t.get(c));f.items.push({mime:c,data:b.data.buffer})})}}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=y;class m{static{this._handlePool=0}constructor(D,a,v,p,f){this._proxy=D,this._textDocumentsAndEditors=a,this._textDocuments=v,this.uri=p,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0,void 0),this._versionId=f.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const D=this,a={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(v){return v=D._validateIndex(v),D._cells[v].apiCell},getCells(v){return(v?D._getCells(v):D._cells).map(f=>f.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(a)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,a,v){this._versionId=D.versionId,this._isDirty=a,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this._moveCells(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(i.index,i.outputs),f.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(i.index,i.language),f.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(i.index,i.metadata),f.push({cell:this._cells[i.index].apiCell,metadata:this._cells[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(i.index,i.internalMetadata),f.push({cell:this._cells[i.index].apiCell,executionSummary:this._cells[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const c=f[i],b=t.get(c.cell);if(b===void 0){const _=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,_-1)}else p.cellChanges[b]={...p.cellChanges[b],...c}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let a=D.start|0,v=D.end|0;return a<0&&(a=0),v>this._cells.length&&(v=this._cells.length),D.with({start:a,end:v})}_getCells(D){D=this._validateRange(D);const a=[];for(let v=D.start;v<D.end;v++)a.push(this._cells[v]);return a}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,a,v){if(this._disposed)return;const p=[],f=[],t=[];if(D.reverse().forEach(i=>{const b=i[2].map(r=>{const s=new y(this,this._textDocumentsAndEditors,r);return a||f.push(y.asModelAddData(this.apiNotebook,r)),s}),_=new u(i[0],i[1],[],b),E=this._cells.splice(i[0],i[1],...b);for(const r of E)t.push(r.uri),_.deletedItems.push(r.apiCell);p.push(_)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}_moveCells(D,a,v,p){const f=this._cells.splice(D,a);this._cells.splice(v,0,...f);const t=[new u(D,a,f.map(i=>i.apiCell),[]),new u(v,0,[],f)];for(const i of t)p.push(i.asApiEvent())}_setCellOutputs(D,a){this._cells[D].setOutputs(a)}_setCellOutputItems(D,a,v,p){this._cells[D].setOutputItems(a,v,p)}_changeCellLanguage(D,a){const v=this._cells[D];v.apiCell.document.languageId!==a&&this._textDocuments.$acceptModelLanguageChanged(v.uri,a)}_changeCellMime(D,a){const v=this._cells[D];v.apiCell.mime=a}_changeCellMetadata(D,a){this._cells[D].setMetadata(a)}_changeCellInternalMetadata(D,a){this._cells[D].setInternalMetadata(a)}getCellFromApiCell(D){return this._cells.find(a=>a.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(a=>a.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=m}),define(Ae[205],Re([1,0,5,2,8,7]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(y,m,P,D={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=m,this._mainThreadBulkEdits=P,this._thresholds=D,this._onWillSaveNotebookDocumentEvent=new w.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(m,P,D)=>{const a=function(p){m.call(P,p)};return a.extension=y,this._onWillSaveNotebookDocumentEvent.event(a,void 0,D)}}async $participateInSave(y,m,P){const D=R.URI.revive(y),a=this._notebooksAndEditors.getNotebookDocument(D);if(!a)throw new Error("Unable to resolve notebook document");const v=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:a.apiNotebook,reason:k.TextDocumentSaveReason.to(m)},P,async(f,t)=>{const i=Date.now(),c=await await Promise.resolve(f);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.WorkspaceEdit?v.push(c):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const f of v){const{edits:t}=k.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Ae[103],Re([1,0,9,8,7]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(u,y,m,P,D,a){this.id=u,this._proxy=y,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=P,this._viewColumn=a}get apiEditor(){if(!this._editor){const u=this;this._editor={get notebook(){return u.notebookData.apiNotebook},get selection(){return u._selections[0]},set selection(y){this.selections=[y]},get selections(){return u._selections},set selections(y){if(!Array.isArray(y)||!y.every(k.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");u._selections=y,u._trySetSelections(y)},get visibleRanges(){return u._visibleRanges},revealRange(y,m){u._proxy.$tryRevealRange(u.id,R.NotebookRange.from(y),m??k.NotebookEditorRevealType.Default)},get viewColumn(){return u._viewColumn}},L.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(u){this._visible=u}_acceptVisibleRanges(u){this._visibleRanges=u}_acceptSelections(u){this._selections=u}_trySetSelections(u){this._proxy.$trySetSelections(this.id,u.map(R.NotebookRange.from))}_acceptViewColumn(u){this._viewColumn=u}}e.ExtHostNotebookEditor=L}),define(Ae[206],Re([1,0,9,5,14,8]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(y,m){this._logService=y,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,m);const P=this._notebooksAndEditors.getEditorById(y);m.visibleRanges&&P._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&P._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const m in y)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(y[m]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=Ve([ze(0,k.ILogService)],A)}),define(Ae[207],Re([1,0,8,71,152,21,64,9]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,v,p){const f=this._handles++,{title:t,location:i,cancellable:c}=v,b={label:(0,k.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(f,{location:w.ProgressLocation.from(i),title:t,source:b,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(u.onUnexpectedExternalError),this._withProgress(f,p,!!c)}_withProgress(a,v,p){let f;p&&(f=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,f));const t=c=>{this._proxy.$progressEnd(c),this._mapHandleToCancellationSource.delete(c),f?.dispose()};let i;try{i=v(new P(this._proxy,a),p&&f?f.token:L.CancellationToken.None)}catch(c){throw t(a),c}return i.then(c=>t(a),c=>t(a)),i}$acceptProgressCanceled(a){const v=this._mapHandleToCancellationSource.get(a);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=y;function m(D,a){return D.message=a.message,typeof a.increment=="number"&&(typeof D.increment=="number"?D.increment+=a.increment:D.increment=a.increment),D}class P extends R.Progress{constructor(a,v){super(p=>this.throttledReport(p)),this._proxy=a,this._handle=v}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,A.throttle)(100,(D,a)=>m(D,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,56,8,2]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(b,_,E,r)=>{let s=_;return{enumerable:!0,configurable:!1,get(){return s},set(n){if(!E(s,n)){const o=s;s=n,b.listener?.(r(n,o))}}}},P=(b,_)=>b===_,D={range:(b,_)=>b===_?!0:!b||!_?!1:b.isEqual(_),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(b,_)=>!(b.length!==_.length||b.some(E=>!_.find(r=>E.id===r.id)))},a=b=>_=>({op:4,update:b(_)}),v=(b,_)=>({range:(()=>{let E;const r=a(s=>({range:w.Range.lift(u.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return E},set(s){b.listener?.({op:6}),D.range(E,s)||(E=s,b.listener?.(r(s)))}}})(),label:m(b,_,D.label,a(E=>({label:E}))),description:m(b,void 0,D.description,a(E=>({description:E}))),sortText:m(b,void 0,D.sortText,a(E=>({sortText:E}))),canResolveChildren:m(b,!1,D.canResolveChildren,E=>({op:2,state:E})),busy:m(b,!1,D.busy,a(E=>({busy:E}))),error:m(b,void 0,D.error,a(E=>({error:u.MarkdownString.fromStrict(E)||null}))),tags:m(b,[],D.tags,(E,r)=>({op:1,new:E.map(u.TestTag.from),old:r.map(u.TestTag.from)}))}),p=b=>{const _=k.TestId.fromString(b.extId),E=new t(_.controllerId,_.localId,b.label,y.URI.revive(b.uri)||void 0);return E.range=u.Range.to(b.range||void 0),E.description=b.description||void 0,E.sortText=b.sortText||void 0,E.tags=b.tags.map(r=>u.TestTag.to({id:(0,A.denamespaceTestTag)(r).tagId})),E},f=b=>{let _;for(const E of b.tests){const r=p(E.item);(0,R.getPrivateApiFor)(r).parent=_,_=r}return _};e.toItemFromContext=f;class t{constructor(_,E,r,s){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const n=(0,R.createPrivateApiFor)(this,_);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,L.createTestItemChildren)(n,R.getPrivateApiFor,t),enumerable:!0,writable:!1},...v(n,r)})}}e.TestItemImpl=t;class i extends t{constructor(_,E){super(_,_,E,void 0),this._isRoot=!0}}e.TestItemRootImpl=i;class c extends L.TestItemCollection{constructor(_,E,r){super({controllerId:_,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:R.getPrivateApiFor,getChildren:s=>s.children,root:new i(_,E),toITestItem:u.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(Ae[105],Re([1,0,51,9,88,8,7]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class u{static{this._Keys=new k.IdGenerator("TextEditorDecorationType")}constructor(a,v,p){const f=u._Keys.nextId();a.$registerTextEditorDecorationType(v.identifier,f,L.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=u;class y{constructor(a,v){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=v.undoStopBefore,this._undoStopAfter=v.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,v){this._throwIfFinalized();let p=null;if(a instanceof A.Position)p=new A.Range(a,a);else if(a instanceof A.Range)p=a;else throw new Error("Unrecognized location");this._pushEdit(p,v,!1)}insert(a,v){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),v,!0)}delete(a){this._throwIfFinalized();let v=null;if(a instanceof A.Range)v=a;else throw new Error("Unrecognized location");this._pushEdit(v,null,!0)}_pushEdit(a,v,p){const f=this._document.validateRange(a);this._collectedEdits.push({range:f,text:v,forceMoveMarkers:p})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=a}}class m{constructor(a,v,p,f){this._proxy=a,this._id=v,this._accept(p),this._logService=f;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(i){t._setTabSize(i)},get indentSize(){return t._indentSize},set indentSize(i){t._setIndentSize(i)},get insertSpaces(){return t._insertSpaces},set insertSpaces(i){t._setInsertSpaces(i)},get cursorStyle(){return t._cursorStyle},set cursorStyle(i){t._setCursorStyle(i)},get lineNumbers(){return t._lineNumbers},set lineNumbers(i){t._setLineNumbers(i)}}}_accept(a){this._tabSize=a.tabSize,this._indentSize=a.indentSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}_setTabSize(a){const v=this._validateTabSize(a);if(v!==null){if(typeof v=="number"){if(this._tabSize===v)return;this._tabSize=v}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:v}))}}_validateIndentSize(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}_setIndentSize(a){const v=this._validateIndentSize(a);if(v!==null){if(typeof v=="number"){if(this._indentSize===v)return;this._indentSize=v}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:v}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:!!a}_setInsertSpaces(a){const v=this._validateInsertSpaces(a);if(typeof v=="boolean"){if(this._insertSpaces===v)return;this._insertSpaces=v}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:v}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(a)})))}assign(a){const v={};let p=!1;if(typeof a.tabSize<"u"){const f=this._validateTabSize(a.tabSize);f==="auto"?(p=!0,v.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,p=!0,v.tabSize=f)}if(typeof a.indentSize<"u"){const f=this._validateIndentSize(a.indentSize);f==="tabSize"?(p=!0,v.indentSize=f):typeof f=="number"&&this._indentSize!==f&&(this._indentSize=f,p=!0,v.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this._validateInsertSpaces(a.insertSpaces);f==="auto"?(p=!0,v.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,p=!0,v.insertSpaces=f)}typeof a.cursorStyle<"u"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,p=!0,v.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,p=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(a.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,v))}_warnOnError(a,v){v.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=m;class P{constructor(a,v,p,f,t,i,c,b){this.id=a,this._proxy=v,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new m(this._proxy,this.id,i,p),this._visibleRanges=c,this._viewColumn=b;const _=this;this.value=Object.freeze({get document(){return f.value},set document(E){throw new R.ReadonlyError("document")},get selection(){return _._selections&&_._selections[0]},set selection(E){if(!(E instanceof A.Selection))throw(0,R.illegalArgument)("selection");_._selections=[E],_._trySetSelection()},get selections(){return _._selections},set selections(E){if(!Array.isArray(E)||E.some(r=>!(r instanceof A.Selection)))throw(0,R.illegalArgument)("selections");_._selections=E,_._trySetSelection()},get visibleRanges(){return _._visibleRanges},set visibleRanges(E){throw new R.ReadonlyError("visibleRanges")},get options(){return _._options.value},set options(E){_._disposed||_._options.assign(E)},get viewColumn(){return _._viewColumn},set viewColumn(E){throw new R.ReadonlyError("viewColumn")},edit(E,r={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(f.value,r);return E(s),_._applyEdit(s)},insertSnippet(E,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=_._selections.map(o=>L.Range.from(o));else if(r instanceof A.Position){const{lineNumber:o,column:S}=L.Position.from(r);n=[{startLineNumber:o,startColumn:S,endLineNumber:o,endColumn:S}]}else if(r instanceof A.Range)n=[L.Range.from(r)];else{n=[];for(const o of r)if(o instanceof A.Range)n.push(L.Range.from(o));else{const{lineNumber:S,column:h}=L.Position.from(o);n.push({startLineNumber:S,startColumn:h,endLineNumber:S,endColumn:h})}}return v.$tryInsertSnippet(a,f.value.version,E.value,n,s)},setDecorations(E,r){const s=r.length===0;s&&!_._hasDecorationsForKey.has(E.key)||(s?_._hasDecorationsForKey.delete(E.key):_._hasDecorationsForKey.add(E.key),_._runOnProxy(()=>{if(L.isDecorationOptionsArr(r))return v.$trySetDecorations(a,E.key,L.fromRangeOrRangeWithMessage(r));{const n=new Array(4*r.length);for(let o=0,S=r.length;o<S;o++){const h=r[o];n[4*o]=h.start.line+1,n[4*o+1]=h.start.character+1,n[4*o+2]=h.end.line+1,n[4*o+3]=h.end.character+1}return v.$trySetDecorationsFast(a,E.key,n)}}))},revealRange(E,r){_._runOnProxy(()=>v.$tryRevealRange(a,L.Range.from(E),r||A.TextEditorRevealType.Default))},show(E){v.$tryShowEditor(a,L.ViewColumn.from(E))},hide(){v.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,w.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,w.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,w.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const v=a.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const c=p[t].end;if(p[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this._logService.warn(v),null))}}e.ExtHostTextEditor=P}),define(Ae[208],Re([1,0,4,171]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,w.refineServiceDecorator)(R.IEnvironmentService)}),define(Ae[106],Re([1,0,20,5,19,6]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i,c){this.versionId=i,this.removedDueToLooping=c}}e.DeltaExtensionsResult=A;class u{static isHostExtension(i,c,b){if(c.getExtensionDescription(i))return!1;const _=b.getExtensionDescription(i);return _?!!((_.main||_.browser)&&_.api==="none"):!1}constructor(i,c){this._activationEventsReader=i,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=c,this._initialize()}_initialize(){this._extensionDescriptions.sort(p),this._extensionsMap=new w.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const c=this._activationEventsReader.readActivationEvents(i);if(Array.isArray(c))for(let b of c)b==="onUri"&&(b=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(i)}}set(i){return this._extensionDescriptions=i,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(i,c){this._extensionDescriptions=f(this._extensionDescriptions,c),this._extensionDescriptions=this._extensionDescriptions.concat(i);const b=u._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=f(this._extensionDescriptions,b.map(_=>_.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,b)}static _findLoopingExtensions(i){const c=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(s){this._nodesSet.has(s)||(this._nodesSet.add(s),this._nodesArr.push(s))}addArc(s,n){this.addNode(s),this.addNode(n),this._arcs.has(s)?this._arcs.get(s).push(n):this._arcs.set(s,[n])}getArcs(s){return this._arcs.has(s)?this._arcs.get(s):[]}hasOnlyGoodArcs(s,n){const o=c.getArcs(s);for(let S=0;S<o.length;S++)if(!n.has(o[S]))return!1;return!0}getNodes(){return this._nodesArr}},b=new w.ExtensionIdentifierMap;for(const s of i)if(b.set(s.identifier,s),s.extensionDependencies)for(const n of s.extensionDependencies)c.addArc(w.ExtensionIdentifier.toKey(s.identifier),w.ExtensionIdentifier.toKey(n));const _=new Set;c.getNodes().filter(s=>c.getArcs(s).length===0).forEach(s=>_.add(s));const E=c.getNodes().filter(s=>!_.has(s));let r;do{r=!1;for(let s=0;s<E.length;s++){const n=E[s];c.hasOnlyGoodArcs(n,_)&&(E.splice(s,1),s--,_.add(n),r=!0)}}while(r);return E.map(s=>b.get(s))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this._activationMap.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(i){const c=this._extensionsMap.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this._extensionsArr)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.ExtensionDescriptionRegistry=u;class y{constructor(i,c){this.versionId=i,this.extensions=c}}e.ExtensionDescriptionRegistrySnapshot=y,e.basicActivationEventsReader={readActivationEvents:t=>t.activationEvents};class m{constructor(i){this._lock=new a,this._actual=new u(i,[])}async acquireLock(i){const c=await this._lock.acquire(i);return new P(this,c)}deltaExtensions(i,c,b){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(c,b)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this._actual.getExtensionDescriptionByIdOrUUID(i,c)}}e.LockableExtensionDescriptionRegistry=m;class P extends L.Disposable{constructor(i,c){super(),this._registry=i,this._isDisposed=!1,this._register(c)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=P;class D{constructor(i){this.name=i,this.promise=new Promise((c,b)=>{this._resolve=c})}resolve(i){this._resolve(i)}}class a{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const c=new D(i);return this._pendingCustomers.push(c),this._advance(),c.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let c=!0;const b=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),_=()=>{c&&(clearTimeout(b),c=!1,this._isLocked=!1,this._advance())};i.resolve((0,L.toDisposable)(_))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==b)return c-b;const _=k.posix.basename(t.extensionLocation.path),E=k.posix.basename(i.extensionLocation.path);return _<E?-1:_>E?1:0}function f(t,i){const c=new w.ExtensionIdentifierSet(i);return t.filter(b=>!c.has(b.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(R||(e.UIKind=R={}));var k;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var L;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(m){const P=w.VSBuffer.alloc(1);switch(m){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=A;function u(m,P){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=u;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Ae[57],Re([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let v=class extends D.Disposable{constructor(i,c){super(),this.initData=i,this.loggerService=c,this._onDidChangeTelemetryEnabled=this._register(new R.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new R.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=P.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=c.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,a.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(c.onDidChangeLogLevel(b=>{(0,k.isLogLevel)(b)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(i,c,b){const _=this.getTelemetryDetails(),E=new p(c,b,i,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(i),{isUsageEnabled:_.isUsageEnabled,isErrorsEnabled:_.isErrorsEnabled}),r=this._telemetryLoggers.get(i.identifier.value)??[];return this._telemetryLoggers.set(i.identifier.value,[...r,E]),E.apiTelemetryLogger}$initializeTelemetryLevel(i,c,b){this._level=i,this._telemetryIsSupported=c,this._productConfig=b??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,c["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,c["common.vscodeversion"]=this.initData.version,c["common.isnewappinstall"]=f(this.initData.telemetryInfo.firstSessionDate),c["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,u.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),c}$onDidChangeTelemetryLevel(i){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=i;const c=this.getTelemetryDetails();this._telemetryLoggers.forEach((b,_)=>{const E=b.filter(r=>!r.isDisposed);E.length===0?this._telemetryLoggers.delete(_):this._telemetryLoggers.set(_,E)}),this._telemetryLoggers.forEach(b=>{for(const _ of b)_.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(i,c){const _=this._telemetryLoggers.get(i.value)?.filter(r=>!r.isDisposed);if(!_)return this._telemetryLoggers.delete(i.value),!1;let E=!1;for(const r of _)r.ignoreUnhandledExtHostErrors||(r.logError(c),E=!0);return E}};e.ExtHostTelemetry=v,e.ExtHostTelemetry=v=Ve([ze(0,L.IExtHostInitDataService),ze(1,k.ILoggerService)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,b,_,E,r,s){this._extension=b,this._logger=_,this._inLoggingOnlyMode=E,this._commonProperties=r,this._onDidChangeEnableStates=new R.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=c?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=c?.additionalCommonProperties,this._sender=i,this._telemetryEnablements={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,c){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:i,isErrorsEnabled:c},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,y.cleanData)(c,[]),this._additionalCommonProperties&&(c=(0,m.mixin)(c,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(c=(0,m.mixin)(c,this._commonProperties)),"properties"in i?i.properties=c:i=c,i}logEvent(i,c){this._sender&&(this._extension.publisher==="vscode"?i=this._extension.name+"/"+i:i=this._extension.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(i,c),this._logger.trace(i,c))}logUsage(i,c){this._telemetryEnablements.isUsageEnabled&&this.logEvent(i,c)}logError(i,c){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof i=="string")this.logEvent(i,c);else{const b={name:i.name,message:i.message,stack:i.stack,cause:i.cause},_=(0,y.cleanData)(b,[]),E=new Error(_.message,{cause:_.cause});E.stack=_.stack,E.name=_.name,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(E,c),this._logger.trace("exception",c)}}get apiTelemetryLogger(){if(!this._apiObject){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return i._telemetryEnablements.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i._onDidChangeEnableStates.event.bind(i)};this._apiObject=Object.freeze(c)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let i=this._sender;this._sender=void 0,Promise.resolve(i.flush()).then(i=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,180,98,20,4]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,u.createDecorator)("extensionService");class y{constructor(E){this.dependency=E}}e.MissingExtensionDependency=y;var m;(function(_){_[_.EagerAutoStart=1]="EagerAutoStart",_[_.EagerManualStart=2]="EagerManualStart",_[_.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class P{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(E,r,s){this._versionId=E,this._allExtensions=r.slice(0),this._myExtensions=s.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(E,r,s){if(this._versionId>E)throw new Error(`ExtensionHostExtensions: invalid versionId ${E} (current: ${this._versionId})`);const n=[],o=[],S=[],h=[],I=D(this._allExtensions),C=D(r),l=(H,x)=>H.extensionLocation.toString()===x.extensionLocation.toString()||H.isBuiltin===x.isBuiltin||H.isUserBuiltin===x.isUserBuiltin||H.isUnderDevelopment===x.isUnderDevelopment;for(const H of this._allExtensions){const x=C.get(H.identifier);if(!x){n.push(H.identifier),I.delete(H.identifier);continue}if(!l(H,x)){n.push(H.identifier),I.delete(H.identifier);continue}}for(const H of r){const x=I.get(H.identifier);if(!x){o.push(H);continue}if(!l(x,H)){n.push(x.identifier),I.delete(x.identifier);continue}}const g=new A.ExtensionIdentifierSet(this._myExtensions),d=new A.ExtensionIdentifierSet(s);for(const H of this._myExtensions)d.has(H)||S.push(H);for(const H of s)g.has(H)||h.push(H);const T=L.ImplicitActivationEvents.createActivationEventsMap(o),z={versionId:E,toRemove:n,toAdd:o,addActivationEvents:T,myToRemove:S,myToAdd:h};return this.delta(z),z}delta(E){if(this._versionId>=E.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:n,myToAdd:o}=E,S=new A.ExtensionIdentifierSet(r),h=new A.ExtensionIdentifierSet(n);for(let I=0;I<this._allExtensions.length;I++)S.has(this._allExtensions[I].identifier)&&(this._allExtensions.splice(I,1),I--);for(let I=0;I<this._myExtensions.length;I++)h.has(this._myExtensions[I])&&(this._myExtensions.splice(I,1),I--);for(const I of s)this._allExtensions.push(I);for(const I of o)this._myExtensions.push(I);return E}containsExtension(E){for(const r of this._myExtensions)if(A.ExtensionIdentifier.equals(r,E))return!0;return!1}}e.ExtensionHostExtensions=P;function D(_){const E=new A.ExtensionIdentifierMap;for(const r of _)E.set(r.identifier,r);return E}function a(_,E){return _.enabledApiProposals?_.enabledApiProposals.includes(E):!1}e.isProposedApiEnabled=a;function v(_,E){if(!a(_,E))throw new Error(`Extension '${_.identifier.value}' CANNOT use API proposal: ${E}.
Its package.json#enabledApiProposals-property declares: ${_.enabledApiProposals?.join(", ")??"[]"} but NOT ${E}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${_.identifier.value}`)}e.checkProposedApiEnabled=v;class p{constructor(E,r,s,n){this.codeLoadingTime=E,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=n}}e.ActivationTimes=p;class f{constructor(E,r){this.description=E,this.value=r}}e.ExtensionPointContribution=f;var t;(function(_){_[_.Normal=0]="Normal",_[_.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(_){return{type:_.isBuiltin?0:1,isBuiltin:_.isBuiltin||_.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(_.publisher,_.name),uuid:_.uuid},manifest:_,location:_.extensionLocation,targetPlatform:_.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function c(_,E){return{identifier:new A.ExtensionIdentifier((0,k.getExtensionId)(_.manifest.publisher,_.manifest.name)),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:!!E,extensionLocation:_.location,..._.manifest,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform}}e.toExtensionDescription=c;class b{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(E){return Promise.resolve(void 0)}activationEventIsDone(E){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(E,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=b}),define(Ae[209],Re([1,0,9,106,20,26,14,12]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(i,c,b,_){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=_}}e.ExtensionActivationTimes=y;class m{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,c){return i===-1||c===-1?-1:c-i}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class P{constructor(i,c,b,_,E,r){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=b,this.module=_,this.exports=E,this.subscriptions=r}}e.ActivatedExtension=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class a extends P{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=a;class v extends P{constructor(i){super(!0,i,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,c,b,_){this._logService=_,this._registry=i,this._globalRegistry=c,this._host=b,this._operations=new k.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[i,c]of this._operations)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,b]of this._operations)i.push(b.wait());await Promise.all(i)}isActivated(i){const c=this._operations.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this._operations.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this._alreadyActivatedEvents[i])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(i);await this._activateExtensions(b.map(_=>({id:_.identifier,reason:{startup:c,extensionId:_.identifier,activationEvent:i}}))),this._alreadyActivatedEvents[i]=!0}activateById(i,c){const b=this._registry.getExtensionDescription(i);if(!b)throw new Error(`Extension '${i}' is not known`);return this._activateExtensions([{id:b.identifier,reason:c}])}async _activateExtensions(i){const c=i.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(c.map(b=>b.wait()))}_handleActivationRequest(i){if(this._operations.has(i.id))return this._operations.get(i.id);if(this._isHostExtension(i.id))return this._createAndSaveOperation(i,null,[],null);const c=this._registry.getExtensionDescription(i.id);if(!c){const E=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this._createAndSaveOperation(i,null,[],new v(E));return this._host.onExtensionActivationError(i.id,E,new L.MissingExtensionDependency(i.id.value)),r}const b=[],_=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const E of _){if(this._isResolvedExtension(E))continue;const r=this._operations.get(E);if(r){b.push(r);continue}if(this._isHostExtension(E)){b.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(E).identifier,reason:i.reason}));continue}const s=this._registry.getExtensionDescription(E);if(s){if(!s.main&&!s.browser)continue;b.push(this._handleActivationRequest({id:s.identifier,reason:i.reason}));continue}const n=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${E}'`),S=this._createAndSaveOperation(i,c.displayName,[],new v(o));return this._host.onExtensionActivationError(c.identifier,o,new L.MissingExtensionDependency(E)),S}return this._createAndSaveOperation(i,c.displayName,b,null)}_createAndSaveOperation(i,c,b,_){const E=new f(i.id,c,i.reason,b,_,this._host,this._logService);return this._operations.set(i.id,E),E}_isHostExtension(i){return R.ExtensionDescriptionRegistry.isHostExtension(i,this._registry,this._globalRegistry)}_isResolvedExtension(i){const c=this._globalRegistry.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.ExtensionsActivator=p,e.ExtensionsActivator=p=Ve([ze(3,A.ILogService)],p);let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(i,c,b,_,E,r,s){this._id=i,this._displayName=c,this._reason=b,this._deps=_,this._value=E,this._host=r,this._logService=s,this._barrier=new u.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let i=0;i<this._deps.length;i++){const c=this._deps[i];if(c.value&&!c.value.activationFailed){this._deps.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);b.detail=c.value.activationFailedError,this._value=new v(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(i=>i.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this._id.value}' failed: ${i.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this._value=new v(c),this._isDisposed&&w.isCancellationError(i))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(i)}}};f=Ve([ze(6,A.ILogService)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,12,7,16,18,8,50,21,125,26]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function i(_,E){if((0,P.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let r;return Array.isArray(_.highlights)&&(r=_.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:_.label,highlights:r}}}class c extends A.Disposable{constructor(E,r,s){super(),this._proxy=E,this.commands=r,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeViewsDnDService;function n(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>n(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(S=>n(S)?this.convertArgument(S):S):o})}registerTreeDataProvider(E,r,s){const n=this.createTreeView(E,{treeDataProvider:r},s);return{dispose:()=>n.dispose()}}createTreeView(E,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],S=!!r.dragAndDropController?.handleDrag,h=!!r.dragAndDropController?.handleDrop,I=this.createExtHostTreeView(E,r,s),C={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:n,dragMimeTypes:o,hasHandleDrag:S,hasHandleDrop:h,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},l=this._proxy.$registerTreeViewDataProvider(E,C),g={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.checkProposedApiEnabled)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.checkProposedApiEnabled)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(d){(0,v.isMarkdownString)(d)&&(0,t.checkProposedApiEnabled)(s,"treeViewMarkdownMessage"),I.message=d},get title(){return I.title},set title(d){I.title=d},get description(){return I.description},set description(d){I.description=d},get badge(){return I.badge},set badge(d){d!==void 0&&m.ViewBadge.isViewBadge(d)?I.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(I.badge=void 0)},reveal:(d,T)=>I.reveal(d,T),dispose:async()=>{await l,this.treeViews.delete(E),I.dispose()}};return this._register(g),g}$getChildren(E,r){const s=this.treeViews.get(E);return s?s.getChildren(r):Promise.reject(new u.NoTreeViewError(E))}async $handleDrop(E,r,s,n,o,S,h,I){const C=this.treeViews.get(E);if(!C)return Promise.reject(new u.NoTreeViewError(E));const l=a.DataTransfer.toDataTransfer(s,async g=>(await this._proxy.$resolveDropFileData(E,r,g)).buffer);return h===E&&I&&await this.addAdditionalTransferItems(l,C,I,o,S),C.onDrop(l,n,o)}async addAdditionalTransferItems(E,r,s,n,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);if(S)(await S)?.forEach((h,I)=>{h&&E.set(I,h)});else if(o&&r.handleDrag){const h=r.handleDrag(s,E,n);this.treeDragAndDropService.addDragOperationTransfer(o,h),await h}return E}async $handleDrag(E,r,s,n){const o=this.treeViews.get(E);if(!o)return Promise.reject(new u.NoTreeViewError(E));const S=await this.addAdditionalTransferItems(new m.DataTransfer,o,r,n,s);if(!(!S||n.isCancellationRequested))return a.DataTransfer.from(S)}async $hasResolve(E){const r=this.treeViews.get(E);if(!r)throw new u.NoTreeViewError(E);return r.hasResolve}$resolve(E,r,s){const n=this.treeViews.get(E);if(!n)throw new u.NoTreeViewError(E);return n.resolveTreeItem(r,s)}$setExpanded(E,r,s){const n=this.treeViews.get(E);if(!n)throw new u.NoTreeViewError(E);n.setExpanded(r,s)}$setSelectionAndFocus(E,r,s){const n=this.treeViews.get(E);if(!n)throw new u.NoTreeViewError(E);n.setSelectionAndFocus(r,s)}$setVisible(E,r){const s=this.treeViews.get(E);if(!s){if(!r)return;throw new u.NoTreeViewError(E)}s.setVisible(r)}$changeCheckboxState(E,r){const s=this.treeViews.get(E);if(!s)throw new u.NoTreeViewError(E);s.setCheckboxState(r)}createExtHostTreeView(E,r,s){const n=this._register(new b(E,r,this._proxy,this.commands.converter,this.logService,s));return this.treeViews.set(E,n),n}convertArgument(E){const r=this.treeViews.get(E.$treeViewId);return r&&"$treeItemHandle"in E?r.getExtensionElement(E.$treeItemHandle):r&&"$focusedTreeItem"in E&&E.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=c;class b extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(E=>this.getExtensionElement(E)).filter(E=>!(0,P.isUndefinedOrNull)(E))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(E,r,s,n,o,S){if(super(),this.viewId=E,this.proxy=s,this.commands=n,this.logService=o,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new L.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new L.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new L.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new L.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new L.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new L.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,S.contributes&&S.contributes.views)for(const l in S.contributes.views)for(const g of S.contributes.views[l])g.id===E&&(this._title=g.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let h,I;const C=L.Event.debounce(this._onDidChangeData.event,(l,g)=>(l||(l={message:!1,elements:[]}),g.element!==!1&&(h||(h=new Promise(d=>I=d),this.refreshPromise=this.refreshPromise.then(()=>h)),Array.isArray(g.element)?l.elements.push(...g.element):l.elements.push(g.element)),g.message&&(l.message=!0),l),200,!0);this._register(C(({message:l,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=I;return h=null,this.refresh(g).then(()=>d())})),l&&this.proxy.$setMessage(this.viewId,a.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(E){const r=E?this.getExtensionElement(E):void 0;if(E&&!r)return this.logService.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(E);return s||(s=await this.fetchChildrenNodes(r)),s?s.map(n=>n.item):void 0}getExtensionElement(E){return this.elements.get(E)}reveal(E,r){r=r||{select:!0,focus:!1};const s=(0,P.isUndefinedOrNull)(r.select)?!0:r.select,n=(0,P.isUndefinedOrNull)(r.focus)?!1:r.focus,o=(0,P.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.refreshPromise.then(()=>this.resolveUnknownParentChain(E)).then(S=>this.resolveTreeNode(E,S[S.length-1]).then(h=>this.proxy.$reveal(this.viewId,{item:h.item,parentChain:S.map(I=>I.item)},{select:s,focus:n,expand:o})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:n,expand:o})}get message(){return this._message}set message(E){this._message=E,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(E){this._title=E,this.proxy.$setTitle(this.viewId,E,this._description)}get description(){return this._description}set description(E){this._description=E,this.proxy.$setTitle(this.viewId,this._title,E)}get badge(){return this._badge}set badge(E){this._badge?.value===E?.value&&this._badge?.tooltip===E?.tooltip||(this._badge=a.ViewBadge.from(E),this.proxy.$setBadge(this.viewId,E))}setExpanded(E,r){const s=this.getExtensionElement(E);s&&(r?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelectionAndFocus(E,r){const s=!(0,D.equals)(this._selectedHandles,E);this._selectedHandles=E;const n=this._focusedHandle!==r;this._focusedHandle=r,s&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),n&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(E){E!==this._visible&&(this._visible=E,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(E){const r=(await Promise.all(E.map(async s=>{const n=this.getExtensionElement(s.treeItemHandle);return n?{extensionItem:n,treeItem:await this.dataProvider.getTreeItem(n),newState:s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(E,r,s){const n=[];for(const o of E){const S=this.getExtensionElement(o);S&&n.push(S)}if(!(!this.dndController?.handleDrag||n.length===0))return await this.dndController.handleDrag(n,r,s),r}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(E,r,s){const n=r?this.getExtensionElement(r):void 0;if(!(!n&&r||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(n,E,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(E,r){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(E);if(s){const n=this.nodes.get(s);if(n){const o=await this.dataProvider.resolveTreeItem(n.extensionItem,s,r)??n.extensionItem;return this.validateTreeItem(o),n.item.tooltip=this.getTooltip(o.tooltip),n.item.command=this.getCommand(n.disposableStore,o.command),n.item}}}resolveUnknownParentChain(E){return this.resolveParent(E).then(r=>r?this.resolveUnknownParentChain(r).then(s=>this.resolveTreeNode(r,s[s.length-1]).then(n=>(s.push(n),s))):Promise.resolve([]))}resolveParent(E){const r=this.nodes.get(E);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(E))}resolveTreeNode(E,r){const s=this.nodes.get(E);return s?Promise.resolve(s):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(n=>this.createHandle(E,n,r,!0)).then(n=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(n);if(o){const S=this.nodes.get(o);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(E){if(E){let r;if(typeof E=="string"){const s=this.getExtensionElement(E);r=s?this.nodes.get(s):void 0}else r=E;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(E){this.clearChildren(E);const r=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=E?this.nodes.get(E):void 0,n=await this.dataProvider.getChildren(E);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,D.coalesce)(n||[]).map(async S=>{const h=await this.dataProvider.getTreeItem(S);return h&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(S,h,s):null}));return r.token.isCancellationRequested?void 0:(0,D.coalesce)(o)}finally{r.dispose()}}refresh(E){if(E.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(E);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(E){const r=new Set,s=E.map(o=>this.nodes.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let S=o;for(;S&&S.parent&&s.findIndex(h=>S&&S.parent&&h&&h.item.handle===S.parent.item.handle)===-1;){const h=this.elements.get(S.parent.item.handle);S=h?this.nodes.get(h):void 0}S&&!S.parent&&r.add(o.item.handle)}const n=[];return r.forEach(o=>{const S=this.elements.get(o);if(S){const h=this.nodes.get(S);h&&(!h.parent||!r.has(h.parent.item.handle))&&n.push(o)}}),n}refreshHandles(E){const r={};return Promise.all(E.map(s=>this.refreshNode(s).then(n=>{n&&(r[s]=n.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(E){const r=this.getExtensionElement(E);if(r){const s=this.nodes.get(r);if(s)return this.clearChildren(r),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(n=>{if(n){const o=this.createTreeNode(r,n,s.parent);return this.updateNodeCache(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(E,r,s){const n=this.createTreeNode(E,r,s);if(r.id&&this.elements.has(n.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.addNodeToCache(E,n),this.addNodeToParentCache(n,s),n}getTooltip(E){return m.MarkdownString.isMarkdownString(E)?a.MarkdownString.from(E):E}getCommand(E,r){return r?{...this.commands.toInternal(r,E),originalId:r.command}:void 0}getCheckbox(E){if(E.checkboxState===void 0)return;let r,s,n;return typeof E.checkboxState=="number"?r=E.checkboxState:(r=E.checkboxState.state,s=E.checkboxState.tooltip,n=E.checkboxState.accessibilityInformation),{isChecked:r===m.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:n}}validateTreeItem(E){if(!m.TreeItem.isTreeItem(E,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(E,r,s){this.validateTreeItem(r);const n=this._register(new A.DisposableStore),o=this.createHandle(E,r,s),S=this.getLightIconPath(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(n,r.command),contextValue:r.contextValue,icon:S,iconDark:this.getDarkIconPath(r)||S,themeIcon:this.getThemeIcon(r),collapsibleState:(0,P.isUndefinedOrNull)(r.collapsibleState)?m.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.getCheckbox(r)},extensionItem:r,parent:s,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(E){return E.iconPath instanceof m.ThemeIcon?E.iconPath:void 0}createHandle(E,{id:r,label:s,resourceUri:n},o,S){if(r)return`${b.ID_HANDLE_PREFIX}/${r}`;const h=i(s,this.extension),I=o?o.item.handle:b.LABEL_HANDLE_PREFIX;let C=h?h.label:n?(0,R.basename)(n):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const l=this.nodes.has(E)?this.nodes.get(E).item.handle:void 0,g=this.getChildrenNodes(o)||[];let d,T=0;do{if(d=`${I}/${T}:${C}`,S||!this.elements.has(d)||l===d)break;T++}while(T<=g.length);return d}getLightIconPath(E){if(E.iconPath&&!(E.iconPath instanceof m.ThemeIcon))return typeof E.iconPath=="string"||k.URI.isUri(E.iconPath)?this.getIconPath(E.iconPath):this.getIconPath(E.iconPath.light)}getDarkIconPath(E){if(E.iconPath&&!(E.iconPath instanceof m.ThemeIcon)&&E.iconPath.dark)return this.getIconPath(E.iconPath.dark)}getIconPath(E){return k.URI.isUri(E)?E:k.URI.file(E)}addNodeToCache(E,r){this.elements.set(r.item.handle,E),this.nodes.set(E,r)}updateNodeCache(E,r,s,n){this.elements.delete(r.item.handle),this.nodes.delete(E),r.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(E,r);const o=this.getChildrenNodes(n)||[],S=o.filter(h=>h.item.handle===s.item.handle)[0];S&&o.splice(o.indexOf(S),1,r)}addNodeToParentCache(E,r){r?(r.children||(r.children=[]),r.children.push(E)):(this.roots||(this.roots=[]),this.roots.push(E))}clearChildren(E){if(E){const r=this.nodes.get(E);if(r){if(r.children)for(const s of r.children){const n=this.elements.get(s.item.handle);n&&this.clear(n)}r.children=void 0}}else this.clearAll()}clear(E){const r=this.nodes.get(E);if(r){if(r.children)for(const s of r.children){const n=this.elements.get(s.item.handle);n&&this.clear(n)}this.nodes.delete(E),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(E=>E.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ae[211],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,72,30,20,211,176,98]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const a=u.Registry.as(A.Extensions.JSONContribution);class v{constructor(E,r,s){this._messageHandler=E,this._extension=r,this._extensionPointId=s}_msg(E,r){this._messageHandler({type:E,message:r,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(E){this._msg(k.default.Error,E)}warn(E){this._msg(k.default.Warning,E)}info(E){this._msg(k.default.Info,E)}}e.ExtensionMessageCollector=v;class p{static _toSet(E){const r=new y.ExtensionIdentifierSet;for(let s=0,n=E.length;s<n;s++)r.add(E[s].description.identifier);return r}static compute(E,r){if(!E||!E.length)return new p(r,[]);if(!r||!r.length)return new p([],E);const s=this._toSet(E),n=this._toSet(r),o=r.filter(h=>!s.has(h.description.identifier)),S=E.filter(h=>!n.has(h.description.identifier));return new p(o,S)}constructor(E,r){this.added=E,this.removed=r}}e.ExtensionPointUserDelta=p;class f{constructor(E,r){this.name=E,this.defaultExtensionKind=r,this._handler=null,this._users=null,this._delta=null}setHandler(E){if(this._handler!==null)throw new Error("Handler already set!");this._handler=E,this._handle()}acceptUsers(E){this._delta=p.compute(this._users,E),this._users=E,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(E){(0,R.onUnexpectedError)(E)}}}e.ExtensionPoint=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(E){if(this._extensionPoints.has(E.extensionPoint))throw new Error("Duplicate extension point: "+E.extensionPoint);const r=new f(E.extensionPoint,E.defaultExtensionKind);return this._extensionPoints.set(E.extensionPoint,r),E.activationEventsGenerator&&D.ImplicitActivationEvents.register(E.extensionPoint,E.activationEventsGenerator),e.schema.properties.contributes.properties[E.extensionPoint]=E.jsonSchema,a.registerSchema(i,e.schema),r}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const b={ExtensionsRegistry:"ExtensionsRegistry"};u.Registry.add(b.ExtensionsRegistry,new c),e.ExtensionsRegistry=u.Registry.as(b.ExtensionsRegistry),a.registerSchema(i,e.schema),a.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,16,24,212,32,5]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var m;(function(a){function v(p,f,t){if(!p)return;const i=R.isString(p.type)?p.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray(p.required))for(const b of p.required)R.isString(b)&&c.push(b);return{extensionId:f.value,taskType:i,required:c,properties:p.properties?k.deepClone(p.properties):{},when:p.when?A.ContextKeyExpr.deserialize(p.when):void 0}}a.from=v})(m||(m={}));const P=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,v)=>{for(const p of a)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:y}});class D{constructor(){this._onDefinitionsChanged=new u.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((v,p)=>{P.setHandler((f,t)=>{this._schema=void 0;try{for(const i of t.removed){const c=i.value;for(const b of c)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const i of t.added){const c=i.value;for(const b of c){const _=m.from(b,i.description.identifier,i.collector);_&&(this.taskTypes[_.taskType]=_)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}v(void 0)})})}onReady(){return this.readyPromise}get(v){return this.taskTypes[v]}all(){return Object.keys(this.taskTypes).map(v=>this.taskTypes[v])}getJsonSchema(){if(this._schema===void 0){const v=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=k.deepClone(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},v.push(f)}this._schema={oneOf:v}}return this._schema}}e.TaskDefinitionRegistry=new D}),define(Ae[214],Re([1,0,164,16,23,24,32,213]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,w.localize(0,null)),e.TASKS_CATEGORY={value:w.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function M(te){if(!te)return N.Strong;switch(te.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=M}(y||(e.ShellQuoting=y={}));var m;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var P;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(P||(e.RevealKind=P={})),function(N){function M(te){switch(te.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=M}(P||(e.RevealKind=P={}));var D;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(N){function M(te){switch(te.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=M}(D||(e.RevealProblemKind=D={}));var a;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(a||(e.PanelKind=a={})),function(N){function M(te){switch(te.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=M}(a||(e.PanelKind=a={}));var v;(function(N){N.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(N){function M(Q){switch(Q.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=M;function te(Q){switch(Q){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=te}(p||(e.RuntimeType=p={}));var f;(function(N){function M(te){return R.isString(te)?te:te.value}N.value=M})(f||(e.CommandString=f={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function M(Q){return Q===N.Clean._id||Q===N.Build._id||Q===N.Rebuild._id||Q===N.Test._id}N.is=M;function te(Q){if(Q!==void 0)return R.isString(Q)?M(Q)?{_id:Q,isDefault:!1}:void 0:Q}N.from=te})(t||(e.TaskGroup=t={}));var i;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function M(te){switch(te){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=M})(c||(e.TaskSourceKind=c={}));var b;(function(N){N.parallel="parallel",N.sequence="sequence"})(b||(e.DependsOrder=b={}));var _;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(_||(e.RunOnOptions=_={}));var E;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:_.default,instanceLimit:1}})(E||(e.RunOptions=E={}));class r{constructor(M,te,Q,Se,_e,Pe){this._label="",this._id=M,te&&(this._label=te),Q&&(this.type=Q),this.runOptions=Se,this.configurationProperties=_e,this._source=Pe}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,te=!1){if(M===void 0)return!1;if(R.isString(M))return M===this._label||M===this.configurationProperties.identifier||te&&M===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class s extends r{constructor(M,te,Q,Se,_e,Pe,Y,ae){super(M,Q,void 0,Y,ae,te),this.command={},this._source=te,this.hasDefinedMatchers=Pe,_e&&(this.command=_e)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let te;switch(this.command?this.command.runtime:void 0){case p.Shell:te="shell";break;case p.Process:te="process";break;case p.CustomExecution:te="customExecution";break;case void 0:te="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:te,_key:this._id,id:this._id}}}static is(M){return M instanceof s}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:te};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new s(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=s;class n extends r{constructor(M,te,Q,Se,_e,Pe,Y){super(M,Q,Se,Pe,Y,te),this._source=te,this.configures=_e}static is(M){return M instanceof n}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:te};return JSON.stringify(Q)}}e.ConfiguringTask=n;class o extends r{constructor(M,te,Q,Se,_e,Pe,Y,ae,Ce){super(M,Q,Se,ae,Ce,te),this.defines=_e,this.hasDefinedMatchers=Y,this.command=Pe,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof o}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new o(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=o;class S extends r{constructor(M,te,Q,Se,_e,Pe){super(M,Q,Se,_e,Pe,te),this._source=te}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new S(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=S;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var I;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class C{constructor(M){this._order=new Map;for(let te=0;te<M.length;te++)this._order.set(M[te].uri.toString(),te)}compare(M,te){const Q=M.getWorkspaceFolder(),Se=te.getWorkspaceFolder();if(Q&&Se){let _e=this._order.get(Q.uri.toString());_e=_e===void 0?0:_e+1;let Pe=this._order.get(Se.uri.toString());return Pe=Pe===void 0?0:Pe+1,_e===Pe?M._label.localeCompare(te._label):_e-Pe}else return!Q&&Se?-1:Q&&!Se?1:0}}e.TaskSorter=C;var l;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(l||(e.TaskEventKind=l={}));var g;(function(N){N.SingleRun="singleRun",N.Background="background"})(g||(e.TaskRunType=g={}));var d;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(d||(e.TaskRunSource=d={}));var T;(function(N){function M(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function te(ae,Ce,le){return{...M(ae),kind:"start",terminalId:Ce,resolvedVariables:le}}N.start=te;function Q(ae,Ce,le){return{...M(ae),kind:"processStarted",terminalId:Ce,processId:le}}N.processStarted=Q;function Se(ae,Ce,le){return{...M(ae),kind:"processEnded",terminalId:Ce,exitCode:le}}N.processEnded=Se;function _e(ae,Ce,le){return{...M(ae),kind:"terminated",exitReason:le,terminalId:Ce}}N.terminated=_e;function Pe(ae,Ce,le){return{...M(Ce),kind:ae,terminalId:le}}N.general=Pe;function Y(){return{kind:"changed"}}N.changed=Y})(T||(e.TaskEvent=T={}));var z;(function(N){function M(Q){const Se=Object.keys(Q).sort();let _e="";for(const Pe of Se){let Y=Q[Pe];Y instanceof Object?Y=M(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),_e+=Pe+","+Y+","}return _e}function te(Q){const _e={_key:M(Q),type:Q.taskType};return Object.assign(_e,Q),_e}N.create=te})(z||(e.KeyedTaskIdentifier=z={}));var H;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(H||(e.TaskSettingId=H={}));var x;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var $;(function(N){function M(te,Q){const Se=u.TaskDefinitionRegistry.get(te.type);if(Se===void 0){const ae=L.deepClone(te);return delete ae._key,z.create(ae)}const _e=Object.create(null);_e.type=Se.taskType;const Pe=new Set;Se.required.forEach(ae=>Pe.add(ae));const Y=Se.properties;for(const ae of Object.keys(Y)){const Ce=te[ae];if(Ce!=null)_e[ae]=Ce;else if(Pe.has(ae)){const le=Y[ae];if(le.default!==void 0)_e[ae]=L.deepClone(le.default);else switch(le.type){case"boolean":_e[ae]=!1;break;case"number":case"integer":_e[ae]=0;break;case"string":_e[ae]="";break;default:Q.error(w.localize(2,null,JSON.stringify(te,void 0,0),ae));return}}}return z.create(_e)}N.createTaskIdentifier=M})($||(e.TaskDefinition=$={}))}),define(Ae[215],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,u)=>{this._actualOk=A,this._actualErr=u,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,w.onUnexpectedError)(A))}then(A,u){return this._ensureActual().then(A,u)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=R;class k extends R{constructor(){super(),this._hasErr=!0,this._err=new w.CancellationError}}e.CanceledLazyPromise=k}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++w.count}}e.ProxyIdentifier=w;const R=[];function k(u){const y=new w(u);return R[y.nid]=y,y}e.createProxyIdentifier=k;function L(u){return R[u].sid}e.getStringIdentifierForProxy=L;class A{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var k;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(k||(e.TabInputKind=k={}));var L;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var u;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(u||(e.WebviewMessageArrayBufferViewType=u={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var m;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this._n=0}static mixin(t){return t._id=D._n++,t}}e.IdObject=D;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,w.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,w.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,w.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,w.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,w.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,w.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents:(0,w.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class k{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(w.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,u,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const m=this._relatedInformationProviders.get(A);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(u,y)??[]}getRelatedInformation(A,u,y){return this._proxy.$getAiRelatedInformation(u,y)}registerRelatedInformationProvider(A,u,y){const m=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(m,y),this._proxy.$registerAiRelatedInformationProvider(m,u),new R.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(m),this._relatedInformationProviders.delete(m)})}}e.ExtHostRelatedInformation=k}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(y,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,m,P){const D=this.getUsageKey(y,m);this._reportedUsages.has(D)||(this._reportedUsages.add(D),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}getUsageKey(y,m){return`${y}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=Ve([ze(0,L.IExtHostRpcService),ze(1,R.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(u,y,m){}})}),define(Ae[217],Re([1,0,5,3,7,20]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new u,this._getSessionsTaskSingler=new u,this._proxy=m.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,P,D,a={}){const v=L.ExtensionIdentifier.toKey(m.identifier),p=[...D].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${v} ${P} ${p}`,async()=>{await this._proxy.$ensureProvider(P);const f=m.displayName||m.name;return this._proxy.$getSession(P,D,v,f,a)})}async getSessions(m,P,D){const a=L.ExtensionIdentifier.toKey(m.identifier),v=[...D].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${a} ${v}`,async()=>{await this._proxy.$ensureProvider(P);const p=m.displayName||m.name;return this._proxy.$getSessions(P,D,a,p)})}async removeSession(m,P){const D=this._authenticationProviders.get(m);return D?D.provider.removeSession(P):this._proxy.$removeSession(m,P)}registerAuthenticationProvider(m,P,D,a){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:P,provider:D,options:a??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===m)||this._providers.push({id:m,label:P});const v=D.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(m,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,P,a?.supportsMultipleAccounts??!1),new k.Disposable(()=>{v.dispose(),this._authenticationProviders.delete(m);const p=this._providers.findIndex(f=>f.id===m);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,P,D){const a=this._authenticationProviders.get(m);if(a)return Promise.resolve(a.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,P){const D=this._authenticationProviders.get(m);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,P){const D=this._authenticationProviders.get(m);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,P){return this._onDidChangeSessions.fire({provider:{id:m,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A;class u{constructor(){this._inFlightPromises=new Map}getOrCreate(m,P){const D=this._inFlightPromises.get(m);if(D)return D;const a=P().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(u,y){this._proxy=u.getProxy(w.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(u,y,m){const P=k.WorkspaceEdit.from(u,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(P,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Ve([ze(0,R.IExtHostRpcService)],L)}),define(Ae[219],Re([1,0,12,5,65,6,58,146,3,8]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class P{static{this._pool=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=P._pool++}}class D{static{this._nextId=0}constructor(v,p){this.logService=p,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new R.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=v.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(v,p,f){const t=new P(v,f);return this._chatProvider.set(t.handle,t),this._proxy.$registerChatProvider(t.handle,p),(0,L.toDisposable)(()=>{this._proxy.$unregisterChatProvider(t.handle),this._chatProvider.delete(t.handle)})}transferChatSession(v,p){const f=k.Iterable.find(this._chatSessions.keys(),t=>this._chatSessions.get(t)===v)??0;typeof f=="number"&&this._proxy.$transferChatSession(f,p)}sendInteractiveRequestToProvider(v,p){this._proxy.$sendRequestToProvider(v,p)}async $prepareChat(v,p,f){const t=this._chatProvider.get(v);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const c=D._nextId++;return this._chatSessions.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,p){const f=this._chatProvider.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>m.ChatReplyFollowup.from(c)))}async $provideFollowups(v,p,f){const t=this._chatProvider.get(v);if(!t)return;const i=this._chatSessions.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(b=>m.ChatFollowup.from(b))}$removeRequest(v,p,f){const t=this._chatProvider.get(v);if(!t)return;const i=this._chatSessions.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(v,p,f,t){const i=this._chatProvider.get(v);if(!i)return;const c=this._chatSessions.get(p);if(!c)return;const b={session:c,message:typeof f.message=="string"?f.message:m.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))b.variables[o]=f.variables[o].map(m.ChatVariable.to);const _=A.StopWatch.create(!1);let E;const r={report:o=>{if(t.isCancellationRequested)return;typeof E>"u"&&(E=_.elapsed());const S=m.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const h=Promise.all([this._proxy.$acceptResponseProgress(v,p,S),o.resolvedContent]);(0,w.raceCancellation)(h,t).then(I=>{if(!I)return;const[C,l]=I;this._proxy.$acceptResponseProgress(v,p,l,C??void 0)})}else this._proxy.$acceptResponseProgress(v,p,S)}};let s;try{s=await i.provider.provideResponseWithProgress(b,r,t),s||(s={errorDetails:{message:(0,u.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,u.localize)(1,null,o.message),responseIsIncomplete:!0}},this.logService.error(o)}try{if(c.saveState&&this._chatSessions.has(p)){const o=c.saveState();this._proxy.$acceptChatState(p,o)}}catch(o){this.logService.warn(o)}const n={firstProgress:E??0,totalElapsed:_.elapsed()};return{errorDetails:s.errorDetails,timings:n}}async $provideSlashCommands(v,p,f){const t=this._chatProvider.get(v);if(!t)return;const i=this._chatSessions.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(b=>({...b,kind:m.CompletionItemKind.from(b.kind)}))}$releaseSession(v){this._chatSessions.delete(v)}async $onDidPerformUserAction(v){this._onDidPerformUserAction.fire(v)}}e.ExtHostChat=D}),define(Ae[220],Re([1,0,12,6,71,3,8,7]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class y{static{this._idPool=0}constructor(D,a,v){this._extHostChatProvider=a,this._logService=v,this._agents=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadChatAgents)}registerAgent(D,a,v,p){const f=y._idPool++;return this._agents.set(f,{extension:D,agent:v}),this._proxy.$registerAgent(f,a,p),(0,R.toDisposable)(()=>{this._proxy.$unregisterAgent(f),this._agents.delete(f)})}async $invokeAgent(D,a,v,p,f){const t=this._agents.get(D);if(!t){this._logService.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const b=new w.DeferredPromise;f.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(t.extension,b.p);const _=t.agent({role:u.ChatMessageRole.User,content:v},{history:p.history.map(A.ChatMessage.to)},new k.Progress(E=>{c(),this._proxy.$handleProgressChunk(a,{content:m(E.message)?E.message:E.message.value})}),f);try{return await(0,w.raceCancellation)(Promise.resolve(_).then(E=>{if(E&&"followUp"in E)return{followUp:E?.followUp?.map(s=>A.ChatFollowup.from(s))}}),f)}finally{i=!0,b.complete()}}}e.ExtHostChatAgents=y;function m(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[221],Re([1,0,6,3,8,71,20]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class u{static{this._idPool=1}constructor(m,P){this._logService=P,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new A.ExtensionIdentifierMap,this._proxy=m.getProxy(R.MainContext.MainThreadChatProvider)}registerProvider(m,P,D,a){const v=u._idPool++;return this._providers.set(v,{extension:m,provider:D}),this._proxy.$registerProvider(v,P,{extension:m,displayName:a.name??m.value}),(0,w.toDisposable)(()=>{this._proxy.$unregisterProvider(v),this._providers.delete(v)})}async $provideChatResponse(m,P,D,a,v){const p=this._providers.get(m);if(!p)return;const f=new L.Progress(async t=>{if(v.isCancellationRequested){this._logService.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return p.provider.provideChatResponse(D.map(k.ChatMessage.to),a,f,v)}allowListExtensionWhile(m,P){this._chatAccessAllowList.set(m,P),P.finally(()=>this._chatAccessAllowList.delete(m))}async requestChatResponseProvider(m,P){if(!this._chatAccessAllowList.has(m))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D._chatAccessAllowList.has(m)},async makeRequest(a,v,p,f){if(!D._chatAccessAllowList.has(m))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D._pendingRequest.set(t,p);try{await D._proxy.$fetchResponse(m,P,t,a.map(k.ChatMessage.from),v,f)}finally{D._pendingRequest.delete(t)}}}}async $handleResponseFragment(m,P){this._pendingRequest.get(m)?.report(P)}}e.ExtHostChatProvider=u}),define(Ae[222],Re([1,0,6,3,9,8]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class A{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadChatVariables)}async $resolveVariable(y,m,P){const D=this._resolver.get(y);if(D)try{const a=await D.resolver.resolve(D.data.name,{message:m},P);if(a)return a.map(L.ChatVariable.from)}catch(a){(0,k.onUnexpectedExternalError)(a)}}registerVariableResolver(y,m,P,D){const a=A._idPool++;return this._resolver.set(a,{extension:y.identifier,data:{name:m,description:P},resolver:D}),this._proxy.$registerVariable(a,{name:m,description:P}),(0,w.toDisposable)(()=>{this._resolver.delete(a),this._proxy.$unregisterVariable(a)})}}e.ExtHostChatVariables=A}),define(Ae[223],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(L){const A=L.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(u){return A.$writeText(u)}})}}e.ExtHostClipboard=R}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,67,44,278,2,6,4,17,104,25,46,41,58,53,57]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{#e;#t;#i;constructor(C,l,g){this._commands=new Map,this._apiCommands=new Map,this.#e=C.getProxy(A.MainContext.MainThreadCommands),this._logService=l,this.#i=g,this.#t=C.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new n(this,d=>{const T=this._apiCommands.get(d);return T?.result===S.Void?T:void 0},l),this._argumentProcessors=[{processArgument(d){return(0,m.revive)(d)}},{processArgument(d){return(0,L.cloneAndChange)(d,function(T){if(P.Range.isIRange(T))return k.Range.to(T);if(D.Position.isIPosition(T))return k.Position.to(T);if(P.Range.isIRange(T.range)&&a.URI.isUri(T.uri))return k.location.to(T);if(T instanceof i.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(C){this._argumentProcessors.push(C)}registerApiCommand(C){const l=this.registerCommand(!1,C.id,async(...g)=>{const d=C.args.map((z,H)=>{if(!z.validate(g[H]))throw new Error(`Invalid argument '${z.name}' when running '${C.id}', received: ${typeof g[H]=="object"?JSON.stringify(g[H],null,"	"):g[H]} `);return z.convert(g[H])}),T=await this.executeCommand(C.internalId,...d);return C.result.convert(T,g,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this._apiCommands.set(C.id,C),new R.Disposable(()=>{l.dispose(),this._apiCommands.delete(C.id)})}registerCommand(C,l,g,d,T,z){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:g,thisArg:d,metadata:T,extension:z}),C&&this.#e.$registerCommand(l),new R.Disposable(()=>{this._commands.delete(l)&&C&&this.#e.$unregisterCommand(l)})}executeCommand(C,...l){return this._logService.trace("ExtHostCommands#executeCommand",C),this._doExecuteCommand(C,l,!0)}async _doExecuteCommand(C,l,g){if(this._commands.has(C))return this.#e.$fireCommandActivationEvent(C),this._executeContributedCommand(C,l,!1);{let d=!1;const T=(0,L.cloneAndChange)(l,function(z){if(z instanceof R.Position)return k.Position.from(z);if(z instanceof R.Range)return k.Range.from(z);if(z instanceof R.Location)return k.location.from(z);if(R.NotebookRange.isNotebookRange(z))return k.NotebookRange.from(z);if(z instanceof ArrayBuffer)return d=!0,i.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return d=!0,i.VSBuffer.wrap(z);if(z instanceof i.VSBuffer)return d=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(C,d?new c.SerializableObjectWithBuffers(T):T,g);return(0,m.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(C,l,!1);throw z}}}async _executeContributedCommand(C,l,g){const d=this._commands.get(C);if(!d)throw new Error("Unknown command");const{callback:T,thisArg:z,metadata:H}=d;if(H?.args)for(let $=0;$<H.args.length;$++)try{(0,w.validateConstraint)(l[$],H.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${H.args[$].name}' - ${H.args[$].description}`)}const x=_.StopWatch.create();try{return await T.apply(z,l)}catch($){if(C===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...l);N&&(C=N.command)}if(this._logService.error($,C,d.extension?.identifier),!g)throw $;if(d.extension?.identifier){const N=this.#i.onExtensionError(d.extension.identifier,$);this._logService.trace("forwarded error to extension?",N,d.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)($)),this.id=C,this.source=d.extension?.displayName??d.extension?.name}}}finally{this._reportTelemetry(d,C,x.elapsed())}}_reportTelemetry(C,l,g){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new E.TelemetryTrustedValue(l),duration:g})}$executeContributedCommand(C,...l){this._logService.trace("ExtHostCommands#$executeContributedCommand",C);const g=this._commands.get(C);return g?(l=l.map(d=>this._argumentProcessors.reduce((T,z)=>z.processArgument(T,g.extension?.identifier),d)),this._executeContributedCommand(C,l,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this._logService.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(l=>(C&&(l=l.filter(g=>g[0]!=="_")),l))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[l,g]of this._commands){const{metadata:d}=g;d&&(C[l]=d)}return Promise.resolve(C)}};e.ExtHostCommands=s,e.ExtHostCommands=s=Ve([ze(0,f.IExtHostRpcService),ze(1,y.ILogService),ze(2,r.IExtHostTelemetry)],s),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class n{constructor(C,l,g){this._commands=C,this._lookupApiCommand=l,this._logService=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(C,l){if(!C)return;const g={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return g;const d=this._lookupApiCommand(C.command);if(d)g.id=d.internalId,g.arguments=d.args.map((T,z)=>T.convert(C.arguments&&C.arguments[z]));else if((0,u.isNonEmptyArray)(C.arguments)){const T=`${C.command} /${++this._cachIdPool}`;this._cache.set(T,C),l.add((0,v.toDisposable)(()=>{this._cache.delete(T),this._logService.trace("CommandsConverter#DISPOSE",T)})),g.$ident=T,g.id=this.delegatingCommandId,g.arguments=[T],this._logService.trace("CommandsConverter#CREATE",C.command,T)}return g}fromInternal(C){return typeof C.$ident=="string"?this._cache.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this._cache.get(C[0])}_executeConvertedCommand(...C){const l=this.getActualCommand(...C);return this._logService.trace("CommandsConverter#EXECUTE",C[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.CommandsConverter=n;class o{static{this.Uri=new o("uri","Uri of a text document",C=>a.URI.isUri(C),C=>C)}static{this.Position=new o("position","A position in a text document",C=>R.Position.isPosition(C),k.Position.from)}static{this.Range=new o("range","A range in a text document",C=>R.Range.isRange(C),k.Range.from)}static{this.Selection=new o("selection","A selection in a text document",C=>R.Selection.isSelection(C),k.Selection.from)}static{this.Number=new o("number","",C=>typeof C=="number",C=>C)}static{this.String=new o("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=o.Arr(o.String)}static Arr(C){return new o(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,l=>Array.isArray(l)&&l.every(g=>C.validate(g)),l=>l.map(g=>C.convert(g)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",C=>C instanceof R.CallHierarchyItem,k.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",C=>C instanceof R.TypeHierarchyItem,k.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VSCodium TestItem",C=>C instanceof t.TestItemImpl,k.TestItem.from)}constructor(C,l,g,d){this.name=C,this.description=l,this.validate=g,this.convert=d}optional(){return new o(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,l){return new o(C??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o;class S{static{this.Void=new S("no result",C=>C)}constructor(C,l){this.description=C,this.convert=l}}e.ApiCommandResult=S;class h{constructor(C,l,g,d,T){this.id=C,this.internalId=l,this.description=g,this.args=d,this.result=T}}e.ApiCommand=h}),define(Ae[224],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const a=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(P.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.isFalsyOrEmpty)(t))return;class c extends D.SymbolInformation{static to(_){const E=new c(_.name,P.SymbolKind.to(_.kind),_.containerName||"",new D.Location(i[0],P.Range.to(_.range)));return E.detail=_.detail,E.range=E.location.range,E.selectionRange=P.Range.to(_.selectionRange),E.children=_.children?_.children.map(c.to):[],E}}return t.map(c.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(P.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(P.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.Position.isPosition(i)),t=>t.map(P.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const b of i.reverse())c=new D.SelectionRange(P.Range.to(b),c);return c}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new D.CompletionList([]);const b=t.suggestions.map(_=>P.CompletionItem.to(_,c));return new D.CompletionList(b,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>p(b=>new D.CodeLens(P.Range.to(b.range),b.command&&c.fromInternal(b.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.Range.isRange(t),t=>D.Selection.isSelection(t)?P.Selection.from(t):P.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,i,c)=>p(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(b.command)}else{const _=new D.CodeAction(b.title,b.kind?new D.CodeActionKind(b.kind):void 0);return b.edit&&(_.edit=P.WorkspaceEdit.to(b.edit)),b.command&&(_.command=c.fromInternal(b.command)),_.isPreferred=b.isPreferred,_}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.ColorInformation(P.Range.to(i.range),P.Color.to(i.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof D.Color,P.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.Range,t=>P.InlineValueContext.from(t))],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>k.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,R.Schemas.http,R.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class v{static register(i){a.forEach(i.registerApiCommand,i),this._registerValidateWhenClausesCommand(i)}static _registerValidateWhenClausesCommand(i){i.registerCommand(!1,"_validateWhenClauses",u.validateWhenClauses)}}e.ExtHostApiCommands=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.isLocationLink(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Ae[225],Re([1,0,12,64,5,6,2,78,20,8,7,3,26]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(p,f,t){const i=p.getProxy(D.MainContext.MainThreadComments);class c{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,f.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const I=this._commentControllers.get(h.handle);return I?I.value:h}else if(h&&h.$mid===7){const I=this._commentControllers.get(h.commentControlHandle);if(!I)return h;const C=I.getCommentThread(h.commentThreadHandle);return C?C.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const I=this._commentControllers.get(h.thread.commentControlHandle);if(!I)return h;const C=I.getCommentThread(h.thread.commentThreadHandle);return C?h.$mid===8?C.value:{thread:C.value,text:h.text}:h}else if(h&&h.$mid===10){const I=this._commentControllers.get(h.thread.commentControlHandle);if(!I)return h;const C=I.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const l=h.commentUniqueId,g=C.getCommentByUniqueId(l);return g||h}else if(h&&h.$mid===11){const I=this._commentControllers.get(h.thread.commentControlHandle);if(!I)return h;const C=I.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const l=h.text,g=h.commentUniqueId,d=C.getCommentByUniqueId(g);return d?(typeof d.body=="string"?d.body=l:d.body=new P.MarkdownString(l),d):h}return h}})}createCommentController(h,I,C){const l=c.handlePool++,g=new _(h,l,I,C);this._commentControllers.set(g.handle,g);const d=this._commentControllersByExtension.get(h.identifier)||[];return d.push(g),this._commentControllersByExtension.set(h.identifier,d),g.value}$createCommentThreadTemplate(h,I,C){const l=this._commentControllers.get(h);l&&l.$createCommentThreadTemplate(I,C)}async $updateCommentThreadTemplate(h,I,C){const l=this._commentControllers.get(h);l&&l.$updateCommentThreadTemplate(I,C)}$deleteCommentThread(h,I){this._commentControllers.get(h)?.$deleteCommentThread(I)}$provideCommentingRanges(h,I,C){const l=this._commentControllers.get(h);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const g=t.getDocument(A.URI.revive(I));return(0,w.asPromise)(async()=>{const d=await l.commentingRangeProvider.provideCommentingRanges(g,C);let T;return Array.isArray(d)?T={ranges:d,fileComments:!1}:d?T={ranges:d.ranges||[],fileComments:d.fileComments||!1}:T=d??void 0,T}).then(d=>{let T;return d&&(T={ranges:d.ranges.map(z=>m.Range.from(z)),fileComments:d.fileComments}),T})}$toggleReaction(h,I,C,l,g){const d=this._commentControllers.get(h);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const T=d.getCommentThread(I);if(T){const z=T.getCommentByUniqueId(l.uniqueIdInThread);if(d!==void 0&&z&&d.reactionHandler)return d.reactionHandler(z,s(g))}return Promise.resolve(void 0)})}}class b{static{this._handlePool=0}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){(h===void 0!=(this._range===void 0)||!h||!this._range||!h.isEqual(this._range))&&(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(h){this._state=h,this.modifications.state=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(h,I,C,l,g,d,T,z){this._commentControllerHandle=I,this._id=C,this._uri=l,this._range=g,this._comments=d,this.extensionDescription=T,this._isTemplate=z,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),i.$createCommentThread(I,this.handle,this._id,this._uri,m.Range.from(this._range),T.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this._localDisposables.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(x){H.range=x},get comments(){return H.comments},set comments(x){H.comments=x},get collapsibleState(){return H.collapsibleState},set collapsibleState(x){H.collapsibleState=x},get canReply(){return H.canReply},set canReply(x){H.canReply=x},get contextValue(){return H.contextValue},set contextValue(x){H.contextValue=x},get label(){return H.label},set label(x){H.label=x},get state(){return H.state},set state(x){H.state=x},dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const h=C=>Object.prototype.hasOwnProperty.call(this.modifications,C),I={};h("range")&&(I.range=m.Range.from(this._range)),h("label")&&(I.label=this.label),h("contextValue")&&(I.contextValue=this.contextValue??null),h("comments")&&(I.comments=this._comments.map(C=>E(this,C,this._commentsMap,this.extensionDescription))),h("collapsibleState")&&(I.collapseState=n(this._collapseState)),h("canReply")&&(I.canReply=this.canReply),h("state")&&(I.state=o(this._state)),h("isTemplate")&&(I.isTemplate=this._isTemplate),this.modifications={},i.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,I)}getCommentByUniqueId(h){for(const I of this._commentsMap){const C=I[0],l=I[1];if(h===l)return C}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}Ve([(0,R.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class _{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,i.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(h,I,C,l){this._extension=h,this._handle=I,this._id=C,this._label=l,this._threads=new Map,i.$registerCommentController(this.handle,C,l,this._extension.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(d){g.options=d},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(d){g.commentingRangeProvider=d},get reactionHandler(){return g.reactionHandler},set reactionHandler(d){g.reactionHandler=d},createCommentThread(d,T,z){return g.createCommentThread(d,T,z).value},dispose:()=>{g.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(h,I,C){I===void 0&&(0,a.checkProposedApiEnabled)(this._extension,"fileComments");const l=new b(this.id,this.handle,void 0,h,I,C,this._extension,!1);return this._threads.set(l.handle,l),l}$createCommentThreadTemplate(h,I){const C=new b(this.id,this.handle,void 0,A.URI.revive(h),m.Range.to(I),[],this._extension,!0);return C.collapsibleState=u.CommentThreadCollapsibleState.Expanded,this._threads.set(C.handle,C),C}$updateCommentThreadTemplate(h,I){const C=this._threads.get(h);C&&(C.range=m.Range.to(I))}$deleteCommentThread(h){this._threads.get(h)?.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function E(S,h,I,C){let l=I.get(h);return l||(l=++S.commentHandle,I.set(h,l)),h.state!==void 0&&(0,a.checkProposedApiEnabled)(C,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:l,body:typeof h.body=="string"?h.body:m.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(g=>r(g)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function r(S){return{label:S.label,iconPath:S.iconPath?m.pathOrURIToURI(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted}}function s(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?A.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1}}function n(S){if(S!==void 0)switch(S){case P.CommentThreadCollapsibleState.Expanded:return u.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return u.CommentThreadCollapsibleState.Collapsed}return u.CommentThreadCollapsibleState.Collapsed}function o(S){if(S!==void 0)switch(S){case P.CommentThreadState.Unresolved:return u.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return u.CommentThreadState.Resolved}return u.CommentThreadState.Unresolved}return new c}e.createExtHostComments=v}),define(Ae[226],Re([1,0,24,3,27,17]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(P,D){this._mainThreadConsole=P.getProxy(R.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(P,D){const a=this,v=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a._handleConsoleCall(P,D,v,arguments)}})}_handleConsoleCall(P,D,a,v){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:y(v,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(P,a,v)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=Ve([ze(0,L.IExtHostRpcService),ze(1,k.IExtHostInitDataService)],A);const u=1e5;function y(m,P){const D=[];if(m.length)for(let a=0;a<m.length;a++){let v=m[a];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}D.push(v)}if(P){const a=new Error().stack;a&&D.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.safeStringify)(D);return a.length>u?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class{static{a=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(f,t){this._logService=t,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=a._handlePool++;this._provider.set(i,{provider:f,extensionDescription:t}),this._proxy.$registerDecorationProvider(i,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(i,null);return}const _=(0,y.asArray)(b);if(_.length<=a._maxEventSize){this._proxy.$onDidChange(i,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,_.length);const E=_.map(n=>({uri:n,rank:(0,m.count)(n.path,"/")})),r=(0,y.groupBy)(E,(n,o)=>n.rank-o.rank||(0,m.compare)(n.uri.path,o.uri.path)),s=[];e:for(const n of r){let o;for(const S of n){const h=(0,P.dirname)(S.uri.path);if(o!==h&&(o=h,s.push(S.uri)>=a._maxEventSize))break e}}this._proxy.$onDidChange(i,s)});return new k.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(f,t,i){if(!this._provider.has(f))return Object.create(null);const c=Object.create(null),{provider:b,extensionDescription:_}=this._provider.get(f);return await Promise.all(t.map(async E=>{try{const{uri:r,id:s}=E,n=await Promise.resolve(b.provideFileDecoration(w.URI.revive(r),i));if(!n)return;try{k.FileDecoration.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.checkProposedApiEnabled)(_,"codiconDecoration"),c[s]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${_.identifier.value}': ${o}`)}}catch(r){this._logService.error(r)}})),c}};e.ExtHostDecorations=v,e.ExtHostDecorations=v=a=Ve([ze(0,A.IExtHostRpcService),ze(1,u.ILogService)],v),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")}),define(Ae[227],Re([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{#e;#t;#i;constructor(t,i,c,b,_,E,r,s){this._name=t,this._owner=i,this._maxDiagnosticsTotal=c,this._maxDiagnosticsPerFile=b,this._modelVersionIdProvider=_,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(b,c),this.#i=new P.ResourceMap(n=>E.getComparisonKey(n)),this.#e=r,this.#t=s}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(t,i){if(!t){this.clear();return}this._checkDisposed();let c=[];if(k.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let E;t=[...t].sort(v._compareIndexedTuplesByUri);for(const r of t){const[s,n]=r;if((!E||s.toString()!==E.toString())&&(E&&this.#i.get(E).length===0&&this.#i.delete(E),E=s,c.push(s),this.#i.set(s,[])),n)this.#i.get(s)?.push(...n);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const b=[];let _=0;for(const E of c){let r=[];const s=this.#i.get(E);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const S of s)if(S.severity===n[o]&&r.push({...u.Diagnostic.from(S),modelVersionId:this._modelVersionIdProvider(E)})===this._maxDiagnosticsPerFile)break e;r.push({severity:R.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(n=>({...u.Diagnostic.from(n),modelVersionId:this._modelVersionIdProvider(E)}));if(b.push([E,r]),_+=r.length,_>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,b)}delete(t){this._checkDisposed(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this._owner,[[t,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(t,i){this._checkDisposed();for(const[c,b]of this)t.call(i,c,b,this)}*[Symbol.iterator](){this._checkDisposed();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this._checkDisposed();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this._checkDisposed(),Array.isArray(this.#i.get(t))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.DiagnosticCollection=v;let p=class{static{a=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*a._maxDiagnosticsPerFile}static _mapper(t){const i=new P.ResourceMap;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,b){this._logService=i,this._fileSystemInfoService=c,this._extHostDocumentsAndEditors=b,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,a._mapper),this._proxy=t.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{_collections:c,_proxy:b,_onDidChangeDiagnostics:_,_logService:E,_fileSystemInfoService:r,_extHostDocumentsAndEditors:s}=this,n=new class{$changeMany(h,I){b.$changeMany(h,I),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,h,I.length===0?"CLEARING":I)}$clear(h){b.$clear(h),E.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,h)}dispose(){b.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a._idPool++,o=i;else if(!c.has(i))o=i;else{this._logService.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a._idPool++;while(c.has(o))}return new class extends v{constructor(){super(i,o,a._maxDiagnosticsTotal,a._maxDiagnosticsPerFile,h=>s.getDocument(h)?.version,r.extUri,n,_),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this._getDiagnostics(t);{const i=new Map,c=[];for(const b of this._collections.values())b.forEach((_,E)=>{let r=i.get(_.toString());typeof r>"u"&&(r=c.length,i.set(_.toString(),r),c.push([_,[]])),c[r][1]=c[r][1].concat(...E)});return c}}_getDiagnostics(t){let i=[];for(const c of this._collections.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this._mirrorCollection){const i="_generated_mirror",c=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(i,c),this._mirrorCollection=c}for(const[i,c]of t)this._mirrorCollection.set(k.URI.revive(i),c.map(u.Diagnostic.to))}};e.ExtHostDiagnostics=p,e.ExtHostDiagnostics=p=a=Ve([ze(1,m.ILogService),ze(2,D.IExtHostFileSystemInfo)],p)}),define(Ae[228],Re([1,0,2,3,26]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(u){this._proxy=u.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(u,y){return y?.allowUIResources&&(0,k.checkProposedApiEnabled)(u,"showLocal"),this._proxy.$showOpenDialog(y).then(m=>m?m.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(u){return this._proxy.$showSaveDialog(u).then(y=>y?w.URI.revive(y):void 0)}}e.ExtHostDialogs=L}),define(Ae[229],Re([1,0,9,2,7,3,13,21,15]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{static{this._handlePool=0}constructor(D,a,v){this._documentsAndEditors=a,this._logService=v,this._documentContentProviders=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,a){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=m._handlePool++;this._documentContentProviders.set(v,a),this._proxy.$registerTextContentProvider(v,D);let p;return typeof a.onDidChange=="function"&&(p=a.onDidChange(f=>{if(f.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const i=this._documentsAndEditors.getDocument(f);if(!i)return;const c=(0,y.splitLines)(t);if(!i.equalLines(c))return this._proxy.$onVirtualDocumentChange(f,t)},w.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(v)&&this._proxy.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,a){const v=this._documentContentProviders.get(D);return v?Promise.resolve(v.provideTextDocumentContent(R.URI.revive(a),u.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=m}),define(Ae[230],Re([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class a{constructor(p,f){this._onDidAddDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidRemoveDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidChangeDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidSaveDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const i of t)this._onDidRemoveDocument.fire(i.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const i of t)this._onDidAddDocument.fire(i.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const f=this._documentsAndEditors.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this._documentsAndEditors.getDocument(p);if(f)return Promise.resolve(f);let t=this._documentLoader.get(p.toString());return t||(t=this._proxy.$tryOpenDocument(p).then(i=>{this._documentLoader.delete(p.toString());const c=k.URI.revive(i);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(c))},i=>(this._documentLoader.delete(p.toString()),Promise.reject(i))),this._documentLoader.set(p.toString(),t)),t}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(f=>k.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=k.URI.revive(p),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");this._onDidRemoveDocument.fire(i.document),i._acceptLanguageId(f),this._onDidAddDocument.fire(i.document)}$acceptModelSaved(p){const f=k.URI.revive(p),t=this._documentsAndEditors.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=k.URI.revive(p),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this._onDidChangeDocument.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=k.URI.revive(p),c=this._documentsAndEditors.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let b;f.isUndoing?b=P.TextDocumentChangeReason.Undo:f.isRedoing&&(b=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:c.document,contentChanges:f.changes.map(_=>({range:u.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:b}))}setWordDefinitionFor(p,f){(0,A.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=a}),define(Ae[59],Re([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,65,48]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class i{constructor(_){this.value=_,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let c=class{constructor(_,E){this._extHostRpc=_,this._logService=E,this._activeEditorId=null,this._editors=new Map,this._documents=new v.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(_){this.acceptDocumentsAndEditorsDelta(_)}acceptDocumentsAndEditorsDelta(_){const E=[],r=[],s=[];if(_.removedDocuments)for(const n of _.removedDocuments){const o=L.URI.revive(n),S=this._documents.get(o);S?.unref()&&(this._documents.delete(o),E.push(S.value))}if(_.addedDocuments)for(const n of _.addedDocuments){const o=L.URI.revive(n.uri);let S=this._documents.get(o);if(S&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);S||(S=new i(new y.ExtHostDocumentData(this._extHostRpc.getProxy(u.MainContext.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(o,S),r.push(S.value)),S.ref()}if(_.removedEditors)for(const n of _.removedEditors){const o=this._editors.get(n);this._editors.delete(n),o&&s.push(o)}if(_.addedEditors)for(const n of _.addedEditors){const o=L.URI.revive(n.documentUri);w.ok(this._documents.has(o),`document '${o}' does not exist`),w.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const S=this._documents.get(o).value,h=new P.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(u.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>S.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(I=>D.Range.to(I)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,h)}_.newActiveEditor!==void 0&&(w.ok(_.newActiveEditor===null||this._editors.has(_.newActiveEditor),`active editor '${_.newActiveEditor}' does not exist`),this._activeEditorId=_.newActiveEditor),(0,k.dispose)(E),(0,k.dispose)(s),_.removedDocuments&&this._onDidRemoveDocuments.fire(E),_.addedDocuments&&this._onDidAddDocuments.fire(r),(_.removedEditors||_.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),_.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(_){return this._documents.get(_)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),_=>_.value)}getEditor(_){return this._editors.get(_)}activeEditor(_){if(!this._activeEditorId)return;const E=this._editors.get(this._activeEditorId);return _?E:E?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=c,e.ExtHostDocumentsAndEditors=c=Ve([ze(0,m.IExtHostRpcService),ze(1,a.ILogService)],c),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,3,2,5,4,7,17,16,231]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class D{constructor(t,i,c){this._activeTabIdGetter=c,this._parentGroup=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(i)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new u.TextTabInput(k.URI.revive(this._dto.input.uri));case 2:return new u.TextDiffTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified));case 3:return new u.TextMergeTabInput(k.URI.revive(this._dto.input.base),k.URI.revive(this._dto.input.input1),k.URI.revive(this._dto.input.input2),k.URI.revive(this._dto.input.result));case 6:return new u.CustomEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new u.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new u.NotebookEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new u.NotebookDiffEditorTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new u.TerminalEditorTabInput;case 9:return new u.InteractiveWindowInput(k.URI.revive(this._dto.input.uri),k.URI.revive(this._dto.input.inputBoxUri));default:return}}}class a{constructor(t,i){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=i;for(const c of t.tabs)c.isActive&&(this._activeTabId=c.id),this._tabs.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(c=>c.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(c=>c.apiObject))}};this._apiObject=Object.freeze(i)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,c),t.tabDto.isActive&&(this._activeTabId=c.tabId),c}else if(t.kind===1){const c=this._tabs.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this._activeTabId&&(this._activeTabId=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this._tabs.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,c),c}const i=this._tabs.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this._activeTabId}}let v=class{constructor(t){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,i={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(c=>c.apiObject))},get activeTabGroup(){const c=t._activeGroupId;return(0,m.assertIsDefined)(t._extHostTabGroups.find(_=>_.groupId===c)?.apiObject)},close:async(c,b)=>{const _=Array.isArray(c)?c:[c];return _.length?p(_[0])?this._closeGroups(_,b):this._closeTabs(_,b):!0}};this._apiObject=Object.freeze(i)}return this._apiObject}$acceptEditorTabModel(t){const i=new Set(this._extHostTabGroups.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),b=(0,P.diffSets)(i,c),_=this._extHostTabGroups.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),E=[],r=[];this._extHostTabGroups=t.map(n=>{const o=new a(n,()=>this._activeGroupId);return b.added.includes(o.groupId)?E.push(o.apiObject):r.push(o.apiObject),o});const s=(0,m.assertIsDefined)(t.find(n=>n.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:E,closed:_,changed:r}))}$acceptTabGroupUpdate(t){const i=this._extHostTabGroups.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this._extHostTabGroups.find(b=>b.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}_findExtHostTabFromApi(t){for(const i of this._extHostTabGroups)for(const c of i.tabs)if(c.apiObject===t)return c}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(i=>i.apiObject===t)}async _closeTabs(t,i){const c=[];for(const b of t){const _=this._findExtHostTabFromApi(b);if(!_)throw new Error("Tab close: Invalid tab not found!");c.push(_.tabId)}return this._proxy.$closeTab(c,i)}async _closeGroups(t,i){const c=[];for(const b of t){const _=this._findExtHostTabGroupFromApi(b);if(!_)throw new Error("Group close: Invalid group not found!");c.push(_.groupId)}return this._proxy.$closeGroup(c,i)}};e.ExtHostEditorTabs=v,e.ExtHostEditorTabs=v=Ve([ze(0,y.IExtHostRpcService)],v);function p(f){return f.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class k{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(w.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,u,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const m=this._AiEmbeddingVectorProviders.get(A);if(!m)throw new Error("Embedding vector provider not found");const P=await m.provideEmbeddingVector(u,y);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,u,y){const m=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(m,y),this._proxy.$registerAiEmbeddingVectorProvider(u,m),new R.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(m),this._AiEmbeddingVectorProviders.delete(m)})}}e.ExtHostAiEmbeddingVector=k}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,50]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class a{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const t=this._schemes.indexOf(f);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),t=[];let i,c,b=14,_=14;for(const E of f){let r=i?(0,y.commonPrefixLength)(i,E):0;for(r===0?c=1:c=_;r<E.length;r++)r+1===E.length?(b=_,_=9):_+=1,t.push([c,E.toUpperCase().charCodeAt(r),_]),t.push([c,E.toLowerCase().charCodeAt(r),_]),c=_;i=E,_=b}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new u.StateMachine(t)}}provideDocumentLinks(f){this._initStateMachine();const t=[],i=u.LinkComputer.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const c of i){const b=A.DocumentLink.to(c);b.target&&t.push(b)}return t}}class v{constructor(f,t){this._extHostLanguageFeatures=t,this._linkProvider=new a,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,t,i,c={}){if(v._validateFileSystemProvider(i),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(b,i);let _=2;c.isCaseSensitive&&(_+=1024),c.isReadonly&&(_+=2048),typeof i.copy=="function"&&(_+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.checkProposedApiEnabled)(f,"fsChunks"),_+=4);let E;c.isReadonly&&(0,D.isMarkdownString)(c.isReadonly)&&((0,P.checkProposedApiEnabled)(f,"readonlyMessage"),E={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this._proxy.$registerFileSystemProvider(b,t,_,E).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const n=[];for(const o of s){const{uri:S,type:h}=o;if(S.scheme!==t)continue;let I;switch(h){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:S,type:I})}this._proxy.$onFileSystemChange(b,n)});return(0,k.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _validateFileSystemProvider(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(f){const{type:t,ctime:i,mtime:c,size:b,permissions:_}=f;return{type:t,ctime:i,mtime:c,size:b,permissions:_}}$stat(f,t){return Promise.resolve(this._getFsProvider(f).stat(w.URI.revive(t))).then(i=>v._asIStat(i))}$readdir(f,t){return Promise.resolve(this._getFsProvider(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this._getFsProvider(f).readFile(w.URI.revive(t))).then(i=>m.VSBuffer.wrap(i))}$writeFile(f,t,i,c){return Promise.resolve(this._getFsProvider(f).writeFile(w.URI.revive(t),i.buffer,c))}$delete(f,t,i){return Promise.resolve(this._getFsProvider(f).delete(w.URI.revive(t),i))}$rename(f,t,i,c){return Promise.resolve(this._getFsProvider(f).rename(w.URI.revive(t),w.URI.revive(i),c))}$copy(f,t,i,c){const b=this._getFsProvider(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(w.URI.revive(t),w.URI.revive(i),c))}$mkdir(f,t){return Promise.resolve(this._getFsProvider(f).createDirectory(w.URI.revive(t)))}$watch(f,t,i,c){const b=this._getFsProvider(f).watch(w.URI.revive(i),c);this._watches.set(t,b)}$unwatch(f,t){const i=this._watches.get(t);i&&(i.dispose(),this._watches.delete(t))}$open(f,t,i){const c=this._getFsProvider(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),i))}$close(f,t){const i=this._getFsProvider(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,c){const b=this._getFsProvider(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const _=m.VSBuffer.alloc(c);return Promise.resolve(b.read(t,i,_.buffer,0,c)).then(E=>_.slice(0,E))}$write(f,t,i,c){const b=this._getFsProvider(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,i,c.buffer,0,c.byteLength))}_getFsProvider(f){const t=this._fsProvider.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.ExtHostFileSystem=v}),define(Ae[61],Re([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let p=v=class{constructor(t,i){this._fileSystemProvider=new Map,this._writeQueue=new P.ResourceQueue,this._proxy=t.getProxy(w.MainContext.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(b){try{let _;const E=c._fileSystemProvider.get(b.scheme);return E?(await c._proxy.$ensureActivation(b.scheme),_=await E.impl.stat(b)):_=await c._proxy.$stat(b),{type:_.type,ctime:_.ctime,mtime:_.mtime,size:_.size,permissions:_.permissions===R.FilePermission.Readonly?1:void 0}}catch(_){v._handleError(_)}},async readDirectory(b){try{const _=c._fileSystemProvider.get(b.scheme);return _?(await c._proxy.$ensureActivation(b.scheme),(await _.impl.readDirectory(b)).slice()):await c._proxy.$readdir(b)}catch(_){return v._handleError(_)}},async createDirectory(b){try{const _=c._fileSystemProvider.get(b.scheme);return _&&!_.isReadonly?(await c._proxy.$ensureActivation(b.scheme),await c.mkdirp(_.impl,_.extUri,b)):await c._proxy.$mkdir(b)}catch(_){return v._handleError(_)}},async readFile(b){try{const _=c._fileSystemProvider.get(b.scheme);return _?(await c._proxy.$ensureActivation(b.scheme),(await _.impl.readFile(b)).slice()):(await c._proxy.$readFile(b)).buffer}catch(_){return v._handleError(_)}},async writeFile(b,_){try{const E=c._fileSystemProvider.get(b.scheme);return E&&!E.isReadonly?(await c._proxy.$ensureActivation(b.scheme),await c.mkdirp(E.impl,E.extUri,E.extUri.dirname(b)),await c._writeQueue.queueFor(b).queue(()=>Promise.resolve(E.impl.writeFile(b,_,{create:!0,overwrite:!0})))):await c._proxy.$writeFile(b,L.VSBuffer.wrap(_))}catch(E){return v._handleError(E)}},async delete(b,_){try{const E=c._fileSystemProvider.get(b.scheme);return E&&!E.isReadonly?(await c._proxy.$ensureActivation(b.scheme),await E.impl.delete(b,{recursive:!1,..._})):await c._proxy.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,..._})}catch(E){return v._handleError(E)}},async rename(b,_,E){try{return await c._proxy.$rename(b,_,{overwrite:!1,...E})}catch(r){return v._handleError(r)}},async copy(b,_,E){try{return await c._proxy.$copy(b,_,{overwrite:!1,...E})}catch(r){return v._handleError(r)}},isWritableFileSystem(b){const _=i.getCapabilities(b);if(typeof _=="number")return!(_&2048)}})}async mkdirp(t,i,c){const b=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&R.FileType.Directory))throw k.FileSystemError.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(_){if(R.toFileSystemProviderErrorCode(_)!==R.FileSystemProviderErrorCode.FileNotFound)throw _;b.push(i.basename(c)),c=i.dirname(c)}for(let _=b.length-1;_>=0;_--){c=i.joinPath(c,b[_]);try{await t.createDirectory(c)}catch(E){if(R.toFileSystemProviderErrorCode(E)!==R.FileSystemProviderErrorCode.FileExists)throw E}}}static _handleError(t){if(t instanceof k.FileSystemError)throw t;if(t instanceof R.FileSystemProviderError)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(t.message);default:throw new k.FileSystemError(t.message,t.name)}if(!(t instanceof Error))throw new k.FileSystemError(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(t.message);default:throw new k.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,i,c){return this._fileSystemProvider.set(t,{impl:i,extUri:c?.isCaseSensitive?D.extUri:D.extUriIgnorePathCase,isReadonly:!!c?.isReadonly}),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(t))}getFileSystemProviderExtUri(t){return this._fileSystemProvider.get(t)?.extUri??D.extUri}};e.ExtHostConsumerFileSystem=p,e.ExtHostConsumerFileSystem=p=v=Ve([ze(0,u.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],p),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7,48]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class m{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(v,p,f,t,i,c,b,_){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter;const E=this.ensureWatching(v,f,i);this._config=0,c&&(this._config+=1),b&&(this._config+=2),_&&(this._config+=4);const r=(0,R.parse)(i),s=typeof i=="string",n=t(o=>{if(!c)for(const S of o.created){const h=k.URI.revive(S);r(h.fsPath)&&(!s||p.getWorkspaceFolder(h))&&this._onDidCreate.fire(h)}if(!b)for(const S of o.changed){const h=k.URI.revive(S);r(h.fsPath)&&(!s||p.getWorkspaceFolder(h))&&this._onDidChange.fire(h)}if(!_)for(const S of o.deleted){const h=k.URI.revive(S);r(h.fsPath)&&(!s||p.getWorkspaceFolder(h))&&this._onDidDelete.fire(h)}});this._disposable=u.Disposable.from(E,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(v,p,f){const t=u.Disposable.from();if(typeof f=="string")return t;const i=v.getProxy(L.MainContext.MainThreadFileSystem);let c=!1;(f.pattern.includes(R.GLOBSTAR)||f.pattern.includes(R.GLOB_SPLIT))&&(c=!0);const b=Math.random();return i.$watch(p.identifier.value,b,f.baseUri,{recursive:c,excludes:[]}),u.Disposable.from({dispose:()=>i.$unwatch(b)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(v){this._events=v,this._created=new y.Lazy(()=>this._events.created.map(k.URI.revive)),this._changed=new y.Lazy(()=>this._events.changed.map(k.URI.revive)),this._deleted=new y.Lazy(()=>this._events.deleted.map(k.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class D{constructor(v,p,f){this._mainContext=v,this._logService=p,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new w.AsyncEmitter,this._onWillCreateFile=new w.AsyncEmitter,this._onWillDeleteFile=new w.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,p,f,t,i,c){return new m(this._mainContext,v,p,this._onFileSystemEvent.event,A.GlobPattern.from(f),t,i,c)}$onFileEvent(v){this._onFileSystemEvent.fire(new P(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(f=>({oldUri:k.URI.revive(f.source),newUri:k.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(f=>k.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(f=>k.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,p){return(f,t,i)=>{const c=function(_){f.call(t,_)};return c.extension=v,p.event(c,void 0,i)}}async $onWillRunFileOperation(v,p,f,t){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(i=>({oldUri:k.URI.revive(i.source),newUri:k.URI.revive(i.target)}))},f,t);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(i=>k.URI.revive(i.target))},f,t);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(i=>k.URI.revive(i.target))},f,t)}}async _fireWillEvent(v,p,f,t){const i=new Set,c=[];if(await v.fireAsync(p,t,async(_,E)=>{const r=Date.now(),s=await Promise.resolve(_);s instanceof u.WorkspaceEdit&&(c.push([E.extension,s]),i.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-r>f&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const b={edits:[]};for(const[,_]of c){const{edits:E}=A.WorkspaceEdit.from(_,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(E)}return{edit:b,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=D}),define(Ae[235],Re([1,0,6,2,3,8,7,31,12]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class m{static{this._pool=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=m._pool++}}class P{constructor(v){this.session=v,this.responses=[]}}class D{static{this._nextId=0}constructor(v,p,f,t){this._documents=f,this._logService=t,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=v.getProxy(k.MainContext.MainThreadInlineChat),p.registerApiCommand(new u.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new u.ApiCommandArgument("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?L.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?L.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?L.Position.from(i.position):void 0}})],u.ApiCommandResult.Void))}registerProvider(v,p,f){const t=new m(v,p);return this._inputProvider.set(t.handle,t),this._proxy.$registerInteractiveEditorProvider(t.handle,f.label,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,w.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(t.handle),this._inputProvider.delete(t.handle)})}async $prepareSession(v,p,f,t){const i=this._inputProvider.get(v);if(!i){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this._documents.getDocument(R.URI.revive(p)),b=L.Selection.to(f),_=await i.provider.prepareInteractiveEditorSession({document:c,selection:b},t);if(!_)return;if(_.wholeRange&&!_.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const E=D._nextId++;return this._inputSessions.set(E,new P(_)),{id:E,placeholder:_.placeholder,slashCommands:_.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:L.Range.from(_.wholeRange),message:_.message}}async $provideResponse(v,p,f,t){const i=this._inputProvider.get(v);if(!i)return;const c=this._inputSessions.get(p.id);if(!c)return;const b={prompt:f.prompt,selection:L.Selection.to(f.selection),wholeRange:L.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let _=!1;const E={report:async h=>{if(!f.live)throw new Error("Progress reporting is only supported for live sessions");_||t.isCancellationRequested||await this._proxy.$handleProgressChunk(f.requestId,{message:h.message,edits:h.edits?.map(L.TextEdit.from),slashCommand:h.slashCommand?.command})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(c.session,b,E,t));let s;try{s=await(0,y.raceCancellation)(r,t)}finally{_=!0}if(!s)return;const n=c.responses.push(s)-1,o={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(D._isMessageResponse(s))return{...o,id:n,type:"message",message:L.MarkdownString.from(s.contents)};const{edits:S}=s;return S instanceof A.WorkspaceEdit?{...o,id:n,type:"bulkEdit",edits:L.WorkspaceEdit.from(S)}:{...o,id:n,type:"editorEdit",edits:S.map(L.TextEdit.from)}}$handleFeedback(v,p,f,t){const i=this._inputProvider.get(v),c=this._inputSessions.get(p),b=c?.responses[f];if(i&&b){const _=L.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(c.session,b,_)}}$releaseSession(v,p){}static _isMessageResponse(v){return typeof v=="object"&&typeof v.contents=="object"}}e.ExtHostInteractiveEditor=D}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(A,u,y,m,P){this._extHostNotebooks=u,this._textDocumentsAndEditors=y,this._commands=m;const D=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",a=>!0,a=>a),new R.ApiCommandArgument("resource","Interactive resource Uri",a=>!0,a=>a),new R.ApiCommandArgument("controllerId","Notebook controller Id",a=>!0,a=>a),new R.ApiCommandArgument("title","Interactive editor title",a=>!0,a=>a)],new R.ApiCommandResult("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const v=this._extHostNotebooks.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:v.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(A,u,y,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:u,lines:[""],languageId:y,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(w.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,u){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=k}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class k{constructor(A){this._IssueUriRequestHandlers=new Map,this._proxy=A.getProxy(w.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,u){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(A);if(!y)throw new Error("Issue request handler not found");const m=await y.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(A,u){const y=A.identifier.value;return this._IssueUriRequestHandlers.set(y,u),this._proxy.$registerIssueUriRequestHandler(y),new R.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=k}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const u=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(u,A),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(u)})}}e.ExtHostLabelService=k}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,74,58,9,12,26,149]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentSymbols(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentSymbols(K,V);if(!(0,P.isFalsyOrEmpty)(G))return G[0]instanceof L.DocumentSymbol?G.map(k.DocumentSymbol.from):n._asDocumentSymbolTree(G)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((G,q)=>{let Z=G.location.range.start.compareTo(q.location.range.start);return Z===0&&(Z=q.location.range.end.compareTo(G.location.range.end)),Z});const V=[],K=[];for(const G of O){const q={name:G.name||"!!MISSING: name!!",kind:k.SymbolKind.from(G.kind),tags:G.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:k.Range.from(G.location.range),selectionRange:k.Range.from(G.location.range),children:[]};for(;;){if(K.length===0){K.push(q),V.push(q);break}const Z=K[K.length-1];if(m.Range.containsRange(Z.range,q.range)&&!m.Range.equalsRange(Z.range,q.range)){Z.children?.push(q),K.push(q);break}K.pop()}}return V}}class o{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(O,V,K){this._documents=O,this._commands=V,this._provider=K,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideCodeLenses(K,V);if(!G||V.isCancellationRequested)return;const q=this._cache.add(G),Z=new f.DisposableStore;this._disposables.set(q,Z);const ce={cacheId:q,lenses:[]};for(let Le=0;Le<G.length;Le++)ce.lenses.push({cacheId:[q,Le],range:k.Range.from(G[Le].range),command:this._commands.toInternal(G[Le].command,Z)});return ce}async resolveCodeLens(O,V){const K=O.cacheId&&this._cache.get(...O.cacheId);if(!K)return;let G;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?G=K:G=await this._provider.resolveCodeLens(K,V),G||(G=K),V.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(q)return O.command=this._commands.toInternal(G.command??o._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}function S(Ie){return Array.isArray(Ie)?Ie.map(k.DefinitionLink.from):Ie?[k.DefinitionLink.from(Ie)]:[]}class h{constructor(O,V){this._documents=O,this._provider=V}async provideDefinition(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDefinition(G,q,K);return S(Z)}}class I{constructor(O,V){this._documents=O,this._provider=V}async provideDeclaration(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDeclaration(G,q,K);return S(Z)}}class C{constructor(O,V){this._documents=O,this._provider=V}async provideImplementation(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideImplementation(G,q,K);return S(Z)}}class l{constructor(O,V){this._documents=O,this._provider=V}async provideTypeDefinition(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideTypeDefinition(G,q,K);return S(Z)}}class g{constructor(O,V){this._documents=O,this._provider=V}async provideHover(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideHover(G,q,K);if(!(!Z||(0,P.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=G.getWordRangeAtPosition(q)),Z.range||(Z.range=new L.Range(q,q)),k.Hover.from(Z)}}class d{constructor(O,V){this._documents=O,this._provider=V}async provideEvaluatableExpression(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideEvaluatableExpression(G,q,K);if(Z)return k.EvaluatableExpression.from(Z)}}class T{constructor(O,V){this._documents=O,this._provider=V}async provideInlineValues(O,V,K,G){const q=this._documents.getDocument(O),Z=await this._provider.provideInlineValues(q,k.Range.to(V),k.InlineValueContext.to(K),G);if(Array.isArray(Z))return Z.map(ce=>k.InlineValue.from(ce))}}class z{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentHighlights(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDocumentHighlights(G,q,K);if(Array.isArray(Z))return Z.map(k.DocumentHighlight.from)}}class H{constructor(O,V){this._documents=O,this._provider=V}async provideLinkedEditingRanges(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideLinkedEditingRanges(G,q,K);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,P.coalesce)(Z.ranges.map(k.Range.from)),wordPattern:Z.wordPattern}}}class x{constructor(O,V){this._documents=O,this._provider=V}async provideReferences(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ce=await this._provider.provideReferences(q,Z,K,G);if(Array.isArray(ce))return ce.map(k.location.from)}}class ${static{this._maxCodeActionsPerFile=1e3}constructor(O,V,K,G,q,Z,ce){this._documents=O,this._commands=V,this._diagnostics=K,this._provider=G,this._logService=q,this._extension=Z,this._apiDeprecation=ce,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,V,K,G){const q=this._documents.getDocument(O),Z=a.Selection.isISelection(V)?k.Selection.to(V):k.Range.to(V),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(Z.intersection(Ye.range)&&ce.push(Ye)>$._maxCodeActionsPerFile)break;const Le={diagnostics:ce,only:K.only?new L.CodeActionKind(K.only):void 0,triggerKind:k.CodeActionTriggerKind.to(K.trigger)},xe=await this._provider.provideCodeActions(q,Z,Le,G);if(!(0,P.isNonEmptyArray)(xe)||G.isCancellationRequested)return;const Ge=this._cache.add(xe),je=new f.DisposableStore;this._disposables.set(Ge,je);const Je=[];for(let Ye=0;Ye<xe.length;Ye++){const Ze=xe[Ye];Ze&&($._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,je)})):(Le.only&&(Ze.kind?Le.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ge,Ye],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,je),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(k.Diagnostic.from),edit:Ze.edit&&k.WorkspaceEdit.from(Ze.edit,void 0),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,isAI:(0,r.isProposedApiEnabled)(this._extension,"codeActionAI")?Ze.isAI:!1,disabled:Ze.disabled?.reason})))}return{cacheId:Ge,actions:Je}}async resolveCodeAction(O,V){const[K,G]=O,q=this._cache.get(K,G);if(!q||$._isCommand(q))return{};if(!this._provider.resolveCodeAction)return{};const Z=await this._provider.resolveCodeAction(q,V)??q;let ce;Z.edit&&(ce=k.WorkspaceEdit.from(Z.edit,void 0));let Le;if(Z.command){const xe=this._disposables.get(K);xe&&(Le=this._commands.toInternal(Z.command,xe))}return{edit:ce,command:Le}}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}class N{static toInternalProviderId(O,V){return O+"."+V}constructor(O,V,K,G,q){this._proxy=O,this._documents=V,this._provider=K,this._handle=G,this._extension=q}async prepareDocumentPaste(O,V,K,G){if(!this._provider.prepareDocumentPaste)return;const q=this._documents.getDocument(O),Z=V.map(xe=>k.Range.to(xe)),ce=k.DataTransfer.toDataTransfer(K,()=>{throw new _.NotImplementedError});if(await this._provider.prepareDocumentPaste(q,Z,ce,G),G.isCancellationRequested)return;const Le=Array.from(ce).filter(([,xe])=>!(xe instanceof L.InternalDataTransferItem));return k.DataTransfer.from(Le)}async providePasteEdits(O,V,K,G,q){if(!this._provider.provideDocumentPasteEdits)return;const Z=this._documents.getDocument(V),ce=K.map(Ge=>k.Range.to(Ge)),Le=k.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolvePasteFileData(this._handle,O,Ge)).buffer),xe=await this._provider.provideDocumentPasteEdits(Z,ce,Le,q);if(xe)return{label:xe.label??(0,s.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:xe.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:N.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?k.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}}}class M{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentFormattingEdits(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(G,V,K);if(Array.isArray(q))return q.map(k.TextEdit.from)}}class te{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeFormattingEdits(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Range.to(V),ce=await this._provider.provideDocumentRangeFormattingEdits(q,Z,K,G);if(Array.isArray(ce))return ce.map(k.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,V,K,G){(0,D.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this._documents.getDocument(O),Z=V.map(k.Range.to),ce=await this._provider.provideDocumentRangesFormattingEdits(q,Z,K,G);if(Array.isArray(ce))return ce.map(k.TextEdit.from)}}class Q{constructor(O,V){this._documents=O,this._provider=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,V,K,G,q){const Z=this._documents.getDocument(O),ce=k.Position.to(V),Le=await this._provider.provideOnTypeFormattingEdits(Z,ce,K,G,q);if(Array.isArray(Le))return Le.map(k.TextEdit.from)}}class Se{constructor(O,V){this._provider=O,this._logService=V,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,V){const K=await this._provider.provideWorkspaceSymbols(O,V);if(!(0,P.isNonEmptyArray)(K))return{symbols:[]};const G=this._cache.add(K),q={cacheId:G,symbols:[]};for(let Z=0;Z<K.length;Z++){const ce=K[Z];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}q.symbols.push({...k.WorkspaceSymbol.from(ce),cacheId:[G,Z]})}return q}async resolveWorkspaceSymbol(O,V){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this._cache.get(...O.cacheId);if(K){const G=await this._provider.resolveWorkspaceSymbol(K,V);return G&&(0,R.mixin)(O,k.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class _e{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,V,K){this._documents=O,this._provider=V,this._logService=K}async provideRenameEdits(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V);try{const ce=await this._provider.provideRenameEdits(q,Z,K,G);return ce?k.WorkspaceEdit.from(ce):void 0}catch(ce){const Le=_e._asMessage(ce);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,V,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const G=this._documents.getDocument(O),q=k.Position.to(V);try{const Z=await this._provider.prepareRename(G,q,K);let ce,Le;if(L.Range.isRange(Z)?(ce=Z,Le=G.getText(Z)):(0,D.isObject)(Z)&&(ce=Z.range,Le=Z.placeholder),!ce||!Le)return;if(ce.start.line>q.line||ce.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ce),text:Le}}catch(Z){const ce=_e._asMessage(Z);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class Pe{constructor(O,V){this.resultId=O,this.tokens=V}}class Y{constructor(O,V){this._documents=O,this._provider=V,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,V,K){const G=this._documents.getDocument(O),q=V!==0?this._previousResults.get(V):null;let Z=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(G,q.resultId,K):await this._provider.provideDocumentSemanticTokens(G,K);return q&&this._previousResults.delete(V),Z?(Z=Y._fixProvidedSemanticTokens(Z),this._send(Y._convertToEdits(q,Z),Z)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return Y._isSemanticTokens(O)?Y._isCorrectSemanticTokens(O)?O:new L.SemanticTokens(new Uint32Array(O.data),O.resultId):Y._isSemanticTokensEdits(O)?Y._isCorrectSemanticTokensEdits(O)?O:new L.SemanticTokensEdits(O.edits.map(V=>new L.SemanticTokensEdit(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const V of O.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,V){if(!Y._isSemanticTokens(V)||!O||!O.tokens)return V;const K=O.tokens,G=K.length,q=V.data,Z=q.length;let ce=0;const Le=Math.min(G,Z);for(;ce<Le&&K[ce]===q[ce];)ce++;if(ce===G&&ce===Z)return new L.SemanticTokensEdits([],V.resultId);let xe=0;const Ge=Le-ce;for(;xe<Ge&&K[G-xe-1]===q[Z-xe-1];)xe++;return new L.SemanticTokensEdits([{start:ce,deleteCount:G-ce-xe,data:q.subarray(ce,Z-xe)}],V.resultId)}_send(O,V){if(Y._isSemanticTokens(O)){const K=this._nextResultId++;return this._previousResults.set(K,new Pe(O.resultId,O.data)),(0,t.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(Y._isSemanticTokensEdits(O)){const K=this._nextResultId++;return Y._isSemanticTokens(V)?this._previousResults.set(K,new Pe(V.resultId,V.data)):this._previousResults.set(K,new Pe(O.resultId)),(0,t.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ae{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeSemanticTokens(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(G,k.Range.to(V),K);return q?this._send(q):null}_send(O){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Ce{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,V,K,G,q){this._documents=O,this._commands=V,this._provider=K,this._apiDeprecation=G,this._extension=q,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ce=q.getWordRangeAtPosition(Z)||new L.Range(Z,Z),Le=ce.with({end:Z}),xe=new b.StopWatch,Ge=await this._provider.provideCompletionItems(q,Z,G,k.CompletionContext.to(K));if(!Ge||G.isCancellationRequested)return;const je=Array.isArray(Ge)?new L.CompletionList(Ge):Ge,Je=Ce.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new f.DisposableStore;this._disposables.set(Je,Ye);const Ze=[],it={x:Je,b:Ze,a:{replace:k.Range.from(ce),insert:k.Range.from(Le)},c:je.isIncomplete||void 0,d:xe.elapsed()};for(let tt=0;tt<je.items.length;tt++){const Ue=je.items[tt],st=this._convertCompletionItem(Ue,[Je,tt],Le,ce);Ze.push(st)}return it}async resolveCompletionItem(O,V){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...O);if(!K)return;const G=this._convertCompletionItem(K,O),q=await this._provider.resolveCompletionItem(K,V);if(!q)return;const Z=this._convertCompletionItem(q,O);return(G.h!==Z.h||G.i!==Z.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==Z.n||G.o!==Z.o||!(0,R.equals)(G.p,Z.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:Z.d,c:Z.c,l:Z.l,h:Z.h,i:Z.i,n:Z.n,o:Z.o,p:Z.p}}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,V,K,G){const q=this._disposables.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const Z=this._commands.toInternal(O.command,q),ce={x:V,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:Z?.$ident,o:Z?.id,p:Z?.$ident?void 0:Z?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=O.textEdit.newText):typeof O.insertText=="string"?ce.h=O.insertText:O.insertText instanceof L.SnippetString&&(ce.h=O.insertText.value,ce.i|=4);let Le;return O.textEdit?Le=O.textEdit.range:O.range&&(Le=O.range),L.Range.isRange(Le)?ce.j=k.Range.from(Le):Le&&(!K?.isEqual(Le.inserting)||!G?.isEqual(Le.replacing))&&(ce.j={insert:k.Range.from(Le.inserting),replace:k.Range.from(Le.replacing)}),ce}}class le{async provideInlineCompletions(O,V,K,G){}disposeCompletions(O){}handleDidShowCompletionItem(O,V,K){}handlePartialAccept(O,V,K){}}class pe extends le{constructor(O,V,K,G){super(),this._extension=O,this._documents=V,this._provider=K,this._commands=G,this._references=new ie,this._isAdditionsProposedApiEnabled=(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ce=await this._provider.provideInlineCompletionItems(q,Z,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:k.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},G);if(!ce||G.isCancellationRequested)return;const Le=Array.isArray(ce)?ce:ce.items,xe=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[],Ge=this._isAdditionsProposedApiEnabled&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let je;return{pid:this._references.createReferenceId({dispose(){je?.dispose()},items:Le}),items:Le.map((Ye,Ze)=>{let it;Ye.command&&(je||(je=new f.DisposableStore),it=this._commands.toInternal(Ye.command,je));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?k.Range.from(Ye.range):void 0,command:it,idx:Ze,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:xe.map(Ye=>(je||(je=new f.DisposableStore),this._commands.toInternal(Ye,je))),suppressSuggestions:!1,enableForwardStability:Ge}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V,K){const G=this._references.get(O)?.items[V];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G,K)}handlePartialAccept(O,V,K){const G=this._references.get(O)?.items[V];G&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(G,K)}}class ie{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const V=this._idPool++;return this._references.set(V,O),V}disposeReferenceId(O){const V=this._references.get(O);return this._references.delete(O),V}get(O){return this._references.get(O)}}class U{constructor(O,V){this._documents=O,this._provider=V,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ce=this.reviveContext(K),Le=await this._provider.provideSignatureHelp(q,Z,G,ce);if(Le){const xe=this._cache.add([Le]);return{...k.SignatureHelp.from(Le),id:xe}}}reviveContext(O){let V;if(O.activeSignatureHelp){const K=k.SignatureHelp.to(O.activeSignatureHelp),G=this._cache.get(O.activeSignatureHelp.id,0);G?(V=G,V.activeSignature=K.activeSignature,V.activeParameter=K.activeParameter):V=K}return{...O,activeSignatureHelp:V}}releaseSignatureHelp(O){this._cache.delete(O)}}class W{constructor(O,V,K,G,q){this._documents=O,this._commands=V,this._provider=K,this._logService=G,this._extension=q,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,V,K){const G=this._documents.getDocument(O),q=k.Range.to(V),Z=await this._provider.provideInlayHints(G,q,K);if(!Array.isArray(Z)||Z.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${V}`);return}if(K.isCancellationRequested)return;const ce=this._cache.add(Z);this._disposables.set(ce,new f.DisposableStore);const Le={hints:[],cacheId:ce};for(let xe=0;xe<Z.length;xe++)this._isValidInlayHint(Z[xe],q)&&Le.hints.push(this._convertInlayHint(Z[xe],[ce,xe]));return this._logService.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this._extension.identifier.value}' for ${V}`),Le}async resolveInlayHint(O,V){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...O);if(!K)return;const G=await this._provider.resolveInlayHint(K,V);if(G&&this._isValidInlayHint(G))return this._convertInlayHint(G,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,V){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(V&&!V.contains(O.position))}_convertInlayHint(O,V){const K=this._disposables.get(V[0]);if(!K)throw Error("DisposableStore is missing...");const G={label:"",cacheId:V,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?G.label=O.label:G.label=O.label.map(q=>{const Z={label:q.value};return Z.tooltip=k.MarkdownString.fromStrict(q.tooltip),L.Location.isLocation(q.location)&&(Z.location=k.location.from(q.location)),q.command&&(Z.command=this._commands.toInternal(q.command,K)),Z}),G}}class ue{constructor(O,V){this._documents=O,this._provider=V,this._cache=new c.Cache("DocumentLink")}async provideLinks(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentLinks(K,V);if(!(!Array.isArray(G)||G.length===0)&&!V.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:G.filter(ue._validateLink).map(k.DocumentLink.from)};{const q=this._cache.add(G),Z={links:[],cacheId:q};for(let ce=0;ce<G.length;ce++){if(!ue._validateLink(G[ce]))continue;const Le=k.DocumentLink.from(G[ce]);Le.cacheId=[q,ce],Z.links.push(Le)}return Z}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,V){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...O);if(!K)return;const G=await this._provider.resolveDocumentLink(K,V);if(!(!G||!ue._validateLink(G)))return k.DocumentLink.from(G)}releaseLinks(O){this._cache.delete(O)}}class we{constructor(O,V){this._documents=O,this._provider=V}async provideColors(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentColors(K,V);return Array.isArray(G)?G.map(Z=>({color:k.Color.from(Z.color),range:k.Range.from(Z.range)})):[]}async provideColorPresentations(O,V,K){const G=this._documents.getDocument(O),q=k.Range.to(V.range),Z=k.Color.to(V.color),ce=await this._provider.provideColorPresentations(Z,{document:G,range:q},K);if(Array.isArray(ce))return ce.map(k.ColorPresentation.from)}}class Ee{constructor(O,V){this._documents=O,this._provider=V}async provideFoldingRanges(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(G,V,K);if(Array.isArray(q))return q.map(k.FoldingRange.from)}}class ge{constructor(O,V,K){this._documents=O,this._provider=V,this._logService=K}async provideSelectionRanges(O,V,K){const G=this._documents.getDocument(O),q=V.map(k.Position.to),Z=await this._provider.provideSelectionRanges(G,q,K);if(!(0,P.isNonEmptyArray)(Z))return[];if(Z.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Le=0;Le<q.length;Le++){const xe=[];ce.push(xe);let Ge=q[Le],je=Z[Le];for(;;){if(!je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(k.SelectionRange.from(je)),!je.parent)break;Ge=je.range,je=je.parent}}return ce}}class ye{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.prepareCallHierarchy(G,q,K);if(!Z)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(Z)?Z.map(Le=>this._cacheAndConvertItem(ce,Le)):[this._cacheAndConvertItem(ce,Z)]}async provideCallsTo(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(G,K);if(q)return q.map(Z=>({from:this._cacheAndConvertItem(O,Z.from),fromRanges:Z.fromRanges.map(ce=>k.Range.from(ce))}))}async provideCallsFrom(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(G,K);if(q)return q.map(Z=>({to:this._cacheAndConvertItem(O,Z.to),fromRanges:Z.fromRanges.map(ce=>k.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const K=this._cache.get(O),G=k.CallHierarchyItem.from(V,O,K.size.toString(36));return K.set(G._itemId,V),G}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class re{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.prepareTypeHierarchy(G,q,K);if(!Z)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(Z)?Z.map(Le=>this._cacheAndConvertItem(ce,Le)):[this._cacheAndConvertItem(ce,Z)]}async provideSupertypes(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(G,K);if(q)return q.map(Z=>this._cacheAndConvertItem(O,Z))}async provideSubtypes(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(G,K);if(q)return q.map(Z=>this._cacheAndConvertItem(O,Z))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const K=this._cache.get(O),G=k.TypeHierarchyItem.from(V,O,K.size.toString(36));return K.set(G._itemId,V),G}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class de{static toInternalProviderId(O,V){return O+"."+V}constructor(O,V,K,G,q){this._proxy=O,this._documents=V,this._provider=K,this._handle=G,this._extension=q}async provideDocumentOnDropEdits(O,V,K,G,q){const Z=this._documents.getDocument(V),ce=k.Position.to(K),Le=k.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Ge)).buffer),xe=await this._provider.provideDocumentDropEdits(Z,ce,Le,q);if(xe)return{label:xe.label??(0,s.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:xe.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:de.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?k.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}}}class se{constructor(O,V){this._documents=O,this._provider=V}async provideMappedEdits(O,V,K,G){const q=w.URI.revive(O),Z=this._documents.getDocument(q),ce=K.documents.map(Ge=>Ge.map(je=>({uri:w.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Je=>k.Range.to(Je))}))),Le={documents:ce,selections:ce[0]?.[0]?.ranges??[]},xe=await this._provider.provideMappedEdits(Z,V,Le,G);return xe?k.WorkspaceEdit.from(xe):null}}class oe{constructor(O,V){this.adapter=O,this.extension=V}}class he{static{this._handlePool=0}constructor(O,V,K,G,q,Z,ce,Le){this._uriTransformer=V,this._documents=K,this._commands=G,this._diagnostics=q,this._logService=Z,this._apiDeprecation=ce,this._extensionTelemetry=Le,this._adapter=new Map,this._proxy=O.getProxy(u.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O,V){return k.DocumentSelector.from(O,this._uriTransformer,V)}_createDisposable(O){return new L.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return he._handlePool++}async _withAdapter(O,V,K,G,q,Z=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof V))return G;const Le=Date.now();Z||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const xe=K(ce.adapter,ce.extension);return Promise.resolve(xe).catch(Ge=>{(0,_.isCancellationError)(Ge)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(Ge),this._extensionTelemetry.onExtensionError(ce.extension.identifier,Ge))}).finally(()=>{Z||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,E.raceCancellationError)(xe,q):xe}_addNewAdapter(O,V){const K=this._nextHandle();return this._adapter.set(K,new oe(O,V)),K}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,V,K,G){const q=this._addNewAdapter(new n(this._documents,K),O),Z=G&&G.label||he._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(V,O),Z),this._createDisposable(q)}$provideDocumentSymbols(O,V,K){return this._withAdapter(O,n,G=>G.provideDocumentSymbols(w.URI.revive(V),K),void 0,K)}registerCodeLensProvider(O,V,K){const G=this._nextHandle(),q=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(G,new oe(new o(this._documents,this._commands.converter,K),O)),this._proxy.$registerCodeLensSupport(G,this._transformDocumentSelector(V,O),q);let Z=this._createDisposable(G);if(q!==void 0){const ce=K.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(q));Z=L.Disposable.from(Z,ce)}return Z}$provideCodeLenses(O,V,K){return this._withAdapter(O,o,G=>G.provideCodeLenses(w.URI.revive(V),K),void 0,K)}$resolveCodeLens(O,V,K){return this._withAdapter(O,o,G=>G.resolveCodeLens(V,K),void 0,void 0)}$releaseCodeLenses(O,V){this._withAdapter(O,o,K=>Promise.resolve(K.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(O,V,K){const G=this._addNewAdapter(new h(this._documents,K),O);return this._proxy.$registerDefinitionSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDefinition(O,V,K,G){return this._withAdapter(O,h,q=>q.provideDefinition(w.URI.revive(V),K,G),[],G)}registerDeclarationProvider(O,V,K){const G=this._addNewAdapter(new I(this._documents,K),O);return this._proxy.$registerDeclarationSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDeclaration(O,V,K,G){return this._withAdapter(O,I,q=>q.provideDeclaration(w.URI.revive(V),K,G),[],G)}registerImplementationProvider(O,V,K){const G=this._addNewAdapter(new C(this._documents,K),O);return this._proxy.$registerImplementationSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideImplementation(O,V,K,G){return this._withAdapter(O,C,q=>q.provideImplementation(w.URI.revive(V),K,G),[],G)}registerTypeDefinitionProvider(O,V,K){const G=this._addNewAdapter(new l(this._documents,K),O);return this._proxy.$registerTypeDefinitionSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideTypeDefinition(O,V,K,G){return this._withAdapter(O,l,q=>q.provideTypeDefinition(w.URI.revive(V),K,G),[],G)}registerHoverProvider(O,V,K,G){const q=this._addNewAdapter(new g(this._documents,K),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(V,O)),this._createDisposable(q)}$provideHover(O,V,K,G){return this._withAdapter(O,g,q=>q.provideHover(w.URI.revive(V),K,G),void 0,G)}registerEvaluatableExpressionProvider(O,V,K,G){const q=this._addNewAdapter(new d(this._documents,K),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(V,O)),this._createDisposable(q)}$provideEvaluatableExpression(O,V,K,G){return this._withAdapter(O,d,q=>q.provideEvaluatableExpression(w.URI.revive(V),K,G),void 0,G)}registerInlineValuesProvider(O,V,K,G){const q=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new T(this._documents,K),O);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(V,O),q);let ce=this._createDisposable(Z);if(q!==void 0){const Le=K.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(q));ce=L.Disposable.from(ce,Le)}return ce}$provideInlineValues(O,V,K,G,q){return this._withAdapter(O,T,Z=>Z.provideInlineValues(w.URI.revive(V),K,G,q),void 0,q)}registerDocumentHighlightProvider(O,V,K){const G=this._addNewAdapter(new z(this._documents,K),O);return this._proxy.$registerDocumentHighlightProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDocumentHighlights(O,V,K,G){return this._withAdapter(O,z,q=>q.provideDocumentHighlights(w.URI.revive(V),K,G),void 0,G)}registerLinkedEditingRangeProvider(O,V,K){const G=this._addNewAdapter(new H(this._documents,K),O);return this._proxy.$registerLinkedEditingRangeProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideLinkedEditingRanges(O,V,K,G){return this._withAdapter(O,H,async q=>{const Z=await q.provideLinkedEditingRanges(w.URI.revive(V),K,G);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?he._serializeRegExp(Z.wordPattern):void 0}},void 0,G)}registerReferenceProvider(O,V,K){const G=this._addNewAdapter(new x(this._documents,K),O);return this._proxy.$registerReferenceSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideReferences(O,V,K,G,q){return this._withAdapter(O,x,Z=>Z.provideReferences(w.URI.revive(V),K,G,q),void 0,q)}registerCodeActionProvider(O,V,K,G){const q=new f.DisposableStore,Z=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,K,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(V,O),{providedKinds:G?.providedCodeActionKinds?.map(ce=>ce.value),documentation:G?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,q)}))},he._extLabel(O),!!K.resolveCodeAction),q.add(this._createDisposable(Z)),q}$provideCodeActions(O,V,K,G,q){return this._withAdapter(O,$,Z=>Z.provideCodeActions(w.URI.revive(V),K,G,q),void 0,q)}$resolveCodeAction(O,V,K){return this._withAdapter(O,$,G=>G.resolveCodeAction(V,K),{},void 0)}$releaseCodeActions(O,V){this._withAdapter(O,$,K=>Promise.resolve(K.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(O,V,K){const G=this._addNewAdapter(new M(this._documents,K),O);return this._proxy.$registerDocumentFormattingSupport(G,this._transformDocumentSelector(V,O),O.identifier,O.displayName||O.name),this._createDisposable(G)}$provideDocumentFormattingEdits(O,V,K,G){return this._withAdapter(O,M,q=>q.provideDocumentFormattingEdits(w.URI.revive(V),K,G),void 0,G)}registerDocumentRangeFormattingEditProvider(O,V,K){const G=typeof K.provideDocumentRangesFormattingEdits=="function",q=this._addNewAdapter(new te(this._documents,K),O);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(V,O),O.identifier,O.displayName||O.name,G),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(O,V,K,G,q){return this._withAdapter(O,te,Z=>Z.provideDocumentRangeFormattingEdits(w.URI.revive(V),K,G,q),void 0,q)}$provideDocumentRangesFormattingEdits(O,V,K,G,q){return this._withAdapter(O,te,Z=>Z.provideDocumentRangesFormattingEdits(w.URI.revive(V),K,G,q),void 0,q)}registerOnTypeFormattingEditProvider(O,V,K,G){const q=this._addNewAdapter(new Q(this._documents,K),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(V,O),G,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,V,K,G,q,Z){return this._withAdapter(O,Q,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(V),K,G,q,Z),void 0,Z)}registerWorkspaceSymbolProvider(O,V){const K=this._addNewAdapter(new Se(V,this._logService),O);return this._proxy.$registerNavigateTypeSupport(K,typeof V.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(O,V,K){return this._withAdapter(O,Se,G=>G.provideWorkspaceSymbols(V,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,V,K){return this._withAdapter(O,Se,G=>G.resolveWorkspaceSymbol(V,K),void 0,void 0)}$releaseWorkspaceSymbols(O,V){this._withAdapter(O,Se,K=>K.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(O,V,K){const G=this._addNewAdapter(new _e(this._documents,K,this._logService),O);return this._proxy.$registerRenameSupport(G,this._transformDocumentSelector(V,O),_e.supportsResolving(K)),this._createDisposable(G)}$provideRenameEdits(O,V,K,G,q){return this._withAdapter(O,_e,Z=>Z.provideRenameEdits(w.URI.revive(V),K,G,q),void 0,q)}$resolveRenameLocation(O,V,K,G){return this._withAdapter(O,_e,q=>q.resolveRenameLocation(w.URI.revive(V),K,G),void 0,G)}registerDocumentSemanticTokensProvider(O,V,K,G){const q=this._addNewAdapter(new Y(this._documents,K),O),Z=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(V,O),G,Z);let ce=this._createDisposable(q);if(Z){const Le=K.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(Z));ce=L.Disposable.from(ce,Le)}return ce}$provideDocumentSemanticTokens(O,V,K,G){return this._withAdapter(O,Y,q=>q.provideDocumentSemanticTokens(w.URI.revive(V),K,G),null,G)}$releaseDocumentSemanticTokens(O,V){this._withAdapter(O,Y,K=>K.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,V,K,G){const q=this._addNewAdapter(new ae(this._documents,K),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(V,O),G),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,V,K,G){return this._withAdapter(O,ae,q=>q.provideDocumentRangeSemanticTokens(w.URI.revive(V),K,G),null,G)}registerCompletionItemProvider(O,V,K,G){const q=this._addNewAdapter(new Ce(this._documents,this._commands.converter,K,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(q,this._transformDocumentSelector(V,O),G,Ce.supportsResolving(K),O.identifier),this._createDisposable(q)}$provideCompletionItems(O,V,K,G,q){return this._withAdapter(O,Ce,Z=>Z.provideCompletionItems(w.URI.revive(V),K,G,q),void 0,q)}$resolveCompletionItem(O,V,K){return this._withAdapter(O,Ce,G=>G.resolveCompletionItem(V,K),void 0,K)}$releaseCompletionItems(O,V){this._withAdapter(O,Ce,K=>K.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(O,V,K,G){const q=new pe(O,this._documents,K,this._commands.converter),Z=this._addNewAdapter(q,O);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(V,O),q.supportsHandleEvents,p.ExtensionIdentifier.toKey(O.identifier.value),G?.yieldTo?.map(ce=>p.ExtensionIdentifier.toKey(ce))||[]),this._createDisposable(Z)}$provideInlineCompletions(O,V,K,G,q){return this._withAdapter(O,le,Z=>Z.provideInlineCompletions(w.URI.revive(V),K,G,q),void 0,q)}$handleInlineCompletionDidShow(O,V,K,G){this._withAdapter(O,le,async q=>{q.handleDidShowCompletionItem(V,K,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,V,K,G){this._withAdapter(O,le,async q=>{q.handlePartialAccept(V,K,G)},void 0,void 0)}$freeInlineCompletionsList(O,V){this._withAdapter(O,le,async K=>{K.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(O,V,K,G){const q=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,Z=this._addNewAdapter(new U(this._documents,K),O);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(V,O),q),this._createDisposable(Z)}$provideSignatureHelp(O,V,K,G,q){return this._withAdapter(O,U,Z=>Z.provideSignatureHelp(w.URI.revive(V),K,G,q),void 0,q)}$releaseSignatureHelp(O,V){this._withAdapter(O,U,K=>K.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(O,V,K){const G=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new W(this._documents,this._commands.converter,K,this._logService,O),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(V,O),typeof K.resolveInlayHint=="function",G,he._extLabel(O));let Z=this._createDisposable(q);if(G!==void 0){const ce=K.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(G));Z=L.Disposable.from(Z,ce)}return Z}$provideInlayHints(O,V,K,G){return this._withAdapter(O,W,q=>q.provideInlayHints(w.URI.revive(V),K,G),void 0,G)}$resolveInlayHint(O,V,K){return this._withAdapter(O,W,G=>G.resolveInlayHint(V,K),void 0,K)}$releaseInlayHints(O,V){this._withAdapter(O,W,K=>K.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(O,V,K){const G=this._addNewAdapter(new ue(this._documents,K),O);return this._proxy.$registerDocumentLinkProvider(G,this._transformDocumentSelector(V,O),typeof K.resolveDocumentLink=="function"),this._createDisposable(G)}$provideDocumentLinks(O,V,K){return this._withAdapter(O,ue,G=>G.provideLinks(w.URI.revive(V),K),void 0,K,V.scheme==="output")}$resolveDocumentLink(O,V,K){return this._withAdapter(O,ue,G=>G.resolveLink(V,K),void 0,void 0,!0)}$releaseDocumentLinks(O,V){this._withAdapter(O,ue,K=>K.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(O,V,K){const G=this._addNewAdapter(new we(this._documents,K),O);return this._proxy.$registerDocumentColorProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDocumentColors(O,V,K){return this._withAdapter(O,we,G=>G.provideColors(w.URI.revive(V),K),[],K)}$provideColorPresentations(O,V,K,G){return this._withAdapter(O,we,q=>q.provideColorPresentations(w.URI.revive(V),K,G),void 0,G)}registerFoldingRangeProvider(O,V,K){const G=this._nextHandle(),q=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(G,new oe(new Ee(this._documents,K),O)),this._proxy.$registerFoldingRangeProvider(G,this._transformDocumentSelector(V,O),O.identifier,q);let Z=this._createDisposable(G);if(q!==void 0){const ce=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));Z=L.Disposable.from(Z,ce)}return Z}$provideFoldingRanges(O,V,K,G){return this._withAdapter(O,Ee,q=>q.provideFoldingRanges(w.URI.revive(V),K,G),void 0,G)}registerSelectionRangeProvider(O,V,K){const G=this._addNewAdapter(new ge(this._documents,K,this._logService),O);return this._proxy.$registerSelectionRangeProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideSelectionRanges(O,V,K,G){return this._withAdapter(O,ge,q=>q.provideSelectionRanges(w.URI.revive(V),K,G),[],G)}registerCallHierarchyProvider(O,V,K){const G=this._addNewAdapter(new ye(this._documents,K),O);return this._proxy.$registerCallHierarchyProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$prepareCallHierarchy(O,V,K,G){return this._withAdapter(O,ye,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),K,G)),void 0,G)}$provideCallHierarchyIncomingCalls(O,V,K,G){return this._withAdapter(O,ye,q=>q.provideCallsTo(V,K,G),void 0,G)}$provideCallHierarchyOutgoingCalls(O,V,K,G){return this._withAdapter(O,ye,q=>q.provideCallsFrom(V,K,G),void 0,G)}$releaseCallHierarchy(O,V){this._withAdapter(O,ye,K=>Promise.resolve(K.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(O,V,K){const G=this._addNewAdapter(new re(this._documents,K),O);return this._proxy.$registerTypeHierarchyProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$prepareTypeHierarchy(O,V,K,G){return this._withAdapter(O,re,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),K,G)),void 0,G)}$provideTypeHierarchySupertypes(O,V,K,G){return this._withAdapter(O,re,q=>q.provideSupertypes(V,K,G),void 0,G)}$provideTypeHierarchySubtypes(O,V,K,G){return this._withAdapter(O,re,q=>q.provideSubtypes(V,K,G),void 0,G)}$releaseTypeHierarchy(O,V){this._withAdapter(O,re,K=>Promise.resolve(K.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(O,V,K,G){const q=this._nextHandle();this._adapter.set(q,new oe(new de(this._proxy,this._documents,K,q,O),O));const Z=(0,r.isProposedApiEnabled)(O,"dropMetadata")&&G?de.toInternalProviderId(O.identifier.value,G.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(V,O),Z,(0,r.isProposedApiEnabled)(O,"dropMetadata")?G:void 0),this._createDisposable(q)}$provideDocumentOnDropEdits(O,V,K,G,q,Z){return this._withAdapter(O,de,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,w.URI.revive(K),G,q,Z)),void 0,void 0)}registerMappedEditsProvider(O,V,K){const G=this._addNewAdapter(new se(this._documents,K),O);return this._proxy.$registerMappedEditsProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideMappedEdits(O,V,K,G,q){return this._withAdapter(O,se,Z=>Promise.resolve(Z.provideMappedEdits(V,K,G,q)),null,q)}registerDocumentPasteEditProvider(O,V,K,G){const q=this._nextHandle();this._adapter.set(q,new oe(new N(this._proxy,this._documents,K,q,O),O));const Z=N.toInternalProviderId(O.identifier.value,G.id);return this._proxy.$registerPasteEditProvider(q,this._transformDocumentSelector(V,O),Z,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this._createDisposable(q)}$prepareDocumentPaste(O,V,K,G,q){return this._withAdapter(O,N,Z=>Z.prepareDocumentPaste(w.URI.revive(V),K,G,q),void 0,q)}$providePasteEdits(O,V,K,G,q,Z){return this._withAdapter(O,N,ce=>ce.providePasteEdits(V,w.URI.revive(K),G,q,Z),void 0,Z)}static _serializeRegExp(O){return{pattern:O.source,flags:O.flags}}static _serializeIndentationRule(O){return{decreaseIndentPattern:he._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:he._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?he._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?he._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:he._serializeRegExp(O.beforeText),afterText:O.afterText?he._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?he._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(he._serializeOnEnterRule)}static _serializeAutoClosingPair(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(V=>L.SyntaxTokenType.toString(V)):void 0}}static _serializeAutoClosingPairs(O){return O.map(he._serializeAutoClosingPair)}setLanguageConfiguration(O,V,K){const{wordPattern:G}=K;if(G&&(0,y.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this._documents.setWordDefinitionFor(V,G):this._documents.setWordDefinitionFor(V,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),Z={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?he._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?he._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?he._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?he._serializeAutoClosingPairs(K.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(q,V,Z),this._createDisposable(q)}$setWordDefinitions(O){for(const V of O)this._documents.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.ExtHostLanguageFeatures=he}),define(Ae[240],Re([1,0,3,8,7,29,12,6]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(P,D,a,v){this._documents=D,this._commands=a,this._uriTransformer=v,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(w.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const a=this._documents.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,D){const a=P.version,v=R.Position.from(D),p=await this._proxy.$tokensAtPosition(P.uri,v),f={type:k.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new k.Range(D.line,D.character,D.line,D.character)};if(!p)return f;const t={range:R.Range.to(p.range),type:R.TokenType.to(p.type)};return!t.range.contains(D)||a!==P.version?f:t}createLanguageStatusItem(P,D,a){const v=this._handlePool++,p=this._proxy,f=this._ids,t=`${P.identifier.value}/${D}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);f.add(t);const i={selector:a,id:D,name:P.displayName??P.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const b=new u.DisposableStore,_=()=>{if(c?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(v,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===k.LanguageStatusSeverity.Error?L.default.Error:i.severity===k.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this._commands.toInternal(i.command,b),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},E={dispose(){b.dispose(),c?.dispose(),p.$removeLanguageStatus(v),f.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,_()},get selector(){return i.selector},set selector(r){i.selector=r,_()},get text(){return i.text},set text(r){i.text=r,_()},get detail(){return i.detail},set detail(r){i.detail=r,_()},get severity(){return i.severity},set severity(r){i.severity=r,_()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,_()},get command(){return i.command},set command(r){i.command=r,_()},get busy(){return i.busy},set busy(r){i.busy=r,_()}};return _(),E}}e.ExtHostLanguages=y}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(a,v,p){this.logService=p,this.bundleCache=new Map,this._proxy=v.getProxy(u.MainContext.MainThreadLocalization),this.currentLanguage=a.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===w.LANGUAGE_DEFAULT}getMessage(a,v){const{message:p,args:f,comment:t}=v;if(this.isDefaultLanguage)return(0,R.format2)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.bundleCache.get(a)?.contents[i];return c||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,R.format2)(c??p,f??{})}getBundle(a){return this.bundleCache.get(a)?.contents}getBundleUri(a){return this.bundleCache.get(a)?.uri}async initializeLocalizedMessages(a){if(this.isDefaultLanguage||!a.l10n&&!a.isBuiltin||this.bundleCache.has(a.identifier.value))return;let v;const p=await this.getBundleLocation(a);if(!p){this.logService.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this._proxy.$fetchBundleContents(p),t=JSON.parse(f);v=a.isBuiltin?t.contents?.bundle:t}catch(f){this.logService.error(`Failed to load translations for ${a.identifier.value} from ${p}: ${f.message}`);return}v&&this.bundleCache.set(a.identifier.value,{contents:v,uri:p})}async getBundleLocation(a){if(a.isBuiltin){const v=await this._proxy.$fetchBuiltInBundleUri(a.identifier.value,this.currentLanguage);return k.URI.revive(v)}return a.l10n?k.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=P,e.ExtHostLocalizationService=P=Ve([ze(0,y.IExtHostInitDataService),ze(1,m.IExtHostRpcService),ze(2,A.ILogService)],P),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,67]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends w.AbstractLoggerService{constructor(D,a){super(a.logLevel,a.logsLocation,a.loggers.map(v=>(0,u.revive)(v))),this._proxy=D.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(D,a){a?this.setLogLevel(A.URI.revive(a),D):this.setLogLevel(D)}setVisibility(D,a){super.setVisibility(D,a),this._proxy.$setVisibility(D,a)}doCreateLogger(D,a,v){return new m(this._proxy,D,a,v)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=Ve([ze(0,L.IExtHostRpcService),ze(1,k.IExtHostInitDataService)],y);class m extends w.AbstractMessageLogger{constructor(D,a,v,p){super(p?.logLevel==="always"),this.proxy=D,this.file=a,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.proxy.$createLogger(a,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(D,a){const v=[[D,a]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(D){this.proxy.$log(this.file,D)}flush(){this.proxy.$flush(this.file)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,R.createDecorator)("IExtHostManagedSockets");let u=class{constructor(D){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=D.getProxy(w.MainContext.MainThreadManagedSockets)}setFactory(D,a){for(const v of this._managedRemoteSockets.values())v.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(D,a),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(D){if(!this._factory||this._factory.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const a=++this._remoteSocketIdCounter,v=await this._factory.makeConnection(),p=new k.DisposableStore;return this._managedRemoteSockets.set(a,new m(a,v,p)),p.add((0,k.toDisposable)(()=>this._managedRemoteSockets.delete(a))),p.add(v.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(a),p.dispose()})),p.add(v.onDidClose(f=>{this._proxy.$onDidManagedSocketClose(a,f?.stack??f?.message),p.dispose()})),p.add(v.onDidReceiveMessage(f=>this._proxy.$onDidManagedSocketHaveData(a,A.VSBuffer.wrap(f)))),a}$remoteSocketWrite(D,a){this._managedRemoteSockets.get(D)?.actual.send(a.buffer)}$remoteSocketEnd(D){const a=this._managedRemoteSockets.get(D);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(D){await this._managedRemoteSockets.get(D)?.actual.drain?.()}};e.ExtHostManagedSockets=u,e.ExtHostManagedSockets=u=Ve([ze(0,L.IExtHostRpcService)],u);class y{constructor(D,a){this.socketFactoryId=D,this.makeConnection=a}}class m extends k.Disposable{constructor(D,a,v){super(),this.socketId=D,this.actual=a,this._register(v)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(u){return u&&u.title}let A=class{constructor(y,m){this._logService=m,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,m,P,D,a){const v={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof D=="string"||L(D)?p=[D,...a]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,p=a),v.useCustom&&(0,k.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:b}=i;f.push({title:c,isCloseAffordance:!!b,handle:t})}else this._logService.warn("Invalid message item:",i)}return this._proxy.$showMessage(m,P,v,f).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=Ve([ze(1,R.ILogService)],A)}),define(Ae[243],Re([1,0,151,25,5,6,28,15,16,2,38,74,3,31,8,7,46,204,103,9,24,13]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class r{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.apiEditor)}constructor(n,o,S,h,I){this._textDocumentsAndEditors=S,this._textDocuments=h,this._extHostFileSystem=I,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new k.Emitter({onListenerError:b.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter({onListenerError:b.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter({onListenerError:b.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter({onListenerError:b.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=n.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=n.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=n.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const l=C.notebookEditor?.notebookUri,g=C.cell.handle,T=this._documents.get(l)?.getCell(g);if(T)return T.apiCell}if(C&&C.$mid===14){const l=C.uri,g=this._documents.get(l);if(g)return g.apiNotebook}return C}}),r._registerApiCommands(o)}getEditorById(n){const o=this._editors.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(n){for(const[o,S]of this._editors)if(S.apiEditor===n)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(n,o){const S=this._documents.get(n);if(!S&&!o)throw new Error(`NO notebook document for '${n}'`);return S}static _convertNotebookRegistrationData(n,o){if(!o)return;const S=o.filenamePattern.map(h=>p.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(o.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:S,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,S){const h=r._notebookStatusBarItemProviderHandlePool++,I=typeof S.onDidChangeCellStatusBarItems=="function"?r._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,I,o);let C;return I!==void 0&&(C=S.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(I))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,I),C?.dispose()})}async createNotebookDocument(n){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:n.viewType,content:n.content&&p.NotebookData.from(n.content)});return m.URI.revive(o)}async openNotebookDocument(n){const o=this._documents.get(n);if(o)return o.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(n),h=this._documents.get(m.URI.revive(S));return(0,y.assertIsDefined)(h?.apiNotebook)}async showNotebookDocument(n,o){m.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let S;typeof o=="object"?S={position:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(p.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:S={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(n.uri,n.notebookType,S),I=h&&this._editors.get(h)?.apiEditor;if(I)return I;throw h?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,S,h){const I=this._notebookStatusBarItemProviders.get(n),C=m.URI.revive(o),l=this._documents.get(C);if(!l||!I)return;const g=l.getCellFromIndex(S);if(!g)return;const d=await I.provideCellStatusBarItems(g.apiCell,h);if(!d)return;const T=new L.DisposableStore,z=this._statusBarCache.add([T]),x=(Array.isArray(d)?d:[d]).map($=>p.NotebookStatusBarItem.from($,this._commandsConverter,T));return{cacheId:z,items:x}}$releaseNotebookCellStatusBarItems(n){this._statusBarCache.delete(n)}registerNotebookSerializer(n,o,S,h,I){if((0,u.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const C=this._handlePool++;return this._notebookSerializer.set(C,{viewType:o,serializer:S,options:h}),this._notebookProxy.$registerNotebookSerializer(C,{id:n.identifier,location:n.extensionLocation},o,p.NotebookDocumentContentOptions.from(h),r._convertNotebookRegistrationData(n,I)),(0,L.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(C)})}async $dataToNotebook(n,o,S){const h=this._notebookSerializer.get(n);if(!h)throw new Error("NO serializer found");const I=await h.serializer.deserializeNotebook(o.buffer,S);return new t.SerializableObjectWithBuffers(p.NotebookData.from(I))}async $notebookToData(n,o,S){const h=this._notebookSerializer.get(n);if(!h)throw new Error("NO serializer found");const I=await h.serializer.serializeNotebook(p.NotebookData.to(o.value),S);return R.VSBuffer.wrap(I)}async $saveNotebook(n,o,S,h,I){const C=m.URI.revive(o),l=this._notebookSerializer.get(n);if(!l)throw new Error("NO serializer found");const g=this._documents.get(C);if(!g)throw new Error("Document NOT found");if(g.versionId!==S)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(C.scheme))throw new P.FileOperationError((0,w.localize)(0,null,this._resourceForError(C)),6);await this._validateWriteFile(C,h);const d={metadata:(0,_.filter)(g.apiNotebook.metadata,$=>!(l.options?.transientDocumentMetadata??{})[$]),cells:[]};for(const $ of g.apiNotebook.getCells()){const N=new f.NotebookCellData($.kind,$.document.getText(),$.document.languageId,$.mime,l.options?.transientOutputs?[]:[...$.outputs],$.metadata,$.executionSummary);N.metadata=(0,_.filter)($.metadata,M=>!(l.options?.transientCellMetadata??{})[M]),d.cells.push(N)}const T=await l.serializer.serializeNotebook(d,I);await this._extHostFileSystem.value.writeFile(C,T);const z=this._extHostFileSystem.getFileSystemProviderExtUri(C.scheme),H=await this._extHostFileSystem.value.stat(C);return{name:z.basename(C),isFile:(H.type&P.FileType.File)!==0,isDirectory:(H.type&P.FileType.Directory)!==0,isSymbolicLink:(H.type&P.FileType.SymbolicLink)!==0,mtime:H.mtime,ctime:H.ctime,size:H.size,readonly:!!((H.permissions??0)&P.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(C.scheme),locked:!!((H.permissions??0)&P.FilePermission.Locked),etag:P.etag({mtime:H.mtime,size:H.size}),children:void 0}}async _validateWriteFile(n,o){const S=await this._extHostFileSystem.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&o.mtime<S.mtime&&o.etag!==P.etag({mtime:o.mtime,size:S.size}))throw new P.FileOperationError((0,w.localize)(1,null),3,o)}_resourceForError(n){return n.scheme===E.Schemas.file?n.fsPath:n.toString()}_createExtHostEditor(n,o,S){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const h=new c.ExtHostNotebookEditor(o,this._notebookEditorsProxy,n,S.visibleRanges.map(p.NotebookRange.to),S.selections.map(p.NotebookRange.to),typeof S.viewColumn=="number"?p.ViewColumn.to(S.viewColumn):void 0);this._editors.set(o,h)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const S of n.value.removedDocuments){const h=m.URI.revive(S),I=this._documents.get(h);I&&(I.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(C=>C.document.uri)}),this._onDidCloseNotebookDocument.fire(I.apiNotebook));for(const C of this._editors.values())C.notebookData.uri.toString()===h.toString()&&this._editors.delete(C.id)}if(n.value.addedDocuments){const S=[];for(const h of n.value.addedDocuments){const I=m.URI.revive(h.uri);if(this._documents.has(I))throw new Error(`adding EXISTING notebook ${I} `);const C=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,I,h);S.push(...h.cells.map(l=>i.ExtHostCell.asModelAddData(C.apiNotebook,l))),this._documents.get(I)?.dispose(),this._documents.set(I,C),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(C.apiNotebook)}}if(n.value.addedEditors)for(const S of n.value.addedEditors){if(this._editors.has(S.id))return;const h=m.URI.revive(S.documentUri),I=this._documents.get(h);I&&this._createExtHostEditor(I,S.id,S)}const o=[];if(n.value.removedEditors)for(const S of n.value.removedEditors){const h=this._editors.get(S);h&&(this._editors.delete(S),this._activeNotebookEditor?.id===h.id&&(this._activeNotebookEditor=void 0),o.push(h))}if(n.value.visibleEditors){this._visibleNotebookEditors=n.value.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const S=new Set;this._visibleNotebookEditors.forEach(h=>S.add(h.id));for(const h of this._editors.values()){const I=S.has(h.id);h._acceptVisibility(I)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this._activeNotebookEditor=void 0:n.value.newActiveEditor&&(this._editors.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(n){const o=v.ApiCommandArgument.String.with("notebookType","A notebook type"),S=new v.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new v.ApiCommandArgument("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>R.VSBuffer.wrap(I))],new v.ApiCommandResult("Notebook Data",I=>p.NotebookData.to(I.value))),h=new v.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new v.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.SerializableObjectWithBuffers(p.NotebookData.from(I)))],new v.ApiCommandResult("Bytes",I=>I.buffer));n.registerApiCommand(S),n.registerApiCommand(h)}}e.ExtHostNotebookController=r}),define(Ae[244],Re([1,0,18,12,21,5,6,28,2,20,14,3,31,8,7,77,197,26,46]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(h,I,C,l,g){this._initData=I,this._extHostNotebook=C,this._commands=l,this._logService=g,this._activeExecutions=new u.ResourceMap,this._activeNotebookExecutions=new u.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=h.getProxy(D.MainContext.MainThreadNotebookKernels);const d=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const z=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:z}}else if(T&&"notebookEditor"in T){const z=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return T})],a.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(h,I,C,l,g,d){for(const ae of this._kernelData.values())if(ae.controller.id===I&&m.ExtensionIdentifier.equals(h.identifier,ae.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this._handlePool++,z=this;this._logService.trace(`NotebookController[${T}], CREATED by ${h.identifier.value}, ${I}`);const H=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${h.identifier}'`);let x=!1;const $=new L.Emitter,N=new L.Emitter,M={id:o(h.identifier,I),notebookType:C,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:l||h.identifier.value,preloads:d?d.map(v.NotebookRendererScript.from):[]};let te=g??H,Q;this._proxy.$addKernel(T,M).catch(ae=>{console.log(ae),x=!0});let Se=0;const _e=()=>{if(x)return;const ae=++Se;Promise.resolve().then(()=>{ae===Se&&this._proxy.$updateKernel(T,M)})},Pe=new u.ResourceMap,Y={get id(){return I},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return M.label},set label(ae){M.label=ae??h.displayName??h.name,_e()},get detail(){return M.detail??""},set detail(ae){M.detail=ae,_e()},get description(){return M.description??""},set description(ae){M.description=ae,_e()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(ae){M.supportedLanguages=ae,_e()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){M.supportsExecutionOrder=ae,_e()},get rendererScripts(){return M.preloads?M.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(ae){te=ae??H},get interruptHandler(){return Q},set interruptHandler(ae){Q=ae,M.supportsInterrupt=!!ae,_e()},createNotebookCellExecution(ae){if(x)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.notebook.uri))throw z._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return z._createNotebookCellExecution(ae,o(h.identifier,this.id))},createNotebookExecution(ae){if((0,i.checkProposedApiEnabled)(h,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.uri))throw z._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return z._createNotebookExecution(ae,o(h.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${T}], DISPOSED`),x=!0,this._kernelData.delete(T),$.dispose(),N.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(ae,Ce){Ce===p.NotebookControllerAffinity2.Hidden&&(0,i.checkProposedApiEnabled)(h,"notebookControllerAffinityHidden"),z._proxy.$updateNotebookPriority(T,ae.uri,Ce)},onDidReceiveMessage:N.event,postMessage(ae,Ce){return(0,i.checkProposedApiEnabled)(h,"notebookMessaging"),z._proxy.$postMessage(T,Ce&&z._extHostNotebook.getIdByEditor(Ce),ae)},asWebviewUri(ae){return(0,i.checkProposedApiEnabled)(h,"notebookMessaging"),(0,f.asWebviewUri)(ae,z._initData.remote)}};return this._kernelData.set(T,{extensionId:h.identifier,controller:Y,onDidReceiveMessage:N,onDidChangeSelection:$,associatedNotebooks:Pe}),Y}getIdByController(h){for(const[I,C]of this._kernelData)if(C.controller===h)return o(C.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,I){const C=this._kernelDetectionTaskHandlePool++,l=this;this._logService.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelDetectionTask(C,I);const g={dispose:()=>{this._kernelDetectionTask.delete(C),l._proxy.$removeKernelDetectionTask(C)}};return this._kernelDetectionTask.set(C,g),g}registerKernelSourceActionProvider(h,I,C){const l=this._kernelSourceActionProviderHandlePool++,g=typeof C.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,d=this;this._kernelSourceActionProviders.set(l,C),this._logService.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelSourceActionProvider(l,l,I);let T;return g!==void 0&&(T=C.onDidChangeNotebookKernelSourceActions(z=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this._kernelSourceActionProviders.delete(l),d._proxy.$removeKernelSourceActionProvider(l,l),T?.dispose()}}}async $provideKernelSourceActions(h,I){const C=this._kernelSourceActionProviders.get(h);if(C){const l=new A.DisposableStore;return(await C.provideNotebookKernelSourceActions(I)??[]).map(d=>v.NotebookKernelSourceAction.from(d,this._commands.converter,l))}return[]}$acceptNotebookAssociation(h,I,C){const l=this._kernelData.get(h);if(l){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(I));C?l.associatedNotebooks.set(g.uri,!0):l.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,g.uri.toString(),C),l.onDidChangeSelection.fire({selected:C,notebook:g.apiNotebook})}}async $executeCells(h,I,C){const l=this._kernelData.get(h);if(!l)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(I)),d=[];for(const T of C){const z=g.getCell(T);z&&d.push(z.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,g.uri.toString(),d.length),await l.controller.executeHandler.call(l.controller,d,g.apiNotebook,l.controller)}catch(T){this._logService.error(`NotebookController[${h}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(h,I,C){const l=this._kernelData.get(h);if(!l)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(I));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,g.apiNotebook);else for(const d of C){const T=g.getCell(d);T&&this._activeExecutions.get(T.uri)?.cancel()}if(l.controller.interruptHandler){const d=this._activeNotebookExecutions.get(g.uri);C.length&&Array.isArray(d)&&d.length&&d.forEach(T=>T.dispose())}}$acceptKernelMessageFromRenderer(h,I,C){const l=this._kernelData.get(h);if(!l)return;const g=this._extHostNotebook.getEditorById(I);l.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:C}))}$cellExecutionChanged(h,I,C){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(h)).getCell(I);if(g){const d=C?v.NotebookCellExecutionState.to(C):p.NotebookCellExecutionState.Idle;d!==void 0&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:d})}}_createNotebookCellExecution(h,I){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const g=new E(I,l,this._proxy);this._activeExecutions.set(l.uri,g);const d=g.onDidChangeState(()=>{g.state===_.Resolved&&(g.dispose(),d.dispose(),this._activeExecutions.delete(l.uri))});return g.asApiObject()}_createNotebookExecution(h,I){const C=this._extHostNotebook.getNotebookDocument(h.uri),l=h.getCells().find(T=>{const z=C.getCellFromApiCell(T);return z&&this._activeExecutions.has(z.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this._activeNotebookExecutions.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const g=new s(I,C,this._proxy),d=g.onDidChangeState(()=>{g.state===r.Resolved&&(g.dispose(),d.dispose(),this._activeNotebookExecutions.delete(C.uri))});return this._activeNotebookExecutions.set(C.uri,[g,d]),g.asApiObject()}};e.ExtHostNotebookKernels=b,e.ExtHostNotebookKernels=b=Ve([ze(4,P.ILogService)],b);var _;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(_||(_={}));class E extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(h,I,C){super(),this._cell=I,this._proxy=C,this._handle=E.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new n(10,l=>this.update(l)),this._executionOrder=I.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,h,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(h){await this._collector.addItem(h)}async update(h){const I=Array.isArray(h)?h:[h];return this._proxy.$updateExecution(this._handle,new c.SerializableObjectWithBuffers(I))}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(h){let I=this._cell;if(h&&(I=this._cell.notebook.getCellFromApiCell(h)),!I)throw new Error("INVALID cell");return I.handle}validateAndConvertOutputs(h){return h.map(I=>{const C=p.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return C===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:C,id:I.id,metadata:I.metadata})})}async updateOutputs(h,I,C){const l=this.cellIndexToHandle(I),g=this.validateAndConvertOutputs((0,w.asArray)(h));return this.updateSoon({editType:t.CellExecutionUpdateType.Output,cellHandle:l,append:C,outputs:g})}async updateOutputItems(h,I,C){return h=p.NotebookCellOutput.ensureUniqueMimeTypes((0,w.asArray)(h),!0),this.updateSoon({editType:t.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:I.id,append:C})}asApiObject(){const h=this;return Object.freeze({get token(){return h._tokenSource.token},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(C){h._executionOrder=C,h.update([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:h._executionOrder}])},start(C){if(h._state===_.Resolved||h._state===_.Started)throw new Error("Cannot call start again");h._state=_.Started,h._onDidChangeState.fire(),h.update({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,l){if(h._state===_.Resolved)throw new Error("Cannot call resolve twice");h._state=_.Resolved,h._onDidChangeState.fire(),h._collector.flush(),h._proxy.$completeExecution(h._handle,new c.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:C}))},clearOutput(C){return h.verifyStateForOutput(),h.updateOutputs([],C,!1)},appendOutput(C,l){return h.verifyStateForOutput(),h.updateOutputs(C,l,!0)},replaceOutput(C,l){return h.verifyStateForOutput(),h.updateOutputs(C,l,!1)},appendOutputItems(C,l){return h.verifyStateForOutput(),h.updateOutputItems(C,l,!0)},replaceOutputItems(C,l){return h.verifyStateForOutput(),h.updateOutputItems(C,l,!1)}})}}var r;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(r||(r={}));class s extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(h,I,C){super(),this._notebook=I,this._proxy=C,this._handle=s.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,h,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===r.Resolved||this._state===r.Started)throw new Error("Cannot call start again");this._state=r.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===r.Resolved)throw new Error("Cannot call resolve twice");this._state=r.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class n{constructor(h,I){this.delay=h,this.callback=I,this.batch=[],this.startedTimer=Date.now()}addItem(h){return this.batch.push(h),this.currentDeferred||(this.currentDeferred=new R.DeferredPromise,this.startedTimer=Date.now(),(0,R.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const h=this.currentDeferred;this.currentDeferred=void 0;const I=this.batch;return this.batch=[],this.callback(I).finally(()=>h.complete())}}function o(S,h){return`${S.value}/${h}`}e.createKernelId=o}),define(Ae[245],Re([1,0,5,3,103]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(u,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=u.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(u,y,m){const P=this._extHostNotebook.getEditorById(u);this._rendererMessageEmitters.get(y)?.fire({editor:P.apiEditor,message:m})}createRendererMessaging(u,y){if(!u.contributes?.notebookRenderer?.some(P=>P.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(P,D,a)=>this.getOrCreateEmitterFor(y).event(P,D,a),postMessage:(P,D)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const a=D&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(a?.id,y,P)}}}getOrCreateEmitterFor(u){let y=this._rendererMessageEmitters.get(u);return y||(y=new w.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(u)}}),this._rendererMessageEmitters.set(u,y),y)}}e.ExtHostNotebookRenderers=L}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class u{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,P,D){if((0,L.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.handlers.set(P,D),this.proxy.$registerProfileContentHandler(P,D.name,D.description,m.identifier.value),(0,w.toDisposable)(()=>{this.handlers.delete(P),this.proxy.$unregisterProfileContentHandler(P)})}async $saveProfile(m,P,D,a){const v=this.handlers.get(m);if(!v)throw new Error(`Unknown handler with id: ${m}`);return v.saveProfile(P,D,a)}async $readProfile(m,P,D){const a=this.handlers.get(m);if(!a)throw new Error(`Unknown handler with id: ${m}`);return a.readProfile((0,R.isString)(P)?P:k.URI.revive(P),D)}}e.ExtHostProfileContentHandlers=u}),define(Ae[247],Re([1,0,2,3,12,8]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(y,m){this.uriTransformer=m,this.providers=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,m,P){const D=w.URI.revive(m),a=this.providers.get(y);return a?(0,k.asPromise)(()=>a.provideOriginalResource(D,P)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,P,D){const a=A.handlePool++;return this.providers.set(a,m),this.proxy.$registerQuickDiffProvider(a,L.DocumentSelector.from(y,this.uriTransformer),P,D),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(a),this.providers.delete(a)}}}}e.ExtHostQuickDiff=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(f,t,i){const c=f.getProxy(L.MainContext.MainThreadQuickOpen);class b{constructor(I,C){this._sessions=new Map,this._instances=0,this._workspace=I,this._commands=C}showQuickPick(I,C,l,g=w.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(C),T=++this._instances,z=c.$show(T,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},g),H={},x=z.then(()=>H);return Promise.race([x,d]).then($=>{if($===H)return;const N=(0,a.isProposedApiEnabled)(I,"quickPickItemTooltip");return d.then(M=>{const te=[];for(let Q=0;Q<M.length;Q++){const Se=M[Q];if(typeof Se=="string")te.push({label:Se,handle:Q});else if(Se.kind===u.QuickPickItemKind.Separator)te.push({type:"separator",label:Se.label});else{Se.tooltip&&!N&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const _e=Se.iconPath?n(Se.iconPath):void 0;te.push({label:Se.label,iconPath:_e?.iconPath,iconClass:_e?.iconClass,description:Se.description,detail:Se.detail,picked:Se.picked,alwaysShow:Se.alwaysShow,tooltip:N?v.MarkdownString.fromStrict(Se.tooltip):void 0,handle:Q})}}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{l.onDidSelectItem(M[Q])}),c.$setItems(T,te),z.then(Q=>{if(typeof Q=="number")return M[Q];if(Array.isArray(Q))return Q.map(Se=>M[Se])})})}).then(void 0,$=>{if(!(0,y.isCancellationError)($))return c.$setError(T,$),Promise.reject($)})}$onItemSelected(I){this._onDidSelectItem?.(I)}showInput(I,C=w.CancellationToken.None){return this._validateInput=I?.validateInput,c.$input(I,typeof this._validateInput=="function",C).then(void 0,l=>{if(!(0,y.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(I){if(!this._validateInput)return;const C=await this._validateInput(I);if(!C||typeof C=="string")return C;let l;switch(C.severity){case u.InputBoxValidationSeverity.Info:l=P.default.Info;break;case u.InputBoxValidationSeverity.Warning:l=P.default.Warning;break;case u.InputBoxValidationSeverity.Error:l=P.default.Error;break;default:l=C.message?P.default.Error:P.default.Ignore;break}return{content:C.message,severity:l}}async showWorkspaceFolderPick(I,C=w.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!l)return;const g=await this._workspace.getWorkspaceFolders2();if(g)return g.find(d=>d.uri.toString()===l.uri.toString())}createQuickPick(I){const C=new o(I,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(I){const C=new S(I,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(I,C){this._sessions.get(I)?._fireDidChangeValue(C)}$onDidAccept(I){this._sessions.get(I)?._fireDidAccept()}$onDidChangeActive(I,C){const l=this._sessions.get(I);l instanceof o&&l._fireDidChangeActive(C)}$onDidChangeSelection(I,C){const l=this._sessions.get(I);l instanceof o&&l._fireDidChangeSelection(C)}$onDidTriggerButton(I,C){this._sessions.get(I)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(I,C,l){const g=this._sessions.get(I);g instanceof o&&g._fireDidTriggerItemButton(C,l)}$onDidHide(I){this._sessions.get(I)?._fireDidHide()}}class _{static{this._nextId=1}constructor(I,C){this._extensionId=I,this._onDidDispose=C,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(I){this._title=I,this.update({title:I})}get step(){return this._steps}set step(I){this._steps=I,this.update({step:I})}get totalSteps(){return this._totalSteps}set totalSteps(I){this._totalSteps=I,this.update({totalSteps:I})}get enabled(){return this._enabled}set enabled(I){this._enabled=I,this.update({enabled:I})}get busy(){return this._busy}set busy(I){this._busy=I,this.update({busy:I})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(I){this._ignoreFocusOut=I,this.update({ignoreFocusOut:I})}get value(){return this._value}set value(I){this._value=I,this.update({value:I})}get placeholder(){return this._placeholder}set placeholder(I){this._placeholder=I,this.update({placeholder:I})}get buttons(){return this._buttons}set buttons(I){this._buttons=I.slice(),this._handlesToButtons.clear(),I.forEach((C,l)=>{const g=C===u.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(g,C)}),this.update({buttons:I.map((C,l)=>({...n(C.iconPath),tooltip:C.tooltip,handle:C===u.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(I){this._value=I,this._onDidChangeValueEmitter.fire(I)}_fireDidTriggerButton(I){const C=this._handlesToButtons.get(I);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(I){if(!this._disposed){for(const C of Object.keys(I)){const l=I[C];this._pendingUpdate[C]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function E(h){if(h instanceof u.ThemeIcon)return{id:h.id};const I=s(h),C=r(h);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof C=="string"?A.URI.file(C):C}}function r(h){return typeof h=="object"&&"light"in h?h.light:h}function s(h){return typeof h=="object"&&"dark"in h?h.dark:h}function n(h){const I=E(h);let C,l;return"id"in I?l=D.ThemeIcon.asClassName(I):C=I,{iconPath:C,iconClass:l}}class o extends _{constructor(I,C){super(I.identifier,C),this.extension=I,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this._onDidTriggerItemButtonEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(I){this._items=I.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),I.forEach((g,d)=>{this._handlesToItems.set(d,g),this._itemsToHandles.set(g,d)});const C=(0,a.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),l=[];for(let g=0;g<I.length;g++){const d=I[g];if(d.kind===u.QuickPickItemKind.Separator)l.push({type:"separator",label:d.label});else{d.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const T=d.iconPath?n(d.iconPath):void 0;l.push({handle:g,label:d.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((z,H)=>({...n(z.iconPath),tooltip:z.tooltip,handle:H}))})}}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(I){this._canSelectMany=I,this.update({canSelectMany:I})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(I){this._matchOnDescription=I,this.update({matchOnDescription:I})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(I){this._matchOnDetail=I,this.update({matchOnDetail:I})}get sortByLabel(){return this._sortByLabel}set sortByLabel(I){this._sortByLabel=I,this.update({sortByLabel:I})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(I){this._keepScrollPosition=I,this.update({keepScrollPosition:I})}get activeItems(){return this._activeItems}set activeItems(I){this._activeItems=I.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(I){this._selectedItems=I.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(I){const C=(0,m.coalesce)(I.map(l=>this._handlesToItems.get(l)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(I){const C=(0,m.coalesce)(I.map(l=>this._handlesToItems.get(l)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(I,C){const l=this._handlesToItems.get(I);if(!l||!l.buttons||!l.buttons.length)return;const g=l.buttons[C];g&&this._onDidTriggerItemButtonEmitter.fire({button:g,item:l})}}class S extends _{constructor(I,C){super(I.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(I){this._password=I,this.update({password:I})}get prompt(){return this._prompt}set prompt(I){this._prompt=I,this.update({prompt:I})}get valueSelection(){return this._valueSelection}set valueSelection(I){this._valueSelection=I,this.update({valueSelection:I})}get validationMessage(){return this._validationMessage}set validationMessage(I){this._validationMessage=I,I?typeof I=="string"?this.update({validationMessage:I,severity:P.default.Error}):this.update({validationMessage:I.message,severity:I.severity??P.default.Error}):this.update({validationMessage:void 0,severity:P.default.Ignore})}}return new b(t,i)}e.createExtHostQuickOpen=p}),define(Ae[249],Re([1,0,2,5,64,6,12,3,18,131,14,20,40,8,26,13]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(g){if(g)return typeof g.iconPath=="string"?w.URI.file(g.iconPath):w.URI.isUri(g.iconPath)||a.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function c(g){if(g.icon){if(w.URI.isUri(g.icon))return g.icon;if(a.ThemeIcon.isThemeIcon(g.icon))return g.icon;{const d=g.icon;return{light:d.light,dark:d.dark}}}else return}function b(g,d){if(!g.iconPath&&!d.iconPath)return 0;if(g.iconPath){if(!d.iconPath)return 1}else return-1;const T=typeof g.iconPath=="string"?g.iconPath:w.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,z=typeof d.iconPath=="string"?d.iconPath:w.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,m.comparePaths)(T,z)}function _(g,d){let T=0;if(g.strikeThrough!==d.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==d.faded)return g.faded?1:-1;if(g.tooltip!==d.tooltip)return(g.tooltip||"").localeCompare(d.tooltip||"");if(T=b(g,d),T!==0)return T;if(g.light&&d.light)T=b(g.light,d.light);else{if(g.light)return 1;if(d.light)return-1}if(T!==0)return T;if(g.dark&&d.dark)T=b(g.dark,d.dark);else{if(g.dark)return 1;if(d.dark)return-1}return T}function E(g,d){if(g.command!==d.command)return g.command<d.command?-1:1;if(g.title!==d.title)return g.title<d.title?-1:1;if(g.tooltip!==d.tooltip){if(g.tooltip!==void 0&&d.tooltip!==void 0)return g.tooltip<d.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(g.arguments===d.arguments)return 0;if(g.arguments)if(d.arguments){if(g.arguments.length!==d.arguments.length)return g.arguments.length-d.arguments.length}else return 1;else return-1;for(let T=0;T<g.arguments.length;T++){const z=g.arguments[T],H=d.arguments[T];if(z!==H)return z<H?-1:1}return 0}function r(g,d){let T=(0,m.comparePaths)(g.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(T!==0)return T;if(g.command&&d.command)T=E(g.command,d.command);else{if(g.command)return 1;if(d.command)return-1}if(T!==0)return T;if(g.decorations&&d.decorations)T=_(g.decorations,d.decorations);else{if(g.decorations)return 1;if(d.decorations)return-1}return T}function s(g,d){for(let T=0;T<g.length;T++)if(g[T]!==d[T])return!1;return!0}function n(g,d){return g.command===d.command&&g.title===d.title&&g.tooltip===d.tooltip&&(g.arguments&&d.arguments?s(g.arguments,d.arguments):g.arguments===d.arguments)}function o(g,d){return(0,y.equals)(g,d,n)}function S(g,d){return g===d?!0:!g||!d?!1:g.id===d.id&&g.label===d.label&&g.upstream?.id===d.upstream?.id&&g.upstream?.label===d.upstream?.label}class h{#e;#t;get value(){return this._value}set value(d){d=d??"",this.#e.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get enabled(){return this._enabled}set enabled(d){d=!!d,this._enabled!==d&&(this._enabled=d,this.#e.$setInputBoxEnablement(this._sourceControlHandle,d))}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this.#e.$setInputBoxVisibility(this._sourceControlHandle,d))}get document(){return(0,p.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(d,T,z,H,x){this._extension=d,this._sourceControlHandle=H,this._documentUri=x,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=T,this.#e=z}showValidationMessage(d,T){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,d,T)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=h;class I{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}constructor(d,T,z,H,x){this._proxy=d,this._commands=T,this._sourceControlHandle=z,this._id=H,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=I._handlePool++}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,T){const z=this._resourceStatesCommandsMap.get(d);return z?(0,A.asPromise)(()=>this._commands.executeCommand(z.command,...z.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(r),z=(0,y.sortedDiff)(this._resourceSnapshot,d,r).map($=>{const N=$.toInsert.map(M=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,M);const Q=M.resourceUri;let Se;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const W=new L.DisposableStore;Se=this._commands.converter.toInternal(M.command,W),this._resourceStatesDisposablesMap.set(te,W)}else this._resourceStatesCommandsMap.set(te,M.command);const _e=i(M.decorations),Pe=M.decorations&&i(M.decorations.light)||_e,Y=M.decorations&&i(M.decorations.dark)||_e,ae=[Pe,Y],Ce=M.decorations&&M.decorations.tooltip||"",le=M.decorations&&!!M.decorations.strikeThrough,pe=M.decorations&&!!M.decorations.faded,ie=M.contextValue||"";return{rawResource:[te,Q,ae,Ce,le,pe,ie,Se],handle:te}});return{start:$.start,deleteCount:$.deleteCount,toInsert:N}}),H=z.map(({start:$,deleteCount:N,toInsert:M})=>[$,N,M.map(te=>te.rawResource)]),x=z.reverse();for(const{start:$,deleteCount:N,toInsert:M}of x){const te=M.map(Se=>Se.handle),Q=this._handlesSnapshot.splice($,N,...te);for(const Se of Q)this._resourceStatesMap.delete(Se),this._resourceStatesCommandsMap.delete(Se),this._resourceStatesDisposablesMap.get(Se)?.dispose(),this._resourceStatesDisposablesMap.delete(Se)}return this._resourceSnapshot=d,H}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class C{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this.#e.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d;let T;(0,p.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(T=d?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d,quickDiffLabel:T})}get historyProvider(){return(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(d){(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=d,this._historyProviderDisposable.value=new L.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!d}),d&&(this._historyProviderDisposable.value.add(d.onDidChangeCurrentHistoryItemGroup(()=>{S(this._historyProviderCurrentHistoryItemGroup,d?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=d?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(d.onDidChangeActionButton(()=>{(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new L.DisposableStore;const T=d.actionButton!==void 0?{command:this._commands.converter.toInternal(d.actionButton.command,this._historyProviderActionButtonDisposable.value),description:d.actionButton.description,enabled:d.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,T??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this.#e.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=d;const T=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=d;const T=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),secondaryCommands:d.secondaryCommands?.map(z=>z.map(H=>this._commands.converter.toInternal(H,this._actionButtonDisposables.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&o(this._statusBarCommands,d))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=d;const T=(d||[]).map(z=>this._commands.converter.toInternal(z,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(d,T,z,H,x,$,N){this._extension=d,this._commands=H,this._id=x,this._label=$,this._rootUri=N,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new L.MutableDisposable,this._historyProviderActionButtonDisposable=new L.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=C._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=z;const M=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${x}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new h(d,T,this.#e,this.handle,M),this.#e.$registerSourceControl(this.handle,x,$,N,M)}createResourceGroup(d,T){const z=new I(this.#e,this._commands,this.handle,d,T),H=R.Event.once(z.onDidDispose)(()=>this.createdResourceGroups.delete(z));return this.createdResourceGroups.set(z,H),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const d=[],T=[];for(const[z,H]of this.createdResourceGroups){H.dispose();const x=z.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(z),this.eventuallyUpdateResourceStates()});R.Event.once(z.onDidDispose)(()=>{this.updatedResourceGroups.delete(z),x.dispose(),this._groups.delete(z.handle),this.#e.$unregisterGroup(this.handle,z.handle)}),d.push([z.handle,z.id,z.label,z.features]);const $=z._takeResourceStateSnapshot();$.length>0&&T.push([z.handle,$]),this._groups.set(z.handle,z)}this.#e.$registerGroups(this.handle,d,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(T=>{const z=T._takeResourceStateSnapshot();z.length!==0&&d.push([T.handle,z])}),d.length>0&&this.#e.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ve([(0,k.debounce)(100)],C.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let l=class{static{t=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(d,T,z,H){this._commands=T,this._extHostDocuments=z,this.logService=H,this._sourceControls=new Map,this._sourceControlsByExtension=new D.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=d.getProxy(u.MainContext.MainThreadSCM),this._telemetry=d.getProxy(u.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===3){const $=this._sourceControls.get(x.sourceControlHandle);if(!$)return x;const N=$.getResourceGroup(x.groupHandle);return N?N.getResourceState(x.handle):x}else if(x&&x.$mid===4){const $=this._sourceControls.get(x.sourceControlHandle);return $?$.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===5){const $=this._sourceControls.get(x.handle);return $||x}return x}})}createSourceControl(d,T,z,H){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,T,z,H),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const x=t._handlePool++,$=new C(d,this._extHostDocuments,this._proxy,this._commands,T,z,H);this._sourceControls.set(x,$);const N=this._sourceControlsByExtension.get(d.identifier)||[];return N.push($),this._sourceControlsByExtension.set(d.identifier,N),$}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const T=this._sourceControlsByExtension.get(d.identifier),z=T&&T[T.length-1];return z&&z.inputBox}$provideOriginalResource(d,T,z){const H=w.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,H.toString());const x=this._sourceControls.get(d);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(H,z)).then($=>$||null)}$onInputBoxValueChange(d,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const z=this._sourceControls.get(d);return z&&z.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(d,T,z,H){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,T,z);const x=this._sourceControls.get(d);if(!x)return Promise.resolve(void 0);const $=x.getResourceGroup(T);return $?$.$executeResourceCommand(z,H):Promise.resolve(void 0)}$validateInput(d,T,z){this.logService.trace("ExtHostSCM#$validateInput",d);const H=this._sourceControls.get(d);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>H.inputBox.validateInput(T,z)).then(x=>{if(!x)return Promise.resolve(void 0);const $=v.MarkdownString.fromStrict(x.message);return $?Promise.resolve([$,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(d,T,z){return await this._sourceControls.get(d)?.historyProvider?.resolveHistoryItemGroupBase(T,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(d,T,z,H){return await this._sourceControls.get(d)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,z,H)??void 0}async $provideHistoryItems(d,T,z,H){return(await this._sourceControls.get(d)?.historyProvider?.provideHistoryItems(T,z,H))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:c(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(d,T,z){return await this._sourceControls.get(d)?.historyProvider?.provideHistoryItemChanges(T,z)??void 0}};e.ExtHostSCM=l,e.ExtHostSCM=l=t=Ve([ze(3,P.ILogService)],l)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(u){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=u.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(u){this._onDidChangePassword.fire(u)}get(u,y){return this._proxy.$getPassword(u,y)}store(u,y,m){return this._proxy.$setPassword(u,y,m)}delete(u,y){return this._proxy.$deletePassword(u,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class L{static{this.handlePool=0}constructor(u,y){this.uriTransformer=y,this.providers=new Map,this.proxy=u.getProxy(w.MainContext.MainThreadShare)}async $provideShare(u,y,m){return await this.providers.get(u)?.provideShare({selection:R.Range.to(y.selection),resourceUri:k.URI.revive(y.resourceUri)},m)??void 0}registerShareProvider(u,y){const m=L.handlePool++;return this.providers.set(m,y),this.proxy.$registerShareProvider(m,R.DocumentSelector.from(u,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(m),this.providers.delete(m)}}}}e.ExtHostShare=L}),define(Ae[251],Re([1,0,7,3,153,6,8,16]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(a,v,p,f,t,i=w.StatusBarAlignment.Left,c){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new L.DisposableStore,this.#e=a,this.#t=v,t&&f){this._entryId=(0,w.asStatusBarItemIdentifier)(f.identifier,t);const b=p.get(this._entryId);b&&(i=b.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=b.priority,this._visible=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=f,this._id=t,this._alignment=i,this._priority=this.validatePriority(c)}validatePriority(a){if((0,u.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!y.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new L.DisposableStore,typeof a=="string"?this._command={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this._latestCommandRegistration)}:a?this._command={fromApi:a,internal:this.#t.toInternal(a,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let v;this._name?v=this._name:v=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,a,this._extension?.identifier.value,v,this._text,f,this._command?.internal,p,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class m{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const v={message:a};return this._messages.unshift(v),this._update(),new w.Disposable(()=>{const p=this._messages.indexOf(v);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(a,v){this._existingItems=new Map,this._proxy=a.getProxy(R.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new m(this)}$acceptStaticEntries(a){for(const v of a)this._existingItems.set(v.entryId,v)}createStatusBarEntry(a,v,p,f){return new y(this._proxy,this._commands,this._existingItems,a,v,p,f)}setStatusBarMessage(a,v){const p=this._statusMessage.setMessage(a);let f;return typeof v=="number"?f=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new w.Disposable(()=>{p.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(u,y){this._logService=y,this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=u.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(u,y){this._proxy.$registerExtensionStorageKeysToSync(u,y)}async initializeExtensionStorage(u,y,m){const P=await this._proxy.$initializeExtensionStorage(u,y);let D;return P&&(D=this.safeParseValue(u,y,P)),D||m}setValue(u,y,m){return this._proxy.$setValue(u,y,m)}$acceptValue(u,y,m){const P=this.safeParseValue(u,y,m);P&&this._onDidChangeStorage.fire({shared:u,key:y,value:P})}safeParseValue(u,y,m){try{return JSON.parse(m)}catch(P){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${u}): ${P}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,61,2]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let u=class{constructor(m,P,D){this._logService=P,this._extHostFileSystem=D,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(m){return A.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,P=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(m){if(this._value)return A.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return A.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=u,e.ExtensionStoragePaths=u=Ve([ze(0,R.IExtHostInitDataService),ze(1,k.ILogService),ze(2,L.IExtHostConsumerFileSystem)],u)}),define(Ae[62],Re([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,12,8,31]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(l,g,d,T){this._proxy=l,this._id=g,this._creationOptions=d,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const z=this;this.value={get name(){return z._name||""},get processId(){return z._pidPromise},get creationOptions(){return z._creationOptions},get exitStatus(){return z._exitStatus},get state(){return z._state},get selection(){return z._selection},sendText(H,x=!0){z._checkDisposed(),z._proxy.$sendText(z._id,H,x)},show(H){z._checkDisposed(),z._proxy.$show(z._id,H)},hide(){z._checkDisposed(),z._proxy.$hide(z._id)},dispose(){z._disposed||(z._disposed=!0,z._proxy.$dispose(z._id))},get dimensions(){if(!(z._cols===void 0||z._rows===void 0))return{columns:z._cols,rows:z._rows}}}}async create(l,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:l.shellPath??void 0,shellArgs:l.shellArgs??void 0,cwd:l.cwd??void 0,env:l.env??void 0,icon:S(l.iconPath)??void 0,color:f.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:l.message??void 0,strictEnv:l.strictEnv??void 0,hideFromUser:l.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this._serializeParentTerminal(l.location,g?.resolvedExtHostIdentifier),isTransient:l.isTransient??void 0})}async createExtensionTerminal(l,g,d,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:f.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(l,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,g){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in l?{viewColumn:i.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitStatus(l,g){this._exitStatus=Object.freeze({code:l,reason:g})}setDimensions(l,g){return l===this._cols&&g===this._rows||l===0||g===0?!1:(this._cols=l,this._rows=g,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(l){this._selection=l}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=b;class _{get onProcessReady(){return this._onProcessReady.event}constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new w.Emitter,this._onDidChangeProperty=new w.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${g}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput?.(l)}resize(l,g){this._pty.setDimensions?.({columns:l,rows:g})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose?.((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions?.(g=>{g&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this._pty.onDidChangeName?.(g=>{this._onDidChangeProperty.fire({type:"title",value:g})}),this._pty.open(l||void 0),l&&this._pty.setDimensions?.(l),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let E=1,r=class extends u.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}constructor(l,g,d){super(),this._extHostCommands=g,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new u.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new w.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new w.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new w.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new w.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new w.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=d.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(l),this._extHostCommands.registerArgumentProcessor({processArgument:T=>{const z=H=>{const x=H;return this._getTerminalById(x.instanceId)?.value};switch(T?.$mid){case 15:return z(T);default:{if(Array.isArray(T))for(let H=0;H<T.length&&T[H].$mid===15;H++)T[H]=z(T[H]);return T}}}}),this._register({dispose:()=>{for(const[T,z]of this._terminalProcesses)z.shutdown(!0)}})}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,g){const d=new b(this._proxy,(0,v.generateUuid)(),l,l.name),T=new _(l.pty);return d.createExtensionTerminal(l.location,this._serializeParentTerminal(l,g).resolvedExtHostIdentifier,S(l.iconPath),h(l.color)).then(z=>{const H=this._setupExtHostProcessListeners(z,T);this._terminalProcessDisposables[z]=H}),this._terminals.push(d),d.value}_serializeParentTerminal(l,g){if(g=g||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const d=l.location.parentTerminal;if(d){const T=this._terminals.find(z=>z.value===d);T&&(g.resolvedExtHostIdentifier=T._id)}}else l.location&&typeof l.location!="object"?g.location=l.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(l,g){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const T=new _(g),z=this._setupExtHostProcessListeners(l,T);this._terminalProcessDisposables[l]=z}async $acceptActiveTerminalChanged(l){const g=this._activeTerminal;if(l===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(l);d&&(this._activeTerminal=d,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,g){const d=this._getTerminalById(l);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:g})}async $acceptTerminalDimensions(l,g,d){const T=this._getTerminalById(l);T&&T.setDimensions(g,d)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(l,g){const d=this._getTerminalById(l);d&&this._onDidExecuteCommand.fire({terminal:d.value,...g})}async $acceptTerminalMaximumDimensions(l,g,d){this._terminalProcesses.get(l)?.resize(g,d)}async $acceptTerminalTitleChange(l,g){const d=this._getTerminalById(l);d&&(d.name=g)}async $acceptTerminalClosed(l,g,d){const T=this._getTerminalObjectIndexById(this._terminals,l);if(T!==null){const z=this._terminals.splice(T,1)[0];z.setExitStatus(g,d),this._onDidCloseTerminal.fire(z.value)}}$acceptTerminalOpened(l,g,d,T){if(g){const x=this._getTerminalObjectIndexById(this._terminals,g);if(x!==null){this._terminals[x]._id=l,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const z={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:L.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},H=new b(this._proxy,l,z,d);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(l,g){this._getTerminalById(l)?._setProcessId(g)}async $startExtensionTerminal(l,g){const d=this._getTerminalById(l);if(!d)return{message:(0,m.localize)(0,null,l)};d.isOpen||await new Promise(z=>{const H=this.onDidOpenTerminal(async x=>{x===d.value&&(H.dispose(),z())})});const T=this._terminalProcesses.get(l);T?T.startSendingEvents(g):this._extensionTerminalAwaitingStart[l]={initialDimensions:g}}_setupExtHostProcessListeners(l,g){const d=new u.DisposableStore;d.add(g.onProcessReady(z=>this._proxy.$sendProcessReady(l,z.pid,z.cwd,z.windowsPty))),d.add(g.onDidChangeProperty(z=>this._proxy.$sendProcessProperty(l,z))),this._bufferer.startBuffering(l,g.onProcessData),d.add(g.onProcessExit(z=>this._onProcessExit(l,z))),this._terminalProcesses.set(l,g);const T=this._extensionTerminalAwaitingStart[l];return T&&g instanceof _&&(g.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),d}$acceptProcessAckDataEvent(l,g){this._terminalProcesses.get(l)?.acknowledgeDataEvent(g)}$acceptProcessInput(l,g){this._terminalProcesses.get(l)?.input(g)}$acceptTerminalInteraction(l){const g=this._getTerminalById(l);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptTerminalSelection(l,g){this._getTerminalById(l)?.setSelection(g)}$acceptProcessResize(l,g,d){try{this._terminalProcesses.get(l)?.resize(g,d)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(l,g){this._terminalProcesses.get(l)?.shutdown(g)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(g=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(g=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:g}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,g,d){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,d),this._proxy.$registerProfileProvider(g,l.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(l,g,d){if(this._quickFixProviders.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this._quickFixProviders.set(l,d),this._proxy.$registerQuickFixProvider(l,g),new y.Disposable(()=>{this._quickFixProviders.delete(l),this._proxy.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,g){const d=new a.CancellationTokenSource().token;if(d.isCancellationRequested)return;const T=this._quickFixProviders.get(l);if(!T)return;const z=await T.provideTerminalQuickFixes(g,d);if(z===null||Array.isArray(z)&&z.length===0)return;const H=new u.DisposableStore;if(this._lastQuickFixCommands.value=H,!Array.isArray(z))return z?i.TerminalQuickFix.from(z,this._extHostCommands.converter,H):void 0;const x=[];for(const $ of z){const N=i.TerminalQuickFix.from($,this._extHostCommands.converter,H);N&&x.push(N)}return x}async $createContributedProfileTerminal(l,g){const d=new a.CancellationTokenSource().token;let T=await this._profileProviders.get(l)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,g);return}this.createTerminalFromOptions(T.options,g)}}async $provideLinks(l,g){const d=this._getTerminalById(l);if(!d)return[];this._terminalLinkCache.delete(l),this._terminalLinkCancellationSource.get(l)?.dispose(!0);const z=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,z);const H=[],x={terminal:d.value,line:g},$=[];for(const te of this._linkProviders)$.push(t.Promises.withAsyncBody(async Q=>{z.token.onCancellationRequested(()=>Q({provider:te,links:[]}));const Se=await te.provideTerminalLinks(x,z.token)||[];z.token.isCancellationRequested||Q({provider:te,links:Se})}));const N=await Promise.all($);if(z.token.isCancellationRequested)return[];const M=new Map;for(const te of N)te&&te.links.length>0&&H.push(...te.links.map(Q=>{const Se={id:E++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return M.set(Se.id,{provider:te.provider,link:Q}),Se}));return this._terminalLinkCache.set(l,M),H}$activateLink(l,g){const d=this._terminalLinkCache.get(l)?.get(g);d&&d.provider.handleTerminalLink(d.link)}_onProcessExit(l,g){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const d=this._terminalProcessDisposables[l];d&&(d.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,g)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,g){const d=this._getTerminalObjectIndexById(l,g);return d!==null?l[d]:null}_getTerminalObjectIndexById(l,g){const d=l.findIndex(T=>T._id===g);return d===-1?null:d}getEnvironmentVariableCollection(l){let g=this._environmentVariableCollections.get(l.identifier.value);return g||(g=new s,this._setEnvironmentVariableCollection(l.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(l,g){const d=(0,D.serializeEnvironmentVariableCollection)(g.map),T=(0,D.serializeEnvironmentDescriptionMap)(g.descriptionMap);this._proxy.$setEnvironmentVariableCollection(l,g.persistent,d.length===0?void 0:d,T)}$initEnvironmentVariableCollections(l){l.forEach(g=>{const d=g[0],T=new s(g[1]);this._setEnvironmentVariableCollection(d,T)})}$acceptDefaultProfile(l,g){const d=this._defaultProfile;this._defaultProfile=l,this._defaultAutomationProfile=g,d?.path!==l.path&&this._onDidChangeShell.fire(l.path)}_setEnvironmentVariableCollection(l,g){this._environmentVariableCollections.set(l,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,g)})}};e.BaseExtHostTerminalService=r,e.BaseExtHostTerminalService=r=Ve([ze(1,c.IExtHostCommands),ze(2,A.IExtHostRpcService)],r);class s{get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(l)}getScopedEnvironmentVariableCollection(l){const g=this.getScopeKey(l);let d=this.scopedCollections.get(g);return d||(d=new n(this,l),this.scopedCollections.set(g,d),d.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),d}replace(l,g,d,T){this._setIfDiffers(l,{value:g,type:y.EnvironmentVariableMutatorType.Replace,options:d??{applyAtProcessCreation:!0},scope:T})}append(l,g,d,T){this._setIfDiffers(l,{value:g,type:y.EnvironmentVariableMutatorType.Append,options:d??{applyAtProcessCreation:!0},scope:T})}prepend(l,g,d,T){this._setIfDiffers(l,{value:g,type:y.EnvironmentVariableMutatorType.Prepend,options:d??{applyAtProcessCreation:!0},scope:T})}_setIfDiffers(l,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const d=this.getKey(l,g.scope),T=this.map.get(d),z=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==g.value||T.type!==g.type||T.options?.applyAtProcessCreation!==z.applyAtProcessCreation||T.options?.applyAtShellIntegration!==z.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const H=this.getKey(l,g.scope),x={variable:l,...g,options:z};this.map.set(H,x),this._onDidChangeCollection.fire()}}get(l,g){const d=this.getKey(l,g),T=this.map.get(d);return T?I(T):void 0}getKey(l,g){const d=this.getScopeKey(g);return d.length?`${l}:::${d}`:l}getScopeKey(l){return this.getWorkspaceKey(l?.workspaceFolder)??""}getWorkspaceKey(l){return l?l.uri.toString():void 0}getVariableMap(l){const g=new Map;for(const[d,T]of this.map)this.getScopeKey(T.scope)===this.getScopeKey(l)&&g.set(T.variable,I(T));return g}delete(l,g){const d=this.getKey(l,g);this.map.delete(d),this._onDidChangeCollection.fire()}clear(l){if(l?.workspaceFolder){for(const[g,d]of this.map)d.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(g);this.clearDescription(l)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(l,g){const d=this.getScopeKey(g),T=this.descriptionMap.get(d);if(!T||T.description!==l){let z;typeof l=="string"?z=l:z=l?.value.split(`

`)[0];const H={description:z,scope:g};this.descriptionMap.set(d,H),this._onDidChangeCollection.fire()}}getDescription(l){const g=this.getScopeKey(l);return this.descriptionMap.get(g)?.description}clearDescription(l){const g=this.getScopeKey(l);this.descriptionMap.delete(g)}}class n{get persistent(){return this.collection.persistent}set persistent(l){this.collection.persistent=l}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l,g){this.collection=l,this.scope=g,this._onDidChangeCollection=new w.Emitter}getScoped(l){return this.collection.getScopedEnvironmentVariableCollection(l)}replace(l,g,d){this.collection.replace(l,g,d,this.scope)}append(l,g,d){this.collection.append(l,g,d,this.scope)}prepend(l,g,d){this.collection.prepend(l,g,d,this.scope)}get(l){return this.collection.get(l,this.scope)}forEach(l,g){this.collection.getVariableMap(this.scope).forEach((d,T)=>l.call(g,T,d,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(l){this.collection.delete(l,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(l){this.collection.setDescription(l,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let o=class extends r{constructor(l,g){super(!1,l,g)}createTerminal(l,g,d){throw new P.NotSupportedError}createTerminalFromOptions(l,g){throw new P.NotSupportedError}};e.WorkerExtHostTerminalService=o,e.WorkerExtHostTerminalService=o=Ve([ze(0,c.IExtHostCommands),ze(1,A.IExtHostRpcService)],o);function S(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function h(C){return f.ThemeColor.isThemeColor(C)?C:void 0}function I(C){const l={...C};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}}),define(Ae[252],Re([1,0,281,12,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,56,26]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(x,$,N){this.editors=N,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=x.getProxy(v.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new S(this.proxy),$.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const te=M,Q=te.tests[te.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,f.toItemFromContext)(M)}case 18:{const{extId:te,message:Q}=M;return{test:this.controllers.get(c.TestId.root(te))?.collection.tree.get(te)?.actual,message:t.TestMessage.to(Q)}}default:return M}}}),$.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await $.executeCommand("_testing.getExplorerSelection"),te=Q=>{const Se=this.controllers.get(c.TestId.root(Q));if(Se)return c.TestId.isRoot(Q)?Se.controller:Se.collection.tree.get(Q)?.actual};return{include:M?.include.map(te).filter(D.isDefined)||[],exclude:M?.exclude.map(te).filter(D.isDefined)||[]}})}createTestController(x,$,N,M){if(this.controllers.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const te=new m.DisposableStore,Q=te.add(new f.ExtHostTestItemCollection($,N,this.editors));Q.root.label=N;const Se=new Map,_e=this.proxy,Pe={items:Q.root.children,get label(){return N},set label(ae){N=ae,Q.root.label=ae,_e.$updateController($,{label:N})},get refreshHandler(){return M},set refreshHandler(ae){M=ae,_e.$updateController($,{canRefresh:!!ae})},get id(){return $},createRunProfile:(ae,Ce,le,pe,ie,U)=>{let W=(0,y.hash)(ae);for(;Se.has(W);)W++;return new T(this.proxy,Se,$,W,ae,Ce,le,pe,ie,U)},createTestItem(ae,Ce,le){return new f.TestItemImpl($,ae,Ce,le)},createTestRun:(ae,Ce,le=!0)=>this.runTracker.createTestRun(x,$,Q,ae,Ce,le),invalidateTestResults:ae=>{if(ae===void 0)this.proxy.$markTestRetired(void 0);else{const Ce=ae instanceof Array?ae:[ae];this.proxy.$markTestRetired(Ce.map(le=>c.TestId.fromExtHostTestItem(le,$).toString()))}},set resolveHandler(ae){Q.resolveHandler=ae},get resolveHandler(){return Q.resolveHandler},dispose:()=>{te.dispose()}};_e.$registerTestController($,N,!!M),te.add((0,m.toDisposable)(()=>_e.$unregisterTestController($)));const Y={controller:Pe,collection:Q,profiles:Se,extension:x};return this.controllers.set($,Y),te.add((0,m.toDisposable)(()=>this.controllers.delete($))),te.add(Q.onDidGenerateDiff(ae=>_e.$publishDiff($,ae.map(_.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.observer.checkout()}async runTests(x,$=L.CancellationToken.None){const N=h(x);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(N.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:x.include?.map(te=>c.TestId.fromExtHostTestItem(te,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:z[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:x.exclude?.map(te=>te.id)},$)}$syncTests(){for(const{collection:x}of this.controllers.values())x.flushDiff();return Promise.resolve()}$provideFileCoverage(x,$,N){return(0,w.mapFindFirst)(this.runTracker.trackers,te=>te.id===x?te.getCoverage($):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(x,$,N,M){return(0,w.mapFindFirst)(this.runTracker.trackers,Q=>Q.id===x?Q.getCoverage($):void 0)?.resolveFileCoverage(N,M)??Promise.resolve([])}$configureRunProfile(x,$){this.controllers.get(x)?.profiles.get($)?.configureHandler?.()}async $refreshTests(x,$){await this.controllers.get(x)?.controller.refreshHandler?.($)}$publishTestResults(x){this.results=Object.freeze(x.map($=>(0,P.deepFreeze)(t.TestResults.to($))).concat(this.results).sort(($,N)=>N.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(x,$){const N=this.controllers.get(c.TestId.fromString(x).controllerId)?.collection;N&&(await N.expand(x,$<0?1/0:$),N.flushDiff())}$acceptDiff(x){this.observer.applyDiff(x.map(_.TestsDiffOp.deserialize))}async $runControllerTests(x,$){return Promise.all(x.map(N=>this.runControllerTestRequest(N,!1,$)))}async $startContinuousRun(x,$){const N=new L.CancellationTokenSource($),M=await Promise.all(x.map(te=>this.runControllerTestRequest(te,!0,N.token)));return!$.isCancellationRequested&&!M.some(te=>te.error)&&await new Promise(te=>$.onCancellationRequested(te)),N.dispose(!0),M}async runControllerTestRequest(x,$,N){const M=this.controllers.get(x.controllerId);if(!M)return{};const{collection:te,profiles:Q,extension:Se}=M,_e=Q.get(x.profileId);if(!_e)return{};const Pe=x.testIds.map(le=>te.tree.get(le)).filter(D.isDefined),Y=x.excludeExtIds.map(le=>M.collection.tree.get(le)).filter(D.isDefined).filter(le=>Pe.some(pe=>pe.fullId.compare(le.fullId)===2));if(!Pe.length)return{};const ae=new i.TestRunRequest(Pe.some(le=>le.actual instanceof f.TestItemRootImpl)?void 0:Pe.map(le=>le.actual),Y.map(le=>le.actual),_e,$),Ce=(0,_.isStartControllerTests)(x)&&this.runTracker.prepareForMainThreadTestRun(ae,I.fromInternal(x,M.collection),Se,N);try{return await _e.runHandler(ae,N),{}}catch(le){return{error:String(le)}}finally{Ce&&(Ce.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(Ce.onEnd),Ce.dispose())}}$cancelExtensionTestRun(x){x===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(x)}};e.ExtHostTesting=r,e.ExtHostTesting=r=Ve([ze(0,p.IExtHostRpcService)],r);const s=1e4;var n;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(n||(n={}));class o extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(x,$,N,M){super(),this.dto=x,this.proxy=$,this.extension=N,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(M));const te=this._register(new R.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(x){return this.tasks.get(x)?.coverage}createRun(x){const $=this.dto.id,N=this.dto.controllerId,M=(0,a.generateUuid)(),te=new C(this.proxy,$,M),Q=Y=>(ae,...Ce)=>{if(_e){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(ae)&&(this.ensureTestIsKnown(ae),Y(ae,...Ce))},Se=(Y,ae)=>{const Ce=ae instanceof Array?ae.map(t.TestMessage.from):[t.TestMessage.from(ae)];if(Ce.some(le=>le.contextValue!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),Y.uri&&Y.range){const le={range:t.Range.from(Y.range),uri:Y.uri};for(const pe of Ce)pe.location=pe.location||le}this.proxy.$appendTestMessagesInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),Ce)};let _e=!1;const Pe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:x,get coverageProvider(){return te.coverageProvider},set coverageProvider(Y){te.coverageProvider=Y},enqueued:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),1)}),skipped:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),5)}),started:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),2)}),errored:Q((Y,ae,Ce)=>{Se(Y,ae),this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),6,Ce)}),failed:Q((Y,ae,Ce)=>{Se(Y,ae),this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,N).toString(),4,Ce)}),passed:Q((Y,ae)=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,this.dto.controllerId).toString(),3,ae)}),appendOutput:(Y,ae,Ce)=>{_e||(Ce&&(this.dto.isIncluded(Ce)?this.ensureTestIsKnown(Ce):Ce=void 0),this.proxy.$appendOutputToRun($,M,k.VSBuffer.fromString(Y),ae&&t.location.from(ae),Ce&&c.TestId.fromExtHostTestItem(Ce,N).toString()))},end:()=>{_e||(_e=!0,this.proxy.$finishedTestRunTask($,M),this.tasks.delete(M),this.tasks.size||this.markEnded())}};return this.tasks.set(M,{run:Pe,coverage:te}),this.proxy.$startedTestRunTask($,{id:M,name:x,running:!0}),Pe}forciblyEndTasks(){for(const{run:x}of this.tasks.values())x.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(x){if(!(x instanceof f.TestItemImpl))throw new b.InvalidTestItemError(x.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString()))return;const $=[],N=this.dto.colllection.root;for(;;){const M=t.TestItem.from(x);if($.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),x===N))break;x=x.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}dispose(){this.markEnded(),super.dispose()}}class S{get trackers(){return this.tracked.values()}constructor(x){this.proxy=x,this.tracked=new Map}prepareForMainThreadTestRun(x,$,N,M){return this.getTracker(x,$,N,M)}cancelRunById(x){for(const $ of this.tracked.values())if($.id===x){$.cancel();return}}cancelAllRuns(){for(const x of this.tracked.values())x.cancel()}createTestRun(x,$,N,M,te,Q){const Se=this.tracked.get(M);if(Se)return Se.createRun(te);const _e=I.fromPublic($,N,M,Q),Pe=h(M);this.proxy.$startedExtensionTestRun({controllerId:$,continuous:!!M.continuous,profile:Pe&&{group:z[Pe.kind],id:Pe.profileId},exclude:M.exclude?.map(ae=>c.TestId.fromExtHostTestItem(ae,N.root.id).toString())??[],id:_e.id,include:M.include?.map(ae=>c.TestId.fromExtHostTestItem(ae,N.root.id).toString())??[N.root.id],persist:Q});const Y=this.getTracker(M,_e,x);return A.Event.once(Y.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(_e.id),Y.dispose()}),Y.createRun(te)}getTracker(x,$,N,M){const te=new o($,this.proxy,N,M);return this.tracked.set(x,te),A.Event.once(te.onEnd)(()=>this.tracked.delete(x)),te}}e.TestRunCoordinator=S;const h=H=>{if(H.profile){if(!(H.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class I{static fromPublic(x,$,N,M){return new I(x,(0,a.generateUuid)(),N.include?.map(te=>c.TestId.fromExtHostTestItem(te,x).toString())??[x],N.exclude?.map(te=>c.TestId.fromExtHostTestItem(te,x).toString())??[],M,$)}static fromInternal(x,$){return new I(x.controllerId,x.runId,x.testIds,x.excludeExtIds,!0,$)}constructor(x,$,N,M,te,Q){this.controllerId=x,this.id=$,this.isPersisted=te,this.colllection=Q,this.includePrefix=N.map(Se=>Se+"\0"),this.excludePrefix=M.map(Se=>Se+"\0")}isIncluded(x){const $=c.TestId.fromExtHostTestItem(x,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if($===N||$.startsWith(N))return!1;for(const N of this.includePrefix)if($===N||$.startsWith(N))return!0;return!1}}e.TestRunDto=I;class C{set coverageProvider(x){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");x&&(this._coverageProvider=x,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(x,$,N){this.proxy=x,this.runId=$,this.taskId=N}async provideFileCoverage(x){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(x))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(x,$){const N=await this.fileCoverage;let M=N?.[x];return!this._coverageProvider||!N||!M?[]:(M.detailedCoverage||(M=N[x]=await this._coverageProvider.resolveFileCoverage?.(M,$)??M),M.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class l{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(x){this.emitter=x,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(x){this.added.add(x)}update(x){Object.assign(x.revived,t.TestItem.toPlain(x.item)),this.added.has(x)||this.updated.add(x)}remove(x){if(this.added.has(x)){this.added.delete(x);return}this.updated.delete(x);const $=c.TestId.parentId(x.item.extId);if($&&this.alreadyRemoved.has($.toString())){this.alreadyRemoved.add(x.item.extId);return}this.removed.add(x)}getChangeEvent(){const{added:x,updated:$,removed:N}=this;return{get added(){return[...x].map(M=>M.revived)},get updated(){return[...$].map(M=>M.revived)},get removed(){return[...N].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(x){return this.items.get(x)}getMirroredTestDataByReference(x){return this.items.get(x.id)}createItem(x,$){return{...x,revived:t.TestItem.toPlain(x.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}class d{constructor(x){this.proxy=x}checkout(){this.current||(this.current=this.createObserverData());const x=this.current;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map($=>$.revived)},dispose:(0,u.createSingleCallFunction)(()=>{--x.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(x){return this.current?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.current?.tests.apply(x)}createObserverData(){const x=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:x}}}class T{#e;#t;get label(){return this._label}set label(x){x!==this._label&&(this._label=x,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:x}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(x){x!==this._supportsContinuousRun&&(this._supportsContinuousRun=x,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:x}))}get isDefault(){return this._isDefault}set isDefault(x){x!==this._isDefault&&(this._isDefault=x,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:x?t.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(x){x!==this._configureHandler&&(this._configureHandler=x,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!x}))}constructor(x,$,N,M,te,Q,Se,_e=!1,Pe=void 0,Y=!1){this.controllerId=N,this.profileId=M,this._label=te,this.kind=Q,this.runHandler=Se,this._isDefault=_e,this._tag=Pe,this._supportsContinuousRun=Y,this.#e=x,this.#t=$,$.set(M,this);const ae=z[Q];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:M,controllerId:N,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:te,group:ae,isDefault:_e,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T;const z={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,105,8,7]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(D,a){this._extHostDocumentsAndEditors=a,this._onDidChangeTextEditorSelection=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=D.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(D){const a=this._extHostDocumentsAndEditors.allEditors();return D?a:a.map(v=>v.value)}async showTextDocument(D,a,v){let p;typeof a=="number"?p={position:u.ViewColumn.from(a),preserveFocus:v}:typeof a=="object"?p={position:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?u.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(D.uri,p),t=f&&this._extHostDocumentsAndEditors.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,a){return new A.TextEditorDecorationType(this._proxy,D,a).value}$acceptEditorPropertiesChanged(D,a){const v=this._extHostDocumentsAndEditors.getEditor(D);if(!v)throw new Error("unknown text editor");if(a.options&&v._acceptOptions(a.options),a.selections){const p=a.selections.selections.map(u.Selection.to);v._acceptSelections(p)}if(a.visibleRanges){const p=w.coalesce(a.visibleRanges.map(u.Range.to));v._acceptVisibleRanges(p)}if(a.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...a.options,lineNumbers:u.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const p=y.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(u.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:f,kind:p})}if(a.visibleRanges){const p=w.coalesce(a.visibleRanges.map(u.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const a in D){const v=this._extHostDocumentsAndEditors.getEditor(a);if(!v)throw new Error("Unknown text editor");const p=u.ViewColumn.to(D[a]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this._proxy.$getDiffInformation(D))}}e.ExtHostEditors=m}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class P{constructor(v,p){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=v.getProxy(k.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this._providers.get(f.source)&&y.ExtensionIdentifier.equals(t,this._providers.get(f.source)?.extension)){const i=f.uri===void 0?void 0:w.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(D(i))?.get(f.handle)}else return;return f}})}async $getTimeline(v,p,f,t){return this._providers.get(v)?.provider.provideTimeline(w.URI.revive(p),f,t)}registerTimelineProvider(v,p,f,t){const i=new L.DisposableStore,c=this.convertTimelineItem(p.id,t,i).bind(this);let b;p.onDidChange&&(b=p.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:p.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...p,scheme:v,onDidChange:void 0,async provideTimeline(E,r,s){r?.resetCache&&(i.clear(),_.get(p.id)?.clear());const n=await p.provideTimeline(E,r,s);if(n==null)return;const o=c(E,r);return{...n,source:p.id,items:n.items.map(o)}},dispose(){for(const E of _.values())E.get(p.id)?.clear();b?.dispose(),i.dispose()}},f)}convertTimelineItem(v,p,f){return(t,i)=>{let c;if(i?.cacheResults){let b=this._itemsBySourceAndUriMap.get(v);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(v,b));const _=D(t);c=b.get(_),c===void 0&&(c=new Map,b.set(_,c))}return b=>{const{iconPath:_,...E}=b,r=`${v}|${b.id??b.timestamp}`;c?.set(r,b);let s,n,o;b.iconPath&&(_ instanceof A.ThemeIcon?o={id:_.id,color:_.color}:w.URI.isUri(_)?(s=_,n=_):{light:s,dark:n}=_);let S;return A.MarkdownString.isMarkdownString(E.tooltip)?S=u.MarkdownString.from(E.tooltip):(0,m.isString)(E.tooltip)?S=E.tooltip:A.MarkdownString.isMarkdownString(E.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=u.MarkdownString.from(E.detail)):(0,m.isString)(E.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=E.detail),{...E,id:E.id??void 0,handle:r,source:v,command:b.command?p.toInternal(b.command,f):void 0,icon:s,iconDark:n,themeIcon:o,tooltip:S,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(v,p){if(this._providers.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this._proxy.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this._providers.set(v.id,{provider:v,extension:p}),(0,L.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(v.id)?.clear();this._providers.delete(v.id),this._proxy.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=P;function D(a){return a?.toString()}}),define(Ae[86],Re([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class v extends y.DisposableTunnel{}var p;(function(t){function i(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=i;function c(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==y.TunnelPrivacyId.ConstantPrivate&&b.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=c})(p||(e.TunnelDtoConverter=p={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let f=class extends k.Disposable{constructor(i,c,b){super(),this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new R.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(m.MainContext.MainThreadTunnelService)}async openTunnel(i,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(c,i.displayName);if(b){const _=new v(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(_),_}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,c){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:i,provider:c}),this._proxy.$registerPortsAttributesProvider(i,b),new a.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(i,c,b,_,E){const r=[];for(const n of i){const o=this._portAttributesProviders.get(n);if(!o)return[];r.push(...await Promise.all(c.map(async S=>{let h;try{h=await o.provider.providePortAttributes({port:S,pid:b,commandLine:_},E)}catch{h=await o.provider.providePortAttributes(S,b,_,E)}return{providedAttributes:h,port:S}})))}const s=r.filter(n=>!!n.providedAttributes);return s.length>0?s.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(_,E)=>await i.provideTunnel(_,E,new w.CancellationTokenSource().token)??void 0;const b=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(b),Promise.resolve((0,k.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter());const b=i.tunnelFactory??(c?this.makeManagedTunnelFactory(c):void 0);if(b){this._forwardPortProvider=b;let _=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&_.length===0&&(_=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const E=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:_}:void 0;this._proxy.$setTunnelProvider(E)}}else this._forwardPortProvider=void 0;return(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(i){}async $closeTunnel(i,c){if(this._extensionTunnels.has(i.host)){const b=this._extensionTunnels.get(i.host);b.has(i.port)&&(c&&b.get(i.port).disposeListener.dispose(),await b.get(i.port).tunnel.dispose(),b.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(i,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const _=await b;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),_===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const E=this._register(_.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(_.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:_,disposeListener:E}),p.fromApiTunnel(_)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(_=>this._showCandidatePort(_.host,_.port,_.detail??""))),b=i.filter((_,E)=>c[E]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(_=>_.port).join(", ")} to ${b.map(_=>_.port).join(", ")}`),b}};e.ExtHostTunnelService=f,e.ExtHostTunnelService=f=Ve([ze(0,D.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,u.ILogService)],f)}),define(Ae[255],Re([1,0,6,13,2,3]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,m,P,D){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const a=D.schemes.find(v=>!A.supportedSchemes.has(v));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,P),this._proxy.$registerUriOpener(m,D.schemes,y,D.label),(0,w.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(y,m,P){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const a=k.URI.revive(m);return D.canOpenExternalUri(a,P)}async $openUri(y,m,P){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(k.URI.revive(m.resolvedUri),{sourceUri:k.URI.revive(m.sourceUri)},P)}}e.ExtHostUriOpeners=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,R,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class u{static{this.HandlePool=0}constructor(m){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(m,P){const D=m.identifier;if(this.handles.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const a=u.HandlePool++;return this.handles.add(D),this.handlers.set(a,P),this._proxy.$registerUriHandler(a,D,m.displayName||m.name),(0,k.toDisposable)(()=>{this.handles.delete(D),this.handlers.delete(a),this._proxy.$unregisterUriHandler(a)})}$handleExternalUri(m,P){const D=this.handlers.get(m);if(!D)return Promise.resolve(void 0);try{D.handleUri(R.URI.revive(P))}catch(a){(0,L.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(m){return R.URI.revive(await this._proxy.$createAppUri(m))}}e.ExtHostUrls=u}),define(Ae[63],Re([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(_,E,r,s,n,o,S){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new w.Emitter,this._onDidDispose=this.#d.event,this.#e=_,this.#t=E,this.#r=r,this.#u=s,this.#l=n,this.#n=o,this.#c=a(o),this.#h=v(o),this.#i=S}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return this.#a=!0,(0,m.asWebviewUri)(_,this.#u)}get cspSource(){const _=this.#n.extensionLocation;if(_.scheme===k.Schemas.https||_.scheme===k.Schemas.http){let E=_.toString();return E.endsWith("/")||(E+="/"),E+" "+m.webviewGenericCspSource}return m.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(_)))}get options(){return this.assertNotDisposed(),this.#r}set options(_){this.assertNotDisposed(),L.equals(this.#r,_)||this.#t.$setOptions(this.#e,t(this.#n,this.#l,_)),this.#r=_}async postMessage(_){if(this.#o)return!1;const E=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,E.message,...E.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(_){if(!this.#h)return _;const E=this.#n.extensionLocation?.scheme===k.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===k.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return _.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,S,h,I)=>{const C=A.URI.from({scheme:S||"file",path:decodeURIComponent(h)}),l=(0,m.asWebviewUri)(C,{isRemote:E,authority:r}).toString();return`${n}${l}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,S,h,I)=>{const C=A.URI.from({scheme:S||"file",path:decodeURIComponent(h)}),l=(0,m.asWebviewUri)(C,{isRemote:E,authority:r}).toString();return`${n}${l}${I}`})}}e.ExtHostWebview=D;function a(b){try{const _=(0,u.normalizeVersion)((0,u.parseVersion)(b.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function v(b){try{const _=(0,u.normalizeVersion)((0,u.parseVersion)(b.engines.vscode));return _?_.majorBase<1||_.majorBase===1&&_.minorBase<60:!1}catch{return!1}}class p extends R.Disposable{constructor(_,E,r,s,n){super(),this.remoteInfo=E,this.workspace=r,this._logService=s,this._deprecationService=n,this._webviews=new Map,this._webviewProxy=_.getProxy(P.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const _ of this._webviews.values())_.dispose();this._webviews.clear()}$onMessage(_,E,r){const s=this.getWebview(_);if(s){const{message:n}=(0,y.deserializeWebviewMessage)(E,r.value);s._onMessageEmitter.fire(n)}}$onMissingCsp(_,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,E,r){const s=new D(_,this._webviewProxy,i(E),this.remoteInfo,this.workspace,r,this._deprecationService);this._webviews.set(_,s);const n=s._onDidDispose(()=>{n.dispose(),this.deleteWebview(_)});return s}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=p;function f(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=f;function t(b,_,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||c(b,_)}}e.serializeWebviewOptions=t;function i(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(_=>A.URI.from(_))}}function c(b,_){return[...(_?.getWorkspaceFolders()||[]).map(E=>E.uri),b.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,13,23,2,8,63,74,3,7]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(s,n){this.document=s,this._storagePath=n,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,n){await this.getEdit(s).undo(),n||this.disposeBackup()}async redo(s,n){await this.getEdit(s).redo(),n||this.disposeBackup()}disposeEdits(s){for(const n of s)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=E(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const n=this._edits.get(s,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this._documents=new Map}get(s,n){return this._documents.get(this.key(s,n))}add(s,n,o){const S=this.key(s,n.uri);if(this._documents.has(S))throw new Error(`Document already exists for viewType:${s} resource:${n.uri}`);const h=new v(n,o);return this._documents.set(S,h),h}delete(s,n){const o=this.key(s,n.uri);this._documents.delete(o)}key(s,n){return`${s}@@@${n}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this._providers=new Map}addTextProvider(s,n,o){return this.add(0,s,n,o)}addCustomProvider(s,n,o){return this.add(1,s,n,o)}get(s){return this._providers.get(s)}add(s,n,o,S){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:s,extension:o,provider:S}),new a.Disposable(()=>this._providers.delete(n))}}class i{constructor(s,n,o,S,h){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=S,this._extHostWebviewPanels=h,this._editorProviders=new t,this._documents=new p,this._proxy=s.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,n,o,S){const h=new k.DisposableStore;return b(o)?(h.add(this._editorProviders.addTextProvider(n,s,o)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(s),n,S.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(s))):(h.add(this._editorProviders.addCustomProvider(n,s,o)),c(o)&&h.add(o.onDidChangeCustomDocument(I=>{const C=this.getCustomDocumentEntry(n,I.document.uri);if(_(I)){const l=C.addEdit(I);this._proxy.$onDidEdit(I.document.uri,n,l,I.label)}else this._proxy.$onContentChange(I.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(s),n,S.webviewOptions||{},!!S.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(s))),a.Disposable.from(h,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(s,n,o,S,h){const I=this._editorProviders.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const C=u.URI.revive(s),l=await I.provider.openCustomDocument(C,{backupId:o,untitledDocumentData:S?.buffer},h);let g;return c(I.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(I.extension)??this._extensionStoragePaths.globalValue(I.extension)),this._documents.add(n,l,g),{editable:c(I.provider)}}async $disposeCustomDocument(s,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const S=u.URI.revive(s),{document:h}=this.getCustomDocumentEntry(n,S);this._documents.delete(n,h),h.dispose()}async $resolveCustomEditor(s,n,o,S,h,I){const C=this._editorProviders.get(o);if(!C)throw new Error(`No provider found for '${o}'`);const l=y.ViewColumn.to(h),g=this._extHostWebview.createNewWebview(n,S.contentOptions,C.extension),d=this._extHostWebviewPanels.createNewWebviewPanel(n,o,S.title,l,S.options,g,S.active),T=u.URI.revive(s);switch(C.type){case 1:{const{document:z}=this.getCustomDocumentEntry(o,T);return C.provider.resolveCustomEditor(z,d,I)}case 0:{const z=this._extHostDocuments.getDocument(T);return C.provider.resolveCustomTextEditor(z,d,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,n,o){this.getCustomDocumentEntry(n,s).disposeEdits(o)}async $onMoveCustomEditor(s,n,o){const S=this._editorProviders.get(o);if(!S)throw new Error(`No provider found for '${o}'`);if(!S.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const h=this._extHostWebviewPanels.getWebviewPanel(s);if(!h)throw new Error("No webview found");const I=u.URI.revive(n),C=this._extHostDocuments.getDocument(I);await S.provider.moveCustomTextEditor(C,h,w.CancellationToken.None)}async $undo(s,n,o,S){return this.getCustomDocumentEntry(n,s).undo(o,S)}async $redo(s,n,o,S){return this.getCustomDocumentEntry(n,s).redo(o,S)}async $revert(s,n,o){const S=this.getCustomDocumentEntry(n,s);await this.getCustomEditorProvider(n).revertCustomDocument(S.document,o),S.disposeBackup()}async $onSave(s,n,o){const S=this.getCustomDocumentEntry(n,s);await this.getCustomEditorProvider(n).saveCustomDocument(S.document,o),S.disposeBackup()}async $onSaveAs(s,n,o,S){const h=this.getCustomDocumentEntry(n,s);return this.getCustomEditorProvider(n).saveCustomDocumentAs(h.document,u.URI.revive(o),S)}async $backup(s,n,o){const S=this.getCustomDocumentEntry(n,s),I=await this.getCustomEditorProvider(n).backupCustomDocument(S.document,{destination:S.getNewBackupUri()},o);return S.updateBackup(I),I.id}getCustomDocumentEntry(s,n){const o=this._documents.get(s,u.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(s){const o=this._editorProviders.get(s)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=i;function c(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function _(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function E(r){const s=r.scheme===L.Schemas.file||r.scheme===L.Schemas.untitled?r.fsPath:r.toString();return(0,R.hash)(s)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(p,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new w.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new w.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=p,this.#t=f,this.#u=t,this.#i=i.viewType,this.#l=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(p){this.assertNotDisposed(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(p){this.assertNotDisposed(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,k.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(p,f){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!f})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class D extends R.Disposable{static newHandle(){return(0,L.generateUuid)()}constructor(p,f,t){super(),this.webviews=f,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(p=>p.dispose()),this._webviewPanels.clear()}createWebviewPanel(p,f,t,i,c={}){const b=typeof i=="object"?i.viewColumn:i,_={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof i=="object"&&!!i.preserveFocus},E=(0,u.shouldSerializeBuffersForPostMessage)(p),r=D.newHandle();this._proxy.$createWebviewPanel((0,u.toExtensionData)(p),r,f,{title:t,panelOptions:a(c),webviewOptions:(0,u.serializeWebviewOptions)(p,this.workspace,c),serializeBuffersForPostMessage:E},_);const s=this.webviews.createNewWebview(r,c,p);return this.createNewWebviewPanel(r,f,t,b,c,s,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const c=p[t],b=p[i];return c.active?1:b.active?-1:+c.visible-+b.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const c=p[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:t,extension:p}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(p)}),new m.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const c=this._serializers.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:b,extension:_}=c,E=this.webviews.createNewWebview(p,t.webviewOptions,_),r=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,E,t.active);await b.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,f,t,i,c,b,_){const E=new P(p,this._proxy,b,{viewType:f,title:t,viewColumn:i,panelOptions:c,active:_});return this._webviewPanels.set(p,E),E}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=D;function a(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,63,8,3,7]),function(be,e,w,R,k,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(D,a,v,p,f,t){super(),this.#l=!1,this.#a=this._register(new w.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new w.Emitter),this.onDidDispose=this.#c.event,this.#i=v,this.#s=p,this.#e=D,this.#t=a,this.#u=f,this.#n=t}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.assertNotDisposed(),this.#r}set description(D){this.assertNotDisposed(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#l||(this.#n=D,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(D){this.assertNotDisposed(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.assertNotDisposed(),this.#t.$show(this.#e,!!D)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class m{constructor(D,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(D,a,v,p){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:v,extension:D}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(D),a,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(D)}),new u.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(D,a,v,p,f){const t=this._viewProviders.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:c}=t,b=this._extHostWebview.createNewWebview(D,{},c),_=new y(D,this._proxy,a,v,b,!0);this._webviewViews.set(D,_),await i.resolveWebviewView(_,{state:p},f)}async $onDidChangeWebviewViewVisibility(D,a){this.getWebviewView(D)._setVisible(a)}async $disposeWebviewView(D){const a=this.getWebviewView(D);this._webviewViews.delete(D),a.dispose(),this._extHostWebview.deleteWebview(D)}getWebviewView(D){const a=this._webviewViews.get(D);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=m}),define(Ae[108],Re([1,0,5,3,2,13,15,4,17,26]),function(be,e,w,R,k,L,A,u,y,m){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class{static{P=this}static{this.InitialState={focused:!0,active:!0}}getState(v){const p=this._state;return{get focused(){return p.focused},get active(){return(0,m.checkProposedApiEnabled)(v,"windowActivity"),p.active}}}constructor(v){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=P.InitialState,this._proxy=v.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this._state[v]&&(this._state={...this._state,[v]:p},this._onDidChangeWindowState.fire(this._state))}openUri(v,p){let f;if(typeof v=="string"){f=v;try{v=k.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,A.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,f,p)}async asExternalUri(v,p){if((0,A.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(v,p);return k.URI.from(f)}};e.ExtHostWindow=D,e.ExtHostWindow=D=P=Ve([ze(0,y.IExtHostRpcService)],D),e.IExtHostWindow=(0,u.createDecorator)("IExtHostWindow")}),define(Ae[260],Re([1,0,226,27,17]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends w.AbstractExtHostConsoleForwarder{constructor(u,y){super(u,y)}_nativeConsoleLogMessage(u,y,m){y.apply(console,m)}};e.ExtHostConsoleForwarder=L,e.ExtHostConsoleForwarder=L=Ve([ze(0,k.IExtHostRpcService),ze(1,R.IExtHostInitDataService)],L)}),define(Ae[261],Re([1,0,12,25,21,9,5,6,132,215,46]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(d,T){try{return JSON.stringify(d,T)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class f{constructor(T,z){this.jsonString=T,this.referencedBuffers=z}}function t(d,T=null,z=!1){const H=[];return{jsonString:(z?a:JSON.stringify)(d,($,N)=>{if(typeof N>"u")return p;if(typeof N=="object"){if(N instanceof R.VSBuffer){const M=H.push(N)-1;return{[v]:M}}if(T)return T($,N)}return N}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=t;function i(d,T,z){return JSON.parse(d,(H,x)=>{if(x){const $=x[v];if(typeof $=="number")return T[$];if(z&&x.$mid===1)return z.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=i;function c(d,T){return JSON.stringify(d,T)}function b(d){return d?(T,z)=>z&&z.$mid===1?d.transformOutgoing(z):z:null}var _;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(_||(e.RequestInitiator=_={}));var E;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(E||(e.ResponsiveState=E={}));const r=()=>{},s=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends u.Disposable{static{D=s}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(T,z=null,H=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=z,this._uriTransformer=H,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,$=P.ProxyIdentifier.count;x<$;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{const z=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],z.resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,y.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:z,sid:H}=T;return this._proxies[z]||(this._proxies[z]=this._createProxy(z,H)),this._proxies[z]}_createProxy(T,z){const H={get:(x,$)=>(typeof $=="string"&&!x[$]&&$.charCodeAt(0)===36&&(x[$]=(...N)=>this._remoteCall(T,$,N)),$===n?z:x[$])};return new Proxy(Object.create(null),H)}set(T,z){return this._locals[T.nid]=z,z}assertRegistered(T){for(let z=0,H=T.length;z<H;z++){const x=T[z];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const z=T.byteLength,H=h.read(T,0),x=H.readUInt8(),$=H.readUInt32();switch(x){case 1:case 2:{let{rpcId:N,method:M,args:te}=C.deserializeRequestJSONArgs(H);this._uriTransformer&&(te=(0,y.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(z,$,N,M,te,x===2);break}case 3:case 4:{let{rpcId:N,method:M,args:te}=C.deserializeRequestMixedArgs(H);this._uriTransformer&&(te=(0,y.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(z,$,N,M,te,x===4);break}case 5:{this._logger?.logIncoming(z,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(z,$);break}case 7:{this._receiveReply(z,$,void 0);break}case 9:{let N=C.deserializeReplyOKJSON(H);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(z,$,N);break}case 10:{const N=C.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(z,$,N);break}case 8:{const N=C.deserializeReplyOKVSBuffer(H);this._receiveReply(z,$,N);break}case 11:{let N=C.deserializeReplyErrError(H);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(z,$,N);break}case 12:{this._receiveReplyErr(z,$,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,z,H,x,$,N){this._logger?.logIncoming(T,z,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(H)}.${x}(`,$);const M=String(z);let te,Q;if(N){const _e=new k.CancellationTokenSource;$.push(_e.token),te=this._invokeHandler(H,x,$),Q=()=>_e.cancel()}else te=this._invokeHandler(H,x,$),Q=r;this._cancelInvokedHandlers[M]=Q;const Se=C.serializeAcknowledged(z);this._logger?.logOutgoing(Se.byteLength,z,1,"ack"),this._protocol.send(Se),te.then(_e=>{delete this._cancelInvokedHandlers[M];const Pe=C.serializeReplyOK(z,_e,this._uriReplacer);this._logger?.logOutgoing(Pe.byteLength,z,1,"reply:",_e),this._protocol.send(Pe)},_e=>{delete this._cancelInvokedHandlers[M];const Pe=C.serializeReplyErr(z,_e);this._logger?.logOutgoing(Pe.byteLength,z,1,"replyErr:",_e),this._protocol.send(Pe)})}_receiveCancel(T,z){this._logger?.logIncoming(T,z,1,"receiveCancel");const H=String(z);this._cancelInvokedHandlers[H]?.()}_receiveReply(T,z,H){this._logger?.logIncoming(T,z,0,"receiveReply:",H);const x=String(z);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const $=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],$.resolveOk(H)}_receiveReplyErr(T,z,H){this._logger?.logIncoming(T,z,0,"receiveReplyErr:",H);const x=String(z);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const $=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let N;H&&(H.$isError?(N=new Error,N.name=H.name,N.message=H.message,N.stack=H.stack):N=H),$.resolveErr(N)}_invokeHandler(T,z,H){try{return Promise.resolve(this._doInvokeHandler(T,z,H))}catch(x){return Promise.reject(x)}}_doInvokeHandler(T,z,H){const x=this._locals[T];if(!x)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(T));const $=x[z];if(typeof $!="function")throw new Error("Unknown method "+z+" on actor "+(0,P.getStringIdentifierForProxy)(T));return $.apply(x,H)}_remoteCall(T,z,H){if(this._isDisposed)return new m.CanceledLazyPromise;let x=null;if(H.length>0&&k.CancellationToken.isCancellationToken(H[H.length-1])&&(x=H.pop()),x&&x.isCancellationRequested)return Promise.reject(L.canceled());const $=C.serializeRequestArguments(H,this._uriReplacer),N=++this._lastMessageId,M=String(N),te=new m.LazyPromise,Q=new u.DisposableStore;x&&Q.add(x.onCancellationRequested(()=>{const _e=C.serializeCancel(N);this._logger?.logOutgoing(_e.byteLength,N,0,"cancel"),this._protocol.send(C.serializeCancel(N))})),this._pendingRPCReplies[M]=new S(te,Q),this._onWillSendRequest(N);const Se=C.serializeRequest(N,T,z,$,!!x);return this._logger?.logOutgoing(Se.byteLength,N,0,`request: ${(0,P.getStringIdentifierForProxy)(T)}.${z}(`,H),this._protocol.send(Se),te}}e.RPCProtocol=o;class S{constructor(T,z){this._promise=T,this._disposable=z}resolveOk(T){this._promise.resolveOk(T),this._disposable.dispose()}resolveErr(T){this._promise.resolveErr(T),this._disposable.dispose()}}class h{static alloc(T,z,H){const x=new h(R.VSBuffer.alloc(H+1+4),0);return x.writeUInt8(T),x.writeUInt32(z),x}static read(T,z){return new h(T,z)}get buffer(){return this._buff}constructor(T,z){this._buff=T,this._offset=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,H}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,H}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,z}static sizeMixedArray(T){let z=0;z+=1;for(let H=0,x=T.length;H<x;H++){const $=T[H];switch(z+=1,$.type){case 1:z+=this.sizeLongString($.value);break;case 2:z+=this.sizeVSBuffer($.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString($.value);for(let N=0;N<$.buffers.length;++N)z+=this.sizeVSBuffer($.buffers[N]);break;case 4:break}}return z}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let z=0,H=T.length;z<H;z++){const x=T[z];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let $=0;$<x.buffers.length;++$)this.writeBuffer(x.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const z=new Array(T);for(let H=0;H<T;H++)switch(this.readUInt8()){case 1:z[H]=this.readLongString();break;case 2:z[H]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),N=this.readLongString(),M=[];for(let te=0;te<$;++te)M.push(this.readVSBuffer());z[H]=new P.SerializableObjectWithBuffers(i(N,M,null));break}case 4:z[H]=void 0;break}return z}}var I;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(I||(I={}));class C{static _useMixedArgSerialization(T){for(let z=0,H=T.length;z<H;z++)if(T[z]instanceof R.VSBuffer||T[z]instanceof P.SerializableObjectWithBuffers||typeof T[z]>"u")return!0;return!1}static serializeRequestArguments(T,z){if(this._useMixedArgSerialization(T)){const H=[];for(let x=0,$=T.length;x<$;x++){const N=T[x];if(N instanceof R.VSBuffer)H[x]={type:2,value:N};else if(typeof N>"u")H[x]={type:4};else if(N instanceof P.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:te}=t(N.value,z);H[x]={type:3,value:R.VSBuffer.fromString(M),buffers:te}}else H[x]={type:1,value:R.VSBuffer.fromString(c(N,z))}}return{type:1,args:H}}return{type:0,args:c(T,z)}}static serializeRequest(T,z,H,x,$){switch(x.type){case 0:return this._requestJSONArgs(T,z,H,x.args,$);case 1:return this._requestMixedArgs(T,z,H,x.args,$)}}static _requestJSONArgs(T,z,H,x,$){const N=R.VSBuffer.fromString(H),M=R.VSBuffer.fromString(x);let te=0;te+=h.sizeUInt8(),te+=h.sizeShortString(N),te+=h.sizeLongString(M);const Q=h.alloc($?2:1,T,te);return Q.writeUInt8(z),Q.writeShortString(N),Q.writeLongString(M),Q.buffer}static deserializeRequestJSONArgs(T){const z=T.readUInt8(),H=T.readShortString(),x=T.readLongString();return{rpcId:z,method:H,args:JSON.parse(x)}}static _requestMixedArgs(T,z,H,x,$){const N=R.VSBuffer.fromString(H);let M=0;M+=h.sizeUInt8(),M+=h.sizeShortString(N),M+=h.sizeMixedArray(x);const te=h.alloc($?4:3,T,M);return te.writeUInt8(z),te.writeShortString(N),te.writeMixedArray(x),te.buffer}static deserializeRequestMixedArgs(T){const z=T.readUInt8(),H=T.readShortString(),x=T.readMixedArray(),$=new Array(x.length);for(let N=0,M=x.length;N<M;N++){const te=x[N];typeof te=="string"?$[N]=JSON.parse(te):$[N]=te}return{rpcId:z,method:H,args:$}}static serializeAcknowledged(T){return h.alloc(5,T,0).buffer}static serializeCancel(T){return h.alloc(6,T,0).buffer}static serializeReplyOK(T,z,H){if(typeof z>"u")return this._serializeReplyOKEmpty(T);if(z instanceof R.VSBuffer)return this._serializeReplyOKVSBuffer(T,z);if(z instanceof P.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:$}=t(z.value,H,!0);return this._serializeReplyOKJSONWithBuffers(T,x,$)}else return this._serializeReplyOKJSON(T,a(z,H))}static _serializeReplyOKEmpty(T){return h.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,z){let H=0;H+=h.sizeVSBuffer(z);const x=h.alloc(8,T,H);return x.writeVSBuffer(z),x.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,z){const H=R.VSBuffer.fromString(z);let x=0;x+=h.sizeLongString(H);const $=h.alloc(9,T,x);return $.writeLongString(H),$.buffer}static _serializeReplyOKJSONWithBuffers(T,z,H){const x=R.VSBuffer.fromString(z);let $=0;$+=h.sizeUInt32,$+=h.sizeLongString(x);for(const M of H)$+=h.sizeVSBuffer(M);const N=h.alloc(10,T,$);N.writeUInt32(H.length),N.writeLongString(x);for(const M of H)N.writeBuffer(M);return N.buffer}static deserializeReplyOKJSON(T){const z=T.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(T,z){const H=T.readUInt32(),x=T.readLongString(),$=[];for(let N=0;N<H;++N)$.push(T.readVSBuffer());return new P.SerializableObjectWithBuffers(i(x,$,z))}static serializeReplyErr(T,z){const H=z?a(L.transformErrorForSerialization(z),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(T);const x=R.VSBuffer.fromString(H);let $=0;$+=h.sizeLongString(x);const N=h.alloc(11,T,$);return N.writeLongString(x),N.buffer}static deserializeReplyErrError(T){const z=T.readLongString();return JSON.parse(z)}static _serializeReplyErrEmpty(T){return h.alloc(12,T,0).buffer}}var l;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var g;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(g||(g={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(L){const A=u=>{globalThis.removeEventListener("message",A);const y=u.data;Object.defineProperties(globalThis,{postMessage:{value(m,P){y.postMessage(m,P)}},onmessage:{get(){return y.onmessage},set(m){y.onmessage=m}}}),y.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(L,A,u){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${A}'))`,m=new Blob([y],{type:"application/javascript"}),P=URL.createObjectURL(m),D=new MessageChannel,a=P,v={type:"_newWorker",id:a,port:D.port2,url:P,options:u};L(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),D.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),D.port1.start()}}e.NestedWorker=R}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var A;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class u{constructor(){this.channels=new Map,this._onDidRegisterChannel=new w.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new w.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(P=>m.push(P)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}R.Registry.add(e.Extensions.OutputChannels,new u),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,20,14,263,61,27,39,129,25,16,38,5,6]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class i extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(E,r,s,n,o){super(),this.id=E,this.name=r,this.logger=s,this.proxy=n,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(s.getLevel()),this._register(s.onDidChangeLogLevel(S=>this.setLevel(S)))}get logLevel(){return this.getLevel()}appendLine(E){this.append(E+`
`)}append(E){this.info(E)}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,u.OutputChannelUpdateMode.Clear,E)}replace(E){const r=this.offset;this.info(E),this.proxy.$update(this.id,u.OutputChannelUpdateMode.Replace,r),this.visible&&this.logger.flush()}show(E,r){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:r))}hide(){this.proxy.$close(this.id)}log(E,r){this.offset+=a.VSBuffer.fromString(r).byteLength,(0,A.log)(this.logger,E,r),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,u.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends i{appendLine(E){this.append(E)}}let b=class{constructor(E,r,s,n,o,S){this.initData=r,this.extHostFileSystem=s,this.extHostFileSystemInfo=n,this.loggerService=o,this.logService=S,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(w.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[r,s]of this.channels)s.visible=r===this.visibleChannelId}createOutputChannel(E,r,s){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,o=(0,v.isString)(r)?r:void 0;if((0,v.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let S;const h=this.initData.environment.extensionLogLevel?.find(([C])=>L.ExtensionIdentifier.equals(s.identifier,C))?.[1];h&&(S=(0,A.parseLogLevel)(h));const I=n?this.doCreateLogOutputChannel(E,S,s):this.doCreateOutputChannel(E,o,s);return I.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),n?this.createExtHostLogOutputChannel(E,S??this.logService.getLevel(),I):this.createExtHostOutputChannel(E,I)}async doCreateOutputChannel(E,r,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const n=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(n,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),S=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.proxy.$register(E,o,r,s.identifier.value);return new i(h,E,S,this.proxy,s)}async doCreateLogOutputChannel(E,r,s){const n=await this.createExtensionLogDirectory(s),o=E.replace(/[\\/:\*\?"<>\|]/g,""),S=this.extHostFileSystemInfo.extUri.joinPath(n,`${o}.log`),h=`${s.identifier.value}.${o}`,I=this.loggerService.createLogger(S,{id:h,name:E,logLevel:r,extensionId:s.identifier.value});return new c(h,E,I,this.proxy,s)}createExtensionLogDirectory(E){let r=this.extensionLogDirectoryPromise.get(E.identifier.value);if(!r){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,E.identifier.value);this.extensionLogDirectoryPromise.set(E.identifier.value,r=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return s})())}return r}createExtHostOutputChannel(E,r){let s=!1;const n=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return E},append(o){n(),r.then(S=>S.append(o))},appendLine(o){n(),r.then(S=>S.appendLine(o))},clear(){n(),r.then(o=>o.clear())},replace(o){n(),r.then(S=>S.replace(o))},show(o,S){n(),r.then(h=>h.show(o,S))},hide(){n(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}createExtHostLogOutputChannel(E,r,s){const n=new t.DisposableStore,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},S=n.add(new f.Emitter);function h(I){r=I,S.fire(I)}return s.then(I=>{n.add(I),I.logLevel!==r&&h(I.logLevel),n.add(I.onDidChangeLogLevel(C=>h(C)))}),{...this.createExtHostOutputChannel(E,s),get logLevel(){return r},onDidChangeLogLevel:S.event,trace(I,...C){o(),s.then(l=>l.trace(I,...C))},debug(I,...C){o(),s.then(l=>l.debug(I,...C))},info(I,...C){o(),s.then(l=>l.info(I,...C))},warn(I,...C){o(),s.then(l=>l.warn(I,...C))},error(I,...C){o(),s.then(l=>l.error(I,...C))},dispose(){n.dispose()}}}};e.ExtHostOutputService=b,e.ExtHostOutputService=b=Ve([ze(0,k.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,P.IExtHostFileSystemInfo),ze(4,A.ILoggerService),ze(5,A.ILogService)],b),e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,12]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let L=1/0;for(let u=0;u<this.maxSampleCount;u++){const y=await k.getRoundTripTime();if(y===void 0)return;L=Math.min(L,y/2),await(0,R.timeout)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((u,y)=>u+y,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((u,y)=>u+y,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,13,19,22,23,2,4,186,54,208,264]),function(be,e,w,R,k,L,A,u,y,m,P,D,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let p=v=class{constructor(t,i,c,b){this.localUserHome=t,this.remoteAgentService=i,this.environmentService=c,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.resolveOS.then(b=>this.doHasValidBasename(t,b,i)):this.doHasValidBasename(t,i,c)}doHasValidBasename(t,i,c){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,w.isValidBasename)(c??(0,A.basename)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const c=(0,m.getVirtualWorkspaceScheme)(i.getWorkspace());if(c)return c;const b=i.getWorkspace().folders[0];if(b)return b.uri.scheme;const _=i.getWorkspace().configuration;return _?_.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?k.win32:k.posix)}async fileURI(t){let i="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(i=t.substring(2),t="/"):(i=t.substring(2,b),t=t.substring(b)||"/")}return u.URI.from({scheme:R.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.AbstractPathService=p,e.AbstractPathService=p=v=Ve([ze(1,a.IRemoteAgentService),ze(2,D.IWorkbenchEnvironmentService),ze(3,P.IWorkspaceContextService)],p)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(A,u){this.line=A,this.character=u}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,u){return new w(0,0)}with(A){return new w(0,0)}}e.Position=w;class R{constructor(A,u,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,u),this.end=new w(y,m)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,110,12]),function(be,e,w,R,k,L,A,u,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",v=" characters skipped \u27EB",p=(a.length+v.length+5)*2;e.ISearchService=(0,u.createDecorator)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Y){return!!Y.preview}e.resultIsMatch=i;function c(Y){return!!Y.resource}e.isFileMatch=c;function b(Y){return!!Y.message}e.isProgressMessage=b;var _;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(_||(e.SearchCompletionExitCode=_={}));class E{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=E;class r{constructor(ae,Ce,le,pe){this.ranges=Ce,this.webviewIndex=pe;const ie=Array.isArray(Ce)?Ce:[Ce];if(le&&le.matchLines===1&&s(ie)){ae=(0,A.getNLines)(ae,le.matchLines);let U="",W=0,ue=0;const we=Math.floor(le.charsPerLine/5),Ee=[];for(const ge of ie){const ye=Math.max(ge.startColumn-we,0),re=ge.startColumn+le.charsPerLine;if(ye>ue+we+p){const de=a+(ye-ue)+v;U+=de+ae.slice(ye,re),W+=ye-(ue+de.length)}else U+=ae.slice(ue,re);Ee.push(new o(0,ge.startColumn-W,ge.endColumn-W)),ue=re}this.preview={text:U,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const U=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ae,matches:(0,w.mapArrayOrNot)(Ce,W=>new n(W.startLineNumber-U,W.startColumn,W.endLineNumber-U,W.endColumn))}}}}e.TextSearchMatch=r;function s(Y){const ae=Y[0].startLineNumber;for(const Ce of Y)if(Ce.startLineNumber!==ae||Ce.endLineNumber!==ae)return!1;return!0}class n{constructor(ae,Ce,le,pe){this.startLineNumber=ae,this.startColumn=Ce,this.endLineNumber=le,this.endColumn=pe}}e.SearchRange=n;class o extends n{constructor(ae,Ce,le){super(ae,Ce,ae,le)}}e.OneLineRange=o;var S;(function(Y){Y.List="list",Y.Tree="tree"})(S||(e.ViewMode=S={}));var h;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function I(Y,ae=!0){const Ce=Y&&Y.files&&Y.files.exclude,le=ae&&Y&&Y.search&&Y.search.exclude;if(!Ce&&!le)return;if(!Ce||!le)return Ce||le;let pe=Object.create(null);return pe=k.mixin(pe,k.deepClone(Ce)),pe=k.mixin(pe,k.deepClone(le),!0),pe}e.getExcludes=I;function C(Y,ae){return Y.excludePattern&&R.match(Y.excludePattern,ae)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&R.match(Y.includePattern,ae)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(Ce=>{const le=Ce.folder.fsPath;if(L.isEqualOrParent(ae,le)){const pe=y.relative(le,ae);return!Ce.includePattern||!!R.match(Ce.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=C;var l;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(l||(e.SearchErrorCode=l={}));class g extends Error{constructor(ae,Ce){super(ae),this.code=Ce}}e.SearchError=g;function d(Y){const ae=Y.message;if((0,m.isCancellationError)(Y))return new g(ae,l.canceled);try{const Ce=JSON.parse(ae);return new g(Ce.message,Ce.code)}catch{return new g(ae,l.other)}}e.deserializeSearchError=d;function T(Y){const ae={message:Y.message,code:Y.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=T;function z(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=z;function H(Y){return Y.type==="success"}e.isSerializedSearchSuccess=H;function x(Y){return!!Y.path}e.isSerializedFileMatch=x;function $(Y,ae){const Ce=Y.searchPath?Y.searchPath:Y.relativePath;return(0,A.fuzzyContains)(Ce,ae)}e.isFilePatternMatch=$;class N{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function M(Y,ae){const Ce={...Y||{},...ae||{}};return Object.keys(Ce).filter(le=>{const pe=Ce[le];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=M;class te{constructor(ae,Ce){this._parsedIncludeExpression=null,this._excludeExpression={...ae.excludePattern||{},...Ce.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let le=ae.includePattern;Ce.includePattern&&(le?le={...le,...Ce.includePattern}:le=Ce.includePattern),le&&(this._parsedIncludeExpression=R.parse(le))}matchesExcludesSync(ae,Ce,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,Ce,le))}includedInQuerySync(ae,Ce,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,Ce,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ae,Ce,le))}includedInQuery(ae,Ce,le){const pe=this._parsedExcludeExpression(ae,Ce,le),ie=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ae,Ce,le):!0;return(0,D.isThenable)(pe)?pe.then(U=>U?!1:ie()):ie()}hasSiblingExcludeClauses(){return Q(this._excludeExpression)}}e.QueryGlobTester=te;function Q(Y){for(const ae in Y)if(typeof Y[ae]!="boolean")return!0;return!1}function Se(Y){if(!Y)return;let ae;return Ce=>(ae||(ae=(Y()||Promise.resolve([])).then(le=>le?Pe(le):{})),ae.then(le=>!!le[Ce]))}e.hasSiblingPromiseFn=Se;function _e(Y){if(!Y)return;let ae;return Ce=>{if(!ae){const le=Y();ae=le?Pe(le):{}}return!!ae[Ce]}}e.hasSiblingFn=_e;function Pe(Y){const ae={};for(const Ce of Y)ae[Ce]=!0;return ae}}),define(Ae[33],Re([1,0,18,12,21,5,6,49,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,55,47,3]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function S(z,H,x){return new P.ExtUri($=>l($,x)).isEqual(z,H)}function h(z,H,x){return S(z.uri,H.uri,x)?0:(0,D.compare)(z.uri.toString(),H.uri.toString())}function I(z,H,x){return z.index!==H.index?z.index<H.index?-1:1:S(z.uri,H.uri,x)?(0,D.compare)(z.name,H.name):(0,D.compare)(z.uri.toString(),H.uri.toString())}function C(z,H,x,$){const N=z.slice(0).sort((te,Q)=>x(te,Q,$)),M=H.slice(0).sort((te,Q)=>x(te,Q,$));return(0,w.delta)(N,M,(te,Q)=>x(te,Q,$))}function l(z,H){const x=H.getCapabilities(z.scheme);return!(x&&x&1024)}class g extends i.Workspace{static toExtHostWorkspace(H,x,$,N){if(!H)return{workspace:null,added:[],removed:[]};const{id:M,name:te,folders:Q,configuration:Se,transient:_e,isUntitled:Pe}=H,Y=[],ae=x;x?Q.forEach((ie,U)=>{const W=a.URI.revive(ie.uri),ue=g._findFolder($||x,W,N);ue?(ue.name=ie.name,ue.index=ie.index,Y.push(ue)):Y.push({uri:W,name:ie.name,index:U})}):Y.push(...Q.map(({uri:ie,name:U,index:W})=>({uri:a.URI.revive(ie),name:U,index:W}))),Y.sort((ie,U)=>ie.index<U.index?-1:1);const Ce=new g(M,te,Y,!!_e,Se?a.URI.revive(Se):null,!!Pe,ie=>l(ie,N)),{added:le,removed:pe}=C(ae?ae.workspaceFolders:[],Ce.workspaceFolders,h,N);return{workspace:Ce,added:le,removed:pe}}static _findFolder(H,x,$){for(let N=0;N<H.folders.length;N++){const M=H.workspaceFolders[N];if(S(M.uri,x,$))return M}}constructor(H,x,$,N,M,te,Q){super(H,$.map(Se=>new i.WorkspaceFolder(Se)),N,M,Q),this._name=x,this._isUntitled=te,this._workspaceFolders=[],this._structure=u.TernarySearchTree.forUris(Q),$.forEach(Se=>{this._workspaceFolders.push(Se),this._structure.set(Se.uri,Se)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(H,x){return x&&this._structure.get(H)&&(H=(0,P.dirname)(H)),this._structure.findSubstr(H)}resolveWorkspaceFolder(H){return this._structure.get(H)}}let d=class{constructor(H,x,$,N,M){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new L.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=N,this._extHostFileSystemInfo=$,this._uriTransformerService=M,this._requestIdProvider=new m.Counter,this._barrier=new R.Barrier,this._proxy=H.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=H.getProxy(o.MainContext.MainThreadMessageService);const te=x.workspace;this._confirmedWorkspace=te?new g(te.id,te.name,[],!!te.transient,te.configuration?a.URI.revive(te.configuration):null,!!te.isUntitled,Q=>l(Q,$)):void 0}$initializeWorkspace(H,x){this._trusted=x,this.$acceptWorkspaceData(H),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:y.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(H,x,$,...N){const M=[];if(Array.isArray(N)&&N.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!M.some(Y=>S(Y.uri,Pe.uri,this._extHostFileSystemInfo))&&M.push({uri:Pe.uri,name:Pe.name||(0,P.basenameOrAuthority)(Pe.uri)})}),this._unconfirmedWorkspace||[x,$].some(Pe=>typeof Pe!="number"||Pe<0)||$===0&&M.length===0)return!1;const te=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+$>te.length)return!1;const Q=te.slice(0);Q.splice(x,$,...M.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.basenameOrAuthority)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Q.length;Pe++){const Y=Q[Pe];if(Q.some((ae,Ce)=>Ce!==Pe&&S(Y.uri,ae.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((Pe,Y)=>Pe.index=Y);const{added:Se,removed:_e}=C(te,Q,I,this._extHostFileSystemInfo);if(Se.length===0&&_e.length===0)return!1;if(this._proxy){const Pe=H.displayName||H.name;this._proxy.$updateWorkspaceFolders(Pe,x,$,M).then(void 0,Y=>{this._unconfirmedWorkspace=void 0;const ae={source:{identifier:H.identifier,label:H.displayName||H.name}};this._messageService.$showMessage(t.Severity.Error,(0,v.localize)(0,null,Pe,Y.toString()),ae,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(H,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,x)}async getWorkspaceFolder2(H,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,x)}async resolveWorkspaceFolder(H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(H)}getPath(){if(!this._actualWorkspace)return;const{folders:H}=this._actualWorkspace;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,x){let $,N="";if(typeof H=="string"?($=a.URI.file(H),N=H):typeof H<"u"&&($=H,N=H.fsPath),!$)return N;const M=this.getWorkspaceFolder($,!0);if(!M)return N;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let te=(0,P.relativePath)(M.uri,$);return x&&M.name&&(te=`${M.name}/${te}`),te}trySetWorkspaceFolders(H){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:H,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:x,added:$,removed:N}=g.toExtHostWorkspace(H,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:N}))}findFiles(H,x,$,N,M=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let te;if(x===null?te=!1:x&&(typeof x=="string"?te=x:te=x.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:Se}=T(E.GlobPattern.from(H));return this._proxy.$startFileSearch(Q??null,Se??null,te??null,$??null,M).then(_e=>Array.isArray(_e)?_e.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(H,x,$,N,M=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const te=this._requestIdProvider.getNext(),Q=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:Se,folder:_e}=T(E.GlobPattern.from(x.include)),Pe=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,Y={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:Q,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:Se,excludePattern:Pe},ae=!1;if(this._activeSearchCallbacks[te]=Ce=>{if(ae)return;const le=a.URI.revive(Ce.resource);Ce.results.forEach(pe=>{(0,n.resultIsMatch)(pe)?$({uri:le,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,ie=>new r.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,ie=>new r.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):$({uri:le,text:pe.text,lineNumber:pe.lineNumber})})},M.isCancellationRequested)return{};try{const Ce=await this._proxy.$startTextSearch(H,_e??null,Y,te,M);return delete this._activeSearchCallbacks[te],Ce||{}}catch(Ce){throw delete this._activeSearchCallbacks[te],Ce}}$handleTextSearchResult(H,x){this._activeSearchCallbacks[x]?.(H)}async save(H){const x=await this._proxy.$save(H,{saveAs:!1});return a.URI.revive(x)}async saveAs(H){const x=await this._proxy.$save(H,{saveAs:!0});return a.URI.revive(x)}saveAll(H){return this._proxy.$saveAll(H)}resolveProxy(H){return this._proxy.$resolveProxy(H)}get trusted(){return this._trusted}requestWorkspaceTrust(H){return this._proxy.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(H,x){if(this._editSessionIdentityProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._editSessionIdentityProviders.set(H,x);const $=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(N,$),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(H),this._proxy.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(H,x){this._logService.info("Getting edit session identifier for workspaceFolder",H);const $=await this.resolveWorkspaceFolder(a.URI.revive(H));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const N=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!N),!N)return;const M=await N.provideEditSessionIdentity($,x);if(this._logService.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(H,x,$,N){this._logService.info("Getting edit session identifier for workspaceFolder",H);const M=await this.resolveWorkspaceFolder(a.URI.revive(H));if(!M){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const te=this._editSessionIdentityProviders.get(M.uri.scheme);if(this._logService.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!te),!te)return;const Q=await te.provideEditSessionIdentityMatch?.(x,$,N);if(this._logService.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(H){return(x,$,N)=>{const M=function(Q){x.call($,Q)};return M.extension=H,this._onWillCreateEditSessionIdentityEvent.event(M,void 0,N)}}async $onWillCreateEditSessionIdentity(H,x,$){const N=await this.resolveWorkspaceFolder(a.URI.revive(H));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:N},x,async(M,te)=>{const Q=Date.now();await Promise.resolve(M),Date.now()-Q>$&&this._logService.warn("SLOW edit session create-participant",te.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(H,x){if(this._canonicalUriProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._canonicalUriProviders.set(H,x);const $=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(N,$),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(H),this._proxy.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(H,x,$){const N=this._canonicalUriProviders.get(H.scheme);if(!N)return;const M=await N.provideCanonicalUri?.(a.URI.revive(H),x,$);if(M)return M}async $provideCanonicalUri(H,x,$){return this.provideCanonicalUri(a.URI.revive(H),{targetScheme:x},$)}};e.ExtHostWorkspace=d,e.ExtHostWorkspace=d=Ve([ze(0,_.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,c.IExtHostFileSystemInfo),ze(3,f.ILogService),ze(4,s.IURITransformerService)],d),e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function T(z){let H,x;return z&&(typeof z=="string"?H=z:(H=z.pattern,x=a.URI.revive(z.baseUri))),{includePattern:H,folder:x}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,n){if(n){const o=n.split(".");let S=s;for(let h=0;S&&h<o.length;h++)S=S[o[h]];return S}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function _(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let E=class{constructor(n,o,S){this._proxy=n.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=S,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new r(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(n,o))}};e.ExtHostConfiguration=E,e.ExtHostConfiguration=E=Ve([ze(0,a.IExtHostRpcService),ze(1,k.IExtHostWorkspace),ze(2,v.ILogService)],E);class r{constructor(n,o,S,h){this._onDidChangeConfiguration=new R.Emitter,this._proxy=n,this._logService=h,this._extHostWorkspace=o,this._configuration=u.Configuration.parse(S),this._configurationScopes=this._toMap(S.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,o){const S={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=u.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,S))}getConfiguration(n,o,S){const h=_(o)||{},I=this._toReadonlyValue(n?f(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,h,S?.identifier);function C(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const l={has(g){return typeof f(I,g)<"u"},get:(g,d)=>{this._validateConfigurationAccess(n?`${n}.${g}`:g,h,S?.identifier);let T=f(I,g);if(typeof T>"u")T=d;else{let z;const H=(x,$)=>{if((0,m.isObject)(x)){let N;const M=()=>{z=z||(0,w.deepClone)(I),N=N||f(z,$)};return new Proxy(x,{get:(te,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return M(),()=>N;if(z)return N=N||f(z,$),N[Q];const Se=te[Q];return typeof Q=="string"?H(Se,`${$}.${Q}`):Se},set:(te,Q,Se)=>(M(),N&&(N[Q]=Se),!0),deleteProperty:(te,Q)=>(M(),N&&delete N[Q],!0),defineProperty:(te,Q,Se)=>(M(),N&&Object.defineProperty(N,Q,Se),!0)})}return Array.isArray(x)?(0,w.deepClone)(x):x};T=H(T,g)}return T},update:(g,d,T,z)=>{g=n?`${n}.${g}`:g;const H=C(T);return d!==void 0?this._proxy.$updateConfigurationOption(H,g,d,h,z):this._proxy.$removeConfigurationOption(H,g,h,z)},inspect:g=>{g=n?`${n}.${g}`:g;const d=this._configuration.inspect(g,h,this._extHostWorkspace.workspace);if(d)return{key:g,defaultValue:(0,w.deepClone)(d.policy?.value??d.default?.value),globalValue:(0,w.deepClone)(d.user?.value??d.application?.value),workspaceValue:(0,w.deepClone)(d.workspace?.value),workspaceFolderValue:(0,w.deepClone)(d.workspaceFolder?.value),defaultLanguageValue:(0,w.deepClone)(d.default?.override),globalLanguageValue:(0,w.deepClone)(d.user?.override??d.application?.override),workspaceLanguageValue:(0,w.deepClone)(d.workspace?.override),workspaceFolderLanguageValue:(0,w.deepClone)(d.workspaceFolder?.override),languageIds:(0,w.deepClone)(d.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.mixin)(l,I,!1),Object.freeze(l)}_toReadonlyValue(n){const o=S=>(0,m.isObject)(S)?new Proxy(S,{get:(h,I)=>o(h[I]),set:(h,I,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(h,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(h,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return o(n)}_validateConfigurationAccess(n,o,S){const h=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),I=S?`[${S.value}] `:"";if(h===4){typeof o?.resource>"u"&&this._logService.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){o?.resource&&this._logService.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,o){const S=new u.ConfigurationChangeEvent(n,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,I)=>S.affectsConfiguration(h,_(I))})}_toMap(n){return n.reduce((o,S)=>(o.set(S[0],S[1]),o),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,59,34,21,62,17,27,4,13,22,14,80,214,9]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var E;(function(H){function x(N){if(N!=null)return N}H.from=x;function $(N){if(N!=null)return N}H.to=$})(E||(E={}));var r;(function(H){function x(N){if(N!=null)return N}H.from=x;function $(N){if(N!=null)return N}H.to=$})(r||(r={}));var s;(function(H){function x(N){if(N!=null)return N}H.from=x;function $(N){if(N!=null)return N}H.to=$})(s||(s={}));var n;(function(H){function x(M){if(M){const te=M;return te&&!!te.process}else return!1}H.is=x;function $(M){if(M==null)return;const te={process:M.process,args:M.args};return M.options&&(te.options=s.from(M.options)),te}H.from=$;function N(M){if(M!=null)return new A.ProcessExecution(M.process,M.args,M.options)}H.to=N})(n||(n={}));var o;(function(H){function x(N){if(N!=null)return N}H.from=x;function $(N){if(N!=null)return N}H.to=$})(o||(o={}));var S;(function(H){function x(M){if(M){const te=M;return te&&(!!te.commandLine||!!te.command)}else return!1}H.is=x;function $(M){if(M==null)return;const te={};return M.commandLine!==void 0?te.commandLine=M.commandLine:(te.command=M.command,te.args=M.args),M.options&&(te.options=o.from(M.options)),te}H.from=$;function N(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.ShellExecution(M.commandLine,M.options):new A.ShellExecution(M.command,M.args?M.args:[],M.options)}H.to=N})(S||(S={}));var h;(function(H){function x(M){if(M){const te=M;return te&&te.customExecution==="customExecution"}else return!1}H.is=x;function $(M){return{customExecution:"customExecution"}}H.from=$;function N(M,te){return te.get(M)}H.to=N})(h||(e.CustomExecutionDTO=h={}));var I;(function(H){function x($,N){let M;return $.scope!==void 0&&typeof $.scope!="number"?M=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?M=N.workspaceFile:M=b.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:M}}H.from=x})(I||(e.TaskHandleDTO=I={}));var C;(function(H){function x($){if($!=null)return{_id:$.id,isDefault:$.isDefault}}H.from=x})(C||(C={}));var l;(function(H){function x(M,te){if(M==null)return[];const Q=[];for(const Se of M){const _e=$(Se,te);_e&&Q.push(_e)}return Q}H.fromMany=x;function $(M,te){if(M==null)return;let Q;M.execution instanceof A.ProcessExecution?Q=n.from(M.execution):M.execution instanceof A.ShellExecution?Q=S.from(M.execution):M.execution&&M.execution instanceof A.CustomExecution&&(Q=h.from(M.execution));const Se=E.from(M.definition);let _e;return M.scope?typeof M.scope=="number"?_e=M.scope:_e=M.scope.uri:_e=A.TaskScope.Workspace,!Se||!_e?void 0:{_id:M._id,definition:Se,name:M.name,source:{extensionId:te.identifier.value,label:M.source,scope:_e},execution:Q,isBackground:M.isBackground,group:C.from(M.group),presentationOptions:r.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}H.from=$;async function N(M,te,Q){if(M==null)return;let Se;n.is(M.execution)?Se=n.to(M.execution):S.is(M.execution)?Se=S.to(M.execution):h.is(M.execution)&&(Se=h.to(M._id,Q));const _e=E.to(M.definition);let Pe;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Pe=M.source.scope:Pe=await te.resolveWorkspaceFolder(w.URI.revive(M.source.scope)):Pe=A.TaskScope.Workspace),!_e||!Pe)return;const Y=new A.Task(_e,Pe,M.name,M.source.label,Se,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=A.TaskGroup.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new A.TaskGroup(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=r.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}H.to=N})(l||(e.TaskDTO=l={}));var g;(function(H){function x(N){return N}H.from=x;function $(N){if(N)return Object.assign(Object.create(null),N)}H.to=$})(g||(g={}));class d{#e;constructor(x,$,N){this._id=$,this._task=N,this.#e=x}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}let T=class{constructor(x,$,N,M,te,Q,Se,_e){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=M,this._configurationService=te,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Se,this._deprecationService=_e,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,$,N){if(!N)return new A.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:$,provider:N,extension:x}),this._proxy.$registerTaskProvider(M,$),new A.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,$){this._proxy.$registerTaskSystem(x,$)}fetchTasks(x){return this._proxy.$fetchTasks(g.from(x)).then(async $=>{const N=[];for(const M of $){const te=await l.to(M,this._workspaceProvider,this._providedCustomExecutions2);te&&N.push(te)}return N})}get taskExecutions(){const x=[];return this._taskExecutions.forEach($=>x.push($)),x}terminateTask(x){if(!(x instanceof d))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,$,N){const M=this._providedCustomExecutions2.get(x.id);M&&(this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal($,await M.callback(N))),this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const $=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:$,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:x.exitCode})}$provideTasks(x,$){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));const M=[],te=(0,R.asPromise)(()=>N.provider.provideTasks(P.CancellationToken.None)).then(Q=>this.provideTasksInternal($,M,N,Q));return new Promise(Q=>{te.then(Se=>{Promise.all(M).then(()=>{Q(Se)})})})}async $resolveTask(x,$){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));if($.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${N.type}].`);const M=await l.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const te=await N.provider.resolveTask(M,P.CancellationToken.None);if(!te)return;this.checkDeprecation(te,N);const Q=l.from(te,N.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(Q.execution)&&await this.addCustomExecution(Q,te,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,$,N){const M=await this._proxy.$createTaskId(x);!N&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,$.execution)),this._providedCustomExecutions2.set(M,$.execution)}async getTaskExecution(x,$){if(typeof x=="string"){const te=this._taskExecutionPromises.get(x);if(!te)throw new _.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return te}const N=this._taskExecutionPromises.get(x.id);if(N)return N;const M=new Promise((te,Q)=>{function Se(_e,Pe,Y){Y?te(new d(_e,Pe.id,Y)):Q("Unexpected: Task does not exist.")}$?Se(this,x,$):l.to(x.task,this._workspaceProvider,this._providedCustomExecutions2).then(_e=>Se(this,x,_e))});return this._taskExecutionPromises.set(x.id,M),M.then(te=>(this._taskExecutions.set(x.id,te),te),te=>Promise.reject(te))}checkDeprecation(x,$){x._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));const N=this._notProvidedCustomExecutions.values();let M=N.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=N.next()}};e.ExtHostTaskBase=T,e.ExtHostTaskBase=T=Ve([ze(0,a.IExtHostRpcService),ze(1,v.IExtHostInitDataService),ze(2,u.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,D.IExtHostTerminalService),ze(6,i.ILogService),ze(7,c.IExtHostApiDeprecationService)],T);let z=class extends T{constructor(x,$,N,M,te,Q,Se,_e){super(x,$,N,M,te,Q,Se,_e),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(x,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const N=l.from($,x);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.addCustomExecution(N,$,!1);else throw new _.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),$);return this._proxy.$executeTask(N).catch(te=>{throw new Error(te)}),M}provideTasksInternal(x,$,N,M){const te=[];if(M)for(const Q of M){this.checkDeprecation(Q,N),(!Q.definition||!x[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const Se=l.from(Q,N.extension);Se&&h.is(Se.execution)?(te.push(Se),$.push(this.addCustomExecution(Se,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:te,extension:N.extension}}async resolveTaskInternal(x){if(h.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,$,N){}};e.WorkerExtHostTask=z,e.WorkerExtHostTask=z=Ve([ze(0,a.IExtHostRpcService),ze(1,v.IExtHostInitDataService),ze(2,u.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,D.IExtHostTerminalService),ze(6,i.ILogService),ze(7,c.IExtHostApiDeprecationService)],z),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,58,47]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(a,v,p){this.config=a,this.provider=v,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&L.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&L.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const v=this.config.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.resultCount++,a(i)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(i=>{const c=i.toString(),b=w.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,b)||this.matchFile(t,{base:i,basename:b})}),Promise.all(v.map(i=>this.searchInFolder(i,t))).then(i=>{p({limitHit:this.isLimitHit,stats:i[0]||void 0})},i=>{f(new Error((0,k.toErrorMessage)(i)))})})}async searchInFolder(a,v){const p=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(a),t=this.initDirectoryTree(),i=new y.QueryGlobTester(this.config,a),c=!i.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(p),b=u.StopWatch.create();const _=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,p.token),E=b.elapsed(),r=u.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(_&&_.forEach(s=>{const n=w.posix.relative(a.folder.path,s.path);if(c){const o=w.basename(s.path);this.matchFile(v,{base:a.folder,relativePath:n,basename:o});return}this.addDirectoryEntries(t,a.folder,n,v)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,i,v),{providerTime:E,postProcessTime:r.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(a){const v=(0,y.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:p,includes:v,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},v,p,f){if(p===this.filePattern){const i=w.basename(this.filePattern);this.matchFile(f,{base:v,relativePath:this.filePattern,basename:i})}function t(i){const c=w.basename(i),b=w.dirname(i);let _=a[b];_||(_=a[b]=[],t(b)),_.push({base:v,relativePath:i,basename:c})}t(p)}matchDirectoryTree({rootEntries:a,pathToEntries:v},p,f){const t=this,i=this.filePattern;function c(b){const _=(0,y.hasSiblingFn)(()=>b.map(E=>E.basename));for(let E=0,r=b.length;E<r;E++){const s=b[E],{relativePath:n,basename:o}=s;if(p.matchesExcludesSync(n,o,i!==o?_:void 0))continue;const S=v[n];if(S)c(S);else{if(n===i)continue;t.matchFile(f,s)}if(t.isLimitHit)break}}c(a)}matchFile(a,v){(!this.includePattern||v.relativePath&&this.includePattern(v.relativePath,v.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(v))}}class P{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(a,v,p,f){const t=this.getSessionTokenSource(a.cacheKey),i=new m(a,v,t&&t.token);let c=0;const b=_=>{c+=_.length,p(_.map(E=>this.rawMatchToSearchItem(E)))};return this.doSearch(i,P.BATCH_SIZE,b,f).then(_=>({limitHit:_.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:_.stats}}))}clearCache(a){this.getSessionTokenSource(a)?.cancel()}getSessionTokenSource(a){if(a)return this.sessions.has(a)||this.sessions.set(a,new R.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,v,p,f){const t=f.onCancellationRequested(()=>{a.cancel()}),i=b=>{b&&(c.push(b),v>0&&c.length>=v&&(p(c),c=[]))};let c=[];return a.search(i).then(b=>(c.length&&p(c),t.dispose(),b),b=>(c.length&&p(c),t.dispose(),Promise.reject(b)))}}e.FileSearchManager=P}),define(Ae[267],Re([1,0,18,231,37,90,28,13,19,23,15,16,2,282,167,43,14,54,102,265,47]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let E=class{constructor(g,d,T,z,H){this.configurationService=g,this.workspaceContextService=d,this.editorGroupsService=T,this.logService=z,this.pathService=H}text(g,d,T={}){g=this.getContentPattern(g,T);const z=this.configurationService.getValue(),H=d&&d.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(d?.map(i.toWorkspaceFolder),T),type:2,contentPattern:g,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:z.search.usePCRE2||H||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(g,d){const T=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const z={...g,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(g,d)&&(z.isCaseSensitive=!0),this.isMultiline(g)&&(z.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),z}file(g,d={}){return{...this.commonQuery(g,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}handleIncludeExclude(g,d){return g?(g=Array.isArray(g)?g.map(S):S(g),d?this.parseSearchPaths(g):{pattern:s(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],d={}){const T=this.handleIncludeExclude(d.includePattern,d.expandPatterns),z=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),H=g.length>1,x=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,d,z)):g.map(M=>this.getFolderQueryForRoot(M,d,z,H))).filter(M=>!!M),$={_reason:d._reason,folderQueries:x,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:z.pattern,includePattern:T.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const M=w.coalesce(w.flatten(this.editorGroupsService.groups.map(Se=>Se.editors.map(_e=>_e.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const te=M.filter(Se=>(0,_.pathIncludedInQuery)($,Se.fsPath)),Q=this.commonQueryFromFileList(te);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...$,...Q}}const N=d.extraFileResources&&d.extraFileResources.filter(M=>(0,_.pathIncludedInQuery)($,M.fsPath));return $.extraFileResources=N&&N.length?N:void 0,$}commonQueryFromFileList(g){const d=[],T=new A.ResourceMap,z={};let H=!1;return g.forEach(x=>{if(x.scheme===u.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(x)){const N=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let M=T.get(N);M||(H=!0,M={folder:N,includePattern:{}},d.push(M),T.set(N,M));const te=y.relative(N.fsPath,x.fsPath);(0,D.assertIsDefined)(M.includePattern)[te.replace(/\\/g,"/")]=!0}else x.fsPath&&(H=!0,z[x.fsPath]=!0)}),{folderQueries:d,includePattern:z,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(g,d){if(d.isSmartCase){if(g.isRegExp){if(P.containsUppercaseCharacter(g.pattern,!0))return!0}else if(P.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,v.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const d=Q=>y.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),z=(Array.isArray(g)?g:n(g)).map(Q=>{const Se=this.pathService.resolvedUserHome;return Se?(0,L.untildify)(Q,Se.scheme===u.Schemas.file?Se.fsPath:Se.path):Q}),H=R.groupBy(z,Q=>d(Q)?"searchPaths":"exprSegments"),x=(H.exprSegments||[]).map(Q=>P.rtrim(Q,"/")).map(Q=>P.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),o(Q))),$={},N=this.expandSearchPathPatterns(H.searchPaths||[]);N&&N.length&&($.searchPaths=N);const M=w.flatten(x),te=s(...M);return te&&($.pattern=te),$}getExcludesForFolder(g,d){return d.disregardExcludeSettings?void 0:(0,_.getExcludes)(g,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const d=g.flatMap(z=>{let{pathPortion:H,globPortion:x}=r(z);return x&&(x=h(x)),this.expandOneSearchPath(H).flatMap(N=>this.resolveOneSearchPathPattern(N,x))}),T=new Map;return d.forEach(z=>{const H=z.searchPath.toString(),x=T.get(H);x?z.pattern&&(x.pattern=x.pattern||{},x.pattern[z.pattern]=!0):T.set(H,{searchPath:z.searchPath,pattern:z.pattern?s(z.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(g){if(y.isAbsolute(g)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==u.Schemas.file?[{searchPath:d[0].uri.with({path:g})}]:[{searchPath:a.URI.file(y.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=S(g),g.startsWith("../")||g===".."){const z=y.posix.resolve(d.path,g);return[{searchPath:d.with({path:z})}]}const T=h(g);return[{searchPath:d,pattern:T}]}else{if(g==="./"||g===".\\")return[];{const d=g.replace(/^\.[\/\\]/,""),z=this.workspaceContextService.getWorkspace().folders.map(H=>{const x=d.match(new RegExp(`^${P.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return x?{match:x,folder:H}:null}).filter(D.isDefined);if(z.length)return z.map(H=>{const x=H.match[1];return{searchPath:H.folder.uri,pattern:x&&h(x)}});{const H=g.match(/\.[\/\\](.+)[\/\\]?/),x=H?H[1]:g,$=p.localize(0,null,x);throw new Error($)}}}}resolveOneSearchPathPattern(g,d){const T=g.pattern&&d?`${g.pattern}/${d}`:g.pattern||d,z=[{searchPath:g.searchPath,pattern:T}];return T&&!T.endsWith("**")&&z.push({searchPath:g.searchPath,pattern:T+"/**"}),z}getFolderQueryForSearchPath(g,d,T){const z=this.getFolderQueryForRoot((0,i.toWorkspaceFolder)(g.searchPath),d,T,!1);return z?{...z,includePattern:g.pattern}:null}getFolderQueryForRoot(g,d,T,z){let H;const x=a.URI.isUri(g)?g:g.uri;if(T.searchPaths){const Q=T.searchPaths.filter(Se=>(0,m.isEqual)(Se.searchPath,x))[0];if(Q&&!Q.pattern)return null;Q&&(H=Q.pattern)}const $=this.configurationService.getValue({resource:x}),M={...this.getExcludesForFolder($,d)||{},...H||{}},te=a.URI.isUri(g)?(0,m.basename)(g):g.name;return{folder:x,folderName:z?te:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!$.search.followSymlinks}}};e.QueryBuilder=E,e.QueryBuilder=E=Ve([ze(0,f.IConfigurationService),ze(1,i.IWorkspaceContextService),ze(2,c.IEditorGroupsService),ze(3,t.ILogService),ze(4,b.IPathService)],E);function r(l){const g=l.match(/[\*\{\}\(\)\[\]\?]/);if(g){const d=g.index,T=l.substr(0,d).match(/[/|\\][^/\\]*$/);if(T){let z=l.substr(0,T.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:l.substr((T.index||0)+1)}}}return{pathPortion:l}}function s(...l){return l.length?l.reduce((g,d)=>(g[d]=!0,g),Object.create(null)):void 0}function n(l){return k.splitGlobAware(l,",").map(g=>g.trim()).filter(g=>!!g.length)}function o(l){return[`**/${l}/**`,`**/${l}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function S(l){return l.replace(/\\/g,"/")}function h(l){return S(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(l){return l.replace(/([?*[\]])/g,"[$1]")}function C(l,g){l=w.distinct(l,z=>z.toString());const d=[],T=g.getWorkspace();return l&&l.forEach(z=>{let H;if(g.getWorkbenchState()===2)H=(0,m.relativePath)(T.folders[0].uri,z),H&&H!=="."&&(H="./"+H);else{const x=g.getWorkspaceFolder(z);if(x){const $=x.name;if(T.folders.filter(M=>M.name===$).length===1){const M=(0,m.relativePath)(x.uri,z);M===""?H=`./${x.name}`:H=`./${x.name}/${M}`}else H=z.fsPath}}H&&d.push(I(H))}),d}e.resolveResourcesForSearchIncludes=C}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,54]),function(be,e,w,R,k,L,A,u,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function D(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],b=[];for(const o of i)if(/^workspaceContains:/.test(o)){const S=o.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||f.forceUsingSearch?b.push(S):c.push(S)}if(c.length===0&&b.length===0)return Promise.resolve(void 0);let _;const E=new Promise((o,S)=>{_=o}),r=o=>_({activationEvent:o}),s=Promise.all(c.map(o=>a(f,o,r))).then(()=>{}),n=v(f,t.identifier,b,r);return Promise.all([s,n]).then(()=>{_(void 0)}),E}e.checkActivateWorkspaceContainsExtension=D;async function a(f,t,i){for(const c of f.folders)if(await f.exists(w.joinPath(R.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function v(f,t,i,c){if(i.length===0)return Promise.resolve(void 0);const b=new k.CancellationTokenSource,_=f.checkExists(f.folders,i,b.token),E=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let r=!1;try{r=await _}catch(s){L.isCancellationError(s)||L.onUnexpectedError(s)}b.dispose(),clearTimeout(E),r&&c(`workspaceContains:${i.join(",")}`)}function p(f,t,i,c){const b=f.get(A.IInstantiationService),_=f.get(y.ISearchService),r=b.createInstance(u.QueryBuilder).file(t.map(s=>(0,m.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return _.fileSearch(r,c).then(s=>!!s.limitHit,s=>L.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=p}),define(Ae[35],Re([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,70,86,62,5,268,83,190,13,81,58,22,82]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s,n,o,S,h,I,C,l,g,d,T,z,H,x,$,N,M){"use strict";var te;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let Q=te=class extends u.Disposable{constructor(ie,U,W,ue,we,Ee,ge,ye,re,de,se,oe){super(),this._extHostManagedSockets=oe,this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=U,this._extHostContext=W,this._initData=ge,this._extHostWorkspace=ue,this._extHostConfiguration=we,this._logService=Ee,this._extHostTunnelService=re,this._extHostTerminalService=de,this._extHostLocalizationService=se,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new le(this._initData.extensions.activationEvents),this._globalRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const he=new b.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,ae(this._globalRegistry,he)),N.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Pe(this._myRegistry)}`)),this._storage=new p.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=ie.createChild(new I.ServiceCollection([p.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState])),this._activator=this._register(new v.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ie,O,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ie,c.transformErrorForSerialization(O),V)},actualActivateExtension:async(Ie,O)=>{if(i.ExtensionDescriptionRegistry.isHostExtension(Ie,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ie,O),new v.HostExtension;const V=this._myRegistry.getExtensionDescription(Ie);return this._activateExtension(V,O)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){c.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this._deactivate(we))}catch{}await Promise.all(ie)}terminate(ie,U=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),c.setUnexpectedErrorHandler(ue=>{this._logService.error(ue)}),this._extHostContext.dispose();const W=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),W]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`):this._logService.info(`Extension host exiting with code ${U}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(U)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const U=await this._mainThreadExtensionsProxy.$getExtension(ie);return U&&{...U,identifier:new b.ExtensionIdentifier(U.identifier.value),extensionLocation:m.URI.revive(U.extensionLocation)}}_activateByEvent(ie,U){return this._activator.activateByEvent(ie,U)}_activateById(ie,U){return this._activator.activateById(ie,U)}activateByIdWithErrors(ie,U){return this._activateById(ie,U).then(()=>{const W=this._activator.getActivatedExtension(ie);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(ie).exports;try{return this._activator.getActivatedExtension(ie).exports}catch{return null}}async _realPathExtensionUri(ie){if(ie.scheme===H.Schemas.file&&this._hostUtils.fsRealpath){const U=await this._hostUtils.fsRealpath(ie.fsPath);return m.URI.file(U)}return ie}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new Ce(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const U=y.TernarySearchTree.forUris(W=>L.extUriBiasedIgnorePathCase.ignorePathCasing(W));return await Promise.all(ie.map(async W=>{if(this._getEntryPoint(W)){const ue=await this._realPathExtensionUri(W.extensionLocation);U.set(ue,W)}})),U}_deactivate(ie){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return U;const W=this._activator.getActivatedExtension(ie);if(!W)return U;try{typeof W.module.deactivate=="function"&&(U=Promise.resolve(W.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(ue)}try{(0,u.dispose)(W.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(ue)}return U}async _activateExtension(ie,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,U).then(W=>{const ue=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,U),this._logExtensionActivationTimes(ie,U,"success",ue),W},W=>{throw this._logExtensionActivationTimes(ie,U,"failure"),W})}_logExtensionActivationTimes(ie,U,W,ue){const we=_e(ie,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...we,...ue||{},outcome:W})}_doActivateExtension(ie,U){const W=_e(ie,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const ue=this._getEntryPoint(ie);if(!ue)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${ie.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this._logService.flush();const we=new v.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(ie,(0,L.joinPath)(ie.extensionLocation,ue),we),this._loadExtensionContext(ie)]).then(Ee=>(k.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),te._callActivate(this._logService,ie.identifier,Ee[0],Ee[1],we))).then(Ee=>(k.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ee))}_loadExtensionContext(ie){const U=new E.ExtensionGlobalMemento(ie,this._storage),W=new E.ExtensionMemento(ie.identifier.value,!1,this._storage),ue=new z.ExtensionSecrets(ie,this._secretState),we=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ee=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([U.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const ge=this;let ye,re;const de=(0,t.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:W,secrets:ue,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return R.join(ie.extensionLocation.fsPath,se)},get storagePath(){return ge._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return ge._storagePath.globalValue(ie).fsPath},get logPath(){return R.join(ge._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return m.URI.joinPath(ge._initData.logsLocation,ie.identifier.value)},get storageUri(){return ge._storagePath.workspaceValue(ie)},get globalStorageUri(){return ge._storagePath.globalValue(ie)},get extensionMode(){return we},get extension(){return ye===void 0&&(ye=new Y(ge,ie.identifier,ie,Ee,!1)),ye},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(ie,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!de)return;const se=g.Event.buffer(g.Event.fromDOMEventEmitter(de,"message",oe=>oe.data));de.start(),re={onDidReceiveMessage:se,postMessage:de.postMessage.bind(de)}}return re}})})}static _callActivate(ie,U,W,ue,we){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,U,W,ue,we).then(Ee=>new v.ActivatedExtension(!1,null,we.build(),W,Ee,ue.subscriptions))}static _callActivateOptional(ie,U,W,ue,we){if(typeof W.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Ee=typeof global=="object"?global:self,ge=W.activate.apply(Ee,[ue]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ge).then(ye=>(we.activateResolveStop(),ye))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(W)}_activateOneStartupFinished(ie,U){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:U}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinishedDeferred(ie,U=0){const ue=Date.now();(0,N.setTimeout0)(()=>{for(let we=U;we<ie.length;we+=1){const Ee=ie[we];for(const ge of Ee.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-ue>50){this._activateAllStartupFinishedDeferred(ie,we);break}else this._activateOneStartupFinished(Ee,ge)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks()),this._extHostConfiguration.getConfigProvider().then(ie=>{const U=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),W=this._myRegistry.getAllExtensionDescriptions();if(U)this._activateAllStartupFinishedDeferred(W);else for(const ue of W)if(ue.activationEvents)for(const we of ue.activationEvents)we==="onStartupFinished"&&this._activateOneStartupFinished(ue,we)})}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(U),ue=this._handleRemoteResolverEagerExtensions(),we=Promise.all([ue,ie,W]).then(()=>{});return Promise.race([we,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),we}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(ie,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,U){if(this.isActivated(U.identifier))return;const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:ie.map(Ee=>Ee.uri),forceUsingSearch:W||!this._hostUtils.fsExists,exists:Ee=>this._hostUtils.fsExists(Ee.fsPath),checkExists:(Ee,ge,ye)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,ge,ye)},we=await(0,d.checkActivateWorkspaceContainsExtension)(ue,U);if(we)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:we.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:U}=this._initData.environment;if(!ie||!U)throw new Error(w.localize(0,null));const W=await this._loadCommonJSModule(null,U,new v.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(w.localize(1,null,U.toString()));return new Promise((ue,we)=>{const Ee=(re,de)=>{re?(N.isCI&&this._logService.error("Test runner called back with error",re),we(re)):(N.isCI&&(de?this._logService.info(`Test runner called back with ${de} failures.`):this._logService.info("Test runner called back with successful outcome.")),ue(typeof de=="number"&&de>0?1:0))},ge=(0,L.originalFSPath)(U),ye=W.run(ge,Ee);ye&&ye.then&&ye.then(()=>{N.isCI&&this._logService.info("Test runner finished successfully."),ue(0)}).catch(re=>{N.isCI&&this._logService.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,U){return this._resolvers[ie]=U,(0,u.toDisposable)(()=>{delete this._resolvers[ie]})}async getRemoteExecServer(ie){const{resolver:U}=await this._activateAndGetResolver(ie);return U?.resolveExecServer?.(ie,{resolveAttempt:0})}async _activateAndGetResolver(ie){const U=ie.indexOf("+");if(U===-1)throw new r.RemoteAuthorityResolverError("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const W=ie.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${W}`,!1),{authorityPrefix:W,resolver:this._resolvers[W]}}async $resolveAuthority(ie,U){const W=$.StopWatch.create(!1),ue=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(ie)},${U})][${W.elapsed()}ms] `,we=G=>this._logService.info(`${ue()}${G}`),Ee=G=>this._logService.warn(`${ue()}${G}`),ge=(G,q=void 0)=>this._logService.error(`${ue()}${G}`,q),ye=G=>{if(G instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},re=async G=>{we(`activating resolver for ${G}...`);const{resolver:q,authorityPrefix:Z}=await this._activateAndGetResolver(G);if(!q)throw ge(`no resolver for ${Z}`),new r.RemoteAuthorityResolverError(`No remote extension installed to resolve ${Z}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:Z,remoteAuthority:G}},de=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${de.join(" -> ")}`);let se;try{se=await Promise.all(de.map(re)).catch(async G=>{if(!(G instanceof r.RemoteAuthorityResolverError)||G._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return Ee(`resolving nested authorities failed: ${G.message}`),[await re(ie)]})}catch(G){return ye(G)}const oe=new A.IntervalTimer;oe.cancelAndSet(()=>we("waiting..."),1e3);let he,Ie;for(const[G,{authorityPrefix:q,resolver:Z,remoteAuthority:ce}]of se.entries())try{if(G===se.length-1)we("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${q}`),he=await Z.resolve(ce,{resolveAttempt:U,execServer:Ie}),k.mark(`code/extHost/didResolveAuthorityOK/${q}`),we("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Z,r.ManagedResolvedAuthority.isManagedResolvedAuthority(he)?he:void 0));else{if(we(`invoking resolveExecServer() for ${ce}`),k.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await Z.resolveExecServer?.(ce,{resolveAttempt:U,execServer:Ie}),!Ie)throw new r.RemoteAuthorityResolverError(`Exec server was not available for ${ce}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Le){return k.mark(`code/extHost/didResolveAuthorityError/${q}`),ge("returned an error",Le),oe.dispose(),ye(Le)}oe.dispose();const O={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures},V={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.ManagedResolvedAuthority.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let K;if(r.ManagedResolvedAuthority.isManagedResolvedAuthority(he)){const G=U;this._extHostManagedSockets.setFactory(G,he.makeConnection),K={authority:ie,connectTo:new s.ManagedRemoteConnection(G),connectionToken:he.connectionToken}}else K={authority:ie,connectTo:new s.WebSocketRemoteConnection(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:K,options:V,tunnelInformation:O}}}async $getCanonicalURI(ie,U){this._logService.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(ie)})`);const{resolver:W}=await this._activateAndGetResolver(ie);if(!W)return null;const ue=m.URI.revive(U);if(typeof W.getCanonicalURI>"u")return ue;const we=await(0,A.asPromise)(()=>W.getCanonicalURI(ue));return we||ue}$startExtensionHost(ie){ie.toAdd.forEach(ue=>ue.extensionLocation=m.URI.revive(ue.extensionLocation));const{globalRegistry:U,myExtensions:W}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(U.getAllExtensionDescriptions()),this._myRegistry.set(W),N.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Pe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(ie,U){return U===1?this._almostReadyToRunExtensions.wait().then(W=>this._activateByEvent(ie,!1)):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(ie,!1))}async $activate(ie,U){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,U),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ee=>Ee.extensionLocation=m.URI.revive(Ee.extensionLocation));const{globalRegistry:U,myExtensions:W}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,ie),ue=await this._createExtensionPathIndex(W);return(await this.getExtensionPathIndex()).setSearchTree(ue),this._globalRegistry.set(U.getAllExtensionDescriptions()),this._myRegistry.set(W),N.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Pe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const U=_.VSBuffer.alloc(ie),W=Math.random()%256;for(let ue=0;ue<ie;ue++)U.writeUInt8(W,ue);return U}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Q,e.AbstractExtHostExtensionService=Q=te=Ve([ze(0,n.IInstantiationService),ze(1,e.IHostUtils),ze(2,h.IExtHostRpcService),ze(3,f.IExtHostWorkspace),ze(4,a.IExtHostConfiguration),ze(5,P.ILogService),ze(6,o.IExtHostInitDataService),ze(7,S.IExtensionStoragePaths),ze(8,C.IExtHostTunnelService),ze(9,l.IExtHostTerminalService),ze(10,x.IExtHostLocalizationService),ze(11,M.IExtHostManagedSockets)],Q);function Se(pe,ie,U,W){pe.addActivationEvents(W.addActivationEvents);const ue=new i.ExtensionDescriptionRegistry(pe,ie.getAllExtensionDescriptions());ue.deltaExtensions(W.toAdd,W.toRemove);const we=new b.ExtensionIdentifierSet(U.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of W.myToRemove)we.delete(ge);for(const ge of W.myToAdd)we.add(ge);const Ee=ae(ue,we);return{globalRegistry:ue,myExtensions:Ee}}function _e(pe,ie){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe(pe){return pe.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(ie,U,W,ue,we){this.#e=ie,this.#t=U,this.#i=W.identifier,this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=R.normalize((0,L.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=ue,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Y;function ae(pe,ie){return pe.getAllExtensionDescriptions().filter(U=>ie.has(U.identifier))}class Ce{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=Ce;class le{constructor(ie){this._map=new b.ExtensionIdentifierMap,this.addActivationEvents(ie)}readActivationEvents(ie){return this._map.get(ie.identifier)}addActivationEvents(ie){for(const U of Object.keys(ie))this._map.set(U,ie[U])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(_,E,r,s,n,o,S){this._apiFactory=_,this._extensionRegistry=E,this._instaService=r,this._extHostConfiguration=s,this._extHostExtensionService=n,this._initData=o,this._logService=S,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const E=await this._extHostExtensionService.getExtensionPathIndex();this.register(new i(this._apiFactory,E,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(c,E,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const E of _.nodeModuleName)this._factories.set(E,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(E=>_.alternativeModuleName(E))}};e.RequireInterceptor=f,e.RequireInterceptor=f=Ve([ze(2,P.IInstantiationService),ze(3,L.IExtHostConfiguration),ze(4,D.IExtHostExtensionService),ze(5,m.IExtHostInitDataService),ze(6,a.ILogService)],f);let t=class{static{p=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(_){if(_.environment.appRoot&&p.aliased.size){const E=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${E}/${n}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const E=this.re.exec(this.forceForwardSlashes(_));if(!E)return;const[,r,s,n]=E,o=p.aliased.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+n}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};t=p=Ve([ze(0,m.IExtHostInitDataService)],t);class i{constructor(_,E,r,s,n){this._apiFactory=_,this._extensionPaths=E,this._extensionRegistry=r,this._configProvider=s,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new u.ExtensionIdentifierMap}load(_,E){const r=this._extensionPaths.findSubstr(E);if(r){let s=this._extApiImpl.get(r.identifier);return s||(s=this._apiFactory(r,this._extensionRegistry,this._configProvider),this._extApiImpl.set(r.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((n,o)=>s+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${E}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(_,E,r){this._extensionPaths=_,this._appUriScheme=E,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=r.getProxy(k.MainContext.MainThreadTelemetry);const s=r.getProxy(k.MainContext.MainThreadWindow);this._impl=(n,o)=>{const S=R.URI.parse(n);return o?this.callOriginal(n,o):S.scheme==="http"||S.scheme==="https"?s.$openUri(S,n,{allowTunneling:!0}):S.scheme==="mailto"||S.scheme===this._appUriScheme?s.$openUri(S,n,{}):this.callOriginal(n,o)}}load(_,E,r){const s=this._extensionPaths.findSubstr(E);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=r(_),this._impl}callOriginal(_,E){return this.sendNoForwardTelemetry(),this._original(_,E)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};c=Ve([ze(2,y.IExtHostRpcService)],c)}),define(Ae[112],Re([1,0,48,6,19,73,4,59,60,35,7,33,200,34]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class p extends a.AbstractVariableResolverService{constructor(i,c,b,_,E,r,s){function n(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const S=_.tabGroups.all.find(h=>h.isActive)?.activeTab;if(S!==void 0){if(S.input instanceof P.TextDiffTabInput||S.input instanceof P.NotebookDiffEditorTabInput)return S.input.modified;if(S.input instanceof P.TextTabInput||S.input instanceof P.NotebookEditorTabInput||S.input instanceof P.CustomEditorTabInput)return S.input.uri}}}super({getFolderUri:o=>{const S=r.folders.filter(h=>h.name===o);if(S&&S.length>0)return S[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,S)=>E.getConfiguration(void 0,o).get(S),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return k.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=n();if(o){const S=c.getWorkspaceFolder(o);if(S)return k.normalize(S.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let f=class extends R.Disposable{constructor(i,c,b,_,E){super(),this.extensionService=i,this.workspaceService=c,this.editorService=b,this.configurationService=_,this.editorTabs=E,this._resolver=new w.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,n,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=f,e.ExtHostVariableResolverProviderService=f=Ve([ze(0,m.IExtHostExtensionService),ze(1,D.IExtHostWorkspace),ze(2,u.IExtHostDocumentsAndEditors),ze(3,v.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],f)}),define(Ae[113],Re([1,0,12,5,2,4,3,60,35,17,7,33,193,195,34,112]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,L.createDecorator)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,n,o,S,h,I){this._workspaceService=n,this._extensionService=o,this._configurationService=S,this._editorTabs=h,this._variableResolver=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=s.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter,this._onDidChangeStackFrameFocus=new R.Emitter,this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(C=>{C.onDidChange(l=>{this.registerAllDebugTypes(C)}),this.registerAllDebugTypes(C)})}asDebugSourceUri(s,n){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let S=`debug:${encodeURIComponent(o.path||"")}`,h="?";return n&&(S+=`${h}session=${encodeURIComponent(n.id)}`,h="&"),S+=`${h}ref=${o.sourceReference}`,k.URI.parse(S)}else{if(o.path)return k.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const n=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const S=o.contributes.debuggers;if(S&&S.length>0)for(const h of S)(0,v.isDebuggerMainContribution)(h)&&n.push(h.type)}this._debugServiceProxy.$registerDebugTypes(n)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const s=[];return this._breakpoints.forEach(n=>s.push(n)),s}addBreakpoints(s){const n=s.filter(h=>{const I=h.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,h),!0)});this.fireBreakpointChanges(n,[],[]);const o=[],S=new Map;for(const h of n)if(h instanceof P.SourceBreakpoint){let I=S.get(h.location.uri.toString());I||(I={type:"sourceMulti",uri:h.location.uri,lines:[]},S.set(h.location.uri.toString(),I),o.push(I)),I.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof P.FunctionBreakpoint&&o.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(s){const n=s.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],n,[]);const o=n.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),S=n.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),h=n.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(o,S,h)}startDebugging(s,n,o){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,n,o){if(!n)return new P.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:S,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,S),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(s,n,o){if(!o)return new P.Disposable(()=>{});if(!this.definesDebugType(s,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:S,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,S),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(s,n){if(!n)return new P.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:o,factory:n}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==n)})}async $runInTerminal(s,n){return Promise.resolve(void 0)}async $substituteVariables(s,n){let o;const S=await this.getFolder(s);return S&&(o={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,n)}createDebugAdapter(s,n){if(s.type==="implementation")return new _(s.implementation)}createSignService(){}async $startDASession(s,n){const o=this,S=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const I=this.convertToDto(h),C=this.createDebugAdapter(I,S);if(!C)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const l=C;return this._debugAdapters.set(s,l),this.getDebugAdapterTrackers(S).then(g=>(g&&this._debugAdaptersTrackers.set(s,g),l.onMessage(async d=>{if(d.type==="request"&&d.command==="handshake"){const T=d,z={type:"response",seq:0,command:T.command,request_seq:T.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(T.arguments.value);z.body={signature:H},l.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,l.sendResponse(z)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(d),d=(0,v.convertToVSCPaths)(d,!0),o._debugServiceProxy.$acceptDAMessage(s,d)}),l.onError(d=>{g&&g.onError&&g.onError(d),this._debugServiceProxy.$acceptDAError(s,d.name,d.message,d.stack)}),l.onExit(d=>{g&&g.onExit&&g.onExit(d??void 0,void 0),this._debugServiceProxy.$acceptDAExit(s,d??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),l.startSession()))})}$sendDAMessage(s,n){n=(0,v.convertToDAPaths)(n,!1);const o=this._debugAdaptersTrackers.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this._debugAdapters.get(s)?.sendMessage(n)}$stopDASession(s){const n=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),n&&n.onWillStopSession&&n.onWillStopSession();const o=this._debugAdapters.get(s);return this._debugAdapters.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const n=[],o=[],S=[];if(s.added)for(const h of s.added){const I=h.id;if(I&&!this._breakpoints.has(I)){let C;if(h.type==="function")C=new P.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")C=new P.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const l=k.URI.revive(h.uri);C=new P.SourceBreakpoint(new P.Location(l,new P.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,P.setBreakpointId)(C,I),this._breakpoints.set(I,C),n.push(C)}}if(s.removed)for(const h of s.removed){const I=this._breakpoints.get(h);I&&(this._breakpoints.delete(h),o.push(I))}if(s.changed){for(const h of s.changed)if(h.id){const I=this._breakpoints.get(h.id);if(I){if(I instanceof P.FunctionBreakpoint&&h.type==="function"){const C=I;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.functionName=h.functionName}else if(I instanceof P.SourceBreakpoint&&h.type==="source"){const C=I;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.location=new P.Location(k.URI.revive(h.uri),new P.Position(h.line,h.character))}S.push(I)}}}this.fireBreakpointChanges(n,o,S)}async $acceptStackFrameFocus(s){let n;const o=s.sessionId?await this.getSession(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?n=new P.ThreadFocus(o,s.threadId):n=new P.StackFrameFocus(o,s.threadId,s.frameId),this._stackFrameFocus=n,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(s,n,o){return(0,w.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(n);return S.provideDebugConfigurations(h,o)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(s,n,o,S){return(0,w.asPromise)(async()=>{const h=this.getConfigProviderByHandle(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(n);return h.resolveDebugConfiguration(I,o,S)})}$resolveDebugConfigurationWithSubstitutedVariables(s,n,o,S){return(0,w.asPromise)(async()=>{const h=this.getConfigProviderByHandle(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(n);return h.resolveDebugConfigurationWithSubstitutedVariables(I,o,S)})}async $provideDebugAdapter(s,n){const o=this.getAdapterDescriptorFactoryByHandle(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(n);return this.getAdapterDescriptor(o,S).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(s){const n=await this.getSession(s);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(s){const n=await this.getSession(s);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,n){(await this.getSession(s))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(s,n){const S={session:await this.getSession(s),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(s){if(s instanceof P.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const n=this._adapterFactories.filter(o=>o.type===s);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(s){const n=this._adapterFactories.filter(o=>o.handle===s);if(n.length>0)return n[0].factory}getConfigProviderByHandle(s){const n=this._configProviders.filter(o=>o.handle===s);if(n.length>0)return n[0].provider}definesDebugType(s,n){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const S of o)if(S.label&&S.type&&S.type===n)return!0}}return!1}getDebugAdapterTrackers(s){const o=s.configuration.type,S=this._trackerFactories.filter(h=>h.type===o||h.type==="*").map(h=>(0,w.asPromise)(()=>h.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(S).then(h=>{const I=h.filter(C=>!!C);if(I.length>0)return new b(I)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async getAdapterDescriptor(s,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.DebugAdapterServer(o));if(s){const h=await this._extensionService.getExtensionRegistry();return(0,w.asPromise)(()=>s.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,h))).then(I=>{if(I)return I})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,S))}daExecutableFromPackage(s,n){}fireBreakpointChanges(s,n,o){(s.length>0||n.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:n,changed:o}))}async getSession(s){if(s)if(typeof s=="string"){const n=this._debugSessions.get(s);if(n)return n}else{let n=this._debugSessions.get(s.id);if(!n){const o=await this.getFolder(s.folderUri),S=s.parent?this._debugSessions.get(s.parent):void 0;n=new i(this._debugServiceProxy,s.id,s.type,s.name,o,s.configuration,S),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(s){if(s){const n=k.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=t,e.ExtHostDebugServiceBase=t=Ve([ze(0,m.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,y.IExtHostExtensionService),ze(3,p.IExtHostConfiguration),ze(4,u.IExtHostEditorTabs),ze(5,f.IExtHostVariableResolverProvider)],t);class i{constructor(s,n,o,S,h,I,C){this._debugServiceProxy=s,this._id=n,this._type=o,this._name=S,this._workspaceFolder=h,this._configuration=I,this._parentSession=C}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,n)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=i;class c{constructor(s){this.value=Object.freeze({append(n){s.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=c;class b{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(n=>n.onError?n.onError(s):void 0)}onExit(s,n){this.trackers.forEach(o=>o.onExit?o.onExit(s,n):void 0)}}class _ extends a.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let E=class extends t{constructor(s,n,o,S,h,I){super(s,n,o,S,h,I)}};e.WorkerExtHostDebugService=E,e.WorkerExtHostDebugService=E=Ve([ze(0,m.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,y.IExtHostExtensionService),ze(3,p.IExtHostConfiguration),ze(4,u.IExtHostEditorTabs),ze(5,f.IExtHostVariableResolverProvider)],E)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,69,70,27,172,17,55,35,57]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const _=b.get(u.ILogService),r=b.get(a.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{_.error(s);const n=w.transformErrorForSerialization(s);r.$onUnexpectedError(n)})}static async installFullHandler(b){const _=b.get(u.ILogService),E=b.get(a.IExtHostRpcService),r=b.get(p.IExtHostExtensionService),s=b.get(f.IExtHostTelemetry),n=E.getProxy(L.MainContext.MainThreadExtensionService),o=E.getProxy(L.MainContext.MainThreadErrors),S=await r.getExtensionPathIndex(),h=new WeakMap;function I(g,d){if(h.has(g))return h.get(g).stack;let T="",z,H;for(const $ of d)T+=`
	at ${$.toString()}`,H=$.getFileName(),!z&&H&&(z=S.findSubstr(k.URI.file(H)));const x=`${g.name||"Error"}: ${g.message||""}${T}`;return h.set(g,{extensionIdentifier:z?.identifier,stack:x}),x}const C=Symbol("prepareStackTrace wrapped");let l=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return l},set(g){if(g===I||!g||g[C]){l=g||I;return}l=function(d,T){return I(d,T),g.call(Error,d,T)},Object.assign(l,{[C]:!0})}}),w.setUnexpectedErrorHandler(g=>{_.error(g);const d=w.transformErrorForSerialization(g),T=h.get(g);if(!T?.extensionIdentifier){o.$onUnexpectedError(d);return}n.$onExtensionRuntimeError(T.extensionIdentifier,d);const z=s.onExtensionError(T.extensionIdentifier,g);_.trace("forwarded error to extension?",z,T)})}}e.ErrorHandler=t;class i{constructor(b,_,E,r,s){this._hostUtils=E,this._rpcProtocol=new A.RPCProtocol(b,null,r),_=i._transform(_,this._rpcProtocol);const n=new m.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(P.IExtHostInitDataService,{_serviceBrand:void 0,..._,messagePorts:s}),n.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),n.set(v.IURITransformerService,new v.URITransformerService(r)),n.set(p.IHostUtils,E);const o=new D.InstantiationService(n,!0);o.invokeFunction(t.installEarlyHandler),this._logService=o.invokeFunction(S=>S.get(u.ILogService)),R.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",_),this._extensionService=o.invokeFunction(S=>S.get(p.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const _=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return k.URI.revive(await _.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,_){b.extensions.allExtensions.forEach(r=>{r.extensionLocation=k.URI.revive(_.transformIncomingURIs(r.extensionLocation))}),b.environment.appRoot=k.URI.revive(_.transformIncomingURIs(b.environment.appRoot));const E=b.environment.extensionDevelopmentLocationURI;return E&&(b.environment.extensionDevelopmentLocationURI=E.map(r=>k.URI.revive(_.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=k.URI.revive(_.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=k.URI.revive(_.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=k.URI.revive(_.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=k.URI.revive(_.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=k.URI.revive(_.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=k.URI.revive(_.transformIncomingURIs(b.logsLocation)),b.workspace=_.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=i}),define(Ae[271],Re([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(c,b,_,E){this.query=c,this.provider=b,this.fileUtils=_,this.processType=E,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,b){const _=this.query.folderQueries||[],E=new k.CancellationTokenSource(b);return new Promise((r,s)=>{this.collector=new v(c);let n=!1;const o=(S,h)=>{if(!n&&!this.isLimitHit){const I=this.resultSize(S);f(S)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,n=!0,E.cancel(),S=this.trimResultToSize(S,this.query.maxResults-this.resultCount));const C=this.resultSize(S);this.resultCount+=C,(C>0||!f(S))&&this.collector.add(S,h)}};Promise.all(_.map((S,h)=>this.searchInFolder(S,I=>o(I,h),E.token))).then(S=>{E.dispose(),this.collector.flush();const h=S.some(I=>!!I&&!!I.limitHit);r({limitHit:this.isLimitHit||h,messages:(0,w.flatten)(S.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.processType}})},S=>{E.dispose();const h=(0,L.toErrorMessage)(S);s(new Error(h))})})}resultSize(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,b){const _=Array.isArray(c.ranges)?c.ranges:[c.ranges],E=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:_.slice(0,b),preview:{matches:E.slice(0,b),text:c.preview.text},uri:c.uri}}async searchInFolder(c,b,_){const E=new P.QueryGlobTester(this.query,c),r=[],s={report:S=>{if(!this.validateProviderResult(S))return;const h=c.folder.scheme===A.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(S.uri))):void 0,I=y.relativePath(c.folder,S.uri);if(I){const C=E.includedInQuery(I,u.basename(I),h);(0,R.isThenable)(C)?r.push(C.then(l=>{l&&b(S)})):C&&b(S)}}},n=this.getSearchOptionsForFolder(c),o=await this.provider.provideTextSearchResults(a(this.query.contentPattern),n,s,_);return r.length&&await Promise.all(r),o}validateProviderResult(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const b=(0,P.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),_=(0,P.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),E={folder:m.URI.from(c.folder),excludes:_,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return E.usePCRE2=this.query.usePCRE2,E}}e.TextSearchManager=D;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,b=>this.sendItems(b))}add(c,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!y.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(p(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=v;function p(i){return f(i)?{preview:{matches:(0,w.mapArrayOrNot)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,w.mapArrayOrNot)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.extensionResultIsMatch=f;class t{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(c,b){this.maxBatchSize=c,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,b){c&&this.addItemToBatch(c,b)}addItems(c,b){c&&this.addItemsToBatch(c,b)}addItemToBatch(c,b){this.batch.push(c),this.batchSize+=b,this.onUpdate()}addItemsToBatch(c,b){this.batch=this.batch.concat(c),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t}),define(Ae[114],Re([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let D=class{constructor(f,t,i){this.extHostRpc=f,this._uriTransformer=t,this._logService=i,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const i=this._handlePool++;return this._textSearchProvider.set(i,t),this._proxy.$registerTextSearchProvider(i,this._transformScheme(f)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const i=this._handlePool++;return this._fileSearchProvider.set(i,t),this._proxy.$registerFileSearchProvider(i,this._transformScheme(f)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,c){const b=a(i),_=this._fileSearchProvider.get(f);if(_)return this._fileSearchManager.fileSearch(b,_,E=>{this._proxy.$handleFileMatch(f,t,E.map(r=>r.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,c){const b=this._textSearchProvider.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const _=a(i);return this.createTextSearchManager(_,b).search(r=>this._proxy.$handleTextMatch(f,t,r),c)}$enableExtensionHostSearch(){}createTextSearchManager(f,t){return new P.TextSearchManager(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.ExtHostSearch=D,e.ExtHostSearch=D=Ve([ze(0,A.IExtHostRpcService),ze(1,u.IURITransformerService),ze(2,y.ILogService)],D);function a(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>m.URI.revive(f))}}e.reviveQuery=a;function v(p){return{...p,folder:m.URI.revive(p.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,59,35,233,234,239,240,242,109,207,248,249,251,84,62,253,210,8,7,53,256,63,108,33,20,198,238,52,107,111,113,114,14,55,17,27,243,196,86,80,217,254,85,61,259,257,258,218,39,252,255,83,60,57,244,110,245,13,95,206,189,236,6,26,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s,n,o,S,h,I,C,l,g,d,T,z,H,x,$,N,M,te,Q,Se,_e,Pe,Y,ae,Ce,le,pe,ie,U,W,ue,we,Ee,ge,ye,re,de,se,oe,he,Ie,O,V,K,G,q,Z,ce,Le,xe,Ge,je,Je,Ye,Ze,it,tt,Ue,st,J,X,ve,Be,Ne,Xe,rt,gt,wt,kt,Qt,Vt,Et,Bt,Lt,$t,Pt,Tt,Mt,zt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ht(at){const lt=at.get(re.IExtHostInitDataService),Kt=at.get(Le.IExtHostFileSystemInfo),It=at.get(K.IExtHostConsumerFileSystem),_t=at.get(o.IExtHostExtensionService),ht=at.get(ae.IExtHostWorkspace),Dt=at.get(Ye.IExtHostTelemetry),Ft=at.get(c.IExtHostConfiguration),St=at.get(ge.IURITransformerService),He=at.get(ye.IExtHostRpcService),Nt=at.get(x.IExtHostStorage),Ut=at.get(V.IExtensionStoragePaths),ke=at.get(Ee.ILoggerService),Te=at.get(Ee.ILogService),me=at.get(oe.IExtHostTunnelService),j=at.get(he.IExtHostApiDeprecationService),Oe=at.get(Y.IExtHostWindow),$e=at.get(je.IExtHostSecretState),Ke=at.get(Je.IExtHostEditorTabs),We=at.get(Lt.IExtHostManagedSockets);He.set(a.ExtHostContext.ExtHostFileSystemInfo,Kt),He.set(a.ExtHostContext.ExtHostLogLevelServiceShape,ke),He.set(a.ExtHostContext.ExtHostWorkspace,ht),He.set(a.ExtHostContext.ExtHostConfiguration,Ft),He.set(a.ExtHostContext.ExtHostExtensionService,_t),He.set(a.ExtHostContext.ExtHostStorage,Nt),He.set(a.ExtHostContext.ExtHostTunnelService,me),He.set(a.ExtHostContext.ExtHostWindow,Oe),He.set(a.ExtHostContext.ExtHostSecretState,$e),He.set(a.ExtHostContext.ExtHostTelemetry,Dt),He.set(a.ExtHostContext.ExtHostEditorTabs,Ke),He.set(a.ExtHostContext.ExtHostManagedSockets,We);const et=He.set(a.ExtHostContext.ExtHostDecorations,at.get(U.IExtHostDecorations)),mt=He.set(a.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),ft=He.set(a.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),vt=He.set(a.ExtHostContext.ExtHostTerminalService,at.get($.IExtHostTerminalService)),dt=He.set(a.ExtHostContext.ExtHostDebugService,at.get(ue.IExtHostDebugService)),At=He.set(a.ExtHostContext.ExtHostSearch,at.get(we.IExtHostSearch)),jt=He.set(a.ExtHostContext.ExtHostTask,at.get(W.IExtHostTask)),_i=He.set(a.ExtHostContext.ExtHostOutputService,at.get(g.IExtHostOutputService)),Wt=He.set(a.ExtHostContext.ExtHostLocalization,at.get(rt.IExtHostLocalizationService)),gi=He.set(a.ExtHostContext.ExtHostUrls,new _e.ExtHostUrls(He)),Ct=He.set(a.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(He,mt)),yi=He.set(a.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(He,mt,Te)),Hi=He.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(Te,Ct,He.getProxy(a.MainContext.MainThreadBulkEdits))),yt=He.set(a.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(He,ft,mt,Ct,It)),ii=He.set(a.ExtHostContext.ExtHostNotebookDocuments,new X.ExtHostNotebookDocuments(yt)),pi=He.set(a.ExtHostContext.ExtHostNotebookEditors,new J.ExtHostNotebookEditors(Te,yt)),oi=He.set(a.ExtHostContext.ExtHostNotebookKernels,new Ze.ExtHostNotebookKernels(He,lt,yt,ft,Te)),Di=He.set(a.ExtHostContext.ExtHostNotebookRenderers,new tt.ExtHostNotebookRenderers(He,yt)),Ci=He.set(a.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Et.ExtHostNotebookDocumentSaveParticipant(Te,yt,He.getProxy(a.MainContext.MainThreadBulkEdits))),Rt=He.set(a.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(He,mt)),vi=He.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(He.getProxy(a.MainContext.MainThreadTreeViews),ft,Te)),Ii=He.set(a.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(He.getProxy(a.MainContext.MainThreadEditorInsets),Rt,lt.remote)),ai=He.set(a.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(He,Te,Kt,mt)),ci=He.set(a.ExtHostContext.ExtHostLanguages,new C.ExtHostLanguages(He,Ct,ft.converter,St)),ct=He.set(a.ExtHostContext.ExtHostLanguageFeatures,new I.ExtHostLanguageFeatures(He,St,Ct,ft,ai,Te,j,Dt)),Wi=He.set(a.ExtHostContext.ExtHostFileSystem,new S.ExtHostFileSystem(He,ct)),Yt=He.set(a.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(He,Te,mt)),ni=He.set(a.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(He,ht,ft)),Ei=He.set(a.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(He,ft,Ct,Te)),ki=He.set(a.ExtHostContext.ExtHostQuickDiff,new kt.ExtHostQuickDiff(He,St)),Vi=He.set(a.ExtHostContext.ExtHostShare,new $t.ExtHostShare(He,St)),Pi=He.set(a.ExtHostContext.ExtHostComments,(0,i.createExtHostComments)(He,ft,Ct)),bi=He.set(a.ExtHostContext.ExtHostProgress,new d.ExtHostProgress(He.getProxy(a.MainContext.MainThreadProgress))),qi=He.set(a.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(He)),Ti=He.set(a.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(He)),li=He.set(a.ExtHostContext.ExtHostAuthentication,new Ie.ExtHostAuthentication(He)),ji=He.set(a.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(He,ft)),wi=He.set(a.ExtHostContext.ExtHostWebviews,new Pe.ExtHostWebviews(He,lt.remote,ht,Te,j)),Ai=He.set(a.ExtHostContext.ExtHostWebviewPanels,new Z.ExtHostWebviewPanels(He,wi,ht)),cn=He.set(a.ExtHostContext.ExtHostCustomEditors,new q.ExtHostCustomEditors(He,Ct,Ut,wi,Ai)),Ri=He.set(a.ExtHostContext.ExtHostWebviewViews,new G.ExtHostWebviewViews(He,wi)),ri=He.set(a.ExtHostContext.ExtHostTesting,new xe.ExtHostTesting(He,ft,mt)),ln=He.set(a.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(He)),un=He.set(a.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(He));He.set(a.ExtHostContext.ExtHostInteractive,new ve.ExtHostInteractive(He,yt,mt,ft,Te));const Ki=He.set(a.ExtHostContext.ExtHostInlineChat,new Vt.ExtHostInteractiveEditor(He,ft,Ct,Te)),fi=He.set(a.ExtHostContext.ExtHostChatProvider,new Pt.ExtHostChatProvider(He,Te)),Gi=He.set(a.ExtHostContext.ExtHostChatAgents,new qt.ExtHostChatAgents(He,fi,Te)),Xi=He.set(a.ExtHostContext.ExtHostChatVariables,new Tt.ExtHostChatVariables(He)),mi=He.set(a.ExtHostContext.ExtHostChat,new Qt.ExtHostChat(He,Te)),Qi=He.set(a.ExtHostContext.ExtHostAiRelatedInformation,new Mt.ExtHostRelatedInformation(He)),Oi=He.set(a.ExtHostContext.ExtHostAiEmbeddingVector,new zt.ExtHostAiEmbeddingVector(He)),Yi=He.set(a.ExtHostContext.ExtHostIssueReporter,new Bt.ExtHostIssueReporter(He)),Jt=He.set(a.ExtHostContext.ExtHostStatusBar,new H.ExtHostStatusBar(He,ft.converter)),Si=Object.values(a.ExtHostContext);He.assertRegistered(Si);const dn=new ce.ExtHostBulkEdits(He,mt),Gt=new f.ExtHostClipboard(He),ui=new l.ExtHostMessageService(He,Te),Fi=new _.ExtHostDialogs(He);return p.ExtHostApiCommands.register(ft),function(Me,Zt,Li){const pt=function(){let ee=!Me.isUnderDevelopment;function fe(){ee||(Te.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(nt){if(Array.isArray(nt))nt.forEach(Fe);else if(typeof nt=="string")fe();else{const bt=nt;typeof bt.scheme>"u"&&fe(),typeof bt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return nt}}(),Ji={getSession(ee,fe,Fe){return li.getSession(Me,ee,fe,Fe)},getSessions(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"authGetSessions"),li.getSessions(Me,ee,fe)},async hasSession(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"authSession"),!!await li.getSession(Me,ee,fe,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(ee,fe,Fe,nt){return li.registerAuthenticationProvider(ee,fe,Fe,nt)}},Zi={registerCommand(ee,fe,Fe){return ft.registerCommand(!0,ee,fe,Fe,void 0,Me)},registerTextEditorCommand(ee,fe,Fe){return ft.registerCommand(!0,ee,(...nt)=>{const bt=Rt.getActiveTextEditor();if(!bt){Te.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(Ot=>{fe.apply(Fe,[bt,Ot,...nt])}).then(Ot=>{Ot||Te.warn("Edits from command "+ee+" were not applied.")},Ot=>{Te.warn("An error occurred while running command "+ee,Ot)})},void 0,void 0,Me)},registerDiffInformationCommand:(ee,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Me,"diffCommand"),ft.registerCommand(!0,ee,async(...nt)=>{const bt=mt.activeEditor(!0);if(!bt){Te.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ot=await Rt.getDiffInformation(bt.id);fe.apply(Fe,[Ot,...nt])},void 0,void 0,Me)),executeCommand(ee,...fe){return ft.executeCommand(ee,...fe)},getCommands(ee=!1){return ft.getCommands(ee)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,fe){return Ye.ExtHostTelemetryLogger.validateSender(ee),Dt.instantiateLogger(Me,ee,fe)},openExternal(ee,fe){return Oe.openUri(ee,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===lt.environment.appUriScheme)return gi.createAppUri(ee);try{return await Oe.asExternalUri(ee,{allowTunneling:!!lt.remote.authority})}catch(fe){if((0,st.matchesScheme)(ee,Ue.Schemas.http)||(0,st.matchesScheme)(ee,Ue.Schemas.https))return ee;throw fe}},get remoteName(){return(0,ie.getRemoteName)(lt.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Te.getLevel()},get onDidChangeLogLevel(){return Te.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Ne.checkProposedApiEnabled)(Me,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Me,ee)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),lt.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const hn={createTestController(ee,fe,Fe){return ri.createTestController(Me,ee,fe,Fe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),ri.createTestObserver()},runTests(ee){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),ri.runTests(ee)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),ri.results}},di=lt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,tn={getExtension(ee,fe){(0,Ne.isProposedApiEnabled)(Me,"extensionsAny")||(fe=!1);const Fe=Zt.mine.getExtensionDescription(ee);if(Fe)return new o.Extension(_t,Me.identifier,Fe,di,!1);if(fe){const nt=Zt.all.getExtensionDescription(ee);if(nt)return new o.Extension(_t,Me.identifier,nt,di,!0)}},get all(){const ee=[];for(const fe of Zt.mine.getAllExtensionDescriptions())ee.push(new o.Extension(_t,Me.identifier,fe,di,!1));return ee},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Me,"extensionsAny");const ee=new Ce.ExtensionIdentifierSet(Zt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of Zt.all.getAllExtensionDescriptions()){const nt=!ee.has(Fe.identifier);fe.push(new o.Extension(_t,Me.identifier,Fe,di,nt))}return fe},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Me,"extensionsAny")?k.Event.any(Zt.mine.onDidChange,Zt.all.onDidChange):Zt.mine.onDidChange}},nn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Me.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,fe){return ci.changeLanguage(ee.uri,fe)},match(ee,fe){const Fe=Ct.getDocumentData(fe.uri)?.notebook;return(0,P.score)(te.LanguageSelector.from(ee),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,fe,Fe){return ct.registerCodeActionProvider(Me,pt(ee),fe,Fe)},registerDocumentPasteEditProvider(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"documentPaste"),ct.registerDocumentPasteEditProvider(Me,pt(ee),fe,Fe)},registerCodeLensProvider(ee,fe){return ct.registerCodeLensProvider(Me,pt(ee),fe)},registerDefinitionProvider(ee,fe){return ct.registerDefinitionProvider(Me,pt(ee),fe)},registerDeclarationProvider(ee,fe){return ct.registerDeclarationProvider(Me,pt(ee),fe)},registerImplementationProvider(ee,fe){return ct.registerImplementationProvider(Me,pt(ee),fe)},registerTypeDefinitionProvider(ee,fe){return ct.registerTypeDefinitionProvider(Me,pt(ee),fe)},registerHoverProvider(ee,fe){return ct.registerHoverProvider(Me,pt(ee),fe,Me.identifier)},registerEvaluatableExpressionProvider(ee,fe){return ct.registerEvaluatableExpressionProvider(Me,pt(ee),fe,Me.identifier)},registerInlineValuesProvider(ee,fe){return ct.registerInlineValuesProvider(Me,pt(ee),fe,Me.identifier)},registerDocumentHighlightProvider(ee,fe){return ct.registerDocumentHighlightProvider(Me,pt(ee),fe)},registerLinkedEditingRangeProvider(ee,fe){return ct.registerLinkedEditingRangeProvider(Me,pt(ee),fe)},registerReferenceProvider(ee,fe){return ct.registerReferenceProvider(Me,pt(ee),fe)},registerRenameProvider(ee,fe){return ct.registerRenameProvider(Me,pt(ee),fe)},registerDocumentSymbolProvider(ee,fe,Fe){return ct.registerDocumentSymbolProvider(Me,pt(ee),fe,Fe)},registerWorkspaceSymbolProvider(ee){return ct.registerWorkspaceSymbolProvider(Me,ee)},registerDocumentFormattingEditProvider(ee,fe){return ct.registerDocumentFormattingEditProvider(Me,pt(ee),fe)},registerDocumentRangeFormattingEditProvider(ee,fe){return ct.registerDocumentRangeFormattingEditProvider(Me,pt(ee),fe)},registerOnTypeFormattingEditProvider(ee,fe,Fe,...nt){return ct.registerOnTypeFormattingEditProvider(Me,pt(ee),fe,[Fe].concat(nt))},registerDocumentSemanticTokensProvider(ee,fe,Fe){return ct.registerDocumentSemanticTokensProvider(Me,pt(ee),fe,Fe)},registerDocumentRangeSemanticTokensProvider(ee,fe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Me,pt(ee),fe,Fe)},registerSignatureHelpProvider(ee,fe,Fe,...nt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Me,pt(ee),fe,Fe):ct.registerSignatureHelpProvider(Me,pt(ee),fe,typeof Fe>"u"?[]:[Fe,...nt])},registerCompletionItemProvider(ee,fe,...Fe){return ct.registerCompletionItemProvider(Me,pt(ee),fe,Fe)},registerInlineCompletionItemProvider(ee,fe,Fe){return fe.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),Fe&&(0,Ne.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Me,pt(ee),fe,Fe)},registerDocumentLinkProvider(ee,fe){return ct.registerDocumentLinkProvider(Me,pt(ee),fe)},registerColorProvider(ee,fe){return ct.registerColorProvider(Me,pt(ee),fe)},registerFoldingRangeProvider(ee,fe){return ct.registerFoldingRangeProvider(Me,pt(ee),fe)},registerSelectionRangeProvider(ee,fe){return ct.registerSelectionRangeProvider(Me,ee,fe)},registerCallHierarchyProvider(ee,fe){return ct.registerCallHierarchyProvider(Me,ee,fe)},registerTypeHierarchyProvider(ee,fe){return ct.registerTypeHierarchyProvider(Me,ee,fe)},setLanguageConfiguration:(ee,fe)=>ct.setLanguageConfiguration(Me,ee,fe),getTokenInformationAtPosition(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"tokenInformation"),ci.tokenAtPosition(ee,fe)},registerInlayHintsProvider(ee,fe){return ct.registerInlayHintsProvider(Me,ee,fe)},createLanguageStatusItem(ee,fe){return ci.createLanguageStatusItem(Me,ee,fe)},registerDocumentDropEditProvider(ee,fe,Fe){return ct.registerDocumentOnDropEditProvider(Me,ee,fe,(0,Ne.isProposedApiEnabled)(Me,"dropMetadata")?Fe:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ee,fe,Fe){const nt=await(A.URI.isUri(ee)?Promise.resolve(sn.openTextDocument(ee)):Promise.resolve(ee));return Rt.showTextDocument(nt,fe,Fe)},createTextEditorDecorationType(ee){return Rt.createTextEditorDecorationType(Me,ee)},onDidChangeActiveTextEditor(ee,fe,Fe){return Rt.onDidChangeActiveTextEditor(ee,fe,Fe)},onDidChangeVisibleTextEditors(ee,fe,Fe){return Rt.onDidChangeVisibleTextEditors(ee,fe,Fe)},onDidChangeTextEditorSelection(ee,fe,Fe){return Rt.onDidChangeTextEditorSelection(ee,fe,Fe)},onDidChangeTextEditorOptions(ee,fe,Fe){return Rt.onDidChangeTextEditorOptions(ee,fe,Fe)},onDidChangeTextEditorVisibleRanges(ee,fe,Fe){return Rt.onDidChangeTextEditorVisibleRanges(ee,fe,Fe)},onDidChangeTextEditorViewColumn(ee,fe,Fe){return Rt.onDidChangeTextEditorViewColumn(ee,fe,Fe)},onDidCloseTerminal(ee,fe,Fe){return vt.onDidCloseTerminal(ee,fe,Fe)},onDidOpenTerminal(ee,fe,Fe){return vt.onDidOpenTerminal(ee,fe,Fe)},onDidChangeActiveTerminal(ee,fe,Fe){return vt.onDidChangeActiveTerminal(ee,fe,Fe)},onDidChangeTerminalDimensions(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"terminalDimensions"),vt.onDidChangeTerminalDimensions(ee,fe,Fe)},onDidChangeTerminalState(ee,fe,Fe){return vt.onDidChangeTerminalState(ee,fe,Fe)},onDidWriteTerminalData(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(ee,fe,Fe)},onDidExecuteTerminalCommand(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(ee,fe,Fe)},get state(){return Oe.getState(Me)},onDidChangeWindowState(ee,fe,Fe){return Oe.onDidChangeWindowState(ee,fe,Fe)},showInformationMessage(ee,...fe){return ui.showMessage(Me,L.default.Info,ee,fe[0],fe.slice(1))},showWarningMessage(ee,...fe){return ui.showMessage(Me,L.default.Warning,ee,fe[0],fe.slice(1))},showErrorMessage(ee,...fe){return ui.showMessage(Me,L.default.Error,ee,fe[0],fe.slice(1))},showQuickPick(ee,fe,Fe){return ni.showQuickPick(Me,ee,fe,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,fe){return ni.showInput(ee,fe)},showOpenDialog(ee){return Fi.showOpenDialog(Me,ee)},showSaveDialog(ee){return Fi.showSaveDialog(ee)},createStatusBarItem(ee,fe,Fe){let nt,bt,Ot;return typeof ee=="string"?(nt=ee,bt=fe,Ot=Fe):(bt=ee,Ot=fe),Jt.createStatusBarEntry(Me,nt,bt,Ot)},setStatusBarMessage(ee,fe){return Jt.setStatusBarMessage(ee,fe)},withScmProgress(ee){return j.report("window.withScmProgress",Me,"Use 'withProgress' instead."),bi.withProgress(Me,{location:Q.ProgressLocation.SourceControl},(fe,Fe)=>ee({report(nt){}}))},withProgress(ee,fe){return bi.withProgress(Me,ee,fe)},createOutputChannel(ee,fe){return _i.createOutputChannel(ee,fe,Me)},createWebviewPanel(ee,fe,Fe,nt){return Ai.createWebviewPanel(Me,ee,fe,Fe,nt)},createWebviewTextEditorInset(ee,fe,Fe,nt){return(0,Ne.checkProposedApiEnabled)(Me,"editorInsets"),Ii.createWebviewEditorInset(ee,fe,Fe,nt,Me)},createTerminal(ee,fe,Fe){return typeof ee=="object"?"pty"in ee?vt.createExtensionTerminal(ee):vt.createTerminalFromOptions(ee):vt.createTerminal(ee,fe,Fe)},registerTerminalLinkProvider(ee){return vt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,fe){return vt.registerProfileProvider(Me,ee,fe)},registerTerminalQuickFixProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(ee,Me.identifier.value,fe)},registerTreeDataProvider(ee,fe){return vi.registerTreeDataProvider(ee,fe,Me)},createTreeView(ee,fe){return vi.createTreeView(ee,fe,Me)},registerWebviewPanelSerializer:(ee,fe)=>Ai.registerWebviewPanelSerializer(Me,ee,fe),registerCustomEditorProvider:(ee,fe,Fe={})=>cn.registerCustomEditorProvider(Me,ee,fe,Fe),registerFileDecorationProvider(ee){return et.registerFileDecorationProvider(ee,Me)},registerUriHandler(ee){return gi.registerUriHandler(Me,ee)},createQuickPick(){return ni.createQuickPick(Me)},createInputBox(){return ni.createInputBox(Me)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(ee,fe,Fe){return Ti.onDidChangeActiveColorTheme(ee,fe,Fe)},registerWebviewViewProvider(ee,fe,Fe){return Ri.registerWebviewViewProvider(Me,ee,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,fe,Fe){return yt.onDidChangeActiveNotebookEditor(ee,fe,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,fe,Fe){return pi.onDidChangeNotebookEditorSelection(ee,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,fe,Fe){return pi.onDidChangeNotebookEditorVisibleRanges(ee,fe,Fe)},showNotebookDocument(ee,fe){return yt.showNotebookDocument(ee,fe)},registerExternalUriOpener(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"externalUriOpener"),ln.registerExternalUriOpener(Me.identifier,ee,fe,Fe)},registerProfileContentHandler(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"profileContentHandlers"),un.registrProfileContentHandler(Me,ee,fe)},registerQuickDiffProvider(ee,fe,Fe,nt){return(0,Ne.checkProposedApiEnabled)(Me,"quickDiffProvider"),ki.registerQuickDiffProvider(pt(ee),fe,Fe,nt)},get tabGroups(){return Ke.tabGroups},registerShareProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"shareProvider"),Vi.registerShareProvider(pt(ee),fe)}},sn={get rootPath(){return j.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ee){throw new R.ReadonlyError("rootPath")},getWorkspaceFolder(ee){return ht.getWorkspaceFolder(ee)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ee){throw new R.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ee){throw new R.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ee,fe,...Fe)=>ht.updateWorkspaceFolders(Me,ee,fe||0,...Fe),onDidChangeWorkspaceFolders:function(ee,fe,Fe){return ht.onDidChangeWorkspace(ee,fe,Fe)},asRelativePath:(ee,fe)=>ht.getRelativePath(ee,fe),findFiles:(ee,fe,Fe,nt)=>ht.findFiles(ee,fe,Fe,Me.identifier,nt),findTextInFiles:(ee,fe,Fe,nt)=>{(0,Ne.checkProposedApiEnabled)(Me,"findTextInFiles");let bt,Ot;return typeof fe=="object"?(bt=fe,Ot=Fe):(bt={},Ot=fe,nt=Fe),ht.findTextInFiles(ee,bt||{},Ot,Me.identifier,nt)},save:ee=>((0,Ne.checkProposedApiEnabled)(Me,"saveEditor"),ht.save(ee)),saveAs:ee=>((0,Ne.checkProposedApiEnabled)(Me,"saveEditor"),ht.saveAs(ee)),saveAll:ee=>ht.saveAll(ee),applyEdit(ee,fe){return dn.applyWorkspaceEdit(ee,Me,fe)},createFileSystemWatcher:(ee,fe,Fe,nt)=>Yt.createFileSystemWatcher(ht,Me,ee,fe,Fe,nt),get textDocuments(){return Ct.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new R.ReadonlyError("textDocuments")},openTextDocument(ee){let fe;const Fe=ee;if(typeof ee=="string")fe=Promise.resolve(A.URI.file(ee));else if(A.URI.isUri(ee))fe=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")fe=Ct.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>Ct.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(ee,fe,Fe)=>Ct.onDidAddDocument(ee,fe,Fe),onDidCloseTextDocument:(ee,fe,Fe)=>Ct.onDidRemoveDocument(ee,fe,Fe),onDidChangeTextDocument:(ee,fe,Fe)=>Ct.onDidChangeDocument(ee,fe,Fe),onDidSaveTextDocument:(ee,fe,Fe)=>Ct.onDidSaveDocument(ee,fe,Fe),onWillSaveTextDocument:(ee,fe,Fe)=>Hi.getOnWillSaveTextDocumentEvent(Me)(ee,fe,Fe),get notebookDocuments(){return yt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,fe){let Fe;if(A.URI.isUri(ee))Fe=ee,await yt.openNotebookDocument(ee);else if(typeof ee=="string")Fe=A.URI.revive(await yt.createNotebookDocument({viewType:ee,content:fe}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,fe,Fe){return ii.onDidSaveNotebookDocument(ee,fe,Fe)},onDidChangeNotebookDocument(ee,fe,Fe){return ii.onDidChangeNotebookDocument(ee,fe,Fe)},onWillSaveNotebookDocument(ee,fe,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Me)(ee,fe,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,fe,Fe,nt){return yt.registerNotebookSerializer(Me,ee,fe,Fe,(0,Ne.isProposedApiEnabled)(Me,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(ee,fe,Fe)=>Li.onDidChangeConfiguration(ee,fe,Fe),getConfiguration(ee,fe){return fe=arguments.length===1?void 0:fe,Li.getConfiguration(ee,fe,Me)},registerTextDocumentContentProvider(ee,fe){return yi.registerTextDocumentContentProvider(ee,fe)},registerTaskProvider:(ee,fe)=>(j.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),jt.registerTaskProvider(Me,ee,fe)),registerFileSystemProvider(ee,fe,Fe){return(0,Be.combinedDisposable)(Wi.registerFileSystemProvider(Me,ee,fe,Fe),It.addFileSystemProvider(ee,fe,Fe))},get fs(){return It.value},registerFileSearchProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"fileSearchProvider"),At.registerFileSearchProvider(ee,fe)),registerTextSearchProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"textSearchProvider"),At.registerTextSearchProvider(ee,fe)),registerRemoteAuthorityResolver:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),_t.registerRemoteAuthorityResolver(ee,fe)),registerResourceLabelFormatter:ee=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),qi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),_t.getRemoteExecServer(ee)),onDidCreateFiles:(ee,fe,Fe)=>Yt.onDidCreateFile(ee,fe,Fe),onDidDeleteFiles:(ee,fe,Fe)=>Yt.onDidDeleteFile(ee,fe,Fe),onDidRenameFiles:(ee,fe,Fe)=>Yt.onDidRenameFile(ee,fe,Fe),onWillCreateFiles:(ee,fe,Fe)=>Yt.getOnWillCreateFileEvent(Me)(ee,fe,Fe),onWillDeleteFiles:(ee,fe,Fe)=>Yt.getOnWillDeleteFileEvent(Me)(ee,fe,Fe),onWillRenameFiles:(ee,fe,Fe)=>Yt.getOnWillRenameFileEvent(Me)(ee,fe,Fe),openTunnel:ee=>((0,Ne.checkProposedApiEnabled)(Me,"tunnels"),me.openTunnel(Me,ee).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Me,"tunnels"),me.getTunnels()},onDidChangeTunnels:(ee,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Me,"tunnels"),me.onDidChangeTunnels(ee,fe,Fe)),registerPortAttributesProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"portsAttributes"),me.registerPortsAttributesProvider(ee,fe)),registerTunnelProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"tunnelFactory"),me.registerTunnelProvider(ee,fe)),registerTimelineProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"timeline"),ji.registerTimelineProvider(ee,fe,Me.identifier,ft.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ee=>((0,Ne.checkProposedApiEnabled)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,fe,Fe)=>ht.onDidGrantWorkspaceTrust(ee,fe,Fe),registerEditSessionIdentityProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ee,fe)),onWillCreateEditSessionIdentity:(ee,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Me)(ee,fe,Fe)),registerCanonicalUriProvider:(ee,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"canonicalUriProvider"),ht.registerCanonicalUriProvider(ee,fe)),getCanonicalUri:(ee,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Me,"canonicalUriProvider"),ht.provideCanonicalUri(ee,fe,Fe))},fn={get inputBox(){return j.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Me)},createSourceControl(ee,fe,Fe){return Ei.createSourceControl(Me,ee,fe,Fe)}},on={createCommentController(ee,fe){return Pi.createCommentController(Me,ee,fe)}},an={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},get stackFrameFocus(){return dt.stackFrameFocus},onDidStartDebugSession(ee,fe,Fe){return dt.onDidStartDebugSession(ee,fe,Fe)},onDidTerminateDebugSession(ee,fe,Fe){return dt.onDidTerminateDebugSession(ee,fe,Fe)},onDidChangeActiveDebugSession(ee,fe,Fe){return dt.onDidChangeActiveDebugSession(ee,fe,Fe)},onDidReceiveDebugSessionCustomEvent(ee,fe,Fe){return dt.onDidReceiveDebugSessionCustomEvent(ee,fe,Fe)},onDidChangeBreakpoints(ee,fe,Fe){return dt.onDidChangeBreakpoints(ee,fe,Fe)},onDidChangeStackFrameFocus(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"debugFocus"),dt.onDidChangeStackFrameFocus(ee,fe,Fe)},registerDebugConfigurationProvider(ee,fe,Fe){return dt.registerDebugConfigurationProvider(ee,fe,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,fe){return dt.registerDebugAdapterDescriptorFactory(Me,ee,fe)},registerDebugAdapterTrackerFactory(ee,fe){return dt.registerDebugAdapterTrackerFactory(ee,fe)},startDebugging(ee,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?dt.startDebugging(ee,fe,{parentSession:Fe}):dt.startDebugging(ee,fe,Fe||{})},stopDebugging(ee){return dt.stopDebugging(ee)},addBreakpoints(ee){return dt.addBreakpoints(ee)},removeBreakpoints(ee){return dt.removeBreakpoints(ee)},asDebugSourceUri(ee,fe){return dt.asDebugSourceUri(ee,fe)}},Mi={registerTaskProvider:(ee,fe)=>jt.registerTaskProvider(Me,ee,fe),fetchTasks:ee=>jt.fetchTasks(ee),executeTask:ee=>jt.executeTask(Me,ee),get taskExecutions(){return jt.taskExecutions},onDidStartTask:(ee,fe,Fe)=>jt.onDidStartTask(ee,fe,Fe),onDidEndTask:(ee,fe,Fe)=>jt.onDidEndTask(ee,fe,Fe),onDidStartTaskProcess:(ee,fe,Fe)=>jt.onDidStartTaskProcess(ee,fe,Fe),onDidEndTaskProcess:(ee,fe,Fe)=>jt.onDidEndTaskProcess(ee,fe,Fe)},Ni={createNotebookController(ee,fe,Fe,nt,bt){return oi.createNotebookController(Me,ee,fe,Fe,nt,(0,Ne.isProposedApiEnabled)(Me,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,fe)=>yt.registerNotebookCellStatusBarItemProvider(Me,ee,fe),createRendererMessaging(ee){return Di.createRendererMessaging(Me,ee)},createNotebookControllerDetectionTask(ee){return(0,Ne.checkProposedApiEnabled)(Me,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Me,ee)},registerKernelSourceActionProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Me,ee,fe)},onDidChangeNotebookCellExecutionState(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,fe,Fe)}},Ui={t(...ee){if(typeof ee[0]=="string"){const fe=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return Wt.getMessage(Me.identifier.value,{message:fe,args:Fe})}return Wt.getMessage(Me.identifier.value,ee[0])},get bundle(){return Wt.getBundle(Me.identifier.value)},get uri(){return Wt.getBundleUri(Me.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),Ki.registerProvider(Me,ee,fe={label:fe?.label??Me.displayName??Me.name})},registerInteractiveSessionProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),mi.registerChatProvider(Me,ee,fe)},sendInteractiveRequestToProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),mi.sendInteractiveRequestToProvider(ee,fe)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(Me,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),mi.transferChatSession(ee,fe)}},xi={getRelatedInformation(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"aiRelatedInformation"),Qi.getRelatedInformation(Me,ee,fe)},registerRelatedInformationProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Me,ee,fe)},registerEmbeddingVectorProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"aiRelatedInformation"),Oi.registerEmbeddingVectorProvider(Me,ee,fe)}},Bi={registerChatResponseProvider(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"chatProvider"),fi.registerProvider(Me.identifier,ee,fe,Fe)},requestChatAccess(ee){return(0,Ne.checkProposedApiEnabled)(Me,"chatRequestAccess"),fi.requestChatResponseProvider(Me.identifier,ee)},registerVariable(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"chatVariables"),Xi.registerVariableResolver(Me,ee,fe,Fe)},registerMappedEditsProvider(ee,fe){return(0,Ne.checkProposedApiEnabled)(Me,"mappedEditsProvider"),ct.registerMappedEditsProvider(Me,ee,fe)},registerAgent(ee,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Me,"chatAgents"),Gi.registerAgent(Me.identifier,ee,fe,Fe)}};return{version:lt.version,ai:xi,authentication:Ji,commands:Zi,comments:on,chat:Bi,debug:an,env:en,extensions:tn,interactive:hi,l10n:Ui,languages:nn,notebooks:Ni,scm:fn,tasks:Mi,tests:hn,window:rn,workspace:sn,Breakpoint:Q.Breakpoint,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatMessage:Q.ChatMessage,ChatMessageRole:Q.ChatMessageRole,ChatVariableLevel:Q.ChatVariableLevel,CallHierarchyIncomingCall:Q.CallHierarchyIncomingCall,CallHierarchyItem:Q.CallHierarchyItem,CallHierarchyOutgoingCall:Q.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:Q.CodeAction,CodeActionKind:Q.CodeActionKind,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.CodeLens,Color:Q.Color,ColorInformation:Q.ColorInformation,ColorPresentation:Q.ColorPresentation,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CompletionItem:Q.CompletionItem,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.CompletionList,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.CustomExecution,DebugAdapterExecutable:Q.DebugAdapterExecutable,DebugAdapterInlineImplementation:Q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Q.DebugAdapterNamedPipeServer,DebugAdapterServer:Q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.Diagnostic,DiagnosticRelatedInformation:Q.DiagnosticRelatedInformation,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.Disposable,DocumentHighlight:Q.DocumentHighlight,DocumentHighlightKind:Q.DocumentHighlightKind,DocumentLink:Q.DocumentLink,DocumentSymbol:Q.DocumentSymbol,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.EvaluatableExpression,InlineValueText:Q.InlineValueText,InlineValueVariableLookup:Q.InlineValueVariableLookup,InlineValueEvaluatableExpression:Q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.FileDecoration,FileDecoration2:Q.FileDecoration,FileSystemError:Q.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Q.FoldingRange,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.FunctionBreakpoint,InlineCompletionItem:Q.InlineSuggestion,InlineCompletionList:Q.InlineSuggestionList,Hover:Q.Hover,IndentAction:m.IndentAction,Location:Q.Location,MarkdownString:Q.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:Q.ParameterInformation,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.Position,ProcessExecution:Q.ProcessExecution,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.QuickInputButtons,Range:Q.Range,RelativePattern:Q.RelativePattern,Selection:Q.Selection,SelectionRange:Q.SelectionRange,SemanticTokens:Q.SemanticTokens,SemanticTokensBuilder:Q.SemanticTokensBuilder,SemanticTokensEdit:Q.SemanticTokensEdit,SemanticTokensEdits:Q.SemanticTokensEdits,SemanticTokensLegend:Q.SemanticTokensLegend,ShellExecution:Q.ShellExecution,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.SignatureHelp,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.SignatureInformation,SnippetString:Q.SnippetString,SourceBreakpoint:Q.SourceBreakpoint,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.SymbolInformation,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.Task,TaskGroup:Q.TaskGroup,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.TerminalLink,TerminalQuickFixExecuteTerminalCommand:Q.TerminalQuickFixCommand,TerminalQuickFixOpener:Q.TerminalQuickFixOpener,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.TerminalProfile,TerminalExitReason:Q.TerminalExitReason,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.TextEdit,SnippetTextEdit:Q.SnippetTextEdit,TextEditorCursorStyle:u.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.ThemeColor,ThemeIcon:Q.ThemeIcon,TreeItem:Q.TreeItem,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.TypeHierarchyItem,UIKind:v.UIKind,Uri:A.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.WorkspaceEdit,DocumentDropEdit:Q.DocumentDropEdit,DocumentPasteEdit:Q.DocumentPasteEdit,InlayHint:Q.InlayHint,InlayHintLabelPart:Q.InlayHintLabelPart,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.RemoteAuthorityResolverError,ResolvedAuthority:Q.ResolvedAuthority,ManagedResolvedAuthority:Q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.TimelineItem,NotebookRange:Q.NotebookRange,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.NotebookCellData,NotebookData:Q.NotebookData,NotebookRendererScript:Q.NotebookRendererScript,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.NotebookCellOutput,NotebookCellOutputItem:Q.NotebookCellOutputItem,NotebookCellStatusBarItem:Q.NotebookCellStatusBarItem,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.NotebookEdit,NotebookKernelSourceAction:Q.NotebookKernelSourceAction,PortAttributes:Q.PortAttributes,LinkedEditingRanges:Q.LinkedEditingRanges,TestResultState:Q.TestResultState,TestRunRequest:Q.TestRunRequest,TestMessage:Q.TestMessage,TestMessage2:Q.TestMessage,TestTag:Q.TestTag,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Q.DataTransfer,DataTransferItem:Q.DataTransferItem,CoveredCount:Q.CoveredCount,FileCoverage:Q.FileCoverage,StatementCoverage:Q.StatementCoverage,BranchCoverage:Q.BranchCoverage,FunctionCoverage:Q.FunctionCoverage,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.TextTabInput,TabInputTextDiff:Q.TextDiffTabInput,TabInputTextMerge:Q.TextMergeTabInput,TabInputCustom:Q.CustomEditorTabInput,TabInputNotebook:Q.NotebookEditorTabInput,TabInputNotebookDiff:Q.NotebookDiffEditorTabInput,TabInputWebview:Q.WebviewEditorTabInput,TabInputTerminal:Q.TerminalEditorTabInput,TabInputInteractiveWindow:Q.InteractiveWindowInput,TelemetryTrustedValue:Se.TelemetryTrustedValue,LogLevel:Ee.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Q.StackFrameFocus,ThreadFocus:Q.ThreadFocus,RelatedInformationType:Q.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=Ht}),define(Ae[273],Re([1,0,69,109,33,107,34,31,59,62,111,113,114,84,86,80,108,61,39,83,57,60,241,14,112,81,82]),function(be,e,w,R,k,L,A,u,y,m,P,D,a,v,p,f,t,i,c,b,_,E,r,s,n,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,w.registerSingleton)(s.ILoggerService,r.ExtHostLoggerService,1),(0,w.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,w.registerSingleton)(u.IExtHostCommands,u.ExtHostCommands,0),(0,w.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,w.registerSingleton)(i.IExtHostConsumerFileSystem,i.ExtHostConsumerFileSystem,0),(0,w.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,w.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,w.registerSingleton)(S.IExtHostManagedSockets,S.ExtHostManagedSockets,0),(0,w.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo,0),(0,w.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,w.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch,0),(0,w.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,w.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask,0),(0,w.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,w.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,w.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,w.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,w.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,w.registerSingleton)(_.IExtHostTelemetry,_.ExtHostTelemetry,0),(0,w.registerSingleton)(E.IExtHostEditorTabs,E.ExtHostEditorTabs,0),(0,w.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,12,260]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends L.RequireInterceptor{_installInterceptor(){}getModule(v,p){for(const f of this._alternatives){const t=f(v);if(t){v=t;break}}if(this._factories.has(v))return this._factories.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const v=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(m,v,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(v){return v.browser}async _loadCommonJSModule(v,p,f){p=p.with({path:D(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=k.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const b=await c.text(),_=`${p.toString(!0)}#vscode-extension`,E=`${b}
//# sourceURL=${_}`;let r;try{r=new Function("module","exports","require",E)}catch(S){throw console.error(t?`Loading code for extension ${t} failed: ${S.message}`:`Loading code failed: ${S.message}`),console.error(`${p.toString(!0)}${typeof S.line=="number"?` line ${S.line}`:""}${typeof S.column=="number"?` column ${S.column}`:""}`),console.error(S),S}v&&await this._extHostLocalizationService.initializeLocalizedMessages(v);const s={},n={exports:s},o=S=>{const h=this._fakeModules.getModule(S,p);if(h===void 0)throw new Error(`Cannot load module '${S}'`);return h};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,s,o),n.exports!==s?n.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async _waitForDebuggerAttachment(v=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,u.timeout)(10)}}e.ExtHostExtensionService=P;function D(a,v){return a.endsWith(v)?a:a+v}}),define(Ae[275],Re([1,0,68,69,14,35,187,85,274]),function(be,e,w,R,k,L,A,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.registerSingleton)(k.ILogService,new w.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,R.registerSingleton)(L.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,R.registerSingleton)(u.IExtensionStoragePaths,u.ExtensionStoragePaths,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,13,2,273,275]),function(be,e,w,R,k,L,A,u,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function f(r){self.fetch=async function(s,n){return s instanceof Request||v(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),p(s,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,n,o,S,h){(async()=>(v(n.toString())&&(n=(await r(P.URI.parse(n.toString()))).toString(!0)),super.open(s,n,o??!0,S,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,n){if(/^file:/i.test(s.toString()))s=m.FileAccess.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const S=`(${function(l){function g(z){return typeof z=="string"||z instanceof URL?String(z).replace(/^file:\/\//i,"vscode-file://vscode-app"):z}const d=fetch.bind(self);self.fetch=function(z,H){return z instanceof Request?d(z,H):d(g(z),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(z,H,x,$,N){return super.open(z,g(H),x??!0,$,N)}};const T=importScripts.bind(self);self.importScripts=(...z)=>{T(...z.map(g))},T(l)}.toString()}('${s}'))`;n=n||{},n.name=n.name||u.basename(s.toString());const h=new Blob([S],{type:"application/javascript"}),I=URL.createObjectURL(h);return new r(I,n)}}else self.Worker=class extends A.NestedWorker{constructor(r,s){super(a,r,{name:u.basename(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){D()}};class i{constructor(){const s=new MessageChannel,n=new R.Emitter;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=S=>{const{data:h}=S;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const I=w.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,k.isMessageOfType)(I,2)){o=!0,b("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:S=>{if(!o){const h=S.buffer.buffer.slice(S.buffer.byteOffset,S.buffer.byteOffset+S.buffer.byteLength);s.port1.postMessage(h,[h])}}}}}function c(r){return new Promise(s=>{const n=r.onMessage(o=>{n.dispose();const S=JSON.parse(o.toString());r.send((0,k.createMessageOfType)(0)),s({protocol:r,initData:S})});r.send((0,k.createMessageOfType)(1))})}let b=r=>D();function _(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function E(){y.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){_(s)&&c(r.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const o=new L.ExtensionHostMain(n.protocol,n.initData,t,null,s.data);f(S=>o.asBrowserUri(S)),b=S=>o.terminate(S)})}}}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/032b38229264250bcce623b6412a0bb7bd9b4052/core/vs/workbench/api/worker/extensionHostWorker.js.map
