/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],j=function(B){for(var e=[],p=0,E=B.length;p<E;p++)e[p]=W[B[p]];return e};define(W[21],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class p{static get(){const T=new Map,O=new Map,r=new Map,h=new Map;function t(l,n){l.has(n.detail)||l.set(n.detail,-n.timestamp)}function s(l,n){const i=l.get(n.detail);i&&(i>=0||l.set(n.detail,i+n.timestamp))}let u=[];typeof B=="function"&&typeof B.getStats=="function"&&(u=B.getStats().slice(0).sort((l,n)=>l.timestamp-n.timestamp));for(const l of u)switch(l.type){case 10:t(T,l);break;case 11:case 12:s(T,l);break;case 21:t(O,l);break;case 22:s(O,l);break;case 33:t(r,l);break;case 34:s(r,l);break;case 31:t(h,l);break;case 32:s(h,l);break}let o=0;r.forEach(l=>o+=l);function g(l){const n=[];return l.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(T),amdInvoke:g(O),nodeRequire:g(r),nodeEval:g(h),nodeRequireTotal:o}}static toMarkdownTable(T,O){let r="";const h=[];return T.forEach((t,s)=>{h[s]=t.length}),O.forEach(t=>{t.forEach((s,u)=>{typeof s>"u"&&(s=t[u]="-");const o=s.toString().length;h[u]=Math.max(o,h[u])})}),T.forEach((t,s)=>{r+=`| ${t+" ".repeat(h[s]-t.toString().length)} `}),r+=`|
`,T.forEach((t,s)=>{r+=`| ${"-".repeat(h[s])} `}),r+=`|
`,O.forEach(t=>{t.forEach((s,u)=>{typeof s<"u"&&(r+=`| ${s+" ".repeat(h[u]-s.toString().length)} `)}),r+=`|
`}),r}}e.LoaderStats=p}),define(W[4],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let p;function E(i){p=i}e.setLogger=E;function T(){return p}e.getLogger=T;class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(a){return r([h(l("|  ",this.indentation)),a])}formatInfo(a){return a.hadValue?a.didChange?[h(" "),s(u(a.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),s(u(a.newValue,60),{color:"green"})]:[h(" (unchanged)")]:[h(" "),s(u(a.newValue,60),{color:"green"}),h(" (initial)")]}handleObservableChanged(a,k){console.log(...this.textToConsoleArgs([t("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(k)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(k=>k.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const k=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(L,D)=>(this.changedObservablesSets.get(a).add(L),k.apply(a,[L,D]))}handleDerivedRecomputed(a,k){const L=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([t("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(k),this.formatChanges(L),{data:[{fn:a._computeFn}]}])),L.clear()}handleFromEventObservableTriggered(a,k){console.log(...this.textToConsoleArgs([t("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(k),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const k=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(L,D)=>(this.changedObservablesSets.get(a).add(L),k.apply(a,[L,D]))}handleAutorunTriggered(a){const k=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([t("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(k),{data:[{fn:a._runFn}]}])),k.clear(),this.indentation++}handleAutorunFinished(a){this.indentation--}handleBeginTransaction(a){let k=a.getDebugName();k===void 0&&(k=""),console.log(...this.textToConsoleArgs([t("transaction"),s(k,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function r(i){const a=new Array,k=[];let L="";function D(w){if("length"in w)for(const m of w)m&&D(m);else"text"in w?(L+=`%c${w.text}`,a.push(w.style),w.data&&k.push(...w.data)):"data"in w&&k.push(...w.data)}D(i);const I=[L,...a];return I.push(...k),I}function h(i){return s(i,{color:"black"})}function t(i){return s(n(`${i}: `,10),{color:"black",bold:!0})}function s(i,a={color:"black"}){function k(D){return Object.entries(D).reduce((I,[w,m])=>`${I}${w}:${m};`,"")}const L={color:a.color};return a.strikeThrough&&(L["text-decoration"]="line-through"),a.bold&&(L["font-weight"]="bold"),{text:i,style:k(L)}}function u(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?o(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function o(i,a){let k="[ ",L=!0;for(const D of i){if(L||(k+=", "),k.length-5>a){k+="...";break}L=!1,k+=`${u(D,a-k.length)}`}return k+=" ]",k}function g(i,a){let k="{ ",L=!0;for(const[D,I]of Object.entries(i)){if(L||(k+=", "),k.length-5>a){k+="...";break}L=!1,k+=`${D}: ${u(I,a-k.length)}`}return k+=" }",k}function l(i,a){let k="";for(let L=1;L<=a;L++)k+=i;return k}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(W[5],j([0,1,4]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.getDebugName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=void 0;let E;function T(v){E=v}e._setDerivedOpts=T;class O{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,_){const A=_===void 0?void 0:d,f=_===void 0?d:_;return E({owner:A,debugName:()=>{const y=L(f);if(y!==void 0)return y;const U=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(U)return`${this.debugName}.${U[2]}`;if(!A)return`${this.debugName} (mapped)`}},y=>f(this.read(y),y))}}e.ConvenientObservable=O;class r extends O{constructor(){super(...arguments),this.observers=new Set}addObserver(d){const _=this.observers.size;this.observers.add(d),_===0&&this.onFirstObserverAdded()}removeObserver(d){this.observers.delete(d)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=r;function h(v,d){const _=new s(v,d);try{v(_)}finally{_.finish()}}e.transaction=h;function t(v,d,_){v?d(v):h(d,_)}e.subtransaction=t;class s{constructor(d,_){this._fn=d,this._getDebugName=_,this.updatingObservers=[],(0,p.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():L(this._fn)}updateObserver(d,_){this.updatingObservers.push({observer:d,observable:_}),d.beginUpdate(_)}finish(){const d=this.updatingObservers;this.updatingObservers=null;for(const{observer:_,observable:A}of d)_.endUpdate(A);(0,p.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=s;const u=new Map,o=new WeakMap;function g(v,d,_,A,f){const y=o.get(v);if(y)return y;const R=l(v,d,_,A,f);if(R){let U=u.get(R)??0;U++,u.set(R,U);const C=U===1?R:`${R}#${U}`;return o.set(v,C),C}}e.getDebugName=g;function l(v,d,_,A,f){const y=o.get(v);if(y)return y;const R=A?a(A)+".":"";let U;if(d!==void 0)if(typeof d=="function"){if(U=d(),U!==void 0)return R+U}else return R+d;if(_!==void 0&&(U=L(_),U!==void 0))return R+U;if(A!==void 0){for(const C in A)if(A[C]===f)return R+C}}const n=new Map,i=new WeakMap;function a(v){const d=i.get(v);if(d)return d;const _=k(v);let A=n.get(_)??0;A++,n.set(_,A);const f=A===1?_:`${_}#${A}`;return i.set(v,f),f}function k(v){const d=v.constructor;return d?d.name:"Object"}function L(v){const d=v.toString(),A=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(A?A[1]:void 0)?.trim()}e.getFunctionName=L;function D(v,d){return typeof v=="string"?new I(void 0,v,d):new I(v,void 0,d)}e.observableValue=D;class I extends r{get debugName(){return g(this,this._debugName,void 0,this._owner,this)??"ObservableValue"}constructor(d,_,A){super(),this._owner=d,this._debugName=_,this._value=A}get(){return this._value}set(d,_,A){if(this._value===d)return;let f;_||(_=f=new s(()=>{},()=>`Setting ${this.debugName}`));try{const y=this._value;this._setValue(d),(0,p.getLogger)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:A,didChange:!0,hadValue:!0});for(const R of this.observers)_.updateObserver(R,this),R.handleChange(this,A)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(d){this._value=d}}e.ObservableValue=I;function w(v,d){return typeof v=="string"?new m(void 0,v,d):new m(v,void 0,d)}e.disposableObservableValue=w;class m extends I{_setValue(d){this._value!==d&&(this._value&&this._value.dispose(),this._value=d)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=m}),define(W[9],j([0,1,42,2,5,4]),function(B,e,p,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorun=e.autorunOpts=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.autorunOpts=r;function h(n){return new g(void 0,n,void 0,void 0)}e.autorun=h;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.autorunHandleChanges=t;function s(n,i){const a=new E.DisposableStore,k=t({debugName:n.debugName??(()=>(0,T.getFunctionName)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(L,D)=>{a.clear(),i(L,D,a)});return(0,E.toDisposable)(()=>{k.dispose(),a.dispose()})}e.autorunWithStoreHandleChanges=s;function u(n){const i=new E.DisposableStore,a=r({debugName:()=>(0,T.getFunctionName)(n)||"(anonymous)"},k=>{i.clear(),n(k,i)});return(0,E.toDisposable)(()=>{a.dispose(),i.dispose()})}e.autorunWithStore=u;var o;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(o||(o={}));class g{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const a=this._debugName();if(a!==void 0)return a}const i=(0,T.getFunctionName)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,k,L){this._debugName=i,this._runFn=a,this.createChangeSummary=k,this._handleChange=L,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,O.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,E.trackDisposable)(this)}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear(),(0,E.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3;try{if(!this.disposed){(0,O.getLogger)()?.handleAutorunTriggered(this);const a=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,a)}}finally{(0,O.getLogger)()?.handleAutorunFinished(this);for(const a of this.dependenciesToBeRemoved)a.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,p.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,a){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:a,didChange:L=>L===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const a=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),a}}e.AutorunObserver=g,function(n){n.Observer=g}(h||(e.autorun=h={}));function l(n,i){let a;return r({debugName:()=>(0,T.getFunctionName)(i)},k=>{const L=n.read(k),D=a;a=L,i({lastValue:D,newValue:L})})}e.autorunDelta=l}),define(W[10],j([0,1,6,2,5,4]),function(B,e,p,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const r=(l,n)=>l===n;function h(l,n){return n!==void 0?new g(l,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,l,void 0,void 0,void 0,r)}e.derived=h;function t(l,n){return new g(l.owner,l.debugName,n,void 0,void 0,void 0,l.equalityComparer??r)}e.derivedOpts=t;function s(l,n){return new g(l.owner,l.debugName,n,l.createEmptyChangeSummary,l.handleChange,void 0,l.equalityComparer??r)}e.derivedHandleChanges=s;function u(l,n){let i,a;n===void 0?(i=l,a=void 0):(a=l,i=n);const k=new E.DisposableStore;return new g(a,()=>(0,T.getFunctionName)(i)??"(anonymous)",L=>(k.clear(),i(L,k)),void 0,void 0,()=>k.dispose(),r)}e.derivedWithStore=u,(0,T._setDerivedOpts)(t);var o;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(o||(o={}));class g extends T.BaseObservable{get debugName(){return(0,T.getDebugName)(this,this._debugName,this._computeFn,this._owner,this)??"(anonymous)"}constructor(n,i,a,k,L,D=void 0,I){super(),this._owner=n,this._debugName=i,this._computeFn=a,this.createChangeSummary=k,this._handleChange=L,this._handleLastObserverRemoved=D,this._equalityComparator=I,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,O.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const i=this.state!==0,a=this.value;this.state=3;const k=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,k)}finally{for(const D of this.dependenciesToBeRemoved)D.removeObserver(this);this.dependenciesToBeRemoved.clear()}const L=i&&!this._equalityComparator(a,this.value);if((0,O.getLogger)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.value,change:void 0,didChange:L,hadValue:i}),L)for(const D of this.observers)D.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const i=this.updateCount===1;if(this.state===3&&(this.state=1,!i))for(const a of this.observers)a.handlePossibleChange(this);if(i)for(const a of this.observers)a.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const i=[...this.observers];for(const a of i)a.endUpdate(this)}if(this.updateCount<0)throw new p.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const i of this.observers)i.handlePossibleChange(this)}}handleChange(n,i){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const a=this._handleChange?this._handleChange({changedObservable:n,change:i,didChange:L=>L===n},this.changeSummary):!0,k=this.state===3;if(a&&(this.state===1||k)&&(this.state=2,k))for(const L of this.observers)L.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),i}addObserver(n){const i=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.Derived=g}),define(W[22],j([0,1,2,9,5,10,4]),function(B,e,p,E,T,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(d){return new t(d)}e.constObservable=h;class t extends T.ConvenientObservable{constructor(_){super(),this.value=_}get debugName(){return this.toString()}get(){return this.value}addObserver(_){}removeObserver(_){}toString(){return`Const: ${this.value}`}}function s(d){const _=(0,T.observableValue)("promiseValue",{});return d.then(A=>{_.set({value:A},void 0)}),_}e.observableFromPromise=s;function u(d,_){return new Promise(A=>{let f=!1,y=!1;const R=(0,E.autorun)(U=>{const C=d.read(U);_(C)&&(f?R.dispose():y=!0,A(C))});f=!0,y&&R.dispose()})}e.waitForState=u;function o(d,_){return new g(d,_)}e.observableFromEvent=o;class g extends T.BaseObservable{constructor(_,A){super(),this.event=_,this._getValue=A,this.hasValue=!1,this.handleEvent=f=>{const y=this._getValue(f),R=!this.hasValue||this.value!==y;(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:y,change:void 0,didChange:R,hadValue:this.hasValue}),R&&(this.value=y,this.hasValue&&(0,T.transaction)(U=>{for(const C of this.observers)U.updateObserver(C,this),C.handleChange(this,void 0)},()=>{const U=this.getDebugName();return"Event fired"+(U?`: ${U}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,T.getFunctionName)(this._getValue)}get debugName(){const _=this.getDebugName();return"From Event"+(_?`: ${_}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=g,function(d){d.Observer=g}(o||(e.observableFromEvent=o={}));function l(d,_){return new n(d,_)}e.observableSignalFromEvent=l;class n extends T.BaseObservable{constructor(_,A){super(),this.debugName=_,this.event=A,this.handleEvent=()=>{(0,T.transaction)(f=>{for(const y of this.observers)f.updateObserver(y,this),y.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function i(d){return typeof d=="string"?new a(d):new a(void 0,d)}e.observableSignal=i;class a extends T.BaseObservable{get debugName(){return(0,T.getDebugName)(this,this._debugName,void 0,this._owner,this)??"Observable Signal"}constructor(_,A){super(),this._debugName=_,this._owner=A}trigger(_,A){if(!_){(0,T.transaction)(f=>{this.trigger(f,A)},()=>`Trigger signal ${this.debugName}`);return}for(const f of this.observers)_.updateObserver(f,this),f.handleChange(this,A)}get(){}}function k(d,_,A){const f=(0,T.observableValue)("debounced",void 0);let y;return A.add((0,E.autorun)(R=>{const U=d.read(R);y&&clearTimeout(y),y=setTimeout(()=>{(0,T.transaction)(C=>{f.set(U,C)})},_)})),f}e.debouncedObservable=k;function L(d,_,A){const f=(0,T.observableValue)("triggeredRecently",!1);let y;return A.add(d(()=>{f.set(!0,void 0),y&&clearTimeout(y),y=setTimeout(()=>{f.set(!1,void 0)},_)})),f}e.wasEventTriggeredRecently=L;function D(d){const _=new w(!1);return d.addObserver(_),(0,p.toDisposable)(()=>{d.removeObserver(_)})}e.keepObserved=D;function I(d){const _=new w(!0);return d.addObserver(_),d.reportChanges(),(0,p.toDisposable)(()=>{d.removeObserver(_)})}e.recomputeInitiallyAndOnChange=I;class w{constructor(_){this.forceRecompute=_,this.counter=0}beginUpdate(_){this.counter++}endUpdate(_){this.counter--,this.counter===0&&this.forceRecompute&&_.reportChanges()}handlePossibleChange(_){}handleChange(_,A){}}function m(d){let _;return(0,O.derived)(f=>(_=d(f,_),_))}e.derivedObservableWithCache=m;function v(d,_){let A;const f=(0,T.observableValue)("derivedObservableWithWritableCache.counter",0),y=(0,O.derived)(d,R=>(f.read(R),A=_(R,A),A));return Object.assign(y,{clearCache:R=>{A=void 0,f.set(f.get()+1,R)}})}e.derivedObservableWithWritableCache=v}),define(W[11],j([0,1,5,10,9,22,4]),function(B,e,p,E,T,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return p.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return p.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return p.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return p.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return T.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return T.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return T.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return T.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return T.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return T.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.wasEventTriggeredRecently}}),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(W[23],j([0,1,6,2]),function(B,e,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(I){const w=I;return w?typeof w.read=="function":!1}e.isReadable=T;function O(I){const w=I;return w?[w.on,w.pause,w.resume,w.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=O;function r(I){const w=I;return w?O(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=r;function h(I,w){return new t(I,w)}e.newWriteableStream=h;class t{constructor(w,m){this.reducer=w,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(m=>m(w))}emitError(w){this.listeners.error.length===0?(0,p.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(m=>m(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,m){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(w,m){if(this.state.destroyed)return;let v;switch(w){case"data":v=this.listeners.data;break;case"end":v=this.listeners.end;break;case"error":v=this.listeners.error;break}if(v){const d=v.indexOf(m);d>=0&&v.splice(d,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(v=>v())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function s(I,w){const m=[];let v;for(;(v=I.read())!==null;)m.push(v);return w(m)}e.consumeReadable=s;function u(I,w,m){const v=[];let d;for(;(d=I.read())!==null&&v.length<m;)v.push(d);return d===null&&v.length>0?w(v):{read:()=>{if(v.length>0)return v.shift();if(typeof d<"u"){const _=d;return d=void 0,_}return I.read()}}}e.peekReadable=u;function o(I,w){return new Promise((m,v)=>{const d=[];g(I,{onData:_=>{w&&d.push(_)},onError:_=>{w?v(_):m(void 0)},onEnd:()=>{m(w?w(d):void 0)}})})}e.consumeStream=o;function g(I,w,m){I.on("error",v=>{m?.isCancellationRequested||w.onError(v)}),I.on("end",()=>{m?.isCancellationRequested||w.onEnd()}),I.on("data",v=>{m?.isCancellationRequested||w.onData(v)})}e.listenStream=g;function l(I,w){return new Promise((m,v)=>{const d=new E.DisposableStore,_=[],A=R=>{if(_.push(R),_.length>w)return d.dispose(),I.pause(),m({stream:I,buffer:_,ended:!1})},f=R=>(d.dispose(),v(R)),y=()=>(d.dispose(),m({stream:I,buffer:_,ended:!0}));d.add((0,E.toDisposable)(()=>I.removeListener("error",f))),I.on("error",f),d.add((0,E.toDisposable)(()=>I.removeListener("end",y))),I.on("end",y),d.add((0,E.toDisposable)(()=>I.removeListener("data",A))),I.on("data",A)})}e.peekStream=l;function n(I,w){const m=h(w);return m.end(I),m}e.toStream=n;function i(){const I=h(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=i;function a(I){let w=!1;return{read:()=>w?null:(w=!0,I)}}e.toReadable=a;function k(I,w,m){const v=h(m);return g(I,{onData:d=>v.write(w.data(d)),onError:d=>v.error(w.error?w.error(d):d),onEnd:()=>v.end()}),v}e.transform=k;function L(I,w,m){let v=!1;return{read:()=>{const d=w.read();return v?d:(v=!0,d!==null?m([I,d]):I)}}}e.prefixedReadable=L;function D(I,w,m){let v=!1;const d=h(m);return g(w,{onData:_=>v?d.write(_):(v=!0,d.write(m([I,_]))),onError:_=>d.error(_),onEnd:()=>{v||(v=!0,d.write(I)),d.end()}}),d}e.prefixedStream=D}),define(W[12],j([0,1,43,23]),function(B,e,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const T=typeof Buffer<"u",O=new p.Lazy(()=>new Uint8Array(256));let r,h;class t{static alloc(b){return T?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return T&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,z){return!(z?.dontUseNodeBuffer||!1)&&T?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const z=t.alloc(b.length);for(let V=0,$=b.length;V<$;V++)z.buffer[V]=b[V];return z}static concat(b,z){if(typeof z>"u"){z=0;for(let K=0,G=b.length;K<G;K++)z+=b[K].byteLength}const V=t.alloc(z);let $=0;for(let K=0,G=b.length;K<G;K++){const q=b[K];V.set(q,$),$+=q.byteLength}return V}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return T?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(b,z){return new t(this.buffer.subarray(b,z))}set(b,z){if(b instanceof t)this.buffer.set(b.buffer,z);else if(b instanceof Uint8Array)this.buffer.set(b,z);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),z);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,z){l(this.buffer,b,z)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,z){i(this.buffer,b,z)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,z){k(this.buffer,b,z)}indexOf(b,z=0){return s(this.buffer,b instanceof t?b.buffer:b,z)}}e.VSBuffer=t;function s(C,b,z=0){const V=b.byteLength,$=C.byteLength;if(V===0)return 0;if(V===1)return C.indexOf(b[0]);if(V>$-z)return-1;const K=O.value;K.fill(b.length);for(let J=0;J<b.length;J++)K[b[J]]=b.length-J-1;let G=z+b.length-1,q=G,H=-1;for(;G<$;)if(C[G]===b[q]){if(q===0){H=G;break}G--,q--}else G+=Math.max(b.length-q,K[C[G]]),q=b.length-1;return H}e.binaryIndexOf=s;function u(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0}e.readUInt16LE=u;function o(C,b,z){C[z+0]=b&255,b=b>>>8,C[z+1]=b&255}e.writeUInt16LE=o;function g(C,b){return C[b]*2**24+C[b+1]*2**16+C[b+2]*2**8+C[b+3]}e.readUInt32BE=g;function l(C,b,z){C[z+3]=b,b=b>>>8,C[z+2]=b,b=b>>>8,C[z+1]=b,b=b>>>8,C[z]=b}e.writeUInt32BE=l;function n(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0|C[b+2]<<16>>>0|C[b+3]<<24>>>0}e.readUInt32LE=n;function i(C,b,z){C[z+0]=b&255,b=b>>>8,C[z+1]=b&255,b=b>>>8,C[z+2]=b&255,b=b>>>8,C[z+3]=b&255}e.writeUInt32LE=i;function a(C,b){return C[b]}e.readUInt8=a;function k(C,b,z){C[z]=b}e.writeUInt8=k;function L(C){return E.consumeReadable(C,b=>t.concat(b))}e.readableToBuffer=L;function D(C){return E.toReadable(C)}e.bufferToReadable=D;function I(C){return E.consumeStream(C,b=>t.concat(b))}e.streamToBuffer=I;async function w(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await I(C.stream)])}e.bufferedStreamToBuffer=w;function m(C){return E.toStream(C,b=>t.concat(b))}e.bufferToStream=m;function v(C){return E.transform(C,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.streamToBufferReadableStream=v;function d(C){return E.newWriteableStream(b=>t.concat(b),C)}e.newWriteableBufferStream=d;function _(C,b){return E.prefixedReadable(C,b,z=>t.concat(z))}e.prefixedBufferReadable=_;function A(C,b){return E.prefixedStream(C,b,z=>t.concat(z))}e.prefixedBufferStream=A;function f(C){let b=0,z=0,V=0;const $=new Uint8Array(Math.floor(C.length/4*3)),K=q=>{switch(z){case 3:$[V++]=b|q,z=0;break;case 2:$[V++]=b|q>>>2,b=q<<6,z=3;break;case 1:$[V++]=b|q>>>4,b=q<<4,z=2;break;default:b=q<<2,z=1}};for(let q=0;q<C.length;q++){const H=C.charCodeAt(q);if(H>=65&&H<=90)K(H-65);else if(H>=97&&H<=122)K(H-97+26);else if(H>=48&&H<=57)K(H-48+52);else if(H===43||H===45)K(62);else if(H===47||H===95)K(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${C[q]}`)}}const G=V;for(;z>0;)K(0);return t.wrap($).slice(0,G)}e.decodeBase64=f;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:C},b=!0,z=!1){const V=z?R:y;let $="";const K=C.byteLength%3;let G=0;for(;G<C.byteLength-K;G+=3){const q=C[G+0],H=C[G+1],J=C[G+2];$+=V[q>>>2],$+=V[(q<<4|H>>>4)&63],$+=V[(H<<2|J>>>6)&63],$+=V[J&63]}if(K===1){const q=C[G+0];$+=V[q>>>2],$+=V[q<<4&63],b&&($+="==")}else if(K===2){const q=C[G+0],H=C[G+1];$+=V[q>>>2],$+=V[(q<<4|H>>>4)&63],$+=V[H<<2&63],b&&($+="=")}return $}e.encodeBase64=U}),define(W[24],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[13],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var p;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(p||(e.StringEOL=p={}));function E(T){let O=0,r=0,h=0,t=0;for(let s=0,u=T.length;s<u;s++){const o=T.charCodeAt(s);o===13?(O===0&&(r=s),O++,s+1<u&&T.charCodeAt(s+1)===10?(t|=2,s++):t|=3,h=s+1):o===10&&(t|=1,O===0&&(r=s),O++,h=s+1)}return O===0&&(r=T.length),[O,r,T.length-h,t]}e.countEOL=E}),define(W[14],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var p;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(p||(e.LanguageId=p={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var T;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(T||(e.ColorId=T={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class h{static getLanguageId(s){return(s&255)>>>0}static getTokenType(s){return(s&768)>>>8}static containsBalancedBrackets(s){return(s&1024)!==0}static getFontStyle(s){return(s&30720)>>>11}static getForeground(s){return(s&16744448)>>>15}static getBackground(s){return(s&4278190080)>>>24}static getClassNameFromMetadata(s){let o="mtk"+this.getForeground(s);const g=this.getFontStyle(s);return g&1&&(o+=" mtki"),g&2&&(o+=" mtkb"),g&4&&(o+=" mtku"),g&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(s,u){const o=this.getForeground(s),g=this.getFontStyle(s);let l=`color: ${u[o]};`;g&1&&(l+="font-style: italic;"),g&2&&(l+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(l+=`text-decoration:${n};`),l}static getPresentationFromMetadata(s){const u=this.getForeground(s),o=this.getFontStyle(s);return{foreground:u,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.TokenMetadata=h}),define(W[25],j([0,1,26]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class E{constructor(r){this._default=r,this._store=[]}get(r){return r<this._store.length?this._store[r]:this._default}set(r,h){for(;r>=this._store.length;)this._store[this._store.length]=this._default;this._store[r]=h}replace(r,h,t){if(r>=this._store.length)return;if(h===0){this.insert(r,t);return}else if(t===0){this.delete(r,h);return}const s=this._store.slice(0,r),u=this._store.slice(r+h),o=T(t,this._default);this._store=s.concat(o,u)}delete(r,h){h===0||r>=this._store.length||this._store.splice(r,h)}insert(r,h){if(h===0||r>=this._store.length)return;const t=[];for(let s=0;s<h;s++)t[s]=this._default;this._store=(0,p.arrayInsert)(this._store,r,t)}}e.FixedArray=E;function T(O,r){const h=[];for(let t=0;t<O;t++)h[t]=r;return h}}),define(W[7],j([0,1,14]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class E{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,h){const t=E.defaultTokenMetadata,s=new Uint32Array(2);return s[0]=r.length,s[1]=t,new E(s,r,h)}constructor(r,h,t){this._lineTokensBrand=void 0,this._tokens=r,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(r){return r instanceof E?this.slicedEquals(r,0,this._tokensCount):!1}slicedEquals(r,h,t){if(this._text!==r._text||this._tokensCount!==r._tokensCount)return!1;const s=h<<1,u=s+(t<<1);for(let o=s;o<u;o++)if(this._tokens[o]!==r._tokens[o])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(r){return r>0?this._tokens[r-1<<1]:0}getMetadata(r){return this._tokens[(r<<1)+1]}getLanguageId(r){const h=this._tokens[(r<<1)+1],t=p.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(r){const h=this._tokens[(r<<1)+1];return p.TokenMetadata.getTokenType(h)}getForeground(r){const h=this._tokens[(r<<1)+1];return p.TokenMetadata.getForeground(h)}getClassName(r){const h=this._tokens[(r<<1)+1];return p.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(r,h){const t=this._tokens[(r<<1)+1];return p.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(r){const h=this._tokens[(r<<1)+1];return p.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(r){return this._tokens[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this._tokens,r)}inflate(){return this}sliceAndInflate(r,h,t){return new T(this,r,h,t)}static convertToEndOffset(r,h){const s=(r.length>>>1)-1;for(let u=0;u<s;u++)r[u<<1]=r[u+1<<1];r[s<<1]=h}static findIndexInTokensArray(r,h){if(r.length<=2)return 0;let t=0,s=(r.length>>>1)-1;for(;t<s;){const u=t+Math.floor((s-t)/2),o=r[u<<1];if(o===h)return u+1;o<h?t=u+1:o>h&&(s=u)}return t}withInserted(r){if(r.length===0)return this;let h=0,t=0,s="";const u=new Array;let o=0;for(;;){const g=h<this._tokensCount?this._tokens[h<<1]:-1,l=t<r.length?r[t]:null;if(g!==-1&&(l===null||g<=l.offset)){s+=this._text.substring(o,g);const n=this._tokens[(h<<1)+1];u.push(s.length,n),h++,o=g}else if(l){if(l.offset>o){s+=this._text.substring(o,l.offset);const n=this._tokens[(h<<1)+1];u.push(s.length,n),o=l.offset}s+=l.text,u.push(s.length,l.tokenMetadata),t++}else break}return new E(new Uint32Array(u),s,this._languageIdCodec)}}e.LineTokens=E;class T{constructor(r,h,t,s){this._source=r,this._startOffset=h,this._endOffset=t,this._deltaOffset=s,this._firstTokenIndex=r.findTokenIndexAtOffset(h),this._tokensCount=0;for(let u=this._firstTokenIndex,o=r.getCount();u<o&&!(r.getStartOffset(u)>=t);u++)this._tokensCount++}getMetadata(r){return this._source.getMetadata(this._firstTokenIndex+r)}getLanguageId(r){return this._source.getLanguageId(this._firstTokenIndex+r)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(r){return r instanceof T?this._startOffset===r._startOffset&&this._endOffset===r._endOffset&&this._deltaOffset===r._deltaOffset&&this._source.slicedEquals(r._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(r){return this._source.getForeground(this._firstTokenIndex+r)}getEndOffset(r){const h=this._source.getEndOffset(this._firstTokenIndex+r);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(r){return this._source.getClassName(this._firstTokenIndex+r)}getInlineStyle(r,h){return this._source.getInlineStyle(this._firstTokenIndex+r,h)}getPresentation(r){return this._source.getPresentation(this._firstTokenIndex+r)}findTokenIndexAtOffset(r){return this._source.findTokenIndexAtOffset(r+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[27],j([0,1,7]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class E{static deleteBeginning(r,h){return r===null||r===e.EMPTY_LINE_TOKENS?r:E.delete(r,0,h)}static deleteEnding(r,h){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=T(r),s=t[t.length-2];return E.delete(r,h,s)}static delete(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS||h===t)return r;const s=T(r),u=s.length>>>1;if(h===0&&s[s.length-2]===t)return e.EMPTY_LINE_TOKENS;const o=p.LineTokens.findIndexInTokensArray(s,h),g=o>0?s[o-1<<1]:0,l=s[o<<1];if(t<l){const L=t-h;for(let D=o;D<u;D++)s[D<<1]-=L;return r}let n,i;g!==h?(s[o<<1]=h,n=o+1<<1,i=h):(n=o<<1,i=g);const a=t-h;for(let L=o+1;L<u;L++){const D=s[L<<1]-a;D>i&&(s[n++]=D,s[n++]=s[(L<<1)+1],i=D)}if(n===s.length)return r;const k=new Uint32Array(n);return k.set(s.subarray(0,n),0),k.buffer}static append(r,h){if(h===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return h;if(r===null)return r;if(h===null)return null;const t=T(r),s=T(h),u=s.length>>>1,o=new Uint32Array(t.length+s.length);o.set(t,0);let g=t.length;const l=t[t.length-2];for(let n=0;n<u;n++)o[g++]=s[n<<1]+l,o[g++]=s[(n<<1)+1];return o.buffer}static insert(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const s=T(r),u=s.length>>>1;let o=p.LineTokens.findIndexInTokensArray(s,h);o>0&&s[o-1<<1]===h&&o--;for(let g=o;g<u;g++)s[g<<1]+=t;return r}}e.ContiguousTokensEditing=E;function T(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.toUint32Array=T}),define(W[28],j([0,1,26,12,44,13,27,15]),function(B,e,p,E,T,O,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(u,o,g){const l=new Uint32Array(u.buffer),n=(0,E.readUInt32BE)(u,o);o+=4;const i=(0,E.readUInt32BE)(u,o);o+=4;const a=[];for(let k=0;k<i;k++){const L=(0,E.readUInt32BE)(u,o);o+=4,a.push(l.subarray(o/4,o/4+L/4)),o+=L}return g.push(new t(n,a)),o}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(u,o){this._startLineNumber=u,this._tokens=o}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(u){return this._tokens[u-this._startLineNumber]}appendLineTokens(u){this._tokens.push(u)}serializeSize(){let u=0;u+=4,u+=4;for(let o=0;o<this._tokens.length;o++){const g=this._tokens[o];if(!(g instanceof Uint32Array))throw new Error("Not supported!");u+=4,u+=g.byteLength}return u}serialize(u,o){(0,E.writeUInt32BE)(u,this._startLineNumber,o),o+=4,(0,E.writeUInt32BE)(u,this._tokens.length,o),o+=4;for(let g=0;g<this._tokens.length;g++){const l=this._tokens[g];if(!(l instanceof Uint32Array))throw new Error("Not supported!");(0,E.writeUInt32BE)(u,l.byteLength,o),o+=4,u.set(new Uint8Array(l.buffer),o),o+=l.byteLength}return o}applyEdit(u,o){const[g,l]=(0,O.countEOL)(o);this._acceptDeleteRange(u),this._acceptInsertText(new T.Position(u.startLineNumber,u.startColumn),g,l)}_acceptDeleteRange(u){if(u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn)return;const o=u.startLineNumber-this._startLineNumber,g=u.endLineNumber-this._startLineNumber;if(g<0){const l=g-o;this._startLineNumber-=l;return}if(!(o>=this._tokens.length)){if(o<0&&g>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(o===g){this._tokens[o]=r.ContiguousTokensEditing.delete(this._tokens[o],u.startColumn-1,u.endColumn-1);return}if(o>=0)if(this._tokens[o]=r.ContiguousTokensEditing.deleteEnding(this._tokens[o],u.startColumn-1),g<this._tokens.length){const l=r.ContiguousTokensEditing.deleteBeginning(this._tokens[g],u.endColumn-1);this._tokens[o]=r.ContiguousTokensEditing.append(this._tokens[o],l),this._tokens.splice(o+1,g-o)}else this._tokens[o]=r.ContiguousTokensEditing.append(this._tokens[o],null),this._tokens=this._tokens.slice(0,o+1);else{const l=-o;this._startLineNumber-=l,this._tokens[g]=r.ContiguousTokensEditing.deleteBeginning(this._tokens[g],u.endColumn-1),this._tokens=this._tokens.slice(g)}}}_acceptInsertText(u,o,g){if(o===0&&g===0)return;const l=u.lineNumber-this._startLineNumber;if(l<0){this._startLineNumber+=o;return}if(!(l>=this._tokens.length)){if(o===0){this._tokens[l]=r.ContiguousTokensEditing.insert(this._tokens[l],u.column-1,g);return}this._tokens[l]=r.ContiguousTokensEditing.deleteEnding(this._tokens[l],u.column-1),this._tokens[l]=r.ContiguousTokensEditing.insert(this._tokens[l],u.column-1,g),this._insertLines(u.lineNumber,o)}}_insertLines(u,o){if(o===0)return;const g=[];for(let l=0;l<o;l++)g[l]=null;this._tokens=p.arrayInsert(this._tokens,u,g)}}e.ContiguousMultilineTokens=t}),define(W[16],j([0,1,12,28]),function(B,e,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class T{static deserialize(r){let h=0;const t=(0,p.readUInt32BE)(r,h);h+=4;const s=[];for(let u=0;u<t;u++)h=E.ContiguousMultilineTokens.deserialize(r,h,s);return s}constructor(){this._tokens=[]}add(r,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(h);return}}this._tokens.push(new E.ContiguousMultilineTokens(r,[h]))}finalize(){return this._tokens}serialize(){const r=this._serializeSize(),h=new Uint8Array(r);return this._serialize(h),h}_serializeSize(){let r=0;r+=4;for(let h=0;h<this._tokens.length;h++)r+=this._tokens[h].serializeSize();return r}_serialize(r){let h=0;(0,p.writeUInt32BE)(r,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(r,h)}}e.ContiguousMultilineTokensBuilder=T}),define(W[29],j([0,1,30,3,31,45]),function(B,e,p,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(f){return f===47||f===92}e.isPathSeparator=r;function h(f){return f.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=h;function t(f){return f.indexOf("/")===-1&&(f=h(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=t;function s(f,y=p.posix.sep){if(!f)return"";const R=f.length,U=f.charCodeAt(0);if(r(U)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let b=3;const z=b;for(;b<R&&!r(f.charCodeAt(b));b++);if(z!==b&&!r(f.charCodeAt(b+1))){for(b+=1;b<R;b++)if(r(f.charCodeAt(b)))return f.slice(0,b+1).replace(/[\\/]/g,y)}}return y}else if(k(U)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+y:f.slice(0,2);let C=f.indexOf("://");if(C!==-1){for(C+=3;C<R;C++)if(r(f.charCodeAt(C)))return f.slice(0,C+1)}return""}e.getRoot=s;function u(f){if(!E.isWindows||!f||f.length<5)return!1;let y=f.charCodeAt(0);if(y!==92||(y=f.charCodeAt(1),y!==92))return!1;let R=2;const U=R;for(;R<f.length&&(y=f.charCodeAt(R),y!==92);R++);return!(U===R||(y=f.charCodeAt(R+1),isNaN(y)||y===92))}e.isUNC=u;const o=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,y=E.isWindows){const R=y?o:g;return!(!f||f.length===0||/^\s+$/.test(f)||(R.lastIndex=0,R.test(f))||y&&l.test(f)||f==="."||f===".."||y&&f[f.length-1]==="."||y&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=n;function i(f,y,R){const U=f===y;return!R||U?U:!f||!y?!1:(0,T.equalsIgnoreCase)(f,y)}e.isEqual=i;function a(f,y,R,U=p.sep){if(f===y)return!0;if(!f||!y||y.length>f.length)return!1;if(R){if(!(0,T.startsWithIgnoreCase)(f,y))return!1;if(y.length===f.length)return!0;let b=y.length;return y.charAt(y.length-1)===U&&b--,f.charAt(b)===U}return y.charAt(y.length-1)!==U&&(y+=U),f.indexOf(y)===0}e.isEqualOrParent=a;function k(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=k;function L(f,y){return E.isWindows&&f.endsWith(":")&&(f+=p.sep),(0,p.isAbsolute)(f)||(f=(0,p.join)(y,f)),f=(0,p.normalize)(f),E.isWindows?(f=(0,T.rtrim)(f,p.sep),f.endsWith(":")&&(f+=p.sep)):(f=(0,T.rtrim)(f,p.sep),f||(f=p.sep)),f}e.sanitizeFilePath=L;function D(f){const y=(0,p.normalize)(f);return E.isWindows?f.length>3?!1:I(y)&&(f.length===2||y.charCodeAt(2)===92):y===p.posix.sep}e.isRootOrDriveLetter=D;function I(f,y=E.isWindows){return y?k(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function w(f,y=E.isWindows){return I(f,y)?f[0]:void 0}e.getDriveLetter=w;function m(f,y,R){return y.length>f.length?-1:f===y?0:(R&&(f=f.toLowerCase(),y=y.toLowerCase()),f.indexOf(y))}e.indexOfPath=m;function v(f){const y=f.split(":");let R,U,C;for(const b of y){const z=Number(b);(0,O.isNumber)(z)?U===void 0?U=z:C===void 0&&(C=z):R=R?[R,b].join(":"):b}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:U!==void 0?U:void 0,column:C!==void 0?C:U!==void 0?1:void 0}}e.parseLineAndColumnAware=v;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function A(f,y,R=8){let U="";for(let b=0;b<R;b++){let z;b===0&&E.isWindows&&!y&&(R===3||R===4)?z=_:z=d,U+=z.charAt(Math.floor(Math.random()*z.length))}let C;return y?C=`${y}-${U}`:C=U,f?(0,p.join)(f,C):C}e.randomPath=A}),define(W[17],j([0,1,6,3,8]),function(B,e,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(s){s.inMemory="inmemory",s.vscode="vscode",s.internal="private",s.walkThrough="walkThrough",s.walkThroughSnippet="walkThroughSnippet",s.http="http",s.https="https",s.file="file",s.mailto="mailto",s.untitled="untitled",s.data="data",s.command="command",s.vscodeRemote="vscode-remote",s.vscodeRemoteResource="vscode-remote-resource",s.vscodeManagedRemoteResource="vscode-managed-remote-resource",s.vscodeUserData="vscode-userdata",s.vscodeCustomEditor="vscode-custom-editor",s.vscodeNotebookCell="vscode-notebook-cell",s.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",s.vscodeNotebookCellOutput="vscode-notebook-cell-output",s.vscodeInteractiveInput="vscode-interactive-input",s.vscodeSettings="vscode-settings",s.vscodeWorkspaceTrust="vscode-workspace-trust",s.vscodeTerminal="vscode-terminal",s.vscodeChatSesssion="vscode-chat-editor",s.webviewPanel="webview-panel",s.vscodeWebview="vscode-webview",s.extension="extension",s.vscodeFileResource="vscode-file",s.tmp="tmp",s.vsls="vsls",s.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class r{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${O.vscodeRemoteResource}`}set(u,o,g){this._hosts[u]=o,this._ports[u]=g}setConnectionToken(u,o){this._connectionTokens[u]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(a){return p.onUnexpectedError(a),u}const o=u.authority;let g=this._hosts[o];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const l=this._ports[o],n=this._connectionTokens[o];let i=`path=${encodeURIComponent(u.path)}`;return typeof n=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),T.URI.from({scheme:E.isWeb?this._preferredWebSchema:O.vscodeRemoteResource,authority:`${g}:${l}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new r,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class h{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(u){const o=this.toUri(u,B);return this.uriToBrowserUri(o)}uriToBrowserUri(u){return u.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(u):u.scheme===O.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${O.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?u.with({scheme:O.vscodeFileResource,authority:u.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const o=this.toUri(u,B);return this.uriToFileUri(o)}uriToFileUri(u){return u.scheme===O.vscodeFileResource?u.with({scheme:O.file,authority:u.authority!==h.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,o){return T.URI.isUri(u)?u:T.URI.parse(o.toUrl(u))}}e.FileAccess=new h;var t;(function(s){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);s.CoopAndCoep=Object.freeze(u.get("3"));const o="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:T.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(o);if(a)return u.get(a)}s.getHeadersFromQuery=g;function l(n,i,a){if(!globalThis.crossOriginIsolated)return;const k=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(o,k):n[o]=k}s.addSearchParam=l})(t||(e.COI=t={}))}),define(W[32],j([0,1,21,17,3,8]),function(B,e,p,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class r{constructor(g,l,n){this.id=g,this.dependencies=l,this.callback=n}}class h{static{this.INSTANCE=new h}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,l,n)=>{typeof g!="string"&&(n=l,l=g,g=null),(typeof l!="object"||!Array.isArray(l))&&(n=l,l=null),this._defineCalls.push(new r(g,l,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const l=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!l)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}_rendererLoadScript(g){return new Promise((l,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",k),i.removeEventListener("error",L)},k=D=>{a(),l(this._defineCalls.pop())},L=D=>{a(),n(D)};i.addEventListener("load",k),i.addEventListener("error",L),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}_workerLoadScript(g){return new Promise((l,n)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),l(this._defineCalls.pop())}catch(i){n(i)}})}async _nodeJSLoadScript(g){try{const l=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=O.URI.parse(g).fsPath,k=l.readFileSync(a).toString(),L=i.wrap(k.replace(/^#!.*/,""));return new n.Script(L).runInThisContext().apply(),this._defineCalls.pop()}catch(l){throw l}}}const t=new Map;let s={};typeof globalThis.require=="object"&&(s=globalThis.require.paths??{});async function u(o,g,l){if(p.isESM){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),s[o]&&(o=s[o]);const n=`${o}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const D=`${l&&!T.isWeb?E.nodeModulesAsarPath:E.nodeModulesPath}/${n}`;i=E.FileAccess.asBrowserUri(D).toString(!0)}const a=h.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{B([o],n,i)})}e.importAMDNodeModule=u}),define(W[18],j([0,1,29,17,30,3,31,8]),function(B,e,p,E,T,O,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(l){return(0,h.uriToFsPath)(l,!0)}e.originalFSPath=t;class s{constructor(n){this._ignorePathCasing=n}compare(n,i,a=!1){return n===i?0:(0,r.compare)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===E.Schemas.file)return p.isEqualOrParent(t(n),t(i),this._ignorePathCasing(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.isEqualAuthority)(n.authority,i.authority))return p.isEqualOrParent(n.path,i.path,this._ignorePathCasing(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return h.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return T.posix.basename(n.path)}extname(n){return T.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===E.Schemas.file?i=h.URI.file(T.dirname(t(n))).path:(i=T.posix.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===E.Schemas.file?i=h.URI.file(T.normalize(t(n))).path:i=T.posix.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.isEqualAuthority)(n.authority,i.authority))return;if(n.scheme===E.Schemas.file){const L=T.relative(t(n),t(i));return O.isWindows?p.toSlashes(L):L}let a=n.path||"/";const k=i.path||"/";if(this._ignorePathCasing(n)){let L=0;for(const D=Math.min(a.length,k.length);L<D&&!(a.charCodeAt(L)!==k.charCodeAt(L)&&a.charAt(L).toLowerCase()!==k.charAt(L).toLowerCase());L++);a=k.substr(0,L)+a.substr(L)}return T.posix.relative(a,k)}resolvePath(n,i){if(n.scheme===E.Schemas.file){const a=h.URI.file(T.resolve(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=p.toPosixPath(i),n.with({path:T.posix.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.equalsIgnoreCase)(n,i)}hasTrailingPathSeparator(n,i=T.sep){if(n.scheme===E.Schemas.file){const a=t(n);return a.length>p.getRoot(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=T.sep){return(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=T.sep){let a=!1;if(n.scheme===E.Schemas.file){const k=t(n);a=k!==void 0&&k.length===p.getRoot(k).length&&k[k.length-1]===i}else{i="/";const k=n.path;a=k.length===1&&k.charCodeAt(k.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path+"/"}):n}}e.ExtUri=s,e.extUri=new s(()=>!1),e.extUriBiasedIgnorePathCase=new s(l=>l.scheme===E.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new s(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function u(l,n){const i=[];for(let a=0;a<l.length;a++){const k=n(l[a]);l.some((L,D)=>D===a?!1:(0,e.isEqualOrParent)(k,n(L)))||i.push(l[a])}return i}e.distinctParents=u;var o;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(D=>{const[I,w]=D.split(":");I&&w&&a.set(I,w)});const L=i.path.substring(0,i.path.indexOf(";"));return L&&a.set(l.META_DATA_MIME,L),a}l.parseMetaData=n})(o||(e.DataUri=o={}));function g(l,n,i){if(n){let a=l.path;return a&&a[0]!==T.posix.sep&&(a=T.posix.sep+a),l.with({scheme:i,authority:n,path:a})}return l.with({scheme:i})}e.toLocalResource=g}),define(W[19],j([0,1,46,6,33,2,18,3,24]),function(B,e,p,E,T,O,r,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function s(N){return!!N&&typeof N.then=="function"}e.isThenable=s;function u(N){const c=new p.CancellationTokenSource,S=N(c.token),P=new Promise((M,F)=>{const Y=c.token.onCancellationRequested(()=>{Y.dispose(),c.dispose(),F(new E.CancellationError)});Promise.resolve(S).then(Z=>{Y.dispose(),c.dispose(),M(Z)},Z=>{Y.dispose(),c.dispose(),F(Z)})});return new class{cancel(){c.cancel()}then(M,F){return P.then(M,F)}catch(M){return this.then(void 0,M)}finally(M){return P.finally(M)}}}e.createCancelablePromise=u;function o(N,c,S){return new Promise((P,M)=>{const F=c.onCancellationRequested(()=>{F.dispose(),P(S)});N.then(P,M).finally(()=>F.dispose())})}e.raceCancellation=o;function g(N,c){return new Promise((S,P)=>{const M=c.onCancellationRequested(()=>{M.dispose(),P(new E.CancellationError)});N.then(S,P).finally(()=>M.dispose())})}e.raceCancellationError=g;async function l(N){let c=-1;const S=N.map((P,M)=>P.then(F=>(c=M,F)));try{return await Promise.race(S)}finally{N.forEach((P,M)=>{M!==c&&P.cancel()})}}e.raceCancellablePromises=l;function n(N,c,S){let P;const M=setTimeout(()=>{P?.(void 0),S?.()},c);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(F=>P=F)])}e.raceTimeout=n;function i(N){return new Promise((c,S)=>{const P=N();s(P)?P.then(c,S):c(P)})}e.asPromise=i;class a{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(c){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=c,!this.queuedPromise){const S=()=>{if(this.queuedPromise=null,this.isDisposed)return;const P=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,P};this.queuedPromise=new Promise(P=>{this.activePromise.then(S,S).then(P)})}return new Promise((S,P)=>{this.queuedPromise.then(S,P)})}return this.activePromise=c(),new Promise((S,P)=>{this.activePromise.then(M=>{this.activePromise=null,S(M)},M=>{this.activePromise=null,P(M)})})}dispose(){this.isDisposed=!0}}e.Throttler=a;class k{constructor(){this.current=Promise.resolve(null)}queue(c){return this.current=this.current.then(()=>c(),()=>c())}}e.Sequencer=k;class L{constructor(){this.promiseMap=new Map}queue(c,S){const M=(this.promiseMap.get(c)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.promiseMap.get(c)===M&&this.promiseMap.delete(c)});return this.promiseMap.set(c,M),M}}e.SequencerByKey=L;const D=(N,c)=>{let S=!0;const P=setTimeout(()=>{S=!1,c()},N);return{isTriggered:()=>S,dispose:()=>{clearTimeout(P),S=!1}}},I=N=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,N())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class w{constructor(c){this.defaultDelay=c,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(c,S=this.defaultDelay){this.task=c,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,F)=>{this.doResolve=M,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}}));const P=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=S===t.MicrotaskDelay?I(P):D(S,P),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new E.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class m{constructor(c){this.delayer=new w(c),this.throttler=new a}trigger(c,S){return this.delayer.trigger(()=>this.throttler.queue(c),S)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=m;class v{constructor(){this._isOpen=!1,this._promise=new Promise((c,S)=>{this._completePromise=c})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class d extends v{constructor(c){super(),this._timeout=setTimeout(()=>this.open(),c)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function _(N,c){return c?new Promise((S,P)=>{const M=setTimeout(()=>{F.dispose(),S()},N),F=c.onCancellationRequested(()=>{clearTimeout(M),F.dispose(),P(new E.CancellationError)})}):u(S=>_(N,S))}e.timeout=_;function A(N,c=0,S){const P=setTimeout(()=>{N(),S&&M.dispose()},c),M=(0,O.toDisposable)(()=>{clearTimeout(P),S?.deleteAndLeak(M)});return S?.add(M),M}e.disposableTimeout=A;function f(N){const c=[];let S=0;const P=N.length;function M(){return S<P?N[S++]():null}function F(Y){Y!=null&&c.push(Y);const Z=M();return Z?Z.then(F):Promise.resolve(c)}return Promise.resolve(null).then(F)}e.sequence=f;function y(N,c=P=>!!P,S=null){let P=0;const M=N.length,F=()=>{if(P>=M)return Promise.resolve(S);const Y=N[P++];return Promise.resolve(Y()).then(X=>c(X)?Promise.resolve(X):F())};return F()}e.first=y;function R(N,c=P=>!!P,S=null){if(N.length===0)return Promise.resolve(S);let P=N.length;const M=()=>{P=-1;for(const F of N)F.cancel?.()};return new Promise((F,Y)=>{for(const Z of N)Z.then(X=>{--P>=0&&c(X)?(M(),F(X)):P===0&&F(S)}).catch(X=>{--P>=0&&(M(),Y(X))})})}e.firstParallel=R;class U{constructor(c){this._size=0,this.maxDegreeOfParalellism=c,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(c){return this._size++,new Promise((S,P)=>{this.outstandingPromises.push({factory:c,c:S,e:P}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const c=this.outstandingPromises.shift();this.runningPromises++;const S=c.factory();S.then(c.c,c.e),S.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=U;class C extends U{constructor(){super(1)}}e.Queue=C;class b{constructor(){this.sequentializer=new x,this.tasks=0}queue(c){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,c())):this.sequentializer.run(this.tasks++,c())}}e.LimitedQueue=b;class z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const c=new te;return this.drainers.add(c),c.p}isDrained(){for(const[,c]of this.queues)if(c.size>0)return!1;return!0}queueFor(c,S=r.extUri){const P=S.getComparisonKey(c);let M=this.queues.get(P);if(!M){M=new C;const F=this.drainListenerCount++,Y=T.Event.once(M.onDrained)(()=>{M?.dispose(),this.queues.delete(P),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(F),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(F,Y),this.queues.set(P,M)}return M}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const c of this.drainers)c.complete();this.drainers.clear()}dispose(){for(const[,c]of this.queues)c.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=z;class V{constructor(c,S){this._token=-1,typeof c=="function"&&typeof S=="number"&&this.setIfNotSet(c,S)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(c,S){this.cancel(),this._token=setTimeout(()=>{this._token=-1,c()},S)}setIfNotSet(c,S){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,c()},S))}}e.TimeoutTimer=V;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(c,S){this.cancel(),this._token=setInterval(()=>{c()},S)}}e.IntervalTimer=$;class K{constructor(c,S){this.timeoutToken=-1,this.runner=c,this.timeout=S,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(c=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,c)}get delay(){return this.timeout}set delay(c){this.timeout=c}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=K;class G{constructor(c,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.runner=c,this.timeout=S,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(c=this.timeout){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(c/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class q extends K{constructor(c,S){super(c,S),this.units=[]}work(c){this.units.push(c),this.isScheduled()||this.schedule()}doRun(){const c=this.units;this.units=[],this.runner?.(c)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class H extends O.Disposable{constructor(c,S){super(),this.options=c,this.handler=S,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(c){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+c.length>this.options.maxBufferedWork)return!1}else if(this.pending+c.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const S of c)this.pendingWork.push(S);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(c)return;const S=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let c=!1;return{dispose(){c||(c=!0)}}}:e.runWhenIdle=(N,c)=>{const S=requestIdleCallback(N,typeof c=="number"?{timeout:c}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(S))}}}}();class J{constructor(c){this._didRun=!1,this._executor=()=>{try{this._value=c()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=J;async function se(N,c,S){let P;for(let M=0;M<S;M++)try{return await N()}catch(F){P=F,await _(c)}throw P}e.retry=se;class x{isRunning(c){return typeof c=="number"?this._running?.taskId===c:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(c,S,P){return this._running={taskId:c,cancel:()=>P?.(),promise:S},S.then(()=>this.doneRunning(c),()=>this.doneRunning(c)),S}doneRunning(c){this._running&&c===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const c=this._queued;this._queued=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this._queued)this._queued.run=c;else{let S,P;const M=new Promise((F,Y)=>{S=F,P=Y});this._queued={run:c,promise:M,promiseResolve:S,promiseReject:P}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=x;class ae{constructor(c,S=()=>Date.now()){this.interval=c,this.nowFn=S,this.lastIncrementTime=0,this.value=0}increment(){const c=this.nowFn();return c-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=c,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var ee;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((c,S)=>{this.completeCallback=c,this.errorCallback=S})}complete(c){return new Promise(S=>{this.completeCallback(c),this.outcome={outcome:0,value:c},S()})}error(c){return new Promise(S=>{this.errorCallback(c),this.outcome={outcome:1,value:c},S()})}cancel(){return this.error(new E.CancellationError)}}e.DeferredPromise=te;var ne;(function(N){async function c(P){let M;const F=await Promise.all(P.map(Y=>Y.then(Z=>Z,Z=>{M||(M=Z)})));if(typeof M<"u")throw M;return F}N.settled=c;function S(P){return new Promise(async(M,F)=>{try{await P(M,F)}catch(Y){F(Y)}})}N.withAsyncBody=S})(ne||(e.Promises=ne={}));var ie;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ie||(ie={}));class Q{static fromArray(c){return new Q(S=>{S.emitMany(c)})}static fromPromise(c){return new Q(async S=>{S.emitMany(await c)})}static fromPromises(c){return new Q(async S=>{await Promise.all(c.map(async P=>S.emitOne(await P)))})}static merge(c){return new Q(async S=>{await Promise.all(c.map(async P=>{for await(const M of P)S.emitOne(M)}))})}static{this.EMPTY=Q.fromArray([])}constructor(c){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const S={emitOne:P=>this.emitOne(P),emitMany:P=>this.emitMany(P),reject:P=>this.reject(P)};try{await Promise.resolve(c(S)),this.resolve()}catch(P){this.reject(P)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(c<this._results.length)return{done:!1,value:this._results[c++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(c,S){return new Q(async P=>{for await(const M of c)P.emitOne(S(M))})}map(c){return Q.map(this,c)}static filter(c,S){return new Q(async P=>{for await(const M of c)S(M)&&P.emitOne(M)})}filter(c){return Q.filter(this,c)}static coalesce(c){return Q.filter(c,S=>!!S)}coalesce(){return Q.coalesce(this)}static async toPromise(c){const S=[];for await(const P of c)S.push(P);return S}toPromise(){return Q.toPromise(this)}emitOne(c){this._state===0&&(this._results.push(c),this._onStateChanged.fire())}emitMany(c){this._state===0&&(this._results=this._results.concat(c),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(c){this._state===0&&(this._state=2,this._error=c,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class re extends Q{constructor(c,S){super(S),this._source=c}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function oe(N){const c=new p.CancellationTokenSource,S=N(c.token);return new re(c,async P=>{const M=c.token.onCancellationRequested(()=>{M.dispose(),c.dispose(),P.reject(new E.CancellationError)});try{for await(const F of S){if(c.token.isCancellationRequested)return;P.emitOne(F)}M.dispose(),c.dispose()}catch(F){M.dispose(),c.dispose(),P.reject(F)}})}e.createCancelableAsyncIterable=oe}),define(W[20],j([0,1,34]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(O){return this===O}};function E(O,r){return new p.TokenizationResult([new p.Token(0,"",O)],r)}e.nullTokenize=E;function T(O,r){const h=new Uint32Array(2);return h[0]=0,h[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new p.EncodedTokenizationResult(h,r===null?e.NullState:r)}e.nullTokenizeEncoded=T}),define(W[35],j([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(B,e,p,E,T,O,r,h,t,s,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var l;(function(w){w[w.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(l||(l={}));class n{constructor(m,v){this.tokenizationSupport=v,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new a(m)}getStartState(m){return this.store.getStartState(m,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class i extends n{constructor(m,v,d,_){super(m,v),this._textModel=d,this._languageIdCodec=_}updateTokensUntilLine(m,v){const d=this._textModel.getLanguageId();for(;;){const _=this.getFirstInvalidLine();if(!_||_.lineNumber>v)break;const A=this._textModel.getLineContent(_.lineNumber),f=D(this._languageIdCodec,d,this.tokenizationSupport,A,!0,_.startState);m.add(_.lineNumber,f.tokens),this.store.setEndState(_.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(m,v){const d=this.getStartState(m.lineNumber);if(!d)return 0;const _=this._textModel.getLanguageId(),A=this._textModel.getLineContent(m.lineNumber),f=A.substring(0,m.column-1)+v+A.substring(m.column-1),y=D(this._languageIdCodec,_,this.tokenizationSupport,f,!0,d),R=new g.LineTokens(y.tokens,f,this._languageIdCodec);if(R.getCount()===0)return 0;const U=R.findTokenIndexAtOffset(m.column-1);return R.getStandardTokenType(U)}tokenizeLineWithEdit(m,v,d){const _=m.lineNumber,A=m.column,f=this.getStartState(_);if(!f)return null;const y=this._textModel.getLineContent(_),R=y.substring(0,A-1)+d+y.substring(A-1+v),U=this._textModel.getLanguageIdAtPosition(_,0),C=D(this._languageIdCodec,U,this.tokenizationSupport,R,!0,f);return new g.LineTokens(C.tokens,R,this._languageIdCodec)}isCheapToTokenize(m){const v=this.store.getFirstInvalidEndStateLineNumberOrMax();return m<v||m===v&&this._textModel.getLineLength(m)<2048}tokenizeHeuristically(m,v,d){if(d<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(m,d),{heuristicTokens:!1};let _=this.guessStartState(v);const A=this._textModel.getLanguageId();for(let f=v;f<=d;f++){const y=this._textModel.getLineContent(f),R=D(this._languageIdCodec,A,this.tokenizationSupport,y,!0,_);m.add(f,R.tokens),_=R.endState}return{heuristicTokens:!0}}guessStartState(m){let v=this._textModel.getLineFirstNonWhitespaceColumn(m);const d=[];let _=null;for(let y=m-1;v>1&&y>=1;y--){const R=this._textModel.getLineFirstNonWhitespaceColumn(y);if(R!==0&&R<v&&(d.push(this._textModel.getLineContent(y)),v=R,_=this.getStartState(y),_))break}_||(_=this.tokenizationSupport.getInitialState()),d.reverse();const A=this._textModel.getLanguageId();let f=_;for(const y of d)f=D(this._languageIdCodec,A,this.tokenizationSupport,y,!1,f).endState;return f}}e.TokenizerWithStateStoreAndTextModel=i;class a{constructor(m){this.lineCount=m,this._tokenizationStateStore=new k,this._invalidEndStatesLineNumbers=new L,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,m+1))}getEndState(m){return this._tokenizationStateStore.getEndState(m)}setEndState(m,v){if(!v)throw new E.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(m);const d=this._tokenizationStateStore.setEndState(m,v);return d&&m<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(m+1,m+2)),d}acceptChange(m,v){this.lineCount+=v-m.length,this._tokenizationStateStore.acceptChange(m,v),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(m.startLineNumber,m.endLineNumberExclusive),v)}acceptChanges(m){for(const v of m){const[d]=(0,r.countEOL)(v.text);this.acceptChange(new h.LineRange(v.range.startLineNumber,v.range.endLineNumber+1),d+1)}}invalidateEndStateRange(m){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(m.startLineNumber,m.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(m,v){return m===1?v:this.getEndState(m-1)}getFirstInvalidLine(m){const v=this.getFirstInvalidEndStateLineNumber();if(v===null)return null;const d=this.getStartState(v,m);if(!d)throw new E.BugIndicatingError("Start state must be defined");return{lineNumber:v,startState:d}}}e.TrackingTokenizationStateStore=a;class k{constructor(){this._lineEndStates=new u.FixedArray(null)}getEndState(m){return this._lineEndStates.get(m)}setEndState(m,v){const d=this._lineEndStates.get(m);return d&&d.equals(v)?!1:(this._lineEndStates.set(m,v),!0)}acceptChange(m,v){let d=m.length;v>0&&d>0&&(d--,v--),this._lineEndStates.replace(m.startLineNumber,d,v)}acceptChanges(m){for(const v of m){const[d]=(0,r.countEOL)(v.text);this.acceptChange(new h.LineRange(v.range.startLineNumber,v.range.endLineNumber+1),d+1)}}}e.TokenizationStateStore=k;class L{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const m=this._ranges[0];return m.start+1===m.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(m.start+1,m.endExclusive),m.start}delete(m){const v=this._ranges.findIndex(d=>d.contains(m));if(v!==-1){const d=this._ranges[v];d.start===m?d.endExclusive===m+1?this._ranges.splice(v,1):this._ranges[v]=new t.OffsetRange(m+1,d.endExclusive):d.endExclusive===m+1?this._ranges[v]=new t.OffsetRange(d.start,m):this._ranges.splice(v,1,new t.OffsetRange(d.start,m),new t.OffsetRange(m+1,d.endExclusive))}}addRange(m){t.OffsetRange.addRange(m,this._ranges)}addRangeAndResize(m,v){let d=0;for(;!(d>=this._ranges.length||m.start<=this._ranges[d].endExclusive);)d++;let _=d;for(;!(_>=this._ranges.length||m.endExclusive<this._ranges[_].start);)_++;const A=v-m.length;for(let f=_;f<this._ranges.length;f++)this._ranges[f]=this._ranges[f].delta(A);if(d===_){const f=new t.OffsetRange(m.start,m.start+v);f.isEmpty||this._ranges.splice(d,0,f)}else{const f=Math.min(m.start,this._ranges[d].start),y=Math.max(m.endExclusive,this._ranges[_-1].endExclusive),R=new t.OffsetRange(f,y+A);R.isEmpty?this._ranges.splice(d,_-d):this._ranges.splice(d,_-d,R)}}toString(){return this._ranges.map(m=>m.toString()).join(" + ")}}e.RangePriorityQueueImpl=L;function D(w,m,v,d,_,A){let f=null;if(v)try{f=v.tokenizeEncoded(d,_,A.clone())}catch(y){(0,E.onUnexpectedError)(y)}return f||(f=(0,s.nullTokenizeEncoded)(w.encodeLanguageId(m),A)),g.LineTokens.convertToEndOffset(f.tokens,d.length),f}class I{constructor(m,v){this._tokenizerWithStateStore=m,this._backgroundTokenStore=v,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,p.runWhenIdle)(m=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(m)}))}_backgroundTokenizeWithDeadline(m){const v=Date.now()+m.timeRemaining(),d=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<v?(0,T.setTimeout0)(d):this._beginBackgroundTokenization())};d()}_backgroundTokenizeForAtLeast1ms(){const m=this._tokenizerWithStateStore._textModel.getLineCount(),v=new o.ContiguousMultilineTokensBuilder,d=O.StopWatch.create(!1);do if(d.elapsed()>1||this._tokenizeOneInvalidLine(v)>=m)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(v.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(m){const v=this._tokenizerWithStateStore?.getFirstInvalidLine();return v?(this._tokenizerWithStateStore.updateTokensUntilLine(m,v.lineNumber),v.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(m,v){this._tokenizerWithStateStore.store.invalidateEndStateRange(new h.LineRange(m,v))}}e.DefaultBackgroundTokenizer=I}),define(W[37],j([0,1,33,2,36,14,34]),function(B,e,p,E,T,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class h extends E.Disposable{constructor(s,u,o,g,l,n,i){super(),this._grammar=s,this._initialState=u,this._containsEmbeddedLanguages=o,this._createBackgroundTokenizer=g,this._backgroundTokenizerShouldOnlyVerifyTokens=l,this._reportTokenizationTime=n,this._reportSlowTokenization=i,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new p.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(s,u,o){throw new Error("Not supported!")}createBackgroundTokenizer(s,u){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(s,u)}tokenizeEncoded(s,u,o){const g=Math.random()*1e4<1,l=this._reportSlowTokenization||g,n=l?new T.StopWatch(!0):void 0,i=this._grammar.tokenizeLine2(s,o,500);if(l){const k=n.elapsed();(g||k>32)&&this._reportTokenizationTime(k,s.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${s.substring(0,100)}`),new r.EncodedTokenizationResult(i.tokens,o);if(this._containsEmbeddedLanguages){const k=this._seenLanguages,L=i.tokens;for(let D=0,I=L.length>>>1;D<I;D++){const w=L[(D<<1)+1],m=O.TokenMetadata.getLanguageId(w);k[m]||(k[m]=!0,this._onDidEncounterLanguage.fire(m))}}let a;return o.equals(i.ruleStack)?a=o:a=i.ruleStack,new r.EncodedTokenizationResult(i.tokens,a)}}e.TextMateTokenizationSupport=h}),define(W[38],j([0,1,20,2,11]),function(B,e,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class O extends E.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,s){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=s,this._register((0,T.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,s){throw new Error("Not supported!")}tokenizeEncoded(h,t,s){return h.length>=this._maxTokenizationLineLength.get()?(0,p.nullTokenizeEncoded)(this._encodedLanguageId,s):this._actual.tokenizeEncoded(h,t,s)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=O}),define(W[39],j([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(B,e,p,E,T,O,r,h,t,s,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class l extends h.MirrorTextModel{constructor(a,k,L,D,I,w,m,v){super(a,k,L,D),this._host=I,this._languageId=w,this._encodedLanguageId=m,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,T.observableValue)(this,-1),this._tokenizeDebouncer=new E.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(v,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(a,k){this._languageId=a,this._encodedLanguageId=k,this._resetTokenization()}onEvents(a){super.onEvents(a),this._tokenizerWithStateStore?.store.acceptChanges(a.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(a){this._maxTokenizationLineLength.set(a,void 0)}retokenize(a,k){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new r.LineRange(a,k)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const a=this._languageId,k=this._encodedLanguageId,L=await this._host.getOrCreateGrammar(a,k);if(!(this._isDisposed||a!==this._languageId||k!==this._encodedLanguageId||!L)){if(L.grammar){const D=new g.TokenizationSupportWithLineLimit(this._encodedLanguageId,new o.TextMateTokenizationSupport(L.grammar,L.initialState,!1,void 0,()=>!1,(I,w,m)=>{this._host.reportTokenizationTime(I,a,L.sourceExtensionId,w,m)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,D)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:k}=await(0,p.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=k}const a=new Date().getTime();for(;;){let k=0;const L=new s.ContiguousMultilineTokensBuilder,D=new n;for(;;){const m=this._tokenizerWithStateStore.getFirstInvalidLine();if(m===null||k>200)break;k++;const v=this._lines[m.lineNumber-1],d=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(v,!0,m.startState);if(this._tokenizerWithStateStore.store.setEndState(m.lineNumber,d.endState)){const A=this._diffStateStacksRefEqFn(m.startState,d.endState);D.setState(m.lineNumber,A)}else D.setState(m.lineNumber,null);if(u.LineTokens.convertToEndOffset(d.tokens,v.length),L.add(m.lineNumber,d.tokens),new Date().getTime()-a>20)break}if(k===0)break;const I=D.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,L.serialize(),I),new Date().getTime()-a>20){(0,O.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=l;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(a,k){a===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(k):this._stateDeltas.push({startLineNumber:a,stateDeltas:[k]}),this._lastStartLineNumber=a}getStateDeltas(){return this._stateDeltas}}}),define(W[40],j([0,1,18]),function(B,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class E{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(O){if(this._scopeNameToLanguageRegistration[O.scopeName]){const r=this._scopeNameToLanguageRegistration[O.scopeName];p.isEqual(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this._scopeNameToLanguageRegistration[O.scopeName]=O}getGrammarDefinition(O){return this._scopeNameToLanguageRegistration[O]||null}}e.TMScopeRegistry=E}),define(W[41],j([0,1,2,40]),function(B,e,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class T extends p.Disposable{constructor(r,h,t,s){super(),this._host=r,this._initialState=t.INITIAL,this._scopeRegistry=new E.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:s,loadGrammar:async u=>{const o=this._scopeRegistry.getGrammarDefinition(u);if(!o)return this._host.logTrace(`No grammar found for scope ${u}`),null;const g=o.location;try{const l=await this._host.readFile(g);return t.parseRawGrammar(l,g.path)}catch(l){return this._host.logError(`Unable to load and parse grammar for scope ${u} from ${g}`,l),null}},getInjections:u=>{const o=u.split(".");let g=[];for(let l=1;l<=o.length;l++){const n=o.slice(0,l).join(".");g=[...g,...this._injections[n]||[]]}return g}}));for(const u of h){if(this._scopeRegistry.register(u),u.injectTo){for(const o of u.injectTo){let g=this._injections[o];g||(this._injections[o]=g=[]),g.push(u.scopeName)}if(u.embeddedLanguages)for(const o of u.injectTo){let g=this._injectedEmbeddedLanguages[o];g||(this._injectedEmbeddedLanguages[o]=g=[]),g.push(u.embeddedLanguages)}}u.language&&this._languageToScope.set(u.language,u.scopeName)}}has(r){return this._languageToScope.has(r)}setTheme(r,h){this._grammarRegistry.setTheme(r,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(r,h){const t=this._languageToScope.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const s=this._scopeRegistry.getGrammarDefinition(t);if(!s)throw new Error(e.missingTMGrammarErrorMessage);const u=s.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const l=this._injectedEmbeddedLanguages[t];for(const n of l)for(const i of Object.keys(n))u[i]=n[i]}const o=Object.keys(u).length>0;let g;try{g=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:u,tokenTypes:s.tokenTypes,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors})}catch(l){throw l.message&&l.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):l}return{languageId:r,grammar:g,initialState:this._initialState,containsEmbeddedLanguages:o,sourceExtensionId:s.sourceExtensionId}}}e.TMGrammarFactory=T}),define(W[49],j([0,1,8,41,39]),function(B,e,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(h,t){return new r(h,t)}e.create=O;class r{constructor(t,s){this._createData=s,this._models=new Map,this._grammarCache=[],this._host=t.host;const u=s.grammarDefinitions.map(o=>({location:p.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(u)}async _loadTMGrammarFactory(t){const s=this._createData.textmateMainUri,u=await new Promise((i,a)=>{B([s],i,a)}),o=await new Promise((i,a)=>{B([this._createData.onigurumaMainUri],i,a)}),l=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(l);const n=Promise.resolve({createOnigScanner:i=>o.createOnigScanner(i),createOnigString:i=>o.createOnigString(i)});return new E.TMGrammarFactory({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this._host.readFile(i)},t,u,n)}acceptNewModel(t){const s=p.URI.revive(t.uri),u=this;this._models.set(t.controllerId,new T.TextMateWorkerTokenizer(s,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,g){const l=await u._grammarFactory;return l?(u._grammarCache[g]||(u._grammarCache[g]=l.createGrammar(o,g)),u._grammarCache[g]):Promise.resolve(null)},setTokensAndStates(o,g,l){u._host.setTokensAndStates(t.controllerId,o,g,l)},reportTokenizationTime(o,g,l,n,i){u._host.reportTokenizationTime(o,g,l,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,s){this._models.get(t).onEvents(s)}retokenize(t,s,u){this._models.get(t).retokenize(s,u)}acceptModelLanguageChanged(t,s,u){this._models.get(t).onLanguageId(s,u)}acceptRemovedModel(t){const s=this._models.get(t);s&&(s.dispose(),this._models.delete(t))}async acceptTheme(t,s){(await this._grammarFactory)?.setTheme(t,s)}acceptMaxTokenizationLineLength(t,s){this._models.get(t).acceptMaxTokenizationLineLength(s)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/032b38229264250bcce623b6412a0bb7bd9b4052/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
